// uninames.h                                   Copyright (C) 2020 Codemist


// $Id: uninames.h 5432 2020-10-15 20:40:59Z arthurcnorman $


/**************************************************************************
 * Copyright (C) 2020, Codemist.                         A C Norman       *
 *                                                                        *
 * Redistribution and use in source and binary forms, with or without     *
 * modification, are permitted provided that the following conditions are *
 * met:                                                                   *
 *                                                                        *
 *     * Redistributions of source code must retain the relevant          *
 *       copyright notice, this list of conditions and the following      *
 *       disclaimer.                                                      *
 *     * Redistributions in binary form must reproduce the above          *
 *       copyright notice, this list of conditions and the following      *
 *       disclaimer in the documentation and/or other materials provided  *
 *       with the distribution.                                           *
 *                                                                        *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS    *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT      *
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS      *
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE         *
 * COPYRIGHT OWNERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,   *
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,   *
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS  *
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND *
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR  *
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF     *
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH   *
 * DAMAGE.                                                                *
 *************************************************************************/

// This file is derived from one made available by the Unicode Formum.
// The Unicode character name list is from the Unicode web site and
// usage rights are as described at
//           http://www.unicode.org/copyright.html
// Their notice reads...
//
// COPYRIGHT AND PERMISSION NOTICE
//
// Copyright  1991-2014 Unicode, Inc. All rights reserved.
// Distributed under the Terms of Use in
// http://www.unicode.org/copyright.html.
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of the Unicode data files and any associated documentation
// (the "Data Files") or Unicode software and any associated documentation
// (the "Software") to deal in the Data Files or Software
// without restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, and/or sell copies of
// the Data Files or Software, and to permit persons to whom the Data Files
// or Software are furnished to do so, provided that
// (a) this copyright and permission notice appear with all copies
// of the Data Files or Software,
// (b) this copyright and permission notice appear in associated
// documentation, and
// (c) there is clear notice in each modified Data File or in the Software
// as well as in the documentation associated with the Data File(s) or
// Software that the data or software has been modified.
//
// THE DATA FILES AND SOFTWARE ARE PROVIDED "AS IS", WITHOUT WARRANTY OF
// ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT OF THIRD PARTY RIGHTS.
// IN NO EVENT SHALL THE COPYRIGHT HOLDER OR HOLDERS INCLUDED IN THIS
// NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL INDIRECT OR CONSEQUENTIAL
// DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
// DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
// TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
// PERFORMANCE OF THE DATA FILES OR SOFTWARE.
//
// Except as contained in this notice, the name of a copyright holder
// shall not be used in advertising or otherwise to promote the sale,
// use or other dealings in these Data Files or Software without prior
// written authorization of the copyright holder.
//



// Here is my statement about modification:
//
// These should be ALL the Unicode characters in existence at the time
// of creation of this file. Names have been adjusted by replacing spaces
// and hyphens with underscores and removing a few "<>" marks, so as to
// leave names acceptable to C/C++.

#define unicode_SPACE                                                 0x0020
#define unicode_EXCLAMATION_MARK                                      0x0021
#define unicode_QUOTATION_MARK                                        0x0022
#define unicode_NUMBER_SIGN                                           0x0023
#define unicode_DOLLAR_SIGN                                           0x0024
#define unicode_PERCENT_SIGN                                          0x0025
#define unicode_AMPERSAND                                             0x0026
#define unicode_APOSTROPHE                                            0x0027
#define unicode_LEFT_PARENTHESIS                                      0x0028
#define unicode_RIGHT_PARENTHESIS                                     0x0029
#define unicode_ASTERISK                                              0x002A
#define unicode_PLUS_SIGN                                             0x002B
#define unicode_COMMA                                                 0x002C
#define unicode_HYPHEN_MINUS                                          0x002D
#define unicode_FULL_STOP                                             0x002E
#define unicode_SOLIDUS                                               0x002F
#define unicode_DIGIT_ZERO                                            0x0030
#define unicode_DIGIT_ONE                                             0x0031
#define unicode_DIGIT_TWO                                             0x0032
#define unicode_DIGIT_THREE                                           0x0033
#define unicode_DIGIT_FOUR                                            0x0034
#define unicode_DIGIT_FIVE                                            0x0035
#define unicode_DIGIT_SIX                                             0x0036
#define unicode_DIGIT_SEVEN                                           0x0037
#define unicode_DIGIT_EIGHT                                           0x0038
#define unicode_DIGIT_NINE                                            0x0039
#define unicode_COLON                                                 0x003A
#define unicode_SEMICOLON                                             0x003B
#define unicode_LESS_THAN_SIGN                                        0x003C
#define unicode_EQUALS_SIGN                                           0x003D
#define unicode_GREATER_THAN_SIGN                                     0x003E
#define unicode_QUESTION_MARK                                         0x003F
#define unicode_COMMERCIAL_AT                                         0x0040
#define unicode_LATIN_CAPITAL_LETTER_A                                0x0041
#define unicode_LATIN_CAPITAL_LETTER_B                                0x0042
#define unicode_LATIN_CAPITAL_LETTER_C                                0x0043
#define unicode_LATIN_CAPITAL_LETTER_D                                0x0044
#define unicode_LATIN_CAPITAL_LETTER_E                                0x0045
#define unicode_LATIN_CAPITAL_LETTER_F                                0x0046
#define unicode_LATIN_CAPITAL_LETTER_G                                0x0047
#define unicode_LATIN_CAPITAL_LETTER_H                                0x0048
#define unicode_LATIN_CAPITAL_LETTER_I                                0x0049
#define unicode_LATIN_CAPITAL_LETTER_J                                0x004A
#define unicode_LATIN_CAPITAL_LETTER_K                                0x004B
#define unicode_LATIN_CAPITAL_LETTER_L                                0x004C
#define unicode_LATIN_CAPITAL_LETTER_M                                0x004D
#define unicode_LATIN_CAPITAL_LETTER_N                                0x004E
#define unicode_LATIN_CAPITAL_LETTER_O                                0x004F
#define unicode_LATIN_CAPITAL_LETTER_P                                0x0050
#define unicode_LATIN_CAPITAL_LETTER_Q                                0x0051
#define unicode_LATIN_CAPITAL_LETTER_R                                0x0052
#define unicode_LATIN_CAPITAL_LETTER_S                                0x0053
#define unicode_LATIN_CAPITAL_LETTER_T                                0x0054
#define unicode_LATIN_CAPITAL_LETTER_U                                0x0055
#define unicode_LATIN_CAPITAL_LETTER_V                                0x0056
#define unicode_LATIN_CAPITAL_LETTER_W                                0x0057
#define unicode_LATIN_CAPITAL_LETTER_X                                0x0058
#define unicode_LATIN_CAPITAL_LETTER_Y                                0x0059
#define unicode_LATIN_CAPITAL_LETTER_Z                                0x005A
#define unicode_LEFT_SQUARE_BRACKET                                   0x005B
#define unicode_REVERSE_SOLIDUS                                       0x005C
#define unicode_RIGHT_SQUARE_BRACKET                                  0x005D
#define unicode_CIRCUMFLEX_ACCENT                                     0x005E
#define unicode_LOW_LINE                                              0x005F
#define unicode_GRAVE_ACCENT                                          0x0060
#define unicode_LATIN_SMALL_LETTER_A                                  0x0061
#define unicode_LATIN_SMALL_LETTER_B                                  0x0062
#define unicode_LATIN_SMALL_LETTER_C                                  0x0063
#define unicode_LATIN_SMALL_LETTER_D                                  0x0064
#define unicode_LATIN_SMALL_LETTER_E                                  0x0065
#define unicode_LATIN_SMALL_LETTER_F                                  0x0066
#define unicode_LATIN_SMALL_LETTER_G                                  0x0067
#define unicode_LATIN_SMALL_LETTER_H                                  0x0068
#define unicode_LATIN_SMALL_LETTER_I                                  0x0069
#define unicode_LATIN_SMALL_LETTER_J                                  0x006A
#define unicode_LATIN_SMALL_LETTER_K                                  0x006B
#define unicode_LATIN_SMALL_LETTER_L                                  0x006C
#define unicode_LATIN_SMALL_LETTER_M                                  0x006D
#define unicode_LATIN_SMALL_LETTER_N                                  0x006E
#define unicode_LATIN_SMALL_LETTER_O                                  0x006F
#define unicode_LATIN_SMALL_LETTER_P                                  0x0070
#define unicode_LATIN_SMALL_LETTER_Q                                  0x0071
#define unicode_LATIN_SMALL_LETTER_R                                  0x0072
#define unicode_LATIN_SMALL_LETTER_S                                  0x0073
#define unicode_LATIN_SMALL_LETTER_T                                  0x0074
#define unicode_LATIN_SMALL_LETTER_U                                  0x0075
#define unicode_LATIN_SMALL_LETTER_V                                  0x0076
#define unicode_LATIN_SMALL_LETTER_W                                  0x0077
#define unicode_LATIN_SMALL_LETTER_X                                  0x0078
#define unicode_LATIN_SMALL_LETTER_Y                                  0x0079
#define unicode_LATIN_SMALL_LETTER_Z                                  0x007A
#define unicode_LEFT_CURLY_BRACKET                                    0x007B
#define unicode_VERTICAL_LINE                                         0x007C
#define unicode_RIGHT_CURLY_BRACKET                                   0x007D
#define unicode_TILDE                                                 0x007E
#define unicode_NO_BREAK_SPACE                                        0x00A0
#define unicode_INVERTED_EXCLAMATION_MARK                             0x00A1
#define unicode_CENT_SIGN                                             0x00A2
#define unicode_POUND_SIGN                                            0x00A3
#define unicode_CURRENCY_SIGN                                         0x00A4
#define unicode_YEN_SIGN                                              0x00A5
#define unicode_BROKEN_BAR                                            0x00A6
#define unicode_SECTION_SIGN                                          0x00A7
#define unicode_DIAERESIS                                             0x00A8
#define unicode_COPYRIGHT_SIGN                                        0x00A9
#define unicode_FEMININE_ORDINAL_INDICATOR                            0x00AA
#define unicode_LEFT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK             0x00AB
#define unicode_NOT_SIGN                                              0x00AC
#define unicode_SOFT_HYPHEN                                           0x00AD
#define unicode_REGISTERED_SIGN                                       0x00AE
#define unicode_MACRON                                                0x00AF
#define unicode_DEGREE_SIGN                                           0x00B0
#define unicode_PLUS_MINUS_SIGN                                       0x00B1
#define unicode_SUPERSCRIPT_TWO                                       0x00B2
#define unicode_SUPERSCRIPT_THREE                                     0x00B3
#define unicode_ACUTE_ACCENT                                          0x00B4
#define unicode_MICRO_SIGN                                            0x00B5
#define unicode_PILCROW_SIGN                                          0x00B6
#define unicode_MIDDLE_DOT                                            0x00B7
#define unicode_CEDILLA                                               0x00B8
#define unicode_SUPERSCRIPT_ONE                                       0x00B9
#define unicode_MASCULINE_ORDINAL_INDICATOR                           0x00BA
#define unicode_RIGHT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK            0x00BB
#define unicode_VULGAR_FRACTION_ONE_QUARTER                           0x00BC
#define unicode_VULGAR_FRACTION_ONE_HALF                              0x00BD
#define unicode_VULGAR_FRACTION_THREE_QUARTERS                        0x00BE
#define unicode_INVERTED_QUESTION_MARK                                0x00BF
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_GRAVE                     0x00C0
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_ACUTE                     0x00C1
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX                0x00C2
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_TILDE                     0x00C3
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_DIAERESIS                 0x00C4
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_RING_ABOVE                0x00C5
#define unicode_LATIN_CAPITAL_LETTER_AE                               0x00C6
#define unicode_LATIN_CAPITAL_LETTER_C_WITH_CEDILLA                   0x00C7
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_GRAVE                     0x00C8
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_ACUTE                     0x00C9
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX                0x00CA
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_DIAERESIS                 0x00CB
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_GRAVE                     0x00CC
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_ACUTE                     0x00CD
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_CIRCUMFLEX                0x00CE
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_DIAERESIS                 0x00CF
#define unicode_LATIN_CAPITAL_LETTER_ETH                              0x00D0
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_TILDE                     0x00D1
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_GRAVE                     0x00D2
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_ACUTE                     0x00D3
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX                0x00D4
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_TILDE                     0x00D5
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_DIAERESIS                 0x00D6
#define unicode_MULTIPLICATION_SIGN                                   0x00D7
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_STROKE                    0x00D8
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_GRAVE                     0x00D9
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_ACUTE                     0x00DA
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_CIRCUMFLEX                0x00DB
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS                 0x00DC
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_ACUTE                     0x00DD
#define unicode_LATIN_CAPITAL_LETTER_THORN                            0x00DE
#define unicode_LATIN_SMALL_LETTER_SHARP_S                            0x00DF
#define unicode_LATIN_SMALL_LETTER_A_WITH_GRAVE                       0x00E0
#define unicode_LATIN_SMALL_LETTER_A_WITH_ACUTE                       0x00E1
#define unicode_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX                  0x00E2
#define unicode_LATIN_SMALL_LETTER_A_WITH_TILDE                       0x00E3
#define unicode_LATIN_SMALL_LETTER_A_WITH_DIAERESIS                   0x00E4
#define unicode_LATIN_SMALL_LETTER_A_WITH_RING_ABOVE                  0x00E5
#define unicode_LATIN_SMALL_LETTER_AE                                 0x00E6
#define unicode_LATIN_SMALL_LETTER_C_WITH_CEDILLA                     0x00E7
#define unicode_LATIN_SMALL_LETTER_E_WITH_GRAVE                       0x00E8
#define unicode_LATIN_SMALL_LETTER_E_WITH_ACUTE                       0x00E9
#define unicode_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX                  0x00EA
#define unicode_LATIN_SMALL_LETTER_E_WITH_DIAERESIS                   0x00EB
#define unicode_LATIN_SMALL_LETTER_I_WITH_GRAVE                       0x00EC
#define unicode_LATIN_SMALL_LETTER_I_WITH_ACUTE                       0x00ED
#define unicode_LATIN_SMALL_LETTER_I_WITH_CIRCUMFLEX                  0x00EE
#define unicode_LATIN_SMALL_LETTER_I_WITH_DIAERESIS                   0x00EF
#define unicode_LATIN_SMALL_LETTER_ETH                                0x00F0
#define unicode_LATIN_SMALL_LETTER_N_WITH_TILDE                       0x00F1
#define unicode_LATIN_SMALL_LETTER_O_WITH_GRAVE                       0x00F2
#define unicode_LATIN_SMALL_LETTER_O_WITH_ACUTE                       0x00F3
#define unicode_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX                  0x00F4
#define unicode_LATIN_SMALL_LETTER_O_WITH_TILDE                       0x00F5
#define unicode_LATIN_SMALL_LETTER_O_WITH_DIAERESIS                   0x00F6
#define unicode_DIVISION_SIGN                                         0x00F7
#define unicode_LATIN_SMALL_LETTER_O_WITH_STROKE                      0x00F8
#define unicode_LATIN_SMALL_LETTER_U_WITH_GRAVE                       0x00F9
#define unicode_LATIN_SMALL_LETTER_U_WITH_ACUTE                       0x00FA
#define unicode_LATIN_SMALL_LETTER_U_WITH_CIRCUMFLEX                  0x00FB
#define unicode_LATIN_SMALL_LETTER_U_WITH_DIAERESIS                   0x00FC
#define unicode_LATIN_SMALL_LETTER_Y_WITH_ACUTE                       0x00FD
#define unicode_LATIN_SMALL_LETTER_THORN                              0x00FE
#define unicode_LATIN_SMALL_LETTER_Y_WITH_DIAERESIS                   0x00FF
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_MACRON                    0x0100
#define unicode_LATIN_SMALL_LETTER_A_WITH_MACRON                      0x0101
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_BREVE                     0x0102
#define unicode_LATIN_SMALL_LETTER_A_WITH_BREVE                       0x0103
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_OGONEK                    0x0104
#define unicode_LATIN_SMALL_LETTER_A_WITH_OGONEK                      0x0105
#define unicode_LATIN_CAPITAL_LETTER_C_WITH_ACUTE                     0x0106
#define unicode_LATIN_SMALL_LETTER_C_WITH_ACUTE                       0x0107
#define unicode_LATIN_CAPITAL_LETTER_C_WITH_CIRCUMFLEX                0x0108
#define unicode_LATIN_SMALL_LETTER_C_WITH_CIRCUMFLEX                  0x0109
#define unicode_LATIN_CAPITAL_LETTER_C_WITH_DOT_ABOVE                 0x010A
#define unicode_LATIN_SMALL_LETTER_C_WITH_DOT_ABOVE                   0x010B
#define unicode_LATIN_CAPITAL_LETTER_C_WITH_CARON                     0x010C
#define unicode_LATIN_SMALL_LETTER_C_WITH_CARON                       0x010D
#define unicode_LATIN_CAPITAL_LETTER_D_WITH_CARON                     0x010E
#define unicode_LATIN_SMALL_LETTER_D_WITH_CARON                       0x010F
#define unicode_LATIN_CAPITAL_LETTER_D_WITH_STROKE                    0x0110
#define unicode_LATIN_SMALL_LETTER_D_WITH_STROKE                      0x0111
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_MACRON                    0x0112
#define unicode_LATIN_SMALL_LETTER_E_WITH_MACRON                      0x0113
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_BREVE                     0x0114
#define unicode_LATIN_SMALL_LETTER_E_WITH_BREVE                       0x0115
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_DOT_ABOVE                 0x0116
#define unicode_LATIN_SMALL_LETTER_E_WITH_DOT_ABOVE                   0x0117
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_OGONEK                    0x0118
#define unicode_LATIN_SMALL_LETTER_E_WITH_OGONEK                      0x0119
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_CARON                     0x011A
#define unicode_LATIN_SMALL_LETTER_E_WITH_CARON                       0x011B
#define unicode_LATIN_CAPITAL_LETTER_G_WITH_CIRCUMFLEX                0x011C
#define unicode_LATIN_SMALL_LETTER_G_WITH_CIRCUMFLEX                  0x011D
#define unicode_LATIN_CAPITAL_LETTER_G_WITH_BREVE                     0x011E
#define unicode_LATIN_SMALL_LETTER_G_WITH_BREVE                       0x011F
#define unicode_LATIN_CAPITAL_LETTER_G_WITH_DOT_ABOVE                 0x0120
#define unicode_LATIN_SMALL_LETTER_G_WITH_DOT_ABOVE                   0x0121
#define unicode_LATIN_CAPITAL_LETTER_G_WITH_CEDILLA                   0x0122
#define unicode_LATIN_SMALL_LETTER_G_WITH_CEDILLA                     0x0123
#define unicode_LATIN_CAPITAL_LETTER_H_WITH_CIRCUMFLEX                0x0124
#define unicode_LATIN_SMALL_LETTER_H_WITH_CIRCUMFLEX                  0x0125
#define unicode_LATIN_CAPITAL_LETTER_H_WITH_STROKE                    0x0126
#define unicode_LATIN_SMALL_LETTER_H_WITH_STROKE                      0x0127
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_TILDE                     0x0128
#define unicode_LATIN_SMALL_LETTER_I_WITH_TILDE                       0x0129
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_MACRON                    0x012A
#define unicode_LATIN_SMALL_LETTER_I_WITH_MACRON                      0x012B
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_BREVE                     0x012C
#define unicode_LATIN_SMALL_LETTER_I_WITH_BREVE                       0x012D
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_OGONEK                    0x012E
#define unicode_LATIN_SMALL_LETTER_I_WITH_OGONEK                      0x012F
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_DOT_ABOVE                 0x0130
#define unicode_LATIN_SMALL_LETTER_DOTLESS_I                          0x0131
#define unicode_LATIN_CAPITAL_LIGATURE_IJ                             0x0132
#define unicode_LATIN_SMALL_LIGATURE_IJ                               0x0133
#define unicode_LATIN_CAPITAL_LETTER_J_WITH_CIRCUMFLEX                0x0134
#define unicode_LATIN_SMALL_LETTER_J_WITH_CIRCUMFLEX                  0x0135
#define unicode_LATIN_CAPITAL_LETTER_K_WITH_CEDILLA                   0x0136
#define unicode_LATIN_SMALL_LETTER_K_WITH_CEDILLA                     0x0137
#define unicode_LATIN_SMALL_LETTER_KRA                                0x0138
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_ACUTE                     0x0139
#define unicode_LATIN_SMALL_LETTER_L_WITH_ACUTE                       0x013A
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_CEDILLA                   0x013B
#define unicode_LATIN_SMALL_LETTER_L_WITH_CEDILLA                     0x013C
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_CARON                     0x013D
#define unicode_LATIN_SMALL_LETTER_L_WITH_CARON                       0x013E
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_MIDDLE_DOT                0x013F
#define unicode_LATIN_SMALL_LETTER_L_WITH_MIDDLE_DOT                  0x0140
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_STROKE                    0x0141
#define unicode_LATIN_SMALL_LETTER_L_WITH_STROKE                      0x0142
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_ACUTE                     0x0143
#define unicode_LATIN_SMALL_LETTER_N_WITH_ACUTE                       0x0144
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_CEDILLA                   0x0145
#define unicode_LATIN_SMALL_LETTER_N_WITH_CEDILLA                     0x0146
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_CARON                     0x0147
#define unicode_LATIN_SMALL_LETTER_N_WITH_CARON                       0x0148
#define unicode_LATIN_SMALL_LETTER_N_PRECEDED_BY_APOSTROPHE           0x0149
#define unicode_LATIN_CAPITAL_LETTER_ENG                              0x014A
#define unicode_LATIN_SMALL_LETTER_ENG                                0x014B
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_MACRON                    0x014C
#define unicode_LATIN_SMALL_LETTER_O_WITH_MACRON                      0x014D
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_BREVE                     0x014E
#define unicode_LATIN_SMALL_LETTER_O_WITH_BREVE                       0x014F
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_DOUBLE_ACUTE              0x0150
#define unicode_LATIN_SMALL_LETTER_O_WITH_DOUBLE_ACUTE                0x0151
#define unicode_LATIN_CAPITAL_LIGATURE_OE                             0x0152
#define unicode_LATIN_SMALL_LIGATURE_OE                               0x0153
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_ACUTE                     0x0154
#define unicode_LATIN_SMALL_LETTER_R_WITH_ACUTE                       0x0155
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_CEDILLA                   0x0156
#define unicode_LATIN_SMALL_LETTER_R_WITH_CEDILLA                     0x0157
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_CARON                     0x0158
#define unicode_LATIN_SMALL_LETTER_R_WITH_CARON                       0x0159
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_ACUTE                     0x015A
#define unicode_LATIN_SMALL_LETTER_S_WITH_ACUTE                       0x015B
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_CIRCUMFLEX                0x015C
#define unicode_LATIN_SMALL_LETTER_S_WITH_CIRCUMFLEX                  0x015D
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_CEDILLA                   0x015E
#define unicode_LATIN_SMALL_LETTER_S_WITH_CEDILLA                     0x015F
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_CARON                     0x0160
#define unicode_LATIN_SMALL_LETTER_S_WITH_CARON                       0x0161
#define unicode_LATIN_CAPITAL_LETTER_T_WITH_CEDILLA                   0x0162
#define unicode_LATIN_SMALL_LETTER_T_WITH_CEDILLA                     0x0163
#define unicode_LATIN_CAPITAL_LETTER_T_WITH_CARON                     0x0164
#define unicode_LATIN_SMALL_LETTER_T_WITH_CARON                       0x0165
#define unicode_LATIN_CAPITAL_LETTER_T_WITH_STROKE                    0x0166
#define unicode_LATIN_SMALL_LETTER_T_WITH_STROKE                      0x0167
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_TILDE                     0x0168
#define unicode_LATIN_SMALL_LETTER_U_WITH_TILDE                       0x0169
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_MACRON                    0x016A
#define unicode_LATIN_SMALL_LETTER_U_WITH_MACRON                      0x016B
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_BREVE                     0x016C
#define unicode_LATIN_SMALL_LETTER_U_WITH_BREVE                       0x016D
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_RING_ABOVE                0x016E
#define unicode_LATIN_SMALL_LETTER_U_WITH_RING_ABOVE                  0x016F
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_DOUBLE_ACUTE              0x0170
#define unicode_LATIN_SMALL_LETTER_U_WITH_DOUBLE_ACUTE                0x0171
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_OGONEK                    0x0172
#define unicode_LATIN_SMALL_LETTER_U_WITH_OGONEK                      0x0173
#define unicode_LATIN_CAPITAL_LETTER_W_WITH_CIRCUMFLEX                0x0174
#define unicode_LATIN_SMALL_LETTER_W_WITH_CIRCUMFLEX                  0x0175
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_CIRCUMFLEX                0x0176
#define unicode_LATIN_SMALL_LETTER_Y_WITH_CIRCUMFLEX                  0x0177
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_DIAERESIS                 0x0178
#define unicode_LATIN_CAPITAL_LETTER_Z_WITH_ACUTE                     0x0179
#define unicode_LATIN_SMALL_LETTER_Z_WITH_ACUTE                       0x017A
#define unicode_LATIN_CAPITAL_LETTER_Z_WITH_DOT_ABOVE                 0x017B
#define unicode_LATIN_SMALL_LETTER_Z_WITH_DOT_ABOVE                   0x017C
#define unicode_LATIN_CAPITAL_LETTER_Z_WITH_CARON                     0x017D
#define unicode_LATIN_SMALL_LETTER_Z_WITH_CARON                       0x017E
#define unicode_LATIN_SMALL_LETTER_LONG_S                             0x017F
#define unicode_LATIN_SMALL_LETTER_B_WITH_STROKE                      0x0180
#define unicode_LATIN_CAPITAL_LETTER_B_WITH_HOOK                      0x0181
#define unicode_LATIN_CAPITAL_LETTER_B_WITH_TOPBAR                    0x0182
#define unicode_LATIN_SMALL_LETTER_B_WITH_TOPBAR                      0x0183
#define unicode_LATIN_CAPITAL_LETTER_TONE_SIX                         0x0184
#define unicode_LATIN_SMALL_LETTER_TONE_SIX                           0x0185
#define unicode_LATIN_CAPITAL_LETTER_OPEN_O                           0x0186
#define unicode_LATIN_CAPITAL_LETTER_C_WITH_HOOK                      0x0187
#define unicode_LATIN_SMALL_LETTER_C_WITH_HOOK                        0x0188
#define unicode_LATIN_CAPITAL_LETTER_AFRICAN_D                        0x0189
#define unicode_LATIN_CAPITAL_LETTER_D_WITH_HOOK                      0x018A
#define unicode_LATIN_CAPITAL_LETTER_D_WITH_TOPBAR                    0x018B
#define unicode_LATIN_SMALL_LETTER_D_WITH_TOPBAR                      0x018C
#define unicode_LATIN_SMALL_LETTER_TURNED_DELTA                       0x018D
#define unicode_LATIN_CAPITAL_LETTER_REVERSED_E                       0x018E
#define unicode_LATIN_CAPITAL_LETTER_SCHWA                            0x018F
#define unicode_LATIN_CAPITAL_LETTER_OPEN_E                           0x0190
#define unicode_LATIN_CAPITAL_LETTER_F_WITH_HOOK                      0x0191
#define unicode_LATIN_SMALL_LETTER_F_WITH_HOOK                        0x0192
#define unicode_LATIN_CAPITAL_LETTER_G_WITH_HOOK                      0x0193
#define unicode_LATIN_CAPITAL_LETTER_GAMMA                            0x0194
#define unicode_LATIN_SMALL_LETTER_HV                                 0x0195
#define unicode_LATIN_CAPITAL_LETTER_IOTA                             0x0196
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_STROKE                    0x0197
#define unicode_LATIN_CAPITAL_LETTER_K_WITH_HOOK                      0x0198
#define unicode_LATIN_SMALL_LETTER_K_WITH_HOOK                        0x0199
#define unicode_LATIN_SMALL_LETTER_L_WITH_BAR                         0x019A
#define unicode_LATIN_SMALL_LETTER_LAMBDA_WITH_STROKE                 0x019B
#define unicode_LATIN_CAPITAL_LETTER_TURNED_M                         0x019C
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_LEFT_HOOK                 0x019D
#define unicode_LATIN_SMALL_LETTER_N_WITH_LONG_RIGHT_LEG              0x019E
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_MIDDLE_TILDE              0x019F
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_HORN                      0x01A0
#define unicode_LATIN_SMALL_LETTER_O_WITH_HORN                        0x01A1
#define unicode_LATIN_CAPITAL_LETTER_OI                               0x01A2
#define unicode_LATIN_SMALL_LETTER_OI                                 0x01A3
#define unicode_LATIN_CAPITAL_LETTER_P_WITH_HOOK                      0x01A4
#define unicode_LATIN_SMALL_LETTER_P_WITH_HOOK                        0x01A5
#define unicode_LATIN_LETTER_YR                                       0x01A6
#define unicode_LATIN_CAPITAL_LETTER_TONE_TWO                         0x01A7
#define unicode_LATIN_SMALL_LETTER_TONE_TWO                           0x01A8
#define unicode_LATIN_CAPITAL_LETTER_ESH                              0x01A9
#define unicode_LATIN_LETTER_REVERSED_ESH_LOOP                        0x01AA
#define unicode_LATIN_SMALL_LETTER_T_WITH_PALATAL_HOOK                0x01AB
#define unicode_LATIN_CAPITAL_LETTER_T_WITH_HOOK                      0x01AC
#define unicode_LATIN_SMALL_LETTER_T_WITH_HOOK                        0x01AD
#define unicode_LATIN_CAPITAL_LETTER_T_WITH_RETROFLEX_HOOK            0x01AE
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_HORN                      0x01AF
#define unicode_LATIN_SMALL_LETTER_U_WITH_HORN                        0x01B0
#define unicode_LATIN_CAPITAL_LETTER_UPSILON                          0x01B1
#define unicode_LATIN_CAPITAL_LETTER_V_WITH_HOOK                      0x01B2
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_HOOK                      0x01B3
#define unicode_LATIN_SMALL_LETTER_Y_WITH_HOOK                        0x01B4
#define unicode_LATIN_CAPITAL_LETTER_Z_WITH_STROKE                    0x01B5
#define unicode_LATIN_SMALL_LETTER_Z_WITH_STROKE                      0x01B6
#define unicode_LATIN_CAPITAL_LETTER_EZH                              0x01B7
#define unicode_LATIN_CAPITAL_LETTER_EZH_REVERSED                     0x01B8
#define unicode_LATIN_SMALL_LETTER_EZH_REVERSED                       0x01B9
#define unicode_LATIN_SMALL_LETTER_EZH_WITH_TAIL                      0x01BA
#define unicode_LATIN_LETTER_TWO_WITH_STROKE                          0x01BB
#define unicode_LATIN_CAPITAL_LETTER_TONE_FIVE                        0x01BC
#define unicode_LATIN_SMALL_LETTER_TONE_FIVE                          0x01BD
#define unicode_LATIN_LETTER_INVERTED_GLOTTAL_STOP_WITH_STROKE        0x01BE
#define unicode_LATIN_LETTER_WYNN                                     0x01BF
#define unicode_LATIN_LETTER_DENTAL_CLICK                             0x01C0
#define unicode_LATIN_LETTER_LATERAL_CLICK                            0x01C1
#define unicode_LATIN_LETTER_ALVEOLAR_CLICK                           0x01C2
#define unicode_LATIN_LETTER_RETROFLEX_CLICK                          0x01C3
#define unicode_LATIN_CAPITAL_LETTER_DZ_WITH_CARON                    0x01C4
#define unicode_LATIN_CAPITAL_LETTER_D_WITH_SMALL_LETTER_Z_WITH_CARON 0x01C5
#define unicode_LATIN_SMALL_LETTER_DZ_WITH_CARON                      0x01C6
#define unicode_LATIN_CAPITAL_LETTER_LJ                               0x01C7
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_SMALL_LETTER_J            0x01C8
#define unicode_LATIN_SMALL_LETTER_LJ                                 0x01C9
#define unicode_LATIN_CAPITAL_LETTER_NJ                               0x01CA
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_SMALL_LETTER_J            0x01CB
#define unicode_LATIN_SMALL_LETTER_NJ                                 0x01CC
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_CARON                     0x01CD
#define unicode_LATIN_SMALL_LETTER_A_WITH_CARON                       0x01CE
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_CARON                     0x01CF
#define unicode_LATIN_SMALL_LETTER_I_WITH_CARON                       0x01D0
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_CARON                     0x01D1
#define unicode_LATIN_SMALL_LETTER_O_WITH_CARON                       0x01D2
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_CARON                     0x01D3
#define unicode_LATIN_SMALL_LETTER_U_WITH_CARON                       0x01D4
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_MACRON      0x01D5
#define unicode_LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_MACRON        0x01D6
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_ACUTE       0x01D7
#define unicode_LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_ACUTE         0x01D8
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_CARON       0x01D9
#define unicode_LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_CARON         0x01DA
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_GRAVE       0x01DB
#define unicode_LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_GRAVE         0x01DC
#define unicode_LATIN_SMALL_LETTER_TURNED_E                           0x01DD
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_DIAERESIS_AND_MACRON      0x01DE
#define unicode_LATIN_SMALL_LETTER_A_WITH_DIAERESIS_AND_MACRON        0x01DF
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_DOT_ABOVE_AND_MACRON      0x01E0
#define unicode_LATIN_SMALL_LETTER_A_WITH_DOT_ABOVE_AND_MACRON        0x01E1
#define unicode_LATIN_CAPITAL_LETTER_AE_WITH_MACRON                   0x01E2
#define unicode_LATIN_SMALL_LETTER_AE_WITH_MACRON                     0x01E3
#define unicode_LATIN_CAPITAL_LETTER_G_WITH_STROKE                    0x01E4
#define unicode_LATIN_SMALL_LETTER_G_WITH_STROKE                      0x01E5
#define unicode_LATIN_CAPITAL_LETTER_G_WITH_CARON                     0x01E6
#define unicode_LATIN_SMALL_LETTER_G_WITH_CARON                       0x01E7
#define unicode_LATIN_CAPITAL_LETTER_K_WITH_CARON                     0x01E8
#define unicode_LATIN_SMALL_LETTER_K_WITH_CARON                       0x01E9
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_OGONEK                    0x01EA
#define unicode_LATIN_SMALL_LETTER_O_WITH_OGONEK                      0x01EB
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_OGONEK_AND_MACRON         0x01EC
#define unicode_LATIN_SMALL_LETTER_O_WITH_OGONEK_AND_MACRON           0x01ED
#define unicode_LATIN_CAPITAL_LETTER_EZH_WITH_CARON                   0x01EE
#define unicode_LATIN_SMALL_LETTER_EZH_WITH_CARON                     0x01EF
#define unicode_LATIN_SMALL_LETTER_J_WITH_CARON                       0x01F0
#define unicode_LATIN_CAPITAL_LETTER_DZ                               0x01F1
#define unicode_LATIN_CAPITAL_LETTER_D_WITH_SMALL_LETTER_Z            0x01F2
#define unicode_LATIN_SMALL_LETTER_DZ                                 0x01F3
#define unicode_LATIN_CAPITAL_LETTER_G_WITH_ACUTE                     0x01F4
#define unicode_LATIN_SMALL_LETTER_G_WITH_ACUTE                       0x01F5
#define unicode_LATIN_CAPITAL_LETTER_HWAIR                            0x01F6
#define unicode_LATIN_CAPITAL_LETTER_WYNN                             0x01F7
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_GRAVE                     0x01F8
#define unicode_LATIN_SMALL_LETTER_N_WITH_GRAVE                       0x01F9
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_RING_ABOVE_AND_ACUTE      0x01FA
#define unicode_LATIN_SMALL_LETTER_A_WITH_RING_ABOVE_AND_ACUTE        0x01FB
#define unicode_LATIN_CAPITAL_LETTER_AE_WITH_ACUTE                    0x01FC
#define unicode_LATIN_SMALL_LETTER_AE_WITH_ACUTE                      0x01FD
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_STROKE_AND_ACUTE          0x01FE
#define unicode_LATIN_SMALL_LETTER_O_WITH_STROKE_AND_ACUTE            0x01FF
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_DOUBLE_GRAVE              0x0200
#define unicode_LATIN_SMALL_LETTER_A_WITH_DOUBLE_GRAVE                0x0201
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_INVERTED_BREVE            0x0202
#define unicode_LATIN_SMALL_LETTER_A_WITH_INVERTED_BREVE              0x0203
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_DOUBLE_GRAVE              0x0204
#define unicode_LATIN_SMALL_LETTER_E_WITH_DOUBLE_GRAVE                0x0205
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_INVERTED_BREVE            0x0206
#define unicode_LATIN_SMALL_LETTER_E_WITH_INVERTED_BREVE              0x0207
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_DOUBLE_GRAVE              0x0208
#define unicode_LATIN_SMALL_LETTER_I_WITH_DOUBLE_GRAVE                0x0209
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_INVERTED_BREVE            0x020A
#define unicode_LATIN_SMALL_LETTER_I_WITH_INVERTED_BREVE              0x020B
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_DOUBLE_GRAVE              0x020C
#define unicode_LATIN_SMALL_LETTER_O_WITH_DOUBLE_GRAVE                0x020D
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_INVERTED_BREVE            0x020E
#define unicode_LATIN_SMALL_LETTER_O_WITH_INVERTED_BREVE              0x020F
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_DOUBLE_GRAVE              0x0210
#define unicode_LATIN_SMALL_LETTER_R_WITH_DOUBLE_GRAVE                0x0211
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_INVERTED_BREVE            0x0212
#define unicode_LATIN_SMALL_LETTER_R_WITH_INVERTED_BREVE              0x0213
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_DOUBLE_GRAVE              0x0214
#define unicode_LATIN_SMALL_LETTER_U_WITH_DOUBLE_GRAVE                0x0215
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_INVERTED_BREVE            0x0216
#define unicode_LATIN_SMALL_LETTER_U_WITH_INVERTED_BREVE              0x0217
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_COMMA_BELOW               0x0218
#define unicode_LATIN_SMALL_LETTER_S_WITH_COMMA_BELOW                 0x0219
#define unicode_LATIN_CAPITAL_LETTER_T_WITH_COMMA_BELOW               0x021A
#define unicode_LATIN_SMALL_LETTER_T_WITH_COMMA_BELOW                 0x021B
#define unicode_LATIN_CAPITAL_LETTER_YOGH                             0x021C
#define unicode_LATIN_SMALL_LETTER_YOGH                               0x021D
#define unicode_LATIN_CAPITAL_LETTER_H_WITH_CARON                     0x021E
#define unicode_LATIN_SMALL_LETTER_H_WITH_CARON                       0x021F
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_LONG_RIGHT_LEG            0x0220
#define unicode_LATIN_SMALL_LETTER_D_WITH_CURL                        0x0221
#define unicode_LATIN_CAPITAL_LETTER_OU                               0x0222
#define unicode_LATIN_SMALL_LETTER_OU                                 0x0223
#define unicode_LATIN_CAPITAL_LETTER_Z_WITH_HOOK                      0x0224
#define unicode_LATIN_SMALL_LETTER_Z_WITH_HOOK                        0x0225
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_DOT_ABOVE                 0x0226
#define unicode_LATIN_SMALL_LETTER_A_WITH_DOT_ABOVE                   0x0227
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_CEDILLA                   0x0228
#define unicode_LATIN_SMALL_LETTER_E_WITH_CEDILLA                     0x0229
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_DIAERESIS_AND_MACRON      0x022A
#define unicode_LATIN_SMALL_LETTER_O_WITH_DIAERESIS_AND_MACRON        0x022B
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_TILDE_AND_MACRON          0x022C
#define unicode_LATIN_SMALL_LETTER_O_WITH_TILDE_AND_MACRON            0x022D
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_DOT_ABOVE                 0x022E
#define unicode_LATIN_SMALL_LETTER_O_WITH_DOT_ABOVE                   0x022F
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_DOT_ABOVE_AND_MACRON      0x0230
#define unicode_LATIN_SMALL_LETTER_O_WITH_DOT_ABOVE_AND_MACRON        0x0231
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_MACRON                    0x0232
#define unicode_LATIN_SMALL_LETTER_Y_WITH_MACRON                      0x0233
#define unicode_LATIN_SMALL_LETTER_L_WITH_CURL                        0x0234
#define unicode_LATIN_SMALL_LETTER_N_WITH_CURL                        0x0235
#define unicode_LATIN_SMALL_LETTER_T_WITH_CURL                        0x0236
#define unicode_LATIN_SMALL_LETTER_DOTLESS_J                          0x0237
#define unicode_LATIN_SMALL_LETTER_DB_DIGRAPH                         0x0238
#define unicode_LATIN_SMALL_LETTER_QP_DIGRAPH                         0x0239
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_STROKE                    0x023A
#define unicode_LATIN_CAPITAL_LETTER_C_WITH_STROKE                    0x023B
#define unicode_LATIN_SMALL_LETTER_C_WITH_STROKE                      0x023C
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_BAR                       0x023D
#define unicode_LATIN_CAPITAL_LETTER_T_WITH_DIAGONAL_STROKE           0x023E
#define unicode_LATIN_SMALL_LETTER_S_WITH_SWASH_TAIL                  0x023F
#define unicode_LATIN_SMALL_LETTER_Z_WITH_SWASH_TAIL                  0x0240
#define unicode_LATIN_CAPITAL_LETTER_GLOTTAL_STOP                     0x0241
#define unicode_LATIN_SMALL_LETTER_GLOTTAL_STOP                       0x0242
#define unicode_LATIN_CAPITAL_LETTER_B_WITH_STROKE                    0x0243
#define unicode_LATIN_CAPITAL_LETTER_U_BAR                            0x0244
#define unicode_LATIN_CAPITAL_LETTER_TURNED_V                         0x0245
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_STROKE                    0x0246
#define unicode_LATIN_SMALL_LETTER_E_WITH_STROKE                      0x0247
#define unicode_LATIN_CAPITAL_LETTER_J_WITH_STROKE                    0x0248
#define unicode_LATIN_SMALL_LETTER_J_WITH_STROKE                      0x0249
#define unicode_LATIN_CAPITAL_LETTER_SMALL_Q_WITH_HOOK_TAIL           0x024A
#define unicode_LATIN_SMALL_LETTER_Q_WITH_HOOK_TAIL                   0x024B
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_STROKE                    0x024C
#define unicode_LATIN_SMALL_LETTER_R_WITH_STROKE                      0x024D
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_STROKE                    0x024E
#define unicode_LATIN_SMALL_LETTER_Y_WITH_STROKE                      0x024F
#define unicode_LATIN_SMALL_LETTER_TURNED_A                           0x0250
#define unicode_LATIN_SMALL_LETTER_ALPHA                              0x0251
#define unicode_LATIN_SMALL_LETTER_TURNED_ALPHA                       0x0252
#define unicode_LATIN_SMALL_LETTER_B_WITH_HOOK                        0x0253
#define unicode_LATIN_SMALL_LETTER_OPEN_O                             0x0254
#define unicode_LATIN_SMALL_LETTER_C_WITH_CURL                        0x0255
#define unicode_LATIN_SMALL_LETTER_D_WITH_TAIL                        0x0256
#define unicode_LATIN_SMALL_LETTER_D_WITH_HOOK                        0x0257
#define unicode_LATIN_SMALL_LETTER_REVERSED_E                         0x0258
#define unicode_LATIN_SMALL_LETTER_SCHWA                              0x0259
#define unicode_LATIN_SMALL_LETTER_SCHWA_WITH_HOOK                    0x025A
#define unicode_LATIN_SMALL_LETTER_OPEN_E                             0x025B
#define unicode_LATIN_SMALL_LETTER_REVERSED_OPEN_E                    0x025C
#define unicode_LATIN_SMALL_LETTER_REVERSED_OPEN_E_WITH_HOOK          0x025D
#define unicode_LATIN_SMALL_LETTER_CLOSED_REVERSED_OPEN_E             0x025E
#define unicode_LATIN_SMALL_LETTER_DOTLESS_J_WITH_STROKE              0x025F
#define unicode_LATIN_SMALL_LETTER_G_WITH_HOOK                        0x0260
#define unicode_LATIN_SMALL_LETTER_SCRIPT_G                           0x0261
#define unicode_LATIN_LETTER_SMALL_CAPITAL_G                          0x0262
#define unicode_LATIN_SMALL_LETTER_GAMMA                              0x0263
#define unicode_LATIN_SMALL_LETTER_RAMS_HORN                          0x0264
#define unicode_LATIN_SMALL_LETTER_TURNED_H                           0x0265
#define unicode_LATIN_SMALL_LETTER_H_WITH_HOOK                        0x0266
#define unicode_LATIN_SMALL_LETTER_HENG_WITH_HOOK                     0x0267
#define unicode_LATIN_SMALL_LETTER_I_WITH_STROKE                      0x0268
#define unicode_LATIN_SMALL_LETTER_IOTA                               0x0269
#define unicode_LATIN_LETTER_SMALL_CAPITAL_I                          0x026A
#define unicode_LATIN_SMALL_LETTER_L_WITH_MIDDLE_TILDE                0x026B
#define unicode_LATIN_SMALL_LETTER_L_WITH_BELT                        0x026C
#define unicode_LATIN_SMALL_LETTER_L_WITH_RETROFLEX_HOOK              0x026D
#define unicode_LATIN_SMALL_LETTER_LEZH                               0x026E
#define unicode_LATIN_SMALL_LETTER_TURNED_M                           0x026F
#define unicode_LATIN_SMALL_LETTER_TURNED_M_WITH_LONG_LEG             0x0270
#define unicode_LATIN_SMALL_LETTER_M_WITH_HOOK                        0x0271
#define unicode_LATIN_SMALL_LETTER_N_WITH_LEFT_HOOK                   0x0272
#define unicode_LATIN_SMALL_LETTER_N_WITH_RETROFLEX_HOOK              0x0273
#define unicode_LATIN_LETTER_SMALL_CAPITAL_N                          0x0274
#define unicode_LATIN_SMALL_LETTER_BARRED_O                           0x0275
#define unicode_LATIN_LETTER_SMALL_CAPITAL_OE                         0x0276
#define unicode_LATIN_SMALL_LETTER_CLOSED_OMEGA                       0x0277
#define unicode_LATIN_SMALL_LETTER_PHI                                0x0278
#define unicode_LATIN_SMALL_LETTER_TURNED_R                           0x0279
#define unicode_LATIN_SMALL_LETTER_TURNED_R_WITH_LONG_LEG             0x027A
#define unicode_LATIN_SMALL_LETTER_TURNED_R_WITH_HOOK                 0x027B
#define unicode_LATIN_SMALL_LETTER_R_WITH_LONG_LEG                    0x027C
#define unicode_LATIN_SMALL_LETTER_R_WITH_TAIL                        0x027D
#define unicode_LATIN_SMALL_LETTER_R_WITH_FISHHOOK                    0x027E
#define unicode_LATIN_SMALL_LETTER_REVERSED_R_WITH_FISHHOOK           0x027F
#define unicode_LATIN_LETTER_SMALL_CAPITAL_R                          0x0280
#define unicode_LATIN_LETTER_SMALL_CAPITAL_INVERTED_R                 0x0281
#define unicode_LATIN_SMALL_LETTER_S_WITH_HOOK                        0x0282
#define unicode_LATIN_SMALL_LETTER_ESH                                0x0283
#define unicode_LATIN_SMALL_LETTER_DOTLESS_J_WITH_STROKE_AND_HOOK     0x0284
#define unicode_LATIN_SMALL_LETTER_SQUAT_REVERSED_ESH                 0x0285
#define unicode_LATIN_SMALL_LETTER_ESH_WITH_CURL                      0x0286
#define unicode_LATIN_SMALL_LETTER_TURNED_T                           0x0287
#define unicode_LATIN_SMALL_LETTER_T_WITH_RETROFLEX_HOOK              0x0288
#define unicode_LATIN_SMALL_LETTER_U_BAR                              0x0289
#define unicode_LATIN_SMALL_LETTER_UPSILON                            0x028A
#define unicode_LATIN_SMALL_LETTER_V_WITH_HOOK                        0x028B
#define unicode_LATIN_SMALL_LETTER_TURNED_V                           0x028C
#define unicode_LATIN_SMALL_LETTER_TURNED_W                           0x028D
#define unicode_LATIN_SMALL_LETTER_TURNED_Y                           0x028E
#define unicode_LATIN_LETTER_SMALL_CAPITAL_Y                          0x028F
#define unicode_LATIN_SMALL_LETTER_Z_WITH_RETROFLEX_HOOK              0x0290
#define unicode_LATIN_SMALL_LETTER_Z_WITH_CURL                        0x0291
#define unicode_LATIN_SMALL_LETTER_EZH                                0x0292
#define unicode_LATIN_SMALL_LETTER_EZH_WITH_CURL                      0x0293
#define unicode_LATIN_LETTER_GLOTTAL_STOP                             0x0294
#define unicode_LATIN_LETTER_PHARYNGEAL_VOICED_FRICATIVE              0x0295
#define unicode_LATIN_LETTER_INVERTED_GLOTTAL_STOP                    0x0296
#define unicode_LATIN_LETTER_STRETCHED_C                              0x0297
#define unicode_LATIN_LETTER_BILABIAL_CLICK                           0x0298
#define unicode_LATIN_LETTER_SMALL_CAPITAL_B                          0x0299
#define unicode_LATIN_SMALL_LETTER_CLOSED_OPEN_E                      0x029A
#define unicode_LATIN_LETTER_SMALL_CAPITAL_G_WITH_HOOK                0x029B
#define unicode_LATIN_LETTER_SMALL_CAPITAL_H                          0x029C
#define unicode_LATIN_SMALL_LETTER_J_WITH_CROSSED_TAIL                0x029D
#define unicode_LATIN_SMALL_LETTER_TURNED_K                           0x029E
#define unicode_LATIN_LETTER_SMALL_CAPITAL_L                          0x029F
#define unicode_LATIN_SMALL_LETTER_Q_WITH_HOOK                        0x02A0
#define unicode_LATIN_LETTER_GLOTTAL_STOP_WITH_STROKE                 0x02A1
#define unicode_LATIN_LETTER_REVERSED_GLOTTAL_STOP_WITH_STROKE        0x02A2
#define unicode_LATIN_SMALL_LETTER_DZ_DIGRAPH                         0x02A3
#define unicode_LATIN_SMALL_LETTER_DEZH_DIGRAPH                       0x02A4
#define unicode_LATIN_SMALL_LETTER_DZ_DIGRAPH_WITH_CURL               0x02A5
#define unicode_LATIN_SMALL_LETTER_TS_DIGRAPH                         0x02A6
#define unicode_LATIN_SMALL_LETTER_TESH_DIGRAPH                       0x02A7
#define unicode_LATIN_SMALL_LETTER_TC_DIGRAPH_WITH_CURL               0x02A8
#define unicode_LATIN_SMALL_LETTER_FENG_DIGRAPH                       0x02A9
#define unicode_LATIN_SMALL_LETTER_LS_DIGRAPH                         0x02AA
#define unicode_LATIN_SMALL_LETTER_LZ_DIGRAPH                         0x02AB
#define unicode_LATIN_LETTER_BILABIAL_PERCUSSIVE                      0x02AC
#define unicode_LATIN_LETTER_BIDENTAL_PERCUSSIVE                      0x02AD
#define unicode_LATIN_SMALL_LETTER_TURNED_H_WITH_FISHHOOK             0x02AE
#define unicode_LATIN_SMALL_LETTER_TURNED_H_WITH_FISHHOOK_AND_TAIL    0x02AF
#define unicode_MODIFIER_LETTER_SMALL_H                               0x02B0
#define unicode_MODIFIER_LETTER_SMALL_H_WITH_HOOK                     0x02B1
#define unicode_MODIFIER_LETTER_SMALL_J                               0x02B2
#define unicode_MODIFIER_LETTER_SMALL_R                               0x02B3
#define unicode_MODIFIER_LETTER_SMALL_TURNED_R                        0x02B4
#define unicode_MODIFIER_LETTER_SMALL_TURNED_R_WITH_HOOK              0x02B5
#define unicode_MODIFIER_LETTER_SMALL_CAPITAL_INVERTED_R              0x02B6
#define unicode_MODIFIER_LETTER_SMALL_W                               0x02B7
#define unicode_MODIFIER_LETTER_SMALL_Y                               0x02B8
#define unicode_MODIFIER_LETTER_PRIME                                 0x02B9
#define unicode_MODIFIER_LETTER_DOUBLE_PRIME                          0x02BA
#define unicode_MODIFIER_LETTER_TURNED_COMMA                          0x02BB
#define unicode_MODIFIER_LETTER_APOSTROPHE                            0x02BC
#define unicode_MODIFIER_LETTER_REVERSED_COMMA                        0x02BD
#define unicode_MODIFIER_LETTER_RIGHT_HALF_RING                       0x02BE
#define unicode_MODIFIER_LETTER_LEFT_HALF_RING                        0x02BF
#define unicode_MODIFIER_LETTER_GLOTTAL_STOP                          0x02C0
#define unicode_MODIFIER_LETTER_REVERSED_GLOTTAL_STOP                 0x02C1
#define unicode_MODIFIER_LETTER_LEFT_ARROWHEAD                        0x02C2
#define unicode_MODIFIER_LETTER_RIGHT_ARROWHEAD                       0x02C3
#define unicode_MODIFIER_LETTER_UP_ARROWHEAD                          0x02C4
#define unicode_MODIFIER_LETTER_DOWN_ARROWHEAD                        0x02C5
#define unicode_MODIFIER_LETTER_CIRCUMFLEX_ACCENT                     0x02C6
#define unicode_CARON                                                 0x02C7
#define unicode_MODIFIER_LETTER_VERTICAL_LINE                         0x02C8
#define unicode_MODIFIER_LETTER_MACRON                                0x02C9
#define unicode_MODIFIER_LETTER_ACUTE_ACCENT                          0x02CA
#define unicode_MODIFIER_LETTER_GRAVE_ACCENT                          0x02CB
#define unicode_MODIFIER_LETTER_LOW_VERTICAL_LINE                     0x02CC
#define unicode_MODIFIER_LETTER_LOW_MACRON                            0x02CD
#define unicode_MODIFIER_LETTER_LOW_GRAVE_ACCENT                      0x02CE
#define unicode_MODIFIER_LETTER_LOW_ACUTE_ACCENT                      0x02CF
#define unicode_MODIFIER_LETTER_TRIANGULAR_COLON                      0x02D0
#define unicode_MODIFIER_LETTER_HALF_TRIANGULAR_COLON                 0x02D1
#define unicode_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING               0x02D2
#define unicode_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING                0x02D3
#define unicode_MODIFIER_LETTER_UP_TACK                               0x02D4
#define unicode_MODIFIER_LETTER_DOWN_TACK                             0x02D5
#define unicode_MODIFIER_LETTER_PLUS_SIGN                             0x02D6
#define unicode_MODIFIER_LETTER_MINUS_SIGN                            0x02D7
#define unicode_BREVE                                                 0x02D8
#define unicode_DOT_ABOVE                                             0x02D9
#define unicode_RING_ABOVE                                            0x02DA
#define unicode_OGONEK                                                0x02DB
#define unicode_SMALL_TILDE                                           0x02DC
#define unicode_DOUBLE_ACUTE_ACCENT                                   0x02DD
#define unicode_MODIFIER_LETTER_RHOTIC_HOOK                           0x02DE
#define unicode_MODIFIER_LETTER_CROSS_ACCENT                          0x02DF
#define unicode_MODIFIER_LETTER_SMALL_GAMMA                           0x02E0
#define unicode_MODIFIER_LETTER_SMALL_L                               0x02E1
#define unicode_MODIFIER_LETTER_SMALL_S                               0x02E2
#define unicode_MODIFIER_LETTER_SMALL_X                               0x02E3
#define unicode_MODIFIER_LETTER_SMALL_REVERSED_GLOTTAL_STOP           0x02E4
#define unicode_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR                   0x02E5
#define unicode_MODIFIER_LETTER_HIGH_TONE_BAR                         0x02E6
#define unicode_MODIFIER_LETTER_MID_TONE_BAR                          0x02E7
#define unicode_MODIFIER_LETTER_LOW_TONE_BAR                          0x02E8
#define unicode_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR                    0x02E9
#define unicode_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK               0x02EA
#define unicode_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK              0x02EB
#define unicode_MODIFIER_LETTER_VOICING                               0x02EC
#define unicode_MODIFIER_LETTER_UNASPIRATED                           0x02ED
#define unicode_MODIFIER_LETTER_DOUBLE_APOSTROPHE                     0x02EE
#define unicode_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD                    0x02EF
#define unicode_MODIFIER_LETTER_LOW_UP_ARROWHEAD                      0x02F0
#define unicode_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD                    0x02F1
#define unicode_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD                   0x02F2
#define unicode_MODIFIER_LETTER_LOW_RING                              0x02F3
#define unicode_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT                   0x02F4
#define unicode_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT            0x02F5
#define unicode_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT            0x02F6
#define unicode_MODIFIER_LETTER_LOW_TILDE                             0x02F7
#define unicode_MODIFIER_LETTER_RAISED_COLON                          0x02F8
#define unicode_MODIFIER_LETTER_BEGIN_HIGH_TONE                       0x02F9
#define unicode_MODIFIER_LETTER_END_HIGH_TONE                         0x02FA
#define unicode_MODIFIER_LETTER_BEGIN_LOW_TONE                        0x02FB
#define unicode_MODIFIER_LETTER_END_LOW_TONE                          0x02FC
#define unicode_MODIFIER_LETTER_SHELF                                 0x02FD
#define unicode_MODIFIER_LETTER_OPEN_SHELF                            0x02FE
#define unicode_MODIFIER_LETTER_LOW_LEFT_ARROW                        0x02FF
#define unicode_COMBINING_GRAVE_ACCENT                                0x0300
#define unicode_COMBINING_ACUTE_ACCENT                                0x0301
#define unicode_COMBINING_CIRCUMFLEX_ACCENT                           0x0302
#define unicode_COMBINING_TILDE                                       0x0303
#define unicode_COMBINING_MACRON                                      0x0304
#define unicode_COMBINING_OVERLINE                                    0x0305
#define unicode_COMBINING_BREVE                                       0x0306
#define unicode_COMBINING_DOT_ABOVE                                   0x0307
#define unicode_COMBINING_DIAERESIS                                   0x0308
#define unicode_COMBINING_HOOK_ABOVE                                  0x0309
#define unicode_COMBINING_RING_ABOVE                                  0x030A
#define unicode_COMBINING_DOUBLE_ACUTE_ACCENT                         0x030B
#define unicode_COMBINING_CARON                                       0x030C
#define unicode_COMBINING_VERTICAL_LINE_ABOVE                         0x030D
#define unicode_COMBINING_DOUBLE_VERTICAL_LINE_ABOVE                  0x030E
#define unicode_COMBINING_DOUBLE_GRAVE_ACCENT                         0x030F
#define unicode_COMBINING_CANDRABINDU                                 0x0310
#define unicode_COMBINING_INVERTED_BREVE                              0x0311
#define unicode_COMBINING_TURNED_COMMA_ABOVE                          0x0312
#define unicode_COMBINING_COMMA_ABOVE                                 0x0313
#define unicode_COMBINING_REVERSED_COMMA_ABOVE                        0x0314
#define unicode_COMBINING_COMMA_ABOVE_RIGHT                           0x0315
#define unicode_COMBINING_GRAVE_ACCENT_BELOW                          0x0316
#define unicode_COMBINING_ACUTE_ACCENT_BELOW                          0x0317
#define unicode_COMBINING_LEFT_TACK_BELOW                             0x0318
#define unicode_COMBINING_RIGHT_TACK_BELOW                            0x0319
#define unicode_COMBINING_LEFT_ANGLE_ABOVE                            0x031A
#define unicode_COMBINING_HORN                                        0x031B
#define unicode_COMBINING_LEFT_HALF_RING_BELOW                        0x031C
#define unicode_COMBINING_UP_TACK_BELOW                               0x031D
#define unicode_COMBINING_DOWN_TACK_BELOW                             0x031E
#define unicode_COMBINING_PLUS_SIGN_BELOW                             0x031F
#define unicode_COMBINING_MINUS_SIGN_BELOW                            0x0320
#define unicode_COMBINING_PALATALIZED_HOOK_BELOW                      0x0321
#define unicode_COMBINING_RETROFLEX_HOOK_BELOW                        0x0322
#define unicode_COMBINING_DOT_BELOW                                   0x0323
#define unicode_COMBINING_DIAERESIS_BELOW                             0x0324
#define unicode_COMBINING_RING_BELOW                                  0x0325
#define unicode_COMBINING_COMMA_BELOW                                 0x0326
#define unicode_COMBINING_CEDILLA                                     0x0327
#define unicode_COMBINING_OGONEK                                      0x0328
#define unicode_COMBINING_VERTICAL_LINE_BELOW                         0x0329
#define unicode_COMBINING_BRIDGE_BELOW                                0x032A
#define unicode_COMBINING_INVERTED_DOUBLE_ARCH_BELOW                  0x032B
#define unicode_COMBINING_CARON_BELOW                                 0x032C
#define unicode_COMBINING_CIRCUMFLEX_ACCENT_BELOW                     0x032D
#define unicode_COMBINING_BREVE_BELOW                                 0x032E
#define unicode_COMBINING_INVERTED_BREVE_BELOW                        0x032F
#define unicode_COMBINING_TILDE_BELOW                                 0x0330
#define unicode_COMBINING_MACRON_BELOW                                0x0331
#define unicode_COMBINING_LOW_LINE                                    0x0332
#define unicode_COMBINING_DOUBLE_LOW_LINE                             0x0333
#define unicode_COMBINING_TILDE_OVERLAY                               0x0334
#define unicode_COMBINING_SHORT_STROKE_OVERLAY                        0x0335
#define unicode_COMBINING_LONG_STROKE_OVERLAY                         0x0336
#define unicode_COMBINING_SHORT_SOLIDUS_OVERLAY                       0x0337
#define unicode_COMBINING_LONG_SOLIDUS_OVERLAY                        0x0338
#define unicode_COMBINING_RIGHT_HALF_RING_BELOW                       0x0339
#define unicode_COMBINING_INVERTED_BRIDGE_BELOW                       0x033A
#define unicode_COMBINING_SQUARE_BELOW                                0x033B
#define unicode_COMBINING_SEAGULL_BELOW                               0x033C
#define unicode_COMBINING_X_ABOVE                                     0x033D
#define unicode_COMBINING_VERTICAL_TILDE                              0x033E
#define unicode_COMBINING_DOUBLE_OVERLINE                             0x033F
#define unicode_COMBINING_GRAVE_TONE_MARK                             0x0340
#define unicode_COMBINING_ACUTE_TONE_MARK                             0x0341
#define unicode_COMBINING_GREEK_PERISPOMENI                           0x0342
#define unicode_COMBINING_GREEK_KORONIS                               0x0343
#define unicode_COMBINING_GREEK_DIALYTIKA_TONOS                       0x0344
#define unicode_COMBINING_GREEK_YPOGEGRAMMENI                         0x0345
#define unicode_COMBINING_BRIDGE_ABOVE                                0x0346
#define unicode_COMBINING_EQUALS_SIGN_BELOW                           0x0347
#define unicode_COMBINING_DOUBLE_VERTICAL_LINE_BELOW                  0x0348
#define unicode_COMBINING_LEFT_ANGLE_BELOW                            0x0349
#define unicode_COMBINING_NOT_TILDE_ABOVE                             0x034A
#define unicode_COMBINING_HOMOTHETIC_ABOVE                            0x034B
#define unicode_COMBINING_ALMOST_EQUAL_TO_ABOVE                       0x034C
#define unicode_COMBINING_LEFT_RIGHT_ARROW_BELOW                      0x034D
#define unicode_COMBINING_UPWARDS_ARROW_BELOW                         0x034E
#define unicode_COMBINING_GRAPHEME_JOINER                             0x034F
#define unicode_COMBINING_RIGHT_ARROWHEAD_ABOVE                       0x0350
#define unicode_COMBINING_LEFT_HALF_RING_ABOVE                        0x0351
#define unicode_COMBINING_FERMATA                                     0x0352
#define unicode_COMBINING_X_BELOW                                     0x0353
#define unicode_COMBINING_LEFT_ARROWHEAD_BELOW                        0x0354
#define unicode_COMBINING_RIGHT_ARROWHEAD_BELOW                       0x0355
#define unicode_COMBINING_RIGHT_ARROWHEAD_AND_UP_ARROWHEAD_BELOW      0x0356
#define unicode_COMBINING_RIGHT_HALF_RING_ABOVE                       0x0357
#define unicode_COMBINING_DOT_ABOVE_RIGHT                             0x0358
#define unicode_COMBINING_ASTERISK_BELOW                              0x0359
#define unicode_COMBINING_DOUBLE_RING_BELOW                           0x035A
#define unicode_COMBINING_ZIGZAG_ABOVE                                0x035B
#define unicode_COMBINING_DOUBLE_BREVE_BELOW                          0x035C
#define unicode_COMBINING_DOUBLE_BREVE                                0x035D
#define unicode_COMBINING_DOUBLE_MACRON                               0x035E
#define unicode_COMBINING_DOUBLE_MACRON_BELOW                         0x035F
#define unicode_COMBINING_DOUBLE_TILDE                                0x0360
#define unicode_COMBINING_DOUBLE_INVERTED_BREVE                       0x0361
#define unicode_COMBINING_DOUBLE_RIGHTWARDS_ARROW_BELOW               0x0362
#define unicode_COMBINING_LATIN_SMALL_LETTER_A                        0x0363
#define unicode_COMBINING_LATIN_SMALL_LETTER_E                        0x0364
#define unicode_COMBINING_LATIN_SMALL_LETTER_I                        0x0365
#define unicode_COMBINING_LATIN_SMALL_LETTER_O                        0x0366
#define unicode_COMBINING_LATIN_SMALL_LETTER_U                        0x0367
#define unicode_COMBINING_LATIN_SMALL_LETTER_C                        0x0368
#define unicode_COMBINING_LATIN_SMALL_LETTER_D                        0x0369
#define unicode_COMBINING_LATIN_SMALL_LETTER_H                        0x036A
#define unicode_COMBINING_LATIN_SMALL_LETTER_M                        0x036B
#define unicode_COMBINING_LATIN_SMALL_LETTER_R                        0x036C
#define unicode_COMBINING_LATIN_SMALL_LETTER_T                        0x036D
#define unicode_COMBINING_LATIN_SMALL_LETTER_V                        0x036E
#define unicode_COMBINING_LATIN_SMALL_LETTER_X                        0x036F
#define unicode_GREEK_CAPITAL_LETTER_HETA                             0x0370
#define unicode_GREEK_SMALL_LETTER_HETA                               0x0371
#define unicode_GREEK_CAPITAL_LETTER_ARCHAIC_SAMPI                    0x0372
#define unicode_GREEK_SMALL_LETTER_ARCHAIC_SAMPI                      0x0373
#define unicode_GREEK_NUMERAL_SIGN                                    0x0374
#define unicode_GREEK_LOWER_NUMERAL_SIGN                              0x0375
#define unicode_GREEK_CAPITAL_LETTER_PAMPHYLIAN_DIGAMMA               0x0376
#define unicode_GREEK_SMALL_LETTER_PAMPHYLIAN_DIGAMMA                 0x0377
#define unicode_GREEK_YPOGEGRAMMENI                                   0x037A
#define unicode_GREEK_SMALL_REVERSED_LUNATE_SIGMA_SYMBOL              0x037B
#define unicode_GREEK_SMALL_DOTTED_LUNATE_SIGMA_SYMBOL                0x037C
#define unicode_GREEK_SMALL_REVERSED_DOTTED_LUNATE_SIGMA_SYMBOL       0x037D
#define unicode_GREEK_QUESTION_MARK                                   0x037E
#define unicode_GREEK_CAPITAL_LETTER_YOT                              0x037F
#define unicode_GREEK_TONOS                                           0x0384
#define unicode_GREEK_DIALYTIKA_TONOS                                 0x0385
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_TONOS                 0x0386
#define unicode_GREEK_ANO_TELEIA                                      0x0387
#define unicode_GREEK_CAPITAL_LETTER_EPSILON_WITH_TONOS               0x0388
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_TONOS                   0x0389
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_TONOS                  0x038A
#define unicode_GREEK_CAPITAL_LETTER_OMICRON_WITH_TONOS               0x038C
#define unicode_GREEK_CAPITAL_LETTER_UPSILON_WITH_TONOS               0x038E
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_TONOS                 0x038F
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_TONOS      0x0390
#define unicode_GREEK_CAPITAL_LETTER_ALPHA                            0x0391
#define unicode_GREEK_CAPITAL_LETTER_BETA                             0x0392
#define unicode_GREEK_CAPITAL_LETTER_GAMMA                            0x0393
#define unicode_GREEK_CAPITAL_LETTER_DELTA                            0x0394
#define unicode_GREEK_CAPITAL_LETTER_EPSILON                          0x0395
#define unicode_GREEK_CAPITAL_LETTER_ZETA                             0x0396
#define unicode_GREEK_CAPITAL_LETTER_ETA                              0x0397
#define unicode_GREEK_CAPITAL_LETTER_THETA                            0x0398
#define unicode_GREEK_CAPITAL_LETTER_IOTA                             0x0399
#define unicode_GREEK_CAPITAL_LETTER_KAPPA                            0x039A
#define unicode_GREEK_CAPITAL_LETTER_LAMDA                            0x039B
#define unicode_GREEK_CAPITAL_LETTER_MU                               0x039C
#define unicode_GREEK_CAPITAL_LETTER_NU                               0x039D
#define unicode_GREEK_CAPITAL_LETTER_XI                               0x039E
#define unicode_GREEK_CAPITAL_LETTER_OMICRON                          0x039F
#define unicode_GREEK_CAPITAL_LETTER_PI                               0x03A0
#define unicode_GREEK_CAPITAL_LETTER_RHO                              0x03A1
#define unicode_GREEK_CAPITAL_LETTER_SIGMA                            0x03A3
#define unicode_GREEK_CAPITAL_LETTER_TAU                              0x03A4
#define unicode_GREEK_CAPITAL_LETTER_UPSILON                          0x03A5
#define unicode_GREEK_CAPITAL_LETTER_PHI                              0x03A6
#define unicode_GREEK_CAPITAL_LETTER_CHI                              0x03A7
#define unicode_GREEK_CAPITAL_LETTER_PSI                              0x03A8
#define unicode_GREEK_CAPITAL_LETTER_OMEGA                            0x03A9
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_DIALYTIKA              0x03AA
#define unicode_GREEK_CAPITAL_LETTER_UPSILON_WITH_DIALYTIKA           0x03AB
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_TONOS                   0x03AC
#define unicode_GREEK_SMALL_LETTER_EPSILON_WITH_TONOS                 0x03AD
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_TONOS                     0x03AE
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_TONOS                    0x03AF
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_TONOS   0x03B0
#define unicode_GREEK_SMALL_LETTER_ALPHA                              0x03B1
#define unicode_GREEK_SMALL_LETTER_BETA                               0x03B2
#define unicode_GREEK_SMALL_LETTER_GAMMA                              0x03B3
#define unicode_GREEK_SMALL_LETTER_DELTA                              0x03B4
#define unicode_GREEK_SMALL_LETTER_EPSILON                            0x03B5
#define unicode_GREEK_SMALL_LETTER_ZETA                               0x03B6
#define unicode_GREEK_SMALL_LETTER_ETA                                0x03B7
#define unicode_GREEK_SMALL_LETTER_THETA                              0x03B8
#define unicode_GREEK_SMALL_LETTER_IOTA                               0x03B9
#define unicode_GREEK_SMALL_LETTER_KAPPA                              0x03BA
#define unicode_GREEK_SMALL_LETTER_LAMDA                              0x03BB
#define unicode_GREEK_SMALL_LETTER_MU                                 0x03BC
#define unicode_GREEK_SMALL_LETTER_NU                                 0x03BD
#define unicode_GREEK_SMALL_LETTER_XI                                 0x03BE
#define unicode_GREEK_SMALL_LETTER_OMICRON                            0x03BF
#define unicode_GREEK_SMALL_LETTER_PI                                 0x03C0
#define unicode_GREEK_SMALL_LETTER_RHO                                0x03C1
#define unicode_GREEK_SMALL_LETTER_FINAL_SIGMA                        0x03C2
#define unicode_GREEK_SMALL_LETTER_SIGMA                              0x03C3
#define unicode_GREEK_SMALL_LETTER_TAU                                0x03C4
#define unicode_GREEK_SMALL_LETTER_UPSILON                            0x03C5
#define unicode_GREEK_SMALL_LETTER_PHI                                0x03C6
#define unicode_GREEK_SMALL_LETTER_CHI                                0x03C7
#define unicode_GREEK_SMALL_LETTER_PSI                                0x03C8
#define unicode_GREEK_SMALL_LETTER_OMEGA                              0x03C9
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA                0x03CA
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA             0x03CB
#define unicode_GREEK_SMALL_LETTER_OMICRON_WITH_TONOS                 0x03CC
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_TONOS                 0x03CD
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_TONOS                   0x03CE
#define unicode_GREEK_CAPITAL_KAI_SYMBOL                              0x03CF
#define unicode_GREEK_BETA_SYMBOL                                     0x03D0
#define unicode_GREEK_THETA_SYMBOL                                    0x03D1
#define unicode_GREEK_UPSILON_WITH_HOOK_SYMBOL                        0x03D2
#define unicode_GREEK_UPSILON_WITH_ACUTE_AND_HOOK_SYMBOL              0x03D3
#define unicode_GREEK_UPSILON_WITH_DIAERESIS_AND_HOOK_SYMBOL          0x03D4
#define unicode_GREEK_PHI_SYMBOL                                      0x03D5
#define unicode_GREEK_PI_SYMBOL                                       0x03D6
#define unicode_GREEK_KAI_SYMBOL                                      0x03D7
#define unicode_GREEK_LETTER_ARCHAIC_KOPPA                            0x03D8
#define unicode_GREEK_SMALL_LETTER_ARCHAIC_KOPPA                      0x03D9
#define unicode_GREEK_LETTER_STIGMA                                   0x03DA
#define unicode_GREEK_SMALL_LETTER_STIGMA                             0x03DB
#define unicode_GREEK_LETTER_DIGAMMA                                  0x03DC
#define unicode_GREEK_SMALL_LETTER_DIGAMMA                            0x03DD
#define unicode_GREEK_LETTER_KOPPA                                    0x03DE
#define unicode_GREEK_SMALL_LETTER_KOPPA                              0x03DF
#define unicode_GREEK_LETTER_SAMPI                                    0x03E0
#define unicode_GREEK_SMALL_LETTER_SAMPI                              0x03E1
#define unicode_COPTIC_CAPITAL_LETTER_SHEI                            0x03E2
#define unicode_COPTIC_SMALL_LETTER_SHEI                              0x03E3
#define unicode_COPTIC_CAPITAL_LETTER_FEI                             0x03E4
#define unicode_COPTIC_SMALL_LETTER_FEI                               0x03E5
#define unicode_COPTIC_CAPITAL_LETTER_KHEI                            0x03E6
#define unicode_COPTIC_SMALL_LETTER_KHEI                              0x03E7
#define unicode_COPTIC_CAPITAL_LETTER_HORI                            0x03E8
#define unicode_COPTIC_SMALL_LETTER_HORI                              0x03E9
#define unicode_COPTIC_CAPITAL_LETTER_GANGIA                          0x03EA
#define unicode_COPTIC_SMALL_LETTER_GANGIA                            0x03EB
#define unicode_COPTIC_CAPITAL_LETTER_SHIMA                           0x03EC
#define unicode_COPTIC_SMALL_LETTER_SHIMA                             0x03ED
#define unicode_COPTIC_CAPITAL_LETTER_DEI                             0x03EE
#define unicode_COPTIC_SMALL_LETTER_DEI                               0x03EF
#define unicode_GREEK_KAPPA_SYMBOL                                    0x03F0
#define unicode_GREEK_RHO_SYMBOL                                      0x03F1
#define unicode_GREEK_LUNATE_SIGMA_SYMBOL                             0x03F2
#define unicode_GREEK_LETTER_YOT                                      0x03F3
#define unicode_GREEK_CAPITAL_THETA_SYMBOL                            0x03F4
#define unicode_GREEK_LUNATE_EPSILON_SYMBOL                           0x03F5
#define unicode_GREEK_REVERSED_LUNATE_EPSILON_SYMBOL                  0x03F6
#define unicode_GREEK_CAPITAL_LETTER_SHO                              0x03F7
#define unicode_GREEK_SMALL_LETTER_SHO                                0x03F8
#define unicode_GREEK_CAPITAL_LUNATE_SIGMA_SYMBOL                     0x03F9
#define unicode_GREEK_CAPITAL_LETTER_SAN                              0x03FA
#define unicode_GREEK_SMALL_LETTER_SAN                                0x03FB
#define unicode_GREEK_RHO_WITH_STROKE_SYMBOL                          0x03FC
#define unicode_GREEK_CAPITAL_REVERSED_LUNATE_SIGMA_SYMBOL            0x03FD
#define unicode_GREEK_CAPITAL_DOTTED_LUNATE_SIGMA_SYMBOL              0x03FE
#define unicode_GREEK_CAPITAL_REVERSED_DOTTED_LUNATE_SIGMA_SYMBOL     0x03FF
#define unicode_CYRILLIC_CAPITAL_LETTER_IE_WITH_GRAVE                 0x0400
#define unicode_CYRILLIC_CAPITAL_LETTER_IO                            0x0401
#define unicode_CYRILLIC_CAPITAL_LETTER_DJE                           0x0402
#define unicode_CYRILLIC_CAPITAL_LETTER_GJE                           0x0403
#define unicode_CYRILLIC_CAPITAL_LETTER_UKRAINIAN_IE                  0x0404
#define unicode_CYRILLIC_CAPITAL_LETTER_DZE                           0x0405
#define unicode_CYRILLIC_CAPITAL_LETTER_BYELORUSSIAN_UKRAINIAN_I      0x0406
#define unicode_CYRILLIC_CAPITAL_LETTER_YI                            0x0407
#define unicode_CYRILLIC_CAPITAL_LETTER_JE                            0x0408
#define unicode_CYRILLIC_CAPITAL_LETTER_LJE                           0x0409
#define unicode_CYRILLIC_CAPITAL_LETTER_NJE                           0x040A
#define unicode_CYRILLIC_CAPITAL_LETTER_TSHE                          0x040B
#define unicode_CYRILLIC_CAPITAL_LETTER_KJE                           0x040C
#define unicode_CYRILLIC_CAPITAL_LETTER_I_WITH_GRAVE                  0x040D
#define unicode_CYRILLIC_CAPITAL_LETTER_SHORT_U                       0x040E
#define unicode_CYRILLIC_CAPITAL_LETTER_DZHE                          0x040F
#define unicode_CYRILLIC_CAPITAL_LETTER_A                             0x0410
#define unicode_CYRILLIC_CAPITAL_LETTER_BE                            0x0411
#define unicode_CYRILLIC_CAPITAL_LETTER_VE                            0x0412
#define unicode_CYRILLIC_CAPITAL_LETTER_GHE                           0x0413
#define unicode_CYRILLIC_CAPITAL_LETTER_DE                            0x0414
#define unicode_CYRILLIC_CAPITAL_LETTER_IE                            0x0415
#define unicode_CYRILLIC_CAPITAL_LETTER_ZHE                           0x0416
#define unicode_CYRILLIC_CAPITAL_LETTER_ZE                            0x0417
#define unicode_CYRILLIC_CAPITAL_LETTER_I                             0x0418
#define unicode_CYRILLIC_CAPITAL_LETTER_SHORT_I                       0x0419
#define unicode_CYRILLIC_CAPITAL_LETTER_KA                            0x041A
#define unicode_CYRILLIC_CAPITAL_LETTER_EL                            0x041B
#define unicode_CYRILLIC_CAPITAL_LETTER_EM                            0x041C
#define unicode_CYRILLIC_CAPITAL_LETTER_EN                            0x041D
#define unicode_CYRILLIC_CAPITAL_LETTER_O                             0x041E
#define unicode_CYRILLIC_CAPITAL_LETTER_PE                            0x041F
#define unicode_CYRILLIC_CAPITAL_LETTER_ER                            0x0420
#define unicode_CYRILLIC_CAPITAL_LETTER_ES                            0x0421
#define unicode_CYRILLIC_CAPITAL_LETTER_TE                            0x0422
#define unicode_CYRILLIC_CAPITAL_LETTER_U                             0x0423
#define unicode_CYRILLIC_CAPITAL_LETTER_EF                            0x0424
#define unicode_CYRILLIC_CAPITAL_LETTER_HA                            0x0425
#define unicode_CYRILLIC_CAPITAL_LETTER_TSE                           0x0426
#define unicode_CYRILLIC_CAPITAL_LETTER_CHE                           0x0427
#define unicode_CYRILLIC_CAPITAL_LETTER_SHA                           0x0428
#define unicode_CYRILLIC_CAPITAL_LETTER_SHCHA                         0x0429
#define unicode_CYRILLIC_CAPITAL_LETTER_HARD_SIGN                     0x042A
#define unicode_CYRILLIC_CAPITAL_LETTER_YERU                          0x042B
#define unicode_CYRILLIC_CAPITAL_LETTER_SOFT_SIGN                     0x042C
#define unicode_CYRILLIC_CAPITAL_LETTER_E                             0x042D
#define unicode_CYRILLIC_CAPITAL_LETTER_YU                            0x042E
#define unicode_CYRILLIC_CAPITAL_LETTER_YA                            0x042F
#define unicode_CYRILLIC_SMALL_LETTER_A                               0x0430
#define unicode_CYRILLIC_SMALL_LETTER_BE                              0x0431
#define unicode_CYRILLIC_SMALL_LETTER_VE                              0x0432
#define unicode_CYRILLIC_SMALL_LETTER_GHE                             0x0433
#define unicode_CYRILLIC_SMALL_LETTER_DE                              0x0434
#define unicode_CYRILLIC_SMALL_LETTER_IE                              0x0435
#define unicode_CYRILLIC_SMALL_LETTER_ZHE                             0x0436
#define unicode_CYRILLIC_SMALL_LETTER_ZE                              0x0437
#define unicode_CYRILLIC_SMALL_LETTER_I                               0x0438
#define unicode_CYRILLIC_SMALL_LETTER_SHORT_I                         0x0439
#define unicode_CYRILLIC_SMALL_LETTER_KA                              0x043A
#define unicode_CYRILLIC_SMALL_LETTER_EL                              0x043B
#define unicode_CYRILLIC_SMALL_LETTER_EM                              0x043C
#define unicode_CYRILLIC_SMALL_LETTER_EN                              0x043D
#define unicode_CYRILLIC_SMALL_LETTER_O                               0x043E
#define unicode_CYRILLIC_SMALL_LETTER_PE                              0x043F
#define unicode_CYRILLIC_SMALL_LETTER_ER                              0x0440
#define unicode_CYRILLIC_SMALL_LETTER_ES                              0x0441
#define unicode_CYRILLIC_SMALL_LETTER_TE                              0x0442
#define unicode_CYRILLIC_SMALL_LETTER_U                               0x0443
#define unicode_CYRILLIC_SMALL_LETTER_EF                              0x0444
#define unicode_CYRILLIC_SMALL_LETTER_HA                              0x0445
#define unicode_CYRILLIC_SMALL_LETTER_TSE                             0x0446
#define unicode_CYRILLIC_SMALL_LETTER_CHE                             0x0447
#define unicode_CYRILLIC_SMALL_LETTER_SHA                             0x0448
#define unicode_CYRILLIC_SMALL_LETTER_SHCHA                           0x0449
#define unicode_CYRILLIC_SMALL_LETTER_HARD_SIGN                       0x044A
#define unicode_CYRILLIC_SMALL_LETTER_YERU                            0x044B
#define unicode_CYRILLIC_SMALL_LETTER_SOFT_SIGN                       0x044C
#define unicode_CYRILLIC_SMALL_LETTER_E                               0x044D
#define unicode_CYRILLIC_SMALL_LETTER_YU                              0x044E
#define unicode_CYRILLIC_SMALL_LETTER_YA                              0x044F
#define unicode_CYRILLIC_SMALL_LETTER_IE_WITH_GRAVE                   0x0450
#define unicode_CYRILLIC_SMALL_LETTER_IO                              0x0451
#define unicode_CYRILLIC_SMALL_LETTER_DJE                             0x0452
#define unicode_CYRILLIC_SMALL_LETTER_GJE                             0x0453
#define unicode_CYRILLIC_SMALL_LETTER_UKRAINIAN_IE                    0x0454
#define unicode_CYRILLIC_SMALL_LETTER_DZE                             0x0455
#define unicode_CYRILLIC_SMALL_LETTER_BYELORUSSIAN_UKRAINIAN_I        0x0456
#define unicode_CYRILLIC_SMALL_LETTER_YI                              0x0457
#define unicode_CYRILLIC_SMALL_LETTER_JE                              0x0458
#define unicode_CYRILLIC_SMALL_LETTER_LJE                             0x0459
#define unicode_CYRILLIC_SMALL_LETTER_NJE                             0x045A
#define unicode_CYRILLIC_SMALL_LETTER_TSHE                            0x045B
#define unicode_CYRILLIC_SMALL_LETTER_KJE                             0x045C
#define unicode_CYRILLIC_SMALL_LETTER_I_WITH_GRAVE                    0x045D
#define unicode_CYRILLIC_SMALL_LETTER_SHORT_U                         0x045E
#define unicode_CYRILLIC_SMALL_LETTER_DZHE                            0x045F
#define unicode_CYRILLIC_CAPITAL_LETTER_OMEGA                         0x0460
#define unicode_CYRILLIC_SMALL_LETTER_OMEGA                           0x0461
#define unicode_CYRILLIC_CAPITAL_LETTER_YAT                           0x0462
#define unicode_CYRILLIC_SMALL_LETTER_YAT                             0x0463
#define unicode_CYRILLIC_CAPITAL_LETTER_IOTIFIED_E                    0x0464
#define unicode_CYRILLIC_SMALL_LETTER_IOTIFIED_E                      0x0465
#define unicode_CYRILLIC_CAPITAL_LETTER_LITTLE_YUS                    0x0466
#define unicode_CYRILLIC_SMALL_LETTER_LITTLE_YUS                      0x0467
#define unicode_CYRILLIC_CAPITAL_LETTER_IOTIFIED_LITTLE_YUS           0x0468
#define unicode_CYRILLIC_SMALL_LETTER_IOTIFIED_LITTLE_YUS             0x0469
#define unicode_CYRILLIC_CAPITAL_LETTER_BIG_YUS                       0x046A
#define unicode_CYRILLIC_SMALL_LETTER_BIG_YUS                         0x046B
#define unicode_CYRILLIC_CAPITAL_LETTER_IOTIFIED_BIG_YUS              0x046C
#define unicode_CYRILLIC_SMALL_LETTER_IOTIFIED_BIG_YUS                0x046D
#define unicode_CYRILLIC_CAPITAL_LETTER_KSI                           0x046E
#define unicode_CYRILLIC_SMALL_LETTER_KSI                             0x046F
#define unicode_CYRILLIC_CAPITAL_LETTER_PSI                           0x0470
#define unicode_CYRILLIC_SMALL_LETTER_PSI                             0x0471
#define unicode_CYRILLIC_CAPITAL_LETTER_FITA                          0x0472
#define unicode_CYRILLIC_SMALL_LETTER_FITA                            0x0473
#define unicode_CYRILLIC_CAPITAL_LETTER_IZHITSA                       0x0474
#define unicode_CYRILLIC_SMALL_LETTER_IZHITSA                         0x0475
#define unicode_CYRILLIC_CAPITAL_LETTER_IZHITSA_WITH_DOUBLE_GRAVE_ACCENT 0x0476
#define unicode_CYRILLIC_SMALL_LETTER_IZHITSA_WITH_DOUBLE_GRAVE_ACCENT 0x0477
#define unicode_CYRILLIC_CAPITAL_LETTER_UK                            0x0478
#define unicode_CYRILLIC_SMALL_LETTER_UK                              0x0479
#define unicode_CYRILLIC_CAPITAL_LETTER_ROUND_OMEGA                   0x047A
#define unicode_CYRILLIC_SMALL_LETTER_ROUND_OMEGA                     0x047B
#define unicode_CYRILLIC_CAPITAL_LETTER_OMEGA_WITH_TITLO              0x047C
#define unicode_CYRILLIC_SMALL_LETTER_OMEGA_WITH_TITLO                0x047D
#define unicode_CYRILLIC_CAPITAL_LETTER_OT                            0x047E
#define unicode_CYRILLIC_SMALL_LETTER_OT                              0x047F
#define unicode_CYRILLIC_CAPITAL_LETTER_KOPPA                         0x0480
#define unicode_CYRILLIC_SMALL_LETTER_KOPPA                           0x0481
#define unicode_CYRILLIC_THOUSANDS_SIGN                               0x0482
#define unicode_COMBINING_CYRILLIC_TITLO                              0x0483
#define unicode_COMBINING_CYRILLIC_PALATALIZATION                     0x0484
#define unicode_COMBINING_CYRILLIC_DASIA_PNEUMATA                     0x0485
#define unicode_COMBINING_CYRILLIC_PSILI_PNEUMATA                     0x0486
#define unicode_COMBINING_CYRILLIC_POKRYTIE                           0x0487
#define unicode_COMBINING_CYRILLIC_HUNDRED_THOUSANDS_SIGN             0x0488
#define unicode_COMBINING_CYRILLIC_MILLIONS_SIGN                      0x0489
#define unicode_CYRILLIC_CAPITAL_LETTER_SHORT_I_WITH_TAIL             0x048A
#define unicode_CYRILLIC_SMALL_LETTER_SHORT_I_WITH_TAIL               0x048B
#define unicode_CYRILLIC_CAPITAL_LETTER_SEMISOFT_SIGN                 0x048C
#define unicode_CYRILLIC_SMALL_LETTER_SEMISOFT_SIGN                   0x048D
#define unicode_CYRILLIC_CAPITAL_LETTER_ER_WITH_TICK                  0x048E
#define unicode_CYRILLIC_SMALL_LETTER_ER_WITH_TICK                    0x048F
#define unicode_CYRILLIC_CAPITAL_LETTER_GHE_WITH_UPTURN               0x0490
#define unicode_CYRILLIC_SMALL_LETTER_GHE_WITH_UPTURN                 0x0491
#define unicode_CYRILLIC_CAPITAL_LETTER_GHE_WITH_STROKE               0x0492
#define unicode_CYRILLIC_SMALL_LETTER_GHE_WITH_STROKE                 0x0493
#define unicode_CYRILLIC_CAPITAL_LETTER_GHE_WITH_MIDDLE_HOOK          0x0494
#define unicode_CYRILLIC_SMALL_LETTER_GHE_WITH_MIDDLE_HOOK            0x0495
#define unicode_CYRILLIC_CAPITAL_LETTER_ZHE_WITH_DESCENDER            0x0496
#define unicode_CYRILLIC_SMALL_LETTER_ZHE_WITH_DESCENDER              0x0497
#define unicode_CYRILLIC_CAPITAL_LETTER_ZE_WITH_DESCENDER             0x0498
#define unicode_CYRILLIC_SMALL_LETTER_ZE_WITH_DESCENDER               0x0499
#define unicode_CYRILLIC_CAPITAL_LETTER_KA_WITH_DESCENDER             0x049A
#define unicode_CYRILLIC_SMALL_LETTER_KA_WITH_DESCENDER               0x049B
#define unicode_CYRILLIC_CAPITAL_LETTER_KA_WITH_VERTICAL_STROKE       0x049C
#define unicode_CYRILLIC_SMALL_LETTER_KA_WITH_VERTICAL_STROKE         0x049D
#define unicode_CYRILLIC_CAPITAL_LETTER_KA_WITH_STROKE                0x049E
#define unicode_CYRILLIC_SMALL_LETTER_KA_WITH_STROKE                  0x049F
#define unicode_CYRILLIC_CAPITAL_LETTER_BASHKIR_KA                    0x04A0
#define unicode_CYRILLIC_SMALL_LETTER_BASHKIR_KA                      0x04A1
#define unicode_CYRILLIC_CAPITAL_LETTER_EN_WITH_DESCENDER             0x04A2
#define unicode_CYRILLIC_SMALL_LETTER_EN_WITH_DESCENDER               0x04A3
#define unicode_CYRILLIC_CAPITAL_LIGATURE_EN_GHE                      0x04A4
#define unicode_CYRILLIC_SMALL_LIGATURE_EN_GHE                        0x04A5
#define unicode_CYRILLIC_CAPITAL_LETTER_PE_WITH_MIDDLE_HOOK           0x04A6
#define unicode_CYRILLIC_SMALL_LETTER_PE_WITH_MIDDLE_HOOK             0x04A7
#define unicode_CYRILLIC_CAPITAL_LETTER_ABKHASIAN_HA                  0x04A8
#define unicode_CYRILLIC_SMALL_LETTER_ABKHASIAN_HA                    0x04A9
#define unicode_CYRILLIC_CAPITAL_LETTER_ES_WITH_DESCENDER             0x04AA
#define unicode_CYRILLIC_SMALL_LETTER_ES_WITH_DESCENDER               0x04AB
#define unicode_CYRILLIC_CAPITAL_LETTER_TE_WITH_DESCENDER             0x04AC
#define unicode_CYRILLIC_SMALL_LETTER_TE_WITH_DESCENDER               0x04AD
#define unicode_CYRILLIC_CAPITAL_LETTER_STRAIGHT_U                    0x04AE
#define unicode_CYRILLIC_SMALL_LETTER_STRAIGHT_U                      0x04AF
#define unicode_CYRILLIC_CAPITAL_LETTER_STRAIGHT_U_WITH_STROKE        0x04B0
#define unicode_CYRILLIC_SMALL_LETTER_STRAIGHT_U_WITH_STROKE          0x04B1
#define unicode_CYRILLIC_CAPITAL_LETTER_HA_WITH_DESCENDER             0x04B2
#define unicode_CYRILLIC_SMALL_LETTER_HA_WITH_DESCENDER               0x04B3
#define unicode_CYRILLIC_CAPITAL_LIGATURE_TE_TSE                      0x04B4
#define unicode_CYRILLIC_SMALL_LIGATURE_TE_TSE                        0x04B5
#define unicode_CYRILLIC_CAPITAL_LETTER_CHE_WITH_DESCENDER            0x04B6
#define unicode_CYRILLIC_SMALL_LETTER_CHE_WITH_DESCENDER              0x04B7
#define unicode_CYRILLIC_CAPITAL_LETTER_CHE_WITH_VERTICAL_STROKE      0x04B8
#define unicode_CYRILLIC_SMALL_LETTER_CHE_WITH_VERTICAL_STROKE        0x04B9
#define unicode_CYRILLIC_CAPITAL_LETTER_SHHA                          0x04BA
#define unicode_CYRILLIC_SMALL_LETTER_SHHA                            0x04BB
#define unicode_CYRILLIC_CAPITAL_LETTER_ABKHASIAN_CHE                 0x04BC
#define unicode_CYRILLIC_SMALL_LETTER_ABKHASIAN_CHE                   0x04BD
#define unicode_CYRILLIC_CAPITAL_LETTER_ABKHASIAN_CHE_WITH_DESCENDER  0x04BE
#define unicode_CYRILLIC_SMALL_LETTER_ABKHASIAN_CHE_WITH_DESCENDER    0x04BF
#define unicode_CYRILLIC_LETTER_PALOCHKA                              0x04C0
#define unicode_CYRILLIC_CAPITAL_LETTER_ZHE_WITH_BREVE                0x04C1
#define unicode_CYRILLIC_SMALL_LETTER_ZHE_WITH_BREVE                  0x04C2
#define unicode_CYRILLIC_CAPITAL_LETTER_KA_WITH_HOOK                  0x04C3
#define unicode_CYRILLIC_SMALL_LETTER_KA_WITH_HOOK                    0x04C4
#define unicode_CYRILLIC_CAPITAL_LETTER_EL_WITH_TAIL                  0x04C5
#define unicode_CYRILLIC_SMALL_LETTER_EL_WITH_TAIL                    0x04C6
#define unicode_CYRILLIC_CAPITAL_LETTER_EN_WITH_HOOK                  0x04C7
#define unicode_CYRILLIC_SMALL_LETTER_EN_WITH_HOOK                    0x04C8
#define unicode_CYRILLIC_CAPITAL_LETTER_EN_WITH_TAIL                  0x04C9
#define unicode_CYRILLIC_SMALL_LETTER_EN_WITH_TAIL                    0x04CA
#define unicode_CYRILLIC_CAPITAL_LETTER_KHAKASSIAN_CHE                0x04CB
#define unicode_CYRILLIC_SMALL_LETTER_KHAKASSIAN_CHE                  0x04CC
#define unicode_CYRILLIC_CAPITAL_LETTER_EM_WITH_TAIL                  0x04CD
#define unicode_CYRILLIC_SMALL_LETTER_EM_WITH_TAIL                    0x04CE
#define unicode_CYRILLIC_SMALL_LETTER_PALOCHKA                        0x04CF
#define unicode_CYRILLIC_CAPITAL_LETTER_A_WITH_BREVE                  0x04D0
#define unicode_CYRILLIC_SMALL_LETTER_A_WITH_BREVE                    0x04D1
#define unicode_CYRILLIC_CAPITAL_LETTER_A_WITH_DIAERESIS              0x04D2
#define unicode_CYRILLIC_SMALL_LETTER_A_WITH_DIAERESIS                0x04D3
#define unicode_CYRILLIC_CAPITAL_LIGATURE_A_IE                        0x04D4
#define unicode_CYRILLIC_SMALL_LIGATURE_A_IE                          0x04D5
#define unicode_CYRILLIC_CAPITAL_LETTER_IE_WITH_BREVE                 0x04D6
#define unicode_CYRILLIC_SMALL_LETTER_IE_WITH_BREVE                   0x04D7
#define unicode_CYRILLIC_CAPITAL_LETTER_SCHWA                         0x04D8
#define unicode_CYRILLIC_SMALL_LETTER_SCHWA                           0x04D9
#define unicode_CYRILLIC_CAPITAL_LETTER_SCHWA_WITH_DIAERESIS          0x04DA
#define unicode_CYRILLIC_SMALL_LETTER_SCHWA_WITH_DIAERESIS            0x04DB
#define unicode_CYRILLIC_CAPITAL_LETTER_ZHE_WITH_DIAERESIS            0x04DC
#define unicode_CYRILLIC_SMALL_LETTER_ZHE_WITH_DIAERESIS              0x04DD
#define unicode_CYRILLIC_CAPITAL_LETTER_ZE_WITH_DIAERESIS             0x04DE
#define unicode_CYRILLIC_SMALL_LETTER_ZE_WITH_DIAERESIS               0x04DF
#define unicode_CYRILLIC_CAPITAL_LETTER_ABKHASIAN_DZE                 0x04E0
#define unicode_CYRILLIC_SMALL_LETTER_ABKHASIAN_DZE                   0x04E1
#define unicode_CYRILLIC_CAPITAL_LETTER_I_WITH_MACRON                 0x04E2
#define unicode_CYRILLIC_SMALL_LETTER_I_WITH_MACRON                   0x04E3
#define unicode_CYRILLIC_CAPITAL_LETTER_I_WITH_DIAERESIS              0x04E4
#define unicode_CYRILLIC_SMALL_LETTER_I_WITH_DIAERESIS                0x04E5
#define unicode_CYRILLIC_CAPITAL_LETTER_O_WITH_DIAERESIS              0x04E6
#define unicode_CYRILLIC_SMALL_LETTER_O_WITH_DIAERESIS                0x04E7
#define unicode_CYRILLIC_CAPITAL_LETTER_BARRED_O                      0x04E8
#define unicode_CYRILLIC_SMALL_LETTER_BARRED_O                        0x04E9
#define unicode_CYRILLIC_CAPITAL_LETTER_BARRED_O_WITH_DIAERESIS       0x04EA
#define unicode_CYRILLIC_SMALL_LETTER_BARRED_O_WITH_DIAERESIS         0x04EB
#define unicode_CYRILLIC_CAPITAL_LETTER_E_WITH_DIAERESIS              0x04EC
#define unicode_CYRILLIC_SMALL_LETTER_E_WITH_DIAERESIS                0x04ED
#define unicode_CYRILLIC_CAPITAL_LETTER_U_WITH_MACRON                 0x04EE
#define unicode_CYRILLIC_SMALL_LETTER_U_WITH_MACRON                   0x04EF
#define unicode_CYRILLIC_CAPITAL_LETTER_U_WITH_DIAERESIS              0x04F0
#define unicode_CYRILLIC_SMALL_LETTER_U_WITH_DIAERESIS                0x04F1
#define unicode_CYRILLIC_CAPITAL_LETTER_U_WITH_DOUBLE_ACUTE           0x04F2
#define unicode_CYRILLIC_SMALL_LETTER_U_WITH_DOUBLE_ACUTE             0x04F3
#define unicode_CYRILLIC_CAPITAL_LETTER_CHE_WITH_DIAERESIS            0x04F4
#define unicode_CYRILLIC_SMALL_LETTER_CHE_WITH_DIAERESIS              0x04F5
#define unicode_CYRILLIC_CAPITAL_LETTER_GHE_WITH_DESCENDER            0x04F6
#define unicode_CYRILLIC_SMALL_LETTER_GHE_WITH_DESCENDER              0x04F7
#define unicode_CYRILLIC_CAPITAL_LETTER_YERU_WITH_DIAERESIS           0x04F8
#define unicode_CYRILLIC_SMALL_LETTER_YERU_WITH_DIAERESIS             0x04F9
#define unicode_CYRILLIC_CAPITAL_LETTER_GHE_WITH_STROKE_AND_HOOK      0x04FA
#define unicode_CYRILLIC_SMALL_LETTER_GHE_WITH_STROKE_AND_HOOK        0x04FB
#define unicode_CYRILLIC_CAPITAL_LETTER_HA_WITH_HOOK                  0x04FC
#define unicode_CYRILLIC_SMALL_LETTER_HA_WITH_HOOK                    0x04FD
#define unicode_CYRILLIC_CAPITAL_LETTER_HA_WITH_STROKE                0x04FE
#define unicode_CYRILLIC_SMALL_LETTER_HA_WITH_STROKE                  0x04FF
#define unicode_CYRILLIC_CAPITAL_LETTER_KOMI_DE                       0x0500
#define unicode_CYRILLIC_SMALL_LETTER_KOMI_DE                         0x0501
#define unicode_CYRILLIC_CAPITAL_LETTER_KOMI_DJE                      0x0502
#define unicode_CYRILLIC_SMALL_LETTER_KOMI_DJE                        0x0503
#define unicode_CYRILLIC_CAPITAL_LETTER_KOMI_ZJE                      0x0504
#define unicode_CYRILLIC_SMALL_LETTER_KOMI_ZJE                        0x0505
#define unicode_CYRILLIC_CAPITAL_LETTER_KOMI_DZJE                     0x0506
#define unicode_CYRILLIC_SMALL_LETTER_KOMI_DZJE                       0x0507
#define unicode_CYRILLIC_CAPITAL_LETTER_KOMI_LJE                      0x0508
#define unicode_CYRILLIC_SMALL_LETTER_KOMI_LJE                        0x0509
#define unicode_CYRILLIC_CAPITAL_LETTER_KOMI_NJE                      0x050A
#define unicode_CYRILLIC_SMALL_LETTER_KOMI_NJE                        0x050B
#define unicode_CYRILLIC_CAPITAL_LETTER_KOMI_SJE                      0x050C
#define unicode_CYRILLIC_SMALL_LETTER_KOMI_SJE                        0x050D
#define unicode_CYRILLIC_CAPITAL_LETTER_KOMI_TJE                      0x050E
#define unicode_CYRILLIC_SMALL_LETTER_KOMI_TJE                        0x050F
#define unicode_CYRILLIC_CAPITAL_LETTER_REVERSED_ZE                   0x0510
#define unicode_CYRILLIC_SMALL_LETTER_REVERSED_ZE                     0x0511
#define unicode_CYRILLIC_CAPITAL_LETTER_EL_WITH_HOOK                  0x0512
#define unicode_CYRILLIC_SMALL_LETTER_EL_WITH_HOOK                    0x0513
#define unicode_CYRILLIC_CAPITAL_LETTER_LHA                           0x0514
#define unicode_CYRILLIC_SMALL_LETTER_LHA                             0x0515
#define unicode_CYRILLIC_CAPITAL_LETTER_RHA                           0x0516
#define unicode_CYRILLIC_SMALL_LETTER_RHA                             0x0517
#define unicode_CYRILLIC_CAPITAL_LETTER_YAE                           0x0518
#define unicode_CYRILLIC_SMALL_LETTER_YAE                             0x0519
#define unicode_CYRILLIC_CAPITAL_LETTER_QA                            0x051A
#define unicode_CYRILLIC_SMALL_LETTER_QA                              0x051B
#define unicode_CYRILLIC_CAPITAL_LETTER_WE                            0x051C
#define unicode_CYRILLIC_SMALL_LETTER_WE                              0x051D
#define unicode_CYRILLIC_CAPITAL_LETTER_ALEUT_KA                      0x051E
#define unicode_CYRILLIC_SMALL_LETTER_ALEUT_KA                        0x051F
#define unicode_CYRILLIC_CAPITAL_LETTER_EL_WITH_MIDDLE_HOOK           0x0520
#define unicode_CYRILLIC_SMALL_LETTER_EL_WITH_MIDDLE_HOOK             0x0521
#define unicode_CYRILLIC_CAPITAL_LETTER_EN_WITH_MIDDLE_HOOK           0x0522
#define unicode_CYRILLIC_SMALL_LETTER_EN_WITH_MIDDLE_HOOK             0x0523
#define unicode_CYRILLIC_CAPITAL_LETTER_PE_WITH_DESCENDER             0x0524
#define unicode_CYRILLIC_SMALL_LETTER_PE_WITH_DESCENDER               0x0525
#define unicode_CYRILLIC_CAPITAL_LETTER_SHHA_WITH_DESCENDER           0x0526
#define unicode_CYRILLIC_SMALL_LETTER_SHHA_WITH_DESCENDER             0x0527
#define unicode_CYRILLIC_CAPITAL_LETTER_EN_WITH_LEFT_HOOK             0x0528
#define unicode_CYRILLIC_SMALL_LETTER_EN_WITH_LEFT_HOOK               0x0529
#define unicode_CYRILLIC_CAPITAL_LETTER_DZZHE                         0x052A
#define unicode_CYRILLIC_SMALL_LETTER_DZZHE                           0x052B
#define unicode_CYRILLIC_CAPITAL_LETTER_DCHE                          0x052C
#define unicode_CYRILLIC_SMALL_LETTER_DCHE                            0x052D
#define unicode_CYRILLIC_CAPITAL_LETTER_EL_WITH_DESCENDER             0x052E
#define unicode_CYRILLIC_SMALL_LETTER_EL_WITH_DESCENDER               0x052F
#define unicode_ARMENIAN_CAPITAL_LETTER_AYB                           0x0531
#define unicode_ARMENIAN_CAPITAL_LETTER_BEN                           0x0532
#define unicode_ARMENIAN_CAPITAL_LETTER_GIM                           0x0533
#define unicode_ARMENIAN_CAPITAL_LETTER_DA                            0x0534
#define unicode_ARMENIAN_CAPITAL_LETTER_ECH                           0x0535
#define unicode_ARMENIAN_CAPITAL_LETTER_ZA                            0x0536
#define unicode_ARMENIAN_CAPITAL_LETTER_EH                            0x0537
#define unicode_ARMENIAN_CAPITAL_LETTER_ET                            0x0538
#define unicode_ARMENIAN_CAPITAL_LETTER_TO                            0x0539
#define unicode_ARMENIAN_CAPITAL_LETTER_ZHE                           0x053A
#define unicode_ARMENIAN_CAPITAL_LETTER_INI                           0x053B
#define unicode_ARMENIAN_CAPITAL_LETTER_LIWN                          0x053C
#define unicode_ARMENIAN_CAPITAL_LETTER_XEH                           0x053D
#define unicode_ARMENIAN_CAPITAL_LETTER_CA                            0x053E
#define unicode_ARMENIAN_CAPITAL_LETTER_KEN                           0x053F
#define unicode_ARMENIAN_CAPITAL_LETTER_HO                            0x0540
#define unicode_ARMENIAN_CAPITAL_LETTER_JA                            0x0541
#define unicode_ARMENIAN_CAPITAL_LETTER_GHAD                          0x0542
#define unicode_ARMENIAN_CAPITAL_LETTER_CHEH                          0x0543
#define unicode_ARMENIAN_CAPITAL_LETTER_MEN                           0x0544
#define unicode_ARMENIAN_CAPITAL_LETTER_YI                            0x0545
#define unicode_ARMENIAN_CAPITAL_LETTER_NOW                           0x0546
#define unicode_ARMENIAN_CAPITAL_LETTER_SHA                           0x0547
#define unicode_ARMENIAN_CAPITAL_LETTER_VO                            0x0548
#define unicode_ARMENIAN_CAPITAL_LETTER_CHA                           0x0549
#define unicode_ARMENIAN_CAPITAL_LETTER_PEH                           0x054A
#define unicode_ARMENIAN_CAPITAL_LETTER_JHEH                          0x054B
#define unicode_ARMENIAN_CAPITAL_LETTER_RA                            0x054C
#define unicode_ARMENIAN_CAPITAL_LETTER_SEH                           0x054D
#define unicode_ARMENIAN_CAPITAL_LETTER_VEW                           0x054E
#define unicode_ARMENIAN_CAPITAL_LETTER_TIWN                          0x054F
#define unicode_ARMENIAN_CAPITAL_LETTER_REH                           0x0550
#define unicode_ARMENIAN_CAPITAL_LETTER_CO                            0x0551
#define unicode_ARMENIAN_CAPITAL_LETTER_YIWN                          0x0552
#define unicode_ARMENIAN_CAPITAL_LETTER_PIWR                          0x0553
#define unicode_ARMENIAN_CAPITAL_LETTER_KEH                           0x0554
#define unicode_ARMENIAN_CAPITAL_LETTER_OH                            0x0555
#define unicode_ARMENIAN_CAPITAL_LETTER_FEH                           0x0556
#define unicode_ARMENIAN_MODIFIER_LETTER_LEFT_HALF_RING               0x0559
#define unicode_ARMENIAN_APOSTROPHE                                   0x055A
#define unicode_ARMENIAN_EMPHASIS_MARK                                0x055B
#define unicode_ARMENIAN_EXCLAMATION_MARK                             0x055C
#define unicode_ARMENIAN_COMMA                                        0x055D
#define unicode_ARMENIAN_QUESTION_MARK                                0x055E
#define unicode_ARMENIAN_ABBREVIATION_MARK                            0x055F
#define unicode_ARMENIAN_SMALL_LETTER_AYB                             0x0561
#define unicode_ARMENIAN_SMALL_LETTER_BEN                             0x0562
#define unicode_ARMENIAN_SMALL_LETTER_GIM                             0x0563
#define unicode_ARMENIAN_SMALL_LETTER_DA                              0x0564
#define unicode_ARMENIAN_SMALL_LETTER_ECH                             0x0565
#define unicode_ARMENIAN_SMALL_LETTER_ZA                              0x0566
#define unicode_ARMENIAN_SMALL_LETTER_EH                              0x0567
#define unicode_ARMENIAN_SMALL_LETTER_ET                              0x0568
#define unicode_ARMENIAN_SMALL_LETTER_TO                              0x0569
#define unicode_ARMENIAN_SMALL_LETTER_ZHE                             0x056A
#define unicode_ARMENIAN_SMALL_LETTER_INI                             0x056B
#define unicode_ARMENIAN_SMALL_LETTER_LIWN                            0x056C
#define unicode_ARMENIAN_SMALL_LETTER_XEH                             0x056D
#define unicode_ARMENIAN_SMALL_LETTER_CA                              0x056E
#define unicode_ARMENIAN_SMALL_LETTER_KEN                             0x056F
#define unicode_ARMENIAN_SMALL_LETTER_HO                              0x0570
#define unicode_ARMENIAN_SMALL_LETTER_JA                              0x0571
#define unicode_ARMENIAN_SMALL_LETTER_GHAD                            0x0572
#define unicode_ARMENIAN_SMALL_LETTER_CHEH                            0x0573
#define unicode_ARMENIAN_SMALL_LETTER_MEN                             0x0574
#define unicode_ARMENIAN_SMALL_LETTER_YI                              0x0575
#define unicode_ARMENIAN_SMALL_LETTER_NOW                             0x0576
#define unicode_ARMENIAN_SMALL_LETTER_SHA                             0x0577
#define unicode_ARMENIAN_SMALL_LETTER_VO                              0x0578
#define unicode_ARMENIAN_SMALL_LETTER_CHA                             0x0579
#define unicode_ARMENIAN_SMALL_LETTER_PEH                             0x057A
#define unicode_ARMENIAN_SMALL_LETTER_JHEH                            0x057B
#define unicode_ARMENIAN_SMALL_LETTER_RA                              0x057C
#define unicode_ARMENIAN_SMALL_LETTER_SEH                             0x057D
#define unicode_ARMENIAN_SMALL_LETTER_VEW                             0x057E
#define unicode_ARMENIAN_SMALL_LETTER_TIWN                            0x057F
#define unicode_ARMENIAN_SMALL_LETTER_REH                             0x0580
#define unicode_ARMENIAN_SMALL_LETTER_CO                              0x0581
#define unicode_ARMENIAN_SMALL_LETTER_YIWN                            0x0582
#define unicode_ARMENIAN_SMALL_LETTER_PIWR                            0x0583
#define unicode_ARMENIAN_SMALL_LETTER_KEH                             0x0584
#define unicode_ARMENIAN_SMALL_LETTER_OH                              0x0585
#define unicode_ARMENIAN_SMALL_LETTER_FEH                             0x0586
#define unicode_ARMENIAN_SMALL_LIGATURE_ECH_YIWN                      0x0587
#define unicode_ARMENIAN_FULL_STOP                                    0x0589
#define unicode_ARMENIAN_HYPHEN                                       0x058A
#define unicode_RIGHT_FACING_ARMENIAN_ETERNITY_SIGN                   0x058D
#define unicode_LEFT_FACING_ARMENIAN_ETERNITY_SIGN                    0x058E
#define unicode_ARMENIAN_DRAM_SIGN                                    0x058F
#define unicode_HEBREW_ACCENT_ETNAHTA                                 0x0591
#define unicode_HEBREW_ACCENT_SEGOL                                   0x0592
#define unicode_HEBREW_ACCENT_SHALSHELET                              0x0593
#define unicode_HEBREW_ACCENT_ZAQEF_QATAN                             0x0594
#define unicode_HEBREW_ACCENT_ZAQEF_GADOL                             0x0595
#define unicode_HEBREW_ACCENT_TIPEHA                                  0x0596
#define unicode_HEBREW_ACCENT_REVIA                                   0x0597
#define unicode_HEBREW_ACCENT_ZARQA                                   0x0598
#define unicode_HEBREW_ACCENT_PASHTA                                  0x0599
#define unicode_HEBREW_ACCENT_YETIV                                   0x059A
#define unicode_HEBREW_ACCENT_TEVIR                                   0x059B
#define unicode_HEBREW_ACCENT_GERESH                                  0x059C
#define unicode_HEBREW_ACCENT_GERESH_MUQDAM                           0x059D
#define unicode_HEBREW_ACCENT_GERSHAYIM                               0x059E
#define unicode_HEBREW_ACCENT_QARNEY_PARA                             0x059F
#define unicode_HEBREW_ACCENT_TELISHA_GEDOLA                          0x05A0
#define unicode_HEBREW_ACCENT_PAZER                                   0x05A1
#define unicode_HEBREW_ACCENT_ATNAH_HAFUKH                            0x05A2
#define unicode_HEBREW_ACCENT_MUNAH                                   0x05A3
#define unicode_HEBREW_ACCENT_MAHAPAKH                                0x05A4
#define unicode_HEBREW_ACCENT_MERKHA                                  0x05A5
#define unicode_HEBREW_ACCENT_MERKHA_KEFULA                           0x05A6
#define unicode_HEBREW_ACCENT_DARGA                                   0x05A7
#define unicode_HEBREW_ACCENT_QADMA                                   0x05A8
#define unicode_HEBREW_ACCENT_TELISHA_QETANA                          0x05A9
#define unicode_HEBREW_ACCENT_YERAH_BEN_YOMO                          0x05AA
#define unicode_HEBREW_ACCENT_OLE                                     0x05AB
#define unicode_HEBREW_ACCENT_ILUY                                    0x05AC
#define unicode_HEBREW_ACCENT_DEHI                                    0x05AD
#define unicode_HEBREW_ACCENT_ZINOR                                   0x05AE
#define unicode_HEBREW_MARK_MASORA_CIRCLE                             0x05AF
#define unicode_HEBREW_POINT_SHEVA                                    0x05B0
#define unicode_HEBREW_POINT_HATAF_SEGOL                              0x05B1
#define unicode_HEBREW_POINT_HATAF_PATAH                              0x05B2
#define unicode_HEBREW_POINT_HATAF_QAMATS                             0x05B3
#define unicode_HEBREW_POINT_HIRIQ                                    0x05B4
#define unicode_HEBREW_POINT_TSERE                                    0x05B5
#define unicode_HEBREW_POINT_SEGOL                                    0x05B6
#define unicode_HEBREW_POINT_PATAH                                    0x05B7
#define unicode_HEBREW_POINT_QAMATS                                   0x05B8
#define unicode_HEBREW_POINT_HOLAM                                    0x05B9
#define unicode_HEBREW_POINT_HOLAM_HASER_FOR_VAV                      0x05BA
#define unicode_HEBREW_POINT_QUBUTS                                   0x05BB
#define unicode_HEBREW_POINT_DAGESH_OR_MAPIQ                          0x05BC
#define unicode_HEBREW_POINT_METEG                                    0x05BD
#define unicode_HEBREW_PUNCTUATION_MAQAF                              0x05BE
#define unicode_HEBREW_POINT_RAFE                                     0x05BF
#define unicode_HEBREW_PUNCTUATION_PASEQ                              0x05C0
#define unicode_HEBREW_POINT_SHIN_DOT                                 0x05C1
#define unicode_HEBREW_POINT_SIN_DOT                                  0x05C2
#define unicode_HEBREW_PUNCTUATION_SOF_PASUQ                          0x05C3
#define unicode_HEBREW_MARK_UPPER_DOT                                 0x05C4
#define unicode_HEBREW_MARK_LOWER_DOT                                 0x05C5
#define unicode_HEBREW_PUNCTUATION_NUN_HAFUKHA                        0x05C6
#define unicode_HEBREW_POINT_QAMATS_QATAN                             0x05C7
#define unicode_HEBREW_LETTER_ALEF                                    0x05D0
#define unicode_HEBREW_LETTER_BET                                     0x05D1
#define unicode_HEBREW_LETTER_GIMEL                                   0x05D2
#define unicode_HEBREW_LETTER_DALET                                   0x05D3
#define unicode_HEBREW_LETTER_HE                                      0x05D4
#define unicode_HEBREW_LETTER_VAV                                     0x05D5
#define unicode_HEBREW_LETTER_ZAYIN                                   0x05D6
#define unicode_HEBREW_LETTER_HET                                     0x05D7
#define unicode_HEBREW_LETTER_TET                                     0x05D8
#define unicode_HEBREW_LETTER_YOD                                     0x05D9
#define unicode_HEBREW_LETTER_FINAL_KAF                               0x05DA
#define unicode_HEBREW_LETTER_KAF                                     0x05DB
#define unicode_HEBREW_LETTER_LAMED                                   0x05DC
#define unicode_HEBREW_LETTER_FINAL_MEM                               0x05DD
#define unicode_HEBREW_LETTER_MEM                                     0x05DE
#define unicode_HEBREW_LETTER_FINAL_NUN                               0x05DF
#define unicode_HEBREW_LETTER_NUN                                     0x05E0
#define unicode_HEBREW_LETTER_SAMEKH                                  0x05E1
#define unicode_HEBREW_LETTER_AYIN                                    0x05E2
#define unicode_HEBREW_LETTER_FINAL_PE                                0x05E3
#define unicode_HEBREW_LETTER_PE                                      0x05E4
#define unicode_HEBREW_LETTER_FINAL_TSADI                             0x05E5
#define unicode_HEBREW_LETTER_TSADI                                   0x05E6
#define unicode_HEBREW_LETTER_QOF                                     0x05E7
#define unicode_HEBREW_LETTER_RESH                                    0x05E8
#define unicode_HEBREW_LETTER_SHIN                                    0x05E9
#define unicode_HEBREW_LETTER_TAV                                     0x05EA
#define unicode_HEBREW_LIGATURE_YIDDISH_DOUBLE_VAV                    0x05F0
#define unicode_HEBREW_LIGATURE_YIDDISH_VAV_YOD                       0x05F1
#define unicode_HEBREW_LIGATURE_YIDDISH_DOUBLE_YOD                    0x05F2
#define unicode_HEBREW_PUNCTUATION_GERESH                             0x05F3
#define unicode_HEBREW_PUNCTUATION_GERSHAYIM                          0x05F4
#define unicode_ARABIC_NUMBER_SIGN                                    0x0600
#define unicode_ARABIC_SIGN_SANAH                                     0x0601
#define unicode_ARABIC_FOOTNOTE_MARKER                                0x0602
#define unicode_ARABIC_SIGN_SAFHA                                     0x0603
#define unicode_ARABIC_SIGN_SAMVAT                                    0x0604
#define unicode_ARABIC_NUMBER_MARK_ABOVE                              0x0605
#define unicode_ARABIC_INDIC_CUBE_ROOT                                0x0606
#define unicode_ARABIC_INDIC_FOURTH_ROOT                              0x0607
#define unicode_ARABIC_RAY                                            0x0608
#define unicode_ARABIC_INDIC_PER_MILLE_SIGN                           0x0609
#define unicode_ARABIC_INDIC_PER_TEN_THOUSAND_SIGN                    0x060A
#define unicode_AFGHANI_SIGN                                          0x060B
#define unicode_ARABIC_COMMA                                          0x060C
#define unicode_ARABIC_DATE_SEPARATOR                                 0x060D
#define unicode_ARABIC_POETIC_VERSE_SIGN                              0x060E
#define unicode_ARABIC_SIGN_MISRA                                     0x060F
#define unicode_ARABIC_SIGN_SALLALLAHOU_ALAYHE_WASSALLAM              0x0610
#define unicode_ARABIC_SIGN_ALAYHE_ASSALLAM                           0x0611
#define unicode_ARABIC_SIGN_RAHMATULLAH_ALAYHE                        0x0612
#define unicode_ARABIC_SIGN_RADI_ALLAHOU_ANHU                         0x0613
#define unicode_ARABIC_SIGN_TAKHALLUS                                 0x0614
#define unicode_ARABIC_SMALL_HIGH_TAH                                 0x0615
#define unicode_ARABIC_SMALL_HIGH_LIGATURE_ALEF_WITH_LAM_WITH_YEH     0x0616
#define unicode_ARABIC_SMALL_HIGH_ZAIN                                0x0617
#define unicode_ARABIC_SMALL_FATHA                                    0x0618
#define unicode_ARABIC_SMALL_DAMMA                                    0x0619
#define unicode_ARABIC_SMALL_KASRA                                    0x061A
#define unicode_ARABIC_SEMICOLON                                      0x061B
#define unicode_ARABIC_LETTER_MARK                                    0x061C
#define unicode_ARABIC_TRIPLE_DOT_PUNCTUATION_MARK                    0x061E
#define unicode_ARABIC_QUESTION_MARK                                  0x061F
#define unicode_ARABIC_LETTER_KASHMIRI_YEH                            0x0620
#define unicode_ARABIC_LETTER_HAMZA                                   0x0621
#define unicode_ARABIC_LETTER_ALEF_WITH_MADDA_ABOVE                   0x0622
#define unicode_ARABIC_LETTER_ALEF_WITH_HAMZA_ABOVE                   0x0623
#define unicode_ARABIC_LETTER_WAW_WITH_HAMZA_ABOVE                    0x0624
#define unicode_ARABIC_LETTER_ALEF_WITH_HAMZA_BELOW                   0x0625
#define unicode_ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE                    0x0626
#define unicode_ARABIC_LETTER_ALEF                                    0x0627
#define unicode_ARABIC_LETTER_BEH                                     0x0628
#define unicode_ARABIC_LETTER_TEH_MARBUTA                             0x0629
#define unicode_ARABIC_LETTER_TEH                                     0x062A
#define unicode_ARABIC_LETTER_THEH                                    0x062B
#define unicode_ARABIC_LETTER_JEEM                                    0x062C
#define unicode_ARABIC_LETTER_HAH                                     0x062D
#define unicode_ARABIC_LETTER_KHAH                                    0x062E
#define unicode_ARABIC_LETTER_DAL                                     0x062F
#define unicode_ARABIC_LETTER_THAL                                    0x0630
#define unicode_ARABIC_LETTER_REH                                     0x0631
#define unicode_ARABIC_LETTER_ZAIN                                    0x0632
#define unicode_ARABIC_LETTER_SEEN                                    0x0633
#define unicode_ARABIC_LETTER_SHEEN                                   0x0634
#define unicode_ARABIC_LETTER_SAD                                     0x0635
#define unicode_ARABIC_LETTER_DAD                                     0x0636
#define unicode_ARABIC_LETTER_TAH                                     0x0637
#define unicode_ARABIC_LETTER_ZAH                                     0x0638
#define unicode_ARABIC_LETTER_AIN                                     0x0639
#define unicode_ARABIC_LETTER_GHAIN                                   0x063A
#define unicode_ARABIC_LETTER_KEHEH_WITH_TWO_DOTS_ABOVE               0x063B
#define unicode_ARABIC_LETTER_KEHEH_WITH_THREE_DOTS_BELOW             0x063C
#define unicode_ARABIC_LETTER_FARSI_YEH_WITH_INVERTED_V               0x063D
#define unicode_ARABIC_LETTER_FARSI_YEH_WITH_TWO_DOTS_ABOVE           0x063E
#define unicode_ARABIC_LETTER_FARSI_YEH_WITH_THREE_DOTS_ABOVE         0x063F
#define unicode_ARABIC_TATWEEL                                        0x0640
#define unicode_ARABIC_LETTER_FEH                                     0x0641
#define unicode_ARABIC_LETTER_QAF                                     0x0642
#define unicode_ARABIC_LETTER_KAF                                     0x0643
#define unicode_ARABIC_LETTER_LAM                                     0x0644
#define unicode_ARABIC_LETTER_MEEM                                    0x0645
#define unicode_ARABIC_LETTER_NOON                                    0x0646
#define unicode_ARABIC_LETTER_HEH                                     0x0647
#define unicode_ARABIC_LETTER_WAW                                     0x0648
#define unicode_ARABIC_LETTER_ALEF_MAKSURA                            0x0649
#define unicode_ARABIC_LETTER_YEH                                     0x064A
#define unicode_ARABIC_FATHATAN                                       0x064B
#define unicode_ARABIC_DAMMATAN                                       0x064C
#define unicode_ARABIC_KASRATAN                                       0x064D
#define unicode_ARABIC_FATHA                                          0x064E
#define unicode_ARABIC_DAMMA                                          0x064F
#define unicode_ARABIC_KASRA                                          0x0650
#define unicode_ARABIC_SHADDA                                         0x0651
#define unicode_ARABIC_SUKUN                                          0x0652
#define unicode_ARABIC_MADDAH_ABOVE                                   0x0653
#define unicode_ARABIC_HAMZA_ABOVE                                    0x0654
#define unicode_ARABIC_HAMZA_BELOW                                    0x0655
#define unicode_ARABIC_SUBSCRIPT_ALEF                                 0x0656
#define unicode_ARABIC_INVERTED_DAMMA                                 0x0657
#define unicode_ARABIC_MARK_NOON_GHUNNA                               0x0658
#define unicode_ARABIC_ZWARAKAY                                       0x0659
#define unicode_ARABIC_VOWEL_SIGN_SMALL_V_ABOVE                       0x065A
#define unicode_ARABIC_VOWEL_SIGN_INVERTED_SMALL_V_ABOVE              0x065B
#define unicode_ARABIC_VOWEL_SIGN_DOT_BELOW                           0x065C
#define unicode_ARABIC_REVERSED_DAMMA                                 0x065D
#define unicode_ARABIC_FATHA_WITH_TWO_DOTS                            0x065E
#define unicode_ARABIC_WAVY_HAMZA_BELOW                               0x065F
#define unicode_ARABIC_INDIC_DIGIT_ZERO                               0x0660
#define unicode_ARABIC_INDIC_DIGIT_ONE                                0x0661
#define unicode_ARABIC_INDIC_DIGIT_TWO                                0x0662
#define unicode_ARABIC_INDIC_DIGIT_THREE                              0x0663
#define unicode_ARABIC_INDIC_DIGIT_FOUR                               0x0664
#define unicode_ARABIC_INDIC_DIGIT_FIVE                               0x0665
#define unicode_ARABIC_INDIC_DIGIT_SIX                                0x0666
#define unicode_ARABIC_INDIC_DIGIT_SEVEN                              0x0667
#define unicode_ARABIC_INDIC_DIGIT_EIGHT                              0x0668
#define unicode_ARABIC_INDIC_DIGIT_NINE                               0x0669
#define unicode_ARABIC_PERCENT_SIGN                                   0x066A
#define unicode_ARABIC_DECIMAL_SEPARATOR                              0x066B
#define unicode_ARABIC_THOUSANDS_SEPARATOR                            0x066C
#define unicode_ARABIC_FIVE_POINTED_STAR                              0x066D
#define unicode_ARABIC_LETTER_DOTLESS_BEH                             0x066E
#define unicode_ARABIC_LETTER_DOTLESS_QAF                             0x066F
#define unicode_ARABIC_LETTER_SUPERSCRIPT_ALEF                        0x0670
#define unicode_ARABIC_LETTER_ALEF_WASLA                              0x0671
#define unicode_ARABIC_LETTER_ALEF_WITH_WAVY_HAMZA_ABOVE              0x0672
#define unicode_ARABIC_LETTER_ALEF_WITH_WAVY_HAMZA_BELOW              0x0673
#define unicode_ARABIC_LETTER_HIGH_HAMZA                              0x0674
#define unicode_ARABIC_LETTER_HIGH_HAMZA_ALEF                         0x0675
#define unicode_ARABIC_LETTER_HIGH_HAMZA_WAW                          0x0676
#define unicode_ARABIC_LETTER_U_WITH_HAMZA_ABOVE                      0x0677
#define unicode_ARABIC_LETTER_HIGH_HAMZA_YEH                          0x0678
#define unicode_ARABIC_LETTER_TTEH                                    0x0679
#define unicode_ARABIC_LETTER_TTEHEH                                  0x067A
#define unicode_ARABIC_LETTER_BEEH                                    0x067B
#define unicode_ARABIC_LETTER_TEH_WITH_RING                           0x067C
#define unicode_ARABIC_LETTER_TEH_WITH_THREE_DOTS_ABOVE_DOWNWARDS     0x067D
#define unicode_ARABIC_LETTER_PEH                                     0x067E
#define unicode_ARABIC_LETTER_TEHEH                                   0x067F
#define unicode_ARABIC_LETTER_BEHEH                                   0x0680
#define unicode_ARABIC_LETTER_HAH_WITH_HAMZA_ABOVE                    0x0681
#define unicode_ARABIC_LETTER_HAH_WITH_TWO_DOTS_VERTICAL_ABOVE        0x0682
#define unicode_ARABIC_LETTER_NYEH                                    0x0683
#define unicode_ARABIC_LETTER_DYEH                                    0x0684
#define unicode_ARABIC_LETTER_HAH_WITH_THREE_DOTS_ABOVE               0x0685
#define unicode_ARABIC_LETTER_TCHEH                                   0x0686
#define unicode_ARABIC_LETTER_TCHEHEH                                 0x0687
#define unicode_ARABIC_LETTER_DDAL                                    0x0688
#define unicode_ARABIC_LETTER_DAL_WITH_RING                           0x0689
#define unicode_ARABIC_LETTER_DAL_WITH_DOT_BELOW                      0x068A
#define unicode_ARABIC_LETTER_DAL_WITH_DOT_BELOW_AND_SMALL_TAH        0x068B
#define unicode_ARABIC_LETTER_DAHAL                                   0x068C
#define unicode_ARABIC_LETTER_DDAHAL                                  0x068D
#define unicode_ARABIC_LETTER_DUL                                     0x068E
#define unicode_ARABIC_LETTER_DAL_WITH_THREE_DOTS_ABOVE_DOWNWARDS     0x068F
#define unicode_ARABIC_LETTER_DAL_WITH_FOUR_DOTS_ABOVE                0x0690
#define unicode_ARABIC_LETTER_RREH                                    0x0691
#define unicode_ARABIC_LETTER_REH_WITH_SMALL_V                        0x0692
#define unicode_ARABIC_LETTER_REH_WITH_RING                           0x0693
#define unicode_ARABIC_LETTER_REH_WITH_DOT_BELOW                      0x0694
#define unicode_ARABIC_LETTER_REH_WITH_SMALL_V_BELOW                  0x0695
#define unicode_ARABIC_LETTER_REH_WITH_DOT_BELOW_AND_DOT_ABOVE        0x0696
#define unicode_ARABIC_LETTER_REH_WITH_TWO_DOTS_ABOVE                 0x0697
#define unicode_ARABIC_LETTER_JEH                                     0x0698
#define unicode_ARABIC_LETTER_REH_WITH_FOUR_DOTS_ABOVE                0x0699
#define unicode_ARABIC_LETTER_SEEN_WITH_DOT_BELOW_AND_DOT_ABOVE       0x069A
#define unicode_ARABIC_LETTER_SEEN_WITH_THREE_DOTS_BELOW              0x069B
#define unicode_ARABIC_LETTER_SEEN_WITH_THREE_DOTS_BELOW_AND_THREE_DOTS_ABOVE 0x069C
#define unicode_ARABIC_LETTER_SAD_WITH_TWO_DOTS_BELOW                 0x069D
#define unicode_ARABIC_LETTER_SAD_WITH_THREE_DOTS_ABOVE               0x069E
#define unicode_ARABIC_LETTER_TAH_WITH_THREE_DOTS_ABOVE               0x069F
#define unicode_ARABIC_LETTER_AIN_WITH_THREE_DOTS_ABOVE               0x06A0
#define unicode_ARABIC_LETTER_DOTLESS_FEH                             0x06A1
#define unicode_ARABIC_LETTER_FEH_WITH_DOT_MOVED_BELOW                0x06A2
#define unicode_ARABIC_LETTER_FEH_WITH_DOT_BELOW                      0x06A3
#define unicode_ARABIC_LETTER_VEH                                     0x06A4
#define unicode_ARABIC_LETTER_FEH_WITH_THREE_DOTS_BELOW               0x06A5
#define unicode_ARABIC_LETTER_PEHEH                                   0x06A6
#define unicode_ARABIC_LETTER_QAF_WITH_DOT_ABOVE                      0x06A7
#define unicode_ARABIC_LETTER_QAF_WITH_THREE_DOTS_ABOVE               0x06A8
#define unicode_ARABIC_LETTER_KEHEH                                   0x06A9
#define unicode_ARABIC_LETTER_SWASH_KAF                               0x06AA
#define unicode_ARABIC_LETTER_KAF_WITH_RING                           0x06AB
#define unicode_ARABIC_LETTER_KAF_WITH_DOT_ABOVE                      0x06AC
#define unicode_ARABIC_LETTER_NG                                      0x06AD
#define unicode_ARABIC_LETTER_KAF_WITH_THREE_DOTS_BELOW               0x06AE
#define unicode_ARABIC_LETTER_GAF                                     0x06AF
#define unicode_ARABIC_LETTER_GAF_WITH_RING                           0x06B0
#define unicode_ARABIC_LETTER_NGOEH                                   0x06B1
#define unicode_ARABIC_LETTER_GAF_WITH_TWO_DOTS_BELOW                 0x06B2
#define unicode_ARABIC_LETTER_GUEH                                    0x06B3
#define unicode_ARABIC_LETTER_GAF_WITH_THREE_DOTS_ABOVE               0x06B4
#define unicode_ARABIC_LETTER_LAM_WITH_SMALL_V                        0x06B5
#define unicode_ARABIC_LETTER_LAM_WITH_DOT_ABOVE                      0x06B6
#define unicode_ARABIC_LETTER_LAM_WITH_THREE_DOTS_ABOVE               0x06B7
#define unicode_ARABIC_LETTER_LAM_WITH_THREE_DOTS_BELOW               0x06B8
#define unicode_ARABIC_LETTER_NOON_WITH_DOT_BELOW                     0x06B9
#define unicode_ARABIC_LETTER_NOON_GHUNNA                             0x06BA
#define unicode_ARABIC_LETTER_RNOON                                   0x06BB
#define unicode_ARABIC_LETTER_NOON_WITH_RING                          0x06BC
#define unicode_ARABIC_LETTER_NOON_WITH_THREE_DOTS_ABOVE              0x06BD
#define unicode_ARABIC_LETTER_HEH_DOACHASHMEE                         0x06BE
#define unicode_ARABIC_LETTER_TCHEH_WITH_DOT_ABOVE                    0x06BF
#define unicode_ARABIC_LETTER_HEH_WITH_YEH_ABOVE                      0x06C0
#define unicode_ARABIC_LETTER_HEH_GOAL                                0x06C1
#define unicode_ARABIC_LETTER_HEH_GOAL_WITH_HAMZA_ABOVE               0x06C2
#define unicode_ARABIC_LETTER_TEH_MARBUTA_GOAL                        0x06C3
#define unicode_ARABIC_LETTER_WAW_WITH_RING                           0x06C4
#define unicode_ARABIC_LETTER_KIRGHIZ_OE                              0x06C5
#define unicode_ARABIC_LETTER_OE                                      0x06C6
#define unicode_ARABIC_LETTER_U                                       0x06C7
#define unicode_ARABIC_LETTER_YU                                      0x06C8
#define unicode_ARABIC_LETTER_KIRGHIZ_YU                              0x06C9
#define unicode_ARABIC_LETTER_WAW_WITH_TWO_DOTS_ABOVE                 0x06CA
#define unicode_ARABIC_LETTER_VE                                      0x06CB
#define unicode_ARABIC_LETTER_FARSI_YEH                               0x06CC
#define unicode_ARABIC_LETTER_YEH_WITH_TAIL                           0x06CD
#define unicode_ARABIC_LETTER_YEH_WITH_SMALL_V                        0x06CE
#define unicode_ARABIC_LETTER_WAW_WITH_DOT_ABOVE                      0x06CF
#define unicode_ARABIC_LETTER_E                                       0x06D0
#define unicode_ARABIC_LETTER_YEH_WITH_THREE_DOTS_BELOW               0x06D1
#define unicode_ARABIC_LETTER_YEH_BARREE                              0x06D2
#define unicode_ARABIC_LETTER_YEH_BARREE_WITH_HAMZA_ABOVE             0x06D3
#define unicode_ARABIC_FULL_STOP                                      0x06D4
#define unicode_ARABIC_LETTER_AE                                      0x06D5
#define unicode_ARABIC_SMALL_HIGH_LIGATURE_SAD_WITH_LAM_WITH_ALEF_MAKSURA 0x06D6
#define unicode_ARABIC_SMALL_HIGH_LIGATURE_QAF_WITH_LAM_WITH_ALEF_MAKSURA 0x06D7
#define unicode_ARABIC_SMALL_HIGH_MEEM_INITIAL_FORM                   0x06D8
#define unicode_ARABIC_SMALL_HIGH_LAM_ALEF                            0x06D9
#define unicode_ARABIC_SMALL_HIGH_JEEM                                0x06DA
#define unicode_ARABIC_SMALL_HIGH_THREE_DOTS                          0x06DB
#define unicode_ARABIC_SMALL_HIGH_SEEN                                0x06DC
#define unicode_ARABIC_END_OF_AYAH                                    0x06DD
#define unicode_ARABIC_START_OF_RUB_EL_HIZB                           0x06DE
#define unicode_ARABIC_SMALL_HIGH_ROUNDED_ZERO                        0x06DF
#define unicode_ARABIC_SMALL_HIGH_UPRIGHT_RECTANGULAR_ZERO            0x06E0
#define unicode_ARABIC_SMALL_HIGH_DOTLESS_HEAD_OF_KHAH                0x06E1
#define unicode_ARABIC_SMALL_HIGH_MEEM_ISOLATED_FORM                  0x06E2
#define unicode_ARABIC_SMALL_LOW_SEEN                                 0x06E3
#define unicode_ARABIC_SMALL_HIGH_MADDA                               0x06E4
#define unicode_ARABIC_SMALL_WAW                                      0x06E5
#define unicode_ARABIC_SMALL_YEH                                      0x06E6
#define unicode_ARABIC_SMALL_HIGH_YEH                                 0x06E7
#define unicode_ARABIC_SMALL_HIGH_NOON                                0x06E8
#define unicode_ARABIC_PLACE_OF_SAJDAH                                0x06E9
#define unicode_ARABIC_EMPTY_CENTRE_LOW_STOP                          0x06EA
#define unicode_ARABIC_EMPTY_CENTRE_HIGH_STOP                         0x06EB
#define unicode_ARABIC_ROUNDED_HIGH_STOP_WITH_FILLED_CENTRE           0x06EC
#define unicode_ARABIC_SMALL_LOW_MEEM                                 0x06ED
#define unicode_ARABIC_LETTER_DAL_WITH_INVERTED_V                     0x06EE
#define unicode_ARABIC_LETTER_REH_WITH_INVERTED_V                     0x06EF
#define unicode_EXTENDED_ARABIC_INDIC_DIGIT_ZERO                      0x06F0
#define unicode_EXTENDED_ARABIC_INDIC_DIGIT_ONE                       0x06F1
#define unicode_EXTENDED_ARABIC_INDIC_DIGIT_TWO                       0x06F2
#define unicode_EXTENDED_ARABIC_INDIC_DIGIT_THREE                     0x06F3
#define unicode_EXTENDED_ARABIC_INDIC_DIGIT_FOUR                      0x06F4
#define unicode_EXTENDED_ARABIC_INDIC_DIGIT_FIVE                      0x06F5
#define unicode_EXTENDED_ARABIC_INDIC_DIGIT_SIX                       0x06F6
#define unicode_EXTENDED_ARABIC_INDIC_DIGIT_SEVEN                     0x06F7
#define unicode_EXTENDED_ARABIC_INDIC_DIGIT_EIGHT                     0x06F8
#define unicode_EXTENDED_ARABIC_INDIC_DIGIT_NINE                      0x06F9
#define unicode_ARABIC_LETTER_SHEEN_WITH_DOT_BELOW                    0x06FA
#define unicode_ARABIC_LETTER_DAD_WITH_DOT_BELOW                      0x06FB
#define unicode_ARABIC_LETTER_GHAIN_WITH_DOT_BELOW                    0x06FC
#define unicode_ARABIC_SIGN_SINDHI_AMPERSAND                          0x06FD
#define unicode_ARABIC_SIGN_SINDHI_POSTPOSITION_MEN                   0x06FE
#define unicode_ARABIC_LETTER_HEH_WITH_INVERTED_V                     0x06FF
#define unicode_SYRIAC_END_OF_PARAGRAPH                               0x0700
#define unicode_SYRIAC_SUPRALINEAR_FULL_STOP                          0x0701
#define unicode_SYRIAC_SUBLINEAR_FULL_STOP                            0x0702
#define unicode_SYRIAC_SUPRALINEAR_COLON                              0x0703
#define unicode_SYRIAC_SUBLINEAR_COLON                                0x0704
#define unicode_SYRIAC_HORIZONTAL_COLON                               0x0705
#define unicode_SYRIAC_COLON_SKEWED_LEFT                              0x0706
#define unicode_SYRIAC_COLON_SKEWED_RIGHT                             0x0707
#define unicode_SYRIAC_SUPRALINEAR_COLON_SKEWED_LEFT                  0x0708
#define unicode_SYRIAC_SUBLINEAR_COLON_SKEWED_RIGHT                   0x0709
#define unicode_SYRIAC_CONTRACTION                                    0x070A
#define unicode_SYRIAC_HARKLEAN_OBELUS                                0x070B
#define unicode_SYRIAC_HARKLEAN_METOBELUS                             0x070C
#define unicode_SYRIAC_HARKLEAN_ASTERISCUS                            0x070D
#define unicode_SYRIAC_ABBREVIATION_MARK                              0x070F
#define unicode_SYRIAC_LETTER_ALAPH                                   0x0710
#define unicode_SYRIAC_LETTER_SUPERSCRIPT_ALAPH                       0x0711
#define unicode_SYRIAC_LETTER_BETH                                    0x0712
#define unicode_SYRIAC_LETTER_GAMAL                                   0x0713
#define unicode_SYRIAC_LETTER_GAMAL_GARSHUNI                          0x0714
#define unicode_SYRIAC_LETTER_DALATH                                  0x0715
#define unicode_SYRIAC_LETTER_DOTLESS_DALATH_RISH                     0x0716
#define unicode_SYRIAC_LETTER_HE                                      0x0717
#define unicode_SYRIAC_LETTER_WAW                                     0x0718
#define unicode_SYRIAC_LETTER_ZAIN                                    0x0719
#define unicode_SYRIAC_LETTER_HETH                                    0x071A
#define unicode_SYRIAC_LETTER_TETH                                    0x071B
#define unicode_SYRIAC_LETTER_TETH_GARSHUNI                           0x071C
#define unicode_SYRIAC_LETTER_YUDH                                    0x071D
#define unicode_SYRIAC_LETTER_YUDH_HE                                 0x071E
#define unicode_SYRIAC_LETTER_KAPH                                    0x071F
#define unicode_SYRIAC_LETTER_LAMADH                                  0x0720
#define unicode_SYRIAC_LETTER_MIM                                     0x0721
#define unicode_SYRIAC_LETTER_NUN                                     0x0722
#define unicode_SYRIAC_LETTER_SEMKATH                                 0x0723
#define unicode_SYRIAC_LETTER_FINAL_SEMKATH                           0x0724
#define unicode_SYRIAC_LETTER_E                                       0x0725
#define unicode_SYRIAC_LETTER_PE                                      0x0726
#define unicode_SYRIAC_LETTER_REVERSED_PE                             0x0727
#define unicode_SYRIAC_LETTER_SADHE                                   0x0728
#define unicode_SYRIAC_LETTER_QAPH                                    0x0729
#define unicode_SYRIAC_LETTER_RISH                                    0x072A
#define unicode_SYRIAC_LETTER_SHIN                                    0x072B
#define unicode_SYRIAC_LETTER_TAW                                     0x072C
#define unicode_SYRIAC_LETTER_PERSIAN_BHETH                           0x072D
#define unicode_SYRIAC_LETTER_PERSIAN_GHAMAL                          0x072E
#define unicode_SYRIAC_LETTER_PERSIAN_DHALATH                         0x072F
#define unicode_SYRIAC_PTHAHA_ABOVE                                   0x0730
#define unicode_SYRIAC_PTHAHA_BELOW                                   0x0731
#define unicode_SYRIAC_PTHAHA_DOTTED                                  0x0732
#define unicode_SYRIAC_ZQAPHA_ABOVE                                   0x0733
#define unicode_SYRIAC_ZQAPHA_BELOW                                   0x0734
#define unicode_SYRIAC_ZQAPHA_DOTTED                                  0x0735
#define unicode_SYRIAC_RBASA_ABOVE                                    0x0736
#define unicode_SYRIAC_RBASA_BELOW                                    0x0737
#define unicode_SYRIAC_DOTTED_ZLAMA_HORIZONTAL                        0x0738
#define unicode_SYRIAC_DOTTED_ZLAMA_ANGULAR                           0x0739
#define unicode_SYRIAC_HBASA_ABOVE                                    0x073A
#define unicode_SYRIAC_HBASA_BELOW                                    0x073B
#define unicode_SYRIAC_HBASA_ESASA_DOTTED                             0x073C
#define unicode_SYRIAC_ESASA_ABOVE                                    0x073D
#define unicode_SYRIAC_ESASA_BELOW                                    0x073E
#define unicode_SYRIAC_RWAHA                                          0x073F
#define unicode_SYRIAC_FEMININE_DOT                                   0x0740
#define unicode_SYRIAC_QUSHSHAYA                                      0x0741
#define unicode_SYRIAC_RUKKAKHA                                       0x0742
#define unicode_SYRIAC_TWO_VERTICAL_DOTS_ABOVE                        0x0743
#define unicode_SYRIAC_TWO_VERTICAL_DOTS_BELOW                        0x0744
#define unicode_SYRIAC_THREE_DOTS_ABOVE                               0x0745
#define unicode_SYRIAC_THREE_DOTS_BELOW                               0x0746
#define unicode_SYRIAC_OBLIQUE_LINE_ABOVE                             0x0747
#define unicode_SYRIAC_OBLIQUE_LINE_BELOW                             0x0748
#define unicode_SYRIAC_MUSIC                                          0x0749
#define unicode_SYRIAC_BARREKH                                        0x074A
#define unicode_SYRIAC_LETTER_SOGDIAN_ZHAIN                           0x074D
#define unicode_SYRIAC_LETTER_SOGDIAN_KHAPH                           0x074E
#define unicode_SYRIAC_LETTER_SOGDIAN_FE                              0x074F
#define unicode_ARABIC_LETTER_BEH_WITH_THREE_DOTS_HORIZONTALLY_BELOW  0x0750
#define unicode_ARABIC_LETTER_BEH_WITH_DOT_BELOW_AND_THREE_DOTS_ABOVE 0x0751
#define unicode_ARABIC_LETTER_BEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW 0x0752
#define unicode_ARABIC_LETTER_BEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW_AND_TWO_DOTS_ABOVE 0x0753
#define unicode_ARABIC_LETTER_BEH_WITH_TWO_DOTS_BELOW_AND_DOT_ABOVE   0x0754
#define unicode_ARABIC_LETTER_BEH_WITH_INVERTED_SMALL_V_BELOW         0x0755
#define unicode_ARABIC_LETTER_BEH_WITH_SMALL_V                        0x0756
#define unicode_ARABIC_LETTER_HAH_WITH_TWO_DOTS_ABOVE                 0x0757
#define unicode_ARABIC_LETTER_HAH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW 0x0758
#define unicode_ARABIC_LETTER_DAL_WITH_TWO_DOTS_VERTICALLY_BELOW_AND_SMALL_TAH 0x0759
#define unicode_ARABIC_LETTER_DAL_WITH_INVERTED_SMALL_V_BELOW         0x075A
#define unicode_ARABIC_LETTER_REH_WITH_STROKE                         0x075B
#define unicode_ARABIC_LETTER_SEEN_WITH_FOUR_DOTS_ABOVE               0x075C
#define unicode_ARABIC_LETTER_AIN_WITH_TWO_DOTS_ABOVE                 0x075D
#define unicode_ARABIC_LETTER_AIN_WITH_THREE_DOTS_POINTING_DOWNWARDS_ABOVE 0x075E
#define unicode_ARABIC_LETTER_AIN_WITH_TWO_DOTS_VERTICALLY_ABOVE      0x075F
#define unicode_ARABIC_LETTER_FEH_WITH_TWO_DOTS_BELOW                 0x0760
#define unicode_ARABIC_LETTER_FEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW 0x0761
#define unicode_ARABIC_LETTER_KEHEH_WITH_DOT_ABOVE                    0x0762
#define unicode_ARABIC_LETTER_KEHEH_WITH_THREE_DOTS_ABOVE             0x0763
#define unicode_ARABIC_LETTER_KEHEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW 0x0764
#define unicode_ARABIC_LETTER_MEEM_WITH_DOT_ABOVE                     0x0765
#define unicode_ARABIC_LETTER_MEEM_WITH_DOT_BELOW                     0x0766
#define unicode_ARABIC_LETTER_NOON_WITH_TWO_DOTS_BELOW                0x0767
#define unicode_ARABIC_LETTER_NOON_WITH_SMALL_TAH                     0x0768
#define unicode_ARABIC_LETTER_NOON_WITH_SMALL_V                       0x0769
#define unicode_ARABIC_LETTER_LAM_WITH_BAR                            0x076A
#define unicode_ARABIC_LETTER_REH_WITH_TWO_DOTS_VERTICALLY_ABOVE      0x076B
#define unicode_ARABIC_LETTER_REH_WITH_HAMZA_ABOVE                    0x076C
#define unicode_ARABIC_LETTER_SEEN_WITH_TWO_DOTS_VERTICALLY_ABOVE     0x076D
#define unicode_ARABIC_LETTER_HAH_WITH_SMALL_ARABIC_LETTER_TAH_BELOW  0x076E
#define unicode_ARABIC_LETTER_HAH_WITH_SMALL_ARABIC_LETTER_TAH_AND_TWO_DOTS 0x076F
#define unicode_ARABIC_LETTER_SEEN_WITH_SMALL_ARABIC_LETTER_TAH_AND_TWO_DOTS 0x0770
#define unicode_ARABIC_LETTER_REH_WITH_SMALL_ARABIC_LETTER_TAH_AND_TWO_DOTS 0x0771
#define unicode_ARABIC_LETTER_HAH_WITH_SMALL_ARABIC_LETTER_TAH_ABOVE  0x0772
#define unicode_ARABIC_LETTER_ALEF_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE 0x0773
#define unicode_ARABIC_LETTER_ALEF_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE 0x0774
#define unicode_ARABIC_LETTER_FARSI_YEH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE 0x0775
#define unicode_ARABIC_LETTER_FARSI_YEH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE 0x0776
#define unicode_ARABIC_LETTER_FARSI_YEH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_FOUR_BELOW 0x0777
#define unicode_ARABIC_LETTER_WAW_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE 0x0778
#define unicode_ARABIC_LETTER_WAW_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE 0x0779
#define unicode_ARABIC_LETTER_YEH_BARREE_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE 0x077A
#define unicode_ARABIC_LETTER_YEH_BARREE_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE 0x077B
#define unicode_ARABIC_LETTER_HAH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_FOUR_BELOW 0x077C
#define unicode_ARABIC_LETTER_SEEN_WITH_EXTENDED_ARABIC_INDIC_DIGIT_FOUR_ABOVE 0x077D
#define unicode_ARABIC_LETTER_SEEN_WITH_INVERTED_V                    0x077E
#define unicode_ARABIC_LETTER_KAF_WITH_TWO_DOTS_ABOVE                 0x077F
#define unicode_THAANA_LETTER_HAA                                     0x0780
#define unicode_THAANA_LETTER_SHAVIYANI                               0x0781
#define unicode_THAANA_LETTER_NOONU                                   0x0782
#define unicode_THAANA_LETTER_RAA                                     0x0783
#define unicode_THAANA_LETTER_BAA                                     0x0784
#define unicode_THAANA_LETTER_LHAVIYANI                               0x0785
#define unicode_THAANA_LETTER_KAAFU                                   0x0786
#define unicode_THAANA_LETTER_ALIFU                                   0x0787
#define unicode_THAANA_LETTER_VAAVU                                   0x0788
#define unicode_THAANA_LETTER_MEEMU                                   0x0789
#define unicode_THAANA_LETTER_FAAFU                                   0x078A
#define unicode_THAANA_LETTER_DHAALU                                  0x078B
#define unicode_THAANA_LETTER_THAA                                    0x078C
#define unicode_THAANA_LETTER_LAAMU                                   0x078D
#define unicode_THAANA_LETTER_GAAFU                                   0x078E
#define unicode_THAANA_LETTER_GNAVIYANI                               0x078F
#define unicode_THAANA_LETTER_SEENU                                   0x0790
#define unicode_THAANA_LETTER_DAVIYANI                                0x0791
#define unicode_THAANA_LETTER_ZAVIYANI                                0x0792
#define unicode_THAANA_LETTER_TAVIYANI                                0x0793
#define unicode_THAANA_LETTER_YAA                                     0x0794
#define unicode_THAANA_LETTER_PAVIYANI                                0x0795
#define unicode_THAANA_LETTER_JAVIYANI                                0x0796
#define unicode_THAANA_LETTER_CHAVIYANI                               0x0797
#define unicode_THAANA_LETTER_TTAA                                    0x0798
#define unicode_THAANA_LETTER_HHAA                                    0x0799
#define unicode_THAANA_LETTER_KHAA                                    0x079A
#define unicode_THAANA_LETTER_THAALU                                  0x079B
#define unicode_THAANA_LETTER_ZAA                                     0x079C
#define unicode_THAANA_LETTER_SHEENU                                  0x079D
#define unicode_THAANA_LETTER_SAADHU                                  0x079E
#define unicode_THAANA_LETTER_DAADHU                                  0x079F
#define unicode_THAANA_LETTER_TO                                      0x07A0
#define unicode_THAANA_LETTER_ZO                                      0x07A1
#define unicode_THAANA_LETTER_AINU                                    0x07A2
#define unicode_THAANA_LETTER_GHAINU                                  0x07A3
#define unicode_THAANA_LETTER_QAAFU                                   0x07A4
#define unicode_THAANA_LETTER_WAAVU                                   0x07A5
#define unicode_THAANA_ABAFILI                                        0x07A6
#define unicode_THAANA_AABAAFILI                                      0x07A7
#define unicode_THAANA_IBIFILI                                        0x07A8
#define unicode_THAANA_EEBEEFILI                                      0x07A9
#define unicode_THAANA_UBUFILI                                        0x07AA
#define unicode_THAANA_OOBOOFILI                                      0x07AB
#define unicode_THAANA_EBEFILI                                        0x07AC
#define unicode_THAANA_EYBEYFILI                                      0x07AD
#define unicode_THAANA_OBOFILI                                        0x07AE
#define unicode_THAANA_OABOAFILI                                      0x07AF
#define unicode_THAANA_SUKUN                                          0x07B0
#define unicode_THAANA_LETTER_NAA                                     0x07B1
#define unicode_NKO_DIGIT_ZERO                                        0x07C0
#define unicode_NKO_DIGIT_ONE                                         0x07C1
#define unicode_NKO_DIGIT_TWO                                         0x07C2
#define unicode_NKO_DIGIT_THREE                                       0x07C3
#define unicode_NKO_DIGIT_FOUR                                        0x07C4
#define unicode_NKO_DIGIT_FIVE                                        0x07C5
#define unicode_NKO_DIGIT_SIX                                         0x07C6
#define unicode_NKO_DIGIT_SEVEN                                       0x07C7
#define unicode_NKO_DIGIT_EIGHT                                       0x07C8
#define unicode_NKO_DIGIT_NINE                                        0x07C9
#define unicode_NKO_LETTER_A                                          0x07CA
#define unicode_NKO_LETTER_EE                                         0x07CB
#define unicode_NKO_LETTER_I                                          0x07CC
#define unicode_NKO_LETTER_E                                          0x07CD
#define unicode_NKO_LETTER_U                                          0x07CE
#define unicode_NKO_LETTER_OO                                         0x07CF
#define unicode_NKO_LETTER_O                                          0x07D0
#define unicode_NKO_LETTER_DAGBASINNA                                 0x07D1
#define unicode_NKO_LETTER_N                                          0x07D2
#define unicode_NKO_LETTER_BA                                         0x07D3
#define unicode_NKO_LETTER_PA                                         0x07D4
#define unicode_NKO_LETTER_TA                                         0x07D5
#define unicode_NKO_LETTER_JA                                         0x07D6
#define unicode_NKO_LETTER_CHA                                        0x07D7
#define unicode_NKO_LETTER_DA                                         0x07D8
#define unicode_NKO_LETTER_RA                                         0x07D9
#define unicode_NKO_LETTER_RRA                                        0x07DA
#define unicode_NKO_LETTER_SA                                         0x07DB
#define unicode_NKO_LETTER_GBA                                        0x07DC
#define unicode_NKO_LETTER_FA                                         0x07DD
#define unicode_NKO_LETTER_KA                                         0x07DE
#define unicode_NKO_LETTER_LA                                         0x07DF
#define unicode_NKO_LETTER_NA_WOLOSO                                  0x07E0
#define unicode_NKO_LETTER_MA                                         0x07E1
#define unicode_NKO_LETTER_NYA                                        0x07E2
#define unicode_NKO_LETTER_NA                                         0x07E3
#define unicode_NKO_LETTER_HA                                         0x07E4
#define unicode_NKO_LETTER_WA                                         0x07E5
#define unicode_NKO_LETTER_YA                                         0x07E6
#define unicode_NKO_LETTER_NYA_WOLOSO                                 0x07E7
#define unicode_NKO_LETTER_JONA_JA                                    0x07E8
#define unicode_NKO_LETTER_JONA_CHA                                   0x07E9
#define unicode_NKO_LETTER_JONA_RA                                    0x07EA
#define unicode_NKO_COMBINING_SHORT_HIGH_TONE                         0x07EB
#define unicode_NKO_COMBINING_SHORT_LOW_TONE                          0x07EC
#define unicode_NKO_COMBINING_SHORT_RISING_TONE                       0x07ED
#define unicode_NKO_COMBINING_LONG_DESCENDING_TONE                    0x07EE
#define unicode_NKO_COMBINING_LONG_HIGH_TONE                          0x07EF
#define unicode_NKO_COMBINING_LONG_LOW_TONE                           0x07F0
#define unicode_NKO_COMBINING_LONG_RISING_TONE                        0x07F1
#define unicode_NKO_COMBINING_NASALIZATION_MARK                       0x07F2
#define unicode_NKO_COMBINING_DOUBLE_DOT_ABOVE                        0x07F3
#define unicode_NKO_HIGH_TONE_APOSTROPHE                              0x07F4
#define unicode_NKO_LOW_TONE_APOSTROPHE                               0x07F5
#define unicode_NKO_SYMBOL_OO_DENNEN                                  0x07F6
#define unicode_NKO_SYMBOL_GBAKURUNEN                                 0x07F7
#define unicode_NKO_COMMA                                             0x07F8
#define unicode_NKO_EXCLAMATION_MARK                                  0x07F9
#define unicode_NKO_LAJANYALAN                                        0x07FA
#define unicode_SAMARITAN_LETTER_ALAF                                 0x0800
#define unicode_SAMARITAN_LETTER_BIT                                  0x0801
#define unicode_SAMARITAN_LETTER_GAMAN                                0x0802
#define unicode_SAMARITAN_LETTER_DALAT                                0x0803
#define unicode_SAMARITAN_LETTER_IY                                   0x0804
#define unicode_SAMARITAN_LETTER_BAA                                  0x0805
#define unicode_SAMARITAN_LETTER_ZEN                                  0x0806
#define unicode_SAMARITAN_LETTER_IT                                   0x0807
#define unicode_SAMARITAN_LETTER_TIT                                  0x0808
#define unicode_SAMARITAN_LETTER_YUT                                  0x0809
#define unicode_SAMARITAN_LETTER_KAAF                                 0x080A
#define unicode_SAMARITAN_LETTER_LABAT                                0x080B
#define unicode_SAMARITAN_LETTER_MIM                                  0x080C
#define unicode_SAMARITAN_LETTER_NUN                                  0x080D
#define unicode_SAMARITAN_LETTER_SINGAAT                              0x080E
#define unicode_SAMARITAN_LETTER_IN                                   0x080F
#define unicode_SAMARITAN_LETTER_FI                                   0x0810
#define unicode_SAMARITAN_LETTER_TSAADIY                              0x0811
#define unicode_SAMARITAN_LETTER_QUF                                  0x0812
#define unicode_SAMARITAN_LETTER_RISH                                 0x0813
#define unicode_SAMARITAN_LETTER_SHAN                                 0x0814
#define unicode_SAMARITAN_LETTER_TAAF                                 0x0815
#define unicode_SAMARITAN_MARK_IN                                     0x0816
#define unicode_SAMARITAN_MARK_IN_ALAF                                0x0817
#define unicode_SAMARITAN_MARK_OCCLUSION                              0x0818
#define unicode_SAMARITAN_MARK_DAGESH                                 0x0819
#define unicode_SAMARITAN_MODIFIER_LETTER_EPENTHETIC_YUT              0x081A
#define unicode_SAMARITAN_MARK_EPENTHETIC_YUT                         0x081B
#define unicode_SAMARITAN_VOWEL_SIGN_LONG_E                           0x081C
#define unicode_SAMARITAN_VOWEL_SIGN_E                                0x081D
#define unicode_SAMARITAN_VOWEL_SIGN_OVERLONG_AA                      0x081E
#define unicode_SAMARITAN_VOWEL_SIGN_LONG_AA                          0x081F
#define unicode_SAMARITAN_VOWEL_SIGN_AA                               0x0820
#define unicode_SAMARITAN_VOWEL_SIGN_OVERLONG_A                       0x0821
#define unicode_SAMARITAN_VOWEL_SIGN_LONG_A                           0x0822
#define unicode_SAMARITAN_VOWEL_SIGN_A                                0x0823
#define unicode_SAMARITAN_MODIFIER_LETTER_SHORT_A                     0x0824
#define unicode_SAMARITAN_VOWEL_SIGN_SHORT_A                          0x0825
#define unicode_SAMARITAN_VOWEL_SIGN_LONG_U                           0x0826
#define unicode_SAMARITAN_VOWEL_SIGN_U                                0x0827
#define unicode_SAMARITAN_MODIFIER_LETTER_I                           0x0828
#define unicode_SAMARITAN_VOWEL_SIGN_LONG_I                           0x0829
#define unicode_SAMARITAN_VOWEL_SIGN_I                                0x082A
#define unicode_SAMARITAN_VOWEL_SIGN_O                                0x082B
#define unicode_SAMARITAN_VOWEL_SIGN_SUKUN                            0x082C
#define unicode_SAMARITAN_MARK_NEQUDAA                                0x082D
#define unicode_SAMARITAN_PUNCTUATION_NEQUDAA                         0x0830
#define unicode_SAMARITAN_PUNCTUATION_AFSAAQ                          0x0831
#define unicode_SAMARITAN_PUNCTUATION_ANGED                           0x0832
#define unicode_SAMARITAN_PUNCTUATION_BAU                             0x0833
#define unicode_SAMARITAN_PUNCTUATION_ATMAAU                          0x0834
#define unicode_SAMARITAN_PUNCTUATION_SHIYYAALAA                      0x0835
#define unicode_SAMARITAN_ABBREVIATION_MARK                           0x0836
#define unicode_SAMARITAN_PUNCTUATION_MELODIC_QITSA                   0x0837
#define unicode_SAMARITAN_PUNCTUATION_ZIQAA                           0x0838
#define unicode_SAMARITAN_PUNCTUATION_QITSA                           0x0839
#define unicode_SAMARITAN_PUNCTUATION_ZAEF                            0x083A
#define unicode_SAMARITAN_PUNCTUATION_TURU                            0x083B
#define unicode_SAMARITAN_PUNCTUATION_ARKAANU                         0x083C
#define unicode_SAMARITAN_PUNCTUATION_SOF_MASHFAAT                    0x083D
#define unicode_SAMARITAN_PUNCTUATION_ANNAAU                          0x083E
#define unicode_MANDAIC_LETTER_HALQA                                  0x0840
#define unicode_MANDAIC_LETTER_AB                                     0x0841
#define unicode_MANDAIC_LETTER_AG                                     0x0842
#define unicode_MANDAIC_LETTER_AD                                     0x0843
#define unicode_MANDAIC_LETTER_AH                                     0x0844
#define unicode_MANDAIC_LETTER_USHENNA                                0x0845
#define unicode_MANDAIC_LETTER_AZ                                     0x0846
#define unicode_MANDAIC_LETTER_IT                                     0x0847
#define unicode_MANDAIC_LETTER_ATT                                    0x0848
#define unicode_MANDAIC_LETTER_AKSA                                   0x0849
#define unicode_MANDAIC_LETTER_AK                                     0x084A
#define unicode_MANDAIC_LETTER_AL                                     0x084B
#define unicode_MANDAIC_LETTER_AM                                     0x084C
#define unicode_MANDAIC_LETTER_AN                                     0x084D
#define unicode_MANDAIC_LETTER_AS                                     0x084E
#define unicode_MANDAIC_LETTER_IN                                     0x084F
#define unicode_MANDAIC_LETTER_AP                                     0x0850
#define unicode_MANDAIC_LETTER_ASZ                                    0x0851
#define unicode_MANDAIC_LETTER_AQ                                     0x0852
#define unicode_MANDAIC_LETTER_AR                                     0x0853
#define unicode_MANDAIC_LETTER_ASH                                    0x0854
#define unicode_MANDAIC_LETTER_AT                                     0x0855
#define unicode_MANDAIC_LETTER_DUSHENNA                               0x0856
#define unicode_MANDAIC_LETTER_KAD                                    0x0857
#define unicode_MANDAIC_LETTER_AIN                                    0x0858
#define unicode_MANDAIC_AFFRICATION_MARK                              0x0859
#define unicode_MANDAIC_VOCALIZATION_MARK                             0x085A
#define unicode_MANDAIC_GEMINATION_MARK                               0x085B
#define unicode_MANDAIC_PUNCTUATION                                   0x085E
#define unicode_ARABIC_LETTER_BEH_WITH_SMALL_V_BELOW                  0x08A0
#define unicode_ARABIC_LETTER_BEH_WITH_HAMZA_ABOVE                    0x08A1
#define unicode_ARABIC_LETTER_JEEM_WITH_TWO_DOTS_ABOVE                0x08A2
#define unicode_ARABIC_LETTER_TAH_WITH_TWO_DOTS_ABOVE                 0x08A3
#define unicode_ARABIC_LETTER_FEH_WITH_DOT_BELOW_AND_THREE_DOTS_ABOVE 0x08A4
#define unicode_ARABIC_LETTER_QAF_WITH_DOT_BELOW                      0x08A5
#define unicode_ARABIC_LETTER_LAM_WITH_DOUBLE_BAR                     0x08A6
#define unicode_ARABIC_LETTER_MEEM_WITH_THREE_DOTS_ABOVE              0x08A7
#define unicode_ARABIC_LETTER_YEH_WITH_TWO_DOTS_BELOW_AND_HAMZA_ABOVE 0x08A8
#define unicode_ARABIC_LETTER_YEH_WITH_TWO_DOTS_BELOW_AND_DOT_ABOVE   0x08A9
#define unicode_ARABIC_LETTER_REH_WITH_LOOP                           0x08AA
#define unicode_ARABIC_LETTER_WAW_WITH_DOT_WITHIN                     0x08AB
#define unicode_ARABIC_LETTER_ROHINGYA_YEH                            0x08AC
#define unicode_ARABIC_LETTER_LOW_ALEF                                0x08AD
#define unicode_ARABIC_LETTER_DAL_WITH_THREE_DOTS_BELOW               0x08AE
#define unicode_ARABIC_LETTER_SAD_WITH_THREE_DOTS_BELOW               0x08AF
#define unicode_ARABIC_LETTER_GAF_WITH_INVERTED_STROKE                0x08B0
#define unicode_ARABIC_LETTER_STRAIGHT_WAW                            0x08B1
#define unicode_ARABIC_LETTER_ZAIN_WITH_INVERTED_V_ABOVE              0x08B2
#define unicode_ARABIC_CURLY_FATHA                                    0x08E4
#define unicode_ARABIC_CURLY_DAMMA                                    0x08E5
#define unicode_ARABIC_CURLY_KASRA                                    0x08E6
#define unicode_ARABIC_CURLY_FATHATAN                                 0x08E7
#define unicode_ARABIC_CURLY_DAMMATAN                                 0x08E8
#define unicode_ARABIC_CURLY_KASRATAN                                 0x08E9
#define unicode_ARABIC_TONE_ONE_DOT_ABOVE                             0x08EA
#define unicode_ARABIC_TONE_TWO_DOTS_ABOVE                            0x08EB
#define unicode_ARABIC_TONE_LOOP_ABOVE                                0x08EC
#define unicode_ARABIC_TONE_ONE_DOT_BELOW                             0x08ED
#define unicode_ARABIC_TONE_TWO_DOTS_BELOW                            0x08EE
#define unicode_ARABIC_TONE_LOOP_BELOW                                0x08EF
#define unicode_ARABIC_OPEN_FATHATAN                                  0x08F0
#define unicode_ARABIC_OPEN_DAMMATAN                                  0x08F1
#define unicode_ARABIC_OPEN_KASRATAN                                  0x08F2
#define unicode_ARABIC_SMALL_HIGH_WAW                                 0x08F3
#define unicode_ARABIC_FATHA_WITH_RING                                0x08F4
#define unicode_ARABIC_FATHA_WITH_DOT_ABOVE                           0x08F5
#define unicode_ARABIC_KASRA_WITH_DOT_BELOW                           0x08F6
#define unicode_ARABIC_LEFT_ARROWHEAD_ABOVE                           0x08F7
#define unicode_ARABIC_RIGHT_ARROWHEAD_ABOVE                          0x08F8
#define unicode_ARABIC_LEFT_ARROWHEAD_BELOW                           0x08F9
#define unicode_ARABIC_RIGHT_ARROWHEAD_BELOW                          0x08FA
#define unicode_ARABIC_DOUBLE_RIGHT_ARROWHEAD_ABOVE                   0x08FB
#define unicode_ARABIC_DOUBLE_RIGHT_ARROWHEAD_ABOVE_WITH_DOT          0x08FC
#define unicode_ARABIC_RIGHT_ARROWHEAD_ABOVE_WITH_DOT                 0x08FD
#define unicode_ARABIC_DAMMA_WITH_DOT                                 0x08FE
#define unicode_ARABIC_MARK_SIDEWAYS_NOON_GHUNNA                      0x08FF
#define unicode_DEVANAGARI_SIGN_INVERTED_CANDRABINDU                  0x0900
#define unicode_DEVANAGARI_SIGN_CANDRABINDU                           0x0901
#define unicode_DEVANAGARI_SIGN_ANUSVARA                              0x0902
#define unicode_DEVANAGARI_SIGN_VISARGA                               0x0903
#define unicode_DEVANAGARI_LETTER_SHORT_A                             0x0904
#define unicode_DEVANAGARI_LETTER_A                                   0x0905
#define unicode_DEVANAGARI_LETTER_AA                                  0x0906
#define unicode_DEVANAGARI_LETTER_I                                   0x0907
#define unicode_DEVANAGARI_LETTER_II                                  0x0908
#define unicode_DEVANAGARI_LETTER_U                                   0x0909
#define unicode_DEVANAGARI_LETTER_UU                                  0x090A
#define unicode_DEVANAGARI_LETTER_VOCALIC_R                           0x090B
#define unicode_DEVANAGARI_LETTER_VOCALIC_L                           0x090C
#define unicode_DEVANAGARI_LETTER_CANDRA_E                            0x090D
#define unicode_DEVANAGARI_LETTER_SHORT_E                             0x090E
#define unicode_DEVANAGARI_LETTER_E                                   0x090F
#define unicode_DEVANAGARI_LETTER_AI                                  0x0910
#define unicode_DEVANAGARI_LETTER_CANDRA_O                            0x0911
#define unicode_DEVANAGARI_LETTER_SHORT_O                             0x0912
#define unicode_DEVANAGARI_LETTER_O                                   0x0913
#define unicode_DEVANAGARI_LETTER_AU                                  0x0914
#define unicode_DEVANAGARI_LETTER_KA                                  0x0915
#define unicode_DEVANAGARI_LETTER_KHA                                 0x0916
#define unicode_DEVANAGARI_LETTER_GA                                  0x0917
#define unicode_DEVANAGARI_LETTER_GHA                                 0x0918
#define unicode_DEVANAGARI_LETTER_NGA                                 0x0919
#define unicode_DEVANAGARI_LETTER_CA                                  0x091A
#define unicode_DEVANAGARI_LETTER_CHA                                 0x091B
#define unicode_DEVANAGARI_LETTER_JA                                  0x091C
#define unicode_DEVANAGARI_LETTER_JHA                                 0x091D
#define unicode_DEVANAGARI_LETTER_NYA                                 0x091E
#define unicode_DEVANAGARI_LETTER_TTA                                 0x091F
#define unicode_DEVANAGARI_LETTER_TTHA                                0x0920
#define unicode_DEVANAGARI_LETTER_DDA                                 0x0921
#define unicode_DEVANAGARI_LETTER_DDHA                                0x0922
#define unicode_DEVANAGARI_LETTER_NNA                                 0x0923
#define unicode_DEVANAGARI_LETTER_TA                                  0x0924
#define unicode_DEVANAGARI_LETTER_THA                                 0x0925
#define unicode_DEVANAGARI_LETTER_DA                                  0x0926
#define unicode_DEVANAGARI_LETTER_DHA                                 0x0927
#define unicode_DEVANAGARI_LETTER_NA                                  0x0928
#define unicode_DEVANAGARI_LETTER_NNNA                                0x0929
#define unicode_DEVANAGARI_LETTER_PA                                  0x092A
#define unicode_DEVANAGARI_LETTER_PHA                                 0x092B
#define unicode_DEVANAGARI_LETTER_BA                                  0x092C
#define unicode_DEVANAGARI_LETTER_BHA                                 0x092D
#define unicode_DEVANAGARI_LETTER_MA                                  0x092E
#define unicode_DEVANAGARI_LETTER_YA                                  0x092F
#define unicode_DEVANAGARI_LETTER_RA                                  0x0930
#define unicode_DEVANAGARI_LETTER_RRA                                 0x0931
#define unicode_DEVANAGARI_LETTER_LA                                  0x0932
#define unicode_DEVANAGARI_LETTER_LLA                                 0x0933
#define unicode_DEVANAGARI_LETTER_LLLA                                0x0934
#define unicode_DEVANAGARI_LETTER_VA                                  0x0935
#define unicode_DEVANAGARI_LETTER_SHA                                 0x0936
#define unicode_DEVANAGARI_LETTER_SSA                                 0x0937
#define unicode_DEVANAGARI_LETTER_SA                                  0x0938
#define unicode_DEVANAGARI_LETTER_HA                                  0x0939
#define unicode_DEVANAGARI_VOWEL_SIGN_OE                              0x093A
#define unicode_DEVANAGARI_VOWEL_SIGN_OOE                             0x093B
#define unicode_DEVANAGARI_SIGN_NUKTA                                 0x093C
#define unicode_DEVANAGARI_SIGN_AVAGRAHA                              0x093D
#define unicode_DEVANAGARI_VOWEL_SIGN_AA                              0x093E
#define unicode_DEVANAGARI_VOWEL_SIGN_I                               0x093F
#define unicode_DEVANAGARI_VOWEL_SIGN_II                              0x0940
#define unicode_DEVANAGARI_VOWEL_SIGN_U                               0x0941
#define unicode_DEVANAGARI_VOWEL_SIGN_UU                              0x0942
#define unicode_DEVANAGARI_VOWEL_SIGN_VOCALIC_R                       0x0943
#define unicode_DEVANAGARI_VOWEL_SIGN_VOCALIC_RR                      0x0944
#define unicode_DEVANAGARI_VOWEL_SIGN_CANDRA_E                        0x0945
#define unicode_DEVANAGARI_VOWEL_SIGN_SHORT_E                         0x0946
#define unicode_DEVANAGARI_VOWEL_SIGN_E                               0x0947
#define unicode_DEVANAGARI_VOWEL_SIGN_AI                              0x0948
#define unicode_DEVANAGARI_VOWEL_SIGN_CANDRA_O                        0x0949
#define unicode_DEVANAGARI_VOWEL_SIGN_SHORT_O                         0x094A
#define unicode_DEVANAGARI_VOWEL_SIGN_O                               0x094B
#define unicode_DEVANAGARI_VOWEL_SIGN_AU                              0x094C
#define unicode_DEVANAGARI_SIGN_VIRAMA                                0x094D
#define unicode_DEVANAGARI_VOWEL_SIGN_PRISHTHAMATRA_E                 0x094E
#define unicode_DEVANAGARI_VOWEL_SIGN_AW                              0x094F
#define unicode_DEVANAGARI_OM                                         0x0950
#define unicode_DEVANAGARI_STRESS_SIGN_UDATTA                         0x0951
#define unicode_DEVANAGARI_STRESS_SIGN_ANUDATTA                       0x0952
#define unicode_DEVANAGARI_GRAVE_ACCENT                               0x0953
#define unicode_DEVANAGARI_ACUTE_ACCENT                               0x0954
#define unicode_DEVANAGARI_VOWEL_SIGN_CANDRA_LONG_E                   0x0955
#define unicode_DEVANAGARI_VOWEL_SIGN_UE                              0x0956
#define unicode_DEVANAGARI_VOWEL_SIGN_UUE                             0x0957
#define unicode_DEVANAGARI_LETTER_QA                                  0x0958
#define unicode_DEVANAGARI_LETTER_KHHA                                0x0959
#define unicode_DEVANAGARI_LETTER_GHHA                                0x095A
#define unicode_DEVANAGARI_LETTER_ZA                                  0x095B
#define unicode_DEVANAGARI_LETTER_DDDHA                               0x095C
#define unicode_DEVANAGARI_LETTER_RHA                                 0x095D
#define unicode_DEVANAGARI_LETTER_FA                                  0x095E
#define unicode_DEVANAGARI_LETTER_YYA                                 0x095F
#define unicode_DEVANAGARI_LETTER_VOCALIC_RR                          0x0960
#define unicode_DEVANAGARI_LETTER_VOCALIC_LL                          0x0961
#define unicode_DEVANAGARI_VOWEL_SIGN_VOCALIC_L                       0x0962
#define unicode_DEVANAGARI_VOWEL_SIGN_VOCALIC_LL                      0x0963
#define unicode_DEVANAGARI_DANDA                                      0x0964
#define unicode_DEVANAGARI_DOUBLE_DANDA                               0x0965
#define unicode_DEVANAGARI_DIGIT_ZERO                                 0x0966
#define unicode_DEVANAGARI_DIGIT_ONE                                  0x0967
#define unicode_DEVANAGARI_DIGIT_TWO                                  0x0968
#define unicode_DEVANAGARI_DIGIT_THREE                                0x0969
#define unicode_DEVANAGARI_DIGIT_FOUR                                 0x096A
#define unicode_DEVANAGARI_DIGIT_FIVE                                 0x096B
#define unicode_DEVANAGARI_DIGIT_SIX                                  0x096C
#define unicode_DEVANAGARI_DIGIT_SEVEN                                0x096D
#define unicode_DEVANAGARI_DIGIT_EIGHT                                0x096E
#define unicode_DEVANAGARI_DIGIT_NINE                                 0x096F
#define unicode_DEVANAGARI_ABBREVIATION_SIGN                          0x0970
#define unicode_DEVANAGARI_SIGN_HIGH_SPACING_DOT                      0x0971
#define unicode_DEVANAGARI_LETTER_CANDRA_A                            0x0972
#define unicode_DEVANAGARI_LETTER_OE                                  0x0973
#define unicode_DEVANAGARI_LETTER_OOE                                 0x0974
#define unicode_DEVANAGARI_LETTER_AW                                  0x0975
#define unicode_DEVANAGARI_LETTER_UE                                  0x0976
#define unicode_DEVANAGARI_LETTER_UUE                                 0x0977
#define unicode_DEVANAGARI_LETTER_MARWARI_DDA                         0x0978
#define unicode_DEVANAGARI_LETTER_ZHA                                 0x0979
#define unicode_DEVANAGARI_LETTER_HEAVY_YA                            0x097A
#define unicode_DEVANAGARI_LETTER_GGA                                 0x097B
#define unicode_DEVANAGARI_LETTER_JJA                                 0x097C
#define unicode_DEVANAGARI_LETTER_GLOTTAL_STOP                        0x097D
#define unicode_DEVANAGARI_LETTER_DDDA                                0x097E
#define unicode_DEVANAGARI_LETTER_BBA                                 0x097F
#define unicode_BENGALI_ANJI                                          0x0980
#define unicode_BENGALI_SIGN_CANDRABINDU                              0x0981
#define unicode_BENGALI_SIGN_ANUSVARA                                 0x0982
#define unicode_BENGALI_SIGN_VISARGA                                  0x0983
#define unicode_BENGALI_LETTER_A                                      0x0985
#define unicode_BENGALI_LETTER_AA                                     0x0986
#define unicode_BENGALI_LETTER_I                                      0x0987
#define unicode_BENGALI_LETTER_II                                     0x0988
#define unicode_BENGALI_LETTER_U                                      0x0989
#define unicode_BENGALI_LETTER_UU                                     0x098A
#define unicode_BENGALI_LETTER_VOCALIC_R                              0x098B
#define unicode_BENGALI_LETTER_VOCALIC_L                              0x098C
#define unicode_BENGALI_LETTER_E                                      0x098F
#define unicode_BENGALI_LETTER_AI                                     0x0990
#define unicode_BENGALI_LETTER_O                                      0x0993
#define unicode_BENGALI_LETTER_AU                                     0x0994
#define unicode_BENGALI_LETTER_KA                                     0x0995
#define unicode_BENGALI_LETTER_KHA                                    0x0996
#define unicode_BENGALI_LETTER_GA                                     0x0997
#define unicode_BENGALI_LETTER_GHA                                    0x0998
#define unicode_BENGALI_LETTER_NGA                                    0x0999
#define unicode_BENGALI_LETTER_CA                                     0x099A
#define unicode_BENGALI_LETTER_CHA                                    0x099B
#define unicode_BENGALI_LETTER_JA                                     0x099C
#define unicode_BENGALI_LETTER_JHA                                    0x099D
#define unicode_BENGALI_LETTER_NYA                                    0x099E
#define unicode_BENGALI_LETTER_TTA                                    0x099F
#define unicode_BENGALI_LETTER_TTHA                                   0x09A0
#define unicode_BENGALI_LETTER_DDA                                    0x09A1
#define unicode_BENGALI_LETTER_DDHA                                   0x09A2
#define unicode_BENGALI_LETTER_NNA                                    0x09A3
#define unicode_BENGALI_LETTER_TA                                     0x09A4
#define unicode_BENGALI_LETTER_THA                                    0x09A5
#define unicode_BENGALI_LETTER_DA                                     0x09A6
#define unicode_BENGALI_LETTER_DHA                                    0x09A7
#define unicode_BENGALI_LETTER_NA                                     0x09A8
#define unicode_BENGALI_LETTER_PA                                     0x09AA
#define unicode_BENGALI_LETTER_PHA                                    0x09AB
#define unicode_BENGALI_LETTER_BA                                     0x09AC
#define unicode_BENGALI_LETTER_BHA                                    0x09AD
#define unicode_BENGALI_LETTER_MA                                     0x09AE
#define unicode_BENGALI_LETTER_YA                                     0x09AF
#define unicode_BENGALI_LETTER_RA                                     0x09B0
#define unicode_BENGALI_LETTER_LA                                     0x09B2
#define unicode_BENGALI_LETTER_SHA                                    0x09B6
#define unicode_BENGALI_LETTER_SSA                                    0x09B7
#define unicode_BENGALI_LETTER_SA                                     0x09B8
#define unicode_BENGALI_LETTER_HA                                     0x09B9
#define unicode_BENGALI_SIGN_NUKTA                                    0x09BC
#define unicode_BENGALI_SIGN_AVAGRAHA                                 0x09BD
#define unicode_BENGALI_VOWEL_SIGN_AA                                 0x09BE
#define unicode_BENGALI_VOWEL_SIGN_I                                  0x09BF
#define unicode_BENGALI_VOWEL_SIGN_II                                 0x09C0
#define unicode_BENGALI_VOWEL_SIGN_U                                  0x09C1
#define unicode_BENGALI_VOWEL_SIGN_UU                                 0x09C2
#define unicode_BENGALI_VOWEL_SIGN_VOCALIC_R                          0x09C3
#define unicode_BENGALI_VOWEL_SIGN_VOCALIC_RR                         0x09C4
#define unicode_BENGALI_VOWEL_SIGN_E                                  0x09C7
#define unicode_BENGALI_VOWEL_SIGN_AI                                 0x09C8
#define unicode_BENGALI_VOWEL_SIGN_O                                  0x09CB
#define unicode_BENGALI_VOWEL_SIGN_AU                                 0x09CC
#define unicode_BENGALI_SIGN_VIRAMA                                   0x09CD
#define unicode_BENGALI_LETTER_KHANDA_TA                              0x09CE
#define unicode_BENGALI_AU_LENGTH_MARK                                0x09D7
#define unicode_BENGALI_LETTER_RRA                                    0x09DC
#define unicode_BENGALI_LETTER_RHA                                    0x09DD
#define unicode_BENGALI_LETTER_YYA                                    0x09DF
#define unicode_BENGALI_LETTER_VOCALIC_RR                             0x09E0
#define unicode_BENGALI_LETTER_VOCALIC_LL                             0x09E1
#define unicode_BENGALI_VOWEL_SIGN_VOCALIC_L                          0x09E2
#define unicode_BENGALI_VOWEL_SIGN_VOCALIC_LL                         0x09E3
#define unicode_BENGALI_DIGIT_ZERO                                    0x09E6
#define unicode_BENGALI_DIGIT_ONE                                     0x09E7
#define unicode_BENGALI_DIGIT_TWO                                     0x09E8
#define unicode_BENGALI_DIGIT_THREE                                   0x09E9
#define unicode_BENGALI_DIGIT_FOUR                                    0x09EA
#define unicode_BENGALI_DIGIT_FIVE                                    0x09EB
#define unicode_BENGALI_DIGIT_SIX                                     0x09EC
#define unicode_BENGALI_DIGIT_SEVEN                                   0x09ED
#define unicode_BENGALI_DIGIT_EIGHT                                   0x09EE
#define unicode_BENGALI_DIGIT_NINE                                    0x09EF
#define unicode_BENGALI_LETTER_RA_WITH_MIDDLE_DIAGONAL                0x09F0
#define unicode_BENGALI_LETTER_RA_WITH_LOWER_DIAGONAL                 0x09F1
#define unicode_BENGALI_RUPEE_MARK                                    0x09F2
#define unicode_BENGALI_RUPEE_SIGN                                    0x09F3
#define unicode_BENGALI_CURRENCY_NUMERATOR_ONE                        0x09F4
#define unicode_BENGALI_CURRENCY_NUMERATOR_TWO                        0x09F5
#define unicode_BENGALI_CURRENCY_NUMERATOR_THREE                      0x09F6
#define unicode_BENGALI_CURRENCY_NUMERATOR_FOUR                       0x09F7
#define unicode_BENGALI_CURRENCY_NUMERATOR_ONE_LESS_THAN_THE_DENOMINATOR 0x09F8
#define unicode_BENGALI_CURRENCY_DENOMINATOR_SIXTEEN                  0x09F9
#define unicode_BENGALI_ISSHAR                                        0x09FA
#define unicode_BENGALI_GANDA_MARK                                    0x09FB
#define unicode_GURMUKHI_SIGN_ADAK_BINDI                              0x0A01
#define unicode_GURMUKHI_SIGN_BINDI                                   0x0A02
#define unicode_GURMUKHI_SIGN_VISARGA                                 0x0A03
#define unicode_GURMUKHI_LETTER_A                                     0x0A05
#define unicode_GURMUKHI_LETTER_AA                                    0x0A06
#define unicode_GURMUKHI_LETTER_I                                     0x0A07
#define unicode_GURMUKHI_LETTER_II                                    0x0A08
#define unicode_GURMUKHI_LETTER_U                                     0x0A09
#define unicode_GURMUKHI_LETTER_UU                                    0x0A0A
#define unicode_GURMUKHI_LETTER_EE                                    0x0A0F
#define unicode_GURMUKHI_LETTER_AI                                    0x0A10
#define unicode_GURMUKHI_LETTER_OO                                    0x0A13
#define unicode_GURMUKHI_LETTER_AU                                    0x0A14
#define unicode_GURMUKHI_LETTER_KA                                    0x0A15
#define unicode_GURMUKHI_LETTER_KHA                                   0x0A16
#define unicode_GURMUKHI_LETTER_GA                                    0x0A17
#define unicode_GURMUKHI_LETTER_GHA                                   0x0A18
#define unicode_GURMUKHI_LETTER_NGA                                   0x0A19
#define unicode_GURMUKHI_LETTER_CA                                    0x0A1A
#define unicode_GURMUKHI_LETTER_CHA                                   0x0A1B
#define unicode_GURMUKHI_LETTER_JA                                    0x0A1C
#define unicode_GURMUKHI_LETTER_JHA                                   0x0A1D
#define unicode_GURMUKHI_LETTER_NYA                                   0x0A1E
#define unicode_GURMUKHI_LETTER_TTA                                   0x0A1F
#define unicode_GURMUKHI_LETTER_TTHA                                  0x0A20
#define unicode_GURMUKHI_LETTER_DDA                                   0x0A21
#define unicode_GURMUKHI_LETTER_DDHA                                  0x0A22
#define unicode_GURMUKHI_LETTER_NNA                                   0x0A23
#define unicode_GURMUKHI_LETTER_TA                                    0x0A24
#define unicode_GURMUKHI_LETTER_THA                                   0x0A25
#define unicode_GURMUKHI_LETTER_DA                                    0x0A26
#define unicode_GURMUKHI_LETTER_DHA                                   0x0A27
#define unicode_GURMUKHI_LETTER_NA                                    0x0A28
#define unicode_GURMUKHI_LETTER_PA                                    0x0A2A
#define unicode_GURMUKHI_LETTER_PHA                                   0x0A2B
#define unicode_GURMUKHI_LETTER_BA                                    0x0A2C
#define unicode_GURMUKHI_LETTER_BHA                                   0x0A2D
#define unicode_GURMUKHI_LETTER_MA                                    0x0A2E
#define unicode_GURMUKHI_LETTER_YA                                    0x0A2F
#define unicode_GURMUKHI_LETTER_RA                                    0x0A30
#define unicode_GURMUKHI_LETTER_LA                                    0x0A32
#define unicode_GURMUKHI_LETTER_LLA                                   0x0A33
#define unicode_GURMUKHI_LETTER_VA                                    0x0A35
#define unicode_GURMUKHI_LETTER_SHA                                   0x0A36
#define unicode_GURMUKHI_LETTER_SA                                    0x0A38
#define unicode_GURMUKHI_LETTER_HA                                    0x0A39
#define unicode_GURMUKHI_SIGN_NUKTA                                   0x0A3C
#define unicode_GURMUKHI_VOWEL_SIGN_AA                                0x0A3E
#define unicode_GURMUKHI_VOWEL_SIGN_I                                 0x0A3F
#define unicode_GURMUKHI_VOWEL_SIGN_II                                0x0A40
#define unicode_GURMUKHI_VOWEL_SIGN_U                                 0x0A41
#define unicode_GURMUKHI_VOWEL_SIGN_UU                                0x0A42
#define unicode_GURMUKHI_VOWEL_SIGN_EE                                0x0A47
#define unicode_GURMUKHI_VOWEL_SIGN_AI                                0x0A48
#define unicode_GURMUKHI_VOWEL_SIGN_OO                                0x0A4B
#define unicode_GURMUKHI_VOWEL_SIGN_AU                                0x0A4C
#define unicode_GURMUKHI_SIGN_VIRAMA                                  0x0A4D
#define unicode_GURMUKHI_SIGN_UDAAT                                   0x0A51
#define unicode_GURMUKHI_LETTER_KHHA                                  0x0A59
#define unicode_GURMUKHI_LETTER_GHHA                                  0x0A5A
#define unicode_GURMUKHI_LETTER_ZA                                    0x0A5B
#define unicode_GURMUKHI_LETTER_RRA                                   0x0A5C
#define unicode_GURMUKHI_LETTER_FA                                    0x0A5E
#define unicode_GURMUKHI_DIGIT_ZERO                                   0x0A66
#define unicode_GURMUKHI_DIGIT_ONE                                    0x0A67
#define unicode_GURMUKHI_DIGIT_TWO                                    0x0A68
#define unicode_GURMUKHI_DIGIT_THREE                                  0x0A69
#define unicode_GURMUKHI_DIGIT_FOUR                                   0x0A6A
#define unicode_GURMUKHI_DIGIT_FIVE                                   0x0A6B
#define unicode_GURMUKHI_DIGIT_SIX                                    0x0A6C
#define unicode_GURMUKHI_DIGIT_SEVEN                                  0x0A6D
#define unicode_GURMUKHI_DIGIT_EIGHT                                  0x0A6E
#define unicode_GURMUKHI_DIGIT_NINE                                   0x0A6F
#define unicode_GURMUKHI_TIPPI                                        0x0A70
#define unicode_GURMUKHI_ADDAK                                        0x0A71
#define unicode_GURMUKHI_IRI                                          0x0A72
#define unicode_GURMUKHI_URA                                          0x0A73
#define unicode_GURMUKHI_EK_ONKAR                                     0x0A74
#define unicode_GURMUKHI_SIGN_YAKASH                                  0x0A75
#define unicode_GUJARATI_SIGN_CANDRABINDU                             0x0A81
#define unicode_GUJARATI_SIGN_ANUSVARA                                0x0A82
#define unicode_GUJARATI_SIGN_VISARGA                                 0x0A83
#define unicode_GUJARATI_LETTER_A                                     0x0A85
#define unicode_GUJARATI_LETTER_AA                                    0x0A86
#define unicode_GUJARATI_LETTER_I                                     0x0A87
#define unicode_GUJARATI_LETTER_II                                    0x0A88
#define unicode_GUJARATI_LETTER_U                                     0x0A89
#define unicode_GUJARATI_LETTER_UU                                    0x0A8A
#define unicode_GUJARATI_LETTER_VOCALIC_R                             0x0A8B
#define unicode_GUJARATI_LETTER_VOCALIC_L                             0x0A8C
#define unicode_GUJARATI_VOWEL_CANDRA_E                               0x0A8D
#define unicode_GUJARATI_LETTER_E                                     0x0A8F
#define unicode_GUJARATI_LETTER_AI                                    0x0A90
#define unicode_GUJARATI_VOWEL_CANDRA_O                               0x0A91
#define unicode_GUJARATI_LETTER_O                                     0x0A93
#define unicode_GUJARATI_LETTER_AU                                    0x0A94
#define unicode_GUJARATI_LETTER_KA                                    0x0A95
#define unicode_GUJARATI_LETTER_KHA                                   0x0A96
#define unicode_GUJARATI_LETTER_GA                                    0x0A97
#define unicode_GUJARATI_LETTER_GHA                                   0x0A98
#define unicode_GUJARATI_LETTER_NGA                                   0x0A99
#define unicode_GUJARATI_LETTER_CA                                    0x0A9A
#define unicode_GUJARATI_LETTER_CHA                                   0x0A9B
#define unicode_GUJARATI_LETTER_JA                                    0x0A9C
#define unicode_GUJARATI_LETTER_JHA                                   0x0A9D
#define unicode_GUJARATI_LETTER_NYA                                   0x0A9E
#define unicode_GUJARATI_LETTER_TTA                                   0x0A9F
#define unicode_GUJARATI_LETTER_TTHA                                  0x0AA0
#define unicode_GUJARATI_LETTER_DDA                                   0x0AA1
#define unicode_GUJARATI_LETTER_DDHA                                  0x0AA2
#define unicode_GUJARATI_LETTER_NNA                                   0x0AA3
#define unicode_GUJARATI_LETTER_TA                                    0x0AA4
#define unicode_GUJARATI_LETTER_THA                                   0x0AA5
#define unicode_GUJARATI_LETTER_DA                                    0x0AA6
#define unicode_GUJARATI_LETTER_DHA                                   0x0AA7
#define unicode_GUJARATI_LETTER_NA                                    0x0AA8
#define unicode_GUJARATI_LETTER_PA                                    0x0AAA
#define unicode_GUJARATI_LETTER_PHA                                   0x0AAB
#define unicode_GUJARATI_LETTER_BA                                    0x0AAC
#define unicode_GUJARATI_LETTER_BHA                                   0x0AAD
#define unicode_GUJARATI_LETTER_MA                                    0x0AAE
#define unicode_GUJARATI_LETTER_YA                                    0x0AAF
#define unicode_GUJARATI_LETTER_RA                                    0x0AB0
#define unicode_GUJARATI_LETTER_LA                                    0x0AB2
#define unicode_GUJARATI_LETTER_LLA                                   0x0AB3
#define unicode_GUJARATI_LETTER_VA                                    0x0AB5
#define unicode_GUJARATI_LETTER_SHA                                   0x0AB6
#define unicode_GUJARATI_LETTER_SSA                                   0x0AB7
#define unicode_GUJARATI_LETTER_SA                                    0x0AB8
#define unicode_GUJARATI_LETTER_HA                                    0x0AB9
#define unicode_GUJARATI_SIGN_NUKTA                                   0x0ABC
#define unicode_GUJARATI_SIGN_AVAGRAHA                                0x0ABD
#define unicode_GUJARATI_VOWEL_SIGN_AA                                0x0ABE
#define unicode_GUJARATI_VOWEL_SIGN_I                                 0x0ABF
#define unicode_GUJARATI_VOWEL_SIGN_II                                0x0AC0
#define unicode_GUJARATI_VOWEL_SIGN_U                                 0x0AC1
#define unicode_GUJARATI_VOWEL_SIGN_UU                                0x0AC2
#define unicode_GUJARATI_VOWEL_SIGN_VOCALIC_R                         0x0AC3
#define unicode_GUJARATI_VOWEL_SIGN_VOCALIC_RR                        0x0AC4
#define unicode_GUJARATI_VOWEL_SIGN_CANDRA_E                          0x0AC5
#define unicode_GUJARATI_VOWEL_SIGN_E                                 0x0AC7
#define unicode_GUJARATI_VOWEL_SIGN_AI                                0x0AC8
#define unicode_GUJARATI_VOWEL_SIGN_CANDRA_O                          0x0AC9
#define unicode_GUJARATI_VOWEL_SIGN_O                                 0x0ACB
#define unicode_GUJARATI_VOWEL_SIGN_AU                                0x0ACC
#define unicode_GUJARATI_SIGN_VIRAMA                                  0x0ACD
#define unicode_GUJARATI_OM                                           0x0AD0
#define unicode_GUJARATI_LETTER_VOCALIC_RR                            0x0AE0
#define unicode_GUJARATI_LETTER_VOCALIC_LL                            0x0AE1
#define unicode_GUJARATI_VOWEL_SIGN_VOCALIC_L                         0x0AE2
#define unicode_GUJARATI_VOWEL_SIGN_VOCALIC_LL                        0x0AE3
#define unicode_GUJARATI_DIGIT_ZERO                                   0x0AE6
#define unicode_GUJARATI_DIGIT_ONE                                    0x0AE7
#define unicode_GUJARATI_DIGIT_TWO                                    0x0AE8
#define unicode_GUJARATI_DIGIT_THREE                                  0x0AE9
#define unicode_GUJARATI_DIGIT_FOUR                                   0x0AEA
#define unicode_GUJARATI_DIGIT_FIVE                                   0x0AEB
#define unicode_GUJARATI_DIGIT_SIX                                    0x0AEC
#define unicode_GUJARATI_DIGIT_SEVEN                                  0x0AED
#define unicode_GUJARATI_DIGIT_EIGHT                                  0x0AEE
#define unicode_GUJARATI_DIGIT_NINE                                   0x0AEF
#define unicode_GUJARATI_ABBREVIATION_SIGN                            0x0AF0
#define unicode_GUJARATI_RUPEE_SIGN                                   0x0AF1
#define unicode_ORIYA_SIGN_CANDRABINDU                                0x0B01
#define unicode_ORIYA_SIGN_ANUSVARA                                   0x0B02
#define unicode_ORIYA_SIGN_VISARGA                                    0x0B03
#define unicode_ORIYA_LETTER_A                                        0x0B05
#define unicode_ORIYA_LETTER_AA                                       0x0B06
#define unicode_ORIYA_LETTER_I                                        0x0B07
#define unicode_ORIYA_LETTER_II                                       0x0B08
#define unicode_ORIYA_LETTER_U                                        0x0B09
#define unicode_ORIYA_LETTER_UU                                       0x0B0A
#define unicode_ORIYA_LETTER_VOCALIC_R                                0x0B0B
#define unicode_ORIYA_LETTER_VOCALIC_L                                0x0B0C
#define unicode_ORIYA_LETTER_E                                        0x0B0F
#define unicode_ORIYA_LETTER_AI                                       0x0B10
#define unicode_ORIYA_LETTER_O                                        0x0B13
#define unicode_ORIYA_LETTER_AU                                       0x0B14
#define unicode_ORIYA_LETTER_KA                                       0x0B15
#define unicode_ORIYA_LETTER_KHA                                      0x0B16
#define unicode_ORIYA_LETTER_GA                                       0x0B17
#define unicode_ORIYA_LETTER_GHA                                      0x0B18
#define unicode_ORIYA_LETTER_NGA                                      0x0B19
#define unicode_ORIYA_LETTER_CA                                       0x0B1A
#define unicode_ORIYA_LETTER_CHA                                      0x0B1B
#define unicode_ORIYA_LETTER_JA                                       0x0B1C
#define unicode_ORIYA_LETTER_JHA                                      0x0B1D
#define unicode_ORIYA_LETTER_NYA                                      0x0B1E
#define unicode_ORIYA_LETTER_TTA                                      0x0B1F
#define unicode_ORIYA_LETTER_TTHA                                     0x0B20
#define unicode_ORIYA_LETTER_DDA                                      0x0B21
#define unicode_ORIYA_LETTER_DDHA                                     0x0B22
#define unicode_ORIYA_LETTER_NNA                                      0x0B23
#define unicode_ORIYA_LETTER_TA                                       0x0B24
#define unicode_ORIYA_LETTER_THA                                      0x0B25
#define unicode_ORIYA_LETTER_DA                                       0x0B26
#define unicode_ORIYA_LETTER_DHA                                      0x0B27
#define unicode_ORIYA_LETTER_NA                                       0x0B28
#define unicode_ORIYA_LETTER_PA                                       0x0B2A
#define unicode_ORIYA_LETTER_PHA                                      0x0B2B
#define unicode_ORIYA_LETTER_BA                                       0x0B2C
#define unicode_ORIYA_LETTER_BHA                                      0x0B2D
#define unicode_ORIYA_LETTER_MA                                       0x0B2E
#define unicode_ORIYA_LETTER_YA                                       0x0B2F
#define unicode_ORIYA_LETTER_RA                                       0x0B30
#define unicode_ORIYA_LETTER_LA                                       0x0B32
#define unicode_ORIYA_LETTER_LLA                                      0x0B33
#define unicode_ORIYA_LETTER_VA                                       0x0B35
#define unicode_ORIYA_LETTER_SHA                                      0x0B36
#define unicode_ORIYA_LETTER_SSA                                      0x0B37
#define unicode_ORIYA_LETTER_SA                                       0x0B38
#define unicode_ORIYA_LETTER_HA                                       0x0B39
#define unicode_ORIYA_SIGN_NUKTA                                      0x0B3C
#define unicode_ORIYA_SIGN_AVAGRAHA                                   0x0B3D
#define unicode_ORIYA_VOWEL_SIGN_AA                                   0x0B3E
#define unicode_ORIYA_VOWEL_SIGN_I                                    0x0B3F
#define unicode_ORIYA_VOWEL_SIGN_II                                   0x0B40
#define unicode_ORIYA_VOWEL_SIGN_U                                    0x0B41
#define unicode_ORIYA_VOWEL_SIGN_UU                                   0x0B42
#define unicode_ORIYA_VOWEL_SIGN_VOCALIC_R                            0x0B43
#define unicode_ORIYA_VOWEL_SIGN_VOCALIC_RR                           0x0B44
#define unicode_ORIYA_VOWEL_SIGN_E                                    0x0B47
#define unicode_ORIYA_VOWEL_SIGN_AI                                   0x0B48
#define unicode_ORIYA_VOWEL_SIGN_O                                    0x0B4B
#define unicode_ORIYA_VOWEL_SIGN_AU                                   0x0B4C
#define unicode_ORIYA_SIGN_VIRAMA                                     0x0B4D
#define unicode_ORIYA_AI_LENGTH_MARK                                  0x0B56
#define unicode_ORIYA_AU_LENGTH_MARK                                  0x0B57
#define unicode_ORIYA_LETTER_RRA                                      0x0B5C
#define unicode_ORIYA_LETTER_RHA                                      0x0B5D
#define unicode_ORIYA_LETTER_YYA                                      0x0B5F
#define unicode_ORIYA_LETTER_VOCALIC_RR                               0x0B60
#define unicode_ORIYA_LETTER_VOCALIC_LL                               0x0B61
#define unicode_ORIYA_VOWEL_SIGN_VOCALIC_L                            0x0B62
#define unicode_ORIYA_VOWEL_SIGN_VOCALIC_LL                           0x0B63
#define unicode_ORIYA_DIGIT_ZERO                                      0x0B66
#define unicode_ORIYA_DIGIT_ONE                                       0x0B67
#define unicode_ORIYA_DIGIT_TWO                                       0x0B68
#define unicode_ORIYA_DIGIT_THREE                                     0x0B69
#define unicode_ORIYA_DIGIT_FOUR                                      0x0B6A
#define unicode_ORIYA_DIGIT_FIVE                                      0x0B6B
#define unicode_ORIYA_DIGIT_SIX                                       0x0B6C
#define unicode_ORIYA_DIGIT_SEVEN                                     0x0B6D
#define unicode_ORIYA_DIGIT_EIGHT                                     0x0B6E
#define unicode_ORIYA_DIGIT_NINE                                      0x0B6F
#define unicode_ORIYA_ISSHAR                                          0x0B70
#define unicode_ORIYA_LETTER_WA                                       0x0B71
#define unicode_ORIYA_FRACTION_ONE_QUARTER                            0x0B72
#define unicode_ORIYA_FRACTION_ONE_HALF                               0x0B73
#define unicode_ORIYA_FRACTION_THREE_QUARTERS                         0x0B74
#define unicode_ORIYA_FRACTION_ONE_SIXTEENTH                          0x0B75
#define unicode_ORIYA_FRACTION_ONE_EIGHTH                             0x0B76
#define unicode_ORIYA_FRACTION_THREE_SIXTEENTHS                       0x0B77
#define unicode_TAMIL_SIGN_ANUSVARA                                   0x0B82
#define unicode_TAMIL_SIGN_VISARGA                                    0x0B83
#define unicode_TAMIL_LETTER_A                                        0x0B85
#define unicode_TAMIL_LETTER_AA                                       0x0B86
#define unicode_TAMIL_LETTER_I                                        0x0B87
#define unicode_TAMIL_LETTER_II                                       0x0B88
#define unicode_TAMIL_LETTER_U                                        0x0B89
#define unicode_TAMIL_LETTER_UU                                       0x0B8A
#define unicode_TAMIL_LETTER_E                                        0x0B8E
#define unicode_TAMIL_LETTER_EE                                       0x0B8F
#define unicode_TAMIL_LETTER_AI                                       0x0B90
#define unicode_TAMIL_LETTER_O                                        0x0B92
#define unicode_TAMIL_LETTER_OO                                       0x0B93
#define unicode_TAMIL_LETTER_AU                                       0x0B94
#define unicode_TAMIL_LETTER_KA                                       0x0B95
#define unicode_TAMIL_LETTER_NGA                                      0x0B99
#define unicode_TAMIL_LETTER_CA                                       0x0B9A
#define unicode_TAMIL_LETTER_JA                                       0x0B9C
#define unicode_TAMIL_LETTER_NYA                                      0x0B9E
#define unicode_TAMIL_LETTER_TTA                                      0x0B9F
#define unicode_TAMIL_LETTER_NNA                                      0x0BA3
#define unicode_TAMIL_LETTER_TA                                       0x0BA4
#define unicode_TAMIL_LETTER_NA                                       0x0BA8
#define unicode_TAMIL_LETTER_NNNA                                     0x0BA9
#define unicode_TAMIL_LETTER_PA                                       0x0BAA
#define unicode_TAMIL_LETTER_MA                                       0x0BAE
#define unicode_TAMIL_LETTER_YA                                       0x0BAF
#define unicode_TAMIL_LETTER_RA                                       0x0BB0
#define unicode_TAMIL_LETTER_RRA                                      0x0BB1
#define unicode_TAMIL_LETTER_LA                                       0x0BB2
#define unicode_TAMIL_LETTER_LLA                                      0x0BB3
#define unicode_TAMIL_LETTER_LLLA                                     0x0BB4
#define unicode_TAMIL_LETTER_VA                                       0x0BB5
#define unicode_TAMIL_LETTER_SHA                                      0x0BB6
#define unicode_TAMIL_LETTER_SSA                                      0x0BB7
#define unicode_TAMIL_LETTER_SA                                       0x0BB8
#define unicode_TAMIL_LETTER_HA                                       0x0BB9
#define unicode_TAMIL_VOWEL_SIGN_AA                                   0x0BBE
#define unicode_TAMIL_VOWEL_SIGN_I                                    0x0BBF
#define unicode_TAMIL_VOWEL_SIGN_II                                   0x0BC0
#define unicode_TAMIL_VOWEL_SIGN_U                                    0x0BC1
#define unicode_TAMIL_VOWEL_SIGN_UU                                   0x0BC2
#define unicode_TAMIL_VOWEL_SIGN_E                                    0x0BC6
#define unicode_TAMIL_VOWEL_SIGN_EE                                   0x0BC7
#define unicode_TAMIL_VOWEL_SIGN_AI                                   0x0BC8
#define unicode_TAMIL_VOWEL_SIGN_O                                    0x0BCA
#define unicode_TAMIL_VOWEL_SIGN_OO                                   0x0BCB
#define unicode_TAMIL_VOWEL_SIGN_AU                                   0x0BCC
#define unicode_TAMIL_SIGN_VIRAMA                                     0x0BCD
#define unicode_TAMIL_OM                                              0x0BD0
#define unicode_TAMIL_AU_LENGTH_MARK                                  0x0BD7
#define unicode_TAMIL_DIGIT_ZERO                                      0x0BE6
#define unicode_TAMIL_DIGIT_ONE                                       0x0BE7
#define unicode_TAMIL_DIGIT_TWO                                       0x0BE8
#define unicode_TAMIL_DIGIT_THREE                                     0x0BE9
#define unicode_TAMIL_DIGIT_FOUR                                      0x0BEA
#define unicode_TAMIL_DIGIT_FIVE                                      0x0BEB
#define unicode_TAMIL_DIGIT_SIX                                       0x0BEC
#define unicode_TAMIL_DIGIT_SEVEN                                     0x0BED
#define unicode_TAMIL_DIGIT_EIGHT                                     0x0BEE
#define unicode_TAMIL_DIGIT_NINE                                      0x0BEF
#define unicode_TAMIL_NUMBER_TEN                                      0x0BF0
#define unicode_TAMIL_NUMBER_ONE_HUNDRED                              0x0BF1
#define unicode_TAMIL_NUMBER_ONE_THOUSAND                             0x0BF2
#define unicode_TAMIL_DAY_SIGN                                        0x0BF3
#define unicode_TAMIL_MONTH_SIGN                                      0x0BF4
#define unicode_TAMIL_YEAR_SIGN                                       0x0BF5
#define unicode_TAMIL_DEBIT_SIGN                                      0x0BF6
#define unicode_TAMIL_CREDIT_SIGN                                     0x0BF7
#define unicode_TAMIL_AS_ABOVE_SIGN                                   0x0BF8
#define unicode_TAMIL_RUPEE_SIGN                                      0x0BF9
#define unicode_TAMIL_NUMBER_SIGN                                     0x0BFA
#define unicode_TELUGU_SIGN_COMBINING_CANDRABINDU_ABOVE               0x0C00
#define unicode_TELUGU_SIGN_CANDRABINDU                               0x0C01
#define unicode_TELUGU_SIGN_ANUSVARA                                  0x0C02
#define unicode_TELUGU_SIGN_VISARGA                                   0x0C03
#define unicode_TELUGU_LETTER_A                                       0x0C05
#define unicode_TELUGU_LETTER_AA                                      0x0C06
#define unicode_TELUGU_LETTER_I                                       0x0C07
#define unicode_TELUGU_LETTER_II                                      0x0C08
#define unicode_TELUGU_LETTER_U                                       0x0C09
#define unicode_TELUGU_LETTER_UU                                      0x0C0A
#define unicode_TELUGU_LETTER_VOCALIC_R                               0x0C0B
#define unicode_TELUGU_LETTER_VOCALIC_L                               0x0C0C
#define unicode_TELUGU_LETTER_E                                       0x0C0E
#define unicode_TELUGU_LETTER_EE                                      0x0C0F
#define unicode_TELUGU_LETTER_AI                                      0x0C10
#define unicode_TELUGU_LETTER_O                                       0x0C12
#define unicode_TELUGU_LETTER_OO                                      0x0C13
#define unicode_TELUGU_LETTER_AU                                      0x0C14
#define unicode_TELUGU_LETTER_KA                                      0x0C15
#define unicode_TELUGU_LETTER_KHA                                     0x0C16
#define unicode_TELUGU_LETTER_GA                                      0x0C17
#define unicode_TELUGU_LETTER_GHA                                     0x0C18
#define unicode_TELUGU_LETTER_NGA                                     0x0C19
#define unicode_TELUGU_LETTER_CA                                      0x0C1A
#define unicode_TELUGU_LETTER_CHA                                     0x0C1B
#define unicode_TELUGU_LETTER_JA                                      0x0C1C
#define unicode_TELUGU_LETTER_JHA                                     0x0C1D
#define unicode_TELUGU_LETTER_NYA                                     0x0C1E
#define unicode_TELUGU_LETTER_TTA                                     0x0C1F
#define unicode_TELUGU_LETTER_TTHA                                    0x0C20
#define unicode_TELUGU_LETTER_DDA                                     0x0C21
#define unicode_TELUGU_LETTER_DDHA                                    0x0C22
#define unicode_TELUGU_LETTER_NNA                                     0x0C23
#define unicode_TELUGU_LETTER_TA                                      0x0C24
#define unicode_TELUGU_LETTER_THA                                     0x0C25
#define unicode_TELUGU_LETTER_DA                                      0x0C26
#define unicode_TELUGU_LETTER_DHA                                     0x0C27
#define unicode_TELUGU_LETTER_NA                                      0x0C28
#define unicode_TELUGU_LETTER_PA                                      0x0C2A
#define unicode_TELUGU_LETTER_PHA                                     0x0C2B
#define unicode_TELUGU_LETTER_BA                                      0x0C2C
#define unicode_TELUGU_LETTER_BHA                                     0x0C2D
#define unicode_TELUGU_LETTER_MA                                      0x0C2E
#define unicode_TELUGU_LETTER_YA                                      0x0C2F
#define unicode_TELUGU_LETTER_RA                                      0x0C30
#define unicode_TELUGU_LETTER_RRA                                     0x0C31
#define unicode_TELUGU_LETTER_LA                                      0x0C32
#define unicode_TELUGU_LETTER_LLA                                     0x0C33
#define unicode_TELUGU_LETTER_LLLA                                    0x0C34
#define unicode_TELUGU_LETTER_VA                                      0x0C35
#define unicode_TELUGU_LETTER_SHA                                     0x0C36
#define unicode_TELUGU_LETTER_SSA                                     0x0C37
#define unicode_TELUGU_LETTER_SA                                      0x0C38
#define unicode_TELUGU_LETTER_HA                                      0x0C39
#define unicode_TELUGU_SIGN_AVAGRAHA                                  0x0C3D
#define unicode_TELUGU_VOWEL_SIGN_AA                                  0x0C3E
#define unicode_TELUGU_VOWEL_SIGN_I                                   0x0C3F
#define unicode_TELUGU_VOWEL_SIGN_II                                  0x0C40
#define unicode_TELUGU_VOWEL_SIGN_U                                   0x0C41
#define unicode_TELUGU_VOWEL_SIGN_UU                                  0x0C42
#define unicode_TELUGU_VOWEL_SIGN_VOCALIC_R                           0x0C43
#define unicode_TELUGU_VOWEL_SIGN_VOCALIC_RR                          0x0C44
#define unicode_TELUGU_VOWEL_SIGN_E                                   0x0C46
#define unicode_TELUGU_VOWEL_SIGN_EE                                  0x0C47
#define unicode_TELUGU_VOWEL_SIGN_AI                                  0x0C48
#define unicode_TELUGU_VOWEL_SIGN_O                                   0x0C4A
#define unicode_TELUGU_VOWEL_SIGN_OO                                  0x0C4B
#define unicode_TELUGU_VOWEL_SIGN_AU                                  0x0C4C
#define unicode_TELUGU_SIGN_VIRAMA                                    0x0C4D
#define unicode_TELUGU_LENGTH_MARK                                    0x0C55
#define unicode_TELUGU_AI_LENGTH_MARK                                 0x0C56
#define unicode_TELUGU_LETTER_TSA                                     0x0C58
#define unicode_TELUGU_LETTER_DZA                                     0x0C59
#define unicode_TELUGU_LETTER_VOCALIC_RR                              0x0C60
#define unicode_TELUGU_LETTER_VOCALIC_LL                              0x0C61
#define unicode_TELUGU_VOWEL_SIGN_VOCALIC_L                           0x0C62
#define unicode_TELUGU_VOWEL_SIGN_VOCALIC_LL                          0x0C63
#define unicode_TELUGU_DIGIT_ZERO                                     0x0C66
#define unicode_TELUGU_DIGIT_ONE                                      0x0C67
#define unicode_TELUGU_DIGIT_TWO                                      0x0C68
#define unicode_TELUGU_DIGIT_THREE                                    0x0C69
#define unicode_TELUGU_DIGIT_FOUR                                     0x0C6A
#define unicode_TELUGU_DIGIT_FIVE                                     0x0C6B
#define unicode_TELUGU_DIGIT_SIX                                      0x0C6C
#define unicode_TELUGU_DIGIT_SEVEN                                    0x0C6D
#define unicode_TELUGU_DIGIT_EIGHT                                    0x0C6E
#define unicode_TELUGU_DIGIT_NINE                                     0x0C6F
#define unicode_TELUGU_FRACTION_DIGIT_ZERO_FOR_ODD_POWERS_OF_FOUR     0x0C78
#define unicode_TELUGU_FRACTION_DIGIT_ONE_FOR_ODD_POWERS_OF_FOUR      0x0C79
#define unicode_TELUGU_FRACTION_DIGIT_TWO_FOR_ODD_POWERS_OF_FOUR      0x0C7A
#define unicode_TELUGU_FRACTION_DIGIT_THREE_FOR_ODD_POWERS_OF_FOUR    0x0C7B
#define unicode_TELUGU_FRACTION_DIGIT_ONE_FOR_EVEN_POWERS_OF_FOUR     0x0C7C
#define unicode_TELUGU_FRACTION_DIGIT_TWO_FOR_EVEN_POWERS_OF_FOUR     0x0C7D
#define unicode_TELUGU_FRACTION_DIGIT_THREE_FOR_EVEN_POWERS_OF_FOUR   0x0C7E
#define unicode_TELUGU_SIGN_TUUMU                                     0x0C7F
#define unicode_KANNADA_SIGN_CANDRABINDU                              0x0C81
#define unicode_KANNADA_SIGN_ANUSVARA                                 0x0C82
#define unicode_KANNADA_SIGN_VISARGA                                  0x0C83
#define unicode_KANNADA_LETTER_A                                      0x0C85
#define unicode_KANNADA_LETTER_AA                                     0x0C86
#define unicode_KANNADA_LETTER_I                                      0x0C87
#define unicode_KANNADA_LETTER_II                                     0x0C88
#define unicode_KANNADA_LETTER_U                                      0x0C89
#define unicode_KANNADA_LETTER_UU                                     0x0C8A
#define unicode_KANNADA_LETTER_VOCALIC_R                              0x0C8B
#define unicode_KANNADA_LETTER_VOCALIC_L                              0x0C8C
#define unicode_KANNADA_LETTER_E                                      0x0C8E
#define unicode_KANNADA_LETTER_EE                                     0x0C8F
#define unicode_KANNADA_LETTER_AI                                     0x0C90
#define unicode_KANNADA_LETTER_O                                      0x0C92
#define unicode_KANNADA_LETTER_OO                                     0x0C93
#define unicode_KANNADA_LETTER_AU                                     0x0C94
#define unicode_KANNADA_LETTER_KA                                     0x0C95
#define unicode_KANNADA_LETTER_KHA                                    0x0C96
#define unicode_KANNADA_LETTER_GA                                     0x0C97
#define unicode_KANNADA_LETTER_GHA                                    0x0C98
#define unicode_KANNADA_LETTER_NGA                                    0x0C99
#define unicode_KANNADA_LETTER_CA                                     0x0C9A
#define unicode_KANNADA_LETTER_CHA                                    0x0C9B
#define unicode_KANNADA_LETTER_JA                                     0x0C9C
#define unicode_KANNADA_LETTER_JHA                                    0x0C9D
#define unicode_KANNADA_LETTER_NYA                                    0x0C9E
#define unicode_KANNADA_LETTER_TTA                                    0x0C9F
#define unicode_KANNADA_LETTER_TTHA                                   0x0CA0
#define unicode_KANNADA_LETTER_DDA                                    0x0CA1
#define unicode_KANNADA_LETTER_DDHA                                   0x0CA2
#define unicode_KANNADA_LETTER_NNA                                    0x0CA3
#define unicode_KANNADA_LETTER_TA                                     0x0CA4
#define unicode_KANNADA_LETTER_THA                                    0x0CA5
#define unicode_KANNADA_LETTER_DA                                     0x0CA6
#define unicode_KANNADA_LETTER_DHA                                    0x0CA7
#define unicode_KANNADA_LETTER_NA                                     0x0CA8
#define unicode_KANNADA_LETTER_PA                                     0x0CAA
#define unicode_KANNADA_LETTER_PHA                                    0x0CAB
#define unicode_KANNADA_LETTER_BA                                     0x0CAC
#define unicode_KANNADA_LETTER_BHA                                    0x0CAD
#define unicode_KANNADA_LETTER_MA                                     0x0CAE
#define unicode_KANNADA_LETTER_YA                                     0x0CAF
#define unicode_KANNADA_LETTER_RA                                     0x0CB0
#define unicode_KANNADA_LETTER_RRA                                    0x0CB1
#define unicode_KANNADA_LETTER_LA                                     0x0CB2
#define unicode_KANNADA_LETTER_LLA                                    0x0CB3
#define unicode_KANNADA_LETTER_VA                                     0x0CB5
#define unicode_KANNADA_LETTER_SHA                                    0x0CB6
#define unicode_KANNADA_LETTER_SSA                                    0x0CB7
#define unicode_KANNADA_LETTER_SA                                     0x0CB8
#define unicode_KANNADA_LETTER_HA                                     0x0CB9
#define unicode_KANNADA_SIGN_NUKTA                                    0x0CBC
#define unicode_KANNADA_SIGN_AVAGRAHA                                 0x0CBD
#define unicode_KANNADA_VOWEL_SIGN_AA                                 0x0CBE
#define unicode_KANNADA_VOWEL_SIGN_I                                  0x0CBF
#define unicode_KANNADA_VOWEL_SIGN_II                                 0x0CC0
#define unicode_KANNADA_VOWEL_SIGN_U                                  0x0CC1
#define unicode_KANNADA_VOWEL_SIGN_UU                                 0x0CC2
#define unicode_KANNADA_VOWEL_SIGN_VOCALIC_R                          0x0CC3
#define unicode_KANNADA_VOWEL_SIGN_VOCALIC_RR                         0x0CC4
#define unicode_KANNADA_VOWEL_SIGN_E                                  0x0CC6
#define unicode_KANNADA_VOWEL_SIGN_EE                                 0x0CC7
#define unicode_KANNADA_VOWEL_SIGN_AI                                 0x0CC8
#define unicode_KANNADA_VOWEL_SIGN_O                                  0x0CCA
#define unicode_KANNADA_VOWEL_SIGN_OO                                 0x0CCB
#define unicode_KANNADA_VOWEL_SIGN_AU                                 0x0CCC
#define unicode_KANNADA_SIGN_VIRAMA                                   0x0CCD
#define unicode_KANNADA_LENGTH_MARK                                   0x0CD5
#define unicode_KANNADA_AI_LENGTH_MARK                                0x0CD6
#define unicode_KANNADA_LETTER_FA                                     0x0CDE
#define unicode_KANNADA_LETTER_VOCALIC_RR                             0x0CE0
#define unicode_KANNADA_LETTER_VOCALIC_LL                             0x0CE1
#define unicode_KANNADA_VOWEL_SIGN_VOCALIC_L                          0x0CE2
#define unicode_KANNADA_VOWEL_SIGN_VOCALIC_LL                         0x0CE3
#define unicode_KANNADA_DIGIT_ZERO                                    0x0CE6
#define unicode_KANNADA_DIGIT_ONE                                     0x0CE7
#define unicode_KANNADA_DIGIT_TWO                                     0x0CE8
#define unicode_KANNADA_DIGIT_THREE                                   0x0CE9
#define unicode_KANNADA_DIGIT_FOUR                                    0x0CEA
#define unicode_KANNADA_DIGIT_FIVE                                    0x0CEB
#define unicode_KANNADA_DIGIT_SIX                                     0x0CEC
#define unicode_KANNADA_DIGIT_SEVEN                                   0x0CED
#define unicode_KANNADA_DIGIT_EIGHT                                   0x0CEE
#define unicode_KANNADA_DIGIT_NINE                                    0x0CEF
#define unicode_KANNADA_SIGN_JIHVAMULIYA                              0x0CF1
#define unicode_KANNADA_SIGN_UPADHMANIYA                              0x0CF2
#define unicode_MALAYALAM_SIGN_CANDRABINDU                            0x0D01
#define unicode_MALAYALAM_SIGN_ANUSVARA                               0x0D02
#define unicode_MALAYALAM_SIGN_VISARGA                                0x0D03
#define unicode_MALAYALAM_LETTER_A                                    0x0D05
#define unicode_MALAYALAM_LETTER_AA                                   0x0D06
#define unicode_MALAYALAM_LETTER_I                                    0x0D07
#define unicode_MALAYALAM_LETTER_II                                   0x0D08
#define unicode_MALAYALAM_LETTER_U                                    0x0D09
#define unicode_MALAYALAM_LETTER_UU                                   0x0D0A
#define unicode_MALAYALAM_LETTER_VOCALIC_R                            0x0D0B
#define unicode_MALAYALAM_LETTER_VOCALIC_L                            0x0D0C
#define unicode_MALAYALAM_LETTER_E                                    0x0D0E
#define unicode_MALAYALAM_LETTER_EE                                   0x0D0F
#define unicode_MALAYALAM_LETTER_AI                                   0x0D10
#define unicode_MALAYALAM_LETTER_O                                    0x0D12
#define unicode_MALAYALAM_LETTER_OO                                   0x0D13
#define unicode_MALAYALAM_LETTER_AU                                   0x0D14
#define unicode_MALAYALAM_LETTER_KA                                   0x0D15
#define unicode_MALAYALAM_LETTER_KHA                                  0x0D16
#define unicode_MALAYALAM_LETTER_GA                                   0x0D17
#define unicode_MALAYALAM_LETTER_GHA                                  0x0D18
#define unicode_MALAYALAM_LETTER_NGA                                  0x0D19
#define unicode_MALAYALAM_LETTER_CA                                   0x0D1A
#define unicode_MALAYALAM_LETTER_CHA                                  0x0D1B
#define unicode_MALAYALAM_LETTER_JA                                   0x0D1C
#define unicode_MALAYALAM_LETTER_JHA                                  0x0D1D
#define unicode_MALAYALAM_LETTER_NYA                                  0x0D1E
#define unicode_MALAYALAM_LETTER_TTA                                  0x0D1F
#define unicode_MALAYALAM_LETTER_TTHA                                 0x0D20
#define unicode_MALAYALAM_LETTER_DDA                                  0x0D21
#define unicode_MALAYALAM_LETTER_DDHA                                 0x0D22
#define unicode_MALAYALAM_LETTER_NNA                                  0x0D23
#define unicode_MALAYALAM_LETTER_TA                                   0x0D24
#define unicode_MALAYALAM_LETTER_THA                                  0x0D25
#define unicode_MALAYALAM_LETTER_DA                                   0x0D26
#define unicode_MALAYALAM_LETTER_DHA                                  0x0D27
#define unicode_MALAYALAM_LETTER_NA                                   0x0D28
#define unicode_MALAYALAM_LETTER_NNNA                                 0x0D29
#define unicode_MALAYALAM_LETTER_PA                                   0x0D2A
#define unicode_MALAYALAM_LETTER_PHA                                  0x0D2B
#define unicode_MALAYALAM_LETTER_BA                                   0x0D2C
#define unicode_MALAYALAM_LETTER_BHA                                  0x0D2D
#define unicode_MALAYALAM_LETTER_MA                                   0x0D2E
#define unicode_MALAYALAM_LETTER_YA                                   0x0D2F
#define unicode_MALAYALAM_LETTER_RA                                   0x0D30
#define unicode_MALAYALAM_LETTER_RRA                                  0x0D31
#define unicode_MALAYALAM_LETTER_LA                                   0x0D32
#define unicode_MALAYALAM_LETTER_LLA                                  0x0D33
#define unicode_MALAYALAM_LETTER_LLLA                                 0x0D34
#define unicode_MALAYALAM_LETTER_VA                                   0x0D35
#define unicode_MALAYALAM_LETTER_SHA                                  0x0D36
#define unicode_MALAYALAM_LETTER_SSA                                  0x0D37
#define unicode_MALAYALAM_LETTER_SA                                   0x0D38
#define unicode_MALAYALAM_LETTER_HA                                   0x0D39
#define unicode_MALAYALAM_LETTER_TTTA                                 0x0D3A
#define unicode_MALAYALAM_SIGN_AVAGRAHA                               0x0D3D
#define unicode_MALAYALAM_VOWEL_SIGN_AA                               0x0D3E
#define unicode_MALAYALAM_VOWEL_SIGN_I                                0x0D3F
#define unicode_MALAYALAM_VOWEL_SIGN_II                               0x0D40
#define unicode_MALAYALAM_VOWEL_SIGN_U                                0x0D41
#define unicode_MALAYALAM_VOWEL_SIGN_UU                               0x0D42
#define unicode_MALAYALAM_VOWEL_SIGN_VOCALIC_R                        0x0D43
#define unicode_MALAYALAM_VOWEL_SIGN_VOCALIC_RR                       0x0D44
#define unicode_MALAYALAM_VOWEL_SIGN_E                                0x0D46
#define unicode_MALAYALAM_VOWEL_SIGN_EE                               0x0D47
#define unicode_MALAYALAM_VOWEL_SIGN_AI                               0x0D48
#define unicode_MALAYALAM_VOWEL_SIGN_O                                0x0D4A
#define unicode_MALAYALAM_VOWEL_SIGN_OO                               0x0D4B
#define unicode_MALAYALAM_VOWEL_SIGN_AU                               0x0D4C
#define unicode_MALAYALAM_SIGN_VIRAMA                                 0x0D4D
#define unicode_MALAYALAM_LETTER_DOT_REPH                             0x0D4E
#define unicode_MALAYALAM_AU_LENGTH_MARK                              0x0D57
#define unicode_MALAYALAM_LETTER_VOCALIC_RR                           0x0D60
#define unicode_MALAYALAM_LETTER_VOCALIC_LL                           0x0D61
#define unicode_MALAYALAM_VOWEL_SIGN_VOCALIC_L                        0x0D62
#define unicode_MALAYALAM_VOWEL_SIGN_VOCALIC_LL                       0x0D63
#define unicode_MALAYALAM_DIGIT_ZERO                                  0x0D66
#define unicode_MALAYALAM_DIGIT_ONE                                   0x0D67
#define unicode_MALAYALAM_DIGIT_TWO                                   0x0D68
#define unicode_MALAYALAM_DIGIT_THREE                                 0x0D69
#define unicode_MALAYALAM_DIGIT_FOUR                                  0x0D6A
#define unicode_MALAYALAM_DIGIT_FIVE                                  0x0D6B
#define unicode_MALAYALAM_DIGIT_SIX                                   0x0D6C
#define unicode_MALAYALAM_DIGIT_SEVEN                                 0x0D6D
#define unicode_MALAYALAM_DIGIT_EIGHT                                 0x0D6E
#define unicode_MALAYALAM_DIGIT_NINE                                  0x0D6F
#define unicode_MALAYALAM_NUMBER_TEN                                  0x0D70
#define unicode_MALAYALAM_NUMBER_ONE_HUNDRED                          0x0D71
#define unicode_MALAYALAM_NUMBER_ONE_THOUSAND                         0x0D72
#define unicode_MALAYALAM_FRACTION_ONE_QUARTER                        0x0D73
#define unicode_MALAYALAM_FRACTION_ONE_HALF                           0x0D74
#define unicode_MALAYALAM_FRACTION_THREE_QUARTERS                     0x0D75
#define unicode_MALAYALAM_DATE_MARK                                   0x0D79
#define unicode_MALAYALAM_LETTER_CHILLU_NN                            0x0D7A
#define unicode_MALAYALAM_LETTER_CHILLU_N                             0x0D7B
#define unicode_MALAYALAM_LETTER_CHILLU_RR                            0x0D7C
#define unicode_MALAYALAM_LETTER_CHILLU_L                             0x0D7D
#define unicode_MALAYALAM_LETTER_CHILLU_LL                            0x0D7E
#define unicode_MALAYALAM_LETTER_CHILLU_K                             0x0D7F
#define unicode_SINHALA_SIGN_ANUSVARAYA                               0x0D82
#define unicode_SINHALA_SIGN_VISARGAYA                                0x0D83
#define unicode_SINHALA_LETTER_AYANNA                                 0x0D85
#define unicode_SINHALA_LETTER_AAYANNA                                0x0D86
#define unicode_SINHALA_LETTER_AEYANNA                                0x0D87
#define unicode_SINHALA_LETTER_AEEYANNA                               0x0D88
#define unicode_SINHALA_LETTER_IYANNA                                 0x0D89
#define unicode_SINHALA_LETTER_IIYANNA                                0x0D8A
#define unicode_SINHALA_LETTER_UYANNA                                 0x0D8B
#define unicode_SINHALA_LETTER_UUYANNA                                0x0D8C
#define unicode_SINHALA_LETTER_IRUYANNA                               0x0D8D
#define unicode_SINHALA_LETTER_IRUUYANNA                              0x0D8E
#define unicode_SINHALA_LETTER_ILUYANNA                               0x0D8F
#define unicode_SINHALA_LETTER_ILUUYANNA                              0x0D90
#define unicode_SINHALA_LETTER_EYANNA                                 0x0D91
#define unicode_SINHALA_LETTER_EEYANNA                                0x0D92
#define unicode_SINHALA_LETTER_AIYANNA                                0x0D93
#define unicode_SINHALA_LETTER_OYANNA                                 0x0D94
#define unicode_SINHALA_LETTER_OOYANNA                                0x0D95
#define unicode_SINHALA_LETTER_AUYANNA                                0x0D96
#define unicode_SINHALA_LETTER_ALPAPRAANA_KAYANNA                     0x0D9A
#define unicode_SINHALA_LETTER_MAHAAPRAANA_KAYANNA                    0x0D9B
#define unicode_SINHALA_LETTER_ALPAPRAANA_GAYANNA                     0x0D9C
#define unicode_SINHALA_LETTER_MAHAAPRAANA_GAYANNA                    0x0D9D
#define unicode_SINHALA_LETTER_KANTAJA_NAASIKYAYA                     0x0D9E
#define unicode_SINHALA_LETTER_SANYAKA_GAYANNA                        0x0D9F
#define unicode_SINHALA_LETTER_ALPAPRAANA_CAYANNA                     0x0DA0
#define unicode_SINHALA_LETTER_MAHAAPRAANA_CAYANNA                    0x0DA1
#define unicode_SINHALA_LETTER_ALPAPRAANA_JAYANNA                     0x0DA2
#define unicode_SINHALA_LETTER_MAHAAPRAANA_JAYANNA                    0x0DA3
#define unicode_SINHALA_LETTER_TAALUJA_NAASIKYAYA                     0x0DA4
#define unicode_SINHALA_LETTER_TAALUJA_SANYOOGA_NAAKSIKYAYA           0x0DA5
#define unicode_SINHALA_LETTER_SANYAKA_JAYANNA                        0x0DA6
#define unicode_SINHALA_LETTER_ALPAPRAANA_TTAYANNA                    0x0DA7
#define unicode_SINHALA_LETTER_MAHAAPRAANA_TTAYANNA                   0x0DA8
#define unicode_SINHALA_LETTER_ALPAPRAANA_DDAYANNA                    0x0DA9
#define unicode_SINHALA_LETTER_MAHAAPRAANA_DDAYANNA                   0x0DAA
#define unicode_SINHALA_LETTER_MUURDHAJA_NAYANNA                      0x0DAB
#define unicode_SINHALA_LETTER_SANYAKA_DDAYANNA                       0x0DAC
#define unicode_SINHALA_LETTER_ALPAPRAANA_TAYANNA                     0x0DAD
#define unicode_SINHALA_LETTER_MAHAAPRAANA_TAYANNA                    0x0DAE
#define unicode_SINHALA_LETTER_ALPAPRAANA_DAYANNA                     0x0DAF
#define unicode_SINHALA_LETTER_MAHAAPRAANA_DAYANNA                    0x0DB0
#define unicode_SINHALA_LETTER_DANTAJA_NAYANNA                        0x0DB1
#define unicode_SINHALA_LETTER_SANYAKA_DAYANNA                        0x0DB3
#define unicode_SINHALA_LETTER_ALPAPRAANA_PAYANNA                     0x0DB4
#define unicode_SINHALA_LETTER_MAHAAPRAANA_PAYANNA                    0x0DB5
#define unicode_SINHALA_LETTER_ALPAPRAANA_BAYANNA                     0x0DB6
#define unicode_SINHALA_LETTER_MAHAAPRAANA_BAYANNA                    0x0DB7
#define unicode_SINHALA_LETTER_MAYANNA                                0x0DB8
#define unicode_SINHALA_LETTER_AMBA_BAYANNA                           0x0DB9
#define unicode_SINHALA_LETTER_YAYANNA                                0x0DBA
#define unicode_SINHALA_LETTER_RAYANNA                                0x0DBB
#define unicode_SINHALA_LETTER_DANTAJA_LAYANNA                        0x0DBD
#define unicode_SINHALA_LETTER_VAYANNA                                0x0DC0
#define unicode_SINHALA_LETTER_TAALUJA_SAYANNA                        0x0DC1
#define unicode_SINHALA_LETTER_MUURDHAJA_SAYANNA                      0x0DC2
#define unicode_SINHALA_LETTER_DANTAJA_SAYANNA                        0x0DC3
#define unicode_SINHALA_LETTER_HAYANNA                                0x0DC4
#define unicode_SINHALA_LETTER_MUURDHAJA_LAYANNA                      0x0DC5
#define unicode_SINHALA_LETTER_FAYANNA                                0x0DC6
#define unicode_SINHALA_SIGN_AL_LAKUNA                                0x0DCA
#define unicode_SINHALA_VOWEL_SIGN_AELA_PILLA                         0x0DCF
#define unicode_SINHALA_VOWEL_SIGN_KETTI_AEDA_PILLA                   0x0DD0
#define unicode_SINHALA_VOWEL_SIGN_DIGA_AEDA_PILLA                    0x0DD1
#define unicode_SINHALA_VOWEL_SIGN_KETTI_IS_PILLA                     0x0DD2
#define unicode_SINHALA_VOWEL_SIGN_DIGA_IS_PILLA                      0x0DD3
#define unicode_SINHALA_VOWEL_SIGN_KETTI_PAA_PILLA                    0x0DD4
#define unicode_SINHALA_VOWEL_SIGN_DIGA_PAA_PILLA                     0x0DD6
#define unicode_SINHALA_VOWEL_SIGN_GAETTA_PILLA                       0x0DD8
#define unicode_SINHALA_VOWEL_SIGN_KOMBUVA                            0x0DD9
#define unicode_SINHALA_VOWEL_SIGN_DIGA_KOMBUVA                       0x0DDA
#define unicode_SINHALA_VOWEL_SIGN_KOMBU_DEKA                         0x0DDB
#define unicode_SINHALA_VOWEL_SIGN_KOMBUVA_HAA_AELA_PILLA             0x0DDC
#define unicode_SINHALA_VOWEL_SIGN_KOMBUVA_HAA_DIGA_AELA_PILLA        0x0DDD
#define unicode_SINHALA_VOWEL_SIGN_KOMBUVA_HAA_GAYANUKITTA            0x0DDE
#define unicode_SINHALA_VOWEL_SIGN_GAYANUKITTA                        0x0DDF
#define unicode_SINHALA_LITH_DIGIT_ZERO                               0x0DE6
#define unicode_SINHALA_LITH_DIGIT_ONE                                0x0DE7
#define unicode_SINHALA_LITH_DIGIT_TWO                                0x0DE8
#define unicode_SINHALA_LITH_DIGIT_THREE                              0x0DE9
#define unicode_SINHALA_LITH_DIGIT_FOUR                               0x0DEA
#define unicode_SINHALA_LITH_DIGIT_FIVE                               0x0DEB
#define unicode_SINHALA_LITH_DIGIT_SIX                                0x0DEC
#define unicode_SINHALA_LITH_DIGIT_SEVEN                              0x0DED
#define unicode_SINHALA_LITH_DIGIT_EIGHT                              0x0DEE
#define unicode_SINHALA_LITH_DIGIT_NINE                               0x0DEF
#define unicode_SINHALA_VOWEL_SIGN_DIGA_GAETTA_PILLA                  0x0DF2
#define unicode_SINHALA_VOWEL_SIGN_DIGA_GAYANUKITTA                   0x0DF3
#define unicode_SINHALA_PUNCTUATION_KUNDDALIYA                        0x0DF4
#define unicode_THAI_CHARACTER_KO_KAI                                 0x0E01
#define unicode_THAI_CHARACTER_KHO_KHAI                               0x0E02
#define unicode_THAI_CHARACTER_KHO_KHUAT                              0x0E03
#define unicode_THAI_CHARACTER_KHO_KHWAI                              0x0E04
#define unicode_THAI_CHARACTER_KHO_KHON                               0x0E05
#define unicode_THAI_CHARACTER_KHO_RAKHANG                            0x0E06
#define unicode_THAI_CHARACTER_NGO_NGU                                0x0E07
#define unicode_THAI_CHARACTER_CHO_CHAN                               0x0E08
#define unicode_THAI_CHARACTER_CHO_CHING                              0x0E09
#define unicode_THAI_CHARACTER_CHO_CHANG                              0x0E0A
#define unicode_THAI_CHARACTER_SO_SO                                  0x0E0B
#define unicode_THAI_CHARACTER_CHO_CHOE                               0x0E0C
#define unicode_THAI_CHARACTER_YO_YING                                0x0E0D
#define unicode_THAI_CHARACTER_DO_CHADA                               0x0E0E
#define unicode_THAI_CHARACTER_TO_PATAK                               0x0E0F
#define unicode_THAI_CHARACTER_THO_THAN                               0x0E10
#define unicode_THAI_CHARACTER_THO_NANGMONTHO                         0x0E11
#define unicode_THAI_CHARACTER_THO_PHUTHAO                            0x0E12
#define unicode_THAI_CHARACTER_NO_NEN                                 0x0E13
#define unicode_THAI_CHARACTER_DO_DEK                                 0x0E14
#define unicode_THAI_CHARACTER_TO_TAO                                 0x0E15
#define unicode_THAI_CHARACTER_THO_THUNG                              0x0E16
#define unicode_THAI_CHARACTER_THO_THAHAN                             0x0E17
#define unicode_THAI_CHARACTER_THO_THONG                              0x0E18
#define unicode_THAI_CHARACTER_NO_NU                                  0x0E19
#define unicode_THAI_CHARACTER_BO_BAIMAI                              0x0E1A
#define unicode_THAI_CHARACTER_PO_PLA                                 0x0E1B
#define unicode_THAI_CHARACTER_PHO_PHUNG                              0x0E1C
#define unicode_THAI_CHARACTER_FO_FA                                  0x0E1D
#define unicode_THAI_CHARACTER_PHO_PHAN                               0x0E1E
#define unicode_THAI_CHARACTER_FO_FAN                                 0x0E1F
#define unicode_THAI_CHARACTER_PHO_SAMPHAO                            0x0E20
#define unicode_THAI_CHARACTER_MO_MA                                  0x0E21
#define unicode_THAI_CHARACTER_YO_YAK                                 0x0E22
#define unicode_THAI_CHARACTER_RO_RUA                                 0x0E23
#define unicode_THAI_CHARACTER_RU                                     0x0E24
#define unicode_THAI_CHARACTER_LO_LING                                0x0E25
#define unicode_THAI_CHARACTER_LU                                     0x0E26
#define unicode_THAI_CHARACTER_WO_WAEN                                0x0E27
#define unicode_THAI_CHARACTER_SO_SALA                                0x0E28
#define unicode_THAI_CHARACTER_SO_RUSI                                0x0E29
#define unicode_THAI_CHARACTER_SO_SUA                                 0x0E2A
#define unicode_THAI_CHARACTER_HO_HIP                                 0x0E2B
#define unicode_THAI_CHARACTER_LO_CHULA                               0x0E2C
#define unicode_THAI_CHARACTER_O_ANG                                  0x0E2D
#define unicode_THAI_CHARACTER_HO_NOKHUK                              0x0E2E
#define unicode_THAI_CHARACTER_PAIYANNOI                              0x0E2F
#define unicode_THAI_CHARACTER_SARA_A                                 0x0E30
#define unicode_THAI_CHARACTER_MAI_HAN_AKAT                           0x0E31
#define unicode_THAI_CHARACTER_SARA_AA                                0x0E32
#define unicode_THAI_CHARACTER_SARA_AM                                0x0E33
#define unicode_THAI_CHARACTER_SARA_I                                 0x0E34
#define unicode_THAI_CHARACTER_SARA_II                                0x0E35
#define unicode_THAI_CHARACTER_SARA_UE                                0x0E36
#define unicode_THAI_CHARACTER_SARA_UEE                               0x0E37
#define unicode_THAI_CHARACTER_SARA_U                                 0x0E38
#define unicode_THAI_CHARACTER_SARA_UU                                0x0E39
#define unicode_THAI_CHARACTER_PHINTHU                                0x0E3A
#define unicode_THAI_CURRENCY_SYMBOL_BAHT                             0x0E3F
#define unicode_THAI_CHARACTER_SARA_E                                 0x0E40
#define unicode_THAI_CHARACTER_SARA_AE                                0x0E41
#define unicode_THAI_CHARACTER_SARA_O                                 0x0E42
#define unicode_THAI_CHARACTER_SARA_AI_MAIMUAN                        0x0E43
#define unicode_THAI_CHARACTER_SARA_AI_MAIMALAI                       0x0E44
#define unicode_THAI_CHARACTER_LAKKHANGYAO                            0x0E45
#define unicode_THAI_CHARACTER_MAIYAMOK                               0x0E46
#define unicode_THAI_CHARACTER_MAITAIKHU                              0x0E47
#define unicode_THAI_CHARACTER_MAI_EK                                 0x0E48
#define unicode_THAI_CHARACTER_MAI_THO                                0x0E49
#define unicode_THAI_CHARACTER_MAI_TRI                                0x0E4A
#define unicode_THAI_CHARACTER_MAI_CHATTAWA                           0x0E4B
#define unicode_THAI_CHARACTER_THANTHAKHAT                            0x0E4C
#define unicode_THAI_CHARACTER_NIKHAHIT                               0x0E4D
#define unicode_THAI_CHARACTER_YAMAKKAN                               0x0E4E
#define unicode_THAI_CHARACTER_FONGMAN                                0x0E4F
#define unicode_THAI_DIGIT_ZERO                                       0x0E50
#define unicode_THAI_DIGIT_ONE                                        0x0E51
#define unicode_THAI_DIGIT_TWO                                        0x0E52
#define unicode_THAI_DIGIT_THREE                                      0x0E53
#define unicode_THAI_DIGIT_FOUR                                       0x0E54
#define unicode_THAI_DIGIT_FIVE                                       0x0E55
#define unicode_THAI_DIGIT_SIX                                        0x0E56
#define unicode_THAI_DIGIT_SEVEN                                      0x0E57
#define unicode_THAI_DIGIT_EIGHT                                      0x0E58
#define unicode_THAI_DIGIT_NINE                                       0x0E59
#define unicode_THAI_CHARACTER_ANGKHANKHU                             0x0E5A
#define unicode_THAI_CHARACTER_KHOMUT                                 0x0E5B
#define unicode_LAO_LETTER_KO                                         0x0E81
#define unicode_LAO_LETTER_KHO_SUNG                                   0x0E82
#define unicode_LAO_LETTER_KHO_TAM                                    0x0E84
#define unicode_LAO_LETTER_NGO                                        0x0E87
#define unicode_LAO_LETTER_CO                                         0x0E88
#define unicode_LAO_LETTER_SO_TAM                                     0x0E8A
#define unicode_LAO_LETTER_NYO                                        0x0E8D
#define unicode_LAO_LETTER_DO                                         0x0E94
#define unicode_LAO_LETTER_TO                                         0x0E95
#define unicode_LAO_LETTER_THO_SUNG                                   0x0E96
#define unicode_LAO_LETTER_THO_TAM                                    0x0E97
#define unicode_LAO_LETTER_NO                                         0x0E99
#define unicode_LAO_LETTER_BO                                         0x0E9A
#define unicode_LAO_LETTER_PO                                         0x0E9B
#define unicode_LAO_LETTER_PHO_SUNG                                   0x0E9C
#define unicode_LAO_LETTER_FO_TAM                                     0x0E9D
#define unicode_LAO_LETTER_PHO_TAM                                    0x0E9E
#define unicode_LAO_LETTER_FO_SUNG                                    0x0E9F
#define unicode_LAO_LETTER_MO                                         0x0EA1
#define unicode_LAO_LETTER_YO                                         0x0EA2
#define unicode_LAO_LETTER_LO_LING                                    0x0EA3
#define unicode_LAO_LETTER_LO_LOOT                                    0x0EA5
#define unicode_LAO_LETTER_WO                                         0x0EA7
#define unicode_LAO_LETTER_SO_SUNG                                    0x0EAA
#define unicode_LAO_LETTER_HO_SUNG                                    0x0EAB
#define unicode_LAO_LETTER_O                                          0x0EAD
#define unicode_LAO_LETTER_HO_TAM                                     0x0EAE
#define unicode_LAO_ELLIPSIS                                          0x0EAF
#define unicode_LAO_VOWEL_SIGN_A                                      0x0EB0
#define unicode_LAO_VOWEL_SIGN_MAI_KAN                                0x0EB1
#define unicode_LAO_VOWEL_SIGN_AA                                     0x0EB2
#define unicode_LAO_VOWEL_SIGN_AM                                     0x0EB3
#define unicode_LAO_VOWEL_SIGN_I                                      0x0EB4
#define unicode_LAO_VOWEL_SIGN_II                                     0x0EB5
#define unicode_LAO_VOWEL_SIGN_Y                                      0x0EB6
#define unicode_LAO_VOWEL_SIGN_YY                                     0x0EB7
#define unicode_LAO_VOWEL_SIGN_U                                      0x0EB8
#define unicode_LAO_VOWEL_SIGN_UU                                     0x0EB9
#define unicode_LAO_VOWEL_SIGN_MAI_KON                                0x0EBB
#define unicode_LAO_SEMIVOWEL_SIGN_LO                                 0x0EBC
#define unicode_LAO_SEMIVOWEL_SIGN_NYO                                0x0EBD
#define unicode_LAO_VOWEL_SIGN_E                                      0x0EC0
#define unicode_LAO_VOWEL_SIGN_EI                                     0x0EC1
#define unicode_LAO_VOWEL_SIGN_O                                      0x0EC2
#define unicode_LAO_VOWEL_SIGN_AY                                     0x0EC3
#define unicode_LAO_VOWEL_SIGN_AI                                     0x0EC4
#define unicode_LAO_KO_LA                                             0x0EC6
#define unicode_LAO_TONE_MAI_EK                                       0x0EC8
#define unicode_LAO_TONE_MAI_THO                                      0x0EC9
#define unicode_LAO_TONE_MAI_TI                                       0x0ECA
#define unicode_LAO_TONE_MAI_CATAWA                                   0x0ECB
#define unicode_LAO_CANCELLATION_MARK                                 0x0ECC
#define unicode_LAO_NIGGAHITA                                         0x0ECD
#define unicode_LAO_DIGIT_ZERO                                        0x0ED0
#define unicode_LAO_DIGIT_ONE                                         0x0ED1
#define unicode_LAO_DIGIT_TWO                                         0x0ED2
#define unicode_LAO_DIGIT_THREE                                       0x0ED3
#define unicode_LAO_DIGIT_FOUR                                        0x0ED4
#define unicode_LAO_DIGIT_FIVE                                        0x0ED5
#define unicode_LAO_DIGIT_SIX                                         0x0ED6
#define unicode_LAO_DIGIT_SEVEN                                       0x0ED7
#define unicode_LAO_DIGIT_EIGHT                                       0x0ED8
#define unicode_LAO_DIGIT_NINE                                        0x0ED9
#define unicode_LAO_HO_NO                                             0x0EDC
#define unicode_LAO_HO_MO                                             0x0EDD
#define unicode_LAO_LETTER_KHMU_GO                                    0x0EDE
#define unicode_LAO_LETTER_KHMU_NYO                                   0x0EDF
#define unicode_TIBETAN_SYLLABLE_OM                                   0x0F00
#define unicode_TIBETAN_MARK_GTER_YIG_MGO_TRUNCATED_A                 0x0F01
#define unicode_TIBETAN_MARK_GTER_YIG_MGO__UM_RNAM_BCAD_MA            0x0F02
#define unicode_TIBETAN_MARK_GTER_YIG_MGO__UM_GTER_TSHEG_MA           0x0F03
#define unicode_TIBETAN_MARK_INITIAL_YIG_MGO_MDUN_MA                  0x0F04
#define unicode_TIBETAN_MARK_CLOSING_YIG_MGO_SGAB_MA                  0x0F05
#define unicode_TIBETAN_MARK_CARET_YIG_MGO_PHUR_SHAD_MA               0x0F06
#define unicode_TIBETAN_MARK_YIG_MGO_TSHEG_SHAD_MA                    0x0F07
#define unicode_TIBETAN_MARK_SBRUL_SHAD                               0x0F08
#define unicode_TIBETAN_MARK_BSKUR_YIG_MGO                            0x0F09
#define unicode_TIBETAN_MARK_BKA__SHOG_YIG_MGO                        0x0F0A
#define unicode_TIBETAN_MARK_INTERSYLLABIC_TSHEG                      0x0F0B
#define unicode_TIBETAN_MARK_DELIMITER_TSHEG_BSTAR                    0x0F0C
#define unicode_TIBETAN_MARK_SHAD                                     0x0F0D
#define unicode_TIBETAN_MARK_NYIS_SHAD                                0x0F0E
#define unicode_TIBETAN_MARK_TSHEG_SHAD                               0x0F0F
#define unicode_TIBETAN_MARK_NYIS_TSHEG_SHAD                          0x0F10
#define unicode_TIBETAN_MARK_RIN_CHEN_SPUNGS_SHAD                     0x0F11
#define unicode_TIBETAN_MARK_RGYA_GRAM_SHAD                           0x0F12
#define unicode_TIBETAN_MARK_CARET__DZUD_RTAGS_ME_LONG_CAN            0x0F13
#define unicode_TIBETAN_MARK_GTER_TSHEG                               0x0F14
#define unicode_TIBETAN_LOGOTYPE_SIGN_CHAD_RTAGS                      0x0F15
#define unicode_TIBETAN_LOGOTYPE_SIGN_LHAG_RTAGS                      0x0F16
#define unicode_TIBETAN_ASTROLOGICAL_SIGN_SGRA_GCAN__CHAR_RTAGS       0x0F17
#define unicode_TIBETAN_ASTROLOGICAL_SIGN__KHYUD_PA                   0x0F18
#define unicode_TIBETAN_ASTROLOGICAL_SIGN_SDONG_TSHUGS                0x0F19
#define unicode_TIBETAN_SIGN_RDEL_DKAR_GCIG                           0x0F1A
#define unicode_TIBETAN_SIGN_RDEL_DKAR_GNYIS                          0x0F1B
#define unicode_TIBETAN_SIGN_RDEL_DKAR_GSUM                           0x0F1C
#define unicode_TIBETAN_SIGN_RDEL_NAG_GCIG                            0x0F1D
#define unicode_TIBETAN_SIGN_RDEL_NAG_GNYIS                           0x0F1E
#define unicode_TIBETAN_SIGN_RDEL_DKAR_RDEL_NAG                       0x0F1F
#define unicode_TIBETAN_DIGIT_ZERO                                    0x0F20
#define unicode_TIBETAN_DIGIT_ONE                                     0x0F21
#define unicode_TIBETAN_DIGIT_TWO                                     0x0F22
#define unicode_TIBETAN_DIGIT_THREE                                   0x0F23
#define unicode_TIBETAN_DIGIT_FOUR                                    0x0F24
#define unicode_TIBETAN_DIGIT_FIVE                                    0x0F25
#define unicode_TIBETAN_DIGIT_SIX                                     0x0F26
#define unicode_TIBETAN_DIGIT_SEVEN                                   0x0F27
#define unicode_TIBETAN_DIGIT_EIGHT                                   0x0F28
#define unicode_TIBETAN_DIGIT_NINE                                    0x0F29
#define unicode_TIBETAN_DIGIT_HALF_ONE                                0x0F2A
#define unicode_TIBETAN_DIGIT_HALF_TWO                                0x0F2B
#define unicode_TIBETAN_DIGIT_HALF_THREE                              0x0F2C
#define unicode_TIBETAN_DIGIT_HALF_FOUR                               0x0F2D
#define unicode_TIBETAN_DIGIT_HALF_FIVE                               0x0F2E
#define unicode_TIBETAN_DIGIT_HALF_SIX                                0x0F2F
#define unicode_TIBETAN_DIGIT_HALF_SEVEN                              0x0F30
#define unicode_TIBETAN_DIGIT_HALF_EIGHT                              0x0F31
#define unicode_TIBETAN_DIGIT_HALF_NINE                               0x0F32
#define unicode_TIBETAN_DIGIT_HALF_ZERO                               0x0F33
#define unicode_TIBETAN_MARK_BSDUS_RTAGS                              0x0F34
#define unicode_TIBETAN_MARK_NGAS_BZUNG_NYI_ZLA                       0x0F35
#define unicode_TIBETAN_MARK_CARET__DZUD_RTAGS_BZHI_MIG_CAN           0x0F36
#define unicode_TIBETAN_MARK_NGAS_BZUNG_SGOR_RTAGS                    0x0F37
#define unicode_TIBETAN_MARK_CHE_MGO                                  0x0F38
#define unicode_TIBETAN_MARK_TSA__PHRU                                0x0F39
#define unicode_TIBETAN_MARK_GUG_RTAGS_GYON                           0x0F3A
#define unicode_TIBETAN_MARK_GUG_RTAGS_GYAS                           0x0F3B
#define unicode_TIBETAN_MARK_ANG_KHANG_GYON                           0x0F3C
#define unicode_TIBETAN_MARK_ANG_KHANG_GYAS                           0x0F3D
#define unicode_TIBETAN_SIGN_YAR_TSHES                                0x0F3E
#define unicode_TIBETAN_SIGN_MAR_TSHES                                0x0F3F
#define unicode_TIBETAN_LETTER_KA                                     0x0F40
#define unicode_TIBETAN_LETTER_KHA                                    0x0F41
#define unicode_TIBETAN_LETTER_GA                                     0x0F42
#define unicode_TIBETAN_LETTER_GHA                                    0x0F43
#define unicode_TIBETAN_LETTER_NGA                                    0x0F44
#define unicode_TIBETAN_LETTER_CA                                     0x0F45
#define unicode_TIBETAN_LETTER_CHA                                    0x0F46
#define unicode_TIBETAN_LETTER_JA                                     0x0F47
#define unicode_TIBETAN_LETTER_NYA                                    0x0F49
#define unicode_TIBETAN_LETTER_TTA                                    0x0F4A
#define unicode_TIBETAN_LETTER_TTHA                                   0x0F4B
#define unicode_TIBETAN_LETTER_DDA                                    0x0F4C
#define unicode_TIBETAN_LETTER_DDHA                                   0x0F4D
#define unicode_TIBETAN_LETTER_NNA                                    0x0F4E
#define unicode_TIBETAN_LETTER_TA                                     0x0F4F
#define unicode_TIBETAN_LETTER_THA                                    0x0F50
#define unicode_TIBETAN_LETTER_DA                                     0x0F51
#define unicode_TIBETAN_LETTER_DHA                                    0x0F52
#define unicode_TIBETAN_LETTER_NA                                     0x0F53
#define unicode_TIBETAN_LETTER_PA                                     0x0F54
#define unicode_TIBETAN_LETTER_PHA                                    0x0F55
#define unicode_TIBETAN_LETTER_BA                                     0x0F56
#define unicode_TIBETAN_LETTER_BHA                                    0x0F57
#define unicode_TIBETAN_LETTER_MA                                     0x0F58
#define unicode_TIBETAN_LETTER_TSA                                    0x0F59
#define unicode_TIBETAN_LETTER_TSHA                                   0x0F5A
#define unicode_TIBETAN_LETTER_DZA                                    0x0F5B
#define unicode_TIBETAN_LETTER_DZHA                                   0x0F5C
#define unicode_TIBETAN_LETTER_WA                                     0x0F5D
#define unicode_TIBETAN_LETTER_ZHA                                    0x0F5E
#define unicode_TIBETAN_LETTER_ZA                                     0x0F5F
#define unicode_TIBETAN_LETTER__A                                     0x0F60
#define unicode_TIBETAN_LETTER_YA                                     0x0F61
#define unicode_TIBETAN_LETTER_RA                                     0x0F62
#define unicode_TIBETAN_LETTER_LA                                     0x0F63
#define unicode_TIBETAN_LETTER_SHA                                    0x0F64
#define unicode_TIBETAN_LETTER_SSA                                    0x0F65
#define unicode_TIBETAN_LETTER_SA                                     0x0F66
#define unicode_TIBETAN_LETTER_HA                                     0x0F67
#define unicode_TIBETAN_LETTER_A                                      0x0F68
#define unicode_TIBETAN_LETTER_KSSA                                   0x0F69
#define unicode_TIBETAN_LETTER_FIXED_FORM_RA                          0x0F6A
#define unicode_TIBETAN_LETTER_KKA                                    0x0F6B
#define unicode_TIBETAN_LETTER_RRA                                    0x0F6C
#define unicode_TIBETAN_VOWEL_SIGN_AA                                 0x0F71
#define unicode_TIBETAN_VOWEL_SIGN_I                                  0x0F72
#define unicode_TIBETAN_VOWEL_SIGN_II                                 0x0F73
#define unicode_TIBETAN_VOWEL_SIGN_U                                  0x0F74
#define unicode_TIBETAN_VOWEL_SIGN_UU                                 0x0F75
#define unicode_TIBETAN_VOWEL_SIGN_VOCALIC_R                          0x0F76
#define unicode_TIBETAN_VOWEL_SIGN_VOCALIC_RR                         0x0F77
#define unicode_TIBETAN_VOWEL_SIGN_VOCALIC_L                          0x0F78
#define unicode_TIBETAN_VOWEL_SIGN_VOCALIC_LL                         0x0F79
#define unicode_TIBETAN_VOWEL_SIGN_E                                  0x0F7A
#define unicode_TIBETAN_VOWEL_SIGN_EE                                 0x0F7B
#define unicode_TIBETAN_VOWEL_SIGN_O                                  0x0F7C
#define unicode_TIBETAN_VOWEL_SIGN_OO                                 0x0F7D
#define unicode_TIBETAN_SIGN_RJES_SU_NGA_RO                           0x0F7E
#define unicode_TIBETAN_SIGN_RNAM_BCAD                                0x0F7F
#define unicode_TIBETAN_VOWEL_SIGN_REVERSED_I                         0x0F80
#define unicode_TIBETAN_VOWEL_SIGN_REVERSED_II                        0x0F81
#define unicode_TIBETAN_SIGN_NYI_ZLA_NAA_DA                           0x0F82
#define unicode_TIBETAN_SIGN_SNA_LDAN                                 0x0F83
#define unicode_TIBETAN_MARK_HALANTA                                  0x0F84
#define unicode_TIBETAN_MARK_PALUTA                                   0x0F85
#define unicode_TIBETAN_SIGN_LCI_RTAGS                                0x0F86
#define unicode_TIBETAN_SIGN_YANG_RTAGS                               0x0F87
#define unicode_TIBETAN_SIGN_LCE_TSA_CAN                              0x0F88
#define unicode_TIBETAN_SIGN_MCHU_CAN                                 0x0F89
#define unicode_TIBETAN_SIGN_GRU_CAN_RGYINGS                          0x0F8A
#define unicode_TIBETAN_SIGN_GRU_MED_RGYINGS                          0x0F8B
#define unicode_TIBETAN_SIGN_INVERTED_MCHU_CAN                        0x0F8C
#define unicode_TIBETAN_SUBJOINED_SIGN_LCE_TSA_CAN                    0x0F8D
#define unicode_TIBETAN_SUBJOINED_SIGN_MCHU_CAN                       0x0F8E
#define unicode_TIBETAN_SUBJOINED_SIGN_INVERTED_MCHU_CAN              0x0F8F
#define unicode_TIBETAN_SUBJOINED_LETTER_KA                           0x0F90
#define unicode_TIBETAN_SUBJOINED_LETTER_KHA                          0x0F91
#define unicode_TIBETAN_SUBJOINED_LETTER_GA                           0x0F92
#define unicode_TIBETAN_SUBJOINED_LETTER_GHA                          0x0F93
#define unicode_TIBETAN_SUBJOINED_LETTER_NGA                          0x0F94
#define unicode_TIBETAN_SUBJOINED_LETTER_CA                           0x0F95
#define unicode_TIBETAN_SUBJOINED_LETTER_CHA                          0x0F96
#define unicode_TIBETAN_SUBJOINED_LETTER_JA                           0x0F97
#define unicode_TIBETAN_SUBJOINED_LETTER_NYA                          0x0F99
#define unicode_TIBETAN_SUBJOINED_LETTER_TTA                          0x0F9A
#define unicode_TIBETAN_SUBJOINED_LETTER_TTHA                         0x0F9B
#define unicode_TIBETAN_SUBJOINED_LETTER_DDA                          0x0F9C
#define unicode_TIBETAN_SUBJOINED_LETTER_DDHA                         0x0F9D
#define unicode_TIBETAN_SUBJOINED_LETTER_NNA                          0x0F9E
#define unicode_TIBETAN_SUBJOINED_LETTER_TA                           0x0F9F
#define unicode_TIBETAN_SUBJOINED_LETTER_THA                          0x0FA0
#define unicode_TIBETAN_SUBJOINED_LETTER_DA                           0x0FA1
#define unicode_TIBETAN_SUBJOINED_LETTER_DHA                          0x0FA2
#define unicode_TIBETAN_SUBJOINED_LETTER_NA                           0x0FA3
#define unicode_TIBETAN_SUBJOINED_LETTER_PA                           0x0FA4
#define unicode_TIBETAN_SUBJOINED_LETTER_PHA                          0x0FA5
#define unicode_TIBETAN_SUBJOINED_LETTER_BA                           0x0FA6
#define unicode_TIBETAN_SUBJOINED_LETTER_BHA                          0x0FA7
#define unicode_TIBETAN_SUBJOINED_LETTER_MA                           0x0FA8
#define unicode_TIBETAN_SUBJOINED_LETTER_TSA                          0x0FA9
#define unicode_TIBETAN_SUBJOINED_LETTER_TSHA                         0x0FAA
#define unicode_TIBETAN_SUBJOINED_LETTER_DZA                          0x0FAB
#define unicode_TIBETAN_SUBJOINED_LETTER_DZHA                         0x0FAC
#define unicode_TIBETAN_SUBJOINED_LETTER_WA                           0x0FAD
#define unicode_TIBETAN_SUBJOINED_LETTER_ZHA                          0x0FAE
#define unicode_TIBETAN_SUBJOINED_LETTER_ZA                           0x0FAF
#define unicode_TIBETAN_SUBJOINED_LETTER__A                           0x0FB0
#define unicode_TIBETAN_SUBJOINED_LETTER_YA                           0x0FB1
#define unicode_TIBETAN_SUBJOINED_LETTER_RA                           0x0FB2
#define unicode_TIBETAN_SUBJOINED_LETTER_LA                           0x0FB3
#define unicode_TIBETAN_SUBJOINED_LETTER_SHA                          0x0FB4
#define unicode_TIBETAN_SUBJOINED_LETTER_SSA                          0x0FB5
#define unicode_TIBETAN_SUBJOINED_LETTER_SA                           0x0FB6
#define unicode_TIBETAN_SUBJOINED_LETTER_HA                           0x0FB7
#define unicode_TIBETAN_SUBJOINED_LETTER_A                            0x0FB8
#define unicode_TIBETAN_SUBJOINED_LETTER_KSSA                         0x0FB9
#define unicode_TIBETAN_SUBJOINED_LETTER_FIXED_FORM_WA                0x0FBA
#define unicode_TIBETAN_SUBJOINED_LETTER_FIXED_FORM_YA                0x0FBB
#define unicode_TIBETAN_SUBJOINED_LETTER_FIXED_FORM_RA                0x0FBC
#define unicode_TIBETAN_KU_RU_KHA                                     0x0FBE
#define unicode_TIBETAN_KU_RU_KHA_BZHI_MIG_CAN                        0x0FBF
#define unicode_TIBETAN_CANTILLATION_SIGN_HEAVY_BEAT                  0x0FC0
#define unicode_TIBETAN_CANTILLATION_SIGN_LIGHT_BEAT                  0x0FC1
#define unicode_TIBETAN_CANTILLATION_SIGN_CANG_TE_U                   0x0FC2
#define unicode_TIBETAN_CANTILLATION_SIGN_SBUB__CHAL                  0x0FC3
#define unicode_TIBETAN_SYMBOL_DRIL_BU                                0x0FC4
#define unicode_TIBETAN_SYMBOL_RDO_RJE                                0x0FC5
#define unicode_TIBETAN_SYMBOL_PADMA_GDAN                             0x0FC6
#define unicode_TIBETAN_SYMBOL_RDO_RJE_RGYA_GRAM                      0x0FC7
#define unicode_TIBETAN_SYMBOL_PHUR_PA                                0x0FC8
#define unicode_TIBETAN_SYMBOL_NOR_BU                                 0x0FC9
#define unicode_TIBETAN_SYMBOL_NOR_BU_NYIS__KHYIL                     0x0FCA
#define unicode_TIBETAN_SYMBOL_NOR_BU_GSUM__KHYIL                     0x0FCB
#define unicode_TIBETAN_SYMBOL_NOR_BU_BZHI__KHYIL                     0x0FCC
#define unicode_TIBETAN_SIGN_RDEL_NAG_RDEL_DKAR                       0x0FCE
#define unicode_TIBETAN_SIGN_RDEL_NAG_GSUM                            0x0FCF
#define unicode_TIBETAN_MARK_BSKA__SHOG_GI_MGO_RGYAN                  0x0FD0
#define unicode_TIBETAN_MARK_MNYAM_YIG_GI_MGO_RGYAN                   0x0FD1
#define unicode_TIBETAN_MARK_NYIS_TSHEG                               0x0FD2
#define unicode_TIBETAN_MARK_INITIAL_BRDA_RNYING_YIG_MGO_MDUN_MA      0x0FD3
#define unicode_TIBETAN_MARK_CLOSING_BRDA_RNYING_YIG_MGO_SGAB_MA      0x0FD4
#define unicode_RIGHT_FACING_SVASTI_SIGN                              0x0FD5
#define unicode_LEFT_FACING_SVASTI_SIGN                               0x0FD6
#define unicode_RIGHT_FACING_SVASTI_SIGN_WITH_DOTS                    0x0FD7
#define unicode_LEFT_FACING_SVASTI_SIGN_WITH_DOTS                     0x0FD8
#define unicode_TIBETAN_MARK_LEADING_MCHAN_RTAGS                      0x0FD9
#define unicode_TIBETAN_MARK_TRAILING_MCHAN_RTAGS                     0x0FDA
#define unicode_MYANMAR_LETTER_KA                                     0x1000
#define unicode_MYANMAR_LETTER_KHA                                    0x1001
#define unicode_MYANMAR_LETTER_GA                                     0x1002
#define unicode_MYANMAR_LETTER_GHA                                    0x1003
#define unicode_MYANMAR_LETTER_NGA                                    0x1004
#define unicode_MYANMAR_LETTER_CA                                     0x1005
#define unicode_MYANMAR_LETTER_CHA                                    0x1006
#define unicode_MYANMAR_LETTER_JA                                     0x1007
#define unicode_MYANMAR_LETTER_JHA                                    0x1008
#define unicode_MYANMAR_LETTER_NYA                                    0x1009
#define unicode_MYANMAR_LETTER_NNYA                                   0x100A
#define unicode_MYANMAR_LETTER_TTA                                    0x100B
#define unicode_MYANMAR_LETTER_TTHA                                   0x100C
#define unicode_MYANMAR_LETTER_DDA                                    0x100D
#define unicode_MYANMAR_LETTER_DDHA                                   0x100E
#define unicode_MYANMAR_LETTER_NNA                                    0x100F
#define unicode_MYANMAR_LETTER_TA                                     0x1010
#define unicode_MYANMAR_LETTER_THA                                    0x1011
#define unicode_MYANMAR_LETTER_DA                                     0x1012
#define unicode_MYANMAR_LETTER_DHA                                    0x1013
#define unicode_MYANMAR_LETTER_NA                                     0x1014
#define unicode_MYANMAR_LETTER_PA                                     0x1015
#define unicode_MYANMAR_LETTER_PHA                                    0x1016
#define unicode_MYANMAR_LETTER_BA                                     0x1017
#define unicode_MYANMAR_LETTER_BHA                                    0x1018
#define unicode_MYANMAR_LETTER_MA                                     0x1019
#define unicode_MYANMAR_LETTER_YA                                     0x101A
#define unicode_MYANMAR_LETTER_RA                                     0x101B
#define unicode_MYANMAR_LETTER_LA                                     0x101C
#define unicode_MYANMAR_LETTER_WA                                     0x101D
#define unicode_MYANMAR_LETTER_SA                                     0x101E
#define unicode_MYANMAR_LETTER_HA                                     0x101F
#define unicode_MYANMAR_LETTER_LLA                                    0x1020
#define unicode_MYANMAR_LETTER_A                                      0x1021
#define unicode_MYANMAR_LETTER_SHAN_A                                 0x1022
#define unicode_MYANMAR_LETTER_I                                      0x1023
#define unicode_MYANMAR_LETTER_II                                     0x1024
#define unicode_MYANMAR_LETTER_U                                      0x1025
#define unicode_MYANMAR_LETTER_UU                                     0x1026
#define unicode_MYANMAR_LETTER_E                                      0x1027
#define unicode_MYANMAR_LETTER_MON_E                                  0x1028
#define unicode_MYANMAR_LETTER_O                                      0x1029
#define unicode_MYANMAR_LETTER_AU                                     0x102A
#define unicode_MYANMAR_VOWEL_SIGN_TALL_AA                            0x102B
#define unicode_MYANMAR_VOWEL_SIGN_AA                                 0x102C
#define unicode_MYANMAR_VOWEL_SIGN_I                                  0x102D
#define unicode_MYANMAR_VOWEL_SIGN_II                                 0x102E
#define unicode_MYANMAR_VOWEL_SIGN_U                                  0x102F
#define unicode_MYANMAR_VOWEL_SIGN_UU                                 0x1030
#define unicode_MYANMAR_VOWEL_SIGN_E                                  0x1031
#define unicode_MYANMAR_VOWEL_SIGN_AI                                 0x1032
#define unicode_MYANMAR_VOWEL_SIGN_MON_II                             0x1033
#define unicode_MYANMAR_VOWEL_SIGN_MON_O                              0x1034
#define unicode_MYANMAR_VOWEL_SIGN_E_ABOVE                            0x1035
#define unicode_MYANMAR_SIGN_ANUSVARA                                 0x1036
#define unicode_MYANMAR_SIGN_DOT_BELOW                                0x1037
#define unicode_MYANMAR_SIGN_VISARGA                                  0x1038
#define unicode_MYANMAR_SIGN_VIRAMA                                   0x1039
#define unicode_MYANMAR_SIGN_ASAT                                     0x103A
#define unicode_MYANMAR_CONSONANT_SIGN_MEDIAL_YA                      0x103B
#define unicode_MYANMAR_CONSONANT_SIGN_MEDIAL_RA                      0x103C
#define unicode_MYANMAR_CONSONANT_SIGN_MEDIAL_WA                      0x103D
#define unicode_MYANMAR_CONSONANT_SIGN_MEDIAL_HA                      0x103E
#define unicode_MYANMAR_LETTER_GREAT_SA                               0x103F
#define unicode_MYANMAR_DIGIT_ZERO                                    0x1040
#define unicode_MYANMAR_DIGIT_ONE                                     0x1041
#define unicode_MYANMAR_DIGIT_TWO                                     0x1042
#define unicode_MYANMAR_DIGIT_THREE                                   0x1043
#define unicode_MYANMAR_DIGIT_FOUR                                    0x1044
#define unicode_MYANMAR_DIGIT_FIVE                                    0x1045
#define unicode_MYANMAR_DIGIT_SIX                                     0x1046
#define unicode_MYANMAR_DIGIT_SEVEN                                   0x1047
#define unicode_MYANMAR_DIGIT_EIGHT                                   0x1048
#define unicode_MYANMAR_DIGIT_NINE                                    0x1049
#define unicode_MYANMAR_SIGN_LITTLE_SECTION                           0x104A
#define unicode_MYANMAR_SIGN_SECTION                                  0x104B
#define unicode_MYANMAR_SYMBOL_LOCATIVE                               0x104C
#define unicode_MYANMAR_SYMBOL_COMPLETED                              0x104D
#define unicode_MYANMAR_SYMBOL_AFOREMENTIONED                         0x104E
#define unicode_MYANMAR_SYMBOL_GENITIVE                               0x104F
#define unicode_MYANMAR_LETTER_SHA                                    0x1050
#define unicode_MYANMAR_LETTER_SSA                                    0x1051
#define unicode_MYANMAR_LETTER_VOCALIC_R                              0x1052
#define unicode_MYANMAR_LETTER_VOCALIC_RR                             0x1053
#define unicode_MYANMAR_LETTER_VOCALIC_L                              0x1054
#define unicode_MYANMAR_LETTER_VOCALIC_LL                             0x1055
#define unicode_MYANMAR_VOWEL_SIGN_VOCALIC_R                          0x1056
#define unicode_MYANMAR_VOWEL_SIGN_VOCALIC_RR                         0x1057
#define unicode_MYANMAR_VOWEL_SIGN_VOCALIC_L                          0x1058
#define unicode_MYANMAR_VOWEL_SIGN_VOCALIC_LL                         0x1059
#define unicode_MYANMAR_LETTER_MON_NGA                                0x105A
#define unicode_MYANMAR_LETTER_MON_JHA                                0x105B
#define unicode_MYANMAR_LETTER_MON_BBA                                0x105C
#define unicode_MYANMAR_LETTER_MON_BBE                                0x105D
#define unicode_MYANMAR_CONSONANT_SIGN_MON_MEDIAL_NA                  0x105E
#define unicode_MYANMAR_CONSONANT_SIGN_MON_MEDIAL_MA                  0x105F
#define unicode_MYANMAR_CONSONANT_SIGN_MON_MEDIAL_LA                  0x1060
#define unicode_MYANMAR_LETTER_SGAW_KAREN_SHA                         0x1061
#define unicode_MYANMAR_VOWEL_SIGN_SGAW_KAREN_EU                      0x1062
#define unicode_MYANMAR_TONE_MARK_SGAW_KAREN_HATHI                    0x1063
#define unicode_MYANMAR_TONE_MARK_SGAW_KAREN_KE_PHO                   0x1064
#define unicode_MYANMAR_LETTER_WESTERN_PWO_KAREN_THA                  0x1065
#define unicode_MYANMAR_LETTER_WESTERN_PWO_KAREN_PWA                  0x1066
#define unicode_MYANMAR_VOWEL_SIGN_WESTERN_PWO_KAREN_EU               0x1067
#define unicode_MYANMAR_VOWEL_SIGN_WESTERN_PWO_KAREN_UE               0x1068
#define unicode_MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_1                 0x1069
#define unicode_MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_2                 0x106A
#define unicode_MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_3                 0x106B
#define unicode_MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_4                 0x106C
#define unicode_MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_5                 0x106D
#define unicode_MYANMAR_LETTER_EASTERN_PWO_KAREN_NNA                  0x106E
#define unicode_MYANMAR_LETTER_EASTERN_PWO_KAREN_YWA                  0x106F
#define unicode_MYANMAR_LETTER_EASTERN_PWO_KAREN_GHWA                 0x1070
#define unicode_MYANMAR_VOWEL_SIGN_GEBA_KAREN_I                       0x1071
#define unicode_MYANMAR_VOWEL_SIGN_KAYAH_OE                           0x1072
#define unicode_MYANMAR_VOWEL_SIGN_KAYAH_U                            0x1073
#define unicode_MYANMAR_VOWEL_SIGN_KAYAH_EE                           0x1074
#define unicode_MYANMAR_LETTER_SHAN_KA                                0x1075
#define unicode_MYANMAR_LETTER_SHAN_KHA                               0x1076
#define unicode_MYANMAR_LETTER_SHAN_GA                                0x1077
#define unicode_MYANMAR_LETTER_SHAN_CA                                0x1078
#define unicode_MYANMAR_LETTER_SHAN_ZA                                0x1079
#define unicode_MYANMAR_LETTER_SHAN_NYA                               0x107A
#define unicode_MYANMAR_LETTER_SHAN_DA                                0x107B
#define unicode_MYANMAR_LETTER_SHAN_NA                                0x107C
#define unicode_MYANMAR_LETTER_SHAN_PHA                               0x107D
#define unicode_MYANMAR_LETTER_SHAN_FA                                0x107E
#define unicode_MYANMAR_LETTER_SHAN_BA                                0x107F
#define unicode_MYANMAR_LETTER_SHAN_THA                               0x1080
#define unicode_MYANMAR_LETTER_SHAN_HA                                0x1081
#define unicode_MYANMAR_CONSONANT_SIGN_SHAN_MEDIAL_WA                 0x1082
#define unicode_MYANMAR_VOWEL_SIGN_SHAN_AA                            0x1083
#define unicode_MYANMAR_VOWEL_SIGN_SHAN_E                             0x1084
#define unicode_MYANMAR_VOWEL_SIGN_SHAN_E_ABOVE                       0x1085
#define unicode_MYANMAR_VOWEL_SIGN_SHAN_FINAL_Y                       0x1086
#define unicode_MYANMAR_SIGN_SHAN_TONE_2                              0x1087
#define unicode_MYANMAR_SIGN_SHAN_TONE_3                              0x1088
#define unicode_MYANMAR_SIGN_SHAN_TONE_5                              0x1089
#define unicode_MYANMAR_SIGN_SHAN_TONE_6                              0x108A
#define unicode_MYANMAR_SIGN_SHAN_COUNCIL_TONE_2                      0x108B
#define unicode_MYANMAR_SIGN_SHAN_COUNCIL_TONE_3                      0x108C
#define unicode_MYANMAR_SIGN_SHAN_COUNCIL_EMPHATIC_TONE               0x108D
#define unicode_MYANMAR_LETTER_RUMAI_PALAUNG_FA                       0x108E
#define unicode_MYANMAR_SIGN_RUMAI_PALAUNG_TONE_5                     0x108F
#define unicode_MYANMAR_SHAN_DIGIT_ZERO                               0x1090
#define unicode_MYANMAR_SHAN_DIGIT_ONE                                0x1091
#define unicode_MYANMAR_SHAN_DIGIT_TWO                                0x1092
#define unicode_MYANMAR_SHAN_DIGIT_THREE                              0x1093
#define unicode_MYANMAR_SHAN_DIGIT_FOUR                               0x1094
#define unicode_MYANMAR_SHAN_DIGIT_FIVE                               0x1095
#define unicode_MYANMAR_SHAN_DIGIT_SIX                                0x1096
#define unicode_MYANMAR_SHAN_DIGIT_SEVEN                              0x1097
#define unicode_MYANMAR_SHAN_DIGIT_EIGHT                              0x1098
#define unicode_MYANMAR_SHAN_DIGIT_NINE                               0x1099
#define unicode_MYANMAR_SIGN_KHAMTI_TONE_1                            0x109A
#define unicode_MYANMAR_SIGN_KHAMTI_TONE_3                            0x109B
#define unicode_MYANMAR_VOWEL_SIGN_AITON_A                            0x109C
#define unicode_MYANMAR_VOWEL_SIGN_AITON_AI                           0x109D
#define unicode_MYANMAR_SYMBOL_SHAN_ONE                               0x109E
#define unicode_MYANMAR_SYMBOL_SHAN_EXCLAMATION                       0x109F
#define unicode_GEORGIAN_CAPITAL_LETTER_AN                            0x10A0
#define unicode_GEORGIAN_CAPITAL_LETTER_BAN                           0x10A1
#define unicode_GEORGIAN_CAPITAL_LETTER_GAN                           0x10A2
#define unicode_GEORGIAN_CAPITAL_LETTER_DON                           0x10A3
#define unicode_GEORGIAN_CAPITAL_LETTER_EN                            0x10A4
#define unicode_GEORGIAN_CAPITAL_LETTER_VIN                           0x10A5
#define unicode_GEORGIAN_CAPITAL_LETTER_ZEN                           0x10A6
#define unicode_GEORGIAN_CAPITAL_LETTER_TAN                           0x10A7
#define unicode_GEORGIAN_CAPITAL_LETTER_IN                            0x10A8
#define unicode_GEORGIAN_CAPITAL_LETTER_KAN                           0x10A9
#define unicode_GEORGIAN_CAPITAL_LETTER_LAS                           0x10AA
#define unicode_GEORGIAN_CAPITAL_LETTER_MAN                           0x10AB
#define unicode_GEORGIAN_CAPITAL_LETTER_NAR                           0x10AC
#define unicode_GEORGIAN_CAPITAL_LETTER_ON                            0x10AD
#define unicode_GEORGIAN_CAPITAL_LETTER_PAR                           0x10AE
#define unicode_GEORGIAN_CAPITAL_LETTER_ZHAR                          0x10AF
#define unicode_GEORGIAN_CAPITAL_LETTER_RAE                           0x10B0
#define unicode_GEORGIAN_CAPITAL_LETTER_SAN                           0x10B1
#define unicode_GEORGIAN_CAPITAL_LETTER_TAR                           0x10B2
#define unicode_GEORGIAN_CAPITAL_LETTER_UN                            0x10B3
#define unicode_GEORGIAN_CAPITAL_LETTER_PHAR                          0x10B4
#define unicode_GEORGIAN_CAPITAL_LETTER_KHAR                          0x10B5
#define unicode_GEORGIAN_CAPITAL_LETTER_GHAN                          0x10B6
#define unicode_GEORGIAN_CAPITAL_LETTER_QAR                           0x10B7
#define unicode_GEORGIAN_CAPITAL_LETTER_SHIN                          0x10B8
#define unicode_GEORGIAN_CAPITAL_LETTER_CHIN                          0x10B9
#define unicode_GEORGIAN_CAPITAL_LETTER_CAN                           0x10BA
#define unicode_GEORGIAN_CAPITAL_LETTER_JIL                           0x10BB
#define unicode_GEORGIAN_CAPITAL_LETTER_CIL                           0x10BC
#define unicode_GEORGIAN_CAPITAL_LETTER_CHAR                          0x10BD
#define unicode_GEORGIAN_CAPITAL_LETTER_XAN                           0x10BE
#define unicode_GEORGIAN_CAPITAL_LETTER_JHAN                          0x10BF
#define unicode_GEORGIAN_CAPITAL_LETTER_HAE                           0x10C0
#define unicode_GEORGIAN_CAPITAL_LETTER_HE                            0x10C1
#define unicode_GEORGIAN_CAPITAL_LETTER_HIE                           0x10C2
#define unicode_GEORGIAN_CAPITAL_LETTER_WE                            0x10C3
#define unicode_GEORGIAN_CAPITAL_LETTER_HAR                           0x10C4
#define unicode_GEORGIAN_CAPITAL_LETTER_HOE                           0x10C5
#define unicode_GEORGIAN_CAPITAL_LETTER_YN                            0x10C7
#define unicode_GEORGIAN_CAPITAL_LETTER_AEN                           0x10CD
#define unicode_GEORGIAN_LETTER_AN                                    0x10D0
#define unicode_GEORGIAN_LETTER_BAN                                   0x10D1
#define unicode_GEORGIAN_LETTER_GAN                                   0x10D2
#define unicode_GEORGIAN_LETTER_DON                                   0x10D3
#define unicode_GEORGIAN_LETTER_EN                                    0x10D4
#define unicode_GEORGIAN_LETTER_VIN                                   0x10D5
#define unicode_GEORGIAN_LETTER_ZEN                                   0x10D6
#define unicode_GEORGIAN_LETTER_TAN                                   0x10D7
#define unicode_GEORGIAN_LETTER_IN                                    0x10D8
#define unicode_GEORGIAN_LETTER_KAN                                   0x10D9
#define unicode_GEORGIAN_LETTER_LAS                                   0x10DA
#define unicode_GEORGIAN_LETTER_MAN                                   0x10DB
#define unicode_GEORGIAN_LETTER_NAR                                   0x10DC
#define unicode_GEORGIAN_LETTER_ON                                    0x10DD
#define unicode_GEORGIAN_LETTER_PAR                                   0x10DE
#define unicode_GEORGIAN_LETTER_ZHAR                                  0x10DF
#define unicode_GEORGIAN_LETTER_RAE                                   0x10E0
#define unicode_GEORGIAN_LETTER_SAN                                   0x10E1
#define unicode_GEORGIAN_LETTER_TAR                                   0x10E2
#define unicode_GEORGIAN_LETTER_UN                                    0x10E3
#define unicode_GEORGIAN_LETTER_PHAR                                  0x10E4
#define unicode_GEORGIAN_LETTER_KHAR                                  0x10E5
#define unicode_GEORGIAN_LETTER_GHAN                                  0x10E6
#define unicode_GEORGIAN_LETTER_QAR                                   0x10E7
#define unicode_GEORGIAN_LETTER_SHIN                                  0x10E8
#define unicode_GEORGIAN_LETTER_CHIN                                  0x10E9
#define unicode_GEORGIAN_LETTER_CAN                                   0x10EA
#define unicode_GEORGIAN_LETTER_JIL                                   0x10EB
#define unicode_GEORGIAN_LETTER_CIL                                   0x10EC
#define unicode_GEORGIAN_LETTER_CHAR                                  0x10ED
#define unicode_GEORGIAN_LETTER_XAN                                   0x10EE
#define unicode_GEORGIAN_LETTER_JHAN                                  0x10EF
#define unicode_GEORGIAN_LETTER_HAE                                   0x10F0
#define unicode_GEORGIAN_LETTER_HE                                    0x10F1
#define unicode_GEORGIAN_LETTER_HIE                                   0x10F2
#define unicode_GEORGIAN_LETTER_WE                                    0x10F3
#define unicode_GEORGIAN_LETTER_HAR                                   0x10F4
#define unicode_GEORGIAN_LETTER_HOE                                   0x10F5
#define unicode_GEORGIAN_LETTER_FI                                    0x10F6
#define unicode_GEORGIAN_LETTER_YN                                    0x10F7
#define unicode_GEORGIAN_LETTER_ELIFI                                 0x10F8
#define unicode_GEORGIAN_LETTER_TURNED_GAN                            0x10F9
#define unicode_GEORGIAN_LETTER_AIN                                   0x10FA
#define unicode_GEORGIAN_PARAGRAPH_SEPARATOR                          0x10FB
#define unicode_MODIFIER_LETTER_GEORGIAN_NAR                          0x10FC
#define unicode_GEORGIAN_LETTER_AEN                                   0x10FD
#define unicode_GEORGIAN_LETTER_HARD_SIGN                             0x10FE
#define unicode_GEORGIAN_LETTER_LABIAL_SIGN                           0x10FF
#define unicode_HANGUL_CHOSEONG_KIYEOK                                0x1100
#define unicode_HANGUL_CHOSEONG_SSANGKIYEOK                           0x1101
#define unicode_HANGUL_CHOSEONG_NIEUN                                 0x1102
#define unicode_HANGUL_CHOSEONG_TIKEUT                                0x1103
#define unicode_HANGUL_CHOSEONG_SSANGTIKEUT                           0x1104
#define unicode_HANGUL_CHOSEONG_RIEUL                                 0x1105
#define unicode_HANGUL_CHOSEONG_MIEUM                                 0x1106
#define unicode_HANGUL_CHOSEONG_PIEUP                                 0x1107
#define unicode_HANGUL_CHOSEONG_SSANGPIEUP                            0x1108
#define unicode_HANGUL_CHOSEONG_SIOS                                  0x1109
#define unicode_HANGUL_CHOSEONG_SSANGSIOS                             0x110A
#define unicode_HANGUL_CHOSEONG_IEUNG                                 0x110B
#define unicode_HANGUL_CHOSEONG_CIEUC                                 0x110C
#define unicode_HANGUL_CHOSEONG_SSANGCIEUC                            0x110D
#define unicode_HANGUL_CHOSEONG_CHIEUCH                               0x110E
#define unicode_HANGUL_CHOSEONG_KHIEUKH                               0x110F
#define unicode_HANGUL_CHOSEONG_THIEUTH                               0x1110
#define unicode_HANGUL_CHOSEONG_PHIEUPH                               0x1111
#define unicode_HANGUL_CHOSEONG_HIEUH                                 0x1112
#define unicode_HANGUL_CHOSEONG_NIEUN_KIYEOK                          0x1113
#define unicode_HANGUL_CHOSEONG_SSANGNIEUN                            0x1114
#define unicode_HANGUL_CHOSEONG_NIEUN_TIKEUT                          0x1115
#define unicode_HANGUL_CHOSEONG_NIEUN_PIEUP                           0x1116
#define unicode_HANGUL_CHOSEONG_TIKEUT_KIYEOK                         0x1117
#define unicode_HANGUL_CHOSEONG_RIEUL_NIEUN                           0x1118
#define unicode_HANGUL_CHOSEONG_SSANGRIEUL                            0x1119
#define unicode_HANGUL_CHOSEONG_RIEUL_HIEUH                           0x111A
#define unicode_HANGUL_CHOSEONG_KAPYEOUNRIEUL                         0x111B
#define unicode_HANGUL_CHOSEONG_MIEUM_PIEUP                           0x111C
#define unicode_HANGUL_CHOSEONG_KAPYEOUNMIEUM                         0x111D
#define unicode_HANGUL_CHOSEONG_PIEUP_KIYEOK                          0x111E
#define unicode_HANGUL_CHOSEONG_PIEUP_NIEUN                           0x111F
#define unicode_HANGUL_CHOSEONG_PIEUP_TIKEUT                          0x1120
#define unicode_HANGUL_CHOSEONG_PIEUP_SIOS                            0x1121
#define unicode_HANGUL_CHOSEONG_PIEUP_SIOS_KIYEOK                     0x1122
#define unicode_HANGUL_CHOSEONG_PIEUP_SIOS_TIKEUT                     0x1123
#define unicode_HANGUL_CHOSEONG_PIEUP_SIOS_PIEUP                      0x1124
#define unicode_HANGUL_CHOSEONG_PIEUP_SSANGSIOS                       0x1125
#define unicode_HANGUL_CHOSEONG_PIEUP_SIOS_CIEUC                      0x1126
#define unicode_HANGUL_CHOSEONG_PIEUP_CIEUC                           0x1127
#define unicode_HANGUL_CHOSEONG_PIEUP_CHIEUCH                         0x1128
#define unicode_HANGUL_CHOSEONG_PIEUP_THIEUTH                         0x1129
#define unicode_HANGUL_CHOSEONG_PIEUP_PHIEUPH                         0x112A
#define unicode_HANGUL_CHOSEONG_KAPYEOUNPIEUP                         0x112B
#define unicode_HANGUL_CHOSEONG_KAPYEOUNSSANGPIEUP                    0x112C
#define unicode_HANGUL_CHOSEONG_SIOS_KIYEOK                           0x112D
#define unicode_HANGUL_CHOSEONG_SIOS_NIEUN                            0x112E
#define unicode_HANGUL_CHOSEONG_SIOS_TIKEUT                           0x112F
#define unicode_HANGUL_CHOSEONG_SIOS_RIEUL                            0x1130
#define unicode_HANGUL_CHOSEONG_SIOS_MIEUM                            0x1131
#define unicode_HANGUL_CHOSEONG_SIOS_PIEUP                            0x1132
#define unicode_HANGUL_CHOSEONG_SIOS_PIEUP_KIYEOK                     0x1133
#define unicode_HANGUL_CHOSEONG_SIOS_SSANGSIOS                        0x1134
#define unicode_HANGUL_CHOSEONG_SIOS_IEUNG                            0x1135
#define unicode_HANGUL_CHOSEONG_SIOS_CIEUC                            0x1136
#define unicode_HANGUL_CHOSEONG_SIOS_CHIEUCH                          0x1137
#define unicode_HANGUL_CHOSEONG_SIOS_KHIEUKH                          0x1138
#define unicode_HANGUL_CHOSEONG_SIOS_THIEUTH                          0x1139
#define unicode_HANGUL_CHOSEONG_SIOS_PHIEUPH                          0x113A
#define unicode_HANGUL_CHOSEONG_SIOS_HIEUH                            0x113B
#define unicode_HANGUL_CHOSEONG_CHITUEUMSIOS                          0x113C
#define unicode_HANGUL_CHOSEONG_CHITUEUMSSANGSIOS                     0x113D
#define unicode_HANGUL_CHOSEONG_CEONGCHIEUMSIOS                       0x113E
#define unicode_HANGUL_CHOSEONG_CEONGCHIEUMSSANGSIOS                  0x113F
#define unicode_HANGUL_CHOSEONG_PANSIOS                               0x1140
#define unicode_HANGUL_CHOSEONG_IEUNG_KIYEOK                          0x1141
#define unicode_HANGUL_CHOSEONG_IEUNG_TIKEUT                          0x1142
#define unicode_HANGUL_CHOSEONG_IEUNG_MIEUM                           0x1143
#define unicode_HANGUL_CHOSEONG_IEUNG_PIEUP                           0x1144
#define unicode_HANGUL_CHOSEONG_IEUNG_SIOS                            0x1145
#define unicode_HANGUL_CHOSEONG_IEUNG_PANSIOS                         0x1146
#define unicode_HANGUL_CHOSEONG_SSANGIEUNG                            0x1147
#define unicode_HANGUL_CHOSEONG_IEUNG_CIEUC                           0x1148
#define unicode_HANGUL_CHOSEONG_IEUNG_CHIEUCH                         0x1149
#define unicode_HANGUL_CHOSEONG_IEUNG_THIEUTH                         0x114A
#define unicode_HANGUL_CHOSEONG_IEUNG_PHIEUPH                         0x114B
#define unicode_HANGUL_CHOSEONG_YESIEUNG                              0x114C
#define unicode_HANGUL_CHOSEONG_CIEUC_IEUNG                           0x114D
#define unicode_HANGUL_CHOSEONG_CHITUEUMCIEUC                         0x114E
#define unicode_HANGUL_CHOSEONG_CHITUEUMSSANGCIEUC                    0x114F
#define unicode_HANGUL_CHOSEONG_CEONGCHIEUMCIEUC                      0x1150
#define unicode_HANGUL_CHOSEONG_CEONGCHIEUMSSANGCIEUC                 0x1151
#define unicode_HANGUL_CHOSEONG_CHIEUCH_KHIEUKH                       0x1152
#define unicode_HANGUL_CHOSEONG_CHIEUCH_HIEUH                         0x1153
#define unicode_HANGUL_CHOSEONG_CHITUEUMCHIEUCH                       0x1154
#define unicode_HANGUL_CHOSEONG_CEONGCHIEUMCHIEUCH                    0x1155
#define unicode_HANGUL_CHOSEONG_PHIEUPH_PIEUP                         0x1156
#define unicode_HANGUL_CHOSEONG_KAPYEOUNPHIEUPH                       0x1157
#define unicode_HANGUL_CHOSEONG_SSANGHIEUH                            0x1158
#define unicode_HANGUL_CHOSEONG_YEORINHIEUH                           0x1159
#define unicode_HANGUL_CHOSEONG_KIYEOK_TIKEUT                         0x115A
#define unicode_HANGUL_CHOSEONG_NIEUN_SIOS                            0x115B
#define unicode_HANGUL_CHOSEONG_NIEUN_CIEUC                           0x115C
#define unicode_HANGUL_CHOSEONG_NIEUN_HIEUH                           0x115D
#define unicode_HANGUL_CHOSEONG_TIKEUT_RIEUL                          0x115E
#define unicode_HANGUL_CHOSEONG_FILLER                                0x115F
#define unicode_HANGUL_JUNGSEONG_FILLER                               0x1160
#define unicode_HANGUL_JUNGSEONG_A                                    0x1161
#define unicode_HANGUL_JUNGSEONG_AE                                   0x1162
#define unicode_HANGUL_JUNGSEONG_YA                                   0x1163
#define unicode_HANGUL_JUNGSEONG_YAE                                  0x1164
#define unicode_HANGUL_JUNGSEONG_EO                                   0x1165
#define unicode_HANGUL_JUNGSEONG_E                                    0x1166
#define unicode_HANGUL_JUNGSEONG_YEO                                  0x1167
#define unicode_HANGUL_JUNGSEONG_YE                                   0x1168
#define unicode_HANGUL_JUNGSEONG_O                                    0x1169
#define unicode_HANGUL_JUNGSEONG_WA                                   0x116A
#define unicode_HANGUL_JUNGSEONG_WAE                                  0x116B
#define unicode_HANGUL_JUNGSEONG_OE                                   0x116C
#define unicode_HANGUL_JUNGSEONG_YO                                   0x116D
#define unicode_HANGUL_JUNGSEONG_U                                    0x116E
#define unicode_HANGUL_JUNGSEONG_WEO                                  0x116F
#define unicode_HANGUL_JUNGSEONG_WE                                   0x1170
#define unicode_HANGUL_JUNGSEONG_WI                                   0x1171
#define unicode_HANGUL_JUNGSEONG_YU                                   0x1172
#define unicode_HANGUL_JUNGSEONG_EU                                   0x1173
#define unicode_HANGUL_JUNGSEONG_YI                                   0x1174
#define unicode_HANGUL_JUNGSEONG_I                                    0x1175
#define unicode_HANGUL_JUNGSEONG_A_O                                  0x1176
#define unicode_HANGUL_JUNGSEONG_A_U                                  0x1177
#define unicode_HANGUL_JUNGSEONG_YA_O                                 0x1178
#define unicode_HANGUL_JUNGSEONG_YA_YO                                0x1179
#define unicode_HANGUL_JUNGSEONG_EO_O                                 0x117A
#define unicode_HANGUL_JUNGSEONG_EO_U                                 0x117B
#define unicode_HANGUL_JUNGSEONG_EO_EU                                0x117C
#define unicode_HANGUL_JUNGSEONG_YEO_O                                0x117D
#define unicode_HANGUL_JUNGSEONG_YEO_U                                0x117E
#define unicode_HANGUL_JUNGSEONG_O_EO                                 0x117F
#define unicode_HANGUL_JUNGSEONG_O_E                                  0x1180
#define unicode_HANGUL_JUNGSEONG_O_YE                                 0x1181
#define unicode_HANGUL_JUNGSEONG_O_O                                  0x1182
#define unicode_HANGUL_JUNGSEONG_O_U                                  0x1183
#define unicode_HANGUL_JUNGSEONG_YO_YA                                0x1184
#define unicode_HANGUL_JUNGSEONG_YO_YAE                               0x1185
#define unicode_HANGUL_JUNGSEONG_YO_YEO                               0x1186
#define unicode_HANGUL_JUNGSEONG_YO_O                                 0x1187
#define unicode_HANGUL_JUNGSEONG_YO_I                                 0x1188
#define unicode_HANGUL_JUNGSEONG_U_A                                  0x1189
#define unicode_HANGUL_JUNGSEONG_U_AE                                 0x118A
#define unicode_HANGUL_JUNGSEONG_U_EO_EU                              0x118B
#define unicode_HANGUL_JUNGSEONG_U_YE                                 0x118C
#define unicode_HANGUL_JUNGSEONG_U_U                                  0x118D
#define unicode_HANGUL_JUNGSEONG_YU_A                                 0x118E
#define unicode_HANGUL_JUNGSEONG_YU_EO                                0x118F
#define unicode_HANGUL_JUNGSEONG_YU_E                                 0x1190
#define unicode_HANGUL_JUNGSEONG_YU_YEO                               0x1191
#define unicode_HANGUL_JUNGSEONG_YU_YE                                0x1192
#define unicode_HANGUL_JUNGSEONG_YU_U                                 0x1193
#define unicode_HANGUL_JUNGSEONG_YU_I                                 0x1194
#define unicode_HANGUL_JUNGSEONG_EU_U                                 0x1195
#define unicode_HANGUL_JUNGSEONG_EU_EU                                0x1196
#define unicode_HANGUL_JUNGSEONG_YI_U                                 0x1197
#define unicode_HANGUL_JUNGSEONG_I_A                                  0x1198
#define unicode_HANGUL_JUNGSEONG_I_YA                                 0x1199
#define unicode_HANGUL_JUNGSEONG_I_O                                  0x119A
#define unicode_HANGUL_JUNGSEONG_I_U                                  0x119B
#define unicode_HANGUL_JUNGSEONG_I_EU                                 0x119C
#define unicode_HANGUL_JUNGSEONG_I_ARAEA                              0x119D
#define unicode_HANGUL_JUNGSEONG_ARAEA                                0x119E
#define unicode_HANGUL_JUNGSEONG_ARAEA_EO                             0x119F
#define unicode_HANGUL_JUNGSEONG_ARAEA_U                              0x11A0
#define unicode_HANGUL_JUNGSEONG_ARAEA_I                              0x11A1
#define unicode_HANGUL_JUNGSEONG_SSANGARAEA                           0x11A2
#define unicode_HANGUL_JUNGSEONG_A_EU                                 0x11A3
#define unicode_HANGUL_JUNGSEONG_YA_U                                 0x11A4
#define unicode_HANGUL_JUNGSEONG_YEO_YA                               0x11A5
#define unicode_HANGUL_JUNGSEONG_O_YA                                 0x11A6
#define unicode_HANGUL_JUNGSEONG_O_YAE                                0x11A7
#define unicode_HANGUL_JONGSEONG_KIYEOK                               0x11A8
#define unicode_HANGUL_JONGSEONG_SSANGKIYEOK                          0x11A9
#define unicode_HANGUL_JONGSEONG_KIYEOK_SIOS                          0x11AA
#define unicode_HANGUL_JONGSEONG_NIEUN                                0x11AB
#define unicode_HANGUL_JONGSEONG_NIEUN_CIEUC                          0x11AC
#define unicode_HANGUL_JONGSEONG_NIEUN_HIEUH                          0x11AD
#define unicode_HANGUL_JONGSEONG_TIKEUT                               0x11AE
#define unicode_HANGUL_JONGSEONG_RIEUL                                0x11AF
#define unicode_HANGUL_JONGSEONG_RIEUL_KIYEOK                         0x11B0
#define unicode_HANGUL_JONGSEONG_RIEUL_MIEUM                          0x11B1
#define unicode_HANGUL_JONGSEONG_RIEUL_PIEUP                          0x11B2
#define unicode_HANGUL_JONGSEONG_RIEUL_SIOS                           0x11B3
#define unicode_HANGUL_JONGSEONG_RIEUL_THIEUTH                        0x11B4
#define unicode_HANGUL_JONGSEONG_RIEUL_PHIEUPH                        0x11B5
#define unicode_HANGUL_JONGSEONG_RIEUL_HIEUH                          0x11B6
#define unicode_HANGUL_JONGSEONG_MIEUM                                0x11B7
#define unicode_HANGUL_JONGSEONG_PIEUP                                0x11B8
#define unicode_HANGUL_JONGSEONG_PIEUP_SIOS                           0x11B9
#define unicode_HANGUL_JONGSEONG_SIOS                                 0x11BA
#define unicode_HANGUL_JONGSEONG_SSANGSIOS                            0x11BB
#define unicode_HANGUL_JONGSEONG_IEUNG                                0x11BC
#define unicode_HANGUL_JONGSEONG_CIEUC                                0x11BD
#define unicode_HANGUL_JONGSEONG_CHIEUCH                              0x11BE
#define unicode_HANGUL_JONGSEONG_KHIEUKH                              0x11BF
#define unicode_HANGUL_JONGSEONG_THIEUTH                              0x11C0
#define unicode_HANGUL_JONGSEONG_PHIEUPH                              0x11C1
#define unicode_HANGUL_JONGSEONG_HIEUH                                0x11C2
#define unicode_HANGUL_JONGSEONG_KIYEOK_RIEUL                         0x11C3
#define unicode_HANGUL_JONGSEONG_KIYEOK_SIOS_KIYEOK                   0x11C4
#define unicode_HANGUL_JONGSEONG_NIEUN_KIYEOK                         0x11C5
#define unicode_HANGUL_JONGSEONG_NIEUN_TIKEUT                         0x11C6
#define unicode_HANGUL_JONGSEONG_NIEUN_SIOS                           0x11C7
#define unicode_HANGUL_JONGSEONG_NIEUN_PANSIOS                        0x11C8
#define unicode_HANGUL_JONGSEONG_NIEUN_THIEUTH                        0x11C9
#define unicode_HANGUL_JONGSEONG_TIKEUT_KIYEOK                        0x11CA
#define unicode_HANGUL_JONGSEONG_TIKEUT_RIEUL                         0x11CB
#define unicode_HANGUL_JONGSEONG_RIEUL_KIYEOK_SIOS                    0x11CC
#define unicode_HANGUL_JONGSEONG_RIEUL_NIEUN                          0x11CD
#define unicode_HANGUL_JONGSEONG_RIEUL_TIKEUT                         0x11CE
#define unicode_HANGUL_JONGSEONG_RIEUL_TIKEUT_HIEUH                   0x11CF
#define unicode_HANGUL_JONGSEONG_SSANGRIEUL                           0x11D0
#define unicode_HANGUL_JONGSEONG_RIEUL_MIEUM_KIYEOK                   0x11D1
#define unicode_HANGUL_JONGSEONG_RIEUL_MIEUM_SIOS                     0x11D2
#define unicode_HANGUL_JONGSEONG_RIEUL_PIEUP_SIOS                     0x11D3
#define unicode_HANGUL_JONGSEONG_RIEUL_PIEUP_HIEUH                    0x11D4
#define unicode_HANGUL_JONGSEONG_RIEUL_KAPYEOUNPIEUP                  0x11D5
#define unicode_HANGUL_JONGSEONG_RIEUL_SSANGSIOS                      0x11D6
#define unicode_HANGUL_JONGSEONG_RIEUL_PANSIOS                        0x11D7
#define unicode_HANGUL_JONGSEONG_RIEUL_KHIEUKH                        0x11D8
#define unicode_HANGUL_JONGSEONG_RIEUL_YEORINHIEUH                    0x11D9
#define unicode_HANGUL_JONGSEONG_MIEUM_KIYEOK                         0x11DA
#define unicode_HANGUL_JONGSEONG_MIEUM_RIEUL                          0x11DB
#define unicode_HANGUL_JONGSEONG_MIEUM_PIEUP                          0x11DC
#define unicode_HANGUL_JONGSEONG_MIEUM_SIOS                           0x11DD
#define unicode_HANGUL_JONGSEONG_MIEUM_SSANGSIOS                      0x11DE
#define unicode_HANGUL_JONGSEONG_MIEUM_PANSIOS                        0x11DF
#define unicode_HANGUL_JONGSEONG_MIEUM_CHIEUCH                        0x11E0
#define unicode_HANGUL_JONGSEONG_MIEUM_HIEUH                          0x11E1
#define unicode_HANGUL_JONGSEONG_KAPYEOUNMIEUM                        0x11E2
#define unicode_HANGUL_JONGSEONG_PIEUP_RIEUL                          0x11E3
#define unicode_HANGUL_JONGSEONG_PIEUP_PHIEUPH                        0x11E4
#define unicode_HANGUL_JONGSEONG_PIEUP_HIEUH                          0x11E5
#define unicode_HANGUL_JONGSEONG_KAPYEOUNPIEUP                        0x11E6
#define unicode_HANGUL_JONGSEONG_SIOS_KIYEOK                          0x11E7
#define unicode_HANGUL_JONGSEONG_SIOS_TIKEUT                          0x11E8
#define unicode_HANGUL_JONGSEONG_SIOS_RIEUL                           0x11E9
#define unicode_HANGUL_JONGSEONG_SIOS_PIEUP                           0x11EA
#define unicode_HANGUL_JONGSEONG_PANSIOS                              0x11EB
#define unicode_HANGUL_JONGSEONG_IEUNG_KIYEOK                         0x11EC
#define unicode_HANGUL_JONGSEONG_IEUNG_SSANGKIYEOK                    0x11ED
#define unicode_HANGUL_JONGSEONG_SSANGIEUNG                           0x11EE
#define unicode_HANGUL_JONGSEONG_IEUNG_KHIEUKH                        0x11EF
#define unicode_HANGUL_JONGSEONG_YESIEUNG                             0x11F0
#define unicode_HANGUL_JONGSEONG_YESIEUNG_SIOS                        0x11F1
#define unicode_HANGUL_JONGSEONG_YESIEUNG_PANSIOS                     0x11F2
#define unicode_HANGUL_JONGSEONG_PHIEUPH_PIEUP                        0x11F3
#define unicode_HANGUL_JONGSEONG_KAPYEOUNPHIEUPH                      0x11F4
#define unicode_HANGUL_JONGSEONG_HIEUH_NIEUN                          0x11F5
#define unicode_HANGUL_JONGSEONG_HIEUH_RIEUL                          0x11F6
#define unicode_HANGUL_JONGSEONG_HIEUH_MIEUM                          0x11F7
#define unicode_HANGUL_JONGSEONG_HIEUH_PIEUP                          0x11F8
#define unicode_HANGUL_JONGSEONG_YEORINHIEUH                          0x11F9
#define unicode_HANGUL_JONGSEONG_KIYEOK_NIEUN                         0x11FA
#define unicode_HANGUL_JONGSEONG_KIYEOK_PIEUP                         0x11FB
#define unicode_HANGUL_JONGSEONG_KIYEOK_CHIEUCH                       0x11FC
#define unicode_HANGUL_JONGSEONG_KIYEOK_KHIEUKH                       0x11FD
#define unicode_HANGUL_JONGSEONG_KIYEOK_HIEUH                         0x11FE
#define unicode_HANGUL_JONGSEONG_SSANGNIEUN                           0x11FF
#define unicode_ETHIOPIC_SYLLABLE_HA                                  0x1200
#define unicode_ETHIOPIC_SYLLABLE_HU                                  0x1201
#define unicode_ETHIOPIC_SYLLABLE_HI                                  0x1202
#define unicode_ETHIOPIC_SYLLABLE_HAA                                 0x1203
#define unicode_ETHIOPIC_SYLLABLE_HEE                                 0x1204
#define unicode_ETHIOPIC_SYLLABLE_HE                                  0x1205
#define unicode_ETHIOPIC_SYLLABLE_HO                                  0x1206
#define unicode_ETHIOPIC_SYLLABLE_HOA                                 0x1207
#define unicode_ETHIOPIC_SYLLABLE_LA                                  0x1208
#define unicode_ETHIOPIC_SYLLABLE_LU                                  0x1209
#define unicode_ETHIOPIC_SYLLABLE_LI                                  0x120A
#define unicode_ETHIOPIC_SYLLABLE_LAA                                 0x120B
#define unicode_ETHIOPIC_SYLLABLE_LEE                                 0x120C
#define unicode_ETHIOPIC_SYLLABLE_LE                                  0x120D
#define unicode_ETHIOPIC_SYLLABLE_LO                                  0x120E
#define unicode_ETHIOPIC_SYLLABLE_LWA                                 0x120F
#define unicode_ETHIOPIC_SYLLABLE_HHA                                 0x1210
#define unicode_ETHIOPIC_SYLLABLE_HHU                                 0x1211
#define unicode_ETHIOPIC_SYLLABLE_HHI                                 0x1212
#define unicode_ETHIOPIC_SYLLABLE_HHAA                                0x1213
#define unicode_ETHIOPIC_SYLLABLE_HHEE                                0x1214
#define unicode_ETHIOPIC_SYLLABLE_HHE                                 0x1215
#define unicode_ETHIOPIC_SYLLABLE_HHO                                 0x1216
#define unicode_ETHIOPIC_SYLLABLE_HHWA                                0x1217
#define unicode_ETHIOPIC_SYLLABLE_MA                                  0x1218
#define unicode_ETHIOPIC_SYLLABLE_MU                                  0x1219
#define unicode_ETHIOPIC_SYLLABLE_MI                                  0x121A
#define unicode_ETHIOPIC_SYLLABLE_MAA                                 0x121B
#define unicode_ETHIOPIC_SYLLABLE_MEE                                 0x121C
#define unicode_ETHIOPIC_SYLLABLE_ME                                  0x121D
#define unicode_ETHIOPIC_SYLLABLE_MO                                  0x121E
#define unicode_ETHIOPIC_SYLLABLE_MWA                                 0x121F
#define unicode_ETHIOPIC_SYLLABLE_SZA                                 0x1220
#define unicode_ETHIOPIC_SYLLABLE_SZU                                 0x1221
#define unicode_ETHIOPIC_SYLLABLE_SZI                                 0x1222
#define unicode_ETHIOPIC_SYLLABLE_SZAA                                0x1223
#define unicode_ETHIOPIC_SYLLABLE_SZEE                                0x1224
#define unicode_ETHIOPIC_SYLLABLE_SZE                                 0x1225
#define unicode_ETHIOPIC_SYLLABLE_SZO                                 0x1226
#define unicode_ETHIOPIC_SYLLABLE_SZWA                                0x1227
#define unicode_ETHIOPIC_SYLLABLE_RA                                  0x1228
#define unicode_ETHIOPIC_SYLLABLE_RU                                  0x1229
#define unicode_ETHIOPIC_SYLLABLE_RI                                  0x122A
#define unicode_ETHIOPIC_SYLLABLE_RAA                                 0x122B
#define unicode_ETHIOPIC_SYLLABLE_REE                                 0x122C
#define unicode_ETHIOPIC_SYLLABLE_RE                                  0x122D
#define unicode_ETHIOPIC_SYLLABLE_RO                                  0x122E
#define unicode_ETHIOPIC_SYLLABLE_RWA                                 0x122F
#define unicode_ETHIOPIC_SYLLABLE_SA                                  0x1230
#define unicode_ETHIOPIC_SYLLABLE_SU                                  0x1231
#define unicode_ETHIOPIC_SYLLABLE_SI                                  0x1232
#define unicode_ETHIOPIC_SYLLABLE_SAA                                 0x1233
#define unicode_ETHIOPIC_SYLLABLE_SEE                                 0x1234
#define unicode_ETHIOPIC_SYLLABLE_SE                                  0x1235
#define unicode_ETHIOPIC_SYLLABLE_SO                                  0x1236
#define unicode_ETHIOPIC_SYLLABLE_SWA                                 0x1237
#define unicode_ETHIOPIC_SYLLABLE_SHA                                 0x1238
#define unicode_ETHIOPIC_SYLLABLE_SHU                                 0x1239
#define unicode_ETHIOPIC_SYLLABLE_SHI                                 0x123A
#define unicode_ETHIOPIC_SYLLABLE_SHAA                                0x123B
#define unicode_ETHIOPIC_SYLLABLE_SHEE                                0x123C
#define unicode_ETHIOPIC_SYLLABLE_SHE                                 0x123D
#define unicode_ETHIOPIC_SYLLABLE_SHO                                 0x123E
#define unicode_ETHIOPIC_SYLLABLE_SHWA                                0x123F
#define unicode_ETHIOPIC_SYLLABLE_QA                                  0x1240
#define unicode_ETHIOPIC_SYLLABLE_QU                                  0x1241
#define unicode_ETHIOPIC_SYLLABLE_QI                                  0x1242
#define unicode_ETHIOPIC_SYLLABLE_QAA                                 0x1243
#define unicode_ETHIOPIC_SYLLABLE_QEE                                 0x1244
#define unicode_ETHIOPIC_SYLLABLE_QE                                  0x1245
#define unicode_ETHIOPIC_SYLLABLE_QO                                  0x1246
#define unicode_ETHIOPIC_SYLLABLE_QOA                                 0x1247
#define unicode_ETHIOPIC_SYLLABLE_QWA                                 0x1248
#define unicode_ETHIOPIC_SYLLABLE_QWI                                 0x124A
#define unicode_ETHIOPIC_SYLLABLE_QWAA                                0x124B
#define unicode_ETHIOPIC_SYLLABLE_QWEE                                0x124C
#define unicode_ETHIOPIC_SYLLABLE_QWE                                 0x124D
#define unicode_ETHIOPIC_SYLLABLE_QHA                                 0x1250
#define unicode_ETHIOPIC_SYLLABLE_QHU                                 0x1251
#define unicode_ETHIOPIC_SYLLABLE_QHI                                 0x1252
#define unicode_ETHIOPIC_SYLLABLE_QHAA                                0x1253
#define unicode_ETHIOPIC_SYLLABLE_QHEE                                0x1254
#define unicode_ETHIOPIC_SYLLABLE_QHE                                 0x1255
#define unicode_ETHIOPIC_SYLLABLE_QHO                                 0x1256
#define unicode_ETHIOPIC_SYLLABLE_QHWA                                0x1258
#define unicode_ETHIOPIC_SYLLABLE_QHWI                                0x125A
#define unicode_ETHIOPIC_SYLLABLE_QHWAA                               0x125B
#define unicode_ETHIOPIC_SYLLABLE_QHWEE                               0x125C
#define unicode_ETHIOPIC_SYLLABLE_QHWE                                0x125D
#define unicode_ETHIOPIC_SYLLABLE_BA                                  0x1260
#define unicode_ETHIOPIC_SYLLABLE_BU                                  0x1261
#define unicode_ETHIOPIC_SYLLABLE_BI                                  0x1262
#define unicode_ETHIOPIC_SYLLABLE_BAA                                 0x1263
#define unicode_ETHIOPIC_SYLLABLE_BEE                                 0x1264
#define unicode_ETHIOPIC_SYLLABLE_BE                                  0x1265
#define unicode_ETHIOPIC_SYLLABLE_BO                                  0x1266
#define unicode_ETHIOPIC_SYLLABLE_BWA                                 0x1267
#define unicode_ETHIOPIC_SYLLABLE_VA                                  0x1268
#define unicode_ETHIOPIC_SYLLABLE_VU                                  0x1269
#define unicode_ETHIOPIC_SYLLABLE_VI                                  0x126A
#define unicode_ETHIOPIC_SYLLABLE_VAA                                 0x126B
#define unicode_ETHIOPIC_SYLLABLE_VEE                                 0x126C
#define unicode_ETHIOPIC_SYLLABLE_VE                                  0x126D
#define unicode_ETHIOPIC_SYLLABLE_VO                                  0x126E
#define unicode_ETHIOPIC_SYLLABLE_VWA                                 0x126F
#define unicode_ETHIOPIC_SYLLABLE_TA                                  0x1270
#define unicode_ETHIOPIC_SYLLABLE_TU                                  0x1271
#define unicode_ETHIOPIC_SYLLABLE_TI                                  0x1272
#define unicode_ETHIOPIC_SYLLABLE_TAA                                 0x1273
#define unicode_ETHIOPIC_SYLLABLE_TEE                                 0x1274
#define unicode_ETHIOPIC_SYLLABLE_TE                                  0x1275
#define unicode_ETHIOPIC_SYLLABLE_TO                                  0x1276
#define unicode_ETHIOPIC_SYLLABLE_TWA                                 0x1277
#define unicode_ETHIOPIC_SYLLABLE_CA                                  0x1278
#define unicode_ETHIOPIC_SYLLABLE_CU                                  0x1279
#define unicode_ETHIOPIC_SYLLABLE_CI                                  0x127A
#define unicode_ETHIOPIC_SYLLABLE_CAA                                 0x127B
#define unicode_ETHIOPIC_SYLLABLE_CEE                                 0x127C
#define unicode_ETHIOPIC_SYLLABLE_CE                                  0x127D
#define unicode_ETHIOPIC_SYLLABLE_CO                                  0x127E
#define unicode_ETHIOPIC_SYLLABLE_CWA                                 0x127F
#define unicode_ETHIOPIC_SYLLABLE_XA                                  0x1280
#define unicode_ETHIOPIC_SYLLABLE_XU                                  0x1281
#define unicode_ETHIOPIC_SYLLABLE_XI                                  0x1282
#define unicode_ETHIOPIC_SYLLABLE_XAA                                 0x1283
#define unicode_ETHIOPIC_SYLLABLE_XEE                                 0x1284
#define unicode_ETHIOPIC_SYLLABLE_XE                                  0x1285
#define unicode_ETHIOPIC_SYLLABLE_XO                                  0x1286
#define unicode_ETHIOPIC_SYLLABLE_XOA                                 0x1287
#define unicode_ETHIOPIC_SYLLABLE_XWA                                 0x1288
#define unicode_ETHIOPIC_SYLLABLE_XWI                                 0x128A
#define unicode_ETHIOPIC_SYLLABLE_XWAA                                0x128B
#define unicode_ETHIOPIC_SYLLABLE_XWEE                                0x128C
#define unicode_ETHIOPIC_SYLLABLE_XWE                                 0x128D
#define unicode_ETHIOPIC_SYLLABLE_NA                                  0x1290
#define unicode_ETHIOPIC_SYLLABLE_NU                                  0x1291
#define unicode_ETHIOPIC_SYLLABLE_NI                                  0x1292
#define unicode_ETHIOPIC_SYLLABLE_NAA                                 0x1293
#define unicode_ETHIOPIC_SYLLABLE_NEE                                 0x1294
#define unicode_ETHIOPIC_SYLLABLE_NE                                  0x1295
#define unicode_ETHIOPIC_SYLLABLE_NO                                  0x1296
#define unicode_ETHIOPIC_SYLLABLE_NWA                                 0x1297
#define unicode_ETHIOPIC_SYLLABLE_NYA                                 0x1298
#define unicode_ETHIOPIC_SYLLABLE_NYU                                 0x1299
#define unicode_ETHIOPIC_SYLLABLE_NYI                                 0x129A
#define unicode_ETHIOPIC_SYLLABLE_NYAA                                0x129B
#define unicode_ETHIOPIC_SYLLABLE_NYEE                                0x129C
#define unicode_ETHIOPIC_SYLLABLE_NYE                                 0x129D
#define unicode_ETHIOPIC_SYLLABLE_NYO                                 0x129E
#define unicode_ETHIOPIC_SYLLABLE_NYWA                                0x129F
#define unicode_ETHIOPIC_SYLLABLE_GLOTTAL_A                           0x12A0
#define unicode_ETHIOPIC_SYLLABLE_GLOTTAL_U                           0x12A1
#define unicode_ETHIOPIC_SYLLABLE_GLOTTAL_I                           0x12A2
#define unicode_ETHIOPIC_SYLLABLE_GLOTTAL_AA                          0x12A3
#define unicode_ETHIOPIC_SYLLABLE_GLOTTAL_EE                          0x12A4
#define unicode_ETHIOPIC_SYLLABLE_GLOTTAL_E                           0x12A5
#define unicode_ETHIOPIC_SYLLABLE_GLOTTAL_O                           0x12A6
#define unicode_ETHIOPIC_SYLLABLE_GLOTTAL_WA                          0x12A7
#define unicode_ETHIOPIC_SYLLABLE_KA                                  0x12A8
#define unicode_ETHIOPIC_SYLLABLE_KU                                  0x12A9
#define unicode_ETHIOPIC_SYLLABLE_KI                                  0x12AA
#define unicode_ETHIOPIC_SYLLABLE_KAA                                 0x12AB
#define unicode_ETHIOPIC_SYLLABLE_KEE                                 0x12AC
#define unicode_ETHIOPIC_SYLLABLE_KE                                  0x12AD
#define unicode_ETHIOPIC_SYLLABLE_KO                                  0x12AE
#define unicode_ETHIOPIC_SYLLABLE_KOA                                 0x12AF
#define unicode_ETHIOPIC_SYLLABLE_KWA                                 0x12B0
#define unicode_ETHIOPIC_SYLLABLE_KWI                                 0x12B2
#define unicode_ETHIOPIC_SYLLABLE_KWAA                                0x12B3
#define unicode_ETHIOPIC_SYLLABLE_KWEE                                0x12B4
#define unicode_ETHIOPIC_SYLLABLE_KWE                                 0x12B5
#define unicode_ETHIOPIC_SYLLABLE_KXA                                 0x12B8
#define unicode_ETHIOPIC_SYLLABLE_KXU                                 0x12B9
#define unicode_ETHIOPIC_SYLLABLE_KXI                                 0x12BA
#define unicode_ETHIOPIC_SYLLABLE_KXAA                                0x12BB
#define unicode_ETHIOPIC_SYLLABLE_KXEE                                0x12BC
#define unicode_ETHIOPIC_SYLLABLE_KXE                                 0x12BD
#define unicode_ETHIOPIC_SYLLABLE_KXO                                 0x12BE
#define unicode_ETHIOPIC_SYLLABLE_KXWA                                0x12C0
#define unicode_ETHIOPIC_SYLLABLE_KXWI                                0x12C2
#define unicode_ETHIOPIC_SYLLABLE_KXWAA                               0x12C3
#define unicode_ETHIOPIC_SYLLABLE_KXWEE                               0x12C4
#define unicode_ETHIOPIC_SYLLABLE_KXWE                                0x12C5
#define unicode_ETHIOPIC_SYLLABLE_WA                                  0x12C8
#define unicode_ETHIOPIC_SYLLABLE_WU                                  0x12C9
#define unicode_ETHIOPIC_SYLLABLE_WI                                  0x12CA
#define unicode_ETHIOPIC_SYLLABLE_WAA                                 0x12CB
#define unicode_ETHIOPIC_SYLLABLE_WEE                                 0x12CC
#define unicode_ETHIOPIC_SYLLABLE_WE                                  0x12CD
#define unicode_ETHIOPIC_SYLLABLE_WO                                  0x12CE
#define unicode_ETHIOPIC_SYLLABLE_WOA                                 0x12CF
#define unicode_ETHIOPIC_SYLLABLE_PHARYNGEAL_A                        0x12D0
#define unicode_ETHIOPIC_SYLLABLE_PHARYNGEAL_U                        0x12D1
#define unicode_ETHIOPIC_SYLLABLE_PHARYNGEAL_I                        0x12D2
#define unicode_ETHIOPIC_SYLLABLE_PHARYNGEAL_AA                       0x12D3
#define unicode_ETHIOPIC_SYLLABLE_PHARYNGEAL_EE                       0x12D4
#define unicode_ETHIOPIC_SYLLABLE_PHARYNGEAL_E                        0x12D5
#define unicode_ETHIOPIC_SYLLABLE_PHARYNGEAL_O                        0x12D6
#define unicode_ETHIOPIC_SYLLABLE_ZA                                  0x12D8
#define unicode_ETHIOPIC_SYLLABLE_ZU                                  0x12D9
#define unicode_ETHIOPIC_SYLLABLE_ZI                                  0x12DA
#define unicode_ETHIOPIC_SYLLABLE_ZAA                                 0x12DB
#define unicode_ETHIOPIC_SYLLABLE_ZEE                                 0x12DC
#define unicode_ETHIOPIC_SYLLABLE_ZE                                  0x12DD
#define unicode_ETHIOPIC_SYLLABLE_ZO                                  0x12DE
#define unicode_ETHIOPIC_SYLLABLE_ZWA                                 0x12DF
#define unicode_ETHIOPIC_SYLLABLE_ZHA                                 0x12E0
#define unicode_ETHIOPIC_SYLLABLE_ZHU                                 0x12E1
#define unicode_ETHIOPIC_SYLLABLE_ZHI                                 0x12E2
#define unicode_ETHIOPIC_SYLLABLE_ZHAA                                0x12E3
#define unicode_ETHIOPIC_SYLLABLE_ZHEE                                0x12E4
#define unicode_ETHIOPIC_SYLLABLE_ZHE                                 0x12E5
#define unicode_ETHIOPIC_SYLLABLE_ZHO                                 0x12E6
#define unicode_ETHIOPIC_SYLLABLE_ZHWA                                0x12E7
#define unicode_ETHIOPIC_SYLLABLE_YA                                  0x12E8
#define unicode_ETHIOPIC_SYLLABLE_YU                                  0x12E9
#define unicode_ETHIOPIC_SYLLABLE_YI                                  0x12EA
#define unicode_ETHIOPIC_SYLLABLE_YAA                                 0x12EB
#define unicode_ETHIOPIC_SYLLABLE_YEE                                 0x12EC
#define unicode_ETHIOPIC_SYLLABLE_YE                                  0x12ED
#define unicode_ETHIOPIC_SYLLABLE_YO                                  0x12EE
#define unicode_ETHIOPIC_SYLLABLE_YOA                                 0x12EF
#define unicode_ETHIOPIC_SYLLABLE_DA                                  0x12F0
#define unicode_ETHIOPIC_SYLLABLE_DU                                  0x12F1
#define unicode_ETHIOPIC_SYLLABLE_DI                                  0x12F2
#define unicode_ETHIOPIC_SYLLABLE_DAA                                 0x12F3
#define unicode_ETHIOPIC_SYLLABLE_DEE                                 0x12F4
#define unicode_ETHIOPIC_SYLLABLE_DE                                  0x12F5
#define unicode_ETHIOPIC_SYLLABLE_DO                                  0x12F6
#define unicode_ETHIOPIC_SYLLABLE_DWA                                 0x12F7
#define unicode_ETHIOPIC_SYLLABLE_DDA                                 0x12F8
#define unicode_ETHIOPIC_SYLLABLE_DDU                                 0x12F9
#define unicode_ETHIOPIC_SYLLABLE_DDI                                 0x12FA
#define unicode_ETHIOPIC_SYLLABLE_DDAA                                0x12FB
#define unicode_ETHIOPIC_SYLLABLE_DDEE                                0x12FC
#define unicode_ETHIOPIC_SYLLABLE_DDE                                 0x12FD
#define unicode_ETHIOPIC_SYLLABLE_DDO                                 0x12FE
#define unicode_ETHIOPIC_SYLLABLE_DDWA                                0x12FF
#define unicode_ETHIOPIC_SYLLABLE_JA                                  0x1300
#define unicode_ETHIOPIC_SYLLABLE_JU                                  0x1301
#define unicode_ETHIOPIC_SYLLABLE_JI                                  0x1302
#define unicode_ETHIOPIC_SYLLABLE_JAA                                 0x1303
#define unicode_ETHIOPIC_SYLLABLE_JEE                                 0x1304
#define unicode_ETHIOPIC_SYLLABLE_JE                                  0x1305
#define unicode_ETHIOPIC_SYLLABLE_JO                                  0x1306
#define unicode_ETHIOPIC_SYLLABLE_JWA                                 0x1307
#define unicode_ETHIOPIC_SYLLABLE_GA                                  0x1308
#define unicode_ETHIOPIC_SYLLABLE_GU                                  0x1309
#define unicode_ETHIOPIC_SYLLABLE_GI                                  0x130A
#define unicode_ETHIOPIC_SYLLABLE_GAA                                 0x130B
#define unicode_ETHIOPIC_SYLLABLE_GEE                                 0x130C
#define unicode_ETHIOPIC_SYLLABLE_GE                                  0x130D
#define unicode_ETHIOPIC_SYLLABLE_GO                                  0x130E
#define unicode_ETHIOPIC_SYLLABLE_GOA                                 0x130F
#define unicode_ETHIOPIC_SYLLABLE_GWA                                 0x1310
#define unicode_ETHIOPIC_SYLLABLE_GWI                                 0x1312
#define unicode_ETHIOPIC_SYLLABLE_GWAA                                0x1313
#define unicode_ETHIOPIC_SYLLABLE_GWEE                                0x1314
#define unicode_ETHIOPIC_SYLLABLE_GWE                                 0x1315
#define unicode_ETHIOPIC_SYLLABLE_GGA                                 0x1318
#define unicode_ETHIOPIC_SYLLABLE_GGU                                 0x1319
#define unicode_ETHIOPIC_SYLLABLE_GGI                                 0x131A
#define unicode_ETHIOPIC_SYLLABLE_GGAA                                0x131B
#define unicode_ETHIOPIC_SYLLABLE_GGEE                                0x131C
#define unicode_ETHIOPIC_SYLLABLE_GGE                                 0x131D
#define unicode_ETHIOPIC_SYLLABLE_GGO                                 0x131E
#define unicode_ETHIOPIC_SYLLABLE_GGWAA                               0x131F
#define unicode_ETHIOPIC_SYLLABLE_THA                                 0x1320
#define unicode_ETHIOPIC_SYLLABLE_THU                                 0x1321
#define unicode_ETHIOPIC_SYLLABLE_THI                                 0x1322
#define unicode_ETHIOPIC_SYLLABLE_THAA                                0x1323
#define unicode_ETHIOPIC_SYLLABLE_THEE                                0x1324
#define unicode_ETHIOPIC_SYLLABLE_THE                                 0x1325
#define unicode_ETHIOPIC_SYLLABLE_THO                                 0x1326
#define unicode_ETHIOPIC_SYLLABLE_THWA                                0x1327
#define unicode_ETHIOPIC_SYLLABLE_CHA                                 0x1328
#define unicode_ETHIOPIC_SYLLABLE_CHU                                 0x1329
#define unicode_ETHIOPIC_SYLLABLE_CHI                                 0x132A
#define unicode_ETHIOPIC_SYLLABLE_CHAA                                0x132B
#define unicode_ETHIOPIC_SYLLABLE_CHEE                                0x132C
#define unicode_ETHIOPIC_SYLLABLE_CHE                                 0x132D
#define unicode_ETHIOPIC_SYLLABLE_CHO                                 0x132E
#define unicode_ETHIOPIC_SYLLABLE_CHWA                                0x132F
#define unicode_ETHIOPIC_SYLLABLE_PHA                                 0x1330
#define unicode_ETHIOPIC_SYLLABLE_PHU                                 0x1331
#define unicode_ETHIOPIC_SYLLABLE_PHI                                 0x1332
#define unicode_ETHIOPIC_SYLLABLE_PHAA                                0x1333
#define unicode_ETHIOPIC_SYLLABLE_PHEE                                0x1334
#define unicode_ETHIOPIC_SYLLABLE_PHE                                 0x1335
#define unicode_ETHIOPIC_SYLLABLE_PHO                                 0x1336
#define unicode_ETHIOPIC_SYLLABLE_PHWA                                0x1337
#define unicode_ETHIOPIC_SYLLABLE_TSA                                 0x1338
#define unicode_ETHIOPIC_SYLLABLE_TSU                                 0x1339
#define unicode_ETHIOPIC_SYLLABLE_TSI                                 0x133A
#define unicode_ETHIOPIC_SYLLABLE_TSAA                                0x133B
#define unicode_ETHIOPIC_SYLLABLE_TSEE                                0x133C
#define unicode_ETHIOPIC_SYLLABLE_TSE                                 0x133D
#define unicode_ETHIOPIC_SYLLABLE_TSO                                 0x133E
#define unicode_ETHIOPIC_SYLLABLE_TSWA                                0x133F
#define unicode_ETHIOPIC_SYLLABLE_TZA                                 0x1340
#define unicode_ETHIOPIC_SYLLABLE_TZU                                 0x1341
#define unicode_ETHIOPIC_SYLLABLE_TZI                                 0x1342
#define unicode_ETHIOPIC_SYLLABLE_TZAA                                0x1343
#define unicode_ETHIOPIC_SYLLABLE_TZEE                                0x1344
#define unicode_ETHIOPIC_SYLLABLE_TZE                                 0x1345
#define unicode_ETHIOPIC_SYLLABLE_TZO                                 0x1346
#define unicode_ETHIOPIC_SYLLABLE_TZOA                                0x1347
#define unicode_ETHIOPIC_SYLLABLE_FA                                  0x1348
#define unicode_ETHIOPIC_SYLLABLE_FU                                  0x1349
#define unicode_ETHIOPIC_SYLLABLE_FI                                  0x134A
#define unicode_ETHIOPIC_SYLLABLE_FAA                                 0x134B
#define unicode_ETHIOPIC_SYLLABLE_FEE                                 0x134C
#define unicode_ETHIOPIC_SYLLABLE_FE                                  0x134D
#define unicode_ETHIOPIC_SYLLABLE_FO                                  0x134E
#define unicode_ETHIOPIC_SYLLABLE_FWA                                 0x134F
#define unicode_ETHIOPIC_SYLLABLE_PA                                  0x1350
#define unicode_ETHIOPIC_SYLLABLE_PU                                  0x1351
#define unicode_ETHIOPIC_SYLLABLE_PI                                  0x1352
#define unicode_ETHIOPIC_SYLLABLE_PAA                                 0x1353
#define unicode_ETHIOPIC_SYLLABLE_PEE                                 0x1354
#define unicode_ETHIOPIC_SYLLABLE_PE                                  0x1355
#define unicode_ETHIOPIC_SYLLABLE_PO                                  0x1356
#define unicode_ETHIOPIC_SYLLABLE_PWA                                 0x1357
#define unicode_ETHIOPIC_SYLLABLE_RYA                                 0x1358
#define unicode_ETHIOPIC_SYLLABLE_MYA                                 0x1359
#define unicode_ETHIOPIC_SYLLABLE_FYA                                 0x135A
#define unicode_ETHIOPIC_COMBINING_GEMINATION_AND_VOWEL_LENGTH_MARK   0x135D
#define unicode_ETHIOPIC_COMBINING_VOWEL_LENGTH_MARK                  0x135E
#define unicode_ETHIOPIC_COMBINING_GEMINATION_MARK                    0x135F
#define unicode_ETHIOPIC_SECTION_MARK                                 0x1360
#define unicode_ETHIOPIC_WORDSPACE                                    0x1361
#define unicode_ETHIOPIC_FULL_STOP                                    0x1362
#define unicode_ETHIOPIC_COMMA                                        0x1363
#define unicode_ETHIOPIC_SEMICOLON                                    0x1364
#define unicode_ETHIOPIC_COLON                                        0x1365
#define unicode_ETHIOPIC_PREFACE_COLON                                0x1366
#define unicode_ETHIOPIC_QUESTION_MARK                                0x1367
#define unicode_ETHIOPIC_PARAGRAPH_SEPARATOR                          0x1368
#define unicode_ETHIOPIC_DIGIT_ONE                                    0x1369
#define unicode_ETHIOPIC_DIGIT_TWO                                    0x136A
#define unicode_ETHIOPIC_DIGIT_THREE                                  0x136B
#define unicode_ETHIOPIC_DIGIT_FOUR                                   0x136C
#define unicode_ETHIOPIC_DIGIT_FIVE                                   0x136D
#define unicode_ETHIOPIC_DIGIT_SIX                                    0x136E
#define unicode_ETHIOPIC_DIGIT_SEVEN                                  0x136F
#define unicode_ETHIOPIC_DIGIT_EIGHT                                  0x1370
#define unicode_ETHIOPIC_DIGIT_NINE                                   0x1371
#define unicode_ETHIOPIC_NUMBER_TEN                                   0x1372
#define unicode_ETHIOPIC_NUMBER_TWENTY                                0x1373
#define unicode_ETHIOPIC_NUMBER_THIRTY                                0x1374
#define unicode_ETHIOPIC_NUMBER_FORTY                                 0x1375
#define unicode_ETHIOPIC_NUMBER_FIFTY                                 0x1376
#define unicode_ETHIOPIC_NUMBER_SIXTY                                 0x1377
#define unicode_ETHIOPIC_NUMBER_SEVENTY                               0x1378
#define unicode_ETHIOPIC_NUMBER_EIGHTY                                0x1379
#define unicode_ETHIOPIC_NUMBER_NINETY                                0x137A
#define unicode_ETHIOPIC_NUMBER_HUNDRED                               0x137B
#define unicode_ETHIOPIC_NUMBER_TEN_THOUSAND                          0x137C
#define unicode_ETHIOPIC_SYLLABLE_SEBATBEIT_MWA                       0x1380
#define unicode_ETHIOPIC_SYLLABLE_MWI                                 0x1381
#define unicode_ETHIOPIC_SYLLABLE_MWEE                                0x1382
#define unicode_ETHIOPIC_SYLLABLE_MWE                                 0x1383
#define unicode_ETHIOPIC_SYLLABLE_SEBATBEIT_BWA                       0x1384
#define unicode_ETHIOPIC_SYLLABLE_BWI                                 0x1385
#define unicode_ETHIOPIC_SYLLABLE_BWEE                                0x1386
#define unicode_ETHIOPIC_SYLLABLE_BWE                                 0x1387
#define unicode_ETHIOPIC_SYLLABLE_SEBATBEIT_FWA                       0x1388
#define unicode_ETHIOPIC_SYLLABLE_FWI                                 0x1389
#define unicode_ETHIOPIC_SYLLABLE_FWEE                                0x138A
#define unicode_ETHIOPIC_SYLLABLE_FWE                                 0x138B
#define unicode_ETHIOPIC_SYLLABLE_SEBATBEIT_PWA                       0x138C
#define unicode_ETHIOPIC_SYLLABLE_PWI                                 0x138D
#define unicode_ETHIOPIC_SYLLABLE_PWEE                                0x138E
#define unicode_ETHIOPIC_SYLLABLE_PWE                                 0x138F
#define unicode_ETHIOPIC_TONAL_MARK_YIZET                             0x1390
#define unicode_ETHIOPIC_TONAL_MARK_DERET                             0x1391
#define unicode_ETHIOPIC_TONAL_MARK_RIKRIK                            0x1392
#define unicode_ETHIOPIC_TONAL_MARK_SHORT_RIKRIK                      0x1393
#define unicode_ETHIOPIC_TONAL_MARK_DIFAT                             0x1394
#define unicode_ETHIOPIC_TONAL_MARK_KENAT                             0x1395
#define unicode_ETHIOPIC_TONAL_MARK_CHIRET                            0x1396
#define unicode_ETHIOPIC_TONAL_MARK_HIDET                             0x1397
#define unicode_ETHIOPIC_TONAL_MARK_DERET_HIDET                       0x1398
#define unicode_ETHIOPIC_TONAL_MARK_KURT                              0x1399
#define unicode_CHEROKEE_LETTER_A                                     0x13A0
#define unicode_CHEROKEE_LETTER_E                                     0x13A1
#define unicode_CHEROKEE_LETTER_I                                     0x13A2
#define unicode_CHEROKEE_LETTER_O                                     0x13A3
#define unicode_CHEROKEE_LETTER_U                                     0x13A4
#define unicode_CHEROKEE_LETTER_V                                     0x13A5
#define unicode_CHEROKEE_LETTER_GA                                    0x13A6
#define unicode_CHEROKEE_LETTER_KA                                    0x13A7
#define unicode_CHEROKEE_LETTER_GE                                    0x13A8
#define unicode_CHEROKEE_LETTER_GI                                    0x13A9
#define unicode_CHEROKEE_LETTER_GO                                    0x13AA
#define unicode_CHEROKEE_LETTER_GU                                    0x13AB
#define unicode_CHEROKEE_LETTER_GV                                    0x13AC
#define unicode_CHEROKEE_LETTER_HA                                    0x13AD
#define unicode_CHEROKEE_LETTER_HE                                    0x13AE
#define unicode_CHEROKEE_LETTER_HI                                    0x13AF
#define unicode_CHEROKEE_LETTER_HO                                    0x13B0
#define unicode_CHEROKEE_LETTER_HU                                    0x13B1
#define unicode_CHEROKEE_LETTER_HV                                    0x13B2
#define unicode_CHEROKEE_LETTER_LA                                    0x13B3
#define unicode_CHEROKEE_LETTER_LE                                    0x13B4
#define unicode_CHEROKEE_LETTER_LI                                    0x13B5
#define unicode_CHEROKEE_LETTER_LO                                    0x13B6
#define unicode_CHEROKEE_LETTER_LU                                    0x13B7
#define unicode_CHEROKEE_LETTER_LV                                    0x13B8
#define unicode_CHEROKEE_LETTER_MA                                    0x13B9
#define unicode_CHEROKEE_LETTER_ME                                    0x13BA
#define unicode_CHEROKEE_LETTER_MI                                    0x13BB
#define unicode_CHEROKEE_LETTER_MO                                    0x13BC
#define unicode_CHEROKEE_LETTER_MU                                    0x13BD
#define unicode_CHEROKEE_LETTER_NA                                    0x13BE
#define unicode_CHEROKEE_LETTER_HNA                                   0x13BF
#define unicode_CHEROKEE_LETTER_NAH                                   0x13C0
#define unicode_CHEROKEE_LETTER_NE                                    0x13C1
#define unicode_CHEROKEE_LETTER_NI                                    0x13C2
#define unicode_CHEROKEE_LETTER_NO                                    0x13C3
#define unicode_CHEROKEE_LETTER_NU                                    0x13C4
#define unicode_CHEROKEE_LETTER_NV                                    0x13C5
#define unicode_CHEROKEE_LETTER_QUA                                   0x13C6
#define unicode_CHEROKEE_LETTER_QUE                                   0x13C7
#define unicode_CHEROKEE_LETTER_QUI                                   0x13C8
#define unicode_CHEROKEE_LETTER_QUO                                   0x13C9
#define unicode_CHEROKEE_LETTER_QUU                                   0x13CA
#define unicode_CHEROKEE_LETTER_QUV                                   0x13CB
#define unicode_CHEROKEE_LETTER_SA                                    0x13CC
#define unicode_CHEROKEE_LETTER_S                                     0x13CD
#define unicode_CHEROKEE_LETTER_SE                                    0x13CE
#define unicode_CHEROKEE_LETTER_SI                                    0x13CF
#define unicode_CHEROKEE_LETTER_SO                                    0x13D0
#define unicode_CHEROKEE_LETTER_SU                                    0x13D1
#define unicode_CHEROKEE_LETTER_SV                                    0x13D2
#define unicode_CHEROKEE_LETTER_DA                                    0x13D3
#define unicode_CHEROKEE_LETTER_TA                                    0x13D4
#define unicode_CHEROKEE_LETTER_DE                                    0x13D5
#define unicode_CHEROKEE_LETTER_TE                                    0x13D6
#define unicode_CHEROKEE_LETTER_DI                                    0x13D7
#define unicode_CHEROKEE_LETTER_TI                                    0x13D8
#define unicode_CHEROKEE_LETTER_DO                                    0x13D9
#define unicode_CHEROKEE_LETTER_DU                                    0x13DA
#define unicode_CHEROKEE_LETTER_DV                                    0x13DB
#define unicode_CHEROKEE_LETTER_DLA                                   0x13DC
#define unicode_CHEROKEE_LETTER_TLA                                   0x13DD
#define unicode_CHEROKEE_LETTER_TLE                                   0x13DE
#define unicode_CHEROKEE_LETTER_TLI                                   0x13DF
#define unicode_CHEROKEE_LETTER_TLO                                   0x13E0
#define unicode_CHEROKEE_LETTER_TLU                                   0x13E1
#define unicode_CHEROKEE_LETTER_TLV                                   0x13E2
#define unicode_CHEROKEE_LETTER_TSA                                   0x13E3
#define unicode_CHEROKEE_LETTER_TSE                                   0x13E4
#define unicode_CHEROKEE_LETTER_TSI                                   0x13E5
#define unicode_CHEROKEE_LETTER_TSO                                   0x13E6
#define unicode_CHEROKEE_LETTER_TSU                                   0x13E7
#define unicode_CHEROKEE_LETTER_TSV                                   0x13E8
#define unicode_CHEROKEE_LETTER_WA                                    0x13E9
#define unicode_CHEROKEE_LETTER_WE                                    0x13EA
#define unicode_CHEROKEE_LETTER_WI                                    0x13EB
#define unicode_CHEROKEE_LETTER_WO                                    0x13EC
#define unicode_CHEROKEE_LETTER_WU                                    0x13ED
#define unicode_CHEROKEE_LETTER_WV                                    0x13EE
#define unicode_CHEROKEE_LETTER_YA                                    0x13EF
#define unicode_CHEROKEE_LETTER_YE                                    0x13F0
#define unicode_CHEROKEE_LETTER_YI                                    0x13F1
#define unicode_CHEROKEE_LETTER_YO                                    0x13F2
#define unicode_CHEROKEE_LETTER_YU                                    0x13F3
#define unicode_CHEROKEE_LETTER_YV                                    0x13F4
#define unicode_CANADIAN_SYLLABICS_HYPHEN                             0x1400
#define unicode_CANADIAN_SYLLABICS_E                                  0x1401
#define unicode_CANADIAN_SYLLABICS_AAI                                0x1402
#define unicode_CANADIAN_SYLLABICS_I                                  0x1403
#define unicode_CANADIAN_SYLLABICS_II                                 0x1404
#define unicode_CANADIAN_SYLLABICS_O                                  0x1405
#define unicode_CANADIAN_SYLLABICS_OO                                 0x1406
#define unicode_CANADIAN_SYLLABICS_Y_CREE_OO                          0x1407
#define unicode_CANADIAN_SYLLABICS_CARRIER_EE                         0x1408
#define unicode_CANADIAN_SYLLABICS_CARRIER_I                          0x1409
#define unicode_CANADIAN_SYLLABICS_A                                  0x140A
#define unicode_CANADIAN_SYLLABICS_AA                                 0x140B
#define unicode_CANADIAN_SYLLABICS_WE                                 0x140C
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_WE                       0x140D
#define unicode_CANADIAN_SYLLABICS_WI                                 0x140E
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_WI                       0x140F
#define unicode_CANADIAN_SYLLABICS_WII                                0x1410
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_WII                      0x1411
#define unicode_CANADIAN_SYLLABICS_WO                                 0x1412
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_WO                       0x1413
#define unicode_CANADIAN_SYLLABICS_WOO                                0x1414
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_WOO                      0x1415
#define unicode_CANADIAN_SYLLABICS_NASKAPI_WOO                        0x1416
#define unicode_CANADIAN_SYLLABICS_WA                                 0x1417
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_WA                       0x1418
#define unicode_CANADIAN_SYLLABICS_WAA                                0x1419
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_WAA                      0x141A
#define unicode_CANADIAN_SYLLABICS_NASKAPI_WAA                        0x141B
#define unicode_CANADIAN_SYLLABICS_AI                                 0x141C
#define unicode_CANADIAN_SYLLABICS_Y_CREE_W                           0x141D
#define unicode_CANADIAN_SYLLABICS_GLOTTAL_STOP                       0x141E
#define unicode_CANADIAN_SYLLABICS_FINAL_ACUTE                        0x141F
#define unicode_CANADIAN_SYLLABICS_FINAL_GRAVE                        0x1420
#define unicode_CANADIAN_SYLLABICS_FINAL_BOTTOM_HALF_RING             0x1421
#define unicode_CANADIAN_SYLLABICS_FINAL_TOP_HALF_RING                0x1422
#define unicode_CANADIAN_SYLLABICS_FINAL_RIGHT_HALF_RING              0x1423
#define unicode_CANADIAN_SYLLABICS_FINAL_RING                         0x1424
#define unicode_CANADIAN_SYLLABICS_FINAL_DOUBLE_ACUTE                 0x1425
#define unicode_CANADIAN_SYLLABICS_FINAL_DOUBLE_SHORT_VERTICAL_STROKES 0x1426
#define unicode_CANADIAN_SYLLABICS_FINAL_MIDDLE_DOT                   0x1427
#define unicode_CANADIAN_SYLLABICS_FINAL_SHORT_HORIZONTAL_STROKE      0x1428
#define unicode_CANADIAN_SYLLABICS_FINAL_PLUS                         0x1429
#define unicode_CANADIAN_SYLLABICS_FINAL_DOWN_TACK                    0x142A
#define unicode_CANADIAN_SYLLABICS_EN                                 0x142B
#define unicode_CANADIAN_SYLLABICS_IN                                 0x142C
#define unicode_CANADIAN_SYLLABICS_ON                                 0x142D
#define unicode_CANADIAN_SYLLABICS_AN                                 0x142E
#define unicode_CANADIAN_SYLLABICS_PE                                 0x142F
#define unicode_CANADIAN_SYLLABICS_PAAI                               0x1430
#define unicode_CANADIAN_SYLLABICS_PI                                 0x1431
#define unicode_CANADIAN_SYLLABICS_PII                                0x1432
#define unicode_CANADIAN_SYLLABICS_PO                                 0x1433
#define unicode_CANADIAN_SYLLABICS_POO                                0x1434
#define unicode_CANADIAN_SYLLABICS_Y_CREE_POO                         0x1435
#define unicode_CANADIAN_SYLLABICS_CARRIER_HEE                        0x1436
#define unicode_CANADIAN_SYLLABICS_CARRIER_HI                         0x1437
#define unicode_CANADIAN_SYLLABICS_PA                                 0x1438
#define unicode_CANADIAN_SYLLABICS_PAA                                0x1439
#define unicode_CANADIAN_SYLLABICS_PWE                                0x143A
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_PWE                      0x143B
#define unicode_CANADIAN_SYLLABICS_PWI                                0x143C
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_PWI                      0x143D
#define unicode_CANADIAN_SYLLABICS_PWII                               0x143E
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_PWII                     0x143F
#define unicode_CANADIAN_SYLLABICS_PWO                                0x1440
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_PWO                      0x1441
#define unicode_CANADIAN_SYLLABICS_PWOO                               0x1442
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_PWOO                     0x1443
#define unicode_CANADIAN_SYLLABICS_PWA                                0x1444
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_PWA                      0x1445
#define unicode_CANADIAN_SYLLABICS_PWAA                               0x1446
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_PWAA                     0x1447
#define unicode_CANADIAN_SYLLABICS_Y_CREE_PWAA                        0x1448
#define unicode_CANADIAN_SYLLABICS_P                                  0x1449
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_P                        0x144A
#define unicode_CANADIAN_SYLLABICS_CARRIER_H                          0x144B
#define unicode_CANADIAN_SYLLABICS_TE                                 0x144C
#define unicode_CANADIAN_SYLLABICS_TAAI                               0x144D
#define unicode_CANADIAN_SYLLABICS_TI                                 0x144E
#define unicode_CANADIAN_SYLLABICS_TII                                0x144F
#define unicode_CANADIAN_SYLLABICS_TO                                 0x1450
#define unicode_CANADIAN_SYLLABICS_TOO                                0x1451
#define unicode_CANADIAN_SYLLABICS_Y_CREE_TOO                         0x1452
#define unicode_CANADIAN_SYLLABICS_CARRIER_DEE                        0x1453
#define unicode_CANADIAN_SYLLABICS_CARRIER_DI                         0x1454
#define unicode_CANADIAN_SYLLABICS_TA                                 0x1455
#define unicode_CANADIAN_SYLLABICS_TAA                                0x1456
#define unicode_CANADIAN_SYLLABICS_TWE                                0x1457
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_TWE                      0x1458
#define unicode_CANADIAN_SYLLABICS_TWI                                0x1459
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_TWI                      0x145A
#define unicode_CANADIAN_SYLLABICS_TWII                               0x145B
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_TWII                     0x145C
#define unicode_CANADIAN_SYLLABICS_TWO                                0x145D
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_TWO                      0x145E
#define unicode_CANADIAN_SYLLABICS_TWOO                               0x145F
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_TWOO                     0x1460
#define unicode_CANADIAN_SYLLABICS_TWA                                0x1461
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_TWA                      0x1462
#define unicode_CANADIAN_SYLLABICS_TWAA                               0x1463
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_TWAA                     0x1464
#define unicode_CANADIAN_SYLLABICS_NASKAPI_TWAA                       0x1465
#define unicode_CANADIAN_SYLLABICS_T                                  0x1466
#define unicode_CANADIAN_SYLLABICS_TTE                                0x1467
#define unicode_CANADIAN_SYLLABICS_TTI                                0x1468
#define unicode_CANADIAN_SYLLABICS_TTO                                0x1469
#define unicode_CANADIAN_SYLLABICS_TTA                                0x146A
#define unicode_CANADIAN_SYLLABICS_KE                                 0x146B
#define unicode_CANADIAN_SYLLABICS_KAAI                               0x146C
#define unicode_CANADIAN_SYLLABICS_KI                                 0x146D
#define unicode_CANADIAN_SYLLABICS_KII                                0x146E
#define unicode_CANADIAN_SYLLABICS_KO                                 0x146F
#define unicode_CANADIAN_SYLLABICS_KOO                                0x1470
#define unicode_CANADIAN_SYLLABICS_Y_CREE_KOO                         0x1471
#define unicode_CANADIAN_SYLLABICS_KA                                 0x1472
#define unicode_CANADIAN_SYLLABICS_KAA                                0x1473
#define unicode_CANADIAN_SYLLABICS_KWE                                0x1474
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_KWE                      0x1475
#define unicode_CANADIAN_SYLLABICS_KWI                                0x1476
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_KWI                      0x1477
#define unicode_CANADIAN_SYLLABICS_KWII                               0x1478
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_KWII                     0x1479
#define unicode_CANADIAN_SYLLABICS_KWO                                0x147A
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_KWO                      0x147B
#define unicode_CANADIAN_SYLLABICS_KWOO                               0x147C
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_KWOO                     0x147D
#define unicode_CANADIAN_SYLLABICS_KWA                                0x147E
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_KWA                      0x147F
#define unicode_CANADIAN_SYLLABICS_KWAA                               0x1480
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_KWAA                     0x1481
#define unicode_CANADIAN_SYLLABICS_NASKAPI_KWAA                       0x1482
#define unicode_CANADIAN_SYLLABICS_K                                  0x1483
#define unicode_CANADIAN_SYLLABICS_KW                                 0x1484
#define unicode_CANADIAN_SYLLABICS_SOUTH_SLAVEY_KEH                   0x1485
#define unicode_CANADIAN_SYLLABICS_SOUTH_SLAVEY_KIH                   0x1486
#define unicode_CANADIAN_SYLLABICS_SOUTH_SLAVEY_KOH                   0x1487
#define unicode_CANADIAN_SYLLABICS_SOUTH_SLAVEY_KAH                   0x1488
#define unicode_CANADIAN_SYLLABICS_CE                                 0x1489
#define unicode_CANADIAN_SYLLABICS_CAAI                               0x148A
#define unicode_CANADIAN_SYLLABICS_CI                                 0x148B
#define unicode_CANADIAN_SYLLABICS_CII                                0x148C
#define unicode_CANADIAN_SYLLABICS_CO                                 0x148D
#define unicode_CANADIAN_SYLLABICS_COO                                0x148E
#define unicode_CANADIAN_SYLLABICS_Y_CREE_COO                         0x148F
#define unicode_CANADIAN_SYLLABICS_CA                                 0x1490
#define unicode_CANADIAN_SYLLABICS_CAA                                0x1491
#define unicode_CANADIAN_SYLLABICS_CWE                                0x1492
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_CWE                      0x1493
#define unicode_CANADIAN_SYLLABICS_CWI                                0x1494
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_CWI                      0x1495
#define unicode_CANADIAN_SYLLABICS_CWII                               0x1496
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_CWII                     0x1497
#define unicode_CANADIAN_SYLLABICS_CWO                                0x1498
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_CWO                      0x1499
#define unicode_CANADIAN_SYLLABICS_CWOO                               0x149A
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_CWOO                     0x149B
#define unicode_CANADIAN_SYLLABICS_CWA                                0x149C
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_CWA                      0x149D
#define unicode_CANADIAN_SYLLABICS_CWAA                               0x149E
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_CWAA                     0x149F
#define unicode_CANADIAN_SYLLABICS_NASKAPI_CWAA                       0x14A0
#define unicode_CANADIAN_SYLLABICS_C                                  0x14A1
#define unicode_CANADIAN_SYLLABICS_SAYISI_TH                          0x14A2
#define unicode_CANADIAN_SYLLABICS_ME                                 0x14A3
#define unicode_CANADIAN_SYLLABICS_MAAI                               0x14A4
#define unicode_CANADIAN_SYLLABICS_MI                                 0x14A5
#define unicode_CANADIAN_SYLLABICS_MII                                0x14A6
#define unicode_CANADIAN_SYLLABICS_MO                                 0x14A7
#define unicode_CANADIAN_SYLLABICS_MOO                                0x14A8
#define unicode_CANADIAN_SYLLABICS_Y_CREE_MOO                         0x14A9
#define unicode_CANADIAN_SYLLABICS_MA                                 0x14AA
#define unicode_CANADIAN_SYLLABICS_MAA                                0x14AB
#define unicode_CANADIAN_SYLLABICS_MWE                                0x14AC
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_MWE                      0x14AD
#define unicode_CANADIAN_SYLLABICS_MWI                                0x14AE
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_MWI                      0x14AF
#define unicode_CANADIAN_SYLLABICS_MWII                               0x14B0
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_MWII                     0x14B1
#define unicode_CANADIAN_SYLLABICS_MWO                                0x14B2
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_MWO                      0x14B3
#define unicode_CANADIAN_SYLLABICS_MWOO                               0x14B4
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_MWOO                     0x14B5
#define unicode_CANADIAN_SYLLABICS_MWA                                0x14B6
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_MWA                      0x14B7
#define unicode_CANADIAN_SYLLABICS_MWAA                               0x14B8
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_MWAA                     0x14B9
#define unicode_CANADIAN_SYLLABICS_NASKAPI_MWAA                       0x14BA
#define unicode_CANADIAN_SYLLABICS_M                                  0x14BB
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_M                        0x14BC
#define unicode_CANADIAN_SYLLABICS_MH                                 0x14BD
#define unicode_CANADIAN_SYLLABICS_ATHAPASCAN_M                       0x14BE
#define unicode_CANADIAN_SYLLABICS_SAYISI_M                           0x14BF
#define unicode_CANADIAN_SYLLABICS_NE                                 0x14C0
#define unicode_CANADIAN_SYLLABICS_NAAI                               0x14C1
#define unicode_CANADIAN_SYLLABICS_NI                                 0x14C2
#define unicode_CANADIAN_SYLLABICS_NII                                0x14C3
#define unicode_CANADIAN_SYLLABICS_NO                                 0x14C4
#define unicode_CANADIAN_SYLLABICS_NOO                                0x14C5
#define unicode_CANADIAN_SYLLABICS_Y_CREE_NOO                         0x14C6
#define unicode_CANADIAN_SYLLABICS_NA                                 0x14C7
#define unicode_CANADIAN_SYLLABICS_NAA                                0x14C8
#define unicode_CANADIAN_SYLLABICS_NWE                                0x14C9
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_NWE                      0x14CA
#define unicode_CANADIAN_SYLLABICS_NWA                                0x14CB
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_NWA                      0x14CC
#define unicode_CANADIAN_SYLLABICS_NWAA                               0x14CD
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_NWAA                     0x14CE
#define unicode_CANADIAN_SYLLABICS_NASKAPI_NWAA                       0x14CF
#define unicode_CANADIAN_SYLLABICS_N                                  0x14D0
#define unicode_CANADIAN_SYLLABICS_CARRIER_NG                         0x14D1
#define unicode_CANADIAN_SYLLABICS_NH                                 0x14D2
#define unicode_CANADIAN_SYLLABICS_LE                                 0x14D3
#define unicode_CANADIAN_SYLLABICS_LAAI                               0x14D4
#define unicode_CANADIAN_SYLLABICS_LI                                 0x14D5
#define unicode_CANADIAN_SYLLABICS_LII                                0x14D6
#define unicode_CANADIAN_SYLLABICS_LO                                 0x14D7
#define unicode_CANADIAN_SYLLABICS_LOO                                0x14D8
#define unicode_CANADIAN_SYLLABICS_Y_CREE_LOO                         0x14D9
#define unicode_CANADIAN_SYLLABICS_LA                                 0x14DA
#define unicode_CANADIAN_SYLLABICS_LAA                                0x14DB
#define unicode_CANADIAN_SYLLABICS_LWE                                0x14DC
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LWE                      0x14DD
#define unicode_CANADIAN_SYLLABICS_LWI                                0x14DE
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LWI                      0x14DF
#define unicode_CANADIAN_SYLLABICS_LWII                               0x14E0
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LWII                     0x14E1
#define unicode_CANADIAN_SYLLABICS_LWO                                0x14E2
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LWO                      0x14E3
#define unicode_CANADIAN_SYLLABICS_LWOO                               0x14E4
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LWOO                     0x14E5
#define unicode_CANADIAN_SYLLABICS_LWA                                0x14E6
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LWA                      0x14E7
#define unicode_CANADIAN_SYLLABICS_LWAA                               0x14E8
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LWAA                     0x14E9
#define unicode_CANADIAN_SYLLABICS_L                                  0x14EA
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_L                        0x14EB
#define unicode_CANADIAN_SYLLABICS_MEDIAL_L                           0x14EC
#define unicode_CANADIAN_SYLLABICS_SE                                 0x14ED
#define unicode_CANADIAN_SYLLABICS_SAAI                               0x14EE
#define unicode_CANADIAN_SYLLABICS_SI                                 0x14EF
#define unicode_CANADIAN_SYLLABICS_SII                                0x14F0
#define unicode_CANADIAN_SYLLABICS_SO                                 0x14F1
#define unicode_CANADIAN_SYLLABICS_SOO                                0x14F2
#define unicode_CANADIAN_SYLLABICS_Y_CREE_SOO                         0x14F3
#define unicode_CANADIAN_SYLLABICS_SA                                 0x14F4
#define unicode_CANADIAN_SYLLABICS_SAA                                0x14F5
#define unicode_CANADIAN_SYLLABICS_SWE                                0x14F6
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SWE                      0x14F7
#define unicode_CANADIAN_SYLLABICS_SWI                                0x14F8
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SWI                      0x14F9
#define unicode_CANADIAN_SYLLABICS_SWII                               0x14FA
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SWII                     0x14FB
#define unicode_CANADIAN_SYLLABICS_SWO                                0x14FC
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SWO                      0x14FD
#define unicode_CANADIAN_SYLLABICS_SWOO                               0x14FE
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SWOO                     0x14FF
#define unicode_CANADIAN_SYLLABICS_SWA                                0x1500
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SWA                      0x1501
#define unicode_CANADIAN_SYLLABICS_SWAA                               0x1502
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SWAA                     0x1503
#define unicode_CANADIAN_SYLLABICS_NASKAPI_SWAA                       0x1504
#define unicode_CANADIAN_SYLLABICS_S                                  0x1505
#define unicode_CANADIAN_SYLLABICS_ATHAPASCAN_S                       0x1506
#define unicode_CANADIAN_SYLLABICS_SW                                 0x1507
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_S                        0x1508
#define unicode_CANADIAN_SYLLABICS_MOOSE_CREE_SK                      0x1509
#define unicode_CANADIAN_SYLLABICS_NASKAPI_SKW                        0x150A
#define unicode_CANADIAN_SYLLABICS_NASKAPI_S_W                        0x150B
#define unicode_CANADIAN_SYLLABICS_NASKAPI_SPWA                       0x150C
#define unicode_CANADIAN_SYLLABICS_NASKAPI_STWA                       0x150D
#define unicode_CANADIAN_SYLLABICS_NASKAPI_SKWA                       0x150E
#define unicode_CANADIAN_SYLLABICS_NASKAPI_SCWA                       0x150F
#define unicode_CANADIAN_SYLLABICS_SHE                                0x1510
#define unicode_CANADIAN_SYLLABICS_SHI                                0x1511
#define unicode_CANADIAN_SYLLABICS_SHII                               0x1512
#define unicode_CANADIAN_SYLLABICS_SHO                                0x1513
#define unicode_CANADIAN_SYLLABICS_SHOO                               0x1514
#define unicode_CANADIAN_SYLLABICS_SHA                                0x1515
#define unicode_CANADIAN_SYLLABICS_SHAA                               0x1516
#define unicode_CANADIAN_SYLLABICS_SHWE                               0x1517
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SHWE                     0x1518
#define unicode_CANADIAN_SYLLABICS_SHWI                               0x1519
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SHWI                     0x151A
#define unicode_CANADIAN_SYLLABICS_SHWII                              0x151B
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SHWII                    0x151C
#define unicode_CANADIAN_SYLLABICS_SHWO                               0x151D
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SHWO                     0x151E
#define unicode_CANADIAN_SYLLABICS_SHWOO                              0x151F
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SHWOO                    0x1520
#define unicode_CANADIAN_SYLLABICS_SHWA                               0x1521
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SHWA                     0x1522
#define unicode_CANADIAN_SYLLABICS_SHWAA                              0x1523
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_SHWAA                    0x1524
#define unicode_CANADIAN_SYLLABICS_SH                                 0x1525
#define unicode_CANADIAN_SYLLABICS_YE                                 0x1526
#define unicode_CANADIAN_SYLLABICS_YAAI                               0x1527
#define unicode_CANADIAN_SYLLABICS_YI                                 0x1528
#define unicode_CANADIAN_SYLLABICS_YII                                0x1529
#define unicode_CANADIAN_SYLLABICS_YO                                 0x152A
#define unicode_CANADIAN_SYLLABICS_YOO                                0x152B
#define unicode_CANADIAN_SYLLABICS_Y_CREE_YOO                         0x152C
#define unicode_CANADIAN_SYLLABICS_YA                                 0x152D
#define unicode_CANADIAN_SYLLABICS_YAA                                0x152E
#define unicode_CANADIAN_SYLLABICS_YWE                                0x152F
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_YWE                      0x1530
#define unicode_CANADIAN_SYLLABICS_YWI                                0x1531
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_YWI                      0x1532
#define unicode_CANADIAN_SYLLABICS_YWII                               0x1533
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_YWII                     0x1534
#define unicode_CANADIAN_SYLLABICS_YWO                                0x1535
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_YWO                      0x1536
#define unicode_CANADIAN_SYLLABICS_YWOO                               0x1537
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_YWOO                     0x1538
#define unicode_CANADIAN_SYLLABICS_YWA                                0x1539
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_YWA                      0x153A
#define unicode_CANADIAN_SYLLABICS_YWAA                               0x153B
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_YWAA                     0x153C
#define unicode_CANADIAN_SYLLABICS_NASKAPI_YWAA                       0x153D
#define unicode_CANADIAN_SYLLABICS_Y                                  0x153E
#define unicode_CANADIAN_SYLLABICS_BIBLE_CREE_Y                       0x153F
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_Y                        0x1540
#define unicode_CANADIAN_SYLLABICS_SAYISI_YI                          0x1541
#define unicode_CANADIAN_SYLLABICS_RE                                 0x1542
#define unicode_CANADIAN_SYLLABICS_R_CREE_RE                          0x1543
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LE                       0x1544
#define unicode_CANADIAN_SYLLABICS_RAAI                               0x1545
#define unicode_CANADIAN_SYLLABICS_RI                                 0x1546
#define unicode_CANADIAN_SYLLABICS_RII                                0x1547
#define unicode_CANADIAN_SYLLABICS_RO                                 0x1548
#define unicode_CANADIAN_SYLLABICS_ROO                                0x1549
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LO                       0x154A
#define unicode_CANADIAN_SYLLABICS_RA                                 0x154B
#define unicode_CANADIAN_SYLLABICS_RAA                                0x154C
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LA                       0x154D
#define unicode_CANADIAN_SYLLABICS_RWAA                               0x154E
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_RWAA                     0x154F
#define unicode_CANADIAN_SYLLABICS_R                                  0x1550
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_R                        0x1551
#define unicode_CANADIAN_SYLLABICS_MEDIAL_R                           0x1552
#define unicode_CANADIAN_SYLLABICS_FE                                 0x1553
#define unicode_CANADIAN_SYLLABICS_FAAI                               0x1554
#define unicode_CANADIAN_SYLLABICS_FI                                 0x1555
#define unicode_CANADIAN_SYLLABICS_FII                                0x1556
#define unicode_CANADIAN_SYLLABICS_FO                                 0x1557
#define unicode_CANADIAN_SYLLABICS_FOO                                0x1558
#define unicode_CANADIAN_SYLLABICS_FA                                 0x1559
#define unicode_CANADIAN_SYLLABICS_FAA                                0x155A
#define unicode_CANADIAN_SYLLABICS_FWAA                               0x155B
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_FWAA                     0x155C
#define unicode_CANADIAN_SYLLABICS_F                                  0x155D
#define unicode_CANADIAN_SYLLABICS_THE                                0x155E
#define unicode_CANADIAN_SYLLABICS_N_CREE_THE                         0x155F
#define unicode_CANADIAN_SYLLABICS_THI                                0x1560
#define unicode_CANADIAN_SYLLABICS_N_CREE_THI                         0x1561
#define unicode_CANADIAN_SYLLABICS_THII                               0x1562
#define unicode_CANADIAN_SYLLABICS_N_CREE_THII                        0x1563
#define unicode_CANADIAN_SYLLABICS_THO                                0x1564
#define unicode_CANADIAN_SYLLABICS_THOO                               0x1565
#define unicode_CANADIAN_SYLLABICS_THA                                0x1566
#define unicode_CANADIAN_SYLLABICS_THAA                               0x1567
#define unicode_CANADIAN_SYLLABICS_THWAA                              0x1568
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_THWAA                    0x1569
#define unicode_CANADIAN_SYLLABICS_TH                                 0x156A
#define unicode_CANADIAN_SYLLABICS_TTHE                               0x156B
#define unicode_CANADIAN_SYLLABICS_TTHI                               0x156C
#define unicode_CANADIAN_SYLLABICS_TTHO                               0x156D
#define unicode_CANADIAN_SYLLABICS_TTHA                               0x156E
#define unicode_CANADIAN_SYLLABICS_TTH                                0x156F
#define unicode_CANADIAN_SYLLABICS_TYE                                0x1570
#define unicode_CANADIAN_SYLLABICS_TYI                                0x1571
#define unicode_CANADIAN_SYLLABICS_TYO                                0x1572
#define unicode_CANADIAN_SYLLABICS_TYA                                0x1573
#define unicode_CANADIAN_SYLLABICS_NUNAVIK_HE                         0x1574
#define unicode_CANADIAN_SYLLABICS_NUNAVIK_HI                         0x1575
#define unicode_CANADIAN_SYLLABICS_NUNAVIK_HII                        0x1576
#define unicode_CANADIAN_SYLLABICS_NUNAVIK_HO                         0x1577
#define unicode_CANADIAN_SYLLABICS_NUNAVIK_HOO                        0x1578
#define unicode_CANADIAN_SYLLABICS_NUNAVIK_HA                         0x1579
#define unicode_CANADIAN_SYLLABICS_NUNAVIK_HAA                        0x157A
#define unicode_CANADIAN_SYLLABICS_NUNAVIK_H                          0x157B
#define unicode_CANADIAN_SYLLABICS_NUNAVUT_H                          0x157C
#define unicode_CANADIAN_SYLLABICS_HK                                 0x157D
#define unicode_CANADIAN_SYLLABICS_QAAI                               0x157E
#define unicode_CANADIAN_SYLLABICS_QI                                 0x157F
#define unicode_CANADIAN_SYLLABICS_QII                                0x1580
#define unicode_CANADIAN_SYLLABICS_QO                                 0x1581
#define unicode_CANADIAN_SYLLABICS_QOO                                0x1582
#define unicode_CANADIAN_SYLLABICS_QA                                 0x1583
#define unicode_CANADIAN_SYLLABICS_QAA                                0x1584
#define unicode_CANADIAN_SYLLABICS_Q                                  0x1585
#define unicode_CANADIAN_SYLLABICS_TLHE                               0x1586
#define unicode_CANADIAN_SYLLABICS_TLHI                               0x1587
#define unicode_CANADIAN_SYLLABICS_TLHO                               0x1588
#define unicode_CANADIAN_SYLLABICS_TLHA                               0x1589
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_RE                       0x158A
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_RI                       0x158B
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_RO                       0x158C
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_RA                       0x158D
#define unicode_CANADIAN_SYLLABICS_NGAAI                              0x158E
#define unicode_CANADIAN_SYLLABICS_NGI                                0x158F
#define unicode_CANADIAN_SYLLABICS_NGII                               0x1590
#define unicode_CANADIAN_SYLLABICS_NGO                                0x1591
#define unicode_CANADIAN_SYLLABICS_NGOO                               0x1592
#define unicode_CANADIAN_SYLLABICS_NGA                                0x1593
#define unicode_CANADIAN_SYLLABICS_NGAA                               0x1594
#define unicode_CANADIAN_SYLLABICS_NG                                 0x1595
#define unicode_CANADIAN_SYLLABICS_NNG                                0x1596
#define unicode_CANADIAN_SYLLABICS_SAYISI_SHE                         0x1597
#define unicode_CANADIAN_SYLLABICS_SAYISI_SHI                         0x1598
#define unicode_CANADIAN_SYLLABICS_SAYISI_SHO                         0x1599
#define unicode_CANADIAN_SYLLABICS_SAYISI_SHA                         0x159A
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_THE                     0x159B
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_THI                     0x159C
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_THO                     0x159D
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_THA                     0x159E
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_TH                      0x159F
#define unicode_CANADIAN_SYLLABICS_LHI                                0x15A0
#define unicode_CANADIAN_SYLLABICS_LHII                               0x15A1
#define unicode_CANADIAN_SYLLABICS_LHO                                0x15A2
#define unicode_CANADIAN_SYLLABICS_LHOO                               0x15A3
#define unicode_CANADIAN_SYLLABICS_LHA                                0x15A4
#define unicode_CANADIAN_SYLLABICS_LHAA                               0x15A5
#define unicode_CANADIAN_SYLLABICS_LH                                 0x15A6
#define unicode_CANADIAN_SYLLABICS_TH_CREE_THE                        0x15A7
#define unicode_CANADIAN_SYLLABICS_TH_CREE_THI                        0x15A8
#define unicode_CANADIAN_SYLLABICS_TH_CREE_THII                       0x15A9
#define unicode_CANADIAN_SYLLABICS_TH_CREE_THO                        0x15AA
#define unicode_CANADIAN_SYLLABICS_TH_CREE_THOO                       0x15AB
#define unicode_CANADIAN_SYLLABICS_TH_CREE_THA                        0x15AC
#define unicode_CANADIAN_SYLLABICS_TH_CREE_THAA                       0x15AD
#define unicode_CANADIAN_SYLLABICS_TH_CREE_TH                         0x15AE
#define unicode_CANADIAN_SYLLABICS_AIVILIK_B                          0x15AF
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_E                        0x15B0
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_I                        0x15B1
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_O                        0x15B2
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_A                        0x15B3
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_WE                       0x15B4
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_WI                       0x15B5
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_WO                       0x15B6
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_WA                       0x15B7
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_NE                       0x15B8
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_NI                       0x15B9
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_NO                       0x15BA
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_NA                       0x15BB
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_KE                       0x15BC
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_KI                       0x15BD
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_KO                       0x15BE
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_KA                       0x15BF
#define unicode_CANADIAN_SYLLABICS_SAYISI_HE                          0x15C0
#define unicode_CANADIAN_SYLLABICS_SAYISI_HI                          0x15C1
#define unicode_CANADIAN_SYLLABICS_SAYISI_HO                          0x15C2
#define unicode_CANADIAN_SYLLABICS_SAYISI_HA                          0x15C3
#define unicode_CANADIAN_SYLLABICS_CARRIER_GHU                        0x15C4
#define unicode_CANADIAN_SYLLABICS_CARRIER_GHO                        0x15C5
#define unicode_CANADIAN_SYLLABICS_CARRIER_GHE                        0x15C6
#define unicode_CANADIAN_SYLLABICS_CARRIER_GHEE                       0x15C7
#define unicode_CANADIAN_SYLLABICS_CARRIER_GHI                        0x15C8
#define unicode_CANADIAN_SYLLABICS_CARRIER_GHA                        0x15C9
#define unicode_CANADIAN_SYLLABICS_CARRIER_RU                         0x15CA
#define unicode_CANADIAN_SYLLABICS_CARRIER_RO                         0x15CB
#define unicode_CANADIAN_SYLLABICS_CARRIER_RE                         0x15CC
#define unicode_CANADIAN_SYLLABICS_CARRIER_REE                        0x15CD
#define unicode_CANADIAN_SYLLABICS_CARRIER_RI                         0x15CE
#define unicode_CANADIAN_SYLLABICS_CARRIER_RA                         0x15CF
#define unicode_CANADIAN_SYLLABICS_CARRIER_WU                         0x15D0
#define unicode_CANADIAN_SYLLABICS_CARRIER_WO                         0x15D1
#define unicode_CANADIAN_SYLLABICS_CARRIER_WE                         0x15D2
#define unicode_CANADIAN_SYLLABICS_CARRIER_WEE                        0x15D3
#define unicode_CANADIAN_SYLLABICS_CARRIER_WI                         0x15D4
#define unicode_CANADIAN_SYLLABICS_CARRIER_WA                         0x15D5
#define unicode_CANADIAN_SYLLABICS_CARRIER_HWU                        0x15D6
#define unicode_CANADIAN_SYLLABICS_CARRIER_HWO                        0x15D7
#define unicode_CANADIAN_SYLLABICS_CARRIER_HWE                        0x15D8
#define unicode_CANADIAN_SYLLABICS_CARRIER_HWEE                       0x15D9
#define unicode_CANADIAN_SYLLABICS_CARRIER_HWI                        0x15DA
#define unicode_CANADIAN_SYLLABICS_CARRIER_HWA                        0x15DB
#define unicode_CANADIAN_SYLLABICS_CARRIER_THU                        0x15DC
#define unicode_CANADIAN_SYLLABICS_CARRIER_THO                        0x15DD
#define unicode_CANADIAN_SYLLABICS_CARRIER_THE                        0x15DE
#define unicode_CANADIAN_SYLLABICS_CARRIER_THEE                       0x15DF
#define unicode_CANADIAN_SYLLABICS_CARRIER_THI                        0x15E0
#define unicode_CANADIAN_SYLLABICS_CARRIER_THA                        0x15E1
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTU                        0x15E2
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTO                        0x15E3
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTE                        0x15E4
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTEE                       0x15E5
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTI                        0x15E6
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTA                        0x15E7
#define unicode_CANADIAN_SYLLABICS_CARRIER_PU                         0x15E8
#define unicode_CANADIAN_SYLLABICS_CARRIER_PO                         0x15E9
#define unicode_CANADIAN_SYLLABICS_CARRIER_PE                         0x15EA
#define unicode_CANADIAN_SYLLABICS_CARRIER_PEE                        0x15EB
#define unicode_CANADIAN_SYLLABICS_CARRIER_PI                         0x15EC
#define unicode_CANADIAN_SYLLABICS_CARRIER_PA                         0x15ED
#define unicode_CANADIAN_SYLLABICS_CARRIER_P                          0x15EE
#define unicode_CANADIAN_SYLLABICS_CARRIER_GU                         0x15EF
#define unicode_CANADIAN_SYLLABICS_CARRIER_GO                         0x15F0
#define unicode_CANADIAN_SYLLABICS_CARRIER_GE                         0x15F1
#define unicode_CANADIAN_SYLLABICS_CARRIER_GEE                        0x15F2
#define unicode_CANADIAN_SYLLABICS_CARRIER_GI                         0x15F3
#define unicode_CANADIAN_SYLLABICS_CARRIER_GA                         0x15F4
#define unicode_CANADIAN_SYLLABICS_CARRIER_KHU                        0x15F5
#define unicode_CANADIAN_SYLLABICS_CARRIER_KHO                        0x15F6
#define unicode_CANADIAN_SYLLABICS_CARRIER_KHE                        0x15F7
#define unicode_CANADIAN_SYLLABICS_CARRIER_KHEE                       0x15F8
#define unicode_CANADIAN_SYLLABICS_CARRIER_KHI                        0x15F9
#define unicode_CANADIAN_SYLLABICS_CARRIER_KHA                        0x15FA
#define unicode_CANADIAN_SYLLABICS_CARRIER_KKU                        0x15FB
#define unicode_CANADIAN_SYLLABICS_CARRIER_KKO                        0x15FC
#define unicode_CANADIAN_SYLLABICS_CARRIER_KKE                        0x15FD
#define unicode_CANADIAN_SYLLABICS_CARRIER_KKEE                       0x15FE
#define unicode_CANADIAN_SYLLABICS_CARRIER_KKI                        0x15FF
#define unicode_CANADIAN_SYLLABICS_CARRIER_KKA                        0x1600
#define unicode_CANADIAN_SYLLABICS_CARRIER_KK                         0x1601
#define unicode_CANADIAN_SYLLABICS_CARRIER_NU                         0x1602
#define unicode_CANADIAN_SYLLABICS_CARRIER_NO                         0x1603
#define unicode_CANADIAN_SYLLABICS_CARRIER_NE                         0x1604
#define unicode_CANADIAN_SYLLABICS_CARRIER_NEE                        0x1605
#define unicode_CANADIAN_SYLLABICS_CARRIER_NI                         0x1606
#define unicode_CANADIAN_SYLLABICS_CARRIER_NA                         0x1607
#define unicode_CANADIAN_SYLLABICS_CARRIER_MU                         0x1608
#define unicode_CANADIAN_SYLLABICS_CARRIER_MO                         0x1609
#define unicode_CANADIAN_SYLLABICS_CARRIER_ME                         0x160A
#define unicode_CANADIAN_SYLLABICS_CARRIER_MEE                        0x160B
#define unicode_CANADIAN_SYLLABICS_CARRIER_MI                         0x160C
#define unicode_CANADIAN_SYLLABICS_CARRIER_MA                         0x160D
#define unicode_CANADIAN_SYLLABICS_CARRIER_YU                         0x160E
#define unicode_CANADIAN_SYLLABICS_CARRIER_YO                         0x160F
#define unicode_CANADIAN_SYLLABICS_CARRIER_YE                         0x1610
#define unicode_CANADIAN_SYLLABICS_CARRIER_YEE                        0x1611
#define unicode_CANADIAN_SYLLABICS_CARRIER_YI                         0x1612
#define unicode_CANADIAN_SYLLABICS_CARRIER_YA                         0x1613
#define unicode_CANADIAN_SYLLABICS_CARRIER_JU                         0x1614
#define unicode_CANADIAN_SYLLABICS_SAYISI_JU                          0x1615
#define unicode_CANADIAN_SYLLABICS_CARRIER_JO                         0x1616
#define unicode_CANADIAN_SYLLABICS_CARRIER_JE                         0x1617
#define unicode_CANADIAN_SYLLABICS_CARRIER_JEE                        0x1618
#define unicode_CANADIAN_SYLLABICS_CARRIER_JI                         0x1619
#define unicode_CANADIAN_SYLLABICS_SAYISI_JI                          0x161A
#define unicode_CANADIAN_SYLLABICS_CARRIER_JA                         0x161B
#define unicode_CANADIAN_SYLLABICS_CARRIER_JJU                        0x161C
#define unicode_CANADIAN_SYLLABICS_CARRIER_JJO                        0x161D
#define unicode_CANADIAN_SYLLABICS_CARRIER_JJE                        0x161E
#define unicode_CANADIAN_SYLLABICS_CARRIER_JJEE                       0x161F
#define unicode_CANADIAN_SYLLABICS_CARRIER_JJI                        0x1620
#define unicode_CANADIAN_SYLLABICS_CARRIER_JJA                        0x1621
#define unicode_CANADIAN_SYLLABICS_CARRIER_LU                         0x1622
#define unicode_CANADIAN_SYLLABICS_CARRIER_LO                         0x1623
#define unicode_CANADIAN_SYLLABICS_CARRIER_LE                         0x1624
#define unicode_CANADIAN_SYLLABICS_CARRIER_LEE                        0x1625
#define unicode_CANADIAN_SYLLABICS_CARRIER_LI                         0x1626
#define unicode_CANADIAN_SYLLABICS_CARRIER_LA                         0x1627
#define unicode_CANADIAN_SYLLABICS_CARRIER_DLU                        0x1628
#define unicode_CANADIAN_SYLLABICS_CARRIER_DLO                        0x1629
#define unicode_CANADIAN_SYLLABICS_CARRIER_DLE                        0x162A
#define unicode_CANADIAN_SYLLABICS_CARRIER_DLEE                       0x162B
#define unicode_CANADIAN_SYLLABICS_CARRIER_DLI                        0x162C
#define unicode_CANADIAN_SYLLABICS_CARRIER_DLA                        0x162D
#define unicode_CANADIAN_SYLLABICS_CARRIER_LHU                        0x162E
#define unicode_CANADIAN_SYLLABICS_CARRIER_LHO                        0x162F
#define unicode_CANADIAN_SYLLABICS_CARRIER_LHE                        0x1630
#define unicode_CANADIAN_SYLLABICS_CARRIER_LHEE                       0x1631
#define unicode_CANADIAN_SYLLABICS_CARRIER_LHI                        0x1632
#define unicode_CANADIAN_SYLLABICS_CARRIER_LHA                        0x1633
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLHU                       0x1634
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLHO                       0x1635
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLHE                       0x1636
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLHEE                      0x1637
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLHI                       0x1638
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLHA                       0x1639
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLU                        0x163A
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLO                        0x163B
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLE                        0x163C
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLEE                       0x163D
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLI                        0x163E
#define unicode_CANADIAN_SYLLABICS_CARRIER_TLA                        0x163F
#define unicode_CANADIAN_SYLLABICS_CARRIER_ZU                         0x1640
#define unicode_CANADIAN_SYLLABICS_CARRIER_ZO                         0x1641
#define unicode_CANADIAN_SYLLABICS_CARRIER_ZE                         0x1642
#define unicode_CANADIAN_SYLLABICS_CARRIER_ZEE                        0x1643
#define unicode_CANADIAN_SYLLABICS_CARRIER_ZI                         0x1644
#define unicode_CANADIAN_SYLLABICS_CARRIER_ZA                         0x1645
#define unicode_CANADIAN_SYLLABICS_CARRIER_Z                          0x1646
#define unicode_CANADIAN_SYLLABICS_CARRIER_INITIAL_Z                  0x1647
#define unicode_CANADIAN_SYLLABICS_CARRIER_DZU                        0x1648
#define unicode_CANADIAN_SYLLABICS_CARRIER_DZO                        0x1649
#define unicode_CANADIAN_SYLLABICS_CARRIER_DZE                        0x164A
#define unicode_CANADIAN_SYLLABICS_CARRIER_DZEE                       0x164B
#define unicode_CANADIAN_SYLLABICS_CARRIER_DZI                        0x164C
#define unicode_CANADIAN_SYLLABICS_CARRIER_DZA                        0x164D
#define unicode_CANADIAN_SYLLABICS_CARRIER_SU                         0x164E
#define unicode_CANADIAN_SYLLABICS_CARRIER_SO                         0x164F
#define unicode_CANADIAN_SYLLABICS_CARRIER_SE                         0x1650
#define unicode_CANADIAN_SYLLABICS_CARRIER_SEE                        0x1651
#define unicode_CANADIAN_SYLLABICS_CARRIER_SI                         0x1652
#define unicode_CANADIAN_SYLLABICS_CARRIER_SA                         0x1653
#define unicode_CANADIAN_SYLLABICS_CARRIER_SHU                        0x1654
#define unicode_CANADIAN_SYLLABICS_CARRIER_SHO                        0x1655
#define unicode_CANADIAN_SYLLABICS_CARRIER_SHE                        0x1656
#define unicode_CANADIAN_SYLLABICS_CARRIER_SHEE                       0x1657
#define unicode_CANADIAN_SYLLABICS_CARRIER_SHI                        0x1658
#define unicode_CANADIAN_SYLLABICS_CARRIER_SHA                        0x1659
#define unicode_CANADIAN_SYLLABICS_CARRIER_SH                         0x165A
#define unicode_CANADIAN_SYLLABICS_CARRIER_TSU                        0x165B
#define unicode_CANADIAN_SYLLABICS_CARRIER_TSO                        0x165C
#define unicode_CANADIAN_SYLLABICS_CARRIER_TSE                        0x165D
#define unicode_CANADIAN_SYLLABICS_CARRIER_TSEE                       0x165E
#define unicode_CANADIAN_SYLLABICS_CARRIER_TSI                        0x165F
#define unicode_CANADIAN_SYLLABICS_CARRIER_TSA                        0x1660
#define unicode_CANADIAN_SYLLABICS_CARRIER_CHU                        0x1661
#define unicode_CANADIAN_SYLLABICS_CARRIER_CHO                        0x1662
#define unicode_CANADIAN_SYLLABICS_CARRIER_CHE                        0x1663
#define unicode_CANADIAN_SYLLABICS_CARRIER_CHEE                       0x1664
#define unicode_CANADIAN_SYLLABICS_CARRIER_CHI                        0x1665
#define unicode_CANADIAN_SYLLABICS_CARRIER_CHA                        0x1666
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTSU                       0x1667
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTSO                       0x1668
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTSE                       0x1669
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTSEE                      0x166A
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTSI                       0x166B
#define unicode_CANADIAN_SYLLABICS_CARRIER_TTSA                       0x166C
#define unicode_CANADIAN_SYLLABICS_CHI_SIGN                           0x166D
#define unicode_CANADIAN_SYLLABICS_FULL_STOP                          0x166E
#define unicode_CANADIAN_SYLLABICS_QAI                                0x166F
#define unicode_CANADIAN_SYLLABICS_NGAI                               0x1670
#define unicode_CANADIAN_SYLLABICS_NNGI                               0x1671
#define unicode_CANADIAN_SYLLABICS_NNGII                              0x1672
#define unicode_CANADIAN_SYLLABICS_NNGO                               0x1673
#define unicode_CANADIAN_SYLLABICS_NNGOO                              0x1674
#define unicode_CANADIAN_SYLLABICS_NNGA                               0x1675
#define unicode_CANADIAN_SYLLABICS_NNGAA                              0x1676
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_THWEE                   0x1677
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_THWI                    0x1678
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_THWII                   0x1679
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_THWO                    0x167A
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_THWOO                   0x167B
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_THWA                    0x167C
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_THWAA                   0x167D
#define unicode_CANADIAN_SYLLABICS_WOODS_CREE_FINAL_TH                0x167E
#define unicode_CANADIAN_SYLLABICS_BLACKFOOT_W                        0x167F
#define unicode_OGHAM_SPACE_MARK                                      0x1680
#define unicode_OGHAM_LETTER_BEITH                                    0x1681
#define unicode_OGHAM_LETTER_LUIS                                     0x1682
#define unicode_OGHAM_LETTER_FEARN                                    0x1683
#define unicode_OGHAM_LETTER_SAIL                                     0x1684
#define unicode_OGHAM_LETTER_NION                                     0x1685
#define unicode_OGHAM_LETTER_UATH                                     0x1686
#define unicode_OGHAM_LETTER_DAIR                                     0x1687
#define unicode_OGHAM_LETTER_TINNE                                    0x1688
#define unicode_OGHAM_LETTER_COLL                                     0x1689
#define unicode_OGHAM_LETTER_CEIRT                                    0x168A
#define unicode_OGHAM_LETTER_MUIN                                     0x168B
#define unicode_OGHAM_LETTER_GORT                                     0x168C
#define unicode_OGHAM_LETTER_NGEADAL                                  0x168D
#define unicode_OGHAM_LETTER_STRAIF                                   0x168E
#define unicode_OGHAM_LETTER_RUIS                                     0x168F
#define unicode_OGHAM_LETTER_AILM                                     0x1690
#define unicode_OGHAM_LETTER_ONN                                      0x1691
#define unicode_OGHAM_LETTER_UR                                       0x1692
#define unicode_OGHAM_LETTER_EADHADH                                  0x1693
#define unicode_OGHAM_LETTER_IODHADH                                  0x1694
#define unicode_OGHAM_LETTER_EABHADH                                  0x1695
#define unicode_OGHAM_LETTER_OR                                       0x1696
#define unicode_OGHAM_LETTER_UILLEANN                                 0x1697
#define unicode_OGHAM_LETTER_IFIN                                     0x1698
#define unicode_OGHAM_LETTER_EAMHANCHOLL                              0x1699
#define unicode_OGHAM_LETTER_PEITH                                    0x169A
#define unicode_OGHAM_FEATHER_MARK                                    0x169B
#define unicode_OGHAM_REVERSED_FEATHER_MARK                           0x169C
#define unicode_RUNIC_LETTER_FEHU_FEOH_FE_F                           0x16A0
#define unicode_RUNIC_LETTER_V                                        0x16A1
#define unicode_RUNIC_LETTER_URUZ_UR_U                                0x16A2
#define unicode_RUNIC_LETTER_YR                                       0x16A3
#define unicode_RUNIC_LETTER_Y                                        0x16A4
#define unicode_RUNIC_LETTER_W                                        0x16A5
#define unicode_RUNIC_LETTER_THURISAZ_THURS_THORN                     0x16A6
#define unicode_RUNIC_LETTER_ETH                                      0x16A7
#define unicode_RUNIC_LETTER_ANSUZ_A                                  0x16A8
#define unicode_RUNIC_LETTER_OS_O                                     0x16A9
#define unicode_RUNIC_LETTER_AC_A                                     0x16AA
#define unicode_RUNIC_LETTER_AESC                                     0x16AB
#define unicode_RUNIC_LETTER_LONG_BRANCH_OSS_O                        0x16AC
#define unicode_RUNIC_LETTER_SHORT_TWIG_OSS_O                         0x16AD
#define unicode_RUNIC_LETTER_O                                        0x16AE
#define unicode_RUNIC_LETTER_OE                                       0x16AF
#define unicode_RUNIC_LETTER_ON                                       0x16B0
#define unicode_RUNIC_LETTER_RAIDO_RAD_REID_R                         0x16B1
#define unicode_RUNIC_LETTER_KAUNA                                    0x16B2
#define unicode_RUNIC_LETTER_CEN                                      0x16B3
#define unicode_RUNIC_LETTER_KAUN_K                                   0x16B4
#define unicode_RUNIC_LETTER_G                                        0x16B5
#define unicode_RUNIC_LETTER_ENG                                      0x16B6
#define unicode_RUNIC_LETTER_GEBO_GYFU_G                              0x16B7
#define unicode_RUNIC_LETTER_GAR                                      0x16B8
#define unicode_RUNIC_LETTER_WUNJO_WYNN_W                             0x16B9
#define unicode_RUNIC_LETTER_HAGLAZ_H                                 0x16BA
#define unicode_RUNIC_LETTER_HAEGL_H                                  0x16BB
#define unicode_RUNIC_LETTER_LONG_BRANCH_HAGALL_H                     0x16BC
#define unicode_RUNIC_LETTER_SHORT_TWIG_HAGALL_H                      0x16BD
#define unicode_RUNIC_LETTER_NAUDIZ_NYD_NAUD_N                        0x16BE
#define unicode_RUNIC_LETTER_SHORT_TWIG_NAUD_N                        0x16BF
#define unicode_RUNIC_LETTER_DOTTED_N                                 0x16C0
#define unicode_RUNIC_LETTER_ISAZ_IS_ISS_I                            0x16C1
#define unicode_RUNIC_LETTER_E                                        0x16C2
#define unicode_RUNIC_LETTER_JERAN_J                                  0x16C3
#define unicode_RUNIC_LETTER_GER                                      0x16C4
#define unicode_RUNIC_LETTER_LONG_BRANCH_AR_AE                        0x16C5
#define unicode_RUNIC_LETTER_SHORT_TWIG_AR_A                          0x16C6
#define unicode_RUNIC_LETTER_IWAZ_EOH                                 0x16C7
#define unicode_RUNIC_LETTER_PERTHO_PEORTH_P                          0x16C8
#define unicode_RUNIC_LETTER_ALGIZ_EOLHX                              0x16C9
#define unicode_RUNIC_LETTER_SOWILO_S                                 0x16CA
#define unicode_RUNIC_LETTER_SIGEL_LONG_BRANCH_SOL_S                  0x16CB
#define unicode_RUNIC_LETTER_SHORT_TWIG_SOL_S                         0x16CC
#define unicode_RUNIC_LETTER_C                                        0x16CD
#define unicode_RUNIC_LETTER_Z                                        0x16CE
#define unicode_RUNIC_LETTER_TIWAZ_TIR_TYR_T                          0x16CF
#define unicode_RUNIC_LETTER_SHORT_TWIG_TYR_T                         0x16D0
#define unicode_RUNIC_LETTER_D                                        0x16D1
#define unicode_RUNIC_LETTER_BERKANAN_BEORC_BJARKAN_B                 0x16D2
#define unicode_RUNIC_LETTER_SHORT_TWIG_BJARKAN_B                     0x16D3
#define unicode_RUNIC_LETTER_DOTTED_P                                 0x16D4
#define unicode_RUNIC_LETTER_OPEN_P                                   0x16D5
#define unicode_RUNIC_LETTER_EHWAZ_EH_E                               0x16D6
#define unicode_RUNIC_LETTER_MANNAZ_MAN_M                             0x16D7
#define unicode_RUNIC_LETTER_LONG_BRANCH_MADR_M                       0x16D8
#define unicode_RUNIC_LETTER_SHORT_TWIG_MADR_M                        0x16D9
#define unicode_RUNIC_LETTER_LAUKAZ_LAGU_LOGR_L                       0x16DA
#define unicode_RUNIC_LETTER_DOTTED_L                                 0x16DB
#define unicode_RUNIC_LETTER_INGWAZ                                   0x16DC
#define unicode_RUNIC_LETTER_ING                                      0x16DD
#define unicode_RUNIC_LETTER_DAGAZ_DAEG_D                             0x16DE
#define unicode_RUNIC_LETTER_OTHALAN_ETHEL_O                          0x16DF
#define unicode_RUNIC_LETTER_EAR                                      0x16E0
#define unicode_RUNIC_LETTER_IOR                                      0x16E1
#define unicode_RUNIC_LETTER_CWEORTH                                  0x16E2
#define unicode_RUNIC_LETTER_CALC                                     0x16E3
#define unicode_RUNIC_LETTER_CEALC                                    0x16E4
#define unicode_RUNIC_LETTER_STAN                                     0x16E5
#define unicode_RUNIC_LETTER_LONG_BRANCH_YR                           0x16E6
#define unicode_RUNIC_LETTER_SHORT_TWIG_YR                            0x16E7
#define unicode_RUNIC_LETTER_ICELANDIC_YR                             0x16E8
#define unicode_RUNIC_LETTER_Q                                        0x16E9
#define unicode_RUNIC_LETTER_X                                        0x16EA
#define unicode_RUNIC_SINGLE_PUNCTUATION                              0x16EB
#define unicode_RUNIC_MULTIPLE_PUNCTUATION                            0x16EC
#define unicode_RUNIC_CROSS_PUNCTUATION                               0x16ED
#define unicode_RUNIC_ARLAUG_SYMBOL                                   0x16EE
#define unicode_RUNIC_TVIMADUR_SYMBOL                                 0x16EF
#define unicode_RUNIC_BELGTHOR_SYMBOL                                 0x16F0
#define unicode_RUNIC_LETTER_K                                        0x16F1
#define unicode_RUNIC_LETTER_SH                                       0x16F2
#define unicode_RUNIC_LETTER_OO                                       0x16F3
#define unicode_RUNIC_LETTER_FRANKS_CASKET_OS                         0x16F4
#define unicode_RUNIC_LETTER_FRANKS_CASKET_IS                         0x16F5
#define unicode_RUNIC_LETTER_FRANKS_CASKET_EH                         0x16F6
#define unicode_RUNIC_LETTER_FRANKS_CASKET_AC                         0x16F7
#define unicode_RUNIC_LETTER_FRANKS_CASKET_AESC                       0x16F8
#define unicode_TAGALOG_LETTER_A                                      0x1700
#define unicode_TAGALOG_LETTER_I                                      0x1701
#define unicode_TAGALOG_LETTER_U                                      0x1702
#define unicode_TAGALOG_LETTER_KA                                     0x1703
#define unicode_TAGALOG_LETTER_GA                                     0x1704
#define unicode_TAGALOG_LETTER_NGA                                    0x1705
#define unicode_TAGALOG_LETTER_TA                                     0x1706
#define unicode_TAGALOG_LETTER_DA                                     0x1707
#define unicode_TAGALOG_LETTER_NA                                     0x1708
#define unicode_TAGALOG_LETTER_PA                                     0x1709
#define unicode_TAGALOG_LETTER_BA                                     0x170A
#define unicode_TAGALOG_LETTER_MA                                     0x170B
#define unicode_TAGALOG_LETTER_YA                                     0x170C
#define unicode_TAGALOG_LETTER_LA                                     0x170E
#define unicode_TAGALOG_LETTER_WA                                     0x170F
#define unicode_TAGALOG_LETTER_SA                                     0x1710
#define unicode_TAGALOG_LETTER_HA                                     0x1711
#define unicode_TAGALOG_VOWEL_SIGN_I                                  0x1712
#define unicode_TAGALOG_VOWEL_SIGN_U                                  0x1713
#define unicode_TAGALOG_SIGN_VIRAMA                                   0x1714
#define unicode_HANUNOO_LETTER_A                                      0x1720
#define unicode_HANUNOO_LETTER_I                                      0x1721
#define unicode_HANUNOO_LETTER_U                                      0x1722
#define unicode_HANUNOO_LETTER_KA                                     0x1723
#define unicode_HANUNOO_LETTER_GA                                     0x1724
#define unicode_HANUNOO_LETTER_NGA                                    0x1725
#define unicode_HANUNOO_LETTER_TA                                     0x1726
#define unicode_HANUNOO_LETTER_DA                                     0x1727
#define unicode_HANUNOO_LETTER_NA                                     0x1728
#define unicode_HANUNOO_LETTER_PA                                     0x1729
#define unicode_HANUNOO_LETTER_BA                                     0x172A
#define unicode_HANUNOO_LETTER_MA                                     0x172B
#define unicode_HANUNOO_LETTER_YA                                     0x172C
#define unicode_HANUNOO_LETTER_RA                                     0x172D
#define unicode_HANUNOO_LETTER_LA                                     0x172E
#define unicode_HANUNOO_LETTER_WA                                     0x172F
#define unicode_HANUNOO_LETTER_SA                                     0x1730
#define unicode_HANUNOO_LETTER_HA                                     0x1731
#define unicode_HANUNOO_VOWEL_SIGN_I                                  0x1732
#define unicode_HANUNOO_VOWEL_SIGN_U                                  0x1733
#define unicode_HANUNOO_SIGN_PAMUDPOD                                 0x1734
#define unicode_PHILIPPINE_SINGLE_PUNCTUATION                         0x1735
#define unicode_PHILIPPINE_DOUBLE_PUNCTUATION                         0x1736
#define unicode_BUHID_LETTER_A                                        0x1740
#define unicode_BUHID_LETTER_I                                        0x1741
#define unicode_BUHID_LETTER_U                                        0x1742
#define unicode_BUHID_LETTER_KA                                       0x1743
#define unicode_BUHID_LETTER_GA                                       0x1744
#define unicode_BUHID_LETTER_NGA                                      0x1745
#define unicode_BUHID_LETTER_TA                                       0x1746
#define unicode_BUHID_LETTER_DA                                       0x1747
#define unicode_BUHID_LETTER_NA                                       0x1748
#define unicode_BUHID_LETTER_PA                                       0x1749
#define unicode_BUHID_LETTER_BA                                       0x174A
#define unicode_BUHID_LETTER_MA                                       0x174B
#define unicode_BUHID_LETTER_YA                                       0x174C
#define unicode_BUHID_LETTER_RA                                       0x174D
#define unicode_BUHID_LETTER_LA                                       0x174E
#define unicode_BUHID_LETTER_WA                                       0x174F
#define unicode_BUHID_LETTER_SA                                       0x1750
#define unicode_BUHID_LETTER_HA                                       0x1751
#define unicode_BUHID_VOWEL_SIGN_I                                    0x1752
#define unicode_BUHID_VOWEL_SIGN_U                                    0x1753
#define unicode_TAGBANWA_LETTER_A                                     0x1760
#define unicode_TAGBANWA_LETTER_I                                     0x1761
#define unicode_TAGBANWA_LETTER_U                                     0x1762
#define unicode_TAGBANWA_LETTER_KA                                    0x1763
#define unicode_TAGBANWA_LETTER_GA                                    0x1764
#define unicode_TAGBANWA_LETTER_NGA                                   0x1765
#define unicode_TAGBANWA_LETTER_TA                                    0x1766
#define unicode_TAGBANWA_LETTER_DA                                    0x1767
#define unicode_TAGBANWA_LETTER_NA                                    0x1768
#define unicode_TAGBANWA_LETTER_PA                                    0x1769
#define unicode_TAGBANWA_LETTER_BA                                    0x176A
#define unicode_TAGBANWA_LETTER_MA                                    0x176B
#define unicode_TAGBANWA_LETTER_YA                                    0x176C
#define unicode_TAGBANWA_LETTER_LA                                    0x176E
#define unicode_TAGBANWA_LETTER_WA                                    0x176F
#define unicode_TAGBANWA_LETTER_SA                                    0x1770
#define unicode_TAGBANWA_VOWEL_SIGN_I                                 0x1772
#define unicode_TAGBANWA_VOWEL_SIGN_U                                 0x1773
#define unicode_KHMER_LETTER_KA                                       0x1780
#define unicode_KHMER_LETTER_KHA                                      0x1781
#define unicode_KHMER_LETTER_KO                                       0x1782
#define unicode_KHMER_LETTER_KHO                                      0x1783
#define unicode_KHMER_LETTER_NGO                                      0x1784
#define unicode_KHMER_LETTER_CA                                       0x1785
#define unicode_KHMER_LETTER_CHA                                      0x1786
#define unicode_KHMER_LETTER_CO                                       0x1787
#define unicode_KHMER_LETTER_CHO                                      0x1788
#define unicode_KHMER_LETTER_NYO                                      0x1789
#define unicode_KHMER_LETTER_DA                                       0x178A
#define unicode_KHMER_LETTER_TTHA                                     0x178B
#define unicode_KHMER_LETTER_DO                                       0x178C
#define unicode_KHMER_LETTER_TTHO                                     0x178D
#define unicode_KHMER_LETTER_NNO                                      0x178E
#define unicode_KHMER_LETTER_TA                                       0x178F
#define unicode_KHMER_LETTER_THA                                      0x1790
#define unicode_KHMER_LETTER_TO                                       0x1791
#define unicode_KHMER_LETTER_THO                                      0x1792
#define unicode_KHMER_LETTER_NO                                       0x1793
#define unicode_KHMER_LETTER_BA                                       0x1794
#define unicode_KHMER_LETTER_PHA                                      0x1795
#define unicode_KHMER_LETTER_PO                                       0x1796
#define unicode_KHMER_LETTER_PHO                                      0x1797
#define unicode_KHMER_LETTER_MO                                       0x1798
#define unicode_KHMER_LETTER_YO                                       0x1799
#define unicode_KHMER_LETTER_RO                                       0x179A
#define unicode_KHMER_LETTER_LO                                       0x179B
#define unicode_KHMER_LETTER_VO                                       0x179C
#define unicode_KHMER_LETTER_SHA                                      0x179D
#define unicode_KHMER_LETTER_SSO                                      0x179E
#define unicode_KHMER_LETTER_SA                                       0x179F
#define unicode_KHMER_LETTER_HA                                       0x17A0
#define unicode_KHMER_LETTER_LA                                       0x17A1
#define unicode_KHMER_LETTER_QA                                       0x17A2
#define unicode_KHMER_INDEPENDENT_VOWEL_QAQ                           0x17A3
#define unicode_KHMER_INDEPENDENT_VOWEL_QAA                           0x17A4
#define unicode_KHMER_INDEPENDENT_VOWEL_QI                            0x17A5
#define unicode_KHMER_INDEPENDENT_VOWEL_QII                           0x17A6
#define unicode_KHMER_INDEPENDENT_VOWEL_QU                            0x17A7
#define unicode_KHMER_INDEPENDENT_VOWEL_QUK                           0x17A8
#define unicode_KHMER_INDEPENDENT_VOWEL_QUU                           0x17A9
#define unicode_KHMER_INDEPENDENT_VOWEL_QUUV                          0x17AA
#define unicode_KHMER_INDEPENDENT_VOWEL_RY                            0x17AB
#define unicode_KHMER_INDEPENDENT_VOWEL_RYY                           0x17AC
#define unicode_KHMER_INDEPENDENT_VOWEL_LY                            0x17AD
#define unicode_KHMER_INDEPENDENT_VOWEL_LYY                           0x17AE
#define unicode_KHMER_INDEPENDENT_VOWEL_QE                            0x17AF
#define unicode_KHMER_INDEPENDENT_VOWEL_QAI                           0x17B0
#define unicode_KHMER_INDEPENDENT_VOWEL_QOO_TYPE_ONE                  0x17B1
#define unicode_KHMER_INDEPENDENT_VOWEL_QOO_TYPE_TWO                  0x17B2
#define unicode_KHMER_INDEPENDENT_VOWEL_QAU                           0x17B3
#define unicode_KHMER_VOWEL_INHERENT_AQ                               0x17B4
#define unicode_KHMER_VOWEL_INHERENT_AA                               0x17B5
#define unicode_KHMER_VOWEL_SIGN_AA                                   0x17B6
#define unicode_KHMER_VOWEL_SIGN_I                                    0x17B7
#define unicode_KHMER_VOWEL_SIGN_II                                   0x17B8
#define unicode_KHMER_VOWEL_SIGN_Y                                    0x17B9
#define unicode_KHMER_VOWEL_SIGN_YY                                   0x17BA
#define unicode_KHMER_VOWEL_SIGN_U                                    0x17BB
#define unicode_KHMER_VOWEL_SIGN_UU                                   0x17BC
#define unicode_KHMER_VOWEL_SIGN_UA                                   0x17BD
#define unicode_KHMER_VOWEL_SIGN_OE                                   0x17BE
#define unicode_KHMER_VOWEL_SIGN_YA                                   0x17BF
#define unicode_KHMER_VOWEL_SIGN_IE                                   0x17C0
#define unicode_KHMER_VOWEL_SIGN_E                                    0x17C1
#define unicode_KHMER_VOWEL_SIGN_AE                                   0x17C2
#define unicode_KHMER_VOWEL_SIGN_AI                                   0x17C3
#define unicode_KHMER_VOWEL_SIGN_OO                                   0x17C4
#define unicode_KHMER_VOWEL_SIGN_AU                                   0x17C5
#define unicode_KHMER_SIGN_NIKAHIT                                    0x17C6
#define unicode_KHMER_SIGN_REAHMUK                                    0x17C7
#define unicode_KHMER_SIGN_YUUKALEAPINTU                              0x17C8
#define unicode_KHMER_SIGN_MUUSIKATOAN                                0x17C9
#define unicode_KHMER_SIGN_TRIISAP                                    0x17CA
#define unicode_KHMER_SIGN_BANTOC                                     0x17CB
#define unicode_KHMER_SIGN_ROBAT                                      0x17CC
#define unicode_KHMER_SIGN_TOANDAKHIAT                                0x17CD
#define unicode_KHMER_SIGN_KAKABAT                                    0x17CE
#define unicode_KHMER_SIGN_AHSDA                                      0x17CF
#define unicode_KHMER_SIGN_SAMYOK_SANNYA                              0x17D0
#define unicode_KHMER_SIGN_VIRIAM                                     0x17D1
#define unicode_KHMER_SIGN_COENG                                      0x17D2
#define unicode_KHMER_SIGN_BATHAMASAT                                 0x17D3
#define unicode_KHMER_SIGN_KHAN                                       0x17D4
#define unicode_KHMER_SIGN_BARIYOOSAN                                 0x17D5
#define unicode_KHMER_SIGN_CAMNUC_PII_KUUH                            0x17D6
#define unicode_KHMER_SIGN_LEK_TOO                                    0x17D7
#define unicode_KHMER_SIGN_BEYYAL                                     0x17D8
#define unicode_KHMER_SIGN_PHNAEK_MUAN                                0x17D9
#define unicode_KHMER_SIGN_KOOMUUT                                    0x17DA
#define unicode_KHMER_CURRENCY_SYMBOL_RIEL                            0x17DB
#define unicode_KHMER_SIGN_AVAKRAHASANYA                              0x17DC
#define unicode_KHMER_SIGN_ATTHACAN                                   0x17DD
#define unicode_KHMER_DIGIT_ZERO                                      0x17E0
#define unicode_KHMER_DIGIT_ONE                                       0x17E1
#define unicode_KHMER_DIGIT_TWO                                       0x17E2
#define unicode_KHMER_DIGIT_THREE                                     0x17E3
#define unicode_KHMER_DIGIT_FOUR                                      0x17E4
#define unicode_KHMER_DIGIT_FIVE                                      0x17E5
#define unicode_KHMER_DIGIT_SIX                                       0x17E6
#define unicode_KHMER_DIGIT_SEVEN                                     0x17E7
#define unicode_KHMER_DIGIT_EIGHT                                     0x17E8
#define unicode_KHMER_DIGIT_NINE                                      0x17E9
#define unicode_KHMER_SYMBOL_LEK_ATTAK_SON                            0x17F0
#define unicode_KHMER_SYMBOL_LEK_ATTAK_MUOY                           0x17F1
#define unicode_KHMER_SYMBOL_LEK_ATTAK_PII                            0x17F2
#define unicode_KHMER_SYMBOL_LEK_ATTAK_BEI                            0x17F3
#define unicode_KHMER_SYMBOL_LEK_ATTAK_BUON                           0x17F4
#define unicode_KHMER_SYMBOL_LEK_ATTAK_PRAM                           0x17F5
#define unicode_KHMER_SYMBOL_LEK_ATTAK_PRAM_MUOY                      0x17F6
#define unicode_KHMER_SYMBOL_LEK_ATTAK_PRAM_PII                       0x17F7
#define unicode_KHMER_SYMBOL_LEK_ATTAK_PRAM_BEI                       0x17F8
#define unicode_KHMER_SYMBOL_LEK_ATTAK_PRAM_BUON                      0x17F9
#define unicode_MONGOLIAN_BIRGA                                       0x1800
#define unicode_MONGOLIAN_ELLIPSIS                                    0x1801
#define unicode_MONGOLIAN_COMMA                                       0x1802
#define unicode_MONGOLIAN_FULL_STOP                                   0x1803
#define unicode_MONGOLIAN_COLON                                       0x1804
#define unicode_MONGOLIAN_FOUR_DOTS                                   0x1805
#define unicode_MONGOLIAN_TODO_SOFT_HYPHEN                            0x1806
#define unicode_MONGOLIAN_SIBE_SYLLABLE_BOUNDARY_MARKER               0x1807
#define unicode_MONGOLIAN_MANCHU_COMMA                                0x1808
#define unicode_MONGOLIAN_MANCHU_FULL_STOP                            0x1809
#define unicode_MONGOLIAN_NIRUGU                                      0x180A
#define unicode_MONGOLIAN_FREE_VARIATION_SELECTOR_ONE                 0x180B
#define unicode_MONGOLIAN_FREE_VARIATION_SELECTOR_TWO                 0x180C
#define unicode_MONGOLIAN_FREE_VARIATION_SELECTOR_THREE               0x180D
#define unicode_MONGOLIAN_VOWEL_SEPARATOR                             0x180E
#define unicode_MONGOLIAN_DIGIT_ZERO                                  0x1810
#define unicode_MONGOLIAN_DIGIT_ONE                                   0x1811
#define unicode_MONGOLIAN_DIGIT_TWO                                   0x1812
#define unicode_MONGOLIAN_DIGIT_THREE                                 0x1813
#define unicode_MONGOLIAN_DIGIT_FOUR                                  0x1814
#define unicode_MONGOLIAN_DIGIT_FIVE                                  0x1815
#define unicode_MONGOLIAN_DIGIT_SIX                                   0x1816
#define unicode_MONGOLIAN_DIGIT_SEVEN                                 0x1817
#define unicode_MONGOLIAN_DIGIT_EIGHT                                 0x1818
#define unicode_MONGOLIAN_DIGIT_NINE                                  0x1819
#define unicode_MONGOLIAN_LETTER_A                                    0x1820
#define unicode_MONGOLIAN_LETTER_E                                    0x1821
#define unicode_MONGOLIAN_LETTER_I                                    0x1822
#define unicode_MONGOLIAN_LETTER_O                                    0x1823
#define unicode_MONGOLIAN_LETTER_U                                    0x1824
#define unicode_MONGOLIAN_LETTER_OE                                   0x1825
#define unicode_MONGOLIAN_LETTER_UE                                   0x1826
#define unicode_MONGOLIAN_LETTER_EE                                   0x1827
#define unicode_MONGOLIAN_LETTER_NA                                   0x1828
#define unicode_MONGOLIAN_LETTER_ANG                                  0x1829
#define unicode_MONGOLIAN_LETTER_BA                                   0x182A
#define unicode_MONGOLIAN_LETTER_PA                                   0x182B
#define unicode_MONGOLIAN_LETTER_QA                                   0x182C
#define unicode_MONGOLIAN_LETTER_GA                                   0x182D
#define unicode_MONGOLIAN_LETTER_MA                                   0x182E
#define unicode_MONGOLIAN_LETTER_LA                                   0x182F
#define unicode_MONGOLIAN_LETTER_SA                                   0x1830
#define unicode_MONGOLIAN_LETTER_SHA                                  0x1831
#define unicode_MONGOLIAN_LETTER_TA                                   0x1832
#define unicode_MONGOLIAN_LETTER_DA                                   0x1833
#define unicode_MONGOLIAN_LETTER_CHA                                  0x1834
#define unicode_MONGOLIAN_LETTER_JA                                   0x1835
#define unicode_MONGOLIAN_LETTER_YA                                   0x1836
#define unicode_MONGOLIAN_LETTER_RA                                   0x1837
#define unicode_MONGOLIAN_LETTER_WA                                   0x1838
#define unicode_MONGOLIAN_LETTER_FA                                   0x1839
#define unicode_MONGOLIAN_LETTER_KA                                   0x183A
#define unicode_MONGOLIAN_LETTER_KHA                                  0x183B
#define unicode_MONGOLIAN_LETTER_TSA                                  0x183C
#define unicode_MONGOLIAN_LETTER_ZA                                   0x183D
#define unicode_MONGOLIAN_LETTER_HAA                                  0x183E
#define unicode_MONGOLIAN_LETTER_ZRA                                  0x183F
#define unicode_MONGOLIAN_LETTER_LHA                                  0x1840
#define unicode_MONGOLIAN_LETTER_ZHI                                  0x1841
#define unicode_MONGOLIAN_LETTER_CHI                                  0x1842
#define unicode_MONGOLIAN_LETTER_TODO_LONG_VOWEL_SIGN                 0x1843
#define unicode_MONGOLIAN_LETTER_TODO_E                               0x1844
#define unicode_MONGOLIAN_LETTER_TODO_I                               0x1845
#define unicode_MONGOLIAN_LETTER_TODO_O                               0x1846
#define unicode_MONGOLIAN_LETTER_TODO_U                               0x1847
#define unicode_MONGOLIAN_LETTER_TODO_OE                              0x1848
#define unicode_MONGOLIAN_LETTER_TODO_UE                              0x1849
#define unicode_MONGOLIAN_LETTER_TODO_ANG                             0x184A
#define unicode_MONGOLIAN_LETTER_TODO_BA                              0x184B
#define unicode_MONGOLIAN_LETTER_TODO_PA                              0x184C
#define unicode_MONGOLIAN_LETTER_TODO_QA                              0x184D
#define unicode_MONGOLIAN_LETTER_TODO_GA                              0x184E
#define unicode_MONGOLIAN_LETTER_TODO_MA                              0x184F
#define unicode_MONGOLIAN_LETTER_TODO_TA                              0x1850
#define unicode_MONGOLIAN_LETTER_TODO_DA                              0x1851
#define unicode_MONGOLIAN_LETTER_TODO_CHA                             0x1852
#define unicode_MONGOLIAN_LETTER_TODO_JA                              0x1853
#define unicode_MONGOLIAN_LETTER_TODO_TSA                             0x1854
#define unicode_MONGOLIAN_LETTER_TODO_YA                              0x1855
#define unicode_MONGOLIAN_LETTER_TODO_WA                              0x1856
#define unicode_MONGOLIAN_LETTER_TODO_KA                              0x1857
#define unicode_MONGOLIAN_LETTER_TODO_GAA                             0x1858
#define unicode_MONGOLIAN_LETTER_TODO_HAA                             0x1859
#define unicode_MONGOLIAN_LETTER_TODO_JIA                             0x185A
#define unicode_MONGOLIAN_LETTER_TODO_NIA                             0x185B
#define unicode_MONGOLIAN_LETTER_TODO_DZA                             0x185C
#define unicode_MONGOLIAN_LETTER_SIBE_E                               0x185D
#define unicode_MONGOLIAN_LETTER_SIBE_I                               0x185E
#define unicode_MONGOLIAN_LETTER_SIBE_IY                              0x185F
#define unicode_MONGOLIAN_LETTER_SIBE_UE                              0x1860
#define unicode_MONGOLIAN_LETTER_SIBE_U                               0x1861
#define unicode_MONGOLIAN_LETTER_SIBE_ANG                             0x1862
#define unicode_MONGOLIAN_LETTER_SIBE_KA                              0x1863
#define unicode_MONGOLIAN_LETTER_SIBE_GA                              0x1864
#define unicode_MONGOLIAN_LETTER_SIBE_HA                              0x1865
#define unicode_MONGOLIAN_LETTER_SIBE_PA                              0x1866
#define unicode_MONGOLIAN_LETTER_SIBE_SHA                             0x1867
#define unicode_MONGOLIAN_LETTER_SIBE_TA                              0x1868
#define unicode_MONGOLIAN_LETTER_SIBE_DA                              0x1869
#define unicode_MONGOLIAN_LETTER_SIBE_JA                              0x186A
#define unicode_MONGOLIAN_LETTER_SIBE_FA                              0x186B
#define unicode_MONGOLIAN_LETTER_SIBE_GAA                             0x186C
#define unicode_MONGOLIAN_LETTER_SIBE_HAA                             0x186D
#define unicode_MONGOLIAN_LETTER_SIBE_TSA                             0x186E
#define unicode_MONGOLIAN_LETTER_SIBE_ZA                              0x186F
#define unicode_MONGOLIAN_LETTER_SIBE_RAA                             0x1870
#define unicode_MONGOLIAN_LETTER_SIBE_CHA                             0x1871
#define unicode_MONGOLIAN_LETTER_SIBE_ZHA                             0x1872
#define unicode_MONGOLIAN_LETTER_MANCHU_I                             0x1873
#define unicode_MONGOLIAN_LETTER_MANCHU_KA                            0x1874
#define unicode_MONGOLIAN_LETTER_MANCHU_RA                            0x1875
#define unicode_MONGOLIAN_LETTER_MANCHU_FA                            0x1876
#define unicode_MONGOLIAN_LETTER_MANCHU_ZHA                           0x1877
#define unicode_MONGOLIAN_LETTER_ALI_GALI_ANUSVARA_ONE                0x1880
#define unicode_MONGOLIAN_LETTER_ALI_GALI_VISARGA_ONE                 0x1881
#define unicode_MONGOLIAN_LETTER_ALI_GALI_DAMARU                      0x1882
#define unicode_MONGOLIAN_LETTER_ALI_GALI_UBADAMA                     0x1883
#define unicode_MONGOLIAN_LETTER_ALI_GALI_INVERTED_UBADAMA            0x1884
#define unicode_MONGOLIAN_LETTER_ALI_GALI_BALUDA                      0x1885
#define unicode_MONGOLIAN_LETTER_ALI_GALI_THREE_BALUDA                0x1886
#define unicode_MONGOLIAN_LETTER_ALI_GALI_A                           0x1887
#define unicode_MONGOLIAN_LETTER_ALI_GALI_I                           0x1888
#define unicode_MONGOLIAN_LETTER_ALI_GALI_KA                          0x1889
#define unicode_MONGOLIAN_LETTER_ALI_GALI_NGA                         0x188A
#define unicode_MONGOLIAN_LETTER_ALI_GALI_CA                          0x188B
#define unicode_MONGOLIAN_LETTER_ALI_GALI_TTA                         0x188C
#define unicode_MONGOLIAN_LETTER_ALI_GALI_TTHA                        0x188D
#define unicode_MONGOLIAN_LETTER_ALI_GALI_DDA                         0x188E
#define unicode_MONGOLIAN_LETTER_ALI_GALI_NNA                         0x188F
#define unicode_MONGOLIAN_LETTER_ALI_GALI_TA                          0x1890
#define unicode_MONGOLIAN_LETTER_ALI_GALI_DA                          0x1891
#define unicode_MONGOLIAN_LETTER_ALI_GALI_PA                          0x1892
#define unicode_MONGOLIAN_LETTER_ALI_GALI_PHA                         0x1893
#define unicode_MONGOLIAN_LETTER_ALI_GALI_SSA                         0x1894
#define unicode_MONGOLIAN_LETTER_ALI_GALI_ZHA                         0x1895
#define unicode_MONGOLIAN_LETTER_ALI_GALI_ZA                          0x1896
#define unicode_MONGOLIAN_LETTER_ALI_GALI_AH                          0x1897
#define unicode_MONGOLIAN_LETTER_TODO_ALI_GALI_TA                     0x1898
#define unicode_MONGOLIAN_LETTER_TODO_ALI_GALI_ZHA                    0x1899
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_GHA                  0x189A
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_NGA                  0x189B
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_CA                   0x189C
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_JHA                  0x189D
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_TTA                  0x189E
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_DDHA                 0x189F
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_TA                   0x18A0
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_DHA                  0x18A1
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_SSA                  0x18A2
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_CYA                  0x18A3
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_ZHA                  0x18A4
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_ZA                   0x18A5
#define unicode_MONGOLIAN_LETTER_ALI_GALI_HALF_U                      0x18A6
#define unicode_MONGOLIAN_LETTER_ALI_GALI_HALF_YA                     0x18A7
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_BHA                  0x18A8
#define unicode_MONGOLIAN_LETTER_ALI_GALI_DAGALGA                     0x18A9
#define unicode_MONGOLIAN_LETTER_MANCHU_ALI_GALI_LHA                  0x18AA
#define unicode_CANADIAN_SYLLABICS_OY                                 0x18B0
#define unicode_CANADIAN_SYLLABICS_AY                                 0x18B1
#define unicode_CANADIAN_SYLLABICS_AAY                                0x18B2
#define unicode_CANADIAN_SYLLABICS_WAY                                0x18B3
#define unicode_CANADIAN_SYLLABICS_POY                                0x18B4
#define unicode_CANADIAN_SYLLABICS_PAY                                0x18B5
#define unicode_CANADIAN_SYLLABICS_PWOY                               0x18B6
#define unicode_CANADIAN_SYLLABICS_TAY                                0x18B7
#define unicode_CANADIAN_SYLLABICS_KAY                                0x18B8
#define unicode_CANADIAN_SYLLABICS_KWAY                               0x18B9
#define unicode_CANADIAN_SYLLABICS_MAY                                0x18BA
#define unicode_CANADIAN_SYLLABICS_NOY                                0x18BB
#define unicode_CANADIAN_SYLLABICS_NAY                                0x18BC
#define unicode_CANADIAN_SYLLABICS_LAY                                0x18BD
#define unicode_CANADIAN_SYLLABICS_SOY                                0x18BE
#define unicode_CANADIAN_SYLLABICS_SAY                                0x18BF
#define unicode_CANADIAN_SYLLABICS_SHOY                               0x18C0
#define unicode_CANADIAN_SYLLABICS_SHAY                               0x18C1
#define unicode_CANADIAN_SYLLABICS_SHWOY                              0x18C2
#define unicode_CANADIAN_SYLLABICS_YOY                                0x18C3
#define unicode_CANADIAN_SYLLABICS_YAY                                0x18C4
#define unicode_CANADIAN_SYLLABICS_RAY                                0x18C5
#define unicode_CANADIAN_SYLLABICS_NWI                                0x18C6
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_NWI                        0x18C7
#define unicode_CANADIAN_SYLLABICS_NWII                               0x18C8
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_NWII                       0x18C9
#define unicode_CANADIAN_SYLLABICS_NWO                                0x18CA
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_NWO                        0x18CB
#define unicode_CANADIAN_SYLLABICS_NWOO                               0x18CC
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_NWOO                       0x18CD
#define unicode_CANADIAN_SYLLABICS_RWEE                               0x18CE
#define unicode_CANADIAN_SYLLABICS_RWI                                0x18CF
#define unicode_CANADIAN_SYLLABICS_RWII                               0x18D0
#define unicode_CANADIAN_SYLLABICS_RWO                                0x18D1
#define unicode_CANADIAN_SYLLABICS_RWOO                               0x18D2
#define unicode_CANADIAN_SYLLABICS_RWA                                0x18D3
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_P                          0x18D4
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_T                          0x18D5
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_K                          0x18D6
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_C                          0x18D7
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_M                          0x18D8
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_N                          0x18D9
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_S                          0x18DA
#define unicode_CANADIAN_SYLLABICS_OJIBWAY_SH                         0x18DB
#define unicode_CANADIAN_SYLLABICS_EASTERN_W                          0x18DC
#define unicode_CANADIAN_SYLLABICS_WESTERN_W                          0x18DD
#define unicode_CANADIAN_SYLLABICS_FINAL_SMALL_RING                   0x18DE
#define unicode_CANADIAN_SYLLABICS_FINAL_RAISED_DOT                   0x18DF
#define unicode_CANADIAN_SYLLABICS_R_CREE_RWE                         0x18E0
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LOO                      0x18E1
#define unicode_CANADIAN_SYLLABICS_WEST_CREE_LAA                      0x18E2
#define unicode_CANADIAN_SYLLABICS_THWE                               0x18E3
#define unicode_CANADIAN_SYLLABICS_THWA                               0x18E4
#define unicode_CANADIAN_SYLLABICS_TTHWE                              0x18E5
#define unicode_CANADIAN_SYLLABICS_TTHOO                              0x18E6
#define unicode_CANADIAN_SYLLABICS_TTHAA                              0x18E7
#define unicode_CANADIAN_SYLLABICS_TLHWE                              0x18E8
#define unicode_CANADIAN_SYLLABICS_TLHOO                              0x18E9
#define unicode_CANADIAN_SYLLABICS_SAYISI_SHWE                        0x18EA
#define unicode_CANADIAN_SYLLABICS_SAYISI_SHOO                        0x18EB
#define unicode_CANADIAN_SYLLABICS_SAYISI_HOO                         0x18EC
#define unicode_CANADIAN_SYLLABICS_CARRIER_GWU                        0x18ED
#define unicode_CANADIAN_SYLLABICS_CARRIER_DENE_GEE                   0x18EE
#define unicode_CANADIAN_SYLLABICS_CARRIER_GAA                        0x18EF
#define unicode_CANADIAN_SYLLABICS_CARRIER_GWA                        0x18F0
#define unicode_CANADIAN_SYLLABICS_SAYISI_JUU                         0x18F1
#define unicode_CANADIAN_SYLLABICS_CARRIER_JWA                        0x18F2
#define unicode_CANADIAN_SYLLABICS_BEAVER_DENE_L                      0x18F3
#define unicode_CANADIAN_SYLLABICS_BEAVER_DENE_R                      0x18F4
#define unicode_CANADIAN_SYLLABICS_CARRIER_DENTAL_S                   0x18F5
#define unicode_LIMBU_VOWEL_CARRIER_LETTER                            0x1900
#define unicode_LIMBU_LETTER_KA                                       0x1901
#define unicode_LIMBU_LETTER_KHA                                      0x1902
#define unicode_LIMBU_LETTER_GA                                       0x1903
#define unicode_LIMBU_LETTER_GHA                                      0x1904
#define unicode_LIMBU_LETTER_NGA                                      0x1905
#define unicode_LIMBU_LETTER_CA                                       0x1906
#define unicode_LIMBU_LETTER_CHA                                      0x1907
#define unicode_LIMBU_LETTER_JA                                       0x1908
#define unicode_LIMBU_LETTER_JHA                                      0x1909
#define unicode_LIMBU_LETTER_YAN                                      0x190A
#define unicode_LIMBU_LETTER_TA                                       0x190B
#define unicode_LIMBU_LETTER_THA                                      0x190C
#define unicode_LIMBU_LETTER_DA                                       0x190D
#define unicode_LIMBU_LETTER_DHA                                      0x190E
#define unicode_LIMBU_LETTER_NA                                       0x190F
#define unicode_LIMBU_LETTER_PA                                       0x1910
#define unicode_LIMBU_LETTER_PHA                                      0x1911
#define unicode_LIMBU_LETTER_BA                                       0x1912
#define unicode_LIMBU_LETTER_BHA                                      0x1913
#define unicode_LIMBU_LETTER_MA                                       0x1914
#define unicode_LIMBU_LETTER_YA                                       0x1915
#define unicode_LIMBU_LETTER_RA                                       0x1916
#define unicode_LIMBU_LETTER_LA                                       0x1917
#define unicode_LIMBU_LETTER_WA                                       0x1918
#define unicode_LIMBU_LETTER_SHA                                      0x1919
#define unicode_LIMBU_LETTER_SSA                                      0x191A
#define unicode_LIMBU_LETTER_SA                                       0x191B
#define unicode_LIMBU_LETTER_HA                                       0x191C
#define unicode_LIMBU_LETTER_GYAN                                     0x191D
#define unicode_LIMBU_LETTER_TRA                                      0x191E
#define unicode_LIMBU_VOWEL_SIGN_A                                    0x1920
#define unicode_LIMBU_VOWEL_SIGN_I                                    0x1921
#define unicode_LIMBU_VOWEL_SIGN_U                                    0x1922
#define unicode_LIMBU_VOWEL_SIGN_EE                                   0x1923
#define unicode_LIMBU_VOWEL_SIGN_AI                                   0x1924
#define unicode_LIMBU_VOWEL_SIGN_OO                                   0x1925
#define unicode_LIMBU_VOWEL_SIGN_AU                                   0x1926
#define unicode_LIMBU_VOWEL_SIGN_E                                    0x1927
#define unicode_LIMBU_VOWEL_SIGN_O                                    0x1928
#define unicode_LIMBU_SUBJOINED_LETTER_YA                             0x1929
#define unicode_LIMBU_SUBJOINED_LETTER_RA                             0x192A
#define unicode_LIMBU_SUBJOINED_LETTER_WA                             0x192B
#define unicode_LIMBU_SMALL_LETTER_KA                                 0x1930
#define unicode_LIMBU_SMALL_LETTER_NGA                                0x1931
#define unicode_LIMBU_SMALL_LETTER_ANUSVARA                           0x1932
#define unicode_LIMBU_SMALL_LETTER_TA                                 0x1933
#define unicode_LIMBU_SMALL_LETTER_NA                                 0x1934
#define unicode_LIMBU_SMALL_LETTER_PA                                 0x1935
#define unicode_LIMBU_SMALL_LETTER_MA                                 0x1936
#define unicode_LIMBU_SMALL_LETTER_RA                                 0x1937
#define unicode_LIMBU_SMALL_LETTER_LA                                 0x1938
#define unicode_LIMBU_SIGN_MUKPHRENG                                  0x1939
#define unicode_LIMBU_SIGN_KEMPHRENG                                  0x193A
#define unicode_LIMBU_SIGN_SA_I                                       0x193B
#define unicode_LIMBU_SIGN_LOO                                        0x1940
#define unicode_LIMBU_EXCLAMATION_MARK                                0x1944
#define unicode_LIMBU_QUESTION_MARK                                   0x1945
#define unicode_LIMBU_DIGIT_ZERO                                      0x1946
#define unicode_LIMBU_DIGIT_ONE                                       0x1947
#define unicode_LIMBU_DIGIT_TWO                                       0x1948
#define unicode_LIMBU_DIGIT_THREE                                     0x1949
#define unicode_LIMBU_DIGIT_FOUR                                      0x194A
#define unicode_LIMBU_DIGIT_FIVE                                      0x194B
#define unicode_LIMBU_DIGIT_SIX                                       0x194C
#define unicode_LIMBU_DIGIT_SEVEN                                     0x194D
#define unicode_LIMBU_DIGIT_EIGHT                                     0x194E
#define unicode_LIMBU_DIGIT_NINE                                      0x194F
#define unicode_TAI_LE_LETTER_KA                                      0x1950
#define unicode_TAI_LE_LETTER_XA                                      0x1951
#define unicode_TAI_LE_LETTER_NGA                                     0x1952
#define unicode_TAI_LE_LETTER_TSA                                     0x1953
#define unicode_TAI_LE_LETTER_SA                                      0x1954
#define unicode_TAI_LE_LETTER_YA                                      0x1955
#define unicode_TAI_LE_LETTER_TA                                      0x1956
#define unicode_TAI_LE_LETTER_THA                                     0x1957
#define unicode_TAI_LE_LETTER_LA                                      0x1958
#define unicode_TAI_LE_LETTER_PA                                      0x1959
#define unicode_TAI_LE_LETTER_PHA                                     0x195A
#define unicode_TAI_LE_LETTER_MA                                      0x195B
#define unicode_TAI_LE_LETTER_FA                                      0x195C
#define unicode_TAI_LE_LETTER_VA                                      0x195D
#define unicode_TAI_LE_LETTER_HA                                      0x195E
#define unicode_TAI_LE_LETTER_QA                                      0x195F
#define unicode_TAI_LE_LETTER_KHA                                     0x1960
#define unicode_TAI_LE_LETTER_TSHA                                    0x1961
#define unicode_TAI_LE_LETTER_NA                                      0x1962
#define unicode_TAI_LE_LETTER_A                                       0x1963
#define unicode_TAI_LE_LETTER_I                                       0x1964
#define unicode_TAI_LE_LETTER_EE                                      0x1965
#define unicode_TAI_LE_LETTER_EH                                      0x1966
#define unicode_TAI_LE_LETTER_U                                       0x1967
#define unicode_TAI_LE_LETTER_OO                                      0x1968
#define unicode_TAI_LE_LETTER_O                                       0x1969
#define unicode_TAI_LE_LETTER_UE                                      0x196A
#define unicode_TAI_LE_LETTER_E                                       0x196B
#define unicode_TAI_LE_LETTER_AUE                                     0x196C
#define unicode_TAI_LE_LETTER_AI                                      0x196D
#define unicode_TAI_LE_LETTER_TONE_2                                  0x1970
#define unicode_TAI_LE_LETTER_TONE_3                                  0x1971
#define unicode_TAI_LE_LETTER_TONE_4                                  0x1972
#define unicode_TAI_LE_LETTER_TONE_5                                  0x1973
#define unicode_TAI_LE_LETTER_TONE_6                                  0x1974
#define unicode_NEW_TAI_LUE_LETTER_HIGH_QA                            0x1980
#define unicode_NEW_TAI_LUE_LETTER_LOW_QA                             0x1981
#define unicode_NEW_TAI_LUE_LETTER_HIGH_KA                            0x1982
#define unicode_NEW_TAI_LUE_LETTER_HIGH_XA                            0x1983
#define unicode_NEW_TAI_LUE_LETTER_HIGH_NGA                           0x1984
#define unicode_NEW_TAI_LUE_LETTER_LOW_KA                             0x1985
#define unicode_NEW_TAI_LUE_LETTER_LOW_XA                             0x1986
#define unicode_NEW_TAI_LUE_LETTER_LOW_NGA                            0x1987
#define unicode_NEW_TAI_LUE_LETTER_HIGH_TSA                           0x1988
#define unicode_NEW_TAI_LUE_LETTER_HIGH_SA                            0x1989
#define unicode_NEW_TAI_LUE_LETTER_HIGH_YA                            0x198A
#define unicode_NEW_TAI_LUE_LETTER_LOW_TSA                            0x198B
#define unicode_NEW_TAI_LUE_LETTER_LOW_SA                             0x198C
#define unicode_NEW_TAI_LUE_LETTER_LOW_YA                             0x198D
#define unicode_NEW_TAI_LUE_LETTER_HIGH_TA                            0x198E
#define unicode_NEW_TAI_LUE_LETTER_HIGH_THA                           0x198F
#define unicode_NEW_TAI_LUE_LETTER_HIGH_NA                            0x1990
#define unicode_NEW_TAI_LUE_LETTER_LOW_TA                             0x1991
#define unicode_NEW_TAI_LUE_LETTER_LOW_THA                            0x1992
#define unicode_NEW_TAI_LUE_LETTER_LOW_NA                             0x1993
#define unicode_NEW_TAI_LUE_LETTER_HIGH_PA                            0x1994
#define unicode_NEW_TAI_LUE_LETTER_HIGH_PHA                           0x1995
#define unicode_NEW_TAI_LUE_LETTER_HIGH_MA                            0x1996
#define unicode_NEW_TAI_LUE_LETTER_LOW_PA                             0x1997
#define unicode_NEW_TAI_LUE_LETTER_LOW_PHA                            0x1998
#define unicode_NEW_TAI_LUE_LETTER_LOW_MA                             0x1999
#define unicode_NEW_TAI_LUE_LETTER_HIGH_FA                            0x199A
#define unicode_NEW_TAI_LUE_LETTER_HIGH_VA                            0x199B
#define unicode_NEW_TAI_LUE_LETTER_HIGH_LA                            0x199C
#define unicode_NEW_TAI_LUE_LETTER_LOW_FA                             0x199D
#define unicode_NEW_TAI_LUE_LETTER_LOW_VA                             0x199E
#define unicode_NEW_TAI_LUE_LETTER_LOW_LA                             0x199F
#define unicode_NEW_TAI_LUE_LETTER_HIGH_HA                            0x19A0
#define unicode_NEW_TAI_LUE_LETTER_HIGH_DA                            0x19A1
#define unicode_NEW_TAI_LUE_LETTER_HIGH_BA                            0x19A2
#define unicode_NEW_TAI_LUE_LETTER_LOW_HA                             0x19A3
#define unicode_NEW_TAI_LUE_LETTER_LOW_DA                             0x19A4
#define unicode_NEW_TAI_LUE_LETTER_LOW_BA                             0x19A5
#define unicode_NEW_TAI_LUE_LETTER_HIGH_KVA                           0x19A6
#define unicode_NEW_TAI_LUE_LETTER_HIGH_XVA                           0x19A7
#define unicode_NEW_TAI_LUE_LETTER_LOW_KVA                            0x19A8
#define unicode_NEW_TAI_LUE_LETTER_LOW_XVA                            0x19A9
#define unicode_NEW_TAI_LUE_LETTER_HIGH_SUA                           0x19AA
#define unicode_NEW_TAI_LUE_LETTER_LOW_SUA                            0x19AB
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_VOWEL_SHORTENER                0x19B0
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_AA                             0x19B1
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_II                             0x19B2
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_U                              0x19B3
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_UU                             0x19B4
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_E                              0x19B5
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_AE                             0x19B6
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_O                              0x19B7
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_OA                             0x19B8
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_UE                             0x19B9
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_AY                             0x19BA
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_AAY                            0x19BB
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_UY                             0x19BC
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_OY                             0x19BD
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_OAY                            0x19BE
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_UEY                            0x19BF
#define unicode_NEW_TAI_LUE_VOWEL_SIGN_IY                             0x19C0
#define unicode_NEW_TAI_LUE_LETTER_FINAL_V                            0x19C1
#define unicode_NEW_TAI_LUE_LETTER_FINAL_NG                           0x19C2
#define unicode_NEW_TAI_LUE_LETTER_FINAL_N                            0x19C3
#define unicode_NEW_TAI_LUE_LETTER_FINAL_M                            0x19C4
#define unicode_NEW_TAI_LUE_LETTER_FINAL_K                            0x19C5
#define unicode_NEW_TAI_LUE_LETTER_FINAL_D                            0x19C6
#define unicode_NEW_TAI_LUE_LETTER_FINAL_B                            0x19C7
#define unicode_NEW_TAI_LUE_TONE_MARK_1                               0x19C8
#define unicode_NEW_TAI_LUE_TONE_MARK_2                               0x19C9
#define unicode_NEW_TAI_LUE_DIGIT_ZERO                                0x19D0
#define unicode_NEW_TAI_LUE_DIGIT_ONE                                 0x19D1
#define unicode_NEW_TAI_LUE_DIGIT_TWO                                 0x19D2
#define unicode_NEW_TAI_LUE_DIGIT_THREE                               0x19D3
#define unicode_NEW_TAI_LUE_DIGIT_FOUR                                0x19D4
#define unicode_NEW_TAI_LUE_DIGIT_FIVE                                0x19D5
#define unicode_NEW_TAI_LUE_DIGIT_SIX                                 0x19D6
#define unicode_NEW_TAI_LUE_DIGIT_SEVEN                               0x19D7
#define unicode_NEW_TAI_LUE_DIGIT_EIGHT                               0x19D8
#define unicode_NEW_TAI_LUE_DIGIT_NINE                                0x19D9
#define unicode_NEW_TAI_LUE_THAM_DIGIT_ONE                            0x19DA
#define unicode_NEW_TAI_LUE_SIGN_LAE                                  0x19DE
#define unicode_NEW_TAI_LUE_SIGN_LAEV                                 0x19DF
#define unicode_KHMER_SYMBOL_PATHAMASAT                               0x19E0
#define unicode_KHMER_SYMBOL_MUOY_KOET                                0x19E1
#define unicode_KHMER_SYMBOL_PII_KOET                                 0x19E2
#define unicode_KHMER_SYMBOL_BEI_KOET                                 0x19E3
#define unicode_KHMER_SYMBOL_BUON_KOET                                0x19E4
#define unicode_KHMER_SYMBOL_PRAM_KOET                                0x19E5
#define unicode_KHMER_SYMBOL_PRAM_MUOY_KOET                           0x19E6
#define unicode_KHMER_SYMBOL_PRAM_PII_KOET                            0x19E7
#define unicode_KHMER_SYMBOL_PRAM_BEI_KOET                            0x19E8
#define unicode_KHMER_SYMBOL_PRAM_BUON_KOET                           0x19E9
#define unicode_KHMER_SYMBOL_DAP_KOET                                 0x19EA
#define unicode_KHMER_SYMBOL_DAP_MUOY_KOET                            0x19EB
#define unicode_KHMER_SYMBOL_DAP_PII_KOET                             0x19EC
#define unicode_KHMER_SYMBOL_DAP_BEI_KOET                             0x19ED
#define unicode_KHMER_SYMBOL_DAP_BUON_KOET                            0x19EE
#define unicode_KHMER_SYMBOL_DAP_PRAM_KOET                            0x19EF
#define unicode_KHMER_SYMBOL_TUTEYASAT                                0x19F0
#define unicode_KHMER_SYMBOL_MUOY_ROC                                 0x19F1
#define unicode_KHMER_SYMBOL_PII_ROC                                  0x19F2
#define unicode_KHMER_SYMBOL_BEI_ROC                                  0x19F3
#define unicode_KHMER_SYMBOL_BUON_ROC                                 0x19F4
#define unicode_KHMER_SYMBOL_PRAM_ROC                                 0x19F5
#define unicode_KHMER_SYMBOL_PRAM_MUOY_ROC                            0x19F6
#define unicode_KHMER_SYMBOL_PRAM_PII_ROC                             0x19F7
#define unicode_KHMER_SYMBOL_PRAM_BEI_ROC                             0x19F8
#define unicode_KHMER_SYMBOL_PRAM_BUON_ROC                            0x19F9
#define unicode_KHMER_SYMBOL_DAP_ROC                                  0x19FA
#define unicode_KHMER_SYMBOL_DAP_MUOY_ROC                             0x19FB
#define unicode_KHMER_SYMBOL_DAP_PII_ROC                              0x19FC
#define unicode_KHMER_SYMBOL_DAP_BEI_ROC                              0x19FD
#define unicode_KHMER_SYMBOL_DAP_BUON_ROC                             0x19FE
#define unicode_KHMER_SYMBOL_DAP_PRAM_ROC                             0x19FF
#define unicode_BUGINESE_LETTER_KA                                    0x1A00
#define unicode_BUGINESE_LETTER_GA                                    0x1A01
#define unicode_BUGINESE_LETTER_NGA                                   0x1A02
#define unicode_BUGINESE_LETTER_NGKA                                  0x1A03
#define unicode_BUGINESE_LETTER_PA                                    0x1A04
#define unicode_BUGINESE_LETTER_BA                                    0x1A05
#define unicode_BUGINESE_LETTER_MA                                    0x1A06
#define unicode_BUGINESE_LETTER_MPA                                   0x1A07
#define unicode_BUGINESE_LETTER_TA                                    0x1A08
#define unicode_BUGINESE_LETTER_DA                                    0x1A09
#define unicode_BUGINESE_LETTER_NA                                    0x1A0A
#define unicode_BUGINESE_LETTER_NRA                                   0x1A0B
#define unicode_BUGINESE_LETTER_CA                                    0x1A0C
#define unicode_BUGINESE_LETTER_JA                                    0x1A0D
#define unicode_BUGINESE_LETTER_NYA                                   0x1A0E
#define unicode_BUGINESE_LETTER_NYCA                                  0x1A0F
#define unicode_BUGINESE_LETTER_YA                                    0x1A10
#define unicode_BUGINESE_LETTER_RA                                    0x1A11
#define unicode_BUGINESE_LETTER_LA                                    0x1A12
#define unicode_BUGINESE_LETTER_VA                                    0x1A13
#define unicode_BUGINESE_LETTER_SA                                    0x1A14
#define unicode_BUGINESE_LETTER_A                                     0x1A15
#define unicode_BUGINESE_LETTER_HA                                    0x1A16
#define unicode_BUGINESE_VOWEL_SIGN_I                                 0x1A17
#define unicode_BUGINESE_VOWEL_SIGN_U                                 0x1A18
#define unicode_BUGINESE_VOWEL_SIGN_E                                 0x1A19
#define unicode_BUGINESE_VOWEL_SIGN_O                                 0x1A1A
#define unicode_BUGINESE_VOWEL_SIGN_AE                                0x1A1B
#define unicode_BUGINESE_PALLAWA                                      0x1A1E
#define unicode_BUGINESE_END_OF_SECTION                               0x1A1F
#define unicode_TAI_THAM_LETTER_HIGH_KA                               0x1A20
#define unicode_TAI_THAM_LETTER_HIGH_KHA                              0x1A21
#define unicode_TAI_THAM_LETTER_HIGH_KXA                              0x1A22
#define unicode_TAI_THAM_LETTER_LOW_KA                                0x1A23
#define unicode_TAI_THAM_LETTER_LOW_KXA                               0x1A24
#define unicode_TAI_THAM_LETTER_LOW_KHA                               0x1A25
#define unicode_TAI_THAM_LETTER_NGA                                   0x1A26
#define unicode_TAI_THAM_LETTER_HIGH_CA                               0x1A27
#define unicode_TAI_THAM_LETTER_HIGH_CHA                              0x1A28
#define unicode_TAI_THAM_LETTER_LOW_CA                                0x1A29
#define unicode_TAI_THAM_LETTER_LOW_SA                                0x1A2A
#define unicode_TAI_THAM_LETTER_LOW_CHA                               0x1A2B
#define unicode_TAI_THAM_LETTER_NYA                                   0x1A2C
#define unicode_TAI_THAM_LETTER_RATA                                  0x1A2D
#define unicode_TAI_THAM_LETTER_HIGH_RATHA                            0x1A2E
#define unicode_TAI_THAM_LETTER_DA                                    0x1A2F
#define unicode_TAI_THAM_LETTER_LOW_RATHA                             0x1A30
#define unicode_TAI_THAM_LETTER_RANA                                  0x1A31
#define unicode_TAI_THAM_LETTER_HIGH_TA                               0x1A32
#define unicode_TAI_THAM_LETTER_HIGH_THA                              0x1A33
#define unicode_TAI_THAM_LETTER_LOW_TA                                0x1A34
#define unicode_TAI_THAM_LETTER_LOW_THA                               0x1A35
#define unicode_TAI_THAM_LETTER_NA                                    0x1A36
#define unicode_TAI_THAM_LETTER_BA                                    0x1A37
#define unicode_TAI_THAM_LETTER_HIGH_PA                               0x1A38
#define unicode_TAI_THAM_LETTER_HIGH_PHA                              0x1A39
#define unicode_TAI_THAM_LETTER_HIGH_FA                               0x1A3A
#define unicode_TAI_THAM_LETTER_LOW_PA                                0x1A3B
#define unicode_TAI_THAM_LETTER_LOW_FA                                0x1A3C
#define unicode_TAI_THAM_LETTER_LOW_PHA                               0x1A3D
#define unicode_TAI_THAM_LETTER_MA                                    0x1A3E
#define unicode_TAI_THAM_LETTER_LOW_YA                                0x1A3F
#define unicode_TAI_THAM_LETTER_HIGH_YA                               0x1A40
#define unicode_TAI_THAM_LETTER_RA                                    0x1A41
#define unicode_TAI_THAM_LETTER_RUE                                   0x1A42
#define unicode_TAI_THAM_LETTER_LA                                    0x1A43
#define unicode_TAI_THAM_LETTER_LUE                                   0x1A44
#define unicode_TAI_THAM_LETTER_WA                                    0x1A45
#define unicode_TAI_THAM_LETTER_HIGH_SHA                              0x1A46
#define unicode_TAI_THAM_LETTER_HIGH_SSA                              0x1A47
#define unicode_TAI_THAM_LETTER_HIGH_SA                               0x1A48
#define unicode_TAI_THAM_LETTER_HIGH_HA                               0x1A49
#define unicode_TAI_THAM_LETTER_LLA                                   0x1A4A
#define unicode_TAI_THAM_LETTER_A                                     0x1A4B
#define unicode_TAI_THAM_LETTER_LOW_HA                                0x1A4C
#define unicode_TAI_THAM_LETTER_I                                     0x1A4D
#define unicode_TAI_THAM_LETTER_II                                    0x1A4E
#define unicode_TAI_THAM_LETTER_U                                     0x1A4F
#define unicode_TAI_THAM_LETTER_UU                                    0x1A50
#define unicode_TAI_THAM_LETTER_EE                                    0x1A51
#define unicode_TAI_THAM_LETTER_OO                                    0x1A52
#define unicode_TAI_THAM_LETTER_LAE                                   0x1A53
#define unicode_TAI_THAM_LETTER_GREAT_SA                              0x1A54
#define unicode_TAI_THAM_CONSONANT_SIGN_MEDIAL_RA                     0x1A55
#define unicode_TAI_THAM_CONSONANT_SIGN_MEDIAL_LA                     0x1A56
#define unicode_TAI_THAM_CONSONANT_SIGN_LA_TANG_LAI                   0x1A57
#define unicode_TAI_THAM_SIGN_MAI_KANG_LAI                            0x1A58
#define unicode_TAI_THAM_CONSONANT_SIGN_FINAL_NGA                     0x1A59
#define unicode_TAI_THAM_CONSONANT_SIGN_LOW_PA                        0x1A5A
#define unicode_TAI_THAM_CONSONANT_SIGN_HIGH_RATHA_OR_LOW_PA          0x1A5B
#define unicode_TAI_THAM_CONSONANT_SIGN_MA                            0x1A5C
#define unicode_TAI_THAM_CONSONANT_SIGN_BA                            0x1A5D
#define unicode_TAI_THAM_CONSONANT_SIGN_SA                            0x1A5E
#define unicode_TAI_THAM_SIGN_SAKOT                                   0x1A60
#define unicode_TAI_THAM_VOWEL_SIGN_A                                 0x1A61
#define unicode_TAI_THAM_VOWEL_SIGN_MAI_SAT                           0x1A62
#define unicode_TAI_THAM_VOWEL_SIGN_AA                                0x1A63
#define unicode_TAI_THAM_VOWEL_SIGN_TALL_AA                           0x1A64
#define unicode_TAI_THAM_VOWEL_SIGN_I                                 0x1A65
#define unicode_TAI_THAM_VOWEL_SIGN_II                                0x1A66
#define unicode_TAI_THAM_VOWEL_SIGN_UE                                0x1A67
#define unicode_TAI_THAM_VOWEL_SIGN_UUE                               0x1A68
#define unicode_TAI_THAM_VOWEL_SIGN_U                                 0x1A69
#define unicode_TAI_THAM_VOWEL_SIGN_UU                                0x1A6A
#define unicode_TAI_THAM_VOWEL_SIGN_O                                 0x1A6B
#define unicode_TAI_THAM_VOWEL_SIGN_OA_BELOW                          0x1A6C
#define unicode_TAI_THAM_VOWEL_SIGN_OY                                0x1A6D
#define unicode_TAI_THAM_VOWEL_SIGN_E                                 0x1A6E
#define unicode_TAI_THAM_VOWEL_SIGN_AE                                0x1A6F
#define unicode_TAI_THAM_VOWEL_SIGN_OO                                0x1A70
#define unicode_TAI_THAM_VOWEL_SIGN_AI                                0x1A71
#define unicode_TAI_THAM_VOWEL_SIGN_THAM_AI                           0x1A72
#define unicode_TAI_THAM_VOWEL_SIGN_OA_ABOVE                          0x1A73
#define unicode_TAI_THAM_SIGN_MAI_KANG                                0x1A74
#define unicode_TAI_THAM_SIGN_TONE_1                                  0x1A75
#define unicode_TAI_THAM_SIGN_TONE_2                                  0x1A76
#define unicode_TAI_THAM_SIGN_KHUEN_TONE_3                            0x1A77
#define unicode_TAI_THAM_SIGN_KHUEN_TONE_4                            0x1A78
#define unicode_TAI_THAM_SIGN_KHUEN_TONE_5                            0x1A79
#define unicode_TAI_THAM_SIGN_RA_HAAM                                 0x1A7A
#define unicode_TAI_THAM_SIGN_MAI_SAM                                 0x1A7B
#define unicode_TAI_THAM_SIGN_KHUEN_LUE_KARAN                         0x1A7C
#define unicode_TAI_THAM_COMBINING_CRYPTOGRAMMIC_DOT                  0x1A7F
#define unicode_TAI_THAM_HORA_DIGIT_ZERO                              0x1A80
#define unicode_TAI_THAM_HORA_DIGIT_ONE                               0x1A81
#define unicode_TAI_THAM_HORA_DIGIT_TWO                               0x1A82
#define unicode_TAI_THAM_HORA_DIGIT_THREE                             0x1A83
#define unicode_TAI_THAM_HORA_DIGIT_FOUR                              0x1A84
#define unicode_TAI_THAM_HORA_DIGIT_FIVE                              0x1A85
#define unicode_TAI_THAM_HORA_DIGIT_SIX                               0x1A86
#define unicode_TAI_THAM_HORA_DIGIT_SEVEN                             0x1A87
#define unicode_TAI_THAM_HORA_DIGIT_EIGHT                             0x1A88
#define unicode_TAI_THAM_HORA_DIGIT_NINE                              0x1A89
#define unicode_TAI_THAM_THAM_DIGIT_ZERO                              0x1A90
#define unicode_TAI_THAM_THAM_DIGIT_ONE                               0x1A91
#define unicode_TAI_THAM_THAM_DIGIT_TWO                               0x1A92
#define unicode_TAI_THAM_THAM_DIGIT_THREE                             0x1A93
#define unicode_TAI_THAM_THAM_DIGIT_FOUR                              0x1A94
#define unicode_TAI_THAM_THAM_DIGIT_FIVE                              0x1A95
#define unicode_TAI_THAM_THAM_DIGIT_SIX                               0x1A96
#define unicode_TAI_THAM_THAM_DIGIT_SEVEN                             0x1A97
#define unicode_TAI_THAM_THAM_DIGIT_EIGHT                             0x1A98
#define unicode_TAI_THAM_THAM_DIGIT_NINE                              0x1A99
#define unicode_TAI_THAM_SIGN_WIANG                                   0x1AA0
#define unicode_TAI_THAM_SIGN_WIANGWAAK                               0x1AA1
#define unicode_TAI_THAM_SIGN_SAWAN                                   0x1AA2
#define unicode_TAI_THAM_SIGN_KEOW                                    0x1AA3
#define unicode_TAI_THAM_SIGN_HOY                                     0x1AA4
#define unicode_TAI_THAM_SIGN_DOKMAI                                  0x1AA5
#define unicode_TAI_THAM_SIGN_REVERSED_ROTATED_RANA                   0x1AA6
#define unicode_TAI_THAM_SIGN_MAI_YAMOK                               0x1AA7
#define unicode_TAI_THAM_SIGN_KAAN                                    0x1AA8
#define unicode_TAI_THAM_SIGN_KAANKUU                                 0x1AA9
#define unicode_TAI_THAM_SIGN_SATKAAN                                 0x1AAA
#define unicode_TAI_THAM_SIGN_SATKAANKUU                              0x1AAB
#define unicode_TAI_THAM_SIGN_HANG                                    0x1AAC
#define unicode_TAI_THAM_SIGN_CAANG                                   0x1AAD
#define unicode_COMBINING_DOUBLED_CIRCUMFLEX_ACCENT                   0x1AB0
#define unicode_COMBINING_DIAERESIS_RING                              0x1AB1
#define unicode_COMBINING_INFINITY                                    0x1AB2
#define unicode_COMBINING_DOWNWARDS_ARROW                             0x1AB3
#define unicode_COMBINING_TRIPLE_DOT                                  0x1AB4
#define unicode_COMBINING_X_X_BELOW                                   0x1AB5
#define unicode_COMBINING_WIGGLY_LINE_BELOW                           0x1AB6
#define unicode_COMBINING_OPEN_MARK_BELOW                             0x1AB7
#define unicode_COMBINING_DOUBLE_OPEN_MARK_BELOW                      0x1AB8
#define unicode_COMBINING_LIGHT_CENTRALIZATION_STROKE_BELOW           0x1AB9
#define unicode_COMBINING_STRONG_CENTRALIZATION_STROKE_BELOW          0x1ABA
#define unicode_COMBINING_PARENTHESES_ABOVE                           0x1ABB
#define unicode_COMBINING_DOUBLE_PARENTHESES_ABOVE                    0x1ABC
#define unicode_COMBINING_PARENTHESES_BELOW                           0x1ABD
#define unicode_COMBINING_PARENTHESES_OVERLAY                         0x1ABE
#define unicode_BALINESE_SIGN_ULU_RICEM                               0x1B00
#define unicode_BALINESE_SIGN_ULU_CANDRA                              0x1B01
#define unicode_BALINESE_SIGN_CECEK                                   0x1B02
#define unicode_BALINESE_SIGN_SURANG                                  0x1B03
#define unicode_BALINESE_SIGN_BISAH                                   0x1B04
#define unicode_BALINESE_LETTER_AKARA                                 0x1B05
#define unicode_BALINESE_LETTER_AKARA_TEDUNG                          0x1B06
#define unicode_BALINESE_LETTER_IKARA                                 0x1B07
#define unicode_BALINESE_LETTER_IKARA_TEDUNG                          0x1B08
#define unicode_BALINESE_LETTER_UKARA                                 0x1B09
#define unicode_BALINESE_LETTER_UKARA_TEDUNG                          0x1B0A
#define unicode_BALINESE_LETTER_RA_REPA                               0x1B0B
#define unicode_BALINESE_LETTER_RA_REPA_TEDUNG                        0x1B0C
#define unicode_BALINESE_LETTER_LA_LENGA                              0x1B0D
#define unicode_BALINESE_LETTER_LA_LENGA_TEDUNG                       0x1B0E
#define unicode_BALINESE_LETTER_EKARA                                 0x1B0F
#define unicode_BALINESE_LETTER_AIKARA                                0x1B10
#define unicode_BALINESE_LETTER_OKARA                                 0x1B11
#define unicode_BALINESE_LETTER_OKARA_TEDUNG                          0x1B12
#define unicode_BALINESE_LETTER_KA                                    0x1B13
#define unicode_BALINESE_LETTER_KA_MAHAPRANA                          0x1B14
#define unicode_BALINESE_LETTER_GA                                    0x1B15
#define unicode_BALINESE_LETTER_GA_GORA                               0x1B16
#define unicode_BALINESE_LETTER_NGA                                   0x1B17
#define unicode_BALINESE_LETTER_CA                                    0x1B18
#define unicode_BALINESE_LETTER_CA_LACA                               0x1B19
#define unicode_BALINESE_LETTER_JA                                    0x1B1A
#define unicode_BALINESE_LETTER_JA_JERA                               0x1B1B
#define unicode_BALINESE_LETTER_NYA                                   0x1B1C
#define unicode_BALINESE_LETTER_TA_LATIK                              0x1B1D
#define unicode_BALINESE_LETTER_TA_MURDA_MAHAPRANA                    0x1B1E
#define unicode_BALINESE_LETTER_DA_MURDA_ALPAPRANA                    0x1B1F
#define unicode_BALINESE_LETTER_DA_MURDA_MAHAPRANA                    0x1B20
#define unicode_BALINESE_LETTER_NA_RAMBAT                             0x1B21
#define unicode_BALINESE_LETTER_TA                                    0x1B22
#define unicode_BALINESE_LETTER_TA_TAWA                               0x1B23
#define unicode_BALINESE_LETTER_DA                                    0x1B24
#define unicode_BALINESE_LETTER_DA_MADU                               0x1B25
#define unicode_BALINESE_LETTER_NA                                    0x1B26
#define unicode_BALINESE_LETTER_PA                                    0x1B27
#define unicode_BALINESE_LETTER_PA_KAPAL                              0x1B28
#define unicode_BALINESE_LETTER_BA                                    0x1B29
#define unicode_BALINESE_LETTER_BA_KEMBANG                            0x1B2A
#define unicode_BALINESE_LETTER_MA                                    0x1B2B
#define unicode_BALINESE_LETTER_YA                                    0x1B2C
#define unicode_BALINESE_LETTER_RA                                    0x1B2D
#define unicode_BALINESE_LETTER_LA                                    0x1B2E
#define unicode_BALINESE_LETTER_WA                                    0x1B2F
#define unicode_BALINESE_LETTER_SA_SAGA                               0x1B30
#define unicode_BALINESE_LETTER_SA_SAPA                               0x1B31
#define unicode_BALINESE_LETTER_SA                                    0x1B32
#define unicode_BALINESE_LETTER_HA                                    0x1B33
#define unicode_BALINESE_SIGN_REREKAN                                 0x1B34
#define unicode_BALINESE_VOWEL_SIGN_TEDUNG                            0x1B35
#define unicode_BALINESE_VOWEL_SIGN_ULU                               0x1B36
#define unicode_BALINESE_VOWEL_SIGN_ULU_SARI                          0x1B37
#define unicode_BALINESE_VOWEL_SIGN_SUKU                              0x1B38
#define unicode_BALINESE_VOWEL_SIGN_SUKU_ILUT                         0x1B39
#define unicode_BALINESE_VOWEL_SIGN_RA_REPA                           0x1B3A
#define unicode_BALINESE_VOWEL_SIGN_RA_REPA_TEDUNG                    0x1B3B
#define unicode_BALINESE_VOWEL_SIGN_LA_LENGA                          0x1B3C
#define unicode_BALINESE_VOWEL_SIGN_LA_LENGA_TEDUNG                   0x1B3D
#define unicode_BALINESE_VOWEL_SIGN_TALING                            0x1B3E
#define unicode_BALINESE_VOWEL_SIGN_TALING_REPA                       0x1B3F
#define unicode_BALINESE_VOWEL_SIGN_TALING_TEDUNG                     0x1B40
#define unicode_BALINESE_VOWEL_SIGN_TALING_REPA_TEDUNG                0x1B41
#define unicode_BALINESE_VOWEL_SIGN_PEPET                             0x1B42
#define unicode_BALINESE_VOWEL_SIGN_PEPET_TEDUNG                      0x1B43
#define unicode_BALINESE_ADEG_ADEG                                    0x1B44
#define unicode_BALINESE_LETTER_KAF_SASAK                             0x1B45
#define unicode_BALINESE_LETTER_KHOT_SASAK                            0x1B46
#define unicode_BALINESE_LETTER_TZIR_SASAK                            0x1B47
#define unicode_BALINESE_LETTER_EF_SASAK                              0x1B48
#define unicode_BALINESE_LETTER_VE_SASAK                              0x1B49
#define unicode_BALINESE_LETTER_ZAL_SASAK                             0x1B4A
#define unicode_BALINESE_LETTER_ASYURA_SASAK                          0x1B4B
#define unicode_BALINESE_DIGIT_ZERO                                   0x1B50
#define unicode_BALINESE_DIGIT_ONE                                    0x1B51
#define unicode_BALINESE_DIGIT_TWO                                    0x1B52
#define unicode_BALINESE_DIGIT_THREE                                  0x1B53
#define unicode_BALINESE_DIGIT_FOUR                                   0x1B54
#define unicode_BALINESE_DIGIT_FIVE                                   0x1B55
#define unicode_BALINESE_DIGIT_SIX                                    0x1B56
#define unicode_BALINESE_DIGIT_SEVEN                                  0x1B57
#define unicode_BALINESE_DIGIT_EIGHT                                  0x1B58
#define unicode_BALINESE_DIGIT_NINE                                   0x1B59
#define unicode_BALINESE_PANTI                                        0x1B5A
#define unicode_BALINESE_PAMADA                                       0x1B5B
#define unicode_BALINESE_WINDU                                        0x1B5C
#define unicode_BALINESE_CARIK_PAMUNGKAH                              0x1B5D
#define unicode_BALINESE_CARIK_SIKI                                   0x1B5E
#define unicode_BALINESE_CARIK_PAREREN                                0x1B5F
#define unicode_BALINESE_PAMENENG                                     0x1B60
#define unicode_BALINESE_MUSICAL_SYMBOL_DONG                          0x1B61
#define unicode_BALINESE_MUSICAL_SYMBOL_DENG                          0x1B62
#define unicode_BALINESE_MUSICAL_SYMBOL_DUNG                          0x1B63
#define unicode_BALINESE_MUSICAL_SYMBOL_DANG                          0x1B64
#define unicode_BALINESE_MUSICAL_SYMBOL_DANG_SURANG                   0x1B65
#define unicode_BALINESE_MUSICAL_SYMBOL_DING                          0x1B66
#define unicode_BALINESE_MUSICAL_SYMBOL_DAENG                         0x1B67
#define unicode_BALINESE_MUSICAL_SYMBOL_DEUNG                         0x1B68
#define unicode_BALINESE_MUSICAL_SYMBOL_DAING                         0x1B69
#define unicode_BALINESE_MUSICAL_SYMBOL_DANG_GEDE                     0x1B6A
#define unicode_BALINESE_MUSICAL_SYMBOL_COMBINING_TEGEH               0x1B6B
#define unicode_BALINESE_MUSICAL_SYMBOL_COMBINING_ENDEP               0x1B6C
#define unicode_BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPUL              0x1B6D
#define unicode_BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPLI              0x1B6E
#define unicode_BALINESE_MUSICAL_SYMBOL_COMBINING_JEGOGAN             0x1B6F
#define unicode_BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPUL_WITH_JEGOGAN 0x1B70
#define unicode_BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPLI_WITH_JEGOGAN 0x1B71
#define unicode_BALINESE_MUSICAL_SYMBOL_COMBINING_BENDE               0x1B72
#define unicode_BALINESE_MUSICAL_SYMBOL_COMBINING_GONG                0x1B73
#define unicode_BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_OPEN_DUG           0x1B74
#define unicode_BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_OPEN_DAG           0x1B75
#define unicode_BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_CLOSED_TUK         0x1B76
#define unicode_BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_CLOSED_TAK         0x1B77
#define unicode_BALINESE_MUSICAL_SYMBOL_LEFT_HAND_OPEN_PANG           0x1B78
#define unicode_BALINESE_MUSICAL_SYMBOL_LEFT_HAND_OPEN_PUNG           0x1B79
#define unicode_BALINESE_MUSICAL_SYMBOL_LEFT_HAND_CLOSED_PLAK         0x1B7A
#define unicode_BALINESE_MUSICAL_SYMBOL_LEFT_HAND_CLOSED_PLUK         0x1B7B
#define unicode_BALINESE_MUSICAL_SYMBOL_LEFT_HAND_OPEN_PING           0x1B7C
#define unicode_SUNDANESE_SIGN_PANYECEK                               0x1B80
#define unicode_SUNDANESE_SIGN_PANGLAYAR                              0x1B81
#define unicode_SUNDANESE_SIGN_PANGWISAD                              0x1B82
#define unicode_SUNDANESE_LETTER_A                                    0x1B83
#define unicode_SUNDANESE_LETTER_I                                    0x1B84
#define unicode_SUNDANESE_LETTER_U                                    0x1B85
#define unicode_SUNDANESE_LETTER_AE                                   0x1B86
#define unicode_SUNDANESE_LETTER_O                                    0x1B87
#define unicode_SUNDANESE_LETTER_E                                    0x1B88
#define unicode_SUNDANESE_LETTER_EU                                   0x1B89
#define unicode_SUNDANESE_LETTER_KA                                   0x1B8A
#define unicode_SUNDANESE_LETTER_QA                                   0x1B8B
#define unicode_SUNDANESE_LETTER_GA                                   0x1B8C
#define unicode_SUNDANESE_LETTER_NGA                                  0x1B8D
#define unicode_SUNDANESE_LETTER_CA                                   0x1B8E
#define unicode_SUNDANESE_LETTER_JA                                   0x1B8F
#define unicode_SUNDANESE_LETTER_ZA                                   0x1B90
#define unicode_SUNDANESE_LETTER_NYA                                  0x1B91
#define unicode_SUNDANESE_LETTER_TA                                   0x1B92
#define unicode_SUNDANESE_LETTER_DA                                   0x1B93
#define unicode_SUNDANESE_LETTER_NA                                   0x1B94
#define unicode_SUNDANESE_LETTER_PA                                   0x1B95
#define unicode_SUNDANESE_LETTER_FA                                   0x1B96
#define unicode_SUNDANESE_LETTER_VA                                   0x1B97
#define unicode_SUNDANESE_LETTER_BA                                   0x1B98
#define unicode_SUNDANESE_LETTER_MA                                   0x1B99
#define unicode_SUNDANESE_LETTER_YA                                   0x1B9A
#define unicode_SUNDANESE_LETTER_RA                                   0x1B9B
#define unicode_SUNDANESE_LETTER_LA                                   0x1B9C
#define unicode_SUNDANESE_LETTER_WA                                   0x1B9D
#define unicode_SUNDANESE_LETTER_SA                                   0x1B9E
#define unicode_SUNDANESE_LETTER_XA                                   0x1B9F
#define unicode_SUNDANESE_LETTER_HA                                   0x1BA0
#define unicode_SUNDANESE_CONSONANT_SIGN_PAMINGKAL                    0x1BA1
#define unicode_SUNDANESE_CONSONANT_SIGN_PANYAKRA                     0x1BA2
#define unicode_SUNDANESE_CONSONANT_SIGN_PANYIKU                      0x1BA3
#define unicode_SUNDANESE_VOWEL_SIGN_PANGHULU                         0x1BA4
#define unicode_SUNDANESE_VOWEL_SIGN_PANYUKU                          0x1BA5
#define unicode_SUNDANESE_VOWEL_SIGN_PANAELAENG                       0x1BA6
#define unicode_SUNDANESE_VOWEL_SIGN_PANOLONG                         0x1BA7
#define unicode_SUNDANESE_VOWEL_SIGN_PAMEPET                          0x1BA8
#define unicode_SUNDANESE_VOWEL_SIGN_PANEULEUNG                       0x1BA9
#define unicode_SUNDANESE_SIGN_PAMAAEH                                0x1BAA
#define unicode_SUNDANESE_SIGN_VIRAMA                                 0x1BAB
#define unicode_SUNDANESE_CONSONANT_SIGN_PASANGAN_MA                  0x1BAC
#define unicode_SUNDANESE_CONSONANT_SIGN_PASANGAN_WA                  0x1BAD
#define unicode_SUNDANESE_LETTER_KHA                                  0x1BAE
#define unicode_SUNDANESE_LETTER_SYA                                  0x1BAF
#define unicode_SUNDANESE_DIGIT_ZERO                                  0x1BB0
#define unicode_SUNDANESE_DIGIT_ONE                                   0x1BB1
#define unicode_SUNDANESE_DIGIT_TWO                                   0x1BB2
#define unicode_SUNDANESE_DIGIT_THREE                                 0x1BB3
#define unicode_SUNDANESE_DIGIT_FOUR                                  0x1BB4
#define unicode_SUNDANESE_DIGIT_FIVE                                  0x1BB5
#define unicode_SUNDANESE_DIGIT_SIX                                   0x1BB6
#define unicode_SUNDANESE_DIGIT_SEVEN                                 0x1BB7
#define unicode_SUNDANESE_DIGIT_EIGHT                                 0x1BB8
#define unicode_SUNDANESE_DIGIT_NINE                                  0x1BB9
#define unicode_SUNDANESE_AVAGRAHA                                    0x1BBA
#define unicode_SUNDANESE_LETTER_REU                                  0x1BBB
#define unicode_SUNDANESE_LETTER_LEU                                  0x1BBC
#define unicode_SUNDANESE_LETTER_BHA                                  0x1BBD
#define unicode_SUNDANESE_LETTER_FINAL_K                              0x1BBE
#define unicode_SUNDANESE_LETTER_FINAL_M                              0x1BBF
#define unicode_BATAK_LETTER_A                                        0x1BC0
#define unicode_BATAK_LETTER_SIMALUNGUN_A                             0x1BC1
#define unicode_BATAK_LETTER_HA                                       0x1BC2
#define unicode_BATAK_LETTER_SIMALUNGUN_HA                            0x1BC3
#define unicode_BATAK_LETTER_MANDAILING_HA                            0x1BC4
#define unicode_BATAK_LETTER_BA                                       0x1BC5
#define unicode_BATAK_LETTER_KARO_BA                                  0x1BC6
#define unicode_BATAK_LETTER_PA                                       0x1BC7
#define unicode_BATAK_LETTER_SIMALUNGUN_PA                            0x1BC8
#define unicode_BATAK_LETTER_NA                                       0x1BC9
#define unicode_BATAK_LETTER_MANDAILING_NA                            0x1BCA
#define unicode_BATAK_LETTER_WA                                       0x1BCB
#define unicode_BATAK_LETTER_SIMALUNGUN_WA                            0x1BCC
#define unicode_BATAK_LETTER_PAKPAK_WA                                0x1BCD
#define unicode_BATAK_LETTER_GA                                       0x1BCE
#define unicode_BATAK_LETTER_SIMALUNGUN_GA                            0x1BCF
#define unicode_BATAK_LETTER_JA                                       0x1BD0
#define unicode_BATAK_LETTER_DA                                       0x1BD1
#define unicode_BATAK_LETTER_RA                                       0x1BD2
#define unicode_BATAK_LETTER_SIMALUNGUN_RA                            0x1BD3
#define unicode_BATAK_LETTER_MA                                       0x1BD4
#define unicode_BATAK_LETTER_SIMALUNGUN_MA                            0x1BD5
#define unicode_BATAK_LETTER_SOUTHERN_TA                              0x1BD6
#define unicode_BATAK_LETTER_NORTHERN_TA                              0x1BD7
#define unicode_BATAK_LETTER_SA                                       0x1BD8
#define unicode_BATAK_LETTER_SIMALUNGUN_SA                            0x1BD9
#define unicode_BATAK_LETTER_MANDAILING_SA                            0x1BDA
#define unicode_BATAK_LETTER_YA                                       0x1BDB
#define unicode_BATAK_LETTER_SIMALUNGUN_YA                            0x1BDC
#define unicode_BATAK_LETTER_NGA                                      0x1BDD
#define unicode_BATAK_LETTER_LA                                       0x1BDE
#define unicode_BATAK_LETTER_SIMALUNGUN_LA                            0x1BDF
#define unicode_BATAK_LETTER_NYA                                      0x1BE0
#define unicode_BATAK_LETTER_CA                                       0x1BE1
#define unicode_BATAK_LETTER_NDA                                      0x1BE2
#define unicode_BATAK_LETTER_MBA                                      0x1BE3
#define unicode_BATAK_LETTER_I                                        0x1BE4
#define unicode_BATAK_LETTER_U                                        0x1BE5
#define unicode_BATAK_SIGN_TOMPI                                      0x1BE6
#define unicode_BATAK_VOWEL_SIGN_E                                    0x1BE7
#define unicode_BATAK_VOWEL_SIGN_PAKPAK_E                             0x1BE8
#define unicode_BATAK_VOWEL_SIGN_EE                                   0x1BE9
#define unicode_BATAK_VOWEL_SIGN_I                                    0x1BEA
#define unicode_BATAK_VOWEL_SIGN_KARO_I                               0x1BEB
#define unicode_BATAK_VOWEL_SIGN_O                                    0x1BEC
#define unicode_BATAK_VOWEL_SIGN_KARO_O                               0x1BED
#define unicode_BATAK_VOWEL_SIGN_U                                    0x1BEE
#define unicode_BATAK_VOWEL_SIGN_U_FOR_SIMALUNGUN_SA                  0x1BEF
#define unicode_BATAK_CONSONANT_SIGN_NG                               0x1BF0
#define unicode_BATAK_CONSONANT_SIGN_H                                0x1BF1
#define unicode_BATAK_PANGOLAT                                        0x1BF2
#define unicode_BATAK_PANONGONAN                                      0x1BF3
#define unicode_BATAK_SYMBOL_BINDU_NA_METEK                           0x1BFC
#define unicode_BATAK_SYMBOL_BINDU_PINARBORAS                         0x1BFD
#define unicode_BATAK_SYMBOL_BINDU_JUDUL                              0x1BFE
#define unicode_BATAK_SYMBOL_BINDU_PANGOLAT                           0x1BFF
#define unicode_LEPCHA_LETTER_KA                                      0x1C00
#define unicode_LEPCHA_LETTER_KLA                                     0x1C01
#define unicode_LEPCHA_LETTER_KHA                                     0x1C02
#define unicode_LEPCHA_LETTER_GA                                      0x1C03
#define unicode_LEPCHA_LETTER_GLA                                     0x1C04
#define unicode_LEPCHA_LETTER_NGA                                     0x1C05
#define unicode_LEPCHA_LETTER_CA                                      0x1C06
#define unicode_LEPCHA_LETTER_CHA                                     0x1C07
#define unicode_LEPCHA_LETTER_JA                                      0x1C08
#define unicode_LEPCHA_LETTER_NYA                                     0x1C09
#define unicode_LEPCHA_LETTER_TA                                      0x1C0A
#define unicode_LEPCHA_LETTER_THA                                     0x1C0B
#define unicode_LEPCHA_LETTER_DA                                      0x1C0C
#define unicode_LEPCHA_LETTER_NA                                      0x1C0D
#define unicode_LEPCHA_LETTER_PA                                      0x1C0E
#define unicode_LEPCHA_LETTER_PLA                                     0x1C0F
#define unicode_LEPCHA_LETTER_PHA                                     0x1C10
#define unicode_LEPCHA_LETTER_FA                                      0x1C11
#define unicode_LEPCHA_LETTER_FLA                                     0x1C12
#define unicode_LEPCHA_LETTER_BA                                      0x1C13
#define unicode_LEPCHA_LETTER_BLA                                     0x1C14
#define unicode_LEPCHA_LETTER_MA                                      0x1C15
#define unicode_LEPCHA_LETTER_MLA                                     0x1C16
#define unicode_LEPCHA_LETTER_TSA                                     0x1C17
#define unicode_LEPCHA_LETTER_TSHA                                    0x1C18
#define unicode_LEPCHA_LETTER_DZA                                     0x1C19
#define unicode_LEPCHA_LETTER_YA                                      0x1C1A
#define unicode_LEPCHA_LETTER_RA                                      0x1C1B
#define unicode_LEPCHA_LETTER_LA                                      0x1C1C
#define unicode_LEPCHA_LETTER_HA                                      0x1C1D
#define unicode_LEPCHA_LETTER_HLA                                     0x1C1E
#define unicode_LEPCHA_LETTER_VA                                      0x1C1F
#define unicode_LEPCHA_LETTER_SA                                      0x1C20
#define unicode_LEPCHA_LETTER_SHA                                     0x1C21
#define unicode_LEPCHA_LETTER_WA                                      0x1C22
#define unicode_LEPCHA_LETTER_A                                       0x1C23
#define unicode_LEPCHA_SUBJOINED_LETTER_YA                            0x1C24
#define unicode_LEPCHA_SUBJOINED_LETTER_RA                            0x1C25
#define unicode_LEPCHA_VOWEL_SIGN_AA                                  0x1C26
#define unicode_LEPCHA_VOWEL_SIGN_I                                   0x1C27
#define unicode_LEPCHA_VOWEL_SIGN_O                                   0x1C28
#define unicode_LEPCHA_VOWEL_SIGN_OO                                  0x1C29
#define unicode_LEPCHA_VOWEL_SIGN_U                                   0x1C2A
#define unicode_LEPCHA_VOWEL_SIGN_UU                                  0x1C2B
#define unicode_LEPCHA_VOWEL_SIGN_E                                   0x1C2C
#define unicode_LEPCHA_CONSONANT_SIGN_K                               0x1C2D
#define unicode_LEPCHA_CONSONANT_SIGN_M                               0x1C2E
#define unicode_LEPCHA_CONSONANT_SIGN_L                               0x1C2F
#define unicode_LEPCHA_CONSONANT_SIGN_N                               0x1C30
#define unicode_LEPCHA_CONSONANT_SIGN_P                               0x1C31
#define unicode_LEPCHA_CONSONANT_SIGN_R                               0x1C32
#define unicode_LEPCHA_CONSONANT_SIGN_T                               0x1C33
#define unicode_LEPCHA_CONSONANT_SIGN_NYIN_DO                         0x1C34
#define unicode_LEPCHA_CONSONANT_SIGN_KANG                            0x1C35
#define unicode_LEPCHA_SIGN_RAN                                       0x1C36
#define unicode_LEPCHA_SIGN_NUKTA                                     0x1C37
#define unicode_LEPCHA_PUNCTUATION_TA_ROL                             0x1C3B
#define unicode_LEPCHA_PUNCTUATION_NYET_THYOOM_TA_ROL                 0x1C3C
#define unicode_LEPCHA_PUNCTUATION_CER_WA                             0x1C3D
#define unicode_LEPCHA_PUNCTUATION_TSHOOK_CER_WA                      0x1C3E
#define unicode_LEPCHA_PUNCTUATION_TSHOOK                             0x1C3F
#define unicode_LEPCHA_DIGIT_ZERO                                     0x1C40
#define unicode_LEPCHA_DIGIT_ONE                                      0x1C41
#define unicode_LEPCHA_DIGIT_TWO                                      0x1C42
#define unicode_LEPCHA_DIGIT_THREE                                    0x1C43
#define unicode_LEPCHA_DIGIT_FOUR                                     0x1C44
#define unicode_LEPCHA_DIGIT_FIVE                                     0x1C45
#define unicode_LEPCHA_DIGIT_SIX                                      0x1C46
#define unicode_LEPCHA_DIGIT_SEVEN                                    0x1C47
#define unicode_LEPCHA_DIGIT_EIGHT                                    0x1C48
#define unicode_LEPCHA_DIGIT_NINE                                     0x1C49
#define unicode_LEPCHA_LETTER_TTA                                     0x1C4D
#define unicode_LEPCHA_LETTER_TTHA                                    0x1C4E
#define unicode_LEPCHA_LETTER_DDA                                     0x1C4F
#define unicode_OL_CHIKI_DIGIT_ZERO                                   0x1C50
#define unicode_OL_CHIKI_DIGIT_ONE                                    0x1C51
#define unicode_OL_CHIKI_DIGIT_TWO                                    0x1C52
#define unicode_OL_CHIKI_DIGIT_THREE                                  0x1C53
#define unicode_OL_CHIKI_DIGIT_FOUR                                   0x1C54
#define unicode_OL_CHIKI_DIGIT_FIVE                                   0x1C55
#define unicode_OL_CHIKI_DIGIT_SIX                                    0x1C56
#define unicode_OL_CHIKI_DIGIT_SEVEN                                  0x1C57
#define unicode_OL_CHIKI_DIGIT_EIGHT                                  0x1C58
#define unicode_OL_CHIKI_DIGIT_NINE                                   0x1C59
#define unicode_OL_CHIKI_LETTER_LA                                    0x1C5A
#define unicode_OL_CHIKI_LETTER_AT                                    0x1C5B
#define unicode_OL_CHIKI_LETTER_AG                                    0x1C5C
#define unicode_OL_CHIKI_LETTER_ANG                                   0x1C5D
#define unicode_OL_CHIKI_LETTER_AL                                    0x1C5E
#define unicode_OL_CHIKI_LETTER_LAA                                   0x1C5F
#define unicode_OL_CHIKI_LETTER_AAK                                   0x1C60
#define unicode_OL_CHIKI_LETTER_AAJ                                   0x1C61
#define unicode_OL_CHIKI_LETTER_AAM                                   0x1C62
#define unicode_OL_CHIKI_LETTER_AAW                                   0x1C63
#define unicode_OL_CHIKI_LETTER_LI                                    0x1C64
#define unicode_OL_CHIKI_LETTER_IS                                    0x1C65
#define unicode_OL_CHIKI_LETTER_IH                                    0x1C66
#define unicode_OL_CHIKI_LETTER_INY                                   0x1C67
#define unicode_OL_CHIKI_LETTER_IR                                    0x1C68
#define unicode_OL_CHIKI_LETTER_LU                                    0x1C69
#define unicode_OL_CHIKI_LETTER_UC                                    0x1C6A
#define unicode_OL_CHIKI_LETTER_UD                                    0x1C6B
#define unicode_OL_CHIKI_LETTER_UNN                                   0x1C6C
#define unicode_OL_CHIKI_LETTER_UY                                    0x1C6D
#define unicode_OL_CHIKI_LETTER_LE                                    0x1C6E
#define unicode_OL_CHIKI_LETTER_EP                                    0x1C6F
#define unicode_OL_CHIKI_LETTER_EDD                                   0x1C70
#define unicode_OL_CHIKI_LETTER_EN                                    0x1C71
#define unicode_OL_CHIKI_LETTER_ERR                                   0x1C72
#define unicode_OL_CHIKI_LETTER_LO                                    0x1C73
#define unicode_OL_CHIKI_LETTER_OTT                                   0x1C74
#define unicode_OL_CHIKI_LETTER_OB                                    0x1C75
#define unicode_OL_CHIKI_LETTER_OV                                    0x1C76
#define unicode_OL_CHIKI_LETTER_OH                                    0x1C77
#define unicode_OL_CHIKI_MU_TTUDDAG                                   0x1C78
#define unicode_OL_CHIKI_GAAHLAA_TTUDDAAG                             0x1C79
#define unicode_OL_CHIKI_MU_GAAHLAA_TTUDDAAG                          0x1C7A
#define unicode_OL_CHIKI_RELAA                                        0x1C7B
#define unicode_OL_CHIKI_PHAARKAA                                     0x1C7C
#define unicode_OL_CHIKI_AHAD                                         0x1C7D
#define unicode_OL_CHIKI_PUNCTUATION_MUCAAD                           0x1C7E
#define unicode_OL_CHIKI_PUNCTUATION_DOUBLE_MUCAAD                    0x1C7F
#define unicode_SUNDANESE_PUNCTUATION_BINDU_SURYA                     0x1CC0
#define unicode_SUNDANESE_PUNCTUATION_BINDU_PANGLONG                  0x1CC1
#define unicode_SUNDANESE_PUNCTUATION_BINDU_PURNAMA                   0x1CC2
#define unicode_SUNDANESE_PUNCTUATION_BINDU_CAKRA                     0x1CC3
#define unicode_SUNDANESE_PUNCTUATION_BINDU_LEU_SATANGA               0x1CC4
#define unicode_SUNDANESE_PUNCTUATION_BINDU_KA_SATANGA                0x1CC5
#define unicode_SUNDANESE_PUNCTUATION_BINDU_DA_SATANGA                0x1CC6
#define unicode_SUNDANESE_PUNCTUATION_BINDU_BA_SATANGA                0x1CC7
#define unicode_VEDIC_TONE_KARSHANA                                   0x1CD0
#define unicode_VEDIC_TONE_SHARA                                      0x1CD1
#define unicode_VEDIC_TONE_PRENKHA                                    0x1CD2
#define unicode_VEDIC_SIGN_NIHSHVASA                                  0x1CD3
#define unicode_VEDIC_SIGN_YAJURVEDIC_MIDLINE_SVARITA                 0x1CD4
#define unicode_VEDIC_TONE_YAJURVEDIC_AGGRAVATED_INDEPENDENT_SVARITA  0x1CD5
#define unicode_VEDIC_TONE_YAJURVEDIC_INDEPENDENT_SVARITA             0x1CD6
#define unicode_VEDIC_TONE_YAJURVEDIC_KATHAKA_INDEPENDENT_SVARITA     0x1CD7
#define unicode_VEDIC_TONE_CANDRA_BELOW                               0x1CD8
#define unicode_VEDIC_TONE_YAJURVEDIC_KATHAKA_INDEPENDENT_SVARITA_SCHROEDER0x1CD9
#define unicode_VEDIC_TONE_DOUBLE_SVARITA                             0x1CDA
#define unicode_VEDIC_TONE_TRIPLE_SVARITA                             0x1CDB
#define unicode_VEDIC_TONE_KATHAKA_ANUDATTA                           0x1CDC
#define unicode_VEDIC_TONE_DOT_BELOW                                  0x1CDD
#define unicode_VEDIC_TONE_TWO_DOTS_BELOW                             0x1CDE
#define unicode_VEDIC_TONE_THREE_DOTS_BELOW                           0x1CDF
#define unicode_VEDIC_TONE_RIGVEDIC_KASHMIRI_INDEPENDENT_SVARITA      0x1CE0
#define unicode_VEDIC_TONE_ATHARVAVEDIC_INDEPENDENT_SVARITA           0x1CE1
#define unicode_VEDIC_SIGN_VISARGA_SVARITA                            0x1CE2
#define unicode_VEDIC_SIGN_VISARGA_UDATTA                             0x1CE3
#define unicode_VEDIC_SIGN_REVERSED_VISARGA_UDATTA                    0x1CE4
#define unicode_VEDIC_SIGN_VISARGA_ANUDATTA                           0x1CE5
#define unicode_VEDIC_SIGN_REVERSED_VISARGA_ANUDATTA                  0x1CE6
#define unicode_VEDIC_SIGN_VISARGA_UDATTA_WITH_TAIL                   0x1CE7
#define unicode_VEDIC_SIGN_VISARGA_ANUDATTA_WITH_TAIL                 0x1CE8
#define unicode_VEDIC_SIGN_ANUSVARA_ANTARGOMUKHA                      0x1CE9
#define unicode_VEDIC_SIGN_ANUSVARA_BAHIRGOMUKHA                      0x1CEA
#define unicode_VEDIC_SIGN_ANUSVARA_VAMAGOMUKHA                       0x1CEB
#define unicode_VEDIC_SIGN_ANUSVARA_VAMAGOMUKHA_WITH_TAIL             0x1CEC
#define unicode_VEDIC_SIGN_TIRYAK                                     0x1CED
#define unicode_VEDIC_SIGN_HEXIFORM_LONG_ANUSVARA                     0x1CEE
#define unicode_VEDIC_SIGN_LONG_ANUSVARA                              0x1CEF
#define unicode_VEDIC_SIGN_RTHANG_LONG_ANUSVARA                       0x1CF0
#define unicode_VEDIC_SIGN_ANUSVARA_UBHAYATO_MUKHA                    0x1CF1
#define unicode_VEDIC_SIGN_ARDHAVISARGA                               0x1CF2
#define unicode_VEDIC_SIGN_ROTATED_ARDHAVISARGA                       0x1CF3
#define unicode_VEDIC_TONE_CANDRA_ABOVE                               0x1CF4
#define unicode_VEDIC_SIGN_JIHVAMULIYA                                0x1CF5
#define unicode_VEDIC_SIGN_UPADHMANIYA                                0x1CF6
#define unicode_VEDIC_TONE_RING_ABOVE                                 0x1CF8
#define unicode_VEDIC_TONE_DOUBLE_RING_ABOVE                          0x1CF9
#define unicode_LATIN_LETTER_SMALL_CAPITAL_A                          0x1D00
#define unicode_LATIN_LETTER_SMALL_CAPITAL_AE                         0x1D01
#define unicode_LATIN_SMALL_LETTER_TURNED_AE                          0x1D02
#define unicode_LATIN_LETTER_SMALL_CAPITAL_BARRED_B                   0x1D03
#define unicode_LATIN_LETTER_SMALL_CAPITAL_C                          0x1D04
#define unicode_LATIN_LETTER_SMALL_CAPITAL_D                          0x1D05
#define unicode_LATIN_LETTER_SMALL_CAPITAL_ETH                        0x1D06
#define unicode_LATIN_LETTER_SMALL_CAPITAL_E                          0x1D07
#define unicode_LATIN_SMALL_LETTER_TURNED_OPEN_E                      0x1D08
#define unicode_LATIN_SMALL_LETTER_TURNED_I                           0x1D09
#define unicode_LATIN_LETTER_SMALL_CAPITAL_J                          0x1D0A
#define unicode_LATIN_LETTER_SMALL_CAPITAL_K                          0x1D0B
#define unicode_LATIN_LETTER_SMALL_CAPITAL_L_WITH_STROKE              0x1D0C
#define unicode_LATIN_LETTER_SMALL_CAPITAL_M                          0x1D0D
#define unicode_LATIN_LETTER_SMALL_CAPITAL_REVERSED_N                 0x1D0E
#define unicode_LATIN_LETTER_SMALL_CAPITAL_O                          0x1D0F
#define unicode_LATIN_LETTER_SMALL_CAPITAL_OPEN_O                     0x1D10
#define unicode_LATIN_SMALL_LETTER_SIDEWAYS_O                         0x1D11
#define unicode_LATIN_SMALL_LETTER_SIDEWAYS_OPEN_O                    0x1D12
#define unicode_LATIN_SMALL_LETTER_SIDEWAYS_O_WITH_STROKE             0x1D13
#define unicode_LATIN_SMALL_LETTER_TURNED_OE                          0x1D14
#define unicode_LATIN_LETTER_SMALL_CAPITAL_OU                         0x1D15
#define unicode_LATIN_SMALL_LETTER_TOP_HALF_O                         0x1D16
#define unicode_LATIN_SMALL_LETTER_BOTTOM_HALF_O                      0x1D17
#define unicode_LATIN_LETTER_SMALL_CAPITAL_P                          0x1D18
#define unicode_LATIN_LETTER_SMALL_CAPITAL_REVERSED_R                 0x1D19
#define unicode_LATIN_LETTER_SMALL_CAPITAL_TURNED_R                   0x1D1A
#define unicode_LATIN_LETTER_SMALL_CAPITAL_T                          0x1D1B
#define unicode_LATIN_LETTER_SMALL_CAPITAL_U                          0x1D1C
#define unicode_LATIN_SMALL_LETTER_SIDEWAYS_U                         0x1D1D
#define unicode_LATIN_SMALL_LETTER_SIDEWAYS_DIAERESIZED_U             0x1D1E
#define unicode_LATIN_SMALL_LETTER_SIDEWAYS_TURNED_M                  0x1D1F
#define unicode_LATIN_LETTER_SMALL_CAPITAL_V                          0x1D20
#define unicode_LATIN_LETTER_SMALL_CAPITAL_W                          0x1D21
#define unicode_LATIN_LETTER_SMALL_CAPITAL_Z                          0x1D22
#define unicode_LATIN_LETTER_SMALL_CAPITAL_EZH                        0x1D23
#define unicode_LATIN_LETTER_VOICED_LARYNGEAL_SPIRANT                 0x1D24
#define unicode_LATIN_LETTER_AIN                                      0x1D25
#define unicode_GREEK_LETTER_SMALL_CAPITAL_GAMMA                      0x1D26
#define unicode_GREEK_LETTER_SMALL_CAPITAL_LAMDA                      0x1D27
#define unicode_GREEK_LETTER_SMALL_CAPITAL_PI                         0x1D28
#define unicode_GREEK_LETTER_SMALL_CAPITAL_RHO                        0x1D29
#define unicode_GREEK_LETTER_SMALL_CAPITAL_PSI                        0x1D2A
#define unicode_CYRILLIC_LETTER_SMALL_CAPITAL_EL                      0x1D2B
#define unicode_MODIFIER_LETTER_CAPITAL_A                             0x1D2C
#define unicode_MODIFIER_LETTER_CAPITAL_AE                            0x1D2D
#define unicode_MODIFIER_LETTER_CAPITAL_B                             0x1D2E
#define unicode_MODIFIER_LETTER_CAPITAL_BARRED_B                      0x1D2F
#define unicode_MODIFIER_LETTER_CAPITAL_D                             0x1D30
#define unicode_MODIFIER_LETTER_CAPITAL_E                             0x1D31
#define unicode_MODIFIER_LETTER_CAPITAL_REVERSED_E                    0x1D32
#define unicode_MODIFIER_LETTER_CAPITAL_G                             0x1D33
#define unicode_MODIFIER_LETTER_CAPITAL_H                             0x1D34
#define unicode_MODIFIER_LETTER_CAPITAL_I                             0x1D35
#define unicode_MODIFIER_LETTER_CAPITAL_J                             0x1D36
#define unicode_MODIFIER_LETTER_CAPITAL_K                             0x1D37
#define unicode_MODIFIER_LETTER_CAPITAL_L                             0x1D38
#define unicode_MODIFIER_LETTER_CAPITAL_M                             0x1D39
#define unicode_MODIFIER_LETTER_CAPITAL_N                             0x1D3A
#define unicode_MODIFIER_LETTER_CAPITAL_REVERSED_N                    0x1D3B
#define unicode_MODIFIER_LETTER_CAPITAL_O                             0x1D3C
#define unicode_MODIFIER_LETTER_CAPITAL_OU                            0x1D3D
#define unicode_MODIFIER_LETTER_CAPITAL_P                             0x1D3E
#define unicode_MODIFIER_LETTER_CAPITAL_R                             0x1D3F
#define unicode_MODIFIER_LETTER_CAPITAL_T                             0x1D40
#define unicode_MODIFIER_LETTER_CAPITAL_U                             0x1D41
#define unicode_MODIFIER_LETTER_CAPITAL_W                             0x1D42
#define unicode_MODIFIER_LETTER_SMALL_A                               0x1D43
#define unicode_MODIFIER_LETTER_SMALL_TURNED_A                        0x1D44
#define unicode_MODIFIER_LETTER_SMALL_ALPHA                           0x1D45
#define unicode_MODIFIER_LETTER_SMALL_TURNED_AE                       0x1D46
#define unicode_MODIFIER_LETTER_SMALL_B                               0x1D47
#define unicode_MODIFIER_LETTER_SMALL_D                               0x1D48
#define unicode_MODIFIER_LETTER_SMALL_E                               0x1D49
#define unicode_MODIFIER_LETTER_SMALL_SCHWA                           0x1D4A
#define unicode_MODIFIER_LETTER_SMALL_OPEN_E                          0x1D4B
#define unicode_MODIFIER_LETTER_SMALL_TURNED_OPEN_E                   0x1D4C
#define unicode_MODIFIER_LETTER_SMALL_G                               0x1D4D
#define unicode_MODIFIER_LETTER_SMALL_TURNED_I                        0x1D4E
#define unicode_MODIFIER_LETTER_SMALL_K                               0x1D4F
#define unicode_MODIFIER_LETTER_SMALL_M                               0x1D50
#define unicode_MODIFIER_LETTER_SMALL_ENG                             0x1D51
#define unicode_MODIFIER_LETTER_SMALL_O                               0x1D52
#define unicode_MODIFIER_LETTER_SMALL_OPEN_O                          0x1D53
#define unicode_MODIFIER_LETTER_SMALL_TOP_HALF_O                      0x1D54
#define unicode_MODIFIER_LETTER_SMALL_BOTTOM_HALF_O                   0x1D55
#define unicode_MODIFIER_LETTER_SMALL_P                               0x1D56
#define unicode_MODIFIER_LETTER_SMALL_T                               0x1D57
#define unicode_MODIFIER_LETTER_SMALL_U                               0x1D58
#define unicode_MODIFIER_LETTER_SMALL_SIDEWAYS_U                      0x1D59
#define unicode_MODIFIER_LETTER_SMALL_TURNED_M                        0x1D5A
#define unicode_MODIFIER_LETTER_SMALL_V                               0x1D5B
#define unicode_MODIFIER_LETTER_SMALL_AIN                             0x1D5C
#define unicode_MODIFIER_LETTER_SMALL_BETA                            0x1D5D
#define unicode_MODIFIER_LETTER_SMALL_GREEK_GAMMA                     0x1D5E
#define unicode_MODIFIER_LETTER_SMALL_DELTA                           0x1D5F
#define unicode_MODIFIER_LETTER_SMALL_GREEK_PHI                       0x1D60
#define unicode_MODIFIER_LETTER_SMALL_CHI                             0x1D61
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_I                        0x1D62
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_R                        0x1D63
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_U                        0x1D64
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_V                        0x1D65
#define unicode_GREEK_SUBSCRIPT_SMALL_LETTER_BETA                     0x1D66
#define unicode_GREEK_SUBSCRIPT_SMALL_LETTER_GAMMA                    0x1D67
#define unicode_GREEK_SUBSCRIPT_SMALL_LETTER_RHO                      0x1D68
#define unicode_GREEK_SUBSCRIPT_SMALL_LETTER_PHI                      0x1D69
#define unicode_GREEK_SUBSCRIPT_SMALL_LETTER_CHI                      0x1D6A
#define unicode_LATIN_SMALL_LETTER_UE                                 0x1D6B
#define unicode_LATIN_SMALL_LETTER_B_WITH_MIDDLE_TILDE                0x1D6C
#define unicode_LATIN_SMALL_LETTER_D_WITH_MIDDLE_TILDE                0x1D6D
#define unicode_LATIN_SMALL_LETTER_F_WITH_MIDDLE_TILDE                0x1D6E
#define unicode_LATIN_SMALL_LETTER_M_WITH_MIDDLE_TILDE                0x1D6F
#define unicode_LATIN_SMALL_LETTER_N_WITH_MIDDLE_TILDE                0x1D70
#define unicode_LATIN_SMALL_LETTER_P_WITH_MIDDLE_TILDE                0x1D71
#define unicode_LATIN_SMALL_LETTER_R_WITH_MIDDLE_TILDE                0x1D72
#define unicode_LATIN_SMALL_LETTER_R_WITH_FISHHOOK_AND_MIDDLE_TILDE   0x1D73
#define unicode_LATIN_SMALL_LETTER_S_WITH_MIDDLE_TILDE                0x1D74
#define unicode_LATIN_SMALL_LETTER_T_WITH_MIDDLE_TILDE                0x1D75
#define unicode_LATIN_SMALL_LETTER_Z_WITH_MIDDLE_TILDE                0x1D76
#define unicode_LATIN_SMALL_LETTER_TURNED_G                           0x1D77
#define unicode_MODIFIER_LETTER_CYRILLIC_EN                           0x1D78
#define unicode_LATIN_SMALL_LETTER_INSULAR_G                          0x1D79
#define unicode_LATIN_SMALL_LETTER_TH_WITH_STRIKETHROUGH              0x1D7A
#define unicode_LATIN_SMALL_CAPITAL_LETTER_I_WITH_STROKE              0x1D7B
#define unicode_LATIN_SMALL_LETTER_IOTA_WITH_STROKE                   0x1D7C
#define unicode_LATIN_SMALL_LETTER_P_WITH_STROKE                      0x1D7D
#define unicode_LATIN_SMALL_CAPITAL_LETTER_U_WITH_STROKE              0x1D7E
#define unicode_LATIN_SMALL_LETTER_UPSILON_WITH_STROKE                0x1D7F
#define unicode_LATIN_SMALL_LETTER_B_WITH_PALATAL_HOOK                0x1D80
#define unicode_LATIN_SMALL_LETTER_D_WITH_PALATAL_HOOK                0x1D81
#define unicode_LATIN_SMALL_LETTER_F_WITH_PALATAL_HOOK                0x1D82
#define unicode_LATIN_SMALL_LETTER_G_WITH_PALATAL_HOOK                0x1D83
#define unicode_LATIN_SMALL_LETTER_K_WITH_PALATAL_HOOK                0x1D84
#define unicode_LATIN_SMALL_LETTER_L_WITH_PALATAL_HOOK                0x1D85
#define unicode_LATIN_SMALL_LETTER_M_WITH_PALATAL_HOOK                0x1D86
#define unicode_LATIN_SMALL_LETTER_N_WITH_PALATAL_HOOK                0x1D87
#define unicode_LATIN_SMALL_LETTER_P_WITH_PALATAL_HOOK                0x1D88
#define unicode_LATIN_SMALL_LETTER_R_WITH_PALATAL_HOOK                0x1D89
#define unicode_LATIN_SMALL_LETTER_S_WITH_PALATAL_HOOK                0x1D8A
#define unicode_LATIN_SMALL_LETTER_ESH_WITH_PALATAL_HOOK              0x1D8B
#define unicode_LATIN_SMALL_LETTER_V_WITH_PALATAL_HOOK                0x1D8C
#define unicode_LATIN_SMALL_LETTER_X_WITH_PALATAL_HOOK                0x1D8D
#define unicode_LATIN_SMALL_LETTER_Z_WITH_PALATAL_HOOK                0x1D8E
#define unicode_LATIN_SMALL_LETTER_A_WITH_RETROFLEX_HOOK              0x1D8F
#define unicode_LATIN_SMALL_LETTER_ALPHA_WITH_RETROFLEX_HOOK          0x1D90
#define unicode_LATIN_SMALL_LETTER_D_WITH_HOOK_AND_TAIL               0x1D91
#define unicode_LATIN_SMALL_LETTER_E_WITH_RETROFLEX_HOOK              0x1D92
#define unicode_LATIN_SMALL_LETTER_OPEN_E_WITH_RETROFLEX_HOOK         0x1D93
#define unicode_LATIN_SMALL_LETTER_REVERSED_OPEN_E_WITH_RETROFLEX_HOOK 0x1D94
#define unicode_LATIN_SMALL_LETTER_SCHWA_WITH_RETROFLEX_HOOK          0x1D95
#define unicode_LATIN_SMALL_LETTER_I_WITH_RETROFLEX_HOOK              0x1D96
#define unicode_LATIN_SMALL_LETTER_OPEN_O_WITH_RETROFLEX_HOOK         0x1D97
#define unicode_LATIN_SMALL_LETTER_ESH_WITH_RETROFLEX_HOOK            0x1D98
#define unicode_LATIN_SMALL_LETTER_U_WITH_RETROFLEX_HOOK              0x1D99
#define unicode_LATIN_SMALL_LETTER_EZH_WITH_RETROFLEX_HOOK            0x1D9A
#define unicode_MODIFIER_LETTER_SMALL_TURNED_ALPHA                    0x1D9B
#define unicode_MODIFIER_LETTER_SMALL_C                               0x1D9C
#define unicode_MODIFIER_LETTER_SMALL_C_WITH_CURL                     0x1D9D
#define unicode_MODIFIER_LETTER_SMALL_ETH                             0x1D9E
#define unicode_MODIFIER_LETTER_SMALL_REVERSED_OPEN_E                 0x1D9F
#define unicode_MODIFIER_LETTER_SMALL_F                               0x1DA0
#define unicode_MODIFIER_LETTER_SMALL_DOTLESS_J_WITH_STROKE           0x1DA1
#define unicode_MODIFIER_LETTER_SMALL_SCRIPT_G                        0x1DA2
#define unicode_MODIFIER_LETTER_SMALL_TURNED_H                        0x1DA3
#define unicode_MODIFIER_LETTER_SMALL_I_WITH_STROKE                   0x1DA4
#define unicode_MODIFIER_LETTER_SMALL_IOTA                            0x1DA5
#define unicode_MODIFIER_LETTER_SMALL_CAPITAL_I                       0x1DA6
#define unicode_MODIFIER_LETTER_SMALL_CAPITAL_I_WITH_STROKE           0x1DA7
#define unicode_MODIFIER_LETTER_SMALL_J_WITH_CROSSED_TAIL             0x1DA8
#define unicode_MODIFIER_LETTER_SMALL_L_WITH_RETROFLEX_HOOK           0x1DA9
#define unicode_MODIFIER_LETTER_SMALL_L_WITH_PALATAL_HOOK             0x1DAA
#define unicode_MODIFIER_LETTER_SMALL_CAPITAL_L                       0x1DAB
#define unicode_MODIFIER_LETTER_SMALL_M_WITH_HOOK                     0x1DAC
#define unicode_MODIFIER_LETTER_SMALL_TURNED_M_WITH_LONG_LEG          0x1DAD
#define unicode_MODIFIER_LETTER_SMALL_N_WITH_LEFT_HOOK                0x1DAE
#define unicode_MODIFIER_LETTER_SMALL_N_WITH_RETROFLEX_HOOK           0x1DAF
#define unicode_MODIFIER_LETTER_SMALL_CAPITAL_N                       0x1DB0
#define unicode_MODIFIER_LETTER_SMALL_BARRED_O                        0x1DB1
#define unicode_MODIFIER_LETTER_SMALL_PHI                             0x1DB2
#define unicode_MODIFIER_LETTER_SMALL_S_WITH_HOOK                     0x1DB3
#define unicode_MODIFIER_LETTER_SMALL_ESH                             0x1DB4
#define unicode_MODIFIER_LETTER_SMALL_T_WITH_PALATAL_HOOK             0x1DB5
#define unicode_MODIFIER_LETTER_SMALL_U_BAR                           0x1DB6
#define unicode_MODIFIER_LETTER_SMALL_UPSILON                         0x1DB7
#define unicode_MODIFIER_LETTER_SMALL_CAPITAL_U                       0x1DB8
#define unicode_MODIFIER_LETTER_SMALL_V_WITH_HOOK                     0x1DB9
#define unicode_MODIFIER_LETTER_SMALL_TURNED_V                        0x1DBA
#define unicode_MODIFIER_LETTER_SMALL_Z                               0x1DBB
#define unicode_MODIFIER_LETTER_SMALL_Z_WITH_RETROFLEX_HOOK           0x1DBC
#define unicode_MODIFIER_LETTER_SMALL_Z_WITH_CURL                     0x1DBD
#define unicode_MODIFIER_LETTER_SMALL_EZH                             0x1DBE
#define unicode_MODIFIER_LETTER_SMALL_THETA                           0x1DBF
#define unicode_COMBINING_DOTTED_GRAVE_ACCENT                         0x1DC0
#define unicode_COMBINING_DOTTED_ACUTE_ACCENT                         0x1DC1
#define unicode_COMBINING_SNAKE_BELOW                                 0x1DC2
#define unicode_COMBINING_SUSPENSION_MARK                             0x1DC3
#define unicode_COMBINING_MACRON_ACUTE                                0x1DC4
#define unicode_COMBINING_GRAVE_MACRON                                0x1DC5
#define unicode_COMBINING_MACRON_GRAVE                                0x1DC6
#define unicode_COMBINING_ACUTE_MACRON                                0x1DC7
#define unicode_COMBINING_GRAVE_ACUTE_GRAVE                           0x1DC8
#define unicode_COMBINING_ACUTE_GRAVE_ACUTE                           0x1DC9
#define unicode_COMBINING_LATIN_SMALL_LETTER_R_BELOW                  0x1DCA
#define unicode_COMBINING_BREVE_MACRON                                0x1DCB
#define unicode_COMBINING_MACRON_BREVE                                0x1DCC
#define unicode_COMBINING_DOUBLE_CIRCUMFLEX_ABOVE                     0x1DCD
#define unicode_COMBINING_OGONEK_ABOVE                                0x1DCE
#define unicode_COMBINING_ZIGZAG_BELOW                                0x1DCF
#define unicode_COMBINING_IS_BELOW                                    0x1DD0
#define unicode_COMBINING_UR_ABOVE                                    0x1DD1
#define unicode_COMBINING_US_ABOVE                                    0x1DD2
#define unicode_COMBINING_LATIN_SMALL_LETTER_FLATTENED_OPEN_A_ABOVE   0x1DD3
#define unicode_COMBINING_LATIN_SMALL_LETTER_AE                       0x1DD4
#define unicode_COMBINING_LATIN_SMALL_LETTER_AO                       0x1DD5
#define unicode_COMBINING_LATIN_SMALL_LETTER_AV                       0x1DD6
#define unicode_COMBINING_LATIN_SMALL_LETTER_C_CEDILLA                0x1DD7
#define unicode_COMBINING_LATIN_SMALL_LETTER_INSULAR_D                0x1DD8
#define unicode_COMBINING_LATIN_SMALL_LETTER_ETH                      0x1DD9
#define unicode_COMBINING_LATIN_SMALL_LETTER_G                        0x1DDA
#define unicode_COMBINING_LATIN_LETTER_SMALL_CAPITAL_G                0x1DDB
#define unicode_COMBINING_LATIN_SMALL_LETTER_K                        0x1DDC
#define unicode_COMBINING_LATIN_SMALL_LETTER_L                        0x1DDD
#define unicode_COMBINING_LATIN_LETTER_SMALL_CAPITAL_L                0x1DDE
#define unicode_COMBINING_LATIN_LETTER_SMALL_CAPITAL_M                0x1DDF
#define unicode_COMBINING_LATIN_SMALL_LETTER_N                        0x1DE0
#define unicode_COMBINING_LATIN_LETTER_SMALL_CAPITAL_N                0x1DE1
#define unicode_COMBINING_LATIN_LETTER_SMALL_CAPITAL_R                0x1DE2
#define unicode_COMBINING_LATIN_SMALL_LETTER_R_ROTUNDA                0x1DE3
#define unicode_COMBINING_LATIN_SMALL_LETTER_S                        0x1DE4
#define unicode_COMBINING_LATIN_SMALL_LETTER_LONG_S                   0x1DE5
#define unicode_COMBINING_LATIN_SMALL_LETTER_Z                        0x1DE6
#define unicode_COMBINING_LATIN_SMALL_LETTER_ALPHA                    0x1DE7
#define unicode_COMBINING_LATIN_SMALL_LETTER_B                        0x1DE8
#define unicode_COMBINING_LATIN_SMALL_LETTER_BETA                     0x1DE9
#define unicode_COMBINING_LATIN_SMALL_LETTER_SCHWA                    0x1DEA
#define unicode_COMBINING_LATIN_SMALL_LETTER_F                        0x1DEB
#define unicode_COMBINING_LATIN_SMALL_LETTER_L_WITH_DOUBLE_MIDDLE_TILDE 0x1DEC
#define unicode_COMBINING_LATIN_SMALL_LETTER_O_WITH_LIGHT_CENTRALIZATION_STROKE 0x1DED
#define unicode_COMBINING_LATIN_SMALL_LETTER_P                        0x1DEE
#define unicode_COMBINING_LATIN_SMALL_LETTER_ESH                      0x1DEF
#define unicode_COMBINING_LATIN_SMALL_LETTER_U_WITH_LIGHT_CENTRALIZATION_STROKE 0x1DF0
#define unicode_COMBINING_LATIN_SMALL_LETTER_W                        0x1DF1
#define unicode_COMBINING_LATIN_SMALL_LETTER_A_WITH_DIAERESIS         0x1DF2
#define unicode_COMBINING_LATIN_SMALL_LETTER_O_WITH_DIAERESIS         0x1DF3
#define unicode_COMBINING_LATIN_SMALL_LETTER_U_WITH_DIAERESIS         0x1DF4
#define unicode_COMBINING_UP_TACK_ABOVE                               0x1DF5
#define unicode_COMBINING_DOUBLE_INVERTED_BREVE_BELOW                 0x1DFC
#define unicode_COMBINING_ALMOST_EQUAL_TO_BELOW                       0x1DFD
#define unicode_COMBINING_LEFT_ARROWHEAD_ABOVE                        0x1DFE
#define unicode_COMBINING_RIGHT_ARROWHEAD_AND_DOWN_ARROWHEAD_BELOW    0x1DFF
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_RING_BELOW                0x1E00
#define unicode_LATIN_SMALL_LETTER_A_WITH_RING_BELOW                  0x1E01
#define unicode_LATIN_CAPITAL_LETTER_B_WITH_DOT_ABOVE                 0x1E02
#define unicode_LATIN_SMALL_LETTER_B_WITH_DOT_ABOVE                   0x1E03
#define unicode_LATIN_CAPITAL_LETTER_B_WITH_DOT_BELOW                 0x1E04
#define unicode_LATIN_SMALL_LETTER_B_WITH_DOT_BELOW                   0x1E05
#define unicode_LATIN_CAPITAL_LETTER_B_WITH_LINE_BELOW                0x1E06
#define unicode_LATIN_SMALL_LETTER_B_WITH_LINE_BELOW                  0x1E07
#define unicode_LATIN_CAPITAL_LETTER_C_WITH_CEDILLA_AND_ACUTE         0x1E08
#define unicode_LATIN_SMALL_LETTER_C_WITH_CEDILLA_AND_ACUTE           0x1E09
#define unicode_LATIN_CAPITAL_LETTER_D_WITH_DOT_ABOVE                 0x1E0A
#define unicode_LATIN_SMALL_LETTER_D_WITH_DOT_ABOVE                   0x1E0B
#define unicode_LATIN_CAPITAL_LETTER_D_WITH_DOT_BELOW                 0x1E0C
#define unicode_LATIN_SMALL_LETTER_D_WITH_DOT_BELOW                   0x1E0D
#define unicode_LATIN_CAPITAL_LETTER_D_WITH_LINE_BELOW                0x1E0E
#define unicode_LATIN_SMALL_LETTER_D_WITH_LINE_BELOW                  0x1E0F
#define unicode_LATIN_CAPITAL_LETTER_D_WITH_CEDILLA                   0x1E10
#define unicode_LATIN_SMALL_LETTER_D_WITH_CEDILLA                     0x1E11
#define unicode_LATIN_CAPITAL_LETTER_D_WITH_CIRCUMFLEX_BELOW          0x1E12
#define unicode_LATIN_SMALL_LETTER_D_WITH_CIRCUMFLEX_BELOW            0x1E13
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_MACRON_AND_GRAVE          0x1E14
#define unicode_LATIN_SMALL_LETTER_E_WITH_MACRON_AND_GRAVE            0x1E15
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_MACRON_AND_ACUTE          0x1E16
#define unicode_LATIN_SMALL_LETTER_E_WITH_MACRON_AND_ACUTE            0x1E17
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_BELOW          0x1E18
#define unicode_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_BELOW            0x1E19
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_TILDE_BELOW               0x1E1A
#define unicode_LATIN_SMALL_LETTER_E_WITH_TILDE_BELOW                 0x1E1B
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_CEDILLA_AND_BREVE         0x1E1C
#define unicode_LATIN_SMALL_LETTER_E_WITH_CEDILLA_AND_BREVE           0x1E1D
#define unicode_LATIN_CAPITAL_LETTER_F_WITH_DOT_ABOVE                 0x1E1E
#define unicode_LATIN_SMALL_LETTER_F_WITH_DOT_ABOVE                   0x1E1F
#define unicode_LATIN_CAPITAL_LETTER_G_WITH_MACRON                    0x1E20
#define unicode_LATIN_SMALL_LETTER_G_WITH_MACRON                      0x1E21
#define unicode_LATIN_CAPITAL_LETTER_H_WITH_DOT_ABOVE                 0x1E22
#define unicode_LATIN_SMALL_LETTER_H_WITH_DOT_ABOVE                   0x1E23
#define unicode_LATIN_CAPITAL_LETTER_H_WITH_DOT_BELOW                 0x1E24
#define unicode_LATIN_SMALL_LETTER_H_WITH_DOT_BELOW                   0x1E25
#define unicode_LATIN_CAPITAL_LETTER_H_WITH_DIAERESIS                 0x1E26
#define unicode_LATIN_SMALL_LETTER_H_WITH_DIAERESIS                   0x1E27
#define unicode_LATIN_CAPITAL_LETTER_H_WITH_CEDILLA                   0x1E28
#define unicode_LATIN_SMALL_LETTER_H_WITH_CEDILLA                     0x1E29
#define unicode_LATIN_CAPITAL_LETTER_H_WITH_BREVE_BELOW               0x1E2A
#define unicode_LATIN_SMALL_LETTER_H_WITH_BREVE_BELOW                 0x1E2B
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_TILDE_BELOW               0x1E2C
#define unicode_LATIN_SMALL_LETTER_I_WITH_TILDE_BELOW                 0x1E2D
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_DIAERESIS_AND_ACUTE       0x1E2E
#define unicode_LATIN_SMALL_LETTER_I_WITH_DIAERESIS_AND_ACUTE         0x1E2F
#define unicode_LATIN_CAPITAL_LETTER_K_WITH_ACUTE                     0x1E30
#define unicode_LATIN_SMALL_LETTER_K_WITH_ACUTE                       0x1E31
#define unicode_LATIN_CAPITAL_LETTER_K_WITH_DOT_BELOW                 0x1E32
#define unicode_LATIN_SMALL_LETTER_K_WITH_DOT_BELOW                   0x1E33
#define unicode_LATIN_CAPITAL_LETTER_K_WITH_LINE_BELOW                0x1E34
#define unicode_LATIN_SMALL_LETTER_K_WITH_LINE_BELOW                  0x1E35
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_DOT_BELOW                 0x1E36
#define unicode_LATIN_SMALL_LETTER_L_WITH_DOT_BELOW                   0x1E37
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_DOT_BELOW_AND_MACRON      0x1E38
#define unicode_LATIN_SMALL_LETTER_L_WITH_DOT_BELOW_AND_MACRON        0x1E39
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_LINE_BELOW                0x1E3A
#define unicode_LATIN_SMALL_LETTER_L_WITH_LINE_BELOW                  0x1E3B
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_CIRCUMFLEX_BELOW          0x1E3C
#define unicode_LATIN_SMALL_LETTER_L_WITH_CIRCUMFLEX_BELOW            0x1E3D
#define unicode_LATIN_CAPITAL_LETTER_M_WITH_ACUTE                     0x1E3E
#define unicode_LATIN_SMALL_LETTER_M_WITH_ACUTE                       0x1E3F
#define unicode_LATIN_CAPITAL_LETTER_M_WITH_DOT_ABOVE                 0x1E40
#define unicode_LATIN_SMALL_LETTER_M_WITH_DOT_ABOVE                   0x1E41
#define unicode_LATIN_CAPITAL_LETTER_M_WITH_DOT_BELOW                 0x1E42
#define unicode_LATIN_SMALL_LETTER_M_WITH_DOT_BELOW                   0x1E43
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_DOT_ABOVE                 0x1E44
#define unicode_LATIN_SMALL_LETTER_N_WITH_DOT_ABOVE                   0x1E45
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_DOT_BELOW                 0x1E46
#define unicode_LATIN_SMALL_LETTER_N_WITH_DOT_BELOW                   0x1E47
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_LINE_BELOW                0x1E48
#define unicode_LATIN_SMALL_LETTER_N_WITH_LINE_BELOW                  0x1E49
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_CIRCUMFLEX_BELOW          0x1E4A
#define unicode_LATIN_SMALL_LETTER_N_WITH_CIRCUMFLEX_BELOW            0x1E4B
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_TILDE_AND_ACUTE           0x1E4C
#define unicode_LATIN_SMALL_LETTER_O_WITH_TILDE_AND_ACUTE             0x1E4D
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_TILDE_AND_DIAERESIS       0x1E4E
#define unicode_LATIN_SMALL_LETTER_O_WITH_TILDE_AND_DIAERESIS         0x1E4F
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_MACRON_AND_GRAVE          0x1E50
#define unicode_LATIN_SMALL_LETTER_O_WITH_MACRON_AND_GRAVE            0x1E51
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_MACRON_AND_ACUTE          0x1E52
#define unicode_LATIN_SMALL_LETTER_O_WITH_MACRON_AND_ACUTE            0x1E53
#define unicode_LATIN_CAPITAL_LETTER_P_WITH_ACUTE                     0x1E54
#define unicode_LATIN_SMALL_LETTER_P_WITH_ACUTE                       0x1E55
#define unicode_LATIN_CAPITAL_LETTER_P_WITH_DOT_ABOVE                 0x1E56
#define unicode_LATIN_SMALL_LETTER_P_WITH_DOT_ABOVE                   0x1E57
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_DOT_ABOVE                 0x1E58
#define unicode_LATIN_SMALL_LETTER_R_WITH_DOT_ABOVE                   0x1E59
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_DOT_BELOW                 0x1E5A
#define unicode_LATIN_SMALL_LETTER_R_WITH_DOT_BELOW                   0x1E5B
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_DOT_BELOW_AND_MACRON      0x1E5C
#define unicode_LATIN_SMALL_LETTER_R_WITH_DOT_BELOW_AND_MACRON        0x1E5D
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_LINE_BELOW                0x1E5E
#define unicode_LATIN_SMALL_LETTER_R_WITH_LINE_BELOW                  0x1E5F
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_DOT_ABOVE                 0x1E60
#define unicode_LATIN_SMALL_LETTER_S_WITH_DOT_ABOVE                   0x1E61
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_DOT_BELOW                 0x1E62
#define unicode_LATIN_SMALL_LETTER_S_WITH_DOT_BELOW                   0x1E63
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_ACUTE_AND_DOT_ABOVE       0x1E64
#define unicode_LATIN_SMALL_LETTER_S_WITH_ACUTE_AND_DOT_ABOVE         0x1E65
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_CARON_AND_DOT_ABOVE       0x1E66
#define unicode_LATIN_SMALL_LETTER_S_WITH_CARON_AND_DOT_ABOVE         0x1E67
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_DOT_BELOW_AND_DOT_ABOVE   0x1E68
#define unicode_LATIN_SMALL_LETTER_S_WITH_DOT_BELOW_AND_DOT_ABOVE     0x1E69
#define unicode_LATIN_CAPITAL_LETTER_T_WITH_DOT_ABOVE                 0x1E6A
#define unicode_LATIN_SMALL_LETTER_T_WITH_DOT_ABOVE                   0x1E6B
#define unicode_LATIN_CAPITAL_LETTER_T_WITH_DOT_BELOW                 0x1E6C
#define unicode_LATIN_SMALL_LETTER_T_WITH_DOT_BELOW                   0x1E6D
#define unicode_LATIN_CAPITAL_LETTER_T_WITH_LINE_BELOW                0x1E6E
#define unicode_LATIN_SMALL_LETTER_T_WITH_LINE_BELOW                  0x1E6F
#define unicode_LATIN_CAPITAL_LETTER_T_WITH_CIRCUMFLEX_BELOW          0x1E70
#define unicode_LATIN_SMALL_LETTER_T_WITH_CIRCUMFLEX_BELOW            0x1E71
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_BELOW           0x1E72
#define unicode_LATIN_SMALL_LETTER_U_WITH_DIAERESIS_BELOW             0x1E73
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_TILDE_BELOW               0x1E74
#define unicode_LATIN_SMALL_LETTER_U_WITH_TILDE_BELOW                 0x1E75
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_CIRCUMFLEX_BELOW          0x1E76
#define unicode_LATIN_SMALL_LETTER_U_WITH_CIRCUMFLEX_BELOW            0x1E77
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_TILDE_AND_ACUTE           0x1E78
#define unicode_LATIN_SMALL_LETTER_U_WITH_TILDE_AND_ACUTE             0x1E79
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_MACRON_AND_DIAERESIS      0x1E7A
#define unicode_LATIN_SMALL_LETTER_U_WITH_MACRON_AND_DIAERESIS        0x1E7B
#define unicode_LATIN_CAPITAL_LETTER_V_WITH_TILDE                     0x1E7C
#define unicode_LATIN_SMALL_LETTER_V_WITH_TILDE                       0x1E7D
#define unicode_LATIN_CAPITAL_LETTER_V_WITH_DOT_BELOW                 0x1E7E
#define unicode_LATIN_SMALL_LETTER_V_WITH_DOT_BELOW                   0x1E7F
#define unicode_LATIN_CAPITAL_LETTER_W_WITH_GRAVE                     0x1E80
#define unicode_LATIN_SMALL_LETTER_W_WITH_GRAVE                       0x1E81
#define unicode_LATIN_CAPITAL_LETTER_W_WITH_ACUTE                     0x1E82
#define unicode_LATIN_SMALL_LETTER_W_WITH_ACUTE                       0x1E83
#define unicode_LATIN_CAPITAL_LETTER_W_WITH_DIAERESIS                 0x1E84
#define unicode_LATIN_SMALL_LETTER_W_WITH_DIAERESIS                   0x1E85
#define unicode_LATIN_CAPITAL_LETTER_W_WITH_DOT_ABOVE                 0x1E86
#define unicode_LATIN_SMALL_LETTER_W_WITH_DOT_ABOVE                   0x1E87
#define unicode_LATIN_CAPITAL_LETTER_W_WITH_DOT_BELOW                 0x1E88
#define unicode_LATIN_SMALL_LETTER_W_WITH_DOT_BELOW                   0x1E89
#define unicode_LATIN_CAPITAL_LETTER_X_WITH_DOT_ABOVE                 0x1E8A
#define unicode_LATIN_SMALL_LETTER_X_WITH_DOT_ABOVE                   0x1E8B
#define unicode_LATIN_CAPITAL_LETTER_X_WITH_DIAERESIS                 0x1E8C
#define unicode_LATIN_SMALL_LETTER_X_WITH_DIAERESIS                   0x1E8D
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_DOT_ABOVE                 0x1E8E
#define unicode_LATIN_SMALL_LETTER_Y_WITH_DOT_ABOVE                   0x1E8F
#define unicode_LATIN_CAPITAL_LETTER_Z_WITH_CIRCUMFLEX                0x1E90
#define unicode_LATIN_SMALL_LETTER_Z_WITH_CIRCUMFLEX                  0x1E91
#define unicode_LATIN_CAPITAL_LETTER_Z_WITH_DOT_BELOW                 0x1E92
#define unicode_LATIN_SMALL_LETTER_Z_WITH_DOT_BELOW                   0x1E93
#define unicode_LATIN_CAPITAL_LETTER_Z_WITH_LINE_BELOW                0x1E94
#define unicode_LATIN_SMALL_LETTER_Z_WITH_LINE_BELOW                  0x1E95
#define unicode_LATIN_SMALL_LETTER_H_WITH_LINE_BELOW                  0x1E96
#define unicode_LATIN_SMALL_LETTER_T_WITH_DIAERESIS                   0x1E97
#define unicode_LATIN_SMALL_LETTER_W_WITH_RING_ABOVE                  0x1E98
#define unicode_LATIN_SMALL_LETTER_Y_WITH_RING_ABOVE                  0x1E99
#define unicode_LATIN_SMALL_LETTER_A_WITH_RIGHT_HALF_RING             0x1E9A
#define unicode_LATIN_SMALL_LETTER_LONG_S_WITH_DOT_ABOVE              0x1E9B
#define unicode_LATIN_SMALL_LETTER_LONG_S_WITH_DIAGONAL_STROKE        0x1E9C
#define unicode_LATIN_SMALL_LETTER_LONG_S_WITH_HIGH_STROKE            0x1E9D
#define unicode_LATIN_CAPITAL_LETTER_SHARP_S                          0x1E9E
#define unicode_LATIN_SMALL_LETTER_DELTA                              0x1E9F
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_DOT_BELOW                 0x1EA0
#define unicode_LATIN_SMALL_LETTER_A_WITH_DOT_BELOW                   0x1EA1
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_HOOK_ABOVE                0x1EA2
#define unicode_LATIN_SMALL_LETTER_A_WITH_HOOK_ABOVE                  0x1EA3
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_ACUTE      0x1EA4
#define unicode_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_ACUTE        0x1EA5
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_GRAVE      0x1EA6
#define unicode_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_GRAVE        0x1EA7
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_HOOK_ABOVE 0x1EA8
#define unicode_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_HOOK_ABOVE   0x1EA9
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_TILDE      0x1EAA
#define unicode_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_TILDE        0x1EAB
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_DOT_BELOW  0x1EAC
#define unicode_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_DOT_BELOW    0x1EAD
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_ACUTE           0x1EAE
#define unicode_LATIN_SMALL_LETTER_A_WITH_BREVE_AND_ACUTE             0x1EAF
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_GRAVE           0x1EB0
#define unicode_LATIN_SMALL_LETTER_A_WITH_BREVE_AND_GRAVE             0x1EB1
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_HOOK_ABOVE      0x1EB2
#define unicode_LATIN_SMALL_LETTER_A_WITH_BREVE_AND_HOOK_ABOVE        0x1EB3
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_TILDE           0x1EB4
#define unicode_LATIN_SMALL_LETTER_A_WITH_BREVE_AND_TILDE             0x1EB5
#define unicode_LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_DOT_BELOW       0x1EB6
#define unicode_LATIN_SMALL_LETTER_A_WITH_BREVE_AND_DOT_BELOW         0x1EB7
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_DOT_BELOW                 0x1EB8
#define unicode_LATIN_SMALL_LETTER_E_WITH_DOT_BELOW                   0x1EB9
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_HOOK_ABOVE                0x1EBA
#define unicode_LATIN_SMALL_LETTER_E_WITH_HOOK_ABOVE                  0x1EBB
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_TILDE                     0x1EBC
#define unicode_LATIN_SMALL_LETTER_E_WITH_TILDE                       0x1EBD
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_ACUTE      0x1EBE
#define unicode_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_ACUTE        0x1EBF
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_GRAVE      0x1EC0
#define unicode_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_GRAVE        0x1EC1
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_HOOK_ABOVE 0x1EC2
#define unicode_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_HOOK_ABOVE   0x1EC3
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_TILDE      0x1EC4
#define unicode_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_TILDE        0x1EC5
#define unicode_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_DOT_BELOW  0x1EC6
#define unicode_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_DOT_BELOW    0x1EC7
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_HOOK_ABOVE                0x1EC8
#define unicode_LATIN_SMALL_LETTER_I_WITH_HOOK_ABOVE                  0x1EC9
#define unicode_LATIN_CAPITAL_LETTER_I_WITH_DOT_BELOW                 0x1ECA
#define unicode_LATIN_SMALL_LETTER_I_WITH_DOT_BELOW                   0x1ECB
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_DOT_BELOW                 0x1ECC
#define unicode_LATIN_SMALL_LETTER_O_WITH_DOT_BELOW                   0x1ECD
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_HOOK_ABOVE                0x1ECE
#define unicode_LATIN_SMALL_LETTER_O_WITH_HOOK_ABOVE                  0x1ECF
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_ACUTE      0x1ED0
#define unicode_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_ACUTE        0x1ED1
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_GRAVE      0x1ED2
#define unicode_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_GRAVE        0x1ED3
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_HOOK_ABOVE 0x1ED4
#define unicode_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_HOOK_ABOVE   0x1ED5
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_TILDE      0x1ED6
#define unicode_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_TILDE        0x1ED7
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_DOT_BELOW  0x1ED8
#define unicode_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_DOT_BELOW    0x1ED9
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_ACUTE            0x1EDA
#define unicode_LATIN_SMALL_LETTER_O_WITH_HORN_AND_ACUTE              0x1EDB
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_GRAVE            0x1EDC
#define unicode_LATIN_SMALL_LETTER_O_WITH_HORN_AND_GRAVE              0x1EDD
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_HOOK_ABOVE       0x1EDE
#define unicode_LATIN_SMALL_LETTER_O_WITH_HORN_AND_HOOK_ABOVE         0x1EDF
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_TILDE            0x1EE0
#define unicode_LATIN_SMALL_LETTER_O_WITH_HORN_AND_TILDE              0x1EE1
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_DOT_BELOW        0x1EE2
#define unicode_LATIN_SMALL_LETTER_O_WITH_HORN_AND_DOT_BELOW          0x1EE3
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_DOT_BELOW                 0x1EE4
#define unicode_LATIN_SMALL_LETTER_U_WITH_DOT_BELOW                   0x1EE5
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_HOOK_ABOVE                0x1EE6
#define unicode_LATIN_SMALL_LETTER_U_WITH_HOOK_ABOVE                  0x1EE7
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_ACUTE            0x1EE8
#define unicode_LATIN_SMALL_LETTER_U_WITH_HORN_AND_ACUTE              0x1EE9
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_GRAVE            0x1EEA
#define unicode_LATIN_SMALL_LETTER_U_WITH_HORN_AND_GRAVE              0x1EEB
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_HOOK_ABOVE       0x1EEC
#define unicode_LATIN_SMALL_LETTER_U_WITH_HORN_AND_HOOK_ABOVE         0x1EED
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_TILDE            0x1EEE
#define unicode_LATIN_SMALL_LETTER_U_WITH_HORN_AND_TILDE              0x1EEF
#define unicode_LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_DOT_BELOW        0x1EF0
#define unicode_LATIN_SMALL_LETTER_U_WITH_HORN_AND_DOT_BELOW          0x1EF1
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_GRAVE                     0x1EF2
#define unicode_LATIN_SMALL_LETTER_Y_WITH_GRAVE                       0x1EF3
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_DOT_BELOW                 0x1EF4
#define unicode_LATIN_SMALL_LETTER_Y_WITH_DOT_BELOW                   0x1EF5
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_HOOK_ABOVE                0x1EF6
#define unicode_LATIN_SMALL_LETTER_Y_WITH_HOOK_ABOVE                  0x1EF7
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_TILDE                     0x1EF8
#define unicode_LATIN_SMALL_LETTER_Y_WITH_TILDE                       0x1EF9
#define unicode_LATIN_CAPITAL_LETTER_MIDDLE_WELSH_LL                  0x1EFA
#define unicode_LATIN_SMALL_LETTER_MIDDLE_WELSH_LL                    0x1EFB
#define unicode_LATIN_CAPITAL_LETTER_MIDDLE_WELSH_V                   0x1EFC
#define unicode_LATIN_SMALL_LETTER_MIDDLE_WELSH_V                     0x1EFD
#define unicode_LATIN_CAPITAL_LETTER_Y_WITH_LOOP                      0x1EFE
#define unicode_LATIN_SMALL_LETTER_Y_WITH_LOOP                        0x1EFF
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI                   0x1F00
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA                   0x1F01
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_VARIA         0x1F02
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_VARIA         0x1F03
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_OXIA          0x1F04
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_OXIA          0x1F05
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI   0x1F06
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI   0x1F07
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI                 0x1F08
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA                 0x1F09
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_VARIA       0x1F0A
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_VARIA       0x1F0B
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_OXIA        0x1F0C
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_OXIA        0x1F0D
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI 0x1F0E
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI 0x1F0F
#define unicode_GREEK_SMALL_LETTER_EPSILON_WITH_PSILI                 0x1F10
#define unicode_GREEK_SMALL_LETTER_EPSILON_WITH_DASIA                 0x1F11
#define unicode_GREEK_SMALL_LETTER_EPSILON_WITH_PSILI_AND_VARIA       0x1F12
#define unicode_GREEK_SMALL_LETTER_EPSILON_WITH_DASIA_AND_VARIA       0x1F13
#define unicode_GREEK_SMALL_LETTER_EPSILON_WITH_PSILI_AND_OXIA        0x1F14
#define unicode_GREEK_SMALL_LETTER_EPSILON_WITH_DASIA_AND_OXIA        0x1F15
#define unicode_GREEK_CAPITAL_LETTER_EPSILON_WITH_PSILI               0x1F18
#define unicode_GREEK_CAPITAL_LETTER_EPSILON_WITH_DASIA               0x1F19
#define unicode_GREEK_CAPITAL_LETTER_EPSILON_WITH_PSILI_AND_VARIA     0x1F1A
#define unicode_GREEK_CAPITAL_LETTER_EPSILON_WITH_DASIA_AND_VARIA     0x1F1B
#define unicode_GREEK_CAPITAL_LETTER_EPSILON_WITH_PSILI_AND_OXIA      0x1F1C
#define unicode_GREEK_CAPITAL_LETTER_EPSILON_WITH_DASIA_AND_OXIA      0x1F1D
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_PSILI                     0x1F20
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_DASIA                     0x1F21
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_VARIA           0x1F22
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_VARIA           0x1F23
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_OXIA            0x1F24
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_OXIA            0x1F25
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI     0x1F26
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI     0x1F27
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI                   0x1F28
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA                   0x1F29
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_VARIA         0x1F2A
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_VARIA         0x1F2B
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_OXIA          0x1F2C
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_OXIA          0x1F2D
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI   0x1F2E
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI   0x1F2F
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_PSILI                    0x1F30
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_DASIA                    0x1F31
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_PSILI_AND_VARIA          0x1F32
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_DASIA_AND_VARIA          0x1F33
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_PSILI_AND_OXIA           0x1F34
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_DASIA_AND_OXIA           0x1F35
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_PSILI_AND_PERISPOMENI    0x1F36
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_DASIA_AND_PERISPOMENI    0x1F37
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI                  0x1F38
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA                  0x1F39
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI_AND_VARIA        0x1F3A
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA_AND_VARIA        0x1F3B
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI_AND_OXIA         0x1F3C
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA_AND_OXIA         0x1F3D
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI_AND_PERISPOMENI  0x1F3E
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA_AND_PERISPOMENI  0x1F3F
#define unicode_GREEK_SMALL_LETTER_OMICRON_WITH_PSILI                 0x1F40
#define unicode_GREEK_SMALL_LETTER_OMICRON_WITH_DASIA                 0x1F41
#define unicode_GREEK_SMALL_LETTER_OMICRON_WITH_PSILI_AND_VARIA       0x1F42
#define unicode_GREEK_SMALL_LETTER_OMICRON_WITH_DASIA_AND_VARIA       0x1F43
#define unicode_GREEK_SMALL_LETTER_OMICRON_WITH_PSILI_AND_OXIA        0x1F44
#define unicode_GREEK_SMALL_LETTER_OMICRON_WITH_DASIA_AND_OXIA        0x1F45
#define unicode_GREEK_CAPITAL_LETTER_OMICRON_WITH_PSILI               0x1F48
#define unicode_GREEK_CAPITAL_LETTER_OMICRON_WITH_DASIA               0x1F49
#define unicode_GREEK_CAPITAL_LETTER_OMICRON_WITH_PSILI_AND_VARIA     0x1F4A
#define unicode_GREEK_CAPITAL_LETTER_OMICRON_WITH_DASIA_AND_VARIA     0x1F4B
#define unicode_GREEK_CAPITAL_LETTER_OMICRON_WITH_PSILI_AND_OXIA      0x1F4C
#define unicode_GREEK_CAPITAL_LETTER_OMICRON_WITH_DASIA_AND_OXIA      0x1F4D
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_PSILI                 0x1F50
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_DASIA                 0x1F51
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_PSILI_AND_VARIA       0x1F52
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_DASIA_AND_VARIA       0x1F53
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_PSILI_AND_OXIA        0x1F54
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_DASIA_AND_OXIA        0x1F55
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_PSILI_AND_PERISPOMENI 0x1F56
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_DASIA_AND_PERISPOMENI 0x1F57
#define unicode_GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA               0x1F59
#define unicode_GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA_AND_VARIA     0x1F5B
#define unicode_GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA_AND_OXIA      0x1F5D
#define unicode_GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA_AND_PERISPOMENI 0x1F5F
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI                   0x1F60
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA                   0x1F61
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_VARIA         0x1F62
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_VARIA         0x1F63
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_OXIA          0x1F64
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_OXIA          0x1F65
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI   0x1F66
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI   0x1F67
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI                 0x1F68
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA                 0x1F69
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_VARIA       0x1F6A
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_VARIA       0x1F6B
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_OXIA        0x1F6C
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_OXIA        0x1F6D
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI 0x1F6E
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI 0x1F6F
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_VARIA                   0x1F70
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_OXIA                    0x1F71
#define unicode_GREEK_SMALL_LETTER_EPSILON_WITH_VARIA                 0x1F72
#define unicode_GREEK_SMALL_LETTER_EPSILON_WITH_OXIA                  0x1F73
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_VARIA                     0x1F74
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_OXIA                      0x1F75
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_VARIA                    0x1F76
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_OXIA                     0x1F77
#define unicode_GREEK_SMALL_LETTER_OMICRON_WITH_VARIA                 0x1F78
#define unicode_GREEK_SMALL_LETTER_OMICRON_WITH_OXIA                  0x1F79
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_VARIA                 0x1F7A
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_OXIA                  0x1F7B
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_VARIA                   0x1F7C
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_OXIA                    0x1F7D
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_YPOGEGRAMMENI 0x1F80
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_YPOGEGRAMMENI 0x1F81
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_VARIA_AND_YPOGEGRAMMENI 0x1F82
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_VARIA_AND_YPOGEGRAMMENI 0x1F83
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_OXIA_AND_YPOGEGRAMMENI 0x1F84
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_OXIA_AND_YPOGEGRAMMENI 0x1F85
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI_AND_YPOGEGRAMMENI 0x1F86
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI_AND_YPOGEGRAMMENI 0x1F87
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_PROSGEGRAMMENI 0x1F88
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_PROSGEGRAMMENI 0x1F89
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_VARIA_AND_PROSGEGRAMMENI 0x1F8A
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_VARIA_AND_PROSGEGRAMMENI 0x1F8B
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_OXIA_AND_PROSGEGRAMMENI 0x1F8C
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_OXIA_AND_PROSGEGRAMMENI 0x1F8D
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI_AND_PROSGEGRAMMENI 0x1F8E
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI_AND_PROSGEGRAMMENI 0x1F8F
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_YPOGEGRAMMENI   0x1F90
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_YPOGEGRAMMENI   0x1F91
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_VARIA_AND_YPOGEGRAMMENI 0x1F92
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_VARIA_AND_YPOGEGRAMMENI 0x1F93
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_OXIA_AND_YPOGEGRAMMENI 0x1F94
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_OXIA_AND_YPOGEGRAMMENI 0x1F95
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI_AND_YPOGEGRAMMENI 0x1F96
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI_AND_YPOGEGRAMMENI 0x1F97
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_PROSGEGRAMMENI 0x1F98
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_PROSGEGRAMMENI  0x1F99
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_VARIA_AND_PROSGEGRAMMENI 0x1F9A
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_VARIA_AND_PROSGEGRAMMENI 0x1F9B
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_OXIA_AND_PROSGEGRAMMENI 0x1F9C
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_OXIA_AND_PROSGEGRAMMENI 0x1F9D
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI_AND_PROSGEGRAMMENI 0x1F9E
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI_AND_PROSGEGRAMMENI 0x1F9F
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_YPOGEGRAMMENI 0x1FA0
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_YPOGEGRAMMENI 0x1FA1
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_VARIA_AND_YPOGEGRAMMENI 0x1FA2
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_VARIA_AND_YPOGEGRAMMENI 0x1FA3
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_OXIA_AND_YPOGEGRAMMENI 0x1FA4
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_OXIA_AND_YPOGEGRAMMENI 0x1FA5
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI_AND_YPOGEGRAMMENI 0x1FA6
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI_AND_YPOGEGRAMMENI 0x1FA7
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_PROSGEGRAMMENI 0x1FA8
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_PROSGEGRAMMENI 0x1FA9
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_VARIA_AND_PROSGEGRAMMENI 0x1FAA
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_VARIA_AND_PROSGEGRAMMENI 0x1FAB
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_OXIA_AND_PROSGEGRAMMENI 0x1FAC
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_OXIA_AND_PROSGEGRAMMENI 0x1FAD
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI_AND_PROSGEGRAMMENI 0x1FAE
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI_AND_PROSGEGRAMMENI 0x1FAF
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_VRACHY                  0x1FB0
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_MACRON                  0x1FB1
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_VARIA_AND_YPOGEGRAMMENI 0x1FB2
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_YPOGEGRAMMENI           0x1FB3
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_OXIA_AND_YPOGEGRAMMENI  0x1FB4
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_PERISPOMENI             0x1FB6
#define unicode_GREEK_SMALL_LETTER_ALPHA_WITH_PERISPOMENI_AND_YPOGEGRAMMENI 0x1FB7
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_VRACHY                0x1FB8
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_MACRON                0x1FB9
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_VARIA                 0x1FBA
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_OXIA                  0x1FBB
#define unicode_GREEK_CAPITAL_LETTER_ALPHA_WITH_PROSGEGRAMMENI        0x1FBC
#define unicode_GREEK_KORONIS                                         0x1FBD
#define unicode_GREEK_PROSGEGRAMMENI                                  0x1FBE
#define unicode_GREEK_PSILI                                           0x1FBF
#define unicode_GREEK_PERISPOMENI                                     0x1FC0
#define unicode_GREEK_DIALYTIKA_AND_PERISPOMENI                       0x1FC1
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_VARIA_AND_YPOGEGRAMMENI   0x1FC2
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_YPOGEGRAMMENI             0x1FC3
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_OXIA_AND_YPOGEGRAMMENI    0x1FC4
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_PERISPOMENI               0x1FC6
#define unicode_GREEK_SMALL_LETTER_ETA_WITH_PERISPOMENI_AND_YPOGEGRAMMENI 0x1FC7
#define unicode_GREEK_CAPITAL_LETTER_EPSILON_WITH_VARIA               0x1FC8
#define unicode_GREEK_CAPITAL_LETTER_EPSILON_WITH_OXIA                0x1FC9
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_VARIA                   0x1FCA
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_OXIA                    0x1FCB
#define unicode_GREEK_CAPITAL_LETTER_ETA_WITH_PROSGEGRAMMENI          0x1FCC
#define unicode_GREEK_PSILI_AND_VARIA                                 0x1FCD
#define unicode_GREEK_PSILI_AND_OXIA                                  0x1FCE
#define unicode_GREEK_PSILI_AND_PERISPOMENI                           0x1FCF
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_VRACHY                   0x1FD0
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_MACRON                   0x1FD1
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_VARIA      0x1FD2
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_OXIA       0x1FD3
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_PERISPOMENI              0x1FD6
#define unicode_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_PERISPOMENI 0x1FD7
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_VRACHY                 0x1FD8
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_MACRON                 0x1FD9
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_VARIA                  0x1FDA
#define unicode_GREEK_CAPITAL_LETTER_IOTA_WITH_OXIA                   0x1FDB
#define unicode_GREEK_DASIA_AND_VARIA                                 0x1FDD
#define unicode_GREEK_DASIA_AND_OXIA                                  0x1FDE
#define unicode_GREEK_DASIA_AND_PERISPOMENI                           0x1FDF
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_VRACHY                0x1FE0
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_MACRON                0x1FE1
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_VARIA   0x1FE2
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_OXIA    0x1FE3
#define unicode_GREEK_SMALL_LETTER_RHO_WITH_PSILI                     0x1FE4
#define unicode_GREEK_SMALL_LETTER_RHO_WITH_DASIA                     0x1FE5
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_PERISPOMENI           0x1FE6
#define unicode_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_PERISPOMENI 0x1FE7
#define unicode_GREEK_CAPITAL_LETTER_UPSILON_WITH_VRACHY              0x1FE8
#define unicode_GREEK_CAPITAL_LETTER_UPSILON_WITH_MACRON              0x1FE9
#define unicode_GREEK_CAPITAL_LETTER_UPSILON_WITH_VARIA               0x1FEA
#define unicode_GREEK_CAPITAL_LETTER_UPSILON_WITH_OXIA                0x1FEB
#define unicode_GREEK_CAPITAL_LETTER_RHO_WITH_DASIA                   0x1FEC
#define unicode_GREEK_DIALYTIKA_AND_VARIA                             0x1FED
#define unicode_GREEK_DIALYTIKA_AND_OXIA                              0x1FEE
#define unicode_GREEK_VARIA                                           0x1FEF
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_VARIA_AND_YPOGEGRAMMENI 0x1FF2
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_YPOGEGRAMMENI           0x1FF3
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_OXIA_AND_YPOGEGRAMMENI  0x1FF4
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_PERISPOMENI             0x1FF6
#define unicode_GREEK_SMALL_LETTER_OMEGA_WITH_PERISPOMENI_AND_YPOGEGRAMMENI 0x1FF7
#define unicode_GREEK_CAPITAL_LETTER_OMICRON_WITH_VARIA               0x1FF8
#define unicode_GREEK_CAPITAL_LETTER_OMICRON_WITH_OXIA                0x1FF9
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_VARIA                 0x1FFA
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_OXIA                  0x1FFB
#define unicode_GREEK_CAPITAL_LETTER_OMEGA_WITH_PROSGEGRAMMENI        0x1FFC
#define unicode_GREEK_OXIA                                            0x1FFD
#define unicode_GREEK_DASIA                                           0x1FFE
#define unicode_EN_QUAD                                               0x2000
#define unicode_EM_QUAD                                               0x2001
#define unicode_EN_SPACE                                              0x2002
#define unicode_EM_SPACE                                              0x2003
#define unicode_THREE_PER_EM_SPACE                                    0x2004
#define unicode_FOUR_PER_EM_SPACE                                     0x2005
#define unicode_SIX_PER_EM_SPACE                                      0x2006
#define unicode_FIGURE_SPACE                                          0x2007
#define unicode_PUNCTUATION_SPACE                                     0x2008
#define unicode_THIN_SPACE                                            0x2009
#define unicode_HAIR_SPACE                                            0x200A
#define unicode_ZERO_WIDTH_SPACE                                      0x200B
#define unicode_ZERO_WIDTH_NON_JOINER                                 0x200C
#define unicode_ZERO_WIDTH_JOINER                                     0x200D
#define unicode_LEFT_TO_RIGHT_MARK                                    0x200E
#define unicode_RIGHT_TO_LEFT_MARK                                    0x200F
#define unicode_HYPHEN                                                0x2010
#define unicode_NON_BREAKING_HYPHEN                                   0x2011
#define unicode_FIGURE_DASH                                           0x2012
#define unicode_EN_DASH                                               0x2013
#define unicode_EM_DASH                                               0x2014
#define unicode_HORIZONTAL_BAR                                        0x2015
#define unicode_DOUBLE_VERTICAL_LINE                                  0x2016
#define unicode_DOUBLE_LOW_LINE                                       0x2017
#define unicode_LEFT_SINGLE_QUOTATION_MARK                            0x2018
#define unicode_RIGHT_SINGLE_QUOTATION_MARK                           0x2019
#define unicode_SINGLE_LOW_9_QUOTATION_MARK                           0x201A
#define unicode_SINGLE_HIGH_REVERSED_9_QUOTATION_MARK                 0x201B
#define unicode_LEFT_DOUBLE_QUOTATION_MARK                            0x201C
#define unicode_RIGHT_DOUBLE_QUOTATION_MARK                           0x201D
#define unicode_DOUBLE_LOW_9_QUOTATION_MARK                           0x201E
#define unicode_DOUBLE_HIGH_REVERSED_9_QUOTATION_MARK                 0x201F
#define unicode_DAGGER                                                0x2020
#define unicode_DOUBLE_DAGGER                                         0x2021
#define unicode_BULLET                                                0x2022
#define unicode_TRIANGULAR_BULLET                                     0x2023
#define unicode_ONE_DOT_LEADER                                        0x2024
#define unicode_TWO_DOT_LEADER                                        0x2025
#define unicode_HORIZONTAL_ELLIPSIS                                   0x2026
#define unicode_HYPHENATION_POINT                                     0x2027
#define unicode_LINE_SEPARATOR                                        0x2028
#define unicode_PARAGRAPH_SEPARATOR                                   0x2029
#define unicode_LEFT_TO_RIGHT_EMBEDDING                               0x202A
#define unicode_RIGHT_TO_LEFT_EMBEDDING                               0x202B
#define unicode_POP_DIRECTIONAL_FORMATTING                            0x202C
#define unicode_LEFT_TO_RIGHT_OVERRIDE                                0x202D
#define unicode_RIGHT_TO_LEFT_OVERRIDE                                0x202E
#define unicode_NARROW_NO_BREAK_SPACE                                 0x202F
#define unicode_PER_MILLE_SIGN                                        0x2030
#define unicode_PER_TEN_THOUSAND_SIGN                                 0x2031
#define unicode_PRIME                                                 0x2032
#define unicode_DOUBLE_PRIME                                          0x2033
#define unicode_TRIPLE_PRIME                                          0x2034
#define unicode_REVERSED_PRIME                                        0x2035
#define unicode_REVERSED_DOUBLE_PRIME                                 0x2036
#define unicode_REVERSED_TRIPLE_PRIME                                 0x2037
#define unicode_CARET                                                 0x2038
#define unicode_SINGLE_LEFT_POINTING_ANGLE_QUOTATION_MARK             0x2039
#define unicode_SINGLE_RIGHT_POINTING_ANGLE_QUOTATION_MARK            0x203A
#define unicode_REFERENCE_MARK                                        0x203B
#define unicode_DOUBLE_EXCLAMATION_MARK                               0x203C
#define unicode_INTERROBANG                                           0x203D
#define unicode_OVERLINE                                              0x203E
#define unicode_UNDERTIE                                              0x203F
#define unicode_CHARACTER_TIE                                         0x2040
#define unicode_CARET_INSERTION_POINT                                 0x2041
#define unicode_ASTERISM                                              0x2042
#define unicode_HYPHEN_BULLET                                         0x2043
#define unicode_FRACTION_SLASH                                        0x2044
#define unicode_LEFT_SQUARE_BRACKET_WITH_QUILL                        0x2045
#define unicode_RIGHT_SQUARE_BRACKET_WITH_QUILL                       0x2046
#define unicode_DOUBLE_QUESTION_MARK                                  0x2047
#define unicode_QUESTION_EXCLAMATION_MARK                             0x2048
#define unicode_EXCLAMATION_QUESTION_MARK                             0x2049
#define unicode_TIRONIAN_SIGN_ET                                      0x204A
#define unicode_REVERSED_PILCROW_SIGN                                 0x204B
#define unicode_BLACK_LEFTWARDS_BULLET                                0x204C
#define unicode_BLACK_RIGHTWARDS_BULLET                               0x204D
#define unicode_LOW_ASTERISK                                          0x204E
#define unicode_REVERSED_SEMICOLON                                    0x204F
#define unicode_CLOSE_UP                                              0x2050
#define unicode_TWO_ASTERISKS_ALIGNED_VERTICALLY                      0x2051
#define unicode_COMMERCIAL_MINUS_SIGN                                 0x2052
#define unicode_SWUNG_DASH                                            0x2053
#define unicode_INVERTED_UNDERTIE                                     0x2054
#define unicode_FLOWER_PUNCTUATION_MARK                               0x2055
#define unicode_THREE_DOT_PUNCTUATION                                 0x2056
#define unicode_QUADRUPLE_PRIME                                       0x2057
#define unicode_FOUR_DOT_PUNCTUATION                                  0x2058
#define unicode_FIVE_DOT_PUNCTUATION                                  0x2059
#define unicode_TWO_DOT_PUNCTUATION                                   0x205A
#define unicode_FOUR_DOT_MARK                                         0x205B
#define unicode_DOTTED_CROSS                                          0x205C
#define unicode_TRICOLON                                              0x205D
#define unicode_VERTICAL_FOUR_DOTS                                    0x205E
#define unicode_MEDIUM_MATHEMATICAL_SPACE                             0x205F
#define unicode_WORD_JOINER                                           0x2060
#define unicode_FUNCTION_APPLICATION                                  0x2061
#define unicode_INVISIBLE_TIMES                                       0x2062
#define unicode_INVISIBLE_SEPARATOR                                   0x2063
#define unicode_INVISIBLE_PLUS                                        0x2064
#define unicode_LEFT_TO_RIGHT_ISOLATE                                 0x2066
#define unicode_RIGHT_TO_LEFT_ISOLATE                                 0x2067
#define unicode_FIRST_STRONG_ISOLATE                                  0x2068
#define unicode_POP_DIRECTIONAL_ISOLATE                               0x2069
#define unicode_INHIBIT_SYMMETRIC_SWAPPING                            0x206A
#define unicode_ACTIVATE_SYMMETRIC_SWAPPING                           0x206B
#define unicode_INHIBIT_ARABIC_FORM_SHAPING                           0x206C
#define unicode_ACTIVATE_ARABIC_FORM_SHAPING                          0x206D
#define unicode_NATIONAL_DIGIT_SHAPES                                 0x206E
#define unicode_NOMINAL_DIGIT_SHAPES                                  0x206F
#define unicode_SUPERSCRIPT_ZERO                                      0x2070
#define unicode_SUPERSCRIPT_LATIN_SMALL_LETTER_I                      0x2071
#define unicode_SUPERSCRIPT_FOUR                                      0x2074
#define unicode_SUPERSCRIPT_FIVE                                      0x2075
#define unicode_SUPERSCRIPT_SIX                                       0x2076
#define unicode_SUPERSCRIPT_SEVEN                                     0x2077
#define unicode_SUPERSCRIPT_EIGHT                                     0x2078
#define unicode_SUPERSCRIPT_NINE                                      0x2079
#define unicode_SUPERSCRIPT_PLUS_SIGN                                 0x207A
#define unicode_SUPERSCRIPT_MINUS                                     0x207B
#define unicode_SUPERSCRIPT_EQUALS_SIGN                               0x207C
#define unicode_SUPERSCRIPT_LEFT_PARENTHESIS                          0x207D
#define unicode_SUPERSCRIPT_RIGHT_PARENTHESIS                         0x207E
#define unicode_SUPERSCRIPT_LATIN_SMALL_LETTER_N                      0x207F
#define unicode_SUBSCRIPT_ZERO                                        0x2080
#define unicode_SUBSCRIPT_ONE                                         0x2081
#define unicode_SUBSCRIPT_TWO                                         0x2082
#define unicode_SUBSCRIPT_THREE                                       0x2083
#define unicode_SUBSCRIPT_FOUR                                        0x2084
#define unicode_SUBSCRIPT_FIVE                                        0x2085
#define unicode_SUBSCRIPT_SIX                                         0x2086
#define unicode_SUBSCRIPT_SEVEN                                       0x2087
#define unicode_SUBSCRIPT_EIGHT                                       0x2088
#define unicode_SUBSCRIPT_NINE                                        0x2089
#define unicode_SUBSCRIPT_PLUS_SIGN                                   0x208A
#define unicode_SUBSCRIPT_MINUS                                       0x208B
#define unicode_SUBSCRIPT_EQUALS_SIGN                                 0x208C
#define unicode_SUBSCRIPT_LEFT_PARENTHESIS                            0x208D
#define unicode_SUBSCRIPT_RIGHT_PARENTHESIS                           0x208E
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_A                        0x2090
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_E                        0x2091
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_O                        0x2092
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_X                        0x2093
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_SCHWA                    0x2094
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_H                        0x2095
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_K                        0x2096
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_L                        0x2097
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_M                        0x2098
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_N                        0x2099
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_P                        0x209A
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_S                        0x209B
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_T                        0x209C
#define unicode_EURO_CURRENCY_SIGN                                    0x20A0
#define unicode_COLON_SIGN                                            0x20A1
#define unicode_CRUZEIRO_SIGN                                         0x20A2
#define unicode_FRENCH_FRANC_SIGN                                     0x20A3
#define unicode_LIRA_SIGN                                             0x20A4
#define unicode_MILL_SIGN                                             0x20A5
#define unicode_NAIRA_SIGN                                            0x20A6
#define unicode_PESETA_SIGN                                           0x20A7
#define unicode_RUPEE_SIGN                                            0x20A8
#define unicode_WON_SIGN                                              0x20A9
#define unicode_NEW_SHEQEL_SIGN                                       0x20AA
#define unicode_DONG_SIGN                                             0x20AB
#define unicode_EURO_SIGN                                             0x20AC
#define unicode_KIP_SIGN                                              0x20AD
#define unicode_TUGRIK_SIGN                                           0x20AE
#define unicode_DRACHMA_SIGN                                          0x20AF
#define unicode_GERMAN_PENNY_SIGN                                     0x20B0
#define unicode_PESO_SIGN                                             0x20B1
#define unicode_GUARANI_SIGN                                          0x20B2
#define unicode_AUSTRAL_SIGN                                          0x20B3
#define unicode_HRYVNIA_SIGN                                          0x20B4
#define unicode_CEDI_SIGN                                             0x20B5
#define unicode_LIVRE_TOURNOIS_SIGN                                   0x20B6
#define unicode_SPESMILO_SIGN                                         0x20B7
#define unicode_TENGE_SIGN                                            0x20B8
#define unicode_INDIAN_RUPEE_SIGN                                     0x20B9
#define unicode_TURKISH_LIRA_SIGN                                     0x20BA
#define unicode_NORDIC_MARK_SIGN                                      0x20BB
#define unicode_MANAT_SIGN                                            0x20BC
#define unicode_RUBLE_SIGN                                            0x20BD
#define unicode_COMBINING_LEFT_HARPOON_ABOVE                          0x20D0
#define unicode_COMBINING_RIGHT_HARPOON_ABOVE                         0x20D1
#define unicode_COMBINING_LONG_VERTICAL_LINE_OVERLAY                  0x20D2
#define unicode_COMBINING_SHORT_VERTICAL_LINE_OVERLAY                 0x20D3
#define unicode_COMBINING_ANTICLOCKWISE_ARROW_ABOVE                   0x20D4
#define unicode_COMBINING_CLOCKWISE_ARROW_ABOVE                       0x20D5
#define unicode_COMBINING_LEFT_ARROW_ABOVE                            0x20D6
#define unicode_COMBINING_RIGHT_ARROW_ABOVE                           0x20D7
#define unicode_COMBINING_RING_OVERLAY                                0x20D8
#define unicode_COMBINING_CLOCKWISE_RING_OVERLAY                      0x20D9
#define unicode_COMBINING_ANTICLOCKWISE_RING_OVERLAY                  0x20DA
#define unicode_COMBINING_THREE_DOTS_ABOVE                            0x20DB
#define unicode_COMBINING_FOUR_DOTS_ABOVE                             0x20DC
#define unicode_COMBINING_ENCLOSING_CIRCLE                            0x20DD
#define unicode_COMBINING_ENCLOSING_SQUARE                            0x20DE
#define unicode_COMBINING_ENCLOSING_DIAMOND                           0x20DF
#define unicode_COMBINING_ENCLOSING_CIRCLE_BACKSLASH                  0x20E0
#define unicode_COMBINING_LEFT_RIGHT_ARROW_ABOVE                      0x20E1
#define unicode_COMBINING_ENCLOSING_SCREEN                            0x20E2
#define unicode_COMBINING_ENCLOSING_KEYCAP                            0x20E3
#define unicode_COMBINING_ENCLOSING_UPWARD_POINTING_TRIANGLE          0x20E4
#define unicode_COMBINING_REVERSE_SOLIDUS_OVERLAY                     0x20E5
#define unicode_COMBINING_DOUBLE_VERTICAL_STROKE_OVERLAY              0x20E6
#define unicode_COMBINING_ANNUITY_SYMBOL                              0x20E7
#define unicode_COMBINING_TRIPLE_UNDERDOT                             0x20E8
#define unicode_COMBINING_WIDE_BRIDGE_ABOVE                           0x20E9
#define unicode_COMBINING_LEFTWARDS_ARROW_OVERLAY                     0x20EA
#define unicode_COMBINING_LONG_DOUBLE_SOLIDUS_OVERLAY                 0x20EB
#define unicode_COMBINING_RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS      0x20EC
#define unicode_COMBINING_LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS       0x20ED
#define unicode_COMBINING_LEFT_ARROW_BELOW                            0x20EE
#define unicode_COMBINING_RIGHT_ARROW_BELOW                           0x20EF
#define unicode_COMBINING_ASTERISK_ABOVE                              0x20F0
#define unicode_ACCOUNT_OF                                            0x2100
#define unicode_ADDRESSED_TO_THE_SUBJECT                              0x2101
#define unicode_DOUBLE_STRUCK_CAPITAL_C                               0x2102
#define unicode_DEGREE_CELSIUS                                        0x2103
#define unicode_CENTRE_LINE_SYMBOL                                    0x2104
#define unicode_CARE_OF                                               0x2105
#define unicode_CADA_UNA                                              0x2106
#define unicode_EULER_CONSTANT                                        0x2107
#define unicode_SCRUPLE                                               0x2108
#define unicode_DEGREE_FAHRENHEIT                                     0x2109
#define unicode_SCRIPT_SMALL_G                                        0x210A
#define unicode_SCRIPT_CAPITAL_H                                      0x210B
#define unicode_BLACK_LETTER_CAPITAL_H                                0x210C
#define unicode_DOUBLE_STRUCK_CAPITAL_H                               0x210D
#define unicode_PLANCK_CONSTANT                                       0x210E
#define unicode_PLANCK_CONSTANT_OVER_TWO_PI                           0x210F
#define unicode_SCRIPT_CAPITAL_I                                      0x2110
#define unicode_BLACK_LETTER_CAPITAL_I                                0x2111
#define unicode_SCRIPT_CAPITAL_L                                      0x2112
#define unicode_SCRIPT_SMALL_L                                        0x2113
#define unicode_L_B_BAR_SYMBOL                                        0x2114
#define unicode_DOUBLE_STRUCK_CAPITAL_N                               0x2115
#define unicode_NUMERO_SIGN                                           0x2116
#define unicode_SOUND_RECORDING_COPYRIGHT                             0x2117
#define unicode_SCRIPT_CAPITAL_P                                      0x2118
#define unicode_DOUBLE_STRUCK_CAPITAL_P                               0x2119
#define unicode_DOUBLE_STRUCK_CAPITAL_Q                               0x211A
#define unicode_SCRIPT_CAPITAL_R                                      0x211B
#define unicode_BLACK_LETTER_CAPITAL_R                                0x211C
#define unicode_DOUBLE_STRUCK_CAPITAL_R                               0x211D
#define unicode_PRESCRIPTION_TAKE                                     0x211E
#define unicode_RESPONSE                                              0x211F
#define unicode_SERVICE_MARK                                          0x2120
#define unicode_TELEPHONE_SIGN                                        0x2121
#define unicode_TRADE_MARK_SIGN                                       0x2122
#define unicode_VERSICLE                                              0x2123
#define unicode_DOUBLE_STRUCK_CAPITAL_Z                               0x2124
#define unicode_OUNCE_SIGN                                            0x2125
#define unicode_OHM_SIGN                                              0x2126
#define unicode_INVERTED_OHM_SIGN                                     0x2127
#define unicode_BLACK_LETTER_CAPITAL_Z                                0x2128
#define unicode_TURNED_GREEK_SMALL_LETTER_IOTA                        0x2129
#define unicode_KELVIN_SIGN                                           0x212A
#define unicode_ANGSTROM_SIGN                                         0x212B
#define unicode_SCRIPT_CAPITAL_B                                      0x212C
#define unicode_BLACK_LETTER_CAPITAL_C                                0x212D
#define unicode_ESTIMATED_SYMBOL                                      0x212E
#define unicode_SCRIPT_SMALL_E                                        0x212F
#define unicode_SCRIPT_CAPITAL_E                                      0x2130
#define unicode_SCRIPT_CAPITAL_F                                      0x2131
#define unicode_TURNED_CAPITAL_F                                      0x2132
#define unicode_SCRIPT_CAPITAL_M                                      0x2133
#define unicode_SCRIPT_SMALL_O                                        0x2134
#define unicode_ALEF_SYMBOL                                           0x2135
#define unicode_BET_SYMBOL                                            0x2136
#define unicode_GIMEL_SYMBOL                                          0x2137
#define unicode_DALET_SYMBOL                                          0x2138
#define unicode_INFORMATION_SOURCE                                    0x2139
#define unicode_ROTATED_CAPITAL_Q                                     0x213A
#define unicode_FACSIMILE_SIGN                                        0x213B
#define unicode_DOUBLE_STRUCK_SMALL_PI                                0x213C
#define unicode_DOUBLE_STRUCK_SMALL_GAMMA                             0x213D
#define unicode_DOUBLE_STRUCK_CAPITAL_GAMMA                           0x213E
#define unicode_DOUBLE_STRUCK_CAPITAL_PI                              0x213F
#define unicode_DOUBLE_STRUCK_N_ARY_SUMMATION                         0x2140
#define unicode_TURNED_SANS_SERIF_CAPITAL_G                           0x2141
#define unicode_TURNED_SANS_SERIF_CAPITAL_L                           0x2142
#define unicode_REVERSED_SANS_SERIF_CAPITAL_L                         0x2143
#define unicode_TURNED_SANS_SERIF_CAPITAL_Y                           0x2144
#define unicode_DOUBLE_STRUCK_ITALIC_CAPITAL_D                        0x2145
#define unicode_DOUBLE_STRUCK_ITALIC_SMALL_D                          0x2146
#define unicode_DOUBLE_STRUCK_ITALIC_SMALL_E                          0x2147
#define unicode_DOUBLE_STRUCK_ITALIC_SMALL_I                          0x2148
#define unicode_DOUBLE_STRUCK_ITALIC_SMALL_J                          0x2149
#define unicode_PROPERTY_LINE                                         0x214A
#define unicode_TURNED_AMPERSAND                                      0x214B
#define unicode_PER_SIGN                                              0x214C
#define unicode_AKTIESELSKAB                                          0x214D
#define unicode_TURNED_SMALL_F                                        0x214E
#define unicode_SYMBOL_FOR_SAMARITAN_SOURCE                           0x214F
#define unicode_VULGAR_FRACTION_ONE_SEVENTH                           0x2150
#define unicode_VULGAR_FRACTION_ONE_NINTH                             0x2151
#define unicode_VULGAR_FRACTION_ONE_TENTH                             0x2152
#define unicode_VULGAR_FRACTION_ONE_THIRD                             0x2153
#define unicode_VULGAR_FRACTION_TWO_THIRDS                            0x2154
#define unicode_VULGAR_FRACTION_ONE_FIFTH                             0x2155
#define unicode_VULGAR_FRACTION_TWO_FIFTHS                            0x2156
#define unicode_VULGAR_FRACTION_THREE_FIFTHS                          0x2157
#define unicode_VULGAR_FRACTION_FOUR_FIFTHS                           0x2158
#define unicode_VULGAR_FRACTION_ONE_SIXTH                             0x2159
#define unicode_VULGAR_FRACTION_FIVE_SIXTHS                           0x215A
#define unicode_VULGAR_FRACTION_ONE_EIGHTH                            0x215B
#define unicode_VULGAR_FRACTION_THREE_EIGHTHS                         0x215C
#define unicode_VULGAR_FRACTION_FIVE_EIGHTHS                          0x215D
#define unicode_VULGAR_FRACTION_SEVEN_EIGHTHS                         0x215E
#define unicode_FRACTION_NUMERATOR_ONE                                0x215F
#define unicode_ROMAN_NUMERAL_ONE                                     0x2160
#define unicode_ROMAN_NUMERAL_TWO                                     0x2161
#define unicode_ROMAN_NUMERAL_THREE                                   0x2162
#define unicode_ROMAN_NUMERAL_FOUR                                    0x2163
#define unicode_ROMAN_NUMERAL_FIVE                                    0x2164
#define unicode_ROMAN_NUMERAL_SIX                                     0x2165
#define unicode_ROMAN_NUMERAL_SEVEN                                   0x2166
#define unicode_ROMAN_NUMERAL_EIGHT                                   0x2167
#define unicode_ROMAN_NUMERAL_NINE                                    0x2168
#define unicode_ROMAN_NUMERAL_TEN                                     0x2169
#define unicode_ROMAN_NUMERAL_ELEVEN                                  0x216A
#define unicode_ROMAN_NUMERAL_TWELVE                                  0x216B
#define unicode_ROMAN_NUMERAL_FIFTY                                   0x216C
#define unicode_ROMAN_NUMERAL_ONE_HUNDRED                             0x216D
#define unicode_ROMAN_NUMERAL_FIVE_HUNDRED                            0x216E
#define unicode_ROMAN_NUMERAL_ONE_THOUSAND                            0x216F
#define unicode_SMALL_ROMAN_NUMERAL_ONE                               0x2170
#define unicode_SMALL_ROMAN_NUMERAL_TWO                               0x2171
#define unicode_SMALL_ROMAN_NUMERAL_THREE                             0x2172
#define unicode_SMALL_ROMAN_NUMERAL_FOUR                              0x2173
#define unicode_SMALL_ROMAN_NUMERAL_FIVE                              0x2174
#define unicode_SMALL_ROMAN_NUMERAL_SIX                               0x2175
#define unicode_SMALL_ROMAN_NUMERAL_SEVEN                             0x2176
#define unicode_SMALL_ROMAN_NUMERAL_EIGHT                             0x2177
#define unicode_SMALL_ROMAN_NUMERAL_NINE                              0x2178
#define unicode_SMALL_ROMAN_NUMERAL_TEN                               0x2179
#define unicode_SMALL_ROMAN_NUMERAL_ELEVEN                            0x217A
#define unicode_SMALL_ROMAN_NUMERAL_TWELVE                            0x217B
#define unicode_SMALL_ROMAN_NUMERAL_FIFTY                             0x217C
#define unicode_SMALL_ROMAN_NUMERAL_ONE_HUNDRED                       0x217D
#define unicode_SMALL_ROMAN_NUMERAL_FIVE_HUNDRED                      0x217E
#define unicode_SMALL_ROMAN_NUMERAL_ONE_THOUSAND                      0x217F
#define unicode_ROMAN_NUMERAL_ONE_THOUSAND_C_D                        0x2180
#define unicode_ROMAN_NUMERAL_FIVE_THOUSAND                           0x2181
#define unicode_ROMAN_NUMERAL_TEN_THOUSAND                            0x2182
#define unicode_ROMAN_NUMERAL_REVERSED_ONE_HUNDRED                    0x2183
#define unicode_LATIN_SMALL_LETTER_REVERSED_C                         0x2184
#define unicode_ROMAN_NUMERAL_SIX_LATE_FORM                           0x2185
#define unicode_ROMAN_NUMERAL_FIFTY_EARLY_FORM                        0x2186
#define unicode_ROMAN_NUMERAL_FIFTY_THOUSAND                          0x2187
#define unicode_ROMAN_NUMERAL_ONE_HUNDRED_THOUSAND                    0x2188
#define unicode_VULGAR_FRACTION_ZERO_THIRDS                           0x2189
#define unicode_LEFTWARDS_ARROW                                       0x2190
#define unicode_UPWARDS_ARROW                                         0x2191
#define unicode_RIGHTWARDS_ARROW                                      0x2192
#define unicode_DOWNWARDS_ARROW                                       0x2193
#define unicode_LEFT_RIGHT_ARROW                                      0x2194
#define unicode_UP_DOWN_ARROW                                         0x2195
#define unicode_NORTH_WEST_ARROW                                      0x2196
#define unicode_NORTH_EAST_ARROW                                      0x2197
#define unicode_SOUTH_EAST_ARROW                                      0x2198
#define unicode_SOUTH_WEST_ARROW                                      0x2199
#define unicode_LEFTWARDS_ARROW_WITH_STROKE                           0x219A
#define unicode_RIGHTWARDS_ARROW_WITH_STROKE                          0x219B
#define unicode_LEFTWARDS_WAVE_ARROW                                  0x219C
#define unicode_RIGHTWARDS_WAVE_ARROW                                 0x219D
#define unicode_LEFTWARDS_TWO_HEADED_ARROW                            0x219E
#define unicode_UPWARDS_TWO_HEADED_ARROW                              0x219F
#define unicode_RIGHTWARDS_TWO_HEADED_ARROW                           0x21A0
#define unicode_DOWNWARDS_TWO_HEADED_ARROW                            0x21A1
#define unicode_LEFTWARDS_ARROW_WITH_TAIL                             0x21A2
#define unicode_RIGHTWARDS_ARROW_WITH_TAIL                            0x21A3
#define unicode_LEFTWARDS_ARROW_FROM_BAR                              0x21A4
#define unicode_UPWARDS_ARROW_FROM_BAR                                0x21A5
#define unicode_RIGHTWARDS_ARROW_FROM_BAR                             0x21A6
#define unicode_DOWNWARDS_ARROW_FROM_BAR                              0x21A7
#define unicode_UP_DOWN_ARROW_WITH_BASE                               0x21A8
#define unicode_LEFTWARDS_ARROW_WITH_HOOK                             0x21A9
#define unicode_RIGHTWARDS_ARROW_WITH_HOOK                            0x21AA
#define unicode_LEFTWARDS_ARROW_WITH_LOOP                             0x21AB
#define unicode_RIGHTWARDS_ARROW_WITH_LOOP                            0x21AC
#define unicode_LEFT_RIGHT_WAVE_ARROW                                 0x21AD
#define unicode_LEFT_RIGHT_ARROW_WITH_STROKE                          0x21AE
#define unicode_DOWNWARDS_ZIGZAG_ARROW                                0x21AF
#define unicode_UPWARDS_ARROW_WITH_TIP_LEFTWARDS                      0x21B0
#define unicode_UPWARDS_ARROW_WITH_TIP_RIGHTWARDS                     0x21B1
#define unicode_DOWNWARDS_ARROW_WITH_TIP_LEFTWARDS                    0x21B2
#define unicode_DOWNWARDS_ARROW_WITH_TIP_RIGHTWARDS                   0x21B3
#define unicode_RIGHTWARDS_ARROW_WITH_CORNER_DOWNWARDS                0x21B4
#define unicode_DOWNWARDS_ARROW_WITH_CORNER_LEFTWARDS                 0x21B5
#define unicode_ANTICLOCKWISE_TOP_SEMICIRCLE_ARROW                    0x21B6
#define unicode_CLOCKWISE_TOP_SEMICIRCLE_ARROW                        0x21B7
#define unicode_NORTH_WEST_ARROW_TO_LONG_BAR                          0x21B8
#define unicode_LEFTWARDS_ARROW_TO_BAR_OVER_RIGHTWARDS_ARROW_TO_BAR   0x21B9
#define unicode_ANTICLOCKWISE_OPEN_CIRCLE_ARROW                       0x21BA
#define unicode_CLOCKWISE_OPEN_CIRCLE_ARROW                           0x21BB
#define unicode_LEFTWARDS_HARPOON_WITH_BARB_UPWARDS                   0x21BC
#define unicode_LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS                 0x21BD
#define unicode_UPWARDS_HARPOON_WITH_BARB_RIGHTWARDS                  0x21BE
#define unicode_UPWARDS_HARPOON_WITH_BARB_LEFTWARDS                   0x21BF
#define unicode_RIGHTWARDS_HARPOON_WITH_BARB_UPWARDS                  0x21C0
#define unicode_RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS                0x21C1
#define unicode_DOWNWARDS_HARPOON_WITH_BARB_RIGHTWARDS                0x21C2
#define unicode_DOWNWARDS_HARPOON_WITH_BARB_LEFTWARDS                 0x21C3
#define unicode_RIGHTWARDS_ARROW_OVER_LEFTWARDS_ARROW                 0x21C4
#define unicode_UPWARDS_ARROW_LEFTWARDS_OF_DOWNWARDS_ARROW            0x21C5
#define unicode_LEFTWARDS_ARROW_OVER_RIGHTWARDS_ARROW                 0x21C6
#define unicode_LEFTWARDS_PAIRED_ARROWS                               0x21C7
#define unicode_UPWARDS_PAIRED_ARROWS                                 0x21C8
#define unicode_RIGHTWARDS_PAIRED_ARROWS                              0x21C9
#define unicode_DOWNWARDS_PAIRED_ARROWS                               0x21CA
#define unicode_LEFTWARDS_HARPOON_OVER_RIGHTWARDS_HARPOON             0x21CB
#define unicode_RIGHTWARDS_HARPOON_OVER_LEFTWARDS_HARPOON             0x21CC
#define unicode_LEFTWARDS_DOUBLE_ARROW_WITH_STROKE                    0x21CD
#define unicode_LEFT_RIGHT_DOUBLE_ARROW_WITH_STROKE                   0x21CE
#define unicode_RIGHTWARDS_DOUBLE_ARROW_WITH_STROKE                   0x21CF
#define unicode_LEFTWARDS_DOUBLE_ARROW                                0x21D0
#define unicode_UPWARDS_DOUBLE_ARROW                                  0x21D1
#define unicode_RIGHTWARDS_DOUBLE_ARROW                               0x21D2
#define unicode_DOWNWARDS_DOUBLE_ARROW                                0x21D3
#define unicode_LEFT_RIGHT_DOUBLE_ARROW                               0x21D4
#define unicode_UP_DOWN_DOUBLE_ARROW                                  0x21D5
#define unicode_NORTH_WEST_DOUBLE_ARROW                               0x21D6
#define unicode_NORTH_EAST_DOUBLE_ARROW                               0x21D7
#define unicode_SOUTH_EAST_DOUBLE_ARROW                               0x21D8
#define unicode_SOUTH_WEST_DOUBLE_ARROW                               0x21D9
#define unicode_LEFTWARDS_TRIPLE_ARROW                                0x21DA
#define unicode_RIGHTWARDS_TRIPLE_ARROW                               0x21DB
#define unicode_LEFTWARDS_SQUIGGLE_ARROW                              0x21DC
#define unicode_RIGHTWARDS_SQUIGGLE_ARROW                             0x21DD
#define unicode_UPWARDS_ARROW_WITH_DOUBLE_STROKE                      0x21DE
#define unicode_DOWNWARDS_ARROW_WITH_DOUBLE_STROKE                    0x21DF
#define unicode_LEFTWARDS_DASHED_ARROW                                0x21E0
#define unicode_UPWARDS_DASHED_ARROW                                  0x21E1
#define unicode_RIGHTWARDS_DASHED_ARROW                               0x21E2
#define unicode_DOWNWARDS_DASHED_ARROW                                0x21E3
#define unicode_LEFTWARDS_ARROW_TO_BAR                                0x21E4
#define unicode_RIGHTWARDS_ARROW_TO_BAR                               0x21E5
#define unicode_LEFTWARDS_WHITE_ARROW                                 0x21E6
#define unicode_UPWARDS_WHITE_ARROW                                   0x21E7
#define unicode_RIGHTWARDS_WHITE_ARROW                                0x21E8
#define unicode_DOWNWARDS_WHITE_ARROW                                 0x21E9
#define unicode_UPWARDS_WHITE_ARROW_FROM_BAR                          0x21EA
#define unicode_UPWARDS_WHITE_ARROW_ON_PEDESTAL                       0x21EB
#define unicode_UPWARDS_WHITE_ARROW_ON_PEDESTAL_WITH_HORIZONTAL_BAR   0x21EC
#define unicode_UPWARDS_WHITE_ARROW_ON_PEDESTAL_WITH_VERTICAL_BAR     0x21ED
#define unicode_UPWARDS_WHITE_DOUBLE_ARROW                            0x21EE
#define unicode_UPWARDS_WHITE_DOUBLE_ARROW_ON_PEDESTAL                0x21EF
#define unicode_RIGHTWARDS_WHITE_ARROW_FROM_WALL                      0x21F0
#define unicode_NORTH_WEST_ARROW_TO_CORNER                            0x21F1
#define unicode_SOUTH_EAST_ARROW_TO_CORNER                            0x21F2
#define unicode_UP_DOWN_WHITE_ARROW                                   0x21F3
#define unicode_RIGHT_ARROW_WITH_SMALL_CIRCLE                         0x21F4
#define unicode_DOWNWARDS_ARROW_LEFTWARDS_OF_UPWARDS_ARROW            0x21F5
#define unicode_THREE_RIGHTWARDS_ARROWS                               0x21F6
#define unicode_LEFTWARDS_ARROW_WITH_VERTICAL_STROKE                  0x21F7
#define unicode_RIGHTWARDS_ARROW_WITH_VERTICAL_STROKE                 0x21F8
#define unicode_LEFT_RIGHT_ARROW_WITH_VERTICAL_STROKE                 0x21F9
#define unicode_LEFTWARDS_ARROW_WITH_DOUBLE_VERTICAL_STROKE           0x21FA
#define unicode_RIGHTWARDS_ARROW_WITH_DOUBLE_VERTICAL_STROKE          0x21FB
#define unicode_LEFT_RIGHT_ARROW_WITH_DOUBLE_VERTICAL_STROKE          0x21FC
#define unicode_LEFTWARDS_OPEN_HEADED_ARROW                           0x21FD
#define unicode_RIGHTWARDS_OPEN_HEADED_ARROW                          0x21FE
#define unicode_LEFT_RIGHT_OPEN_HEADED_ARROW                          0x21FF
#define unicode_FOR_ALL                                               0x2200
#define unicode_COMPLEMENT                                            0x2201
#define unicode_PARTIAL_DIFFERENTIAL                                  0x2202
#define unicode_THERE_EXISTS                                          0x2203
#define unicode_THERE_DOES_NOT_EXIST                                  0x2204
#define unicode_EMPTY_SET                                             0x2205
#define unicode_INCREMENT                                             0x2206
#define unicode_NABLA                                                 0x2207
#define unicode_ELEMENT_OF                                            0x2208
#define unicode_NOT_AN_ELEMENT_OF                                     0x2209
#define unicode_SMALL_ELEMENT_OF                                      0x220A
#define unicode_CONTAINS_AS_MEMBER                                    0x220B
#define unicode_DOES_NOT_CONTAIN_AS_MEMBER                            0x220C
#define unicode_SMALL_CONTAINS_AS_MEMBER                              0x220D
#define unicode_END_OF_PROOF                                          0x220E
#define unicode_N_ARY_PRODUCT                                         0x220F
#define unicode_N_ARY_COPRODUCT                                       0x2210
#define unicode_N_ARY_SUMMATION                                       0x2211
#define unicode_MINUS_SIGN                                            0x2212
#define unicode_MINUS_OR_PLUS_SIGN                                    0x2213
#define unicode_DOT_PLUS                                              0x2214
#define unicode_DIVISION_SLASH                                        0x2215
#define unicode_SET_MINUS                                             0x2216
#define unicode_ASTERISK_OPERATOR                                     0x2217
#define unicode_RING_OPERATOR                                         0x2218
#define unicode_BULLET_OPERATOR                                       0x2219
#define unicode_SQUARE_ROOT                                           0x221A
#define unicode_CUBE_ROOT                                             0x221B
#define unicode_FOURTH_ROOT                                           0x221C
#define unicode_PROPORTIONAL_TO                                       0x221D
#define unicode_INFINITY                                              0x221E
#define unicode_RIGHT_ANGLE                                           0x221F
#define unicode_ANGLE                                                 0x2220
#define unicode_MEASURED_ANGLE                                        0x2221
#define unicode_SPHERICAL_ANGLE                                       0x2222
#define unicode_DIVIDES                                               0x2223
#define unicode_DOES_NOT_DIVIDE                                       0x2224
#define unicode_PARALLEL_TO                                           0x2225
#define unicode_NOT_PARALLEL_TO                                       0x2226
#define unicode_LOGICAL_AND                                           0x2227
#define unicode_LOGICAL_OR                                            0x2228
#define unicode_INTERSECTION                                          0x2229
#define unicode_UNION                                                 0x222A
#define unicode_INTEGRAL                                              0x222B
#define unicode_DOUBLE_INTEGRAL                                       0x222C
#define unicode_TRIPLE_INTEGRAL                                       0x222D
#define unicode_CONTOUR_INTEGRAL                                      0x222E
#define unicode_SURFACE_INTEGRAL                                      0x222F
#define unicode_VOLUME_INTEGRAL                                       0x2230
#define unicode_CLOCKWISE_INTEGRAL                                    0x2231
#define unicode_CLOCKWISE_CONTOUR_INTEGRAL                            0x2232
#define unicode_ANTICLOCKWISE_CONTOUR_INTEGRAL                        0x2233
#define unicode_THEREFORE                                             0x2234
#define unicode_BECAUSE                                               0x2235
#define unicode_RATIO                                                 0x2236
#define unicode_PROPORTION                                            0x2237
#define unicode_DOT_MINUS                                             0x2238
#define unicode_EXCESS                                                0x2239
#define unicode_GEOMETRIC_PROPORTION                                  0x223A
#define unicode_HOMOTHETIC                                            0x223B
#define unicode_TILDE_OPERATOR                                        0x223C
#define unicode_REVERSED_TILDE                                        0x223D
#define unicode_INVERTED_LAZY_S                                       0x223E
#define unicode_SINE_WAVE                                             0x223F
#define unicode_WREATH_PRODUCT                                        0x2240
#define unicode_NOT_TILDE                                             0x2241
#define unicode_MINUS_TILDE                                           0x2242
#define unicode_ASYMPTOTICALLY_EQUAL_TO                               0x2243
#define unicode_NOT_ASYMPTOTICALLY_EQUAL_TO                           0x2244
#define unicode_APPROXIMATELY_EQUAL_TO                                0x2245
#define unicode_APPROXIMATELY_BUT_NOT_ACTUALLY_EQUAL_TO               0x2246
#define unicode_NEITHER_APPROXIMATELY_NOR_ACTUALLY_EQUAL_TO           0x2247
#define unicode_ALMOST_EQUAL_TO                                       0x2248
#define unicode_NOT_ALMOST_EQUAL_TO                                   0x2249
#define unicode_ALMOST_EQUAL_OR_EQUAL_TO                              0x224A
#define unicode_TRIPLE_TILDE                                          0x224B
#define unicode_ALL_EQUAL_TO                                          0x224C
#define unicode_EQUIVALENT_TO                                         0x224D
#define unicode_GEOMETRICALLY_EQUIVALENT_TO                           0x224E
#define unicode_DIFFERENCE_BETWEEN                                    0x224F
#define unicode_APPROACHES_THE_LIMIT                                  0x2250
#define unicode_GEOMETRICALLY_EQUAL_TO                                0x2251
#define unicode_APPROXIMATELY_EQUAL_TO_OR_THE_IMAGE_OF                0x2252
#define unicode_IMAGE_OF_OR_APPROXIMATELY_EQUAL_TO                    0x2253
#define unicode_COLON_EQUALS                                          0x2254
#define unicode_EQUALS_COLON                                          0x2255
#define unicode_RING_IN_EQUAL_TO                                      0x2256
#define unicode_RING_EQUAL_TO                                         0x2257
#define unicode_CORRESPONDS_TO                                        0x2258
#define unicode_ESTIMATES                                             0x2259
#define unicode_EQUIANGULAR_TO                                        0x225A
#define unicode_STAR_EQUALS                                           0x225B
#define unicode_DELTA_EQUAL_TO                                        0x225C
#define unicode_EQUAL_TO_BY_DEFINITION                                0x225D
#define unicode_MEASURED_BY                                           0x225E
#define unicode_QUESTIONED_EQUAL_TO                                   0x225F
#define unicode_NOT_EQUAL_TO                                          0x2260
#define unicode_IDENTICAL_TO                                          0x2261
#define unicode_NOT_IDENTICAL_TO                                      0x2262
#define unicode_STRICTLY_EQUIVALENT_TO                                0x2263
#define unicode_LESS_THAN_OR_EQUAL_TO                                 0x2264
#define unicode_GREATER_THAN_OR_EQUAL_TO                              0x2265
#define unicode_LESS_THAN_OVER_EQUAL_TO                               0x2266
#define unicode_GREATER_THAN_OVER_EQUAL_TO                            0x2267
#define unicode_LESS_THAN_BUT_NOT_EQUAL_TO                            0x2268
#define unicode_GREATER_THAN_BUT_NOT_EQUAL_TO                         0x2269
#define unicode_MUCH_LESS_THAN                                        0x226A
#define unicode_MUCH_GREATER_THAN                                     0x226B
#define unicode_BETWEEN                                               0x226C
#define unicode_NOT_EQUIVALENT_TO                                     0x226D
#define unicode_NOT_LESS_THAN                                         0x226E
#define unicode_NOT_GREATER_THAN                                      0x226F
#define unicode_NEITHER_LESS_THAN_NOR_EQUAL_TO                        0x2270
#define unicode_NEITHER_GREATER_THAN_NOR_EQUAL_TO                     0x2271
#define unicode_LESS_THAN_OR_EQUIVALENT_TO                            0x2272
#define unicode_GREATER_THAN_OR_EQUIVALENT_TO                         0x2273
#define unicode_NEITHER_LESS_THAN_NOR_EQUIVALENT_TO                   0x2274
#define unicode_NEITHER_GREATER_THAN_NOR_EQUIVALENT_TO                0x2275
#define unicode_LESS_THAN_OR_GREATER_THAN                             0x2276
#define unicode_GREATER_THAN_OR_LESS_THAN                             0x2277
#define unicode_NEITHER_LESS_THAN_NOR_GREATER_THAN                    0x2278
#define unicode_NEITHER_GREATER_THAN_NOR_LESS_THAN                    0x2279
#define unicode_PRECEDES                                              0x227A
#define unicode_SUCCEEDS                                              0x227B
#define unicode_PRECEDES_OR_EQUAL_TO                                  0x227C
#define unicode_SUCCEEDS_OR_EQUAL_TO                                  0x227D
#define unicode_PRECEDES_OR_EQUIVALENT_TO                             0x227E
#define unicode_SUCCEEDS_OR_EQUIVALENT_TO                             0x227F
#define unicode_DOES_NOT_PRECEDE                                      0x2280
#define unicode_DOES_NOT_SUCCEED                                      0x2281
#define unicode_SUBSET_OF                                             0x2282
#define unicode_SUPERSET_OF                                           0x2283
#define unicode_NOT_A_SUBSET_OF                                       0x2284
#define unicode_NOT_A_SUPERSET_OF                                     0x2285
#define unicode_SUBSET_OF_OR_EQUAL_TO                                 0x2286
#define unicode_SUPERSET_OF_OR_EQUAL_TO                               0x2287
#define unicode_NEITHER_A_SUBSET_OF_NOR_EQUAL_TO                      0x2288
#define unicode_NEITHER_A_SUPERSET_OF_NOR_EQUAL_TO                    0x2289
#define unicode_SUBSET_OF_WITH_NOT_EQUAL_TO                           0x228A
#define unicode_SUPERSET_OF_WITH_NOT_EQUAL_TO                         0x228B
#define unicode_MULTISET                                              0x228C
#define unicode_MULTISET_MULTIPLICATION                               0x228D
#define unicode_MULTISET_UNION                                        0x228E
#define unicode_SQUARE_IMAGE_OF                                       0x228F
#define unicode_SQUARE_ORIGINAL_OF                                    0x2290
#define unicode_SQUARE_IMAGE_OF_OR_EQUAL_TO                           0x2291
#define unicode_SQUARE_ORIGINAL_OF_OR_EQUAL_TO                        0x2292
#define unicode_SQUARE_CAP                                            0x2293
#define unicode_SQUARE_CUP                                            0x2294
#define unicode_CIRCLED_PLUS                                          0x2295
#define unicode_CIRCLED_MINUS                                         0x2296
#define unicode_CIRCLED_TIMES                                         0x2297
#define unicode_CIRCLED_DIVISION_SLASH                                0x2298
#define unicode_CIRCLED_DOT_OPERATOR                                  0x2299
#define unicode_CIRCLED_RING_OPERATOR                                 0x229A
#define unicode_CIRCLED_ASTERISK_OPERATOR                             0x229B
#define unicode_CIRCLED_EQUALS                                        0x229C
#define unicode_CIRCLED_DASH                                          0x229D
#define unicode_SQUARED_PLUS                                          0x229E
#define unicode_SQUARED_MINUS                                         0x229F
#define unicode_SQUARED_TIMES                                         0x22A0
#define unicode_SQUARED_DOT_OPERATOR                                  0x22A1
#define unicode_RIGHT_TACK                                            0x22A2
#define unicode_LEFT_TACK                                             0x22A3
#define unicode_DOWN_TACK                                             0x22A4
#define unicode_UP_TACK                                               0x22A5
#define unicode_ASSERTION                                             0x22A6
#define unicode_MODELS                                                0x22A7
#define unicode_TRUE                                                  0x22A8
#define unicode_FORCES                                                0x22A9
#define unicode_TRIPLE_VERTICAL_BAR_RIGHT_TURNSTILE                   0x22AA
#define unicode_DOUBLE_VERTICAL_BAR_DOUBLE_RIGHT_TURNSTILE            0x22AB
#define unicode_DOES_NOT_PROVE                                        0x22AC
#define unicode_NOT_TRUE                                              0x22AD
#define unicode_DOES_NOT_FORCE                                        0x22AE
#define unicode_NEGATED_DOUBLE_VERTICAL_BAR_DOUBLE_RIGHT_TURNSTILE    0x22AF
#define unicode_PRECEDES_UNDER_RELATION                               0x22B0
#define unicode_SUCCEEDS_UNDER_RELATION                               0x22B1
#define unicode_NORMAL_SUBGROUP_OF                                    0x22B2
#define unicode_CONTAINS_AS_NORMAL_SUBGROUP                           0x22B3
#define unicode_NORMAL_SUBGROUP_OF_OR_EQUAL_TO                        0x22B4
#define unicode_CONTAINS_AS_NORMAL_SUBGROUP_OR_EQUAL_TO               0x22B5
#define unicode_ORIGINAL_OF                                           0x22B6
#define unicode_IMAGE_OF                                              0x22B7
#define unicode_MULTIMAP                                              0x22B8
#define unicode_HERMITIAN_CONJUGATE_MATRIX                            0x22B9
#define unicode_INTERCALATE                                           0x22BA
#define unicode_XOR                                                   0x22BB
#define unicode_NAND                                                  0x22BC
#define unicode_NOR                                                   0x22BD
#define unicode_RIGHT_ANGLE_WITH_ARC                                  0x22BE
#define unicode_RIGHT_TRIANGLE                                        0x22BF
#define unicode_N_ARY_LOGICAL_AND                                     0x22C0
#define unicode_N_ARY_LOGICAL_OR                                      0x22C1
#define unicode_N_ARY_INTERSECTION                                    0x22C2
#define unicode_N_ARY_UNION                                           0x22C3
#define unicode_DIAMOND_OPERATOR                                      0x22C4
#define unicode_DOT_OPERATOR                                          0x22C5
#define unicode_STAR_OPERATOR                                         0x22C6
#define unicode_DIVISION_TIMES                                        0x22C7
#define unicode_BOWTIE                                                0x22C8
#define unicode_LEFT_NORMAL_FACTOR_SEMIDIRECT_PRODUCT                 0x22C9
#define unicode_RIGHT_NORMAL_FACTOR_SEMIDIRECT_PRODUCT                0x22CA
#define unicode_LEFT_SEMIDIRECT_PRODUCT                               0x22CB
#define unicode_RIGHT_SEMIDIRECT_PRODUCT                              0x22CC
#define unicode_REVERSED_TILDE_EQUALS                                 0x22CD
#define unicode_CURLY_LOGICAL_OR                                      0x22CE
#define unicode_CURLY_LOGICAL_AND                                     0x22CF
#define unicode_DOUBLE_SUBSET                                         0x22D0
#define unicode_DOUBLE_SUPERSET                                       0x22D1
#define unicode_DOUBLE_INTERSECTION                                   0x22D2
#define unicode_DOUBLE_UNION                                          0x22D3
#define unicode_PITCHFORK                                             0x22D4
#define unicode_EQUAL_AND_PARALLEL_TO                                 0x22D5
#define unicode_LESS_THAN_WITH_DOT                                    0x22D6
#define unicode_GREATER_THAN_WITH_DOT                                 0x22D7
#define unicode_VERY_MUCH_LESS_THAN                                   0x22D8
#define unicode_VERY_MUCH_GREATER_THAN                                0x22D9
#define unicode_LESS_THAN_EQUAL_TO_OR_GREATER_THAN                    0x22DA
#define unicode_GREATER_THAN_EQUAL_TO_OR_LESS_THAN                    0x22DB
#define unicode_EQUAL_TO_OR_LESS_THAN                                 0x22DC
#define unicode_EQUAL_TO_OR_GREATER_THAN                              0x22DD
#define unicode_EQUAL_TO_OR_PRECEDES                                  0x22DE
#define unicode_EQUAL_TO_OR_SUCCEEDS                                  0x22DF
#define unicode_DOES_NOT_PRECEDE_OR_EQUAL                             0x22E0
#define unicode_DOES_NOT_SUCCEED_OR_EQUAL                             0x22E1
#define unicode_NOT_SQUARE_IMAGE_OF_OR_EQUAL_TO                       0x22E2
#define unicode_NOT_SQUARE_ORIGINAL_OF_OR_EQUAL_TO                    0x22E3
#define unicode_SQUARE_IMAGE_OF_OR_NOT_EQUAL_TO                       0x22E4
#define unicode_SQUARE_ORIGINAL_OF_OR_NOT_EQUAL_TO                    0x22E5
#define unicode_LESS_THAN_BUT_NOT_EQUIVALENT_TO                       0x22E6
#define unicode_GREATER_THAN_BUT_NOT_EQUIVALENT_TO                    0x22E7
#define unicode_PRECEDES_BUT_NOT_EQUIVALENT_TO                        0x22E8
#define unicode_SUCCEEDS_BUT_NOT_EQUIVALENT_TO                        0x22E9
#define unicode_NOT_NORMAL_SUBGROUP_OF                                0x22EA
#define unicode_DOES_NOT_CONTAIN_AS_NORMAL_SUBGROUP                   0x22EB
#define unicode_NOT_NORMAL_SUBGROUP_OF_OR_EQUAL_TO                    0x22EC
#define unicode_DOES_NOT_CONTAIN_AS_NORMAL_SUBGROUP_OR_EQUAL          0x22ED
#define unicode_VERTICAL_ELLIPSIS                                     0x22EE
#define unicode_MIDLINE_HORIZONTAL_ELLIPSIS                           0x22EF
#define unicode_UP_RIGHT_DIAGONAL_ELLIPSIS                            0x22F0
#define unicode_DOWN_RIGHT_DIAGONAL_ELLIPSIS                          0x22F1
#define unicode_ELEMENT_OF_WITH_LONG_HORIZONTAL_STROKE                0x22F2
#define unicode_ELEMENT_OF_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE 0x22F3
#define unicode_SMALL_ELEMENT_OF_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE 0x22F4
#define unicode_ELEMENT_OF_WITH_DOT_ABOVE                             0x22F5
#define unicode_ELEMENT_OF_WITH_OVERBAR                               0x22F6
#define unicode_SMALL_ELEMENT_OF_WITH_OVERBAR                         0x22F7
#define unicode_ELEMENT_OF_WITH_UNDERBAR                              0x22F8
#define unicode_ELEMENT_OF_WITH_TWO_HORIZONTAL_STROKES                0x22F9
#define unicode_CONTAINS_WITH_LONG_HORIZONTAL_STROKE                  0x22FA
#define unicode_CONTAINS_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE 0x22FB
#define unicode_SMALL_CONTAINS_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE 0x22FC
#define unicode_CONTAINS_WITH_OVERBAR                                 0x22FD
#define unicode_SMALL_CONTAINS_WITH_OVERBAR                           0x22FE
#define unicode_Z_NOTATION_BAG_MEMBERSHIP                             0x22FF
#define unicode_DIAMETER_SIGN                                         0x2300
#define unicode_ELECTRIC_ARROW                                        0x2301
#define unicode_HOUSE                                                 0x2302
#define unicode_UP_ARROWHEAD                                          0x2303
#define unicode_DOWN_ARROWHEAD                                        0x2304
#define unicode_PROJECTIVE                                            0x2305
#define unicode_PERSPECTIVE                                           0x2306
#define unicode_WAVY_LINE                                             0x2307
#define unicode_LEFT_CEILING                                          0x2308
#define unicode_RIGHT_CEILING                                         0x2309
#define unicode_LEFT_FLOOR                                            0x230A
#define unicode_RIGHT_FLOOR                                           0x230B
#define unicode_BOTTOM_RIGHT_CROP                                     0x230C
#define unicode_BOTTOM_LEFT_CROP                                      0x230D
#define unicode_TOP_RIGHT_CROP                                        0x230E
#define unicode_TOP_LEFT_CROP                                         0x230F
#define unicode_REVERSED_NOT_SIGN                                     0x2310
#define unicode_SQUARE_LOZENGE                                        0x2311
#define unicode_ARC                                                   0x2312
#define unicode_SEGMENT                                               0x2313
#define unicode_SECTOR                                                0x2314
#define unicode_TELEPHONE_RECORDER                                    0x2315
#define unicode_POSITION_INDICATOR                                    0x2316
#define unicode_VIEWDATA_SQUARE                                       0x2317
#define unicode_PLACE_OF_INTEREST_SIGN                                0x2318
#define unicode_TURNED_NOT_SIGN                                       0x2319
#define unicode_WATCH                                                 0x231A
#define unicode_HOURGLASS                                             0x231B
#define unicode_TOP_LEFT_CORNER                                       0x231C
#define unicode_TOP_RIGHT_CORNER                                      0x231D
#define unicode_BOTTOM_LEFT_CORNER                                    0x231E
#define unicode_BOTTOM_RIGHT_CORNER                                   0x231F
#define unicode_TOP_HALF_INTEGRAL                                     0x2320
#define unicode_BOTTOM_HALF_INTEGRAL                                  0x2321
#define unicode_FROWN                                                 0x2322
#define unicode_SMILE                                                 0x2323
#define unicode_UP_ARROWHEAD_BETWEEN_TWO_HORIZONTAL_BARS              0x2324
#define unicode_OPTION_KEY                                            0x2325
#define unicode_ERASE_TO_THE_RIGHT                                    0x2326
#define unicode_X_IN_A_RECTANGLE_BOX                                  0x2327
#define unicode_KEYBOARD                                              0x2328
#define unicode_LEFT_POINTING_ANGLE_BRACKET                           0x2329
#define unicode_RIGHT_POINTING_ANGLE_BRACKET                          0x232A
#define unicode_ERASE_TO_THE_LEFT                                     0x232B
#define unicode_BENZENE_RING                                          0x232C
#define unicode_CYLINDRICITY                                          0x232D
#define unicode_ALL_AROUND_PROFILE                                    0x232E
#define unicode_SYMMETRY                                              0x232F
#define unicode_TOTAL_RUNOUT                                          0x2330
#define unicode_DIMENSION_ORIGIN                                      0x2331
#define unicode_CONICAL_TAPER                                         0x2332
#define unicode_SLOPE                                                 0x2333
#define unicode_COUNTERBORE                                           0x2334
#define unicode_COUNTERSINK                                           0x2335
#define unicode_APL_FUNCTIONAL_SYMBOL_I_BEAM                          0x2336
#define unicode_APL_FUNCTIONAL_SYMBOL_SQUISH_QUAD                     0x2337
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_EQUAL                      0x2338
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_DIVIDE                     0x2339
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_DIAMOND                    0x233A
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_JOT                        0x233B
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_CIRCLE                     0x233C
#define unicode_APL_FUNCTIONAL_SYMBOL_CIRCLE_STILE                    0x233D
#define unicode_APL_FUNCTIONAL_SYMBOL_CIRCLE_JOT                      0x233E
#define unicode_APL_FUNCTIONAL_SYMBOL_SLASH_BAR                       0x233F
#define unicode_APL_FUNCTIONAL_SYMBOL_BACKSLASH_BAR                   0x2340
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_SLASH                      0x2341
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_BACKSLASH                  0x2342
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_LESS_THAN                  0x2343
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_GREATER_THAN               0x2344
#define unicode_APL_FUNCTIONAL_SYMBOL_LEFTWARDS_VANE                  0x2345
#define unicode_APL_FUNCTIONAL_SYMBOL_RIGHTWARDS_VANE                 0x2346
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_LEFTWARDS_ARROW            0x2347
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_RIGHTWARDS_ARROW           0x2348
#define unicode_APL_FUNCTIONAL_SYMBOL_CIRCLE_BACKSLASH                0x2349
#define unicode_APL_FUNCTIONAL_SYMBOL_DOWN_TACK_UNDERBAR              0x234A
#define unicode_APL_FUNCTIONAL_SYMBOL_DELTA_STILE                     0x234B
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_DOWN_CARET                 0x234C
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_DELTA                      0x234D
#define unicode_APL_FUNCTIONAL_SYMBOL_DOWN_TACK_JOT                   0x234E
#define unicode_APL_FUNCTIONAL_SYMBOL_UPWARDS_VANE                    0x234F
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_UPWARDS_ARROW              0x2350
#define unicode_APL_FUNCTIONAL_SYMBOL_UP_TACK_OVERBAR                 0x2351
#define unicode_APL_FUNCTIONAL_SYMBOL_DEL_STILE                       0x2352
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_UP_CARET                   0x2353
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_DEL                        0x2354
#define unicode_APL_FUNCTIONAL_SYMBOL_UP_TACK_JOT                     0x2355
#define unicode_APL_FUNCTIONAL_SYMBOL_DOWNWARDS_VANE                  0x2356
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_DOWNWARDS_ARROW            0x2357
#define unicode_APL_FUNCTIONAL_SYMBOL_QUOTE_UNDERBAR                  0x2358
#define unicode_APL_FUNCTIONAL_SYMBOL_DELTA_UNDERBAR                  0x2359
#define unicode_APL_FUNCTIONAL_SYMBOL_DIAMOND_UNDERBAR                0x235A
#define unicode_APL_FUNCTIONAL_SYMBOL_JOT_UNDERBAR                    0x235B
#define unicode_APL_FUNCTIONAL_SYMBOL_CIRCLE_UNDERBAR                 0x235C
#define unicode_APL_FUNCTIONAL_SYMBOL_UP_SHOE_JOT                     0x235D
#define unicode_APL_FUNCTIONAL_SYMBOL_QUOTE_QUAD                      0x235E
#define unicode_APL_FUNCTIONAL_SYMBOL_CIRCLE_STAR                     0x235F
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_COLON                      0x2360
#define unicode_APL_FUNCTIONAL_SYMBOL_UP_TACK_DIAERESIS               0x2361
#define unicode_APL_FUNCTIONAL_SYMBOL_DEL_DIAERESIS                   0x2362
#define unicode_APL_FUNCTIONAL_SYMBOL_STAR_DIAERESIS                  0x2363
#define unicode_APL_FUNCTIONAL_SYMBOL_JOT_DIAERESIS                   0x2364
#define unicode_APL_FUNCTIONAL_SYMBOL_CIRCLE_DIAERESIS                0x2365
#define unicode_APL_FUNCTIONAL_SYMBOL_DOWN_SHOE_STILE                 0x2366
#define unicode_APL_FUNCTIONAL_SYMBOL_LEFT_SHOE_STILE                 0x2367
#define unicode_APL_FUNCTIONAL_SYMBOL_TILDE_DIAERESIS                 0x2368
#define unicode_APL_FUNCTIONAL_SYMBOL_GREATER_THAN_DIAERESIS          0x2369
#define unicode_APL_FUNCTIONAL_SYMBOL_COMMA_BAR                       0x236A
#define unicode_APL_FUNCTIONAL_SYMBOL_DEL_TILDE                       0x236B
#define unicode_APL_FUNCTIONAL_SYMBOL_ZILDE                           0x236C
#define unicode_APL_FUNCTIONAL_SYMBOL_STILE_TILDE                     0x236D
#define unicode_APL_FUNCTIONAL_SYMBOL_SEMICOLON_UNDERBAR              0x236E
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_NOT_EQUAL                  0x236F
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD_QUESTION                   0x2370
#define unicode_APL_FUNCTIONAL_SYMBOL_DOWN_CARET_TILDE                0x2371
#define unicode_APL_FUNCTIONAL_SYMBOL_UP_CARET_TILDE                  0x2372
#define unicode_APL_FUNCTIONAL_SYMBOL_IOTA                            0x2373
#define unicode_APL_FUNCTIONAL_SYMBOL_RHO                             0x2374
#define unicode_APL_FUNCTIONAL_SYMBOL_OMEGA                           0x2375
#define unicode_APL_FUNCTIONAL_SYMBOL_ALPHA_UNDERBAR                  0x2376
#define unicode_APL_FUNCTIONAL_SYMBOL_EPSILON_UNDERBAR                0x2377
#define unicode_APL_FUNCTIONAL_SYMBOL_IOTA_UNDERBAR                   0x2378
#define unicode_APL_FUNCTIONAL_SYMBOL_OMEGA_UNDERBAR                  0x2379
#define unicode_APL_FUNCTIONAL_SYMBOL_ALPHA                           0x237A
#define unicode_NOT_CHECK_MARK                                        0x237B
#define unicode_RIGHT_ANGLE_WITH_DOWNWARDS_ZIGZAG_ARROW               0x237C
#define unicode_SHOULDERED_OPEN_BOX                                   0x237D
#define unicode_BELL_SYMBOL                                           0x237E
#define unicode_VERTICAL_LINE_WITH_MIDDLE_DOT                         0x237F
#define unicode_INSERTION_SYMBOL                                      0x2380
#define unicode_CONTINUOUS_UNDERLINE_SYMBOL                           0x2381
#define unicode_DISCONTINUOUS_UNDERLINE_SYMBOL                        0x2382
#define unicode_EMPHASIS_SYMBOL                                       0x2383
#define unicode_COMPOSITION_SYMBOL                                    0x2384
#define unicode_WHITE_SQUARE_WITH_CENTRE_VERTICAL_LINE                0x2385
#define unicode_ENTER_SYMBOL                                          0x2386
#define unicode_ALTERNATIVE_KEY_SYMBOL                                0x2387
#define unicode_HELM_SYMBOL                                           0x2388
#define unicode_CIRCLED_HORIZONTAL_BAR_WITH_NOTCH                     0x2389
#define unicode_CIRCLED_TRIANGLE_DOWN                                 0x238A
#define unicode_BROKEN_CIRCLE_WITH_NORTHWEST_ARROW                    0x238B
#define unicode_UNDO_SYMBOL                                           0x238C
#define unicode_MONOSTABLE_SYMBOL                                     0x238D
#define unicode_HYSTERESIS_SYMBOL                                     0x238E
#define unicode_OPEN_CIRCUIT_OUTPUT_H_TYPE_SYMBOL                     0x238F
#define unicode_OPEN_CIRCUIT_OUTPUT_L_TYPE_SYMBOL                     0x2390
#define unicode_PASSIVE_PULL_DOWN_OUTPUT_SYMBOL                       0x2391
#define unicode_PASSIVE_PULL_UP_OUTPUT_SYMBOL                         0x2392
#define unicode_DIRECT_CURRENT_SYMBOL_FORM_TWO                        0x2393
#define unicode_SOFTWARE_FUNCTION_SYMBOL                              0x2394
#define unicode_APL_FUNCTIONAL_SYMBOL_QUAD                            0x2395
#define unicode_DECIMAL_SEPARATOR_KEY_SYMBOL                          0x2396
#define unicode_PREVIOUS_PAGE                                         0x2397
#define unicode_NEXT_PAGE                                             0x2398
#define unicode_PRINT_SCREEN_SYMBOL                                   0x2399
#define unicode_CLEAR_SCREEN_SYMBOL                                   0x239A
#define unicode_LEFT_PARENTHESIS_UPPER_HOOK                           0x239B
#define unicode_LEFT_PARENTHESIS_EXTENSION                            0x239C
#define unicode_LEFT_PARENTHESIS_LOWER_HOOK                           0x239D
#define unicode_RIGHT_PARENTHESIS_UPPER_HOOK                          0x239E
#define unicode_RIGHT_PARENTHESIS_EXTENSION                           0x239F
#define unicode_RIGHT_PARENTHESIS_LOWER_HOOK                          0x23A0
#define unicode_LEFT_SQUARE_BRACKET_UPPER_CORNER                      0x23A1
#define unicode_LEFT_SQUARE_BRACKET_EXTENSION                         0x23A2
#define unicode_LEFT_SQUARE_BRACKET_LOWER_CORNER                      0x23A3
#define unicode_RIGHT_SQUARE_BRACKET_UPPER_CORNER                     0x23A4
#define unicode_RIGHT_SQUARE_BRACKET_EXTENSION                        0x23A5
#define unicode_RIGHT_SQUARE_BRACKET_LOWER_CORNER                     0x23A6
#define unicode_LEFT_CURLY_BRACKET_UPPER_HOOK                         0x23A7
#define unicode_LEFT_CURLY_BRACKET_MIDDLE_PIECE                       0x23A8
#define unicode_LEFT_CURLY_BRACKET_LOWER_HOOK                         0x23A9
#define unicode_CURLY_BRACKET_EXTENSION                               0x23AA
#define unicode_RIGHT_CURLY_BRACKET_UPPER_HOOK                        0x23AB
#define unicode_RIGHT_CURLY_BRACKET_MIDDLE_PIECE                      0x23AC
#define unicode_RIGHT_CURLY_BRACKET_LOWER_HOOK                        0x23AD
#define unicode_INTEGRAL_EXTENSION                                    0x23AE
#define unicode_HORIZONTAL_LINE_EXTENSION                             0x23AF
#define unicode_UPPER_LEFT_OR_LOWER_RIGHT_CURLY_BRACKET_SECTION       0x23B0
#define unicode_UPPER_RIGHT_OR_LOWER_LEFT_CURLY_BRACKET_SECTION       0x23B1
#define unicode_SUMMATION_TOP                                         0x23B2
#define unicode_SUMMATION_BOTTOM                                      0x23B3
#define unicode_TOP_SQUARE_BRACKET                                    0x23B4
#define unicode_BOTTOM_SQUARE_BRACKET                                 0x23B5
#define unicode_BOTTOM_SQUARE_BRACKET_OVER_TOP_SQUARE_BRACKET         0x23B6
#define unicode_RADICAL_SYMBOL_BOTTOM                                 0x23B7
#define unicode_LEFT_VERTICAL_BOX_LINE                                0x23B8
#define unicode_RIGHT_VERTICAL_BOX_LINE                               0x23B9
#define unicode_HORIZONTAL_SCAN_LINE_1                                0x23BA
#define unicode_HORIZONTAL_SCAN_LINE_3                                0x23BB
#define unicode_HORIZONTAL_SCAN_LINE_7                                0x23BC
#define unicode_HORIZONTAL_SCAN_LINE_9                                0x23BD
#define unicode_DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_TOP_RIGHT         0x23BE
#define unicode_DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_BOTTOM_RIGHT      0x23BF
#define unicode_DENTISTRY_SYMBOL_LIGHT_VERTICAL_WITH_CIRCLE           0x23C0
#define unicode_DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL_WITH_CIRCLE 0x23C1
#define unicode_DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL_WITH_CIRCLE  0x23C2
#define unicode_DENTISTRY_SYMBOL_LIGHT_VERTICAL_WITH_TRIANGLE         0x23C3
#define unicode_DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL_WITH_TRIANGLE 0x23C4
#define unicode_DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL_WITH_TRIANGLE 0x23C5
#define unicode_DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_WAVE              0x23C6
#define unicode_DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL_WITH_WAVE  0x23C7
#define unicode_DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL_WITH_WAVE    0x23C8
#define unicode_DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL            0x23C9
#define unicode_DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL              0x23CA
#define unicode_DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_TOP_LEFT          0x23CB
#define unicode_DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_BOTTOM_LEFT       0x23CC
#define unicode_SQUARE_FOOT                                           0x23CD
#define unicode_RETURN_SYMBOL                                         0x23CE
#define unicode_EJECT_SYMBOL                                          0x23CF
#define unicode_VERTICAL_LINE_EXTENSION                               0x23D0
#define unicode_METRICAL_BREVE                                        0x23D1
#define unicode_METRICAL_LONG_OVER_SHORT                              0x23D2
#define unicode_METRICAL_SHORT_OVER_LONG                              0x23D3
#define unicode_METRICAL_LONG_OVER_TWO_SHORTS                         0x23D4
#define unicode_METRICAL_TWO_SHORTS_OVER_LONG                         0x23D5
#define unicode_METRICAL_TWO_SHORTS_JOINED                            0x23D6
#define unicode_METRICAL_TRISEME                                      0x23D7
#define unicode_METRICAL_TETRASEME                                    0x23D8
#define unicode_METRICAL_PENTASEME                                    0x23D9
#define unicode_EARTH_GROUND                                          0x23DA
#define unicode_FUSE                                                  0x23DB
#define unicode_TOP_PARENTHESIS                                       0x23DC
#define unicode_BOTTOM_PARENTHESIS                                    0x23DD
#define unicode_TOP_CURLY_BRACKET                                     0x23DE
#define unicode_BOTTOM_CURLY_BRACKET                                  0x23DF
#define unicode_TOP_TORTOISE_SHELL_BRACKET                            0x23E0
#define unicode_BOTTOM_TORTOISE_SHELL_BRACKET                         0x23E1
#define unicode_WHITE_TRAPEZIUM                                       0x23E2
#define unicode_BENZENE_RING_WITH_CIRCLE                              0x23E3
#define unicode_STRAIGHTNESS                                          0x23E4
#define unicode_FLATNESS                                              0x23E5
#define unicode_AC_CURRENT                                            0x23E6
#define unicode_ELECTRICAL_INTERSECTION                               0x23E7
#define unicode_DECIMAL_EXPONENT_SYMBOL                               0x23E8
#define unicode_BLACK_RIGHT_POINTING_DOUBLE_TRIANGLE                  0x23E9
#define unicode_BLACK_LEFT_POINTING_DOUBLE_TRIANGLE                   0x23EA
#define unicode_BLACK_UP_POINTING_DOUBLE_TRIANGLE                     0x23EB
#define unicode_BLACK_DOWN_POINTING_DOUBLE_TRIANGLE                   0x23EC
#define unicode_BLACK_RIGHT_POINTING_DOUBLE_TRIANGLE_WITH_VERTICAL_BAR 0x23ED
#define unicode_BLACK_LEFT_POINTING_DOUBLE_TRIANGLE_WITH_VERTICAL_BAR 0x23EE
#define unicode_BLACK_RIGHT_POINTING_TRIANGLE_WITH_DOUBLE_VERTICAL_BAR 0x23EF
#define unicode_ALARM_CLOCK                                           0x23F0
#define unicode_STOPWATCH                                             0x23F1
#define unicode_TIMER_CLOCK                                           0x23F2
#define unicode_HOURGLASS_WITH_FLOWING_SAND                           0x23F3
#define unicode_BLACK_MEDIUM_LEFT_POINTING_TRIANGLE                   0x23F4
#define unicode_BLACK_MEDIUM_RIGHT_POINTING_TRIANGLE                  0x23F5
#define unicode_BLACK_MEDIUM_UP_POINTING_TRIANGLE                     0x23F6
#define unicode_BLACK_MEDIUM_DOWN_POINTING_TRIANGLE                   0x23F7
#define unicode_DOUBLE_VERTICAL_BAR                                   0x23F8
#define unicode_BLACK_SQUARE_FOR_STOP                                 0x23F9
#define unicode_BLACK_CIRCLE_FOR_RECORD                               0x23FA
#define unicode_SYMBOL_FOR_NULL                                       0x2400
#define unicode_SYMBOL_FOR_START_OF_HEADING                           0x2401
#define unicode_SYMBOL_FOR_START_OF_TEXT                              0x2402
#define unicode_SYMBOL_FOR_END_OF_TEXT                                0x2403
#define unicode_SYMBOL_FOR_END_OF_TRANSMISSION                        0x2404
#define unicode_SYMBOL_FOR_ENQUIRY                                    0x2405
#define unicode_SYMBOL_FOR_ACKNOWLEDGE                                0x2406
#define unicode_SYMBOL_FOR_BELL                                       0x2407
#define unicode_SYMBOL_FOR_BACKSPACE                                  0x2408
#define unicode_SYMBOL_FOR_HORIZONTAL_TABULATION                      0x2409
#define unicode_SYMBOL_FOR_LINE_FEED                                  0x240A
#define unicode_SYMBOL_FOR_VERTICAL_TABULATION                        0x240B
#define unicode_SYMBOL_FOR_FORM_FEED                                  0x240C
#define unicode_SYMBOL_FOR_CARRIAGE_RETURN                            0x240D
#define unicode_SYMBOL_FOR_SHIFT_OUT                                  0x240E
#define unicode_SYMBOL_FOR_SHIFT_IN                                   0x240F
#define unicode_SYMBOL_FOR_DATA_LINK_ESCAPE                           0x2410
#define unicode_SYMBOL_FOR_DEVICE_CONTROL_ONE                         0x2411
#define unicode_SYMBOL_FOR_DEVICE_CONTROL_TWO                         0x2412
#define unicode_SYMBOL_FOR_DEVICE_CONTROL_THREE                       0x2413
#define unicode_SYMBOL_FOR_DEVICE_CONTROL_FOUR                        0x2414
#define unicode_SYMBOL_FOR_NEGATIVE_ACKNOWLEDGE                       0x2415
#define unicode_SYMBOL_FOR_SYNCHRONOUS_IDLE                           0x2416
#define unicode_SYMBOL_FOR_END_OF_TRANSMISSION_BLOCK                  0x2417
#define unicode_SYMBOL_FOR_CANCEL                                     0x2418
#define unicode_SYMBOL_FOR_END_OF_MEDIUM                              0x2419
#define unicode_SYMBOL_FOR_SUBSTITUTE                                 0x241A
#define unicode_SYMBOL_FOR_ESCAPE                                     0x241B
#define unicode_SYMBOL_FOR_FILE_SEPARATOR                             0x241C
#define unicode_SYMBOL_FOR_GROUP_SEPARATOR                            0x241D
#define unicode_SYMBOL_FOR_RECORD_SEPARATOR                           0x241E
#define unicode_SYMBOL_FOR_UNIT_SEPARATOR                             0x241F
#define unicode_SYMBOL_FOR_SPACE                                      0x2420
#define unicode_SYMBOL_FOR_DELETE                                     0x2421
#define unicode_BLANK_SYMBOL                                          0x2422
#define unicode_OPEN_BOX                                              0x2423
#define unicode_SYMBOL_FOR_NEWLINE                                    0x2424
#define unicode_SYMBOL_FOR_DELETE_FORM_TWO                            0x2425
#define unicode_SYMBOL_FOR_SUBSTITUTE_FORM_TWO                        0x2426
#define unicode_OCR_HOOK                                              0x2440
#define unicode_OCR_CHAIR                                             0x2441
#define unicode_OCR_FORK                                              0x2442
#define unicode_OCR_INVERTED_FORK                                     0x2443
#define unicode_OCR_BELT_BUCKLE                                       0x2444
#define unicode_OCR_BOW_TIE                                           0x2445
#define unicode_OCR_BRANCH_BANK_IDENTIFICATION                        0x2446
#define unicode_OCR_AMOUNT_OF_CHECK                                   0x2447
#define unicode_OCR_DASH                                              0x2448
#define unicode_OCR_CUSTOMER_ACCOUNT_NUMBER                           0x2449
#define unicode_OCR_DOUBLE_BACKSLASH                                  0x244A
#define unicode_CIRCLED_DIGIT_ONE                                     0x2460
#define unicode_CIRCLED_DIGIT_TWO                                     0x2461
#define unicode_CIRCLED_DIGIT_THREE                                   0x2462
#define unicode_CIRCLED_DIGIT_FOUR                                    0x2463
#define unicode_CIRCLED_DIGIT_FIVE                                    0x2464
#define unicode_CIRCLED_DIGIT_SIX                                     0x2465
#define unicode_CIRCLED_DIGIT_SEVEN                                   0x2466
#define unicode_CIRCLED_DIGIT_EIGHT                                   0x2467
#define unicode_CIRCLED_DIGIT_NINE                                    0x2468
#define unicode_CIRCLED_NUMBER_TEN                                    0x2469
#define unicode_CIRCLED_NUMBER_ELEVEN                                 0x246A
#define unicode_CIRCLED_NUMBER_TWELVE                                 0x246B
#define unicode_CIRCLED_NUMBER_THIRTEEN                               0x246C
#define unicode_CIRCLED_NUMBER_FOURTEEN                               0x246D
#define unicode_CIRCLED_NUMBER_FIFTEEN                                0x246E
#define unicode_CIRCLED_NUMBER_SIXTEEN                                0x246F
#define unicode_CIRCLED_NUMBER_SEVENTEEN                              0x2470
#define unicode_CIRCLED_NUMBER_EIGHTEEN                               0x2471
#define unicode_CIRCLED_NUMBER_NINETEEN                               0x2472
#define unicode_CIRCLED_NUMBER_TWENTY                                 0x2473
#define unicode_PARENTHESIZED_DIGIT_ONE                               0x2474
#define unicode_PARENTHESIZED_DIGIT_TWO                               0x2475
#define unicode_PARENTHESIZED_DIGIT_THREE                             0x2476
#define unicode_PARENTHESIZED_DIGIT_FOUR                              0x2477
#define unicode_PARENTHESIZED_DIGIT_FIVE                              0x2478
#define unicode_PARENTHESIZED_DIGIT_SIX                               0x2479
#define unicode_PARENTHESIZED_DIGIT_SEVEN                             0x247A
#define unicode_PARENTHESIZED_DIGIT_EIGHT                             0x247B
#define unicode_PARENTHESIZED_DIGIT_NINE                              0x247C
#define unicode_PARENTHESIZED_NUMBER_TEN                              0x247D
#define unicode_PARENTHESIZED_NUMBER_ELEVEN                           0x247E
#define unicode_PARENTHESIZED_NUMBER_TWELVE                           0x247F
#define unicode_PARENTHESIZED_NUMBER_THIRTEEN                         0x2480
#define unicode_PARENTHESIZED_NUMBER_FOURTEEN                         0x2481
#define unicode_PARENTHESIZED_NUMBER_FIFTEEN                          0x2482
#define unicode_PARENTHESIZED_NUMBER_SIXTEEN                          0x2483
#define unicode_PARENTHESIZED_NUMBER_SEVENTEEN                        0x2484
#define unicode_PARENTHESIZED_NUMBER_EIGHTEEN                         0x2485
#define unicode_PARENTHESIZED_NUMBER_NINETEEN                         0x2486
#define unicode_PARENTHESIZED_NUMBER_TWENTY                           0x2487
#define unicode_DIGIT_ONE_FULL_STOP                                   0x2488
#define unicode_DIGIT_TWO_FULL_STOP                                   0x2489
#define unicode_DIGIT_THREE_FULL_STOP                                 0x248A
#define unicode_DIGIT_FOUR_FULL_STOP                                  0x248B
#define unicode_DIGIT_FIVE_FULL_STOP                                  0x248C
#define unicode_DIGIT_SIX_FULL_STOP                                   0x248D
#define unicode_DIGIT_SEVEN_FULL_STOP                                 0x248E
#define unicode_DIGIT_EIGHT_FULL_STOP                                 0x248F
#define unicode_DIGIT_NINE_FULL_STOP                                  0x2490
#define unicode_NUMBER_TEN_FULL_STOP                                  0x2491
#define unicode_NUMBER_ELEVEN_FULL_STOP                               0x2492
#define unicode_NUMBER_TWELVE_FULL_STOP                               0x2493
#define unicode_NUMBER_THIRTEEN_FULL_STOP                             0x2494
#define unicode_NUMBER_FOURTEEN_FULL_STOP                             0x2495
#define unicode_NUMBER_FIFTEEN_FULL_STOP                              0x2496
#define unicode_NUMBER_SIXTEEN_FULL_STOP                              0x2497
#define unicode_NUMBER_SEVENTEEN_FULL_STOP                            0x2498
#define unicode_NUMBER_EIGHTEEN_FULL_STOP                             0x2499
#define unicode_NUMBER_NINETEEN_FULL_STOP                             0x249A
#define unicode_NUMBER_TWENTY_FULL_STOP                               0x249B
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_A                    0x249C
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_B                    0x249D
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_C                    0x249E
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_D                    0x249F
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_E                    0x24A0
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_F                    0x24A1
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_G                    0x24A2
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_H                    0x24A3
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_I                    0x24A4
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_J                    0x24A5
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_K                    0x24A6
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_L                    0x24A7
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_M                    0x24A8
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_N                    0x24A9
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_O                    0x24AA
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_P                    0x24AB
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_Q                    0x24AC
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_R                    0x24AD
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_S                    0x24AE
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_T                    0x24AF
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_U                    0x24B0
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_V                    0x24B1
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_W                    0x24B2
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_X                    0x24B3
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_Y                    0x24B4
#define unicode_PARENTHESIZED_LATIN_SMALL_LETTER_Z                    0x24B5
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_A                        0x24B6
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_B                        0x24B7
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_C                        0x24B8
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_D                        0x24B9
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_E                        0x24BA
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_F                        0x24BB
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_G                        0x24BC
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_H                        0x24BD
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_I                        0x24BE
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_J                        0x24BF
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_K                        0x24C0
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_L                        0x24C1
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_M                        0x24C2
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_N                        0x24C3
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_O                        0x24C4
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_P                        0x24C5
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_Q                        0x24C6
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_R                        0x24C7
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_S                        0x24C8
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_T                        0x24C9
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_U                        0x24CA
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_V                        0x24CB
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_W                        0x24CC
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_X                        0x24CD
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_Y                        0x24CE
#define unicode_CIRCLED_LATIN_CAPITAL_LETTER_Z                        0x24CF
#define unicode_CIRCLED_LATIN_SMALL_LETTER_A                          0x24D0
#define unicode_CIRCLED_LATIN_SMALL_LETTER_B                          0x24D1
#define unicode_CIRCLED_LATIN_SMALL_LETTER_C                          0x24D2
#define unicode_CIRCLED_LATIN_SMALL_LETTER_D                          0x24D3
#define unicode_CIRCLED_LATIN_SMALL_LETTER_E                          0x24D4
#define unicode_CIRCLED_LATIN_SMALL_LETTER_F                          0x24D5
#define unicode_CIRCLED_LATIN_SMALL_LETTER_G                          0x24D6
#define unicode_CIRCLED_LATIN_SMALL_LETTER_H                          0x24D7
#define unicode_CIRCLED_LATIN_SMALL_LETTER_I                          0x24D8
#define unicode_CIRCLED_LATIN_SMALL_LETTER_J                          0x24D9
#define unicode_CIRCLED_LATIN_SMALL_LETTER_K                          0x24DA
#define unicode_CIRCLED_LATIN_SMALL_LETTER_L                          0x24DB
#define unicode_CIRCLED_LATIN_SMALL_LETTER_M                          0x24DC
#define unicode_CIRCLED_LATIN_SMALL_LETTER_N                          0x24DD
#define unicode_CIRCLED_LATIN_SMALL_LETTER_O                          0x24DE
#define unicode_CIRCLED_LATIN_SMALL_LETTER_P                          0x24DF
#define unicode_CIRCLED_LATIN_SMALL_LETTER_Q                          0x24E0
#define unicode_CIRCLED_LATIN_SMALL_LETTER_R                          0x24E1
#define unicode_CIRCLED_LATIN_SMALL_LETTER_S                          0x24E2
#define unicode_CIRCLED_LATIN_SMALL_LETTER_T                          0x24E3
#define unicode_CIRCLED_LATIN_SMALL_LETTER_U                          0x24E4
#define unicode_CIRCLED_LATIN_SMALL_LETTER_V                          0x24E5
#define unicode_CIRCLED_LATIN_SMALL_LETTER_W                          0x24E6
#define unicode_CIRCLED_LATIN_SMALL_LETTER_X                          0x24E7
#define unicode_CIRCLED_LATIN_SMALL_LETTER_Y                          0x24E8
#define unicode_CIRCLED_LATIN_SMALL_LETTER_Z                          0x24E9
#define unicode_CIRCLED_DIGIT_ZERO                                    0x24EA
#define unicode_NEGATIVE_CIRCLED_NUMBER_ELEVEN                        0x24EB
#define unicode_NEGATIVE_CIRCLED_NUMBER_TWELVE                        0x24EC
#define unicode_NEGATIVE_CIRCLED_NUMBER_THIRTEEN                      0x24ED
#define unicode_NEGATIVE_CIRCLED_NUMBER_FOURTEEN                      0x24EE
#define unicode_NEGATIVE_CIRCLED_NUMBER_FIFTEEN                       0x24EF
#define unicode_NEGATIVE_CIRCLED_NUMBER_SIXTEEN                       0x24F0
#define unicode_NEGATIVE_CIRCLED_NUMBER_SEVENTEEN                     0x24F1
#define unicode_NEGATIVE_CIRCLED_NUMBER_EIGHTEEN                      0x24F2
#define unicode_NEGATIVE_CIRCLED_NUMBER_NINETEEN                      0x24F3
#define unicode_NEGATIVE_CIRCLED_NUMBER_TWENTY                        0x24F4
#define unicode_DOUBLE_CIRCLED_DIGIT_ONE                              0x24F5
#define unicode_DOUBLE_CIRCLED_DIGIT_TWO                              0x24F6
#define unicode_DOUBLE_CIRCLED_DIGIT_THREE                            0x24F7
#define unicode_DOUBLE_CIRCLED_DIGIT_FOUR                             0x24F8
#define unicode_DOUBLE_CIRCLED_DIGIT_FIVE                             0x24F9
#define unicode_DOUBLE_CIRCLED_DIGIT_SIX                              0x24FA
#define unicode_DOUBLE_CIRCLED_DIGIT_SEVEN                            0x24FB
#define unicode_DOUBLE_CIRCLED_DIGIT_EIGHT                            0x24FC
#define unicode_DOUBLE_CIRCLED_DIGIT_NINE                             0x24FD
#define unicode_DOUBLE_CIRCLED_NUMBER_TEN                             0x24FE
#define unicode_NEGATIVE_CIRCLED_DIGIT_ZERO                           0x24FF
#define unicode_BOX_DRAWINGS_LIGHT_HORIZONTAL                         0x2500
#define unicode_BOX_DRAWINGS_HEAVY_HORIZONTAL                         0x2501
#define unicode_BOX_DRAWINGS_LIGHT_VERTICAL                           0x2502
#define unicode_BOX_DRAWINGS_HEAVY_VERTICAL                           0x2503
#define unicode_BOX_DRAWINGS_LIGHT_TRIPLE_DASH_HORIZONTAL             0x2504
#define unicode_BOX_DRAWINGS_HEAVY_TRIPLE_DASH_HORIZONTAL             0x2505
#define unicode_BOX_DRAWINGS_LIGHT_TRIPLE_DASH_VERTICAL               0x2506
#define unicode_BOX_DRAWINGS_HEAVY_TRIPLE_DASH_VERTICAL               0x2507
#define unicode_BOX_DRAWINGS_LIGHT_QUADRUPLE_DASH_HORIZONTAL          0x2508
#define unicode_BOX_DRAWINGS_HEAVY_QUADRUPLE_DASH_HORIZONTAL          0x2509
#define unicode_BOX_DRAWINGS_LIGHT_QUADRUPLE_DASH_VERTICAL            0x250A
#define unicode_BOX_DRAWINGS_HEAVY_QUADRUPLE_DASH_VERTICAL            0x250B
#define unicode_BOX_DRAWINGS_LIGHT_DOWN_AND_RIGHT                     0x250C
#define unicode_BOX_DRAWINGS_DOWN_LIGHT_AND_RIGHT_HEAVY               0x250D
#define unicode_BOX_DRAWINGS_DOWN_HEAVY_AND_RIGHT_LIGHT               0x250E
#define unicode_BOX_DRAWINGS_HEAVY_DOWN_AND_RIGHT                     0x250F
#define unicode_BOX_DRAWINGS_LIGHT_DOWN_AND_LEFT                      0x2510
#define unicode_BOX_DRAWINGS_DOWN_LIGHT_AND_LEFT_HEAVY                0x2511
#define unicode_BOX_DRAWINGS_DOWN_HEAVY_AND_LEFT_LIGHT                0x2512
#define unicode_BOX_DRAWINGS_HEAVY_DOWN_AND_LEFT                      0x2513
#define unicode_BOX_DRAWINGS_LIGHT_UP_AND_RIGHT                       0x2514
#define unicode_BOX_DRAWINGS_UP_LIGHT_AND_RIGHT_HEAVY                 0x2515
#define unicode_BOX_DRAWINGS_UP_HEAVY_AND_RIGHT_LIGHT                 0x2516
#define unicode_BOX_DRAWINGS_HEAVY_UP_AND_RIGHT                       0x2517
#define unicode_BOX_DRAWINGS_LIGHT_UP_AND_LEFT                        0x2518
#define unicode_BOX_DRAWINGS_UP_LIGHT_AND_LEFT_HEAVY                  0x2519
#define unicode_BOX_DRAWINGS_UP_HEAVY_AND_LEFT_LIGHT                  0x251A
#define unicode_BOX_DRAWINGS_HEAVY_UP_AND_LEFT                        0x251B
#define unicode_BOX_DRAWINGS_LIGHT_VERTICAL_AND_RIGHT                 0x251C
#define unicode_BOX_DRAWINGS_VERTICAL_LIGHT_AND_RIGHT_HEAVY           0x251D
#define unicode_BOX_DRAWINGS_UP_HEAVY_AND_RIGHT_DOWN_LIGHT            0x251E
#define unicode_BOX_DRAWINGS_DOWN_HEAVY_AND_RIGHT_UP_LIGHT            0x251F
#define unicode_BOX_DRAWINGS_VERTICAL_HEAVY_AND_RIGHT_LIGHT           0x2520
#define unicode_BOX_DRAWINGS_DOWN_LIGHT_AND_RIGHT_UP_HEAVY            0x2521
#define unicode_BOX_DRAWINGS_UP_LIGHT_AND_RIGHT_DOWN_HEAVY            0x2522
#define unicode_BOX_DRAWINGS_HEAVY_VERTICAL_AND_RIGHT                 0x2523
#define unicode_BOX_DRAWINGS_LIGHT_VERTICAL_AND_LEFT                  0x2524
#define unicode_BOX_DRAWINGS_VERTICAL_LIGHT_AND_LEFT_HEAVY            0x2525
#define unicode_BOX_DRAWINGS_UP_HEAVY_AND_LEFT_DOWN_LIGHT             0x2526
#define unicode_BOX_DRAWINGS_DOWN_HEAVY_AND_LEFT_UP_LIGHT             0x2527
#define unicode_BOX_DRAWINGS_VERTICAL_HEAVY_AND_LEFT_LIGHT            0x2528
#define unicode_BOX_DRAWINGS_DOWN_LIGHT_AND_LEFT_UP_HEAVY             0x2529
#define unicode_BOX_DRAWINGS_UP_LIGHT_AND_LEFT_DOWN_HEAVY             0x252A
#define unicode_BOX_DRAWINGS_HEAVY_VERTICAL_AND_LEFT                  0x252B
#define unicode_BOX_DRAWINGS_LIGHT_DOWN_AND_HORIZONTAL                0x252C
#define unicode_BOX_DRAWINGS_LEFT_HEAVY_AND_RIGHT_DOWN_LIGHT          0x252D
#define unicode_BOX_DRAWINGS_RIGHT_HEAVY_AND_LEFT_DOWN_LIGHT          0x252E
#define unicode_BOX_DRAWINGS_DOWN_LIGHT_AND_HORIZONTAL_HEAVY          0x252F
#define unicode_BOX_DRAWINGS_DOWN_HEAVY_AND_HORIZONTAL_LIGHT          0x2530
#define unicode_BOX_DRAWINGS_RIGHT_LIGHT_AND_LEFT_DOWN_HEAVY          0x2531
#define unicode_BOX_DRAWINGS_LEFT_LIGHT_AND_RIGHT_DOWN_HEAVY          0x2532
#define unicode_BOX_DRAWINGS_HEAVY_DOWN_AND_HORIZONTAL                0x2533
#define unicode_BOX_DRAWINGS_LIGHT_UP_AND_HORIZONTAL                  0x2534
#define unicode_BOX_DRAWINGS_LEFT_HEAVY_AND_RIGHT_UP_LIGHT            0x2535
#define unicode_BOX_DRAWINGS_RIGHT_HEAVY_AND_LEFT_UP_LIGHT            0x2536
#define unicode_BOX_DRAWINGS_UP_LIGHT_AND_HORIZONTAL_HEAVY            0x2537
#define unicode_BOX_DRAWINGS_UP_HEAVY_AND_HORIZONTAL_LIGHT            0x2538
#define unicode_BOX_DRAWINGS_RIGHT_LIGHT_AND_LEFT_UP_HEAVY            0x2539
#define unicode_BOX_DRAWINGS_LEFT_LIGHT_AND_RIGHT_UP_HEAVY            0x253A
#define unicode_BOX_DRAWINGS_HEAVY_UP_AND_HORIZONTAL                  0x253B
#define unicode_BOX_DRAWINGS_LIGHT_VERTICAL_AND_HORIZONTAL            0x253C
#define unicode_BOX_DRAWINGS_LEFT_HEAVY_AND_RIGHT_VERTICAL_LIGHT      0x253D
#define unicode_BOX_DRAWINGS_RIGHT_HEAVY_AND_LEFT_VERTICAL_LIGHT      0x253E
#define unicode_BOX_DRAWINGS_VERTICAL_LIGHT_AND_HORIZONTAL_HEAVY      0x253F
#define unicode_BOX_DRAWINGS_UP_HEAVY_AND_DOWN_HORIZONTAL_LIGHT       0x2540
#define unicode_BOX_DRAWINGS_DOWN_HEAVY_AND_UP_HORIZONTAL_LIGHT       0x2541
#define unicode_BOX_DRAWINGS_VERTICAL_HEAVY_AND_HORIZONTAL_LIGHT      0x2542
#define unicode_BOX_DRAWINGS_LEFT_UP_HEAVY_AND_RIGHT_DOWN_LIGHT       0x2543
#define unicode_BOX_DRAWINGS_RIGHT_UP_HEAVY_AND_LEFT_DOWN_LIGHT       0x2544
#define unicode_BOX_DRAWINGS_LEFT_DOWN_HEAVY_AND_RIGHT_UP_LIGHT       0x2545
#define unicode_BOX_DRAWINGS_RIGHT_DOWN_HEAVY_AND_LEFT_UP_LIGHT       0x2546
#define unicode_BOX_DRAWINGS_DOWN_LIGHT_AND_UP_HORIZONTAL_HEAVY       0x2547
#define unicode_BOX_DRAWINGS_UP_LIGHT_AND_DOWN_HORIZONTAL_HEAVY       0x2548
#define unicode_BOX_DRAWINGS_RIGHT_LIGHT_AND_LEFT_VERTICAL_HEAVY      0x2549
#define unicode_BOX_DRAWINGS_LEFT_LIGHT_AND_RIGHT_VERTICAL_HEAVY      0x254A
#define unicode_BOX_DRAWINGS_HEAVY_VERTICAL_AND_HORIZONTAL            0x254B
#define unicode_BOX_DRAWINGS_LIGHT_DOUBLE_DASH_HORIZONTAL             0x254C
#define unicode_BOX_DRAWINGS_HEAVY_DOUBLE_DASH_HORIZONTAL             0x254D
#define unicode_BOX_DRAWINGS_LIGHT_DOUBLE_DASH_VERTICAL               0x254E
#define unicode_BOX_DRAWINGS_HEAVY_DOUBLE_DASH_VERTICAL               0x254F
#define unicode_BOX_DRAWINGS_DOUBLE_HORIZONTAL                        0x2550
#define unicode_BOX_DRAWINGS_DOUBLE_VERTICAL                          0x2551
#define unicode_BOX_DRAWINGS_DOWN_SINGLE_AND_RIGHT_DOUBLE             0x2552
#define unicode_BOX_DRAWINGS_DOWN_DOUBLE_AND_RIGHT_SINGLE             0x2553
#define unicode_BOX_DRAWINGS_DOUBLE_DOWN_AND_RIGHT                    0x2554
#define unicode_BOX_DRAWINGS_DOWN_SINGLE_AND_LEFT_DOUBLE              0x2555
#define unicode_BOX_DRAWINGS_DOWN_DOUBLE_AND_LEFT_SINGLE              0x2556
#define unicode_BOX_DRAWINGS_DOUBLE_DOWN_AND_LEFT                     0x2557
#define unicode_BOX_DRAWINGS_UP_SINGLE_AND_RIGHT_DOUBLE               0x2558
#define unicode_BOX_DRAWINGS_UP_DOUBLE_AND_RIGHT_SINGLE               0x2559
#define unicode_BOX_DRAWINGS_DOUBLE_UP_AND_RIGHT                      0x255A
#define unicode_BOX_DRAWINGS_UP_SINGLE_AND_LEFT_DOUBLE                0x255B
#define unicode_BOX_DRAWINGS_UP_DOUBLE_AND_LEFT_SINGLE                0x255C
#define unicode_BOX_DRAWINGS_DOUBLE_UP_AND_LEFT                       0x255D
#define unicode_BOX_DRAWINGS_VERTICAL_SINGLE_AND_RIGHT_DOUBLE         0x255E
#define unicode_BOX_DRAWINGS_VERTICAL_DOUBLE_AND_RIGHT_SINGLE         0x255F
#define unicode_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_RIGHT                0x2560
#define unicode_BOX_DRAWINGS_VERTICAL_SINGLE_AND_LEFT_DOUBLE          0x2561
#define unicode_BOX_DRAWINGS_VERTICAL_DOUBLE_AND_LEFT_SINGLE          0x2562
#define unicode_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_LEFT                 0x2563
#define unicode_BOX_DRAWINGS_DOWN_SINGLE_AND_HORIZONTAL_DOUBLE        0x2564
#define unicode_BOX_DRAWINGS_DOWN_DOUBLE_AND_HORIZONTAL_SINGLE        0x2565
#define unicode_BOX_DRAWINGS_DOUBLE_DOWN_AND_HORIZONTAL               0x2566
#define unicode_BOX_DRAWINGS_UP_SINGLE_AND_HORIZONTAL_DOUBLE          0x2567
#define unicode_BOX_DRAWINGS_UP_DOUBLE_AND_HORIZONTAL_SINGLE          0x2568
#define unicode_BOX_DRAWINGS_DOUBLE_UP_AND_HORIZONTAL                 0x2569
#define unicode_BOX_DRAWINGS_VERTICAL_SINGLE_AND_HORIZONTAL_DOUBLE    0x256A
#define unicode_BOX_DRAWINGS_VERTICAL_DOUBLE_AND_HORIZONTAL_SINGLE    0x256B
#define unicode_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_HORIZONTAL           0x256C
#define unicode_BOX_DRAWINGS_LIGHT_ARC_DOWN_AND_RIGHT                 0x256D
#define unicode_BOX_DRAWINGS_LIGHT_ARC_DOWN_AND_LEFT                  0x256E
#define unicode_BOX_DRAWINGS_LIGHT_ARC_UP_AND_LEFT                    0x256F
#define unicode_BOX_DRAWINGS_LIGHT_ARC_UP_AND_RIGHT                   0x2570
#define unicode_BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_RIGHT_TO_LOWER_LEFT 0x2571
#define unicode_BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_LEFT_TO_LOWER_RIGHT 0x2572
#define unicode_BOX_DRAWINGS_LIGHT_DIAGONAL_CROSS                     0x2573
#define unicode_BOX_DRAWINGS_LIGHT_LEFT                               0x2574
#define unicode_BOX_DRAWINGS_LIGHT_UP                                 0x2575
#define unicode_BOX_DRAWINGS_LIGHT_RIGHT                              0x2576
#define unicode_BOX_DRAWINGS_LIGHT_DOWN                               0x2577
#define unicode_BOX_DRAWINGS_HEAVY_LEFT                               0x2578
#define unicode_BOX_DRAWINGS_HEAVY_UP                                 0x2579
#define unicode_BOX_DRAWINGS_HEAVY_RIGHT                              0x257A
#define unicode_BOX_DRAWINGS_HEAVY_DOWN                               0x257B
#define unicode_BOX_DRAWINGS_LIGHT_LEFT_AND_HEAVY_RIGHT               0x257C
#define unicode_BOX_DRAWINGS_LIGHT_UP_AND_HEAVY_DOWN                  0x257D
#define unicode_BOX_DRAWINGS_HEAVY_LEFT_AND_LIGHT_RIGHT               0x257E
#define unicode_BOX_DRAWINGS_HEAVY_UP_AND_LIGHT_DOWN                  0x257F
#define unicode_UPPER_HALF_BLOCK                                      0x2580
#define unicode_LOWER_ONE_EIGHTH_BLOCK                                0x2581
#define unicode_LOWER_ONE_QUARTER_BLOCK                               0x2582
#define unicode_LOWER_THREE_EIGHTHS_BLOCK                             0x2583
#define unicode_LOWER_HALF_BLOCK                                      0x2584
#define unicode_LOWER_FIVE_EIGHTHS_BLOCK                              0x2585
#define unicode_LOWER_THREE_QUARTERS_BLOCK                            0x2586
#define unicode_LOWER_SEVEN_EIGHTHS_BLOCK                             0x2587
#define unicode_FULL_BLOCK                                            0x2588
#define unicode_LEFT_SEVEN_EIGHTHS_BLOCK                              0x2589
#define unicode_LEFT_THREE_QUARTERS_BLOCK                             0x258A
#define unicode_LEFT_FIVE_EIGHTHS_BLOCK                               0x258B
#define unicode_LEFT_HALF_BLOCK                                       0x258C
#define unicode_LEFT_THREE_EIGHTHS_BLOCK                              0x258D
#define unicode_LEFT_ONE_QUARTER_BLOCK                                0x258E
#define unicode_LEFT_ONE_EIGHTH_BLOCK                                 0x258F
#define unicode_RIGHT_HALF_BLOCK                                      0x2590
#define unicode_LIGHT_SHADE                                           0x2591
#define unicode_MEDIUM_SHADE                                          0x2592
#define unicode_DARK_SHADE                                            0x2593
#define unicode_UPPER_ONE_EIGHTH_BLOCK                                0x2594
#define unicode_RIGHT_ONE_EIGHTH_BLOCK                                0x2595
#define unicode_QUADRANT_LOWER_LEFT                                   0x2596
#define unicode_QUADRANT_LOWER_RIGHT                                  0x2597
#define unicode_QUADRANT_UPPER_LEFT                                   0x2598
#define unicode_QUADRANT_UPPER_LEFT_AND_LOWER_LEFT_AND_LOWER_RIGHT    0x2599
#define unicode_QUADRANT_UPPER_LEFT_AND_LOWER_RIGHT                   0x259A
#define unicode_QUADRANT_UPPER_LEFT_AND_UPPER_RIGHT_AND_LOWER_LEFT    0x259B
#define unicode_QUADRANT_UPPER_LEFT_AND_UPPER_RIGHT_AND_LOWER_RIGHT   0x259C
#define unicode_QUADRANT_UPPER_RIGHT                                  0x259D
#define unicode_QUADRANT_UPPER_RIGHT_AND_LOWER_LEFT                   0x259E
#define unicode_QUADRANT_UPPER_RIGHT_AND_LOWER_LEFT_AND_LOWER_RIGHT   0x259F
#define unicode_BLACK_SQUARE                                          0x25A0
#define unicode_WHITE_SQUARE                                          0x25A1
#define unicode_WHITE_SQUARE_WITH_ROUNDED_CORNERS                     0x25A2
#define unicode_WHITE_SQUARE_CONTAINING_BLACK_SMALL_SQUARE            0x25A3
#define unicode_SQUARE_WITH_HORIZONTAL_FILL                           0x25A4
#define unicode_SQUARE_WITH_VERTICAL_FILL                             0x25A5
#define unicode_SQUARE_WITH_ORTHOGONAL_CROSSHATCH_FILL                0x25A6
#define unicode_SQUARE_WITH_UPPER_LEFT_TO_LOWER_RIGHT_FILL            0x25A7
#define unicode_SQUARE_WITH_UPPER_RIGHT_TO_LOWER_LEFT_FILL            0x25A8
#define unicode_SQUARE_WITH_DIAGONAL_CROSSHATCH_FILL                  0x25A9
#define unicode_BLACK_SMALL_SQUARE                                    0x25AA
#define unicode_WHITE_SMALL_SQUARE                                    0x25AB
#define unicode_BLACK_RECTANGLE                                       0x25AC
#define unicode_WHITE_RECTANGLE                                       0x25AD
#define unicode_BLACK_VERTICAL_RECTANGLE                              0x25AE
#define unicode_WHITE_VERTICAL_RECTANGLE                              0x25AF
#define unicode_BLACK_PARALLELOGRAM                                   0x25B0
#define unicode_WHITE_PARALLELOGRAM                                   0x25B1
#define unicode_BLACK_UP_POINTING_TRIANGLE                            0x25B2
#define unicode_WHITE_UP_POINTING_TRIANGLE                            0x25B3
#define unicode_BLACK_UP_POINTING_SMALL_TRIANGLE                      0x25B4
#define unicode_WHITE_UP_POINTING_SMALL_TRIANGLE                      0x25B5
#define unicode_BLACK_RIGHT_POINTING_TRIANGLE                         0x25B6
#define unicode_WHITE_RIGHT_POINTING_TRIANGLE                         0x25B7
#define unicode_BLACK_RIGHT_POINTING_SMALL_TRIANGLE                   0x25B8
#define unicode_WHITE_RIGHT_POINTING_SMALL_TRIANGLE                   0x25B9
#define unicode_BLACK_RIGHT_POINTING_POINTER                          0x25BA
#define unicode_WHITE_RIGHT_POINTING_POINTER                          0x25BB
#define unicode_BLACK_DOWN_POINTING_TRIANGLE                          0x25BC
#define unicode_WHITE_DOWN_POINTING_TRIANGLE                          0x25BD
#define unicode_BLACK_DOWN_POINTING_SMALL_TRIANGLE                    0x25BE
#define unicode_WHITE_DOWN_POINTING_SMALL_TRIANGLE                    0x25BF
#define unicode_BLACK_LEFT_POINTING_TRIANGLE                          0x25C0
#define unicode_WHITE_LEFT_POINTING_TRIANGLE                          0x25C1
#define unicode_BLACK_LEFT_POINTING_SMALL_TRIANGLE                    0x25C2
#define unicode_WHITE_LEFT_POINTING_SMALL_TRIANGLE                    0x25C3
#define unicode_BLACK_LEFT_POINTING_POINTER                           0x25C4
#define unicode_WHITE_LEFT_POINTING_POINTER                           0x25C5
#define unicode_BLACK_DIAMOND                                         0x25C6
#define unicode_WHITE_DIAMOND                                         0x25C7
#define unicode_WHITE_DIAMOND_CONTAINING_BLACK_SMALL_DIAMOND          0x25C8
#define unicode_FISHEYE                                               0x25C9
#define unicode_LOZENGE                                               0x25CA
#define unicode_WHITE_CIRCLE                                          0x25CB
#define unicode_DOTTED_CIRCLE                                         0x25CC
#define unicode_CIRCLE_WITH_VERTICAL_FILL                             0x25CD
#define unicode_BULLSEYE                                              0x25CE
#define unicode_BLACK_CIRCLE                                          0x25CF
#define unicode_CIRCLE_WITH_LEFT_HALF_BLACK                           0x25D0
#define unicode_CIRCLE_WITH_RIGHT_HALF_BLACK                          0x25D1
#define unicode_CIRCLE_WITH_LOWER_HALF_BLACK                          0x25D2
#define unicode_CIRCLE_WITH_UPPER_HALF_BLACK                          0x25D3
#define unicode_CIRCLE_WITH_UPPER_RIGHT_QUADRANT_BLACK                0x25D4
#define unicode_CIRCLE_WITH_ALL_BUT_UPPER_LEFT_QUADRANT_BLACK         0x25D5
#define unicode_LEFT_HALF_BLACK_CIRCLE                                0x25D6
#define unicode_RIGHT_HALF_BLACK_CIRCLE                               0x25D7
#define unicode_INVERSE_BULLET                                        0x25D8
#define unicode_INVERSE_WHITE_CIRCLE                                  0x25D9
#define unicode_UPPER_HALF_INVERSE_WHITE_CIRCLE                       0x25DA
#define unicode_LOWER_HALF_INVERSE_WHITE_CIRCLE                       0x25DB
#define unicode_UPPER_LEFT_QUADRANT_CIRCULAR_ARC                      0x25DC
#define unicode_UPPER_RIGHT_QUADRANT_CIRCULAR_ARC                     0x25DD
#define unicode_LOWER_RIGHT_QUADRANT_CIRCULAR_ARC                     0x25DE
#define unicode_LOWER_LEFT_QUADRANT_CIRCULAR_ARC                      0x25DF
#define unicode_UPPER_HALF_CIRCLE                                     0x25E0
#define unicode_LOWER_HALF_CIRCLE                                     0x25E1
#define unicode_BLACK_LOWER_RIGHT_TRIANGLE                            0x25E2
#define unicode_BLACK_LOWER_LEFT_TRIANGLE                             0x25E3
#define unicode_BLACK_UPPER_LEFT_TRIANGLE                             0x25E4
#define unicode_BLACK_UPPER_RIGHT_TRIANGLE                            0x25E5
#define unicode_WHITE_BULLET                                          0x25E6
#define unicode_SQUARE_WITH_LEFT_HALF_BLACK                           0x25E7
#define unicode_SQUARE_WITH_RIGHT_HALF_BLACK                          0x25E8
#define unicode_SQUARE_WITH_UPPER_LEFT_DIAGONAL_HALF_BLACK            0x25E9
#define unicode_SQUARE_WITH_LOWER_RIGHT_DIAGONAL_HALF_BLACK           0x25EA
#define unicode_WHITE_SQUARE_WITH_VERTICAL_BISECTING_LINE             0x25EB
#define unicode_WHITE_UP_POINTING_TRIANGLE_WITH_DOT                   0x25EC
#define unicode_UP_POINTING_TRIANGLE_WITH_LEFT_HALF_BLACK             0x25ED
#define unicode_UP_POINTING_TRIANGLE_WITH_RIGHT_HALF_BLACK            0x25EE
#define unicode_LARGE_CIRCLE                                          0x25EF
#define unicode_WHITE_SQUARE_WITH_UPPER_LEFT_QUADRANT                 0x25F0
#define unicode_WHITE_SQUARE_WITH_LOWER_LEFT_QUADRANT                 0x25F1
#define unicode_WHITE_SQUARE_WITH_LOWER_RIGHT_QUADRANT                0x25F2
#define unicode_WHITE_SQUARE_WITH_UPPER_RIGHT_QUADRANT                0x25F3
#define unicode_WHITE_CIRCLE_WITH_UPPER_LEFT_QUADRANT                 0x25F4
#define unicode_WHITE_CIRCLE_WITH_LOWER_LEFT_QUADRANT                 0x25F5
#define unicode_WHITE_CIRCLE_WITH_LOWER_RIGHT_QUADRANT                0x25F6
#define unicode_WHITE_CIRCLE_WITH_UPPER_RIGHT_QUADRANT                0x25F7
#define unicode_UPPER_LEFT_TRIANGLE                                   0x25F8
#define unicode_UPPER_RIGHT_TRIANGLE                                  0x25F9
#define unicode_LOWER_LEFT_TRIANGLE                                   0x25FA
#define unicode_WHITE_MEDIUM_SQUARE                                   0x25FB
#define unicode_BLACK_MEDIUM_SQUARE                                   0x25FC
#define unicode_WHITE_MEDIUM_SMALL_SQUARE                             0x25FD
#define unicode_BLACK_MEDIUM_SMALL_SQUARE                             0x25FE
#define unicode_LOWER_RIGHT_TRIANGLE                                  0x25FF
#define unicode_BLACK_SUN_WITH_RAYS                                   0x2600
#define unicode_CLOUD                                                 0x2601
#define unicode_UMBRELLA                                              0x2602
#define unicode_SNOWMAN                                               0x2603
#define unicode_COMET                                                 0x2604
#define unicode_BLACK_STAR                                            0x2605
#define unicode_WHITE_STAR                                            0x2606
#define unicode_LIGHTNING                                             0x2607
#define unicode_THUNDERSTORM                                          0x2608
#define unicode_SUN                                                   0x2609
#define unicode_ASCENDING_NODE                                        0x260A
#define unicode_DESCENDING_NODE                                       0x260B
#define unicode_CONJUNCTION                                           0x260C
#define unicode_OPPOSITION                                            0x260D
#define unicode_BLACK_TELEPHONE                                       0x260E
#define unicode_WHITE_TELEPHONE                                       0x260F
#define unicode_BALLOT_BOX                                            0x2610
#define unicode_BALLOT_BOX_WITH_CHECK                                 0x2611
#define unicode_BALLOT_BOX_WITH_X                                     0x2612
#define unicode_SALTIRE                                               0x2613
#define unicode_UMBRELLA_WITH_RAIN_DROPS                              0x2614
#define unicode_HOT_BEVERAGE                                          0x2615
#define unicode_WHITE_SHOGI_PIECE                                     0x2616
#define unicode_BLACK_SHOGI_PIECE                                     0x2617
#define unicode_SHAMROCK                                              0x2618
#define unicode_REVERSED_ROTATED_FLORAL_HEART_BULLET                  0x2619
#define unicode_BLACK_LEFT_POINTING_INDEX                             0x261A
#define unicode_BLACK_RIGHT_POINTING_INDEX                            0x261B
#define unicode_WHITE_LEFT_POINTING_INDEX                             0x261C
#define unicode_WHITE_UP_POINTING_INDEX                               0x261D
#define unicode_WHITE_RIGHT_POINTING_INDEX                            0x261E
#define unicode_WHITE_DOWN_POINTING_INDEX                             0x261F
#define unicode_SKULL_AND_CROSSBONES                                  0x2620
#define unicode_CAUTION_SIGN                                          0x2621
#define unicode_RADIOACTIVE_SIGN                                      0x2622
#define unicode_BIOHAZARD_SIGN                                        0x2623
#define unicode_CADUCEUS                                              0x2624
#define unicode_ANKH                                                  0x2625
#define unicode_ORTHODOX_CROSS                                        0x2626
#define unicode_CHI_RHO                                               0x2627
#define unicode_CROSS_OF_LORRAINE                                     0x2628
#define unicode_CROSS_OF_JERUSALEM                                    0x2629
#define unicode_STAR_AND_CRESCENT                                     0x262A
#define unicode_FARSI_SYMBOL                                          0x262B
#define unicode_ADI_SHAKTI                                            0x262C
#define unicode_HAMMER_AND_SICKLE                                     0x262D
#define unicode_PEACE_SYMBOL                                          0x262E
#define unicode_YIN_YANG                                              0x262F
#define unicode_TRIGRAM_FOR_HEAVEN                                    0x2630
#define unicode_TRIGRAM_FOR_LAKE                                      0x2631
#define unicode_TRIGRAM_FOR_FIRE                                      0x2632
#define unicode_TRIGRAM_FOR_THUNDER                                   0x2633
#define unicode_TRIGRAM_FOR_WIND                                      0x2634
#define unicode_TRIGRAM_FOR_WATER                                     0x2635
#define unicode_TRIGRAM_FOR_MOUNTAIN                                  0x2636
#define unicode_TRIGRAM_FOR_EARTH                                     0x2637
#define unicode_WHEEL_OF_DHARMA                                       0x2638
#define unicode_WHITE_FROWNING_FACE                                   0x2639
#define unicode_WHITE_SMILING_FACE                                    0x263A
#define unicode_BLACK_SMILING_FACE                                    0x263B
#define unicode_WHITE_SUN_WITH_RAYS                                   0x263C
#define unicode_FIRST_QUARTER_MOON                                    0x263D
#define unicode_LAST_QUARTER_MOON                                     0x263E
#define unicode_MERCURY                                               0x263F
#define unicode_FEMALE_SIGN                                           0x2640
#define unicode_EARTH                                                 0x2641
#define unicode_MALE_SIGN                                             0x2642
#define unicode_JUPITER                                               0x2643
#define unicode_SATURN                                                0x2644
#define unicode_URANUS                                                0x2645
#define unicode_NEPTUNE                                               0x2646
#define unicode_PLUTO                                                 0x2647
#define unicode_ARIES                                                 0x2648
#define unicode_TAURUS                                                0x2649
#define unicode_GEMINI                                                0x264A
#define unicode_CANCER                                                0x264B
#define unicode_LEO                                                   0x264C
#define unicode_VIRGO                                                 0x264D
#define unicode_LIBRA                                                 0x264E
#define unicode_SCORPIUS                                              0x264F
#define unicode_SAGITTARIUS                                           0x2650
#define unicode_CAPRICORN                                             0x2651
#define unicode_AQUARIUS                                              0x2652
#define unicode_PISCES                                                0x2653
#define unicode_WHITE_CHESS_KING                                      0x2654
#define unicode_WHITE_CHESS_QUEEN                                     0x2655
#define unicode_WHITE_CHESS_ROOK                                      0x2656
#define unicode_WHITE_CHESS_BISHOP                                    0x2657
#define unicode_WHITE_CHESS_KNIGHT                                    0x2658
#define unicode_WHITE_CHESS_PAWN                                      0x2659
#define unicode_BLACK_CHESS_KING                                      0x265A
#define unicode_BLACK_CHESS_QUEEN                                     0x265B
#define unicode_BLACK_CHESS_ROOK                                      0x265C
#define unicode_BLACK_CHESS_BISHOP                                    0x265D
#define unicode_BLACK_CHESS_KNIGHT                                    0x265E
#define unicode_BLACK_CHESS_PAWN                                      0x265F
#define unicode_BLACK_SPADE_SUIT                                      0x2660
#define unicode_WHITE_HEART_SUIT                                      0x2661
#define unicode_WHITE_DIAMOND_SUIT                                    0x2662
#define unicode_BLACK_CLUB_SUIT                                       0x2663
#define unicode_WHITE_SPADE_SUIT                                      0x2664
#define unicode_BLACK_HEART_SUIT                                      0x2665
#define unicode_BLACK_DIAMOND_SUIT                                    0x2666
#define unicode_WHITE_CLUB_SUIT                                       0x2667
#define unicode_HOT_SPRINGS                                           0x2668
#define unicode_QUARTER_NOTE                                          0x2669
#define unicode_EIGHTH_NOTE                                           0x266A
#define unicode_BEAMED_EIGHTH_NOTES                                   0x266B
#define unicode_BEAMED_SIXTEENTH_NOTES                                0x266C
#define unicode_MUSIC_FLAT_SIGN                                       0x266D
#define unicode_MUSIC_NATURAL_SIGN                                    0x266E
#define unicode_MUSIC_SHARP_SIGN                                      0x266F
#define unicode_WEST_SYRIAC_CROSS                                     0x2670
#define unicode_EAST_SYRIAC_CROSS                                     0x2671
#define unicode_UNIVERSAL_RECYCLING_SYMBOL                            0x2672
#define unicode_RECYCLING_SYMBOL_FOR_TYPE_1_PLASTICS                  0x2673
#define unicode_RECYCLING_SYMBOL_FOR_TYPE_2_PLASTICS                  0x2674
#define unicode_RECYCLING_SYMBOL_FOR_TYPE_3_PLASTICS                  0x2675
#define unicode_RECYCLING_SYMBOL_FOR_TYPE_4_PLASTICS                  0x2676
#define unicode_RECYCLING_SYMBOL_FOR_TYPE_5_PLASTICS                  0x2677
#define unicode_RECYCLING_SYMBOL_FOR_TYPE_6_PLASTICS                  0x2678
#define unicode_RECYCLING_SYMBOL_FOR_TYPE_7_PLASTICS                  0x2679
#define unicode_RECYCLING_SYMBOL_FOR_GENERIC_MATERIALS                0x267A
#define unicode_BLACK_UNIVERSAL_RECYCLING_SYMBOL                      0x267B
#define unicode_RECYCLED_PAPER_SYMBOL                                 0x267C
#define unicode_PARTIALLY_RECYCLED_PAPER_SYMBOL                       0x267D
#define unicode_PERMANENT_PAPER_SIGN                                  0x267E
#define unicode_WHEELCHAIR_SYMBOL                                     0x267F
#define unicode_DIE_FACE_1                                            0x2680
#define unicode_DIE_FACE_2                                            0x2681
#define unicode_DIE_FACE_3                                            0x2682
#define unicode_DIE_FACE_4                                            0x2683
#define unicode_DIE_FACE_5                                            0x2684
#define unicode_DIE_FACE_6                                            0x2685
#define unicode_WHITE_CIRCLE_WITH_DOT_RIGHT                           0x2686
#define unicode_WHITE_CIRCLE_WITH_TWO_DOTS                            0x2687
#define unicode_BLACK_CIRCLE_WITH_WHITE_DOT_RIGHT                     0x2688
#define unicode_BLACK_CIRCLE_WITH_TWO_WHITE_DOTS                      0x2689
#define unicode_MONOGRAM_FOR_YANG                                     0x268A
#define unicode_MONOGRAM_FOR_YIN                                      0x268B
#define unicode_DIGRAM_FOR_GREATER_YANG                               0x268C
#define unicode_DIGRAM_FOR_LESSER_YIN                                 0x268D
#define unicode_DIGRAM_FOR_LESSER_YANG                                0x268E
#define unicode_DIGRAM_FOR_GREATER_YIN                                0x268F
#define unicode_WHITE_FLAG                                            0x2690
#define unicode_BLACK_FLAG                                            0x2691
#define unicode_HAMMER_AND_PICK                                       0x2692
#define unicode_ANCHOR                                                0x2693
#define unicode_CROSSED_SWORDS                                        0x2694
#define unicode_STAFF_OF_AESCULAPIUS                                  0x2695
#define unicode_SCALES                                                0x2696
#define unicode_ALEMBIC                                               0x2697
#define unicode_FLOWER                                                0x2698
#define unicode_GEAR                                                  0x2699
#define unicode_STAFF_OF_HERMES                                       0x269A
#define unicode_ATOM_SYMBOL                                           0x269B
#define unicode_FLEUR_DE_LIS                                          0x269C
#define unicode_OUTLINED_WHITE_STAR                                   0x269D
#define unicode_THREE_LINES_CONVERGING_RIGHT                          0x269E
#define unicode_THREE_LINES_CONVERGING_LEFT                           0x269F
#define unicode_WARNING_SIGN                                          0x26A0
#define unicode_HIGH_VOLTAGE_SIGN                                     0x26A1
#define unicode_DOUBLED_FEMALE_SIGN                                   0x26A2
#define unicode_DOUBLED_MALE_SIGN                                     0x26A3
#define unicode_INTERLOCKED_FEMALE_AND_MALE_SIGN                      0x26A4
#define unicode_MALE_AND_FEMALE_SIGN                                  0x26A5
#define unicode_MALE_WITH_STROKE_SIGN                                 0x26A6
#define unicode_MALE_WITH_STROKE_AND_MALE_AND_FEMALE_SIGN             0x26A7
#define unicode_VERTICAL_MALE_WITH_STROKE_SIGN                        0x26A8
#define unicode_HORIZONTAL_MALE_WITH_STROKE_SIGN                      0x26A9
#define unicode_MEDIUM_WHITE_CIRCLE                                   0x26AA
#define unicode_MEDIUM_BLACK_CIRCLE                                   0x26AB
#define unicode_MEDIUM_SMALL_WHITE_CIRCLE                             0x26AC
#define unicode_MARRIAGE_SYMBOL                                       0x26AD
#define unicode_DIVORCE_SYMBOL                                        0x26AE
#define unicode_UNMARRIED_PARTNERSHIP_SYMBOL                          0x26AF
#define unicode_COFFIN                                                0x26B0
#define unicode_FUNERAL_URN                                           0x26B1
#define unicode_NEUTER                                                0x26B2
#define unicode_CERES                                                 0x26B3
#define unicode_PALLAS                                                0x26B4
#define unicode_JUNO                                                  0x26B5
#define unicode_VESTA                                                 0x26B6
#define unicode_CHIRON                                                0x26B7
#define unicode_BLACK_MOON_LILITH                                     0x26B8
#define unicode_SEXTILE                                               0x26B9
#define unicode_SEMISEXTILE                                           0x26BA
#define unicode_QUINCUNX                                              0x26BB
#define unicode_SESQUIQUADRATE                                        0x26BC
#define unicode_SOCCER_BALL                                           0x26BD
#define unicode_BASEBALL                                              0x26BE
#define unicode_SQUARED_KEY                                           0x26BF
#define unicode_WHITE_DRAUGHTS_MAN                                    0x26C0
#define unicode_WHITE_DRAUGHTS_KING                                   0x26C1
#define unicode_BLACK_DRAUGHTS_MAN                                    0x26C2
#define unicode_BLACK_DRAUGHTS_KING                                   0x26C3
#define unicode_SNOWMAN_WITHOUT_SNOW                                  0x26C4
#define unicode_SUN_BEHIND_CLOUD                                      0x26C5
#define unicode_RAIN                                                  0x26C6
#define unicode_BLACK_SNOWMAN                                         0x26C7
#define unicode_THUNDER_CLOUD_AND_RAIN                                0x26C8
#define unicode_TURNED_WHITE_SHOGI_PIECE                              0x26C9
#define unicode_TURNED_BLACK_SHOGI_PIECE                              0x26CA
#define unicode_WHITE_DIAMOND_IN_SQUARE                               0x26CB
#define unicode_CROSSING_LANES                                        0x26CC
#define unicode_DISABLED_CAR                                          0x26CD
#define unicode_OPHIUCHUS                                             0x26CE
#define unicode_PICK                                                  0x26CF
#define unicode_CAR_SLIDING                                           0x26D0
#define unicode_HELMET_WITH_WHITE_CROSS                               0x26D1
#define unicode_CIRCLED_CROSSING_LANES                                0x26D2
#define unicode_CHAINS                                                0x26D3
#define unicode_NO_ENTRY                                              0x26D4
#define unicode_ALTERNATE_ONE_WAY_LEFT_WAY_TRAFFIC                    0x26D5
#define unicode_BLACK_TWO_WAY_LEFT_WAY_TRAFFIC                        0x26D6
#define unicode_WHITE_TWO_WAY_LEFT_WAY_TRAFFIC                        0x26D7
#define unicode_BLACK_LEFT_LANE_MERGE                                 0x26D8
#define unicode_WHITE_LEFT_LANE_MERGE                                 0x26D9
#define unicode_DRIVE_SLOW_SIGN                                       0x26DA
#define unicode_HEAVY_WHITE_DOWN_POINTING_TRIANGLE                    0x26DB
#define unicode_LEFT_CLOSED_ENTRY                                     0x26DC
#define unicode_SQUARED_SALTIRE                                       0x26DD
#define unicode_FALLING_DIAGONAL_IN_WHITE_CIRCLE_IN_BLACK_SQUARE      0x26DE
#define unicode_BLACK_TRUCK                                           0x26DF
#define unicode_RESTRICTED_LEFT_ENTRY_1                               0x26E0
#define unicode_RESTRICTED_LEFT_ENTRY_2                               0x26E1
#define unicode_ASTRONOMICAL_SYMBOL_FOR_URANUS                        0x26E2
#define unicode_HEAVY_CIRCLE_WITH_STROKE_AND_TWO_DOTS_ABOVE           0x26E3
#define unicode_PENTAGRAM                                             0x26E4
#define unicode_RIGHT_HANDED_INTERLACED_PENTAGRAM                     0x26E5
#define unicode_LEFT_HANDED_INTERLACED_PENTAGRAM                      0x26E6
#define unicode_INVERTED_PENTAGRAM                                    0x26E7
#define unicode_BLACK_CROSS_ON_SHIELD                                 0x26E8
#define unicode_SHINTO_SHRINE                                         0x26E9
#define unicode_CHURCH                                                0x26EA
#define unicode_CASTLE                                                0x26EB
#define unicode_HISTORIC_SITE                                         0x26EC
#define unicode_GEAR_WITHOUT_HUB                                      0x26ED
#define unicode_GEAR_WITH_HANDLES                                     0x26EE
#define unicode_MAP_SYMBOL_FOR_LIGHTHOUSE                             0x26EF
#define unicode_MOUNTAIN                                              0x26F0
#define unicode_UMBRELLA_ON_GROUND                                    0x26F1
#define unicode_FOUNTAIN                                              0x26F2
#define unicode_FLAG_IN_HOLE                                          0x26F3
#define unicode_FERRY                                                 0x26F4
#define unicode_SAILBOAT                                              0x26F5
#define unicode_SQUARE_FOUR_CORNERS                                   0x26F6
#define unicode_SKIER                                                 0x26F7
#define unicode_ICE_SKATE                                             0x26F8
#define unicode_PERSON_WITH_BALL                                      0x26F9
#define unicode_TENT                                                  0x26FA
#define unicode_JAPANESE_BANK_SYMBOL                                  0x26FB
#define unicode_HEADSTONE_GRAVEYARD_SYMBOL                            0x26FC
#define unicode_FUEL_PUMP                                             0x26FD
#define unicode_CUP_ON_BLACK_SQUARE                                   0x26FE
#define unicode_WHITE_FLAG_WITH_HORIZONTAL_MIDDLE_BLACK_STRIPE        0x26FF
#define unicode_BLACK_SAFETY_SCISSORS                                 0x2700
#define unicode_UPPER_BLADE_SCISSORS                                  0x2701
#define unicode_BLACK_SCISSORS                                        0x2702
#define unicode_LOWER_BLADE_SCISSORS                                  0x2703
#define unicode_WHITE_SCISSORS                                        0x2704
#define unicode_WHITE_HEAVY_CHECK_MARK                                0x2705
#define unicode_TELEPHONE_LOCATION_SIGN                               0x2706
#define unicode_TAPE_DRIVE                                            0x2707
#define unicode_AIRPLANE                                              0x2708
#define unicode_ENVELOPE                                              0x2709
#define unicode_RAISED_FIST                                           0x270A
#define unicode_RAISED_HAND                                           0x270B
#define unicode_VICTORY_HAND                                          0x270C
#define unicode_WRITING_HAND                                          0x270D
#define unicode_LOWER_RIGHT_PENCIL                                    0x270E
#define unicode_PENCIL                                                0x270F
#define unicode_UPPER_RIGHT_PENCIL                                    0x2710
#define unicode_WHITE_NIB                                             0x2711
#define unicode_BLACK_NIB                                             0x2712
#define unicode_CHECK_MARK                                            0x2713
#define unicode_HEAVY_CHECK_MARK                                      0x2714
#define unicode_MULTIPLICATION_X                                      0x2715
#define unicode_HEAVY_MULTIPLICATION_X                                0x2716
#define unicode_BALLOT_X                                              0x2717
#define unicode_HEAVY_BALLOT_X                                        0x2718
#define unicode_OUTLINED_GREEK_CROSS                                  0x2719
#define unicode_HEAVY_GREEK_CROSS                                     0x271A
#define unicode_OPEN_CENTRE_CROSS                                     0x271B
#define unicode_HEAVY_OPEN_CENTRE_CROSS                               0x271C
#define unicode_LATIN_CROSS                                           0x271D
#define unicode_SHADOWED_WHITE_LATIN_CROSS                            0x271E
#define unicode_OUTLINED_LATIN_CROSS                                  0x271F
#define unicode_MALTESE_CROSS                                         0x2720
#define unicode_STAR_OF_DAVID                                         0x2721
#define unicode_FOUR_TEARDROP_SPOKED_ASTERISK                         0x2722
#define unicode_FOUR_BALLOON_SPOKED_ASTERISK                          0x2723
#define unicode_HEAVY_FOUR_BALLOON_SPOKED_ASTERISK                    0x2724
#define unicode_FOUR_CLUB_SPOKED_ASTERISK                             0x2725
#define unicode_BLACK_FOUR_POINTED_STAR                               0x2726
#define unicode_WHITE_FOUR_POINTED_STAR                               0x2727
#define unicode_SPARKLES                                              0x2728
#define unicode_STRESS_OUTLINED_WHITE_STAR                            0x2729
#define unicode_CIRCLED_WHITE_STAR                                    0x272A
#define unicode_OPEN_CENTRE_BLACK_STAR                                0x272B
#define unicode_BLACK_CENTRE_WHITE_STAR                               0x272C
#define unicode_OUTLINED_BLACK_STAR                                   0x272D
#define unicode_HEAVY_OUTLINED_BLACK_STAR                             0x272E
#define unicode_PINWHEEL_STAR                                         0x272F
#define unicode_SHADOWED_WHITE_STAR                                   0x2730
#define unicode_HEAVY_ASTERISK                                        0x2731
#define unicode_OPEN_CENTRE_ASTERISK                                  0x2732
#define unicode_EIGHT_SPOKED_ASTERISK                                 0x2733
#define unicode_EIGHT_POINTED_BLACK_STAR                              0x2734
#define unicode_EIGHT_POINTED_PINWHEEL_STAR                           0x2735
#define unicode_SIX_POINTED_BLACK_STAR                                0x2736
#define unicode_EIGHT_POINTED_RECTILINEAR_BLACK_STAR                  0x2737
#define unicode_HEAVY_EIGHT_POINTED_RECTILINEAR_BLACK_STAR            0x2738
#define unicode_TWELVE_POINTED_BLACK_STAR                             0x2739
#define unicode_SIXTEEN_POINTED_ASTERISK                              0x273A
#define unicode_TEARDROP_SPOKED_ASTERISK                              0x273B
#define unicode_OPEN_CENTRE_TEARDROP_SPOKED_ASTERISK                  0x273C
#define unicode_HEAVY_TEARDROP_SPOKED_ASTERISK                        0x273D
#define unicode_SIX_PETALLED_BLACK_AND_WHITE_FLORETTE                 0x273E
#define unicode_BLACK_FLORETTE                                        0x273F
#define unicode_WHITE_FLORETTE                                        0x2740
#define unicode_EIGHT_PETALLED_OUTLINED_BLACK_FLORETTE                0x2741
#define unicode_CIRCLED_OPEN_CENTRE_EIGHT_POINTED_STAR                0x2742
#define unicode_HEAVY_TEARDROP_SPOKED_PINWHEEL_ASTERISK               0x2743
#define unicode_SNOWFLAKE                                             0x2744
#define unicode_TIGHT_TRIFOLIATE_SNOWFLAKE                            0x2745
#define unicode_HEAVY_CHEVRON_SNOWFLAKE                               0x2746
#define unicode_SPARKLE                                               0x2747
#define unicode_HEAVY_SPARKLE                                         0x2748
#define unicode_BALLOON_SPOKED_ASTERISK                               0x2749
#define unicode_EIGHT_TEARDROP_SPOKED_PROPELLER_ASTERISK              0x274A
#define unicode_HEAVY_EIGHT_TEARDROP_SPOKED_PROPELLER_ASTERISK        0x274B
#define unicode_CROSS_MARK                                            0x274C
#define unicode_SHADOWED_WHITE_CIRCLE                                 0x274D
#define unicode_NEGATIVE_SQUARED_CROSS_MARK                           0x274E
#define unicode_LOWER_RIGHT_DROP_SHADOWED_WHITE_SQUARE                0x274F
#define unicode_UPPER_RIGHT_DROP_SHADOWED_WHITE_SQUARE                0x2750
#define unicode_LOWER_RIGHT_SHADOWED_WHITE_SQUARE                     0x2751
#define unicode_UPPER_RIGHT_SHADOWED_WHITE_SQUARE                     0x2752
#define unicode_BLACK_QUESTION_MARK_ORNAMENT                          0x2753
#define unicode_WHITE_QUESTION_MARK_ORNAMENT                          0x2754
#define unicode_WHITE_EXCLAMATION_MARK_ORNAMENT                       0x2755
#define unicode_BLACK_DIAMOND_MINUS_WHITE_X                           0x2756
#define unicode_HEAVY_EXCLAMATION_MARK_SYMBOL                         0x2757
#define unicode_LIGHT_VERTICAL_BAR                                    0x2758
#define unicode_MEDIUM_VERTICAL_BAR                                   0x2759
#define unicode_HEAVY_VERTICAL_BAR                                    0x275A
#define unicode_HEAVY_SINGLE_TURNED_COMMA_QUOTATION_MARK_ORNAMENT     0x275B
#define unicode_HEAVY_SINGLE_COMMA_QUOTATION_MARK_ORNAMENT            0x275C
#define unicode_HEAVY_DOUBLE_TURNED_COMMA_QUOTATION_MARK_ORNAMENT     0x275D
#define unicode_HEAVY_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT            0x275E
#define unicode_HEAVY_LOW_SINGLE_COMMA_QUOTATION_MARK_ORNAMENT        0x275F
#define unicode_HEAVY_LOW_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT        0x2760
#define unicode_CURVED_STEM_PARAGRAPH_SIGN_ORNAMENT                   0x2761
#define unicode_HEAVY_EXCLAMATION_MARK_ORNAMENT                       0x2762
#define unicode_HEAVY_HEART_EXCLAMATION_MARK_ORNAMENT                 0x2763
#define unicode_HEAVY_BLACK_HEART                                     0x2764
#define unicode_ROTATED_HEAVY_BLACK_HEART_BULLET                      0x2765
#define unicode_FLORAL_HEART                                          0x2766
#define unicode_ROTATED_FLORAL_HEART_BULLET                           0x2767
#define unicode_MEDIUM_LEFT_PARENTHESIS_ORNAMENT                      0x2768
#define unicode_MEDIUM_RIGHT_PARENTHESIS_ORNAMENT                     0x2769
#define unicode_MEDIUM_FLATTENED_LEFT_PARENTHESIS_ORNAMENT            0x276A
#define unicode_MEDIUM_FLATTENED_RIGHT_PARENTHESIS_ORNAMENT           0x276B
#define unicode_MEDIUM_LEFT_POINTING_ANGLE_BRACKET_ORNAMENT           0x276C
#define unicode_MEDIUM_RIGHT_POINTING_ANGLE_BRACKET_ORNAMENT          0x276D
#define unicode_HEAVY_LEFT_POINTING_ANGLE_QUOTATION_MARK_ORNAMENT     0x276E
#define unicode_HEAVY_RIGHT_POINTING_ANGLE_QUOTATION_MARK_ORNAMENT    0x276F
#define unicode_HEAVY_LEFT_POINTING_ANGLE_BRACKET_ORNAMENT            0x2770
#define unicode_HEAVY_RIGHT_POINTING_ANGLE_BRACKET_ORNAMENT           0x2771
#define unicode_LIGHT_LEFT_TORTOISE_SHELL_BRACKET_ORNAMENT            0x2772
#define unicode_LIGHT_RIGHT_TORTOISE_SHELL_BRACKET_ORNAMENT           0x2773
#define unicode_MEDIUM_LEFT_CURLY_BRACKET_ORNAMENT                    0x2774
#define unicode_MEDIUM_RIGHT_CURLY_BRACKET_ORNAMENT                   0x2775
#define unicode_DINGBAT_NEGATIVE_CIRCLED_DIGIT_ONE                    0x2776
#define unicode_DINGBAT_NEGATIVE_CIRCLED_DIGIT_TWO                    0x2777
#define unicode_DINGBAT_NEGATIVE_CIRCLED_DIGIT_THREE                  0x2778
#define unicode_DINGBAT_NEGATIVE_CIRCLED_DIGIT_FOUR                   0x2779
#define unicode_DINGBAT_NEGATIVE_CIRCLED_DIGIT_FIVE                   0x277A
#define unicode_DINGBAT_NEGATIVE_CIRCLED_DIGIT_SIX                    0x277B
#define unicode_DINGBAT_NEGATIVE_CIRCLED_DIGIT_SEVEN                  0x277C
#define unicode_DINGBAT_NEGATIVE_CIRCLED_DIGIT_EIGHT                  0x277D
#define unicode_DINGBAT_NEGATIVE_CIRCLED_DIGIT_NINE                   0x277E
#define unicode_DINGBAT_NEGATIVE_CIRCLED_NUMBER_TEN                   0x277F
#define unicode_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_ONE                  0x2780
#define unicode_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_TWO                  0x2781
#define unicode_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_THREE                0x2782
#define unicode_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_FOUR                 0x2783
#define unicode_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_FIVE                 0x2784
#define unicode_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_SIX                  0x2785
#define unicode_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_SEVEN                0x2786
#define unicode_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_EIGHT                0x2787
#define unicode_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_NINE                 0x2788
#define unicode_DINGBAT_CIRCLED_SANS_SERIF_NUMBER_TEN                 0x2789
#define unicode_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_ONE         0x278A
#define unicode_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_TWO         0x278B
#define unicode_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_THREE       0x278C
#define unicode_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_FOUR        0x278D
#define unicode_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_FIVE        0x278E
#define unicode_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_SIX         0x278F
#define unicode_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_SEVEN       0x2790
#define unicode_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_EIGHT       0x2791
#define unicode_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_NINE        0x2792
#define unicode_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_NUMBER_TEN        0x2793
#define unicode_HEAVY_WIDE_HEADED_RIGHTWARDS_ARROW                    0x2794
#define unicode_HEAVY_PLUS_SIGN                                       0x2795
#define unicode_HEAVY_MINUS_SIGN                                      0x2796
#define unicode_HEAVY_DIVISION_SIGN                                   0x2797
#define unicode_HEAVY_SOUTH_EAST_ARROW                                0x2798
#define unicode_HEAVY_RIGHTWARDS_ARROW                                0x2799
#define unicode_HEAVY_NORTH_EAST_ARROW                                0x279A
#define unicode_DRAFTING_POINT_RIGHTWARDS_ARROW                       0x279B
#define unicode_HEAVY_ROUND_TIPPED_RIGHTWARDS_ARROW                   0x279C
#define unicode_TRIANGLE_HEADED_RIGHTWARDS_ARROW                      0x279D
#define unicode_HEAVY_TRIANGLE_HEADED_RIGHTWARDS_ARROW                0x279E
#define unicode_DASHED_TRIANGLE_HEADED_RIGHTWARDS_ARROW               0x279F
#define unicode_HEAVY_DASHED_TRIANGLE_HEADED_RIGHTWARDS_ARROW         0x27A0
#define unicode_BLACK_RIGHTWARDS_ARROW                                0x27A1
#define unicode_THREE_D_TOP_LIGHTED_RIGHTWARDS_ARROWHEAD              0x27A2
#define unicode_THREE_D_BOTTOM_LIGHTED_RIGHTWARDS_ARROWHEAD           0x27A3
#define unicode_BLACK_RIGHTWARDS_ARROWHEAD                            0x27A4
#define unicode_HEAVY_BLACK_CURVED_DOWNWARDS_AND_RIGHTWARDS_ARROW     0x27A5
#define unicode_HEAVY_BLACK_CURVED_UPWARDS_AND_RIGHTWARDS_ARROW       0x27A6
#define unicode_SQUAT_BLACK_RIGHTWARDS_ARROW                          0x27A7
#define unicode_HEAVY_CONCAVE_POINTED_BLACK_RIGHTWARDS_ARROW          0x27A8
#define unicode_RIGHT_SHADED_WHITE_RIGHTWARDS_ARROW                   0x27A9
#define unicode_LEFT_SHADED_WHITE_RIGHTWARDS_ARROW                    0x27AA
#define unicode_BACK_TILTED_SHADOWED_WHITE_RIGHTWARDS_ARROW           0x27AB
#define unicode_FRONT_TILTED_SHADOWED_WHITE_RIGHTWARDS_ARROW          0x27AC
#define unicode_HEAVY_LOWER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW     0x27AD
#define unicode_HEAVY_UPPER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW     0x27AE
#define unicode_NOTCHED_LOWER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW   0x27AF
#define unicode_CURLY_LOOP                                            0x27B0
#define unicode_NOTCHED_UPPER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW   0x27B1
#define unicode_CIRCLED_HEAVY_WHITE_RIGHTWARDS_ARROW                  0x27B2
#define unicode_WHITE_FEATHERED_RIGHTWARDS_ARROW                      0x27B3
#define unicode_BLACK_FEATHERED_SOUTH_EAST_ARROW                      0x27B4
#define unicode_BLACK_FEATHERED_RIGHTWARDS_ARROW                      0x27B5
#define unicode_BLACK_FEATHERED_NORTH_EAST_ARROW                      0x27B6
#define unicode_HEAVY_BLACK_FEATHERED_SOUTH_EAST_ARROW                0x27B7
#define unicode_HEAVY_BLACK_FEATHERED_RIGHTWARDS_ARROW                0x27B8
#define unicode_HEAVY_BLACK_FEATHERED_NORTH_EAST_ARROW                0x27B9
#define unicode_TEARDROP_BARBED_RIGHTWARDS_ARROW                      0x27BA
#define unicode_HEAVY_TEARDROP_SHANKED_RIGHTWARDS_ARROW               0x27BB
#define unicode_WEDGE_TAILED_RIGHTWARDS_ARROW                         0x27BC
#define unicode_HEAVY_WEDGE_TAILED_RIGHTWARDS_ARROW                   0x27BD
#define unicode_OPEN_OUTLINED_RIGHTWARDS_ARROW                        0x27BE
#define unicode_DOUBLE_CURLY_LOOP                                     0x27BF
#define unicode_THREE_DIMENSIONAL_ANGLE                               0x27C0
#define unicode_WHITE_TRIANGLE_CONTAINING_SMALL_WHITE_TRIANGLE        0x27C1
#define unicode_PERPENDICULAR                                         0x27C2
#define unicode_OPEN_SUBSET                                           0x27C3
#define unicode_OPEN_SUPERSET                                         0x27C4
#define unicode_LEFT_S_SHAPED_BAG_DELIMITER                           0x27C5
#define unicode_RIGHT_S_SHAPED_BAG_DELIMITER                          0x27C6
#define unicode_OR_WITH_DOT_INSIDE                                    0x27C7
#define unicode_REVERSE_SOLIDUS_PRECEDING_SUBSET                      0x27C8
#define unicode_SUPERSET_PRECEDING_SOLIDUS                            0x27C9
#define unicode_VERTICAL_BAR_WITH_HORIZONTAL_STROKE                   0x27CA
#define unicode_MATHEMATICAL_RISING_DIAGONAL                          0x27CB
#define unicode_LONG_DIVISION                                         0x27CC
#define unicode_MATHEMATICAL_FALLING_DIAGONAL                         0x27CD
#define unicode_SQUARED_LOGICAL_AND                                   0x27CE
#define unicode_SQUARED_LOGICAL_OR                                    0x27CF
#define unicode_WHITE_DIAMOND_WITH_CENTRED_DOT                        0x27D0
#define unicode_AND_WITH_DOT                                          0x27D1
#define unicode_ELEMENT_OF_OPENING_UPWARDS                            0x27D2
#define unicode_LOWER_RIGHT_CORNER_WITH_DOT                           0x27D3
#define unicode_UPPER_LEFT_CORNER_WITH_DOT                            0x27D4
#define unicode_LEFT_OUTER_JOIN                                       0x27D5
#define unicode_RIGHT_OUTER_JOIN                                      0x27D6
#define unicode_FULL_OUTER_JOIN                                       0x27D7
#define unicode_LARGE_UP_TACK                                         0x27D8
#define unicode_LARGE_DOWN_TACK                                       0x27D9
#define unicode_LEFT_AND_RIGHT_DOUBLE_TURNSTILE                       0x27DA
#define unicode_LEFT_AND_RIGHT_TACK                                   0x27DB
#define unicode_LEFT_MULTIMAP                                         0x27DC
#define unicode_LONG_RIGHT_TACK                                       0x27DD
#define unicode_LONG_LEFT_TACK                                        0x27DE
#define unicode_UP_TACK_WITH_CIRCLE_ABOVE                             0x27DF
#define unicode_LOZENGE_DIVIDED_BY_HORIZONTAL_RULE                    0x27E0
#define unicode_WHITE_CONCAVE_SIDED_DIAMOND                           0x27E1
#define unicode_WHITE_CONCAVE_SIDED_DIAMOND_WITH_LEFTWARDS_TICK       0x27E2
#define unicode_WHITE_CONCAVE_SIDED_DIAMOND_WITH_RIGHTWARDS_TICK      0x27E3
#define unicode_WHITE_SQUARE_WITH_LEFTWARDS_TICK                      0x27E4
#define unicode_WHITE_SQUARE_WITH_RIGHTWARDS_TICK                     0x27E5
#define unicode_MATHEMATICAL_LEFT_WHITE_SQUARE_BRACKET                0x27E6
#define unicode_MATHEMATICAL_RIGHT_WHITE_SQUARE_BRACKET               0x27E7
#define unicode_MATHEMATICAL_LEFT_ANGLE_BRACKET                       0x27E8
#define unicode_MATHEMATICAL_RIGHT_ANGLE_BRACKET                      0x27E9
#define unicode_MATHEMATICAL_LEFT_DOUBLE_ANGLE_BRACKET                0x27EA
#define unicode_MATHEMATICAL_RIGHT_DOUBLE_ANGLE_BRACKET               0x27EB
#define unicode_MATHEMATICAL_LEFT_WHITE_TORTOISE_SHELL_BRACKET        0x27EC
#define unicode_MATHEMATICAL_RIGHT_WHITE_TORTOISE_SHELL_BRACKET       0x27ED
#define unicode_MATHEMATICAL_LEFT_FLATTENED_PARENTHESIS               0x27EE
#define unicode_MATHEMATICAL_RIGHT_FLATTENED_PARENTHESIS              0x27EF
#define unicode_UPWARDS_QUADRUPLE_ARROW                               0x27F0
#define unicode_DOWNWARDS_QUADRUPLE_ARROW                             0x27F1
#define unicode_ANTICLOCKWISE_GAPPED_CIRCLE_ARROW                     0x27F2
#define unicode_CLOCKWISE_GAPPED_CIRCLE_ARROW                         0x27F3
#define unicode_RIGHT_ARROW_WITH_CIRCLED_PLUS                         0x27F4
#define unicode_LONG_LEFTWARDS_ARROW                                  0x27F5
#define unicode_LONG_RIGHTWARDS_ARROW                                 0x27F6
#define unicode_LONG_LEFT_RIGHT_ARROW                                 0x27F7
#define unicode_LONG_LEFTWARDS_DOUBLE_ARROW                           0x27F8
#define unicode_LONG_RIGHTWARDS_DOUBLE_ARROW                          0x27F9
#define unicode_LONG_LEFT_RIGHT_DOUBLE_ARROW                          0x27FA
#define unicode_LONG_LEFTWARDS_ARROW_FROM_BAR                         0x27FB
#define unicode_LONG_RIGHTWARDS_ARROW_FROM_BAR                        0x27FC
#define unicode_LONG_LEFTWARDS_DOUBLE_ARROW_FROM_BAR                  0x27FD
#define unicode_LONG_RIGHTWARDS_DOUBLE_ARROW_FROM_BAR                 0x27FE
#define unicode_LONG_RIGHTWARDS_SQUIGGLE_ARROW                        0x27FF
#define unicode_BRAILLE_PATTERN_BLANK                                 0x2800
#define unicode_BRAILLE_PATTERN_DOTS_1                                0x2801
#define unicode_BRAILLE_PATTERN_DOTS_2                                0x2802
#define unicode_BRAILLE_PATTERN_DOTS_12                               0x2803
#define unicode_BRAILLE_PATTERN_DOTS_3                                0x2804
#define unicode_BRAILLE_PATTERN_DOTS_13                               0x2805
#define unicode_BRAILLE_PATTERN_DOTS_23                               0x2806
#define unicode_BRAILLE_PATTERN_DOTS_123                              0x2807
#define unicode_BRAILLE_PATTERN_DOTS_4                                0x2808
#define unicode_BRAILLE_PATTERN_DOTS_14                               0x2809
#define unicode_BRAILLE_PATTERN_DOTS_24                               0x280A
#define unicode_BRAILLE_PATTERN_DOTS_124                              0x280B
#define unicode_BRAILLE_PATTERN_DOTS_34                               0x280C
#define unicode_BRAILLE_PATTERN_DOTS_134                              0x280D
#define unicode_BRAILLE_PATTERN_DOTS_234                              0x280E
#define unicode_BRAILLE_PATTERN_DOTS_1234                             0x280F
#define unicode_BRAILLE_PATTERN_DOTS_5                                0x2810
#define unicode_BRAILLE_PATTERN_DOTS_15                               0x2811
#define unicode_BRAILLE_PATTERN_DOTS_25                               0x2812
#define unicode_BRAILLE_PATTERN_DOTS_125                              0x2813
#define unicode_BRAILLE_PATTERN_DOTS_35                               0x2814
#define unicode_BRAILLE_PATTERN_DOTS_135                              0x2815
#define unicode_BRAILLE_PATTERN_DOTS_235                              0x2816
#define unicode_BRAILLE_PATTERN_DOTS_1235                             0x2817
#define unicode_BRAILLE_PATTERN_DOTS_45                               0x2818
#define unicode_BRAILLE_PATTERN_DOTS_145                              0x2819
#define unicode_BRAILLE_PATTERN_DOTS_245                              0x281A
#define unicode_BRAILLE_PATTERN_DOTS_1245                             0x281B
#define unicode_BRAILLE_PATTERN_DOTS_345                              0x281C
#define unicode_BRAILLE_PATTERN_DOTS_1345                             0x281D
#define unicode_BRAILLE_PATTERN_DOTS_2345                             0x281E
#define unicode_BRAILLE_PATTERN_DOTS_12345                            0x281F
#define unicode_BRAILLE_PATTERN_DOTS_6                                0x2820
#define unicode_BRAILLE_PATTERN_DOTS_16                               0x2821
#define unicode_BRAILLE_PATTERN_DOTS_26                               0x2822
#define unicode_BRAILLE_PATTERN_DOTS_126                              0x2823
#define unicode_BRAILLE_PATTERN_DOTS_36                               0x2824
#define unicode_BRAILLE_PATTERN_DOTS_136                              0x2825
#define unicode_BRAILLE_PATTERN_DOTS_236                              0x2826
#define unicode_BRAILLE_PATTERN_DOTS_1236                             0x2827
#define unicode_BRAILLE_PATTERN_DOTS_46                               0x2828
#define unicode_BRAILLE_PATTERN_DOTS_146                              0x2829
#define unicode_BRAILLE_PATTERN_DOTS_246                              0x282A
#define unicode_BRAILLE_PATTERN_DOTS_1246                             0x282B
#define unicode_BRAILLE_PATTERN_DOTS_346                              0x282C
#define unicode_BRAILLE_PATTERN_DOTS_1346                             0x282D
#define unicode_BRAILLE_PATTERN_DOTS_2346                             0x282E
#define unicode_BRAILLE_PATTERN_DOTS_12346                            0x282F
#define unicode_BRAILLE_PATTERN_DOTS_56                               0x2830
#define unicode_BRAILLE_PATTERN_DOTS_156                              0x2831
#define unicode_BRAILLE_PATTERN_DOTS_256                              0x2832
#define unicode_BRAILLE_PATTERN_DOTS_1256                             0x2833
#define unicode_BRAILLE_PATTERN_DOTS_356                              0x2834
#define unicode_BRAILLE_PATTERN_DOTS_1356                             0x2835
#define unicode_BRAILLE_PATTERN_DOTS_2356                             0x2836
#define unicode_BRAILLE_PATTERN_DOTS_12356                            0x2837
#define unicode_BRAILLE_PATTERN_DOTS_456                              0x2838
#define unicode_BRAILLE_PATTERN_DOTS_1456                             0x2839
#define unicode_BRAILLE_PATTERN_DOTS_2456                             0x283A
#define unicode_BRAILLE_PATTERN_DOTS_12456                            0x283B
#define unicode_BRAILLE_PATTERN_DOTS_3456                             0x283C
#define unicode_BRAILLE_PATTERN_DOTS_13456                            0x283D
#define unicode_BRAILLE_PATTERN_DOTS_23456                            0x283E
#define unicode_BRAILLE_PATTERN_DOTS_123456                           0x283F
#define unicode_BRAILLE_PATTERN_DOTS_7                                0x2840
#define unicode_BRAILLE_PATTERN_DOTS_17                               0x2841
#define unicode_BRAILLE_PATTERN_DOTS_27                               0x2842
#define unicode_BRAILLE_PATTERN_DOTS_127                              0x2843
#define unicode_BRAILLE_PATTERN_DOTS_37                               0x2844
#define unicode_BRAILLE_PATTERN_DOTS_137                              0x2845
#define unicode_BRAILLE_PATTERN_DOTS_237                              0x2846
#define unicode_BRAILLE_PATTERN_DOTS_1237                             0x2847
#define unicode_BRAILLE_PATTERN_DOTS_47                               0x2848
#define unicode_BRAILLE_PATTERN_DOTS_147                              0x2849
#define unicode_BRAILLE_PATTERN_DOTS_247                              0x284A
#define unicode_BRAILLE_PATTERN_DOTS_1247                             0x284B
#define unicode_BRAILLE_PATTERN_DOTS_347                              0x284C
#define unicode_BRAILLE_PATTERN_DOTS_1347                             0x284D
#define unicode_BRAILLE_PATTERN_DOTS_2347                             0x284E
#define unicode_BRAILLE_PATTERN_DOTS_12347                            0x284F
#define unicode_BRAILLE_PATTERN_DOTS_57                               0x2850
#define unicode_BRAILLE_PATTERN_DOTS_157                              0x2851
#define unicode_BRAILLE_PATTERN_DOTS_257                              0x2852
#define unicode_BRAILLE_PATTERN_DOTS_1257                             0x2853
#define unicode_BRAILLE_PATTERN_DOTS_357                              0x2854
#define unicode_BRAILLE_PATTERN_DOTS_1357                             0x2855
#define unicode_BRAILLE_PATTERN_DOTS_2357                             0x2856
#define unicode_BRAILLE_PATTERN_DOTS_12357                            0x2857
#define unicode_BRAILLE_PATTERN_DOTS_457                              0x2858
#define unicode_BRAILLE_PATTERN_DOTS_1457                             0x2859
#define unicode_BRAILLE_PATTERN_DOTS_2457                             0x285A
#define unicode_BRAILLE_PATTERN_DOTS_12457                            0x285B
#define unicode_BRAILLE_PATTERN_DOTS_3457                             0x285C
#define unicode_BRAILLE_PATTERN_DOTS_13457                            0x285D
#define unicode_BRAILLE_PATTERN_DOTS_23457                            0x285E
#define unicode_BRAILLE_PATTERN_DOTS_123457                           0x285F
#define unicode_BRAILLE_PATTERN_DOTS_67                               0x2860
#define unicode_BRAILLE_PATTERN_DOTS_167                              0x2861
#define unicode_BRAILLE_PATTERN_DOTS_267                              0x2862
#define unicode_BRAILLE_PATTERN_DOTS_1267                             0x2863
#define unicode_BRAILLE_PATTERN_DOTS_367                              0x2864
#define unicode_BRAILLE_PATTERN_DOTS_1367                             0x2865
#define unicode_BRAILLE_PATTERN_DOTS_2367                             0x2866
#define unicode_BRAILLE_PATTERN_DOTS_12367                            0x2867
#define unicode_BRAILLE_PATTERN_DOTS_467                              0x2868
#define unicode_BRAILLE_PATTERN_DOTS_1467                             0x2869
#define unicode_BRAILLE_PATTERN_DOTS_2467                             0x286A
#define unicode_BRAILLE_PATTERN_DOTS_12467                            0x286B
#define unicode_BRAILLE_PATTERN_DOTS_3467                             0x286C
#define unicode_BRAILLE_PATTERN_DOTS_13467                            0x286D
#define unicode_BRAILLE_PATTERN_DOTS_23467                            0x286E
#define unicode_BRAILLE_PATTERN_DOTS_123467                           0x286F
#define unicode_BRAILLE_PATTERN_DOTS_567                              0x2870
#define unicode_BRAILLE_PATTERN_DOTS_1567                             0x2871
#define unicode_BRAILLE_PATTERN_DOTS_2567                             0x2872
#define unicode_BRAILLE_PATTERN_DOTS_12567                            0x2873
#define unicode_BRAILLE_PATTERN_DOTS_3567                             0x2874
#define unicode_BRAILLE_PATTERN_DOTS_13567                            0x2875
#define unicode_BRAILLE_PATTERN_DOTS_23567                            0x2876
#define unicode_BRAILLE_PATTERN_DOTS_123567                           0x2877
#define unicode_BRAILLE_PATTERN_DOTS_4567                             0x2878
#define unicode_BRAILLE_PATTERN_DOTS_14567                            0x2879
#define unicode_BRAILLE_PATTERN_DOTS_24567                            0x287A
#define unicode_BRAILLE_PATTERN_DOTS_124567                           0x287B
#define unicode_BRAILLE_PATTERN_DOTS_34567                            0x287C
#define unicode_BRAILLE_PATTERN_DOTS_134567                           0x287D
#define unicode_BRAILLE_PATTERN_DOTS_234567                           0x287E
#define unicode_BRAILLE_PATTERN_DOTS_1234567                          0x287F
#define unicode_BRAILLE_PATTERN_DOTS_8                                0x2880
#define unicode_BRAILLE_PATTERN_DOTS_18                               0x2881
#define unicode_BRAILLE_PATTERN_DOTS_28                               0x2882
#define unicode_BRAILLE_PATTERN_DOTS_128                              0x2883
#define unicode_BRAILLE_PATTERN_DOTS_38                               0x2884
#define unicode_BRAILLE_PATTERN_DOTS_138                              0x2885
#define unicode_BRAILLE_PATTERN_DOTS_238                              0x2886
#define unicode_BRAILLE_PATTERN_DOTS_1238                             0x2887
#define unicode_BRAILLE_PATTERN_DOTS_48                               0x2888
#define unicode_BRAILLE_PATTERN_DOTS_148                              0x2889
#define unicode_BRAILLE_PATTERN_DOTS_248                              0x288A
#define unicode_BRAILLE_PATTERN_DOTS_1248                             0x288B
#define unicode_BRAILLE_PATTERN_DOTS_348                              0x288C
#define unicode_BRAILLE_PATTERN_DOTS_1348                             0x288D
#define unicode_BRAILLE_PATTERN_DOTS_2348                             0x288E
#define unicode_BRAILLE_PATTERN_DOTS_12348                            0x288F
#define unicode_BRAILLE_PATTERN_DOTS_58                               0x2890
#define unicode_BRAILLE_PATTERN_DOTS_158                              0x2891
#define unicode_BRAILLE_PATTERN_DOTS_258                              0x2892
#define unicode_BRAILLE_PATTERN_DOTS_1258                             0x2893
#define unicode_BRAILLE_PATTERN_DOTS_358                              0x2894
#define unicode_BRAILLE_PATTERN_DOTS_1358                             0x2895
#define unicode_BRAILLE_PATTERN_DOTS_2358                             0x2896
#define unicode_BRAILLE_PATTERN_DOTS_12358                            0x2897
#define unicode_BRAILLE_PATTERN_DOTS_458                              0x2898
#define unicode_BRAILLE_PATTERN_DOTS_1458                             0x2899
#define unicode_BRAILLE_PATTERN_DOTS_2458                             0x289A
#define unicode_BRAILLE_PATTERN_DOTS_12458                            0x289B
#define unicode_BRAILLE_PATTERN_DOTS_3458                             0x289C
#define unicode_BRAILLE_PATTERN_DOTS_13458                            0x289D
#define unicode_BRAILLE_PATTERN_DOTS_23458                            0x289E
#define unicode_BRAILLE_PATTERN_DOTS_123458                           0x289F
#define unicode_BRAILLE_PATTERN_DOTS_68                               0x28A0
#define unicode_BRAILLE_PATTERN_DOTS_168                              0x28A1
#define unicode_BRAILLE_PATTERN_DOTS_268                              0x28A2
#define unicode_BRAILLE_PATTERN_DOTS_1268                             0x28A3
#define unicode_BRAILLE_PATTERN_DOTS_368                              0x28A4
#define unicode_BRAILLE_PATTERN_DOTS_1368                             0x28A5
#define unicode_BRAILLE_PATTERN_DOTS_2368                             0x28A6
#define unicode_BRAILLE_PATTERN_DOTS_12368                            0x28A7
#define unicode_BRAILLE_PATTERN_DOTS_468                              0x28A8
#define unicode_BRAILLE_PATTERN_DOTS_1468                             0x28A9
#define unicode_BRAILLE_PATTERN_DOTS_2468                             0x28AA
#define unicode_BRAILLE_PATTERN_DOTS_12468                            0x28AB
#define unicode_BRAILLE_PATTERN_DOTS_3468                             0x28AC
#define unicode_BRAILLE_PATTERN_DOTS_13468                            0x28AD
#define unicode_BRAILLE_PATTERN_DOTS_23468                            0x28AE
#define unicode_BRAILLE_PATTERN_DOTS_123468                           0x28AF
#define unicode_BRAILLE_PATTERN_DOTS_568                              0x28B0
#define unicode_BRAILLE_PATTERN_DOTS_1568                             0x28B1
#define unicode_BRAILLE_PATTERN_DOTS_2568                             0x28B2
#define unicode_BRAILLE_PATTERN_DOTS_12568                            0x28B3
#define unicode_BRAILLE_PATTERN_DOTS_3568                             0x28B4
#define unicode_BRAILLE_PATTERN_DOTS_13568                            0x28B5
#define unicode_BRAILLE_PATTERN_DOTS_23568                            0x28B6
#define unicode_BRAILLE_PATTERN_DOTS_123568                           0x28B7
#define unicode_BRAILLE_PATTERN_DOTS_4568                             0x28B8
#define unicode_BRAILLE_PATTERN_DOTS_14568                            0x28B9
#define unicode_BRAILLE_PATTERN_DOTS_24568                            0x28BA
#define unicode_BRAILLE_PATTERN_DOTS_124568                           0x28BB
#define unicode_BRAILLE_PATTERN_DOTS_34568                            0x28BC
#define unicode_BRAILLE_PATTERN_DOTS_134568                           0x28BD
#define unicode_BRAILLE_PATTERN_DOTS_234568                           0x28BE
#define unicode_BRAILLE_PATTERN_DOTS_1234568                          0x28BF
#define unicode_BRAILLE_PATTERN_DOTS_78                               0x28C0
#define unicode_BRAILLE_PATTERN_DOTS_178                              0x28C1
#define unicode_BRAILLE_PATTERN_DOTS_278                              0x28C2
#define unicode_BRAILLE_PATTERN_DOTS_1278                             0x28C3
#define unicode_BRAILLE_PATTERN_DOTS_378                              0x28C4
#define unicode_BRAILLE_PATTERN_DOTS_1378                             0x28C5
#define unicode_BRAILLE_PATTERN_DOTS_2378                             0x28C6
#define unicode_BRAILLE_PATTERN_DOTS_12378                            0x28C7
#define unicode_BRAILLE_PATTERN_DOTS_478                              0x28C8
#define unicode_BRAILLE_PATTERN_DOTS_1478                             0x28C9
#define unicode_BRAILLE_PATTERN_DOTS_2478                             0x28CA
#define unicode_BRAILLE_PATTERN_DOTS_12478                            0x28CB
#define unicode_BRAILLE_PATTERN_DOTS_3478                             0x28CC
#define unicode_BRAILLE_PATTERN_DOTS_13478                            0x28CD
#define unicode_BRAILLE_PATTERN_DOTS_23478                            0x28CE
#define unicode_BRAILLE_PATTERN_DOTS_123478                           0x28CF
#define unicode_BRAILLE_PATTERN_DOTS_578                              0x28D0
#define unicode_BRAILLE_PATTERN_DOTS_1578                             0x28D1
#define unicode_BRAILLE_PATTERN_DOTS_2578                             0x28D2
#define unicode_BRAILLE_PATTERN_DOTS_12578                            0x28D3
#define unicode_BRAILLE_PATTERN_DOTS_3578                             0x28D4
#define unicode_BRAILLE_PATTERN_DOTS_13578                            0x28D5
#define unicode_BRAILLE_PATTERN_DOTS_23578                            0x28D6
#define unicode_BRAILLE_PATTERN_DOTS_123578                           0x28D7
#define unicode_BRAILLE_PATTERN_DOTS_4578                             0x28D8
#define unicode_BRAILLE_PATTERN_DOTS_14578                            0x28D9
#define unicode_BRAILLE_PATTERN_DOTS_24578                            0x28DA
#define unicode_BRAILLE_PATTERN_DOTS_124578                           0x28DB
#define unicode_BRAILLE_PATTERN_DOTS_34578                            0x28DC
#define unicode_BRAILLE_PATTERN_DOTS_134578                           0x28DD
#define unicode_BRAILLE_PATTERN_DOTS_234578                           0x28DE
#define unicode_BRAILLE_PATTERN_DOTS_1234578                          0x28DF
#define unicode_BRAILLE_PATTERN_DOTS_678                              0x28E0
#define unicode_BRAILLE_PATTERN_DOTS_1678                             0x28E1
#define unicode_BRAILLE_PATTERN_DOTS_2678                             0x28E2
#define unicode_BRAILLE_PATTERN_DOTS_12678                            0x28E3
#define unicode_BRAILLE_PATTERN_DOTS_3678                             0x28E4
#define unicode_BRAILLE_PATTERN_DOTS_13678                            0x28E5
#define unicode_BRAILLE_PATTERN_DOTS_23678                            0x28E6
#define unicode_BRAILLE_PATTERN_DOTS_123678                           0x28E7
#define unicode_BRAILLE_PATTERN_DOTS_4678                             0x28E8
#define unicode_BRAILLE_PATTERN_DOTS_14678                            0x28E9
#define unicode_BRAILLE_PATTERN_DOTS_24678                            0x28EA
#define unicode_BRAILLE_PATTERN_DOTS_124678                           0x28EB
#define unicode_BRAILLE_PATTERN_DOTS_34678                            0x28EC
#define unicode_BRAILLE_PATTERN_DOTS_134678                           0x28ED
#define unicode_BRAILLE_PATTERN_DOTS_234678                           0x28EE
#define unicode_BRAILLE_PATTERN_DOTS_1234678                          0x28EF
#define unicode_BRAILLE_PATTERN_DOTS_5678                             0x28F0
#define unicode_BRAILLE_PATTERN_DOTS_15678                            0x28F1
#define unicode_BRAILLE_PATTERN_DOTS_25678                            0x28F2
#define unicode_BRAILLE_PATTERN_DOTS_125678                           0x28F3
#define unicode_BRAILLE_PATTERN_DOTS_35678                            0x28F4
#define unicode_BRAILLE_PATTERN_DOTS_135678                           0x28F5
#define unicode_BRAILLE_PATTERN_DOTS_235678                           0x28F6
#define unicode_BRAILLE_PATTERN_DOTS_1235678                          0x28F7
#define unicode_BRAILLE_PATTERN_DOTS_45678                            0x28F8
#define unicode_BRAILLE_PATTERN_DOTS_145678                           0x28F9
#define unicode_BRAILLE_PATTERN_DOTS_245678                           0x28FA
#define unicode_BRAILLE_PATTERN_DOTS_1245678                          0x28FB
#define unicode_BRAILLE_PATTERN_DOTS_345678                           0x28FC
#define unicode_BRAILLE_PATTERN_DOTS_1345678                          0x28FD
#define unicode_BRAILLE_PATTERN_DOTS_2345678                          0x28FE
#define unicode_BRAILLE_PATTERN_DOTS_12345678                         0x28FF
#define unicode_RIGHTWARDS_TWO_HEADED_ARROW_WITH_VERTICAL_STROKE      0x2900
#define unicode_RIGHTWARDS_TWO_HEADED_ARROW_WITH_DOUBLE_VERTICAL_STROKE 0x2901
#define unicode_LEFTWARDS_DOUBLE_ARROW_WITH_VERTICAL_STROKE           0x2902
#define unicode_RIGHTWARDS_DOUBLE_ARROW_WITH_VERTICAL_STROKE          0x2903
#define unicode_LEFT_RIGHT_DOUBLE_ARROW_WITH_VERTICAL_STROKE          0x2904
#define unicode_RIGHTWARDS_TWO_HEADED_ARROW_FROM_BAR                  0x2905
#define unicode_LEFTWARDS_DOUBLE_ARROW_FROM_BAR                       0x2906
#define unicode_RIGHTWARDS_DOUBLE_ARROW_FROM_BAR                      0x2907
#define unicode_DOWNWARDS_ARROW_WITH_HORIZONTAL_STROKE                0x2908
#define unicode_UPWARDS_ARROW_WITH_HORIZONTAL_STROKE                  0x2909
#define unicode_UPWARDS_TRIPLE_ARROW                                  0x290A
#define unicode_DOWNWARDS_TRIPLE_ARROW                                0x290B
#define unicode_LEFTWARDS_DOUBLE_DASH_ARROW                           0x290C
#define unicode_RIGHTWARDS_DOUBLE_DASH_ARROW                          0x290D
#define unicode_LEFTWARDS_TRIPLE_DASH_ARROW                           0x290E
#define unicode_RIGHTWARDS_TRIPLE_DASH_ARROW                          0x290F
#define unicode_RIGHTWARDS_TWO_HEADED_TRIPLE_DASH_ARROW               0x2910
#define unicode_RIGHTWARDS_ARROW_WITH_DOTTED_STEM                     0x2911
#define unicode_UPWARDS_ARROW_TO_BAR                                  0x2912
#define unicode_DOWNWARDS_ARROW_TO_BAR                                0x2913
#define unicode_RIGHTWARDS_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE       0x2914
#define unicode_RIGHTWARDS_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE 0x2915
#define unicode_RIGHTWARDS_TWO_HEADED_ARROW_WITH_TAIL                 0x2916
#define unicode_RIGHTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE 0x2917
#define unicode_RIGHTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE 0x2918
#define unicode_LEFTWARDS_ARROW_TAIL                                  0x2919
#define unicode_RIGHTWARDS_ARROW_TAIL                                 0x291A
#define unicode_LEFTWARDS_DOUBLE_ARROW_TAIL                           0x291B
#define unicode_RIGHTWARDS_DOUBLE_ARROW_TAIL                          0x291C
#define unicode_LEFTWARDS_ARROW_TO_BLACK_DIAMOND                      0x291D
#define unicode_RIGHTWARDS_ARROW_TO_BLACK_DIAMOND                     0x291E
#define unicode_LEFTWARDS_ARROW_FROM_BAR_TO_BLACK_DIAMOND             0x291F
#define unicode_RIGHTWARDS_ARROW_FROM_BAR_TO_BLACK_DIAMOND            0x2920
#define unicode_NORTH_WEST_AND_SOUTH_EAST_ARROW                       0x2921
#define unicode_NORTH_EAST_AND_SOUTH_WEST_ARROW                       0x2922
#define unicode_NORTH_WEST_ARROW_WITH_HOOK                            0x2923
#define unicode_NORTH_EAST_ARROW_WITH_HOOK                            0x2924
#define unicode_SOUTH_EAST_ARROW_WITH_HOOK                            0x2925
#define unicode_SOUTH_WEST_ARROW_WITH_HOOK                            0x2926
#define unicode_NORTH_WEST_ARROW_AND_NORTH_EAST_ARROW                 0x2927
#define unicode_NORTH_EAST_ARROW_AND_SOUTH_EAST_ARROW                 0x2928
#define unicode_SOUTH_EAST_ARROW_AND_SOUTH_WEST_ARROW                 0x2929
#define unicode_SOUTH_WEST_ARROW_AND_NORTH_WEST_ARROW                 0x292A
#define unicode_RISING_DIAGONAL_CROSSING_FALLING_DIAGONAL             0x292B
#define unicode_FALLING_DIAGONAL_CROSSING_RISING_DIAGONAL             0x292C
#define unicode_SOUTH_EAST_ARROW_CROSSING_NORTH_EAST_ARROW            0x292D
#define unicode_NORTH_EAST_ARROW_CROSSING_SOUTH_EAST_ARROW            0x292E
#define unicode_FALLING_DIAGONAL_CROSSING_NORTH_EAST_ARROW            0x292F
#define unicode_RISING_DIAGONAL_CROSSING_SOUTH_EAST_ARROW             0x2930
#define unicode_NORTH_EAST_ARROW_CROSSING_NORTH_WEST_ARROW            0x2931
#define unicode_NORTH_WEST_ARROW_CROSSING_NORTH_EAST_ARROW            0x2932
#define unicode_WAVE_ARROW_POINTING_DIRECTLY_RIGHT                    0x2933
#define unicode_ARROW_POINTING_RIGHTWARDS_THEN_CURVING_UPWARDS        0x2934
#define unicode_ARROW_POINTING_RIGHTWARDS_THEN_CURVING_DOWNWARDS      0x2935
#define unicode_ARROW_POINTING_DOWNWARDS_THEN_CURVING_LEFTWARDS       0x2936
#define unicode_ARROW_POINTING_DOWNWARDS_THEN_CURVING_RIGHTWARDS      0x2937
#define unicode_RIGHT_SIDE_ARC_CLOCKWISE_ARROW                        0x2938
#define unicode_LEFT_SIDE_ARC_ANTICLOCKWISE_ARROW                     0x2939
#define unicode_TOP_ARC_ANTICLOCKWISE_ARROW                           0x293A
#define unicode_BOTTOM_ARC_ANTICLOCKWISE_ARROW                        0x293B
#define unicode_TOP_ARC_CLOCKWISE_ARROW_WITH_MINUS                    0x293C
#define unicode_TOP_ARC_ANTICLOCKWISE_ARROW_WITH_PLUS                 0x293D
#define unicode_LOWER_RIGHT_SEMICIRCULAR_CLOCKWISE_ARROW              0x293E
#define unicode_LOWER_LEFT_SEMICIRCULAR_ANTICLOCKWISE_ARROW           0x293F
#define unicode_ANTICLOCKWISE_CLOSED_CIRCLE_ARROW                     0x2940
#define unicode_CLOCKWISE_CLOSED_CIRCLE_ARROW                         0x2941
#define unicode_RIGHTWARDS_ARROW_ABOVE_SHORT_LEFTWARDS_ARROW          0x2942
#define unicode_LEFTWARDS_ARROW_ABOVE_SHORT_RIGHTWARDS_ARROW          0x2943
#define unicode_SHORT_RIGHTWARDS_ARROW_ABOVE_LEFTWARDS_ARROW          0x2944
#define unicode_RIGHTWARDS_ARROW_WITH_PLUS_BELOW                      0x2945
#define unicode_LEFTWARDS_ARROW_WITH_PLUS_BELOW                       0x2946
#define unicode_RIGHTWARDS_ARROW_THROUGH_X                            0x2947
#define unicode_LEFT_RIGHT_ARROW_THROUGH_SMALL_CIRCLE                 0x2948
#define unicode_UPWARDS_TWO_HEADED_ARROW_FROM_SMALL_CIRCLE            0x2949
#define unicode_LEFT_BARB_UP_RIGHT_BARB_DOWN_HARPOON                  0x294A
#define unicode_LEFT_BARB_DOWN_RIGHT_BARB_UP_HARPOON                  0x294B
#define unicode_UP_BARB_RIGHT_DOWN_BARB_LEFT_HARPOON                  0x294C
#define unicode_UP_BARB_LEFT_DOWN_BARB_RIGHT_HARPOON                  0x294D
#define unicode_LEFT_BARB_UP_RIGHT_BARB_UP_HARPOON                    0x294E
#define unicode_UP_BARB_RIGHT_DOWN_BARB_RIGHT_HARPOON                 0x294F
#define unicode_LEFT_BARB_DOWN_RIGHT_BARB_DOWN_HARPOON                0x2950
#define unicode_UP_BARB_LEFT_DOWN_BARB_LEFT_HARPOON                   0x2951
#define unicode_LEFTWARDS_HARPOON_WITH_BARB_UP_TO_BAR                 0x2952
#define unicode_RIGHTWARDS_HARPOON_WITH_BARB_UP_TO_BAR                0x2953
#define unicode_UPWARDS_HARPOON_WITH_BARB_RIGHT_TO_BAR                0x2954
#define unicode_DOWNWARDS_HARPOON_WITH_BARB_RIGHT_TO_BAR              0x2955
#define unicode_LEFTWARDS_HARPOON_WITH_BARB_DOWN_TO_BAR               0x2956
#define unicode_RIGHTWARDS_HARPOON_WITH_BARB_DOWN_TO_BAR              0x2957
#define unicode_UPWARDS_HARPOON_WITH_BARB_LEFT_TO_BAR                 0x2958
#define unicode_DOWNWARDS_HARPOON_WITH_BARB_LEFT_TO_BAR               0x2959
#define unicode_LEFTWARDS_HARPOON_WITH_BARB_UP_FROM_BAR               0x295A
#define unicode_RIGHTWARDS_HARPOON_WITH_BARB_UP_FROM_BAR              0x295B
#define unicode_UPWARDS_HARPOON_WITH_BARB_RIGHT_FROM_BAR              0x295C
#define unicode_DOWNWARDS_HARPOON_WITH_BARB_RIGHT_FROM_BAR            0x295D
#define unicode_LEFTWARDS_HARPOON_WITH_BARB_DOWN_FROM_BAR             0x295E
#define unicode_RIGHTWARDS_HARPOON_WITH_BARB_DOWN_FROM_BAR            0x295F
#define unicode_UPWARDS_HARPOON_WITH_BARB_LEFT_FROM_BAR               0x2960
#define unicode_DOWNWARDS_HARPOON_WITH_BARB_LEFT_FROM_BAR             0x2961
#define unicode_LEFTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LEFTWARDS_HARPOON_WITH_BARB_DOWN 0x2962
#define unicode_UPWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_UPWARDS_HARPOON_WITH_BARB_RIGHT 0x2963
#define unicode_RIGHTWARDS_HARPOON_WITH_BARB_UP_ABOVE_RIGHTWARDS_HARPOON_WITH_BARB_DOWN 0x2964
#define unicode_DOWNWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_DOWNWARDS_HARPOON_WITH_BARB_RIGHT 0x2965
#define unicode_LEFTWARDS_HARPOON_WITH_BARB_UP_ABOVE_RIGHTWARDS_HARPOON_WITH_BARB_UP 0x2966
#define unicode_LEFTWARDS_HARPOON_WITH_BARB_DOWN_ABOVE_RIGHTWARDS_HARPOON_WITH_BARB_DOWN 0x2967
#define unicode_RIGHTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LEFTWARDS_HARPOON_WITH_BARB_UP 0x2968
#define unicode_RIGHTWARDS_HARPOON_WITH_BARB_DOWN_ABOVE_LEFTWARDS_HARPOON_WITH_BARB_DOWN 0x2969
#define unicode_LEFTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LONG_DASH        0x296A
#define unicode_LEFTWARDS_HARPOON_WITH_BARB_DOWN_BELOW_LONG_DASH      0x296B
#define unicode_RIGHTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LONG_DASH       0x296C
#define unicode_RIGHTWARDS_HARPOON_WITH_BARB_DOWN_BELOW_LONG_DASH     0x296D
#define unicode_UPWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_DOWNWARDS_HARPOON_WITH_BARB_RIGHT 0x296E
#define unicode_DOWNWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_UPWARDS_HARPOON_WITH_BARB_RIGHT 0x296F
#define unicode_RIGHT_DOUBLE_ARROW_WITH_ROUNDED_HEAD                  0x2970
#define unicode_EQUALS_SIGN_ABOVE_RIGHTWARDS_ARROW                    0x2971
#define unicode_TILDE_OPERATOR_ABOVE_RIGHTWARDS_ARROW                 0x2972
#define unicode_LEFTWARDS_ARROW_ABOVE_TILDE_OPERATOR                  0x2973
#define unicode_RIGHTWARDS_ARROW_ABOVE_TILDE_OPERATOR                 0x2974
#define unicode_RIGHTWARDS_ARROW_ABOVE_ALMOST_EQUAL_TO                0x2975
#define unicode_LESS_THAN_ABOVE_LEFTWARDS_ARROW                       0x2976
#define unicode_LEFTWARDS_ARROW_THROUGH_LESS_THAN                     0x2977
#define unicode_GREATER_THAN_ABOVE_RIGHTWARDS_ARROW                   0x2978
#define unicode_SUBSET_ABOVE_RIGHTWARDS_ARROW                         0x2979
#define unicode_LEFTWARDS_ARROW_THROUGH_SUBSET                        0x297A
#define unicode_SUPERSET_ABOVE_LEFTWARDS_ARROW                        0x297B
#define unicode_LEFT_FISH_TAIL                                        0x297C
#define unicode_RIGHT_FISH_TAIL                                       0x297D
#define unicode_UP_FISH_TAIL                                          0x297E
#define unicode_DOWN_FISH_TAIL                                        0x297F
#define unicode_TRIPLE_VERTICAL_BAR_DELIMITER                         0x2980
#define unicode_Z_NOTATION_SPOT                                       0x2981
#define unicode_Z_NOTATION_TYPE_COLON                                 0x2982
#define unicode_LEFT_WHITE_CURLY_BRACKET                              0x2983
#define unicode_RIGHT_WHITE_CURLY_BRACKET                             0x2984
#define unicode_LEFT_WHITE_PARENTHESIS                                0x2985
#define unicode_RIGHT_WHITE_PARENTHESIS                               0x2986
#define unicode_Z_NOTATION_LEFT_IMAGE_BRACKET                         0x2987
#define unicode_Z_NOTATION_RIGHT_IMAGE_BRACKET                        0x2988
#define unicode_Z_NOTATION_LEFT_BINDING_BRACKET                       0x2989
#define unicode_Z_NOTATION_RIGHT_BINDING_BRACKET                      0x298A
#define unicode_LEFT_SQUARE_BRACKET_WITH_UNDERBAR                     0x298B
#define unicode_RIGHT_SQUARE_BRACKET_WITH_UNDERBAR                    0x298C
#define unicode_LEFT_SQUARE_BRACKET_WITH_TICK_IN_TOP_CORNER           0x298D
#define unicode_RIGHT_SQUARE_BRACKET_WITH_TICK_IN_BOTTOM_CORNER       0x298E
#define unicode_LEFT_SQUARE_BRACKET_WITH_TICK_IN_BOTTOM_CORNER        0x298F
#define unicode_RIGHT_SQUARE_BRACKET_WITH_TICK_IN_TOP_CORNER          0x2990
#define unicode_LEFT_ANGLE_BRACKET_WITH_DOT                           0x2991
#define unicode_RIGHT_ANGLE_BRACKET_WITH_DOT                          0x2992
#define unicode_LEFT_ARC_LESS_THAN_BRACKET                            0x2993
#define unicode_RIGHT_ARC_GREATER_THAN_BRACKET                        0x2994
#define unicode_DOUBLE_LEFT_ARC_GREATER_THAN_BRACKET                  0x2995
#define unicode_DOUBLE_RIGHT_ARC_LESS_THAN_BRACKET                    0x2996
#define unicode_LEFT_BLACK_TORTOISE_SHELL_BRACKET                     0x2997
#define unicode_RIGHT_BLACK_TORTOISE_SHELL_BRACKET                    0x2998
#define unicode_DOTTED_FENCE                                          0x2999
#define unicode_VERTICAL_ZIGZAG_LINE                                  0x299A
#define unicode_MEASURED_ANGLE_OPENING_LEFT                           0x299B
#define unicode_RIGHT_ANGLE_VARIANT_WITH_SQUARE                       0x299C
#define unicode_MEASURED_RIGHT_ANGLE_WITH_DOT                         0x299D
#define unicode_ANGLE_WITH_S_INSIDE                                   0x299E
#define unicode_ACUTE_ANGLE                                           0x299F
#define unicode_SPHERICAL_ANGLE_OPENING_LEFT                          0x29A0
#define unicode_SPHERICAL_ANGLE_OPENING_UP                            0x29A1
#define unicode_TURNED_ANGLE                                          0x29A2
#define unicode_REVERSED_ANGLE                                        0x29A3
#define unicode_ANGLE_WITH_UNDERBAR                                   0x29A4
#define unicode_REVERSED_ANGLE_WITH_UNDERBAR                          0x29A5
#define unicode_OBLIQUE_ANGLE_OPENING_UP                              0x29A6
#define unicode_OBLIQUE_ANGLE_OPENING_DOWN                            0x29A7
#define unicode_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_UP_AND_RIGHT 0x29A8
#define unicode_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_UP_AND_LEFT 0x29A9
#define unicode_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_DOWN_AND_RIGHT 0x29AA
#define unicode_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_DOWN_AND_LEFT 0x29AB
#define unicode_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_RIGHT_AND_UP 0x29AC
#define unicode_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_LEFT_AND_UP 0x29AD
#define unicode_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_RIGHT_AND_DOWN 0x29AE
#define unicode_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_LEFT_AND_DOWN 0x29AF
#define unicode_REVERSED_EMPTY_SET                                    0x29B0
#define unicode_EMPTY_SET_WITH_OVERBAR                                0x29B1
#define unicode_EMPTY_SET_WITH_SMALL_CIRCLE_ABOVE                     0x29B2
#define unicode_EMPTY_SET_WITH_RIGHT_ARROW_ABOVE                      0x29B3
#define unicode_EMPTY_SET_WITH_LEFT_ARROW_ABOVE                       0x29B4
#define unicode_CIRCLE_WITH_HORIZONTAL_BAR                            0x29B5
#define unicode_CIRCLED_VERTICAL_BAR                                  0x29B6
#define unicode_CIRCLED_PARALLEL                                      0x29B7
#define unicode_CIRCLED_REVERSE_SOLIDUS                               0x29B8
#define unicode_CIRCLED_PERPENDICULAR                                 0x29B9
#define unicode_CIRCLE_DIVIDED_BY_HORIZONTAL_BAR_AND_TOP_HALF_DIVIDED_BY_VERTICAL_BAR 0x29BA
#define unicode_CIRCLE_WITH_SUPERIMPOSED_X                            0x29BB
#define unicode_CIRCLED_ANTICLOCKWISE_ROTATED_DIVISION_SIGN           0x29BC
#define unicode_UP_ARROW_THROUGH_CIRCLE                               0x29BD
#define unicode_CIRCLED_WHITE_BULLET                                  0x29BE
#define unicode_CIRCLED_BULLET                                        0x29BF
#define unicode_CIRCLED_LESS_THAN                                     0x29C0
#define unicode_CIRCLED_GREATER_THAN                                  0x29C1
#define unicode_CIRCLE_WITH_SMALL_CIRCLE_TO_THE_RIGHT                 0x29C2
#define unicode_CIRCLE_WITH_TWO_HORIZONTAL_STROKES_TO_THE_RIGHT       0x29C3
#define unicode_SQUARED_RISING_DIAGONAL_SLASH                         0x29C4
#define unicode_SQUARED_FALLING_DIAGONAL_SLASH                        0x29C5
#define unicode_SQUARED_ASTERISK                                      0x29C6
#define unicode_SQUARED_SMALL_CIRCLE                                  0x29C7
#define unicode_SQUARED_SQUARE                                        0x29C8
#define unicode_TWO_JOINED_SQUARES                                    0x29C9
#define unicode_TRIANGLE_WITH_DOT_ABOVE                               0x29CA
#define unicode_TRIANGLE_WITH_UNDERBAR                                0x29CB
#define unicode_S_IN_TRIANGLE                                         0x29CC
#define unicode_TRIANGLE_WITH_SERIFS_AT_BOTTOM                        0x29CD
#define unicode_RIGHT_TRIANGLE_ABOVE_LEFT_TRIANGLE                    0x29CE
#define unicode_LEFT_TRIANGLE_BESIDE_VERTICAL_BAR                     0x29CF
#define unicode_VERTICAL_BAR_BESIDE_RIGHT_TRIANGLE                    0x29D0
#define unicode_BOWTIE_WITH_LEFT_HALF_BLACK                           0x29D1
#define unicode_BOWTIE_WITH_RIGHT_HALF_BLACK                          0x29D2
#define unicode_BLACK_BOWTIE                                          0x29D3
#define unicode_TIMES_WITH_LEFT_HALF_BLACK                            0x29D4
#define unicode_TIMES_WITH_RIGHT_HALF_BLACK                           0x29D5
#define unicode_WHITE_HOURGLASS                                       0x29D6
#define unicode_BLACK_HOURGLASS                                       0x29D7
#define unicode_LEFT_WIGGLY_FENCE                                     0x29D8
#define unicode_RIGHT_WIGGLY_FENCE                                    0x29D9
#define unicode_LEFT_DOUBLE_WIGGLY_FENCE                              0x29DA
#define unicode_RIGHT_DOUBLE_WIGGLY_FENCE                             0x29DB
#define unicode_INCOMPLETE_INFINITY                                   0x29DC
#define unicode_TIE_OVER_INFINITY                                     0x29DD
#define unicode_INFINITY_NEGATED_WITH_VERTICAL_BAR                    0x29DE
#define unicode_DOUBLE_ENDED_MULTIMAP                                 0x29DF
#define unicode_SQUARE_WITH_CONTOURED_OUTLINE                         0x29E0
#define unicode_INCREASES_AS                                          0x29E1
#define unicode_SHUFFLE_PRODUCT                                       0x29E2
#define unicode_EQUALS_SIGN_AND_SLANTED_PARALLEL                      0x29E3
#define unicode_EQUALS_SIGN_AND_SLANTED_PARALLEL_WITH_TILDE_ABOVE     0x29E4
#define unicode_IDENTICAL_TO_AND_SLANTED_PARALLEL                     0x29E5
#define unicode_GLEICH_STARK                                          0x29E6
#define unicode_THERMODYNAMIC                                         0x29E7
#define unicode_DOWN_POINTING_TRIANGLE_WITH_LEFT_HALF_BLACK           0x29E8
#define unicode_DOWN_POINTING_TRIANGLE_WITH_RIGHT_HALF_BLACK          0x29E9
#define unicode_BLACK_DIAMOND_WITH_DOWN_ARROW                         0x29EA
#define unicode_BLACK_LOZENGE                                         0x29EB
#define unicode_WHITE_CIRCLE_WITH_DOWN_ARROW                          0x29EC
#define unicode_BLACK_CIRCLE_WITH_DOWN_ARROW                          0x29ED
#define unicode_ERROR_BARRED_WHITE_SQUARE                             0x29EE
#define unicode_ERROR_BARRED_BLACK_SQUARE                             0x29EF
#define unicode_ERROR_BARRED_WHITE_DIAMOND                            0x29F0
#define unicode_ERROR_BARRED_BLACK_DIAMOND                            0x29F1
#define unicode_ERROR_BARRED_WHITE_CIRCLE                             0x29F2
#define unicode_ERROR_BARRED_BLACK_CIRCLE                             0x29F3
#define unicode_RULE_DELAYED                                          0x29F4
#define unicode_REVERSE_SOLIDUS_OPERATOR                              0x29F5
#define unicode_SOLIDUS_WITH_OVERBAR                                  0x29F6
#define unicode_REVERSE_SOLIDUS_WITH_HORIZONTAL_STROKE                0x29F7
#define unicode_BIG_SOLIDUS                                           0x29F8
#define unicode_BIG_REVERSE_SOLIDUS                                   0x29F9
#define unicode_DOUBLE_PLUS                                           0x29FA
#define unicode_TRIPLE_PLUS                                           0x29FB
#define unicode_LEFT_POINTING_CURVED_ANGLE_BRACKET                    0x29FC
#define unicode_RIGHT_POINTING_CURVED_ANGLE_BRACKET                   0x29FD
#define unicode_TINY                                                  0x29FE
#define unicode_MINY                                                  0x29FF
#define unicode_N_ARY_CIRCLED_DOT_OPERATOR                            0x2A00
#define unicode_N_ARY_CIRCLED_PLUS_OPERATOR                           0x2A01
#define unicode_N_ARY_CIRCLED_TIMES_OPERATOR                          0x2A02
#define unicode_N_ARY_UNION_OPERATOR_WITH_DOT                         0x2A03
#define unicode_N_ARY_UNION_OPERATOR_WITH_PLUS                        0x2A04
#define unicode_N_ARY_SQUARE_INTERSECTION_OPERATOR                    0x2A05
#define unicode_N_ARY_SQUARE_UNION_OPERATOR                           0x2A06
#define unicode_TWO_LOGICAL_AND_OPERATOR                              0x2A07
#define unicode_TWO_LOGICAL_OR_OPERATOR                               0x2A08
#define unicode_N_ARY_TIMES_OPERATOR                                  0x2A09
#define unicode_MODULO_TWO_SUM                                        0x2A0A
#define unicode_SUMMATION_WITH_INTEGRAL                               0x2A0B
#define unicode_QUADRUPLE_INTEGRAL_OPERATOR                           0x2A0C
#define unicode_FINITE_PART_INTEGRAL                                  0x2A0D
#define unicode_INTEGRAL_WITH_DOUBLE_STROKE                           0x2A0E
#define unicode_INTEGRAL_AVERAGE_WITH_SLASH                           0x2A0F
#define unicode_CIRCULATION_FUNCTION                                  0x2A10
#define unicode_ANTICLOCKWISE_INTEGRATION                             0x2A11
#define unicode_LINE_INTEGRATION_WITH_RECTANGULAR_PATH_AROUND_POLE    0x2A12
#define unicode_LINE_INTEGRATION_WITH_SEMICIRCULAR_PATH_AROUND_POLE   0x2A13
#define unicode_LINE_INTEGRATION_NOT_INCLUDING_THE_POLE               0x2A14
#define unicode_INTEGRAL_AROUND_A_POINT_OPERATOR                      0x2A15
#define unicode_QUATERNION_INTEGRAL_OPERATOR                          0x2A16
#define unicode_INTEGRAL_WITH_LEFTWARDS_ARROW_WITH_HOOK               0x2A17
#define unicode_INTEGRAL_WITH_TIMES_SIGN                              0x2A18
#define unicode_INTEGRAL_WITH_INTERSECTION                            0x2A19
#define unicode_INTEGRAL_WITH_UNION                                   0x2A1A
#define unicode_INTEGRAL_WITH_OVERBAR                                 0x2A1B
#define unicode_INTEGRAL_WITH_UNDERBAR                                0x2A1C
#define unicode_JOIN                                                  0x2A1D
#define unicode_LARGE_LEFT_TRIANGLE_OPERATOR                          0x2A1E
#define unicode_Z_NOTATION_SCHEMA_COMPOSITION                         0x2A1F
#define unicode_Z_NOTATION_SCHEMA_PIPING                              0x2A20
#define unicode_Z_NOTATION_SCHEMA_PROJECTION                          0x2A21
#define unicode_PLUS_SIGN_WITH_SMALL_CIRCLE_ABOVE                     0x2A22
#define unicode_PLUS_SIGN_WITH_CIRCUMFLEX_ACCENT_ABOVE                0x2A23
#define unicode_PLUS_SIGN_WITH_TILDE_ABOVE                            0x2A24
#define unicode_PLUS_SIGN_WITH_DOT_BELOW                              0x2A25
#define unicode_PLUS_SIGN_WITH_TILDE_BELOW                            0x2A26
#define unicode_PLUS_SIGN_WITH_SUBSCRIPT_TWO                          0x2A27
#define unicode_PLUS_SIGN_WITH_BLACK_TRIANGLE                         0x2A28
#define unicode_MINUS_SIGN_WITH_COMMA_ABOVE                           0x2A29
#define unicode_MINUS_SIGN_WITH_DOT_BELOW                             0x2A2A
#define unicode_MINUS_SIGN_WITH_FALLING_DOTS                          0x2A2B
#define unicode_MINUS_SIGN_WITH_RISING_DOTS                           0x2A2C
#define unicode_PLUS_SIGN_IN_LEFT_HALF_CIRCLE                         0x2A2D
#define unicode_PLUS_SIGN_IN_RIGHT_HALF_CIRCLE                        0x2A2E
#define unicode_VECTOR_OR_CROSS_PRODUCT                               0x2A2F
#define unicode_MULTIPLICATION_SIGN_WITH_DOT_ABOVE                    0x2A30
#define unicode_MULTIPLICATION_SIGN_WITH_UNDERBAR                     0x2A31
#define unicode_SEMIDIRECT_PRODUCT_WITH_BOTTOM_CLOSED                 0x2A32
#define unicode_SMASH_PRODUCT                                         0x2A33
#define unicode_MULTIPLICATION_SIGN_IN_LEFT_HALF_CIRCLE               0x2A34
#define unicode_MULTIPLICATION_SIGN_IN_RIGHT_HALF_CIRCLE              0x2A35
#define unicode_CIRCLED_MULTIPLICATION_SIGN_WITH_CIRCUMFLEX_ACCENT    0x2A36
#define unicode_MULTIPLICATION_SIGN_IN_DOUBLE_CIRCLE                  0x2A37
#define unicode_CIRCLED_DIVISION_SIGN                                 0x2A38
#define unicode_PLUS_SIGN_IN_TRIANGLE                                 0x2A39
#define unicode_MINUS_SIGN_IN_TRIANGLE                                0x2A3A
#define unicode_MULTIPLICATION_SIGN_IN_TRIANGLE                       0x2A3B
#define unicode_INTERIOR_PRODUCT                                      0x2A3C
#define unicode_RIGHTHAND_INTERIOR_PRODUCT                            0x2A3D
#define unicode_Z_NOTATION_RELATIONAL_COMPOSITION                     0x2A3E
#define unicode_AMALGAMATION_OR_COPRODUCT                             0x2A3F
#define unicode_INTERSECTION_WITH_DOT                                 0x2A40
#define unicode_UNION_WITH_MINUS_SIGN                                 0x2A41
#define unicode_UNION_WITH_OVERBAR                                    0x2A42
#define unicode_INTERSECTION_WITH_OVERBAR                             0x2A43
#define unicode_INTERSECTION_WITH_LOGICAL_AND                         0x2A44
#define unicode_UNION_WITH_LOGICAL_OR                                 0x2A45
#define unicode_UNION_ABOVE_INTERSECTION                              0x2A46
#define unicode_INTERSECTION_ABOVE_UNION                              0x2A47
#define unicode_UNION_ABOVE_BAR_ABOVE_INTERSECTION                    0x2A48
#define unicode_INTERSECTION_ABOVE_BAR_ABOVE_UNION                    0x2A49
#define unicode_UNION_BESIDE_AND_JOINED_WITH_UNION                    0x2A4A
#define unicode_INTERSECTION_BESIDE_AND_JOINED_WITH_INTERSECTION      0x2A4B
#define unicode_CLOSED_UNION_WITH_SERIFS                              0x2A4C
#define unicode_CLOSED_INTERSECTION_WITH_SERIFS                       0x2A4D
#define unicode_DOUBLE_SQUARE_INTERSECTION                            0x2A4E
#define unicode_DOUBLE_SQUARE_UNION                                   0x2A4F
#define unicode_CLOSED_UNION_WITH_SERIFS_AND_SMASH_PRODUCT            0x2A50
#define unicode_LOGICAL_AND_WITH_DOT_ABOVE                            0x2A51
#define unicode_LOGICAL_OR_WITH_DOT_ABOVE                             0x2A52
#define unicode_DOUBLE_LOGICAL_AND                                    0x2A53
#define unicode_DOUBLE_LOGICAL_OR                                     0x2A54
#define unicode_TWO_INTERSECTING_LOGICAL_AND                          0x2A55
#define unicode_TWO_INTERSECTING_LOGICAL_OR                           0x2A56
#define unicode_SLOPING_LARGE_OR                                      0x2A57
#define unicode_SLOPING_LARGE_AND                                     0x2A58
#define unicode_LOGICAL_OR_OVERLAPPING_LOGICAL_AND                    0x2A59
#define unicode_LOGICAL_AND_WITH_MIDDLE_STEM                          0x2A5A
#define unicode_LOGICAL_OR_WITH_MIDDLE_STEM                           0x2A5B
#define unicode_LOGICAL_AND_WITH_HORIZONTAL_DASH                      0x2A5C
#define unicode_LOGICAL_OR_WITH_HORIZONTAL_DASH                       0x2A5D
#define unicode_LOGICAL_AND_WITH_DOUBLE_OVERBAR                       0x2A5E
#define unicode_LOGICAL_AND_WITH_UNDERBAR                             0x2A5F
#define unicode_LOGICAL_AND_WITH_DOUBLE_UNDERBAR                      0x2A60
#define unicode_SMALL_VEE_WITH_UNDERBAR                               0x2A61
#define unicode_LOGICAL_OR_WITH_DOUBLE_OVERBAR                        0x2A62
#define unicode_LOGICAL_OR_WITH_DOUBLE_UNDERBAR                       0x2A63
#define unicode_Z_NOTATION_DOMAIN_ANTIRESTRICTION                     0x2A64
#define unicode_Z_NOTATION_RANGE_ANTIRESTRICTION                      0x2A65
#define unicode_EQUALS_SIGN_WITH_DOT_BELOW                            0x2A66
#define unicode_IDENTICAL_WITH_DOT_ABOVE                              0x2A67
#define unicode_TRIPLE_HORIZONTAL_BAR_WITH_DOUBLE_VERTICAL_STROKE     0x2A68
#define unicode_TRIPLE_HORIZONTAL_BAR_WITH_TRIPLE_VERTICAL_STROKE     0x2A69
#define unicode_TILDE_OPERATOR_WITH_DOT_ABOVE                         0x2A6A
#define unicode_TILDE_OPERATOR_WITH_RISING_DOTS                       0x2A6B
#define unicode_SIMILAR_MINUS_SIMILAR                                 0x2A6C
#define unicode_CONGRUENT_WITH_DOT_ABOVE                              0x2A6D
#define unicode_EQUALS_WITH_ASTERISK                                  0x2A6E
#define unicode_ALMOST_EQUAL_TO_WITH_CIRCUMFLEX_ACCENT                0x2A6F
#define unicode_APPROXIMATELY_EQUAL_OR_EQUAL_TO                       0x2A70
#define unicode_EQUALS_SIGN_ABOVE_PLUS_SIGN                           0x2A71
#define unicode_PLUS_SIGN_ABOVE_EQUALS_SIGN                           0x2A72
#define unicode_EQUALS_SIGN_ABOVE_TILDE_OPERATOR                      0x2A73
#define unicode_DOUBLE_COLON_EQUAL                                    0x2A74
#define unicode_TWO_CONSECUTIVE_EQUALS_SIGNS                          0x2A75
#define unicode_THREE_CONSECUTIVE_EQUALS_SIGNS                        0x2A76
#define unicode_EQUALS_SIGN_WITH_TWO_DOTS_ABOVE_AND_TWO_DOTS_BELOW    0x2A77
#define unicode_EQUIVALENT_WITH_FOUR_DOTS_ABOVE                       0x2A78
#define unicode_LESS_THAN_WITH_CIRCLE_INSIDE                          0x2A79
#define unicode_GREATER_THAN_WITH_CIRCLE_INSIDE                       0x2A7A
#define unicode_LESS_THAN_WITH_QUESTION_MARK_ABOVE                    0x2A7B
#define unicode_GREATER_THAN_WITH_QUESTION_MARK_ABOVE                 0x2A7C
#define unicode_LESS_THAN_OR_SLANTED_EQUAL_TO                         0x2A7D
#define unicode_GREATER_THAN_OR_SLANTED_EQUAL_TO                      0x2A7E
#define unicode_LESS_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_INSIDE         0x2A7F
#define unicode_GREATER_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_INSIDE      0x2A80
#define unicode_LESS_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE          0x2A81
#define unicode_GREATER_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE       0x2A82
#define unicode_LESS_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE_RIGHT    0x2A83
#define unicode_GREATER_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE_LEFT  0x2A84
#define unicode_LESS_THAN_OR_APPROXIMATE                              0x2A85
#define unicode_GREATER_THAN_OR_APPROXIMATE                           0x2A86
#define unicode_LESS_THAN_AND_SINGLE_LINE_NOT_EQUAL_TO                0x2A87
#define unicode_GREATER_THAN_AND_SINGLE_LINE_NOT_EQUAL_TO             0x2A88
#define unicode_LESS_THAN_AND_NOT_APPROXIMATE                         0x2A89
#define unicode_GREATER_THAN_AND_NOT_APPROXIMATE                      0x2A8A
#define unicode_LESS_THAN_ABOVE_DOUBLE_LINE_EQUAL_ABOVE_GREATER_THAN  0x2A8B
#define unicode_GREATER_THAN_ABOVE_DOUBLE_LINE_EQUAL_ABOVE_LESS_THAN  0x2A8C
#define unicode_LESS_THAN_ABOVE_SIMILAR_OR_EQUAL                      0x2A8D
#define unicode_GREATER_THAN_ABOVE_SIMILAR_OR_EQUAL                   0x2A8E
#define unicode_LESS_THAN_ABOVE_SIMILAR_ABOVE_GREATER_THAN            0x2A8F
#define unicode_GREATER_THAN_ABOVE_SIMILAR_ABOVE_LESS_THAN            0x2A90
#define unicode_LESS_THAN_ABOVE_GREATER_THAN_ABOVE_DOUBLE_LINE_EQUAL  0x2A91
#define unicode_GREATER_THAN_ABOVE_LESS_THAN_ABOVE_DOUBLE_LINE_EQUAL  0x2A92
#define unicode_LESS_THAN_ABOVE_SLANTED_EQUAL_ABOVE_GREATER_THAN_ABOVE_SLANTED_EQUAL 0x2A93
#define unicode_GREATER_THAN_ABOVE_SLANTED_EQUAL_ABOVE_LESS_THAN_ABOVE_SLANTED_EQUAL 0x2A94
#define unicode_SLANTED_EQUAL_TO_OR_LESS_THAN                         0x2A95
#define unicode_SLANTED_EQUAL_TO_OR_GREATER_THAN                      0x2A96
#define unicode_SLANTED_EQUAL_TO_OR_LESS_THAN_WITH_DOT_INSIDE         0x2A97
#define unicode_SLANTED_EQUAL_TO_OR_GREATER_THAN_WITH_DOT_INSIDE      0x2A98
#define unicode_DOUBLE_LINE_EQUAL_TO_OR_LESS_THAN                     0x2A99
#define unicode_DOUBLE_LINE_EQUAL_TO_OR_GREATER_THAN                  0x2A9A
#define unicode_DOUBLE_LINE_SLANTED_EQUAL_TO_OR_LESS_THAN             0x2A9B
#define unicode_DOUBLE_LINE_SLANTED_EQUAL_TO_OR_GREATER_THAN          0x2A9C
#define unicode_SIMILAR_OR_LESS_THAN                                  0x2A9D
#define unicode_SIMILAR_OR_GREATER_THAN                               0x2A9E
#define unicode_SIMILAR_ABOVE_LESS_THAN_ABOVE_EQUALS_SIGN             0x2A9F
#define unicode_SIMILAR_ABOVE_GREATER_THAN_ABOVE_EQUALS_SIGN          0x2AA0
#define unicode_DOUBLE_NESTED_LESS_THAN                               0x2AA1
#define unicode_DOUBLE_NESTED_GREATER_THAN                            0x2AA2
#define unicode_DOUBLE_NESTED_LESS_THAN_WITH_UNDERBAR                 0x2AA3
#define unicode_GREATER_THAN_OVERLAPPING_LESS_THAN                    0x2AA4
#define unicode_GREATER_THAN_BESIDE_LESS_THAN                         0x2AA5
#define unicode_LESS_THAN_CLOSED_BY_CURVE                             0x2AA6
#define unicode_GREATER_THAN_CLOSED_BY_CURVE                          0x2AA7
#define unicode_LESS_THAN_CLOSED_BY_CURVE_ABOVE_SLANTED_EQUAL         0x2AA8
#define unicode_GREATER_THAN_CLOSED_BY_CURVE_ABOVE_SLANTED_EQUAL      0x2AA9
#define unicode_SMALLER_THAN                                          0x2AAA
#define unicode_LARGER_THAN                                           0x2AAB
#define unicode_SMALLER_THAN_OR_EQUAL_TO                              0x2AAC
#define unicode_LARGER_THAN_OR_EQUAL_TO                               0x2AAD
#define unicode_EQUALS_SIGN_WITH_BUMPY_ABOVE                          0x2AAE
#define unicode_PRECEDES_ABOVE_SINGLE_LINE_EQUALS_SIGN                0x2AAF
#define unicode_SUCCEEDS_ABOVE_SINGLE_LINE_EQUALS_SIGN                0x2AB0
#define unicode_PRECEDES_ABOVE_SINGLE_LINE_NOT_EQUAL_TO               0x2AB1
#define unicode_SUCCEEDS_ABOVE_SINGLE_LINE_NOT_EQUAL_TO               0x2AB2
#define unicode_PRECEDES_ABOVE_EQUALS_SIGN                            0x2AB3
#define unicode_SUCCEEDS_ABOVE_EQUALS_SIGN                            0x2AB4
#define unicode_PRECEDES_ABOVE_NOT_EQUAL_TO                           0x2AB5
#define unicode_SUCCEEDS_ABOVE_NOT_EQUAL_TO                           0x2AB6
#define unicode_PRECEDES_ABOVE_ALMOST_EQUAL_TO                        0x2AB7
#define unicode_SUCCEEDS_ABOVE_ALMOST_EQUAL_TO                        0x2AB8
#define unicode_PRECEDES_ABOVE_NOT_ALMOST_EQUAL_TO                    0x2AB9
#define unicode_SUCCEEDS_ABOVE_NOT_ALMOST_EQUAL_TO                    0x2ABA
#define unicode_DOUBLE_PRECEDES                                       0x2ABB
#define unicode_DOUBLE_SUCCEEDS                                       0x2ABC
#define unicode_SUBSET_WITH_DOT                                       0x2ABD
#define unicode_SUPERSET_WITH_DOT                                     0x2ABE
#define unicode_SUBSET_WITH_PLUS_SIGN_BELOW                           0x2ABF
#define unicode_SUPERSET_WITH_PLUS_SIGN_BELOW                         0x2AC0
#define unicode_SUBSET_WITH_MULTIPLICATION_SIGN_BELOW                 0x2AC1
#define unicode_SUPERSET_WITH_MULTIPLICATION_SIGN_BELOW               0x2AC2
#define unicode_SUBSET_OF_OR_EQUAL_TO_WITH_DOT_ABOVE                  0x2AC3
#define unicode_SUPERSET_OF_OR_EQUAL_TO_WITH_DOT_ABOVE                0x2AC4
#define unicode_SUBSET_OF_ABOVE_EQUALS_SIGN                           0x2AC5
#define unicode_SUPERSET_OF_ABOVE_EQUALS_SIGN                         0x2AC6
#define unicode_SUBSET_OF_ABOVE_TILDE_OPERATOR                        0x2AC7
#define unicode_SUPERSET_OF_ABOVE_TILDE_OPERATOR                      0x2AC8
#define unicode_SUBSET_OF_ABOVE_ALMOST_EQUAL_TO                       0x2AC9
#define unicode_SUPERSET_OF_ABOVE_ALMOST_EQUAL_TO                     0x2ACA
#define unicode_SUBSET_OF_ABOVE_NOT_EQUAL_TO                          0x2ACB
#define unicode_SUPERSET_OF_ABOVE_NOT_EQUAL_TO                        0x2ACC
#define unicode_SQUARE_LEFT_OPEN_BOX_OPERATOR                         0x2ACD
#define unicode_SQUARE_RIGHT_OPEN_BOX_OPERATOR                        0x2ACE
#define unicode_CLOSED_SUBSET                                         0x2ACF
#define unicode_CLOSED_SUPERSET                                       0x2AD0
#define unicode_CLOSED_SUBSET_OR_EQUAL_TO                             0x2AD1
#define unicode_CLOSED_SUPERSET_OR_EQUAL_TO                           0x2AD2
#define unicode_SUBSET_ABOVE_SUPERSET                                 0x2AD3
#define unicode_SUPERSET_ABOVE_SUBSET                                 0x2AD4
#define unicode_SUBSET_ABOVE_SUBSET                                   0x2AD5
#define unicode_SUPERSET_ABOVE_SUPERSET                               0x2AD6
#define unicode_SUPERSET_BESIDE_SUBSET                                0x2AD7
#define unicode_SUPERSET_BESIDE_AND_JOINED_BY_DASH_WITH_SUBSET        0x2AD8
#define unicode_ELEMENT_OF_OPENING_DOWNWARDS                          0x2AD9
#define unicode_PITCHFORK_WITH_TEE_TOP                                0x2ADA
#define unicode_TRANSVERSAL_INTERSECTION                              0x2ADB
#define unicode_FORKING                                               0x2ADC
#define unicode_NONFORKING                                            0x2ADD
#define unicode_SHORT_LEFT_TACK                                       0x2ADE
#define unicode_SHORT_DOWN_TACK                                       0x2ADF
#define unicode_SHORT_UP_TACK                                         0x2AE0
#define unicode_PERPENDICULAR_WITH_S                                  0x2AE1
#define unicode_VERTICAL_BAR_TRIPLE_RIGHT_TURNSTILE                   0x2AE2
#define unicode_DOUBLE_VERTICAL_BAR_LEFT_TURNSTILE                    0x2AE3
#define unicode_VERTICAL_BAR_DOUBLE_LEFT_TURNSTILE                    0x2AE4
#define unicode_DOUBLE_VERTICAL_BAR_DOUBLE_LEFT_TURNSTILE             0x2AE5
#define unicode_LONG_DASH_FROM_LEFT_MEMBER_OF_DOUBLE_VERTICAL         0x2AE6
#define unicode_SHORT_DOWN_TACK_WITH_OVERBAR                          0x2AE7
#define unicode_SHORT_UP_TACK_WITH_UNDERBAR                           0x2AE8
#define unicode_SHORT_UP_TACK_ABOVE_SHORT_DOWN_TACK                   0x2AE9
#define unicode_DOUBLE_DOWN_TACK                                      0x2AEA
#define unicode_DOUBLE_UP_TACK                                        0x2AEB
#define unicode_DOUBLE_STROKE_NOT_SIGN                                0x2AEC
#define unicode_REVERSED_DOUBLE_STROKE_NOT_SIGN                       0x2AED
#define unicode_DOES_NOT_DIVIDE_WITH_REVERSED_NEGATION_SLASH          0x2AEE
#define unicode_VERTICAL_LINE_WITH_CIRCLE_ABOVE                       0x2AEF
#define unicode_VERTICAL_LINE_WITH_CIRCLE_BELOW                       0x2AF0
#define unicode_DOWN_TACK_WITH_CIRCLE_BELOW                           0x2AF1
#define unicode_PARALLEL_WITH_HORIZONTAL_STROKE                       0x2AF2
#define unicode_PARALLEL_WITH_TILDE_OPERATOR                          0x2AF3
#define unicode_TRIPLE_VERTICAL_BAR_BINARY_RELATION                   0x2AF4
#define unicode_TRIPLE_VERTICAL_BAR_WITH_HORIZONTAL_STROKE            0x2AF5
#define unicode_TRIPLE_COLON_OPERATOR                                 0x2AF6
#define unicode_TRIPLE_NESTED_LESS_THAN                               0x2AF7
#define unicode_TRIPLE_NESTED_GREATER_THAN                            0x2AF8
#define unicode_DOUBLE_LINE_SLANTED_LESS_THAN_OR_EQUAL_TO             0x2AF9
#define unicode_DOUBLE_LINE_SLANTED_GREATER_THAN_OR_EQUAL_TO          0x2AFA
#define unicode_TRIPLE_SOLIDUS_BINARY_RELATION                        0x2AFB
#define unicode_LARGE_TRIPLE_VERTICAL_BAR_OPERATOR                    0x2AFC
#define unicode_DOUBLE_SOLIDUS_OPERATOR                               0x2AFD
#define unicode_WHITE_VERTICAL_BAR                                    0x2AFE
#define unicode_N_ARY_WHITE_VERTICAL_BAR                              0x2AFF
#define unicode_NORTH_EAST_WHITE_ARROW                                0x2B00
#define unicode_NORTH_WEST_WHITE_ARROW                                0x2B01
#define unicode_SOUTH_EAST_WHITE_ARROW                                0x2B02
#define unicode_SOUTH_WEST_WHITE_ARROW                                0x2B03
#define unicode_LEFT_RIGHT_WHITE_ARROW                                0x2B04
#define unicode_LEFTWARDS_BLACK_ARROW                                 0x2B05
#define unicode_UPWARDS_BLACK_ARROW                                   0x2B06
#define unicode_DOWNWARDS_BLACK_ARROW                                 0x2B07
#define unicode_NORTH_EAST_BLACK_ARROW                                0x2B08
#define unicode_NORTH_WEST_BLACK_ARROW                                0x2B09
#define unicode_SOUTH_EAST_BLACK_ARROW                                0x2B0A
#define unicode_SOUTH_WEST_BLACK_ARROW                                0x2B0B
#define unicode_LEFT_RIGHT_BLACK_ARROW                                0x2B0C
#define unicode_UP_DOWN_BLACK_ARROW                                   0x2B0D
#define unicode_RIGHTWARDS_ARROW_WITH_TIP_DOWNWARDS                   0x2B0E
#define unicode_RIGHTWARDS_ARROW_WITH_TIP_UPWARDS                     0x2B0F
#define unicode_LEFTWARDS_ARROW_WITH_TIP_DOWNWARDS                    0x2B10
#define unicode_LEFTWARDS_ARROW_WITH_TIP_UPWARDS                      0x2B11
#define unicode_SQUARE_WITH_TOP_HALF_BLACK                            0x2B12
#define unicode_SQUARE_WITH_BOTTOM_HALF_BLACK                         0x2B13
#define unicode_SQUARE_WITH_UPPER_RIGHT_DIAGONAL_HALF_BLACK           0x2B14
#define unicode_SQUARE_WITH_LOWER_LEFT_DIAGONAL_HALF_BLACK            0x2B15
#define unicode_DIAMOND_WITH_LEFT_HALF_BLACK                          0x2B16
#define unicode_DIAMOND_WITH_RIGHT_HALF_BLACK                         0x2B17
#define unicode_DIAMOND_WITH_TOP_HALF_BLACK                           0x2B18
#define unicode_DIAMOND_WITH_BOTTOM_HALF_BLACK                        0x2B19
#define unicode_DOTTED_SQUARE                                         0x2B1A
#define unicode_BLACK_LARGE_SQUARE                                    0x2B1B
#define unicode_WHITE_LARGE_SQUARE                                    0x2B1C
#define unicode_BLACK_VERY_SMALL_SQUARE                               0x2B1D
#define unicode_WHITE_VERY_SMALL_SQUARE                               0x2B1E
#define unicode_BLACK_PENTAGON                                        0x2B1F
#define unicode_WHITE_PENTAGON                                        0x2B20
#define unicode_WHITE_HEXAGON                                         0x2B21
#define unicode_BLACK_HEXAGON                                         0x2B22
#define unicode_HORIZONTAL_BLACK_HEXAGON                              0x2B23
#define unicode_BLACK_LARGE_CIRCLE                                    0x2B24
#define unicode_BLACK_MEDIUM_DIAMOND                                  0x2B25
#define unicode_WHITE_MEDIUM_DIAMOND                                  0x2B26
#define unicode_BLACK_MEDIUM_LOZENGE                                  0x2B27
#define unicode_WHITE_MEDIUM_LOZENGE                                  0x2B28
#define unicode_BLACK_SMALL_DIAMOND                                   0x2B29
#define unicode_BLACK_SMALL_LOZENGE                                   0x2B2A
#define unicode_WHITE_SMALL_LOZENGE                                   0x2B2B
#define unicode_BLACK_HORIZONTAL_ELLIPSE                              0x2B2C
#define unicode_WHITE_HORIZONTAL_ELLIPSE                              0x2B2D
#define unicode_BLACK_VERTICAL_ELLIPSE                                0x2B2E
#define unicode_WHITE_VERTICAL_ELLIPSE                                0x2B2F
#define unicode_LEFT_ARROW_WITH_SMALL_CIRCLE                          0x2B30
#define unicode_THREE_LEFTWARDS_ARROWS                                0x2B31
#define unicode_LEFT_ARROW_WITH_CIRCLED_PLUS                          0x2B32
#define unicode_LONG_LEFTWARDS_SQUIGGLE_ARROW                         0x2B33
#define unicode_LEFTWARDS_TWO_HEADED_ARROW_WITH_VERTICAL_STROKE       0x2B34
#define unicode_LEFTWARDS_TWO_HEADED_ARROW_WITH_DOUBLE_VERTICAL_STROKE 0x2B35
#define unicode_LEFTWARDS_TWO_HEADED_ARROW_FROM_BAR                   0x2B36
#define unicode_LEFTWARDS_TWO_HEADED_TRIPLE_DASH_ARROW                0x2B37
#define unicode_LEFTWARDS_ARROW_WITH_DOTTED_STEM                      0x2B38
#define unicode_LEFTWARDS_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE        0x2B39
#define unicode_LEFTWARDS_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE 0x2B3A
#define unicode_LEFTWARDS_TWO_HEADED_ARROW_WITH_TAIL                  0x2B3B
#define unicode_LEFTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE 0x2B3C
#define unicode_LEFTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE 0x2B3D
#define unicode_LEFTWARDS_ARROW_THROUGH_X                             0x2B3E
#define unicode_WAVE_ARROW_POINTING_DIRECTLY_LEFT                     0x2B3F
#define unicode_EQUALS_SIGN_ABOVE_LEFTWARDS_ARROW                     0x2B40
#define unicode_REVERSE_TILDE_OPERATOR_ABOVE_LEFTWARDS_ARROW          0x2B41
#define unicode_LEFTWARDS_ARROW_ABOVE_REVERSE_ALMOST_EQUAL_TO         0x2B42
#define unicode_RIGHTWARDS_ARROW_THROUGH_GREATER_THAN                 0x2B43
#define unicode_RIGHTWARDS_ARROW_THROUGH_SUPERSET                     0x2B44
#define unicode_LEFTWARDS_QUADRUPLE_ARROW                             0x2B45
#define unicode_RIGHTWARDS_QUADRUPLE_ARROW                            0x2B46
#define unicode_REVERSE_TILDE_OPERATOR_ABOVE_RIGHTWARDS_ARROW         0x2B47
#define unicode_RIGHTWARDS_ARROW_ABOVE_REVERSE_ALMOST_EQUAL_TO        0x2B48
#define unicode_TILDE_OPERATOR_ABOVE_LEFTWARDS_ARROW                  0x2B49
#define unicode_LEFTWARDS_ARROW_ABOVE_ALMOST_EQUAL_TO                 0x2B4A
#define unicode_LEFTWARDS_ARROW_ABOVE_REVERSE_TILDE_OPERATOR          0x2B4B
#define unicode_RIGHTWARDS_ARROW_ABOVE_REVERSE_TILDE_OPERATOR         0x2B4C
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ZIGZAG_ARROW                0x2B4D
#define unicode_SHORT_SLANTED_NORTH_ARROW                             0x2B4E
#define unicode_SHORT_BACKSLANTED_SOUTH_ARROW                         0x2B4F
#define unicode_WHITE_MEDIUM_STAR                                     0x2B50
#define unicode_BLACK_SMALL_STAR                                      0x2B51
#define unicode_WHITE_SMALL_STAR                                      0x2B52
#define unicode_BLACK_RIGHT_POINTING_PENTAGON                         0x2B53
#define unicode_WHITE_RIGHT_POINTING_PENTAGON                         0x2B54
#define unicode_HEAVY_LARGE_CIRCLE                                    0x2B55
#define unicode_HEAVY_OVAL_WITH_OVAL_INSIDE                           0x2B56
#define unicode_HEAVY_CIRCLE_WITH_CIRCLE_INSIDE                       0x2B57
#define unicode_HEAVY_CIRCLE                                          0x2B58
#define unicode_HEAVY_CIRCLED_SALTIRE                                 0x2B59
#define unicode_SLANTED_NORTH_ARROW_WITH_HOOKED_HEAD                  0x2B5A
#define unicode_BACKSLANTED_SOUTH_ARROW_WITH_HOOKED_TAIL              0x2B5B
#define unicode_SLANTED_NORTH_ARROW_WITH_HORIZONTAL_TAIL              0x2B5C
#define unicode_BACKSLANTED_SOUTH_ARROW_WITH_HORIZONTAL_TAIL          0x2B5D
#define unicode_BENT_ARROW_POINTING_DOWNWARDS_THEN_NORTH_EAST         0x2B5E
#define unicode_SHORT_BENT_ARROW_POINTING_DOWNWARDS_THEN_NORTH_EAST   0x2B5F
#define unicode_LEFTWARDS_TRIANGLE_HEADED_ARROW                       0x2B60
#define unicode_UPWARDS_TRIANGLE_HEADED_ARROW                         0x2B61
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_ARROW                      0x2B62
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ARROW                       0x2B63
#define unicode_LEFT_RIGHT_TRIANGLE_HEADED_ARROW                      0x2B64
#define unicode_UP_DOWN_TRIANGLE_HEADED_ARROW                         0x2B65
#define unicode_NORTH_WEST_TRIANGLE_HEADED_ARROW                      0x2B66
#define unicode_NORTH_EAST_TRIANGLE_HEADED_ARROW                      0x2B67
#define unicode_SOUTH_EAST_TRIANGLE_HEADED_ARROW                      0x2B68
#define unicode_SOUTH_WEST_TRIANGLE_HEADED_ARROW                      0x2B69
#define unicode_LEFTWARDS_TRIANGLE_HEADED_DASHED_ARROW                0x2B6A
#define unicode_UPWARDS_TRIANGLE_HEADED_DASHED_ARROW                  0x2B6B
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_DASHED_ARROW               0x2B6C
#define unicode_DOWNWARDS_TRIANGLE_HEADED_DASHED_ARROW                0x2B6D
#define unicode_CLOCKWISE_TRIANGLE_HEADED_OPEN_CIRCLE_ARROW           0x2B6E
#define unicode_ANTICLOCKWISE_TRIANGLE_HEADED_OPEN_CIRCLE_ARROW       0x2B6F
#define unicode_LEFTWARDS_TRIANGLE_HEADED_ARROW_TO_BAR                0x2B70
#define unicode_UPWARDS_TRIANGLE_HEADED_ARROW_TO_BAR                  0x2B71
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_ARROW_TO_BAR               0x2B72
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ARROW_TO_BAR                0x2B73
#define unicode_NORTH_WEST_TRIANGLE_HEADED_ARROW_TO_BAR               0x2B76
#define unicode_NORTH_EAST_TRIANGLE_HEADED_ARROW_TO_BAR               0x2B77
#define unicode_SOUTH_EAST_TRIANGLE_HEADED_ARROW_TO_BAR               0x2B78
#define unicode_SOUTH_WEST_TRIANGLE_HEADED_ARROW_TO_BAR               0x2B79
#define unicode_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE 0x2B7A
#define unicode_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE 0x2B7B
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE 0x2B7C
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE 0x2B7D
#define unicode_HORIZONTAL_TAB_KEY                                    0x2B7E
#define unicode_VERTICAL_TAB_KEY                                      0x2B7F
#define unicode_LEFTWARDS_TRIANGLE_HEADED_ARROW_OVER_RIGHTWARDS_TRIANGLE_HEADED_ARROW 0x2B80
#define unicode_UPWARDS_TRIANGLE_HEADED_ARROW_LEFTWARDS_OF_DOWNWARDS_TRIANGLE_HEADED_ARROW 0x2B81
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_ARROW_OVER_LEFTWARDS_TRIANGLE_HEADED_ARROW 0x2B82
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ARROW_LEFTWARDS_OF_UPWARDS_TRIANGLE_HEADED_ARROW 0x2B83
#define unicode_LEFTWARDS_TRIANGLE_HEADED_PAIRED_ARROWS               0x2B84
#define unicode_UPWARDS_TRIANGLE_HEADED_PAIRED_ARROWS                 0x2B85
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_PAIRED_ARROWS              0x2B86
#define unicode_DOWNWARDS_TRIANGLE_HEADED_PAIRED_ARROWS               0x2B87
#define unicode_LEFTWARDS_BLACK_CIRCLED_WHITE_ARROW                   0x2B88
#define unicode_UPWARDS_BLACK_CIRCLED_WHITE_ARROW                     0x2B89
#define unicode_RIGHTWARDS_BLACK_CIRCLED_WHITE_ARROW                  0x2B8A
#define unicode_DOWNWARDS_BLACK_CIRCLED_WHITE_ARROW                   0x2B8B
#define unicode_ANTICLOCKWISE_TRIANGLE_HEADED_RIGHT_U_SHAPED_ARROW    0x2B8C
#define unicode_ANTICLOCKWISE_TRIANGLE_HEADED_BOTTOM_U_SHAPED_ARROW   0x2B8D
#define unicode_ANTICLOCKWISE_TRIANGLE_HEADED_LEFT_U_SHAPED_ARROW     0x2B8E
#define unicode_ANTICLOCKWISE_TRIANGLE_HEADED_TOP_U_SHAPED_ARROW      0x2B8F
#define unicode_RETURN_LEFT                                           0x2B90
#define unicode_RETURN_RIGHT                                          0x2B91
#define unicode_NEWLINE_LEFT                                          0x2B92
#define unicode_NEWLINE_RIGHT                                         0x2B93
#define unicode_FOUR_CORNER_ARROWS_CIRCLING_ANTICLOCKWISE             0x2B94
#define unicode_RIGHTWARDS_BLACK_ARROW                                0x2B95
#define unicode_THREE_D_TOP_LIGHTED_LEFTWARDS_EQUILATERAL_ARROWHEAD   0x2B98
#define unicode_THREE_D_RIGHT_LIGHTED_UPWARDS_EQUILATERAL_ARROWHEAD   0x2B99
#define unicode_THREE_D_TOP_LIGHTED_RIGHTWARDS_EQUILATERAL_ARROWHEAD  0x2B9A
#define unicode_THREE_D_LEFT_LIGHTED_DOWNWARDS_EQUILATERAL_ARROWHEAD  0x2B9B
#define unicode_BLACK_LEFTWARDS_EQUILATERAL_ARROWHEAD                 0x2B9C
#define unicode_BLACK_UPWARDS_EQUILATERAL_ARROWHEAD                   0x2B9D
#define unicode_BLACK_RIGHTWARDS_EQUILATERAL_ARROWHEAD                0x2B9E
#define unicode_BLACK_DOWNWARDS_EQUILATERAL_ARROWHEAD                 0x2B9F
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_LEFTWARDS 0x2BA0
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_RIGHTWARDS 0x2BA1
#define unicode_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_LEFTWARDS 0x2BA2
#define unicode_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_RIGHTWARDS 0x2BA3
#define unicode_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_UPWARDS 0x2BA4
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_UPWARDS 0x2BA5
#define unicode_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_DOWNWARDS 0x2BA6
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_DOWNWARDS 0x2BA7
#define unicode_BLACK_CURVED_DOWNWARDS_AND_LEFTWARDS_ARROW            0x2BA8
#define unicode_BLACK_CURVED_DOWNWARDS_AND_RIGHTWARDS_ARROW           0x2BA9
#define unicode_BLACK_CURVED_UPWARDS_AND_LEFTWARDS_ARROW              0x2BAA
#define unicode_BLACK_CURVED_UPWARDS_AND_RIGHTWARDS_ARROW             0x2BAB
#define unicode_BLACK_CURVED_LEFTWARDS_AND_UPWARDS_ARROW              0x2BAC
#define unicode_BLACK_CURVED_RIGHTWARDS_AND_UPWARDS_ARROW             0x2BAD
#define unicode_BLACK_CURVED_LEFTWARDS_AND_DOWNWARDS_ARROW            0x2BAE
#define unicode_BLACK_CURVED_RIGHTWARDS_AND_DOWNWARDS_ARROW           0x2BAF
#define unicode_RIBBON_ARROW_DOWN_LEFT                                0x2BB0
#define unicode_RIBBON_ARROW_DOWN_RIGHT                               0x2BB1
#define unicode_RIBBON_ARROW_UP_LEFT                                  0x2BB2
#define unicode_RIBBON_ARROW_UP_RIGHT                                 0x2BB3
#define unicode_RIBBON_ARROW_LEFT_UP                                  0x2BB4
#define unicode_RIBBON_ARROW_RIGHT_UP                                 0x2BB5
#define unicode_RIBBON_ARROW_LEFT_DOWN                                0x2BB6
#define unicode_RIBBON_ARROW_RIGHT_DOWN                               0x2BB7
#define unicode_UPWARDS_WHITE_ARROW_FROM_BAR_WITH_HORIZONTAL_BAR      0x2BB8
#define unicode_UP_ARROWHEAD_IN_A_RECTANGLE_BOX                       0x2BB9
#define unicode_BALLOT_BOX_WITH_LIGHT_X                               0x2BBD
#define unicode_CIRCLED_X                                             0x2BBE
#define unicode_CIRCLED_BOLD_X                                        0x2BBF
#define unicode_BLACK_SQUARE_CENTRED                                  0x2BC0
#define unicode_BLACK_DIAMOND_CENTRED                                 0x2BC1
#define unicode_TURNED_BLACK_PENTAGON                                 0x2BC2
#define unicode_HORIZONTAL_BLACK_OCTAGON                              0x2BC3
#define unicode_BLACK_OCTAGON                                         0x2BC4
#define unicode_BLACK_MEDIUM_UP_POINTING_TRIANGLE_CENTRED             0x2BC5
#define unicode_BLACK_MEDIUM_DOWN_POINTING_TRIANGLE_CENTRED           0x2BC6
#define unicode_BLACK_MEDIUM_LEFT_POINTING_TRIANGLE_CENTRED           0x2BC7
#define unicode_BLACK_MEDIUM_RIGHT_POINTING_TRIANGLE_CENTRED          0x2BC8
#define unicode_TOP_HALF_BLACK_CIRCLE                                 0x2BCA
#define unicode_BOTTOM_HALF_BLACK_CIRCLE                              0x2BCB
#define unicode_LIGHT_FOUR_POINTED_BLACK_CUSP                         0x2BCC
#define unicode_ROTATED_LIGHT_FOUR_POINTED_BLACK_CUSP                 0x2BCD
#define unicode_WHITE_FOUR_POINTED_CUSP                               0x2BCE
#define unicode_ROTATED_WHITE_FOUR_POINTED_CUSP                       0x2BCF
#define unicode_SQUARE_POSITION_INDICATOR                             0x2BD0
#define unicode_UNCERTAINTY_SIGN                                      0x2BD1
#define unicode_GLAGOLITIC_CAPITAL_LETTER_AZU                         0x2C00
#define unicode_GLAGOLITIC_CAPITAL_LETTER_BUKY                        0x2C01
#define unicode_GLAGOLITIC_CAPITAL_LETTER_VEDE                        0x2C02
#define unicode_GLAGOLITIC_CAPITAL_LETTER_GLAGOLI                     0x2C03
#define unicode_GLAGOLITIC_CAPITAL_LETTER_DOBRO                       0x2C04
#define unicode_GLAGOLITIC_CAPITAL_LETTER_YESTU                       0x2C05
#define unicode_GLAGOLITIC_CAPITAL_LETTER_ZHIVETE                     0x2C06
#define unicode_GLAGOLITIC_CAPITAL_LETTER_DZELO                       0x2C07
#define unicode_GLAGOLITIC_CAPITAL_LETTER_ZEMLJA                      0x2C08
#define unicode_GLAGOLITIC_CAPITAL_LETTER_IZHE                        0x2C09
#define unicode_GLAGOLITIC_CAPITAL_LETTER_INITIAL_IZHE                0x2C0A
#define unicode_GLAGOLITIC_CAPITAL_LETTER_I                           0x2C0B
#define unicode_GLAGOLITIC_CAPITAL_LETTER_DJERVI                      0x2C0C
#define unicode_GLAGOLITIC_CAPITAL_LETTER_KAKO                        0x2C0D
#define unicode_GLAGOLITIC_CAPITAL_LETTER_LJUDIJE                     0x2C0E
#define unicode_GLAGOLITIC_CAPITAL_LETTER_MYSLITE                     0x2C0F
#define unicode_GLAGOLITIC_CAPITAL_LETTER_NASHI                       0x2C10
#define unicode_GLAGOLITIC_CAPITAL_LETTER_ONU                         0x2C11
#define unicode_GLAGOLITIC_CAPITAL_LETTER_POKOJI                      0x2C12
#define unicode_GLAGOLITIC_CAPITAL_LETTER_RITSI                       0x2C13
#define unicode_GLAGOLITIC_CAPITAL_LETTER_SLOVO                       0x2C14
#define unicode_GLAGOLITIC_CAPITAL_LETTER_TVRIDO                      0x2C15
#define unicode_GLAGOLITIC_CAPITAL_LETTER_UKU                         0x2C16
#define unicode_GLAGOLITIC_CAPITAL_LETTER_FRITU                       0x2C17
#define unicode_GLAGOLITIC_CAPITAL_LETTER_HERU                        0x2C18
#define unicode_GLAGOLITIC_CAPITAL_LETTER_OTU                         0x2C19
#define unicode_GLAGOLITIC_CAPITAL_LETTER_PE                          0x2C1A
#define unicode_GLAGOLITIC_CAPITAL_LETTER_SHTA                        0x2C1B
#define unicode_GLAGOLITIC_CAPITAL_LETTER_TSI                         0x2C1C
#define unicode_GLAGOLITIC_CAPITAL_LETTER_CHRIVI                      0x2C1D
#define unicode_GLAGOLITIC_CAPITAL_LETTER_SHA                         0x2C1E
#define unicode_GLAGOLITIC_CAPITAL_LETTER_YERU                        0x2C1F
#define unicode_GLAGOLITIC_CAPITAL_LETTER_YERI                        0x2C20
#define unicode_GLAGOLITIC_CAPITAL_LETTER_YATI                        0x2C21
#define unicode_GLAGOLITIC_CAPITAL_LETTER_SPIDERY_HA                  0x2C22
#define unicode_GLAGOLITIC_CAPITAL_LETTER_YU                          0x2C23
#define unicode_GLAGOLITIC_CAPITAL_LETTER_SMALL_YUS                   0x2C24
#define unicode_GLAGOLITIC_CAPITAL_LETTER_SMALL_YUS_WITH_TAIL         0x2C25
#define unicode_GLAGOLITIC_CAPITAL_LETTER_YO                          0x2C26
#define unicode_GLAGOLITIC_CAPITAL_LETTER_IOTATED_SMALL_YUS           0x2C27
#define unicode_GLAGOLITIC_CAPITAL_LETTER_BIG_YUS                     0x2C28
#define unicode_GLAGOLITIC_CAPITAL_LETTER_IOTATED_BIG_YUS             0x2C29
#define unicode_GLAGOLITIC_CAPITAL_LETTER_FITA                        0x2C2A
#define unicode_GLAGOLITIC_CAPITAL_LETTER_IZHITSA                     0x2C2B
#define unicode_GLAGOLITIC_CAPITAL_LETTER_SHTAPIC                     0x2C2C
#define unicode_GLAGOLITIC_CAPITAL_LETTER_TROKUTASTI_A                0x2C2D
#define unicode_GLAGOLITIC_CAPITAL_LETTER_LATINATE_MYSLITE            0x2C2E
#define unicode_GLAGOLITIC_SMALL_LETTER_AZU                           0x2C30
#define unicode_GLAGOLITIC_SMALL_LETTER_BUKY                          0x2C31
#define unicode_GLAGOLITIC_SMALL_LETTER_VEDE                          0x2C32
#define unicode_GLAGOLITIC_SMALL_LETTER_GLAGOLI                       0x2C33
#define unicode_GLAGOLITIC_SMALL_LETTER_DOBRO                         0x2C34
#define unicode_GLAGOLITIC_SMALL_LETTER_YESTU                         0x2C35
#define unicode_GLAGOLITIC_SMALL_LETTER_ZHIVETE                       0x2C36
#define unicode_GLAGOLITIC_SMALL_LETTER_DZELO                         0x2C37
#define unicode_GLAGOLITIC_SMALL_LETTER_ZEMLJA                        0x2C38
#define unicode_GLAGOLITIC_SMALL_LETTER_IZHE                          0x2C39
#define unicode_GLAGOLITIC_SMALL_LETTER_INITIAL_IZHE                  0x2C3A
#define unicode_GLAGOLITIC_SMALL_LETTER_I                             0x2C3B
#define unicode_GLAGOLITIC_SMALL_LETTER_DJERVI                        0x2C3C
#define unicode_GLAGOLITIC_SMALL_LETTER_KAKO                          0x2C3D
#define unicode_GLAGOLITIC_SMALL_LETTER_LJUDIJE                       0x2C3E
#define unicode_GLAGOLITIC_SMALL_LETTER_MYSLITE                       0x2C3F
#define unicode_GLAGOLITIC_SMALL_LETTER_NASHI                         0x2C40
#define unicode_GLAGOLITIC_SMALL_LETTER_ONU                           0x2C41
#define unicode_GLAGOLITIC_SMALL_LETTER_POKOJI                        0x2C42
#define unicode_GLAGOLITIC_SMALL_LETTER_RITSI                         0x2C43
#define unicode_GLAGOLITIC_SMALL_LETTER_SLOVO                         0x2C44
#define unicode_GLAGOLITIC_SMALL_LETTER_TVRIDO                        0x2C45
#define unicode_GLAGOLITIC_SMALL_LETTER_UKU                           0x2C46
#define unicode_GLAGOLITIC_SMALL_LETTER_FRITU                         0x2C47
#define unicode_GLAGOLITIC_SMALL_LETTER_HERU                          0x2C48
#define unicode_GLAGOLITIC_SMALL_LETTER_OTU                           0x2C49
#define unicode_GLAGOLITIC_SMALL_LETTER_PE                            0x2C4A
#define unicode_GLAGOLITIC_SMALL_LETTER_SHTA                          0x2C4B
#define unicode_GLAGOLITIC_SMALL_LETTER_TSI                           0x2C4C
#define unicode_GLAGOLITIC_SMALL_LETTER_CHRIVI                        0x2C4D
#define unicode_GLAGOLITIC_SMALL_LETTER_SHA                           0x2C4E
#define unicode_GLAGOLITIC_SMALL_LETTER_YERU                          0x2C4F
#define unicode_GLAGOLITIC_SMALL_LETTER_YERI                          0x2C50
#define unicode_GLAGOLITIC_SMALL_LETTER_YATI                          0x2C51
#define unicode_GLAGOLITIC_SMALL_LETTER_SPIDERY_HA                    0x2C52
#define unicode_GLAGOLITIC_SMALL_LETTER_YU                            0x2C53
#define unicode_GLAGOLITIC_SMALL_LETTER_SMALL_YUS                     0x2C54
#define unicode_GLAGOLITIC_SMALL_LETTER_SMALL_YUS_WITH_TAIL           0x2C55
#define unicode_GLAGOLITIC_SMALL_LETTER_YO                            0x2C56
#define unicode_GLAGOLITIC_SMALL_LETTER_IOTATED_SMALL_YUS             0x2C57
#define unicode_GLAGOLITIC_SMALL_LETTER_BIG_YUS                       0x2C58
#define unicode_GLAGOLITIC_SMALL_LETTER_IOTATED_BIG_YUS               0x2C59
#define unicode_GLAGOLITIC_SMALL_LETTER_FITA                          0x2C5A
#define unicode_GLAGOLITIC_SMALL_LETTER_IZHITSA                       0x2C5B
#define unicode_GLAGOLITIC_SMALL_LETTER_SHTAPIC                       0x2C5C
#define unicode_GLAGOLITIC_SMALL_LETTER_TROKUTASTI_A                  0x2C5D
#define unicode_GLAGOLITIC_SMALL_LETTER_LATINATE_MYSLITE              0x2C5E
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_DOUBLE_BAR                0x2C60
#define unicode_LATIN_SMALL_LETTER_L_WITH_DOUBLE_BAR                  0x2C61
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_MIDDLE_TILDE              0x2C62
#define unicode_LATIN_CAPITAL_LETTER_P_WITH_STROKE                    0x2C63
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_TAIL                      0x2C64
#define unicode_LATIN_SMALL_LETTER_A_WITH_STROKE                      0x2C65
#define unicode_LATIN_SMALL_LETTER_T_WITH_DIAGONAL_STROKE             0x2C66
#define unicode_LATIN_CAPITAL_LETTER_H_WITH_DESCENDER                 0x2C67
#define unicode_LATIN_SMALL_LETTER_H_WITH_DESCENDER                   0x2C68
#define unicode_LATIN_CAPITAL_LETTER_K_WITH_DESCENDER                 0x2C69
#define unicode_LATIN_SMALL_LETTER_K_WITH_DESCENDER                   0x2C6A
#define unicode_LATIN_CAPITAL_LETTER_Z_WITH_DESCENDER                 0x2C6B
#define unicode_LATIN_SMALL_LETTER_Z_WITH_DESCENDER                   0x2C6C
#define unicode_LATIN_CAPITAL_LETTER_ALPHA                            0x2C6D
#define unicode_LATIN_CAPITAL_LETTER_M_WITH_HOOK                      0x2C6E
#define unicode_LATIN_CAPITAL_LETTER_TURNED_A                         0x2C6F
#define unicode_LATIN_CAPITAL_LETTER_TURNED_ALPHA                     0x2C70
#define unicode_LATIN_SMALL_LETTER_V_WITH_RIGHT_HOOK                  0x2C71
#define unicode_LATIN_CAPITAL_LETTER_W_WITH_HOOK                      0x2C72
#define unicode_LATIN_SMALL_LETTER_W_WITH_HOOK                        0x2C73
#define unicode_LATIN_SMALL_LETTER_V_WITH_CURL                        0x2C74
#define unicode_LATIN_CAPITAL_LETTER_HALF_H                           0x2C75
#define unicode_LATIN_SMALL_LETTER_HALF_H                             0x2C76
#define unicode_LATIN_SMALL_LETTER_TAILLESS_PHI                       0x2C77
#define unicode_LATIN_SMALL_LETTER_E_WITH_NOTCH                       0x2C78
#define unicode_LATIN_SMALL_LETTER_TURNED_R_WITH_TAIL                 0x2C79
#define unicode_LATIN_SMALL_LETTER_O_WITH_LOW_RING_INSIDE             0x2C7A
#define unicode_LATIN_LETTER_SMALL_CAPITAL_TURNED_E                   0x2C7B
#define unicode_LATIN_SUBSCRIPT_SMALL_LETTER_J                        0x2C7C
#define unicode_MODIFIER_LETTER_CAPITAL_V                             0x2C7D
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_SWASH_TAIL                0x2C7E
#define unicode_LATIN_CAPITAL_LETTER_Z_WITH_SWASH_TAIL                0x2C7F
#define unicode_COPTIC_CAPITAL_LETTER_ALFA                            0x2C80
#define unicode_COPTIC_SMALL_LETTER_ALFA                              0x2C81
#define unicode_COPTIC_CAPITAL_LETTER_VIDA                            0x2C82
#define unicode_COPTIC_SMALL_LETTER_VIDA                              0x2C83
#define unicode_COPTIC_CAPITAL_LETTER_GAMMA                           0x2C84
#define unicode_COPTIC_SMALL_LETTER_GAMMA                             0x2C85
#define unicode_COPTIC_CAPITAL_LETTER_DALDA                           0x2C86
#define unicode_COPTIC_SMALL_LETTER_DALDA                             0x2C87
#define unicode_COPTIC_CAPITAL_LETTER_EIE                             0x2C88
#define unicode_COPTIC_SMALL_LETTER_EIE                               0x2C89
#define unicode_COPTIC_CAPITAL_LETTER_SOU                             0x2C8A
#define unicode_COPTIC_SMALL_LETTER_SOU                               0x2C8B
#define unicode_COPTIC_CAPITAL_LETTER_ZATA                            0x2C8C
#define unicode_COPTIC_SMALL_LETTER_ZATA                              0x2C8D
#define unicode_COPTIC_CAPITAL_LETTER_HATE                            0x2C8E
#define unicode_COPTIC_SMALL_LETTER_HATE                              0x2C8F
#define unicode_COPTIC_CAPITAL_LETTER_THETHE                          0x2C90
#define unicode_COPTIC_SMALL_LETTER_THETHE                            0x2C91
#define unicode_COPTIC_CAPITAL_LETTER_IAUDA                           0x2C92
#define unicode_COPTIC_SMALL_LETTER_IAUDA                             0x2C93
#define unicode_COPTIC_CAPITAL_LETTER_KAPA                            0x2C94
#define unicode_COPTIC_SMALL_LETTER_KAPA                              0x2C95
#define unicode_COPTIC_CAPITAL_LETTER_LAULA                           0x2C96
#define unicode_COPTIC_SMALL_LETTER_LAULA                             0x2C97
#define unicode_COPTIC_CAPITAL_LETTER_MI                              0x2C98
#define unicode_COPTIC_SMALL_LETTER_MI                                0x2C99
#define unicode_COPTIC_CAPITAL_LETTER_NI                              0x2C9A
#define unicode_COPTIC_SMALL_LETTER_NI                                0x2C9B
#define unicode_COPTIC_CAPITAL_LETTER_KSI                             0x2C9C
#define unicode_COPTIC_SMALL_LETTER_KSI                               0x2C9D
#define unicode_COPTIC_CAPITAL_LETTER_O                               0x2C9E
#define unicode_COPTIC_SMALL_LETTER_O                                 0x2C9F
#define unicode_COPTIC_CAPITAL_LETTER_PI                              0x2CA0
#define unicode_COPTIC_SMALL_LETTER_PI                                0x2CA1
#define unicode_COPTIC_CAPITAL_LETTER_RO                              0x2CA2
#define unicode_COPTIC_SMALL_LETTER_RO                                0x2CA3
#define unicode_COPTIC_CAPITAL_LETTER_SIMA                            0x2CA4
#define unicode_COPTIC_SMALL_LETTER_SIMA                              0x2CA5
#define unicode_COPTIC_CAPITAL_LETTER_TAU                             0x2CA6
#define unicode_COPTIC_SMALL_LETTER_TAU                               0x2CA7
#define unicode_COPTIC_CAPITAL_LETTER_UA                              0x2CA8
#define unicode_COPTIC_SMALL_LETTER_UA                                0x2CA9
#define unicode_COPTIC_CAPITAL_LETTER_FI                              0x2CAA
#define unicode_COPTIC_SMALL_LETTER_FI                                0x2CAB
#define unicode_COPTIC_CAPITAL_LETTER_KHI                             0x2CAC
#define unicode_COPTIC_SMALL_LETTER_KHI                               0x2CAD
#define unicode_COPTIC_CAPITAL_LETTER_PSI                             0x2CAE
#define unicode_COPTIC_SMALL_LETTER_PSI                               0x2CAF
#define unicode_COPTIC_CAPITAL_LETTER_OOU                             0x2CB0
#define unicode_COPTIC_SMALL_LETTER_OOU                               0x2CB1
#define unicode_COPTIC_CAPITAL_LETTER_DIALECT_P_ALEF                  0x2CB2
#define unicode_COPTIC_SMALL_LETTER_DIALECT_P_ALEF                    0x2CB3
#define unicode_COPTIC_CAPITAL_LETTER_OLD_COPTIC_AIN                  0x2CB4
#define unicode_COPTIC_SMALL_LETTER_OLD_COPTIC_AIN                    0x2CB5
#define unicode_COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_EIE               0x2CB6
#define unicode_COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_EIE                 0x2CB7
#define unicode_COPTIC_CAPITAL_LETTER_DIALECT_P_KAPA                  0x2CB8
#define unicode_COPTIC_SMALL_LETTER_DIALECT_P_KAPA                    0x2CB9
#define unicode_COPTIC_CAPITAL_LETTER_DIALECT_P_NI                    0x2CBA
#define unicode_COPTIC_SMALL_LETTER_DIALECT_P_NI                      0x2CBB
#define unicode_COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_NI                0x2CBC
#define unicode_COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_NI                  0x2CBD
#define unicode_COPTIC_CAPITAL_LETTER_OLD_COPTIC_OOU                  0x2CBE
#define unicode_COPTIC_SMALL_LETTER_OLD_COPTIC_OOU                    0x2CBF
#define unicode_COPTIC_CAPITAL_LETTER_SAMPI                           0x2CC0
#define unicode_COPTIC_SMALL_LETTER_SAMPI                             0x2CC1
#define unicode_COPTIC_CAPITAL_LETTER_CROSSED_SHEI                    0x2CC2
#define unicode_COPTIC_SMALL_LETTER_CROSSED_SHEI                      0x2CC3
#define unicode_COPTIC_CAPITAL_LETTER_OLD_COPTIC_SHEI                 0x2CC4
#define unicode_COPTIC_SMALL_LETTER_OLD_COPTIC_SHEI                   0x2CC5
#define unicode_COPTIC_CAPITAL_LETTER_OLD_COPTIC_ESH                  0x2CC6
#define unicode_COPTIC_SMALL_LETTER_OLD_COPTIC_ESH                    0x2CC7
#define unicode_COPTIC_CAPITAL_LETTER_AKHMIMIC_KHEI                   0x2CC8
#define unicode_COPTIC_SMALL_LETTER_AKHMIMIC_KHEI                     0x2CC9
#define unicode_COPTIC_CAPITAL_LETTER_DIALECT_P_HORI                  0x2CCA
#define unicode_COPTIC_SMALL_LETTER_DIALECT_P_HORI                    0x2CCB
#define unicode_COPTIC_CAPITAL_LETTER_OLD_COPTIC_HORI                 0x2CCC
#define unicode_COPTIC_SMALL_LETTER_OLD_COPTIC_HORI                   0x2CCD
#define unicode_COPTIC_CAPITAL_LETTER_OLD_COPTIC_HA                   0x2CCE
#define unicode_COPTIC_SMALL_LETTER_OLD_COPTIC_HA                     0x2CCF
#define unicode_COPTIC_CAPITAL_LETTER_L_SHAPED_HA                     0x2CD0
#define unicode_COPTIC_SMALL_LETTER_L_SHAPED_HA                       0x2CD1
#define unicode_COPTIC_CAPITAL_LETTER_OLD_COPTIC_HEI                  0x2CD2
#define unicode_COPTIC_SMALL_LETTER_OLD_COPTIC_HEI                    0x2CD3
#define unicode_COPTIC_CAPITAL_LETTER_OLD_COPTIC_HAT                  0x2CD4
#define unicode_COPTIC_SMALL_LETTER_OLD_COPTIC_HAT                    0x2CD5
#define unicode_COPTIC_CAPITAL_LETTER_OLD_COPTIC_GANGIA               0x2CD6
#define unicode_COPTIC_SMALL_LETTER_OLD_COPTIC_GANGIA                 0x2CD7
#define unicode_COPTIC_CAPITAL_LETTER_OLD_COPTIC_DJA                  0x2CD8
#define unicode_COPTIC_SMALL_LETTER_OLD_COPTIC_DJA                    0x2CD9
#define unicode_COPTIC_CAPITAL_LETTER_OLD_COPTIC_SHIMA                0x2CDA
#define unicode_COPTIC_SMALL_LETTER_OLD_COPTIC_SHIMA                  0x2CDB
#define unicode_COPTIC_CAPITAL_LETTER_OLD_NUBIAN_SHIMA                0x2CDC
#define unicode_COPTIC_SMALL_LETTER_OLD_NUBIAN_SHIMA                  0x2CDD
#define unicode_COPTIC_CAPITAL_LETTER_OLD_NUBIAN_NGI                  0x2CDE
#define unicode_COPTIC_SMALL_LETTER_OLD_NUBIAN_NGI                    0x2CDF
#define unicode_COPTIC_CAPITAL_LETTER_OLD_NUBIAN_NYI                  0x2CE0
#define unicode_COPTIC_SMALL_LETTER_OLD_NUBIAN_NYI                    0x2CE1
#define unicode_COPTIC_CAPITAL_LETTER_OLD_NUBIAN_WAU                  0x2CE2
#define unicode_COPTIC_SMALL_LETTER_OLD_NUBIAN_WAU                    0x2CE3
#define unicode_COPTIC_SYMBOL_KAI                                     0x2CE4
#define unicode_COPTIC_SYMBOL_MI_RO                                   0x2CE5
#define unicode_COPTIC_SYMBOL_PI_RO                                   0x2CE6
#define unicode_COPTIC_SYMBOL_STAUROS                                 0x2CE7
#define unicode_COPTIC_SYMBOL_TAU_RO                                  0x2CE8
#define unicode_COPTIC_SYMBOL_KHI_RO                                  0x2CE9
#define unicode_COPTIC_SYMBOL_SHIMA_SIMA                              0x2CEA
#define unicode_COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_SHEI              0x2CEB
#define unicode_COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_SHEI                0x2CEC
#define unicode_COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_GANGIA            0x2CED
#define unicode_COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_GANGIA              0x2CEE
#define unicode_COPTIC_COMBINING_NI_ABOVE                             0x2CEF
#define unicode_COPTIC_COMBINING_SPIRITUS_ASPER                       0x2CF0
#define unicode_COPTIC_COMBINING_SPIRITUS_LENIS                       0x2CF1
#define unicode_COPTIC_CAPITAL_LETTER_BOHAIRIC_KHEI                   0x2CF2
#define unicode_COPTIC_SMALL_LETTER_BOHAIRIC_KHEI                     0x2CF3
#define unicode_COPTIC_OLD_NUBIAN_FULL_STOP                           0x2CF9
#define unicode_COPTIC_OLD_NUBIAN_DIRECT_QUESTION_MARK                0x2CFA
#define unicode_COPTIC_OLD_NUBIAN_INDIRECT_QUESTION_MARK              0x2CFB
#define unicode_COPTIC_OLD_NUBIAN_VERSE_DIVIDER                       0x2CFC
#define unicode_COPTIC_FRACTION_ONE_HALF                              0x2CFD
#define unicode_COPTIC_FULL_STOP                                      0x2CFE
#define unicode_COPTIC_MORPHOLOGICAL_DIVIDER                          0x2CFF
#define unicode_GEORGIAN_SMALL_LETTER_AN                              0x2D00
#define unicode_GEORGIAN_SMALL_LETTER_BAN                             0x2D01
#define unicode_GEORGIAN_SMALL_LETTER_GAN                             0x2D02
#define unicode_GEORGIAN_SMALL_LETTER_DON                             0x2D03
#define unicode_GEORGIAN_SMALL_LETTER_EN                              0x2D04
#define unicode_GEORGIAN_SMALL_LETTER_VIN                             0x2D05
#define unicode_GEORGIAN_SMALL_LETTER_ZEN                             0x2D06
#define unicode_GEORGIAN_SMALL_LETTER_TAN                             0x2D07
#define unicode_GEORGIAN_SMALL_LETTER_IN                              0x2D08
#define unicode_GEORGIAN_SMALL_LETTER_KAN                             0x2D09
#define unicode_GEORGIAN_SMALL_LETTER_LAS                             0x2D0A
#define unicode_GEORGIAN_SMALL_LETTER_MAN                             0x2D0B
#define unicode_GEORGIAN_SMALL_LETTER_NAR                             0x2D0C
#define unicode_GEORGIAN_SMALL_LETTER_ON                              0x2D0D
#define unicode_GEORGIAN_SMALL_LETTER_PAR                             0x2D0E
#define unicode_GEORGIAN_SMALL_LETTER_ZHAR                            0x2D0F
#define unicode_GEORGIAN_SMALL_LETTER_RAE                             0x2D10
#define unicode_GEORGIAN_SMALL_LETTER_SAN                             0x2D11
#define unicode_GEORGIAN_SMALL_LETTER_TAR                             0x2D12
#define unicode_GEORGIAN_SMALL_LETTER_UN                              0x2D13
#define unicode_GEORGIAN_SMALL_LETTER_PHAR                            0x2D14
#define unicode_GEORGIAN_SMALL_LETTER_KHAR                            0x2D15
#define unicode_GEORGIAN_SMALL_LETTER_GHAN                            0x2D16
#define unicode_GEORGIAN_SMALL_LETTER_QAR                             0x2D17
#define unicode_GEORGIAN_SMALL_LETTER_SHIN                            0x2D18
#define unicode_GEORGIAN_SMALL_LETTER_CHIN                            0x2D19
#define unicode_GEORGIAN_SMALL_LETTER_CAN                             0x2D1A
#define unicode_GEORGIAN_SMALL_LETTER_JIL                             0x2D1B
#define unicode_GEORGIAN_SMALL_LETTER_CIL                             0x2D1C
#define unicode_GEORGIAN_SMALL_LETTER_CHAR                            0x2D1D
#define unicode_GEORGIAN_SMALL_LETTER_XAN                             0x2D1E
#define unicode_GEORGIAN_SMALL_LETTER_JHAN                            0x2D1F
#define unicode_GEORGIAN_SMALL_LETTER_HAE                             0x2D20
#define unicode_GEORGIAN_SMALL_LETTER_HE                              0x2D21
#define unicode_GEORGIAN_SMALL_LETTER_HIE                             0x2D22
#define unicode_GEORGIAN_SMALL_LETTER_WE                              0x2D23
#define unicode_GEORGIAN_SMALL_LETTER_HAR                             0x2D24
#define unicode_GEORGIAN_SMALL_LETTER_HOE                             0x2D25
#define unicode_GEORGIAN_SMALL_LETTER_YN                              0x2D27
#define unicode_GEORGIAN_SMALL_LETTER_AEN                             0x2D2D
#define unicode_TIFINAGH_LETTER_YA                                    0x2D30
#define unicode_TIFINAGH_LETTER_YAB                                   0x2D31
#define unicode_TIFINAGH_LETTER_YABH                                  0x2D32
#define unicode_TIFINAGH_LETTER_YAG                                   0x2D33
#define unicode_TIFINAGH_LETTER_YAGHH                                 0x2D34
#define unicode_TIFINAGH_LETTER_BERBER_ACADEMY_YAJ                    0x2D35
#define unicode_TIFINAGH_LETTER_YAJ                                   0x2D36
#define unicode_TIFINAGH_LETTER_YAD                                   0x2D37
#define unicode_TIFINAGH_LETTER_YADH                                  0x2D38
#define unicode_TIFINAGH_LETTER_YADD                                  0x2D39
#define unicode_TIFINAGH_LETTER_YADDH                                 0x2D3A
#define unicode_TIFINAGH_LETTER_YEY                                   0x2D3B
#define unicode_TIFINAGH_LETTER_YAF                                   0x2D3C
#define unicode_TIFINAGH_LETTER_YAK                                   0x2D3D
#define unicode_TIFINAGH_LETTER_TUAREG_YAK                            0x2D3E
#define unicode_TIFINAGH_LETTER_YAKHH                                 0x2D3F
#define unicode_TIFINAGH_LETTER_YAH                                   0x2D40
#define unicode_TIFINAGH_LETTER_BERBER_ACADEMY_YAH                    0x2D41
#define unicode_TIFINAGH_LETTER_TUAREG_YAH                            0x2D42
#define unicode_TIFINAGH_LETTER_YAHH                                  0x2D43
#define unicode_TIFINAGH_LETTER_YAA                                   0x2D44
#define unicode_TIFINAGH_LETTER_YAKH                                  0x2D45
#define unicode_TIFINAGH_LETTER_TUAREG_YAKH                           0x2D46
#define unicode_TIFINAGH_LETTER_YAQ                                   0x2D47
#define unicode_TIFINAGH_LETTER_TUAREG_YAQ                            0x2D48
#define unicode_TIFINAGH_LETTER_YI                                    0x2D49
#define unicode_TIFINAGH_LETTER_YAZH                                  0x2D4A
#define unicode_TIFINAGH_LETTER_AHAGGAR_YAZH                          0x2D4B
#define unicode_TIFINAGH_LETTER_TUAREG_YAZH                           0x2D4C
#define unicode_TIFINAGH_LETTER_YAL                                   0x2D4D
#define unicode_TIFINAGH_LETTER_YAM                                   0x2D4E
#define unicode_TIFINAGH_LETTER_YAN                                   0x2D4F
#define unicode_TIFINAGH_LETTER_TUAREG_YAGN                           0x2D50
#define unicode_TIFINAGH_LETTER_TUAREG_YANG                           0x2D51
#define unicode_TIFINAGH_LETTER_YAP                                   0x2D52
#define unicode_TIFINAGH_LETTER_YU                                    0x2D53
#define unicode_TIFINAGH_LETTER_YAR                                   0x2D54
#define unicode_TIFINAGH_LETTER_YARR                                  0x2D55
#define unicode_TIFINAGH_LETTER_YAGH                                  0x2D56
#define unicode_TIFINAGH_LETTER_TUAREG_YAGH                           0x2D57
#define unicode_TIFINAGH_LETTER_AYER_YAGH                             0x2D58
#define unicode_TIFINAGH_LETTER_YAS                                   0x2D59
#define unicode_TIFINAGH_LETTER_YASS                                  0x2D5A
#define unicode_TIFINAGH_LETTER_YASH                                  0x2D5B
#define unicode_TIFINAGH_LETTER_YAT                                   0x2D5C
#define unicode_TIFINAGH_LETTER_YATH                                  0x2D5D
#define unicode_TIFINAGH_LETTER_YACH                                  0x2D5E
#define unicode_TIFINAGH_LETTER_YATT                                  0x2D5F
#define unicode_TIFINAGH_LETTER_YAV                                   0x2D60
#define unicode_TIFINAGH_LETTER_YAW                                   0x2D61
#define unicode_TIFINAGH_LETTER_YAY                                   0x2D62
#define unicode_TIFINAGH_LETTER_YAZ                                   0x2D63
#define unicode_TIFINAGH_LETTER_TAWELLEMET_YAZ                        0x2D64
#define unicode_TIFINAGH_LETTER_YAZZ                                  0x2D65
#define unicode_TIFINAGH_LETTER_YE                                    0x2D66
#define unicode_TIFINAGH_LETTER_YO                                    0x2D67
#define unicode_TIFINAGH_MODIFIER_LETTER_LABIALIZATION_MARK           0x2D6F
#define unicode_TIFINAGH_SEPARATOR_MARK                               0x2D70
#define unicode_TIFINAGH_CONSONANT_JOINER                             0x2D7F
#define unicode_ETHIOPIC_SYLLABLE_LOA                                 0x2D80
#define unicode_ETHIOPIC_SYLLABLE_MOA                                 0x2D81
#define unicode_ETHIOPIC_SYLLABLE_ROA                                 0x2D82
#define unicode_ETHIOPIC_SYLLABLE_SOA                                 0x2D83
#define unicode_ETHIOPIC_SYLLABLE_SHOA                                0x2D84
#define unicode_ETHIOPIC_SYLLABLE_BOA                                 0x2D85
#define unicode_ETHIOPIC_SYLLABLE_TOA                                 0x2D86
#define unicode_ETHIOPIC_SYLLABLE_COA                                 0x2D87
#define unicode_ETHIOPIC_SYLLABLE_NOA                                 0x2D88
#define unicode_ETHIOPIC_SYLLABLE_NYOA                                0x2D89
#define unicode_ETHIOPIC_SYLLABLE_GLOTTAL_OA                          0x2D8A
#define unicode_ETHIOPIC_SYLLABLE_ZOA                                 0x2D8B
#define unicode_ETHIOPIC_SYLLABLE_DOA                                 0x2D8C
#define unicode_ETHIOPIC_SYLLABLE_DDOA                                0x2D8D
#define unicode_ETHIOPIC_SYLLABLE_JOA                                 0x2D8E
#define unicode_ETHIOPIC_SYLLABLE_THOA                                0x2D8F
#define unicode_ETHIOPIC_SYLLABLE_CHOA                                0x2D90
#define unicode_ETHIOPIC_SYLLABLE_PHOA                                0x2D91
#define unicode_ETHIOPIC_SYLLABLE_POA                                 0x2D92
#define unicode_ETHIOPIC_SYLLABLE_GGWA                                0x2D93
#define unicode_ETHIOPIC_SYLLABLE_GGWI                                0x2D94
#define unicode_ETHIOPIC_SYLLABLE_GGWEE                               0x2D95
#define unicode_ETHIOPIC_SYLLABLE_GGWE                                0x2D96
#define unicode_ETHIOPIC_SYLLABLE_SSA                                 0x2DA0
#define unicode_ETHIOPIC_SYLLABLE_SSU                                 0x2DA1
#define unicode_ETHIOPIC_SYLLABLE_SSI                                 0x2DA2
#define unicode_ETHIOPIC_SYLLABLE_SSAA                                0x2DA3
#define unicode_ETHIOPIC_SYLLABLE_SSEE                                0x2DA4
#define unicode_ETHIOPIC_SYLLABLE_SSE                                 0x2DA5
#define unicode_ETHIOPIC_SYLLABLE_SSO                                 0x2DA6
#define unicode_ETHIOPIC_SYLLABLE_CCA                                 0x2DA8
#define unicode_ETHIOPIC_SYLLABLE_CCU                                 0x2DA9
#define unicode_ETHIOPIC_SYLLABLE_CCI                                 0x2DAA
#define unicode_ETHIOPIC_SYLLABLE_CCAA                                0x2DAB
#define unicode_ETHIOPIC_SYLLABLE_CCEE                                0x2DAC
#define unicode_ETHIOPIC_SYLLABLE_CCE                                 0x2DAD
#define unicode_ETHIOPIC_SYLLABLE_CCO                                 0x2DAE
#define unicode_ETHIOPIC_SYLLABLE_ZZA                                 0x2DB0
#define unicode_ETHIOPIC_SYLLABLE_ZZU                                 0x2DB1
#define unicode_ETHIOPIC_SYLLABLE_ZZI                                 0x2DB2
#define unicode_ETHIOPIC_SYLLABLE_ZZAA                                0x2DB3
#define unicode_ETHIOPIC_SYLLABLE_ZZEE                                0x2DB4
#define unicode_ETHIOPIC_SYLLABLE_ZZE                                 0x2DB5
#define unicode_ETHIOPIC_SYLLABLE_ZZO                                 0x2DB6
#define unicode_ETHIOPIC_SYLLABLE_CCHA                                0x2DB8
#define unicode_ETHIOPIC_SYLLABLE_CCHU                                0x2DB9
#define unicode_ETHIOPIC_SYLLABLE_CCHI                                0x2DBA
#define unicode_ETHIOPIC_SYLLABLE_CCHAA                               0x2DBB
#define unicode_ETHIOPIC_SYLLABLE_CCHEE                               0x2DBC
#define unicode_ETHIOPIC_SYLLABLE_CCHE                                0x2DBD
#define unicode_ETHIOPIC_SYLLABLE_CCHO                                0x2DBE
#define unicode_ETHIOPIC_SYLLABLE_QYA                                 0x2DC0
#define unicode_ETHIOPIC_SYLLABLE_QYU                                 0x2DC1
#define unicode_ETHIOPIC_SYLLABLE_QYI                                 0x2DC2
#define unicode_ETHIOPIC_SYLLABLE_QYAA                                0x2DC3
#define unicode_ETHIOPIC_SYLLABLE_QYEE                                0x2DC4
#define unicode_ETHIOPIC_SYLLABLE_QYE                                 0x2DC5
#define unicode_ETHIOPIC_SYLLABLE_QYO                                 0x2DC6
#define unicode_ETHIOPIC_SYLLABLE_KYA                                 0x2DC8
#define unicode_ETHIOPIC_SYLLABLE_KYU                                 0x2DC9
#define unicode_ETHIOPIC_SYLLABLE_KYI                                 0x2DCA
#define unicode_ETHIOPIC_SYLLABLE_KYAA                                0x2DCB
#define unicode_ETHIOPIC_SYLLABLE_KYEE                                0x2DCC
#define unicode_ETHIOPIC_SYLLABLE_KYE                                 0x2DCD
#define unicode_ETHIOPIC_SYLLABLE_KYO                                 0x2DCE
#define unicode_ETHIOPIC_SYLLABLE_XYA                                 0x2DD0
#define unicode_ETHIOPIC_SYLLABLE_XYU                                 0x2DD1
#define unicode_ETHIOPIC_SYLLABLE_XYI                                 0x2DD2
#define unicode_ETHIOPIC_SYLLABLE_XYAA                                0x2DD3
#define unicode_ETHIOPIC_SYLLABLE_XYEE                                0x2DD4
#define unicode_ETHIOPIC_SYLLABLE_XYE                                 0x2DD5
#define unicode_ETHIOPIC_SYLLABLE_XYO                                 0x2DD6
#define unicode_ETHIOPIC_SYLLABLE_GYA                                 0x2DD8
#define unicode_ETHIOPIC_SYLLABLE_GYU                                 0x2DD9
#define unicode_ETHIOPIC_SYLLABLE_GYI                                 0x2DDA
#define unicode_ETHIOPIC_SYLLABLE_GYAA                                0x2DDB
#define unicode_ETHIOPIC_SYLLABLE_GYEE                                0x2DDC
#define unicode_ETHIOPIC_SYLLABLE_GYE                                 0x2DDD
#define unicode_ETHIOPIC_SYLLABLE_GYO                                 0x2DDE
#define unicode_COMBINING_CYRILLIC_LETTER_BE                          0x2DE0
#define unicode_COMBINING_CYRILLIC_LETTER_VE                          0x2DE1
#define unicode_COMBINING_CYRILLIC_LETTER_GHE                         0x2DE2
#define unicode_COMBINING_CYRILLIC_LETTER_DE                          0x2DE3
#define unicode_COMBINING_CYRILLIC_LETTER_ZHE                         0x2DE4
#define unicode_COMBINING_CYRILLIC_LETTER_ZE                          0x2DE5
#define unicode_COMBINING_CYRILLIC_LETTER_KA                          0x2DE6
#define unicode_COMBINING_CYRILLIC_LETTER_EL                          0x2DE7
#define unicode_COMBINING_CYRILLIC_LETTER_EM                          0x2DE8
#define unicode_COMBINING_CYRILLIC_LETTER_EN                          0x2DE9
#define unicode_COMBINING_CYRILLIC_LETTER_O                           0x2DEA
#define unicode_COMBINING_CYRILLIC_LETTER_PE                          0x2DEB
#define unicode_COMBINING_CYRILLIC_LETTER_ER                          0x2DEC
#define unicode_COMBINING_CYRILLIC_LETTER_ES                          0x2DED
#define unicode_COMBINING_CYRILLIC_LETTER_TE                          0x2DEE
#define unicode_COMBINING_CYRILLIC_LETTER_HA                          0x2DEF
#define unicode_COMBINING_CYRILLIC_LETTER_TSE                         0x2DF0
#define unicode_COMBINING_CYRILLIC_LETTER_CHE                         0x2DF1
#define unicode_COMBINING_CYRILLIC_LETTER_SHA                         0x2DF2
#define unicode_COMBINING_CYRILLIC_LETTER_SHCHA                       0x2DF3
#define unicode_COMBINING_CYRILLIC_LETTER_FITA                        0x2DF4
#define unicode_COMBINING_CYRILLIC_LETTER_ES_TE                       0x2DF5
#define unicode_COMBINING_CYRILLIC_LETTER_A                           0x2DF6
#define unicode_COMBINING_CYRILLIC_LETTER_IE                          0x2DF7
#define unicode_COMBINING_CYRILLIC_LETTER_DJERV                       0x2DF8
#define unicode_COMBINING_CYRILLIC_LETTER_MONOGRAPH_UK                0x2DF9
#define unicode_COMBINING_CYRILLIC_LETTER_YAT                         0x2DFA
#define unicode_COMBINING_CYRILLIC_LETTER_YU                          0x2DFB
#define unicode_COMBINING_CYRILLIC_LETTER_IOTIFIED_A                  0x2DFC
#define unicode_COMBINING_CYRILLIC_LETTER_LITTLE_YUS                  0x2DFD
#define unicode_COMBINING_CYRILLIC_LETTER_BIG_YUS                     0x2DFE
#define unicode_COMBINING_CYRILLIC_LETTER_IOTIFIED_BIG_YUS            0x2DFF
#define unicode_RIGHT_ANGLE_SUBSTITUTION_MARKER                       0x2E00
#define unicode_RIGHT_ANGLE_DOTTED_SUBSTITUTION_MARKER                0x2E01
#define unicode_LEFT_SUBSTITUTION_BRACKET                             0x2E02
#define unicode_RIGHT_SUBSTITUTION_BRACKET                            0x2E03
#define unicode_LEFT_DOTTED_SUBSTITUTION_BRACKET                      0x2E04
#define unicode_RIGHT_DOTTED_SUBSTITUTION_BRACKET                     0x2E05
#define unicode_RAISED_INTERPOLATION_MARKER                           0x2E06
#define unicode_RAISED_DOTTED_INTERPOLATION_MARKER                    0x2E07
#define unicode_DOTTED_TRANSPOSITION_MARKER                           0x2E08
#define unicode_LEFT_TRANSPOSITION_BRACKET                            0x2E09
#define unicode_RIGHT_TRANSPOSITION_BRACKET                           0x2E0A
#define unicode_RAISED_SQUARE                                         0x2E0B
#define unicode_LEFT_RAISED_OMISSION_BRACKET                          0x2E0C
#define unicode_RIGHT_RAISED_OMISSION_BRACKET                         0x2E0D
#define unicode_EDITORIAL_CORONIS                                     0x2E0E
#define unicode_PARAGRAPHOS                                           0x2E0F
#define unicode_FORKED_PARAGRAPHOS                                    0x2E10
#define unicode_REVERSED_FORKED_PARAGRAPHOS                           0x2E11
#define unicode_HYPODIASTOLE                                          0x2E12
#define unicode_DOTTED_OBELOS                                         0x2E13
#define unicode_DOWNWARDS_ANCORA                                      0x2E14
#define unicode_UPWARDS_ANCORA                                        0x2E15
#define unicode_DOTTED_RIGHT_POINTING_ANGLE                           0x2E16
#define unicode_DOUBLE_OBLIQUE_HYPHEN                                 0x2E17
#define unicode_INVERTED_INTERROBANG                                  0x2E18
#define unicode_PALM_BRANCH                                           0x2E19
#define unicode_HYPHEN_WITH_DIAERESIS                                 0x2E1A
#define unicode_TILDE_WITH_RING_ABOVE                                 0x2E1B
#define unicode_LEFT_LOW_PARAPHRASE_BRACKET                           0x2E1C
#define unicode_RIGHT_LOW_PARAPHRASE_BRACKET                          0x2E1D
#define unicode_TILDE_WITH_DOT_ABOVE                                  0x2E1E
#define unicode_TILDE_WITH_DOT_BELOW                                  0x2E1F
#define unicode_LEFT_VERTICAL_BAR_WITH_QUILL                          0x2E20
#define unicode_RIGHT_VERTICAL_BAR_WITH_QUILL                         0x2E21
#define unicode_TOP_LEFT_HALF_BRACKET                                 0x2E22
#define unicode_TOP_RIGHT_HALF_BRACKET                                0x2E23
#define unicode_BOTTOM_LEFT_HALF_BRACKET                              0x2E24
#define unicode_BOTTOM_RIGHT_HALF_BRACKET                             0x2E25
#define unicode_LEFT_SIDEWAYS_U_BRACKET                               0x2E26
#define unicode_RIGHT_SIDEWAYS_U_BRACKET                              0x2E27
#define unicode_LEFT_DOUBLE_PARENTHESIS                               0x2E28
#define unicode_RIGHT_DOUBLE_PARENTHESIS                              0x2E29
#define unicode_TWO_DOTS_OVER_ONE_DOT_PUNCTUATION                     0x2E2A
#define unicode_ONE_DOT_OVER_TWO_DOTS_PUNCTUATION                     0x2E2B
#define unicode_SQUARED_FOUR_DOT_PUNCTUATION                          0x2E2C
#define unicode_FIVE_DOT_MARK                                         0x2E2D
#define unicode_REVERSED_QUESTION_MARK                                0x2E2E
#define unicode_VERTICAL_TILDE                                        0x2E2F
#define unicode_RING_POINT                                            0x2E30
#define unicode_WORD_SEPARATOR_MIDDLE_DOT                             0x2E31
#define unicode_TURNED_COMMA                                          0x2E32
#define unicode_RAISED_DOT                                            0x2E33
#define unicode_RAISED_COMMA                                          0x2E34
#define unicode_TURNED_SEMICOLON                                      0x2E35
#define unicode_DAGGER_WITH_LEFT_GUARD                                0x2E36
#define unicode_DAGGER_WITH_RIGHT_GUARD                               0x2E37
#define unicode_TURNED_DAGGER                                         0x2E38
#define unicode_TOP_HALF_SECTION_SIGN                                 0x2E39
#define unicode_TWO_EM_DASH                                           0x2E3A
#define unicode_THREE_EM_DASH                                         0x2E3B
#define unicode_STENOGRAPHIC_FULL_STOP                                0x2E3C
#define unicode_VERTICAL_SIX_DOTS                                     0x2E3D
#define unicode_WIGGLY_VERTICAL_LINE                                  0x2E3E
#define unicode_CAPITULUM                                             0x2E3F
#define unicode_DOUBLE_HYPHEN                                         0x2E40
#define unicode_REVERSED_COMMA                                        0x2E41
#define unicode_DOUBLE_LOW_REVERSED_9_QUOTATION_MARK                  0x2E42
#define unicode_CJK_RADICAL_REPEAT                                    0x2E80
#define unicode_CJK_RADICAL_CLIFF                                     0x2E81
#define unicode_CJK_RADICAL_SECOND_ONE                                0x2E82
#define unicode_CJK_RADICAL_SECOND_TWO                                0x2E83
#define unicode_CJK_RADICAL_SECOND_THREE                              0x2E84
#define unicode_CJK_RADICAL_PERSON                                    0x2E85
#define unicode_CJK_RADICAL_BOX                                       0x2E86
#define unicode_CJK_RADICAL_TABLE                                     0x2E87
#define unicode_CJK_RADICAL_KNIFE_ONE                                 0x2E88
#define unicode_CJK_RADICAL_KNIFE_TWO                                 0x2E89
#define unicode_CJK_RADICAL_DIVINATION                                0x2E8A
#define unicode_CJK_RADICAL_SEAL                                      0x2E8B
#define unicode_CJK_RADICAL_SMALL_ONE                                 0x2E8C
#define unicode_CJK_RADICAL_SMALL_TWO                                 0x2E8D
#define unicode_CJK_RADICAL_LAME_ONE                                  0x2E8E
#define unicode_CJK_RADICAL_LAME_TWO                                  0x2E8F
#define unicode_CJK_RADICAL_LAME_THREE                                0x2E90
#define unicode_CJK_RADICAL_LAME_FOUR                                 0x2E91
#define unicode_CJK_RADICAL_SNAKE                                     0x2E92
#define unicode_CJK_RADICAL_THREAD                                    0x2E93
#define unicode_CJK_RADICAL_SNOUT_ONE                                 0x2E94
#define unicode_CJK_RADICAL_SNOUT_TWO                                 0x2E95
#define unicode_CJK_RADICAL_HEART_ONE                                 0x2E96
#define unicode_CJK_RADICAL_HEART_TWO                                 0x2E97
#define unicode_CJK_RADICAL_HAND                                      0x2E98
#define unicode_CJK_RADICAL_RAP                                       0x2E99
#define unicode_CJK_RADICAL_CHOKE                                     0x2E9B
#define unicode_CJK_RADICAL_SUN                                       0x2E9C
#define unicode_CJK_RADICAL_MOON                                      0x2E9D
#define unicode_CJK_RADICAL_DEATH                                     0x2E9E
#define unicode_CJK_RADICAL_MOTHER                                    0x2E9F
#define unicode_CJK_RADICAL_CIVILIAN                                  0x2EA0
#define unicode_CJK_RADICAL_WATER_ONE                                 0x2EA1
#define unicode_CJK_RADICAL_WATER_TWO                                 0x2EA2
#define unicode_CJK_RADICAL_FIRE                                      0x2EA3
#define unicode_CJK_RADICAL_PAW_ONE                                   0x2EA4
#define unicode_CJK_RADICAL_PAW_TWO                                   0x2EA5
#define unicode_CJK_RADICAL_SIMPLIFIED_HALF_TREE_TRUNK                0x2EA6
#define unicode_CJK_RADICAL_COW                                       0x2EA7
#define unicode_CJK_RADICAL_DOG                                       0x2EA8
#define unicode_CJK_RADICAL_JADE                                      0x2EA9
#define unicode_CJK_RADICAL_BOLT_OF_CLOTH                             0x2EAA
#define unicode_CJK_RADICAL_EYE                                       0x2EAB
#define unicode_CJK_RADICAL_SPIRIT_ONE                                0x2EAC
#define unicode_CJK_RADICAL_SPIRIT_TWO                                0x2EAD
#define unicode_CJK_RADICAL_BAMBOO                                    0x2EAE
#define unicode_CJK_RADICAL_SILK                                      0x2EAF
#define unicode_CJK_RADICAL_C_SIMPLIFIED_SILK                         0x2EB0
#define unicode_CJK_RADICAL_NET_ONE                                   0x2EB1
#define unicode_CJK_RADICAL_NET_TWO                                   0x2EB2
#define unicode_CJK_RADICAL_NET_THREE                                 0x2EB3
#define unicode_CJK_RADICAL_NET_FOUR                                  0x2EB4
#define unicode_CJK_RADICAL_MESH                                      0x2EB5
#define unicode_CJK_RADICAL_SHEEP                                     0x2EB6
#define unicode_CJK_RADICAL_RAM                                       0x2EB7
#define unicode_CJK_RADICAL_EWE                                       0x2EB8
#define unicode_CJK_RADICAL_OLD                                       0x2EB9
#define unicode_CJK_RADICAL_BRUSH_ONE                                 0x2EBA
#define unicode_CJK_RADICAL_BRUSH_TWO                                 0x2EBB
#define unicode_CJK_RADICAL_MEAT                                      0x2EBC
#define unicode_CJK_RADICAL_MORTAR                                    0x2EBD
#define unicode_CJK_RADICAL_GRASS_ONE                                 0x2EBE
#define unicode_CJK_RADICAL_GRASS_TWO                                 0x2EBF
#define unicode_CJK_RADICAL_GRASS_THREE                               0x2EC0
#define unicode_CJK_RADICAL_TIGER                                     0x2EC1
#define unicode_CJK_RADICAL_CLOTHES                                   0x2EC2
#define unicode_CJK_RADICAL_WEST_ONE                                  0x2EC3
#define unicode_CJK_RADICAL_WEST_TWO                                  0x2EC4
#define unicode_CJK_RADICAL_C_SIMPLIFIED_SEE                          0x2EC5
#define unicode_CJK_RADICAL_SIMPLIFIED_HORN                           0x2EC6
#define unicode_CJK_RADICAL_HORN                                      0x2EC7
#define unicode_CJK_RADICAL_C_SIMPLIFIED_SPEECH                       0x2EC8
#define unicode_CJK_RADICAL_C_SIMPLIFIED_SHELL                        0x2EC9
#define unicode_CJK_RADICAL_FOOT                                      0x2ECA
#define unicode_CJK_RADICAL_C_SIMPLIFIED_CART                         0x2ECB
#define unicode_CJK_RADICAL_SIMPLIFIED_WALK                           0x2ECC
#define unicode_CJK_RADICAL_WALK_ONE                                  0x2ECD
#define unicode_CJK_RADICAL_WALK_TWO                                  0x2ECE
#define unicode_CJK_RADICAL_CITY                                      0x2ECF
#define unicode_CJK_RADICAL_C_SIMPLIFIED_GOLD                         0x2ED0
#define unicode_CJK_RADICAL_LONG_ONE                                  0x2ED1
#define unicode_CJK_RADICAL_LONG_TWO                                  0x2ED2
#define unicode_CJK_RADICAL_C_SIMPLIFIED_LONG                         0x2ED3
#define unicode_CJK_RADICAL_C_SIMPLIFIED_GATE                         0x2ED4
#define unicode_CJK_RADICAL_MOUND_ONE                                 0x2ED5
#define unicode_CJK_RADICAL_MOUND_TWO                                 0x2ED6
#define unicode_CJK_RADICAL_RAIN                                      0x2ED7
#define unicode_CJK_RADICAL_BLUE                                      0x2ED8
#define unicode_CJK_RADICAL_C_SIMPLIFIED_TANNED_LEATHER               0x2ED9
#define unicode_CJK_RADICAL_C_SIMPLIFIED_LEAF                         0x2EDA
#define unicode_CJK_RADICAL_C_SIMPLIFIED_WIND                         0x2EDB
#define unicode_CJK_RADICAL_C_SIMPLIFIED_FLY                          0x2EDC
#define unicode_CJK_RADICAL_EAT_ONE                                   0x2EDD
#define unicode_CJK_RADICAL_EAT_TWO                                   0x2EDE
#define unicode_CJK_RADICAL_EAT_THREE                                 0x2EDF
#define unicode_CJK_RADICAL_C_SIMPLIFIED_EAT                          0x2EE0
#define unicode_CJK_RADICAL_HEAD                                      0x2EE1
#define unicode_CJK_RADICAL_C_SIMPLIFIED_HORSE                        0x2EE2
#define unicode_CJK_RADICAL_BONE                                      0x2EE3
#define unicode_CJK_RADICAL_GHOST                                     0x2EE4
#define unicode_CJK_RADICAL_C_SIMPLIFIED_FISH                         0x2EE5
#define unicode_CJK_RADICAL_C_SIMPLIFIED_BIRD                         0x2EE6
#define unicode_CJK_RADICAL_C_SIMPLIFIED_SALT                         0x2EE7
#define unicode_CJK_RADICAL_SIMPLIFIED_WHEAT                          0x2EE8
#define unicode_CJK_RADICAL_SIMPLIFIED_YELLOW                         0x2EE9
#define unicode_CJK_RADICAL_C_SIMPLIFIED_FROG                         0x2EEA
#define unicode_CJK_RADICAL_J_SIMPLIFIED_EVEN                         0x2EEB
#define unicode_CJK_RADICAL_C_SIMPLIFIED_EVEN                         0x2EEC
#define unicode_CJK_RADICAL_J_SIMPLIFIED_TOOTH                        0x2EED
#define unicode_CJK_RADICAL_C_SIMPLIFIED_TOOTH                        0x2EEE
#define unicode_CJK_RADICAL_J_SIMPLIFIED_DRAGON                       0x2EEF
#define unicode_CJK_RADICAL_C_SIMPLIFIED_DRAGON                       0x2EF0
#define unicode_CJK_RADICAL_TURTLE                                    0x2EF1
#define unicode_CJK_RADICAL_J_SIMPLIFIED_TURTLE                       0x2EF2
#define unicode_CJK_RADICAL_C_SIMPLIFIED_TURTLE                       0x2EF3
#define unicode_KANGXI_RADICAL_ONE                                    0x2F00
#define unicode_KANGXI_RADICAL_LINE                                   0x2F01
#define unicode_KANGXI_RADICAL_DOT                                    0x2F02
#define unicode_KANGXI_RADICAL_SLASH                                  0x2F03
#define unicode_KANGXI_RADICAL_SECOND                                 0x2F04
#define unicode_KANGXI_RADICAL_HOOK                                   0x2F05
#define unicode_KANGXI_RADICAL_TWO                                    0x2F06
#define unicode_KANGXI_RADICAL_LID                                    0x2F07
#define unicode_KANGXI_RADICAL_MAN                                    0x2F08
#define unicode_KANGXI_RADICAL_LEGS                                   0x2F09
#define unicode_KANGXI_RADICAL_ENTER                                  0x2F0A
#define unicode_KANGXI_RADICAL_EIGHT                                  0x2F0B
#define unicode_KANGXI_RADICAL_DOWN_BOX                               0x2F0C
#define unicode_KANGXI_RADICAL_COVER                                  0x2F0D
#define unicode_KANGXI_RADICAL_ICE                                    0x2F0E
#define unicode_KANGXI_RADICAL_TABLE                                  0x2F0F
#define unicode_KANGXI_RADICAL_OPEN_BOX                               0x2F10
#define unicode_KANGXI_RADICAL_KNIFE                                  0x2F11
#define unicode_KANGXI_RADICAL_POWER                                  0x2F12
#define unicode_KANGXI_RADICAL_WRAP                                   0x2F13
#define unicode_KANGXI_RADICAL_SPOON                                  0x2F14
#define unicode_KANGXI_RADICAL_RIGHT_OPEN_BOX                         0x2F15
#define unicode_KANGXI_RADICAL_HIDING_ENCLOSURE                       0x2F16
#define unicode_KANGXI_RADICAL_TEN                                    0x2F17
#define unicode_KANGXI_RADICAL_DIVINATION                             0x2F18
#define unicode_KANGXI_RADICAL_SEAL                                   0x2F19
#define unicode_KANGXI_RADICAL_CLIFF                                  0x2F1A
#define unicode_KANGXI_RADICAL_PRIVATE                                0x2F1B
#define unicode_KANGXI_RADICAL_AGAIN                                  0x2F1C
#define unicode_KANGXI_RADICAL_MOUTH                                  0x2F1D
#define unicode_KANGXI_RADICAL_ENCLOSURE                              0x2F1E
#define unicode_KANGXI_RADICAL_EARTH                                  0x2F1F
#define unicode_KANGXI_RADICAL_SCHOLAR                                0x2F20
#define unicode_KANGXI_RADICAL_GO                                     0x2F21
#define unicode_KANGXI_RADICAL_GO_SLOWLY                              0x2F22
#define unicode_KANGXI_RADICAL_EVENING                                0x2F23
#define unicode_KANGXI_RADICAL_BIG                                    0x2F24
#define unicode_KANGXI_RADICAL_WOMAN                                  0x2F25
#define unicode_KANGXI_RADICAL_CHILD                                  0x2F26
#define unicode_KANGXI_RADICAL_ROOF                                   0x2F27
#define unicode_KANGXI_RADICAL_INCH                                   0x2F28
#define unicode_KANGXI_RADICAL_SMALL                                  0x2F29
#define unicode_KANGXI_RADICAL_LAME                                   0x2F2A
#define unicode_KANGXI_RADICAL_CORPSE                                 0x2F2B
#define unicode_KANGXI_RADICAL_SPROUT                                 0x2F2C
#define unicode_KANGXI_RADICAL_MOUNTAIN                               0x2F2D
#define unicode_KANGXI_RADICAL_RIVER                                  0x2F2E
#define unicode_KANGXI_RADICAL_WORK                                   0x2F2F
#define unicode_KANGXI_RADICAL_ONESELF                                0x2F30
#define unicode_KANGXI_RADICAL_TURBAN                                 0x2F31
#define unicode_KANGXI_RADICAL_DRY                                    0x2F32
#define unicode_KANGXI_RADICAL_SHORT_THREAD                           0x2F33
#define unicode_KANGXI_RADICAL_DOTTED_CLIFF                           0x2F34
#define unicode_KANGXI_RADICAL_LONG_STRIDE                            0x2F35
#define unicode_KANGXI_RADICAL_TWO_HANDS                              0x2F36
#define unicode_KANGXI_RADICAL_SHOOT                                  0x2F37
#define unicode_KANGXI_RADICAL_BOW                                    0x2F38
#define unicode_KANGXI_RADICAL_SNOUT                                  0x2F39
#define unicode_KANGXI_RADICAL_BRISTLE                                0x2F3A
#define unicode_KANGXI_RADICAL_STEP                                   0x2F3B
#define unicode_KANGXI_RADICAL_HEART                                  0x2F3C
#define unicode_KANGXI_RADICAL_HALBERD                                0x2F3D
#define unicode_KANGXI_RADICAL_DOOR                                   0x2F3E
#define unicode_KANGXI_RADICAL_HAND                                   0x2F3F
#define unicode_KANGXI_RADICAL_BRANCH                                 0x2F40
#define unicode_KANGXI_RADICAL_RAP                                    0x2F41
#define unicode_KANGXI_RADICAL_SCRIPT                                 0x2F42
#define unicode_KANGXI_RADICAL_DIPPER                                 0x2F43
#define unicode_KANGXI_RADICAL_AXE                                    0x2F44
#define unicode_KANGXI_RADICAL_SQUARE                                 0x2F45
#define unicode_KANGXI_RADICAL_NOT                                    0x2F46
#define unicode_KANGXI_RADICAL_SUN                                    0x2F47
#define unicode_KANGXI_RADICAL_SAY                                    0x2F48
#define unicode_KANGXI_RADICAL_MOON                                   0x2F49
#define unicode_KANGXI_RADICAL_TREE                                   0x2F4A
#define unicode_KANGXI_RADICAL_LACK                                   0x2F4B
#define unicode_KANGXI_RADICAL_STOP                                   0x2F4C
#define unicode_KANGXI_RADICAL_DEATH                                  0x2F4D
#define unicode_KANGXI_RADICAL_WEAPON                                 0x2F4E
#define unicode_KANGXI_RADICAL_DO_NOT                                 0x2F4F
#define unicode_KANGXI_RADICAL_COMPARE                                0x2F50
#define unicode_KANGXI_RADICAL_FUR                                    0x2F51
#define unicode_KANGXI_RADICAL_CLAN                                   0x2F52
#define unicode_KANGXI_RADICAL_STEAM                                  0x2F53
#define unicode_KANGXI_RADICAL_WATER                                  0x2F54
#define unicode_KANGXI_RADICAL_FIRE                                   0x2F55
#define unicode_KANGXI_RADICAL_CLAW                                   0x2F56
#define unicode_KANGXI_RADICAL_FATHER                                 0x2F57
#define unicode_KANGXI_RADICAL_DOUBLE_X                               0x2F58
#define unicode_KANGXI_RADICAL_HALF_TREE_TRUNK                        0x2F59
#define unicode_KANGXI_RADICAL_SLICE                                  0x2F5A
#define unicode_KANGXI_RADICAL_FANG                                   0x2F5B
#define unicode_KANGXI_RADICAL_COW                                    0x2F5C
#define unicode_KANGXI_RADICAL_DOG                                    0x2F5D
#define unicode_KANGXI_RADICAL_PROFOUND                               0x2F5E
#define unicode_KANGXI_RADICAL_JADE                                   0x2F5F
#define unicode_KANGXI_RADICAL_MELON                                  0x2F60
#define unicode_KANGXI_RADICAL_TILE                                   0x2F61
#define unicode_KANGXI_RADICAL_SWEET                                  0x2F62
#define unicode_KANGXI_RADICAL_LIFE                                   0x2F63
#define unicode_KANGXI_RADICAL_USE                                    0x2F64
#define unicode_KANGXI_RADICAL_FIELD                                  0x2F65
#define unicode_KANGXI_RADICAL_BOLT_OF_CLOTH                          0x2F66
#define unicode_KANGXI_RADICAL_SICKNESS                               0x2F67
#define unicode_KANGXI_RADICAL_DOTTED_TENT                            0x2F68
#define unicode_KANGXI_RADICAL_WHITE                                  0x2F69
#define unicode_KANGXI_RADICAL_SKIN                                   0x2F6A
#define unicode_KANGXI_RADICAL_DISH                                   0x2F6B
#define unicode_KANGXI_RADICAL_EYE                                    0x2F6C
#define unicode_KANGXI_RADICAL_SPEAR                                  0x2F6D
#define unicode_KANGXI_RADICAL_ARROW                                  0x2F6E
#define unicode_KANGXI_RADICAL_STONE                                  0x2F6F
#define unicode_KANGXI_RADICAL_SPIRIT                                 0x2F70
#define unicode_KANGXI_RADICAL_TRACK                                  0x2F71
#define unicode_KANGXI_RADICAL_GRAIN                                  0x2F72
#define unicode_KANGXI_RADICAL_CAVE                                   0x2F73
#define unicode_KANGXI_RADICAL_STAND                                  0x2F74
#define unicode_KANGXI_RADICAL_BAMBOO                                 0x2F75
#define unicode_KANGXI_RADICAL_RICE                                   0x2F76
#define unicode_KANGXI_RADICAL_SILK                                   0x2F77
#define unicode_KANGXI_RADICAL_JAR                                    0x2F78
#define unicode_KANGXI_RADICAL_NET                                    0x2F79
#define unicode_KANGXI_RADICAL_SHEEP                                  0x2F7A
#define unicode_KANGXI_RADICAL_FEATHER                                0x2F7B
#define unicode_KANGXI_RADICAL_OLD                                    0x2F7C
#define unicode_KANGXI_RADICAL_AND                                    0x2F7D
#define unicode_KANGXI_RADICAL_PLOW                                   0x2F7E
#define unicode_KANGXI_RADICAL_EAR                                    0x2F7F
#define unicode_KANGXI_RADICAL_BRUSH                                  0x2F80
#define unicode_KANGXI_RADICAL_MEAT                                   0x2F81
#define unicode_KANGXI_RADICAL_MINISTER                               0x2F82
#define unicode_KANGXI_RADICAL_SELF                                   0x2F83
#define unicode_KANGXI_RADICAL_ARRIVE                                 0x2F84
#define unicode_KANGXI_RADICAL_MORTAR                                 0x2F85
#define unicode_KANGXI_RADICAL_TONGUE                                 0x2F86
#define unicode_KANGXI_RADICAL_OPPOSE                                 0x2F87
#define unicode_KANGXI_RADICAL_BOAT                                   0x2F88
#define unicode_KANGXI_RADICAL_STOPPING                               0x2F89
#define unicode_KANGXI_RADICAL_COLOR                                  0x2F8A
#define unicode_KANGXI_RADICAL_GRASS                                  0x2F8B
#define unicode_KANGXI_RADICAL_TIGER                                  0x2F8C
#define unicode_KANGXI_RADICAL_INSECT                                 0x2F8D
#define unicode_KANGXI_RADICAL_BLOOD                                  0x2F8E
#define unicode_KANGXI_RADICAL_WALK_ENCLOSURE                         0x2F8F
#define unicode_KANGXI_RADICAL_CLOTHES                                0x2F90
#define unicode_KANGXI_RADICAL_WEST                                   0x2F91
#define unicode_KANGXI_RADICAL_SEE                                    0x2F92
#define unicode_KANGXI_RADICAL_HORN                                   0x2F93
#define unicode_KANGXI_RADICAL_SPEECH                                 0x2F94
#define unicode_KANGXI_RADICAL_VALLEY                                 0x2F95
#define unicode_KANGXI_RADICAL_BEAN                                   0x2F96
#define unicode_KANGXI_RADICAL_PIG                                    0x2F97
#define unicode_KANGXI_RADICAL_BADGER                                 0x2F98
#define unicode_KANGXI_RADICAL_SHELL                                  0x2F99
#define unicode_KANGXI_RADICAL_RED                                    0x2F9A
#define unicode_KANGXI_RADICAL_RUN                                    0x2F9B
#define unicode_KANGXI_RADICAL_FOOT                                   0x2F9C
#define unicode_KANGXI_RADICAL_BODY                                   0x2F9D
#define unicode_KANGXI_RADICAL_CART                                   0x2F9E
#define unicode_KANGXI_RADICAL_BITTER                                 0x2F9F
#define unicode_KANGXI_RADICAL_MORNING                                0x2FA0
#define unicode_KANGXI_RADICAL_WALK                                   0x2FA1
#define unicode_KANGXI_RADICAL_CITY                                   0x2FA2
#define unicode_KANGXI_RADICAL_WINE                                   0x2FA3
#define unicode_KANGXI_RADICAL_DISTINGUISH                            0x2FA4
#define unicode_KANGXI_RADICAL_VILLAGE                                0x2FA5
#define unicode_KANGXI_RADICAL_GOLD                                   0x2FA6
#define unicode_KANGXI_RADICAL_LONG                                   0x2FA7
#define unicode_KANGXI_RADICAL_GATE                                   0x2FA8
#define unicode_KANGXI_RADICAL_MOUND                                  0x2FA9
#define unicode_KANGXI_RADICAL_SLAVE                                  0x2FAA
#define unicode_KANGXI_RADICAL_SHORT_TAILED_BIRD                      0x2FAB
#define unicode_KANGXI_RADICAL_RAIN                                   0x2FAC
#define unicode_KANGXI_RADICAL_BLUE                                   0x2FAD
#define unicode_KANGXI_RADICAL_WRONG                                  0x2FAE
#define unicode_KANGXI_RADICAL_FACE                                   0x2FAF
#define unicode_KANGXI_RADICAL_LEATHER                                0x2FB0
#define unicode_KANGXI_RADICAL_TANNED_LEATHER                         0x2FB1
#define unicode_KANGXI_RADICAL_LEEK                                   0x2FB2
#define unicode_KANGXI_RADICAL_SOUND                                  0x2FB3
#define unicode_KANGXI_RADICAL_LEAF                                   0x2FB4
#define unicode_KANGXI_RADICAL_WIND                                   0x2FB5
#define unicode_KANGXI_RADICAL_FLY                                    0x2FB6
#define unicode_KANGXI_RADICAL_EAT                                    0x2FB7
#define unicode_KANGXI_RADICAL_HEAD                                   0x2FB8
#define unicode_KANGXI_RADICAL_FRAGRANT                               0x2FB9
#define unicode_KANGXI_RADICAL_HORSE                                  0x2FBA
#define unicode_KANGXI_RADICAL_BONE                                   0x2FBB
#define unicode_KANGXI_RADICAL_TALL                                   0x2FBC
#define unicode_KANGXI_RADICAL_HAIR                                   0x2FBD
#define unicode_KANGXI_RADICAL_FIGHT                                  0x2FBE
#define unicode_KANGXI_RADICAL_SACRIFICIAL_WINE                       0x2FBF
#define unicode_KANGXI_RADICAL_CAULDRON                               0x2FC0
#define unicode_KANGXI_RADICAL_GHOST                                  0x2FC1
#define unicode_KANGXI_RADICAL_FISH                                   0x2FC2
#define unicode_KANGXI_RADICAL_BIRD                                   0x2FC3
#define unicode_KANGXI_RADICAL_SALT                                   0x2FC4
#define unicode_KANGXI_RADICAL_DEER                                   0x2FC5
#define unicode_KANGXI_RADICAL_WHEAT                                  0x2FC6
#define unicode_KANGXI_RADICAL_HEMP                                   0x2FC7
#define unicode_KANGXI_RADICAL_YELLOW                                 0x2FC8
#define unicode_KANGXI_RADICAL_MILLET                                 0x2FC9
#define unicode_KANGXI_RADICAL_BLACK                                  0x2FCA
#define unicode_KANGXI_RADICAL_EMBROIDERY                             0x2FCB
#define unicode_KANGXI_RADICAL_FROG                                   0x2FCC
#define unicode_KANGXI_RADICAL_TRIPOD                                 0x2FCD
#define unicode_KANGXI_RADICAL_DRUM                                   0x2FCE
#define unicode_KANGXI_RADICAL_RAT                                    0x2FCF
#define unicode_KANGXI_RADICAL_NOSE                                   0x2FD0
#define unicode_KANGXI_RADICAL_EVEN                                   0x2FD1
#define unicode_KANGXI_RADICAL_TOOTH                                  0x2FD2
#define unicode_KANGXI_RADICAL_DRAGON                                 0x2FD3
#define unicode_KANGXI_RADICAL_TURTLE                                 0x2FD4
#define unicode_KANGXI_RADICAL_FLUTE                                  0x2FD5
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_LEFT_TO_RIGHT       0x2FF0
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_ABOVE_TO_BELOW      0x2FF1
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_LEFT_TO_MIDDLE_AND_RIGHT 0x2FF2
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_ABOVE_TO_MIDDLE_AND_BELOW 0x2FF3
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_FULL_SURROUND       0x2FF4
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_ABOVE 0x2FF5
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_BELOW 0x2FF6
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_LEFT  0x2FF7
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_UPPER_LEFT 0x2FF8
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_UPPER_RIGHT 0x2FF9
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_LOWER_LEFT 0x2FFA
#define unicode_IDEOGRAPHIC_DESCRIPTION_CHARACTER_OVERLAID            0x2FFB
#define unicode_IDEOGRAPHIC_SPACE                                     0x3000
#define unicode_IDEOGRAPHIC_COMMA                                     0x3001
#define unicode_IDEOGRAPHIC_FULL_STOP                                 0x3002
#define unicode_DITTO_MARK                                            0x3003
#define unicode_JAPANESE_INDUSTRIAL_STANDARD_SYMBOL                   0x3004
#define unicode_IDEOGRAPHIC_ITERATION_MARK                            0x3005
#define unicode_IDEOGRAPHIC_CLOSING_MARK                              0x3006
#define unicode_IDEOGRAPHIC_NUMBER_ZERO                               0x3007
#define unicode_LEFT_ANGLE_BRACKET                                    0x3008
#define unicode_RIGHT_ANGLE_BRACKET                                   0x3009
#define unicode_LEFT_DOUBLE_ANGLE_BRACKET                             0x300A
#define unicode_RIGHT_DOUBLE_ANGLE_BRACKET                            0x300B
#define unicode_LEFT_CORNER_BRACKET                                   0x300C
#define unicode_RIGHT_CORNER_BRACKET                                  0x300D
#define unicode_LEFT_WHITE_CORNER_BRACKET                             0x300E
#define unicode_RIGHT_WHITE_CORNER_BRACKET                            0x300F
#define unicode_LEFT_BLACK_LENTICULAR_BRACKET                         0x3010
#define unicode_RIGHT_BLACK_LENTICULAR_BRACKET                        0x3011
#define unicode_POSTAL_MARK                                           0x3012
#define unicode_GETA_MARK                                             0x3013
#define unicode_LEFT_TORTOISE_SHELL_BRACKET                           0x3014
#define unicode_RIGHT_TORTOISE_SHELL_BRACKET                          0x3015
#define unicode_LEFT_WHITE_LENTICULAR_BRACKET                         0x3016
#define unicode_RIGHT_WHITE_LENTICULAR_BRACKET                        0x3017
#define unicode_LEFT_WHITE_TORTOISE_SHELL_BRACKET                     0x3018
#define unicode_RIGHT_WHITE_TORTOISE_SHELL_BRACKET                    0x3019
#define unicode_LEFT_WHITE_SQUARE_BRACKET                             0x301A
#define unicode_RIGHT_WHITE_SQUARE_BRACKET                            0x301B
#define unicode_WAVE_DASH                                             0x301C
#define unicode_REVERSED_DOUBLE_PRIME_QUOTATION_MARK                  0x301D
#define unicode_DOUBLE_PRIME_QUOTATION_MARK                           0x301E
#define unicode_LOW_DOUBLE_PRIME_QUOTATION_MARK                       0x301F
#define unicode_POSTAL_MARK_FACE                                      0x3020
#define unicode_HANGZHOU_NUMERAL_ONE                                  0x3021
#define unicode_HANGZHOU_NUMERAL_TWO                                  0x3022
#define unicode_HANGZHOU_NUMERAL_THREE                                0x3023
#define unicode_HANGZHOU_NUMERAL_FOUR                                 0x3024
#define unicode_HANGZHOU_NUMERAL_FIVE                                 0x3025
#define unicode_HANGZHOU_NUMERAL_SIX                                  0x3026
#define unicode_HANGZHOU_NUMERAL_SEVEN                                0x3027
#define unicode_HANGZHOU_NUMERAL_EIGHT                                0x3028
#define unicode_HANGZHOU_NUMERAL_NINE                                 0x3029
#define unicode_IDEOGRAPHIC_LEVEL_TONE_MARK                           0x302A
#define unicode_IDEOGRAPHIC_RISING_TONE_MARK                          0x302B
#define unicode_IDEOGRAPHIC_DEPARTING_TONE_MARK                       0x302C
#define unicode_IDEOGRAPHIC_ENTERING_TONE_MARK                        0x302D
#define unicode_HANGUL_SINGLE_DOT_TONE_MARK                           0x302E
#define unicode_HANGUL_DOUBLE_DOT_TONE_MARK                           0x302F
#define unicode_WAVY_DASH                                             0x3030
#define unicode_VERTICAL_KANA_REPEAT_MARK                             0x3031
#define unicode_VERTICAL_KANA_REPEAT_WITH_VOICED_SOUND_MARK           0x3032
#define unicode_VERTICAL_KANA_REPEAT_MARK_UPPER_HALF                  0x3033
#define unicode_VERTICAL_KANA_REPEAT_WITH_VOICED_SOUND_MARK_UPPER_HALF 0x3034
#define unicode_VERTICAL_KANA_REPEAT_MARK_LOWER_HALF                  0x3035
#define unicode_CIRCLED_POSTAL_MARK                                   0x3036
#define unicode_IDEOGRAPHIC_TELEGRAPH_LINE_FEED_SEPARATOR_SYMBOL      0x3037
#define unicode_HANGZHOU_NUMERAL_TEN                                  0x3038
#define unicode_HANGZHOU_NUMERAL_TWENTY                               0x3039
#define unicode_HANGZHOU_NUMERAL_THIRTY                               0x303A
#define unicode_VERTICAL_IDEOGRAPHIC_ITERATION_MARK                   0x303B
#define unicode_MASU_MARK                                             0x303C
#define unicode_PART_ALTERNATION_MARK                                 0x303D
#define unicode_IDEOGRAPHIC_VARIATION_INDICATOR                       0x303E
#define unicode_IDEOGRAPHIC_HALF_FILL_SPACE                           0x303F
#define unicode_HIRAGANA_LETTER_SMALL_A                               0x3041
#define unicode_HIRAGANA_LETTER_A                                     0x3042
#define unicode_HIRAGANA_LETTER_SMALL_I                               0x3043
#define unicode_HIRAGANA_LETTER_I                                     0x3044
#define unicode_HIRAGANA_LETTER_SMALL_U                               0x3045
#define unicode_HIRAGANA_LETTER_U                                     0x3046
#define unicode_HIRAGANA_LETTER_SMALL_E                               0x3047
#define unicode_HIRAGANA_LETTER_E                                     0x3048
#define unicode_HIRAGANA_LETTER_SMALL_O                               0x3049
#define unicode_HIRAGANA_LETTER_O                                     0x304A
#define unicode_HIRAGANA_LETTER_KA                                    0x304B
#define unicode_HIRAGANA_LETTER_GA                                    0x304C
#define unicode_HIRAGANA_LETTER_KI                                    0x304D
#define unicode_HIRAGANA_LETTER_GI                                    0x304E
#define unicode_HIRAGANA_LETTER_KU                                    0x304F
#define unicode_HIRAGANA_LETTER_GU                                    0x3050
#define unicode_HIRAGANA_LETTER_KE                                    0x3051
#define unicode_HIRAGANA_LETTER_GE                                    0x3052
#define unicode_HIRAGANA_LETTER_KO                                    0x3053
#define unicode_HIRAGANA_LETTER_GO                                    0x3054
#define unicode_HIRAGANA_LETTER_SA                                    0x3055
#define unicode_HIRAGANA_LETTER_ZA                                    0x3056
#define unicode_HIRAGANA_LETTER_SI                                    0x3057
#define unicode_HIRAGANA_LETTER_ZI                                    0x3058
#define unicode_HIRAGANA_LETTER_SU                                    0x3059
#define unicode_HIRAGANA_LETTER_ZU                                    0x305A
#define unicode_HIRAGANA_LETTER_SE                                    0x305B
#define unicode_HIRAGANA_LETTER_ZE                                    0x305C
#define unicode_HIRAGANA_LETTER_SO                                    0x305D
#define unicode_HIRAGANA_LETTER_ZO                                    0x305E
#define unicode_HIRAGANA_LETTER_TA                                    0x305F
#define unicode_HIRAGANA_LETTER_DA                                    0x3060
#define unicode_HIRAGANA_LETTER_TI                                    0x3061
#define unicode_HIRAGANA_LETTER_DI                                    0x3062
#define unicode_HIRAGANA_LETTER_SMALL_TU                              0x3063
#define unicode_HIRAGANA_LETTER_TU                                    0x3064
#define unicode_HIRAGANA_LETTER_DU                                    0x3065
#define unicode_HIRAGANA_LETTER_TE                                    0x3066
#define unicode_HIRAGANA_LETTER_DE                                    0x3067
#define unicode_HIRAGANA_LETTER_TO                                    0x3068
#define unicode_HIRAGANA_LETTER_DO                                    0x3069
#define unicode_HIRAGANA_LETTER_NA                                    0x306A
#define unicode_HIRAGANA_LETTER_NI                                    0x306B
#define unicode_HIRAGANA_LETTER_NU                                    0x306C
#define unicode_HIRAGANA_LETTER_NE                                    0x306D
#define unicode_HIRAGANA_LETTER_NO                                    0x306E
#define unicode_HIRAGANA_LETTER_HA                                    0x306F
#define unicode_HIRAGANA_LETTER_BA                                    0x3070
#define unicode_HIRAGANA_LETTER_PA                                    0x3071
#define unicode_HIRAGANA_LETTER_HI                                    0x3072
#define unicode_HIRAGANA_LETTER_BI                                    0x3073
#define unicode_HIRAGANA_LETTER_PI                                    0x3074
#define unicode_HIRAGANA_LETTER_HU                                    0x3075
#define unicode_HIRAGANA_LETTER_BU                                    0x3076
#define unicode_HIRAGANA_LETTER_PU                                    0x3077
#define unicode_HIRAGANA_LETTER_HE                                    0x3078
#define unicode_HIRAGANA_LETTER_BE                                    0x3079
#define unicode_HIRAGANA_LETTER_PE                                    0x307A
#define unicode_HIRAGANA_LETTER_HO                                    0x307B
#define unicode_HIRAGANA_LETTER_BO                                    0x307C
#define unicode_HIRAGANA_LETTER_PO                                    0x307D
#define unicode_HIRAGANA_LETTER_MA                                    0x307E
#define unicode_HIRAGANA_LETTER_MI                                    0x307F
#define unicode_HIRAGANA_LETTER_MU                                    0x3080
#define unicode_HIRAGANA_LETTER_ME                                    0x3081
#define unicode_HIRAGANA_LETTER_MO                                    0x3082
#define unicode_HIRAGANA_LETTER_SMALL_YA                              0x3083
#define unicode_HIRAGANA_LETTER_YA                                    0x3084
#define unicode_HIRAGANA_LETTER_SMALL_YU                              0x3085
#define unicode_HIRAGANA_LETTER_YU                                    0x3086
#define unicode_HIRAGANA_LETTER_SMALL_YO                              0x3087
#define unicode_HIRAGANA_LETTER_YO                                    0x3088
#define unicode_HIRAGANA_LETTER_RA                                    0x3089
#define unicode_HIRAGANA_LETTER_RI                                    0x308A
#define unicode_HIRAGANA_LETTER_RU                                    0x308B
#define unicode_HIRAGANA_LETTER_RE                                    0x308C
#define unicode_HIRAGANA_LETTER_RO                                    0x308D
#define unicode_HIRAGANA_LETTER_SMALL_WA                              0x308E
#define unicode_HIRAGANA_LETTER_WA                                    0x308F
#define unicode_HIRAGANA_LETTER_WI                                    0x3090
#define unicode_HIRAGANA_LETTER_WE                                    0x3091
#define unicode_HIRAGANA_LETTER_WO                                    0x3092
#define unicode_HIRAGANA_LETTER_N                                     0x3093
#define unicode_HIRAGANA_LETTER_VU                                    0x3094
#define unicode_HIRAGANA_LETTER_SMALL_KA                              0x3095
#define unicode_HIRAGANA_LETTER_SMALL_KE                              0x3096
#define unicode_COMBINING_KATAKANA_HIRAGANA_VOICED_SOUND_MARK         0x3099
#define unicode_COMBINING_KATAKANA_HIRAGANA_SEMI_VOICED_SOUND_MARK    0x309A
#define unicode_KATAKANA_HIRAGANA_VOICED_SOUND_MARK                   0x309B
#define unicode_KATAKANA_HIRAGANA_SEMI_VOICED_SOUND_MARK              0x309C
#define unicode_HIRAGANA_ITERATION_MARK                               0x309D
#define unicode_HIRAGANA_VOICED_ITERATION_MARK                        0x309E
#define unicode_HIRAGANA_DIGRAPH_YORI                                 0x309F
#define unicode_KATAKANA_HIRAGANA_DOUBLE_HYPHEN                       0x30A0
#define unicode_KATAKANA_LETTER_SMALL_A                               0x30A1
#define unicode_KATAKANA_LETTER_A                                     0x30A2
#define unicode_KATAKANA_LETTER_SMALL_I                               0x30A3
#define unicode_KATAKANA_LETTER_I                                     0x30A4
#define unicode_KATAKANA_LETTER_SMALL_U                               0x30A5
#define unicode_KATAKANA_LETTER_U                                     0x30A6
#define unicode_KATAKANA_LETTER_SMALL_E                               0x30A7
#define unicode_KATAKANA_LETTER_E                                     0x30A8
#define unicode_KATAKANA_LETTER_SMALL_O                               0x30A9
#define unicode_KATAKANA_LETTER_O                                     0x30AA
#define unicode_KATAKANA_LETTER_KA                                    0x30AB
#define unicode_KATAKANA_LETTER_GA                                    0x30AC
#define unicode_KATAKANA_LETTER_KI                                    0x30AD
#define unicode_KATAKANA_LETTER_GI                                    0x30AE
#define unicode_KATAKANA_LETTER_KU                                    0x30AF
#define unicode_KATAKANA_LETTER_GU                                    0x30B0
#define unicode_KATAKANA_LETTER_KE                                    0x30B1
#define unicode_KATAKANA_LETTER_GE                                    0x30B2
#define unicode_KATAKANA_LETTER_KO                                    0x30B3
#define unicode_KATAKANA_LETTER_GO                                    0x30B4
#define unicode_KATAKANA_LETTER_SA                                    0x30B5
#define unicode_KATAKANA_LETTER_ZA                                    0x30B6
#define unicode_KATAKANA_LETTER_SI                                    0x30B7
#define unicode_KATAKANA_LETTER_ZI                                    0x30B8
#define unicode_KATAKANA_LETTER_SU                                    0x30B9
#define unicode_KATAKANA_LETTER_ZU                                    0x30BA
#define unicode_KATAKANA_LETTER_SE                                    0x30BB
#define unicode_KATAKANA_LETTER_ZE                                    0x30BC
#define unicode_KATAKANA_LETTER_SO                                    0x30BD
#define unicode_KATAKANA_LETTER_ZO                                    0x30BE
#define unicode_KATAKANA_LETTER_TA                                    0x30BF
#define unicode_KATAKANA_LETTER_DA                                    0x30C0
#define unicode_KATAKANA_LETTER_TI                                    0x30C1
#define unicode_KATAKANA_LETTER_DI                                    0x30C2
#define unicode_KATAKANA_LETTER_SMALL_TU                              0x30C3
#define unicode_KATAKANA_LETTER_TU                                    0x30C4
#define unicode_KATAKANA_LETTER_DU                                    0x30C5
#define unicode_KATAKANA_LETTER_TE                                    0x30C6
#define unicode_KATAKANA_LETTER_DE                                    0x30C7
#define unicode_KATAKANA_LETTER_TO                                    0x30C8
#define unicode_KATAKANA_LETTER_DO                                    0x30C9
#define unicode_KATAKANA_LETTER_NA                                    0x30CA
#define unicode_KATAKANA_LETTER_NI                                    0x30CB
#define unicode_KATAKANA_LETTER_NU                                    0x30CC
#define unicode_KATAKANA_LETTER_NE                                    0x30CD
#define unicode_KATAKANA_LETTER_NO                                    0x30CE
#define unicode_KATAKANA_LETTER_HA                                    0x30CF
#define unicode_KATAKANA_LETTER_BA                                    0x30D0
#define unicode_KATAKANA_LETTER_PA                                    0x30D1
#define unicode_KATAKANA_LETTER_HI                                    0x30D2
#define unicode_KATAKANA_LETTER_BI                                    0x30D3
#define unicode_KATAKANA_LETTER_PI                                    0x30D4
#define unicode_KATAKANA_LETTER_HU                                    0x30D5
#define unicode_KATAKANA_LETTER_BU                                    0x30D6
#define unicode_KATAKANA_LETTER_PU                                    0x30D7
#define unicode_KATAKANA_LETTER_HE                                    0x30D8
#define unicode_KATAKANA_LETTER_BE                                    0x30D9
#define unicode_KATAKANA_LETTER_PE                                    0x30DA
#define unicode_KATAKANA_LETTER_HO                                    0x30DB
#define unicode_KATAKANA_LETTER_BO                                    0x30DC
#define unicode_KATAKANA_LETTER_PO                                    0x30DD
#define unicode_KATAKANA_LETTER_MA                                    0x30DE
#define unicode_KATAKANA_LETTER_MI                                    0x30DF
#define unicode_KATAKANA_LETTER_MU                                    0x30E0
#define unicode_KATAKANA_LETTER_ME                                    0x30E1
#define unicode_KATAKANA_LETTER_MO                                    0x30E2
#define unicode_KATAKANA_LETTER_SMALL_YA                              0x30E3
#define unicode_KATAKANA_LETTER_YA                                    0x30E4
#define unicode_KATAKANA_LETTER_SMALL_YU                              0x30E5
#define unicode_KATAKANA_LETTER_YU                                    0x30E6
#define unicode_KATAKANA_LETTER_SMALL_YO                              0x30E7
#define unicode_KATAKANA_LETTER_YO                                    0x30E8
#define unicode_KATAKANA_LETTER_RA                                    0x30E9
#define unicode_KATAKANA_LETTER_RI                                    0x30EA
#define unicode_KATAKANA_LETTER_RU                                    0x30EB
#define unicode_KATAKANA_LETTER_RE                                    0x30EC
#define unicode_KATAKANA_LETTER_RO                                    0x30ED
#define unicode_KATAKANA_LETTER_SMALL_WA                              0x30EE
#define unicode_KATAKANA_LETTER_WA                                    0x30EF
#define unicode_KATAKANA_LETTER_WI                                    0x30F0
#define unicode_KATAKANA_LETTER_WE                                    0x30F1
#define unicode_KATAKANA_LETTER_WO                                    0x30F2
#define unicode_KATAKANA_LETTER_N                                     0x30F3
#define unicode_KATAKANA_LETTER_VU                                    0x30F4
#define unicode_KATAKANA_LETTER_SMALL_KA                              0x30F5
#define unicode_KATAKANA_LETTER_SMALL_KE                              0x30F6
#define unicode_KATAKANA_LETTER_VA                                    0x30F7
#define unicode_KATAKANA_LETTER_VI                                    0x30F8
#define unicode_KATAKANA_LETTER_VE                                    0x30F9
#define unicode_KATAKANA_LETTER_VO                                    0x30FA
#define unicode_KATAKANA_MIDDLE_DOT                                   0x30FB
#define unicode_KATAKANA_HIRAGANA_PROLONGED_SOUND_MARK                0x30FC
#define unicode_KATAKANA_ITERATION_MARK                               0x30FD
#define unicode_KATAKANA_VOICED_ITERATION_MARK                        0x30FE
#define unicode_KATAKANA_DIGRAPH_KOTO                                 0x30FF
#define unicode_BOPOMOFO_LETTER_B                                     0x3105
#define unicode_BOPOMOFO_LETTER_P                                     0x3106
#define unicode_BOPOMOFO_LETTER_M                                     0x3107
#define unicode_BOPOMOFO_LETTER_F                                     0x3108
#define unicode_BOPOMOFO_LETTER_D                                     0x3109
#define unicode_BOPOMOFO_LETTER_T                                     0x310A
#define unicode_BOPOMOFO_LETTER_N                                     0x310B
#define unicode_BOPOMOFO_LETTER_L                                     0x310C
#define unicode_BOPOMOFO_LETTER_G                                     0x310D
#define unicode_BOPOMOFO_LETTER_K                                     0x310E
#define unicode_BOPOMOFO_LETTER_H                                     0x310F
#define unicode_BOPOMOFO_LETTER_J                                     0x3110
#define unicode_BOPOMOFO_LETTER_Q                                     0x3111
#define unicode_BOPOMOFO_LETTER_X                                     0x3112
#define unicode_BOPOMOFO_LETTER_ZH                                    0x3113
#define unicode_BOPOMOFO_LETTER_CH                                    0x3114
#define unicode_BOPOMOFO_LETTER_SH                                    0x3115
#define unicode_BOPOMOFO_LETTER_R                                     0x3116
#define unicode_BOPOMOFO_LETTER_Z                                     0x3117
#define unicode_BOPOMOFO_LETTER_C                                     0x3118
#define unicode_BOPOMOFO_LETTER_S                                     0x3119
#define unicode_BOPOMOFO_LETTER_A                                     0x311A
#define unicode_BOPOMOFO_LETTER_O                                     0x311B
#define unicode_BOPOMOFO_LETTER_E                                     0x311C
#define unicode_BOPOMOFO_LETTER_EH                                    0x311D
#define unicode_BOPOMOFO_LETTER_AI                                    0x311E
#define unicode_BOPOMOFO_LETTER_EI                                    0x311F
#define unicode_BOPOMOFO_LETTER_AU                                    0x3120
#define unicode_BOPOMOFO_LETTER_OU                                    0x3121
#define unicode_BOPOMOFO_LETTER_AN                                    0x3122
#define unicode_BOPOMOFO_LETTER_EN                                    0x3123
#define unicode_BOPOMOFO_LETTER_ANG                                   0x3124
#define unicode_BOPOMOFO_LETTER_ENG                                   0x3125
#define unicode_BOPOMOFO_LETTER_ER                                    0x3126
#define unicode_BOPOMOFO_LETTER_I                                     0x3127
#define unicode_BOPOMOFO_LETTER_U                                     0x3128
#define unicode_BOPOMOFO_LETTER_IU                                    0x3129
#define unicode_BOPOMOFO_LETTER_V                                     0x312A
#define unicode_BOPOMOFO_LETTER_NG                                    0x312B
#define unicode_BOPOMOFO_LETTER_GN                                    0x312C
#define unicode_BOPOMOFO_LETTER_IH                                    0x312D
#define unicode_HANGUL_LETTER_KIYEOK                                  0x3131
#define unicode_HANGUL_LETTER_SSANGKIYEOK                             0x3132
#define unicode_HANGUL_LETTER_KIYEOK_SIOS                             0x3133
#define unicode_HANGUL_LETTER_NIEUN                                   0x3134
#define unicode_HANGUL_LETTER_NIEUN_CIEUC                             0x3135
#define unicode_HANGUL_LETTER_NIEUN_HIEUH                             0x3136
#define unicode_HANGUL_LETTER_TIKEUT                                  0x3137
#define unicode_HANGUL_LETTER_SSANGTIKEUT                             0x3138
#define unicode_HANGUL_LETTER_RIEUL                                   0x3139
#define unicode_HANGUL_LETTER_RIEUL_KIYEOK                            0x313A
#define unicode_HANGUL_LETTER_RIEUL_MIEUM                             0x313B
#define unicode_HANGUL_LETTER_RIEUL_PIEUP                             0x313C
#define unicode_HANGUL_LETTER_RIEUL_SIOS                              0x313D
#define unicode_HANGUL_LETTER_RIEUL_THIEUTH                           0x313E
#define unicode_HANGUL_LETTER_RIEUL_PHIEUPH                           0x313F
#define unicode_HANGUL_LETTER_RIEUL_HIEUH                             0x3140
#define unicode_HANGUL_LETTER_MIEUM                                   0x3141
#define unicode_HANGUL_LETTER_PIEUP                                   0x3142
#define unicode_HANGUL_LETTER_SSANGPIEUP                              0x3143
#define unicode_HANGUL_LETTER_PIEUP_SIOS                              0x3144
#define unicode_HANGUL_LETTER_SIOS                                    0x3145
#define unicode_HANGUL_LETTER_SSANGSIOS                               0x3146
#define unicode_HANGUL_LETTER_IEUNG                                   0x3147
#define unicode_HANGUL_LETTER_CIEUC                                   0x3148
#define unicode_HANGUL_LETTER_SSANGCIEUC                              0x3149
#define unicode_HANGUL_LETTER_CHIEUCH                                 0x314A
#define unicode_HANGUL_LETTER_KHIEUKH                                 0x314B
#define unicode_HANGUL_LETTER_THIEUTH                                 0x314C
#define unicode_HANGUL_LETTER_PHIEUPH                                 0x314D
#define unicode_HANGUL_LETTER_HIEUH                                   0x314E
#define unicode_HANGUL_LETTER_A                                       0x314F
#define unicode_HANGUL_LETTER_AE                                      0x3150
#define unicode_HANGUL_LETTER_YA                                      0x3151
#define unicode_HANGUL_LETTER_YAE                                     0x3152
#define unicode_HANGUL_LETTER_EO                                      0x3153
#define unicode_HANGUL_LETTER_E                                       0x3154
#define unicode_HANGUL_LETTER_YEO                                     0x3155
#define unicode_HANGUL_LETTER_YE                                      0x3156
#define unicode_HANGUL_LETTER_O                                       0x3157
#define unicode_HANGUL_LETTER_WA                                      0x3158
#define unicode_HANGUL_LETTER_WAE                                     0x3159
#define unicode_HANGUL_LETTER_OE                                      0x315A
#define unicode_HANGUL_LETTER_YO                                      0x315B
#define unicode_HANGUL_LETTER_U                                       0x315C
#define unicode_HANGUL_LETTER_WEO                                     0x315D
#define unicode_HANGUL_LETTER_WE                                      0x315E
#define unicode_HANGUL_LETTER_WI                                      0x315F
#define unicode_HANGUL_LETTER_YU                                      0x3160
#define unicode_HANGUL_LETTER_EU                                      0x3161
#define unicode_HANGUL_LETTER_YI                                      0x3162
#define unicode_HANGUL_LETTER_I                                       0x3163
#define unicode_HANGUL_FILLER                                         0x3164
#define unicode_HANGUL_LETTER_SSANGNIEUN                              0x3165
#define unicode_HANGUL_LETTER_NIEUN_TIKEUT                            0x3166
#define unicode_HANGUL_LETTER_NIEUN_SIOS                              0x3167
#define unicode_HANGUL_LETTER_NIEUN_PANSIOS                           0x3168
#define unicode_HANGUL_LETTER_RIEUL_KIYEOK_SIOS                       0x3169
#define unicode_HANGUL_LETTER_RIEUL_TIKEUT                            0x316A
#define unicode_HANGUL_LETTER_RIEUL_PIEUP_SIOS                        0x316B
#define unicode_HANGUL_LETTER_RIEUL_PANSIOS                           0x316C
#define unicode_HANGUL_LETTER_RIEUL_YEORINHIEUH                       0x316D
#define unicode_HANGUL_LETTER_MIEUM_PIEUP                             0x316E
#define unicode_HANGUL_LETTER_MIEUM_SIOS                              0x316F
#define unicode_HANGUL_LETTER_MIEUM_PANSIOS                           0x3170
#define unicode_HANGUL_LETTER_KAPYEOUNMIEUM                           0x3171
#define unicode_HANGUL_LETTER_PIEUP_KIYEOK                            0x3172
#define unicode_HANGUL_LETTER_PIEUP_TIKEUT                            0x3173
#define unicode_HANGUL_LETTER_PIEUP_SIOS_KIYEOK                       0x3174
#define unicode_HANGUL_LETTER_PIEUP_SIOS_TIKEUT                       0x3175
#define unicode_HANGUL_LETTER_PIEUP_CIEUC                             0x3176
#define unicode_HANGUL_LETTER_PIEUP_THIEUTH                           0x3177
#define unicode_HANGUL_LETTER_KAPYEOUNPIEUP                           0x3178
#define unicode_HANGUL_LETTER_KAPYEOUNSSANGPIEUP                      0x3179
#define unicode_HANGUL_LETTER_SIOS_KIYEOK                             0x317A
#define unicode_HANGUL_LETTER_SIOS_NIEUN                              0x317B
#define unicode_HANGUL_LETTER_SIOS_TIKEUT                             0x317C
#define unicode_HANGUL_LETTER_SIOS_PIEUP                              0x317D
#define unicode_HANGUL_LETTER_SIOS_CIEUC                              0x317E
#define unicode_HANGUL_LETTER_PANSIOS                                 0x317F
#define unicode_HANGUL_LETTER_SSANGIEUNG                              0x3180
#define unicode_HANGUL_LETTER_YESIEUNG                                0x3181
#define unicode_HANGUL_LETTER_YESIEUNG_SIOS                           0x3182
#define unicode_HANGUL_LETTER_YESIEUNG_PANSIOS                        0x3183
#define unicode_HANGUL_LETTER_KAPYEOUNPHIEUPH                         0x3184
#define unicode_HANGUL_LETTER_SSANGHIEUH                              0x3185
#define unicode_HANGUL_LETTER_YEORINHIEUH                             0x3186
#define unicode_HANGUL_LETTER_YO_YA                                   0x3187
#define unicode_HANGUL_LETTER_YO_YAE                                  0x3188
#define unicode_HANGUL_LETTER_YO_I                                    0x3189
#define unicode_HANGUL_LETTER_YU_YEO                                  0x318A
#define unicode_HANGUL_LETTER_YU_YE                                   0x318B
#define unicode_HANGUL_LETTER_YU_I                                    0x318C
#define unicode_HANGUL_LETTER_ARAEA                                   0x318D
#define unicode_HANGUL_LETTER_ARAEAE                                  0x318E
#define unicode_IDEOGRAPHIC_ANNOTATION_LINKING_MARK                   0x3190
#define unicode_IDEOGRAPHIC_ANNOTATION_REVERSE_MARK                   0x3191
#define unicode_IDEOGRAPHIC_ANNOTATION_ONE_MARK                       0x3192
#define unicode_IDEOGRAPHIC_ANNOTATION_TWO_MARK                       0x3193
#define unicode_IDEOGRAPHIC_ANNOTATION_THREE_MARK                     0x3194
#define unicode_IDEOGRAPHIC_ANNOTATION_FOUR_MARK                      0x3195
#define unicode_IDEOGRAPHIC_ANNOTATION_TOP_MARK                       0x3196
#define unicode_IDEOGRAPHIC_ANNOTATION_MIDDLE_MARK                    0x3197
#define unicode_IDEOGRAPHIC_ANNOTATION_BOTTOM_MARK                    0x3198
#define unicode_IDEOGRAPHIC_ANNOTATION_FIRST_MARK                     0x3199
#define unicode_IDEOGRAPHIC_ANNOTATION_SECOND_MARK                    0x319A
#define unicode_IDEOGRAPHIC_ANNOTATION_THIRD_MARK                     0x319B
#define unicode_IDEOGRAPHIC_ANNOTATION_FOURTH_MARK                    0x319C
#define unicode_IDEOGRAPHIC_ANNOTATION_HEAVEN_MARK                    0x319D
#define unicode_IDEOGRAPHIC_ANNOTATION_EARTH_MARK                     0x319E
#define unicode_IDEOGRAPHIC_ANNOTATION_MAN_MARK                       0x319F
#define unicode_BOPOMOFO_LETTER_BU                                    0x31A0
#define unicode_BOPOMOFO_LETTER_ZI                                    0x31A1
#define unicode_BOPOMOFO_LETTER_JI                                    0x31A2
#define unicode_BOPOMOFO_LETTER_GU                                    0x31A3
#define unicode_BOPOMOFO_LETTER_EE                                    0x31A4
#define unicode_BOPOMOFO_LETTER_ENN                                   0x31A5
#define unicode_BOPOMOFO_LETTER_OO                                    0x31A6
#define unicode_BOPOMOFO_LETTER_ONN                                   0x31A7
#define unicode_BOPOMOFO_LETTER_IR                                    0x31A8
#define unicode_BOPOMOFO_LETTER_ANN                                   0x31A9
#define unicode_BOPOMOFO_LETTER_INN                                   0x31AA
#define unicode_BOPOMOFO_LETTER_UNN                                   0x31AB
#define unicode_BOPOMOFO_LETTER_IM                                    0x31AC
#define unicode_BOPOMOFO_LETTER_NGG                                   0x31AD
#define unicode_BOPOMOFO_LETTER_AINN                                  0x31AE
#define unicode_BOPOMOFO_LETTER_AUNN                                  0x31AF
#define unicode_BOPOMOFO_LETTER_AM                                    0x31B0
#define unicode_BOPOMOFO_LETTER_OM                                    0x31B1
#define unicode_BOPOMOFO_LETTER_ONG                                   0x31B2
#define unicode_BOPOMOFO_LETTER_INNN                                  0x31B3
#define unicode_BOPOMOFO_FINAL_LETTER_P                               0x31B4
#define unicode_BOPOMOFO_FINAL_LETTER_T                               0x31B5
#define unicode_BOPOMOFO_FINAL_LETTER_K                               0x31B6
#define unicode_BOPOMOFO_FINAL_LETTER_H                               0x31B7
#define unicode_BOPOMOFO_LETTER_GH                                    0x31B8
#define unicode_BOPOMOFO_LETTER_LH                                    0x31B9
#define unicode_BOPOMOFO_LETTER_ZY                                    0x31BA
#define unicode_CJK_STROKE_T                                          0x31C0
#define unicode_CJK_STROKE_WG                                         0x31C1
#define unicode_CJK_STROKE_XG                                         0x31C2
#define unicode_CJK_STROKE_BXG                                        0x31C3
#define unicode_CJK_STROKE_SW                                         0x31C4
#define unicode_CJK_STROKE_HZZ                                        0x31C5
#define unicode_CJK_STROKE_HZG                                        0x31C6
#define unicode_CJK_STROKE_HP                                         0x31C7
#define unicode_CJK_STROKE_HZWG                                       0x31C8
#define unicode_CJK_STROKE_SZWG                                       0x31C9
#define unicode_CJK_STROKE_HZT                                        0x31CA
#define unicode_CJK_STROKE_HZZP                                       0x31CB
#define unicode_CJK_STROKE_HPWG                                       0x31CC
#define unicode_CJK_STROKE_HZW                                        0x31CD
#define unicode_CJK_STROKE_HZZZ                                       0x31CE
#define unicode_CJK_STROKE_N                                          0x31CF
#define unicode_CJK_STROKE_H                                          0x31D0
#define unicode_CJK_STROKE_S                                          0x31D1
#define unicode_CJK_STROKE_P                                          0x31D2
#define unicode_CJK_STROKE_SP                                         0x31D3
#define unicode_CJK_STROKE_D                                          0x31D4
#define unicode_CJK_STROKE_HZ                                         0x31D5
#define unicode_CJK_STROKE_HG                                         0x31D6
#define unicode_CJK_STROKE_SZ                                         0x31D7
#define unicode_CJK_STROKE_SWZ                                        0x31D8
#define unicode_CJK_STROKE_ST                                         0x31D9
#define unicode_CJK_STROKE_SG                                         0x31DA
#define unicode_CJK_STROKE_PD                                         0x31DB
#define unicode_CJK_STROKE_PZ                                         0x31DC
#define unicode_CJK_STROKE_TN                                         0x31DD
#define unicode_CJK_STROKE_SZZ                                        0x31DE
#define unicode_CJK_STROKE_SWG                                        0x31DF
#define unicode_CJK_STROKE_HXWG                                       0x31E0
#define unicode_CJK_STROKE_HZZZG                                      0x31E1
#define unicode_CJK_STROKE_PG                                         0x31E2
#define unicode_CJK_STROKE_Q                                          0x31E3
#define unicode_KATAKANA_LETTER_SMALL_KU                              0x31F0
#define unicode_KATAKANA_LETTER_SMALL_SI                              0x31F1
#define unicode_KATAKANA_LETTER_SMALL_SU                              0x31F2
#define unicode_KATAKANA_LETTER_SMALL_TO                              0x31F3
#define unicode_KATAKANA_LETTER_SMALL_NU                              0x31F4
#define unicode_KATAKANA_LETTER_SMALL_HA                              0x31F5
#define unicode_KATAKANA_LETTER_SMALL_HI                              0x31F6
#define unicode_KATAKANA_LETTER_SMALL_HU                              0x31F7
#define unicode_KATAKANA_LETTER_SMALL_HE                              0x31F8
#define unicode_KATAKANA_LETTER_SMALL_HO                              0x31F9
#define unicode_KATAKANA_LETTER_SMALL_MU                              0x31FA
#define unicode_KATAKANA_LETTER_SMALL_RA                              0x31FB
#define unicode_KATAKANA_LETTER_SMALL_RI                              0x31FC
#define unicode_KATAKANA_LETTER_SMALL_RU                              0x31FD
#define unicode_KATAKANA_LETTER_SMALL_RE                              0x31FE
#define unicode_KATAKANA_LETTER_SMALL_RO                              0x31FF
#define unicode_PARENTHESIZED_HANGUL_KIYEOK                           0x3200
#define unicode_PARENTHESIZED_HANGUL_NIEUN                            0x3201
#define unicode_PARENTHESIZED_HANGUL_TIKEUT                           0x3202
#define unicode_PARENTHESIZED_HANGUL_RIEUL                            0x3203
#define unicode_PARENTHESIZED_HANGUL_MIEUM                            0x3204
#define unicode_PARENTHESIZED_HANGUL_PIEUP                            0x3205
#define unicode_PARENTHESIZED_HANGUL_SIOS                             0x3206
#define unicode_PARENTHESIZED_HANGUL_IEUNG                            0x3207
#define unicode_PARENTHESIZED_HANGUL_CIEUC                            0x3208
#define unicode_PARENTHESIZED_HANGUL_CHIEUCH                          0x3209
#define unicode_PARENTHESIZED_HANGUL_KHIEUKH                          0x320A
#define unicode_PARENTHESIZED_HANGUL_THIEUTH                          0x320B
#define unicode_PARENTHESIZED_HANGUL_PHIEUPH                          0x320C
#define unicode_PARENTHESIZED_HANGUL_HIEUH                            0x320D
#define unicode_PARENTHESIZED_HANGUL_KIYEOK_A                         0x320E
#define unicode_PARENTHESIZED_HANGUL_NIEUN_A                          0x320F
#define unicode_PARENTHESIZED_HANGUL_TIKEUT_A                         0x3210
#define unicode_PARENTHESIZED_HANGUL_RIEUL_A                          0x3211
#define unicode_PARENTHESIZED_HANGUL_MIEUM_A                          0x3212
#define unicode_PARENTHESIZED_HANGUL_PIEUP_A                          0x3213
#define unicode_PARENTHESIZED_HANGUL_SIOS_A                           0x3214
#define unicode_PARENTHESIZED_HANGUL_IEUNG_A                          0x3215
#define unicode_PARENTHESIZED_HANGUL_CIEUC_A                          0x3216
#define unicode_PARENTHESIZED_HANGUL_CHIEUCH_A                        0x3217
#define unicode_PARENTHESIZED_HANGUL_KHIEUKH_A                        0x3218
#define unicode_PARENTHESIZED_HANGUL_THIEUTH_A                        0x3219
#define unicode_PARENTHESIZED_HANGUL_PHIEUPH_A                        0x321A
#define unicode_PARENTHESIZED_HANGUL_HIEUH_A                          0x321B
#define unicode_PARENTHESIZED_HANGUL_CIEUC_U                          0x321C
#define unicode_PARENTHESIZED_KOREAN_CHARACTER_OJEON                  0x321D
#define unicode_PARENTHESIZED_KOREAN_CHARACTER_O_HU                   0x321E
#define unicode_PARENTHESIZED_IDEOGRAPH_ONE                           0x3220
#define unicode_PARENTHESIZED_IDEOGRAPH_TWO                           0x3221
#define unicode_PARENTHESIZED_IDEOGRAPH_THREE                         0x3222
#define unicode_PARENTHESIZED_IDEOGRAPH_FOUR                          0x3223
#define unicode_PARENTHESIZED_IDEOGRAPH_FIVE                          0x3224
#define unicode_PARENTHESIZED_IDEOGRAPH_SIX                           0x3225
#define unicode_PARENTHESIZED_IDEOGRAPH_SEVEN                         0x3226
#define unicode_PARENTHESIZED_IDEOGRAPH_EIGHT                         0x3227
#define unicode_PARENTHESIZED_IDEOGRAPH_NINE                          0x3228
#define unicode_PARENTHESIZED_IDEOGRAPH_TEN                           0x3229
#define unicode_PARENTHESIZED_IDEOGRAPH_MOON                          0x322A
#define unicode_PARENTHESIZED_IDEOGRAPH_FIRE                          0x322B
#define unicode_PARENTHESIZED_IDEOGRAPH_WATER                         0x322C
#define unicode_PARENTHESIZED_IDEOGRAPH_WOOD                          0x322D
#define unicode_PARENTHESIZED_IDEOGRAPH_METAL                         0x322E
#define unicode_PARENTHESIZED_IDEOGRAPH_EARTH                         0x322F
#define unicode_PARENTHESIZED_IDEOGRAPH_SUN                           0x3230
#define unicode_PARENTHESIZED_IDEOGRAPH_STOCK                         0x3231
#define unicode_PARENTHESIZED_IDEOGRAPH_HAVE                          0x3232
#define unicode_PARENTHESIZED_IDEOGRAPH_SOCIETY                       0x3233
#define unicode_PARENTHESIZED_IDEOGRAPH_NAME                          0x3234
#define unicode_PARENTHESIZED_IDEOGRAPH_SPECIAL                       0x3235
#define unicode_PARENTHESIZED_IDEOGRAPH_FINANCIAL                     0x3236
#define unicode_PARENTHESIZED_IDEOGRAPH_CONGRATULATION                0x3237
#define unicode_PARENTHESIZED_IDEOGRAPH_LABOR                         0x3238
#define unicode_PARENTHESIZED_IDEOGRAPH_REPRESENT                     0x3239
#define unicode_PARENTHESIZED_IDEOGRAPH_CALL                          0x323A
#define unicode_PARENTHESIZED_IDEOGRAPH_STUDY                         0x323B
#define unicode_PARENTHESIZED_IDEOGRAPH_SUPERVISE                     0x323C
#define unicode_PARENTHESIZED_IDEOGRAPH_ENTERPRISE                    0x323D
#define unicode_PARENTHESIZED_IDEOGRAPH_RESOURCE                      0x323E
#define unicode_PARENTHESIZED_IDEOGRAPH_ALLIANCE                      0x323F
#define unicode_PARENTHESIZED_IDEOGRAPH_FESTIVAL                      0x3240
#define unicode_PARENTHESIZED_IDEOGRAPH_REST                          0x3241
#define unicode_PARENTHESIZED_IDEOGRAPH_SELF                          0x3242
#define unicode_PARENTHESIZED_IDEOGRAPH_REACH                         0x3243
#define unicode_CIRCLED_IDEOGRAPH_QUESTION                            0x3244
#define unicode_CIRCLED_IDEOGRAPH_KINDERGARTEN                        0x3245
#define unicode_CIRCLED_IDEOGRAPH_SCHOOL                              0x3246
#define unicode_CIRCLED_IDEOGRAPH_KOTO                                0x3247
#define unicode_CIRCLED_NUMBER_TEN_ON_BLACK_SQUARE                    0x3248
#define unicode_CIRCLED_NUMBER_TWENTY_ON_BLACK_SQUARE                 0x3249
#define unicode_CIRCLED_NUMBER_THIRTY_ON_BLACK_SQUARE                 0x324A
#define unicode_CIRCLED_NUMBER_FORTY_ON_BLACK_SQUARE                  0x324B
#define unicode_CIRCLED_NUMBER_FIFTY_ON_BLACK_SQUARE                  0x324C
#define unicode_CIRCLED_NUMBER_SIXTY_ON_BLACK_SQUARE                  0x324D
#define unicode_CIRCLED_NUMBER_SEVENTY_ON_BLACK_SQUARE                0x324E
#define unicode_CIRCLED_NUMBER_EIGHTY_ON_BLACK_SQUARE                 0x324F
#define unicode_PARTNERSHIP_SIGN                                      0x3250
#define unicode_CIRCLED_NUMBER_TWENTY_ONE                             0x3251
#define unicode_CIRCLED_NUMBER_TWENTY_TWO                             0x3252
#define unicode_CIRCLED_NUMBER_TWENTY_THREE                           0x3253
#define unicode_CIRCLED_NUMBER_TWENTY_FOUR                            0x3254
#define unicode_CIRCLED_NUMBER_TWENTY_FIVE                            0x3255
#define unicode_CIRCLED_NUMBER_TWENTY_SIX                             0x3256
#define unicode_CIRCLED_NUMBER_TWENTY_SEVEN                           0x3257
#define unicode_CIRCLED_NUMBER_TWENTY_EIGHT                           0x3258
#define unicode_CIRCLED_NUMBER_TWENTY_NINE                            0x3259
#define unicode_CIRCLED_NUMBER_THIRTY                                 0x325A
#define unicode_CIRCLED_NUMBER_THIRTY_ONE                             0x325B
#define unicode_CIRCLED_NUMBER_THIRTY_TWO                             0x325C
#define unicode_CIRCLED_NUMBER_THIRTY_THREE                           0x325D
#define unicode_CIRCLED_NUMBER_THIRTY_FOUR                            0x325E
#define unicode_CIRCLED_NUMBER_THIRTY_FIVE                            0x325F
#define unicode_CIRCLED_HANGUL_KIYEOK                                 0x3260
#define unicode_CIRCLED_HANGUL_NIEUN                                  0x3261
#define unicode_CIRCLED_HANGUL_TIKEUT                                 0x3262
#define unicode_CIRCLED_HANGUL_RIEUL                                  0x3263
#define unicode_CIRCLED_HANGUL_MIEUM                                  0x3264
#define unicode_CIRCLED_HANGUL_PIEUP                                  0x3265
#define unicode_CIRCLED_HANGUL_SIOS                                   0x3266
#define unicode_CIRCLED_HANGUL_IEUNG                                  0x3267
#define unicode_CIRCLED_HANGUL_CIEUC                                  0x3268
#define unicode_CIRCLED_HANGUL_CHIEUCH                                0x3269
#define unicode_CIRCLED_HANGUL_KHIEUKH                                0x326A
#define unicode_CIRCLED_HANGUL_THIEUTH                                0x326B
#define unicode_CIRCLED_HANGUL_PHIEUPH                                0x326C
#define unicode_CIRCLED_HANGUL_HIEUH                                  0x326D
#define unicode_CIRCLED_HANGUL_KIYEOK_A                               0x326E
#define unicode_CIRCLED_HANGUL_NIEUN_A                                0x326F
#define unicode_CIRCLED_HANGUL_TIKEUT_A                               0x3270
#define unicode_CIRCLED_HANGUL_RIEUL_A                                0x3271
#define unicode_CIRCLED_HANGUL_MIEUM_A                                0x3272
#define unicode_CIRCLED_HANGUL_PIEUP_A                                0x3273
#define unicode_CIRCLED_HANGUL_SIOS_A                                 0x3274
#define unicode_CIRCLED_HANGUL_IEUNG_A                                0x3275
#define unicode_CIRCLED_HANGUL_CIEUC_A                                0x3276
#define unicode_CIRCLED_HANGUL_CHIEUCH_A                              0x3277
#define unicode_CIRCLED_HANGUL_KHIEUKH_A                              0x3278
#define unicode_CIRCLED_HANGUL_THIEUTH_A                              0x3279
#define unicode_CIRCLED_HANGUL_PHIEUPH_A                              0x327A
#define unicode_CIRCLED_HANGUL_HIEUH_A                                0x327B
#define unicode_CIRCLED_KOREAN_CHARACTER_CHAMKO                       0x327C
#define unicode_CIRCLED_KOREAN_CHARACTER_JUEUI                        0x327D
#define unicode_CIRCLED_HANGUL_IEUNG_U                                0x327E
#define unicode_KOREAN_STANDARD_SYMBOL                                0x327F
#define unicode_CIRCLED_IDEOGRAPH_ONE                                 0x3280
#define unicode_CIRCLED_IDEOGRAPH_TWO                                 0x3281
#define unicode_CIRCLED_IDEOGRAPH_THREE                               0x3282
#define unicode_CIRCLED_IDEOGRAPH_FOUR                                0x3283
#define unicode_CIRCLED_IDEOGRAPH_FIVE                                0x3284
#define unicode_CIRCLED_IDEOGRAPH_SIX                                 0x3285
#define unicode_CIRCLED_IDEOGRAPH_SEVEN                               0x3286
#define unicode_CIRCLED_IDEOGRAPH_EIGHT                               0x3287
#define unicode_CIRCLED_IDEOGRAPH_NINE                                0x3288
#define unicode_CIRCLED_IDEOGRAPH_TEN                                 0x3289
#define unicode_CIRCLED_IDEOGRAPH_MOON                                0x328A
#define unicode_CIRCLED_IDEOGRAPH_FIRE                                0x328B
#define unicode_CIRCLED_IDEOGRAPH_WATER                               0x328C
#define unicode_CIRCLED_IDEOGRAPH_WOOD                                0x328D
#define unicode_CIRCLED_IDEOGRAPH_METAL                               0x328E
#define unicode_CIRCLED_IDEOGRAPH_EARTH                               0x328F
#define unicode_CIRCLED_IDEOGRAPH_SUN                                 0x3290
#define unicode_CIRCLED_IDEOGRAPH_STOCK                               0x3291
#define unicode_CIRCLED_IDEOGRAPH_HAVE                                0x3292
#define unicode_CIRCLED_IDEOGRAPH_SOCIETY                             0x3293
#define unicode_CIRCLED_IDEOGRAPH_NAME                                0x3294
#define unicode_CIRCLED_IDEOGRAPH_SPECIAL                             0x3295
#define unicode_CIRCLED_IDEOGRAPH_FINANCIAL                           0x3296
#define unicode_CIRCLED_IDEOGRAPH_CONGRATULATION                      0x3297
#define unicode_CIRCLED_IDEOGRAPH_LABOR                               0x3298
#define unicode_CIRCLED_IDEOGRAPH_SECRET                              0x3299
#define unicode_CIRCLED_IDEOGRAPH_MALE                                0x329A
#define unicode_CIRCLED_IDEOGRAPH_FEMALE                              0x329B
#define unicode_CIRCLED_IDEOGRAPH_SUITABLE                            0x329C
#define unicode_CIRCLED_IDEOGRAPH_EXCELLENT                           0x329D
#define unicode_CIRCLED_IDEOGRAPH_PRINT                               0x329E
#define unicode_CIRCLED_IDEOGRAPH_ATTENTION                           0x329F
#define unicode_CIRCLED_IDEOGRAPH_ITEM                                0x32A0
#define unicode_CIRCLED_IDEOGRAPH_REST                                0x32A1
#define unicode_CIRCLED_IDEOGRAPH_COPY                                0x32A2
#define unicode_CIRCLED_IDEOGRAPH_CORRECT                             0x32A3
#define unicode_CIRCLED_IDEOGRAPH_HIGH                                0x32A4
#define unicode_CIRCLED_IDEOGRAPH_CENTRE                              0x32A5
#define unicode_CIRCLED_IDEOGRAPH_LOW                                 0x32A6
#define unicode_CIRCLED_IDEOGRAPH_LEFT                                0x32A7
#define unicode_CIRCLED_IDEOGRAPH_RIGHT                               0x32A8
#define unicode_CIRCLED_IDEOGRAPH_MEDICINE                            0x32A9
#define unicode_CIRCLED_IDEOGRAPH_RELIGION                            0x32AA
#define unicode_CIRCLED_IDEOGRAPH_STUDY                               0x32AB
#define unicode_CIRCLED_IDEOGRAPH_SUPERVISE                           0x32AC
#define unicode_CIRCLED_IDEOGRAPH_ENTERPRISE                          0x32AD
#define unicode_CIRCLED_IDEOGRAPH_RESOURCE                            0x32AE
#define unicode_CIRCLED_IDEOGRAPH_ALLIANCE                            0x32AF
#define unicode_CIRCLED_IDEOGRAPH_NIGHT                               0x32B0
#define unicode_CIRCLED_NUMBER_THIRTY_SIX                             0x32B1
#define unicode_CIRCLED_NUMBER_THIRTY_SEVEN                           0x32B2
#define unicode_CIRCLED_NUMBER_THIRTY_EIGHT                           0x32B3
#define unicode_CIRCLED_NUMBER_THIRTY_NINE                            0x32B4
#define unicode_CIRCLED_NUMBER_FORTY                                  0x32B5
#define unicode_CIRCLED_NUMBER_FORTY_ONE                              0x32B6
#define unicode_CIRCLED_NUMBER_FORTY_TWO                              0x32B7
#define unicode_CIRCLED_NUMBER_FORTY_THREE                            0x32B8
#define unicode_CIRCLED_NUMBER_FORTY_FOUR                             0x32B9
#define unicode_CIRCLED_NUMBER_FORTY_FIVE                             0x32BA
#define unicode_CIRCLED_NUMBER_FORTY_SIX                              0x32BB
#define unicode_CIRCLED_NUMBER_FORTY_SEVEN                            0x32BC
#define unicode_CIRCLED_NUMBER_FORTY_EIGHT                            0x32BD
#define unicode_CIRCLED_NUMBER_FORTY_NINE                             0x32BE
#define unicode_CIRCLED_NUMBER_FIFTY                                  0x32BF
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_JANUARY              0x32C0
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_FEBRUARY             0x32C1
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_MARCH                0x32C2
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_APRIL                0x32C3
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_MAY                  0x32C4
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_JUNE                 0x32C5
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_JULY                 0x32C6
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_AUGUST               0x32C7
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_SEPTEMBER            0x32C8
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_OCTOBER              0x32C9
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_NOVEMBER             0x32CA
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DECEMBER             0x32CB
#define unicode_SQUARE_HG                                             0x32CC
#define unicode_SQUARE_ERG                                            0x32CD
#define unicode_SQUARE_EV                                             0x32CE
#define unicode_LIMITED_LIABILITY_SIGN                                0x32CF
#define unicode_CIRCLED_KATAKANA_A                                    0x32D0
#define unicode_CIRCLED_KATAKANA_I                                    0x32D1
#define unicode_CIRCLED_KATAKANA_U                                    0x32D2
#define unicode_CIRCLED_KATAKANA_E                                    0x32D3
#define unicode_CIRCLED_KATAKANA_O                                    0x32D4
#define unicode_CIRCLED_KATAKANA_KA                                   0x32D5
#define unicode_CIRCLED_KATAKANA_KI                                   0x32D6
#define unicode_CIRCLED_KATAKANA_KU                                   0x32D7
#define unicode_CIRCLED_KATAKANA_KE                                   0x32D8
#define unicode_CIRCLED_KATAKANA_KO                                   0x32D9
#define unicode_CIRCLED_KATAKANA_SA                                   0x32DA
#define unicode_CIRCLED_KATAKANA_SI                                   0x32DB
#define unicode_CIRCLED_KATAKANA_SU                                   0x32DC
#define unicode_CIRCLED_KATAKANA_SE                                   0x32DD
#define unicode_CIRCLED_KATAKANA_SO                                   0x32DE
#define unicode_CIRCLED_KATAKANA_TA                                   0x32DF
#define unicode_CIRCLED_KATAKANA_TI                                   0x32E0
#define unicode_CIRCLED_KATAKANA_TU                                   0x32E1
#define unicode_CIRCLED_KATAKANA_TE                                   0x32E2
#define unicode_CIRCLED_KATAKANA_TO                                   0x32E3
#define unicode_CIRCLED_KATAKANA_NA                                   0x32E4
#define unicode_CIRCLED_KATAKANA_NI                                   0x32E5
#define unicode_CIRCLED_KATAKANA_NU                                   0x32E6
#define unicode_CIRCLED_KATAKANA_NE                                   0x32E7
#define unicode_CIRCLED_KATAKANA_NO                                   0x32E8
#define unicode_CIRCLED_KATAKANA_HA                                   0x32E9
#define unicode_CIRCLED_KATAKANA_HI                                   0x32EA
#define unicode_CIRCLED_KATAKANA_HU                                   0x32EB
#define unicode_CIRCLED_KATAKANA_HE                                   0x32EC
#define unicode_CIRCLED_KATAKANA_HO                                   0x32ED
#define unicode_CIRCLED_KATAKANA_MA                                   0x32EE
#define unicode_CIRCLED_KATAKANA_MI                                   0x32EF
#define unicode_CIRCLED_KATAKANA_MU                                   0x32F0
#define unicode_CIRCLED_KATAKANA_ME                                   0x32F1
#define unicode_CIRCLED_KATAKANA_MO                                   0x32F2
#define unicode_CIRCLED_KATAKANA_YA                                   0x32F3
#define unicode_CIRCLED_KATAKANA_YU                                   0x32F4
#define unicode_CIRCLED_KATAKANA_YO                                   0x32F5
#define unicode_CIRCLED_KATAKANA_RA                                   0x32F6
#define unicode_CIRCLED_KATAKANA_RI                                   0x32F7
#define unicode_CIRCLED_KATAKANA_RU                                   0x32F8
#define unicode_CIRCLED_KATAKANA_RE                                   0x32F9
#define unicode_CIRCLED_KATAKANA_RO                                   0x32FA
#define unicode_CIRCLED_KATAKANA_WA                                   0x32FB
#define unicode_CIRCLED_KATAKANA_WI                                   0x32FC
#define unicode_CIRCLED_KATAKANA_WE                                   0x32FD
#define unicode_CIRCLED_KATAKANA_WO                                   0x32FE
#define unicode_SQUARE_APAATO                                         0x3300
#define unicode_SQUARE_ARUHUA                                         0x3301
#define unicode_SQUARE_ANPEA                                          0x3302
#define unicode_SQUARE_AARU                                           0x3303
#define unicode_SQUARE_ININGU                                         0x3304
#define unicode_SQUARE_INTI                                           0x3305
#define unicode_SQUARE_UON                                            0x3306
#define unicode_SQUARE_ESUKUUDO                                       0x3307
#define unicode_SQUARE_EEKAA                                          0x3308
#define unicode_SQUARE_ONSU                                           0x3309
#define unicode_SQUARE_OOMU                                           0x330A
#define unicode_SQUARE_KAIRI                                          0x330B
#define unicode_SQUARE_KARATTO                                        0x330C
#define unicode_SQUARE_KARORII                                        0x330D
#define unicode_SQUARE_GARON                                          0x330E
#define unicode_SQUARE_GANMA                                          0x330F
#define unicode_SQUARE_GIGA                                           0x3310
#define unicode_SQUARE_GINII                                          0x3311
#define unicode_SQUARE_KYURII                                         0x3312
#define unicode_SQUARE_GIRUDAA                                        0x3313
#define unicode_SQUARE_KIRO                                           0x3314
#define unicode_SQUARE_KIROGURAMU                                     0x3315
#define unicode_SQUARE_KIROMEETORU                                    0x3316
#define unicode_SQUARE_KIROWATTO                                      0x3317
#define unicode_SQUARE_GURAMU                                         0x3318
#define unicode_SQUARE_GURAMUTON                                      0x3319
#define unicode_SQUARE_KURUZEIRO                                      0x331A
#define unicode_SQUARE_KUROONE                                        0x331B
#define unicode_SQUARE_KEESU                                          0x331C
#define unicode_SQUARE_KORUNA                                         0x331D
#define unicode_SQUARE_KOOPO                                          0x331E
#define unicode_SQUARE_SAIKURU                                        0x331F
#define unicode_SQUARE_SANTIIMU                                       0x3320
#define unicode_SQUARE_SIRINGU                                        0x3321
#define unicode_SQUARE_SENTI                                          0x3322
#define unicode_SQUARE_SENTO                                          0x3323
#define unicode_SQUARE_DAASU                                          0x3324
#define unicode_SQUARE_DESI                                           0x3325
#define unicode_SQUARE_DORU                                           0x3326
#define unicode_SQUARE_TON                                            0x3327
#define unicode_SQUARE_NANO                                           0x3328
#define unicode_SQUARE_NOTTO                                          0x3329
#define unicode_SQUARE_HAITU                                          0x332A
#define unicode_SQUARE_PAASENTO                                       0x332B
#define unicode_SQUARE_PAATU                                          0x332C
#define unicode_SQUARE_BAARERU                                        0x332D
#define unicode_SQUARE_PIASUTORU                                      0x332E
#define unicode_SQUARE_PIKURU                                         0x332F
#define unicode_SQUARE_PIKO                                           0x3330
#define unicode_SQUARE_BIRU                                           0x3331
#define unicode_SQUARE_HUARADDO                                       0x3332
#define unicode_SQUARE_HUIITO                                         0x3333
#define unicode_SQUARE_BUSSYERU                                       0x3334
#define unicode_SQUARE_HURAN                                          0x3335
#define unicode_SQUARE_HEKUTAARU                                      0x3336
#define unicode_SQUARE_PESO                                           0x3337
#define unicode_SQUARE_PENIHI                                         0x3338
#define unicode_SQUARE_HERUTU                                         0x3339
#define unicode_SQUARE_PENSU                                          0x333A
#define unicode_SQUARE_PEEZI                                          0x333B
#define unicode_SQUARE_BEETA                                          0x333C
#define unicode_SQUARE_POINTO                                         0x333D
#define unicode_SQUARE_BORUTO                                         0x333E
#define unicode_SQUARE_HON                                            0x333F
#define unicode_SQUARE_PONDO                                          0x3340
#define unicode_SQUARE_HOORU                                          0x3341
#define unicode_SQUARE_HOON                                           0x3342
#define unicode_SQUARE_MAIKURO                                        0x3343
#define unicode_SQUARE_MAIRU                                          0x3344
#define unicode_SQUARE_MAHHA                                          0x3345
#define unicode_SQUARE_MARUKU                                         0x3346
#define unicode_SQUARE_MANSYON                                        0x3347
#define unicode_SQUARE_MIKURON                                        0x3348
#define unicode_SQUARE_MIRI                                           0x3349
#define unicode_SQUARE_MIRIBAARU                                      0x334A
#define unicode_SQUARE_MEGA                                           0x334B
#define unicode_SQUARE_MEGATON                                        0x334C
#define unicode_SQUARE_MEETORU                                        0x334D
#define unicode_SQUARE_YAADO                                          0x334E
#define unicode_SQUARE_YAARU                                          0x334F
#define unicode_SQUARE_YUAN                                           0x3350
#define unicode_SQUARE_RITTORU                                        0x3351
#define unicode_SQUARE_RIRA                                           0x3352
#define unicode_SQUARE_RUPII                                          0x3353
#define unicode_SQUARE_RUUBURU                                        0x3354
#define unicode_SQUARE_REMU                                           0x3355
#define unicode_SQUARE_RENTOGEN                                       0x3356
#define unicode_SQUARE_WATTO                                          0x3357
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_ZERO            0x3358
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_ONE             0x3359
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWO             0x335A
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_THREE           0x335B
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FOUR            0x335C
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FIVE            0x335D
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SIX             0x335E
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SEVEN           0x335F
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_EIGHT           0x3360
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_NINE            0x3361
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TEN             0x3362
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_ELEVEN          0x3363
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWELVE          0x3364
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_THIRTEEN        0x3365
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FOURTEEN        0x3366
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FIFTEEN         0x3367
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SIXTEEN         0x3368
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SEVENTEEN       0x3369
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_EIGHTEEN        0x336A
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_NINETEEN        0x336B
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY          0x336C
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_ONE      0x336D
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_TWO      0x336E
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_THREE    0x336F
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_FOUR     0x3370
#define unicode_SQUARE_HPA                                            0x3371
#define unicode_SQUARE_DA                                             0x3372
#define unicode_SQUARE_AU                                             0x3373
#define unicode_SQUARE_BAR                                            0x3374
#define unicode_SQUARE_OV                                             0x3375
#define unicode_SQUARE_PC                                             0x3376
#define unicode_SQUARE_DM                                             0x3377
#define unicode_SQUARE_DM_SQUARED                                     0x3378
#define unicode_SQUARE_DM_CUBED                                       0x3379
#define unicode_SQUARE_IU                                             0x337A
#define unicode_SQUARE_ERA_NAME_HEISEI                                0x337B
#define unicode_SQUARE_ERA_NAME_SYOUWA                                0x337C
#define unicode_SQUARE_ERA_NAME_TAISYOU                               0x337D
#define unicode_SQUARE_ERA_NAME_MEIZI                                 0x337E
#define unicode_SQUARE_CORPORATION                                    0x337F
#define unicode_SQUARE_PA_AMPS                                        0x3380
#define unicode_SQUARE_NA                                             0x3381
#define unicode_SQUARE_MU_A                                           0x3382
#define unicode_SQUARE_MA                                             0x3383
#define unicode_SQUARE_KA                                             0x3384
#define unicode_SQUARE_KB                                             0x3385
#define unicode_SQUARE_MB                                             0x3386
#define unicode_SQUARE_GB                                             0x3387
#define unicode_SQUARE_CAL                                            0x3388
#define unicode_SQUARE_KCAL                                           0x3389
#define unicode_SQUARE_PF                                             0x338A
#define unicode_SQUARE_NF                                             0x338B
#define unicode_SQUARE_MU_F                                           0x338C
#define unicode_SQUARE_MU_G                                           0x338D
#define unicode_SQUARE_MG                                             0x338E
#define unicode_SQUARE_KG                                             0x338F
#define unicode_SQUARE_HZ                                             0x3390
#define unicode_SQUARE_KHZ                                            0x3391
#define unicode_SQUARE_MHZ                                            0x3392
#define unicode_SQUARE_GHZ                                            0x3393
#define unicode_SQUARE_THZ                                            0x3394
#define unicode_SQUARE_MU_L                                           0x3395
#define unicode_SQUARE_ML                                             0x3396
#define unicode_SQUARE_DL                                             0x3397
#define unicode_SQUARE_KL                                             0x3398
#define unicode_SQUARE_FM                                             0x3399
#define unicode_SQUARE_NM                                             0x339A
#define unicode_SQUARE_MU_M                                           0x339B
#define unicode_SQUARE_MM                                             0x339C
#define unicode_SQUARE_CM                                             0x339D
#define unicode_SQUARE_KM                                             0x339E
#define unicode_SQUARE_MM_SQUARED                                     0x339F
#define unicode_SQUARE_CM_SQUARED                                     0x33A0
#define unicode_SQUARE_M_SQUARED                                      0x33A1
#define unicode_SQUARE_KM_SQUARED                                     0x33A2
#define unicode_SQUARE_MM_CUBED                                       0x33A3
#define unicode_SQUARE_CM_CUBED                                       0x33A4
#define unicode_SQUARE_M_CUBED                                        0x33A5
#define unicode_SQUARE_KM_CUBED                                       0x33A6
#define unicode_SQUARE_M_OVER_S                                       0x33A7
#define unicode_SQUARE_M_OVER_S_SQUARED                               0x33A8
#define unicode_SQUARE_PA                                             0x33A9
#define unicode_SQUARE_KPA                                            0x33AA
#define unicode_SQUARE_MPA                                            0x33AB
#define unicode_SQUARE_GPA                                            0x33AC
#define unicode_SQUARE_RAD                                            0x33AD
#define unicode_SQUARE_RAD_OVER_S                                     0x33AE
#define unicode_SQUARE_RAD_OVER_S_SQUARED                             0x33AF
#define unicode_SQUARE_PS                                             0x33B0
#define unicode_SQUARE_NS                                             0x33B1
#define unicode_SQUARE_MU_S                                           0x33B2
#define unicode_SQUARE_MS                                             0x33B3
#define unicode_SQUARE_PV                                             0x33B4
#define unicode_SQUARE_NV                                             0x33B5
#define unicode_SQUARE_MU_V                                           0x33B6
#define unicode_SQUARE_MV                                             0x33B7
#define unicode_SQUARE_KV                                             0x33B8
#define unicode_SQUARE_MV_MEGA                                        0x33B9
#define unicode_SQUARE_PW                                             0x33BA
#define unicode_SQUARE_NW                                             0x33BB
#define unicode_SQUARE_MU_W                                           0x33BC
#define unicode_SQUARE_MW                                             0x33BD
#define unicode_SQUARE_KW                                             0x33BE
#define unicode_SQUARE_MW_MEGA                                        0x33BF
#define unicode_SQUARE_K_OHM                                          0x33C0
#define unicode_SQUARE_M_OHM                                          0x33C1
#define unicode_SQUARE_AM                                             0x33C2
#define unicode_SQUARE_BQ                                             0x33C3
#define unicode_SQUARE_CC                                             0x33C4
#define unicode_SQUARE_CD                                             0x33C5
#define unicode_SQUARE_C_OVER_KG                                      0x33C6
#define unicode_SQUARE_CO                                             0x33C7
#define unicode_SQUARE_DB                                             0x33C8
#define unicode_SQUARE_GY                                             0x33C9
#define unicode_SQUARE_HA                                             0x33CA
#define unicode_SQUARE_HP                                             0x33CB
#define unicode_SQUARE_IN                                             0x33CC
#define unicode_SQUARE_KK                                             0x33CD
#define unicode_SQUARE_KM_CAPITAL                                     0x33CE
#define unicode_SQUARE_KT                                             0x33CF
#define unicode_SQUARE_LM                                             0x33D0
#define unicode_SQUARE_LN                                             0x33D1
#define unicode_SQUARE_LOG                                            0x33D2
#define unicode_SQUARE_LX                                             0x33D3
#define unicode_SQUARE_MB_SMALL                                       0x33D4
#define unicode_SQUARE_MIL                                            0x33D5
#define unicode_SQUARE_MOL                                            0x33D6
#define unicode_SQUARE_PH                                             0x33D7
#define unicode_SQUARE_PM                                             0x33D8
#define unicode_SQUARE_PPM                                            0x33D9
#define unicode_SQUARE_PR                                             0x33DA
#define unicode_SQUARE_SR                                             0x33DB
#define unicode_SQUARE_SV                                             0x33DC
#define unicode_SQUARE_WB                                             0x33DD
#define unicode_SQUARE_V_OVER_M                                       0x33DE
#define unicode_SQUARE_A_OVER_M                                       0x33DF
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_ONE              0x33E0
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWO              0x33E1
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THREE            0x33E2
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FOUR             0x33E3
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FIVE             0x33E4
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SIX              0x33E5
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SEVEN            0x33E6
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_EIGHT            0x33E7
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_NINE             0x33E8
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TEN              0x33E9
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_ELEVEN           0x33EA
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWELVE           0x33EB
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THIRTEEN         0x33EC
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FOURTEEN         0x33ED
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FIFTEEN          0x33EE
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SIXTEEN          0x33EF
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SEVENTEEN        0x33F0
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_EIGHTEEN         0x33F1
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_NINETEEN         0x33F2
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY           0x33F3
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_ONE       0x33F4
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_TWO       0x33F5
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_THREE     0x33F6
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_FOUR      0x33F7
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_FIVE      0x33F8
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_SIX       0x33F9
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_SEVEN     0x33FA
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_EIGHT     0x33FB
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_NINE      0x33FC
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THIRTY           0x33FD
#define unicode_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THIRTY_ONE       0x33FE
#define unicode_SQUARE_GAL                                            0x33FF
#define unicode_CJK_Ideograph_Extension_A__First                      0x3400
#define unicode_CJK_Ideograph_Extension_A__Last                       0x4DB5
#define unicode_HEXAGRAM_FOR_THE_CREATIVE_HEAVEN                      0x4DC0
#define unicode_HEXAGRAM_FOR_THE_RECEPTIVE_EARTH                      0x4DC1
#define unicode_HEXAGRAM_FOR_DIFFICULTY_AT_THE_BEGINNING              0x4DC2
#define unicode_HEXAGRAM_FOR_YOUTHFUL_FOLLY                           0x4DC3
#define unicode_HEXAGRAM_FOR_WAITING                                  0x4DC4
#define unicode_HEXAGRAM_FOR_CONFLICT                                 0x4DC5
#define unicode_HEXAGRAM_FOR_THE_ARMY                                 0x4DC6
#define unicode_HEXAGRAM_FOR_HOLDING_TOGETHER                         0x4DC7
#define unicode_HEXAGRAM_FOR_SMALL_TAMING                             0x4DC8
#define unicode_HEXAGRAM_FOR_TREADING                                 0x4DC9
#define unicode_HEXAGRAM_FOR_PEACE                                    0x4DCA
#define unicode_HEXAGRAM_FOR_STANDSTILL                               0x4DCB
#define unicode_HEXAGRAM_FOR_FELLOWSHIP                               0x4DCC
#define unicode_HEXAGRAM_FOR_GREAT_POSSESSION                         0x4DCD
#define unicode_HEXAGRAM_FOR_MODESTY                                  0x4DCE
#define unicode_HEXAGRAM_FOR_ENTHUSIASM                               0x4DCF
#define unicode_HEXAGRAM_FOR_FOLLOWING                                0x4DD0
#define unicode_HEXAGRAM_FOR_WORK_ON_THE_DECAYED                      0x4DD1
#define unicode_HEXAGRAM_FOR_APPROACH                                 0x4DD2
#define unicode_HEXAGRAM_FOR_CONTEMPLATION                            0x4DD3
#define unicode_HEXAGRAM_FOR_BITING_THROUGH                           0x4DD4
#define unicode_HEXAGRAM_FOR_GRACE                                    0x4DD5
#define unicode_HEXAGRAM_FOR_SPLITTING_APART                          0x4DD6
#define unicode_HEXAGRAM_FOR_RETURN                                   0x4DD7
#define unicode_HEXAGRAM_FOR_INNOCENCE                                0x4DD8
#define unicode_HEXAGRAM_FOR_GREAT_TAMING                             0x4DD9
#define unicode_HEXAGRAM_FOR_MOUTH_CORNERS                            0x4DDA
#define unicode_HEXAGRAM_FOR_GREAT_PREPONDERANCE                      0x4DDB
#define unicode_HEXAGRAM_FOR_THE_ABYSMAL_WATER                        0x4DDC
#define unicode_HEXAGRAM_FOR_THE_CLINGING_FIRE                        0x4DDD
#define unicode_HEXAGRAM_FOR_INFLUENCE                                0x4DDE
#define unicode_HEXAGRAM_FOR_DURATION                                 0x4DDF
#define unicode_HEXAGRAM_FOR_RETREAT                                  0x4DE0
#define unicode_HEXAGRAM_FOR_GREAT_POWER                              0x4DE1
#define unicode_HEXAGRAM_FOR_PROGRESS                                 0x4DE2
#define unicode_HEXAGRAM_FOR_DARKENING_OF_THE_LIGHT                   0x4DE3
#define unicode_HEXAGRAM_FOR_THE_FAMILY                               0x4DE4
#define unicode_HEXAGRAM_FOR_OPPOSITION                               0x4DE5
#define unicode_HEXAGRAM_FOR_OBSTRUCTION                              0x4DE6
#define unicode_HEXAGRAM_FOR_DELIVERANCE                              0x4DE7
#define unicode_HEXAGRAM_FOR_DECREASE                                 0x4DE8
#define unicode_HEXAGRAM_FOR_INCREASE                                 0x4DE9
#define unicode_HEXAGRAM_FOR_BREAKTHROUGH                             0x4DEA
#define unicode_HEXAGRAM_FOR_COMING_TO_MEET                           0x4DEB
#define unicode_HEXAGRAM_FOR_GATHERING_TOGETHER                       0x4DEC
#define unicode_HEXAGRAM_FOR_PUSHING_UPWARD                           0x4DED
#define unicode_HEXAGRAM_FOR_OPPRESSION                               0x4DEE
#define unicode_HEXAGRAM_FOR_THE_WELL                                 0x4DEF
#define unicode_HEXAGRAM_FOR_REVOLUTION                               0x4DF0
#define unicode_HEXAGRAM_FOR_THE_CAULDRON                             0x4DF1
#define unicode_HEXAGRAM_FOR_THE_AROUSING_THUNDER                     0x4DF2
#define unicode_HEXAGRAM_FOR_THE_KEEPING_STILL_MOUNTAIN               0x4DF3
#define unicode_HEXAGRAM_FOR_DEVELOPMENT                              0x4DF4
#define unicode_HEXAGRAM_FOR_THE_MARRYING_MAIDEN                      0x4DF5
#define unicode_HEXAGRAM_FOR_ABUNDANCE                                0x4DF6
#define unicode_HEXAGRAM_FOR_THE_WANDERER                             0x4DF7
#define unicode_HEXAGRAM_FOR_THE_GENTLE_WIND                          0x4DF8
#define unicode_HEXAGRAM_FOR_THE_JOYOUS_LAKE                          0x4DF9
#define unicode_HEXAGRAM_FOR_DISPERSION                               0x4DFA
#define unicode_HEXAGRAM_FOR_LIMITATION                               0x4DFB
#define unicode_HEXAGRAM_FOR_INNER_TRUTH                              0x4DFC
#define unicode_HEXAGRAM_FOR_SMALL_PREPONDERANCE                      0x4DFD
#define unicode_HEXAGRAM_FOR_AFTER_COMPLETION                         0x4DFE
#define unicode_HEXAGRAM_FOR_BEFORE_COMPLETION                        0x4DFF
#define unicode_CJK_Ideograph__First                                  0x4E00
#define unicode_CJK_Ideograph__Last                                   0x9FCC
#define unicode_YI_SYLLABLE_IT                                        0xA000
#define unicode_YI_SYLLABLE_IX                                        0xA001
#define unicode_YI_SYLLABLE_I                                         0xA002
#define unicode_YI_SYLLABLE_IP                                        0xA003
#define unicode_YI_SYLLABLE_IET                                       0xA004
#define unicode_YI_SYLLABLE_IEX                                       0xA005
#define unicode_YI_SYLLABLE_IE                                        0xA006
#define unicode_YI_SYLLABLE_IEP                                       0xA007
#define unicode_YI_SYLLABLE_AT                                        0xA008
#define unicode_YI_SYLLABLE_AX                                        0xA009
#define unicode_YI_SYLLABLE_A                                         0xA00A
#define unicode_YI_SYLLABLE_AP                                        0xA00B
#define unicode_YI_SYLLABLE_UOX                                       0xA00C
#define unicode_YI_SYLLABLE_UO                                        0xA00D
#define unicode_YI_SYLLABLE_UOP                                       0xA00E
#define unicode_YI_SYLLABLE_OT                                        0xA00F
#define unicode_YI_SYLLABLE_OX                                        0xA010
#define unicode_YI_SYLLABLE_O                                         0xA011
#define unicode_YI_SYLLABLE_OP                                        0xA012
#define unicode_YI_SYLLABLE_EX                                        0xA013
#define unicode_YI_SYLLABLE_E                                         0xA014
#define unicode_YI_SYLLABLE_WU                                        0xA015
#define unicode_YI_SYLLABLE_BIT                                       0xA016
#define unicode_YI_SYLLABLE_BIX                                       0xA017
#define unicode_YI_SYLLABLE_BI                                        0xA018
#define unicode_YI_SYLLABLE_BIP                                       0xA019
#define unicode_YI_SYLLABLE_BIET                                      0xA01A
#define unicode_YI_SYLLABLE_BIEX                                      0xA01B
#define unicode_YI_SYLLABLE_BIE                                       0xA01C
#define unicode_YI_SYLLABLE_BIEP                                      0xA01D
#define unicode_YI_SYLLABLE_BAT                                       0xA01E
#define unicode_YI_SYLLABLE_BAX                                       0xA01F
#define unicode_YI_SYLLABLE_BA                                        0xA020
#define unicode_YI_SYLLABLE_BAP                                       0xA021
#define unicode_YI_SYLLABLE_BUOX                                      0xA022
#define unicode_YI_SYLLABLE_BUO                                       0xA023
#define unicode_YI_SYLLABLE_BUOP                                      0xA024
#define unicode_YI_SYLLABLE_BOT                                       0xA025
#define unicode_YI_SYLLABLE_BOX                                       0xA026
#define unicode_YI_SYLLABLE_BO                                        0xA027
#define unicode_YI_SYLLABLE_BOP                                       0xA028
#define unicode_YI_SYLLABLE_BEX                                       0xA029
#define unicode_YI_SYLLABLE_BE                                        0xA02A
#define unicode_YI_SYLLABLE_BEP                                       0xA02B
#define unicode_YI_SYLLABLE_BUT                                       0xA02C
#define unicode_YI_SYLLABLE_BUX                                       0xA02D
#define unicode_YI_SYLLABLE_BU                                        0xA02E
#define unicode_YI_SYLLABLE_BUP                                       0xA02F
#define unicode_YI_SYLLABLE_BURX                                      0xA030
#define unicode_YI_SYLLABLE_BUR                                       0xA031
#define unicode_YI_SYLLABLE_BYT                                       0xA032
#define unicode_YI_SYLLABLE_BYX                                       0xA033
#define unicode_YI_SYLLABLE_BY                                        0xA034
#define unicode_YI_SYLLABLE_BYP                                       0xA035
#define unicode_YI_SYLLABLE_BYRX                                      0xA036
#define unicode_YI_SYLLABLE_BYR                                       0xA037
#define unicode_YI_SYLLABLE_PIT                                       0xA038
#define unicode_YI_SYLLABLE_PIX                                       0xA039
#define unicode_YI_SYLLABLE_PI                                        0xA03A
#define unicode_YI_SYLLABLE_PIP                                       0xA03B
#define unicode_YI_SYLLABLE_PIEX                                      0xA03C
#define unicode_YI_SYLLABLE_PIE                                       0xA03D
#define unicode_YI_SYLLABLE_PIEP                                      0xA03E
#define unicode_YI_SYLLABLE_PAT                                       0xA03F
#define unicode_YI_SYLLABLE_PAX                                       0xA040
#define unicode_YI_SYLLABLE_PA                                        0xA041
#define unicode_YI_SYLLABLE_PAP                                       0xA042
#define unicode_YI_SYLLABLE_PUOX                                      0xA043
#define unicode_YI_SYLLABLE_PUO                                       0xA044
#define unicode_YI_SYLLABLE_PUOP                                      0xA045
#define unicode_YI_SYLLABLE_POT                                       0xA046
#define unicode_YI_SYLLABLE_POX                                       0xA047
#define unicode_YI_SYLLABLE_PO                                        0xA048
#define unicode_YI_SYLLABLE_POP                                       0xA049
#define unicode_YI_SYLLABLE_PUT                                       0xA04A
#define unicode_YI_SYLLABLE_PUX                                       0xA04B
#define unicode_YI_SYLLABLE_PU                                        0xA04C
#define unicode_YI_SYLLABLE_PUP                                       0xA04D
#define unicode_YI_SYLLABLE_PURX                                      0xA04E
#define unicode_YI_SYLLABLE_PUR                                       0xA04F
#define unicode_YI_SYLLABLE_PYT                                       0xA050
#define unicode_YI_SYLLABLE_PYX                                       0xA051
#define unicode_YI_SYLLABLE_PY                                        0xA052
#define unicode_YI_SYLLABLE_PYP                                       0xA053
#define unicode_YI_SYLLABLE_PYRX                                      0xA054
#define unicode_YI_SYLLABLE_PYR                                       0xA055
#define unicode_YI_SYLLABLE_BBIT                                      0xA056
#define unicode_YI_SYLLABLE_BBIX                                      0xA057
#define unicode_YI_SYLLABLE_BBI                                       0xA058
#define unicode_YI_SYLLABLE_BBIP                                      0xA059
#define unicode_YI_SYLLABLE_BBIET                                     0xA05A
#define unicode_YI_SYLLABLE_BBIEX                                     0xA05B
#define unicode_YI_SYLLABLE_BBIE                                      0xA05C
#define unicode_YI_SYLLABLE_BBIEP                                     0xA05D
#define unicode_YI_SYLLABLE_BBAT                                      0xA05E
#define unicode_YI_SYLLABLE_BBAX                                      0xA05F
#define unicode_YI_SYLLABLE_BBA                                       0xA060
#define unicode_YI_SYLLABLE_BBAP                                      0xA061
#define unicode_YI_SYLLABLE_BBUOX                                     0xA062
#define unicode_YI_SYLLABLE_BBUO                                      0xA063
#define unicode_YI_SYLLABLE_BBUOP                                     0xA064
#define unicode_YI_SYLLABLE_BBOT                                      0xA065
#define unicode_YI_SYLLABLE_BBOX                                      0xA066
#define unicode_YI_SYLLABLE_BBO                                       0xA067
#define unicode_YI_SYLLABLE_BBOP                                      0xA068
#define unicode_YI_SYLLABLE_BBEX                                      0xA069
#define unicode_YI_SYLLABLE_BBE                                       0xA06A
#define unicode_YI_SYLLABLE_BBEP                                      0xA06B
#define unicode_YI_SYLLABLE_BBUT                                      0xA06C
#define unicode_YI_SYLLABLE_BBUX                                      0xA06D
#define unicode_YI_SYLLABLE_BBU                                       0xA06E
#define unicode_YI_SYLLABLE_BBUP                                      0xA06F
#define unicode_YI_SYLLABLE_BBURX                                     0xA070
#define unicode_YI_SYLLABLE_BBUR                                      0xA071
#define unicode_YI_SYLLABLE_BBYT                                      0xA072
#define unicode_YI_SYLLABLE_BBYX                                      0xA073
#define unicode_YI_SYLLABLE_BBY                                       0xA074
#define unicode_YI_SYLLABLE_BBYP                                      0xA075
#define unicode_YI_SYLLABLE_NBIT                                      0xA076
#define unicode_YI_SYLLABLE_NBIX                                      0xA077
#define unicode_YI_SYLLABLE_NBI                                       0xA078
#define unicode_YI_SYLLABLE_NBIP                                      0xA079
#define unicode_YI_SYLLABLE_NBIEX                                     0xA07A
#define unicode_YI_SYLLABLE_NBIE                                      0xA07B
#define unicode_YI_SYLLABLE_NBIEP                                     0xA07C
#define unicode_YI_SYLLABLE_NBAT                                      0xA07D
#define unicode_YI_SYLLABLE_NBAX                                      0xA07E
#define unicode_YI_SYLLABLE_NBA                                       0xA07F
#define unicode_YI_SYLLABLE_NBAP                                      0xA080
#define unicode_YI_SYLLABLE_NBOT                                      0xA081
#define unicode_YI_SYLLABLE_NBOX                                      0xA082
#define unicode_YI_SYLLABLE_NBO                                       0xA083
#define unicode_YI_SYLLABLE_NBOP                                      0xA084
#define unicode_YI_SYLLABLE_NBUT                                      0xA085
#define unicode_YI_SYLLABLE_NBUX                                      0xA086
#define unicode_YI_SYLLABLE_NBU                                       0xA087
#define unicode_YI_SYLLABLE_NBUP                                      0xA088
#define unicode_YI_SYLLABLE_NBURX                                     0xA089
#define unicode_YI_SYLLABLE_NBUR                                      0xA08A
#define unicode_YI_SYLLABLE_NBYT                                      0xA08B
#define unicode_YI_SYLLABLE_NBYX                                      0xA08C
#define unicode_YI_SYLLABLE_NBY                                       0xA08D
#define unicode_YI_SYLLABLE_NBYP                                      0xA08E
#define unicode_YI_SYLLABLE_NBYRX                                     0xA08F
#define unicode_YI_SYLLABLE_NBYR                                      0xA090
#define unicode_YI_SYLLABLE_HMIT                                      0xA091
#define unicode_YI_SYLLABLE_HMIX                                      0xA092
#define unicode_YI_SYLLABLE_HMI                                       0xA093
#define unicode_YI_SYLLABLE_HMIP                                      0xA094
#define unicode_YI_SYLLABLE_HMIEX                                     0xA095
#define unicode_YI_SYLLABLE_HMIE                                      0xA096
#define unicode_YI_SYLLABLE_HMIEP                                     0xA097
#define unicode_YI_SYLLABLE_HMAT                                      0xA098
#define unicode_YI_SYLLABLE_HMAX                                      0xA099
#define unicode_YI_SYLLABLE_HMA                                       0xA09A
#define unicode_YI_SYLLABLE_HMAP                                      0xA09B
#define unicode_YI_SYLLABLE_HMUOX                                     0xA09C
#define unicode_YI_SYLLABLE_HMUO                                      0xA09D
#define unicode_YI_SYLLABLE_HMUOP                                     0xA09E
#define unicode_YI_SYLLABLE_HMOT                                      0xA09F
#define unicode_YI_SYLLABLE_HMOX                                      0xA0A0
#define unicode_YI_SYLLABLE_HMO                                       0xA0A1
#define unicode_YI_SYLLABLE_HMOP                                      0xA0A2
#define unicode_YI_SYLLABLE_HMUT                                      0xA0A3
#define unicode_YI_SYLLABLE_HMUX                                      0xA0A4
#define unicode_YI_SYLLABLE_HMU                                       0xA0A5
#define unicode_YI_SYLLABLE_HMUP                                      0xA0A6
#define unicode_YI_SYLLABLE_HMURX                                     0xA0A7
#define unicode_YI_SYLLABLE_HMUR                                      0xA0A8
#define unicode_YI_SYLLABLE_HMYX                                      0xA0A9
#define unicode_YI_SYLLABLE_HMY                                       0xA0AA
#define unicode_YI_SYLLABLE_HMYP                                      0xA0AB
#define unicode_YI_SYLLABLE_HMYRX                                     0xA0AC
#define unicode_YI_SYLLABLE_HMYR                                      0xA0AD
#define unicode_YI_SYLLABLE_MIT                                       0xA0AE
#define unicode_YI_SYLLABLE_MIX                                       0xA0AF
#define unicode_YI_SYLLABLE_MI                                        0xA0B0
#define unicode_YI_SYLLABLE_MIP                                       0xA0B1
#define unicode_YI_SYLLABLE_MIEX                                      0xA0B2
#define unicode_YI_SYLLABLE_MIE                                       0xA0B3
#define unicode_YI_SYLLABLE_MIEP                                      0xA0B4
#define unicode_YI_SYLLABLE_MAT                                       0xA0B5
#define unicode_YI_SYLLABLE_MAX                                       0xA0B6
#define unicode_YI_SYLLABLE_MA                                        0xA0B7
#define unicode_YI_SYLLABLE_MAP                                       0xA0B8
#define unicode_YI_SYLLABLE_MUOT                                      0xA0B9
#define unicode_YI_SYLLABLE_MUOX                                      0xA0BA
#define unicode_YI_SYLLABLE_MUO                                       0xA0BB
#define unicode_YI_SYLLABLE_MUOP                                      0xA0BC
#define unicode_YI_SYLLABLE_MOT                                       0xA0BD
#define unicode_YI_SYLLABLE_MOX                                       0xA0BE
#define unicode_YI_SYLLABLE_MO                                        0xA0BF
#define unicode_YI_SYLLABLE_MOP                                       0xA0C0
#define unicode_YI_SYLLABLE_MEX                                       0xA0C1
#define unicode_YI_SYLLABLE_ME                                        0xA0C2
#define unicode_YI_SYLLABLE_MUT                                       0xA0C3
#define unicode_YI_SYLLABLE_MUX                                       0xA0C4
#define unicode_YI_SYLLABLE_MU                                        0xA0C5
#define unicode_YI_SYLLABLE_MUP                                       0xA0C6
#define unicode_YI_SYLLABLE_MURX                                      0xA0C7
#define unicode_YI_SYLLABLE_MUR                                       0xA0C8
#define unicode_YI_SYLLABLE_MYT                                       0xA0C9
#define unicode_YI_SYLLABLE_MYX                                       0xA0CA
#define unicode_YI_SYLLABLE_MY                                        0xA0CB
#define unicode_YI_SYLLABLE_MYP                                       0xA0CC
#define unicode_YI_SYLLABLE_FIT                                       0xA0CD
#define unicode_YI_SYLLABLE_FIX                                       0xA0CE
#define unicode_YI_SYLLABLE_FI                                        0xA0CF
#define unicode_YI_SYLLABLE_FIP                                       0xA0D0
#define unicode_YI_SYLLABLE_FAT                                       0xA0D1
#define unicode_YI_SYLLABLE_FAX                                       0xA0D2
#define unicode_YI_SYLLABLE_FA                                        0xA0D3
#define unicode_YI_SYLLABLE_FAP                                       0xA0D4
#define unicode_YI_SYLLABLE_FOX                                       0xA0D5
#define unicode_YI_SYLLABLE_FO                                        0xA0D6
#define unicode_YI_SYLLABLE_FOP                                       0xA0D7
#define unicode_YI_SYLLABLE_FUT                                       0xA0D8
#define unicode_YI_SYLLABLE_FUX                                       0xA0D9
#define unicode_YI_SYLLABLE_FU                                        0xA0DA
#define unicode_YI_SYLLABLE_FUP                                       0xA0DB
#define unicode_YI_SYLLABLE_FURX                                      0xA0DC
#define unicode_YI_SYLLABLE_FUR                                       0xA0DD
#define unicode_YI_SYLLABLE_FYT                                       0xA0DE
#define unicode_YI_SYLLABLE_FYX                                       0xA0DF
#define unicode_YI_SYLLABLE_FY                                        0xA0E0
#define unicode_YI_SYLLABLE_FYP                                       0xA0E1
#define unicode_YI_SYLLABLE_VIT                                       0xA0E2
#define unicode_YI_SYLLABLE_VIX                                       0xA0E3
#define unicode_YI_SYLLABLE_VI                                        0xA0E4
#define unicode_YI_SYLLABLE_VIP                                       0xA0E5
#define unicode_YI_SYLLABLE_VIET                                      0xA0E6
#define unicode_YI_SYLLABLE_VIEX                                      0xA0E7
#define unicode_YI_SYLLABLE_VIE                                       0xA0E8
#define unicode_YI_SYLLABLE_VIEP                                      0xA0E9
#define unicode_YI_SYLLABLE_VAT                                       0xA0EA
#define unicode_YI_SYLLABLE_VAX                                       0xA0EB
#define unicode_YI_SYLLABLE_VA                                        0xA0EC
#define unicode_YI_SYLLABLE_VAP                                       0xA0ED
#define unicode_YI_SYLLABLE_VOT                                       0xA0EE
#define unicode_YI_SYLLABLE_VOX                                       0xA0EF
#define unicode_YI_SYLLABLE_VO                                        0xA0F0
#define unicode_YI_SYLLABLE_VOP                                       0xA0F1
#define unicode_YI_SYLLABLE_VEX                                       0xA0F2
#define unicode_YI_SYLLABLE_VEP                                       0xA0F3
#define unicode_YI_SYLLABLE_VUT                                       0xA0F4
#define unicode_YI_SYLLABLE_VUX                                       0xA0F5
#define unicode_YI_SYLLABLE_VU                                        0xA0F6
#define unicode_YI_SYLLABLE_VUP                                       0xA0F7
#define unicode_YI_SYLLABLE_VURX                                      0xA0F8
#define unicode_YI_SYLLABLE_VUR                                       0xA0F9
#define unicode_YI_SYLLABLE_VYT                                       0xA0FA
#define unicode_YI_SYLLABLE_VYX                                       0xA0FB
#define unicode_YI_SYLLABLE_VY                                        0xA0FC
#define unicode_YI_SYLLABLE_VYP                                       0xA0FD
#define unicode_YI_SYLLABLE_VYRX                                      0xA0FE
#define unicode_YI_SYLLABLE_VYR                                       0xA0FF
#define unicode_YI_SYLLABLE_DIT                                       0xA100
#define unicode_YI_SYLLABLE_DIX                                       0xA101
#define unicode_YI_SYLLABLE_DI                                        0xA102
#define unicode_YI_SYLLABLE_DIP                                       0xA103
#define unicode_YI_SYLLABLE_DIEX                                      0xA104
#define unicode_YI_SYLLABLE_DIE                                       0xA105
#define unicode_YI_SYLLABLE_DIEP                                      0xA106
#define unicode_YI_SYLLABLE_DAT                                       0xA107
#define unicode_YI_SYLLABLE_DAX                                       0xA108
#define unicode_YI_SYLLABLE_DA                                        0xA109
#define unicode_YI_SYLLABLE_DAP                                       0xA10A
#define unicode_YI_SYLLABLE_DUOX                                      0xA10B
#define unicode_YI_SYLLABLE_DUO                                       0xA10C
#define unicode_YI_SYLLABLE_DOT                                       0xA10D
#define unicode_YI_SYLLABLE_DOX                                       0xA10E
#define unicode_YI_SYLLABLE_DO                                        0xA10F
#define unicode_YI_SYLLABLE_DOP                                       0xA110
#define unicode_YI_SYLLABLE_DEX                                       0xA111
#define unicode_YI_SYLLABLE_DE                                        0xA112
#define unicode_YI_SYLLABLE_DEP                                       0xA113
#define unicode_YI_SYLLABLE_DUT                                       0xA114
#define unicode_YI_SYLLABLE_DUX                                       0xA115
#define unicode_YI_SYLLABLE_DU                                        0xA116
#define unicode_YI_SYLLABLE_DUP                                       0xA117
#define unicode_YI_SYLLABLE_DURX                                      0xA118
#define unicode_YI_SYLLABLE_DUR                                       0xA119
#define unicode_YI_SYLLABLE_TIT                                       0xA11A
#define unicode_YI_SYLLABLE_TIX                                       0xA11B
#define unicode_YI_SYLLABLE_TI                                        0xA11C
#define unicode_YI_SYLLABLE_TIP                                       0xA11D
#define unicode_YI_SYLLABLE_TIEX                                      0xA11E
#define unicode_YI_SYLLABLE_TIE                                       0xA11F
#define unicode_YI_SYLLABLE_TIEP                                      0xA120
#define unicode_YI_SYLLABLE_TAT                                       0xA121
#define unicode_YI_SYLLABLE_TAX                                       0xA122
#define unicode_YI_SYLLABLE_TA                                        0xA123
#define unicode_YI_SYLLABLE_TAP                                       0xA124
#define unicode_YI_SYLLABLE_TUOT                                      0xA125
#define unicode_YI_SYLLABLE_TUOX                                      0xA126
#define unicode_YI_SYLLABLE_TUO                                       0xA127
#define unicode_YI_SYLLABLE_TUOP                                      0xA128
#define unicode_YI_SYLLABLE_TOT                                       0xA129
#define unicode_YI_SYLLABLE_TOX                                       0xA12A
#define unicode_YI_SYLLABLE_TO                                        0xA12B
#define unicode_YI_SYLLABLE_TOP                                       0xA12C
#define unicode_YI_SYLLABLE_TEX                                       0xA12D
#define unicode_YI_SYLLABLE_TE                                        0xA12E
#define unicode_YI_SYLLABLE_TEP                                       0xA12F
#define unicode_YI_SYLLABLE_TUT                                       0xA130
#define unicode_YI_SYLLABLE_TUX                                       0xA131
#define unicode_YI_SYLLABLE_TU                                        0xA132
#define unicode_YI_SYLLABLE_TUP                                       0xA133
#define unicode_YI_SYLLABLE_TURX                                      0xA134
#define unicode_YI_SYLLABLE_TUR                                       0xA135
#define unicode_YI_SYLLABLE_DDIT                                      0xA136
#define unicode_YI_SYLLABLE_DDIX                                      0xA137
#define unicode_YI_SYLLABLE_DDI                                       0xA138
#define unicode_YI_SYLLABLE_DDIP                                      0xA139
#define unicode_YI_SYLLABLE_DDIEX                                     0xA13A
#define unicode_YI_SYLLABLE_DDIE                                      0xA13B
#define unicode_YI_SYLLABLE_DDIEP                                     0xA13C
#define unicode_YI_SYLLABLE_DDAT                                      0xA13D
#define unicode_YI_SYLLABLE_DDAX                                      0xA13E
#define unicode_YI_SYLLABLE_DDA                                       0xA13F
#define unicode_YI_SYLLABLE_DDAP                                      0xA140
#define unicode_YI_SYLLABLE_DDUOX                                     0xA141
#define unicode_YI_SYLLABLE_DDUO                                      0xA142
#define unicode_YI_SYLLABLE_DDUOP                                     0xA143
#define unicode_YI_SYLLABLE_DDOT                                      0xA144
#define unicode_YI_SYLLABLE_DDOX                                      0xA145
#define unicode_YI_SYLLABLE_DDO                                       0xA146
#define unicode_YI_SYLLABLE_DDOP                                      0xA147
#define unicode_YI_SYLLABLE_DDEX                                      0xA148
#define unicode_YI_SYLLABLE_DDE                                       0xA149
#define unicode_YI_SYLLABLE_DDEP                                      0xA14A
#define unicode_YI_SYLLABLE_DDUT                                      0xA14B
#define unicode_YI_SYLLABLE_DDUX                                      0xA14C
#define unicode_YI_SYLLABLE_DDU                                       0xA14D
#define unicode_YI_SYLLABLE_DDUP                                      0xA14E
#define unicode_YI_SYLLABLE_DDURX                                     0xA14F
#define unicode_YI_SYLLABLE_DDUR                                      0xA150
#define unicode_YI_SYLLABLE_NDIT                                      0xA151
#define unicode_YI_SYLLABLE_NDIX                                      0xA152
#define unicode_YI_SYLLABLE_NDI                                       0xA153
#define unicode_YI_SYLLABLE_NDIP                                      0xA154
#define unicode_YI_SYLLABLE_NDIEX                                     0xA155
#define unicode_YI_SYLLABLE_NDIE                                      0xA156
#define unicode_YI_SYLLABLE_NDAT                                      0xA157
#define unicode_YI_SYLLABLE_NDAX                                      0xA158
#define unicode_YI_SYLLABLE_NDA                                       0xA159
#define unicode_YI_SYLLABLE_NDAP                                      0xA15A
#define unicode_YI_SYLLABLE_NDOT                                      0xA15B
#define unicode_YI_SYLLABLE_NDOX                                      0xA15C
#define unicode_YI_SYLLABLE_NDO                                       0xA15D
#define unicode_YI_SYLLABLE_NDOP                                      0xA15E
#define unicode_YI_SYLLABLE_NDEX                                      0xA15F
#define unicode_YI_SYLLABLE_NDE                                       0xA160
#define unicode_YI_SYLLABLE_NDEP                                      0xA161
#define unicode_YI_SYLLABLE_NDUT                                      0xA162
#define unicode_YI_SYLLABLE_NDUX                                      0xA163
#define unicode_YI_SYLLABLE_NDU                                       0xA164
#define unicode_YI_SYLLABLE_NDUP                                      0xA165
#define unicode_YI_SYLLABLE_NDURX                                     0xA166
#define unicode_YI_SYLLABLE_NDUR                                      0xA167
#define unicode_YI_SYLLABLE_HNIT                                      0xA168
#define unicode_YI_SYLLABLE_HNIX                                      0xA169
#define unicode_YI_SYLLABLE_HNI                                       0xA16A
#define unicode_YI_SYLLABLE_HNIP                                      0xA16B
#define unicode_YI_SYLLABLE_HNIET                                     0xA16C
#define unicode_YI_SYLLABLE_HNIEX                                     0xA16D
#define unicode_YI_SYLLABLE_HNIE                                      0xA16E
#define unicode_YI_SYLLABLE_HNIEP                                     0xA16F
#define unicode_YI_SYLLABLE_HNAT                                      0xA170
#define unicode_YI_SYLLABLE_HNAX                                      0xA171
#define unicode_YI_SYLLABLE_HNA                                       0xA172
#define unicode_YI_SYLLABLE_HNAP                                      0xA173
#define unicode_YI_SYLLABLE_HNUOX                                     0xA174
#define unicode_YI_SYLLABLE_HNUO                                      0xA175
#define unicode_YI_SYLLABLE_HNOT                                      0xA176
#define unicode_YI_SYLLABLE_HNOX                                      0xA177
#define unicode_YI_SYLLABLE_HNOP                                      0xA178
#define unicode_YI_SYLLABLE_HNEX                                      0xA179
#define unicode_YI_SYLLABLE_HNE                                       0xA17A
#define unicode_YI_SYLLABLE_HNEP                                      0xA17B
#define unicode_YI_SYLLABLE_HNUT                                      0xA17C
#define unicode_YI_SYLLABLE_NIT                                       0xA17D
#define unicode_YI_SYLLABLE_NIX                                       0xA17E
#define unicode_YI_SYLLABLE_NI                                        0xA17F
#define unicode_YI_SYLLABLE_NIP                                       0xA180
#define unicode_YI_SYLLABLE_NIEX                                      0xA181
#define unicode_YI_SYLLABLE_NIE                                       0xA182
#define unicode_YI_SYLLABLE_NIEP                                      0xA183
#define unicode_YI_SYLLABLE_NAX                                       0xA184
#define unicode_YI_SYLLABLE_NA                                        0xA185
#define unicode_YI_SYLLABLE_NAP                                       0xA186
#define unicode_YI_SYLLABLE_NUOX                                      0xA187
#define unicode_YI_SYLLABLE_NUO                                       0xA188
#define unicode_YI_SYLLABLE_NUOP                                      0xA189
#define unicode_YI_SYLLABLE_NOT                                       0xA18A
#define unicode_YI_SYLLABLE_NOX                                       0xA18B
#define unicode_YI_SYLLABLE_NO                                        0xA18C
#define unicode_YI_SYLLABLE_NOP                                       0xA18D
#define unicode_YI_SYLLABLE_NEX                                       0xA18E
#define unicode_YI_SYLLABLE_NE                                        0xA18F
#define unicode_YI_SYLLABLE_NEP                                       0xA190
#define unicode_YI_SYLLABLE_NUT                                       0xA191
#define unicode_YI_SYLLABLE_NUX                                       0xA192
#define unicode_YI_SYLLABLE_NU                                        0xA193
#define unicode_YI_SYLLABLE_NUP                                       0xA194
#define unicode_YI_SYLLABLE_NURX                                      0xA195
#define unicode_YI_SYLLABLE_NUR                                       0xA196
#define unicode_YI_SYLLABLE_HLIT                                      0xA197
#define unicode_YI_SYLLABLE_HLIX                                      0xA198
#define unicode_YI_SYLLABLE_HLI                                       0xA199
#define unicode_YI_SYLLABLE_HLIP                                      0xA19A
#define unicode_YI_SYLLABLE_HLIEX                                     0xA19B
#define unicode_YI_SYLLABLE_HLIE                                      0xA19C
#define unicode_YI_SYLLABLE_HLIEP                                     0xA19D
#define unicode_YI_SYLLABLE_HLAT                                      0xA19E
#define unicode_YI_SYLLABLE_HLAX                                      0xA19F
#define unicode_YI_SYLLABLE_HLA                                       0xA1A0
#define unicode_YI_SYLLABLE_HLAP                                      0xA1A1
#define unicode_YI_SYLLABLE_HLUOX                                     0xA1A2
#define unicode_YI_SYLLABLE_HLUO                                      0xA1A3
#define unicode_YI_SYLLABLE_HLUOP                                     0xA1A4
#define unicode_YI_SYLLABLE_HLOX                                      0xA1A5
#define unicode_YI_SYLLABLE_HLO                                       0xA1A6
#define unicode_YI_SYLLABLE_HLOP                                      0xA1A7
#define unicode_YI_SYLLABLE_HLEX                                      0xA1A8
#define unicode_YI_SYLLABLE_HLE                                       0xA1A9
#define unicode_YI_SYLLABLE_HLEP                                      0xA1AA
#define unicode_YI_SYLLABLE_HLUT                                      0xA1AB
#define unicode_YI_SYLLABLE_HLUX                                      0xA1AC
#define unicode_YI_SYLLABLE_HLU                                       0xA1AD
#define unicode_YI_SYLLABLE_HLUP                                      0xA1AE
#define unicode_YI_SYLLABLE_HLURX                                     0xA1AF
#define unicode_YI_SYLLABLE_HLUR                                      0xA1B0
#define unicode_YI_SYLLABLE_HLYT                                      0xA1B1
#define unicode_YI_SYLLABLE_HLYX                                      0xA1B2
#define unicode_YI_SYLLABLE_HLY                                       0xA1B3
#define unicode_YI_SYLLABLE_HLYP                                      0xA1B4
#define unicode_YI_SYLLABLE_HLYRX                                     0xA1B5
#define unicode_YI_SYLLABLE_HLYR                                      0xA1B6
#define unicode_YI_SYLLABLE_LIT                                       0xA1B7
#define unicode_YI_SYLLABLE_LIX                                       0xA1B8
#define unicode_YI_SYLLABLE_LI                                        0xA1B9
#define unicode_YI_SYLLABLE_LIP                                       0xA1BA
#define unicode_YI_SYLLABLE_LIET                                      0xA1BB
#define unicode_YI_SYLLABLE_LIEX                                      0xA1BC
#define unicode_YI_SYLLABLE_LIE                                       0xA1BD
#define unicode_YI_SYLLABLE_LIEP                                      0xA1BE
#define unicode_YI_SYLLABLE_LAT                                       0xA1BF
#define unicode_YI_SYLLABLE_LAX                                       0xA1C0
#define unicode_YI_SYLLABLE_LA                                        0xA1C1
#define unicode_YI_SYLLABLE_LAP                                       0xA1C2
#define unicode_YI_SYLLABLE_LUOT                                      0xA1C3
#define unicode_YI_SYLLABLE_LUOX                                      0xA1C4
#define unicode_YI_SYLLABLE_LUO                                       0xA1C5
#define unicode_YI_SYLLABLE_LUOP                                      0xA1C6
#define unicode_YI_SYLLABLE_LOT                                       0xA1C7
#define unicode_YI_SYLLABLE_LOX                                       0xA1C8
#define unicode_YI_SYLLABLE_LO                                        0xA1C9
#define unicode_YI_SYLLABLE_LOP                                       0xA1CA
#define unicode_YI_SYLLABLE_LEX                                       0xA1CB
#define unicode_YI_SYLLABLE_LE                                        0xA1CC
#define unicode_YI_SYLLABLE_LEP                                       0xA1CD
#define unicode_YI_SYLLABLE_LUT                                       0xA1CE
#define unicode_YI_SYLLABLE_LUX                                       0xA1CF
#define unicode_YI_SYLLABLE_LU                                        0xA1D0
#define unicode_YI_SYLLABLE_LUP                                       0xA1D1
#define unicode_YI_SYLLABLE_LURX                                      0xA1D2
#define unicode_YI_SYLLABLE_LUR                                       0xA1D3
#define unicode_YI_SYLLABLE_LYT                                       0xA1D4
#define unicode_YI_SYLLABLE_LYX                                       0xA1D5
#define unicode_YI_SYLLABLE_LY                                        0xA1D6
#define unicode_YI_SYLLABLE_LYP                                       0xA1D7
#define unicode_YI_SYLLABLE_LYRX                                      0xA1D8
#define unicode_YI_SYLLABLE_LYR                                       0xA1D9
#define unicode_YI_SYLLABLE_GIT                                       0xA1DA
#define unicode_YI_SYLLABLE_GIX                                       0xA1DB
#define unicode_YI_SYLLABLE_GI                                        0xA1DC
#define unicode_YI_SYLLABLE_GIP                                       0xA1DD
#define unicode_YI_SYLLABLE_GIET                                      0xA1DE
#define unicode_YI_SYLLABLE_GIEX                                      0xA1DF
#define unicode_YI_SYLLABLE_GIE                                       0xA1E0
#define unicode_YI_SYLLABLE_GIEP                                      0xA1E1
#define unicode_YI_SYLLABLE_GAT                                       0xA1E2
#define unicode_YI_SYLLABLE_GAX                                       0xA1E3
#define unicode_YI_SYLLABLE_GA                                        0xA1E4
#define unicode_YI_SYLLABLE_GAP                                       0xA1E5
#define unicode_YI_SYLLABLE_GUOT                                      0xA1E6
#define unicode_YI_SYLLABLE_GUOX                                      0xA1E7
#define unicode_YI_SYLLABLE_GUO                                       0xA1E8
#define unicode_YI_SYLLABLE_GUOP                                      0xA1E9
#define unicode_YI_SYLLABLE_GOT                                       0xA1EA
#define unicode_YI_SYLLABLE_GOX                                       0xA1EB
#define unicode_YI_SYLLABLE_GO                                        0xA1EC
#define unicode_YI_SYLLABLE_GOP                                       0xA1ED
#define unicode_YI_SYLLABLE_GET                                       0xA1EE
#define unicode_YI_SYLLABLE_GEX                                       0xA1EF
#define unicode_YI_SYLLABLE_GE                                        0xA1F0
#define unicode_YI_SYLLABLE_GEP                                       0xA1F1
#define unicode_YI_SYLLABLE_GUT                                       0xA1F2
#define unicode_YI_SYLLABLE_GUX                                       0xA1F3
#define unicode_YI_SYLLABLE_GU                                        0xA1F4
#define unicode_YI_SYLLABLE_GUP                                       0xA1F5
#define unicode_YI_SYLLABLE_GURX                                      0xA1F6
#define unicode_YI_SYLLABLE_GUR                                       0xA1F7
#define unicode_YI_SYLLABLE_KIT                                       0xA1F8
#define unicode_YI_SYLLABLE_KIX                                       0xA1F9
#define unicode_YI_SYLLABLE_KI                                        0xA1FA
#define unicode_YI_SYLLABLE_KIP                                       0xA1FB
#define unicode_YI_SYLLABLE_KIEX                                      0xA1FC
#define unicode_YI_SYLLABLE_KIE                                       0xA1FD
#define unicode_YI_SYLLABLE_KIEP                                      0xA1FE
#define unicode_YI_SYLLABLE_KAT                                       0xA1FF
#define unicode_YI_SYLLABLE_KAX                                       0xA200
#define unicode_YI_SYLLABLE_KA                                        0xA201
#define unicode_YI_SYLLABLE_KAP                                       0xA202
#define unicode_YI_SYLLABLE_KUOX                                      0xA203
#define unicode_YI_SYLLABLE_KUO                                       0xA204
#define unicode_YI_SYLLABLE_KUOP                                      0xA205
#define unicode_YI_SYLLABLE_KOT                                       0xA206
#define unicode_YI_SYLLABLE_KOX                                       0xA207
#define unicode_YI_SYLLABLE_KO                                        0xA208
#define unicode_YI_SYLLABLE_KOP                                       0xA209
#define unicode_YI_SYLLABLE_KET                                       0xA20A
#define unicode_YI_SYLLABLE_KEX                                       0xA20B
#define unicode_YI_SYLLABLE_KE                                        0xA20C
#define unicode_YI_SYLLABLE_KEP                                       0xA20D
#define unicode_YI_SYLLABLE_KUT                                       0xA20E
#define unicode_YI_SYLLABLE_KUX                                       0xA20F
#define unicode_YI_SYLLABLE_KU                                        0xA210
#define unicode_YI_SYLLABLE_KUP                                       0xA211
#define unicode_YI_SYLLABLE_KURX                                      0xA212
#define unicode_YI_SYLLABLE_KUR                                       0xA213
#define unicode_YI_SYLLABLE_GGIT                                      0xA214
#define unicode_YI_SYLLABLE_GGIX                                      0xA215
#define unicode_YI_SYLLABLE_GGI                                       0xA216
#define unicode_YI_SYLLABLE_GGIEX                                     0xA217
#define unicode_YI_SYLLABLE_GGIE                                      0xA218
#define unicode_YI_SYLLABLE_GGIEP                                     0xA219
#define unicode_YI_SYLLABLE_GGAT                                      0xA21A
#define unicode_YI_SYLLABLE_GGAX                                      0xA21B
#define unicode_YI_SYLLABLE_GGA                                       0xA21C
#define unicode_YI_SYLLABLE_GGAP                                      0xA21D
#define unicode_YI_SYLLABLE_GGUOT                                     0xA21E
#define unicode_YI_SYLLABLE_GGUOX                                     0xA21F
#define unicode_YI_SYLLABLE_GGUO                                      0xA220
#define unicode_YI_SYLLABLE_GGUOP                                     0xA221
#define unicode_YI_SYLLABLE_GGOT                                      0xA222
#define unicode_YI_SYLLABLE_GGOX                                      0xA223
#define unicode_YI_SYLLABLE_GGO                                       0xA224
#define unicode_YI_SYLLABLE_GGOP                                      0xA225
#define unicode_YI_SYLLABLE_GGET                                      0xA226
#define unicode_YI_SYLLABLE_GGEX                                      0xA227
#define unicode_YI_SYLLABLE_GGE                                       0xA228
#define unicode_YI_SYLLABLE_GGEP                                      0xA229
#define unicode_YI_SYLLABLE_GGUT                                      0xA22A
#define unicode_YI_SYLLABLE_GGUX                                      0xA22B
#define unicode_YI_SYLLABLE_GGU                                       0xA22C
#define unicode_YI_SYLLABLE_GGUP                                      0xA22D
#define unicode_YI_SYLLABLE_GGURX                                     0xA22E
#define unicode_YI_SYLLABLE_GGUR                                      0xA22F
#define unicode_YI_SYLLABLE_MGIEX                                     0xA230
#define unicode_YI_SYLLABLE_MGIE                                      0xA231
#define unicode_YI_SYLLABLE_MGAT                                      0xA232
#define unicode_YI_SYLLABLE_MGAX                                      0xA233
#define unicode_YI_SYLLABLE_MGA                                       0xA234
#define unicode_YI_SYLLABLE_MGAP                                      0xA235
#define unicode_YI_SYLLABLE_MGUOX                                     0xA236
#define unicode_YI_SYLLABLE_MGUO                                      0xA237
#define unicode_YI_SYLLABLE_MGUOP                                     0xA238
#define unicode_YI_SYLLABLE_MGOT                                      0xA239
#define unicode_YI_SYLLABLE_MGOX                                      0xA23A
#define unicode_YI_SYLLABLE_MGO                                       0xA23B
#define unicode_YI_SYLLABLE_MGOP                                      0xA23C
#define unicode_YI_SYLLABLE_MGEX                                      0xA23D
#define unicode_YI_SYLLABLE_MGE                                       0xA23E
#define unicode_YI_SYLLABLE_MGEP                                      0xA23F
#define unicode_YI_SYLLABLE_MGUT                                      0xA240
#define unicode_YI_SYLLABLE_MGUX                                      0xA241
#define unicode_YI_SYLLABLE_MGU                                       0xA242
#define unicode_YI_SYLLABLE_MGUP                                      0xA243
#define unicode_YI_SYLLABLE_MGURX                                     0xA244
#define unicode_YI_SYLLABLE_MGUR                                      0xA245
#define unicode_YI_SYLLABLE_HXIT                                      0xA246
#define unicode_YI_SYLLABLE_HXIX                                      0xA247
#define unicode_YI_SYLLABLE_HXI                                       0xA248
#define unicode_YI_SYLLABLE_HXIP                                      0xA249
#define unicode_YI_SYLLABLE_HXIET                                     0xA24A
#define unicode_YI_SYLLABLE_HXIEX                                     0xA24B
#define unicode_YI_SYLLABLE_HXIE                                      0xA24C
#define unicode_YI_SYLLABLE_HXIEP                                     0xA24D
#define unicode_YI_SYLLABLE_HXAT                                      0xA24E
#define unicode_YI_SYLLABLE_HXAX                                      0xA24F
#define unicode_YI_SYLLABLE_HXA                                       0xA250
#define unicode_YI_SYLLABLE_HXAP                                      0xA251
#define unicode_YI_SYLLABLE_HXUOT                                     0xA252
#define unicode_YI_SYLLABLE_HXUOX                                     0xA253
#define unicode_YI_SYLLABLE_HXUO                                      0xA254
#define unicode_YI_SYLLABLE_HXUOP                                     0xA255
#define unicode_YI_SYLLABLE_HXOT                                      0xA256
#define unicode_YI_SYLLABLE_HXOX                                      0xA257
#define unicode_YI_SYLLABLE_HXO                                       0xA258
#define unicode_YI_SYLLABLE_HXOP                                      0xA259
#define unicode_YI_SYLLABLE_HXEX                                      0xA25A
#define unicode_YI_SYLLABLE_HXE                                       0xA25B
#define unicode_YI_SYLLABLE_HXEP                                      0xA25C
#define unicode_YI_SYLLABLE_NGIEX                                     0xA25D
#define unicode_YI_SYLLABLE_NGIE                                      0xA25E
#define unicode_YI_SYLLABLE_NGIEP                                     0xA25F
#define unicode_YI_SYLLABLE_NGAT                                      0xA260
#define unicode_YI_SYLLABLE_NGAX                                      0xA261
#define unicode_YI_SYLLABLE_NGA                                       0xA262
#define unicode_YI_SYLLABLE_NGAP                                      0xA263
#define unicode_YI_SYLLABLE_NGUOT                                     0xA264
#define unicode_YI_SYLLABLE_NGUOX                                     0xA265
#define unicode_YI_SYLLABLE_NGUO                                      0xA266
#define unicode_YI_SYLLABLE_NGOT                                      0xA267
#define unicode_YI_SYLLABLE_NGOX                                      0xA268
#define unicode_YI_SYLLABLE_NGO                                       0xA269
#define unicode_YI_SYLLABLE_NGOP                                      0xA26A
#define unicode_YI_SYLLABLE_NGEX                                      0xA26B
#define unicode_YI_SYLLABLE_NGE                                       0xA26C
#define unicode_YI_SYLLABLE_NGEP                                      0xA26D
#define unicode_YI_SYLLABLE_HIT                                       0xA26E
#define unicode_YI_SYLLABLE_HIEX                                      0xA26F
#define unicode_YI_SYLLABLE_HIE                                       0xA270
#define unicode_YI_SYLLABLE_HAT                                       0xA271
#define unicode_YI_SYLLABLE_HAX                                       0xA272
#define unicode_YI_SYLLABLE_HA                                        0xA273
#define unicode_YI_SYLLABLE_HAP                                       0xA274
#define unicode_YI_SYLLABLE_HUOT                                      0xA275
#define unicode_YI_SYLLABLE_HUOX                                      0xA276
#define unicode_YI_SYLLABLE_HUO                                       0xA277
#define unicode_YI_SYLLABLE_HUOP                                      0xA278
#define unicode_YI_SYLLABLE_HOT                                       0xA279
#define unicode_YI_SYLLABLE_HOX                                       0xA27A
#define unicode_YI_SYLLABLE_HO                                        0xA27B
#define unicode_YI_SYLLABLE_HOP                                       0xA27C
#define unicode_YI_SYLLABLE_HEX                                       0xA27D
#define unicode_YI_SYLLABLE_HE                                        0xA27E
#define unicode_YI_SYLLABLE_HEP                                       0xA27F
#define unicode_YI_SYLLABLE_WAT                                       0xA280
#define unicode_YI_SYLLABLE_WAX                                       0xA281
#define unicode_YI_SYLLABLE_WA                                        0xA282
#define unicode_YI_SYLLABLE_WAP                                       0xA283
#define unicode_YI_SYLLABLE_WUOX                                      0xA284
#define unicode_YI_SYLLABLE_WUO                                       0xA285
#define unicode_YI_SYLLABLE_WUOP                                      0xA286
#define unicode_YI_SYLLABLE_WOX                                       0xA287
#define unicode_YI_SYLLABLE_WO                                        0xA288
#define unicode_YI_SYLLABLE_WOP                                       0xA289
#define unicode_YI_SYLLABLE_WEX                                       0xA28A
#define unicode_YI_SYLLABLE_WE                                        0xA28B
#define unicode_YI_SYLLABLE_WEP                                       0xA28C
#define unicode_YI_SYLLABLE_ZIT                                       0xA28D
#define unicode_YI_SYLLABLE_ZIX                                       0xA28E
#define unicode_YI_SYLLABLE_ZI                                        0xA28F
#define unicode_YI_SYLLABLE_ZIP                                       0xA290
#define unicode_YI_SYLLABLE_ZIEX                                      0xA291
#define unicode_YI_SYLLABLE_ZIE                                       0xA292
#define unicode_YI_SYLLABLE_ZIEP                                      0xA293
#define unicode_YI_SYLLABLE_ZAT                                       0xA294
#define unicode_YI_SYLLABLE_ZAX                                       0xA295
#define unicode_YI_SYLLABLE_ZA                                        0xA296
#define unicode_YI_SYLLABLE_ZAP                                       0xA297
#define unicode_YI_SYLLABLE_ZUOX                                      0xA298
#define unicode_YI_SYLLABLE_ZUO                                       0xA299
#define unicode_YI_SYLLABLE_ZUOP                                      0xA29A
#define unicode_YI_SYLLABLE_ZOT                                       0xA29B
#define unicode_YI_SYLLABLE_ZOX                                       0xA29C
#define unicode_YI_SYLLABLE_ZO                                        0xA29D
#define unicode_YI_SYLLABLE_ZOP                                       0xA29E
#define unicode_YI_SYLLABLE_ZEX                                       0xA29F
#define unicode_YI_SYLLABLE_ZE                                        0xA2A0
#define unicode_YI_SYLLABLE_ZEP                                       0xA2A1
#define unicode_YI_SYLLABLE_ZUT                                       0xA2A2
#define unicode_YI_SYLLABLE_ZUX                                       0xA2A3
#define unicode_YI_SYLLABLE_ZU                                        0xA2A4
#define unicode_YI_SYLLABLE_ZUP                                       0xA2A5
#define unicode_YI_SYLLABLE_ZURX                                      0xA2A6
#define unicode_YI_SYLLABLE_ZUR                                       0xA2A7
#define unicode_YI_SYLLABLE_ZYT                                       0xA2A8
#define unicode_YI_SYLLABLE_ZYX                                       0xA2A9
#define unicode_YI_SYLLABLE_ZY                                        0xA2AA
#define unicode_YI_SYLLABLE_ZYP                                       0xA2AB
#define unicode_YI_SYLLABLE_ZYRX                                      0xA2AC
#define unicode_YI_SYLLABLE_ZYR                                       0xA2AD
#define unicode_YI_SYLLABLE_CIT                                       0xA2AE
#define unicode_YI_SYLLABLE_CIX                                       0xA2AF
#define unicode_YI_SYLLABLE_CI                                        0xA2B0
#define unicode_YI_SYLLABLE_CIP                                       0xA2B1
#define unicode_YI_SYLLABLE_CIET                                      0xA2B2
#define unicode_YI_SYLLABLE_CIEX                                      0xA2B3
#define unicode_YI_SYLLABLE_CIE                                       0xA2B4
#define unicode_YI_SYLLABLE_CIEP                                      0xA2B5
#define unicode_YI_SYLLABLE_CAT                                       0xA2B6
#define unicode_YI_SYLLABLE_CAX                                       0xA2B7
#define unicode_YI_SYLLABLE_CA                                        0xA2B8
#define unicode_YI_SYLLABLE_CAP                                       0xA2B9
#define unicode_YI_SYLLABLE_CUOX                                      0xA2BA
#define unicode_YI_SYLLABLE_CUO                                       0xA2BB
#define unicode_YI_SYLLABLE_CUOP                                      0xA2BC
#define unicode_YI_SYLLABLE_COT                                       0xA2BD
#define unicode_YI_SYLLABLE_COX                                       0xA2BE
#define unicode_YI_SYLLABLE_CO                                        0xA2BF
#define unicode_YI_SYLLABLE_COP                                       0xA2C0
#define unicode_YI_SYLLABLE_CEX                                       0xA2C1
#define unicode_YI_SYLLABLE_CE                                        0xA2C2
#define unicode_YI_SYLLABLE_CEP                                       0xA2C3
#define unicode_YI_SYLLABLE_CUT                                       0xA2C4
#define unicode_YI_SYLLABLE_CUX                                       0xA2C5
#define unicode_YI_SYLLABLE_CU                                        0xA2C6
#define unicode_YI_SYLLABLE_CUP                                       0xA2C7
#define unicode_YI_SYLLABLE_CURX                                      0xA2C8
#define unicode_YI_SYLLABLE_CUR                                       0xA2C9
#define unicode_YI_SYLLABLE_CYT                                       0xA2CA
#define unicode_YI_SYLLABLE_CYX                                       0xA2CB
#define unicode_YI_SYLLABLE_CY                                        0xA2CC
#define unicode_YI_SYLLABLE_CYP                                       0xA2CD
#define unicode_YI_SYLLABLE_CYRX                                      0xA2CE
#define unicode_YI_SYLLABLE_CYR                                       0xA2CF
#define unicode_YI_SYLLABLE_ZZIT                                      0xA2D0
#define unicode_YI_SYLLABLE_ZZIX                                      0xA2D1
#define unicode_YI_SYLLABLE_ZZI                                       0xA2D2
#define unicode_YI_SYLLABLE_ZZIP                                      0xA2D3
#define unicode_YI_SYLLABLE_ZZIET                                     0xA2D4
#define unicode_YI_SYLLABLE_ZZIEX                                     0xA2D5
#define unicode_YI_SYLLABLE_ZZIE                                      0xA2D6
#define unicode_YI_SYLLABLE_ZZIEP                                     0xA2D7
#define unicode_YI_SYLLABLE_ZZAT                                      0xA2D8
#define unicode_YI_SYLLABLE_ZZAX                                      0xA2D9
#define unicode_YI_SYLLABLE_ZZA                                       0xA2DA
#define unicode_YI_SYLLABLE_ZZAP                                      0xA2DB
#define unicode_YI_SYLLABLE_ZZOX                                      0xA2DC
#define unicode_YI_SYLLABLE_ZZO                                       0xA2DD
#define unicode_YI_SYLLABLE_ZZOP                                      0xA2DE
#define unicode_YI_SYLLABLE_ZZEX                                      0xA2DF
#define unicode_YI_SYLLABLE_ZZE                                       0xA2E0
#define unicode_YI_SYLLABLE_ZZEP                                      0xA2E1
#define unicode_YI_SYLLABLE_ZZUX                                      0xA2E2
#define unicode_YI_SYLLABLE_ZZU                                       0xA2E3
#define unicode_YI_SYLLABLE_ZZUP                                      0xA2E4
#define unicode_YI_SYLLABLE_ZZURX                                     0xA2E5
#define unicode_YI_SYLLABLE_ZZUR                                      0xA2E6
#define unicode_YI_SYLLABLE_ZZYT                                      0xA2E7
#define unicode_YI_SYLLABLE_ZZYX                                      0xA2E8
#define unicode_YI_SYLLABLE_ZZY                                       0xA2E9
#define unicode_YI_SYLLABLE_ZZYP                                      0xA2EA
#define unicode_YI_SYLLABLE_ZZYRX                                     0xA2EB
#define unicode_YI_SYLLABLE_ZZYR                                      0xA2EC
#define unicode_YI_SYLLABLE_NZIT                                      0xA2ED
#define unicode_YI_SYLLABLE_NZIX                                      0xA2EE
#define unicode_YI_SYLLABLE_NZI                                       0xA2EF
#define unicode_YI_SYLLABLE_NZIP                                      0xA2F0
#define unicode_YI_SYLLABLE_NZIEX                                     0xA2F1
#define unicode_YI_SYLLABLE_NZIE                                      0xA2F2
#define unicode_YI_SYLLABLE_NZIEP                                     0xA2F3
#define unicode_YI_SYLLABLE_NZAT                                      0xA2F4
#define unicode_YI_SYLLABLE_NZAX                                      0xA2F5
#define unicode_YI_SYLLABLE_NZA                                       0xA2F6
#define unicode_YI_SYLLABLE_NZAP                                      0xA2F7
#define unicode_YI_SYLLABLE_NZUOX                                     0xA2F8
#define unicode_YI_SYLLABLE_NZUO                                      0xA2F9
#define unicode_YI_SYLLABLE_NZOX                                      0xA2FA
#define unicode_YI_SYLLABLE_NZOP                                      0xA2FB
#define unicode_YI_SYLLABLE_NZEX                                      0xA2FC
#define unicode_YI_SYLLABLE_NZE                                       0xA2FD
#define unicode_YI_SYLLABLE_NZUX                                      0xA2FE
#define unicode_YI_SYLLABLE_NZU                                       0xA2FF
#define unicode_YI_SYLLABLE_NZUP                                      0xA300
#define unicode_YI_SYLLABLE_NZURX                                     0xA301
#define unicode_YI_SYLLABLE_NZUR                                      0xA302
#define unicode_YI_SYLLABLE_NZYT                                      0xA303
#define unicode_YI_SYLLABLE_NZYX                                      0xA304
#define unicode_YI_SYLLABLE_NZY                                       0xA305
#define unicode_YI_SYLLABLE_NZYP                                      0xA306
#define unicode_YI_SYLLABLE_NZYRX                                     0xA307
#define unicode_YI_SYLLABLE_NZYR                                      0xA308
#define unicode_YI_SYLLABLE_SIT                                       0xA309
#define unicode_YI_SYLLABLE_SIX                                       0xA30A
#define unicode_YI_SYLLABLE_SI                                        0xA30B
#define unicode_YI_SYLLABLE_SIP                                       0xA30C
#define unicode_YI_SYLLABLE_SIEX                                      0xA30D
#define unicode_YI_SYLLABLE_SIE                                       0xA30E
#define unicode_YI_SYLLABLE_SIEP                                      0xA30F
#define unicode_YI_SYLLABLE_SAT                                       0xA310
#define unicode_YI_SYLLABLE_SAX                                       0xA311
#define unicode_YI_SYLLABLE_SA                                        0xA312
#define unicode_YI_SYLLABLE_SAP                                       0xA313
#define unicode_YI_SYLLABLE_SUOX                                      0xA314
#define unicode_YI_SYLLABLE_SUO                                       0xA315
#define unicode_YI_SYLLABLE_SUOP                                      0xA316
#define unicode_YI_SYLLABLE_SOT                                       0xA317
#define unicode_YI_SYLLABLE_SOX                                       0xA318
#define unicode_YI_SYLLABLE_SO                                        0xA319
#define unicode_YI_SYLLABLE_SOP                                       0xA31A
#define unicode_YI_SYLLABLE_SEX                                       0xA31B
#define unicode_YI_SYLLABLE_SE                                        0xA31C
#define unicode_YI_SYLLABLE_SEP                                       0xA31D
#define unicode_YI_SYLLABLE_SUT                                       0xA31E
#define unicode_YI_SYLLABLE_SUX                                       0xA31F
#define unicode_YI_SYLLABLE_SU                                        0xA320
#define unicode_YI_SYLLABLE_SUP                                       0xA321
#define unicode_YI_SYLLABLE_SURX                                      0xA322
#define unicode_YI_SYLLABLE_SUR                                       0xA323
#define unicode_YI_SYLLABLE_SYT                                       0xA324
#define unicode_YI_SYLLABLE_SYX                                       0xA325
#define unicode_YI_SYLLABLE_SY                                        0xA326
#define unicode_YI_SYLLABLE_SYP                                       0xA327
#define unicode_YI_SYLLABLE_SYRX                                      0xA328
#define unicode_YI_SYLLABLE_SYR                                       0xA329
#define unicode_YI_SYLLABLE_SSIT                                      0xA32A
#define unicode_YI_SYLLABLE_SSIX                                      0xA32B
#define unicode_YI_SYLLABLE_SSI                                       0xA32C
#define unicode_YI_SYLLABLE_SSIP                                      0xA32D
#define unicode_YI_SYLLABLE_SSIEX                                     0xA32E
#define unicode_YI_SYLLABLE_SSIE                                      0xA32F
#define unicode_YI_SYLLABLE_SSIEP                                     0xA330
#define unicode_YI_SYLLABLE_SSAT                                      0xA331
#define unicode_YI_SYLLABLE_SSAX                                      0xA332
#define unicode_YI_SYLLABLE_SSA                                       0xA333
#define unicode_YI_SYLLABLE_SSAP                                      0xA334
#define unicode_YI_SYLLABLE_SSOT                                      0xA335
#define unicode_YI_SYLLABLE_SSOX                                      0xA336
#define unicode_YI_SYLLABLE_SSO                                       0xA337
#define unicode_YI_SYLLABLE_SSOP                                      0xA338
#define unicode_YI_SYLLABLE_SSEX                                      0xA339
#define unicode_YI_SYLLABLE_SSE                                       0xA33A
#define unicode_YI_SYLLABLE_SSEP                                      0xA33B
#define unicode_YI_SYLLABLE_SSUT                                      0xA33C
#define unicode_YI_SYLLABLE_SSUX                                      0xA33D
#define unicode_YI_SYLLABLE_SSU                                       0xA33E
#define unicode_YI_SYLLABLE_SSUP                                      0xA33F
#define unicode_YI_SYLLABLE_SSYT                                      0xA340
#define unicode_YI_SYLLABLE_SSYX                                      0xA341
#define unicode_YI_SYLLABLE_SSY                                       0xA342
#define unicode_YI_SYLLABLE_SSYP                                      0xA343
#define unicode_YI_SYLLABLE_SSYRX                                     0xA344
#define unicode_YI_SYLLABLE_SSYR                                      0xA345
#define unicode_YI_SYLLABLE_ZHAT                                      0xA346
#define unicode_YI_SYLLABLE_ZHAX                                      0xA347
#define unicode_YI_SYLLABLE_ZHA                                       0xA348
#define unicode_YI_SYLLABLE_ZHAP                                      0xA349
#define unicode_YI_SYLLABLE_ZHUOX                                     0xA34A
#define unicode_YI_SYLLABLE_ZHUO                                      0xA34B
#define unicode_YI_SYLLABLE_ZHUOP                                     0xA34C
#define unicode_YI_SYLLABLE_ZHOT                                      0xA34D
#define unicode_YI_SYLLABLE_ZHOX                                      0xA34E
#define unicode_YI_SYLLABLE_ZHO                                       0xA34F
#define unicode_YI_SYLLABLE_ZHOP                                      0xA350
#define unicode_YI_SYLLABLE_ZHET                                      0xA351
#define unicode_YI_SYLLABLE_ZHEX                                      0xA352
#define unicode_YI_SYLLABLE_ZHE                                       0xA353
#define unicode_YI_SYLLABLE_ZHEP                                      0xA354
#define unicode_YI_SYLLABLE_ZHUT                                      0xA355
#define unicode_YI_SYLLABLE_ZHUX                                      0xA356
#define unicode_YI_SYLLABLE_ZHU                                       0xA357
#define unicode_YI_SYLLABLE_ZHUP                                      0xA358
#define unicode_YI_SYLLABLE_ZHURX                                     0xA359
#define unicode_YI_SYLLABLE_ZHUR                                      0xA35A
#define unicode_YI_SYLLABLE_ZHYT                                      0xA35B
#define unicode_YI_SYLLABLE_ZHYX                                      0xA35C
#define unicode_YI_SYLLABLE_ZHY                                       0xA35D
#define unicode_YI_SYLLABLE_ZHYP                                      0xA35E
#define unicode_YI_SYLLABLE_ZHYRX                                     0xA35F
#define unicode_YI_SYLLABLE_ZHYR                                      0xA360
#define unicode_YI_SYLLABLE_CHAT                                      0xA361
#define unicode_YI_SYLLABLE_CHAX                                      0xA362
#define unicode_YI_SYLLABLE_CHA                                       0xA363
#define unicode_YI_SYLLABLE_CHAP                                      0xA364
#define unicode_YI_SYLLABLE_CHUOT                                     0xA365
#define unicode_YI_SYLLABLE_CHUOX                                     0xA366
#define unicode_YI_SYLLABLE_CHUO                                      0xA367
#define unicode_YI_SYLLABLE_CHUOP                                     0xA368
#define unicode_YI_SYLLABLE_CHOT                                      0xA369
#define unicode_YI_SYLLABLE_CHOX                                      0xA36A
#define unicode_YI_SYLLABLE_CHO                                       0xA36B
#define unicode_YI_SYLLABLE_CHOP                                      0xA36C
#define unicode_YI_SYLLABLE_CHET                                      0xA36D
#define unicode_YI_SYLLABLE_CHEX                                      0xA36E
#define unicode_YI_SYLLABLE_CHE                                       0xA36F
#define unicode_YI_SYLLABLE_CHEP                                      0xA370
#define unicode_YI_SYLLABLE_CHUX                                      0xA371
#define unicode_YI_SYLLABLE_CHU                                       0xA372
#define unicode_YI_SYLLABLE_CHUP                                      0xA373
#define unicode_YI_SYLLABLE_CHURX                                     0xA374
#define unicode_YI_SYLLABLE_CHUR                                      0xA375
#define unicode_YI_SYLLABLE_CHYT                                      0xA376
#define unicode_YI_SYLLABLE_CHYX                                      0xA377
#define unicode_YI_SYLLABLE_CHY                                       0xA378
#define unicode_YI_SYLLABLE_CHYP                                      0xA379
#define unicode_YI_SYLLABLE_CHYRX                                     0xA37A
#define unicode_YI_SYLLABLE_CHYR                                      0xA37B
#define unicode_YI_SYLLABLE_RRAX                                      0xA37C
#define unicode_YI_SYLLABLE_RRA                                       0xA37D
#define unicode_YI_SYLLABLE_RRUOX                                     0xA37E
#define unicode_YI_SYLLABLE_RRUO                                      0xA37F
#define unicode_YI_SYLLABLE_RROT                                      0xA380
#define unicode_YI_SYLLABLE_RROX                                      0xA381
#define unicode_YI_SYLLABLE_RRO                                       0xA382
#define unicode_YI_SYLLABLE_RROP                                      0xA383
#define unicode_YI_SYLLABLE_RRET                                      0xA384
#define unicode_YI_SYLLABLE_RREX                                      0xA385
#define unicode_YI_SYLLABLE_RRE                                       0xA386
#define unicode_YI_SYLLABLE_RREP                                      0xA387
#define unicode_YI_SYLLABLE_RRUT                                      0xA388
#define unicode_YI_SYLLABLE_RRUX                                      0xA389
#define unicode_YI_SYLLABLE_RRU                                       0xA38A
#define unicode_YI_SYLLABLE_RRUP                                      0xA38B
#define unicode_YI_SYLLABLE_RRURX                                     0xA38C
#define unicode_YI_SYLLABLE_RRUR                                      0xA38D
#define unicode_YI_SYLLABLE_RRYT                                      0xA38E
#define unicode_YI_SYLLABLE_RRYX                                      0xA38F
#define unicode_YI_SYLLABLE_RRY                                       0xA390
#define unicode_YI_SYLLABLE_RRYP                                      0xA391
#define unicode_YI_SYLLABLE_RRYRX                                     0xA392
#define unicode_YI_SYLLABLE_RRYR                                      0xA393
#define unicode_YI_SYLLABLE_NRAT                                      0xA394
#define unicode_YI_SYLLABLE_NRAX                                      0xA395
#define unicode_YI_SYLLABLE_NRA                                       0xA396
#define unicode_YI_SYLLABLE_NRAP                                      0xA397
#define unicode_YI_SYLLABLE_NROX                                      0xA398
#define unicode_YI_SYLLABLE_NRO                                       0xA399
#define unicode_YI_SYLLABLE_NROP                                      0xA39A
#define unicode_YI_SYLLABLE_NRET                                      0xA39B
#define unicode_YI_SYLLABLE_NREX                                      0xA39C
#define unicode_YI_SYLLABLE_NRE                                       0xA39D
#define unicode_YI_SYLLABLE_NREP                                      0xA39E
#define unicode_YI_SYLLABLE_NRUT                                      0xA39F
#define unicode_YI_SYLLABLE_NRUX                                      0xA3A0
#define unicode_YI_SYLLABLE_NRU                                       0xA3A1
#define unicode_YI_SYLLABLE_NRUP                                      0xA3A2
#define unicode_YI_SYLLABLE_NRURX                                     0xA3A3
#define unicode_YI_SYLLABLE_NRUR                                      0xA3A4
#define unicode_YI_SYLLABLE_NRYT                                      0xA3A5
#define unicode_YI_SYLLABLE_NRYX                                      0xA3A6
#define unicode_YI_SYLLABLE_NRY                                       0xA3A7
#define unicode_YI_SYLLABLE_NRYP                                      0xA3A8
#define unicode_YI_SYLLABLE_NRYRX                                     0xA3A9
#define unicode_YI_SYLLABLE_NRYR                                      0xA3AA
#define unicode_YI_SYLLABLE_SHAT                                      0xA3AB
#define unicode_YI_SYLLABLE_SHAX                                      0xA3AC
#define unicode_YI_SYLLABLE_SHA                                       0xA3AD
#define unicode_YI_SYLLABLE_SHAP                                      0xA3AE
#define unicode_YI_SYLLABLE_SHUOX                                     0xA3AF
#define unicode_YI_SYLLABLE_SHUO                                      0xA3B0
#define unicode_YI_SYLLABLE_SHUOP                                     0xA3B1
#define unicode_YI_SYLLABLE_SHOT                                      0xA3B2
#define unicode_YI_SYLLABLE_SHOX                                      0xA3B3
#define unicode_YI_SYLLABLE_SHO                                       0xA3B4
#define unicode_YI_SYLLABLE_SHOP                                      0xA3B5
#define unicode_YI_SYLLABLE_SHET                                      0xA3B6
#define unicode_YI_SYLLABLE_SHEX                                      0xA3B7
#define unicode_YI_SYLLABLE_SHE                                       0xA3B8
#define unicode_YI_SYLLABLE_SHEP                                      0xA3B9
#define unicode_YI_SYLLABLE_SHUT                                      0xA3BA
#define unicode_YI_SYLLABLE_SHUX                                      0xA3BB
#define unicode_YI_SYLLABLE_SHU                                       0xA3BC
#define unicode_YI_SYLLABLE_SHUP                                      0xA3BD
#define unicode_YI_SYLLABLE_SHURX                                     0xA3BE
#define unicode_YI_SYLLABLE_SHUR                                      0xA3BF
#define unicode_YI_SYLLABLE_SHYT                                      0xA3C0
#define unicode_YI_SYLLABLE_SHYX                                      0xA3C1
#define unicode_YI_SYLLABLE_SHY                                       0xA3C2
#define unicode_YI_SYLLABLE_SHYP                                      0xA3C3
#define unicode_YI_SYLLABLE_SHYRX                                     0xA3C4
#define unicode_YI_SYLLABLE_SHYR                                      0xA3C5
#define unicode_YI_SYLLABLE_RAT                                       0xA3C6
#define unicode_YI_SYLLABLE_RAX                                       0xA3C7
#define unicode_YI_SYLLABLE_RA                                        0xA3C8
#define unicode_YI_SYLLABLE_RAP                                       0xA3C9
#define unicode_YI_SYLLABLE_RUOX                                      0xA3CA
#define unicode_YI_SYLLABLE_RUO                                       0xA3CB
#define unicode_YI_SYLLABLE_RUOP                                      0xA3CC
#define unicode_YI_SYLLABLE_ROT                                       0xA3CD
#define unicode_YI_SYLLABLE_ROX                                       0xA3CE
#define unicode_YI_SYLLABLE_RO                                        0xA3CF
#define unicode_YI_SYLLABLE_ROP                                       0xA3D0
#define unicode_YI_SYLLABLE_REX                                       0xA3D1
#define unicode_YI_SYLLABLE_RE                                        0xA3D2
#define unicode_YI_SYLLABLE_REP                                       0xA3D3
#define unicode_YI_SYLLABLE_RUT                                       0xA3D4
#define unicode_YI_SYLLABLE_RUX                                       0xA3D5
#define unicode_YI_SYLLABLE_RU                                        0xA3D6
#define unicode_YI_SYLLABLE_RUP                                       0xA3D7
#define unicode_YI_SYLLABLE_RURX                                      0xA3D8
#define unicode_YI_SYLLABLE_RUR                                       0xA3D9
#define unicode_YI_SYLLABLE_RYT                                       0xA3DA
#define unicode_YI_SYLLABLE_RYX                                       0xA3DB
#define unicode_YI_SYLLABLE_RY                                        0xA3DC
#define unicode_YI_SYLLABLE_RYP                                       0xA3DD
#define unicode_YI_SYLLABLE_RYRX                                      0xA3DE
#define unicode_YI_SYLLABLE_RYR                                       0xA3DF
#define unicode_YI_SYLLABLE_JIT                                       0xA3E0
#define unicode_YI_SYLLABLE_JIX                                       0xA3E1
#define unicode_YI_SYLLABLE_JI                                        0xA3E2
#define unicode_YI_SYLLABLE_JIP                                       0xA3E3
#define unicode_YI_SYLLABLE_JIET                                      0xA3E4
#define unicode_YI_SYLLABLE_JIEX                                      0xA3E5
#define unicode_YI_SYLLABLE_JIE                                       0xA3E6
#define unicode_YI_SYLLABLE_JIEP                                      0xA3E7
#define unicode_YI_SYLLABLE_JUOT                                      0xA3E8
#define unicode_YI_SYLLABLE_JUOX                                      0xA3E9
#define unicode_YI_SYLLABLE_JUO                                       0xA3EA
#define unicode_YI_SYLLABLE_JUOP                                      0xA3EB
#define unicode_YI_SYLLABLE_JOT                                       0xA3EC
#define unicode_YI_SYLLABLE_JOX                                       0xA3ED
#define unicode_YI_SYLLABLE_JO                                        0xA3EE
#define unicode_YI_SYLLABLE_JOP                                       0xA3EF
#define unicode_YI_SYLLABLE_JUT                                       0xA3F0
#define unicode_YI_SYLLABLE_JUX                                       0xA3F1
#define unicode_YI_SYLLABLE_JU                                        0xA3F2
#define unicode_YI_SYLLABLE_JUP                                       0xA3F3
#define unicode_YI_SYLLABLE_JURX                                      0xA3F4
#define unicode_YI_SYLLABLE_JUR                                       0xA3F5
#define unicode_YI_SYLLABLE_JYT                                       0xA3F6
#define unicode_YI_SYLLABLE_JYX                                       0xA3F7
#define unicode_YI_SYLLABLE_JY                                        0xA3F8
#define unicode_YI_SYLLABLE_JYP                                       0xA3F9
#define unicode_YI_SYLLABLE_JYRX                                      0xA3FA
#define unicode_YI_SYLLABLE_JYR                                       0xA3FB
#define unicode_YI_SYLLABLE_QIT                                       0xA3FC
#define unicode_YI_SYLLABLE_QIX                                       0xA3FD
#define unicode_YI_SYLLABLE_QI                                        0xA3FE
#define unicode_YI_SYLLABLE_QIP                                       0xA3FF
#define unicode_YI_SYLLABLE_QIET                                      0xA400
#define unicode_YI_SYLLABLE_QIEX                                      0xA401
#define unicode_YI_SYLLABLE_QIE                                       0xA402
#define unicode_YI_SYLLABLE_QIEP                                      0xA403
#define unicode_YI_SYLLABLE_QUOT                                      0xA404
#define unicode_YI_SYLLABLE_QUOX                                      0xA405
#define unicode_YI_SYLLABLE_QUO                                       0xA406
#define unicode_YI_SYLLABLE_QUOP                                      0xA407
#define unicode_YI_SYLLABLE_QOT                                       0xA408
#define unicode_YI_SYLLABLE_QOX                                       0xA409
#define unicode_YI_SYLLABLE_QO                                        0xA40A
#define unicode_YI_SYLLABLE_QOP                                       0xA40B
#define unicode_YI_SYLLABLE_QUT                                       0xA40C
#define unicode_YI_SYLLABLE_QUX                                       0xA40D
#define unicode_YI_SYLLABLE_QU                                        0xA40E
#define unicode_YI_SYLLABLE_QUP                                       0xA40F
#define unicode_YI_SYLLABLE_QURX                                      0xA410
#define unicode_YI_SYLLABLE_QUR                                       0xA411
#define unicode_YI_SYLLABLE_QYT                                       0xA412
#define unicode_YI_SYLLABLE_QYX                                       0xA413
#define unicode_YI_SYLLABLE_QY                                        0xA414
#define unicode_YI_SYLLABLE_QYP                                       0xA415
#define unicode_YI_SYLLABLE_QYRX                                      0xA416
#define unicode_YI_SYLLABLE_QYR                                       0xA417
#define unicode_YI_SYLLABLE_JJIT                                      0xA418
#define unicode_YI_SYLLABLE_JJIX                                      0xA419
#define unicode_YI_SYLLABLE_JJI                                       0xA41A
#define unicode_YI_SYLLABLE_JJIP                                      0xA41B
#define unicode_YI_SYLLABLE_JJIET                                     0xA41C
#define unicode_YI_SYLLABLE_JJIEX                                     0xA41D
#define unicode_YI_SYLLABLE_JJIE                                      0xA41E
#define unicode_YI_SYLLABLE_JJIEP                                     0xA41F
#define unicode_YI_SYLLABLE_JJUOX                                     0xA420
#define unicode_YI_SYLLABLE_JJUO                                      0xA421
#define unicode_YI_SYLLABLE_JJUOP                                     0xA422
#define unicode_YI_SYLLABLE_JJOT                                      0xA423
#define unicode_YI_SYLLABLE_JJOX                                      0xA424
#define unicode_YI_SYLLABLE_JJO                                       0xA425
#define unicode_YI_SYLLABLE_JJOP                                      0xA426
#define unicode_YI_SYLLABLE_JJUT                                      0xA427
#define unicode_YI_SYLLABLE_JJUX                                      0xA428
#define unicode_YI_SYLLABLE_JJU                                       0xA429
#define unicode_YI_SYLLABLE_JJUP                                      0xA42A
#define unicode_YI_SYLLABLE_JJURX                                     0xA42B
#define unicode_YI_SYLLABLE_JJUR                                      0xA42C
#define unicode_YI_SYLLABLE_JJYT                                      0xA42D
#define unicode_YI_SYLLABLE_JJYX                                      0xA42E
#define unicode_YI_SYLLABLE_JJY                                       0xA42F
#define unicode_YI_SYLLABLE_JJYP                                      0xA430
#define unicode_YI_SYLLABLE_NJIT                                      0xA431
#define unicode_YI_SYLLABLE_NJIX                                      0xA432
#define unicode_YI_SYLLABLE_NJI                                       0xA433
#define unicode_YI_SYLLABLE_NJIP                                      0xA434
#define unicode_YI_SYLLABLE_NJIET                                     0xA435
#define unicode_YI_SYLLABLE_NJIEX                                     0xA436
#define unicode_YI_SYLLABLE_NJIE                                      0xA437
#define unicode_YI_SYLLABLE_NJIEP                                     0xA438
#define unicode_YI_SYLLABLE_NJUOX                                     0xA439
#define unicode_YI_SYLLABLE_NJUO                                      0xA43A
#define unicode_YI_SYLLABLE_NJOT                                      0xA43B
#define unicode_YI_SYLLABLE_NJOX                                      0xA43C
#define unicode_YI_SYLLABLE_NJO                                       0xA43D
#define unicode_YI_SYLLABLE_NJOP                                      0xA43E
#define unicode_YI_SYLLABLE_NJUX                                      0xA43F
#define unicode_YI_SYLLABLE_NJU                                       0xA440
#define unicode_YI_SYLLABLE_NJUP                                      0xA441
#define unicode_YI_SYLLABLE_NJURX                                     0xA442
#define unicode_YI_SYLLABLE_NJUR                                      0xA443
#define unicode_YI_SYLLABLE_NJYT                                      0xA444
#define unicode_YI_SYLLABLE_NJYX                                      0xA445
#define unicode_YI_SYLLABLE_NJY                                       0xA446
#define unicode_YI_SYLLABLE_NJYP                                      0xA447
#define unicode_YI_SYLLABLE_NJYRX                                     0xA448
#define unicode_YI_SYLLABLE_NJYR                                      0xA449
#define unicode_YI_SYLLABLE_NYIT                                      0xA44A
#define unicode_YI_SYLLABLE_NYIX                                      0xA44B
#define unicode_YI_SYLLABLE_NYI                                       0xA44C
#define unicode_YI_SYLLABLE_NYIP                                      0xA44D
#define unicode_YI_SYLLABLE_NYIET                                     0xA44E
#define unicode_YI_SYLLABLE_NYIEX                                     0xA44F
#define unicode_YI_SYLLABLE_NYIE                                      0xA450
#define unicode_YI_SYLLABLE_NYIEP                                     0xA451
#define unicode_YI_SYLLABLE_NYUOX                                     0xA452
#define unicode_YI_SYLLABLE_NYUO                                      0xA453
#define unicode_YI_SYLLABLE_NYUOP                                     0xA454
#define unicode_YI_SYLLABLE_NYOT                                      0xA455
#define unicode_YI_SYLLABLE_NYOX                                      0xA456
#define unicode_YI_SYLLABLE_NYO                                       0xA457
#define unicode_YI_SYLLABLE_NYOP                                      0xA458
#define unicode_YI_SYLLABLE_NYUT                                      0xA459
#define unicode_YI_SYLLABLE_NYUX                                      0xA45A
#define unicode_YI_SYLLABLE_NYU                                       0xA45B
#define unicode_YI_SYLLABLE_NYUP                                      0xA45C
#define unicode_YI_SYLLABLE_XIT                                       0xA45D
#define unicode_YI_SYLLABLE_XIX                                       0xA45E
#define unicode_YI_SYLLABLE_XI                                        0xA45F
#define unicode_YI_SYLLABLE_XIP                                       0xA460
#define unicode_YI_SYLLABLE_XIET                                      0xA461
#define unicode_YI_SYLLABLE_XIEX                                      0xA462
#define unicode_YI_SYLLABLE_XIE                                       0xA463
#define unicode_YI_SYLLABLE_XIEP                                      0xA464
#define unicode_YI_SYLLABLE_XUOX                                      0xA465
#define unicode_YI_SYLLABLE_XUO                                       0xA466
#define unicode_YI_SYLLABLE_XOT                                       0xA467
#define unicode_YI_SYLLABLE_XOX                                       0xA468
#define unicode_YI_SYLLABLE_XO                                        0xA469
#define unicode_YI_SYLLABLE_XOP                                       0xA46A
#define unicode_YI_SYLLABLE_XYT                                       0xA46B
#define unicode_YI_SYLLABLE_XYX                                       0xA46C
#define unicode_YI_SYLLABLE_XY                                        0xA46D
#define unicode_YI_SYLLABLE_XYP                                       0xA46E
#define unicode_YI_SYLLABLE_XYRX                                      0xA46F
#define unicode_YI_SYLLABLE_XYR                                       0xA470
#define unicode_YI_SYLLABLE_YIT                                       0xA471
#define unicode_YI_SYLLABLE_YIX                                       0xA472
#define unicode_YI_SYLLABLE_YI                                        0xA473
#define unicode_YI_SYLLABLE_YIP                                       0xA474
#define unicode_YI_SYLLABLE_YIET                                      0xA475
#define unicode_YI_SYLLABLE_YIEX                                      0xA476
#define unicode_YI_SYLLABLE_YIE                                       0xA477
#define unicode_YI_SYLLABLE_YIEP                                      0xA478
#define unicode_YI_SYLLABLE_YUOT                                      0xA479
#define unicode_YI_SYLLABLE_YUOX                                      0xA47A
#define unicode_YI_SYLLABLE_YUO                                       0xA47B
#define unicode_YI_SYLLABLE_YUOP                                      0xA47C
#define unicode_YI_SYLLABLE_YOT                                       0xA47D
#define unicode_YI_SYLLABLE_YOX                                       0xA47E
#define unicode_YI_SYLLABLE_YO                                        0xA47F
#define unicode_YI_SYLLABLE_YOP                                       0xA480
#define unicode_YI_SYLLABLE_YUT                                       0xA481
#define unicode_YI_SYLLABLE_YUX                                       0xA482
#define unicode_YI_SYLLABLE_YU                                        0xA483
#define unicode_YI_SYLLABLE_YUP                                       0xA484
#define unicode_YI_SYLLABLE_YURX                                      0xA485
#define unicode_YI_SYLLABLE_YUR                                       0xA486
#define unicode_YI_SYLLABLE_YYT                                       0xA487
#define unicode_YI_SYLLABLE_YYX                                       0xA488
#define unicode_YI_SYLLABLE_YY                                        0xA489
#define unicode_YI_SYLLABLE_YYP                                       0xA48A
#define unicode_YI_SYLLABLE_YYRX                                      0xA48B
#define unicode_YI_SYLLABLE_YYR                                       0xA48C
#define unicode_YI_RADICAL_QOT                                        0xA490
#define unicode_YI_RADICAL_LI                                         0xA491
#define unicode_YI_RADICAL_KIT                                        0xA492
#define unicode_YI_RADICAL_NYIP                                       0xA493
#define unicode_YI_RADICAL_CYP                                        0xA494
#define unicode_YI_RADICAL_SSI                                        0xA495
#define unicode_YI_RADICAL_GGOP                                       0xA496
#define unicode_YI_RADICAL_GEP                                        0xA497
#define unicode_YI_RADICAL_MI                                         0xA498
#define unicode_YI_RADICAL_HXIT                                       0xA499
#define unicode_YI_RADICAL_LYR                                        0xA49A
#define unicode_YI_RADICAL_BBUT                                       0xA49B
#define unicode_YI_RADICAL_MOP                                        0xA49C
#define unicode_YI_RADICAL_YO                                         0xA49D
#define unicode_YI_RADICAL_PUT                                        0xA49E
#define unicode_YI_RADICAL_HXUO                                       0xA49F
#define unicode_YI_RADICAL_TAT                                        0xA4A0
#define unicode_YI_RADICAL_GA                                         0xA4A1
#define unicode_YI_RADICAL_ZUP                                        0xA4A2
#define unicode_YI_RADICAL_CYT                                        0xA4A3
#define unicode_YI_RADICAL_DDUR                                       0xA4A4
#define unicode_YI_RADICAL_BUR                                        0xA4A5
#define unicode_YI_RADICAL_GGUO                                       0xA4A6
#define unicode_YI_RADICAL_NYOP                                       0xA4A7
#define unicode_YI_RADICAL_TU                                         0xA4A8
#define unicode_YI_RADICAL_OP                                         0xA4A9
#define unicode_YI_RADICAL_JJUT                                       0xA4AA
#define unicode_YI_RADICAL_ZOT                                        0xA4AB
#define unicode_YI_RADICAL_PYT                                        0xA4AC
#define unicode_YI_RADICAL_HMO                                        0xA4AD
#define unicode_YI_RADICAL_YIT                                        0xA4AE
#define unicode_YI_RADICAL_VUR                                        0xA4AF
#define unicode_YI_RADICAL_SHY                                        0xA4B0
#define unicode_YI_RADICAL_VEP                                        0xA4B1
#define unicode_YI_RADICAL_ZA                                         0xA4B2
#define unicode_YI_RADICAL_JO                                         0xA4B3
#define unicode_YI_RADICAL_NZUP                                       0xA4B4
#define unicode_YI_RADICAL_JJY                                        0xA4B5
#define unicode_YI_RADICAL_GOT                                        0xA4B6
#define unicode_YI_RADICAL_JJIE                                       0xA4B7
#define unicode_YI_RADICAL_WO                                         0xA4B8
#define unicode_YI_RADICAL_DU                                         0xA4B9
#define unicode_YI_RADICAL_SHUR                                       0xA4BA
#define unicode_YI_RADICAL_LIE                                        0xA4BB
#define unicode_YI_RADICAL_CY                                         0xA4BC
#define unicode_YI_RADICAL_CUOP                                       0xA4BD
#define unicode_YI_RADICAL_CIP                                        0xA4BE
#define unicode_YI_RADICAL_HXOP                                       0xA4BF
#define unicode_YI_RADICAL_SHAT                                       0xA4C0
#define unicode_YI_RADICAL_ZUR                                        0xA4C1
#define unicode_YI_RADICAL_SHOP                                       0xA4C2
#define unicode_YI_RADICAL_CHE                                        0xA4C3
#define unicode_YI_RADICAL_ZZIET                                      0xA4C4
#define unicode_YI_RADICAL_NBIE                                       0xA4C5
#define unicode_YI_RADICAL_KE                                         0xA4C6
#define unicode_LISU_LETTER_BA                                        0xA4D0
#define unicode_LISU_LETTER_PA                                        0xA4D1
#define unicode_LISU_LETTER_PHA                                       0xA4D2
#define unicode_LISU_LETTER_DA                                        0xA4D3
#define unicode_LISU_LETTER_TA                                        0xA4D4
#define unicode_LISU_LETTER_THA                                       0xA4D5
#define unicode_LISU_LETTER_GA                                        0xA4D6
#define unicode_LISU_LETTER_KA                                        0xA4D7
#define unicode_LISU_LETTER_KHA                                       0xA4D8
#define unicode_LISU_LETTER_JA                                        0xA4D9
#define unicode_LISU_LETTER_CA                                        0xA4DA
#define unicode_LISU_LETTER_CHA                                       0xA4DB
#define unicode_LISU_LETTER_DZA                                       0xA4DC
#define unicode_LISU_LETTER_TSA                                       0xA4DD
#define unicode_LISU_LETTER_TSHA                                      0xA4DE
#define unicode_LISU_LETTER_MA                                        0xA4DF
#define unicode_LISU_LETTER_NA                                        0xA4E0
#define unicode_LISU_LETTER_LA                                        0xA4E1
#define unicode_LISU_LETTER_SA                                        0xA4E2
#define unicode_LISU_LETTER_ZHA                                       0xA4E3
#define unicode_LISU_LETTER_ZA                                        0xA4E4
#define unicode_LISU_LETTER_NGA                                       0xA4E5
#define unicode_LISU_LETTER_HA                                        0xA4E6
#define unicode_LISU_LETTER_XA                                        0xA4E7
#define unicode_LISU_LETTER_HHA                                       0xA4E8
#define unicode_LISU_LETTER_FA                                        0xA4E9
#define unicode_LISU_LETTER_WA                                        0xA4EA
#define unicode_LISU_LETTER_SHA                                       0xA4EB
#define unicode_LISU_LETTER_YA                                        0xA4EC
#define unicode_LISU_LETTER_GHA                                       0xA4ED
#define unicode_LISU_LETTER_A                                         0xA4EE
#define unicode_LISU_LETTER_AE                                        0xA4EF
#define unicode_LISU_LETTER_E                                         0xA4F0
#define unicode_LISU_LETTER_EU                                        0xA4F1
#define unicode_LISU_LETTER_I                                         0xA4F2
#define unicode_LISU_LETTER_O                                         0xA4F3
#define unicode_LISU_LETTER_U                                         0xA4F4
#define unicode_LISU_LETTER_UE                                        0xA4F5
#define unicode_LISU_LETTER_UH                                        0xA4F6
#define unicode_LISU_LETTER_OE                                        0xA4F7
#define unicode_LISU_LETTER_TONE_MYA_TI                               0xA4F8
#define unicode_LISU_LETTER_TONE_NA_PO                                0xA4F9
#define unicode_LISU_LETTER_TONE_MYA_CYA                              0xA4FA
#define unicode_LISU_LETTER_TONE_MYA_BO                               0xA4FB
#define unicode_LISU_LETTER_TONE_MYA_NA                               0xA4FC
#define unicode_LISU_LETTER_TONE_MYA_JEU                              0xA4FD
#define unicode_LISU_PUNCTUATION_COMMA                                0xA4FE
#define unicode_LISU_PUNCTUATION_FULL_STOP                            0xA4FF
#define unicode_VAI_SYLLABLE_EE                                       0xA500
#define unicode_VAI_SYLLABLE_EEN                                      0xA501
#define unicode_VAI_SYLLABLE_HEE                                      0xA502
#define unicode_VAI_SYLLABLE_WEE                                      0xA503
#define unicode_VAI_SYLLABLE_WEEN                                     0xA504
#define unicode_VAI_SYLLABLE_PEE                                      0xA505
#define unicode_VAI_SYLLABLE_BHEE                                     0xA506
#define unicode_VAI_SYLLABLE_BEE                                      0xA507
#define unicode_VAI_SYLLABLE_MBEE                                     0xA508
#define unicode_VAI_SYLLABLE_KPEE                                     0xA509
#define unicode_VAI_SYLLABLE_MGBEE                                    0xA50A
#define unicode_VAI_SYLLABLE_GBEE                                     0xA50B
#define unicode_VAI_SYLLABLE_FEE                                      0xA50C
#define unicode_VAI_SYLLABLE_VEE                                      0xA50D
#define unicode_VAI_SYLLABLE_TEE                                      0xA50E
#define unicode_VAI_SYLLABLE_THEE                                     0xA50F
#define unicode_VAI_SYLLABLE_DHEE                                     0xA510
#define unicode_VAI_SYLLABLE_DHHEE                                    0xA511
#define unicode_VAI_SYLLABLE_LEE                                      0xA512
#define unicode_VAI_SYLLABLE_REE                                      0xA513
#define unicode_VAI_SYLLABLE_DEE                                      0xA514
#define unicode_VAI_SYLLABLE_NDEE                                     0xA515
#define unicode_VAI_SYLLABLE_SEE                                      0xA516
#define unicode_VAI_SYLLABLE_SHEE                                     0xA517
#define unicode_VAI_SYLLABLE_ZEE                                      0xA518
#define unicode_VAI_SYLLABLE_ZHEE                                     0xA519
#define unicode_VAI_SYLLABLE_CEE                                      0xA51A
#define unicode_VAI_SYLLABLE_JEE                                      0xA51B
#define unicode_VAI_SYLLABLE_NJEE                                     0xA51C
#define unicode_VAI_SYLLABLE_YEE                                      0xA51D
#define unicode_VAI_SYLLABLE_KEE                                      0xA51E
#define unicode_VAI_SYLLABLE_NGGEE                                    0xA51F
#define unicode_VAI_SYLLABLE_GEE                                      0xA520
#define unicode_VAI_SYLLABLE_MEE                                      0xA521
#define unicode_VAI_SYLLABLE_NEE                                      0xA522
#define unicode_VAI_SYLLABLE_NYEE                                     0xA523
#define unicode_VAI_SYLLABLE_I                                        0xA524
#define unicode_VAI_SYLLABLE_IN                                       0xA525
#define unicode_VAI_SYLLABLE_HI                                       0xA526
#define unicode_VAI_SYLLABLE_HIN                                      0xA527
#define unicode_VAI_SYLLABLE_WI                                       0xA528
#define unicode_VAI_SYLLABLE_WIN                                      0xA529
#define unicode_VAI_SYLLABLE_PI                                       0xA52A
#define unicode_VAI_SYLLABLE_BHI                                      0xA52B
#define unicode_VAI_SYLLABLE_BI                                       0xA52C
#define unicode_VAI_SYLLABLE_MBI                                      0xA52D
#define unicode_VAI_SYLLABLE_KPI                                      0xA52E
#define unicode_VAI_SYLLABLE_MGBI                                     0xA52F
#define unicode_VAI_SYLLABLE_GBI                                      0xA530
#define unicode_VAI_SYLLABLE_FI                                       0xA531
#define unicode_VAI_SYLLABLE_VI                                       0xA532
#define unicode_VAI_SYLLABLE_TI                                       0xA533
#define unicode_VAI_SYLLABLE_THI                                      0xA534
#define unicode_VAI_SYLLABLE_DHI                                      0xA535
#define unicode_VAI_SYLLABLE_DHHI                                     0xA536
#define unicode_VAI_SYLLABLE_LI                                       0xA537
#define unicode_VAI_SYLLABLE_RI                                       0xA538
#define unicode_VAI_SYLLABLE_DI                                       0xA539
#define unicode_VAI_SYLLABLE_NDI                                      0xA53A
#define unicode_VAI_SYLLABLE_SI                                       0xA53B
#define unicode_VAI_SYLLABLE_SHI                                      0xA53C
#define unicode_VAI_SYLLABLE_ZI                                       0xA53D
#define unicode_VAI_SYLLABLE_ZHI                                      0xA53E
#define unicode_VAI_SYLLABLE_CI                                       0xA53F
#define unicode_VAI_SYLLABLE_JI                                       0xA540
#define unicode_VAI_SYLLABLE_NJI                                      0xA541
#define unicode_VAI_SYLLABLE_YI                                       0xA542
#define unicode_VAI_SYLLABLE_KI                                       0xA543
#define unicode_VAI_SYLLABLE_NGGI                                     0xA544
#define unicode_VAI_SYLLABLE_GI                                       0xA545
#define unicode_VAI_SYLLABLE_MI                                       0xA546
#define unicode_VAI_SYLLABLE_NI                                       0xA547
#define unicode_VAI_SYLLABLE_NYI                                      0xA548
#define unicode_VAI_SYLLABLE_A                                        0xA549
#define unicode_VAI_SYLLABLE_AN                                       0xA54A
#define unicode_VAI_SYLLABLE_NGAN                                     0xA54B
#define unicode_VAI_SYLLABLE_HA                                       0xA54C
#define unicode_VAI_SYLLABLE_HAN                                      0xA54D
#define unicode_VAI_SYLLABLE_WA                                       0xA54E
#define unicode_VAI_SYLLABLE_WAN                                      0xA54F
#define unicode_VAI_SYLLABLE_PA                                       0xA550
#define unicode_VAI_SYLLABLE_BHA                                      0xA551
#define unicode_VAI_SYLLABLE_BA                                       0xA552
#define unicode_VAI_SYLLABLE_MBA                                      0xA553
#define unicode_VAI_SYLLABLE_KPA                                      0xA554
#define unicode_VAI_SYLLABLE_KPAN                                     0xA555
#define unicode_VAI_SYLLABLE_MGBA                                     0xA556
#define unicode_VAI_SYLLABLE_GBA                                      0xA557
#define unicode_VAI_SYLLABLE_FA                                       0xA558
#define unicode_VAI_SYLLABLE_VA                                       0xA559
#define unicode_VAI_SYLLABLE_TA                                       0xA55A
#define unicode_VAI_SYLLABLE_THA                                      0xA55B
#define unicode_VAI_SYLLABLE_DHA                                      0xA55C
#define unicode_VAI_SYLLABLE_DHHA                                     0xA55D
#define unicode_VAI_SYLLABLE_LA                                       0xA55E
#define unicode_VAI_SYLLABLE_RA                                       0xA55F
#define unicode_VAI_SYLLABLE_DA                                       0xA560
#define unicode_VAI_SYLLABLE_NDA                                      0xA561
#define unicode_VAI_SYLLABLE_SA                                       0xA562
#define unicode_VAI_SYLLABLE_SHA                                      0xA563
#define unicode_VAI_SYLLABLE_ZA                                       0xA564
#define unicode_VAI_SYLLABLE_ZHA                                      0xA565
#define unicode_VAI_SYLLABLE_CA                                       0xA566
#define unicode_VAI_SYLLABLE_JA                                       0xA567
#define unicode_VAI_SYLLABLE_NJA                                      0xA568
#define unicode_VAI_SYLLABLE_YA                                       0xA569
#define unicode_VAI_SYLLABLE_KA                                       0xA56A
#define unicode_VAI_SYLLABLE_KAN                                      0xA56B
#define unicode_VAI_SYLLABLE_NGGA                                     0xA56C
#define unicode_VAI_SYLLABLE_GA                                       0xA56D
#define unicode_VAI_SYLLABLE_MA                                       0xA56E
#define unicode_VAI_SYLLABLE_NA                                       0xA56F
#define unicode_VAI_SYLLABLE_NYA                                      0xA570
#define unicode_VAI_SYLLABLE_OO                                       0xA571
#define unicode_VAI_SYLLABLE_OON                                      0xA572
#define unicode_VAI_SYLLABLE_HOO                                      0xA573
#define unicode_VAI_SYLLABLE_WOO                                      0xA574
#define unicode_VAI_SYLLABLE_WOON                                     0xA575
#define unicode_VAI_SYLLABLE_POO                                      0xA576
#define unicode_VAI_SYLLABLE_BHOO                                     0xA577
#define unicode_VAI_SYLLABLE_BOO                                      0xA578
#define unicode_VAI_SYLLABLE_MBOO                                     0xA579
#define unicode_VAI_SYLLABLE_KPOO                                     0xA57A
#define unicode_VAI_SYLLABLE_MGBOO                                    0xA57B
#define unicode_VAI_SYLLABLE_GBOO                                     0xA57C
#define unicode_VAI_SYLLABLE_FOO                                      0xA57D
#define unicode_VAI_SYLLABLE_VOO                                      0xA57E
#define unicode_VAI_SYLLABLE_TOO                                      0xA57F
#define unicode_VAI_SYLLABLE_THOO                                     0xA580
#define unicode_VAI_SYLLABLE_DHOO                                     0xA581
#define unicode_VAI_SYLLABLE_DHHOO                                    0xA582
#define unicode_VAI_SYLLABLE_LOO                                      0xA583
#define unicode_VAI_SYLLABLE_ROO                                      0xA584
#define unicode_VAI_SYLLABLE_DOO                                      0xA585
#define unicode_VAI_SYLLABLE_NDOO                                     0xA586
#define unicode_VAI_SYLLABLE_SOO                                      0xA587
#define unicode_VAI_SYLLABLE_SHOO                                     0xA588
#define unicode_VAI_SYLLABLE_ZOO                                      0xA589
#define unicode_VAI_SYLLABLE_ZHOO                                     0xA58A
#define unicode_VAI_SYLLABLE_COO                                      0xA58B
#define unicode_VAI_SYLLABLE_JOO                                      0xA58C
#define unicode_VAI_SYLLABLE_NJOO                                     0xA58D
#define unicode_VAI_SYLLABLE_YOO                                      0xA58E
#define unicode_VAI_SYLLABLE_KOO                                      0xA58F
#define unicode_VAI_SYLLABLE_NGGOO                                    0xA590
#define unicode_VAI_SYLLABLE_GOO                                      0xA591
#define unicode_VAI_SYLLABLE_MOO                                      0xA592
#define unicode_VAI_SYLLABLE_NOO                                      0xA593
#define unicode_VAI_SYLLABLE_NYOO                                     0xA594
#define unicode_VAI_SYLLABLE_U                                        0xA595
#define unicode_VAI_SYLLABLE_UN                                       0xA596
#define unicode_VAI_SYLLABLE_HU                                       0xA597
#define unicode_VAI_SYLLABLE_HUN                                      0xA598
#define unicode_VAI_SYLLABLE_WU                                       0xA599
#define unicode_VAI_SYLLABLE_WUN                                      0xA59A
#define unicode_VAI_SYLLABLE_PU                                       0xA59B
#define unicode_VAI_SYLLABLE_BHU                                      0xA59C
#define unicode_VAI_SYLLABLE_BU                                       0xA59D
#define unicode_VAI_SYLLABLE_MBU                                      0xA59E
#define unicode_VAI_SYLLABLE_KPU                                      0xA59F
#define unicode_VAI_SYLLABLE_MGBU                                     0xA5A0
#define unicode_VAI_SYLLABLE_GBU                                      0xA5A1
#define unicode_VAI_SYLLABLE_FU                                       0xA5A2
#define unicode_VAI_SYLLABLE_VU                                       0xA5A3
#define unicode_VAI_SYLLABLE_TU                                       0xA5A4
#define unicode_VAI_SYLLABLE_THU                                      0xA5A5
#define unicode_VAI_SYLLABLE_DHU                                      0xA5A6
#define unicode_VAI_SYLLABLE_DHHU                                     0xA5A7
#define unicode_VAI_SYLLABLE_LU                                       0xA5A8
#define unicode_VAI_SYLLABLE_RU                                       0xA5A9
#define unicode_VAI_SYLLABLE_DU                                       0xA5AA
#define unicode_VAI_SYLLABLE_NDU                                      0xA5AB
#define unicode_VAI_SYLLABLE_SU                                       0xA5AC
#define unicode_VAI_SYLLABLE_SHU                                      0xA5AD
#define unicode_VAI_SYLLABLE_ZU                                       0xA5AE
#define unicode_VAI_SYLLABLE_ZHU                                      0xA5AF
#define unicode_VAI_SYLLABLE_CU                                       0xA5B0
#define unicode_VAI_SYLLABLE_JU                                       0xA5B1
#define unicode_VAI_SYLLABLE_NJU                                      0xA5B2
#define unicode_VAI_SYLLABLE_YU                                       0xA5B3
#define unicode_VAI_SYLLABLE_KU                                       0xA5B4
#define unicode_VAI_SYLLABLE_NGGU                                     0xA5B5
#define unicode_VAI_SYLLABLE_GU                                       0xA5B6
#define unicode_VAI_SYLLABLE_MU                                       0xA5B7
#define unicode_VAI_SYLLABLE_NU                                       0xA5B8
#define unicode_VAI_SYLLABLE_NYU                                      0xA5B9
#define unicode_VAI_SYLLABLE_O                                        0xA5BA
#define unicode_VAI_SYLLABLE_ON                                       0xA5BB
#define unicode_VAI_SYLLABLE_NGON                                     0xA5BC
#define unicode_VAI_SYLLABLE_HO                                       0xA5BD
#define unicode_VAI_SYLLABLE_HON                                      0xA5BE
#define unicode_VAI_SYLLABLE_WO                                       0xA5BF
#define unicode_VAI_SYLLABLE_WON                                      0xA5C0
#define unicode_VAI_SYLLABLE_PO                                       0xA5C1
#define unicode_VAI_SYLLABLE_BHO                                      0xA5C2
#define unicode_VAI_SYLLABLE_BO                                       0xA5C3
#define unicode_VAI_SYLLABLE_MBO                                      0xA5C4
#define unicode_VAI_SYLLABLE_KPO                                      0xA5C5
#define unicode_VAI_SYLLABLE_MGBO                                     0xA5C6
#define unicode_VAI_SYLLABLE_GBO                                      0xA5C7
#define unicode_VAI_SYLLABLE_GBON                                     0xA5C8
#define unicode_VAI_SYLLABLE_FO                                       0xA5C9
#define unicode_VAI_SYLLABLE_VO                                       0xA5CA
#define unicode_VAI_SYLLABLE_TO                                       0xA5CB
#define unicode_VAI_SYLLABLE_THO                                      0xA5CC
#define unicode_VAI_SYLLABLE_DHO                                      0xA5CD
#define unicode_VAI_SYLLABLE_DHHO                                     0xA5CE
#define unicode_VAI_SYLLABLE_LO                                       0xA5CF
#define unicode_VAI_SYLLABLE_RO                                       0xA5D0
#define unicode_VAI_SYLLABLE_DO                                       0xA5D1
#define unicode_VAI_SYLLABLE_NDO                                      0xA5D2
#define unicode_VAI_SYLLABLE_SO                                       0xA5D3
#define unicode_VAI_SYLLABLE_SHO                                      0xA5D4
#define unicode_VAI_SYLLABLE_ZO                                       0xA5D5
#define unicode_VAI_SYLLABLE_ZHO                                      0xA5D6
#define unicode_VAI_SYLLABLE_CO                                       0xA5D7
#define unicode_VAI_SYLLABLE_JO                                       0xA5D8
#define unicode_VAI_SYLLABLE_NJO                                      0xA5D9
#define unicode_VAI_SYLLABLE_YO                                       0xA5DA
#define unicode_VAI_SYLLABLE_KO                                       0xA5DB
#define unicode_VAI_SYLLABLE_NGGO                                     0xA5DC
#define unicode_VAI_SYLLABLE_GO                                       0xA5DD
#define unicode_VAI_SYLLABLE_MO                                       0xA5DE
#define unicode_VAI_SYLLABLE_NO                                       0xA5DF
#define unicode_VAI_SYLLABLE_NYO                                      0xA5E0
#define unicode_VAI_SYLLABLE_E                                        0xA5E1
#define unicode_VAI_SYLLABLE_EN                                       0xA5E2
#define unicode_VAI_SYLLABLE_NGEN                                     0xA5E3
#define unicode_VAI_SYLLABLE_HE                                       0xA5E4
#define unicode_VAI_SYLLABLE_HEN                                      0xA5E5
#define unicode_VAI_SYLLABLE_WE                                       0xA5E6
#define unicode_VAI_SYLLABLE_WEN                                      0xA5E7
#define unicode_VAI_SYLLABLE_PE                                       0xA5E8
#define unicode_VAI_SYLLABLE_BHE                                      0xA5E9
#define unicode_VAI_SYLLABLE_BE                                       0xA5EA
#define unicode_VAI_SYLLABLE_MBE                                      0xA5EB
#define unicode_VAI_SYLLABLE_KPE                                      0xA5EC
#define unicode_VAI_SYLLABLE_KPEN                                     0xA5ED
#define unicode_VAI_SYLLABLE_MGBE                                     0xA5EE
#define unicode_VAI_SYLLABLE_GBE                                      0xA5EF
#define unicode_VAI_SYLLABLE_GBEN                                     0xA5F0
#define unicode_VAI_SYLLABLE_FE                                       0xA5F1
#define unicode_VAI_SYLLABLE_VE                                       0xA5F2
#define unicode_VAI_SYLLABLE_TE                                       0xA5F3
#define unicode_VAI_SYLLABLE_THE                                      0xA5F4
#define unicode_VAI_SYLLABLE_DHE                                      0xA5F5
#define unicode_VAI_SYLLABLE_DHHE                                     0xA5F6
#define unicode_VAI_SYLLABLE_LE                                       0xA5F7
#define unicode_VAI_SYLLABLE_RE                                       0xA5F8
#define unicode_VAI_SYLLABLE_DE                                       0xA5F9
#define unicode_VAI_SYLLABLE_NDE                                      0xA5FA
#define unicode_VAI_SYLLABLE_SE                                       0xA5FB
#define unicode_VAI_SYLLABLE_SHE                                      0xA5FC
#define unicode_VAI_SYLLABLE_ZE                                       0xA5FD
#define unicode_VAI_SYLLABLE_ZHE                                      0xA5FE
#define unicode_VAI_SYLLABLE_CE                                       0xA5FF
#define unicode_VAI_SYLLABLE_JE                                       0xA600
#define unicode_VAI_SYLLABLE_NJE                                      0xA601
#define unicode_VAI_SYLLABLE_YE                                       0xA602
#define unicode_VAI_SYLLABLE_KE                                       0xA603
#define unicode_VAI_SYLLABLE_NGGE                                     0xA604
#define unicode_VAI_SYLLABLE_NGGEN                                    0xA605
#define unicode_VAI_SYLLABLE_GE                                       0xA606
#define unicode_VAI_SYLLABLE_GEN                                      0xA607
#define unicode_VAI_SYLLABLE_ME                                       0xA608
#define unicode_VAI_SYLLABLE_NE                                       0xA609
#define unicode_VAI_SYLLABLE_NYE                                      0xA60A
#define unicode_VAI_SYLLABLE_NG                                       0xA60B
#define unicode_VAI_SYLLABLE_LENGTHENER                               0xA60C
#define unicode_VAI_COMMA                                             0xA60D
#define unicode_VAI_FULL_STOP                                         0xA60E
#define unicode_VAI_QUESTION_MARK                                     0xA60F
#define unicode_VAI_SYLLABLE_NDOLE_FA                                 0xA610
#define unicode_VAI_SYLLABLE_NDOLE_KA                                 0xA611
#define unicode_VAI_SYLLABLE_NDOLE_SOO                                0xA612
#define unicode_VAI_SYMBOL_FEENG                                      0xA613
#define unicode_VAI_SYMBOL_KEENG                                      0xA614
#define unicode_VAI_SYMBOL_TING                                       0xA615
#define unicode_VAI_SYMBOL_NII                                        0xA616
#define unicode_VAI_SYMBOL_BANG                                       0xA617
#define unicode_VAI_SYMBOL_FAA                                        0xA618
#define unicode_VAI_SYMBOL_TAA                                        0xA619
#define unicode_VAI_SYMBOL_DANG                                       0xA61A
#define unicode_VAI_SYMBOL_DOONG                                      0xA61B
#define unicode_VAI_SYMBOL_KUNG                                       0xA61C
#define unicode_VAI_SYMBOL_TONG                                       0xA61D
#define unicode_VAI_SYMBOL_DO_O                                       0xA61E
#define unicode_VAI_SYMBOL_JONG                                       0xA61F
#define unicode_VAI_DIGIT_ZERO                                        0xA620
#define unicode_VAI_DIGIT_ONE                                         0xA621
#define unicode_VAI_DIGIT_TWO                                         0xA622
#define unicode_VAI_DIGIT_THREE                                       0xA623
#define unicode_VAI_DIGIT_FOUR                                        0xA624
#define unicode_VAI_DIGIT_FIVE                                        0xA625
#define unicode_VAI_DIGIT_SIX                                         0xA626
#define unicode_VAI_DIGIT_SEVEN                                       0xA627
#define unicode_VAI_DIGIT_EIGHT                                       0xA628
#define unicode_VAI_DIGIT_NINE                                        0xA629
#define unicode_VAI_SYLLABLE_NDOLE_MA                                 0xA62A
#define unicode_VAI_SYLLABLE_NDOLE_DO                                 0xA62B
#define unicode_CYRILLIC_CAPITAL_LETTER_ZEMLYA                        0xA640
#define unicode_CYRILLIC_SMALL_LETTER_ZEMLYA                          0xA641
#define unicode_CYRILLIC_CAPITAL_LETTER_DZELO                         0xA642
#define unicode_CYRILLIC_SMALL_LETTER_DZELO                           0xA643
#define unicode_CYRILLIC_CAPITAL_LETTER_REVERSED_DZE                  0xA644
#define unicode_CYRILLIC_SMALL_LETTER_REVERSED_DZE                    0xA645
#define unicode_CYRILLIC_CAPITAL_LETTER_IOTA                          0xA646
#define unicode_CYRILLIC_SMALL_LETTER_IOTA                            0xA647
#define unicode_CYRILLIC_CAPITAL_LETTER_DJERV                         0xA648
#define unicode_CYRILLIC_SMALL_LETTER_DJERV                           0xA649
#define unicode_CYRILLIC_CAPITAL_LETTER_MONOGRAPH_UK                  0xA64A
#define unicode_CYRILLIC_SMALL_LETTER_MONOGRAPH_UK                    0xA64B
#define unicode_CYRILLIC_CAPITAL_LETTER_BROAD_OMEGA                   0xA64C
#define unicode_CYRILLIC_SMALL_LETTER_BROAD_OMEGA                     0xA64D
#define unicode_CYRILLIC_CAPITAL_LETTER_NEUTRAL_YER                   0xA64E
#define unicode_CYRILLIC_SMALL_LETTER_NEUTRAL_YER                     0xA64F
#define unicode_CYRILLIC_CAPITAL_LETTER_YERU_WITH_BACK_YER            0xA650
#define unicode_CYRILLIC_SMALL_LETTER_YERU_WITH_BACK_YER              0xA651
#define unicode_CYRILLIC_CAPITAL_LETTER_IOTIFIED_YAT                  0xA652
#define unicode_CYRILLIC_SMALL_LETTER_IOTIFIED_YAT                    0xA653
#define unicode_CYRILLIC_CAPITAL_LETTER_REVERSED_YU                   0xA654
#define unicode_CYRILLIC_SMALL_LETTER_REVERSED_YU                     0xA655
#define unicode_CYRILLIC_CAPITAL_LETTER_IOTIFIED_A                    0xA656
#define unicode_CYRILLIC_SMALL_LETTER_IOTIFIED_A                      0xA657
#define unicode_CYRILLIC_CAPITAL_LETTER_CLOSED_LITTLE_YUS             0xA658
#define unicode_CYRILLIC_SMALL_LETTER_CLOSED_LITTLE_YUS               0xA659
#define unicode_CYRILLIC_CAPITAL_LETTER_BLENDED_YUS                   0xA65A
#define unicode_CYRILLIC_SMALL_LETTER_BLENDED_YUS                     0xA65B
#define unicode_CYRILLIC_CAPITAL_LETTER_IOTIFIED_CLOSED_LITTLE_YUS    0xA65C
#define unicode_CYRILLIC_SMALL_LETTER_IOTIFIED_CLOSED_LITTLE_YUS      0xA65D
#define unicode_CYRILLIC_CAPITAL_LETTER_YN                            0xA65E
#define unicode_CYRILLIC_SMALL_LETTER_YN                              0xA65F
#define unicode_CYRILLIC_CAPITAL_LETTER_REVERSED_TSE                  0xA660
#define unicode_CYRILLIC_SMALL_LETTER_REVERSED_TSE                    0xA661
#define unicode_CYRILLIC_CAPITAL_LETTER_SOFT_DE                       0xA662
#define unicode_CYRILLIC_SMALL_LETTER_SOFT_DE                         0xA663
#define unicode_CYRILLIC_CAPITAL_LETTER_SOFT_EL                       0xA664
#define unicode_CYRILLIC_SMALL_LETTER_SOFT_EL                         0xA665
#define unicode_CYRILLIC_CAPITAL_LETTER_SOFT_EM                       0xA666
#define unicode_CYRILLIC_SMALL_LETTER_SOFT_EM                         0xA667
#define unicode_CYRILLIC_CAPITAL_LETTER_MONOCULAR_O                   0xA668
#define unicode_CYRILLIC_SMALL_LETTER_MONOCULAR_O                     0xA669
#define unicode_CYRILLIC_CAPITAL_LETTER_BINOCULAR_O                   0xA66A
#define unicode_CYRILLIC_SMALL_LETTER_BINOCULAR_O                     0xA66B
#define unicode_CYRILLIC_CAPITAL_LETTER_DOUBLE_MONOCULAR_O            0xA66C
#define unicode_CYRILLIC_SMALL_LETTER_DOUBLE_MONOCULAR_O              0xA66D
#define unicode_CYRILLIC_LETTER_MULTIOCULAR_O                         0xA66E
#define unicode_COMBINING_CYRILLIC_VZMET                              0xA66F
#define unicode_COMBINING_CYRILLIC_TEN_MILLIONS_SIGN                  0xA670
#define unicode_COMBINING_CYRILLIC_HUNDRED_MILLIONS_SIGN              0xA671
#define unicode_COMBINING_CYRILLIC_THOUSAND_MILLIONS_SIGN             0xA672
#define unicode_SLAVONIC_ASTERISK                                     0xA673
#define unicode_COMBINING_CYRILLIC_LETTER_UKRAINIAN_IE                0xA674
#define unicode_COMBINING_CYRILLIC_LETTER_I                           0xA675
#define unicode_COMBINING_CYRILLIC_LETTER_YI                          0xA676
#define unicode_COMBINING_CYRILLIC_LETTER_U                           0xA677
#define unicode_COMBINING_CYRILLIC_LETTER_HARD_SIGN                   0xA678
#define unicode_COMBINING_CYRILLIC_LETTER_YERU                        0xA679
#define unicode_COMBINING_CYRILLIC_LETTER_SOFT_SIGN                   0xA67A
#define unicode_COMBINING_CYRILLIC_LETTER_OMEGA                       0xA67B
#define unicode_COMBINING_CYRILLIC_KAVYKA                             0xA67C
#define unicode_COMBINING_CYRILLIC_PAYEROK                            0xA67D
#define unicode_CYRILLIC_KAVYKA                                       0xA67E
#define unicode_CYRILLIC_PAYEROK                                      0xA67F
#define unicode_CYRILLIC_CAPITAL_LETTER_DWE                           0xA680
#define unicode_CYRILLIC_SMALL_LETTER_DWE                             0xA681
#define unicode_CYRILLIC_CAPITAL_LETTER_DZWE                          0xA682
#define unicode_CYRILLIC_SMALL_LETTER_DZWE                            0xA683
#define unicode_CYRILLIC_CAPITAL_LETTER_ZHWE                          0xA684
#define unicode_CYRILLIC_SMALL_LETTER_ZHWE                            0xA685
#define unicode_CYRILLIC_CAPITAL_LETTER_CCHE                          0xA686
#define unicode_CYRILLIC_SMALL_LETTER_CCHE                            0xA687
#define unicode_CYRILLIC_CAPITAL_LETTER_DZZE                          0xA688
#define unicode_CYRILLIC_SMALL_LETTER_DZZE                            0xA689
#define unicode_CYRILLIC_CAPITAL_LETTER_TE_WITH_MIDDLE_HOOK           0xA68A
#define unicode_CYRILLIC_SMALL_LETTER_TE_WITH_MIDDLE_HOOK             0xA68B
#define unicode_CYRILLIC_CAPITAL_LETTER_TWE                           0xA68C
#define unicode_CYRILLIC_SMALL_LETTER_TWE                             0xA68D
#define unicode_CYRILLIC_CAPITAL_LETTER_TSWE                          0xA68E
#define unicode_CYRILLIC_SMALL_LETTER_TSWE                            0xA68F
#define unicode_CYRILLIC_CAPITAL_LETTER_TSSE                          0xA690
#define unicode_CYRILLIC_SMALL_LETTER_TSSE                            0xA691
#define unicode_CYRILLIC_CAPITAL_LETTER_TCHE                          0xA692
#define unicode_CYRILLIC_SMALL_LETTER_TCHE                            0xA693
#define unicode_CYRILLIC_CAPITAL_LETTER_HWE                           0xA694
#define unicode_CYRILLIC_SMALL_LETTER_HWE                             0xA695
#define unicode_CYRILLIC_CAPITAL_LETTER_SHWE                          0xA696
#define unicode_CYRILLIC_SMALL_LETTER_SHWE                            0xA697
#define unicode_CYRILLIC_CAPITAL_LETTER_DOUBLE_O                      0xA698
#define unicode_CYRILLIC_SMALL_LETTER_DOUBLE_O                        0xA699
#define unicode_CYRILLIC_CAPITAL_LETTER_CROSSED_O                     0xA69A
#define unicode_CYRILLIC_SMALL_LETTER_CROSSED_O                       0xA69B
#define unicode_MODIFIER_LETTER_CYRILLIC_HARD_SIGN                    0xA69C
#define unicode_MODIFIER_LETTER_CYRILLIC_SOFT_SIGN                    0xA69D
#define unicode_COMBINING_CYRILLIC_LETTER_IOTIFIED_E                  0xA69F
#define unicode_BAMUM_LETTER_A                                        0xA6A0
#define unicode_BAMUM_LETTER_KA                                       0xA6A1
#define unicode_BAMUM_LETTER_U                                        0xA6A2
#define unicode_BAMUM_LETTER_KU                                       0xA6A3
#define unicode_BAMUM_LETTER_EE                                       0xA6A4
#define unicode_BAMUM_LETTER_REE                                      0xA6A5
#define unicode_BAMUM_LETTER_TAE                                      0xA6A6
#define unicode_BAMUM_LETTER_O                                        0xA6A7
#define unicode_BAMUM_LETTER_NYI                                      0xA6A8
#define unicode_BAMUM_LETTER_I                                        0xA6A9
#define unicode_BAMUM_LETTER_LA                                       0xA6AA
#define unicode_BAMUM_LETTER_PA                                       0xA6AB
#define unicode_BAMUM_LETTER_RII                                      0xA6AC
#define unicode_BAMUM_LETTER_RIEE                                     0xA6AD
#define unicode_BAMUM_LETTER_LEEEE                                    0xA6AE
#define unicode_BAMUM_LETTER_MEEEE                                    0xA6AF
#define unicode_BAMUM_LETTER_TAA                                      0xA6B0
#define unicode_BAMUM_LETTER_NDAA                                     0xA6B1
#define unicode_BAMUM_LETTER_NJAEM                                    0xA6B2
#define unicode_BAMUM_LETTER_M                                        0xA6B3
#define unicode_BAMUM_LETTER_SUU                                      0xA6B4
#define unicode_BAMUM_LETTER_MU                                       0xA6B5
#define unicode_BAMUM_LETTER_SHII                                     0xA6B6
#define unicode_BAMUM_LETTER_SI                                       0xA6B7
#define unicode_BAMUM_LETTER_SHEUX                                    0xA6B8
#define unicode_BAMUM_LETTER_SEUX                                     0xA6B9
#define unicode_BAMUM_LETTER_KYEE                                     0xA6BA
#define unicode_BAMUM_LETTER_KET                                      0xA6BB
#define unicode_BAMUM_LETTER_NUAE                                     0xA6BC
#define unicode_BAMUM_LETTER_NU                                       0xA6BD
#define unicode_BAMUM_LETTER_NJUAE                                    0xA6BE
#define unicode_BAMUM_LETTER_YOQ                                      0xA6BF
#define unicode_BAMUM_LETTER_SHU                                      0xA6C0
#define unicode_BAMUM_LETTER_YUQ                                      0xA6C1
#define unicode_BAMUM_LETTER_YA                                       0xA6C2
#define unicode_BAMUM_LETTER_NSHA                                     0xA6C3
#define unicode_BAMUM_LETTER_KEUX                                     0xA6C4
#define unicode_BAMUM_LETTER_PEUX                                     0xA6C5
#define unicode_BAMUM_LETTER_NJEE                                     0xA6C6
#define unicode_BAMUM_LETTER_NTEE                                     0xA6C7
#define unicode_BAMUM_LETTER_PUE                                      0xA6C8
#define unicode_BAMUM_LETTER_WUE                                      0xA6C9
#define unicode_BAMUM_LETTER_PEE                                      0xA6CA
#define unicode_BAMUM_LETTER_FEE                                      0xA6CB
#define unicode_BAMUM_LETTER_RU                                       0xA6CC
#define unicode_BAMUM_LETTER_LU                                       0xA6CD
#define unicode_BAMUM_LETTER_MI                                       0xA6CE
#define unicode_BAMUM_LETTER_NI                                       0xA6CF
#define unicode_BAMUM_LETTER_REUX                                     0xA6D0
#define unicode_BAMUM_LETTER_RAE                                      0xA6D1
#define unicode_BAMUM_LETTER_KEN                                      0xA6D2
#define unicode_BAMUM_LETTER_NGKWAEN                                  0xA6D3
#define unicode_BAMUM_LETTER_NGGA                                     0xA6D4
#define unicode_BAMUM_LETTER_NGA                                      0xA6D5
#define unicode_BAMUM_LETTER_SHO                                      0xA6D6
#define unicode_BAMUM_LETTER_PUAE                                     0xA6D7
#define unicode_BAMUM_LETTER_FU                                       0xA6D8
#define unicode_BAMUM_LETTER_FOM                                      0xA6D9
#define unicode_BAMUM_LETTER_WA                                       0xA6DA
#define unicode_BAMUM_LETTER_NA                                       0xA6DB
#define unicode_BAMUM_LETTER_LI                                       0xA6DC
#define unicode_BAMUM_LETTER_PI                                       0xA6DD
#define unicode_BAMUM_LETTER_LOQ                                      0xA6DE
#define unicode_BAMUM_LETTER_KO                                       0xA6DF
#define unicode_BAMUM_LETTER_MBEN                                     0xA6E0
#define unicode_BAMUM_LETTER_REN                                      0xA6E1
#define unicode_BAMUM_LETTER_MEN                                      0xA6E2
#define unicode_BAMUM_LETTER_MA                                       0xA6E3
#define unicode_BAMUM_LETTER_TI                                       0xA6E4
#define unicode_BAMUM_LETTER_KI                                       0xA6E5
#define unicode_BAMUM_LETTER_MO                                       0xA6E6
#define unicode_BAMUM_LETTER_MBAA                                     0xA6E7
#define unicode_BAMUM_LETTER_TET                                      0xA6E8
#define unicode_BAMUM_LETTER_KPA                                      0xA6E9
#define unicode_BAMUM_LETTER_TEN                                      0xA6EA
#define unicode_BAMUM_LETTER_NTUU                                     0xA6EB
#define unicode_BAMUM_LETTER_SAMBA                                    0xA6EC
#define unicode_BAMUM_LETTER_FAAMAE                                   0xA6ED
#define unicode_BAMUM_LETTER_KOVUU                                    0xA6EE
#define unicode_BAMUM_LETTER_KOGHOM                                   0xA6EF
#define unicode_BAMUM_COMBINING_MARK_KOQNDON                          0xA6F0
#define unicode_BAMUM_COMBINING_MARK_TUKWENTIS                        0xA6F1
#define unicode_BAMUM_NJAEMLI                                         0xA6F2
#define unicode_BAMUM_FULL_STOP                                       0xA6F3
#define unicode_BAMUM_COLON                                           0xA6F4
#define unicode_BAMUM_COMMA                                           0xA6F5
#define unicode_BAMUM_SEMICOLON                                       0xA6F6
#define unicode_BAMUM_QUESTION_MARK                                   0xA6F7
#define unicode_MODIFIER_LETTER_CHINESE_TONE_YIN_PING                 0xA700
#define unicode_MODIFIER_LETTER_CHINESE_TONE_YANG_PING                0xA701
#define unicode_MODIFIER_LETTER_CHINESE_TONE_YIN_SHANG                0xA702
#define unicode_MODIFIER_LETTER_CHINESE_TONE_YANG_SHANG               0xA703
#define unicode_MODIFIER_LETTER_CHINESE_TONE_YIN_QU                   0xA704
#define unicode_MODIFIER_LETTER_CHINESE_TONE_YANG_QU                  0xA705
#define unicode_MODIFIER_LETTER_CHINESE_TONE_YIN_RU                   0xA706
#define unicode_MODIFIER_LETTER_CHINESE_TONE_YANG_RU                  0xA707
#define unicode_MODIFIER_LETTER_EXTRA_HIGH_DOTTED_TONE_BAR            0xA708
#define unicode_MODIFIER_LETTER_HIGH_DOTTED_TONE_BAR                  0xA709
#define unicode_MODIFIER_LETTER_MID_DOTTED_TONE_BAR                   0xA70A
#define unicode_MODIFIER_LETTER_LOW_DOTTED_TONE_BAR                   0xA70B
#define unicode_MODIFIER_LETTER_EXTRA_LOW_DOTTED_TONE_BAR             0xA70C
#define unicode_MODIFIER_LETTER_EXTRA_HIGH_DOTTED_LEFT_STEM_TONE_BAR  0xA70D
#define unicode_MODIFIER_LETTER_HIGH_DOTTED_LEFT_STEM_TONE_BAR        0xA70E
#define unicode_MODIFIER_LETTER_MID_DOTTED_LEFT_STEM_TONE_BAR         0xA70F
#define unicode_MODIFIER_LETTER_LOW_DOTTED_LEFT_STEM_TONE_BAR         0xA710
#define unicode_MODIFIER_LETTER_EXTRA_LOW_DOTTED_LEFT_STEM_TONE_BAR   0xA711
#define unicode_MODIFIER_LETTER_EXTRA_HIGH_LEFT_STEM_TONE_BAR         0xA712
#define unicode_MODIFIER_LETTER_HIGH_LEFT_STEM_TONE_BAR               0xA713
#define unicode_MODIFIER_LETTER_MID_LEFT_STEM_TONE_BAR                0xA714
#define unicode_MODIFIER_LETTER_LOW_LEFT_STEM_TONE_BAR                0xA715
#define unicode_MODIFIER_LETTER_EXTRA_LOW_LEFT_STEM_TONE_BAR          0xA716
#define unicode_MODIFIER_LETTER_DOT_VERTICAL_BAR                      0xA717
#define unicode_MODIFIER_LETTER_DOT_SLASH                             0xA718
#define unicode_MODIFIER_LETTER_DOT_HORIZONTAL_BAR                    0xA719
#define unicode_MODIFIER_LETTER_LOWER_RIGHT_CORNER_ANGLE              0xA71A
#define unicode_MODIFIER_LETTER_RAISED_UP_ARROW                       0xA71B
#define unicode_MODIFIER_LETTER_RAISED_DOWN_ARROW                     0xA71C
#define unicode_MODIFIER_LETTER_RAISED_EXCLAMATION_MARK               0xA71D
#define unicode_MODIFIER_LETTER_RAISED_INVERTED_EXCLAMATION_MARK      0xA71E
#define unicode_MODIFIER_LETTER_LOW_INVERTED_EXCLAMATION_MARK         0xA71F
#define unicode_MODIFIER_LETTER_STRESS_AND_HIGH_TONE                  0xA720
#define unicode_MODIFIER_LETTER_STRESS_AND_LOW_TONE                   0xA721
#define unicode_LATIN_CAPITAL_LETTER_EGYPTOLOGICAL_ALEF               0xA722
#define unicode_LATIN_SMALL_LETTER_EGYPTOLOGICAL_ALEF                 0xA723
#define unicode_LATIN_CAPITAL_LETTER_EGYPTOLOGICAL_AIN                0xA724
#define unicode_LATIN_SMALL_LETTER_EGYPTOLOGICAL_AIN                  0xA725
#define unicode_LATIN_CAPITAL_LETTER_HENG                             0xA726
#define unicode_LATIN_SMALL_LETTER_HENG                               0xA727
#define unicode_LATIN_CAPITAL_LETTER_TZ                               0xA728
#define unicode_LATIN_SMALL_LETTER_TZ                                 0xA729
#define unicode_LATIN_CAPITAL_LETTER_TRESILLO                         0xA72A
#define unicode_LATIN_SMALL_LETTER_TRESILLO                           0xA72B
#define unicode_LATIN_CAPITAL_LETTER_CUATRILLO                        0xA72C
#define unicode_LATIN_SMALL_LETTER_CUATRILLO                          0xA72D
#define unicode_LATIN_CAPITAL_LETTER_CUATRILLO_WITH_COMMA             0xA72E
#define unicode_LATIN_SMALL_LETTER_CUATRILLO_WITH_COMMA               0xA72F
#define unicode_LATIN_LETTER_SMALL_CAPITAL_F                          0xA730
#define unicode_LATIN_LETTER_SMALL_CAPITAL_S                          0xA731
#define unicode_LATIN_CAPITAL_LETTER_AA                               0xA732
#define unicode_LATIN_SMALL_LETTER_AA                                 0xA733
#define unicode_LATIN_CAPITAL_LETTER_AO                               0xA734
#define unicode_LATIN_SMALL_LETTER_AO                                 0xA735
#define unicode_LATIN_CAPITAL_LETTER_AU                               0xA736
#define unicode_LATIN_SMALL_LETTER_AU                                 0xA737
#define unicode_LATIN_CAPITAL_LETTER_AV                               0xA738
#define unicode_LATIN_SMALL_LETTER_AV                                 0xA739
#define unicode_LATIN_CAPITAL_LETTER_AV_WITH_HORIZONTAL_BAR           0xA73A
#define unicode_LATIN_SMALL_LETTER_AV_WITH_HORIZONTAL_BAR             0xA73B
#define unicode_LATIN_CAPITAL_LETTER_AY                               0xA73C
#define unicode_LATIN_SMALL_LETTER_AY                                 0xA73D
#define unicode_LATIN_CAPITAL_LETTER_REVERSED_C_WITH_DOT              0xA73E
#define unicode_LATIN_SMALL_LETTER_REVERSED_C_WITH_DOT                0xA73F
#define unicode_LATIN_CAPITAL_LETTER_K_WITH_STROKE                    0xA740
#define unicode_LATIN_SMALL_LETTER_K_WITH_STROKE                      0xA741
#define unicode_LATIN_CAPITAL_LETTER_K_WITH_DIAGONAL_STROKE           0xA742
#define unicode_LATIN_SMALL_LETTER_K_WITH_DIAGONAL_STROKE             0xA743
#define unicode_LATIN_CAPITAL_LETTER_K_WITH_STROKE_AND_DIAGONAL_STROKE 0xA744
#define unicode_LATIN_SMALL_LETTER_K_WITH_STROKE_AND_DIAGONAL_STROKE  0xA745
#define unicode_LATIN_CAPITAL_LETTER_BROKEN_L                         0xA746
#define unicode_LATIN_SMALL_LETTER_BROKEN_L                           0xA747
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_HIGH_STROKE               0xA748
#define unicode_LATIN_SMALL_LETTER_L_WITH_HIGH_STROKE                 0xA749
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_LONG_STROKE_OVERLAY       0xA74A
#define unicode_LATIN_SMALL_LETTER_O_WITH_LONG_STROKE_OVERLAY         0xA74B
#define unicode_LATIN_CAPITAL_LETTER_O_WITH_LOOP                      0xA74C
#define unicode_LATIN_SMALL_LETTER_O_WITH_LOOP                        0xA74D
#define unicode_LATIN_CAPITAL_LETTER_OO                               0xA74E
#define unicode_LATIN_SMALL_LETTER_OO                                 0xA74F
#define unicode_LATIN_CAPITAL_LETTER_P_WITH_STROKE_THROUGH_DESCENDER  0xA750
#define unicode_LATIN_SMALL_LETTER_P_WITH_STROKE_THROUGH_DESCENDER    0xA751
#define unicode_LATIN_CAPITAL_LETTER_P_WITH_FLOURISH                  0xA752
#define unicode_LATIN_SMALL_LETTER_P_WITH_FLOURISH                    0xA753
#define unicode_LATIN_CAPITAL_LETTER_P_WITH_SQUIRREL_TAIL             0xA754
#define unicode_LATIN_SMALL_LETTER_P_WITH_SQUIRREL_TAIL               0xA755
#define unicode_LATIN_CAPITAL_LETTER_Q_WITH_STROKE_THROUGH_DESCENDER  0xA756
#define unicode_LATIN_SMALL_LETTER_Q_WITH_STROKE_THROUGH_DESCENDER    0xA757
#define unicode_LATIN_CAPITAL_LETTER_Q_WITH_DIAGONAL_STROKE           0xA758
#define unicode_LATIN_SMALL_LETTER_Q_WITH_DIAGONAL_STROKE             0xA759
#define unicode_LATIN_CAPITAL_LETTER_R_ROTUNDA                        0xA75A
#define unicode_LATIN_SMALL_LETTER_R_ROTUNDA                          0xA75B
#define unicode_LATIN_CAPITAL_LETTER_RUM_ROTUNDA                      0xA75C
#define unicode_LATIN_SMALL_LETTER_RUM_ROTUNDA                        0xA75D
#define unicode_LATIN_CAPITAL_LETTER_V_WITH_DIAGONAL_STROKE           0xA75E
#define unicode_LATIN_SMALL_LETTER_V_WITH_DIAGONAL_STROKE             0xA75F
#define unicode_LATIN_CAPITAL_LETTER_VY                               0xA760
#define unicode_LATIN_SMALL_LETTER_VY                                 0xA761
#define unicode_LATIN_CAPITAL_LETTER_VISIGOTHIC_Z                     0xA762
#define unicode_LATIN_SMALL_LETTER_VISIGOTHIC_Z                       0xA763
#define unicode_LATIN_CAPITAL_LETTER_THORN_WITH_STROKE                0xA764
#define unicode_LATIN_SMALL_LETTER_THORN_WITH_STROKE                  0xA765
#define unicode_LATIN_CAPITAL_LETTER_THORN_WITH_STROKE_THROUGH_DESCENDER 0xA766
#define unicode_LATIN_SMALL_LETTER_THORN_WITH_STROKE_THROUGH_DESCENDER 0xA767
#define unicode_LATIN_CAPITAL_LETTER_VEND                             0xA768
#define unicode_LATIN_SMALL_LETTER_VEND                               0xA769
#define unicode_LATIN_CAPITAL_LETTER_ET                               0xA76A
#define unicode_LATIN_SMALL_LETTER_ET                                 0xA76B
#define unicode_LATIN_CAPITAL_LETTER_IS                               0xA76C
#define unicode_LATIN_SMALL_LETTER_IS                                 0xA76D
#define unicode_LATIN_CAPITAL_LETTER_CON                              0xA76E
#define unicode_LATIN_SMALL_LETTER_CON                                0xA76F
#define unicode_MODIFIER_LETTER_US                                    0xA770
#define unicode_LATIN_SMALL_LETTER_DUM                                0xA771
#define unicode_LATIN_SMALL_LETTER_LUM                                0xA772
#define unicode_LATIN_SMALL_LETTER_MUM                                0xA773
#define unicode_LATIN_SMALL_LETTER_NUM                                0xA774
#define unicode_LATIN_SMALL_LETTER_RUM                                0xA775
#define unicode_LATIN_LETTER_SMALL_CAPITAL_RUM                        0xA776
#define unicode_LATIN_SMALL_LETTER_TUM                                0xA777
#define unicode_LATIN_SMALL_LETTER_UM                                 0xA778
#define unicode_LATIN_CAPITAL_LETTER_INSULAR_D                        0xA779
#define unicode_LATIN_SMALL_LETTER_INSULAR_D                          0xA77A
#define unicode_LATIN_CAPITAL_LETTER_INSULAR_F                        0xA77B
#define unicode_LATIN_SMALL_LETTER_INSULAR_F                          0xA77C
#define unicode_LATIN_CAPITAL_LETTER_INSULAR_G                        0xA77D
#define unicode_LATIN_CAPITAL_LETTER_TURNED_INSULAR_G                 0xA77E
#define unicode_LATIN_SMALL_LETTER_TURNED_INSULAR_G                   0xA77F
#define unicode_LATIN_CAPITAL_LETTER_TURNED_L                         0xA780
#define unicode_LATIN_SMALL_LETTER_TURNED_L                           0xA781
#define unicode_LATIN_CAPITAL_LETTER_INSULAR_R                        0xA782
#define unicode_LATIN_SMALL_LETTER_INSULAR_R                          0xA783
#define unicode_LATIN_CAPITAL_LETTER_INSULAR_S                        0xA784
#define unicode_LATIN_SMALL_LETTER_INSULAR_S                          0xA785
#define unicode_LATIN_CAPITAL_LETTER_INSULAR_T                        0xA786
#define unicode_LATIN_SMALL_LETTER_INSULAR_T                          0xA787
#define unicode_MODIFIER_LETTER_LOW_CIRCUMFLEX_ACCENT                 0xA788
#define unicode_MODIFIER_LETTER_COLON                                 0xA789
#define unicode_MODIFIER_LETTER_SHORT_EQUALS_SIGN                     0xA78A
#define unicode_LATIN_CAPITAL_LETTER_SALTILLO                         0xA78B
#define unicode_LATIN_SMALL_LETTER_SALTILLO                           0xA78C
#define unicode_LATIN_CAPITAL_LETTER_TURNED_H                         0xA78D
#define unicode_LATIN_SMALL_LETTER_L_WITH_RETROFLEX_HOOK_AND_BELT     0xA78E
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_DESCENDER                 0xA790
#define unicode_LATIN_SMALL_LETTER_N_WITH_DESCENDER                   0xA791
#define unicode_LATIN_CAPITAL_LETTER_C_WITH_BAR                       0xA792
#define unicode_LATIN_SMALL_LETTER_C_WITH_BAR                         0xA793
#define unicode_LATIN_SMALL_LETTER_C_WITH_PALATAL_HOOK                0xA794
#define unicode_LATIN_SMALL_LETTER_H_WITH_PALATAL_HOOK                0xA795
#define unicode_LATIN_CAPITAL_LETTER_B_WITH_FLOURISH                  0xA796
#define unicode_LATIN_SMALL_LETTER_B_WITH_FLOURISH                    0xA797
#define unicode_LATIN_CAPITAL_LETTER_F_WITH_STROKE                    0xA798
#define unicode_LATIN_SMALL_LETTER_F_WITH_STROKE                      0xA799
#define unicode_LATIN_CAPITAL_LETTER_VOLAPUK_AE                       0xA79A
#define unicode_LATIN_SMALL_LETTER_VOLAPUK_AE                         0xA79B
#define unicode_LATIN_CAPITAL_LETTER_VOLAPUK_OE                       0xA79C
#define unicode_LATIN_SMALL_LETTER_VOLAPUK_OE                         0xA79D
#define unicode_LATIN_CAPITAL_LETTER_VOLAPUK_UE                       0xA79E
#define unicode_LATIN_SMALL_LETTER_VOLAPUK_UE                         0xA79F
#define unicode_LATIN_CAPITAL_LETTER_G_WITH_OBLIQUE_STROKE            0xA7A0
#define unicode_LATIN_SMALL_LETTER_G_WITH_OBLIQUE_STROKE              0xA7A1
#define unicode_LATIN_CAPITAL_LETTER_K_WITH_OBLIQUE_STROKE            0xA7A2
#define unicode_LATIN_SMALL_LETTER_K_WITH_OBLIQUE_STROKE              0xA7A3
#define unicode_LATIN_CAPITAL_LETTER_N_WITH_OBLIQUE_STROKE            0xA7A4
#define unicode_LATIN_SMALL_LETTER_N_WITH_OBLIQUE_STROKE              0xA7A5
#define unicode_LATIN_CAPITAL_LETTER_R_WITH_OBLIQUE_STROKE            0xA7A6
#define unicode_LATIN_SMALL_LETTER_R_WITH_OBLIQUE_STROKE              0xA7A7
#define unicode_LATIN_CAPITAL_LETTER_S_WITH_OBLIQUE_STROKE            0xA7A8
#define unicode_LATIN_SMALL_LETTER_S_WITH_OBLIQUE_STROKE              0xA7A9
#define unicode_LATIN_CAPITAL_LETTER_H_WITH_HOOK                      0xA7AA
#define unicode_LATIN_CAPITAL_LETTER_REVERSED_OPEN_E                  0xA7AB
#define unicode_LATIN_CAPITAL_LETTER_SCRIPT_G                         0xA7AC
#define unicode_LATIN_CAPITAL_LETTER_L_WITH_BELT                      0xA7AD
#define unicode_LATIN_CAPITAL_LETTER_TURNED_K                         0xA7B0
#define unicode_LATIN_CAPITAL_LETTER_TURNED_T                         0xA7B1
#define unicode_LATIN_EPIGRAPHIC_LETTER_SIDEWAYS_I                    0xA7F7
#define unicode_MODIFIER_LETTER_CAPITAL_H_WITH_STROKE                 0xA7F8
#define unicode_MODIFIER_LETTER_SMALL_LIGATURE_OE                     0xA7F9
#define unicode_LATIN_LETTER_SMALL_CAPITAL_TURNED_M                   0xA7FA
#define unicode_LATIN_EPIGRAPHIC_LETTER_REVERSED_F                    0xA7FB
#define unicode_LATIN_EPIGRAPHIC_LETTER_REVERSED_P                    0xA7FC
#define unicode_LATIN_EPIGRAPHIC_LETTER_INVERTED_M                    0xA7FD
#define unicode_LATIN_EPIGRAPHIC_LETTER_I_LONGA                       0xA7FE
#define unicode_LATIN_EPIGRAPHIC_LETTER_ARCHAIC_M                     0xA7FF
#define unicode_SYLOTI_NAGRI_LETTER_A                                 0xA800
#define unicode_SYLOTI_NAGRI_LETTER_I                                 0xA801
#define unicode_SYLOTI_NAGRI_SIGN_DVISVARA                            0xA802
#define unicode_SYLOTI_NAGRI_LETTER_U                                 0xA803
#define unicode_SYLOTI_NAGRI_LETTER_E                                 0xA804
#define unicode_SYLOTI_NAGRI_LETTER_O                                 0xA805
#define unicode_SYLOTI_NAGRI_SIGN_HASANTA                             0xA806
#define unicode_SYLOTI_NAGRI_LETTER_KO                                0xA807
#define unicode_SYLOTI_NAGRI_LETTER_KHO                               0xA808
#define unicode_SYLOTI_NAGRI_LETTER_GO                                0xA809
#define unicode_SYLOTI_NAGRI_LETTER_GHO                               0xA80A
#define unicode_SYLOTI_NAGRI_SIGN_ANUSVARA                            0xA80B
#define unicode_SYLOTI_NAGRI_LETTER_CO                                0xA80C
#define unicode_SYLOTI_NAGRI_LETTER_CHO                               0xA80D
#define unicode_SYLOTI_NAGRI_LETTER_JO                                0xA80E
#define unicode_SYLOTI_NAGRI_LETTER_JHO                               0xA80F
#define unicode_SYLOTI_NAGRI_LETTER_TTO                               0xA810
#define unicode_SYLOTI_NAGRI_LETTER_TTHO                              0xA811
#define unicode_SYLOTI_NAGRI_LETTER_DDO                               0xA812
#define unicode_SYLOTI_NAGRI_LETTER_DDHO                              0xA813
#define unicode_SYLOTI_NAGRI_LETTER_TO                                0xA814
#define unicode_SYLOTI_NAGRI_LETTER_THO                               0xA815
#define unicode_SYLOTI_NAGRI_LETTER_DO                                0xA816
#define unicode_SYLOTI_NAGRI_LETTER_DHO                               0xA817
#define unicode_SYLOTI_NAGRI_LETTER_NO                                0xA818
#define unicode_SYLOTI_NAGRI_LETTER_PO                                0xA819
#define unicode_SYLOTI_NAGRI_LETTER_PHO                               0xA81A
#define unicode_SYLOTI_NAGRI_LETTER_BO                                0xA81B
#define unicode_SYLOTI_NAGRI_LETTER_BHO                               0xA81C
#define unicode_SYLOTI_NAGRI_LETTER_MO                                0xA81D
#define unicode_SYLOTI_NAGRI_LETTER_RO                                0xA81E
#define unicode_SYLOTI_NAGRI_LETTER_LO                                0xA81F
#define unicode_SYLOTI_NAGRI_LETTER_RRO                               0xA820
#define unicode_SYLOTI_NAGRI_LETTER_SO                                0xA821
#define unicode_SYLOTI_NAGRI_LETTER_HO                                0xA822
#define unicode_SYLOTI_NAGRI_VOWEL_SIGN_A                             0xA823
#define unicode_SYLOTI_NAGRI_VOWEL_SIGN_I                             0xA824
#define unicode_SYLOTI_NAGRI_VOWEL_SIGN_U                             0xA825
#define unicode_SYLOTI_NAGRI_VOWEL_SIGN_E                             0xA826
#define unicode_SYLOTI_NAGRI_VOWEL_SIGN_OO                            0xA827
#define unicode_SYLOTI_NAGRI_POETRY_MARK_1                            0xA828
#define unicode_SYLOTI_NAGRI_POETRY_MARK_2                            0xA829
#define unicode_SYLOTI_NAGRI_POETRY_MARK_3                            0xA82A
#define unicode_SYLOTI_NAGRI_POETRY_MARK_4                            0xA82B
#define unicode_NORTH_INDIC_FRACTION_ONE_QUARTER                      0xA830
#define unicode_NORTH_INDIC_FRACTION_ONE_HALF                         0xA831
#define unicode_NORTH_INDIC_FRACTION_THREE_QUARTERS                   0xA832
#define unicode_NORTH_INDIC_FRACTION_ONE_SIXTEENTH                    0xA833
#define unicode_NORTH_INDIC_FRACTION_ONE_EIGHTH                       0xA834
#define unicode_NORTH_INDIC_FRACTION_THREE_SIXTEENTHS                 0xA835
#define unicode_NORTH_INDIC_QUARTER_MARK                              0xA836
#define unicode_NORTH_INDIC_PLACEHOLDER_MARK                          0xA837
#define unicode_NORTH_INDIC_RUPEE_MARK                                0xA838
#define unicode_NORTH_INDIC_QUANTITY_MARK                             0xA839
#define unicode_PHAGS_PA_LETTER_KA                                    0xA840
#define unicode_PHAGS_PA_LETTER_KHA                                   0xA841
#define unicode_PHAGS_PA_LETTER_GA                                    0xA842
#define unicode_PHAGS_PA_LETTER_NGA                                   0xA843
#define unicode_PHAGS_PA_LETTER_CA                                    0xA844
#define unicode_PHAGS_PA_LETTER_CHA                                   0xA845
#define unicode_PHAGS_PA_LETTER_JA                                    0xA846
#define unicode_PHAGS_PA_LETTER_NYA                                   0xA847
#define unicode_PHAGS_PA_LETTER_TA                                    0xA848
#define unicode_PHAGS_PA_LETTER_THA                                   0xA849
#define unicode_PHAGS_PA_LETTER_DA                                    0xA84A
#define unicode_PHAGS_PA_LETTER_NA                                    0xA84B
#define unicode_PHAGS_PA_LETTER_PA                                    0xA84C
#define unicode_PHAGS_PA_LETTER_PHA                                   0xA84D
#define unicode_PHAGS_PA_LETTER_BA                                    0xA84E
#define unicode_PHAGS_PA_LETTER_MA                                    0xA84F
#define unicode_PHAGS_PA_LETTER_TSA                                   0xA850
#define unicode_PHAGS_PA_LETTER_TSHA                                  0xA851
#define unicode_PHAGS_PA_LETTER_DZA                                   0xA852
#define unicode_PHAGS_PA_LETTER_WA                                    0xA853
#define unicode_PHAGS_PA_LETTER_ZHA                                   0xA854
#define unicode_PHAGS_PA_LETTER_ZA                                    0xA855
#define unicode_PHAGS_PA_LETTER_SMALL_A                               0xA856
#define unicode_PHAGS_PA_LETTER_YA                                    0xA857
#define unicode_PHAGS_PA_LETTER_RA                                    0xA858
#define unicode_PHAGS_PA_LETTER_LA                                    0xA859
#define unicode_PHAGS_PA_LETTER_SHA                                   0xA85A
#define unicode_PHAGS_PA_LETTER_SA                                    0xA85B
#define unicode_PHAGS_PA_LETTER_HA                                    0xA85C
#define unicode_PHAGS_PA_LETTER_A                                     0xA85D
#define unicode_PHAGS_PA_LETTER_I                                     0xA85E
#define unicode_PHAGS_PA_LETTER_U                                     0xA85F
#define unicode_PHAGS_PA_LETTER_E                                     0xA860
#define unicode_PHAGS_PA_LETTER_O                                     0xA861
#define unicode_PHAGS_PA_LETTER_QA                                    0xA862
#define unicode_PHAGS_PA_LETTER_XA                                    0xA863
#define unicode_PHAGS_PA_LETTER_FA                                    0xA864
#define unicode_PHAGS_PA_LETTER_GGA                                   0xA865
#define unicode_PHAGS_PA_LETTER_EE                                    0xA866
#define unicode_PHAGS_PA_SUBJOINED_LETTER_WA                          0xA867
#define unicode_PHAGS_PA_SUBJOINED_LETTER_YA                          0xA868
#define unicode_PHAGS_PA_LETTER_TTA                                   0xA869
#define unicode_PHAGS_PA_LETTER_TTHA                                  0xA86A
#define unicode_PHAGS_PA_LETTER_DDA                                   0xA86B
#define unicode_PHAGS_PA_LETTER_NNA                                   0xA86C
#define unicode_PHAGS_PA_LETTER_ALTERNATE_YA                          0xA86D
#define unicode_PHAGS_PA_LETTER_VOICELESS_SHA                         0xA86E
#define unicode_PHAGS_PA_LETTER_VOICED_HA                             0xA86F
#define unicode_PHAGS_PA_LETTER_ASPIRATED_FA                          0xA870
#define unicode_PHAGS_PA_SUBJOINED_LETTER_RA                          0xA871
#define unicode_PHAGS_PA_SUPERFIXED_LETTER_RA                         0xA872
#define unicode_PHAGS_PA_LETTER_CANDRABINDU                           0xA873
#define unicode_PHAGS_PA_SINGLE_HEAD_MARK                             0xA874
#define unicode_PHAGS_PA_DOUBLE_HEAD_MARK                             0xA875
#define unicode_PHAGS_PA_MARK_SHAD                                    0xA876
#define unicode_PHAGS_PA_MARK_DOUBLE_SHAD                             0xA877
#define unicode_SAURASHTRA_SIGN_ANUSVARA                              0xA880
#define unicode_SAURASHTRA_SIGN_VISARGA                               0xA881
#define unicode_SAURASHTRA_LETTER_A                                   0xA882
#define unicode_SAURASHTRA_LETTER_AA                                  0xA883
#define unicode_SAURASHTRA_LETTER_I                                   0xA884
#define unicode_SAURASHTRA_LETTER_II                                  0xA885
#define unicode_SAURASHTRA_LETTER_U                                   0xA886
#define unicode_SAURASHTRA_LETTER_UU                                  0xA887
#define unicode_SAURASHTRA_LETTER_VOCALIC_R                           0xA888
#define unicode_SAURASHTRA_LETTER_VOCALIC_RR                          0xA889
#define unicode_SAURASHTRA_LETTER_VOCALIC_L                           0xA88A
#define unicode_SAURASHTRA_LETTER_VOCALIC_LL                          0xA88B
#define unicode_SAURASHTRA_LETTER_E                                   0xA88C
#define unicode_SAURASHTRA_LETTER_EE                                  0xA88D
#define unicode_SAURASHTRA_LETTER_AI                                  0xA88E
#define unicode_SAURASHTRA_LETTER_O                                   0xA88F
#define unicode_SAURASHTRA_LETTER_OO                                  0xA890
#define unicode_SAURASHTRA_LETTER_AU                                  0xA891
#define unicode_SAURASHTRA_LETTER_KA                                  0xA892
#define unicode_SAURASHTRA_LETTER_KHA                                 0xA893
#define unicode_SAURASHTRA_LETTER_GA                                  0xA894
#define unicode_SAURASHTRA_LETTER_GHA                                 0xA895
#define unicode_SAURASHTRA_LETTER_NGA                                 0xA896
#define unicode_SAURASHTRA_LETTER_CA                                  0xA897
#define unicode_SAURASHTRA_LETTER_CHA                                 0xA898
#define unicode_SAURASHTRA_LETTER_JA                                  0xA899
#define unicode_SAURASHTRA_LETTER_JHA                                 0xA89A
#define unicode_SAURASHTRA_LETTER_NYA                                 0xA89B
#define unicode_SAURASHTRA_LETTER_TTA                                 0xA89C
#define unicode_SAURASHTRA_LETTER_TTHA                                0xA89D
#define unicode_SAURASHTRA_LETTER_DDA                                 0xA89E
#define unicode_SAURASHTRA_LETTER_DDHA                                0xA89F
#define unicode_SAURASHTRA_LETTER_NNA                                 0xA8A0
#define unicode_SAURASHTRA_LETTER_TA                                  0xA8A1
#define unicode_SAURASHTRA_LETTER_THA                                 0xA8A2
#define unicode_SAURASHTRA_LETTER_DA                                  0xA8A3
#define unicode_SAURASHTRA_LETTER_DHA                                 0xA8A4
#define unicode_SAURASHTRA_LETTER_NA                                  0xA8A5
#define unicode_SAURASHTRA_LETTER_PA                                  0xA8A6
#define unicode_SAURASHTRA_LETTER_PHA                                 0xA8A7
#define unicode_SAURASHTRA_LETTER_BA                                  0xA8A8
#define unicode_SAURASHTRA_LETTER_BHA                                 0xA8A9
#define unicode_SAURASHTRA_LETTER_MA                                  0xA8AA
#define unicode_SAURASHTRA_LETTER_YA                                  0xA8AB
#define unicode_SAURASHTRA_LETTER_RA                                  0xA8AC
#define unicode_SAURASHTRA_LETTER_LA                                  0xA8AD
#define unicode_SAURASHTRA_LETTER_VA                                  0xA8AE
#define unicode_SAURASHTRA_LETTER_SHA                                 0xA8AF
#define unicode_SAURASHTRA_LETTER_SSA                                 0xA8B0
#define unicode_SAURASHTRA_LETTER_SA                                  0xA8B1
#define unicode_SAURASHTRA_LETTER_HA                                  0xA8B2
#define unicode_SAURASHTRA_LETTER_LLA                                 0xA8B3
#define unicode_SAURASHTRA_CONSONANT_SIGN_HAARU                       0xA8B4
#define unicode_SAURASHTRA_VOWEL_SIGN_AA                              0xA8B5
#define unicode_SAURASHTRA_VOWEL_SIGN_I                               0xA8B6
#define unicode_SAURASHTRA_VOWEL_SIGN_II                              0xA8B7
#define unicode_SAURASHTRA_VOWEL_SIGN_U                               0xA8B8
#define unicode_SAURASHTRA_VOWEL_SIGN_UU                              0xA8B9
#define unicode_SAURASHTRA_VOWEL_SIGN_VOCALIC_R                       0xA8BA
#define unicode_SAURASHTRA_VOWEL_SIGN_VOCALIC_RR                      0xA8BB
#define unicode_SAURASHTRA_VOWEL_SIGN_VOCALIC_L                       0xA8BC
#define unicode_SAURASHTRA_VOWEL_SIGN_VOCALIC_LL                      0xA8BD
#define unicode_SAURASHTRA_VOWEL_SIGN_E                               0xA8BE
#define unicode_SAURASHTRA_VOWEL_SIGN_EE                              0xA8BF
#define unicode_SAURASHTRA_VOWEL_SIGN_AI                              0xA8C0
#define unicode_SAURASHTRA_VOWEL_SIGN_O                               0xA8C1
#define unicode_SAURASHTRA_VOWEL_SIGN_OO                              0xA8C2
#define unicode_SAURASHTRA_VOWEL_SIGN_AU                              0xA8C3
#define unicode_SAURASHTRA_SIGN_VIRAMA                                0xA8C4
#define unicode_SAURASHTRA_DANDA                                      0xA8CE
#define unicode_SAURASHTRA_DOUBLE_DANDA                               0xA8CF
#define unicode_SAURASHTRA_DIGIT_ZERO                                 0xA8D0
#define unicode_SAURASHTRA_DIGIT_ONE                                  0xA8D1
#define unicode_SAURASHTRA_DIGIT_TWO                                  0xA8D2
#define unicode_SAURASHTRA_DIGIT_THREE                                0xA8D3
#define unicode_SAURASHTRA_DIGIT_FOUR                                 0xA8D4
#define unicode_SAURASHTRA_DIGIT_FIVE                                 0xA8D5
#define unicode_SAURASHTRA_DIGIT_SIX                                  0xA8D6
#define unicode_SAURASHTRA_DIGIT_SEVEN                                0xA8D7
#define unicode_SAURASHTRA_DIGIT_EIGHT                                0xA8D8
#define unicode_SAURASHTRA_DIGIT_NINE                                 0xA8D9
#define unicode_COMBINING_DEVANAGARI_DIGIT_ZERO                       0xA8E0
#define unicode_COMBINING_DEVANAGARI_DIGIT_ONE                        0xA8E1
#define unicode_COMBINING_DEVANAGARI_DIGIT_TWO                        0xA8E2
#define unicode_COMBINING_DEVANAGARI_DIGIT_THREE                      0xA8E3
#define unicode_COMBINING_DEVANAGARI_DIGIT_FOUR                       0xA8E4
#define unicode_COMBINING_DEVANAGARI_DIGIT_FIVE                       0xA8E5
#define unicode_COMBINING_DEVANAGARI_DIGIT_SIX                        0xA8E6
#define unicode_COMBINING_DEVANAGARI_DIGIT_SEVEN                      0xA8E7
#define unicode_COMBINING_DEVANAGARI_DIGIT_EIGHT                      0xA8E8
#define unicode_COMBINING_DEVANAGARI_DIGIT_NINE                       0xA8E9
#define unicode_COMBINING_DEVANAGARI_LETTER_A                         0xA8EA
#define unicode_COMBINING_DEVANAGARI_LETTER_U                         0xA8EB
#define unicode_COMBINING_DEVANAGARI_LETTER_KA                        0xA8EC
#define unicode_COMBINING_DEVANAGARI_LETTER_NA                        0xA8ED
#define unicode_COMBINING_DEVANAGARI_LETTER_PA                        0xA8EE
#define unicode_COMBINING_DEVANAGARI_LETTER_RA                        0xA8EF
#define unicode_COMBINING_DEVANAGARI_LETTER_VI                        0xA8F0
#define unicode_COMBINING_DEVANAGARI_SIGN_AVAGRAHA                    0xA8F1
#define unicode_DEVANAGARI_SIGN_SPACING_CANDRABINDU                   0xA8F2
#define unicode_DEVANAGARI_SIGN_CANDRABINDU_VIRAMA                    0xA8F3
#define unicode_DEVANAGARI_SIGN_DOUBLE_CANDRABINDU_VIRAMA             0xA8F4
#define unicode_DEVANAGARI_SIGN_CANDRABINDU_TWO                       0xA8F5
#define unicode_DEVANAGARI_SIGN_CANDRABINDU_THREE                     0xA8F6
#define unicode_DEVANAGARI_SIGN_CANDRABINDU_AVAGRAHA                  0xA8F7
#define unicode_DEVANAGARI_SIGN_PUSHPIKA                              0xA8F8
#define unicode_DEVANAGARI_GAP_FILLER                                 0xA8F9
#define unicode_DEVANAGARI_CARET                                      0xA8FA
#define unicode_DEVANAGARI_HEADSTROKE                                 0xA8FB
#define unicode_KAYAH_LI_DIGIT_ZERO                                   0xA900
#define unicode_KAYAH_LI_DIGIT_ONE                                    0xA901
#define unicode_KAYAH_LI_DIGIT_TWO                                    0xA902
#define unicode_KAYAH_LI_DIGIT_THREE                                  0xA903
#define unicode_KAYAH_LI_DIGIT_FOUR                                   0xA904
#define unicode_KAYAH_LI_DIGIT_FIVE                                   0xA905
#define unicode_KAYAH_LI_DIGIT_SIX                                    0xA906
#define unicode_KAYAH_LI_DIGIT_SEVEN                                  0xA907
#define unicode_KAYAH_LI_DIGIT_EIGHT                                  0xA908
#define unicode_KAYAH_LI_DIGIT_NINE                                   0xA909
#define unicode_KAYAH_LI_LETTER_KA                                    0xA90A
#define unicode_KAYAH_LI_LETTER_KHA                                   0xA90B
#define unicode_KAYAH_LI_LETTER_GA                                    0xA90C
#define unicode_KAYAH_LI_LETTER_NGA                                   0xA90D
#define unicode_KAYAH_LI_LETTER_SA                                    0xA90E
#define unicode_KAYAH_LI_LETTER_SHA                                   0xA90F
#define unicode_KAYAH_LI_LETTER_ZA                                    0xA910
#define unicode_KAYAH_LI_LETTER_NYA                                   0xA911
#define unicode_KAYAH_LI_LETTER_TA                                    0xA912
#define unicode_KAYAH_LI_LETTER_HTA                                   0xA913
#define unicode_KAYAH_LI_LETTER_NA                                    0xA914
#define unicode_KAYAH_LI_LETTER_PA                                    0xA915
#define unicode_KAYAH_LI_LETTER_PHA                                   0xA916
#define unicode_KAYAH_LI_LETTER_MA                                    0xA917
#define unicode_KAYAH_LI_LETTER_DA                                    0xA918
#define unicode_KAYAH_LI_LETTER_BA                                    0xA919
#define unicode_KAYAH_LI_LETTER_RA                                    0xA91A
#define unicode_KAYAH_LI_LETTER_YA                                    0xA91B
#define unicode_KAYAH_LI_LETTER_LA                                    0xA91C
#define unicode_KAYAH_LI_LETTER_WA                                    0xA91D
#define unicode_KAYAH_LI_LETTER_THA                                   0xA91E
#define unicode_KAYAH_LI_LETTER_HA                                    0xA91F
#define unicode_KAYAH_LI_LETTER_VA                                    0xA920
#define unicode_KAYAH_LI_LETTER_CA                                    0xA921
#define unicode_KAYAH_LI_LETTER_A                                     0xA922
#define unicode_KAYAH_LI_LETTER_OE                                    0xA923
#define unicode_KAYAH_LI_LETTER_I                                     0xA924
#define unicode_KAYAH_LI_LETTER_OO                                    0xA925
#define unicode_KAYAH_LI_VOWEL_UE                                     0xA926
#define unicode_KAYAH_LI_VOWEL_E                                      0xA927
#define unicode_KAYAH_LI_VOWEL_U                                      0xA928
#define unicode_KAYAH_LI_VOWEL_EE                                     0xA929
#define unicode_KAYAH_LI_VOWEL_O                                      0xA92A
#define unicode_KAYAH_LI_TONE_PLOPHU                                  0xA92B
#define unicode_KAYAH_LI_TONE_CALYA                                   0xA92C
#define unicode_KAYAH_LI_TONE_CALYA_PLOPHU                            0xA92D
#define unicode_KAYAH_LI_SIGN_CWI                                     0xA92E
#define unicode_KAYAH_LI_SIGN_SHYA                                    0xA92F
#define unicode_REJANG_LETTER_KA                                      0xA930
#define unicode_REJANG_LETTER_GA                                      0xA931
#define unicode_REJANG_LETTER_NGA                                     0xA932
#define unicode_REJANG_LETTER_TA                                      0xA933
#define unicode_REJANG_LETTER_DA                                      0xA934
#define unicode_REJANG_LETTER_NA                                      0xA935
#define unicode_REJANG_LETTER_PA                                      0xA936
#define unicode_REJANG_LETTER_BA                                      0xA937
#define unicode_REJANG_LETTER_MA                                      0xA938
#define unicode_REJANG_LETTER_CA                                      0xA939
#define unicode_REJANG_LETTER_JA                                      0xA93A
#define unicode_REJANG_LETTER_NYA                                     0xA93B
#define unicode_REJANG_LETTER_SA                                      0xA93C
#define unicode_REJANG_LETTER_RA                                      0xA93D
#define unicode_REJANG_LETTER_LA                                      0xA93E
#define unicode_REJANG_LETTER_YA                                      0xA93F
#define unicode_REJANG_LETTER_WA                                      0xA940
#define unicode_REJANG_LETTER_HA                                      0xA941
#define unicode_REJANG_LETTER_MBA                                     0xA942
#define unicode_REJANG_LETTER_NGGA                                    0xA943
#define unicode_REJANG_LETTER_NDA                                     0xA944
#define unicode_REJANG_LETTER_NYJA                                    0xA945
#define unicode_REJANG_LETTER_A                                       0xA946
#define unicode_REJANG_VOWEL_SIGN_I                                   0xA947
#define unicode_REJANG_VOWEL_SIGN_U                                   0xA948
#define unicode_REJANG_VOWEL_SIGN_E                                   0xA949
#define unicode_REJANG_VOWEL_SIGN_AI                                  0xA94A
#define unicode_REJANG_VOWEL_SIGN_O                                   0xA94B
#define unicode_REJANG_VOWEL_SIGN_AU                                  0xA94C
#define unicode_REJANG_VOWEL_SIGN_EU                                  0xA94D
#define unicode_REJANG_VOWEL_SIGN_EA                                  0xA94E
#define unicode_REJANG_CONSONANT_SIGN_NG                              0xA94F
#define unicode_REJANG_CONSONANT_SIGN_N                               0xA950
#define unicode_REJANG_CONSONANT_SIGN_R                               0xA951
#define unicode_REJANG_CONSONANT_SIGN_H                               0xA952
#define unicode_REJANG_VIRAMA                                         0xA953
#define unicode_REJANG_SECTION_MARK                                   0xA95F
#define unicode_HANGUL_CHOSEONG_TIKEUT_MIEUM                          0xA960
#define unicode_HANGUL_CHOSEONG_TIKEUT_PIEUP                          0xA961
#define unicode_HANGUL_CHOSEONG_TIKEUT_SIOS                           0xA962
#define unicode_HANGUL_CHOSEONG_TIKEUT_CIEUC                          0xA963
#define unicode_HANGUL_CHOSEONG_RIEUL_KIYEOK                          0xA964
#define unicode_HANGUL_CHOSEONG_RIEUL_SSANGKIYEOK                     0xA965
#define unicode_HANGUL_CHOSEONG_RIEUL_TIKEUT                          0xA966
#define unicode_HANGUL_CHOSEONG_RIEUL_SSANGTIKEUT                     0xA967
#define unicode_HANGUL_CHOSEONG_RIEUL_MIEUM                           0xA968
#define unicode_HANGUL_CHOSEONG_RIEUL_PIEUP                           0xA969
#define unicode_HANGUL_CHOSEONG_RIEUL_SSANGPIEUP                      0xA96A
#define unicode_HANGUL_CHOSEONG_RIEUL_KAPYEOUNPIEUP                   0xA96B
#define unicode_HANGUL_CHOSEONG_RIEUL_SIOS                            0xA96C
#define unicode_HANGUL_CHOSEONG_RIEUL_CIEUC                           0xA96D
#define unicode_HANGUL_CHOSEONG_RIEUL_KHIEUKH                         0xA96E
#define unicode_HANGUL_CHOSEONG_MIEUM_KIYEOK                          0xA96F
#define unicode_HANGUL_CHOSEONG_MIEUM_TIKEUT                          0xA970
#define unicode_HANGUL_CHOSEONG_MIEUM_SIOS                            0xA971
#define unicode_HANGUL_CHOSEONG_PIEUP_SIOS_THIEUTH                    0xA972
#define unicode_HANGUL_CHOSEONG_PIEUP_KHIEUKH                         0xA973
#define unicode_HANGUL_CHOSEONG_PIEUP_HIEUH                           0xA974
#define unicode_HANGUL_CHOSEONG_SSANGSIOS_PIEUP                       0xA975
#define unicode_HANGUL_CHOSEONG_IEUNG_RIEUL                           0xA976
#define unicode_HANGUL_CHOSEONG_IEUNG_HIEUH                           0xA977
#define unicode_HANGUL_CHOSEONG_SSANGCIEUC_HIEUH                      0xA978
#define unicode_HANGUL_CHOSEONG_SSANGTHIEUTH                          0xA979
#define unicode_HANGUL_CHOSEONG_PHIEUPH_HIEUH                         0xA97A
#define unicode_HANGUL_CHOSEONG_HIEUH_SIOS                            0xA97B
#define unicode_HANGUL_CHOSEONG_SSANGYEORINHIEUH                      0xA97C
#define unicode_JAVANESE_SIGN_PANYANGGA                               0xA980
#define unicode_JAVANESE_SIGN_CECAK                                   0xA981
#define unicode_JAVANESE_SIGN_LAYAR                                   0xA982
#define unicode_JAVANESE_SIGN_WIGNYAN                                 0xA983
#define unicode_JAVANESE_LETTER_A                                     0xA984
#define unicode_JAVANESE_LETTER_I_KAWI                                0xA985
#define unicode_JAVANESE_LETTER_I                                     0xA986
#define unicode_JAVANESE_LETTER_II                                    0xA987
#define unicode_JAVANESE_LETTER_U                                     0xA988
#define unicode_JAVANESE_LETTER_PA_CEREK                              0xA989
#define unicode_JAVANESE_LETTER_NGA_LELET                             0xA98A
#define unicode_JAVANESE_LETTER_NGA_LELET_RASWADI                     0xA98B
#define unicode_JAVANESE_LETTER_E                                     0xA98C
#define unicode_JAVANESE_LETTER_AI                                    0xA98D
#define unicode_JAVANESE_LETTER_O                                     0xA98E
#define unicode_JAVANESE_LETTER_KA                                    0xA98F
#define unicode_JAVANESE_LETTER_KA_SASAK                              0xA990
#define unicode_JAVANESE_LETTER_KA_MURDA                              0xA991
#define unicode_JAVANESE_LETTER_GA                                    0xA992
#define unicode_JAVANESE_LETTER_GA_MURDA                              0xA993
#define unicode_JAVANESE_LETTER_NGA                                   0xA994
#define unicode_JAVANESE_LETTER_CA                                    0xA995
#define unicode_JAVANESE_LETTER_CA_MURDA                              0xA996
#define unicode_JAVANESE_LETTER_JA                                    0xA997
#define unicode_JAVANESE_LETTER_NYA_MURDA                             0xA998
#define unicode_JAVANESE_LETTER_JA_MAHAPRANA                          0xA999
#define unicode_JAVANESE_LETTER_NYA                                   0xA99A
#define unicode_JAVANESE_LETTER_TTA                                   0xA99B
#define unicode_JAVANESE_LETTER_TTA_MAHAPRANA                         0xA99C
#define unicode_JAVANESE_LETTER_DDA                                   0xA99D
#define unicode_JAVANESE_LETTER_DDA_MAHAPRANA                         0xA99E
#define unicode_JAVANESE_LETTER_NA_MURDA                              0xA99F
#define unicode_JAVANESE_LETTER_TA                                    0xA9A0
#define unicode_JAVANESE_LETTER_TA_MURDA                              0xA9A1
#define unicode_JAVANESE_LETTER_DA                                    0xA9A2
#define unicode_JAVANESE_LETTER_DA_MAHAPRANA                          0xA9A3
#define unicode_JAVANESE_LETTER_NA                                    0xA9A4
#define unicode_JAVANESE_LETTER_PA                                    0xA9A5
#define unicode_JAVANESE_LETTER_PA_MURDA                              0xA9A6
#define unicode_JAVANESE_LETTER_BA                                    0xA9A7
#define unicode_JAVANESE_LETTER_BA_MURDA                              0xA9A8
#define unicode_JAVANESE_LETTER_MA                                    0xA9A9
#define unicode_JAVANESE_LETTER_YA                                    0xA9AA
#define unicode_JAVANESE_LETTER_RA                                    0xA9AB
#define unicode_JAVANESE_LETTER_RA_AGUNG                              0xA9AC
#define unicode_JAVANESE_LETTER_LA                                    0xA9AD
#define unicode_JAVANESE_LETTER_WA                                    0xA9AE
#define unicode_JAVANESE_LETTER_SA_MURDA                              0xA9AF
#define unicode_JAVANESE_LETTER_SA_MAHAPRANA                          0xA9B0
#define unicode_JAVANESE_LETTER_SA                                    0xA9B1
#define unicode_JAVANESE_LETTER_HA                                    0xA9B2
#define unicode_JAVANESE_SIGN_CECAK_TELU                              0xA9B3
#define unicode_JAVANESE_VOWEL_SIGN_TARUNG                            0xA9B4
#define unicode_JAVANESE_VOWEL_SIGN_TOLONG                            0xA9B5
#define unicode_JAVANESE_VOWEL_SIGN_WULU                              0xA9B6
#define unicode_JAVANESE_VOWEL_SIGN_WULU_MELIK                        0xA9B7
#define unicode_JAVANESE_VOWEL_SIGN_SUKU                              0xA9B8
#define unicode_JAVANESE_VOWEL_SIGN_SUKU_MENDUT                       0xA9B9
#define unicode_JAVANESE_VOWEL_SIGN_TALING                            0xA9BA
#define unicode_JAVANESE_VOWEL_SIGN_DIRGA_MURE                        0xA9BB
#define unicode_JAVANESE_VOWEL_SIGN_PEPET                             0xA9BC
#define unicode_JAVANESE_CONSONANT_SIGN_KERET                         0xA9BD
#define unicode_JAVANESE_CONSONANT_SIGN_PENGKAL                       0xA9BE
#define unicode_JAVANESE_CONSONANT_SIGN_CAKRA                         0xA9BF
#define unicode_JAVANESE_PANGKON                                      0xA9C0
#define unicode_JAVANESE_LEFT_RERENGGAN                               0xA9C1
#define unicode_JAVANESE_RIGHT_RERENGGAN                              0xA9C2
#define unicode_JAVANESE_PADA_ANDAP                                   0xA9C3
#define unicode_JAVANESE_PADA_MADYA                                   0xA9C4
#define unicode_JAVANESE_PADA_LUHUR                                   0xA9C5
#define unicode_JAVANESE_PADA_WINDU                                   0xA9C6
#define unicode_JAVANESE_PADA_PANGKAT                                 0xA9C7
#define unicode_JAVANESE_PADA_LINGSA                                  0xA9C8
#define unicode_JAVANESE_PADA_LUNGSI                                  0xA9C9
#define unicode_JAVANESE_PADA_ADEG                                    0xA9CA
#define unicode_JAVANESE_PADA_ADEG_ADEG                               0xA9CB
#define unicode_JAVANESE_PADA_PISELEH                                 0xA9CC
#define unicode_JAVANESE_TURNED_PADA_PISELEH                          0xA9CD
#define unicode_JAVANESE_PANGRANGKEP                                  0xA9CF
#define unicode_JAVANESE_DIGIT_ZERO                                   0xA9D0
#define unicode_JAVANESE_DIGIT_ONE                                    0xA9D1
#define unicode_JAVANESE_DIGIT_TWO                                    0xA9D2
#define unicode_JAVANESE_DIGIT_THREE                                  0xA9D3
#define unicode_JAVANESE_DIGIT_FOUR                                   0xA9D4
#define unicode_JAVANESE_DIGIT_FIVE                                   0xA9D5
#define unicode_JAVANESE_DIGIT_SIX                                    0xA9D6
#define unicode_JAVANESE_DIGIT_SEVEN                                  0xA9D7
#define unicode_JAVANESE_DIGIT_EIGHT                                  0xA9D8
#define unicode_JAVANESE_DIGIT_NINE                                   0xA9D9
#define unicode_JAVANESE_PADA_TIRTA_TUMETES                           0xA9DE
#define unicode_JAVANESE_PADA_ISEN_ISEN                               0xA9DF
#define unicode_MYANMAR_LETTER_SHAN_GHA                               0xA9E0
#define unicode_MYANMAR_LETTER_SHAN_CHA                               0xA9E1
#define unicode_MYANMAR_LETTER_SHAN_JHA                               0xA9E2
#define unicode_MYANMAR_LETTER_SHAN_NNA                               0xA9E3
#define unicode_MYANMAR_LETTER_SHAN_BHA                               0xA9E4
#define unicode_MYANMAR_SIGN_SHAN_SAW                                 0xA9E5
#define unicode_MYANMAR_MODIFIER_LETTER_SHAN_REDUPLICATION            0xA9E6
#define unicode_MYANMAR_LETTER_TAI_LAING_NYA                          0xA9E7
#define unicode_MYANMAR_LETTER_TAI_LAING_FA                           0xA9E8
#define unicode_MYANMAR_LETTER_TAI_LAING_GA                           0xA9E9
#define unicode_MYANMAR_LETTER_TAI_LAING_GHA                          0xA9EA
#define unicode_MYANMAR_LETTER_TAI_LAING_JA                           0xA9EB
#define unicode_MYANMAR_LETTER_TAI_LAING_JHA                          0xA9EC
#define unicode_MYANMAR_LETTER_TAI_LAING_DDA                          0xA9ED
#define unicode_MYANMAR_LETTER_TAI_LAING_DDHA                         0xA9EE
#define unicode_MYANMAR_LETTER_TAI_LAING_NNA                          0xA9EF
#define unicode_MYANMAR_TAI_LAING_DIGIT_ZERO                          0xA9F0
#define unicode_MYANMAR_TAI_LAING_DIGIT_ONE                           0xA9F1
#define unicode_MYANMAR_TAI_LAING_DIGIT_TWO                           0xA9F2
#define unicode_MYANMAR_TAI_LAING_DIGIT_THREE                         0xA9F3
#define unicode_MYANMAR_TAI_LAING_DIGIT_FOUR                          0xA9F4
#define unicode_MYANMAR_TAI_LAING_DIGIT_FIVE                          0xA9F5
#define unicode_MYANMAR_TAI_LAING_DIGIT_SIX                           0xA9F6
#define unicode_MYANMAR_TAI_LAING_DIGIT_SEVEN                         0xA9F7
#define unicode_MYANMAR_TAI_LAING_DIGIT_EIGHT                         0xA9F8
#define unicode_MYANMAR_TAI_LAING_DIGIT_NINE                          0xA9F9
#define unicode_MYANMAR_LETTER_TAI_LAING_LLA                          0xA9FA
#define unicode_MYANMAR_LETTER_TAI_LAING_DA                           0xA9FB
#define unicode_MYANMAR_LETTER_TAI_LAING_DHA                          0xA9FC
#define unicode_MYANMAR_LETTER_TAI_LAING_BA                           0xA9FD
#define unicode_MYANMAR_LETTER_TAI_LAING_BHA                          0xA9FE
#define unicode_CHAM_LETTER_A                                         0xAA00
#define unicode_CHAM_LETTER_I                                         0xAA01
#define unicode_CHAM_LETTER_U                                         0xAA02
#define unicode_CHAM_LETTER_E                                         0xAA03
#define unicode_CHAM_LETTER_AI                                        0xAA04
#define unicode_CHAM_LETTER_O                                         0xAA05
#define unicode_CHAM_LETTER_KA                                        0xAA06
#define unicode_CHAM_LETTER_KHA                                       0xAA07
#define unicode_CHAM_LETTER_GA                                        0xAA08
#define unicode_CHAM_LETTER_GHA                                       0xAA09
#define unicode_CHAM_LETTER_NGUE                                      0xAA0A
#define unicode_CHAM_LETTER_NGA                                       0xAA0B
#define unicode_CHAM_LETTER_CHA                                       0xAA0C
#define unicode_CHAM_LETTER_CHHA                                      0xAA0D
#define unicode_CHAM_LETTER_JA                                        0xAA0E
#define unicode_CHAM_LETTER_JHA                                       0xAA0F
#define unicode_CHAM_LETTER_NHUE                                      0xAA10
#define unicode_CHAM_LETTER_NHA                                       0xAA11
#define unicode_CHAM_LETTER_NHJA                                      0xAA12
#define unicode_CHAM_LETTER_TA                                        0xAA13
#define unicode_CHAM_LETTER_THA                                       0xAA14
#define unicode_CHAM_LETTER_DA                                        0xAA15
#define unicode_CHAM_LETTER_DHA                                       0xAA16
#define unicode_CHAM_LETTER_NUE                                       0xAA17
#define unicode_CHAM_LETTER_NA                                        0xAA18
#define unicode_CHAM_LETTER_DDA                                       0xAA19
#define unicode_CHAM_LETTER_PA                                        0xAA1A
#define unicode_CHAM_LETTER_PPA                                       0xAA1B
#define unicode_CHAM_LETTER_PHA                                       0xAA1C
#define unicode_CHAM_LETTER_BA                                        0xAA1D
#define unicode_CHAM_LETTER_BHA                                       0xAA1E
#define unicode_CHAM_LETTER_MUE                                       0xAA1F
#define unicode_CHAM_LETTER_MA                                        0xAA20
#define unicode_CHAM_LETTER_BBA                                       0xAA21
#define unicode_CHAM_LETTER_YA                                        0xAA22
#define unicode_CHAM_LETTER_RA                                        0xAA23
#define unicode_CHAM_LETTER_LA                                        0xAA24
#define unicode_CHAM_LETTER_VA                                        0xAA25
#define unicode_CHAM_LETTER_SSA                                       0xAA26
#define unicode_CHAM_LETTER_SA                                        0xAA27
#define unicode_CHAM_LETTER_HA                                        0xAA28
#define unicode_CHAM_VOWEL_SIGN_AA                                    0xAA29
#define unicode_CHAM_VOWEL_SIGN_I                                     0xAA2A
#define unicode_CHAM_VOWEL_SIGN_II                                    0xAA2B
#define unicode_CHAM_VOWEL_SIGN_EI                                    0xAA2C
#define unicode_CHAM_VOWEL_SIGN_U                                     0xAA2D
#define unicode_CHAM_VOWEL_SIGN_OE                                    0xAA2E
#define unicode_CHAM_VOWEL_SIGN_O                                     0xAA2F
#define unicode_CHAM_VOWEL_SIGN_AI                                    0xAA30
#define unicode_CHAM_VOWEL_SIGN_AU                                    0xAA31
#define unicode_CHAM_VOWEL_SIGN_UE                                    0xAA32
#define unicode_CHAM_CONSONANT_SIGN_YA                                0xAA33
#define unicode_CHAM_CONSONANT_SIGN_RA                                0xAA34
#define unicode_CHAM_CONSONANT_SIGN_LA                                0xAA35
#define unicode_CHAM_CONSONANT_SIGN_WA                                0xAA36
#define unicode_CHAM_LETTER_FINAL_K                                   0xAA40
#define unicode_CHAM_LETTER_FINAL_G                                   0xAA41
#define unicode_CHAM_LETTER_FINAL_NG                                  0xAA42
#define unicode_CHAM_CONSONANT_SIGN_FINAL_NG                          0xAA43
#define unicode_CHAM_LETTER_FINAL_CH                                  0xAA44
#define unicode_CHAM_LETTER_FINAL_T                                   0xAA45
#define unicode_CHAM_LETTER_FINAL_N                                   0xAA46
#define unicode_CHAM_LETTER_FINAL_P                                   0xAA47
#define unicode_CHAM_LETTER_FINAL_Y                                   0xAA48
#define unicode_CHAM_LETTER_FINAL_R                                   0xAA49
#define unicode_CHAM_LETTER_FINAL_L                                   0xAA4A
#define unicode_CHAM_LETTER_FINAL_SS                                  0xAA4B
#define unicode_CHAM_CONSONANT_SIGN_FINAL_M                           0xAA4C
#define unicode_CHAM_CONSONANT_SIGN_FINAL_H                           0xAA4D
#define unicode_CHAM_DIGIT_ZERO                                       0xAA50
#define unicode_CHAM_DIGIT_ONE                                        0xAA51
#define unicode_CHAM_DIGIT_TWO                                        0xAA52
#define unicode_CHAM_DIGIT_THREE                                      0xAA53
#define unicode_CHAM_DIGIT_FOUR                                       0xAA54
#define unicode_CHAM_DIGIT_FIVE                                       0xAA55
#define unicode_CHAM_DIGIT_SIX                                        0xAA56
#define unicode_CHAM_DIGIT_SEVEN                                      0xAA57
#define unicode_CHAM_DIGIT_EIGHT                                      0xAA58
#define unicode_CHAM_DIGIT_NINE                                       0xAA59
#define unicode_CHAM_PUNCTUATION_SPIRAL                               0xAA5C
#define unicode_CHAM_PUNCTUATION_DANDA                                0xAA5D
#define unicode_CHAM_PUNCTUATION_DOUBLE_DANDA                         0xAA5E
#define unicode_CHAM_PUNCTUATION_TRIPLE_DANDA                         0xAA5F
#define unicode_MYANMAR_LETTER_KHAMTI_GA                              0xAA60
#define unicode_MYANMAR_LETTER_KHAMTI_CA                              0xAA61
#define unicode_MYANMAR_LETTER_KHAMTI_CHA                             0xAA62
#define unicode_MYANMAR_LETTER_KHAMTI_JA                              0xAA63
#define unicode_MYANMAR_LETTER_KHAMTI_JHA                             0xAA64
#define unicode_MYANMAR_LETTER_KHAMTI_NYA                             0xAA65
#define unicode_MYANMAR_LETTER_KHAMTI_TTA                             0xAA66
#define unicode_MYANMAR_LETTER_KHAMTI_TTHA                            0xAA67
#define unicode_MYANMAR_LETTER_KHAMTI_DDA                             0xAA68
#define unicode_MYANMAR_LETTER_KHAMTI_DDHA                            0xAA69
#define unicode_MYANMAR_LETTER_KHAMTI_DHA                             0xAA6A
#define unicode_MYANMAR_LETTER_KHAMTI_NA                              0xAA6B
#define unicode_MYANMAR_LETTER_KHAMTI_SA                              0xAA6C
#define unicode_MYANMAR_LETTER_KHAMTI_HA                              0xAA6D
#define unicode_MYANMAR_LETTER_KHAMTI_HHA                             0xAA6E
#define unicode_MYANMAR_LETTER_KHAMTI_FA                              0xAA6F
#define unicode_MYANMAR_MODIFIER_LETTER_KHAMTI_REDUPLICATION          0xAA70
#define unicode_MYANMAR_LETTER_KHAMTI_XA                              0xAA71
#define unicode_MYANMAR_LETTER_KHAMTI_ZA                              0xAA72
#define unicode_MYANMAR_LETTER_KHAMTI_RA                              0xAA73
#define unicode_MYANMAR_LOGOGRAM_KHAMTI_OAY                           0xAA74
#define unicode_MYANMAR_LOGOGRAM_KHAMTI_QN                            0xAA75
#define unicode_MYANMAR_LOGOGRAM_KHAMTI_HM                            0xAA76
#define unicode_MYANMAR_SYMBOL_AITON_EXCLAMATION                      0xAA77
#define unicode_MYANMAR_SYMBOL_AITON_ONE                              0xAA78
#define unicode_MYANMAR_SYMBOL_AITON_TWO                              0xAA79
#define unicode_MYANMAR_LETTER_AITON_RA                               0xAA7A
#define unicode_MYANMAR_SIGN_PAO_KAREN_TONE                           0xAA7B
#define unicode_MYANMAR_SIGN_TAI_LAING_TONE_2                         0xAA7C
#define unicode_MYANMAR_SIGN_TAI_LAING_TONE_5                         0xAA7D
#define unicode_MYANMAR_LETTER_SHWE_PALAUNG_CHA                       0xAA7E
#define unicode_MYANMAR_LETTER_SHWE_PALAUNG_SHA                       0xAA7F
#define unicode_TAI_VIET_LETTER_LOW_KO                                0xAA80
#define unicode_TAI_VIET_LETTER_HIGH_KO                               0xAA81
#define unicode_TAI_VIET_LETTER_LOW_KHO                               0xAA82
#define unicode_TAI_VIET_LETTER_HIGH_KHO                              0xAA83
#define unicode_TAI_VIET_LETTER_LOW_KHHO                              0xAA84
#define unicode_TAI_VIET_LETTER_HIGH_KHHO                             0xAA85
#define unicode_TAI_VIET_LETTER_LOW_GO                                0xAA86
#define unicode_TAI_VIET_LETTER_HIGH_GO                               0xAA87
#define unicode_TAI_VIET_LETTER_LOW_NGO                               0xAA88
#define unicode_TAI_VIET_LETTER_HIGH_NGO                              0xAA89
#define unicode_TAI_VIET_LETTER_LOW_CO                                0xAA8A
#define unicode_TAI_VIET_LETTER_HIGH_CO                               0xAA8B
#define unicode_TAI_VIET_LETTER_LOW_CHO                               0xAA8C
#define unicode_TAI_VIET_LETTER_HIGH_CHO                              0xAA8D
#define unicode_TAI_VIET_LETTER_LOW_SO                                0xAA8E
#define unicode_TAI_VIET_LETTER_HIGH_SO                               0xAA8F
#define unicode_TAI_VIET_LETTER_LOW_NYO                               0xAA90
#define unicode_TAI_VIET_LETTER_HIGH_NYO                              0xAA91
#define unicode_TAI_VIET_LETTER_LOW_DO                                0xAA92
#define unicode_TAI_VIET_LETTER_HIGH_DO                               0xAA93
#define unicode_TAI_VIET_LETTER_LOW_TO                                0xAA94
#define unicode_TAI_VIET_LETTER_HIGH_TO                               0xAA95
#define unicode_TAI_VIET_LETTER_LOW_THO                               0xAA96
#define unicode_TAI_VIET_LETTER_HIGH_THO                              0xAA97
#define unicode_TAI_VIET_LETTER_LOW_NO                                0xAA98
#define unicode_TAI_VIET_LETTER_HIGH_NO                               0xAA99
#define unicode_TAI_VIET_LETTER_LOW_BO                                0xAA9A
#define unicode_TAI_VIET_LETTER_HIGH_BO                               0xAA9B
#define unicode_TAI_VIET_LETTER_LOW_PO                                0xAA9C
#define unicode_TAI_VIET_LETTER_HIGH_PO                               0xAA9D
#define unicode_TAI_VIET_LETTER_LOW_PHO                               0xAA9E
#define unicode_TAI_VIET_LETTER_HIGH_PHO                              0xAA9F
#define unicode_TAI_VIET_LETTER_LOW_FO                                0xAAA0
#define unicode_TAI_VIET_LETTER_HIGH_FO                               0xAAA1
#define unicode_TAI_VIET_LETTER_LOW_MO                                0xAAA2
#define unicode_TAI_VIET_LETTER_HIGH_MO                               0xAAA3
#define unicode_TAI_VIET_LETTER_LOW_YO                                0xAAA4
#define unicode_TAI_VIET_LETTER_HIGH_YO                               0xAAA5
#define unicode_TAI_VIET_LETTER_LOW_RO                                0xAAA6
#define unicode_TAI_VIET_LETTER_HIGH_RO                               0xAAA7
#define unicode_TAI_VIET_LETTER_LOW_LO                                0xAAA8
#define unicode_TAI_VIET_LETTER_HIGH_LO                               0xAAA9
#define unicode_TAI_VIET_LETTER_LOW_VO                                0xAAAA
#define unicode_TAI_VIET_LETTER_HIGH_VO                               0xAAAB
#define unicode_TAI_VIET_LETTER_LOW_HO                                0xAAAC
#define unicode_TAI_VIET_LETTER_HIGH_HO                               0xAAAD
#define unicode_TAI_VIET_LETTER_LOW_O                                 0xAAAE
#define unicode_TAI_VIET_LETTER_HIGH_O                                0xAAAF
#define unicode_TAI_VIET_MAI_KANG                                     0xAAB0
#define unicode_TAI_VIET_VOWEL_AA                                     0xAAB1
#define unicode_TAI_VIET_VOWEL_I                                      0xAAB2
#define unicode_TAI_VIET_VOWEL_UE                                     0xAAB3
#define unicode_TAI_VIET_VOWEL_U                                      0xAAB4
#define unicode_TAI_VIET_VOWEL_E                                      0xAAB5
#define unicode_TAI_VIET_VOWEL_O                                      0xAAB6
#define unicode_TAI_VIET_MAI_KHIT                                     0xAAB7
#define unicode_TAI_VIET_VOWEL_IA                                     0xAAB8
#define unicode_TAI_VIET_VOWEL_UEA                                    0xAAB9
#define unicode_TAI_VIET_VOWEL_UA                                     0xAABA
#define unicode_TAI_VIET_VOWEL_AUE                                    0xAABB
#define unicode_TAI_VIET_VOWEL_AY                                     0xAABC
#define unicode_TAI_VIET_VOWEL_AN                                     0xAABD
#define unicode_TAI_VIET_VOWEL_AM                                     0xAABE
#define unicode_TAI_VIET_TONE_MAI_EK                                  0xAABF
#define unicode_TAI_VIET_TONE_MAI_NUENG                               0xAAC0
#define unicode_TAI_VIET_TONE_MAI_THO                                 0xAAC1
#define unicode_TAI_VIET_TONE_MAI_SONG                                0xAAC2
#define unicode_TAI_VIET_SYMBOL_KON                                   0xAADB
#define unicode_TAI_VIET_SYMBOL_NUENG                                 0xAADC
#define unicode_TAI_VIET_SYMBOL_SAM                                   0xAADD
#define unicode_TAI_VIET_SYMBOL_HO_HOI                                0xAADE
#define unicode_TAI_VIET_SYMBOL_KOI_KOI                               0xAADF
#define unicode_MEETEI_MAYEK_LETTER_E                                 0xAAE0
#define unicode_MEETEI_MAYEK_LETTER_O                                 0xAAE1
#define unicode_MEETEI_MAYEK_LETTER_CHA                               0xAAE2
#define unicode_MEETEI_MAYEK_LETTER_NYA                               0xAAE3
#define unicode_MEETEI_MAYEK_LETTER_TTA                               0xAAE4
#define unicode_MEETEI_MAYEK_LETTER_TTHA                              0xAAE5
#define unicode_MEETEI_MAYEK_LETTER_DDA                               0xAAE6
#define unicode_MEETEI_MAYEK_LETTER_DDHA                              0xAAE7
#define unicode_MEETEI_MAYEK_LETTER_NNA                               0xAAE8
#define unicode_MEETEI_MAYEK_LETTER_SHA                               0xAAE9
#define unicode_MEETEI_MAYEK_LETTER_SSA                               0xAAEA
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_II                            0xAAEB
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_UU                            0xAAEC
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_AAI                           0xAAED
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_AU                            0xAAEE
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_AAU                           0xAAEF
#define unicode_MEETEI_MAYEK_CHEIKHAN                                 0xAAF0
#define unicode_MEETEI_MAYEK_AHANG_KHUDAM                             0xAAF1
#define unicode_MEETEI_MAYEK_ANJI                                     0xAAF2
#define unicode_MEETEI_MAYEK_SYLLABLE_REPETITION_MARK                 0xAAF3
#define unicode_MEETEI_MAYEK_WORD_REPETITION_MARK                     0xAAF4
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_VISARGA                       0xAAF5
#define unicode_MEETEI_MAYEK_VIRAMA                                   0xAAF6
#define unicode_ETHIOPIC_SYLLABLE_TTHU                                0xAB01
#define unicode_ETHIOPIC_SYLLABLE_TTHI                                0xAB02
#define unicode_ETHIOPIC_SYLLABLE_TTHAA                               0xAB03
#define unicode_ETHIOPIC_SYLLABLE_TTHEE                               0xAB04
#define unicode_ETHIOPIC_SYLLABLE_TTHE                                0xAB05
#define unicode_ETHIOPIC_SYLLABLE_TTHO                                0xAB06
#define unicode_ETHIOPIC_SYLLABLE_DDHU                                0xAB09
#define unicode_ETHIOPIC_SYLLABLE_DDHI                                0xAB0A
#define unicode_ETHIOPIC_SYLLABLE_DDHAA                               0xAB0B
#define unicode_ETHIOPIC_SYLLABLE_DDHEE                               0xAB0C
#define unicode_ETHIOPIC_SYLLABLE_DDHE                                0xAB0D
#define unicode_ETHIOPIC_SYLLABLE_DDHO                                0xAB0E
#define unicode_ETHIOPIC_SYLLABLE_DZU                                 0xAB11
#define unicode_ETHIOPIC_SYLLABLE_DZI                                 0xAB12
#define unicode_ETHIOPIC_SYLLABLE_DZAA                                0xAB13
#define unicode_ETHIOPIC_SYLLABLE_DZEE                                0xAB14
#define unicode_ETHIOPIC_SYLLABLE_DZE                                 0xAB15
#define unicode_ETHIOPIC_SYLLABLE_DZO                                 0xAB16
#define unicode_ETHIOPIC_SYLLABLE_CCHHA                               0xAB20
#define unicode_ETHIOPIC_SYLLABLE_CCHHU                               0xAB21
#define unicode_ETHIOPIC_SYLLABLE_CCHHI                               0xAB22
#define unicode_ETHIOPIC_SYLLABLE_CCHHAA                              0xAB23
#define unicode_ETHIOPIC_SYLLABLE_CCHHEE                              0xAB24
#define unicode_ETHIOPIC_SYLLABLE_CCHHE                               0xAB25
#define unicode_ETHIOPIC_SYLLABLE_CCHHO                               0xAB26
#define unicode_ETHIOPIC_SYLLABLE_BBA                                 0xAB28
#define unicode_ETHIOPIC_SYLLABLE_BBU                                 0xAB29
#define unicode_ETHIOPIC_SYLLABLE_BBI                                 0xAB2A
#define unicode_ETHIOPIC_SYLLABLE_BBAA                                0xAB2B
#define unicode_ETHIOPIC_SYLLABLE_BBEE                                0xAB2C
#define unicode_ETHIOPIC_SYLLABLE_BBE                                 0xAB2D
#define unicode_ETHIOPIC_SYLLABLE_BBO                                 0xAB2E
#define unicode_LATIN_SMALL_LETTER_BARRED_ALPHA                       0xAB30
#define unicode_LATIN_SMALL_LETTER_A_REVERSED_SCHWA                   0xAB31
#define unicode_LATIN_SMALL_LETTER_BLACKLETTER_E                      0xAB32
#define unicode_LATIN_SMALL_LETTER_BARRED_E                           0xAB33
#define unicode_LATIN_SMALL_LETTER_E_WITH_FLOURISH                    0xAB34
#define unicode_LATIN_SMALL_LETTER_LENIS_F                            0xAB35
#define unicode_LATIN_SMALL_LETTER_SCRIPT_G_WITH_CROSSED_TAIL         0xAB36
#define unicode_LATIN_SMALL_LETTER_L_WITH_INVERTED_LAZY_S             0xAB37
#define unicode_LATIN_SMALL_LETTER_L_WITH_DOUBLE_MIDDLE_TILDE         0xAB38
#define unicode_LATIN_SMALL_LETTER_L_WITH_MIDDLE_RING                 0xAB39
#define unicode_LATIN_SMALL_LETTER_M_WITH_CROSSED_TAIL                0xAB3A
#define unicode_LATIN_SMALL_LETTER_N_WITH_CROSSED_TAIL                0xAB3B
#define unicode_LATIN_SMALL_LETTER_ENG_WITH_CROSSED_TAIL              0xAB3C
#define unicode_LATIN_SMALL_LETTER_BLACKLETTER_O                      0xAB3D
#define unicode_LATIN_SMALL_LETTER_BLACKLETTER_O_WITH_STROKE          0xAB3E
#define unicode_LATIN_SMALL_LETTER_OPEN_O_WITH_STROKE                 0xAB3F
#define unicode_LATIN_SMALL_LETTER_INVERTED_OE                        0xAB40
#define unicode_LATIN_SMALL_LETTER_TURNED_OE_WITH_STROKE              0xAB41
#define unicode_LATIN_SMALL_LETTER_TURNED_OE_WITH_HORIZONTAL_STROKE   0xAB42
#define unicode_LATIN_SMALL_LETTER_TURNED_O_OPEN_O                    0xAB43
#define unicode_LATIN_SMALL_LETTER_TURNED_O_OPEN_O_WITH_STROKE        0xAB44
#define unicode_LATIN_SMALL_LETTER_STIRRUP_R                          0xAB45
#define unicode_LATIN_LETTER_SMALL_CAPITAL_R_WITH_RIGHT_LEG           0xAB46
#define unicode_LATIN_SMALL_LETTER_R_WITHOUT_HANDLE                   0xAB47
#define unicode_LATIN_SMALL_LETTER_DOUBLE_R                           0xAB48
#define unicode_LATIN_SMALL_LETTER_R_WITH_CROSSED_TAIL                0xAB49
#define unicode_LATIN_SMALL_LETTER_DOUBLE_R_WITH_CROSSED_TAIL         0xAB4A
#define unicode_LATIN_SMALL_LETTER_SCRIPT_R                           0xAB4B
#define unicode_LATIN_SMALL_LETTER_SCRIPT_R_WITH_RING                 0xAB4C
#define unicode_LATIN_SMALL_LETTER_BASELINE_ESH                       0xAB4D
#define unicode_LATIN_SMALL_LETTER_U_WITH_SHORT_RIGHT_LEG             0xAB4E
#define unicode_LATIN_SMALL_LETTER_U_BAR_WITH_SHORT_RIGHT_LEG         0xAB4F
#define unicode_LATIN_SMALL_LETTER_UI                                 0xAB50
#define unicode_LATIN_SMALL_LETTER_TURNED_UI                          0xAB51
#define unicode_LATIN_SMALL_LETTER_U_WITH_LEFT_HOOK                   0xAB52
#define unicode_LATIN_SMALL_LETTER_CHI                                0xAB53
#define unicode_LATIN_SMALL_LETTER_CHI_WITH_LOW_RIGHT_RING            0xAB54
#define unicode_LATIN_SMALL_LETTER_CHI_WITH_LOW_LEFT_SERIF            0xAB55
#define unicode_LATIN_SMALL_LETTER_X_WITH_LOW_RIGHT_RING              0xAB56
#define unicode_LATIN_SMALL_LETTER_X_WITH_LONG_LEFT_LEG               0xAB57
#define unicode_LATIN_SMALL_LETTER_X_WITH_LONG_LEFT_LEG_AND_LOW_RIGHT_RING 0xAB58
#define unicode_LATIN_SMALL_LETTER_X_WITH_LONG_LEFT_LEG_WITH_SERIF    0xAB59
#define unicode_LATIN_SMALL_LETTER_Y_WITH_SHORT_RIGHT_LEG             0xAB5A
#define unicode_MODIFIER_BREVE_WITH_INVERTED_BREVE                    0xAB5B
#define unicode_MODIFIER_LETTER_SMALL_HENG                            0xAB5C
#define unicode_MODIFIER_LETTER_SMALL_L_WITH_INVERTED_LAZY_S          0xAB5D
#define unicode_MODIFIER_LETTER_SMALL_L_WITH_MIDDLE_TILDE             0xAB5E
#define unicode_MODIFIER_LETTER_SMALL_U_WITH_LEFT_HOOK                0xAB5F
#define unicode_LATIN_SMALL_LETTER_INVERTED_ALPHA                     0xAB64
#define unicode_GREEK_LETTER_SMALL_CAPITAL_OMEGA                      0xAB65
#define unicode_MEETEI_MAYEK_LETTER_KOK                               0xABC0
#define unicode_MEETEI_MAYEK_LETTER_SAM                               0xABC1
#define unicode_MEETEI_MAYEK_LETTER_LAI                               0xABC2
#define unicode_MEETEI_MAYEK_LETTER_MIT                               0xABC3
#define unicode_MEETEI_MAYEK_LETTER_PA                                0xABC4
#define unicode_MEETEI_MAYEK_LETTER_NA                                0xABC5
#define unicode_MEETEI_MAYEK_LETTER_CHIL                              0xABC6
#define unicode_MEETEI_MAYEK_LETTER_TIL                               0xABC7
#define unicode_MEETEI_MAYEK_LETTER_KHOU                              0xABC8
#define unicode_MEETEI_MAYEK_LETTER_NGOU                              0xABC9
#define unicode_MEETEI_MAYEK_LETTER_THOU                              0xABCA
#define unicode_MEETEI_MAYEK_LETTER_WAI                               0xABCB
#define unicode_MEETEI_MAYEK_LETTER_YANG                              0xABCC
#define unicode_MEETEI_MAYEK_LETTER_HUK                               0xABCD
#define unicode_MEETEI_MAYEK_LETTER_UN                                0xABCE
#define unicode_MEETEI_MAYEK_LETTER_I                                 0xABCF
#define unicode_MEETEI_MAYEK_LETTER_PHAM                              0xABD0
#define unicode_MEETEI_MAYEK_LETTER_ATIYA                             0xABD1
#define unicode_MEETEI_MAYEK_LETTER_GOK                               0xABD2
#define unicode_MEETEI_MAYEK_LETTER_JHAM                              0xABD3
#define unicode_MEETEI_MAYEK_LETTER_RAI                               0xABD4
#define unicode_MEETEI_MAYEK_LETTER_BA                                0xABD5
#define unicode_MEETEI_MAYEK_LETTER_JIL                               0xABD6
#define unicode_MEETEI_MAYEK_LETTER_DIL                               0xABD7
#define unicode_MEETEI_MAYEK_LETTER_GHOU                              0xABD8
#define unicode_MEETEI_MAYEK_LETTER_DHOU                              0xABD9
#define unicode_MEETEI_MAYEK_LETTER_BHAM                              0xABDA
#define unicode_MEETEI_MAYEK_LETTER_KOK_LONSUM                        0xABDB
#define unicode_MEETEI_MAYEK_LETTER_LAI_LONSUM                        0xABDC
#define unicode_MEETEI_MAYEK_LETTER_MIT_LONSUM                        0xABDD
#define unicode_MEETEI_MAYEK_LETTER_PA_LONSUM                         0xABDE
#define unicode_MEETEI_MAYEK_LETTER_NA_LONSUM                         0xABDF
#define unicode_MEETEI_MAYEK_LETTER_TIL_LONSUM                        0xABE0
#define unicode_MEETEI_MAYEK_LETTER_NGOU_LONSUM                       0xABE1
#define unicode_MEETEI_MAYEK_LETTER_I_LONSUM                          0xABE2
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_ONAP                          0xABE3
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_INAP                          0xABE4
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_ANAP                          0xABE5
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_YENAP                         0xABE6
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_SOUNAP                        0xABE7
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_UNAP                          0xABE8
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_CHEINAP                       0xABE9
#define unicode_MEETEI_MAYEK_VOWEL_SIGN_NUNG                          0xABEA
#define unicode_MEETEI_MAYEK_CHEIKHEI                                 0xABEB
#define unicode_MEETEI_MAYEK_LUM_IYEK                                 0xABEC
#define unicode_MEETEI_MAYEK_APUN_IYEK                                0xABED
#define unicode_MEETEI_MAYEK_DIGIT_ZERO                               0xABF0
#define unicode_MEETEI_MAYEK_DIGIT_ONE                                0xABF1
#define unicode_MEETEI_MAYEK_DIGIT_TWO                                0xABF2
#define unicode_MEETEI_MAYEK_DIGIT_THREE                              0xABF3
#define unicode_MEETEI_MAYEK_DIGIT_FOUR                               0xABF4
#define unicode_MEETEI_MAYEK_DIGIT_FIVE                               0xABF5
#define unicode_MEETEI_MAYEK_DIGIT_SIX                                0xABF6
#define unicode_MEETEI_MAYEK_DIGIT_SEVEN                              0xABF7
#define unicode_MEETEI_MAYEK_DIGIT_EIGHT                              0xABF8
#define unicode_MEETEI_MAYEK_DIGIT_NINE                               0xABF9
#define unicode_Hangul_Syllable__First                                0xAC00
#define unicode_Hangul_Syllable__Last                                 0xD7A3
#define unicode_HANGUL_JUNGSEONG_O_YEO                                0xD7B0
#define unicode_HANGUL_JUNGSEONG_O_O_I                                0xD7B1
#define unicode_HANGUL_JUNGSEONG_YO_A                                 0xD7B2
#define unicode_HANGUL_JUNGSEONG_YO_AE                                0xD7B3
#define unicode_HANGUL_JUNGSEONG_YO_EO                                0xD7B4
#define unicode_HANGUL_JUNGSEONG_U_YEO                                0xD7B5
#define unicode_HANGUL_JUNGSEONG_U_I_I                                0xD7B6
#define unicode_HANGUL_JUNGSEONG_YU_AE                                0xD7B7
#define unicode_HANGUL_JUNGSEONG_YU_O                                 0xD7B8
#define unicode_HANGUL_JUNGSEONG_EU_A                                 0xD7B9
#define unicode_HANGUL_JUNGSEONG_EU_EO                                0xD7BA
#define unicode_HANGUL_JUNGSEONG_EU_E                                 0xD7BB
#define unicode_HANGUL_JUNGSEONG_EU_O                                 0xD7BC
#define unicode_HANGUL_JUNGSEONG_I_YA_O                               0xD7BD
#define unicode_HANGUL_JUNGSEONG_I_YAE                                0xD7BE
#define unicode_HANGUL_JUNGSEONG_I_YEO                                0xD7BF
#define unicode_HANGUL_JUNGSEONG_I_YE                                 0xD7C0
#define unicode_HANGUL_JUNGSEONG_I_O_I                                0xD7C1
#define unicode_HANGUL_JUNGSEONG_I_YO                                 0xD7C2
#define unicode_HANGUL_JUNGSEONG_I_YU                                 0xD7C3
#define unicode_HANGUL_JUNGSEONG_I_I                                  0xD7C4
#define unicode_HANGUL_JUNGSEONG_ARAEA_A                              0xD7C5
#define unicode_HANGUL_JUNGSEONG_ARAEA_E                              0xD7C6
#define unicode_HANGUL_JONGSEONG_NIEUN_RIEUL                          0xD7CB
#define unicode_HANGUL_JONGSEONG_NIEUN_CHIEUCH                        0xD7CC
#define unicode_HANGUL_JONGSEONG_SSANGTIKEUT                          0xD7CD
#define unicode_HANGUL_JONGSEONG_SSANGTIKEUT_PIEUP                    0xD7CE
#define unicode_HANGUL_JONGSEONG_TIKEUT_PIEUP                         0xD7CF
#define unicode_HANGUL_JONGSEONG_TIKEUT_SIOS                          0xD7D0
#define unicode_HANGUL_JONGSEONG_TIKEUT_SIOS_KIYEOK                   0xD7D1
#define unicode_HANGUL_JONGSEONG_TIKEUT_CIEUC                         0xD7D2
#define unicode_HANGUL_JONGSEONG_TIKEUT_CHIEUCH                       0xD7D3
#define unicode_HANGUL_JONGSEONG_TIKEUT_THIEUTH                       0xD7D4
#define unicode_HANGUL_JONGSEONG_RIEUL_SSANGKIYEOK                    0xD7D5
#define unicode_HANGUL_JONGSEONG_RIEUL_KIYEOK_HIEUH                   0xD7D6
#define unicode_HANGUL_JONGSEONG_SSANGRIEUL_KHIEUKH                   0xD7D7
#define unicode_HANGUL_JONGSEONG_RIEUL_MIEUM_HIEUH                    0xD7D8
#define unicode_HANGUL_JONGSEONG_RIEUL_PIEUP_TIKEUT                   0xD7D9
#define unicode_HANGUL_JONGSEONG_RIEUL_PIEUP_PHIEUPH                  0xD7DA
#define unicode_HANGUL_JONGSEONG_RIEUL_YESIEUNG                       0xD7DB
#define unicode_HANGUL_JONGSEONG_RIEUL_YEORINHIEUH_HIEUH              0xD7DC
#define unicode_HANGUL_JONGSEONG_KAPYEOUNRIEUL                        0xD7DD
#define unicode_HANGUL_JONGSEONG_MIEUM_NIEUN                          0xD7DE
#define unicode_HANGUL_JONGSEONG_MIEUM_SSANGNIEUN                     0xD7DF
#define unicode_HANGUL_JONGSEONG_SSANGMIEUM                           0xD7E0
#define unicode_HANGUL_JONGSEONG_MIEUM_PIEUP_SIOS                     0xD7E1
#define unicode_HANGUL_JONGSEONG_MIEUM_CIEUC                          0xD7E2
#define unicode_HANGUL_JONGSEONG_PIEUP_TIKEUT                         0xD7E3
#define unicode_HANGUL_JONGSEONG_PIEUP_RIEUL_PHIEUPH                  0xD7E4
#define unicode_HANGUL_JONGSEONG_PIEUP_MIEUM                          0xD7E5
#define unicode_HANGUL_JONGSEONG_SSANGPIEUP                           0xD7E6
#define unicode_HANGUL_JONGSEONG_PIEUP_SIOS_TIKEUT                    0xD7E7
#define unicode_HANGUL_JONGSEONG_PIEUP_CIEUC                          0xD7E8
#define unicode_HANGUL_JONGSEONG_PIEUP_CHIEUCH                        0xD7E9
#define unicode_HANGUL_JONGSEONG_SIOS_MIEUM                           0xD7EA
#define unicode_HANGUL_JONGSEONG_SIOS_KAPYEOUNPIEUP                   0xD7EB
#define unicode_HANGUL_JONGSEONG_SSANGSIOS_KIYEOK                     0xD7EC
#define unicode_HANGUL_JONGSEONG_SSANGSIOS_TIKEUT                     0xD7ED
#define unicode_HANGUL_JONGSEONG_SIOS_PANSIOS                         0xD7EE
#define unicode_HANGUL_JONGSEONG_SIOS_CIEUC                           0xD7EF
#define unicode_HANGUL_JONGSEONG_SIOS_CHIEUCH                         0xD7F0
#define unicode_HANGUL_JONGSEONG_SIOS_THIEUTH                         0xD7F1
#define unicode_HANGUL_JONGSEONG_SIOS_HIEUH                           0xD7F2
#define unicode_HANGUL_JONGSEONG_PANSIOS_PIEUP                        0xD7F3
#define unicode_HANGUL_JONGSEONG_PANSIOS_KAPYEOUNPIEUP                0xD7F4
#define unicode_HANGUL_JONGSEONG_YESIEUNG_MIEUM                       0xD7F5
#define unicode_HANGUL_JONGSEONG_YESIEUNG_HIEUH                       0xD7F6
#define unicode_HANGUL_JONGSEONG_CIEUC_PIEUP                          0xD7F7
#define unicode_HANGUL_JONGSEONG_CIEUC_SSANGPIEUP                     0xD7F8
#define unicode_HANGUL_JONGSEONG_SSANGCIEUC                           0xD7F9
#define unicode_HANGUL_JONGSEONG_PHIEUPH_SIOS                         0xD7FA
#define unicode_HANGUL_JONGSEONG_PHIEUPH_THIEUTH                      0xD7FB
#define unicode_Non_Private_Use_High_Surrogate__First                 0xD800
#define unicode_Non_Private_Use_High_Surrogate__Last                  0xDB7F
#define unicode_Private_Use_High_Surrogate__First                     0xDB80
#define unicode_Private_Use_High_Surrogate__Last                      0xDBFF
#define unicode_Low_Surrogate__First                                  0xDC00
#define unicode_Low_Surrogate__Last                                   0xDFFF
#define unicode_Private_Use__First                                    0xE000
#define unicode_Private_Use__Last                                     0xF8FF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F900                      0xF900
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F901                      0xF901
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F902                      0xF902
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F903                      0xF903
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F904                      0xF904
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F905                      0xF905
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F906                      0xF906
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F907                      0xF907
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F908                      0xF908
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F909                      0xF909
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F90A                      0xF90A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F90B                      0xF90B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F90C                      0xF90C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F90D                      0xF90D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F90E                      0xF90E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F90F                      0xF90F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F910                      0xF910
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F911                      0xF911
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F912                      0xF912
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F913                      0xF913
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F914                      0xF914
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F915                      0xF915
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F916                      0xF916
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F917                      0xF917
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F918                      0xF918
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F919                      0xF919
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F91A                      0xF91A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F91B                      0xF91B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F91C                      0xF91C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F91D                      0xF91D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F91E                      0xF91E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F91F                      0xF91F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F920                      0xF920
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F921                      0xF921
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F922                      0xF922
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F923                      0xF923
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F924                      0xF924
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F925                      0xF925
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F926                      0xF926
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F927                      0xF927
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F928                      0xF928
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F929                      0xF929
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F92A                      0xF92A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F92B                      0xF92B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F92C                      0xF92C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F92D                      0xF92D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F92E                      0xF92E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F92F                      0xF92F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F930                      0xF930
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F931                      0xF931
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F932                      0xF932
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F933                      0xF933
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F934                      0xF934
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F935                      0xF935
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F936                      0xF936
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F937                      0xF937
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F938                      0xF938
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F939                      0xF939
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F93A                      0xF93A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F93B                      0xF93B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F93C                      0xF93C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F93D                      0xF93D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F93E                      0xF93E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F93F                      0xF93F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F940                      0xF940
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F941                      0xF941
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F942                      0xF942
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F943                      0xF943
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F944                      0xF944
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F945                      0xF945
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F946                      0xF946
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F947                      0xF947
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F948                      0xF948
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F949                      0xF949
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F94A                      0xF94A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F94B                      0xF94B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F94C                      0xF94C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F94D                      0xF94D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F94E                      0xF94E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F94F                      0xF94F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F950                      0xF950
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F951                      0xF951
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F952                      0xF952
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F953                      0xF953
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F954                      0xF954
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F955                      0xF955
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F956                      0xF956
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F957                      0xF957
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F958                      0xF958
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F959                      0xF959
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F95A                      0xF95A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F95B                      0xF95B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F95C                      0xF95C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F95D                      0xF95D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F95E                      0xF95E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F95F                      0xF95F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F960                      0xF960
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F961                      0xF961
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F962                      0xF962
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F963                      0xF963
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F964                      0xF964
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F965                      0xF965
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F966                      0xF966
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F967                      0xF967
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F968                      0xF968
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F969                      0xF969
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F96A                      0xF96A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F96B                      0xF96B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F96C                      0xF96C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F96D                      0xF96D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F96E                      0xF96E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F96F                      0xF96F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F970                      0xF970
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F971                      0xF971
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F972                      0xF972
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F973                      0xF973
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F974                      0xF974
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F975                      0xF975
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F976                      0xF976
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F977                      0xF977
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F978                      0xF978
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F979                      0xF979
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F97A                      0xF97A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F97B                      0xF97B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F97C                      0xF97C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F97D                      0xF97D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F97E                      0xF97E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F97F                      0xF97F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F980                      0xF980
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F981                      0xF981
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F982                      0xF982
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F983                      0xF983
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F984                      0xF984
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F985                      0xF985
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F986                      0xF986
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F987                      0xF987
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F988                      0xF988
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F989                      0xF989
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F98A                      0xF98A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F98B                      0xF98B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F98C                      0xF98C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F98D                      0xF98D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F98E                      0xF98E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F98F                      0xF98F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F990                      0xF990
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F991                      0xF991
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F992                      0xF992
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F993                      0xF993
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F994                      0xF994
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F995                      0xF995
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F996                      0xF996
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F997                      0xF997
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F998                      0xF998
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F999                      0xF999
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F99A                      0xF99A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F99B                      0xF99B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F99C                      0xF99C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F99D                      0xF99D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F99E                      0xF99E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F99F                      0xF99F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9A0                      0xF9A0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9A1                      0xF9A1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9A2                      0xF9A2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9A3                      0xF9A3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9A4                      0xF9A4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9A5                      0xF9A5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9A6                      0xF9A6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9A7                      0xF9A7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9A8                      0xF9A8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9A9                      0xF9A9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9AA                      0xF9AA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9AB                      0xF9AB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9AC                      0xF9AC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9AD                      0xF9AD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9AE                      0xF9AE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9AF                      0xF9AF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9B0                      0xF9B0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9B1                      0xF9B1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9B2                      0xF9B2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9B3                      0xF9B3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9B4                      0xF9B4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9B5                      0xF9B5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9B6                      0xF9B6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9B7                      0xF9B7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9B8                      0xF9B8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9B9                      0xF9B9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9BA                      0xF9BA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9BB                      0xF9BB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9BC                      0xF9BC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9BD                      0xF9BD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9BE                      0xF9BE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9BF                      0xF9BF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9C0                      0xF9C0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9C1                      0xF9C1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9C2                      0xF9C2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9C3                      0xF9C3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9C4                      0xF9C4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9C5                      0xF9C5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9C6                      0xF9C6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9C7                      0xF9C7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9C8                      0xF9C8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9C9                      0xF9C9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9CA                      0xF9CA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9CB                      0xF9CB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9CC                      0xF9CC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9CD                      0xF9CD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9CE                      0xF9CE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9CF                      0xF9CF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9D0                      0xF9D0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9D1                      0xF9D1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9D2                      0xF9D2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9D3                      0xF9D3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9D4                      0xF9D4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9D5                      0xF9D5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9D6                      0xF9D6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9D7                      0xF9D7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9D8                      0xF9D8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9D9                      0xF9D9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9DA                      0xF9DA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9DB                      0xF9DB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9DC                      0xF9DC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9DD                      0xF9DD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9DE                      0xF9DE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9DF                      0xF9DF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9E0                      0xF9E0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9E1                      0xF9E1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9E2                      0xF9E2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9E3                      0xF9E3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9E4                      0xF9E4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9E5                      0xF9E5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9E6                      0xF9E6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9E7                      0xF9E7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9E8                      0xF9E8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9E9                      0xF9E9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9EA                      0xF9EA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9EB                      0xF9EB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9EC                      0xF9EC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9ED                      0xF9ED
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9EE                      0xF9EE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9EF                      0xF9EF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9F0                      0xF9F0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9F1                      0xF9F1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9F2                      0xF9F2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9F3                      0xF9F3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9F4                      0xF9F4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9F5                      0xF9F5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9F6                      0xF9F6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9F7                      0xF9F7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9F8                      0xF9F8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9F9                      0xF9F9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9FA                      0xF9FA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9FB                      0xF9FB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9FC                      0xF9FC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9FD                      0xF9FD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9FE                      0xF9FE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_F9FF                      0xF9FF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA00                      0xFA00
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA01                      0xFA01
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA02                      0xFA02
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA03                      0xFA03
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA04                      0xFA04
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA05                      0xFA05
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA06                      0xFA06
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA07                      0xFA07
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA08                      0xFA08
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA09                      0xFA09
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA0A                      0xFA0A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA0B                      0xFA0B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA0C                      0xFA0C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA0D                      0xFA0D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA0E                      0xFA0E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA0F                      0xFA0F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA10                      0xFA10
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA11                      0xFA11
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA12                      0xFA12
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA13                      0xFA13
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA14                      0xFA14
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA15                      0xFA15
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA16                      0xFA16
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA17                      0xFA17
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA18                      0xFA18
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA19                      0xFA19
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA1A                      0xFA1A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA1B                      0xFA1B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA1C                      0xFA1C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA1D                      0xFA1D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA1E                      0xFA1E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA1F                      0xFA1F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA20                      0xFA20
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA21                      0xFA21
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA22                      0xFA22
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA23                      0xFA23
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA24                      0xFA24
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA25                      0xFA25
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA26                      0xFA26
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA27                      0xFA27
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA28                      0xFA28
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA29                      0xFA29
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA2A                      0xFA2A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA2B                      0xFA2B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA2C                      0xFA2C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA2D                      0xFA2D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA2E                      0xFA2E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA2F                      0xFA2F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA30                      0xFA30
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA31                      0xFA31
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA32                      0xFA32
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA33                      0xFA33
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA34                      0xFA34
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA35                      0xFA35
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA36                      0xFA36
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA37                      0xFA37
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA38                      0xFA38
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA39                      0xFA39
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA3A                      0xFA3A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA3B                      0xFA3B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA3C                      0xFA3C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA3D                      0xFA3D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA3E                      0xFA3E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA3F                      0xFA3F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA40                      0xFA40
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA41                      0xFA41
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA42                      0xFA42
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA43                      0xFA43
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA44                      0xFA44
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA45                      0xFA45
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA46                      0xFA46
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA47                      0xFA47
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA48                      0xFA48
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA49                      0xFA49
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA4A                      0xFA4A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA4B                      0xFA4B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA4C                      0xFA4C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA4D                      0xFA4D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA4E                      0xFA4E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA4F                      0xFA4F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA50                      0xFA50
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA51                      0xFA51
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA52                      0xFA52
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA53                      0xFA53
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA54                      0xFA54
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA55                      0xFA55
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA56                      0xFA56
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA57                      0xFA57
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA58                      0xFA58
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA59                      0xFA59
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA5A                      0xFA5A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA5B                      0xFA5B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA5C                      0xFA5C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA5D                      0xFA5D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA5E                      0xFA5E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA5F                      0xFA5F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA60                      0xFA60
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA61                      0xFA61
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA62                      0xFA62
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA63                      0xFA63
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA64                      0xFA64
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA65                      0xFA65
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA66                      0xFA66
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA67                      0xFA67
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA68                      0xFA68
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA69                      0xFA69
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA6A                      0xFA6A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA6B                      0xFA6B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA6C                      0xFA6C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA6D                      0xFA6D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA70                      0xFA70
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA71                      0xFA71
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA72                      0xFA72
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA73                      0xFA73
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA74                      0xFA74
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA75                      0xFA75
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA76                      0xFA76
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA77                      0xFA77
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA78                      0xFA78
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA79                      0xFA79
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA7A                      0xFA7A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA7B                      0xFA7B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA7C                      0xFA7C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA7D                      0xFA7D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA7E                      0xFA7E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA7F                      0xFA7F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA80                      0xFA80
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA81                      0xFA81
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA82                      0xFA82
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA83                      0xFA83
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA84                      0xFA84
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA85                      0xFA85
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA86                      0xFA86
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA87                      0xFA87
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA88                      0xFA88
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA89                      0xFA89
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA8A                      0xFA8A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA8B                      0xFA8B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA8C                      0xFA8C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA8D                      0xFA8D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA8E                      0xFA8E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA8F                      0xFA8F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA90                      0xFA90
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA91                      0xFA91
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA92                      0xFA92
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA93                      0xFA93
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA94                      0xFA94
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA95                      0xFA95
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA96                      0xFA96
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA97                      0xFA97
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA98                      0xFA98
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA99                      0xFA99
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA9A                      0xFA9A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA9B                      0xFA9B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA9C                      0xFA9C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA9D                      0xFA9D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA9E                      0xFA9E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FA9F                      0xFA9F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAA0                      0xFAA0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAA1                      0xFAA1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAA2                      0xFAA2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAA3                      0xFAA3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAA4                      0xFAA4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAA5                      0xFAA5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAA6                      0xFAA6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAA7                      0xFAA7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAA8                      0xFAA8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAA9                      0xFAA9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAAA                      0xFAAA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAAB                      0xFAAB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAAC                      0xFAAC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAAD                      0xFAAD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAAE                      0xFAAE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAAF                      0xFAAF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAB0                      0xFAB0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAB1                      0xFAB1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAB2                      0xFAB2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAB3                      0xFAB3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAB4                      0xFAB4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAB5                      0xFAB5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAB6                      0xFAB6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAB7                      0xFAB7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAB8                      0xFAB8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAB9                      0xFAB9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FABA                      0xFABA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FABB                      0xFABB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FABC                      0xFABC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FABD                      0xFABD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FABE                      0xFABE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FABF                      0xFABF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAC0                      0xFAC0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAC1                      0xFAC1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAC2                      0xFAC2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAC3                      0xFAC3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAC4                      0xFAC4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAC5                      0xFAC5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAC6                      0xFAC6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAC7                      0xFAC7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAC8                      0xFAC8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAC9                      0xFAC9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FACA                      0xFACA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FACB                      0xFACB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FACC                      0xFACC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FACD                      0xFACD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FACE                      0xFACE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FACF                      0xFACF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAD0                      0xFAD0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAD1                      0xFAD1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAD2                      0xFAD2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAD3                      0xFAD3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAD4                      0xFAD4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAD5                      0xFAD5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAD6                      0xFAD6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAD7                      0xFAD7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAD8                      0xFAD8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_FAD9                      0xFAD9
#define unicode_LATIN_SMALL_LIGATURE_FF                               0xFB00
#define unicode_LATIN_SMALL_LIGATURE_FI                               0xFB01
#define unicode_LATIN_SMALL_LIGATURE_FL                               0xFB02
#define unicode_LATIN_SMALL_LIGATURE_FFI                              0xFB03
#define unicode_LATIN_SMALL_LIGATURE_FFL                              0xFB04
#define unicode_LATIN_SMALL_LIGATURE_LONG_S_T                         0xFB05
#define unicode_LATIN_SMALL_LIGATURE_ST                               0xFB06
#define unicode_ARMENIAN_SMALL_LIGATURE_MEN_NOW                       0xFB13
#define unicode_ARMENIAN_SMALL_LIGATURE_MEN_ECH                       0xFB14
#define unicode_ARMENIAN_SMALL_LIGATURE_MEN_INI                       0xFB15
#define unicode_ARMENIAN_SMALL_LIGATURE_VEW_NOW                       0xFB16
#define unicode_ARMENIAN_SMALL_LIGATURE_MEN_XEH                       0xFB17
#define unicode_HEBREW_LETTER_YOD_WITH_HIRIQ                          0xFB1D
#define unicode_HEBREW_POINT_JUDEO_SPANISH_VARIKA                     0xFB1E
#define unicode_HEBREW_LIGATURE_YIDDISH_YOD_YOD_PATAH                 0xFB1F
#define unicode_HEBREW_LETTER_ALTERNATIVE_AYIN                        0xFB20
#define unicode_HEBREW_LETTER_WIDE_ALEF                               0xFB21
#define unicode_HEBREW_LETTER_WIDE_DALET                              0xFB22
#define unicode_HEBREW_LETTER_WIDE_HE                                 0xFB23
#define unicode_HEBREW_LETTER_WIDE_KAF                                0xFB24
#define unicode_HEBREW_LETTER_WIDE_LAMED                              0xFB25
#define unicode_HEBREW_LETTER_WIDE_FINAL_MEM                          0xFB26
#define unicode_HEBREW_LETTER_WIDE_RESH                               0xFB27
#define unicode_HEBREW_LETTER_WIDE_TAV                                0xFB28
#define unicode_HEBREW_LETTER_ALTERNATIVE_PLUS_SIGN                   0xFB29
#define unicode_HEBREW_LETTER_SHIN_WITH_SHIN_DOT                      0xFB2A
#define unicode_HEBREW_LETTER_SHIN_WITH_SIN_DOT                       0xFB2B
#define unicode_HEBREW_LETTER_SHIN_WITH_DAGESH_AND_SHIN_DOT           0xFB2C
#define unicode_HEBREW_LETTER_SHIN_WITH_DAGESH_AND_SIN_DOT            0xFB2D
#define unicode_HEBREW_LETTER_ALEF_WITH_PATAH                         0xFB2E
#define unicode_HEBREW_LETTER_ALEF_WITH_QAMATS                        0xFB2F
#define unicode_HEBREW_LETTER_ALEF_WITH_MAPIQ                         0xFB30
#define unicode_HEBREW_LETTER_BET_WITH_DAGESH                         0xFB31
#define unicode_HEBREW_LETTER_GIMEL_WITH_DAGESH                       0xFB32
#define unicode_HEBREW_LETTER_DALET_WITH_DAGESH                       0xFB33
#define unicode_HEBREW_LETTER_HE_WITH_MAPIQ                           0xFB34
#define unicode_HEBREW_LETTER_VAV_WITH_DAGESH                         0xFB35
#define unicode_HEBREW_LETTER_ZAYIN_WITH_DAGESH                       0xFB36
#define unicode_HEBREW_LETTER_TET_WITH_DAGESH                         0xFB38
#define unicode_HEBREW_LETTER_YOD_WITH_DAGESH                         0xFB39
#define unicode_HEBREW_LETTER_FINAL_KAF_WITH_DAGESH                   0xFB3A
#define unicode_HEBREW_LETTER_KAF_WITH_DAGESH                         0xFB3B
#define unicode_HEBREW_LETTER_LAMED_WITH_DAGESH                       0xFB3C
#define unicode_HEBREW_LETTER_MEM_WITH_DAGESH                         0xFB3E
#define unicode_HEBREW_LETTER_NUN_WITH_DAGESH                         0xFB40
#define unicode_HEBREW_LETTER_SAMEKH_WITH_DAGESH                      0xFB41
#define unicode_HEBREW_LETTER_FINAL_PE_WITH_DAGESH                    0xFB43
#define unicode_HEBREW_LETTER_PE_WITH_DAGESH                          0xFB44
#define unicode_HEBREW_LETTER_TSADI_WITH_DAGESH                       0xFB46
#define unicode_HEBREW_LETTER_QOF_WITH_DAGESH                         0xFB47
#define unicode_HEBREW_LETTER_RESH_WITH_DAGESH                        0xFB48
#define unicode_HEBREW_LETTER_SHIN_WITH_DAGESH                        0xFB49
#define unicode_HEBREW_LETTER_TAV_WITH_DAGESH                         0xFB4A
#define unicode_HEBREW_LETTER_VAV_WITH_HOLAM                          0xFB4B
#define unicode_HEBREW_LETTER_BET_WITH_RAFE                           0xFB4C
#define unicode_HEBREW_LETTER_KAF_WITH_RAFE                           0xFB4D
#define unicode_HEBREW_LETTER_PE_WITH_RAFE                            0xFB4E
#define unicode_HEBREW_LIGATURE_ALEF_LAMED                            0xFB4F
#define unicode_ARABIC_LETTER_ALEF_WASLA_ISOLATED_FORM                0xFB50
#define unicode_ARABIC_LETTER_ALEF_WASLA_FINAL_FORM                   0xFB51
#define unicode_ARABIC_LETTER_BEEH_ISOLATED_FORM                      0xFB52
#define unicode_ARABIC_LETTER_BEEH_FINAL_FORM                         0xFB53
#define unicode_ARABIC_LETTER_BEEH_INITIAL_FORM                       0xFB54
#define unicode_ARABIC_LETTER_BEEH_MEDIAL_FORM                        0xFB55
#define unicode_ARABIC_LETTER_PEH_ISOLATED_FORM                       0xFB56
#define unicode_ARABIC_LETTER_PEH_FINAL_FORM                          0xFB57
#define unicode_ARABIC_LETTER_PEH_INITIAL_FORM                        0xFB58
#define unicode_ARABIC_LETTER_PEH_MEDIAL_FORM                         0xFB59
#define unicode_ARABIC_LETTER_BEHEH_ISOLATED_FORM                     0xFB5A
#define unicode_ARABIC_LETTER_BEHEH_FINAL_FORM                        0xFB5B
#define unicode_ARABIC_LETTER_BEHEH_INITIAL_FORM                      0xFB5C
#define unicode_ARABIC_LETTER_BEHEH_MEDIAL_FORM                       0xFB5D
#define unicode_ARABIC_LETTER_TTEHEH_ISOLATED_FORM                    0xFB5E
#define unicode_ARABIC_LETTER_TTEHEH_FINAL_FORM                       0xFB5F
#define unicode_ARABIC_LETTER_TTEHEH_INITIAL_FORM                     0xFB60
#define unicode_ARABIC_LETTER_TTEHEH_MEDIAL_FORM                      0xFB61
#define unicode_ARABIC_LETTER_TEHEH_ISOLATED_FORM                     0xFB62
#define unicode_ARABIC_LETTER_TEHEH_FINAL_FORM                        0xFB63
#define unicode_ARABIC_LETTER_TEHEH_INITIAL_FORM                      0xFB64
#define unicode_ARABIC_LETTER_TEHEH_MEDIAL_FORM                       0xFB65
#define unicode_ARABIC_LETTER_TTEH_ISOLATED_FORM                      0xFB66
#define unicode_ARABIC_LETTER_TTEH_FINAL_FORM                         0xFB67
#define unicode_ARABIC_LETTER_TTEH_INITIAL_FORM                       0xFB68
#define unicode_ARABIC_LETTER_TTEH_MEDIAL_FORM                        0xFB69
#define unicode_ARABIC_LETTER_VEH_ISOLATED_FORM                       0xFB6A
#define unicode_ARABIC_LETTER_VEH_FINAL_FORM                          0xFB6B
#define unicode_ARABIC_LETTER_VEH_INITIAL_FORM                        0xFB6C
#define unicode_ARABIC_LETTER_VEH_MEDIAL_FORM                         0xFB6D
#define unicode_ARABIC_LETTER_PEHEH_ISOLATED_FORM                     0xFB6E
#define unicode_ARABIC_LETTER_PEHEH_FINAL_FORM                        0xFB6F
#define unicode_ARABIC_LETTER_PEHEH_INITIAL_FORM                      0xFB70
#define unicode_ARABIC_LETTER_PEHEH_MEDIAL_FORM                       0xFB71
#define unicode_ARABIC_LETTER_DYEH_ISOLATED_FORM                      0xFB72
#define unicode_ARABIC_LETTER_DYEH_FINAL_FORM                         0xFB73
#define unicode_ARABIC_LETTER_DYEH_INITIAL_FORM                       0xFB74
#define unicode_ARABIC_LETTER_DYEH_MEDIAL_FORM                        0xFB75
#define unicode_ARABIC_LETTER_NYEH_ISOLATED_FORM                      0xFB76
#define unicode_ARABIC_LETTER_NYEH_FINAL_FORM                         0xFB77
#define unicode_ARABIC_LETTER_NYEH_INITIAL_FORM                       0xFB78
#define unicode_ARABIC_LETTER_NYEH_MEDIAL_FORM                        0xFB79
#define unicode_ARABIC_LETTER_TCHEH_ISOLATED_FORM                     0xFB7A
#define unicode_ARABIC_LETTER_TCHEH_FINAL_FORM                        0xFB7B
#define unicode_ARABIC_LETTER_TCHEH_INITIAL_FORM                      0xFB7C
#define unicode_ARABIC_LETTER_TCHEH_MEDIAL_FORM                       0xFB7D
#define unicode_ARABIC_LETTER_TCHEHEH_ISOLATED_FORM                   0xFB7E
#define unicode_ARABIC_LETTER_TCHEHEH_FINAL_FORM                      0xFB7F
#define unicode_ARABIC_LETTER_TCHEHEH_INITIAL_FORM                    0xFB80
#define unicode_ARABIC_LETTER_TCHEHEH_MEDIAL_FORM                     0xFB81
#define unicode_ARABIC_LETTER_DDAHAL_ISOLATED_FORM                    0xFB82
#define unicode_ARABIC_LETTER_DDAHAL_FINAL_FORM                       0xFB83
#define unicode_ARABIC_LETTER_DAHAL_ISOLATED_FORM                     0xFB84
#define unicode_ARABIC_LETTER_DAHAL_FINAL_FORM                        0xFB85
#define unicode_ARABIC_LETTER_DUL_ISOLATED_FORM                       0xFB86
#define unicode_ARABIC_LETTER_DUL_FINAL_FORM                          0xFB87
#define unicode_ARABIC_LETTER_DDAL_ISOLATED_FORM                      0xFB88
#define unicode_ARABIC_LETTER_DDAL_FINAL_FORM                         0xFB89
#define unicode_ARABIC_LETTER_JEH_ISOLATED_FORM                       0xFB8A
#define unicode_ARABIC_LETTER_JEH_FINAL_FORM                          0xFB8B
#define unicode_ARABIC_LETTER_RREH_ISOLATED_FORM                      0xFB8C
#define unicode_ARABIC_LETTER_RREH_FINAL_FORM                         0xFB8D
#define unicode_ARABIC_LETTER_KEHEH_ISOLATED_FORM                     0xFB8E
#define unicode_ARABIC_LETTER_KEHEH_FINAL_FORM                        0xFB8F
#define unicode_ARABIC_LETTER_KEHEH_INITIAL_FORM                      0xFB90
#define unicode_ARABIC_LETTER_KEHEH_MEDIAL_FORM                       0xFB91
#define unicode_ARABIC_LETTER_GAF_ISOLATED_FORM                       0xFB92
#define unicode_ARABIC_LETTER_GAF_FINAL_FORM                          0xFB93
#define unicode_ARABIC_LETTER_GAF_INITIAL_FORM                        0xFB94
#define unicode_ARABIC_LETTER_GAF_MEDIAL_FORM                         0xFB95
#define unicode_ARABIC_LETTER_GUEH_ISOLATED_FORM                      0xFB96
#define unicode_ARABIC_LETTER_GUEH_FINAL_FORM                         0xFB97
#define unicode_ARABIC_LETTER_GUEH_INITIAL_FORM                       0xFB98
#define unicode_ARABIC_LETTER_GUEH_MEDIAL_FORM                        0xFB99
#define unicode_ARABIC_LETTER_NGOEH_ISOLATED_FORM                     0xFB9A
#define unicode_ARABIC_LETTER_NGOEH_FINAL_FORM                        0xFB9B
#define unicode_ARABIC_LETTER_NGOEH_INITIAL_FORM                      0xFB9C
#define unicode_ARABIC_LETTER_NGOEH_MEDIAL_FORM                       0xFB9D
#define unicode_ARABIC_LETTER_NOON_GHUNNA_ISOLATED_FORM               0xFB9E
#define unicode_ARABIC_LETTER_NOON_GHUNNA_FINAL_FORM                  0xFB9F
#define unicode_ARABIC_LETTER_RNOON_ISOLATED_FORM                     0xFBA0
#define unicode_ARABIC_LETTER_RNOON_FINAL_FORM                        0xFBA1
#define unicode_ARABIC_LETTER_RNOON_INITIAL_FORM                      0xFBA2
#define unicode_ARABIC_LETTER_RNOON_MEDIAL_FORM                       0xFBA3
#define unicode_ARABIC_LETTER_HEH_WITH_YEH_ABOVE_ISOLATED_FORM        0xFBA4
#define unicode_ARABIC_LETTER_HEH_WITH_YEH_ABOVE_FINAL_FORM           0xFBA5
#define unicode_ARABIC_LETTER_HEH_GOAL_ISOLATED_FORM                  0xFBA6
#define unicode_ARABIC_LETTER_HEH_GOAL_FINAL_FORM                     0xFBA7
#define unicode_ARABIC_LETTER_HEH_GOAL_INITIAL_FORM                   0xFBA8
#define unicode_ARABIC_LETTER_HEH_GOAL_MEDIAL_FORM                    0xFBA9
#define unicode_ARABIC_LETTER_HEH_DOACHASHMEE_ISOLATED_FORM           0xFBAA
#define unicode_ARABIC_LETTER_HEH_DOACHASHMEE_FINAL_FORM              0xFBAB
#define unicode_ARABIC_LETTER_HEH_DOACHASHMEE_INITIAL_FORM            0xFBAC
#define unicode_ARABIC_LETTER_HEH_DOACHASHMEE_MEDIAL_FORM             0xFBAD
#define unicode_ARABIC_LETTER_YEH_BARREE_ISOLATED_FORM                0xFBAE
#define unicode_ARABIC_LETTER_YEH_BARREE_FINAL_FORM                   0xFBAF
#define unicode_ARABIC_LETTER_YEH_BARREE_WITH_HAMZA_ABOVE_ISOLATED_FORM 0xFBB0
#define unicode_ARABIC_LETTER_YEH_BARREE_WITH_HAMZA_ABOVE_FINAL_FORM  0xFBB1
#define unicode_ARABIC_SYMBOL_DOT_ABOVE                               0xFBB2
#define unicode_ARABIC_SYMBOL_DOT_BELOW                               0xFBB3
#define unicode_ARABIC_SYMBOL_TWO_DOTS_ABOVE                          0xFBB4
#define unicode_ARABIC_SYMBOL_TWO_DOTS_BELOW                          0xFBB5
#define unicode_ARABIC_SYMBOL_THREE_DOTS_ABOVE                        0xFBB6
#define unicode_ARABIC_SYMBOL_THREE_DOTS_BELOW                        0xFBB7
#define unicode_ARABIC_SYMBOL_THREE_DOTS_POINTING_DOWNWARDS_ABOVE     0xFBB8
#define unicode_ARABIC_SYMBOL_THREE_DOTS_POINTING_DOWNWARDS_BELOW     0xFBB9
#define unicode_ARABIC_SYMBOL_FOUR_DOTS_ABOVE                         0xFBBA
#define unicode_ARABIC_SYMBOL_FOUR_DOTS_BELOW                         0xFBBB
#define unicode_ARABIC_SYMBOL_DOUBLE_VERTICAL_BAR_BELOW               0xFBBC
#define unicode_ARABIC_SYMBOL_TWO_DOTS_VERTICALLY_ABOVE               0xFBBD
#define unicode_ARABIC_SYMBOL_TWO_DOTS_VERTICALLY_BELOW               0xFBBE
#define unicode_ARABIC_SYMBOL_RING                                    0xFBBF
#define unicode_ARABIC_SYMBOL_SMALL_TAH_ABOVE                         0xFBC0
#define unicode_ARABIC_SYMBOL_SMALL_TAH_BELOW                         0xFBC1
#define unicode_ARABIC_LETTER_NG_ISOLATED_FORM                        0xFBD3
#define unicode_ARABIC_LETTER_NG_FINAL_FORM                           0xFBD4
#define unicode_ARABIC_LETTER_NG_INITIAL_FORM                         0xFBD5
#define unicode_ARABIC_LETTER_NG_MEDIAL_FORM                          0xFBD6
#define unicode_ARABIC_LETTER_U_ISOLATED_FORM                         0xFBD7
#define unicode_ARABIC_LETTER_U_FINAL_FORM                            0xFBD8
#define unicode_ARABIC_LETTER_OE_ISOLATED_FORM                        0xFBD9
#define unicode_ARABIC_LETTER_OE_FINAL_FORM                           0xFBDA
#define unicode_ARABIC_LETTER_YU_ISOLATED_FORM                        0xFBDB
#define unicode_ARABIC_LETTER_YU_FINAL_FORM                           0xFBDC
#define unicode_ARABIC_LETTER_U_WITH_HAMZA_ABOVE_ISOLATED_FORM        0xFBDD
#define unicode_ARABIC_LETTER_VE_ISOLATED_FORM                        0xFBDE
#define unicode_ARABIC_LETTER_VE_FINAL_FORM                           0xFBDF
#define unicode_ARABIC_LETTER_KIRGHIZ_OE_ISOLATED_FORM                0xFBE0
#define unicode_ARABIC_LETTER_KIRGHIZ_OE_FINAL_FORM                   0xFBE1
#define unicode_ARABIC_LETTER_KIRGHIZ_YU_ISOLATED_FORM                0xFBE2
#define unicode_ARABIC_LETTER_KIRGHIZ_YU_FINAL_FORM                   0xFBE3
#define unicode_ARABIC_LETTER_E_ISOLATED_FORM                         0xFBE4
#define unicode_ARABIC_LETTER_E_FINAL_FORM                            0xFBE5
#define unicode_ARABIC_LETTER_E_INITIAL_FORM                          0xFBE6
#define unicode_ARABIC_LETTER_E_MEDIAL_FORM                           0xFBE7
#define unicode_ARABIC_LETTER_UIGHUR_KAZAKH_KIRGHIZ_ALEF_MAKSURA_INITIAL_FORM 0xFBE8
#define unicode_ARABIC_LETTER_UIGHUR_KAZAKH_KIRGHIZ_ALEF_MAKSURA_MEDIAL_FORM 0xFBE9
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_ISOLATED_FORM 0xFBEA
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_FINAL_FORM 0xFBEB
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_AE_ISOLATED_FORM 0xFBEC
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_AE_FINAL_FORM 0xFBED
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_WAW_ISOLATED_FORM 0xFBEE
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_WAW_FINAL_FORM 0xFBEF
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_U_ISOLATED_FORM 0xFBF0
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_U_FINAL_FORM 0xFBF1
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_OE_ISOLATED_FORM 0xFBF2
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_OE_FINAL_FORM 0xFBF3
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YU_ISOLATED_FORM 0xFBF4
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YU_FINAL_FORM 0xFBF5
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_E_ISOLATED_FORM 0xFBF6
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_E_FINAL_FORM 0xFBF7
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_E_INITIAL_FORM 0xFBF8
#define unicode_ARABIC_LIGATURE_UIGHUR_KIRGHIZ_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_ISOLATED_FORM 0xFBF9
#define unicode_ARABIC_LIGATURE_UIGHUR_KIRGHIZ_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_FINAL_FORM 0xFBFA
#define unicode_ARABIC_LIGATURE_UIGHUR_KIRGHIZ_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_INITIAL_FORM 0xFBFB
#define unicode_ARABIC_LETTER_FARSI_YEH_ISOLATED_FORM                 0xFBFC
#define unicode_ARABIC_LETTER_FARSI_YEH_FINAL_FORM                    0xFBFD
#define unicode_ARABIC_LETTER_FARSI_YEH_INITIAL_FORM                  0xFBFE
#define unicode_ARABIC_LETTER_FARSI_YEH_MEDIAL_FORM                   0xFBFF
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_JEEM_ISOLATED_FORM 0xFC00
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HAH_ISOLATED_FORM 0xFC01
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_ISOLATED_FORM 0xFC02
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_ISOLATED_FORM 0xFC03
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YEH_ISOLATED_FORM 0xFC04
#define unicode_ARABIC_LIGATURE_BEH_WITH_JEEM_ISOLATED_FORM           0xFC05
#define unicode_ARABIC_LIGATURE_BEH_WITH_HAH_ISOLATED_FORM            0xFC06
#define unicode_ARABIC_LIGATURE_BEH_WITH_KHAH_ISOLATED_FORM           0xFC07
#define unicode_ARABIC_LIGATURE_BEH_WITH_MEEM_ISOLATED_FORM           0xFC08
#define unicode_ARABIC_LIGATURE_BEH_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFC09
#define unicode_ARABIC_LIGATURE_BEH_WITH_YEH_ISOLATED_FORM            0xFC0A
#define unicode_ARABIC_LIGATURE_TEH_WITH_JEEM_ISOLATED_FORM           0xFC0B
#define unicode_ARABIC_LIGATURE_TEH_WITH_HAH_ISOLATED_FORM            0xFC0C
#define unicode_ARABIC_LIGATURE_TEH_WITH_KHAH_ISOLATED_FORM           0xFC0D
#define unicode_ARABIC_LIGATURE_TEH_WITH_MEEM_ISOLATED_FORM           0xFC0E
#define unicode_ARABIC_LIGATURE_TEH_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFC0F
#define unicode_ARABIC_LIGATURE_TEH_WITH_YEH_ISOLATED_FORM            0xFC10
#define unicode_ARABIC_LIGATURE_THEH_WITH_JEEM_ISOLATED_FORM          0xFC11
#define unicode_ARABIC_LIGATURE_THEH_WITH_MEEM_ISOLATED_FORM          0xFC12
#define unicode_ARABIC_LIGATURE_THEH_WITH_ALEF_MAKSURA_ISOLATED_FORM  0xFC13
#define unicode_ARABIC_LIGATURE_THEH_WITH_YEH_ISOLATED_FORM           0xFC14
#define unicode_ARABIC_LIGATURE_JEEM_WITH_HAH_ISOLATED_FORM           0xFC15
#define unicode_ARABIC_LIGATURE_JEEM_WITH_MEEM_ISOLATED_FORM          0xFC16
#define unicode_ARABIC_LIGATURE_HAH_WITH_JEEM_ISOLATED_FORM           0xFC17
#define unicode_ARABIC_LIGATURE_HAH_WITH_MEEM_ISOLATED_FORM           0xFC18
#define unicode_ARABIC_LIGATURE_KHAH_WITH_JEEM_ISOLATED_FORM          0xFC19
#define unicode_ARABIC_LIGATURE_KHAH_WITH_HAH_ISOLATED_FORM           0xFC1A
#define unicode_ARABIC_LIGATURE_KHAH_WITH_MEEM_ISOLATED_FORM          0xFC1B
#define unicode_ARABIC_LIGATURE_SEEN_WITH_JEEM_ISOLATED_FORM          0xFC1C
#define unicode_ARABIC_LIGATURE_SEEN_WITH_HAH_ISOLATED_FORM           0xFC1D
#define unicode_ARABIC_LIGATURE_SEEN_WITH_KHAH_ISOLATED_FORM          0xFC1E
#define unicode_ARABIC_LIGATURE_SEEN_WITH_MEEM_ISOLATED_FORM          0xFC1F
#define unicode_ARABIC_LIGATURE_SAD_WITH_HAH_ISOLATED_FORM            0xFC20
#define unicode_ARABIC_LIGATURE_SAD_WITH_MEEM_ISOLATED_FORM           0xFC21
#define unicode_ARABIC_LIGATURE_DAD_WITH_JEEM_ISOLATED_FORM           0xFC22
#define unicode_ARABIC_LIGATURE_DAD_WITH_HAH_ISOLATED_FORM            0xFC23
#define unicode_ARABIC_LIGATURE_DAD_WITH_KHAH_ISOLATED_FORM           0xFC24
#define unicode_ARABIC_LIGATURE_DAD_WITH_MEEM_ISOLATED_FORM           0xFC25
#define unicode_ARABIC_LIGATURE_TAH_WITH_HAH_ISOLATED_FORM            0xFC26
#define unicode_ARABIC_LIGATURE_TAH_WITH_MEEM_ISOLATED_FORM           0xFC27
#define unicode_ARABIC_LIGATURE_ZAH_WITH_MEEM_ISOLATED_FORM           0xFC28
#define unicode_ARABIC_LIGATURE_AIN_WITH_JEEM_ISOLATED_FORM           0xFC29
#define unicode_ARABIC_LIGATURE_AIN_WITH_MEEM_ISOLATED_FORM           0xFC2A
#define unicode_ARABIC_LIGATURE_GHAIN_WITH_JEEM_ISOLATED_FORM         0xFC2B
#define unicode_ARABIC_LIGATURE_GHAIN_WITH_MEEM_ISOLATED_FORM         0xFC2C
#define unicode_ARABIC_LIGATURE_FEH_WITH_JEEM_ISOLATED_FORM           0xFC2D
#define unicode_ARABIC_LIGATURE_FEH_WITH_HAH_ISOLATED_FORM            0xFC2E
#define unicode_ARABIC_LIGATURE_FEH_WITH_KHAH_ISOLATED_FORM           0xFC2F
#define unicode_ARABIC_LIGATURE_FEH_WITH_MEEM_ISOLATED_FORM           0xFC30
#define unicode_ARABIC_LIGATURE_FEH_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFC31
#define unicode_ARABIC_LIGATURE_FEH_WITH_YEH_ISOLATED_FORM            0xFC32
#define unicode_ARABIC_LIGATURE_QAF_WITH_HAH_ISOLATED_FORM            0xFC33
#define unicode_ARABIC_LIGATURE_QAF_WITH_MEEM_ISOLATED_FORM           0xFC34
#define unicode_ARABIC_LIGATURE_QAF_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFC35
#define unicode_ARABIC_LIGATURE_QAF_WITH_YEH_ISOLATED_FORM            0xFC36
#define unicode_ARABIC_LIGATURE_KAF_WITH_ALEF_ISOLATED_FORM           0xFC37
#define unicode_ARABIC_LIGATURE_KAF_WITH_JEEM_ISOLATED_FORM           0xFC38
#define unicode_ARABIC_LIGATURE_KAF_WITH_HAH_ISOLATED_FORM            0xFC39
#define unicode_ARABIC_LIGATURE_KAF_WITH_KHAH_ISOLATED_FORM           0xFC3A
#define unicode_ARABIC_LIGATURE_KAF_WITH_LAM_ISOLATED_FORM            0xFC3B
#define unicode_ARABIC_LIGATURE_KAF_WITH_MEEM_ISOLATED_FORM           0xFC3C
#define unicode_ARABIC_LIGATURE_KAF_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFC3D
#define unicode_ARABIC_LIGATURE_KAF_WITH_YEH_ISOLATED_FORM            0xFC3E
#define unicode_ARABIC_LIGATURE_LAM_WITH_JEEM_ISOLATED_FORM           0xFC3F
#define unicode_ARABIC_LIGATURE_LAM_WITH_HAH_ISOLATED_FORM            0xFC40
#define unicode_ARABIC_LIGATURE_LAM_WITH_KHAH_ISOLATED_FORM           0xFC41
#define unicode_ARABIC_LIGATURE_LAM_WITH_MEEM_ISOLATED_FORM           0xFC42
#define unicode_ARABIC_LIGATURE_LAM_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFC43
#define unicode_ARABIC_LIGATURE_LAM_WITH_YEH_ISOLATED_FORM            0xFC44
#define unicode_ARABIC_LIGATURE_MEEM_WITH_JEEM_ISOLATED_FORM          0xFC45
#define unicode_ARABIC_LIGATURE_MEEM_WITH_HAH_ISOLATED_FORM           0xFC46
#define unicode_ARABIC_LIGATURE_MEEM_WITH_KHAH_ISOLATED_FORM          0xFC47
#define unicode_ARABIC_LIGATURE_MEEM_WITH_MEEM_ISOLATED_FORM          0xFC48
#define unicode_ARABIC_LIGATURE_MEEM_WITH_ALEF_MAKSURA_ISOLATED_FORM  0xFC49
#define unicode_ARABIC_LIGATURE_MEEM_WITH_YEH_ISOLATED_FORM           0xFC4A
#define unicode_ARABIC_LIGATURE_NOON_WITH_JEEM_ISOLATED_FORM          0xFC4B
#define unicode_ARABIC_LIGATURE_NOON_WITH_HAH_ISOLATED_FORM           0xFC4C
#define unicode_ARABIC_LIGATURE_NOON_WITH_KHAH_ISOLATED_FORM          0xFC4D
#define unicode_ARABIC_LIGATURE_NOON_WITH_MEEM_ISOLATED_FORM          0xFC4E
#define unicode_ARABIC_LIGATURE_NOON_WITH_ALEF_MAKSURA_ISOLATED_FORM  0xFC4F
#define unicode_ARABIC_LIGATURE_NOON_WITH_YEH_ISOLATED_FORM           0xFC50
#define unicode_ARABIC_LIGATURE_HEH_WITH_JEEM_ISOLATED_FORM           0xFC51
#define unicode_ARABIC_LIGATURE_HEH_WITH_MEEM_ISOLATED_FORM           0xFC52
#define unicode_ARABIC_LIGATURE_HEH_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFC53
#define unicode_ARABIC_LIGATURE_HEH_WITH_YEH_ISOLATED_FORM            0xFC54
#define unicode_ARABIC_LIGATURE_YEH_WITH_JEEM_ISOLATED_FORM           0xFC55
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAH_ISOLATED_FORM            0xFC56
#define unicode_ARABIC_LIGATURE_YEH_WITH_KHAH_ISOLATED_FORM           0xFC57
#define unicode_ARABIC_LIGATURE_YEH_WITH_MEEM_ISOLATED_FORM           0xFC58
#define unicode_ARABIC_LIGATURE_YEH_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFC59
#define unicode_ARABIC_LIGATURE_YEH_WITH_YEH_ISOLATED_FORM            0xFC5A
#define unicode_ARABIC_LIGATURE_THAL_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM 0xFC5B
#define unicode_ARABIC_LIGATURE_REH_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM 0xFC5C
#define unicode_ARABIC_LIGATURE_ALEF_MAKSURA_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM 0xFC5D
#define unicode_ARABIC_LIGATURE_SHADDA_WITH_DAMMATAN_ISOLATED_FORM    0xFC5E
#define unicode_ARABIC_LIGATURE_SHADDA_WITH_KASRATAN_ISOLATED_FORM    0xFC5F
#define unicode_ARABIC_LIGATURE_SHADDA_WITH_FATHA_ISOLATED_FORM       0xFC60
#define unicode_ARABIC_LIGATURE_SHADDA_WITH_DAMMA_ISOLATED_FORM       0xFC61
#define unicode_ARABIC_LIGATURE_SHADDA_WITH_KASRA_ISOLATED_FORM       0xFC62
#define unicode_ARABIC_LIGATURE_SHADDA_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM 0xFC63
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_REH_FINAL_FORM 0xFC64
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ZAIN_FINAL_FORM 0xFC65
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_FINAL_FORM 0xFC66
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_NOON_FINAL_FORM 0xFC67
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_FINAL_FORM 0xFC68
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YEH_FINAL_FORM 0xFC69
#define unicode_ARABIC_LIGATURE_BEH_WITH_REH_FINAL_FORM               0xFC6A
#define unicode_ARABIC_LIGATURE_BEH_WITH_ZAIN_FINAL_FORM              0xFC6B
#define unicode_ARABIC_LIGATURE_BEH_WITH_MEEM_FINAL_FORM              0xFC6C
#define unicode_ARABIC_LIGATURE_BEH_WITH_NOON_FINAL_FORM              0xFC6D
#define unicode_ARABIC_LIGATURE_BEH_WITH_ALEF_MAKSURA_FINAL_FORM      0xFC6E
#define unicode_ARABIC_LIGATURE_BEH_WITH_YEH_FINAL_FORM               0xFC6F
#define unicode_ARABIC_LIGATURE_TEH_WITH_REH_FINAL_FORM               0xFC70
#define unicode_ARABIC_LIGATURE_TEH_WITH_ZAIN_FINAL_FORM              0xFC71
#define unicode_ARABIC_LIGATURE_TEH_WITH_MEEM_FINAL_FORM              0xFC72
#define unicode_ARABIC_LIGATURE_TEH_WITH_NOON_FINAL_FORM              0xFC73
#define unicode_ARABIC_LIGATURE_TEH_WITH_ALEF_MAKSURA_FINAL_FORM      0xFC74
#define unicode_ARABIC_LIGATURE_TEH_WITH_YEH_FINAL_FORM               0xFC75
#define unicode_ARABIC_LIGATURE_THEH_WITH_REH_FINAL_FORM              0xFC76
#define unicode_ARABIC_LIGATURE_THEH_WITH_ZAIN_FINAL_FORM             0xFC77
#define unicode_ARABIC_LIGATURE_THEH_WITH_MEEM_FINAL_FORM             0xFC78
#define unicode_ARABIC_LIGATURE_THEH_WITH_NOON_FINAL_FORM             0xFC79
#define unicode_ARABIC_LIGATURE_THEH_WITH_ALEF_MAKSURA_FINAL_FORM     0xFC7A
#define unicode_ARABIC_LIGATURE_THEH_WITH_YEH_FINAL_FORM              0xFC7B
#define unicode_ARABIC_LIGATURE_FEH_WITH_ALEF_MAKSURA_FINAL_FORM      0xFC7C
#define unicode_ARABIC_LIGATURE_FEH_WITH_YEH_FINAL_FORM               0xFC7D
#define unicode_ARABIC_LIGATURE_QAF_WITH_ALEF_MAKSURA_FINAL_FORM      0xFC7E
#define unicode_ARABIC_LIGATURE_QAF_WITH_YEH_FINAL_FORM               0xFC7F
#define unicode_ARABIC_LIGATURE_KAF_WITH_ALEF_FINAL_FORM              0xFC80
#define unicode_ARABIC_LIGATURE_KAF_WITH_LAM_FINAL_FORM               0xFC81
#define unicode_ARABIC_LIGATURE_KAF_WITH_MEEM_FINAL_FORM              0xFC82
#define unicode_ARABIC_LIGATURE_KAF_WITH_ALEF_MAKSURA_FINAL_FORM      0xFC83
#define unicode_ARABIC_LIGATURE_KAF_WITH_YEH_FINAL_FORM               0xFC84
#define unicode_ARABIC_LIGATURE_LAM_WITH_MEEM_FINAL_FORM              0xFC85
#define unicode_ARABIC_LIGATURE_LAM_WITH_ALEF_MAKSURA_FINAL_FORM      0xFC86
#define unicode_ARABIC_LIGATURE_LAM_WITH_YEH_FINAL_FORM               0xFC87
#define unicode_ARABIC_LIGATURE_MEEM_WITH_ALEF_FINAL_FORM             0xFC88
#define unicode_ARABIC_LIGATURE_MEEM_WITH_MEEM_FINAL_FORM             0xFC89
#define unicode_ARABIC_LIGATURE_NOON_WITH_REH_FINAL_FORM              0xFC8A
#define unicode_ARABIC_LIGATURE_NOON_WITH_ZAIN_FINAL_FORM             0xFC8B
#define unicode_ARABIC_LIGATURE_NOON_WITH_MEEM_FINAL_FORM             0xFC8C
#define unicode_ARABIC_LIGATURE_NOON_WITH_NOON_FINAL_FORM             0xFC8D
#define unicode_ARABIC_LIGATURE_NOON_WITH_ALEF_MAKSURA_FINAL_FORM     0xFC8E
#define unicode_ARABIC_LIGATURE_NOON_WITH_YEH_FINAL_FORM              0xFC8F
#define unicode_ARABIC_LIGATURE_ALEF_MAKSURA_WITH_SUPERSCRIPT_ALEF_FINAL_FORM 0xFC90
#define unicode_ARABIC_LIGATURE_YEH_WITH_REH_FINAL_FORM               0xFC91
#define unicode_ARABIC_LIGATURE_YEH_WITH_ZAIN_FINAL_FORM              0xFC92
#define unicode_ARABIC_LIGATURE_YEH_WITH_MEEM_FINAL_FORM              0xFC93
#define unicode_ARABIC_LIGATURE_YEH_WITH_NOON_FINAL_FORM              0xFC94
#define unicode_ARABIC_LIGATURE_YEH_WITH_ALEF_MAKSURA_FINAL_FORM      0xFC95
#define unicode_ARABIC_LIGATURE_YEH_WITH_YEH_FINAL_FORM               0xFC96
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_JEEM_INITIAL_FORM 0xFC97
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HAH_INITIAL_FORM 0xFC98
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_KHAH_INITIAL_FORM 0xFC99
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_INITIAL_FORM 0xFC9A
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HEH_INITIAL_FORM 0xFC9B
#define unicode_ARABIC_LIGATURE_BEH_WITH_JEEM_INITIAL_FORM            0xFC9C
#define unicode_ARABIC_LIGATURE_BEH_WITH_HAH_INITIAL_FORM             0xFC9D
#define unicode_ARABIC_LIGATURE_BEH_WITH_KHAH_INITIAL_FORM            0xFC9E
#define unicode_ARABIC_LIGATURE_BEH_WITH_MEEM_INITIAL_FORM            0xFC9F
#define unicode_ARABIC_LIGATURE_BEH_WITH_HEH_INITIAL_FORM             0xFCA0
#define unicode_ARABIC_LIGATURE_TEH_WITH_JEEM_INITIAL_FORM            0xFCA1
#define unicode_ARABIC_LIGATURE_TEH_WITH_HAH_INITIAL_FORM             0xFCA2
#define unicode_ARABIC_LIGATURE_TEH_WITH_KHAH_INITIAL_FORM            0xFCA3
#define unicode_ARABIC_LIGATURE_TEH_WITH_MEEM_INITIAL_FORM            0xFCA4
#define unicode_ARABIC_LIGATURE_TEH_WITH_HEH_INITIAL_FORM             0xFCA5
#define unicode_ARABIC_LIGATURE_THEH_WITH_MEEM_INITIAL_FORM           0xFCA6
#define unicode_ARABIC_LIGATURE_JEEM_WITH_HAH_INITIAL_FORM            0xFCA7
#define unicode_ARABIC_LIGATURE_JEEM_WITH_MEEM_INITIAL_FORM           0xFCA8
#define unicode_ARABIC_LIGATURE_HAH_WITH_JEEM_INITIAL_FORM            0xFCA9
#define unicode_ARABIC_LIGATURE_HAH_WITH_MEEM_INITIAL_FORM            0xFCAA
#define unicode_ARABIC_LIGATURE_KHAH_WITH_JEEM_INITIAL_FORM           0xFCAB
#define unicode_ARABIC_LIGATURE_KHAH_WITH_MEEM_INITIAL_FORM           0xFCAC
#define unicode_ARABIC_LIGATURE_SEEN_WITH_JEEM_INITIAL_FORM           0xFCAD
#define unicode_ARABIC_LIGATURE_SEEN_WITH_HAH_INITIAL_FORM            0xFCAE
#define unicode_ARABIC_LIGATURE_SEEN_WITH_KHAH_INITIAL_FORM           0xFCAF
#define unicode_ARABIC_LIGATURE_SEEN_WITH_MEEM_INITIAL_FORM           0xFCB0
#define unicode_ARABIC_LIGATURE_SAD_WITH_HAH_INITIAL_FORM             0xFCB1
#define unicode_ARABIC_LIGATURE_SAD_WITH_KHAH_INITIAL_FORM            0xFCB2
#define unicode_ARABIC_LIGATURE_SAD_WITH_MEEM_INITIAL_FORM            0xFCB3
#define unicode_ARABIC_LIGATURE_DAD_WITH_JEEM_INITIAL_FORM            0xFCB4
#define unicode_ARABIC_LIGATURE_DAD_WITH_HAH_INITIAL_FORM             0xFCB5
#define unicode_ARABIC_LIGATURE_DAD_WITH_KHAH_INITIAL_FORM            0xFCB6
#define unicode_ARABIC_LIGATURE_DAD_WITH_MEEM_INITIAL_FORM            0xFCB7
#define unicode_ARABIC_LIGATURE_TAH_WITH_HAH_INITIAL_FORM             0xFCB8
#define unicode_ARABIC_LIGATURE_ZAH_WITH_MEEM_INITIAL_FORM            0xFCB9
#define unicode_ARABIC_LIGATURE_AIN_WITH_JEEM_INITIAL_FORM            0xFCBA
#define unicode_ARABIC_LIGATURE_AIN_WITH_MEEM_INITIAL_FORM            0xFCBB
#define unicode_ARABIC_LIGATURE_GHAIN_WITH_JEEM_INITIAL_FORM          0xFCBC
#define unicode_ARABIC_LIGATURE_GHAIN_WITH_MEEM_INITIAL_FORM          0xFCBD
#define unicode_ARABIC_LIGATURE_FEH_WITH_JEEM_INITIAL_FORM            0xFCBE
#define unicode_ARABIC_LIGATURE_FEH_WITH_HAH_INITIAL_FORM             0xFCBF
#define unicode_ARABIC_LIGATURE_FEH_WITH_KHAH_INITIAL_FORM            0xFCC0
#define unicode_ARABIC_LIGATURE_FEH_WITH_MEEM_INITIAL_FORM            0xFCC1
#define unicode_ARABIC_LIGATURE_QAF_WITH_HAH_INITIAL_FORM             0xFCC2
#define unicode_ARABIC_LIGATURE_QAF_WITH_MEEM_INITIAL_FORM            0xFCC3
#define unicode_ARABIC_LIGATURE_KAF_WITH_JEEM_INITIAL_FORM            0xFCC4
#define unicode_ARABIC_LIGATURE_KAF_WITH_HAH_INITIAL_FORM             0xFCC5
#define unicode_ARABIC_LIGATURE_KAF_WITH_KHAH_INITIAL_FORM            0xFCC6
#define unicode_ARABIC_LIGATURE_KAF_WITH_LAM_INITIAL_FORM             0xFCC7
#define unicode_ARABIC_LIGATURE_KAF_WITH_MEEM_INITIAL_FORM            0xFCC8
#define unicode_ARABIC_LIGATURE_LAM_WITH_JEEM_INITIAL_FORM            0xFCC9
#define unicode_ARABIC_LIGATURE_LAM_WITH_HAH_INITIAL_FORM             0xFCCA
#define unicode_ARABIC_LIGATURE_LAM_WITH_KHAH_INITIAL_FORM            0xFCCB
#define unicode_ARABIC_LIGATURE_LAM_WITH_MEEM_INITIAL_FORM            0xFCCC
#define unicode_ARABIC_LIGATURE_LAM_WITH_HEH_INITIAL_FORM             0xFCCD
#define unicode_ARABIC_LIGATURE_MEEM_WITH_JEEM_INITIAL_FORM           0xFCCE
#define unicode_ARABIC_LIGATURE_MEEM_WITH_HAH_INITIAL_FORM            0xFCCF
#define unicode_ARABIC_LIGATURE_MEEM_WITH_KHAH_INITIAL_FORM           0xFCD0
#define unicode_ARABIC_LIGATURE_MEEM_WITH_MEEM_INITIAL_FORM           0xFCD1
#define unicode_ARABIC_LIGATURE_NOON_WITH_JEEM_INITIAL_FORM           0xFCD2
#define unicode_ARABIC_LIGATURE_NOON_WITH_HAH_INITIAL_FORM            0xFCD3
#define unicode_ARABIC_LIGATURE_NOON_WITH_KHAH_INITIAL_FORM           0xFCD4
#define unicode_ARABIC_LIGATURE_NOON_WITH_MEEM_INITIAL_FORM           0xFCD5
#define unicode_ARABIC_LIGATURE_NOON_WITH_HEH_INITIAL_FORM            0xFCD6
#define unicode_ARABIC_LIGATURE_HEH_WITH_JEEM_INITIAL_FORM            0xFCD7
#define unicode_ARABIC_LIGATURE_HEH_WITH_MEEM_INITIAL_FORM            0xFCD8
#define unicode_ARABIC_LIGATURE_HEH_WITH_SUPERSCRIPT_ALEF_INITIAL_FORM 0xFCD9
#define unicode_ARABIC_LIGATURE_YEH_WITH_JEEM_INITIAL_FORM            0xFCDA
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAH_INITIAL_FORM             0xFCDB
#define unicode_ARABIC_LIGATURE_YEH_WITH_KHAH_INITIAL_FORM            0xFCDC
#define unicode_ARABIC_LIGATURE_YEH_WITH_MEEM_INITIAL_FORM            0xFCDD
#define unicode_ARABIC_LIGATURE_YEH_WITH_HEH_INITIAL_FORM             0xFCDE
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_MEDIAL_FORM 0xFCDF
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HEH_MEDIAL_FORM 0xFCE0
#define unicode_ARABIC_LIGATURE_BEH_WITH_MEEM_MEDIAL_FORM             0xFCE1
#define unicode_ARABIC_LIGATURE_BEH_WITH_HEH_MEDIAL_FORM              0xFCE2
#define unicode_ARABIC_LIGATURE_TEH_WITH_MEEM_MEDIAL_FORM             0xFCE3
#define unicode_ARABIC_LIGATURE_TEH_WITH_HEH_MEDIAL_FORM              0xFCE4
#define unicode_ARABIC_LIGATURE_THEH_WITH_MEEM_MEDIAL_FORM            0xFCE5
#define unicode_ARABIC_LIGATURE_THEH_WITH_HEH_MEDIAL_FORM             0xFCE6
#define unicode_ARABIC_LIGATURE_SEEN_WITH_MEEM_MEDIAL_FORM            0xFCE7
#define unicode_ARABIC_LIGATURE_SEEN_WITH_HEH_MEDIAL_FORM             0xFCE8
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_MEEM_MEDIAL_FORM           0xFCE9
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_HEH_MEDIAL_FORM            0xFCEA
#define unicode_ARABIC_LIGATURE_KAF_WITH_LAM_MEDIAL_FORM              0xFCEB
#define unicode_ARABIC_LIGATURE_KAF_WITH_MEEM_MEDIAL_FORM             0xFCEC
#define unicode_ARABIC_LIGATURE_LAM_WITH_MEEM_MEDIAL_FORM             0xFCED
#define unicode_ARABIC_LIGATURE_NOON_WITH_MEEM_MEDIAL_FORM            0xFCEE
#define unicode_ARABIC_LIGATURE_NOON_WITH_HEH_MEDIAL_FORM             0xFCEF
#define unicode_ARABIC_LIGATURE_YEH_WITH_MEEM_MEDIAL_FORM             0xFCF0
#define unicode_ARABIC_LIGATURE_YEH_WITH_HEH_MEDIAL_FORM              0xFCF1
#define unicode_ARABIC_LIGATURE_SHADDA_WITH_FATHA_MEDIAL_FORM         0xFCF2
#define unicode_ARABIC_LIGATURE_SHADDA_WITH_DAMMA_MEDIAL_FORM         0xFCF3
#define unicode_ARABIC_LIGATURE_SHADDA_WITH_KASRA_MEDIAL_FORM         0xFCF4
#define unicode_ARABIC_LIGATURE_TAH_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFCF5
#define unicode_ARABIC_LIGATURE_TAH_WITH_YEH_ISOLATED_FORM            0xFCF6
#define unicode_ARABIC_LIGATURE_AIN_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFCF7
#define unicode_ARABIC_LIGATURE_AIN_WITH_YEH_ISOLATED_FORM            0xFCF8
#define unicode_ARABIC_LIGATURE_GHAIN_WITH_ALEF_MAKSURA_ISOLATED_FORM 0xFCF9
#define unicode_ARABIC_LIGATURE_GHAIN_WITH_YEH_ISOLATED_FORM          0xFCFA
#define unicode_ARABIC_LIGATURE_SEEN_WITH_ALEF_MAKSURA_ISOLATED_FORM  0xFCFB
#define unicode_ARABIC_LIGATURE_SEEN_WITH_YEH_ISOLATED_FORM           0xFCFC
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_ALEF_MAKSURA_ISOLATED_FORM 0xFCFD
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_YEH_ISOLATED_FORM          0xFCFE
#define unicode_ARABIC_LIGATURE_HAH_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFCFF
#define unicode_ARABIC_LIGATURE_HAH_WITH_YEH_ISOLATED_FORM            0xFD00
#define unicode_ARABIC_LIGATURE_JEEM_WITH_ALEF_MAKSURA_ISOLATED_FORM  0xFD01
#define unicode_ARABIC_LIGATURE_JEEM_WITH_YEH_ISOLATED_FORM           0xFD02
#define unicode_ARABIC_LIGATURE_KHAH_WITH_ALEF_MAKSURA_ISOLATED_FORM  0xFD03
#define unicode_ARABIC_LIGATURE_KHAH_WITH_YEH_ISOLATED_FORM           0xFD04
#define unicode_ARABIC_LIGATURE_SAD_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFD05
#define unicode_ARABIC_LIGATURE_SAD_WITH_YEH_ISOLATED_FORM            0xFD06
#define unicode_ARABIC_LIGATURE_DAD_WITH_ALEF_MAKSURA_ISOLATED_FORM   0xFD07
#define unicode_ARABIC_LIGATURE_DAD_WITH_YEH_ISOLATED_FORM            0xFD08
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_JEEM_ISOLATED_FORM         0xFD09
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_HAH_ISOLATED_FORM          0xFD0A
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_KHAH_ISOLATED_FORM         0xFD0B
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_MEEM_ISOLATED_FORM         0xFD0C
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_REH_ISOLATED_FORM          0xFD0D
#define unicode_ARABIC_LIGATURE_SEEN_WITH_REH_ISOLATED_FORM           0xFD0E
#define unicode_ARABIC_LIGATURE_SAD_WITH_REH_ISOLATED_FORM            0xFD0F
#define unicode_ARABIC_LIGATURE_DAD_WITH_REH_ISOLATED_FORM            0xFD10
#define unicode_ARABIC_LIGATURE_TAH_WITH_ALEF_MAKSURA_FINAL_FORM      0xFD11
#define unicode_ARABIC_LIGATURE_TAH_WITH_YEH_FINAL_FORM               0xFD12
#define unicode_ARABIC_LIGATURE_AIN_WITH_ALEF_MAKSURA_FINAL_FORM      0xFD13
#define unicode_ARABIC_LIGATURE_AIN_WITH_YEH_FINAL_FORM               0xFD14
#define unicode_ARABIC_LIGATURE_GHAIN_WITH_ALEF_MAKSURA_FINAL_FORM    0xFD15
#define unicode_ARABIC_LIGATURE_GHAIN_WITH_YEH_FINAL_FORM             0xFD16
#define unicode_ARABIC_LIGATURE_SEEN_WITH_ALEF_MAKSURA_FINAL_FORM     0xFD17
#define unicode_ARABIC_LIGATURE_SEEN_WITH_YEH_FINAL_FORM              0xFD18
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_ALEF_MAKSURA_FINAL_FORM    0xFD19
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_YEH_FINAL_FORM             0xFD1A
#define unicode_ARABIC_LIGATURE_HAH_WITH_ALEF_MAKSURA_FINAL_FORM      0xFD1B
#define unicode_ARABIC_LIGATURE_HAH_WITH_YEH_FINAL_FORM               0xFD1C
#define unicode_ARABIC_LIGATURE_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM     0xFD1D
#define unicode_ARABIC_LIGATURE_JEEM_WITH_YEH_FINAL_FORM              0xFD1E
#define unicode_ARABIC_LIGATURE_KHAH_WITH_ALEF_MAKSURA_FINAL_FORM     0xFD1F
#define unicode_ARABIC_LIGATURE_KHAH_WITH_YEH_FINAL_FORM              0xFD20
#define unicode_ARABIC_LIGATURE_SAD_WITH_ALEF_MAKSURA_FINAL_FORM      0xFD21
#define unicode_ARABIC_LIGATURE_SAD_WITH_YEH_FINAL_FORM               0xFD22
#define unicode_ARABIC_LIGATURE_DAD_WITH_ALEF_MAKSURA_FINAL_FORM      0xFD23
#define unicode_ARABIC_LIGATURE_DAD_WITH_YEH_FINAL_FORM               0xFD24
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_JEEM_FINAL_FORM            0xFD25
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_HAH_FINAL_FORM             0xFD26
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_KHAH_FINAL_FORM            0xFD27
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_MEEM_FINAL_FORM            0xFD28
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_REH_FINAL_FORM             0xFD29
#define unicode_ARABIC_LIGATURE_SEEN_WITH_REH_FINAL_FORM              0xFD2A
#define unicode_ARABIC_LIGATURE_SAD_WITH_REH_FINAL_FORM               0xFD2B
#define unicode_ARABIC_LIGATURE_DAD_WITH_REH_FINAL_FORM               0xFD2C
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_JEEM_INITIAL_FORM          0xFD2D
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_HAH_INITIAL_FORM           0xFD2E
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_KHAH_INITIAL_FORM          0xFD2F
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_MEEM_INITIAL_FORM          0xFD30
#define unicode_ARABIC_LIGATURE_SEEN_WITH_HEH_INITIAL_FORM            0xFD31
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_HEH_INITIAL_FORM           0xFD32
#define unicode_ARABIC_LIGATURE_TAH_WITH_MEEM_INITIAL_FORM            0xFD33
#define unicode_ARABIC_LIGATURE_SEEN_WITH_JEEM_MEDIAL_FORM            0xFD34
#define unicode_ARABIC_LIGATURE_SEEN_WITH_HAH_MEDIAL_FORM             0xFD35
#define unicode_ARABIC_LIGATURE_SEEN_WITH_KHAH_MEDIAL_FORM            0xFD36
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_JEEM_MEDIAL_FORM           0xFD37
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_HAH_MEDIAL_FORM            0xFD38
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_KHAH_MEDIAL_FORM           0xFD39
#define unicode_ARABIC_LIGATURE_TAH_WITH_MEEM_MEDIAL_FORM             0xFD3A
#define unicode_ARABIC_LIGATURE_ZAH_WITH_MEEM_MEDIAL_FORM             0xFD3B
#define unicode_ARABIC_LIGATURE_ALEF_WITH_FATHATAN_FINAL_FORM         0xFD3C
#define unicode_ARABIC_LIGATURE_ALEF_WITH_FATHATAN_ISOLATED_FORM      0xFD3D
#define unicode_ORNATE_LEFT_PARENTHESIS                               0xFD3E
#define unicode_ORNATE_RIGHT_PARENTHESIS                              0xFD3F
#define unicode_ARABIC_LIGATURE_TEH_WITH_JEEM_WITH_MEEM_INITIAL_FORM  0xFD50
#define unicode_ARABIC_LIGATURE_TEH_WITH_HAH_WITH_JEEM_FINAL_FORM     0xFD51
#define unicode_ARABIC_LIGATURE_TEH_WITH_HAH_WITH_JEEM_INITIAL_FORM   0xFD52
#define unicode_ARABIC_LIGATURE_TEH_WITH_HAH_WITH_MEEM_INITIAL_FORM   0xFD53
#define unicode_ARABIC_LIGATURE_TEH_WITH_KHAH_WITH_MEEM_INITIAL_FORM  0xFD54
#define unicode_ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_JEEM_INITIAL_FORM  0xFD55
#define unicode_ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_HAH_INITIAL_FORM   0xFD56
#define unicode_ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_KHAH_INITIAL_FORM  0xFD57
#define unicode_ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_HAH_FINAL_FORM    0xFD58
#define unicode_ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_HAH_INITIAL_FORM  0xFD59
#define unicode_ARABIC_LIGATURE_HAH_WITH_MEEM_WITH_YEH_FINAL_FORM     0xFD5A
#define unicode_ARABIC_LIGATURE_HAH_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM 0xFD5B
#define unicode_ARABIC_LIGATURE_SEEN_WITH_HAH_WITH_JEEM_INITIAL_FORM  0xFD5C
#define unicode_ARABIC_LIGATURE_SEEN_WITH_JEEM_WITH_HAH_INITIAL_FORM  0xFD5D
#define unicode_ARABIC_LIGATURE_SEEN_WITH_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM 0xFD5E
#define unicode_ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_HAH_FINAL_FORM    0xFD5F
#define unicode_ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_HAH_INITIAL_FORM  0xFD60
#define unicode_ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_JEEM_INITIAL_FORM 0xFD61
#define unicode_ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_MEEM_FINAL_FORM   0xFD62
#define unicode_ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_MEEM_INITIAL_FORM 0xFD63
#define unicode_ARABIC_LIGATURE_SAD_WITH_HAH_WITH_HAH_FINAL_FORM      0xFD64
#define unicode_ARABIC_LIGATURE_SAD_WITH_HAH_WITH_HAH_INITIAL_FORM    0xFD65
#define unicode_ARABIC_LIGATURE_SAD_WITH_MEEM_WITH_MEEM_FINAL_FORM    0xFD66
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_HAH_WITH_MEEM_FINAL_FORM   0xFD67
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_HAH_WITH_MEEM_INITIAL_FORM 0xFD68
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_JEEM_WITH_YEH_FINAL_FORM   0xFD69
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_KHAH_FINAL_FORM  0xFD6A
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_KHAH_INITIAL_FORM 0xFD6B
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_MEEM_FINAL_FORM  0xFD6C
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_MEEM_INITIAL_FORM 0xFD6D
#define unicode_ARABIC_LIGATURE_DAD_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM 0xFD6E
#define unicode_ARABIC_LIGATURE_DAD_WITH_KHAH_WITH_MEEM_FINAL_FORM    0xFD6F
#define unicode_ARABIC_LIGATURE_DAD_WITH_KHAH_WITH_MEEM_INITIAL_FORM  0xFD70
#define unicode_ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_HAH_FINAL_FORM     0xFD71
#define unicode_ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_HAH_INITIAL_FORM   0xFD72
#define unicode_ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_MEEM_INITIAL_FORM  0xFD73
#define unicode_ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_YEH_FINAL_FORM     0xFD74
#define unicode_ARABIC_LIGATURE_AIN_WITH_JEEM_WITH_MEEM_FINAL_FORM    0xFD75
#define unicode_ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_MEEM_FINAL_FORM    0xFD76
#define unicode_ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_MEEM_INITIAL_FORM  0xFD77
#define unicode_ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM 0xFD78
#define unicode_ARABIC_LIGATURE_GHAIN_WITH_MEEM_WITH_MEEM_FINAL_FORM  0xFD79
#define unicode_ARABIC_LIGATURE_GHAIN_WITH_MEEM_WITH_YEH_FINAL_FORM   0xFD7A
#define unicode_ARABIC_LIGATURE_GHAIN_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM 0xFD7B
#define unicode_ARABIC_LIGATURE_FEH_WITH_KHAH_WITH_MEEM_FINAL_FORM    0xFD7C
#define unicode_ARABIC_LIGATURE_FEH_WITH_KHAH_WITH_MEEM_INITIAL_FORM  0xFD7D
#define unicode_ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_HAH_FINAL_FORM     0xFD7E
#define unicode_ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_MEEM_FINAL_FORM    0xFD7F
#define unicode_ARABIC_LIGATURE_LAM_WITH_HAH_WITH_MEEM_FINAL_FORM     0xFD80
#define unicode_ARABIC_LIGATURE_LAM_WITH_HAH_WITH_YEH_FINAL_FORM      0xFD81
#define unicode_ARABIC_LIGATURE_LAM_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM 0xFD82
#define unicode_ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_JEEM_INITIAL_FORM  0xFD83
#define unicode_ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_JEEM_FINAL_FORM    0xFD84
#define unicode_ARABIC_LIGATURE_LAM_WITH_KHAH_WITH_MEEM_FINAL_FORM    0xFD85
#define unicode_ARABIC_LIGATURE_LAM_WITH_KHAH_WITH_MEEM_INITIAL_FORM  0xFD86
#define unicode_ARABIC_LIGATURE_LAM_WITH_MEEM_WITH_HAH_FINAL_FORM     0xFD87
#define unicode_ARABIC_LIGATURE_LAM_WITH_MEEM_WITH_HAH_INITIAL_FORM   0xFD88
#define unicode_ARABIC_LIGATURE_MEEM_WITH_HAH_WITH_JEEM_INITIAL_FORM  0xFD89
#define unicode_ARABIC_LIGATURE_MEEM_WITH_HAH_WITH_MEEM_INITIAL_FORM  0xFD8A
#define unicode_ARABIC_LIGATURE_MEEM_WITH_HAH_WITH_YEH_FINAL_FORM     0xFD8B
#define unicode_ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_HAH_INITIAL_FORM  0xFD8C
#define unicode_ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_MEEM_INITIAL_FORM 0xFD8D
#define unicode_ARABIC_LIGATURE_MEEM_WITH_KHAH_WITH_JEEM_INITIAL_FORM 0xFD8E
#define unicode_ARABIC_LIGATURE_MEEM_WITH_KHAH_WITH_MEEM_INITIAL_FORM 0xFD8F
#define unicode_ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_KHAH_INITIAL_FORM 0xFD92
#define unicode_ARABIC_LIGATURE_HEH_WITH_MEEM_WITH_JEEM_INITIAL_FORM  0xFD93
#define unicode_ARABIC_LIGATURE_HEH_WITH_MEEM_WITH_MEEM_INITIAL_FORM  0xFD94
#define unicode_ARABIC_LIGATURE_NOON_WITH_HAH_WITH_MEEM_INITIAL_FORM  0xFD95
#define unicode_ARABIC_LIGATURE_NOON_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM 0xFD96
#define unicode_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_MEEM_FINAL_FORM   0xFD97
#define unicode_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_MEEM_INITIAL_FORM 0xFD98
#define unicode_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM 0xFD99
#define unicode_ARABIC_LIGATURE_NOON_WITH_MEEM_WITH_YEH_FINAL_FORM    0xFD9A
#define unicode_ARABIC_LIGATURE_NOON_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM 0xFD9B
#define unicode_ARABIC_LIGATURE_YEH_WITH_MEEM_WITH_MEEM_FINAL_FORM    0xFD9C
#define unicode_ARABIC_LIGATURE_YEH_WITH_MEEM_WITH_MEEM_INITIAL_FORM  0xFD9D
#define unicode_ARABIC_LIGATURE_BEH_WITH_KHAH_WITH_YEH_FINAL_FORM     0xFD9E
#define unicode_ARABIC_LIGATURE_TEH_WITH_JEEM_WITH_YEH_FINAL_FORM     0xFD9F
#define unicode_ARABIC_LIGATURE_TEH_WITH_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM 0xFDA0
#define unicode_ARABIC_LIGATURE_TEH_WITH_KHAH_WITH_YEH_FINAL_FORM     0xFDA1
#define unicode_ARABIC_LIGATURE_TEH_WITH_KHAH_WITH_ALEF_MAKSURA_FINAL_FORM 0xFDA2
#define unicode_ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_YEH_FINAL_FORM     0xFDA3
#define unicode_ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM 0xFDA4
#define unicode_ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_YEH_FINAL_FORM    0xFDA5
#define unicode_ARABIC_LIGATURE_JEEM_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM 0xFDA6
#define unicode_ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM 0xFDA7
#define unicode_ARABIC_LIGATURE_SEEN_WITH_KHAH_WITH_ALEF_MAKSURA_FINAL_FORM 0xFDA8
#define unicode_ARABIC_LIGATURE_SAD_WITH_HAH_WITH_YEH_FINAL_FORM      0xFDA9
#define unicode_ARABIC_LIGATURE_SHEEN_WITH_HAH_WITH_YEH_FINAL_FORM    0xFDAA
#define unicode_ARABIC_LIGATURE_DAD_WITH_HAH_WITH_YEH_FINAL_FORM      0xFDAB
#define unicode_ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_YEH_FINAL_FORM     0xFDAC
#define unicode_ARABIC_LIGATURE_LAM_WITH_MEEM_WITH_YEH_FINAL_FORM     0xFDAD
#define unicode_ARABIC_LIGATURE_YEH_WITH_HAH_WITH_YEH_FINAL_FORM      0xFDAE
#define unicode_ARABIC_LIGATURE_YEH_WITH_JEEM_WITH_YEH_FINAL_FORM     0xFDAF
#define unicode_ARABIC_LIGATURE_YEH_WITH_MEEM_WITH_YEH_FINAL_FORM     0xFDB0
#define unicode_ARABIC_LIGATURE_MEEM_WITH_MEEM_WITH_YEH_FINAL_FORM    0xFDB1
#define unicode_ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_YEH_FINAL_FORM     0xFDB2
#define unicode_ARABIC_LIGATURE_NOON_WITH_HAH_WITH_YEH_FINAL_FORM     0xFDB3
#define unicode_ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_HAH_INITIAL_FORM   0xFDB4
#define unicode_ARABIC_LIGATURE_LAM_WITH_HAH_WITH_MEEM_INITIAL_FORM   0xFDB5
#define unicode_ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_YEH_FINAL_FORM     0xFDB6
#define unicode_ARABIC_LIGATURE_KAF_WITH_MEEM_WITH_YEH_FINAL_FORM     0xFDB7
#define unicode_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_HAH_INITIAL_FORM  0xFDB8
#define unicode_ARABIC_LIGATURE_MEEM_WITH_KHAH_WITH_YEH_FINAL_FORM    0xFDB9
#define unicode_ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_MEEM_INITIAL_FORM  0xFDBA
#define unicode_ARABIC_LIGATURE_KAF_WITH_MEEM_WITH_MEEM_FINAL_FORM    0xFDBB
#define unicode_ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_MEEM_FINAL_FORM    0xFDBC
#define unicode_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_HAH_FINAL_FORM    0xFDBD
#define unicode_ARABIC_LIGATURE_JEEM_WITH_HAH_WITH_YEH_FINAL_FORM     0xFDBE
#define unicode_ARABIC_LIGATURE_HAH_WITH_JEEM_WITH_YEH_FINAL_FORM     0xFDBF
#define unicode_ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_YEH_FINAL_FORM    0xFDC0
#define unicode_ARABIC_LIGATURE_FEH_WITH_MEEM_WITH_YEH_FINAL_FORM     0xFDC1
#define unicode_ARABIC_LIGATURE_BEH_WITH_HAH_WITH_YEH_FINAL_FORM      0xFDC2
#define unicode_ARABIC_LIGATURE_KAF_WITH_MEEM_WITH_MEEM_INITIAL_FORM  0xFDC3
#define unicode_ARABIC_LIGATURE_AIN_WITH_JEEM_WITH_MEEM_INITIAL_FORM  0xFDC4
#define unicode_ARABIC_LIGATURE_SAD_WITH_MEEM_WITH_MEEM_INITIAL_FORM  0xFDC5
#define unicode_ARABIC_LIGATURE_SEEN_WITH_KHAH_WITH_YEH_FINAL_FORM    0xFDC6
#define unicode_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_YEH_FINAL_FORM    0xFDC7
#define unicode_ARABIC_LIGATURE_SALLA_USED_AS_KORANIC_STOP_SIGN_ISOLATED_FORM 0xFDF0
#define unicode_ARABIC_LIGATURE_QALA_USED_AS_KORANIC_STOP_SIGN_ISOLATED_FORM 0xFDF1
#define unicode_ARABIC_LIGATURE_ALLAH_ISOLATED_FORM                   0xFDF2
#define unicode_ARABIC_LIGATURE_AKBAR_ISOLATED_FORM                   0xFDF3
#define unicode_ARABIC_LIGATURE_MOHAMMAD_ISOLATED_FORM                0xFDF4
#define unicode_ARABIC_LIGATURE_SALAM_ISOLATED_FORM                   0xFDF5
#define unicode_ARABIC_LIGATURE_RASOUL_ISOLATED_FORM                  0xFDF6
#define unicode_ARABIC_LIGATURE_ALAYHE_ISOLATED_FORM                  0xFDF7
#define unicode_ARABIC_LIGATURE_WASALLAM_ISOLATED_FORM                0xFDF8
#define unicode_ARABIC_LIGATURE_SALLA_ISOLATED_FORM                   0xFDF9
#define unicode_ARABIC_LIGATURE_SALLALLAHOU_ALAYHE_WASALLAM           0xFDFA
#define unicode_ARABIC_LIGATURE_JALLAJALALOUHOU                       0xFDFB
#define unicode_RIAL_SIGN                                             0xFDFC
#define unicode_ARABIC_LIGATURE_BISMILLAH_AR_RAHMAN_AR_RAHEEM         0xFDFD
#define unicode_VARIATION_SELECTOR_1                                  0xFE00
#define unicode_VARIATION_SELECTOR_2                                  0xFE01
#define unicode_VARIATION_SELECTOR_3                                  0xFE02
#define unicode_VARIATION_SELECTOR_4                                  0xFE03
#define unicode_VARIATION_SELECTOR_5                                  0xFE04
#define unicode_VARIATION_SELECTOR_6                                  0xFE05
#define unicode_VARIATION_SELECTOR_7                                  0xFE06
#define unicode_VARIATION_SELECTOR_8                                  0xFE07
#define unicode_VARIATION_SELECTOR_9                                  0xFE08
#define unicode_VARIATION_SELECTOR_10                                 0xFE09
#define unicode_VARIATION_SELECTOR_11                                 0xFE0A
#define unicode_VARIATION_SELECTOR_12                                 0xFE0B
#define unicode_VARIATION_SELECTOR_13                                 0xFE0C
#define unicode_VARIATION_SELECTOR_14                                 0xFE0D
#define unicode_VARIATION_SELECTOR_15                                 0xFE0E
#define unicode_VARIATION_SELECTOR_16                                 0xFE0F
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_COMMA                  0xFE10
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_IDEOGRAPHIC_COMMA      0xFE11
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_IDEOGRAPHIC_FULL_STOP  0xFE12
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_COLON                  0xFE13
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_SEMICOLON              0xFE14
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_EXCLAMATION_MARK       0xFE15
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_QUESTION_MARK          0xFE16
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_LEFT_WHITE_LENTICULAR_BRACKET 0xFE17
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_WHITE_LENTICULAR_BRAKCET 0xFE18
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_HORIZONTAL_ELLIPSIS    0xFE19
#define unicode_COMBINING_LIGATURE_LEFT_HALF                          0xFE20
#define unicode_COMBINING_LIGATURE_RIGHT_HALF                         0xFE21
#define unicode_COMBINING_DOUBLE_TILDE_LEFT_HALF                      0xFE22
#define unicode_COMBINING_DOUBLE_TILDE_RIGHT_HALF                     0xFE23
#define unicode_COMBINING_MACRON_LEFT_HALF                            0xFE24
#define unicode_COMBINING_MACRON_RIGHT_HALF                           0xFE25
#define unicode_COMBINING_CONJOINING_MACRON                           0xFE26
#define unicode_COMBINING_LIGATURE_LEFT_HALF_BELOW                    0xFE27
#define unicode_COMBINING_LIGATURE_RIGHT_HALF_BELOW                   0xFE28
#define unicode_COMBINING_TILDE_LEFT_HALF_BELOW                       0xFE29
#define unicode_COMBINING_TILDE_RIGHT_HALF_BELOW                      0xFE2A
#define unicode_COMBINING_MACRON_LEFT_HALF_BELOW                      0xFE2B
#define unicode_COMBINING_MACRON_RIGHT_HALF_BELOW                     0xFE2C
#define unicode_COMBINING_CONJOINING_MACRON_BELOW                     0xFE2D
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_TWO_DOT_LEADER         0xFE30
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_EM_DASH                0xFE31
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_EN_DASH                0xFE32
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_LOW_LINE               0xFE33
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_WAVY_LOW_LINE          0xFE34
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_LEFT_PARENTHESIS       0xFE35
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_PARENTHESIS      0xFE36
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_LEFT_CURLY_BRACKET     0xFE37
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_CURLY_BRACKET    0xFE38
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_LEFT_TORTOISE_SHELL_BRACKET 0xFE39
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_TORTOISE_SHELL_BRACKET 0xFE3A
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_LEFT_BLACK_LENTICULAR_BRACKET 0xFE3B
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_BLACK_LENTICULAR_BRACKET 0xFE3C
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_LEFT_DOUBLE_ANGLE_BRACKET 0xFE3D
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_DOUBLE_ANGLE_BRACKET 0xFE3E
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_LEFT_ANGLE_BRACKET     0xFE3F
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_ANGLE_BRACKET    0xFE40
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_LEFT_CORNER_BRACKET    0xFE41
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_CORNER_BRACKET   0xFE42
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_LEFT_WHITE_CORNER_BRACKET 0xFE43
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_WHITE_CORNER_BRACKET 0xFE44
#define unicode_SESAME_DOT                                            0xFE45
#define unicode_WHITE_SESAME_DOT                                      0xFE46
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_LEFT_SQUARE_BRACKET    0xFE47
#define unicode_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_SQUARE_BRACKET   0xFE48
#define unicode_DASHED_OVERLINE                                       0xFE49
#define unicode_CENTRELINE_OVERLINE                                   0xFE4A
#define unicode_WAVY_OVERLINE                                         0xFE4B
#define unicode_DOUBLE_WAVY_OVERLINE                                  0xFE4C
#define unicode_DASHED_LOW_LINE                                       0xFE4D
#define unicode_CENTRELINE_LOW_LINE                                   0xFE4E
#define unicode_WAVY_LOW_LINE                                         0xFE4F
#define unicode_SMALL_COMMA                                           0xFE50
#define unicode_SMALL_IDEOGRAPHIC_COMMA                               0xFE51
#define unicode_SMALL_FULL_STOP                                       0xFE52
#define unicode_SMALL_SEMICOLON                                       0xFE54
#define unicode_SMALL_COLON                                           0xFE55
#define unicode_SMALL_QUESTION_MARK                                   0xFE56
#define unicode_SMALL_EXCLAMATION_MARK                                0xFE57
#define unicode_SMALL_EM_DASH                                         0xFE58
#define unicode_SMALL_LEFT_PARENTHESIS                                0xFE59
#define unicode_SMALL_RIGHT_PARENTHESIS                               0xFE5A
#define unicode_SMALL_LEFT_CURLY_BRACKET                              0xFE5B
#define unicode_SMALL_RIGHT_CURLY_BRACKET                             0xFE5C
#define unicode_SMALL_LEFT_TORTOISE_SHELL_BRACKET                     0xFE5D
#define unicode_SMALL_RIGHT_TORTOISE_SHELL_BRACKET                    0xFE5E
#define unicode_SMALL_NUMBER_SIGN                                     0xFE5F
#define unicode_SMALL_AMPERSAND                                       0xFE60
#define unicode_SMALL_ASTERISK                                        0xFE61
#define unicode_SMALL_PLUS_SIGN                                       0xFE62
#define unicode_SMALL_HYPHEN_MINUS                                    0xFE63
#define unicode_SMALL_LESS_THAN_SIGN                                  0xFE64
#define unicode_SMALL_GREATER_THAN_SIGN                               0xFE65
#define unicode_SMALL_EQUALS_SIGN                                     0xFE66
#define unicode_SMALL_REVERSE_SOLIDUS                                 0xFE68
#define unicode_SMALL_DOLLAR_SIGN                                     0xFE69
#define unicode_SMALL_PERCENT_SIGN                                    0xFE6A
#define unicode_SMALL_COMMERCIAL_AT                                   0xFE6B
#define unicode_ARABIC_FATHATAN_ISOLATED_FORM                         0xFE70
#define unicode_ARABIC_TATWEEL_WITH_FATHATAN_ABOVE                    0xFE71
#define unicode_ARABIC_DAMMATAN_ISOLATED_FORM                         0xFE72
#define unicode_ARABIC_TAIL_FRAGMENT                                  0xFE73
#define unicode_ARABIC_KASRATAN_ISOLATED_FORM                         0xFE74
#define unicode_ARABIC_FATHA_ISOLATED_FORM                            0xFE76
#define unicode_ARABIC_FATHA_MEDIAL_FORM                              0xFE77
#define unicode_ARABIC_DAMMA_ISOLATED_FORM                            0xFE78
#define unicode_ARABIC_DAMMA_MEDIAL_FORM                              0xFE79
#define unicode_ARABIC_KASRA_ISOLATED_FORM                            0xFE7A
#define unicode_ARABIC_KASRA_MEDIAL_FORM                              0xFE7B
#define unicode_ARABIC_SHADDA_ISOLATED_FORM                           0xFE7C
#define unicode_ARABIC_SHADDA_MEDIAL_FORM                             0xFE7D
#define unicode_ARABIC_SUKUN_ISOLATED_FORM                            0xFE7E
#define unicode_ARABIC_SUKUN_MEDIAL_FORM                              0xFE7F
#define unicode_ARABIC_LETTER_HAMZA_ISOLATED_FORM                     0xFE80
#define unicode_ARABIC_LETTER_ALEF_WITH_MADDA_ABOVE_ISOLATED_FORM     0xFE81
#define unicode_ARABIC_LETTER_ALEF_WITH_MADDA_ABOVE_FINAL_FORM        0xFE82
#define unicode_ARABIC_LETTER_ALEF_WITH_HAMZA_ABOVE_ISOLATED_FORM     0xFE83
#define unicode_ARABIC_LETTER_ALEF_WITH_HAMZA_ABOVE_FINAL_FORM        0xFE84
#define unicode_ARABIC_LETTER_WAW_WITH_HAMZA_ABOVE_ISOLATED_FORM      0xFE85
#define unicode_ARABIC_LETTER_WAW_WITH_HAMZA_ABOVE_FINAL_FORM         0xFE86
#define unicode_ARABIC_LETTER_ALEF_WITH_HAMZA_BELOW_ISOLATED_FORM     0xFE87
#define unicode_ARABIC_LETTER_ALEF_WITH_HAMZA_BELOW_FINAL_FORM        0xFE88
#define unicode_ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_ISOLATED_FORM      0xFE89
#define unicode_ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_FINAL_FORM         0xFE8A
#define unicode_ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_INITIAL_FORM       0xFE8B
#define unicode_ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_MEDIAL_FORM        0xFE8C
#define unicode_ARABIC_LETTER_ALEF_ISOLATED_FORM                      0xFE8D
#define unicode_ARABIC_LETTER_ALEF_FINAL_FORM                         0xFE8E
#define unicode_ARABIC_LETTER_BEH_ISOLATED_FORM                       0xFE8F
#define unicode_ARABIC_LETTER_BEH_FINAL_FORM                          0xFE90
#define unicode_ARABIC_LETTER_BEH_INITIAL_FORM                        0xFE91
#define unicode_ARABIC_LETTER_BEH_MEDIAL_FORM                         0xFE92
#define unicode_ARABIC_LETTER_TEH_MARBUTA_ISOLATED_FORM               0xFE93
#define unicode_ARABIC_LETTER_TEH_MARBUTA_FINAL_FORM                  0xFE94
#define unicode_ARABIC_LETTER_TEH_ISOLATED_FORM                       0xFE95
#define unicode_ARABIC_LETTER_TEH_FINAL_FORM                          0xFE96
#define unicode_ARABIC_LETTER_TEH_INITIAL_FORM                        0xFE97
#define unicode_ARABIC_LETTER_TEH_MEDIAL_FORM                         0xFE98
#define unicode_ARABIC_LETTER_THEH_ISOLATED_FORM                      0xFE99
#define unicode_ARABIC_LETTER_THEH_FINAL_FORM                         0xFE9A
#define unicode_ARABIC_LETTER_THEH_INITIAL_FORM                       0xFE9B
#define unicode_ARABIC_LETTER_THEH_MEDIAL_FORM                        0xFE9C
#define unicode_ARABIC_LETTER_JEEM_ISOLATED_FORM                      0xFE9D
#define unicode_ARABIC_LETTER_JEEM_FINAL_FORM                         0xFE9E
#define unicode_ARABIC_LETTER_JEEM_INITIAL_FORM                       0xFE9F
#define unicode_ARABIC_LETTER_JEEM_MEDIAL_FORM                        0xFEA0
#define unicode_ARABIC_LETTER_HAH_ISOLATED_FORM                       0xFEA1
#define unicode_ARABIC_LETTER_HAH_FINAL_FORM                          0xFEA2
#define unicode_ARABIC_LETTER_HAH_INITIAL_FORM                        0xFEA3
#define unicode_ARABIC_LETTER_HAH_MEDIAL_FORM                         0xFEA4
#define unicode_ARABIC_LETTER_KHAH_ISOLATED_FORM                      0xFEA5
#define unicode_ARABIC_LETTER_KHAH_FINAL_FORM                         0xFEA6
#define unicode_ARABIC_LETTER_KHAH_INITIAL_FORM                       0xFEA7
#define unicode_ARABIC_LETTER_KHAH_MEDIAL_FORM                        0xFEA8
#define unicode_ARABIC_LETTER_DAL_ISOLATED_FORM                       0xFEA9
#define unicode_ARABIC_LETTER_DAL_FINAL_FORM                          0xFEAA
#define unicode_ARABIC_LETTER_THAL_ISOLATED_FORM                      0xFEAB
#define unicode_ARABIC_LETTER_THAL_FINAL_FORM                         0xFEAC
#define unicode_ARABIC_LETTER_REH_ISOLATED_FORM                       0xFEAD
#define unicode_ARABIC_LETTER_REH_FINAL_FORM                          0xFEAE
#define unicode_ARABIC_LETTER_ZAIN_ISOLATED_FORM                      0xFEAF
#define unicode_ARABIC_LETTER_ZAIN_FINAL_FORM                         0xFEB0
#define unicode_ARABIC_LETTER_SEEN_ISOLATED_FORM                      0xFEB1
#define unicode_ARABIC_LETTER_SEEN_FINAL_FORM                         0xFEB2
#define unicode_ARABIC_LETTER_SEEN_INITIAL_FORM                       0xFEB3
#define unicode_ARABIC_LETTER_SEEN_MEDIAL_FORM                        0xFEB4
#define unicode_ARABIC_LETTER_SHEEN_ISOLATED_FORM                     0xFEB5
#define unicode_ARABIC_LETTER_SHEEN_FINAL_FORM                        0xFEB6
#define unicode_ARABIC_LETTER_SHEEN_INITIAL_FORM                      0xFEB7
#define unicode_ARABIC_LETTER_SHEEN_MEDIAL_FORM                       0xFEB8
#define unicode_ARABIC_LETTER_SAD_ISOLATED_FORM                       0xFEB9
#define unicode_ARABIC_LETTER_SAD_FINAL_FORM                          0xFEBA
#define unicode_ARABIC_LETTER_SAD_INITIAL_FORM                        0xFEBB
#define unicode_ARABIC_LETTER_SAD_MEDIAL_FORM                         0xFEBC
#define unicode_ARABIC_LETTER_DAD_ISOLATED_FORM                       0xFEBD
#define unicode_ARABIC_LETTER_DAD_FINAL_FORM                          0xFEBE
#define unicode_ARABIC_LETTER_DAD_INITIAL_FORM                        0xFEBF
#define unicode_ARABIC_LETTER_DAD_MEDIAL_FORM                         0xFEC0
#define unicode_ARABIC_LETTER_TAH_ISOLATED_FORM                       0xFEC1
#define unicode_ARABIC_LETTER_TAH_FINAL_FORM                          0xFEC2
#define unicode_ARABIC_LETTER_TAH_INITIAL_FORM                        0xFEC3
#define unicode_ARABIC_LETTER_TAH_MEDIAL_FORM                         0xFEC4
#define unicode_ARABIC_LETTER_ZAH_ISOLATED_FORM                       0xFEC5
#define unicode_ARABIC_LETTER_ZAH_FINAL_FORM                          0xFEC6
#define unicode_ARABIC_LETTER_ZAH_INITIAL_FORM                        0xFEC7
#define unicode_ARABIC_LETTER_ZAH_MEDIAL_FORM                         0xFEC8
#define unicode_ARABIC_LETTER_AIN_ISOLATED_FORM                       0xFEC9
#define unicode_ARABIC_LETTER_AIN_FINAL_FORM                          0xFECA
#define unicode_ARABIC_LETTER_AIN_INITIAL_FORM                        0xFECB
#define unicode_ARABIC_LETTER_AIN_MEDIAL_FORM                         0xFECC
#define unicode_ARABIC_LETTER_GHAIN_ISOLATED_FORM                     0xFECD
#define unicode_ARABIC_LETTER_GHAIN_FINAL_FORM                        0xFECE
#define unicode_ARABIC_LETTER_GHAIN_INITIAL_FORM                      0xFECF
#define unicode_ARABIC_LETTER_GHAIN_MEDIAL_FORM                       0xFED0
#define unicode_ARABIC_LETTER_FEH_ISOLATED_FORM                       0xFED1
#define unicode_ARABIC_LETTER_FEH_FINAL_FORM                          0xFED2
#define unicode_ARABIC_LETTER_FEH_INITIAL_FORM                        0xFED3
#define unicode_ARABIC_LETTER_FEH_MEDIAL_FORM                         0xFED4
#define unicode_ARABIC_LETTER_QAF_ISOLATED_FORM                       0xFED5
#define unicode_ARABIC_LETTER_QAF_FINAL_FORM                          0xFED6
#define unicode_ARABIC_LETTER_QAF_INITIAL_FORM                        0xFED7
#define unicode_ARABIC_LETTER_QAF_MEDIAL_FORM                         0xFED8
#define unicode_ARABIC_LETTER_KAF_ISOLATED_FORM                       0xFED9
#define unicode_ARABIC_LETTER_KAF_FINAL_FORM                          0xFEDA
#define unicode_ARABIC_LETTER_KAF_INITIAL_FORM                        0xFEDB
#define unicode_ARABIC_LETTER_KAF_MEDIAL_FORM                         0xFEDC
#define unicode_ARABIC_LETTER_LAM_ISOLATED_FORM                       0xFEDD
#define unicode_ARABIC_LETTER_LAM_FINAL_FORM                          0xFEDE
#define unicode_ARABIC_LETTER_LAM_INITIAL_FORM                        0xFEDF
#define unicode_ARABIC_LETTER_LAM_MEDIAL_FORM                         0xFEE0
#define unicode_ARABIC_LETTER_MEEM_ISOLATED_FORM                      0xFEE1
#define unicode_ARABIC_LETTER_MEEM_FINAL_FORM                         0xFEE2
#define unicode_ARABIC_LETTER_MEEM_INITIAL_FORM                       0xFEE3
#define unicode_ARABIC_LETTER_MEEM_MEDIAL_FORM                        0xFEE4
#define unicode_ARABIC_LETTER_NOON_ISOLATED_FORM                      0xFEE5
#define unicode_ARABIC_LETTER_NOON_FINAL_FORM                         0xFEE6
#define unicode_ARABIC_LETTER_NOON_INITIAL_FORM                       0xFEE7
#define unicode_ARABIC_LETTER_NOON_MEDIAL_FORM                        0xFEE8
#define unicode_ARABIC_LETTER_HEH_ISOLATED_FORM                       0xFEE9
#define unicode_ARABIC_LETTER_HEH_FINAL_FORM                          0xFEEA
#define unicode_ARABIC_LETTER_HEH_INITIAL_FORM                        0xFEEB
#define unicode_ARABIC_LETTER_HEH_MEDIAL_FORM                         0xFEEC
#define unicode_ARABIC_LETTER_WAW_ISOLATED_FORM                       0xFEED
#define unicode_ARABIC_LETTER_WAW_FINAL_FORM                          0xFEEE
#define unicode_ARABIC_LETTER_ALEF_MAKSURA_ISOLATED_FORM              0xFEEF
#define unicode_ARABIC_LETTER_ALEF_MAKSURA_FINAL_FORM                 0xFEF0
#define unicode_ARABIC_LETTER_YEH_ISOLATED_FORM                       0xFEF1
#define unicode_ARABIC_LETTER_YEH_FINAL_FORM                          0xFEF2
#define unicode_ARABIC_LETTER_YEH_INITIAL_FORM                        0xFEF3
#define unicode_ARABIC_LETTER_YEH_MEDIAL_FORM                         0xFEF4
#define unicode_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_MADDA_ABOVE_ISOLATED_FORM 0xFEF5
#define unicode_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_MADDA_ABOVE_FINAL_FORM 0xFEF6
#define unicode_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_ABOVE_ISOLATED_FORM 0xFEF7
#define unicode_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_ABOVE_FINAL_FORM 0xFEF8
#define unicode_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_BELOW_ISOLATED_FORM 0xFEF9
#define unicode_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_BELOW_FINAL_FORM 0xFEFA
#define unicode_ARABIC_LIGATURE_LAM_WITH_ALEF_ISOLATED_FORM           0xFEFB
#define unicode_ARABIC_LIGATURE_LAM_WITH_ALEF_FINAL_FORM              0xFEFC
#define unicode_ZERO_WIDTH_NO_BREAK_SPACE                             0xFEFF
#define unicode_FULLWIDTH_EXCLAMATION_MARK                            0xFF01
#define unicode_FULLWIDTH_QUOTATION_MARK                              0xFF02
#define unicode_FULLWIDTH_NUMBER_SIGN                                 0xFF03
#define unicode_FULLWIDTH_DOLLAR_SIGN                                 0xFF04
#define unicode_FULLWIDTH_PERCENT_SIGN                                0xFF05
#define unicode_FULLWIDTH_AMPERSAND                                   0xFF06
#define unicode_FULLWIDTH_APOSTROPHE                                  0xFF07
#define unicode_FULLWIDTH_LEFT_PARENTHESIS                            0xFF08
#define unicode_FULLWIDTH_RIGHT_PARENTHESIS                           0xFF09
#define unicode_FULLWIDTH_ASTERISK                                    0xFF0A
#define unicode_FULLWIDTH_PLUS_SIGN                                   0xFF0B
#define unicode_FULLWIDTH_COMMA                                       0xFF0C
#define unicode_FULLWIDTH_HYPHEN_MINUS                                0xFF0D
#define unicode_FULLWIDTH_FULL_STOP                                   0xFF0E
#define unicode_FULLWIDTH_SOLIDUS                                     0xFF0F
#define unicode_FULLWIDTH_DIGIT_ZERO                                  0xFF10
#define unicode_FULLWIDTH_DIGIT_ONE                                   0xFF11
#define unicode_FULLWIDTH_DIGIT_TWO                                   0xFF12
#define unicode_FULLWIDTH_DIGIT_THREE                                 0xFF13
#define unicode_FULLWIDTH_DIGIT_FOUR                                  0xFF14
#define unicode_FULLWIDTH_DIGIT_FIVE                                  0xFF15
#define unicode_FULLWIDTH_DIGIT_SIX                                   0xFF16
#define unicode_FULLWIDTH_DIGIT_SEVEN                                 0xFF17
#define unicode_FULLWIDTH_DIGIT_EIGHT                                 0xFF18
#define unicode_FULLWIDTH_DIGIT_NINE                                  0xFF19
#define unicode_FULLWIDTH_COLON                                       0xFF1A
#define unicode_FULLWIDTH_SEMICOLON                                   0xFF1B
#define unicode_FULLWIDTH_LESS_THAN_SIGN                              0xFF1C
#define unicode_FULLWIDTH_EQUALS_SIGN                                 0xFF1D
#define unicode_FULLWIDTH_GREATER_THAN_SIGN                           0xFF1E
#define unicode_FULLWIDTH_QUESTION_MARK                               0xFF1F
#define unicode_FULLWIDTH_COMMERCIAL_AT                               0xFF20
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_A                      0xFF21
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_B                      0xFF22
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_C                      0xFF23
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_D                      0xFF24
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_E                      0xFF25
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_F                      0xFF26
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_G                      0xFF27
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_H                      0xFF28
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_I                      0xFF29
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_J                      0xFF2A
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_K                      0xFF2B
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_L                      0xFF2C
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_M                      0xFF2D
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_N                      0xFF2E
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_O                      0xFF2F
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_P                      0xFF30
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_Q                      0xFF31
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_R                      0xFF32
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_S                      0xFF33
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_T                      0xFF34
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_U                      0xFF35
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_V                      0xFF36
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_W                      0xFF37
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_X                      0xFF38
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_Y                      0xFF39
#define unicode_FULLWIDTH_LATIN_CAPITAL_LETTER_Z                      0xFF3A
#define unicode_FULLWIDTH_LEFT_SQUARE_BRACKET                         0xFF3B
#define unicode_FULLWIDTH_REVERSE_SOLIDUS                             0xFF3C
#define unicode_FULLWIDTH_RIGHT_SQUARE_BRACKET                        0xFF3D
#define unicode_FULLWIDTH_CIRCUMFLEX_ACCENT                           0xFF3E
#define unicode_FULLWIDTH_LOW_LINE                                    0xFF3F
#define unicode_FULLWIDTH_GRAVE_ACCENT                                0xFF40
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_A                        0xFF41
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_B                        0xFF42
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_C                        0xFF43
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_D                        0xFF44
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_E                        0xFF45
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_F                        0xFF46
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_G                        0xFF47
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_H                        0xFF48
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_I                        0xFF49
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_J                        0xFF4A
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_K                        0xFF4B
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_L                        0xFF4C
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_M                        0xFF4D
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_N                        0xFF4E
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_O                        0xFF4F
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_P                        0xFF50
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_Q                        0xFF51
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_R                        0xFF52
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_S                        0xFF53
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_T                        0xFF54
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_U                        0xFF55
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_V                        0xFF56
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_W                        0xFF57
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_X                        0xFF58
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_Y                        0xFF59
#define unicode_FULLWIDTH_LATIN_SMALL_LETTER_Z                        0xFF5A
#define unicode_FULLWIDTH_LEFT_CURLY_BRACKET                          0xFF5B
#define unicode_FULLWIDTH_VERTICAL_LINE                               0xFF5C
#define unicode_FULLWIDTH_RIGHT_CURLY_BRACKET                         0xFF5D
#define unicode_FULLWIDTH_TILDE                                       0xFF5E
#define unicode_FULLWIDTH_LEFT_WHITE_PARENTHESIS                      0xFF5F
#define unicode_FULLWIDTH_RIGHT_WHITE_PARENTHESIS                     0xFF60
#define unicode_HALFWIDTH_IDEOGRAPHIC_FULL_STOP                       0xFF61
#define unicode_HALFWIDTH_LEFT_CORNER_BRACKET                         0xFF62
#define unicode_HALFWIDTH_RIGHT_CORNER_BRACKET                        0xFF63
#define unicode_HALFWIDTH_IDEOGRAPHIC_COMMA                           0xFF64
#define unicode_HALFWIDTH_KATAKANA_MIDDLE_DOT                         0xFF65
#define unicode_HALFWIDTH_KATAKANA_LETTER_WO                          0xFF66
#define unicode_HALFWIDTH_KATAKANA_LETTER_SMALL_A                     0xFF67
#define unicode_HALFWIDTH_KATAKANA_LETTER_SMALL_I                     0xFF68
#define unicode_HALFWIDTH_KATAKANA_LETTER_SMALL_U                     0xFF69
#define unicode_HALFWIDTH_KATAKANA_LETTER_SMALL_E                     0xFF6A
#define unicode_HALFWIDTH_KATAKANA_LETTER_SMALL_O                     0xFF6B
#define unicode_HALFWIDTH_KATAKANA_LETTER_SMALL_YA                    0xFF6C
#define unicode_HALFWIDTH_KATAKANA_LETTER_SMALL_YU                    0xFF6D
#define unicode_HALFWIDTH_KATAKANA_LETTER_SMALL_YO                    0xFF6E
#define unicode_HALFWIDTH_KATAKANA_LETTER_SMALL_TU                    0xFF6F
#define unicode_HALFWIDTH_KATAKANA_HIRAGANA_PROLONGED_SOUND_MARK      0xFF70
#define unicode_HALFWIDTH_KATAKANA_LETTER_A                           0xFF71
#define unicode_HALFWIDTH_KATAKANA_LETTER_I                           0xFF72
#define unicode_HALFWIDTH_KATAKANA_LETTER_U                           0xFF73
#define unicode_HALFWIDTH_KATAKANA_LETTER_E                           0xFF74
#define unicode_HALFWIDTH_KATAKANA_LETTER_O                           0xFF75
#define unicode_HALFWIDTH_KATAKANA_LETTER_KA                          0xFF76
#define unicode_HALFWIDTH_KATAKANA_LETTER_KI                          0xFF77
#define unicode_HALFWIDTH_KATAKANA_LETTER_KU                          0xFF78
#define unicode_HALFWIDTH_KATAKANA_LETTER_KE                          0xFF79
#define unicode_HALFWIDTH_KATAKANA_LETTER_KO                          0xFF7A
#define unicode_HALFWIDTH_KATAKANA_LETTER_SA                          0xFF7B
#define unicode_HALFWIDTH_KATAKANA_LETTER_SI                          0xFF7C
#define unicode_HALFWIDTH_KATAKANA_LETTER_SU                          0xFF7D
#define unicode_HALFWIDTH_KATAKANA_LETTER_SE                          0xFF7E
#define unicode_HALFWIDTH_KATAKANA_LETTER_SO                          0xFF7F
#define unicode_HALFWIDTH_KATAKANA_LETTER_TA                          0xFF80
#define unicode_HALFWIDTH_KATAKANA_LETTER_TI                          0xFF81
#define unicode_HALFWIDTH_KATAKANA_LETTER_TU                          0xFF82
#define unicode_HALFWIDTH_KATAKANA_LETTER_TE                          0xFF83
#define unicode_HALFWIDTH_KATAKANA_LETTER_TO                          0xFF84
#define unicode_HALFWIDTH_KATAKANA_LETTER_NA                          0xFF85
#define unicode_HALFWIDTH_KATAKANA_LETTER_NI                          0xFF86
#define unicode_HALFWIDTH_KATAKANA_LETTER_NU                          0xFF87
#define unicode_HALFWIDTH_KATAKANA_LETTER_NE                          0xFF88
#define unicode_HALFWIDTH_KATAKANA_LETTER_NO                          0xFF89
#define unicode_HALFWIDTH_KATAKANA_LETTER_HA                          0xFF8A
#define unicode_HALFWIDTH_KATAKANA_LETTER_HI                          0xFF8B
#define unicode_HALFWIDTH_KATAKANA_LETTER_HU                          0xFF8C
#define unicode_HALFWIDTH_KATAKANA_LETTER_HE                          0xFF8D
#define unicode_HALFWIDTH_KATAKANA_LETTER_HO                          0xFF8E
#define unicode_HALFWIDTH_KATAKANA_LETTER_MA                          0xFF8F
#define unicode_HALFWIDTH_KATAKANA_LETTER_MI                          0xFF90
#define unicode_HALFWIDTH_KATAKANA_LETTER_MU                          0xFF91
#define unicode_HALFWIDTH_KATAKANA_LETTER_ME                          0xFF92
#define unicode_HALFWIDTH_KATAKANA_LETTER_MO                          0xFF93
#define unicode_HALFWIDTH_KATAKANA_LETTER_YA                          0xFF94
#define unicode_HALFWIDTH_KATAKANA_LETTER_YU                          0xFF95
#define unicode_HALFWIDTH_KATAKANA_LETTER_YO                          0xFF96
#define unicode_HALFWIDTH_KATAKANA_LETTER_RA                          0xFF97
#define unicode_HALFWIDTH_KATAKANA_LETTER_RI                          0xFF98
#define unicode_HALFWIDTH_KATAKANA_LETTER_RU                          0xFF99
#define unicode_HALFWIDTH_KATAKANA_LETTER_RE                          0xFF9A
#define unicode_HALFWIDTH_KATAKANA_LETTER_RO                          0xFF9B
#define unicode_HALFWIDTH_KATAKANA_LETTER_WA                          0xFF9C
#define unicode_HALFWIDTH_KATAKANA_LETTER_N                           0xFF9D
#define unicode_HALFWIDTH_KATAKANA_VOICED_SOUND_MARK                  0xFF9E
#define unicode_HALFWIDTH_KATAKANA_SEMI_VOICED_SOUND_MARK             0xFF9F
#define unicode_HALFWIDTH_HANGUL_FILLER                               0xFFA0
#define unicode_HALFWIDTH_HANGUL_LETTER_KIYEOK                        0xFFA1
#define unicode_HALFWIDTH_HANGUL_LETTER_SSANGKIYEOK                   0xFFA2
#define unicode_HALFWIDTH_HANGUL_LETTER_KIYEOK_SIOS                   0xFFA3
#define unicode_HALFWIDTH_HANGUL_LETTER_NIEUN                         0xFFA4
#define unicode_HALFWIDTH_HANGUL_LETTER_NIEUN_CIEUC                   0xFFA5
#define unicode_HALFWIDTH_HANGUL_LETTER_NIEUN_HIEUH                   0xFFA6
#define unicode_HALFWIDTH_HANGUL_LETTER_TIKEUT                        0xFFA7
#define unicode_HALFWIDTH_HANGUL_LETTER_SSANGTIKEUT                   0xFFA8
#define unicode_HALFWIDTH_HANGUL_LETTER_RIEUL                         0xFFA9
#define unicode_HALFWIDTH_HANGUL_LETTER_RIEUL_KIYEOK                  0xFFAA
#define unicode_HALFWIDTH_HANGUL_LETTER_RIEUL_MIEUM                   0xFFAB
#define unicode_HALFWIDTH_HANGUL_LETTER_RIEUL_PIEUP                   0xFFAC
#define unicode_HALFWIDTH_HANGUL_LETTER_RIEUL_SIOS                    0xFFAD
#define unicode_HALFWIDTH_HANGUL_LETTER_RIEUL_THIEUTH                 0xFFAE
#define unicode_HALFWIDTH_HANGUL_LETTER_RIEUL_PHIEUPH                 0xFFAF
#define unicode_HALFWIDTH_HANGUL_LETTER_RIEUL_HIEUH                   0xFFB0
#define unicode_HALFWIDTH_HANGUL_LETTER_MIEUM                         0xFFB1
#define unicode_HALFWIDTH_HANGUL_LETTER_PIEUP                         0xFFB2
#define unicode_HALFWIDTH_HANGUL_LETTER_SSANGPIEUP                    0xFFB3
#define unicode_HALFWIDTH_HANGUL_LETTER_PIEUP_SIOS                    0xFFB4
#define unicode_HALFWIDTH_HANGUL_LETTER_SIOS                          0xFFB5
#define unicode_HALFWIDTH_HANGUL_LETTER_SSANGSIOS                     0xFFB6
#define unicode_HALFWIDTH_HANGUL_LETTER_IEUNG                         0xFFB7
#define unicode_HALFWIDTH_HANGUL_LETTER_CIEUC                         0xFFB8
#define unicode_HALFWIDTH_HANGUL_LETTER_SSANGCIEUC                    0xFFB9
#define unicode_HALFWIDTH_HANGUL_LETTER_CHIEUCH                       0xFFBA
#define unicode_HALFWIDTH_HANGUL_LETTER_KHIEUKH                       0xFFBB
#define unicode_HALFWIDTH_HANGUL_LETTER_THIEUTH                       0xFFBC
#define unicode_HALFWIDTH_HANGUL_LETTER_PHIEUPH                       0xFFBD
#define unicode_HALFWIDTH_HANGUL_LETTER_HIEUH                         0xFFBE
#define unicode_HALFWIDTH_HANGUL_LETTER_A                             0xFFC2
#define unicode_HALFWIDTH_HANGUL_LETTER_AE                            0xFFC3
#define unicode_HALFWIDTH_HANGUL_LETTER_YA                            0xFFC4
#define unicode_HALFWIDTH_HANGUL_LETTER_YAE                           0xFFC5
#define unicode_HALFWIDTH_HANGUL_LETTER_EO                            0xFFC6
#define unicode_HALFWIDTH_HANGUL_LETTER_E                             0xFFC7
#define unicode_HALFWIDTH_HANGUL_LETTER_YEO                           0xFFCA
#define unicode_HALFWIDTH_HANGUL_LETTER_YE                            0xFFCB
#define unicode_HALFWIDTH_HANGUL_LETTER_O                             0xFFCC
#define unicode_HALFWIDTH_HANGUL_LETTER_WA                            0xFFCD
#define unicode_HALFWIDTH_HANGUL_LETTER_WAE                           0xFFCE
#define unicode_HALFWIDTH_HANGUL_LETTER_OE                            0xFFCF
#define unicode_HALFWIDTH_HANGUL_LETTER_YO                            0xFFD2
#define unicode_HALFWIDTH_HANGUL_LETTER_U                             0xFFD3
#define unicode_HALFWIDTH_HANGUL_LETTER_WEO                           0xFFD4
#define unicode_HALFWIDTH_HANGUL_LETTER_WE                            0xFFD5
#define unicode_HALFWIDTH_HANGUL_LETTER_WI                            0xFFD6
#define unicode_HALFWIDTH_HANGUL_LETTER_YU                            0xFFD7
#define unicode_HALFWIDTH_HANGUL_LETTER_EU                            0xFFDA
#define unicode_HALFWIDTH_HANGUL_LETTER_YI                            0xFFDB
#define unicode_HALFWIDTH_HANGUL_LETTER_I                             0xFFDC
#define unicode_FULLWIDTH_CENT_SIGN                                   0xFFE0
#define unicode_FULLWIDTH_POUND_SIGN                                  0xFFE1
#define unicode_FULLWIDTH_NOT_SIGN                                    0xFFE2
#define unicode_FULLWIDTH_MACRON                                      0xFFE3
#define unicode_FULLWIDTH_BROKEN_BAR                                  0xFFE4
#define unicode_FULLWIDTH_YEN_SIGN                                    0xFFE5
#define unicode_FULLWIDTH_WON_SIGN                                    0xFFE6
#define unicode_HALFWIDTH_FORMS_LIGHT_VERTICAL                        0xFFE8
#define unicode_HALFWIDTH_LEFTWARDS_ARROW                             0xFFE9
#define unicode_HALFWIDTH_UPWARDS_ARROW                               0xFFEA
#define unicode_HALFWIDTH_RIGHTWARDS_ARROW                            0xFFEB
#define unicode_HALFWIDTH_DOWNWARDS_ARROW                             0xFFEC
#define unicode_HALFWIDTH_BLACK_SQUARE                                0xFFED
#define unicode_HALFWIDTH_WHITE_CIRCLE                                0xFFEE
#define unicode_INTERLINEAR_ANNOTATION_ANCHOR                         0xFFF9
#define unicode_INTERLINEAR_ANNOTATION_SEPARATOR                      0xFFFA
#define unicode_INTERLINEAR_ANNOTATION_TERMINATOR                     0xFFFB
#define unicode_OBJECT_REPLACEMENT_CHARACTER                          0xFFFC
#define unicode_REPLACEMENT_CHARACTER                                 0xFFFD
#define unicode_LINEAR_B_SYLLABLE_B008_A                              0x10000
#define unicode_LINEAR_B_SYLLABLE_B038_E                              0x10001
#define unicode_LINEAR_B_SYLLABLE_B028_I                              0x10002
#define unicode_LINEAR_B_SYLLABLE_B061_O                              0x10003
#define unicode_LINEAR_B_SYLLABLE_B010_U                              0x10004
#define unicode_LINEAR_B_SYLLABLE_B001_DA                             0x10005
#define unicode_LINEAR_B_SYLLABLE_B045_DE                             0x10006
#define unicode_LINEAR_B_SYLLABLE_B007_DI                             0x10007
#define unicode_LINEAR_B_SYLLABLE_B014_DO                             0x10008
#define unicode_LINEAR_B_SYLLABLE_B051_DU                             0x10009
#define unicode_LINEAR_B_SYLLABLE_B057_JA                             0x1000A
#define unicode_LINEAR_B_SYLLABLE_B046_JE                             0x1000B
#define unicode_LINEAR_B_SYLLABLE_B036_JO                             0x1000D
#define unicode_LINEAR_B_SYLLABLE_B065_JU                             0x1000E
#define unicode_LINEAR_B_SYLLABLE_B077_KA                             0x1000F
#define unicode_LINEAR_B_SYLLABLE_B044_KE                             0x10010
#define unicode_LINEAR_B_SYLLABLE_B067_KI                             0x10011
#define unicode_LINEAR_B_SYLLABLE_B070_KO                             0x10012
#define unicode_LINEAR_B_SYLLABLE_B081_KU                             0x10013
#define unicode_LINEAR_B_SYLLABLE_B080_MA                             0x10014
#define unicode_LINEAR_B_SYLLABLE_B013_ME                             0x10015
#define unicode_LINEAR_B_SYLLABLE_B073_MI                             0x10016
#define unicode_LINEAR_B_SYLLABLE_B015_MO                             0x10017
#define unicode_LINEAR_B_SYLLABLE_B023_MU                             0x10018
#define unicode_LINEAR_B_SYLLABLE_B006_NA                             0x10019
#define unicode_LINEAR_B_SYLLABLE_B024_NE                             0x1001A
#define unicode_LINEAR_B_SYLLABLE_B030_NI                             0x1001B
#define unicode_LINEAR_B_SYLLABLE_B052_NO                             0x1001C
#define unicode_LINEAR_B_SYLLABLE_B055_NU                             0x1001D
#define unicode_LINEAR_B_SYLLABLE_B003_PA                             0x1001E
#define unicode_LINEAR_B_SYLLABLE_B072_PE                             0x1001F
#define unicode_LINEAR_B_SYLLABLE_B039_PI                             0x10020
#define unicode_LINEAR_B_SYLLABLE_B011_PO                             0x10021
#define unicode_LINEAR_B_SYLLABLE_B050_PU                             0x10022
#define unicode_LINEAR_B_SYLLABLE_B016_QA                             0x10023
#define unicode_LINEAR_B_SYLLABLE_B078_QE                             0x10024
#define unicode_LINEAR_B_SYLLABLE_B021_QI                             0x10025
#define unicode_LINEAR_B_SYLLABLE_B032_QO                             0x10026
#define unicode_LINEAR_B_SYLLABLE_B060_RA                             0x10028
#define unicode_LINEAR_B_SYLLABLE_B027_RE                             0x10029
#define unicode_LINEAR_B_SYLLABLE_B053_RI                             0x1002A
#define unicode_LINEAR_B_SYLLABLE_B002_RO                             0x1002B
#define unicode_LINEAR_B_SYLLABLE_B026_RU                             0x1002C
#define unicode_LINEAR_B_SYLLABLE_B031_SA                             0x1002D
#define unicode_LINEAR_B_SYLLABLE_B009_SE                             0x1002E
#define unicode_LINEAR_B_SYLLABLE_B041_SI                             0x1002F
#define unicode_LINEAR_B_SYLLABLE_B012_SO                             0x10030
#define unicode_LINEAR_B_SYLLABLE_B058_SU                             0x10031
#define unicode_LINEAR_B_SYLLABLE_B059_TA                             0x10032
#define unicode_LINEAR_B_SYLLABLE_B004_TE                             0x10033
#define unicode_LINEAR_B_SYLLABLE_B037_TI                             0x10034
#define unicode_LINEAR_B_SYLLABLE_B005_TO                             0x10035
#define unicode_LINEAR_B_SYLLABLE_B069_TU                             0x10036
#define unicode_LINEAR_B_SYLLABLE_B054_WA                             0x10037
#define unicode_LINEAR_B_SYLLABLE_B075_WE                             0x10038
#define unicode_LINEAR_B_SYLLABLE_B040_WI                             0x10039
#define unicode_LINEAR_B_SYLLABLE_B042_WO                             0x1003A
#define unicode_LINEAR_B_SYLLABLE_B017_ZA                             0x1003C
#define unicode_LINEAR_B_SYLLABLE_B074_ZE                             0x1003D
#define unicode_LINEAR_B_SYLLABLE_B020_ZO                             0x1003F
#define unicode_LINEAR_B_SYLLABLE_B025_A2                             0x10040
#define unicode_LINEAR_B_SYLLABLE_B043_A3                             0x10041
#define unicode_LINEAR_B_SYLLABLE_B085_AU                             0x10042
#define unicode_LINEAR_B_SYLLABLE_B071_DWE                            0x10043
#define unicode_LINEAR_B_SYLLABLE_B090_DWO                            0x10044
#define unicode_LINEAR_B_SYLLABLE_B048_NWA                            0x10045
#define unicode_LINEAR_B_SYLLABLE_B029_PU2                            0x10046
#define unicode_LINEAR_B_SYLLABLE_B062_PTE                            0x10047
#define unicode_LINEAR_B_SYLLABLE_B076_RA2                            0x10048
#define unicode_LINEAR_B_SYLLABLE_B033_RA3                            0x10049
#define unicode_LINEAR_B_SYLLABLE_B068_RO2                            0x1004A
#define unicode_LINEAR_B_SYLLABLE_B066_TA2                            0x1004B
#define unicode_LINEAR_B_SYLLABLE_B087_TWE                            0x1004C
#define unicode_LINEAR_B_SYLLABLE_B091_TWO                            0x1004D
#define unicode_LINEAR_B_SYMBOL_B018                                  0x10050
#define unicode_LINEAR_B_SYMBOL_B019                                  0x10051
#define unicode_LINEAR_B_SYMBOL_B022                                  0x10052
#define unicode_LINEAR_B_SYMBOL_B034                                  0x10053
#define unicode_LINEAR_B_SYMBOL_B047                                  0x10054
#define unicode_LINEAR_B_SYMBOL_B049                                  0x10055
#define unicode_LINEAR_B_SYMBOL_B056                                  0x10056
#define unicode_LINEAR_B_SYMBOL_B063                                  0x10057
#define unicode_LINEAR_B_SYMBOL_B064                                  0x10058
#define unicode_LINEAR_B_SYMBOL_B079                                  0x10059
#define unicode_LINEAR_B_SYMBOL_B082                                  0x1005A
#define unicode_LINEAR_B_SYMBOL_B083                                  0x1005B
#define unicode_LINEAR_B_SYMBOL_B086                                  0x1005C
#define unicode_LINEAR_B_SYMBOL_B089                                  0x1005D
#define unicode_LINEAR_B_IDEOGRAM_B100_MAN                            0x10080
#define unicode_LINEAR_B_IDEOGRAM_B102_WOMAN                          0x10081
#define unicode_LINEAR_B_IDEOGRAM_B104_DEER                           0x10082
#define unicode_LINEAR_B_IDEOGRAM_B105_EQUID                          0x10083
#define unicode_LINEAR_B_IDEOGRAM_B105F_MARE                          0x10084
#define unicode_LINEAR_B_IDEOGRAM_B105M_STALLION                      0x10085
#define unicode_LINEAR_B_IDEOGRAM_B106F_EWE                           0x10086
#define unicode_LINEAR_B_IDEOGRAM_B106M_RAM                           0x10087
#define unicode_LINEAR_B_IDEOGRAM_B107F_SHE_GOAT                      0x10088
#define unicode_LINEAR_B_IDEOGRAM_B107M_HE_GOAT                       0x10089
#define unicode_LINEAR_B_IDEOGRAM_B108F_SOW                           0x1008A
#define unicode_LINEAR_B_IDEOGRAM_B108M_BOAR                          0x1008B
#define unicode_LINEAR_B_IDEOGRAM_B109F_COW                           0x1008C
#define unicode_LINEAR_B_IDEOGRAM_B109M_BULL                          0x1008D
#define unicode_LINEAR_B_IDEOGRAM_B120_WHEAT                          0x1008E
#define unicode_LINEAR_B_IDEOGRAM_B121_BARLEY                         0x1008F
#define unicode_LINEAR_B_IDEOGRAM_B122_OLIVE                          0x10090
#define unicode_LINEAR_B_IDEOGRAM_B123_SPICE                          0x10091
#define unicode_LINEAR_B_IDEOGRAM_B125_CYPERUS                        0x10092
#define unicode_LINEAR_B_MONOGRAM_B127_KAPO                           0x10093
#define unicode_LINEAR_B_MONOGRAM_B128_KANAKO                         0x10094
#define unicode_LINEAR_B_IDEOGRAM_B130_OIL                            0x10095
#define unicode_LINEAR_B_IDEOGRAM_B131_WINE                           0x10096
#define unicode_LINEAR_B_IDEOGRAM_B132                                0x10097
#define unicode_LINEAR_B_MONOGRAM_B133_AREPA                          0x10098
#define unicode_LINEAR_B_MONOGRAM_B135_MERI                           0x10099
#define unicode_LINEAR_B_IDEOGRAM_B140_BRONZE                         0x1009A
#define unicode_LINEAR_B_IDEOGRAM_B141_GOLD                           0x1009B
#define unicode_LINEAR_B_IDEOGRAM_B142                                0x1009C
#define unicode_LINEAR_B_IDEOGRAM_B145_WOOL                           0x1009D
#define unicode_LINEAR_B_IDEOGRAM_B146                                0x1009E
#define unicode_LINEAR_B_IDEOGRAM_B150                                0x1009F
#define unicode_LINEAR_B_IDEOGRAM_B151_HORN                           0x100A0
#define unicode_LINEAR_B_IDEOGRAM_B152                                0x100A1
#define unicode_LINEAR_B_IDEOGRAM_B153                                0x100A2
#define unicode_LINEAR_B_IDEOGRAM_B154                                0x100A3
#define unicode_LINEAR_B_MONOGRAM_B156_TURO2                          0x100A4
#define unicode_LINEAR_B_IDEOGRAM_B157                                0x100A5
#define unicode_LINEAR_B_IDEOGRAM_B158                                0x100A6
#define unicode_LINEAR_B_IDEOGRAM_B159_CLOTH                          0x100A7
#define unicode_LINEAR_B_IDEOGRAM_B160                                0x100A8
#define unicode_LINEAR_B_IDEOGRAM_B161                                0x100A9
#define unicode_LINEAR_B_IDEOGRAM_B162_GARMENT                        0x100AA
#define unicode_LINEAR_B_IDEOGRAM_B163_ARMOUR                         0x100AB
#define unicode_LINEAR_B_IDEOGRAM_B164                                0x100AC
#define unicode_LINEAR_B_IDEOGRAM_B165                                0x100AD
#define unicode_LINEAR_B_IDEOGRAM_B166                                0x100AE
#define unicode_LINEAR_B_IDEOGRAM_B167                                0x100AF
#define unicode_LINEAR_B_IDEOGRAM_B168                                0x100B0
#define unicode_LINEAR_B_IDEOGRAM_B169                                0x100B1
#define unicode_LINEAR_B_IDEOGRAM_B170                                0x100B2
#define unicode_LINEAR_B_IDEOGRAM_B171                                0x100B3
#define unicode_LINEAR_B_IDEOGRAM_B172                                0x100B4
#define unicode_LINEAR_B_IDEOGRAM_B173_MONTH                          0x100B5
#define unicode_LINEAR_B_IDEOGRAM_B174                                0x100B6
#define unicode_LINEAR_B_IDEOGRAM_B176_TREE                           0x100B7
#define unicode_LINEAR_B_IDEOGRAM_B177                                0x100B8
#define unicode_LINEAR_B_IDEOGRAM_B178                                0x100B9
#define unicode_LINEAR_B_IDEOGRAM_B179                                0x100BA
#define unicode_LINEAR_B_IDEOGRAM_B180                                0x100BB
#define unicode_LINEAR_B_IDEOGRAM_B181                                0x100BC
#define unicode_LINEAR_B_IDEOGRAM_B182                                0x100BD
#define unicode_LINEAR_B_IDEOGRAM_B183                                0x100BE
#define unicode_LINEAR_B_IDEOGRAM_B184                                0x100BF
#define unicode_LINEAR_B_IDEOGRAM_B185                                0x100C0
#define unicode_LINEAR_B_IDEOGRAM_B189                                0x100C1
#define unicode_LINEAR_B_IDEOGRAM_B190                                0x100C2
#define unicode_LINEAR_B_IDEOGRAM_B191_HELMET                         0x100C3
#define unicode_LINEAR_B_IDEOGRAM_B220_FOOTSTOOL                      0x100C4
#define unicode_LINEAR_B_IDEOGRAM_B225_BATHTUB                        0x100C5
#define unicode_LINEAR_B_IDEOGRAM_B230_SPEAR                          0x100C6
#define unicode_LINEAR_B_IDEOGRAM_B231_ARROW                          0x100C7
#define unicode_LINEAR_B_IDEOGRAM_B232                                0x100C8
#define unicode_LINEAR_B_IDEOGRAM_B233_SWORD                          0x100C9
#define unicode_LINEAR_B_IDEOGRAM_B234                                0x100CA
#define unicode_LINEAR_B_IDEOGRAM_B236                                0x100CB
#define unicode_LINEAR_B_IDEOGRAM_B240_WHEELED_CHARIOT                0x100CC
#define unicode_LINEAR_B_IDEOGRAM_B241_CHARIOT                        0x100CD
#define unicode_LINEAR_B_IDEOGRAM_B242_CHARIOT_FRAME                  0x100CE
#define unicode_LINEAR_B_IDEOGRAM_B243_WHEEL                          0x100CF
#define unicode_LINEAR_B_IDEOGRAM_B245                                0x100D0
#define unicode_LINEAR_B_IDEOGRAM_B246                                0x100D1
#define unicode_LINEAR_B_MONOGRAM_B247_DIPTE                          0x100D2
#define unicode_LINEAR_B_IDEOGRAM_B248                                0x100D3
#define unicode_LINEAR_B_IDEOGRAM_B249                                0x100D4
#define unicode_LINEAR_B_IDEOGRAM_B251                                0x100D5
#define unicode_LINEAR_B_IDEOGRAM_B252                                0x100D6
#define unicode_LINEAR_B_IDEOGRAM_B253                                0x100D7
#define unicode_LINEAR_B_IDEOGRAM_B254_DART                           0x100D8
#define unicode_LINEAR_B_IDEOGRAM_B255                                0x100D9
#define unicode_LINEAR_B_IDEOGRAM_B256                                0x100DA
#define unicode_LINEAR_B_IDEOGRAM_B257                                0x100DB
#define unicode_LINEAR_B_IDEOGRAM_B258                                0x100DC
#define unicode_LINEAR_B_IDEOGRAM_B259                                0x100DD
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B155                         0x100DE
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B200                         0x100DF
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B201                         0x100E0
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B202                         0x100E1
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B203                         0x100E2
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B204                         0x100E3
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B205                         0x100E4
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B206                         0x100E5
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B207                         0x100E6
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B208                         0x100E7
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B209                         0x100E8
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B210                         0x100E9
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B211                         0x100EA
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B212                         0x100EB
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B213                         0x100EC
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B214                         0x100ED
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B215                         0x100EE
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B216                         0x100EF
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B217                         0x100F0
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B218                         0x100F1
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B219                         0x100F2
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B221                         0x100F3
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B222                         0x100F4
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B226                         0x100F5
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B227                         0x100F6
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B228                         0x100F7
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B229                         0x100F8
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B250                         0x100F9
#define unicode_LINEAR_B_IDEOGRAM_VESSEL_B305                         0x100FA
#define unicode_AEGEAN_WORD_SEPARATOR_LINE                            0x10100
#define unicode_AEGEAN_WORD_SEPARATOR_DOT                             0x10101
#define unicode_AEGEAN_CHECK_MARK                                     0x10102
#define unicode_AEGEAN_NUMBER_ONE                                     0x10107
#define unicode_AEGEAN_NUMBER_TWO                                     0x10108
#define unicode_AEGEAN_NUMBER_THREE                                   0x10109
#define unicode_AEGEAN_NUMBER_FOUR                                    0x1010A
#define unicode_AEGEAN_NUMBER_FIVE                                    0x1010B
#define unicode_AEGEAN_NUMBER_SIX                                     0x1010C
#define unicode_AEGEAN_NUMBER_SEVEN                                   0x1010D
#define unicode_AEGEAN_NUMBER_EIGHT                                   0x1010E
#define unicode_AEGEAN_NUMBER_NINE                                    0x1010F
#define unicode_AEGEAN_NUMBER_TEN                                     0x10110
#define unicode_AEGEAN_NUMBER_TWENTY                                  0x10111
#define unicode_AEGEAN_NUMBER_THIRTY                                  0x10112
#define unicode_AEGEAN_NUMBER_FORTY                                   0x10113
#define unicode_AEGEAN_NUMBER_FIFTY                                   0x10114
#define unicode_AEGEAN_NUMBER_SIXTY                                   0x10115
#define unicode_AEGEAN_NUMBER_SEVENTY                                 0x10116
#define unicode_AEGEAN_NUMBER_EIGHTY                                  0x10117
#define unicode_AEGEAN_NUMBER_NINETY                                  0x10118
#define unicode_AEGEAN_NUMBER_ONE_HUNDRED                             0x10119
#define unicode_AEGEAN_NUMBER_TWO_HUNDRED                             0x1011A
#define unicode_AEGEAN_NUMBER_THREE_HUNDRED                           0x1011B
#define unicode_AEGEAN_NUMBER_FOUR_HUNDRED                            0x1011C
#define unicode_AEGEAN_NUMBER_FIVE_HUNDRED                            0x1011D
#define unicode_AEGEAN_NUMBER_SIX_HUNDRED                             0x1011E
#define unicode_AEGEAN_NUMBER_SEVEN_HUNDRED                           0x1011F
#define unicode_AEGEAN_NUMBER_EIGHT_HUNDRED                           0x10120
#define unicode_AEGEAN_NUMBER_NINE_HUNDRED                            0x10121
#define unicode_AEGEAN_NUMBER_ONE_THOUSAND                            0x10122
#define unicode_AEGEAN_NUMBER_TWO_THOUSAND                            0x10123
#define unicode_AEGEAN_NUMBER_THREE_THOUSAND                          0x10124
#define unicode_AEGEAN_NUMBER_FOUR_THOUSAND                           0x10125
#define unicode_AEGEAN_NUMBER_FIVE_THOUSAND                           0x10126
#define unicode_AEGEAN_NUMBER_SIX_THOUSAND                            0x10127
#define unicode_AEGEAN_NUMBER_SEVEN_THOUSAND                          0x10128
#define unicode_AEGEAN_NUMBER_EIGHT_THOUSAND                          0x10129
#define unicode_AEGEAN_NUMBER_NINE_THOUSAND                           0x1012A
#define unicode_AEGEAN_NUMBER_TEN_THOUSAND                            0x1012B
#define unicode_AEGEAN_NUMBER_TWENTY_THOUSAND                         0x1012C
#define unicode_AEGEAN_NUMBER_THIRTY_THOUSAND                         0x1012D
#define unicode_AEGEAN_NUMBER_FORTY_THOUSAND                          0x1012E
#define unicode_AEGEAN_NUMBER_FIFTY_THOUSAND                          0x1012F
#define unicode_AEGEAN_NUMBER_SIXTY_THOUSAND                          0x10130
#define unicode_AEGEAN_NUMBER_SEVENTY_THOUSAND                        0x10131
#define unicode_AEGEAN_NUMBER_EIGHTY_THOUSAND                         0x10132
#define unicode_AEGEAN_NUMBER_NINETY_THOUSAND                         0x10133
#define unicode_AEGEAN_WEIGHT_BASE_UNIT                               0x10137
#define unicode_AEGEAN_WEIGHT_FIRST_SUBUNIT                           0x10138
#define unicode_AEGEAN_WEIGHT_SECOND_SUBUNIT                          0x10139
#define unicode_AEGEAN_WEIGHT_THIRD_SUBUNIT                           0x1013A
#define unicode_AEGEAN_WEIGHT_FOURTH_SUBUNIT                          0x1013B
#define unicode_AEGEAN_DRY_MEASURE_FIRST_SUBUNIT                      0x1013C
#define unicode_AEGEAN_LIQUID_MEASURE_FIRST_SUBUNIT                   0x1013D
#define unicode_AEGEAN_MEASURE_SECOND_SUBUNIT                         0x1013E
#define unicode_AEGEAN_MEASURE_THIRD_SUBUNIT                          0x1013F
#define unicode_GREEK_ACROPHONIC_ATTIC_ONE_QUARTER                    0x10140
#define unicode_GREEK_ACROPHONIC_ATTIC_ONE_HALF                       0x10141
#define unicode_GREEK_ACROPHONIC_ATTIC_ONE_DRACHMA                    0x10142
#define unicode_GREEK_ACROPHONIC_ATTIC_FIVE                           0x10143
#define unicode_GREEK_ACROPHONIC_ATTIC_FIFTY                          0x10144
#define unicode_GREEK_ACROPHONIC_ATTIC_FIVE_HUNDRED                   0x10145
#define unicode_GREEK_ACROPHONIC_ATTIC_FIVE_THOUSAND                  0x10146
#define unicode_GREEK_ACROPHONIC_ATTIC_FIFTY_THOUSAND                 0x10147
#define unicode_GREEK_ACROPHONIC_ATTIC_FIVE_TALENTS                   0x10148
#define unicode_GREEK_ACROPHONIC_ATTIC_TEN_TALENTS                    0x10149
#define unicode_GREEK_ACROPHONIC_ATTIC_FIFTY_TALENTS                  0x1014A
#define unicode_GREEK_ACROPHONIC_ATTIC_ONE_HUNDRED_TALENTS            0x1014B
#define unicode_GREEK_ACROPHONIC_ATTIC_FIVE_HUNDRED_TALENTS           0x1014C
#define unicode_GREEK_ACROPHONIC_ATTIC_ONE_THOUSAND_TALENTS           0x1014D
#define unicode_GREEK_ACROPHONIC_ATTIC_FIVE_THOUSAND_TALENTS          0x1014E
#define unicode_GREEK_ACROPHONIC_ATTIC_FIVE_STATERS                   0x1014F
#define unicode_GREEK_ACROPHONIC_ATTIC_TEN_STATERS                    0x10150
#define unicode_GREEK_ACROPHONIC_ATTIC_FIFTY_STATERS                  0x10151
#define unicode_GREEK_ACROPHONIC_ATTIC_ONE_HUNDRED_STATERS            0x10152
#define unicode_GREEK_ACROPHONIC_ATTIC_FIVE_HUNDRED_STATERS           0x10153
#define unicode_GREEK_ACROPHONIC_ATTIC_ONE_THOUSAND_STATERS           0x10154
#define unicode_GREEK_ACROPHONIC_ATTIC_TEN_THOUSAND_STATERS           0x10155
#define unicode_GREEK_ACROPHONIC_ATTIC_FIFTY_THOUSAND_STATERS         0x10156
#define unicode_GREEK_ACROPHONIC_ATTIC_TEN_MNAS                       0x10157
#define unicode_GREEK_ACROPHONIC_HERAEUM_ONE_PLETHRON                 0x10158
#define unicode_GREEK_ACROPHONIC_THESPIAN_ONE                         0x10159
#define unicode_GREEK_ACROPHONIC_HERMIONIAN_ONE                       0x1015A
#define unicode_GREEK_ACROPHONIC_EPIDAUREAN_TWO                       0x1015B
#define unicode_GREEK_ACROPHONIC_THESPIAN_TWO                         0x1015C
#define unicode_GREEK_ACROPHONIC_CYRENAIC_TWO_DRACHMAS                0x1015D
#define unicode_GREEK_ACROPHONIC_EPIDAUREAN_TWO_DRACHMAS              0x1015E
#define unicode_GREEK_ACROPHONIC_TROEZENIAN_FIVE                      0x1015F
#define unicode_GREEK_ACROPHONIC_TROEZENIAN_TEN                       0x10160
#define unicode_GREEK_ACROPHONIC_TROEZENIAN_TEN_ALTERNATE_FORM        0x10161
#define unicode_GREEK_ACROPHONIC_HERMIONIAN_TEN                       0x10162
#define unicode_GREEK_ACROPHONIC_MESSENIAN_TEN                        0x10163
#define unicode_GREEK_ACROPHONIC_THESPIAN_TEN                         0x10164
#define unicode_GREEK_ACROPHONIC_THESPIAN_THIRTY                      0x10165
#define unicode_GREEK_ACROPHONIC_TROEZENIAN_FIFTY                     0x10166
#define unicode_GREEK_ACROPHONIC_TROEZENIAN_FIFTY_ALTERNATE_FORM      0x10167
#define unicode_GREEK_ACROPHONIC_HERMIONIAN_FIFTY                     0x10168
#define unicode_GREEK_ACROPHONIC_THESPIAN_FIFTY                       0x10169
#define unicode_GREEK_ACROPHONIC_THESPIAN_ONE_HUNDRED                 0x1016A
#define unicode_GREEK_ACROPHONIC_THESPIAN_THREE_HUNDRED               0x1016B
#define unicode_GREEK_ACROPHONIC_EPIDAUREAN_FIVE_HUNDRED              0x1016C
#define unicode_GREEK_ACROPHONIC_TROEZENIAN_FIVE_HUNDRED              0x1016D
#define unicode_GREEK_ACROPHONIC_THESPIAN_FIVE_HUNDRED                0x1016E
#define unicode_GREEK_ACROPHONIC_CARYSTIAN_FIVE_HUNDRED               0x1016F
#define unicode_GREEK_ACROPHONIC_NAXIAN_FIVE_HUNDRED                  0x10170
#define unicode_GREEK_ACROPHONIC_THESPIAN_ONE_THOUSAND                0x10171
#define unicode_GREEK_ACROPHONIC_THESPIAN_FIVE_THOUSAND               0x10172
#define unicode_GREEK_ACROPHONIC_DELPHIC_FIVE_MNAS                    0x10173
#define unicode_GREEK_ACROPHONIC_STRATIAN_FIFTY_MNAS                  0x10174
#define unicode_GREEK_ONE_HALF_SIGN                                   0x10175
#define unicode_GREEK_ONE_HALF_SIGN_ALTERNATE_FORM                    0x10176
#define unicode_GREEK_TWO_THIRDS_SIGN                                 0x10177
#define unicode_GREEK_THREE_QUARTERS_SIGN                             0x10178
#define unicode_GREEK_YEAR_SIGN                                       0x10179
#define unicode_GREEK_TALENT_SIGN                                     0x1017A
#define unicode_GREEK_DRACHMA_SIGN                                    0x1017B
#define unicode_GREEK_OBOL_SIGN                                       0x1017C
#define unicode_GREEK_TWO_OBOLS_SIGN                                  0x1017D
#define unicode_GREEK_THREE_OBOLS_SIGN                                0x1017E
#define unicode_GREEK_FOUR_OBOLS_SIGN                                 0x1017F
#define unicode_GREEK_FIVE_OBOLS_SIGN                                 0x10180
#define unicode_GREEK_METRETES_SIGN                                   0x10181
#define unicode_GREEK_KYATHOS_BASE_SIGN                               0x10182
#define unicode_GREEK_LITRA_SIGN                                      0x10183
#define unicode_GREEK_OUNKIA_SIGN                                     0x10184
#define unicode_GREEK_XESTES_SIGN                                     0x10185
#define unicode_GREEK_ARTABE_SIGN                                     0x10186
#define unicode_GREEK_AROURA_SIGN                                     0x10187
#define unicode_GREEK_GRAMMA_SIGN                                     0x10188
#define unicode_GREEK_TRYBLION_BASE_SIGN                              0x10189
#define unicode_GREEK_ZERO_SIGN                                       0x1018A
#define unicode_GREEK_ONE_QUARTER_SIGN                                0x1018B
#define unicode_GREEK_SINUSOID_SIGN                                   0x1018C
#define unicode_ROMAN_SEXTANS_SIGN                                    0x10190
#define unicode_ROMAN_UNCIA_SIGN                                      0x10191
#define unicode_ROMAN_SEMUNCIA_SIGN                                   0x10192
#define unicode_ROMAN_SEXTULA_SIGN                                    0x10193
#define unicode_ROMAN_DIMIDIA_SEXTULA_SIGN                            0x10194
#define unicode_ROMAN_SILIQUA_SIGN                                    0x10195
#define unicode_ROMAN_DENARIUS_SIGN                                   0x10196
#define unicode_ROMAN_QUINARIUS_SIGN                                  0x10197
#define unicode_ROMAN_SESTERTIUS_SIGN                                 0x10198
#define unicode_ROMAN_DUPONDIUS_SIGN                                  0x10199
#define unicode_ROMAN_AS_SIGN                                         0x1019A
#define unicode_ROMAN_CENTURIAL_SIGN                                  0x1019B
#define unicode_GREEK_SYMBOL_TAU_RHO                                  0x101A0
#define unicode_PHAISTOS_DISC_SIGN_PEDESTRIAN                         0x101D0
#define unicode_PHAISTOS_DISC_SIGN_PLUMED_HEAD                        0x101D1
#define unicode_PHAISTOS_DISC_SIGN_TATTOOED_HEAD                      0x101D2
#define unicode_PHAISTOS_DISC_SIGN_CAPTIVE                            0x101D3
#define unicode_PHAISTOS_DISC_SIGN_CHILD                              0x101D4
#define unicode_PHAISTOS_DISC_SIGN_WOMAN                              0x101D5
#define unicode_PHAISTOS_DISC_SIGN_HELMET                             0x101D6
#define unicode_PHAISTOS_DISC_SIGN_GAUNTLET                           0x101D7
#define unicode_PHAISTOS_DISC_SIGN_TIARA                              0x101D8
#define unicode_PHAISTOS_DISC_SIGN_ARROW                              0x101D9
#define unicode_PHAISTOS_DISC_SIGN_BOW                                0x101DA
#define unicode_PHAISTOS_DISC_SIGN_SHIELD                             0x101DB
#define unicode_PHAISTOS_DISC_SIGN_CLUB                               0x101DC
#define unicode_PHAISTOS_DISC_SIGN_MANACLES                           0x101DD
#define unicode_PHAISTOS_DISC_SIGN_MATTOCK                            0x101DE
#define unicode_PHAISTOS_DISC_SIGN_SAW                                0x101DF
#define unicode_PHAISTOS_DISC_SIGN_LID                                0x101E0
#define unicode_PHAISTOS_DISC_SIGN_BOOMERANG                          0x101E1
#define unicode_PHAISTOS_DISC_SIGN_CARPENTRY_PLANE                    0x101E2
#define unicode_PHAISTOS_DISC_SIGN_DOLIUM                             0x101E3
#define unicode_PHAISTOS_DISC_SIGN_COMB                               0x101E4
#define unicode_PHAISTOS_DISC_SIGN_SLING                              0x101E5
#define unicode_PHAISTOS_DISC_SIGN_COLUMN                             0x101E6
#define unicode_PHAISTOS_DISC_SIGN_BEEHIVE                            0x101E7
#define unicode_PHAISTOS_DISC_SIGN_SHIP                               0x101E8
#define unicode_PHAISTOS_DISC_SIGN_HORN                               0x101E9
#define unicode_PHAISTOS_DISC_SIGN_HIDE                               0x101EA
#define unicode_PHAISTOS_DISC_SIGN_BULLS_LEG                          0x101EB
#define unicode_PHAISTOS_DISC_SIGN_CAT                                0x101EC
#define unicode_PHAISTOS_DISC_SIGN_RAM                                0x101ED
#define unicode_PHAISTOS_DISC_SIGN_EAGLE                              0x101EE
#define unicode_PHAISTOS_DISC_SIGN_DOVE                               0x101EF
#define unicode_PHAISTOS_DISC_SIGN_TUNNY                              0x101F0
#define unicode_PHAISTOS_DISC_SIGN_BEE                                0x101F1
#define unicode_PHAISTOS_DISC_SIGN_PLANE_TREE                         0x101F2
#define unicode_PHAISTOS_DISC_SIGN_VINE                               0x101F3
#define unicode_PHAISTOS_DISC_SIGN_PAPYRUS                            0x101F4
#define unicode_PHAISTOS_DISC_SIGN_ROSETTE                            0x101F5
#define unicode_PHAISTOS_DISC_SIGN_LILY                               0x101F6
#define unicode_PHAISTOS_DISC_SIGN_OX_BACK                            0x101F7
#define unicode_PHAISTOS_DISC_SIGN_FLUTE                              0x101F8
#define unicode_PHAISTOS_DISC_SIGN_GRATER                             0x101F9
#define unicode_PHAISTOS_DISC_SIGN_STRAINER                           0x101FA
#define unicode_PHAISTOS_DISC_SIGN_SMALL_AXE                          0x101FB
#define unicode_PHAISTOS_DISC_SIGN_WAVY_BAND                          0x101FC
#define unicode_PHAISTOS_DISC_SIGN_COMBINING_OBLIQUE_STROKE           0x101FD
#define unicode_LYCIAN_LETTER_A                                       0x10280
#define unicode_LYCIAN_LETTER_E                                       0x10281
#define unicode_LYCIAN_LETTER_B                                       0x10282
#define unicode_LYCIAN_LETTER_BH                                      0x10283
#define unicode_LYCIAN_LETTER_G                                       0x10284
#define unicode_LYCIAN_LETTER_D                                       0x10285
#define unicode_LYCIAN_LETTER_I                                       0x10286
#define unicode_LYCIAN_LETTER_W                                       0x10287
#define unicode_LYCIAN_LETTER_Z                                       0x10288
#define unicode_LYCIAN_LETTER_TH                                      0x10289
#define unicode_LYCIAN_LETTER_J                                       0x1028A
#define unicode_LYCIAN_LETTER_K                                       0x1028B
#define unicode_LYCIAN_LETTER_Q                                       0x1028C
#define unicode_LYCIAN_LETTER_L                                       0x1028D
#define unicode_LYCIAN_LETTER_M                                       0x1028E
#define unicode_LYCIAN_LETTER_N                                       0x1028F
#define unicode_LYCIAN_LETTER_MM                                      0x10290
#define unicode_LYCIAN_LETTER_NN                                      0x10291
#define unicode_LYCIAN_LETTER_U                                       0x10292
#define unicode_LYCIAN_LETTER_P                                       0x10293
#define unicode_LYCIAN_LETTER_KK                                      0x10294
#define unicode_LYCIAN_LETTER_R                                       0x10295
#define unicode_LYCIAN_LETTER_S                                       0x10296
#define unicode_LYCIAN_LETTER_T                                       0x10297
#define unicode_LYCIAN_LETTER_TT                                      0x10298
#define unicode_LYCIAN_LETTER_AN                                      0x10299
#define unicode_LYCIAN_LETTER_EN                                      0x1029A
#define unicode_LYCIAN_LETTER_H                                       0x1029B
#define unicode_LYCIAN_LETTER_X                                       0x1029C
#define unicode_CARIAN_LETTER_A                                       0x102A0
#define unicode_CARIAN_LETTER_P2                                      0x102A1
#define unicode_CARIAN_LETTER_D                                       0x102A2
#define unicode_CARIAN_LETTER_L                                       0x102A3
#define unicode_CARIAN_LETTER_UUU                                     0x102A4
#define unicode_CARIAN_LETTER_R                                       0x102A5
#define unicode_CARIAN_LETTER_LD                                      0x102A6
#define unicode_CARIAN_LETTER_A2                                      0x102A7
#define unicode_CARIAN_LETTER_Q                                       0x102A8
#define unicode_CARIAN_LETTER_B                                       0x102A9
#define unicode_CARIAN_LETTER_M                                       0x102AA
#define unicode_CARIAN_LETTER_O                                       0x102AB
#define unicode_CARIAN_LETTER_D2                                      0x102AC
#define unicode_CARIAN_LETTER_T                                       0x102AD
#define unicode_CARIAN_LETTER_SH                                      0x102AE
#define unicode_CARIAN_LETTER_SH2                                     0x102AF
#define unicode_CARIAN_LETTER_S                                       0x102B0
#define unicode_CARIAN_LETTER_C_18                                    0x102B1
#define unicode_CARIAN_LETTER_U                                       0x102B2
#define unicode_CARIAN_LETTER_NN                                      0x102B3
#define unicode_CARIAN_LETTER_X                                       0x102B4
#define unicode_CARIAN_LETTER_N                                       0x102B5
#define unicode_CARIAN_LETTER_TT2                                     0x102B6
#define unicode_CARIAN_LETTER_P                                       0x102B7
#define unicode_CARIAN_LETTER_SS                                      0x102B8
#define unicode_CARIAN_LETTER_I                                       0x102B9
#define unicode_CARIAN_LETTER_E                                       0x102BA
#define unicode_CARIAN_LETTER_UUUU                                    0x102BB
#define unicode_CARIAN_LETTER_K                                       0x102BC
#define unicode_CARIAN_LETTER_K2                                      0x102BD
#define unicode_CARIAN_LETTER_ND                                      0x102BE
#define unicode_CARIAN_LETTER_UU                                      0x102BF
#define unicode_CARIAN_LETTER_G                                       0x102C0
#define unicode_CARIAN_LETTER_G2                                      0x102C1
#define unicode_CARIAN_LETTER_ST                                      0x102C2
#define unicode_CARIAN_LETTER_ST2                                     0x102C3
#define unicode_CARIAN_LETTER_NG                                      0x102C4
#define unicode_CARIAN_LETTER_II                                      0x102C5
#define unicode_CARIAN_LETTER_C_39                                    0x102C6
#define unicode_CARIAN_LETTER_TT                                      0x102C7
#define unicode_CARIAN_LETTER_UUU2                                    0x102C8
#define unicode_CARIAN_LETTER_RR                                      0x102C9
#define unicode_CARIAN_LETTER_MB                                      0x102CA
#define unicode_CARIAN_LETTER_MB2                                     0x102CB
#define unicode_CARIAN_LETTER_MB3                                     0x102CC
#define unicode_CARIAN_LETTER_MB4                                     0x102CD
#define unicode_CARIAN_LETTER_LD2                                     0x102CE
#define unicode_CARIAN_LETTER_E2                                      0x102CF
#define unicode_CARIAN_LETTER_UUU3                                    0x102D0
#define unicode_COPTIC_EPACT_THOUSANDS_MARK                           0x102E0
#define unicode_COPTIC_EPACT_DIGIT_ONE                                0x102E1
#define unicode_COPTIC_EPACT_DIGIT_TWO                                0x102E2
#define unicode_COPTIC_EPACT_DIGIT_THREE                              0x102E3
#define unicode_COPTIC_EPACT_DIGIT_FOUR                               0x102E4
#define unicode_COPTIC_EPACT_DIGIT_FIVE                               0x102E5
#define unicode_COPTIC_EPACT_DIGIT_SIX                                0x102E6
#define unicode_COPTIC_EPACT_DIGIT_SEVEN                              0x102E7
#define unicode_COPTIC_EPACT_DIGIT_EIGHT                              0x102E8
#define unicode_COPTIC_EPACT_DIGIT_NINE                               0x102E9
#define unicode_COPTIC_EPACT_NUMBER_TEN                               0x102EA
#define unicode_COPTIC_EPACT_NUMBER_TWENTY                            0x102EB
#define unicode_COPTIC_EPACT_NUMBER_THIRTY                            0x102EC
#define unicode_COPTIC_EPACT_NUMBER_FORTY                             0x102ED
#define unicode_COPTIC_EPACT_NUMBER_FIFTY                             0x102EE
#define unicode_COPTIC_EPACT_NUMBER_SIXTY                             0x102EF
#define unicode_COPTIC_EPACT_NUMBER_SEVENTY                           0x102F0
#define unicode_COPTIC_EPACT_NUMBER_EIGHTY                            0x102F1
#define unicode_COPTIC_EPACT_NUMBER_NINETY                            0x102F2
#define unicode_COPTIC_EPACT_NUMBER_ONE_HUNDRED                       0x102F3
#define unicode_COPTIC_EPACT_NUMBER_TWO_HUNDRED                       0x102F4
#define unicode_COPTIC_EPACT_NUMBER_THREE_HUNDRED                     0x102F5
#define unicode_COPTIC_EPACT_NUMBER_FOUR_HUNDRED                      0x102F6
#define unicode_COPTIC_EPACT_NUMBER_FIVE_HUNDRED                      0x102F7
#define unicode_COPTIC_EPACT_NUMBER_SIX_HUNDRED                       0x102F8
#define unicode_COPTIC_EPACT_NUMBER_SEVEN_HUNDRED                     0x102F9
#define unicode_COPTIC_EPACT_NUMBER_EIGHT_HUNDRED                     0x102FA
#define unicode_COPTIC_EPACT_NUMBER_NINE_HUNDRED                      0x102FB
#define unicode_OLD_ITALIC_LETTER_A                                   0x10300
#define unicode_OLD_ITALIC_LETTER_BE                                  0x10301
#define unicode_OLD_ITALIC_LETTER_KE                                  0x10302
#define unicode_OLD_ITALIC_LETTER_DE                                  0x10303
#define unicode_OLD_ITALIC_LETTER_E                                   0x10304
#define unicode_OLD_ITALIC_LETTER_VE                                  0x10305
#define unicode_OLD_ITALIC_LETTER_ZE                                  0x10306
#define unicode_OLD_ITALIC_LETTER_HE                                  0x10307
#define unicode_OLD_ITALIC_LETTER_THE                                 0x10308
#define unicode_OLD_ITALIC_LETTER_I                                   0x10309
#define unicode_OLD_ITALIC_LETTER_KA                                  0x1030A
#define unicode_OLD_ITALIC_LETTER_EL                                  0x1030B
#define unicode_OLD_ITALIC_LETTER_EM                                  0x1030C
#define unicode_OLD_ITALIC_LETTER_EN                                  0x1030D
#define unicode_OLD_ITALIC_LETTER_ESH                                 0x1030E
#define unicode_OLD_ITALIC_LETTER_O                                   0x1030F
#define unicode_OLD_ITALIC_LETTER_PE                                  0x10310
#define unicode_OLD_ITALIC_LETTER_SHE                                 0x10311
#define unicode_OLD_ITALIC_LETTER_KU                                  0x10312
#define unicode_OLD_ITALIC_LETTER_ER                                  0x10313
#define unicode_OLD_ITALIC_LETTER_ES                                  0x10314
#define unicode_OLD_ITALIC_LETTER_TE                                  0x10315
#define unicode_OLD_ITALIC_LETTER_U                                   0x10316
#define unicode_OLD_ITALIC_LETTER_EKS                                 0x10317
#define unicode_OLD_ITALIC_LETTER_PHE                                 0x10318
#define unicode_OLD_ITALIC_LETTER_KHE                                 0x10319
#define unicode_OLD_ITALIC_LETTER_EF                                  0x1031A
#define unicode_OLD_ITALIC_LETTER_ERS                                 0x1031B
#define unicode_OLD_ITALIC_LETTER_CHE                                 0x1031C
#define unicode_OLD_ITALIC_LETTER_II                                  0x1031D
#define unicode_OLD_ITALIC_LETTER_UU                                  0x1031E
#define unicode_OLD_ITALIC_LETTER_ESS                                 0x1031F
#define unicode_OLD_ITALIC_NUMERAL_ONE                                0x10320
#define unicode_OLD_ITALIC_NUMERAL_FIVE                               0x10321
#define unicode_OLD_ITALIC_NUMERAL_TEN                                0x10322
#define unicode_OLD_ITALIC_NUMERAL_FIFTY                              0x10323
#define unicode_GOTHIC_LETTER_AHSA                                    0x10330
#define unicode_GOTHIC_LETTER_BAIRKAN                                 0x10331
#define unicode_GOTHIC_LETTER_GIBA                                    0x10332
#define unicode_GOTHIC_LETTER_DAGS                                    0x10333
#define unicode_GOTHIC_LETTER_AIHVUS                                  0x10334
#define unicode_GOTHIC_LETTER_QAIRTHRA                                0x10335
#define unicode_GOTHIC_LETTER_IUJA                                    0x10336
#define unicode_GOTHIC_LETTER_HAGL                                    0x10337
#define unicode_GOTHIC_LETTER_THIUTH                                  0x10338
#define unicode_GOTHIC_LETTER_EIS                                     0x10339
#define unicode_GOTHIC_LETTER_KUSMA                                   0x1033A
#define unicode_GOTHIC_LETTER_LAGUS                                   0x1033B
#define unicode_GOTHIC_LETTER_MANNA                                   0x1033C
#define unicode_GOTHIC_LETTER_NAUTHS                                  0x1033D
#define unicode_GOTHIC_LETTER_JER                                     0x1033E
#define unicode_GOTHIC_LETTER_URUS                                    0x1033F
#define unicode_GOTHIC_LETTER_PAIRTHRA                                0x10340
#define unicode_GOTHIC_LETTER_NINETY                                  0x10341
#define unicode_GOTHIC_LETTER_RAIDA                                   0x10342
#define unicode_GOTHIC_LETTER_SAUIL                                   0x10343
#define unicode_GOTHIC_LETTER_TEIWS                                   0x10344
#define unicode_GOTHIC_LETTER_WINJA                                   0x10345
#define unicode_GOTHIC_LETTER_FAIHU                                   0x10346
#define unicode_GOTHIC_LETTER_IGGWS                                   0x10347
#define unicode_GOTHIC_LETTER_HWAIR                                   0x10348
#define unicode_GOTHIC_LETTER_OTHAL                                   0x10349
#define unicode_GOTHIC_LETTER_NINE_HUNDRED                            0x1034A
#define unicode_OLD_PERMIC_LETTER_AN                                  0x10350
#define unicode_OLD_PERMIC_LETTER_BUR                                 0x10351
#define unicode_OLD_PERMIC_LETTER_GAI                                 0x10352
#define unicode_OLD_PERMIC_LETTER_DOI                                 0x10353
#define unicode_OLD_PERMIC_LETTER_E                                   0x10354
#define unicode_OLD_PERMIC_LETTER_ZHOI                                0x10355
#define unicode_OLD_PERMIC_LETTER_DZHOI                               0x10356
#define unicode_OLD_PERMIC_LETTER_ZATA                                0x10357
#define unicode_OLD_PERMIC_LETTER_DZITA                               0x10358
#define unicode_OLD_PERMIC_LETTER_I                                   0x10359
#define unicode_OLD_PERMIC_LETTER_KOKE                                0x1035A
#define unicode_OLD_PERMIC_LETTER_LEI                                 0x1035B
#define unicode_OLD_PERMIC_LETTER_MENOE                               0x1035C
#define unicode_OLD_PERMIC_LETTER_NENOE                               0x1035D
#define unicode_OLD_PERMIC_LETTER_VOOI                                0x1035E
#define unicode_OLD_PERMIC_LETTER_PEEI                                0x1035F
#define unicode_OLD_PERMIC_LETTER_REI                                 0x10360
#define unicode_OLD_PERMIC_LETTER_SII                                 0x10361
#define unicode_OLD_PERMIC_LETTER_TAI                                 0x10362
#define unicode_OLD_PERMIC_LETTER_U                                   0x10363
#define unicode_OLD_PERMIC_LETTER_CHERY                               0x10364
#define unicode_OLD_PERMIC_LETTER_SHOOI                               0x10365
#define unicode_OLD_PERMIC_LETTER_SHCHOOI                             0x10366
#define unicode_OLD_PERMIC_LETTER_YRY                                 0x10367
#define unicode_OLD_PERMIC_LETTER_YERU                                0x10368
#define unicode_OLD_PERMIC_LETTER_O                                   0x10369
#define unicode_OLD_PERMIC_LETTER_OO                                  0x1036A
#define unicode_OLD_PERMIC_LETTER_EF                                  0x1036B
#define unicode_OLD_PERMIC_LETTER_HA                                  0x1036C
#define unicode_OLD_PERMIC_LETTER_TSIU                                0x1036D
#define unicode_OLD_PERMIC_LETTER_VER                                 0x1036E
#define unicode_OLD_PERMIC_LETTER_YER                                 0x1036F
#define unicode_OLD_PERMIC_LETTER_YERI                                0x10370
#define unicode_OLD_PERMIC_LETTER_YAT                                 0x10371
#define unicode_OLD_PERMIC_LETTER_IE                                  0x10372
#define unicode_OLD_PERMIC_LETTER_YU                                  0x10373
#define unicode_OLD_PERMIC_LETTER_YA                                  0x10374
#define unicode_OLD_PERMIC_LETTER_IA                                  0x10375
#define unicode_COMBINING_OLD_PERMIC_LETTER_AN                        0x10376
#define unicode_COMBINING_OLD_PERMIC_LETTER_DOI                       0x10377
#define unicode_COMBINING_OLD_PERMIC_LETTER_ZATA                      0x10378
#define unicode_COMBINING_OLD_PERMIC_LETTER_NENOE                     0x10379
#define unicode_COMBINING_OLD_PERMIC_LETTER_SII                       0x1037A
#define unicode_UGARITIC_LETTER_ALPA                                  0x10380
#define unicode_UGARITIC_LETTER_BETA                                  0x10381
#define unicode_UGARITIC_LETTER_GAMLA                                 0x10382
#define unicode_UGARITIC_LETTER_KHA                                   0x10383
#define unicode_UGARITIC_LETTER_DELTA                                 0x10384
#define unicode_UGARITIC_LETTER_HO                                    0x10385
#define unicode_UGARITIC_LETTER_WO                                    0x10386
#define unicode_UGARITIC_LETTER_ZETA                                  0x10387
#define unicode_UGARITIC_LETTER_HOTA                                  0x10388
#define unicode_UGARITIC_LETTER_TET                                   0x10389
#define unicode_UGARITIC_LETTER_YOD                                   0x1038A
#define unicode_UGARITIC_LETTER_KAF                                   0x1038B
#define unicode_UGARITIC_LETTER_SHIN                                  0x1038C
#define unicode_UGARITIC_LETTER_LAMDA                                 0x1038D
#define unicode_UGARITIC_LETTER_MEM                                   0x1038E
#define unicode_UGARITIC_LETTER_DHAL                                  0x1038F
#define unicode_UGARITIC_LETTER_NUN                                   0x10390
#define unicode_UGARITIC_LETTER_ZU                                    0x10391
#define unicode_UGARITIC_LETTER_SAMKA                                 0x10392
#define unicode_UGARITIC_LETTER_AIN                                   0x10393
#define unicode_UGARITIC_LETTER_PU                                    0x10394
#define unicode_UGARITIC_LETTER_SADE                                  0x10395
#define unicode_UGARITIC_LETTER_QOPA                                  0x10396
#define unicode_UGARITIC_LETTER_RASHA                                 0x10397
#define unicode_UGARITIC_LETTER_THANNA                                0x10398
#define unicode_UGARITIC_LETTER_GHAIN                                 0x10399
#define unicode_UGARITIC_LETTER_TO                                    0x1039A
#define unicode_UGARITIC_LETTER_I                                     0x1039B
#define unicode_UGARITIC_LETTER_U                                     0x1039C
#define unicode_UGARITIC_LETTER_SSU                                   0x1039D
#define unicode_UGARITIC_WORD_DIVIDER                                 0x1039F
#define unicode_OLD_PERSIAN_SIGN_A                                    0x103A0
#define unicode_OLD_PERSIAN_SIGN_I                                    0x103A1
#define unicode_OLD_PERSIAN_SIGN_U                                    0x103A2
#define unicode_OLD_PERSIAN_SIGN_KA                                   0x103A3
#define unicode_OLD_PERSIAN_SIGN_KU                                   0x103A4
#define unicode_OLD_PERSIAN_SIGN_GA                                   0x103A5
#define unicode_OLD_PERSIAN_SIGN_GU                                   0x103A6
#define unicode_OLD_PERSIAN_SIGN_XA                                   0x103A7
#define unicode_OLD_PERSIAN_SIGN_CA                                   0x103A8
#define unicode_OLD_PERSIAN_SIGN_JA                                   0x103A9
#define unicode_OLD_PERSIAN_SIGN_JI                                   0x103AA
#define unicode_OLD_PERSIAN_SIGN_TA                                   0x103AB
#define unicode_OLD_PERSIAN_SIGN_TU                                   0x103AC
#define unicode_OLD_PERSIAN_SIGN_DA                                   0x103AD
#define unicode_OLD_PERSIAN_SIGN_DI                                   0x103AE
#define unicode_OLD_PERSIAN_SIGN_DU                                   0x103AF
#define unicode_OLD_PERSIAN_SIGN_THA                                  0x103B0
#define unicode_OLD_PERSIAN_SIGN_PA                                   0x103B1
#define unicode_OLD_PERSIAN_SIGN_BA                                   0x103B2
#define unicode_OLD_PERSIAN_SIGN_FA                                   0x103B3
#define unicode_OLD_PERSIAN_SIGN_NA                                   0x103B4
#define unicode_OLD_PERSIAN_SIGN_NU                                   0x103B5
#define unicode_OLD_PERSIAN_SIGN_MA                                   0x103B6
#define unicode_OLD_PERSIAN_SIGN_MI                                   0x103B7
#define unicode_OLD_PERSIAN_SIGN_MU                                   0x103B8
#define unicode_OLD_PERSIAN_SIGN_YA                                   0x103B9
#define unicode_OLD_PERSIAN_SIGN_VA                                   0x103BA
#define unicode_OLD_PERSIAN_SIGN_VI                                   0x103BB
#define unicode_OLD_PERSIAN_SIGN_RA                                   0x103BC
#define unicode_OLD_PERSIAN_SIGN_RU                                   0x103BD
#define unicode_OLD_PERSIAN_SIGN_LA                                   0x103BE
#define unicode_OLD_PERSIAN_SIGN_SA                                   0x103BF
#define unicode_OLD_PERSIAN_SIGN_ZA                                   0x103C0
#define unicode_OLD_PERSIAN_SIGN_SHA                                  0x103C1
#define unicode_OLD_PERSIAN_SIGN_SSA                                  0x103C2
#define unicode_OLD_PERSIAN_SIGN_HA                                   0x103C3
#define unicode_OLD_PERSIAN_SIGN_AURAMAZDAA                           0x103C8
#define unicode_OLD_PERSIAN_SIGN_AURAMAZDAA_2                         0x103C9
#define unicode_OLD_PERSIAN_SIGN_AURAMAZDAAHA                         0x103CA
#define unicode_OLD_PERSIAN_SIGN_XSHAAYATHIYA                         0x103CB
#define unicode_OLD_PERSIAN_SIGN_DAHYAAUSH                            0x103CC
#define unicode_OLD_PERSIAN_SIGN_DAHYAAUSH_2                          0x103CD
#define unicode_OLD_PERSIAN_SIGN_BAGA                                 0x103CE
#define unicode_OLD_PERSIAN_SIGN_BUUMISH                              0x103CF
#define unicode_OLD_PERSIAN_WORD_DIVIDER                              0x103D0
#define unicode_OLD_PERSIAN_NUMBER_ONE                                0x103D1
#define unicode_OLD_PERSIAN_NUMBER_TWO                                0x103D2
#define unicode_OLD_PERSIAN_NUMBER_TEN                                0x103D3
#define unicode_OLD_PERSIAN_NUMBER_TWENTY                             0x103D4
#define unicode_OLD_PERSIAN_NUMBER_HUNDRED                            0x103D5
#define unicode_DESERET_CAPITAL_LETTER_LONG_I                         0x10400
#define unicode_DESERET_CAPITAL_LETTER_LONG_E                         0x10401
#define unicode_DESERET_CAPITAL_LETTER_LONG_A                         0x10402
#define unicode_DESERET_CAPITAL_LETTER_LONG_AH                        0x10403
#define unicode_DESERET_CAPITAL_LETTER_LONG_O                         0x10404
#define unicode_DESERET_CAPITAL_LETTER_LONG_OO                        0x10405
#define unicode_DESERET_CAPITAL_LETTER_SHORT_I                        0x10406
#define unicode_DESERET_CAPITAL_LETTER_SHORT_E                        0x10407
#define unicode_DESERET_CAPITAL_LETTER_SHORT_A                        0x10408
#define unicode_DESERET_CAPITAL_LETTER_SHORT_AH                       0x10409
#define unicode_DESERET_CAPITAL_LETTER_SHORT_O                        0x1040A
#define unicode_DESERET_CAPITAL_LETTER_SHORT_OO                       0x1040B
#define unicode_DESERET_CAPITAL_LETTER_AY                             0x1040C
#define unicode_DESERET_CAPITAL_LETTER_OW                             0x1040D
#define unicode_DESERET_CAPITAL_LETTER_WU                             0x1040E
#define unicode_DESERET_CAPITAL_LETTER_YEE                            0x1040F
#define unicode_DESERET_CAPITAL_LETTER_H                              0x10410
#define unicode_DESERET_CAPITAL_LETTER_PEE                            0x10411
#define unicode_DESERET_CAPITAL_LETTER_BEE                            0x10412
#define unicode_DESERET_CAPITAL_LETTER_TEE                            0x10413
#define unicode_DESERET_CAPITAL_LETTER_DEE                            0x10414
#define unicode_DESERET_CAPITAL_LETTER_CHEE                           0x10415
#define unicode_DESERET_CAPITAL_LETTER_JEE                            0x10416
#define unicode_DESERET_CAPITAL_LETTER_KAY                            0x10417
#define unicode_DESERET_CAPITAL_LETTER_GAY                            0x10418
#define unicode_DESERET_CAPITAL_LETTER_EF                             0x10419
#define unicode_DESERET_CAPITAL_LETTER_VEE                            0x1041A
#define unicode_DESERET_CAPITAL_LETTER_ETH                            0x1041B
#define unicode_DESERET_CAPITAL_LETTER_THEE                           0x1041C
#define unicode_DESERET_CAPITAL_LETTER_ES                             0x1041D
#define unicode_DESERET_CAPITAL_LETTER_ZEE                            0x1041E
#define unicode_DESERET_CAPITAL_LETTER_ESH                            0x1041F
#define unicode_DESERET_CAPITAL_LETTER_ZHEE                           0x10420
#define unicode_DESERET_CAPITAL_LETTER_ER                             0x10421
#define unicode_DESERET_CAPITAL_LETTER_EL                             0x10422
#define unicode_DESERET_CAPITAL_LETTER_EM                             0x10423
#define unicode_DESERET_CAPITAL_LETTER_EN                             0x10424
#define unicode_DESERET_CAPITAL_LETTER_ENG                            0x10425
#define unicode_DESERET_CAPITAL_LETTER_OI                             0x10426
#define unicode_DESERET_CAPITAL_LETTER_EW                             0x10427
#define unicode_DESERET_SMALL_LETTER_LONG_I                           0x10428
#define unicode_DESERET_SMALL_LETTER_LONG_E                           0x10429
#define unicode_DESERET_SMALL_LETTER_LONG_A                           0x1042A
#define unicode_DESERET_SMALL_LETTER_LONG_AH                          0x1042B
#define unicode_DESERET_SMALL_LETTER_LONG_O                           0x1042C
#define unicode_DESERET_SMALL_LETTER_LONG_OO                          0x1042D
#define unicode_DESERET_SMALL_LETTER_SHORT_I                          0x1042E
#define unicode_DESERET_SMALL_LETTER_SHORT_E                          0x1042F
#define unicode_DESERET_SMALL_LETTER_SHORT_A                          0x10430
#define unicode_DESERET_SMALL_LETTER_SHORT_AH                         0x10431
#define unicode_DESERET_SMALL_LETTER_SHORT_O                          0x10432
#define unicode_DESERET_SMALL_LETTER_SHORT_OO                         0x10433
#define unicode_DESERET_SMALL_LETTER_AY                               0x10434
#define unicode_DESERET_SMALL_LETTER_OW                               0x10435
#define unicode_DESERET_SMALL_LETTER_WU                               0x10436
#define unicode_DESERET_SMALL_LETTER_YEE                              0x10437
#define unicode_DESERET_SMALL_LETTER_H                                0x10438
#define unicode_DESERET_SMALL_LETTER_PEE                              0x10439
#define unicode_DESERET_SMALL_LETTER_BEE                              0x1043A
#define unicode_DESERET_SMALL_LETTER_TEE                              0x1043B
#define unicode_DESERET_SMALL_LETTER_DEE                              0x1043C
#define unicode_DESERET_SMALL_LETTER_CHEE                             0x1043D
#define unicode_DESERET_SMALL_LETTER_JEE                              0x1043E
#define unicode_DESERET_SMALL_LETTER_KAY                              0x1043F
#define unicode_DESERET_SMALL_LETTER_GAY                              0x10440
#define unicode_DESERET_SMALL_LETTER_EF                               0x10441
#define unicode_DESERET_SMALL_LETTER_VEE                              0x10442
#define unicode_DESERET_SMALL_LETTER_ETH                              0x10443
#define unicode_DESERET_SMALL_LETTER_THEE                             0x10444
#define unicode_DESERET_SMALL_LETTER_ES                               0x10445
#define unicode_DESERET_SMALL_LETTER_ZEE                              0x10446
#define unicode_DESERET_SMALL_LETTER_ESH                              0x10447
#define unicode_DESERET_SMALL_LETTER_ZHEE                             0x10448
#define unicode_DESERET_SMALL_LETTER_ER                               0x10449
#define unicode_DESERET_SMALL_LETTER_EL                               0x1044A
#define unicode_DESERET_SMALL_LETTER_EM                               0x1044B
#define unicode_DESERET_SMALL_LETTER_EN                               0x1044C
#define unicode_DESERET_SMALL_LETTER_ENG                              0x1044D
#define unicode_DESERET_SMALL_LETTER_OI                               0x1044E
#define unicode_DESERET_SMALL_LETTER_EW                               0x1044F
#define unicode_SHAVIAN_LETTER_PEEP                                   0x10450
#define unicode_SHAVIAN_LETTER_TOT                                    0x10451
#define unicode_SHAVIAN_LETTER_KICK                                   0x10452
#define unicode_SHAVIAN_LETTER_FEE                                    0x10453
#define unicode_SHAVIAN_LETTER_THIGH                                  0x10454
#define unicode_SHAVIAN_LETTER_SO                                     0x10455
#define unicode_SHAVIAN_LETTER_SURE                                   0x10456
#define unicode_SHAVIAN_LETTER_CHURCH                                 0x10457
#define unicode_SHAVIAN_LETTER_YEA                                    0x10458
#define unicode_SHAVIAN_LETTER_HUNG                                   0x10459
#define unicode_SHAVIAN_LETTER_BIB                                    0x1045A
#define unicode_SHAVIAN_LETTER_DEAD                                   0x1045B
#define unicode_SHAVIAN_LETTER_GAG                                    0x1045C
#define unicode_SHAVIAN_LETTER_VOW                                    0x1045D
#define unicode_SHAVIAN_LETTER_THEY                                   0x1045E
#define unicode_SHAVIAN_LETTER_ZOO                                    0x1045F
#define unicode_SHAVIAN_LETTER_MEASURE                                0x10460
#define unicode_SHAVIAN_LETTER_JUDGE                                  0x10461
#define unicode_SHAVIAN_LETTER_WOE                                    0x10462
#define unicode_SHAVIAN_LETTER_HA_HA                                  0x10463
#define unicode_SHAVIAN_LETTER_LOLL                                   0x10464
#define unicode_SHAVIAN_LETTER_MIME                                   0x10465
#define unicode_SHAVIAN_LETTER_IF                                     0x10466
#define unicode_SHAVIAN_LETTER_EGG                                    0x10467
#define unicode_SHAVIAN_LETTER_ASH                                    0x10468
#define unicode_SHAVIAN_LETTER_ADO                                    0x10469
#define unicode_SHAVIAN_LETTER_ON                                     0x1046A
#define unicode_SHAVIAN_LETTER_WOOL                                   0x1046B
#define unicode_SHAVIAN_LETTER_OUT                                    0x1046C
#define unicode_SHAVIAN_LETTER_AH                                     0x1046D
#define unicode_SHAVIAN_LETTER_ROAR                                   0x1046E
#define unicode_SHAVIAN_LETTER_NUN                                    0x1046F
#define unicode_SHAVIAN_LETTER_EAT                                    0x10470
#define unicode_SHAVIAN_LETTER_AGE                                    0x10471
#define unicode_SHAVIAN_LETTER_ICE                                    0x10472
#define unicode_SHAVIAN_LETTER_UP                                     0x10473
#define unicode_SHAVIAN_LETTER_OAK                                    0x10474
#define unicode_SHAVIAN_LETTER_OOZE                                   0x10475
#define unicode_SHAVIAN_LETTER_OIL                                    0x10476
#define unicode_SHAVIAN_LETTER_AWE                                    0x10477
#define unicode_SHAVIAN_LETTER_ARE                                    0x10478
#define unicode_SHAVIAN_LETTER_OR                                     0x10479
#define unicode_SHAVIAN_LETTER_AIR                                    0x1047A
#define unicode_SHAVIAN_LETTER_ERR                                    0x1047B
#define unicode_SHAVIAN_LETTER_ARRAY                                  0x1047C
#define unicode_SHAVIAN_LETTER_EAR                                    0x1047D
#define unicode_SHAVIAN_LETTER_IAN                                    0x1047E
#define unicode_SHAVIAN_LETTER_YEW                                    0x1047F
#define unicode_OSMANYA_LETTER_ALEF                                   0x10480
#define unicode_OSMANYA_LETTER_BA                                     0x10481
#define unicode_OSMANYA_LETTER_TA                                     0x10482
#define unicode_OSMANYA_LETTER_JA                                     0x10483
#define unicode_OSMANYA_LETTER_XA                                     0x10484
#define unicode_OSMANYA_LETTER_KHA                                    0x10485
#define unicode_OSMANYA_LETTER_DEEL                                   0x10486
#define unicode_OSMANYA_LETTER_RA                                     0x10487
#define unicode_OSMANYA_LETTER_SA                                     0x10488
#define unicode_OSMANYA_LETTER_SHIIN                                  0x10489
#define unicode_OSMANYA_LETTER_DHA                                    0x1048A
#define unicode_OSMANYA_LETTER_CAYN                                   0x1048B
#define unicode_OSMANYA_LETTER_GA                                     0x1048C
#define unicode_OSMANYA_LETTER_FA                                     0x1048D
#define unicode_OSMANYA_LETTER_QAAF                                   0x1048E
#define unicode_OSMANYA_LETTER_KAAF                                   0x1048F
#define unicode_OSMANYA_LETTER_LAAN                                   0x10490
#define unicode_OSMANYA_LETTER_MIIN                                   0x10491
#define unicode_OSMANYA_LETTER_NUUN                                   0x10492
#define unicode_OSMANYA_LETTER_WAW                                    0x10493
#define unicode_OSMANYA_LETTER_HA                                     0x10494
#define unicode_OSMANYA_LETTER_YA                                     0x10495
#define unicode_OSMANYA_LETTER_A                                      0x10496
#define unicode_OSMANYA_LETTER_E                                      0x10497
#define unicode_OSMANYA_LETTER_I                                      0x10498
#define unicode_OSMANYA_LETTER_O                                      0x10499
#define unicode_OSMANYA_LETTER_U                                      0x1049A
#define unicode_OSMANYA_LETTER_AA                                     0x1049B
#define unicode_OSMANYA_LETTER_EE                                     0x1049C
#define unicode_OSMANYA_LETTER_OO                                     0x1049D
#define unicode_OSMANYA_DIGIT_ZERO                                    0x104A0
#define unicode_OSMANYA_DIGIT_ONE                                     0x104A1
#define unicode_OSMANYA_DIGIT_TWO                                     0x104A2
#define unicode_OSMANYA_DIGIT_THREE                                   0x104A3
#define unicode_OSMANYA_DIGIT_FOUR                                    0x104A4
#define unicode_OSMANYA_DIGIT_FIVE                                    0x104A5
#define unicode_OSMANYA_DIGIT_SIX                                     0x104A6
#define unicode_OSMANYA_DIGIT_SEVEN                                   0x104A7
#define unicode_OSMANYA_DIGIT_EIGHT                                   0x104A8
#define unicode_OSMANYA_DIGIT_NINE                                    0x104A9
#define unicode_ELBASAN_LETTER_A                                      0x10500
#define unicode_ELBASAN_LETTER_BE                                     0x10501
#define unicode_ELBASAN_LETTER_CE                                     0x10502
#define unicode_ELBASAN_LETTER_CHE                                    0x10503
#define unicode_ELBASAN_LETTER_DE                                     0x10504
#define unicode_ELBASAN_LETTER_NDE                                    0x10505
#define unicode_ELBASAN_LETTER_DHE                                    0x10506
#define unicode_ELBASAN_LETTER_EI                                     0x10507
#define unicode_ELBASAN_LETTER_E                                      0x10508
#define unicode_ELBASAN_LETTER_FE                                     0x10509
#define unicode_ELBASAN_LETTER_GE                                     0x1050A
#define unicode_ELBASAN_LETTER_GJE                                    0x1050B
#define unicode_ELBASAN_LETTER_HE                                     0x1050C
#define unicode_ELBASAN_LETTER_I                                      0x1050D
#define unicode_ELBASAN_LETTER_JE                                     0x1050E
#define unicode_ELBASAN_LETTER_KE                                     0x1050F
#define unicode_ELBASAN_LETTER_LE                                     0x10510
#define unicode_ELBASAN_LETTER_LLE                                    0x10511
#define unicode_ELBASAN_LETTER_ME                                     0x10512
#define unicode_ELBASAN_LETTER_NE                                     0x10513
#define unicode_ELBASAN_LETTER_NA                                     0x10514
#define unicode_ELBASAN_LETTER_NJE                                    0x10515
#define unicode_ELBASAN_LETTER_O                                      0x10516
#define unicode_ELBASAN_LETTER_PE                                     0x10517
#define unicode_ELBASAN_LETTER_QE                                     0x10518
#define unicode_ELBASAN_LETTER_RE                                     0x10519
#define unicode_ELBASAN_LETTER_RRE                                    0x1051A
#define unicode_ELBASAN_LETTER_SE                                     0x1051B
#define unicode_ELBASAN_LETTER_SHE                                    0x1051C
#define unicode_ELBASAN_LETTER_TE                                     0x1051D
#define unicode_ELBASAN_LETTER_THE                                    0x1051E
#define unicode_ELBASAN_LETTER_U                                      0x1051F
#define unicode_ELBASAN_LETTER_VE                                     0x10520
#define unicode_ELBASAN_LETTER_XE                                     0x10521
#define unicode_ELBASAN_LETTER_Y                                      0x10522
#define unicode_ELBASAN_LETTER_ZE                                     0x10523
#define unicode_ELBASAN_LETTER_ZHE                                    0x10524
#define unicode_ELBASAN_LETTER_GHE                                    0x10525
#define unicode_ELBASAN_LETTER_GHAMMA                                 0x10526
#define unicode_ELBASAN_LETTER_KHE                                    0x10527
#define unicode_CAUCASIAN_ALBANIAN_LETTER_ALT                         0x10530
#define unicode_CAUCASIAN_ALBANIAN_LETTER_BET                         0x10531
#define unicode_CAUCASIAN_ALBANIAN_LETTER_GIM                         0x10532
#define unicode_CAUCASIAN_ALBANIAN_LETTER_DAT                         0x10533
#define unicode_CAUCASIAN_ALBANIAN_LETTER_EB                          0x10534
#define unicode_CAUCASIAN_ALBANIAN_LETTER_ZARL                        0x10535
#define unicode_CAUCASIAN_ALBANIAN_LETTER_EYN                         0x10536
#define unicode_CAUCASIAN_ALBANIAN_LETTER_ZHIL                        0x10537
#define unicode_CAUCASIAN_ALBANIAN_LETTER_TAS                         0x10538
#define unicode_CAUCASIAN_ALBANIAN_LETTER_CHA                         0x10539
#define unicode_CAUCASIAN_ALBANIAN_LETTER_YOWD                        0x1053A
#define unicode_CAUCASIAN_ALBANIAN_LETTER_ZHA                         0x1053B
#define unicode_CAUCASIAN_ALBANIAN_LETTER_IRB                         0x1053C
#define unicode_CAUCASIAN_ALBANIAN_LETTER_SHA                         0x1053D
#define unicode_CAUCASIAN_ALBANIAN_LETTER_LAN                         0x1053E
#define unicode_CAUCASIAN_ALBANIAN_LETTER_INYA                        0x1053F
#define unicode_CAUCASIAN_ALBANIAN_LETTER_XEYN                        0x10540
#define unicode_CAUCASIAN_ALBANIAN_LETTER_DYAN                        0x10541
#define unicode_CAUCASIAN_ALBANIAN_LETTER_CAR                         0x10542
#define unicode_CAUCASIAN_ALBANIAN_LETTER_JHOX                        0x10543
#define unicode_CAUCASIAN_ALBANIAN_LETTER_KAR                         0x10544
#define unicode_CAUCASIAN_ALBANIAN_LETTER_LYIT                        0x10545
#define unicode_CAUCASIAN_ALBANIAN_LETTER_HEYT                        0x10546
#define unicode_CAUCASIAN_ALBANIAN_LETTER_QAY                         0x10547
#define unicode_CAUCASIAN_ALBANIAN_LETTER_AOR                         0x10548
#define unicode_CAUCASIAN_ALBANIAN_LETTER_CHOY                        0x10549
#define unicode_CAUCASIAN_ALBANIAN_LETTER_CHI                         0x1054A
#define unicode_CAUCASIAN_ALBANIAN_LETTER_CYAY                        0x1054B
#define unicode_CAUCASIAN_ALBANIAN_LETTER_MAQ                         0x1054C
#define unicode_CAUCASIAN_ALBANIAN_LETTER_QAR                         0x1054D
#define unicode_CAUCASIAN_ALBANIAN_LETTER_NOWC                        0x1054E
#define unicode_CAUCASIAN_ALBANIAN_LETTER_DZYAY                       0x1054F
#define unicode_CAUCASIAN_ALBANIAN_LETTER_SHAK                        0x10550
#define unicode_CAUCASIAN_ALBANIAN_LETTER_JAYN                        0x10551
#define unicode_CAUCASIAN_ALBANIAN_LETTER_ON                          0x10552
#define unicode_CAUCASIAN_ALBANIAN_LETTER_TYAY                        0x10553
#define unicode_CAUCASIAN_ALBANIAN_LETTER_FAM                         0x10554
#define unicode_CAUCASIAN_ALBANIAN_LETTER_DZAY                        0x10555
#define unicode_CAUCASIAN_ALBANIAN_LETTER_CHAT                        0x10556
#define unicode_CAUCASIAN_ALBANIAN_LETTER_PEN                         0x10557
#define unicode_CAUCASIAN_ALBANIAN_LETTER_GHEYS                       0x10558
#define unicode_CAUCASIAN_ALBANIAN_LETTER_RAT                         0x10559
#define unicode_CAUCASIAN_ALBANIAN_LETTER_SEYK                        0x1055A
#define unicode_CAUCASIAN_ALBANIAN_LETTER_VEYZ                        0x1055B
#define unicode_CAUCASIAN_ALBANIAN_LETTER_TIWR                        0x1055C
#define unicode_CAUCASIAN_ALBANIAN_LETTER_SHOY                        0x1055D
#define unicode_CAUCASIAN_ALBANIAN_LETTER_IWN                         0x1055E
#define unicode_CAUCASIAN_ALBANIAN_LETTER_CYAW                        0x1055F
#define unicode_CAUCASIAN_ALBANIAN_LETTER_CAYN                        0x10560
#define unicode_CAUCASIAN_ALBANIAN_LETTER_YAYD                        0x10561
#define unicode_CAUCASIAN_ALBANIAN_LETTER_PIWR                        0x10562
#define unicode_CAUCASIAN_ALBANIAN_LETTER_KIW                         0x10563
#define unicode_CAUCASIAN_ALBANIAN_CITATION_MARK                      0x1056F
#define unicode_LINEAR_A_SIGN_AB001                                   0x10600
#define unicode_LINEAR_A_SIGN_AB002                                   0x10601
#define unicode_LINEAR_A_SIGN_AB003                                   0x10602
#define unicode_LINEAR_A_SIGN_AB004                                   0x10603
#define unicode_LINEAR_A_SIGN_AB005                                   0x10604
#define unicode_LINEAR_A_SIGN_AB006                                   0x10605
#define unicode_LINEAR_A_SIGN_AB007                                   0x10606
#define unicode_LINEAR_A_SIGN_AB008                                   0x10607
#define unicode_LINEAR_A_SIGN_AB009                                   0x10608
#define unicode_LINEAR_A_SIGN_AB010                                   0x10609
#define unicode_LINEAR_A_SIGN_AB011                                   0x1060A
#define unicode_LINEAR_A_SIGN_AB013                                   0x1060B
#define unicode_LINEAR_A_SIGN_AB016                                   0x1060C
#define unicode_LINEAR_A_SIGN_AB017                                   0x1060D
#define unicode_LINEAR_A_SIGN_AB020                                   0x1060E
#define unicode_LINEAR_A_SIGN_AB021                                   0x1060F
#define unicode_LINEAR_A_SIGN_AB021F                                  0x10610
#define unicode_LINEAR_A_SIGN_AB021M                                  0x10611
#define unicode_LINEAR_A_SIGN_AB022                                   0x10612
#define unicode_LINEAR_A_SIGN_AB022F                                  0x10613
#define unicode_LINEAR_A_SIGN_AB022M                                  0x10614
#define unicode_LINEAR_A_SIGN_AB023                                   0x10615
#define unicode_LINEAR_A_SIGN_AB023M                                  0x10616
#define unicode_LINEAR_A_SIGN_AB024                                   0x10617
#define unicode_LINEAR_A_SIGN_AB026                                   0x10618
#define unicode_LINEAR_A_SIGN_AB027                                   0x10619
#define unicode_LINEAR_A_SIGN_AB028                                   0x1061A
#define unicode_LINEAR_A_SIGN_A028B                                   0x1061B
#define unicode_LINEAR_A_SIGN_AB029                                   0x1061C
#define unicode_LINEAR_A_SIGN_AB030                                   0x1061D
#define unicode_LINEAR_A_SIGN_AB031                                   0x1061E
#define unicode_LINEAR_A_SIGN_AB034                                   0x1061F
#define unicode_LINEAR_A_SIGN_AB037                                   0x10620
#define unicode_LINEAR_A_SIGN_AB038                                   0x10621
#define unicode_LINEAR_A_SIGN_AB039                                   0x10622
#define unicode_LINEAR_A_SIGN_AB040                                   0x10623
#define unicode_LINEAR_A_SIGN_AB041                                   0x10624
#define unicode_LINEAR_A_SIGN_AB044                                   0x10625
#define unicode_LINEAR_A_SIGN_AB045                                   0x10626
#define unicode_LINEAR_A_SIGN_AB046                                   0x10627
#define unicode_LINEAR_A_SIGN_AB047                                   0x10628
#define unicode_LINEAR_A_SIGN_AB048                                   0x10629
#define unicode_LINEAR_A_SIGN_AB049                                   0x1062A
#define unicode_LINEAR_A_SIGN_AB050                                   0x1062B
#define unicode_LINEAR_A_SIGN_AB051                                   0x1062C
#define unicode_LINEAR_A_SIGN_AB053                                   0x1062D
#define unicode_LINEAR_A_SIGN_AB054                                   0x1062E
#define unicode_LINEAR_A_SIGN_AB055                                   0x1062F
#define unicode_LINEAR_A_SIGN_AB056                                   0x10630
#define unicode_LINEAR_A_SIGN_AB057                                   0x10631
#define unicode_LINEAR_A_SIGN_AB058                                   0x10632
#define unicode_LINEAR_A_SIGN_AB059                                   0x10633
#define unicode_LINEAR_A_SIGN_AB060                                   0x10634
#define unicode_LINEAR_A_SIGN_AB061                                   0x10635
#define unicode_LINEAR_A_SIGN_AB065                                   0x10636
#define unicode_LINEAR_A_SIGN_AB066                                   0x10637
#define unicode_LINEAR_A_SIGN_AB067                                   0x10638
#define unicode_LINEAR_A_SIGN_AB069                                   0x10639
#define unicode_LINEAR_A_SIGN_AB070                                   0x1063A
#define unicode_LINEAR_A_SIGN_AB073                                   0x1063B
#define unicode_LINEAR_A_SIGN_AB074                                   0x1063C
#define unicode_LINEAR_A_SIGN_AB076                                   0x1063D
#define unicode_LINEAR_A_SIGN_AB077                                   0x1063E
#define unicode_LINEAR_A_SIGN_AB078                                   0x1063F
#define unicode_LINEAR_A_SIGN_AB079                                   0x10640
#define unicode_LINEAR_A_SIGN_AB080                                   0x10641
#define unicode_LINEAR_A_SIGN_AB081                                   0x10642
#define unicode_LINEAR_A_SIGN_AB082                                   0x10643
#define unicode_LINEAR_A_SIGN_AB085                                   0x10644
#define unicode_LINEAR_A_SIGN_AB086                                   0x10645
#define unicode_LINEAR_A_SIGN_AB087                                   0x10646
#define unicode_LINEAR_A_SIGN_A100_102                                0x10647
#define unicode_LINEAR_A_SIGN_AB118                                   0x10648
#define unicode_LINEAR_A_SIGN_AB120                                   0x10649
#define unicode_LINEAR_A_SIGN_A120B                                   0x1064A
#define unicode_LINEAR_A_SIGN_AB122                                   0x1064B
#define unicode_LINEAR_A_SIGN_AB123                                   0x1064C
#define unicode_LINEAR_A_SIGN_AB131A                                  0x1064D
#define unicode_LINEAR_A_SIGN_AB131B                                  0x1064E
#define unicode_LINEAR_A_SIGN_A131C                                   0x1064F
#define unicode_LINEAR_A_SIGN_AB164                                   0x10650
#define unicode_LINEAR_A_SIGN_AB171                                   0x10651
#define unicode_LINEAR_A_SIGN_AB180                                   0x10652
#define unicode_LINEAR_A_SIGN_AB188                                   0x10653
#define unicode_LINEAR_A_SIGN_AB191                                   0x10654
#define unicode_LINEAR_A_SIGN_A301                                    0x10655
#define unicode_LINEAR_A_SIGN_A302                                    0x10656
#define unicode_LINEAR_A_SIGN_A303                                    0x10657
#define unicode_LINEAR_A_SIGN_A304                                    0x10658
#define unicode_LINEAR_A_SIGN_A305                                    0x10659
#define unicode_LINEAR_A_SIGN_A306                                    0x1065A
#define unicode_LINEAR_A_SIGN_A307                                    0x1065B
#define unicode_LINEAR_A_SIGN_A308                                    0x1065C
#define unicode_LINEAR_A_SIGN_A309A                                   0x1065D
#define unicode_LINEAR_A_SIGN_A309B                                   0x1065E
#define unicode_LINEAR_A_SIGN_A309C                                   0x1065F
#define unicode_LINEAR_A_SIGN_A310                                    0x10660
#define unicode_LINEAR_A_SIGN_A311                                    0x10661
#define unicode_LINEAR_A_SIGN_A312                                    0x10662
#define unicode_LINEAR_A_SIGN_A313A                                   0x10663
#define unicode_LINEAR_A_SIGN_A313B                                   0x10664
#define unicode_LINEAR_A_SIGN_A313C                                   0x10665
#define unicode_LINEAR_A_SIGN_A314                                    0x10666
#define unicode_LINEAR_A_SIGN_A315                                    0x10667
#define unicode_LINEAR_A_SIGN_A316                                    0x10668
#define unicode_LINEAR_A_SIGN_A317                                    0x10669
#define unicode_LINEAR_A_SIGN_A318                                    0x1066A
#define unicode_LINEAR_A_SIGN_A319                                    0x1066B
#define unicode_LINEAR_A_SIGN_A320                                    0x1066C
#define unicode_LINEAR_A_SIGN_A321                                    0x1066D
#define unicode_LINEAR_A_SIGN_A322                                    0x1066E
#define unicode_LINEAR_A_SIGN_A323                                    0x1066F
#define unicode_LINEAR_A_SIGN_A324                                    0x10670
#define unicode_LINEAR_A_SIGN_A325                                    0x10671
#define unicode_LINEAR_A_SIGN_A326                                    0x10672
#define unicode_LINEAR_A_SIGN_A327                                    0x10673
#define unicode_LINEAR_A_SIGN_A328                                    0x10674
#define unicode_LINEAR_A_SIGN_A329                                    0x10675
#define unicode_LINEAR_A_SIGN_A330                                    0x10676
#define unicode_LINEAR_A_SIGN_A331                                    0x10677
#define unicode_LINEAR_A_SIGN_A332                                    0x10678
#define unicode_LINEAR_A_SIGN_A333                                    0x10679
#define unicode_LINEAR_A_SIGN_A334                                    0x1067A
#define unicode_LINEAR_A_SIGN_A335                                    0x1067B
#define unicode_LINEAR_A_SIGN_A336                                    0x1067C
#define unicode_LINEAR_A_SIGN_A337                                    0x1067D
#define unicode_LINEAR_A_SIGN_A338                                    0x1067E
#define unicode_LINEAR_A_SIGN_A339                                    0x1067F
#define unicode_LINEAR_A_SIGN_A340                                    0x10680
#define unicode_LINEAR_A_SIGN_A341                                    0x10681
#define unicode_LINEAR_A_SIGN_A342                                    0x10682
#define unicode_LINEAR_A_SIGN_A343                                    0x10683
#define unicode_LINEAR_A_SIGN_A344                                    0x10684
#define unicode_LINEAR_A_SIGN_A345                                    0x10685
#define unicode_LINEAR_A_SIGN_A346                                    0x10686
#define unicode_LINEAR_A_SIGN_A347                                    0x10687
#define unicode_LINEAR_A_SIGN_A348                                    0x10688
#define unicode_LINEAR_A_SIGN_A349                                    0x10689
#define unicode_LINEAR_A_SIGN_A350                                    0x1068A
#define unicode_LINEAR_A_SIGN_A351                                    0x1068B
#define unicode_LINEAR_A_SIGN_A352                                    0x1068C
#define unicode_LINEAR_A_SIGN_A353                                    0x1068D
#define unicode_LINEAR_A_SIGN_A354                                    0x1068E
#define unicode_LINEAR_A_SIGN_A355                                    0x1068F
#define unicode_LINEAR_A_SIGN_A356                                    0x10690
#define unicode_LINEAR_A_SIGN_A357                                    0x10691
#define unicode_LINEAR_A_SIGN_A358                                    0x10692
#define unicode_LINEAR_A_SIGN_A359                                    0x10693
#define unicode_LINEAR_A_SIGN_A360                                    0x10694
#define unicode_LINEAR_A_SIGN_A361                                    0x10695
#define unicode_LINEAR_A_SIGN_A362                                    0x10696
#define unicode_LINEAR_A_SIGN_A363                                    0x10697
#define unicode_LINEAR_A_SIGN_A364                                    0x10698
#define unicode_LINEAR_A_SIGN_A365                                    0x10699
#define unicode_LINEAR_A_SIGN_A366                                    0x1069A
#define unicode_LINEAR_A_SIGN_A367                                    0x1069B
#define unicode_LINEAR_A_SIGN_A368                                    0x1069C
#define unicode_LINEAR_A_SIGN_A369                                    0x1069D
#define unicode_LINEAR_A_SIGN_A370                                    0x1069E
#define unicode_LINEAR_A_SIGN_A371                                    0x1069F
#define unicode_LINEAR_A_SIGN_A400_VAS                                0x106A0
#define unicode_LINEAR_A_SIGN_A401_VAS                                0x106A1
#define unicode_LINEAR_A_SIGN_A402_VAS                                0x106A2
#define unicode_LINEAR_A_SIGN_A403_VAS                                0x106A3
#define unicode_LINEAR_A_SIGN_A404_VAS                                0x106A4
#define unicode_LINEAR_A_SIGN_A405_VAS                                0x106A5
#define unicode_LINEAR_A_SIGN_A406_VAS                                0x106A6
#define unicode_LINEAR_A_SIGN_A407_VAS                                0x106A7
#define unicode_LINEAR_A_SIGN_A408_VAS                                0x106A8
#define unicode_LINEAR_A_SIGN_A409_VAS                                0x106A9
#define unicode_LINEAR_A_SIGN_A410_VAS                                0x106AA
#define unicode_LINEAR_A_SIGN_A411_VAS                                0x106AB
#define unicode_LINEAR_A_SIGN_A412_VAS                                0x106AC
#define unicode_LINEAR_A_SIGN_A413_VAS                                0x106AD
#define unicode_LINEAR_A_SIGN_A414_VAS                                0x106AE
#define unicode_LINEAR_A_SIGN_A415_VAS                                0x106AF
#define unicode_LINEAR_A_SIGN_A416_VAS                                0x106B0
#define unicode_LINEAR_A_SIGN_A417_VAS                                0x106B1
#define unicode_LINEAR_A_SIGN_A418_VAS                                0x106B2
#define unicode_LINEAR_A_SIGN_A501                                    0x106B3
#define unicode_LINEAR_A_SIGN_A502                                    0x106B4
#define unicode_LINEAR_A_SIGN_A503                                    0x106B5
#define unicode_LINEAR_A_SIGN_A504                                    0x106B6
#define unicode_LINEAR_A_SIGN_A505                                    0x106B7
#define unicode_LINEAR_A_SIGN_A506                                    0x106B8
#define unicode_LINEAR_A_SIGN_A508                                    0x106B9
#define unicode_LINEAR_A_SIGN_A509                                    0x106BA
#define unicode_LINEAR_A_SIGN_A510                                    0x106BB
#define unicode_LINEAR_A_SIGN_A511                                    0x106BC
#define unicode_LINEAR_A_SIGN_A512                                    0x106BD
#define unicode_LINEAR_A_SIGN_A513                                    0x106BE
#define unicode_LINEAR_A_SIGN_A515                                    0x106BF
#define unicode_LINEAR_A_SIGN_A516                                    0x106C0
#define unicode_LINEAR_A_SIGN_A520                                    0x106C1
#define unicode_LINEAR_A_SIGN_A521                                    0x106C2
#define unicode_LINEAR_A_SIGN_A523                                    0x106C3
#define unicode_LINEAR_A_SIGN_A524                                    0x106C4
#define unicode_LINEAR_A_SIGN_A525                                    0x106C5
#define unicode_LINEAR_A_SIGN_A526                                    0x106C6
#define unicode_LINEAR_A_SIGN_A527                                    0x106C7
#define unicode_LINEAR_A_SIGN_A528                                    0x106C8
#define unicode_LINEAR_A_SIGN_A529                                    0x106C9
#define unicode_LINEAR_A_SIGN_A530                                    0x106CA
#define unicode_LINEAR_A_SIGN_A531                                    0x106CB
#define unicode_LINEAR_A_SIGN_A532                                    0x106CC
#define unicode_LINEAR_A_SIGN_A534                                    0x106CD
#define unicode_LINEAR_A_SIGN_A535                                    0x106CE
#define unicode_LINEAR_A_SIGN_A536                                    0x106CF
#define unicode_LINEAR_A_SIGN_A537                                    0x106D0
#define unicode_LINEAR_A_SIGN_A538                                    0x106D1
#define unicode_LINEAR_A_SIGN_A539                                    0x106D2
#define unicode_LINEAR_A_SIGN_A540                                    0x106D3
#define unicode_LINEAR_A_SIGN_A541                                    0x106D4
#define unicode_LINEAR_A_SIGN_A542                                    0x106D5
#define unicode_LINEAR_A_SIGN_A545                                    0x106D6
#define unicode_LINEAR_A_SIGN_A547                                    0x106D7
#define unicode_LINEAR_A_SIGN_A548                                    0x106D8
#define unicode_LINEAR_A_SIGN_A549                                    0x106D9
#define unicode_LINEAR_A_SIGN_A550                                    0x106DA
#define unicode_LINEAR_A_SIGN_A551                                    0x106DB
#define unicode_LINEAR_A_SIGN_A552                                    0x106DC
#define unicode_LINEAR_A_SIGN_A553                                    0x106DD
#define unicode_LINEAR_A_SIGN_A554                                    0x106DE
#define unicode_LINEAR_A_SIGN_A555                                    0x106DF
#define unicode_LINEAR_A_SIGN_A556                                    0x106E0
#define unicode_LINEAR_A_SIGN_A557                                    0x106E1
#define unicode_LINEAR_A_SIGN_A559                                    0x106E2
#define unicode_LINEAR_A_SIGN_A563                                    0x106E3
#define unicode_LINEAR_A_SIGN_A564                                    0x106E4
#define unicode_LINEAR_A_SIGN_A565                                    0x106E5
#define unicode_LINEAR_A_SIGN_A566                                    0x106E6
#define unicode_LINEAR_A_SIGN_A568                                    0x106E7
#define unicode_LINEAR_A_SIGN_A569                                    0x106E8
#define unicode_LINEAR_A_SIGN_A570                                    0x106E9
#define unicode_LINEAR_A_SIGN_A571                                    0x106EA
#define unicode_LINEAR_A_SIGN_A572                                    0x106EB
#define unicode_LINEAR_A_SIGN_A573                                    0x106EC
#define unicode_LINEAR_A_SIGN_A574                                    0x106ED
#define unicode_LINEAR_A_SIGN_A575                                    0x106EE
#define unicode_LINEAR_A_SIGN_A576                                    0x106EF
#define unicode_LINEAR_A_SIGN_A577                                    0x106F0
#define unicode_LINEAR_A_SIGN_A578                                    0x106F1
#define unicode_LINEAR_A_SIGN_A579                                    0x106F2
#define unicode_LINEAR_A_SIGN_A580                                    0x106F3
#define unicode_LINEAR_A_SIGN_A581                                    0x106F4
#define unicode_LINEAR_A_SIGN_A582                                    0x106F5
#define unicode_LINEAR_A_SIGN_A583                                    0x106F6
#define unicode_LINEAR_A_SIGN_A584                                    0x106F7
#define unicode_LINEAR_A_SIGN_A585                                    0x106F8
#define unicode_LINEAR_A_SIGN_A586                                    0x106F9
#define unicode_LINEAR_A_SIGN_A587                                    0x106FA
#define unicode_LINEAR_A_SIGN_A588                                    0x106FB
#define unicode_LINEAR_A_SIGN_A589                                    0x106FC
#define unicode_LINEAR_A_SIGN_A591                                    0x106FD
#define unicode_LINEAR_A_SIGN_A592                                    0x106FE
#define unicode_LINEAR_A_SIGN_A594                                    0x106FF
#define unicode_LINEAR_A_SIGN_A595                                    0x10700
#define unicode_LINEAR_A_SIGN_A596                                    0x10701
#define unicode_LINEAR_A_SIGN_A598                                    0x10702
#define unicode_LINEAR_A_SIGN_A600                                    0x10703
#define unicode_LINEAR_A_SIGN_A601                                    0x10704
#define unicode_LINEAR_A_SIGN_A602                                    0x10705
#define unicode_LINEAR_A_SIGN_A603                                    0x10706
#define unicode_LINEAR_A_SIGN_A604                                    0x10707
#define unicode_LINEAR_A_SIGN_A606                                    0x10708
#define unicode_LINEAR_A_SIGN_A608                                    0x10709
#define unicode_LINEAR_A_SIGN_A609                                    0x1070A
#define unicode_LINEAR_A_SIGN_A610                                    0x1070B
#define unicode_LINEAR_A_SIGN_A611                                    0x1070C
#define unicode_LINEAR_A_SIGN_A612                                    0x1070D
#define unicode_LINEAR_A_SIGN_A613                                    0x1070E
#define unicode_LINEAR_A_SIGN_A614                                    0x1070F
#define unicode_LINEAR_A_SIGN_A615                                    0x10710
#define unicode_LINEAR_A_SIGN_A616                                    0x10711
#define unicode_LINEAR_A_SIGN_A617                                    0x10712
#define unicode_LINEAR_A_SIGN_A618                                    0x10713
#define unicode_LINEAR_A_SIGN_A619                                    0x10714
#define unicode_LINEAR_A_SIGN_A620                                    0x10715
#define unicode_LINEAR_A_SIGN_A621                                    0x10716
#define unicode_LINEAR_A_SIGN_A622                                    0x10717
#define unicode_LINEAR_A_SIGN_A623                                    0x10718
#define unicode_LINEAR_A_SIGN_A624                                    0x10719
#define unicode_LINEAR_A_SIGN_A626                                    0x1071A
#define unicode_LINEAR_A_SIGN_A627                                    0x1071B
#define unicode_LINEAR_A_SIGN_A628                                    0x1071C
#define unicode_LINEAR_A_SIGN_A629                                    0x1071D
#define unicode_LINEAR_A_SIGN_A634                                    0x1071E
#define unicode_LINEAR_A_SIGN_A637                                    0x1071F
#define unicode_LINEAR_A_SIGN_A638                                    0x10720
#define unicode_LINEAR_A_SIGN_A640                                    0x10721
#define unicode_LINEAR_A_SIGN_A642                                    0x10722
#define unicode_LINEAR_A_SIGN_A643                                    0x10723
#define unicode_LINEAR_A_SIGN_A644                                    0x10724
#define unicode_LINEAR_A_SIGN_A645                                    0x10725
#define unicode_LINEAR_A_SIGN_A646                                    0x10726
#define unicode_LINEAR_A_SIGN_A648                                    0x10727
#define unicode_LINEAR_A_SIGN_A649                                    0x10728
#define unicode_LINEAR_A_SIGN_A651                                    0x10729
#define unicode_LINEAR_A_SIGN_A652                                    0x1072A
#define unicode_LINEAR_A_SIGN_A653                                    0x1072B
#define unicode_LINEAR_A_SIGN_A654                                    0x1072C
#define unicode_LINEAR_A_SIGN_A655                                    0x1072D
#define unicode_LINEAR_A_SIGN_A656                                    0x1072E
#define unicode_LINEAR_A_SIGN_A657                                    0x1072F
#define unicode_LINEAR_A_SIGN_A658                                    0x10730
#define unicode_LINEAR_A_SIGN_A659                                    0x10731
#define unicode_LINEAR_A_SIGN_A660                                    0x10732
#define unicode_LINEAR_A_SIGN_A661                                    0x10733
#define unicode_LINEAR_A_SIGN_A662                                    0x10734
#define unicode_LINEAR_A_SIGN_A663                                    0x10735
#define unicode_LINEAR_A_SIGN_A664                                    0x10736
#define unicode_LINEAR_A_SIGN_A701_A                                  0x10740
#define unicode_LINEAR_A_SIGN_A702_B                                  0x10741
#define unicode_LINEAR_A_SIGN_A703_D                                  0x10742
#define unicode_LINEAR_A_SIGN_A704_E                                  0x10743
#define unicode_LINEAR_A_SIGN_A705_F                                  0x10744
#define unicode_LINEAR_A_SIGN_A706_H                                  0x10745
#define unicode_LINEAR_A_SIGN_A707_J                                  0x10746
#define unicode_LINEAR_A_SIGN_A708_K                                  0x10747
#define unicode_LINEAR_A_SIGN_A709_L                                  0x10748
#define unicode_LINEAR_A_SIGN_A709_2_L2                               0x10749
#define unicode_LINEAR_A_SIGN_A709_3_L3                               0x1074A
#define unicode_LINEAR_A_SIGN_A709_4_L4                               0x1074B
#define unicode_LINEAR_A_SIGN_A709_6_L6                               0x1074C
#define unicode_LINEAR_A_SIGN_A710_W                                  0x1074D
#define unicode_LINEAR_A_SIGN_A711_X                                  0x1074E
#define unicode_LINEAR_A_SIGN_A712_Y                                  0x1074F
#define unicode_LINEAR_A_SIGN_A713_OMEGA                              0x10750
#define unicode_LINEAR_A_SIGN_A714_ABB                                0x10751
#define unicode_LINEAR_A_SIGN_A715_BB                                 0x10752
#define unicode_LINEAR_A_SIGN_A717_DD                                 0x10753
#define unicode_LINEAR_A_SIGN_A726_EYYY                               0x10754
#define unicode_LINEAR_A_SIGN_A732_JE                                 0x10755
#define unicode_LINEAR_A_SIGN_A800                                    0x10760
#define unicode_LINEAR_A_SIGN_A801                                    0x10761
#define unicode_LINEAR_A_SIGN_A802                                    0x10762
#define unicode_LINEAR_A_SIGN_A803                                    0x10763
#define unicode_LINEAR_A_SIGN_A804                                    0x10764
#define unicode_LINEAR_A_SIGN_A805                                    0x10765
#define unicode_LINEAR_A_SIGN_A806                                    0x10766
#define unicode_LINEAR_A_SIGN_A807                                    0x10767
#define unicode_CYPRIOT_SYLLABLE_A                                    0x10800
#define unicode_CYPRIOT_SYLLABLE_E                                    0x10801
#define unicode_CYPRIOT_SYLLABLE_I                                    0x10802
#define unicode_CYPRIOT_SYLLABLE_O                                    0x10803
#define unicode_CYPRIOT_SYLLABLE_U                                    0x10804
#define unicode_CYPRIOT_SYLLABLE_JA                                   0x10805
#define unicode_CYPRIOT_SYLLABLE_JO                                   0x10808
#define unicode_CYPRIOT_SYLLABLE_KA                                   0x1080A
#define unicode_CYPRIOT_SYLLABLE_KE                                   0x1080B
#define unicode_CYPRIOT_SYLLABLE_KI                                   0x1080C
#define unicode_CYPRIOT_SYLLABLE_KO                                   0x1080D
#define unicode_CYPRIOT_SYLLABLE_KU                                   0x1080E
#define unicode_CYPRIOT_SYLLABLE_LA                                   0x1080F
#define unicode_CYPRIOT_SYLLABLE_LE                                   0x10810
#define unicode_CYPRIOT_SYLLABLE_LI                                   0x10811
#define unicode_CYPRIOT_SYLLABLE_LO                                   0x10812
#define unicode_CYPRIOT_SYLLABLE_LU                                   0x10813
#define unicode_CYPRIOT_SYLLABLE_MA                                   0x10814
#define unicode_CYPRIOT_SYLLABLE_ME                                   0x10815
#define unicode_CYPRIOT_SYLLABLE_MI                                   0x10816
#define unicode_CYPRIOT_SYLLABLE_MO                                   0x10817
#define unicode_CYPRIOT_SYLLABLE_MU                                   0x10818
#define unicode_CYPRIOT_SYLLABLE_NA                                   0x10819
#define unicode_CYPRIOT_SYLLABLE_NE                                   0x1081A
#define unicode_CYPRIOT_SYLLABLE_NI                                   0x1081B
#define unicode_CYPRIOT_SYLLABLE_NO                                   0x1081C
#define unicode_CYPRIOT_SYLLABLE_NU                                   0x1081D
#define unicode_CYPRIOT_SYLLABLE_PA                                   0x1081E
#define unicode_CYPRIOT_SYLLABLE_PE                                   0x1081F
#define unicode_CYPRIOT_SYLLABLE_PI                                   0x10820
#define unicode_CYPRIOT_SYLLABLE_PO                                   0x10821
#define unicode_CYPRIOT_SYLLABLE_PU                                   0x10822
#define unicode_CYPRIOT_SYLLABLE_RA                                   0x10823
#define unicode_CYPRIOT_SYLLABLE_RE                                   0x10824
#define unicode_CYPRIOT_SYLLABLE_RI                                   0x10825
#define unicode_CYPRIOT_SYLLABLE_RO                                   0x10826
#define unicode_CYPRIOT_SYLLABLE_RU                                   0x10827
#define unicode_CYPRIOT_SYLLABLE_SA                                   0x10828
#define unicode_CYPRIOT_SYLLABLE_SE                                   0x10829
#define unicode_CYPRIOT_SYLLABLE_SI                                   0x1082A
#define unicode_CYPRIOT_SYLLABLE_SO                                   0x1082B
#define unicode_CYPRIOT_SYLLABLE_SU                                   0x1082C
#define unicode_CYPRIOT_SYLLABLE_TA                                   0x1082D
#define unicode_CYPRIOT_SYLLABLE_TE                                   0x1082E
#define unicode_CYPRIOT_SYLLABLE_TI                                   0x1082F
#define unicode_CYPRIOT_SYLLABLE_TO                                   0x10830
#define unicode_CYPRIOT_SYLLABLE_TU                                   0x10831
#define unicode_CYPRIOT_SYLLABLE_WA                                   0x10832
#define unicode_CYPRIOT_SYLLABLE_WE                                   0x10833
#define unicode_CYPRIOT_SYLLABLE_WI                                   0x10834
#define unicode_CYPRIOT_SYLLABLE_WO                                   0x10835
#define unicode_CYPRIOT_SYLLABLE_XA                                   0x10837
#define unicode_CYPRIOT_SYLLABLE_XE                                   0x10838
#define unicode_CYPRIOT_SYLLABLE_ZA                                   0x1083C
#define unicode_CYPRIOT_SYLLABLE_ZO                                   0x1083F
#define unicode_IMPERIAL_ARAMAIC_LETTER_ALEPH                         0x10840
#define unicode_IMPERIAL_ARAMAIC_LETTER_BETH                          0x10841
#define unicode_IMPERIAL_ARAMAIC_LETTER_GIMEL                         0x10842
#define unicode_IMPERIAL_ARAMAIC_LETTER_DALETH                        0x10843
#define unicode_IMPERIAL_ARAMAIC_LETTER_HE                            0x10844
#define unicode_IMPERIAL_ARAMAIC_LETTER_WAW                           0x10845
#define unicode_IMPERIAL_ARAMAIC_LETTER_ZAYIN                         0x10846
#define unicode_IMPERIAL_ARAMAIC_LETTER_HETH                          0x10847
#define unicode_IMPERIAL_ARAMAIC_LETTER_TETH                          0x10848
#define unicode_IMPERIAL_ARAMAIC_LETTER_YODH                          0x10849
#define unicode_IMPERIAL_ARAMAIC_LETTER_KAPH                          0x1084A
#define unicode_IMPERIAL_ARAMAIC_LETTER_LAMEDH                        0x1084B
#define unicode_IMPERIAL_ARAMAIC_LETTER_MEM                           0x1084C
#define unicode_IMPERIAL_ARAMAIC_LETTER_NUN                           0x1084D
#define unicode_IMPERIAL_ARAMAIC_LETTER_SAMEKH                        0x1084E
#define unicode_IMPERIAL_ARAMAIC_LETTER_AYIN                          0x1084F
#define unicode_IMPERIAL_ARAMAIC_LETTER_PE                            0x10850
#define unicode_IMPERIAL_ARAMAIC_LETTER_SADHE                         0x10851
#define unicode_IMPERIAL_ARAMAIC_LETTER_QOPH                          0x10852
#define unicode_IMPERIAL_ARAMAIC_LETTER_RESH                          0x10853
#define unicode_IMPERIAL_ARAMAIC_LETTER_SHIN                          0x10854
#define unicode_IMPERIAL_ARAMAIC_LETTER_TAW                           0x10855
#define unicode_IMPERIAL_ARAMAIC_SECTION_SIGN                         0x10857
#define unicode_IMPERIAL_ARAMAIC_NUMBER_ONE                           0x10858
#define unicode_IMPERIAL_ARAMAIC_NUMBER_TWO                           0x10859
#define unicode_IMPERIAL_ARAMAIC_NUMBER_THREE                         0x1085A
#define unicode_IMPERIAL_ARAMAIC_NUMBER_TEN                           0x1085B
#define unicode_IMPERIAL_ARAMAIC_NUMBER_TWENTY                        0x1085C
#define unicode_IMPERIAL_ARAMAIC_NUMBER_ONE_HUNDRED                   0x1085D
#define unicode_IMPERIAL_ARAMAIC_NUMBER_ONE_THOUSAND                  0x1085E
#define unicode_IMPERIAL_ARAMAIC_NUMBER_TEN_THOUSAND                  0x1085F
#define unicode_PALMYRENE_LETTER_ALEPH                                0x10860
#define unicode_PALMYRENE_LETTER_BETH                                 0x10861
#define unicode_PALMYRENE_LETTER_GIMEL                                0x10862
#define unicode_PALMYRENE_LETTER_DALETH                               0x10863
#define unicode_PALMYRENE_LETTER_HE                                   0x10864
#define unicode_PALMYRENE_LETTER_WAW                                  0x10865
#define unicode_PALMYRENE_LETTER_ZAYIN                                0x10866
#define unicode_PALMYRENE_LETTER_HETH                                 0x10867
#define unicode_PALMYRENE_LETTER_TETH                                 0x10868
#define unicode_PALMYRENE_LETTER_YODH                                 0x10869
#define unicode_PALMYRENE_LETTER_KAPH                                 0x1086A
#define unicode_PALMYRENE_LETTER_LAMEDH                               0x1086B
#define unicode_PALMYRENE_LETTER_MEM                                  0x1086C
#define unicode_PALMYRENE_LETTER_FINAL_NUN                            0x1086D
#define unicode_PALMYRENE_LETTER_NUN                                  0x1086E
#define unicode_PALMYRENE_LETTER_SAMEKH                               0x1086F
#define unicode_PALMYRENE_LETTER_AYIN                                 0x10870
#define unicode_PALMYRENE_LETTER_PE                                   0x10871
#define unicode_PALMYRENE_LETTER_SADHE                                0x10872
#define unicode_PALMYRENE_LETTER_QOPH                                 0x10873
#define unicode_PALMYRENE_LETTER_RESH                                 0x10874
#define unicode_PALMYRENE_LETTER_SHIN                                 0x10875
#define unicode_PALMYRENE_LETTER_TAW                                  0x10876
#define unicode_PALMYRENE_LEFT_POINTING_FLEURON                       0x10877
#define unicode_PALMYRENE_RIGHT_POINTING_FLEURON                      0x10878
#define unicode_PALMYRENE_NUMBER_ONE                                  0x10879
#define unicode_PALMYRENE_NUMBER_TWO                                  0x1087A
#define unicode_PALMYRENE_NUMBER_THREE                                0x1087B
#define unicode_PALMYRENE_NUMBER_FOUR                                 0x1087C
#define unicode_PALMYRENE_NUMBER_FIVE                                 0x1087D
#define unicode_PALMYRENE_NUMBER_TEN                                  0x1087E
#define unicode_PALMYRENE_NUMBER_TWENTY                               0x1087F
#define unicode_NABATAEAN_LETTER_FINAL_ALEPH                          0x10880
#define unicode_NABATAEAN_LETTER_ALEPH                                0x10881
#define unicode_NABATAEAN_LETTER_FINAL_BETH                           0x10882
#define unicode_NABATAEAN_LETTER_BETH                                 0x10883
#define unicode_NABATAEAN_LETTER_GIMEL                                0x10884
#define unicode_NABATAEAN_LETTER_DALETH                               0x10885
#define unicode_NABATAEAN_LETTER_FINAL_HE                             0x10886
#define unicode_NABATAEAN_LETTER_HE                                   0x10887
#define unicode_NABATAEAN_LETTER_WAW                                  0x10888
#define unicode_NABATAEAN_LETTER_ZAYIN                                0x10889
#define unicode_NABATAEAN_LETTER_HETH                                 0x1088A
#define unicode_NABATAEAN_LETTER_TETH                                 0x1088B
#define unicode_NABATAEAN_LETTER_FINAL_YODH                           0x1088C
#define unicode_NABATAEAN_LETTER_YODH                                 0x1088D
#define unicode_NABATAEAN_LETTER_FINAL_KAPH                           0x1088E
#define unicode_NABATAEAN_LETTER_KAPH                                 0x1088F
#define unicode_NABATAEAN_LETTER_FINAL_LAMEDH                         0x10890
#define unicode_NABATAEAN_LETTER_LAMEDH                               0x10891
#define unicode_NABATAEAN_LETTER_FINAL_MEM                            0x10892
#define unicode_NABATAEAN_LETTER_MEM                                  0x10893
#define unicode_NABATAEAN_LETTER_FINAL_NUN                            0x10894
#define unicode_NABATAEAN_LETTER_NUN                                  0x10895
#define unicode_NABATAEAN_LETTER_SAMEKH                               0x10896
#define unicode_NABATAEAN_LETTER_AYIN                                 0x10897
#define unicode_NABATAEAN_LETTER_PE                                   0x10898
#define unicode_NABATAEAN_LETTER_SADHE                                0x10899
#define unicode_NABATAEAN_LETTER_QOPH                                 0x1089A
#define unicode_NABATAEAN_LETTER_RESH                                 0x1089B
#define unicode_NABATAEAN_LETTER_FINAL_SHIN                           0x1089C
#define unicode_NABATAEAN_LETTER_SHIN                                 0x1089D
#define unicode_NABATAEAN_LETTER_TAW                                  0x1089E
#define unicode_NABATAEAN_NUMBER_ONE                                  0x108A7
#define unicode_NABATAEAN_NUMBER_TWO                                  0x108A8
#define unicode_NABATAEAN_NUMBER_THREE                                0x108A9
#define unicode_NABATAEAN_NUMBER_FOUR                                 0x108AA
#define unicode_NABATAEAN_CRUCIFORM_NUMBER_FOUR                       0x108AB
#define unicode_NABATAEAN_NUMBER_FIVE                                 0x108AC
#define unicode_NABATAEAN_NUMBER_TEN                                  0x108AD
#define unicode_NABATAEAN_NUMBER_TWENTY                               0x108AE
#define unicode_NABATAEAN_NUMBER_ONE_HUNDRED                          0x108AF
#define unicode_PHOENICIAN_LETTER_ALF                                 0x10900
#define unicode_PHOENICIAN_LETTER_BET                                 0x10901
#define unicode_PHOENICIAN_LETTER_GAML                                0x10902
#define unicode_PHOENICIAN_LETTER_DELT                                0x10903
#define unicode_PHOENICIAN_LETTER_HE                                  0x10904
#define unicode_PHOENICIAN_LETTER_WAU                                 0x10905
#define unicode_PHOENICIAN_LETTER_ZAI                                 0x10906
#define unicode_PHOENICIAN_LETTER_HET                                 0x10907
#define unicode_PHOENICIAN_LETTER_TET                                 0x10908
#define unicode_PHOENICIAN_LETTER_YOD                                 0x10909
#define unicode_PHOENICIAN_LETTER_KAF                                 0x1090A
#define unicode_PHOENICIAN_LETTER_LAMD                                0x1090B
#define unicode_PHOENICIAN_LETTER_MEM                                 0x1090C
#define unicode_PHOENICIAN_LETTER_NUN                                 0x1090D
#define unicode_PHOENICIAN_LETTER_SEMK                                0x1090E
#define unicode_PHOENICIAN_LETTER_AIN                                 0x1090F
#define unicode_PHOENICIAN_LETTER_PE                                  0x10910
#define unicode_PHOENICIAN_LETTER_SADE                                0x10911
#define unicode_PHOENICIAN_LETTER_QOF                                 0x10912
#define unicode_PHOENICIAN_LETTER_ROSH                                0x10913
#define unicode_PHOENICIAN_LETTER_SHIN                                0x10914
#define unicode_PHOENICIAN_LETTER_TAU                                 0x10915
#define unicode_PHOENICIAN_NUMBER_ONE                                 0x10916
#define unicode_PHOENICIAN_NUMBER_TEN                                 0x10917
#define unicode_PHOENICIAN_NUMBER_TWENTY                              0x10918
#define unicode_PHOENICIAN_NUMBER_ONE_HUNDRED                         0x10919
#define unicode_PHOENICIAN_NUMBER_TWO                                 0x1091A
#define unicode_PHOENICIAN_NUMBER_THREE                               0x1091B
#define unicode_PHOENICIAN_WORD_SEPARATOR                             0x1091F
#define unicode_LYDIAN_LETTER_A                                       0x10920
#define unicode_LYDIAN_LETTER_B                                       0x10921
#define unicode_LYDIAN_LETTER_G                                       0x10922
#define unicode_LYDIAN_LETTER_D                                       0x10923
#define unicode_LYDIAN_LETTER_E                                       0x10924
#define unicode_LYDIAN_LETTER_V                                       0x10925
#define unicode_LYDIAN_LETTER_I                                       0x10926
#define unicode_LYDIAN_LETTER_Y                                       0x10927
#define unicode_LYDIAN_LETTER_K                                       0x10928
#define unicode_LYDIAN_LETTER_L                                       0x10929
#define unicode_LYDIAN_LETTER_M                                       0x1092A
#define unicode_LYDIAN_LETTER_N                                       0x1092B
#define unicode_LYDIAN_LETTER_O                                       0x1092C
#define unicode_LYDIAN_LETTER_R                                       0x1092D
#define unicode_LYDIAN_LETTER_SS                                      0x1092E
#define unicode_LYDIAN_LETTER_T                                       0x1092F
#define unicode_LYDIAN_LETTER_U                                       0x10930
#define unicode_LYDIAN_LETTER_F                                       0x10931
#define unicode_LYDIAN_LETTER_Q                                       0x10932
#define unicode_LYDIAN_LETTER_S                                       0x10933
#define unicode_LYDIAN_LETTER_TT                                      0x10934
#define unicode_LYDIAN_LETTER_AN                                      0x10935
#define unicode_LYDIAN_LETTER_EN                                      0x10936
#define unicode_LYDIAN_LETTER_LY                                      0x10937
#define unicode_LYDIAN_LETTER_NN                                      0x10938
#define unicode_LYDIAN_LETTER_C                                       0x10939
#define unicode_LYDIAN_TRIANGULAR_MARK                                0x1093F
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_A                        0x10980
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_E                        0x10981
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_I                        0x10982
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_O                        0x10983
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_YA                       0x10984
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_WA                       0x10985
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_BA                       0x10986
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_BA_2                     0x10987
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_PA                       0x10988
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_MA                       0x10989
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_NA                       0x1098A
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_NA_2                     0x1098B
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_NE                       0x1098C
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_NE_2                     0x1098D
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_RA                       0x1098E
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_RA_2                     0x1098F
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_LA                       0x10990
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_KHA                      0x10991
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_HHA                      0x10992
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_SA                       0x10993
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_SA_2                     0x10994
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_SE                       0x10995
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_KA                       0x10996
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_QA                       0x10997
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_TA                       0x10998
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_TA_2                     0x10999
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_TE                       0x1099A
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_TE_2                     0x1099B
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_TO                       0x1099C
#define unicode_MEROITIC_HIEROGLYPHIC_LETTER_DA                       0x1099D
#define unicode_MEROITIC_HIEROGLYPHIC_SYMBOL_VIDJ                     0x1099E
#define unicode_MEROITIC_HIEROGLYPHIC_SYMBOL_VIDJ_2                   0x1099F
#define unicode_MEROITIC_CURSIVE_LETTER_A                             0x109A0
#define unicode_MEROITIC_CURSIVE_LETTER_E                             0x109A1
#define unicode_MEROITIC_CURSIVE_LETTER_I                             0x109A2
#define unicode_MEROITIC_CURSIVE_LETTER_O                             0x109A3
#define unicode_MEROITIC_CURSIVE_LETTER_YA                            0x109A4
#define unicode_MEROITIC_CURSIVE_LETTER_WA                            0x109A5
#define unicode_MEROITIC_CURSIVE_LETTER_BA                            0x109A6
#define unicode_MEROITIC_CURSIVE_LETTER_PA                            0x109A7
#define unicode_MEROITIC_CURSIVE_LETTER_MA                            0x109A8
#define unicode_MEROITIC_CURSIVE_LETTER_NA                            0x109A9
#define unicode_MEROITIC_CURSIVE_LETTER_NE                            0x109AA
#define unicode_MEROITIC_CURSIVE_LETTER_RA                            0x109AB
#define unicode_MEROITIC_CURSIVE_LETTER_LA                            0x109AC
#define unicode_MEROITIC_CURSIVE_LETTER_KHA                           0x109AD
#define unicode_MEROITIC_CURSIVE_LETTER_HHA                           0x109AE
#define unicode_MEROITIC_CURSIVE_LETTER_SA                            0x109AF
#define unicode_MEROITIC_CURSIVE_LETTER_ARCHAIC_SA                    0x109B0
#define unicode_MEROITIC_CURSIVE_LETTER_SE                            0x109B1
#define unicode_MEROITIC_CURSIVE_LETTER_KA                            0x109B2
#define unicode_MEROITIC_CURSIVE_LETTER_QA                            0x109B3
#define unicode_MEROITIC_CURSIVE_LETTER_TA                            0x109B4
#define unicode_MEROITIC_CURSIVE_LETTER_TE                            0x109B5
#define unicode_MEROITIC_CURSIVE_LETTER_TO                            0x109B6
#define unicode_MEROITIC_CURSIVE_LETTER_DA                            0x109B7
#define unicode_MEROITIC_CURSIVE_LOGOGRAM_RMT                         0x109BE
#define unicode_MEROITIC_CURSIVE_LOGOGRAM_IMN                         0x109BF
#define unicode_KHAROSHTHI_LETTER_A                                   0x10A00
#define unicode_KHAROSHTHI_VOWEL_SIGN_I                               0x10A01
#define unicode_KHAROSHTHI_VOWEL_SIGN_U                               0x10A02
#define unicode_KHAROSHTHI_VOWEL_SIGN_VOCALIC_R                       0x10A03
#define unicode_KHAROSHTHI_VOWEL_SIGN_E                               0x10A05
#define unicode_KHAROSHTHI_VOWEL_SIGN_O                               0x10A06
#define unicode_KHAROSHTHI_VOWEL_LENGTH_MARK                          0x10A0C
#define unicode_KHAROSHTHI_SIGN_DOUBLE_RING_BELOW                     0x10A0D
#define unicode_KHAROSHTHI_SIGN_ANUSVARA                              0x10A0E
#define unicode_KHAROSHTHI_SIGN_VISARGA                               0x10A0F
#define unicode_KHAROSHTHI_LETTER_KA                                  0x10A10
#define unicode_KHAROSHTHI_LETTER_KHA                                 0x10A11
#define unicode_KHAROSHTHI_LETTER_GA                                  0x10A12
#define unicode_KHAROSHTHI_LETTER_GHA                                 0x10A13
#define unicode_KHAROSHTHI_LETTER_CA                                  0x10A15
#define unicode_KHAROSHTHI_LETTER_CHA                                 0x10A16
#define unicode_KHAROSHTHI_LETTER_JA                                  0x10A17
#define unicode_KHAROSHTHI_LETTER_NYA                                 0x10A19
#define unicode_KHAROSHTHI_LETTER_TTA                                 0x10A1A
#define unicode_KHAROSHTHI_LETTER_TTHA                                0x10A1B
#define unicode_KHAROSHTHI_LETTER_DDA                                 0x10A1C
#define unicode_KHAROSHTHI_LETTER_DDHA                                0x10A1D
#define unicode_KHAROSHTHI_LETTER_NNA                                 0x10A1E
#define unicode_KHAROSHTHI_LETTER_TA                                  0x10A1F
#define unicode_KHAROSHTHI_LETTER_THA                                 0x10A20
#define unicode_KHAROSHTHI_LETTER_DA                                  0x10A21
#define unicode_KHAROSHTHI_LETTER_DHA                                 0x10A22
#define unicode_KHAROSHTHI_LETTER_NA                                  0x10A23
#define unicode_KHAROSHTHI_LETTER_PA                                  0x10A24
#define unicode_KHAROSHTHI_LETTER_PHA                                 0x10A25
#define unicode_KHAROSHTHI_LETTER_BA                                  0x10A26
#define unicode_KHAROSHTHI_LETTER_BHA                                 0x10A27
#define unicode_KHAROSHTHI_LETTER_MA                                  0x10A28
#define unicode_KHAROSHTHI_LETTER_YA                                  0x10A29
#define unicode_KHAROSHTHI_LETTER_RA                                  0x10A2A
#define unicode_KHAROSHTHI_LETTER_LA                                  0x10A2B
#define unicode_KHAROSHTHI_LETTER_VA                                  0x10A2C
#define unicode_KHAROSHTHI_LETTER_SHA                                 0x10A2D
#define unicode_KHAROSHTHI_LETTER_SSA                                 0x10A2E
#define unicode_KHAROSHTHI_LETTER_SA                                  0x10A2F
#define unicode_KHAROSHTHI_LETTER_ZA                                  0x10A30
#define unicode_KHAROSHTHI_LETTER_HA                                  0x10A31
#define unicode_KHAROSHTHI_LETTER_KKA                                 0x10A32
#define unicode_KHAROSHTHI_LETTER_TTTHA                               0x10A33
#define unicode_KHAROSHTHI_SIGN_BAR_ABOVE                             0x10A38
#define unicode_KHAROSHTHI_SIGN_CAUDA                                 0x10A39
#define unicode_KHAROSHTHI_SIGN_DOT_BELOW                             0x10A3A
#define unicode_KHAROSHTHI_VIRAMA                                     0x10A3F
#define unicode_KHAROSHTHI_DIGIT_ONE                                  0x10A40
#define unicode_KHAROSHTHI_DIGIT_TWO                                  0x10A41
#define unicode_KHAROSHTHI_DIGIT_THREE                                0x10A42
#define unicode_KHAROSHTHI_DIGIT_FOUR                                 0x10A43
#define unicode_KHAROSHTHI_NUMBER_TEN                                 0x10A44
#define unicode_KHAROSHTHI_NUMBER_TWENTY                              0x10A45
#define unicode_KHAROSHTHI_NUMBER_ONE_HUNDRED                         0x10A46
#define unicode_KHAROSHTHI_NUMBER_ONE_THOUSAND                        0x10A47
#define unicode_KHAROSHTHI_PUNCTUATION_DOT                            0x10A50
#define unicode_KHAROSHTHI_PUNCTUATION_SMALL_CIRCLE                   0x10A51
#define unicode_KHAROSHTHI_PUNCTUATION_CIRCLE                         0x10A52
#define unicode_KHAROSHTHI_PUNCTUATION_CRESCENT_BAR                   0x10A53
#define unicode_KHAROSHTHI_PUNCTUATION_MANGALAM                       0x10A54
#define unicode_KHAROSHTHI_PUNCTUATION_LOTUS                          0x10A55
#define unicode_KHAROSHTHI_PUNCTUATION_DANDA                          0x10A56
#define unicode_KHAROSHTHI_PUNCTUATION_DOUBLE_DANDA                   0x10A57
#define unicode_KHAROSHTHI_PUNCTUATION_LINES                          0x10A58
#define unicode_OLD_SOUTH_ARABIAN_LETTER_HE                           0x10A60
#define unicode_OLD_SOUTH_ARABIAN_LETTER_LAMEDH                       0x10A61
#define unicode_OLD_SOUTH_ARABIAN_LETTER_HETH                         0x10A62
#define unicode_OLD_SOUTH_ARABIAN_LETTER_MEM                          0x10A63
#define unicode_OLD_SOUTH_ARABIAN_LETTER_QOPH                         0x10A64
#define unicode_OLD_SOUTH_ARABIAN_LETTER_WAW                          0x10A65
#define unicode_OLD_SOUTH_ARABIAN_LETTER_SHIN                         0x10A66
#define unicode_OLD_SOUTH_ARABIAN_LETTER_RESH                         0x10A67
#define unicode_OLD_SOUTH_ARABIAN_LETTER_BETH                         0x10A68
#define unicode_OLD_SOUTH_ARABIAN_LETTER_TAW                          0x10A69
#define unicode_OLD_SOUTH_ARABIAN_LETTER_SAT                          0x10A6A
#define unicode_OLD_SOUTH_ARABIAN_LETTER_KAPH                         0x10A6B
#define unicode_OLD_SOUTH_ARABIAN_LETTER_NUN                          0x10A6C
#define unicode_OLD_SOUTH_ARABIAN_LETTER_KHETH                        0x10A6D
#define unicode_OLD_SOUTH_ARABIAN_LETTER_SADHE                        0x10A6E
#define unicode_OLD_SOUTH_ARABIAN_LETTER_SAMEKH                       0x10A6F
#define unicode_OLD_SOUTH_ARABIAN_LETTER_FE                           0x10A70
#define unicode_OLD_SOUTH_ARABIAN_LETTER_ALEF                         0x10A71
#define unicode_OLD_SOUTH_ARABIAN_LETTER_AYN                          0x10A72
#define unicode_OLD_SOUTH_ARABIAN_LETTER_DHADHE                       0x10A73
#define unicode_OLD_SOUTH_ARABIAN_LETTER_GIMEL                        0x10A74
#define unicode_OLD_SOUTH_ARABIAN_LETTER_DALETH                       0x10A75
#define unicode_OLD_SOUTH_ARABIAN_LETTER_GHAYN                        0x10A76
#define unicode_OLD_SOUTH_ARABIAN_LETTER_TETH                         0x10A77
#define unicode_OLD_SOUTH_ARABIAN_LETTER_ZAYN                         0x10A78
#define unicode_OLD_SOUTH_ARABIAN_LETTER_DHALETH                      0x10A79
#define unicode_OLD_SOUTH_ARABIAN_LETTER_YODH                         0x10A7A
#define unicode_OLD_SOUTH_ARABIAN_LETTER_THAW                         0x10A7B
#define unicode_OLD_SOUTH_ARABIAN_LETTER_THETH                        0x10A7C
#define unicode_OLD_SOUTH_ARABIAN_NUMBER_ONE                          0x10A7D
#define unicode_OLD_SOUTH_ARABIAN_NUMBER_FIFTY                        0x10A7E
#define unicode_OLD_SOUTH_ARABIAN_NUMERIC_INDICATOR                   0x10A7F
#define unicode_OLD_NORTH_ARABIAN_LETTER_HEH                          0x10A80
#define unicode_OLD_NORTH_ARABIAN_LETTER_LAM                          0x10A81
#define unicode_OLD_NORTH_ARABIAN_LETTER_HAH                          0x10A82
#define unicode_OLD_NORTH_ARABIAN_LETTER_MEEM                         0x10A83
#define unicode_OLD_NORTH_ARABIAN_LETTER_QAF                          0x10A84
#define unicode_OLD_NORTH_ARABIAN_LETTER_WAW                          0x10A85
#define unicode_OLD_NORTH_ARABIAN_LETTER_ES_2                         0x10A86
#define unicode_OLD_NORTH_ARABIAN_LETTER_REH                          0x10A87
#define unicode_OLD_NORTH_ARABIAN_LETTER_BEH                          0x10A88
#define unicode_OLD_NORTH_ARABIAN_LETTER_TEH                          0x10A89
#define unicode_OLD_NORTH_ARABIAN_LETTER_ES_1                         0x10A8A
#define unicode_OLD_NORTH_ARABIAN_LETTER_KAF                          0x10A8B
#define unicode_OLD_NORTH_ARABIAN_LETTER_NOON                         0x10A8C
#define unicode_OLD_NORTH_ARABIAN_LETTER_KHAH                         0x10A8D
#define unicode_OLD_NORTH_ARABIAN_LETTER_SAD                          0x10A8E
#define unicode_OLD_NORTH_ARABIAN_LETTER_ES_3                         0x10A8F
#define unicode_OLD_NORTH_ARABIAN_LETTER_FEH                          0x10A90
#define unicode_OLD_NORTH_ARABIAN_LETTER_ALEF                         0x10A91
#define unicode_OLD_NORTH_ARABIAN_LETTER_AIN                          0x10A92
#define unicode_OLD_NORTH_ARABIAN_LETTER_DAD                          0x10A93
#define unicode_OLD_NORTH_ARABIAN_LETTER_GEEM                         0x10A94
#define unicode_OLD_NORTH_ARABIAN_LETTER_DAL                          0x10A95
#define unicode_OLD_NORTH_ARABIAN_LETTER_GHAIN                        0x10A96
#define unicode_OLD_NORTH_ARABIAN_LETTER_TAH                          0x10A97
#define unicode_OLD_NORTH_ARABIAN_LETTER_ZAIN                         0x10A98
#define unicode_OLD_NORTH_ARABIAN_LETTER_THAL                         0x10A99
#define unicode_OLD_NORTH_ARABIAN_LETTER_YEH                          0x10A9A
#define unicode_OLD_NORTH_ARABIAN_LETTER_THEH                         0x10A9B
#define unicode_OLD_NORTH_ARABIAN_LETTER_ZAH                          0x10A9C
#define unicode_OLD_NORTH_ARABIAN_NUMBER_ONE                          0x10A9D
#define unicode_OLD_NORTH_ARABIAN_NUMBER_TEN                          0x10A9E
#define unicode_OLD_NORTH_ARABIAN_NUMBER_TWENTY                       0x10A9F
#define unicode_MANICHAEAN_LETTER_ALEPH                               0x10AC0
#define unicode_MANICHAEAN_LETTER_BETH                                0x10AC1
#define unicode_MANICHAEAN_LETTER_BHETH                               0x10AC2
#define unicode_MANICHAEAN_LETTER_GIMEL                               0x10AC3
#define unicode_MANICHAEAN_LETTER_GHIMEL                              0x10AC4
#define unicode_MANICHAEAN_LETTER_DALETH                              0x10AC5
#define unicode_MANICHAEAN_LETTER_HE                                  0x10AC6
#define unicode_MANICHAEAN_LETTER_WAW                                 0x10AC7
#define unicode_MANICHAEAN_SIGN_UD                                    0x10AC8
#define unicode_MANICHAEAN_LETTER_ZAYIN                               0x10AC9
#define unicode_MANICHAEAN_LETTER_ZHAYIN                              0x10ACA
#define unicode_MANICHAEAN_LETTER_JAYIN                               0x10ACB
#define unicode_MANICHAEAN_LETTER_JHAYIN                              0x10ACC
#define unicode_MANICHAEAN_LETTER_HETH                                0x10ACD
#define unicode_MANICHAEAN_LETTER_TETH                                0x10ACE
#define unicode_MANICHAEAN_LETTER_YODH                                0x10ACF
#define unicode_MANICHAEAN_LETTER_KAPH                                0x10AD0
#define unicode_MANICHAEAN_LETTER_XAPH                                0x10AD1
#define unicode_MANICHAEAN_LETTER_KHAPH                               0x10AD2
#define unicode_MANICHAEAN_LETTER_LAMEDH                              0x10AD3
#define unicode_MANICHAEAN_LETTER_DHAMEDH                             0x10AD4
#define unicode_MANICHAEAN_LETTER_THAMEDH                             0x10AD5
#define unicode_MANICHAEAN_LETTER_MEM                                 0x10AD6
#define unicode_MANICHAEAN_LETTER_NUN                                 0x10AD7
#define unicode_MANICHAEAN_LETTER_SAMEKH                              0x10AD8
#define unicode_MANICHAEAN_LETTER_AYIN                                0x10AD9
#define unicode_MANICHAEAN_LETTER_AAYIN                               0x10ADA
#define unicode_MANICHAEAN_LETTER_PE                                  0x10ADB
#define unicode_MANICHAEAN_LETTER_FE                                  0x10ADC
#define unicode_MANICHAEAN_LETTER_SADHE                               0x10ADD
#define unicode_MANICHAEAN_LETTER_QOPH                                0x10ADE
#define unicode_MANICHAEAN_LETTER_XOPH                                0x10ADF
#define unicode_MANICHAEAN_LETTER_QHOPH                               0x10AE0
#define unicode_MANICHAEAN_LETTER_RESH                                0x10AE1
#define unicode_MANICHAEAN_LETTER_SHIN                                0x10AE2
#define unicode_MANICHAEAN_LETTER_SSHIN                               0x10AE3
#define unicode_MANICHAEAN_LETTER_TAW                                 0x10AE4
#define unicode_MANICHAEAN_ABBREVIATION_MARK_ABOVE                    0x10AE5
#define unicode_MANICHAEAN_ABBREVIATION_MARK_BELOW                    0x10AE6
#define unicode_MANICHAEAN_NUMBER_ONE                                 0x10AEB
#define unicode_MANICHAEAN_NUMBER_FIVE                                0x10AEC
#define unicode_MANICHAEAN_NUMBER_TEN                                 0x10AED
#define unicode_MANICHAEAN_NUMBER_TWENTY                              0x10AEE
#define unicode_MANICHAEAN_NUMBER_ONE_HUNDRED                         0x10AEF
#define unicode_MANICHAEAN_PUNCTUATION_STAR                           0x10AF0
#define unicode_MANICHAEAN_PUNCTUATION_FLEURON                        0x10AF1
#define unicode_MANICHAEAN_PUNCTUATION_DOUBLE_DOT_WITHIN_DOT          0x10AF2
#define unicode_MANICHAEAN_PUNCTUATION_DOT_WITHIN_DOT                 0x10AF3
#define unicode_MANICHAEAN_PUNCTUATION_DOT                            0x10AF4
#define unicode_MANICHAEAN_PUNCTUATION_TWO_DOTS                       0x10AF5
#define unicode_MANICHAEAN_PUNCTUATION_LINE_FILLER                    0x10AF6
#define unicode_AVESTAN_LETTER_A                                      0x10B00
#define unicode_AVESTAN_LETTER_AA                                     0x10B01
#define unicode_AVESTAN_LETTER_AO                                     0x10B02
#define unicode_AVESTAN_LETTER_AAO                                    0x10B03
#define unicode_AVESTAN_LETTER_AN                                     0x10B04
#define unicode_AVESTAN_LETTER_AAN                                    0x10B05
#define unicode_AVESTAN_LETTER_AE                                     0x10B06
#define unicode_AVESTAN_LETTER_AEE                                    0x10B07
#define unicode_AVESTAN_LETTER_E                                      0x10B08
#define unicode_AVESTAN_LETTER_EE                                     0x10B09
#define unicode_AVESTAN_LETTER_O                                      0x10B0A
#define unicode_AVESTAN_LETTER_OO                                     0x10B0B
#define unicode_AVESTAN_LETTER_I                                      0x10B0C
#define unicode_AVESTAN_LETTER_II                                     0x10B0D
#define unicode_AVESTAN_LETTER_U                                      0x10B0E
#define unicode_AVESTAN_LETTER_UU                                     0x10B0F
#define unicode_AVESTAN_LETTER_KE                                     0x10B10
#define unicode_AVESTAN_LETTER_XE                                     0x10B11
#define unicode_AVESTAN_LETTER_XYE                                    0x10B12
#define unicode_AVESTAN_LETTER_XVE                                    0x10B13
#define unicode_AVESTAN_LETTER_GE                                     0x10B14
#define unicode_AVESTAN_LETTER_GGE                                    0x10B15
#define unicode_AVESTAN_LETTER_GHE                                    0x10B16
#define unicode_AVESTAN_LETTER_CE                                     0x10B17
#define unicode_AVESTAN_LETTER_JE                                     0x10B18
#define unicode_AVESTAN_LETTER_TE                                     0x10B19
#define unicode_AVESTAN_LETTER_THE                                    0x10B1A
#define unicode_AVESTAN_LETTER_DE                                     0x10B1B
#define unicode_AVESTAN_LETTER_DHE                                    0x10B1C
#define unicode_AVESTAN_LETTER_TTE                                    0x10B1D
#define unicode_AVESTAN_LETTER_PE                                     0x10B1E
#define unicode_AVESTAN_LETTER_FE                                     0x10B1F
#define unicode_AVESTAN_LETTER_BE                                     0x10B20
#define unicode_AVESTAN_LETTER_BHE                                    0x10B21
#define unicode_AVESTAN_LETTER_NGE                                    0x10B22
#define unicode_AVESTAN_LETTER_NGYE                                   0x10B23
#define unicode_AVESTAN_LETTER_NGVE                                   0x10B24
#define unicode_AVESTAN_LETTER_NE                                     0x10B25
#define unicode_AVESTAN_LETTER_NYE                                    0x10B26
#define unicode_AVESTAN_LETTER_NNE                                    0x10B27
#define unicode_AVESTAN_LETTER_ME                                     0x10B28
#define unicode_AVESTAN_LETTER_HME                                    0x10B29
#define unicode_AVESTAN_LETTER_YYE                                    0x10B2A
#define unicode_AVESTAN_LETTER_YE                                     0x10B2B
#define unicode_AVESTAN_LETTER_VE                                     0x10B2C
#define unicode_AVESTAN_LETTER_RE                                     0x10B2D
#define unicode_AVESTAN_LETTER_LE                                     0x10B2E
#define unicode_AVESTAN_LETTER_SE                                     0x10B2F
#define unicode_AVESTAN_LETTER_ZE                                     0x10B30
#define unicode_AVESTAN_LETTER_SHE                                    0x10B31
#define unicode_AVESTAN_LETTER_ZHE                                    0x10B32
#define unicode_AVESTAN_LETTER_SHYE                                   0x10B33
#define unicode_AVESTAN_LETTER_SSHE                                   0x10B34
#define unicode_AVESTAN_LETTER_HE                                     0x10B35
#define unicode_AVESTAN_ABBREVIATION_MARK                             0x10B39
#define unicode_TINY_TWO_DOTS_OVER_ONE_DOT_PUNCTUATION                0x10B3A
#define unicode_SMALL_TWO_DOTS_OVER_ONE_DOT_PUNCTUATION               0x10B3B
#define unicode_LARGE_TWO_DOTS_OVER_ONE_DOT_PUNCTUATION               0x10B3C
#define unicode_LARGE_ONE_DOT_OVER_TWO_DOTS_PUNCTUATION               0x10B3D
#define unicode_LARGE_TWO_RINGS_OVER_ONE_RING_PUNCTUATION             0x10B3E
#define unicode_LARGE_ONE_RING_OVER_TWO_RINGS_PUNCTUATION             0x10B3F
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_ALEPH                   0x10B40
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_BETH                    0x10B41
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_GIMEL                   0x10B42
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_DALETH                  0x10B43
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_HE                      0x10B44
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_WAW                     0x10B45
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_ZAYIN                   0x10B46
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_HETH                    0x10B47
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_TETH                    0x10B48
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_YODH                    0x10B49
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_KAPH                    0x10B4A
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_LAMEDH                  0x10B4B
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_MEM                     0x10B4C
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_NUN                     0x10B4D
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_SAMEKH                  0x10B4E
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_AYIN                    0x10B4F
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_PE                      0x10B50
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_SADHE                   0x10B51
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_QOPH                    0x10B52
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_RESH                    0x10B53
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_SHIN                    0x10B54
#define unicode_INSCRIPTIONAL_PARTHIAN_LETTER_TAW                     0x10B55
#define unicode_INSCRIPTIONAL_PARTHIAN_NUMBER_ONE                     0x10B58
#define unicode_INSCRIPTIONAL_PARTHIAN_NUMBER_TWO                     0x10B59
#define unicode_INSCRIPTIONAL_PARTHIAN_NUMBER_THREE                   0x10B5A
#define unicode_INSCRIPTIONAL_PARTHIAN_NUMBER_FOUR                    0x10B5B
#define unicode_INSCRIPTIONAL_PARTHIAN_NUMBER_TEN                     0x10B5C
#define unicode_INSCRIPTIONAL_PARTHIAN_NUMBER_TWENTY                  0x10B5D
#define unicode_INSCRIPTIONAL_PARTHIAN_NUMBER_ONE_HUNDRED             0x10B5E
#define unicode_INSCRIPTIONAL_PARTHIAN_NUMBER_ONE_THOUSAND            0x10B5F
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_ALEPH                    0x10B60
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_BETH                     0x10B61
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_GIMEL                    0x10B62
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_DALETH                   0x10B63
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_HE                       0x10B64
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_WAW_AYIN_RESH            0x10B65
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_ZAYIN                    0x10B66
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_HETH                     0x10B67
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_TETH                     0x10B68
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_YODH                     0x10B69
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_KAPH                     0x10B6A
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_LAMEDH                   0x10B6B
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_MEM_QOPH                 0x10B6C
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_NUN                      0x10B6D
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_SAMEKH                   0x10B6E
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_PE                       0x10B6F
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_SADHE                    0x10B70
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_SHIN                     0x10B71
#define unicode_INSCRIPTIONAL_PAHLAVI_LETTER_TAW                      0x10B72
#define unicode_INSCRIPTIONAL_PAHLAVI_NUMBER_ONE                      0x10B78
#define unicode_INSCRIPTIONAL_PAHLAVI_NUMBER_TWO                      0x10B79
#define unicode_INSCRIPTIONAL_PAHLAVI_NUMBER_THREE                    0x10B7A
#define unicode_INSCRIPTIONAL_PAHLAVI_NUMBER_FOUR                     0x10B7B
#define unicode_INSCRIPTIONAL_PAHLAVI_NUMBER_TEN                      0x10B7C
#define unicode_INSCRIPTIONAL_PAHLAVI_NUMBER_TWENTY                   0x10B7D
#define unicode_INSCRIPTIONAL_PAHLAVI_NUMBER_ONE_HUNDRED              0x10B7E
#define unicode_INSCRIPTIONAL_PAHLAVI_NUMBER_ONE_THOUSAND             0x10B7F
#define unicode_PSALTER_PAHLAVI_LETTER_ALEPH                          0x10B80
#define unicode_PSALTER_PAHLAVI_LETTER_BETH                           0x10B81
#define unicode_PSALTER_PAHLAVI_LETTER_GIMEL                          0x10B82
#define unicode_PSALTER_PAHLAVI_LETTER_DALETH                         0x10B83
#define unicode_PSALTER_PAHLAVI_LETTER_HE                             0x10B84
#define unicode_PSALTER_PAHLAVI_LETTER_WAW_AYIN_RESH                  0x10B85
#define unicode_PSALTER_PAHLAVI_LETTER_ZAYIN                          0x10B86
#define unicode_PSALTER_PAHLAVI_LETTER_HETH                           0x10B87
#define unicode_PSALTER_PAHLAVI_LETTER_YODH                           0x10B88
#define unicode_PSALTER_PAHLAVI_LETTER_KAPH                           0x10B89
#define unicode_PSALTER_PAHLAVI_LETTER_LAMEDH                         0x10B8A
#define unicode_PSALTER_PAHLAVI_LETTER_MEM_QOPH                       0x10B8B
#define unicode_PSALTER_PAHLAVI_LETTER_NUN                            0x10B8C
#define unicode_PSALTER_PAHLAVI_LETTER_SAMEKH                         0x10B8D
#define unicode_PSALTER_PAHLAVI_LETTER_PE                             0x10B8E
#define unicode_PSALTER_PAHLAVI_LETTER_SADHE                          0x10B8F
#define unicode_PSALTER_PAHLAVI_LETTER_SHIN                           0x10B90
#define unicode_PSALTER_PAHLAVI_LETTER_TAW                            0x10B91
#define unicode_PSALTER_PAHLAVI_SECTION_MARK                          0x10B99
#define unicode_PSALTER_PAHLAVI_TURNED_SECTION_MARK                   0x10B9A
#define unicode_PSALTER_PAHLAVI_FOUR_DOTS_WITH_CROSS                  0x10B9B
#define unicode_PSALTER_PAHLAVI_FOUR_DOTS_WITH_DOT                    0x10B9C
#define unicode_PSALTER_PAHLAVI_NUMBER_ONE                            0x10BA9
#define unicode_PSALTER_PAHLAVI_NUMBER_TWO                            0x10BAA
#define unicode_PSALTER_PAHLAVI_NUMBER_THREE                          0x10BAB
#define unicode_PSALTER_PAHLAVI_NUMBER_FOUR                           0x10BAC
#define unicode_PSALTER_PAHLAVI_NUMBER_TEN                            0x10BAD
#define unicode_PSALTER_PAHLAVI_NUMBER_TWENTY                         0x10BAE
#define unicode_PSALTER_PAHLAVI_NUMBER_ONE_HUNDRED                    0x10BAF
#define unicode_OLD_TURKIC_LETTER_ORKHON_A                            0x10C00
#define unicode_OLD_TURKIC_LETTER_YENISEI_A                           0x10C01
#define unicode_OLD_TURKIC_LETTER_YENISEI_AE                          0x10C02
#define unicode_OLD_TURKIC_LETTER_ORKHON_I                            0x10C03
#define unicode_OLD_TURKIC_LETTER_YENISEI_I                           0x10C04
#define unicode_OLD_TURKIC_LETTER_YENISEI_E                           0x10C05
#define unicode_OLD_TURKIC_LETTER_ORKHON_O                            0x10C06
#define unicode_OLD_TURKIC_LETTER_ORKHON_OE                           0x10C07
#define unicode_OLD_TURKIC_LETTER_YENISEI_OE                          0x10C08
#define unicode_OLD_TURKIC_LETTER_ORKHON_AB                           0x10C09
#define unicode_OLD_TURKIC_LETTER_YENISEI_AB                          0x10C0A
#define unicode_OLD_TURKIC_LETTER_ORKHON_AEB                          0x10C0B
#define unicode_OLD_TURKIC_LETTER_YENISEI_AEB                         0x10C0C
#define unicode_OLD_TURKIC_LETTER_ORKHON_AG                           0x10C0D
#define unicode_OLD_TURKIC_LETTER_YENISEI_AG                          0x10C0E
#define unicode_OLD_TURKIC_LETTER_ORKHON_AEG                          0x10C0F
#define unicode_OLD_TURKIC_LETTER_YENISEI_AEG                         0x10C10
#define unicode_OLD_TURKIC_LETTER_ORKHON_AD                           0x10C11
#define unicode_OLD_TURKIC_LETTER_YENISEI_AD                          0x10C12
#define unicode_OLD_TURKIC_LETTER_ORKHON_AED                          0x10C13
#define unicode_OLD_TURKIC_LETTER_ORKHON_EZ                           0x10C14
#define unicode_OLD_TURKIC_LETTER_YENISEI_EZ                          0x10C15
#define unicode_OLD_TURKIC_LETTER_ORKHON_AY                           0x10C16
#define unicode_OLD_TURKIC_LETTER_YENISEI_AY                          0x10C17
#define unicode_OLD_TURKIC_LETTER_ORKHON_AEY                          0x10C18
#define unicode_OLD_TURKIC_LETTER_YENISEI_AEY                         0x10C19
#define unicode_OLD_TURKIC_LETTER_ORKHON_AEK                          0x10C1A
#define unicode_OLD_TURKIC_LETTER_YENISEI_AEK                         0x10C1B
#define unicode_OLD_TURKIC_LETTER_ORKHON_OEK                          0x10C1C
#define unicode_OLD_TURKIC_LETTER_YENISEI_OEK                         0x10C1D
#define unicode_OLD_TURKIC_LETTER_ORKHON_AL                           0x10C1E
#define unicode_OLD_TURKIC_LETTER_YENISEI_AL                          0x10C1F
#define unicode_OLD_TURKIC_LETTER_ORKHON_AEL                          0x10C20
#define unicode_OLD_TURKIC_LETTER_ORKHON_ELT                          0x10C21
#define unicode_OLD_TURKIC_LETTER_ORKHON_EM                           0x10C22
#define unicode_OLD_TURKIC_LETTER_ORKHON_AN                           0x10C23
#define unicode_OLD_TURKIC_LETTER_ORKHON_AEN                          0x10C24
#define unicode_OLD_TURKIC_LETTER_YENISEI_AEN                         0x10C25
#define unicode_OLD_TURKIC_LETTER_ORKHON_ENT                          0x10C26
#define unicode_OLD_TURKIC_LETTER_YENISEI_ENT                         0x10C27
#define unicode_OLD_TURKIC_LETTER_ORKHON_ENC                          0x10C28
#define unicode_OLD_TURKIC_LETTER_YENISEI_ENC                         0x10C29
#define unicode_OLD_TURKIC_LETTER_ORKHON_ENY                          0x10C2A
#define unicode_OLD_TURKIC_LETTER_YENISEI_ENY                         0x10C2B
#define unicode_OLD_TURKIC_LETTER_YENISEI_ANG                         0x10C2C
#define unicode_OLD_TURKIC_LETTER_ORKHON_ENG                          0x10C2D
#define unicode_OLD_TURKIC_LETTER_YENISEI_AENG                        0x10C2E
#define unicode_OLD_TURKIC_LETTER_ORKHON_EP                           0x10C2F
#define unicode_OLD_TURKIC_LETTER_ORKHON_OP                           0x10C30
#define unicode_OLD_TURKIC_LETTER_ORKHON_IC                           0x10C31
#define unicode_OLD_TURKIC_LETTER_ORKHON_EC                           0x10C32
#define unicode_OLD_TURKIC_LETTER_YENISEI_EC                          0x10C33
#define unicode_OLD_TURKIC_LETTER_ORKHON_AQ                           0x10C34
#define unicode_OLD_TURKIC_LETTER_YENISEI_AQ                          0x10C35
#define unicode_OLD_TURKIC_LETTER_ORKHON_IQ                           0x10C36
#define unicode_OLD_TURKIC_LETTER_YENISEI_IQ                          0x10C37
#define unicode_OLD_TURKIC_LETTER_ORKHON_OQ                           0x10C38
#define unicode_OLD_TURKIC_LETTER_YENISEI_OQ                          0x10C39
#define unicode_OLD_TURKIC_LETTER_ORKHON_AR                           0x10C3A
#define unicode_OLD_TURKIC_LETTER_YENISEI_AR                          0x10C3B
#define unicode_OLD_TURKIC_LETTER_ORKHON_AER                          0x10C3C
#define unicode_OLD_TURKIC_LETTER_ORKHON_AS                           0x10C3D
#define unicode_OLD_TURKIC_LETTER_ORKHON_AES                          0x10C3E
#define unicode_OLD_TURKIC_LETTER_ORKHON_ASH                          0x10C3F
#define unicode_OLD_TURKIC_LETTER_YENISEI_ASH                         0x10C40
#define unicode_OLD_TURKIC_LETTER_ORKHON_ESH                          0x10C41
#define unicode_OLD_TURKIC_LETTER_YENISEI_ESH                         0x10C42
#define unicode_OLD_TURKIC_LETTER_ORKHON_AT                           0x10C43
#define unicode_OLD_TURKIC_LETTER_YENISEI_AT                          0x10C44
#define unicode_OLD_TURKIC_LETTER_ORKHON_AET                          0x10C45
#define unicode_OLD_TURKIC_LETTER_YENISEI_AET                         0x10C46
#define unicode_OLD_TURKIC_LETTER_ORKHON_OT                           0x10C47
#define unicode_OLD_TURKIC_LETTER_ORKHON_BASH                         0x10C48
#define unicode_RUMI_DIGIT_ONE                                        0x10E60
#define unicode_RUMI_DIGIT_TWO                                        0x10E61
#define unicode_RUMI_DIGIT_THREE                                      0x10E62
#define unicode_RUMI_DIGIT_FOUR                                       0x10E63
#define unicode_RUMI_DIGIT_FIVE                                       0x10E64
#define unicode_RUMI_DIGIT_SIX                                        0x10E65
#define unicode_RUMI_DIGIT_SEVEN                                      0x10E66
#define unicode_RUMI_DIGIT_EIGHT                                      0x10E67
#define unicode_RUMI_DIGIT_NINE                                       0x10E68
#define unicode_RUMI_NUMBER_TEN                                       0x10E69
#define unicode_RUMI_NUMBER_TWENTY                                    0x10E6A
#define unicode_RUMI_NUMBER_THIRTY                                    0x10E6B
#define unicode_RUMI_NUMBER_FORTY                                     0x10E6C
#define unicode_RUMI_NUMBER_FIFTY                                     0x10E6D
#define unicode_RUMI_NUMBER_SIXTY                                     0x10E6E
#define unicode_RUMI_NUMBER_SEVENTY                                   0x10E6F
#define unicode_RUMI_NUMBER_EIGHTY                                    0x10E70
#define unicode_RUMI_NUMBER_NINETY                                    0x10E71
#define unicode_RUMI_NUMBER_ONE_HUNDRED                               0x10E72
#define unicode_RUMI_NUMBER_TWO_HUNDRED                               0x10E73
#define unicode_RUMI_NUMBER_THREE_HUNDRED                             0x10E74
#define unicode_RUMI_NUMBER_FOUR_HUNDRED                              0x10E75
#define unicode_RUMI_NUMBER_FIVE_HUNDRED                              0x10E76
#define unicode_RUMI_NUMBER_SIX_HUNDRED                               0x10E77
#define unicode_RUMI_NUMBER_SEVEN_HUNDRED                             0x10E78
#define unicode_RUMI_NUMBER_EIGHT_HUNDRED                             0x10E79
#define unicode_RUMI_NUMBER_NINE_HUNDRED                              0x10E7A
#define unicode_RUMI_FRACTION_ONE_HALF                                0x10E7B
#define unicode_RUMI_FRACTION_ONE_QUARTER                             0x10E7C
#define unicode_RUMI_FRACTION_ONE_THIRD                               0x10E7D
#define unicode_RUMI_FRACTION_TWO_THIRDS                              0x10E7E
#define unicode_BRAHMI_SIGN_CANDRABINDU                               0x11000
#define unicode_BRAHMI_SIGN_ANUSVARA                                  0x11001
#define unicode_BRAHMI_SIGN_VISARGA                                   0x11002
#define unicode_BRAHMI_SIGN_JIHVAMULIYA                               0x11003
#define unicode_BRAHMI_SIGN_UPADHMANIYA                               0x11004
#define unicode_BRAHMI_LETTER_A                                       0x11005
#define unicode_BRAHMI_LETTER_AA                                      0x11006
#define unicode_BRAHMI_LETTER_I                                       0x11007
#define unicode_BRAHMI_LETTER_II                                      0x11008
#define unicode_BRAHMI_LETTER_U                                       0x11009
#define unicode_BRAHMI_LETTER_UU                                      0x1100A
#define unicode_BRAHMI_LETTER_VOCALIC_R                               0x1100B
#define unicode_BRAHMI_LETTER_VOCALIC_RR                              0x1100C
#define unicode_BRAHMI_LETTER_VOCALIC_L                               0x1100D
#define unicode_BRAHMI_LETTER_VOCALIC_LL                              0x1100E
#define unicode_BRAHMI_LETTER_E                                       0x1100F
#define unicode_BRAHMI_LETTER_AI                                      0x11010
#define unicode_BRAHMI_LETTER_O                                       0x11011
#define unicode_BRAHMI_LETTER_AU                                      0x11012
#define unicode_BRAHMI_LETTER_KA                                      0x11013
#define unicode_BRAHMI_LETTER_KHA                                     0x11014
#define unicode_BRAHMI_LETTER_GA                                      0x11015
#define unicode_BRAHMI_LETTER_GHA                                     0x11016
#define unicode_BRAHMI_LETTER_NGA                                     0x11017
#define unicode_BRAHMI_LETTER_CA                                      0x11018
#define unicode_BRAHMI_LETTER_CHA                                     0x11019
#define unicode_BRAHMI_LETTER_JA                                      0x1101A
#define unicode_BRAHMI_LETTER_JHA                                     0x1101B
#define unicode_BRAHMI_LETTER_NYA                                     0x1101C
#define unicode_BRAHMI_LETTER_TTA                                     0x1101D
#define unicode_BRAHMI_LETTER_TTHA                                    0x1101E
#define unicode_BRAHMI_LETTER_DDA                                     0x1101F
#define unicode_BRAHMI_LETTER_DDHA                                    0x11020
#define unicode_BRAHMI_LETTER_NNA                                     0x11021
#define unicode_BRAHMI_LETTER_TA                                      0x11022
#define unicode_BRAHMI_LETTER_THA                                     0x11023
#define unicode_BRAHMI_LETTER_DA                                      0x11024
#define unicode_BRAHMI_LETTER_DHA                                     0x11025
#define unicode_BRAHMI_LETTER_NA                                      0x11026
#define unicode_BRAHMI_LETTER_PA                                      0x11027
#define unicode_BRAHMI_LETTER_PHA                                     0x11028
#define unicode_BRAHMI_LETTER_BA                                      0x11029
#define unicode_BRAHMI_LETTER_BHA                                     0x1102A
#define unicode_BRAHMI_LETTER_MA                                      0x1102B
#define unicode_BRAHMI_LETTER_YA                                      0x1102C
#define unicode_BRAHMI_LETTER_RA                                      0x1102D
#define unicode_BRAHMI_LETTER_LA                                      0x1102E
#define unicode_BRAHMI_LETTER_VA                                      0x1102F
#define unicode_BRAHMI_LETTER_SHA                                     0x11030
#define unicode_BRAHMI_LETTER_SSA                                     0x11031
#define unicode_BRAHMI_LETTER_SA                                      0x11032
#define unicode_BRAHMI_LETTER_HA                                      0x11033
#define unicode_BRAHMI_LETTER_LLA                                     0x11034
#define unicode_BRAHMI_LETTER_OLD_TAMIL_LLLA                          0x11035
#define unicode_BRAHMI_LETTER_OLD_TAMIL_RRA                           0x11036
#define unicode_BRAHMI_LETTER_OLD_TAMIL_NNNA                          0x11037
#define unicode_BRAHMI_VOWEL_SIGN_AA                                  0x11038
#define unicode_BRAHMI_VOWEL_SIGN_BHATTIPROLU_AA                      0x11039
#define unicode_BRAHMI_VOWEL_SIGN_I                                   0x1103A
#define unicode_BRAHMI_VOWEL_SIGN_II                                  0x1103B
#define unicode_BRAHMI_VOWEL_SIGN_U                                   0x1103C
#define unicode_BRAHMI_VOWEL_SIGN_UU                                  0x1103D
#define unicode_BRAHMI_VOWEL_SIGN_VOCALIC_R                           0x1103E
#define unicode_BRAHMI_VOWEL_SIGN_VOCALIC_RR                          0x1103F
#define unicode_BRAHMI_VOWEL_SIGN_VOCALIC_L                           0x11040
#define unicode_BRAHMI_VOWEL_SIGN_VOCALIC_LL                          0x11041
#define unicode_BRAHMI_VOWEL_SIGN_E                                   0x11042
#define unicode_BRAHMI_VOWEL_SIGN_AI                                  0x11043
#define unicode_BRAHMI_VOWEL_SIGN_O                                   0x11044
#define unicode_BRAHMI_VOWEL_SIGN_AU                                  0x11045
#define unicode_BRAHMI_VIRAMA                                         0x11046
#define unicode_BRAHMI_DANDA                                          0x11047
#define unicode_BRAHMI_DOUBLE_DANDA                                   0x11048
#define unicode_BRAHMI_PUNCTUATION_DOT                                0x11049
#define unicode_BRAHMI_PUNCTUATION_DOUBLE_DOT                         0x1104A
#define unicode_BRAHMI_PUNCTUATION_LINE                               0x1104B
#define unicode_BRAHMI_PUNCTUATION_CRESCENT_BAR                       0x1104C
#define unicode_BRAHMI_PUNCTUATION_LOTUS                              0x1104D
#define unicode_BRAHMI_NUMBER_ONE                                     0x11052
#define unicode_BRAHMI_NUMBER_TWO                                     0x11053
#define unicode_BRAHMI_NUMBER_THREE                                   0x11054
#define unicode_BRAHMI_NUMBER_FOUR                                    0x11055
#define unicode_BRAHMI_NUMBER_FIVE                                    0x11056
#define unicode_BRAHMI_NUMBER_SIX                                     0x11057
#define unicode_BRAHMI_NUMBER_SEVEN                                   0x11058
#define unicode_BRAHMI_NUMBER_EIGHT                                   0x11059
#define unicode_BRAHMI_NUMBER_NINE                                    0x1105A
#define unicode_BRAHMI_NUMBER_TEN                                     0x1105B
#define unicode_BRAHMI_NUMBER_TWENTY                                  0x1105C
#define unicode_BRAHMI_NUMBER_THIRTY                                  0x1105D
#define unicode_BRAHMI_NUMBER_FORTY                                   0x1105E
#define unicode_BRAHMI_NUMBER_FIFTY                                   0x1105F
#define unicode_BRAHMI_NUMBER_SIXTY                                   0x11060
#define unicode_BRAHMI_NUMBER_SEVENTY                                 0x11061
#define unicode_BRAHMI_NUMBER_EIGHTY                                  0x11062
#define unicode_BRAHMI_NUMBER_NINETY                                  0x11063
#define unicode_BRAHMI_NUMBER_ONE_HUNDRED                             0x11064
#define unicode_BRAHMI_NUMBER_ONE_THOUSAND                            0x11065
#define unicode_BRAHMI_DIGIT_ZERO                                     0x11066
#define unicode_BRAHMI_DIGIT_ONE                                      0x11067
#define unicode_BRAHMI_DIGIT_TWO                                      0x11068
#define unicode_BRAHMI_DIGIT_THREE                                    0x11069
#define unicode_BRAHMI_DIGIT_FOUR                                     0x1106A
#define unicode_BRAHMI_DIGIT_FIVE                                     0x1106B
#define unicode_BRAHMI_DIGIT_SIX                                      0x1106C
#define unicode_BRAHMI_DIGIT_SEVEN                                    0x1106D
#define unicode_BRAHMI_DIGIT_EIGHT                                    0x1106E
#define unicode_BRAHMI_DIGIT_NINE                                     0x1106F
#define unicode_BRAHMI_NUMBER_JOINER                                  0x1107F
#define unicode_KAITHI_SIGN_CANDRABINDU                               0x11080
#define unicode_KAITHI_SIGN_ANUSVARA                                  0x11081
#define unicode_KAITHI_SIGN_VISARGA                                   0x11082
#define unicode_KAITHI_LETTER_A                                       0x11083
#define unicode_KAITHI_LETTER_AA                                      0x11084
#define unicode_KAITHI_LETTER_I                                       0x11085
#define unicode_KAITHI_LETTER_II                                      0x11086
#define unicode_KAITHI_LETTER_U                                       0x11087
#define unicode_KAITHI_LETTER_UU                                      0x11088
#define unicode_KAITHI_LETTER_E                                       0x11089
#define unicode_KAITHI_LETTER_AI                                      0x1108A
#define unicode_KAITHI_LETTER_O                                       0x1108B
#define unicode_KAITHI_LETTER_AU                                      0x1108C
#define unicode_KAITHI_LETTER_KA                                      0x1108D
#define unicode_KAITHI_LETTER_KHA                                     0x1108E
#define unicode_KAITHI_LETTER_GA                                      0x1108F
#define unicode_KAITHI_LETTER_GHA                                     0x11090
#define unicode_KAITHI_LETTER_NGA                                     0x11091
#define unicode_KAITHI_LETTER_CA                                      0x11092
#define unicode_KAITHI_LETTER_CHA                                     0x11093
#define unicode_KAITHI_LETTER_JA                                      0x11094
#define unicode_KAITHI_LETTER_JHA                                     0x11095
#define unicode_KAITHI_LETTER_NYA                                     0x11096
#define unicode_KAITHI_LETTER_TTA                                     0x11097
#define unicode_KAITHI_LETTER_TTHA                                    0x11098
#define unicode_KAITHI_LETTER_DDA                                     0x11099
#define unicode_KAITHI_LETTER_DDDHA                                   0x1109A
#define unicode_KAITHI_LETTER_DDHA                                    0x1109B
#define unicode_KAITHI_LETTER_RHA                                     0x1109C
#define unicode_KAITHI_LETTER_NNA                                     0x1109D
#define unicode_KAITHI_LETTER_TA                                      0x1109E
#define unicode_KAITHI_LETTER_THA                                     0x1109F
#define unicode_KAITHI_LETTER_DA                                      0x110A0
#define unicode_KAITHI_LETTER_DHA                                     0x110A1
#define unicode_KAITHI_LETTER_NA                                      0x110A2
#define unicode_KAITHI_LETTER_PA                                      0x110A3
#define unicode_KAITHI_LETTER_PHA                                     0x110A4
#define unicode_KAITHI_LETTER_BA                                      0x110A5
#define unicode_KAITHI_LETTER_BHA                                     0x110A6
#define unicode_KAITHI_LETTER_MA                                      0x110A7
#define unicode_KAITHI_LETTER_YA                                      0x110A8
#define unicode_KAITHI_LETTER_RA                                      0x110A9
#define unicode_KAITHI_LETTER_LA                                      0x110AA
#define unicode_KAITHI_LETTER_VA                                      0x110AB
#define unicode_KAITHI_LETTER_SHA                                     0x110AC
#define unicode_KAITHI_LETTER_SSA                                     0x110AD
#define unicode_KAITHI_LETTER_SA                                      0x110AE
#define unicode_KAITHI_LETTER_HA                                      0x110AF
#define unicode_KAITHI_VOWEL_SIGN_AA                                  0x110B0
#define unicode_KAITHI_VOWEL_SIGN_I                                   0x110B1
#define unicode_KAITHI_VOWEL_SIGN_II                                  0x110B2
#define unicode_KAITHI_VOWEL_SIGN_U                                   0x110B3
#define unicode_KAITHI_VOWEL_SIGN_UU                                  0x110B4
#define unicode_KAITHI_VOWEL_SIGN_E                                   0x110B5
#define unicode_KAITHI_VOWEL_SIGN_AI                                  0x110B6
#define unicode_KAITHI_VOWEL_SIGN_O                                   0x110B7
#define unicode_KAITHI_VOWEL_SIGN_AU                                  0x110B8
#define unicode_KAITHI_SIGN_VIRAMA                                    0x110B9
#define unicode_KAITHI_SIGN_NUKTA                                     0x110BA
#define unicode_KAITHI_ABBREVIATION_SIGN                              0x110BB
#define unicode_KAITHI_ENUMERATION_SIGN                               0x110BC
#define unicode_KAITHI_NUMBER_SIGN                                    0x110BD
#define unicode_KAITHI_SECTION_MARK                                   0x110BE
#define unicode_KAITHI_DOUBLE_SECTION_MARK                            0x110BF
#define unicode_KAITHI_DANDA                                          0x110C0
#define unicode_KAITHI_DOUBLE_DANDA                                   0x110C1
#define unicode_SORA_SOMPENG_LETTER_SAH                               0x110D0
#define unicode_SORA_SOMPENG_LETTER_TAH                               0x110D1
#define unicode_SORA_SOMPENG_LETTER_BAH                               0x110D2
#define unicode_SORA_SOMPENG_LETTER_CAH                               0x110D3
#define unicode_SORA_SOMPENG_LETTER_DAH                               0x110D4
#define unicode_SORA_SOMPENG_LETTER_GAH                               0x110D5
#define unicode_SORA_SOMPENG_LETTER_MAH                               0x110D6
#define unicode_SORA_SOMPENG_LETTER_NGAH                              0x110D7
#define unicode_SORA_SOMPENG_LETTER_LAH                               0x110D8
#define unicode_SORA_SOMPENG_LETTER_NAH                               0x110D9
#define unicode_SORA_SOMPENG_LETTER_VAH                               0x110DA
#define unicode_SORA_SOMPENG_LETTER_PAH                               0x110DB
#define unicode_SORA_SOMPENG_LETTER_YAH                               0x110DC
#define unicode_SORA_SOMPENG_LETTER_RAH                               0x110DD
#define unicode_SORA_SOMPENG_LETTER_HAH                               0x110DE
#define unicode_SORA_SOMPENG_LETTER_KAH                               0x110DF
#define unicode_SORA_SOMPENG_LETTER_JAH                               0x110E0
#define unicode_SORA_SOMPENG_LETTER_NYAH                              0x110E1
#define unicode_SORA_SOMPENG_LETTER_AH                                0x110E2
#define unicode_SORA_SOMPENG_LETTER_EEH                               0x110E3
#define unicode_SORA_SOMPENG_LETTER_IH                                0x110E4
#define unicode_SORA_SOMPENG_LETTER_UH                                0x110E5
#define unicode_SORA_SOMPENG_LETTER_OH                                0x110E6
#define unicode_SORA_SOMPENG_LETTER_EH                                0x110E7
#define unicode_SORA_SOMPENG_LETTER_MAE                               0x110E8
#define unicode_SORA_SOMPENG_DIGIT_ZERO                               0x110F0
#define unicode_SORA_SOMPENG_DIGIT_ONE                                0x110F1
#define unicode_SORA_SOMPENG_DIGIT_TWO                                0x110F2
#define unicode_SORA_SOMPENG_DIGIT_THREE                              0x110F3
#define unicode_SORA_SOMPENG_DIGIT_FOUR                               0x110F4
#define unicode_SORA_SOMPENG_DIGIT_FIVE                               0x110F5
#define unicode_SORA_SOMPENG_DIGIT_SIX                                0x110F6
#define unicode_SORA_SOMPENG_DIGIT_SEVEN                              0x110F7
#define unicode_SORA_SOMPENG_DIGIT_EIGHT                              0x110F8
#define unicode_SORA_SOMPENG_DIGIT_NINE                               0x110F9
#define unicode_CHAKMA_SIGN_CANDRABINDU                               0x11100
#define unicode_CHAKMA_SIGN_ANUSVARA                                  0x11101
#define unicode_CHAKMA_SIGN_VISARGA                                   0x11102
#define unicode_CHAKMA_LETTER_AA                                      0x11103
#define unicode_CHAKMA_LETTER_I                                       0x11104
#define unicode_CHAKMA_LETTER_U                                       0x11105
#define unicode_CHAKMA_LETTER_E                                       0x11106
#define unicode_CHAKMA_LETTER_KAA                                     0x11107
#define unicode_CHAKMA_LETTER_KHAA                                    0x11108
#define unicode_CHAKMA_LETTER_GAA                                     0x11109
#define unicode_CHAKMA_LETTER_GHAA                                    0x1110A
#define unicode_CHAKMA_LETTER_NGAA                                    0x1110B
#define unicode_CHAKMA_LETTER_CAA                                     0x1110C
#define unicode_CHAKMA_LETTER_CHAA                                    0x1110D
#define unicode_CHAKMA_LETTER_JAA                                     0x1110E
#define unicode_CHAKMA_LETTER_JHAA                                    0x1110F
#define unicode_CHAKMA_LETTER_NYAA                                    0x11110
#define unicode_CHAKMA_LETTER_TTAA                                    0x11111
#define unicode_CHAKMA_LETTER_TTHAA                                   0x11112
#define unicode_CHAKMA_LETTER_DDAA                                    0x11113
#define unicode_CHAKMA_LETTER_DDHAA                                   0x11114
#define unicode_CHAKMA_LETTER_NNAA                                    0x11115
#define unicode_CHAKMA_LETTER_TAA                                     0x11116
#define unicode_CHAKMA_LETTER_THAA                                    0x11117
#define unicode_CHAKMA_LETTER_DAA                                     0x11118
#define unicode_CHAKMA_LETTER_DHAA                                    0x11119
#define unicode_CHAKMA_LETTER_NAA                                     0x1111A
#define unicode_CHAKMA_LETTER_PAA                                     0x1111B
#define unicode_CHAKMA_LETTER_PHAA                                    0x1111C
#define unicode_CHAKMA_LETTER_BAA                                     0x1111D
#define unicode_CHAKMA_LETTER_BHAA                                    0x1111E
#define unicode_CHAKMA_LETTER_MAA                                     0x1111F
#define unicode_CHAKMA_LETTER_YYAA                                    0x11120
#define unicode_CHAKMA_LETTER_YAA                                     0x11121
#define unicode_CHAKMA_LETTER_RAA                                     0x11122
#define unicode_CHAKMA_LETTER_LAA                                     0x11123
#define unicode_CHAKMA_LETTER_WAA                                     0x11124
#define unicode_CHAKMA_LETTER_SAA                                     0x11125
#define unicode_CHAKMA_LETTER_HAA                                     0x11126
#define unicode_CHAKMA_VOWEL_SIGN_A                                   0x11127
#define unicode_CHAKMA_VOWEL_SIGN_I                                   0x11128
#define unicode_CHAKMA_VOWEL_SIGN_II                                  0x11129
#define unicode_CHAKMA_VOWEL_SIGN_U                                   0x1112A
#define unicode_CHAKMA_VOWEL_SIGN_UU                                  0x1112B
#define unicode_CHAKMA_VOWEL_SIGN_E                                   0x1112C
#define unicode_CHAKMA_VOWEL_SIGN_AI                                  0x1112D
#define unicode_CHAKMA_VOWEL_SIGN_O                                   0x1112E
#define unicode_CHAKMA_VOWEL_SIGN_AU                                  0x1112F
#define unicode_CHAKMA_VOWEL_SIGN_OI                                  0x11130
#define unicode_CHAKMA_O_MARK                                         0x11131
#define unicode_CHAKMA_AU_MARK                                        0x11132
#define unicode_CHAKMA_VIRAMA                                         0x11133
#define unicode_CHAKMA_MAAYYAA                                        0x11134
#define unicode_CHAKMA_DIGIT_ZERO                                     0x11136
#define unicode_CHAKMA_DIGIT_ONE                                      0x11137
#define unicode_CHAKMA_DIGIT_TWO                                      0x11138
#define unicode_CHAKMA_DIGIT_THREE                                    0x11139
#define unicode_CHAKMA_DIGIT_FOUR                                     0x1113A
#define unicode_CHAKMA_DIGIT_FIVE                                     0x1113B
#define unicode_CHAKMA_DIGIT_SIX                                      0x1113C
#define unicode_CHAKMA_DIGIT_SEVEN                                    0x1113D
#define unicode_CHAKMA_DIGIT_EIGHT                                    0x1113E
#define unicode_CHAKMA_DIGIT_NINE                                     0x1113F
#define unicode_CHAKMA_SECTION_MARK                                   0x11140
#define unicode_CHAKMA_DANDA                                          0x11141
#define unicode_CHAKMA_DOUBLE_DANDA                                   0x11142
#define unicode_CHAKMA_QUESTION_MARK                                  0x11143
#define unicode_MAHAJANI_LETTER_A                                     0x11150
#define unicode_MAHAJANI_LETTER_I                                     0x11151
#define unicode_MAHAJANI_LETTER_U                                     0x11152
#define unicode_MAHAJANI_LETTER_E                                     0x11153
#define unicode_MAHAJANI_LETTER_O                                     0x11154
#define unicode_MAHAJANI_LETTER_KA                                    0x11155
#define unicode_MAHAJANI_LETTER_KHA                                   0x11156
#define unicode_MAHAJANI_LETTER_GA                                    0x11157
#define unicode_MAHAJANI_LETTER_GHA                                   0x11158
#define unicode_MAHAJANI_LETTER_CA                                    0x11159
#define unicode_MAHAJANI_LETTER_CHA                                   0x1115A
#define unicode_MAHAJANI_LETTER_JA                                    0x1115B
#define unicode_MAHAJANI_LETTER_JHA                                   0x1115C
#define unicode_MAHAJANI_LETTER_NYA                                   0x1115D
#define unicode_MAHAJANI_LETTER_TTA                                   0x1115E
#define unicode_MAHAJANI_LETTER_TTHA                                  0x1115F
#define unicode_MAHAJANI_LETTER_DDA                                   0x11160
#define unicode_MAHAJANI_LETTER_DDHA                                  0x11161
#define unicode_MAHAJANI_LETTER_NNA                                   0x11162
#define unicode_MAHAJANI_LETTER_TA                                    0x11163
#define unicode_MAHAJANI_LETTER_THA                                   0x11164
#define unicode_MAHAJANI_LETTER_DA                                    0x11165
#define unicode_MAHAJANI_LETTER_DHA                                   0x11166
#define unicode_MAHAJANI_LETTER_NA                                    0x11167
#define unicode_MAHAJANI_LETTER_PA                                    0x11168
#define unicode_MAHAJANI_LETTER_PHA                                   0x11169
#define unicode_MAHAJANI_LETTER_BA                                    0x1116A
#define unicode_MAHAJANI_LETTER_BHA                                   0x1116B
#define unicode_MAHAJANI_LETTER_MA                                    0x1116C
#define unicode_MAHAJANI_LETTER_RA                                    0x1116D
#define unicode_MAHAJANI_LETTER_LA                                    0x1116E
#define unicode_MAHAJANI_LETTER_VA                                    0x1116F
#define unicode_MAHAJANI_LETTER_SA                                    0x11170
#define unicode_MAHAJANI_LETTER_HA                                    0x11171
#define unicode_MAHAJANI_LETTER_RRA                                   0x11172
#define unicode_MAHAJANI_SIGN_NUKTA                                   0x11173
#define unicode_MAHAJANI_ABBREVIATION_SIGN                            0x11174
#define unicode_MAHAJANI_SECTION_MARK                                 0x11175
#define unicode_MAHAJANI_LIGATURE_SHRI                                0x11176
#define unicode_SHARADA_SIGN_CANDRABINDU                              0x11180
#define unicode_SHARADA_SIGN_ANUSVARA                                 0x11181
#define unicode_SHARADA_SIGN_VISARGA                                  0x11182
#define unicode_SHARADA_LETTER_A                                      0x11183
#define unicode_SHARADA_LETTER_AA                                     0x11184
#define unicode_SHARADA_LETTER_I                                      0x11185
#define unicode_SHARADA_LETTER_II                                     0x11186
#define unicode_SHARADA_LETTER_U                                      0x11187
#define unicode_SHARADA_LETTER_UU                                     0x11188
#define unicode_SHARADA_LETTER_VOCALIC_R                              0x11189
#define unicode_SHARADA_LETTER_VOCALIC_RR                             0x1118A
#define unicode_SHARADA_LETTER_VOCALIC_L                              0x1118B
#define unicode_SHARADA_LETTER_VOCALIC_LL                             0x1118C
#define unicode_SHARADA_LETTER_E                                      0x1118D
#define unicode_SHARADA_LETTER_AI                                     0x1118E
#define unicode_SHARADA_LETTER_O                                      0x1118F
#define unicode_SHARADA_LETTER_AU                                     0x11190
#define unicode_SHARADA_LETTER_KA                                     0x11191
#define unicode_SHARADA_LETTER_KHA                                    0x11192
#define unicode_SHARADA_LETTER_GA                                     0x11193
#define unicode_SHARADA_LETTER_GHA                                    0x11194
#define unicode_SHARADA_LETTER_NGA                                    0x11195
#define unicode_SHARADA_LETTER_CA                                     0x11196
#define unicode_SHARADA_LETTER_CHA                                    0x11197
#define unicode_SHARADA_LETTER_JA                                     0x11198
#define unicode_SHARADA_LETTER_JHA                                    0x11199
#define unicode_SHARADA_LETTER_NYA                                    0x1119A
#define unicode_SHARADA_LETTER_TTA                                    0x1119B
#define unicode_SHARADA_LETTER_TTHA                                   0x1119C
#define unicode_SHARADA_LETTER_DDA                                    0x1119D
#define unicode_SHARADA_LETTER_DDHA                                   0x1119E
#define unicode_SHARADA_LETTER_NNA                                    0x1119F
#define unicode_SHARADA_LETTER_TA                                     0x111A0
#define unicode_SHARADA_LETTER_THA                                    0x111A1
#define unicode_SHARADA_LETTER_DA                                     0x111A2
#define unicode_SHARADA_LETTER_DHA                                    0x111A3
#define unicode_SHARADA_LETTER_NA                                     0x111A4
#define unicode_SHARADA_LETTER_PA                                     0x111A5
#define unicode_SHARADA_LETTER_PHA                                    0x111A6
#define unicode_SHARADA_LETTER_BA                                     0x111A7
#define unicode_SHARADA_LETTER_BHA                                    0x111A8
#define unicode_SHARADA_LETTER_MA                                     0x111A9
#define unicode_SHARADA_LETTER_YA                                     0x111AA
#define unicode_SHARADA_LETTER_RA                                     0x111AB
#define unicode_SHARADA_LETTER_LA                                     0x111AC
#define unicode_SHARADA_LETTER_LLA                                    0x111AD
#define unicode_SHARADA_LETTER_VA                                     0x111AE
#define unicode_SHARADA_LETTER_SHA                                    0x111AF
#define unicode_SHARADA_LETTER_SSA                                    0x111B0
#define unicode_SHARADA_LETTER_SA                                     0x111B1
#define unicode_SHARADA_LETTER_HA                                     0x111B2
#define unicode_SHARADA_VOWEL_SIGN_AA                                 0x111B3
#define unicode_SHARADA_VOWEL_SIGN_I                                  0x111B4
#define unicode_SHARADA_VOWEL_SIGN_II                                 0x111B5
#define unicode_SHARADA_VOWEL_SIGN_U                                  0x111B6
#define unicode_SHARADA_VOWEL_SIGN_UU                                 0x111B7
#define unicode_SHARADA_VOWEL_SIGN_VOCALIC_R                          0x111B8
#define unicode_SHARADA_VOWEL_SIGN_VOCALIC_RR                         0x111B9
#define unicode_SHARADA_VOWEL_SIGN_VOCALIC_L                          0x111BA
#define unicode_SHARADA_VOWEL_SIGN_VOCALIC_LL                         0x111BB
#define unicode_SHARADA_VOWEL_SIGN_E                                  0x111BC
#define unicode_SHARADA_VOWEL_SIGN_AI                                 0x111BD
#define unicode_SHARADA_VOWEL_SIGN_O                                  0x111BE
#define unicode_SHARADA_VOWEL_SIGN_AU                                 0x111BF
#define unicode_SHARADA_SIGN_VIRAMA                                   0x111C0
#define unicode_SHARADA_SIGN_AVAGRAHA                                 0x111C1
#define unicode_SHARADA_SIGN_JIHVAMULIYA                              0x111C2
#define unicode_SHARADA_SIGN_UPADHMANIYA                              0x111C3
#define unicode_SHARADA_OM                                            0x111C4
#define unicode_SHARADA_DANDA                                         0x111C5
#define unicode_SHARADA_DOUBLE_DANDA                                  0x111C6
#define unicode_SHARADA_ABBREVIATION_SIGN                             0x111C7
#define unicode_SHARADA_SEPARATOR                                     0x111C8
#define unicode_SHARADA_SUTRA_MARK                                    0x111CD
#define unicode_SHARADA_DIGIT_ZERO                                    0x111D0
#define unicode_SHARADA_DIGIT_ONE                                     0x111D1
#define unicode_SHARADA_DIGIT_TWO                                     0x111D2
#define unicode_SHARADA_DIGIT_THREE                                   0x111D3
#define unicode_SHARADA_DIGIT_FOUR                                    0x111D4
#define unicode_SHARADA_DIGIT_FIVE                                    0x111D5
#define unicode_SHARADA_DIGIT_SIX                                     0x111D6
#define unicode_SHARADA_DIGIT_SEVEN                                   0x111D7
#define unicode_SHARADA_DIGIT_EIGHT                                   0x111D8
#define unicode_SHARADA_DIGIT_NINE                                    0x111D9
#define unicode_SHARADA_EKAM                                          0x111DA
#define unicode_SINHALA_ARCHAIC_DIGIT_ONE                             0x111E1
#define unicode_SINHALA_ARCHAIC_DIGIT_TWO                             0x111E2
#define unicode_SINHALA_ARCHAIC_DIGIT_THREE                           0x111E3
#define unicode_SINHALA_ARCHAIC_DIGIT_FOUR                            0x111E4
#define unicode_SINHALA_ARCHAIC_DIGIT_FIVE                            0x111E5
#define unicode_SINHALA_ARCHAIC_DIGIT_SIX                             0x111E6
#define unicode_SINHALA_ARCHAIC_DIGIT_SEVEN                           0x111E7
#define unicode_SINHALA_ARCHAIC_DIGIT_EIGHT                           0x111E8
#define unicode_SINHALA_ARCHAIC_DIGIT_NINE                            0x111E9
#define unicode_SINHALA_ARCHAIC_NUMBER_TEN                            0x111EA
#define unicode_SINHALA_ARCHAIC_NUMBER_TWENTY                         0x111EB
#define unicode_SINHALA_ARCHAIC_NUMBER_THIRTY                         0x111EC
#define unicode_SINHALA_ARCHAIC_NUMBER_FORTY                          0x111ED
#define unicode_SINHALA_ARCHAIC_NUMBER_FIFTY                          0x111EE
#define unicode_SINHALA_ARCHAIC_NUMBER_SIXTY                          0x111EF
#define unicode_SINHALA_ARCHAIC_NUMBER_SEVENTY                        0x111F0
#define unicode_SINHALA_ARCHAIC_NUMBER_EIGHTY                         0x111F1
#define unicode_SINHALA_ARCHAIC_NUMBER_NINETY                         0x111F2
#define unicode_SINHALA_ARCHAIC_NUMBER_ONE_HUNDRED                    0x111F3
#define unicode_SINHALA_ARCHAIC_NUMBER_ONE_THOUSAND                   0x111F4
#define unicode_KHOJKI_LETTER_A                                       0x11200
#define unicode_KHOJKI_LETTER_AA                                      0x11201
#define unicode_KHOJKI_LETTER_I                                       0x11202
#define unicode_KHOJKI_LETTER_U                                       0x11203
#define unicode_KHOJKI_LETTER_E                                       0x11204
#define unicode_KHOJKI_LETTER_AI                                      0x11205
#define unicode_KHOJKI_LETTER_O                                       0x11206
#define unicode_KHOJKI_LETTER_AU                                      0x11207
#define unicode_KHOJKI_LETTER_KA                                      0x11208
#define unicode_KHOJKI_LETTER_KHA                                     0x11209
#define unicode_KHOJKI_LETTER_GA                                      0x1120A
#define unicode_KHOJKI_LETTER_GGA                                     0x1120B
#define unicode_KHOJKI_LETTER_GHA                                     0x1120C
#define unicode_KHOJKI_LETTER_NGA                                     0x1120D
#define unicode_KHOJKI_LETTER_CA                                      0x1120E
#define unicode_KHOJKI_LETTER_CHA                                     0x1120F
#define unicode_KHOJKI_LETTER_JA                                      0x11210
#define unicode_KHOJKI_LETTER_JJA                                     0x11211
#define unicode_KHOJKI_LETTER_NYA                                     0x11213
#define unicode_KHOJKI_LETTER_TTA                                     0x11214
#define unicode_KHOJKI_LETTER_TTHA                                    0x11215
#define unicode_KHOJKI_LETTER_DDA                                     0x11216
#define unicode_KHOJKI_LETTER_DDHA                                    0x11217
#define unicode_KHOJKI_LETTER_NNA                                     0x11218
#define unicode_KHOJKI_LETTER_TA                                      0x11219
#define unicode_KHOJKI_LETTER_THA                                     0x1121A
#define unicode_KHOJKI_LETTER_DA                                      0x1121B
#define unicode_KHOJKI_LETTER_DDDA                                    0x1121C
#define unicode_KHOJKI_LETTER_DHA                                     0x1121D
#define unicode_KHOJKI_LETTER_NA                                      0x1121E
#define unicode_KHOJKI_LETTER_PA                                      0x1121F
#define unicode_KHOJKI_LETTER_PHA                                     0x11220
#define unicode_KHOJKI_LETTER_BA                                      0x11221
#define unicode_KHOJKI_LETTER_BBA                                     0x11222
#define unicode_KHOJKI_LETTER_BHA                                     0x11223
#define unicode_KHOJKI_LETTER_MA                                      0x11224
#define unicode_KHOJKI_LETTER_YA                                      0x11225
#define unicode_KHOJKI_LETTER_RA                                      0x11226
#define unicode_KHOJKI_LETTER_LA                                      0x11227
#define unicode_KHOJKI_LETTER_VA                                      0x11228
#define unicode_KHOJKI_LETTER_SA                                      0x11229
#define unicode_KHOJKI_LETTER_HA                                      0x1122A
#define unicode_KHOJKI_LETTER_LLA                                     0x1122B
#define unicode_KHOJKI_VOWEL_SIGN_AA                                  0x1122C
#define unicode_KHOJKI_VOWEL_SIGN_I                                   0x1122D
#define unicode_KHOJKI_VOWEL_SIGN_II                                  0x1122E
#define unicode_KHOJKI_VOWEL_SIGN_U                                   0x1122F
#define unicode_KHOJKI_VOWEL_SIGN_E                                   0x11230
#define unicode_KHOJKI_VOWEL_SIGN_AI                                  0x11231
#define unicode_KHOJKI_VOWEL_SIGN_O                                   0x11232
#define unicode_KHOJKI_VOWEL_SIGN_AU                                  0x11233
#define unicode_KHOJKI_SIGN_ANUSVARA                                  0x11234
#define unicode_KHOJKI_SIGN_VIRAMA                                    0x11235
#define unicode_KHOJKI_SIGN_NUKTA                                     0x11236
#define unicode_KHOJKI_SIGN_SHADDA                                    0x11237
#define unicode_KHOJKI_DANDA                                          0x11238
#define unicode_KHOJKI_DOUBLE_DANDA                                   0x11239
#define unicode_KHOJKI_WORD_SEPARATOR                                 0x1123A
#define unicode_KHOJKI_SECTION_MARK                                   0x1123B
#define unicode_KHOJKI_DOUBLE_SECTION_MARK                            0x1123C
#define unicode_KHOJKI_ABBREVIATION_SIGN                              0x1123D
#define unicode_KHUDAWADI_LETTER_A                                    0x112B0
#define unicode_KHUDAWADI_LETTER_AA                                   0x112B1
#define unicode_KHUDAWADI_LETTER_I                                    0x112B2
#define unicode_KHUDAWADI_LETTER_II                                   0x112B3
#define unicode_KHUDAWADI_LETTER_U                                    0x112B4
#define unicode_KHUDAWADI_LETTER_UU                                   0x112B5
#define unicode_KHUDAWADI_LETTER_E                                    0x112B6
#define unicode_KHUDAWADI_LETTER_AI                                   0x112B7
#define unicode_KHUDAWADI_LETTER_O                                    0x112B8
#define unicode_KHUDAWADI_LETTER_AU                                   0x112B9
#define unicode_KHUDAWADI_LETTER_KA                                   0x112BA
#define unicode_KHUDAWADI_LETTER_KHA                                  0x112BB
#define unicode_KHUDAWADI_LETTER_GA                                   0x112BC
#define unicode_KHUDAWADI_LETTER_GGA                                  0x112BD
#define unicode_KHUDAWADI_LETTER_GHA                                  0x112BE
#define unicode_KHUDAWADI_LETTER_NGA                                  0x112BF
#define unicode_KHUDAWADI_LETTER_CA                                   0x112C0
#define unicode_KHUDAWADI_LETTER_CHA                                  0x112C1
#define unicode_KHUDAWADI_LETTER_JA                                   0x112C2
#define unicode_KHUDAWADI_LETTER_JJA                                  0x112C3
#define unicode_KHUDAWADI_LETTER_JHA                                  0x112C4
#define unicode_KHUDAWADI_LETTER_NYA                                  0x112C5
#define unicode_KHUDAWADI_LETTER_TTA                                  0x112C6
#define unicode_KHUDAWADI_LETTER_TTHA                                 0x112C7
#define unicode_KHUDAWADI_LETTER_DDA                                  0x112C8
#define unicode_KHUDAWADI_LETTER_DDDA                                 0x112C9
#define unicode_KHUDAWADI_LETTER_RRA                                  0x112CA
#define unicode_KHUDAWADI_LETTER_DDHA                                 0x112CB
#define unicode_KHUDAWADI_LETTER_NNA                                  0x112CC
#define unicode_KHUDAWADI_LETTER_TA                                   0x112CD
#define unicode_KHUDAWADI_LETTER_THA                                  0x112CE
#define unicode_KHUDAWADI_LETTER_DA                                   0x112CF
#define unicode_KHUDAWADI_LETTER_DHA                                  0x112D0
#define unicode_KHUDAWADI_LETTER_NA                                   0x112D1
#define unicode_KHUDAWADI_LETTER_PA                                   0x112D2
#define unicode_KHUDAWADI_LETTER_PHA                                  0x112D3
#define unicode_KHUDAWADI_LETTER_BA                                   0x112D4
#define unicode_KHUDAWADI_LETTER_BBA                                  0x112D5
#define unicode_KHUDAWADI_LETTER_BHA                                  0x112D6
#define unicode_KHUDAWADI_LETTER_MA                                   0x112D7
#define unicode_KHUDAWADI_LETTER_YA                                   0x112D8
#define unicode_KHUDAWADI_LETTER_RA                                   0x112D9
#define unicode_KHUDAWADI_LETTER_LA                                   0x112DA
#define unicode_KHUDAWADI_LETTER_VA                                   0x112DB
#define unicode_KHUDAWADI_LETTER_SHA                                  0x112DC
#define unicode_KHUDAWADI_LETTER_SA                                   0x112DD
#define unicode_KHUDAWADI_LETTER_HA                                   0x112DE
#define unicode_KHUDAWADI_SIGN_ANUSVARA                               0x112DF
#define unicode_KHUDAWADI_VOWEL_SIGN_AA                               0x112E0
#define unicode_KHUDAWADI_VOWEL_SIGN_I                                0x112E1
#define unicode_KHUDAWADI_VOWEL_SIGN_II                               0x112E2
#define unicode_KHUDAWADI_VOWEL_SIGN_U                                0x112E3
#define unicode_KHUDAWADI_VOWEL_SIGN_UU                               0x112E4
#define unicode_KHUDAWADI_VOWEL_SIGN_E                                0x112E5
#define unicode_KHUDAWADI_VOWEL_SIGN_AI                               0x112E6
#define unicode_KHUDAWADI_VOWEL_SIGN_O                                0x112E7
#define unicode_KHUDAWADI_VOWEL_SIGN_AU                               0x112E8
#define unicode_KHUDAWADI_SIGN_NUKTA                                  0x112E9
#define unicode_KHUDAWADI_SIGN_VIRAMA                                 0x112EA
#define unicode_KHUDAWADI_DIGIT_ZERO                                  0x112F0
#define unicode_KHUDAWADI_DIGIT_ONE                                   0x112F1
#define unicode_KHUDAWADI_DIGIT_TWO                                   0x112F2
#define unicode_KHUDAWADI_DIGIT_THREE                                 0x112F3
#define unicode_KHUDAWADI_DIGIT_FOUR                                  0x112F4
#define unicode_KHUDAWADI_DIGIT_FIVE                                  0x112F5
#define unicode_KHUDAWADI_DIGIT_SIX                                   0x112F6
#define unicode_KHUDAWADI_DIGIT_SEVEN                                 0x112F7
#define unicode_KHUDAWADI_DIGIT_EIGHT                                 0x112F8
#define unicode_KHUDAWADI_DIGIT_NINE                                  0x112F9
#define unicode_GRANTHA_SIGN_CANDRABINDU                              0x11301
#define unicode_GRANTHA_SIGN_ANUSVARA                                 0x11302
#define unicode_GRANTHA_SIGN_VISARGA                                  0x11303
#define unicode_GRANTHA_LETTER_A                                      0x11305
#define unicode_GRANTHA_LETTER_AA                                     0x11306
#define unicode_GRANTHA_LETTER_I                                      0x11307
#define unicode_GRANTHA_LETTER_II                                     0x11308
#define unicode_GRANTHA_LETTER_U                                      0x11309
#define unicode_GRANTHA_LETTER_UU                                     0x1130A
#define unicode_GRANTHA_LETTER_VOCALIC_R                              0x1130B
#define unicode_GRANTHA_LETTER_VOCALIC_L                              0x1130C
#define unicode_GRANTHA_LETTER_EE                                     0x1130F
#define unicode_GRANTHA_LETTER_AI                                     0x11310
#define unicode_GRANTHA_LETTER_OO                                     0x11313
#define unicode_GRANTHA_LETTER_AU                                     0x11314
#define unicode_GRANTHA_LETTER_KA                                     0x11315
#define unicode_GRANTHA_LETTER_KHA                                    0x11316
#define unicode_GRANTHA_LETTER_GA                                     0x11317
#define unicode_GRANTHA_LETTER_GHA                                    0x11318
#define unicode_GRANTHA_LETTER_NGA                                    0x11319
#define unicode_GRANTHA_LETTER_CA                                     0x1131A
#define unicode_GRANTHA_LETTER_CHA                                    0x1131B
#define unicode_GRANTHA_LETTER_JA                                     0x1131C
#define unicode_GRANTHA_LETTER_JHA                                    0x1131D
#define unicode_GRANTHA_LETTER_NYA                                    0x1131E
#define unicode_GRANTHA_LETTER_TTA                                    0x1131F
#define unicode_GRANTHA_LETTER_TTHA                                   0x11320
#define unicode_GRANTHA_LETTER_DDA                                    0x11321
#define unicode_GRANTHA_LETTER_DDHA                                   0x11322
#define unicode_GRANTHA_LETTER_NNA                                    0x11323
#define unicode_GRANTHA_LETTER_TA                                     0x11324
#define unicode_GRANTHA_LETTER_THA                                    0x11325
#define unicode_GRANTHA_LETTER_DA                                     0x11326
#define unicode_GRANTHA_LETTER_DHA                                    0x11327
#define unicode_GRANTHA_LETTER_NA                                     0x11328
#define unicode_GRANTHA_LETTER_PA                                     0x1132A
#define unicode_GRANTHA_LETTER_PHA                                    0x1132B
#define unicode_GRANTHA_LETTER_BA                                     0x1132C
#define unicode_GRANTHA_LETTER_BHA                                    0x1132D
#define unicode_GRANTHA_LETTER_MA                                     0x1132E
#define unicode_GRANTHA_LETTER_YA                                     0x1132F
#define unicode_GRANTHA_LETTER_RA                                     0x11330
#define unicode_GRANTHA_LETTER_LA                                     0x11332
#define unicode_GRANTHA_LETTER_LLA                                    0x11333
#define unicode_GRANTHA_LETTER_VA                                     0x11335
#define unicode_GRANTHA_LETTER_SHA                                    0x11336
#define unicode_GRANTHA_LETTER_SSA                                    0x11337
#define unicode_GRANTHA_LETTER_SA                                     0x11338
#define unicode_GRANTHA_LETTER_HA                                     0x11339
#define unicode_GRANTHA_SIGN_NUKTA                                    0x1133C
#define unicode_GRANTHA_SIGN_AVAGRAHA                                 0x1133D
#define unicode_GRANTHA_VOWEL_SIGN_AA                                 0x1133E
#define unicode_GRANTHA_VOWEL_SIGN_I                                  0x1133F
#define unicode_GRANTHA_VOWEL_SIGN_II                                 0x11340
#define unicode_GRANTHA_VOWEL_SIGN_U                                  0x11341
#define unicode_GRANTHA_VOWEL_SIGN_UU                                 0x11342
#define unicode_GRANTHA_VOWEL_SIGN_VOCALIC_R                          0x11343
#define unicode_GRANTHA_VOWEL_SIGN_VOCALIC_RR                         0x11344
#define unicode_GRANTHA_VOWEL_SIGN_EE                                 0x11347
#define unicode_GRANTHA_VOWEL_SIGN_AI                                 0x11348
#define unicode_GRANTHA_VOWEL_SIGN_OO                                 0x1134B
#define unicode_GRANTHA_VOWEL_SIGN_AU                                 0x1134C
#define unicode_GRANTHA_SIGN_VIRAMA                                   0x1134D
#define unicode_GRANTHA_AU_LENGTH_MARK                                0x11357
#define unicode_GRANTHA_SIGN_PLUTA                                    0x1135D
#define unicode_GRANTHA_LETTER_VEDIC_ANUSVARA                         0x1135E
#define unicode_GRANTHA_LETTER_VEDIC_DOUBLE_ANUSVARA                  0x1135F
#define unicode_GRANTHA_LETTER_VOCALIC_RR                             0x11360
#define unicode_GRANTHA_LETTER_VOCALIC_LL                             0x11361
#define unicode_GRANTHA_VOWEL_SIGN_VOCALIC_L                          0x11362
#define unicode_GRANTHA_VOWEL_SIGN_VOCALIC_LL                         0x11363
#define unicode_COMBINING_GRANTHA_DIGIT_ZERO                          0x11366
#define unicode_COMBINING_GRANTHA_DIGIT_ONE                           0x11367
#define unicode_COMBINING_GRANTHA_DIGIT_TWO                           0x11368
#define unicode_COMBINING_GRANTHA_DIGIT_THREE                         0x11369
#define unicode_COMBINING_GRANTHA_DIGIT_FOUR                          0x1136A
#define unicode_COMBINING_GRANTHA_DIGIT_FIVE                          0x1136B
#define unicode_COMBINING_GRANTHA_DIGIT_SIX                           0x1136C
#define unicode_COMBINING_GRANTHA_LETTER_A                            0x11370
#define unicode_COMBINING_GRANTHA_LETTER_KA                           0x11371
#define unicode_COMBINING_GRANTHA_LETTER_NA                           0x11372
#define unicode_COMBINING_GRANTHA_LETTER_VI                           0x11373
#define unicode_COMBINING_GRANTHA_LETTER_PA                           0x11374
#define unicode_TIRHUTA_ANJI                                          0x11480
#define unicode_TIRHUTA_LETTER_A                                      0x11481
#define unicode_TIRHUTA_LETTER_AA                                     0x11482
#define unicode_TIRHUTA_LETTER_I                                      0x11483
#define unicode_TIRHUTA_LETTER_II                                     0x11484
#define unicode_TIRHUTA_LETTER_U                                      0x11485
#define unicode_TIRHUTA_LETTER_UU                                     0x11486
#define unicode_TIRHUTA_LETTER_VOCALIC_R                              0x11487
#define unicode_TIRHUTA_LETTER_VOCALIC_RR                             0x11488
#define unicode_TIRHUTA_LETTER_VOCALIC_L                              0x11489
#define unicode_TIRHUTA_LETTER_VOCALIC_LL                             0x1148A
#define unicode_TIRHUTA_LETTER_E                                      0x1148B
#define unicode_TIRHUTA_LETTER_AI                                     0x1148C
#define unicode_TIRHUTA_LETTER_O                                      0x1148D
#define unicode_TIRHUTA_LETTER_AU                                     0x1148E
#define unicode_TIRHUTA_LETTER_KA                                     0x1148F
#define unicode_TIRHUTA_LETTER_KHA                                    0x11490
#define unicode_TIRHUTA_LETTER_GA                                     0x11491
#define unicode_TIRHUTA_LETTER_GHA                                    0x11492
#define unicode_TIRHUTA_LETTER_NGA                                    0x11493
#define unicode_TIRHUTA_LETTER_CA                                     0x11494
#define unicode_TIRHUTA_LETTER_CHA                                    0x11495
#define unicode_TIRHUTA_LETTER_JA                                     0x11496
#define unicode_TIRHUTA_LETTER_JHA                                    0x11497
#define unicode_TIRHUTA_LETTER_NYA                                    0x11498
#define unicode_TIRHUTA_LETTER_TTA                                    0x11499
#define unicode_TIRHUTA_LETTER_TTHA                                   0x1149A
#define unicode_TIRHUTA_LETTER_DDA                                    0x1149B
#define unicode_TIRHUTA_LETTER_DDHA                                   0x1149C
#define unicode_TIRHUTA_LETTER_NNA                                    0x1149D
#define unicode_TIRHUTA_LETTER_TA                                     0x1149E
#define unicode_TIRHUTA_LETTER_THA                                    0x1149F
#define unicode_TIRHUTA_LETTER_DA                                     0x114A0
#define unicode_TIRHUTA_LETTER_DHA                                    0x114A1
#define unicode_TIRHUTA_LETTER_NA                                     0x114A2
#define unicode_TIRHUTA_LETTER_PA                                     0x114A3
#define unicode_TIRHUTA_LETTER_PHA                                    0x114A4
#define unicode_TIRHUTA_LETTER_BA                                     0x114A5
#define unicode_TIRHUTA_LETTER_BHA                                    0x114A6
#define unicode_TIRHUTA_LETTER_MA                                     0x114A7
#define unicode_TIRHUTA_LETTER_YA                                     0x114A8
#define unicode_TIRHUTA_LETTER_RA                                     0x114A9
#define unicode_TIRHUTA_LETTER_LA                                     0x114AA
#define unicode_TIRHUTA_LETTER_VA                                     0x114AB
#define unicode_TIRHUTA_LETTER_SHA                                    0x114AC
#define unicode_TIRHUTA_LETTER_SSA                                    0x114AD
#define unicode_TIRHUTA_LETTER_SA                                     0x114AE
#define unicode_TIRHUTA_LETTER_HA                                     0x114AF
#define unicode_TIRHUTA_VOWEL_SIGN_AA                                 0x114B0
#define unicode_TIRHUTA_VOWEL_SIGN_I                                  0x114B1
#define unicode_TIRHUTA_VOWEL_SIGN_II                                 0x114B2
#define unicode_TIRHUTA_VOWEL_SIGN_U                                  0x114B3
#define unicode_TIRHUTA_VOWEL_SIGN_UU                                 0x114B4
#define unicode_TIRHUTA_VOWEL_SIGN_VOCALIC_R                          0x114B5
#define unicode_TIRHUTA_VOWEL_SIGN_VOCALIC_RR                         0x114B6
#define unicode_TIRHUTA_VOWEL_SIGN_VOCALIC_L                          0x114B7
#define unicode_TIRHUTA_VOWEL_SIGN_VOCALIC_LL                         0x114B8
#define unicode_TIRHUTA_VOWEL_SIGN_E                                  0x114B9
#define unicode_TIRHUTA_VOWEL_SIGN_SHORT_E                            0x114BA
#define unicode_TIRHUTA_VOWEL_SIGN_AI                                 0x114BB
#define unicode_TIRHUTA_VOWEL_SIGN_O                                  0x114BC
#define unicode_TIRHUTA_VOWEL_SIGN_SHORT_O                            0x114BD
#define unicode_TIRHUTA_VOWEL_SIGN_AU                                 0x114BE
#define unicode_TIRHUTA_SIGN_CANDRABINDU                              0x114BF
#define unicode_TIRHUTA_SIGN_ANUSVARA                                 0x114C0
#define unicode_TIRHUTA_SIGN_VISARGA                                  0x114C1
#define unicode_TIRHUTA_SIGN_VIRAMA                                   0x114C2
#define unicode_TIRHUTA_SIGN_NUKTA                                    0x114C3
#define unicode_TIRHUTA_SIGN_AVAGRAHA                                 0x114C4
#define unicode_TIRHUTA_GVANG                                         0x114C5
#define unicode_TIRHUTA_ABBREVIATION_SIGN                             0x114C6
#define unicode_TIRHUTA_OM                                            0x114C7
#define unicode_TIRHUTA_DIGIT_ZERO                                    0x114D0
#define unicode_TIRHUTA_DIGIT_ONE                                     0x114D1
#define unicode_TIRHUTA_DIGIT_TWO                                     0x114D2
#define unicode_TIRHUTA_DIGIT_THREE                                   0x114D3
#define unicode_TIRHUTA_DIGIT_FOUR                                    0x114D4
#define unicode_TIRHUTA_DIGIT_FIVE                                    0x114D5
#define unicode_TIRHUTA_DIGIT_SIX                                     0x114D6
#define unicode_TIRHUTA_DIGIT_SEVEN                                   0x114D7
#define unicode_TIRHUTA_DIGIT_EIGHT                                   0x114D8
#define unicode_TIRHUTA_DIGIT_NINE                                    0x114D9
#define unicode_SIDDHAM_LETTER_A                                      0x11580
#define unicode_SIDDHAM_LETTER_AA                                     0x11581
#define unicode_SIDDHAM_LETTER_I                                      0x11582
#define unicode_SIDDHAM_LETTER_II                                     0x11583
#define unicode_SIDDHAM_LETTER_U                                      0x11584
#define unicode_SIDDHAM_LETTER_UU                                     0x11585
#define unicode_SIDDHAM_LETTER_VOCALIC_R                              0x11586
#define unicode_SIDDHAM_LETTER_VOCALIC_RR                             0x11587
#define unicode_SIDDHAM_LETTER_VOCALIC_L                              0x11588
#define unicode_SIDDHAM_LETTER_VOCALIC_LL                             0x11589
#define unicode_SIDDHAM_LETTER_E                                      0x1158A
#define unicode_SIDDHAM_LETTER_AI                                     0x1158B
#define unicode_SIDDHAM_LETTER_O                                      0x1158C
#define unicode_SIDDHAM_LETTER_AU                                     0x1158D
#define unicode_SIDDHAM_LETTER_KA                                     0x1158E
#define unicode_SIDDHAM_LETTER_KHA                                    0x1158F
#define unicode_SIDDHAM_LETTER_GA                                     0x11590
#define unicode_SIDDHAM_LETTER_GHA                                    0x11591
#define unicode_SIDDHAM_LETTER_NGA                                    0x11592
#define unicode_SIDDHAM_LETTER_CA                                     0x11593
#define unicode_SIDDHAM_LETTER_CHA                                    0x11594
#define unicode_SIDDHAM_LETTER_JA                                     0x11595
#define unicode_SIDDHAM_LETTER_JHA                                    0x11596
#define unicode_SIDDHAM_LETTER_NYA                                    0x11597
#define unicode_SIDDHAM_LETTER_TTA                                    0x11598
#define unicode_SIDDHAM_LETTER_TTHA                                   0x11599
#define unicode_SIDDHAM_LETTER_DDA                                    0x1159A
#define unicode_SIDDHAM_LETTER_DDHA                                   0x1159B
#define unicode_SIDDHAM_LETTER_NNA                                    0x1159C
#define unicode_SIDDHAM_LETTER_TA                                     0x1159D
#define unicode_SIDDHAM_LETTER_THA                                    0x1159E
#define unicode_SIDDHAM_LETTER_DA                                     0x1159F
#define unicode_SIDDHAM_LETTER_DHA                                    0x115A0
#define unicode_SIDDHAM_LETTER_NA                                     0x115A1
#define unicode_SIDDHAM_LETTER_PA                                     0x115A2
#define unicode_SIDDHAM_LETTER_PHA                                    0x115A3
#define unicode_SIDDHAM_LETTER_BA                                     0x115A4
#define unicode_SIDDHAM_LETTER_BHA                                    0x115A5
#define unicode_SIDDHAM_LETTER_MA                                     0x115A6
#define unicode_SIDDHAM_LETTER_YA                                     0x115A7
#define unicode_SIDDHAM_LETTER_RA                                     0x115A8
#define unicode_SIDDHAM_LETTER_LA                                     0x115A9
#define unicode_SIDDHAM_LETTER_VA                                     0x115AA
#define unicode_SIDDHAM_LETTER_SHA                                    0x115AB
#define unicode_SIDDHAM_LETTER_SSA                                    0x115AC
#define unicode_SIDDHAM_LETTER_SA                                     0x115AD
#define unicode_SIDDHAM_LETTER_HA                                     0x115AE
#define unicode_SIDDHAM_VOWEL_SIGN_AA                                 0x115AF
#define unicode_SIDDHAM_VOWEL_SIGN_I                                  0x115B0
#define unicode_SIDDHAM_VOWEL_SIGN_II                                 0x115B1
#define unicode_SIDDHAM_VOWEL_SIGN_U                                  0x115B2
#define unicode_SIDDHAM_VOWEL_SIGN_UU                                 0x115B3
#define unicode_SIDDHAM_VOWEL_SIGN_VOCALIC_R                          0x115B4
#define unicode_SIDDHAM_VOWEL_SIGN_VOCALIC_RR                         0x115B5
#define unicode_SIDDHAM_VOWEL_SIGN_E                                  0x115B8
#define unicode_SIDDHAM_VOWEL_SIGN_AI                                 0x115B9
#define unicode_SIDDHAM_VOWEL_SIGN_O                                  0x115BA
#define unicode_SIDDHAM_VOWEL_SIGN_AU                                 0x115BB
#define unicode_SIDDHAM_SIGN_CANDRABINDU                              0x115BC
#define unicode_SIDDHAM_SIGN_ANUSVARA                                 0x115BD
#define unicode_SIDDHAM_SIGN_VISARGA                                  0x115BE
#define unicode_SIDDHAM_SIGN_VIRAMA                                   0x115BF
#define unicode_SIDDHAM_SIGN_NUKTA                                    0x115C0
#define unicode_SIDDHAM_SIGN_SIDDHAM                                  0x115C1
#define unicode_SIDDHAM_DANDA                                         0x115C2
#define unicode_SIDDHAM_DOUBLE_DANDA                                  0x115C3
#define unicode_SIDDHAM_SEPARATOR_DOT                                 0x115C4
#define unicode_SIDDHAM_SEPARATOR_BAR                                 0x115C5
#define unicode_SIDDHAM_REPETITION_MARK_1                             0x115C6
#define unicode_SIDDHAM_REPETITION_MARK_2                             0x115C7
#define unicode_SIDDHAM_REPETITION_MARK_3                             0x115C8
#define unicode_SIDDHAM_END_OF_TEXT_MARK                              0x115C9
#define unicode_MODI_LETTER_A                                         0x11600
#define unicode_MODI_LETTER_AA                                        0x11601
#define unicode_MODI_LETTER_I                                         0x11602
#define unicode_MODI_LETTER_II                                        0x11603
#define unicode_MODI_LETTER_U                                         0x11604
#define unicode_MODI_LETTER_UU                                        0x11605
#define unicode_MODI_LETTER_VOCALIC_R                                 0x11606
#define unicode_MODI_LETTER_VOCALIC_RR                                0x11607
#define unicode_MODI_LETTER_VOCALIC_L                                 0x11608
#define unicode_MODI_LETTER_VOCALIC_LL                                0x11609
#define unicode_MODI_LETTER_E                                         0x1160A
#define unicode_MODI_LETTER_AI                                        0x1160B
#define unicode_MODI_LETTER_O                                         0x1160C
#define unicode_MODI_LETTER_AU                                        0x1160D
#define unicode_MODI_LETTER_KA                                        0x1160E
#define unicode_MODI_LETTER_KHA                                       0x1160F
#define unicode_MODI_LETTER_GA                                        0x11610
#define unicode_MODI_LETTER_GHA                                       0x11611
#define unicode_MODI_LETTER_NGA                                       0x11612
#define unicode_MODI_LETTER_CA                                        0x11613
#define unicode_MODI_LETTER_CHA                                       0x11614
#define unicode_MODI_LETTER_JA                                        0x11615
#define unicode_MODI_LETTER_JHA                                       0x11616
#define unicode_MODI_LETTER_NYA                                       0x11617
#define unicode_MODI_LETTER_TTA                                       0x11618
#define unicode_MODI_LETTER_TTHA                                      0x11619
#define unicode_MODI_LETTER_DDA                                       0x1161A
#define unicode_MODI_LETTER_DDHA                                      0x1161B
#define unicode_MODI_LETTER_NNA                                       0x1161C
#define unicode_MODI_LETTER_TA                                        0x1161D
#define unicode_MODI_LETTER_THA                                       0x1161E
#define unicode_MODI_LETTER_DA                                        0x1161F
#define unicode_MODI_LETTER_DHA                                       0x11620
#define unicode_MODI_LETTER_NA                                        0x11621
#define unicode_MODI_LETTER_PA                                        0x11622
#define unicode_MODI_LETTER_PHA                                       0x11623
#define unicode_MODI_LETTER_BA                                        0x11624
#define unicode_MODI_LETTER_BHA                                       0x11625
#define unicode_MODI_LETTER_MA                                        0x11626
#define unicode_MODI_LETTER_YA                                        0x11627
#define unicode_MODI_LETTER_RA                                        0x11628
#define unicode_MODI_LETTER_LA                                        0x11629
#define unicode_MODI_LETTER_VA                                        0x1162A
#define unicode_MODI_LETTER_SHA                                       0x1162B
#define unicode_MODI_LETTER_SSA                                       0x1162C
#define unicode_MODI_LETTER_SA                                        0x1162D
#define unicode_MODI_LETTER_HA                                        0x1162E
#define unicode_MODI_LETTER_LLA                                       0x1162F
#define unicode_MODI_VOWEL_SIGN_AA                                    0x11630
#define unicode_MODI_VOWEL_SIGN_I                                     0x11631
#define unicode_MODI_VOWEL_SIGN_II                                    0x11632
#define unicode_MODI_VOWEL_SIGN_U                                     0x11633
#define unicode_MODI_VOWEL_SIGN_UU                                    0x11634
#define unicode_MODI_VOWEL_SIGN_VOCALIC_R                             0x11635
#define unicode_MODI_VOWEL_SIGN_VOCALIC_RR                            0x11636
#define unicode_MODI_VOWEL_SIGN_VOCALIC_L                             0x11637
#define unicode_MODI_VOWEL_SIGN_VOCALIC_LL                            0x11638
#define unicode_MODI_VOWEL_SIGN_E                                     0x11639
#define unicode_MODI_VOWEL_SIGN_AI                                    0x1163A
#define unicode_MODI_VOWEL_SIGN_O                                     0x1163B
#define unicode_MODI_VOWEL_SIGN_AU                                    0x1163C
#define unicode_MODI_SIGN_ANUSVARA                                    0x1163D
#define unicode_MODI_SIGN_VISARGA                                     0x1163E
#define unicode_MODI_SIGN_VIRAMA                                      0x1163F
#define unicode_MODI_SIGN_ARDHACANDRA                                 0x11640
#define unicode_MODI_DANDA                                            0x11641
#define unicode_MODI_DOUBLE_DANDA                                     0x11642
#define unicode_MODI_ABBREVIATION_SIGN                                0x11643
#define unicode_MODI_SIGN_HUVA                                        0x11644
#define unicode_MODI_DIGIT_ZERO                                       0x11650
#define unicode_MODI_DIGIT_ONE                                        0x11651
#define unicode_MODI_DIGIT_TWO                                        0x11652
#define unicode_MODI_DIGIT_THREE                                      0x11653
#define unicode_MODI_DIGIT_FOUR                                       0x11654
#define unicode_MODI_DIGIT_FIVE                                       0x11655
#define unicode_MODI_DIGIT_SIX                                        0x11656
#define unicode_MODI_DIGIT_SEVEN                                      0x11657
#define unicode_MODI_DIGIT_EIGHT                                      0x11658
#define unicode_MODI_DIGIT_NINE                                       0x11659
#define unicode_TAKRI_LETTER_A                                        0x11680
#define unicode_TAKRI_LETTER_AA                                       0x11681
#define unicode_TAKRI_LETTER_I                                        0x11682
#define unicode_TAKRI_LETTER_II                                       0x11683
#define unicode_TAKRI_LETTER_U                                        0x11684
#define unicode_TAKRI_LETTER_UU                                       0x11685
#define unicode_TAKRI_LETTER_E                                        0x11686
#define unicode_TAKRI_LETTER_AI                                       0x11687
#define unicode_TAKRI_LETTER_O                                        0x11688
#define unicode_TAKRI_LETTER_AU                                       0x11689
#define unicode_TAKRI_LETTER_KA                                       0x1168A
#define unicode_TAKRI_LETTER_KHA                                      0x1168B
#define unicode_TAKRI_LETTER_GA                                       0x1168C
#define unicode_TAKRI_LETTER_GHA                                      0x1168D
#define unicode_TAKRI_LETTER_NGA                                      0x1168E
#define unicode_TAKRI_LETTER_CA                                       0x1168F
#define unicode_TAKRI_LETTER_CHA                                      0x11690
#define unicode_TAKRI_LETTER_JA                                       0x11691
#define unicode_TAKRI_LETTER_JHA                                      0x11692
#define unicode_TAKRI_LETTER_NYA                                      0x11693
#define unicode_TAKRI_LETTER_TTA                                      0x11694
#define unicode_TAKRI_LETTER_TTHA                                     0x11695
#define unicode_TAKRI_LETTER_DDA                                      0x11696
#define unicode_TAKRI_LETTER_DDHA                                     0x11697
#define unicode_TAKRI_LETTER_NNA                                      0x11698
#define unicode_TAKRI_LETTER_TA                                       0x11699
#define unicode_TAKRI_LETTER_THA                                      0x1169A
#define unicode_TAKRI_LETTER_DA                                       0x1169B
#define unicode_TAKRI_LETTER_DHA                                      0x1169C
#define unicode_TAKRI_LETTER_NA                                       0x1169D
#define unicode_TAKRI_LETTER_PA                                       0x1169E
#define unicode_TAKRI_LETTER_PHA                                      0x1169F
#define unicode_TAKRI_LETTER_BA                                       0x116A0
#define unicode_TAKRI_LETTER_BHA                                      0x116A1
#define unicode_TAKRI_LETTER_MA                                       0x116A2
#define unicode_TAKRI_LETTER_YA                                       0x116A3
#define unicode_TAKRI_LETTER_RA                                       0x116A4
#define unicode_TAKRI_LETTER_LA                                       0x116A5
#define unicode_TAKRI_LETTER_VA                                       0x116A6
#define unicode_TAKRI_LETTER_SHA                                      0x116A7
#define unicode_TAKRI_LETTER_SA                                       0x116A8
#define unicode_TAKRI_LETTER_HA                                       0x116A9
#define unicode_TAKRI_LETTER_RRA                                      0x116AA
#define unicode_TAKRI_SIGN_ANUSVARA                                   0x116AB
#define unicode_TAKRI_SIGN_VISARGA                                    0x116AC
#define unicode_TAKRI_VOWEL_SIGN_AA                                   0x116AD
#define unicode_TAKRI_VOWEL_SIGN_I                                    0x116AE
#define unicode_TAKRI_VOWEL_SIGN_II                                   0x116AF
#define unicode_TAKRI_VOWEL_SIGN_U                                    0x116B0
#define unicode_TAKRI_VOWEL_SIGN_UU                                   0x116B1
#define unicode_TAKRI_VOWEL_SIGN_E                                    0x116B2
#define unicode_TAKRI_VOWEL_SIGN_AI                                   0x116B3
#define unicode_TAKRI_VOWEL_SIGN_O                                    0x116B4
#define unicode_TAKRI_VOWEL_SIGN_AU                                   0x116B5
#define unicode_TAKRI_SIGN_VIRAMA                                     0x116B6
#define unicode_TAKRI_SIGN_NUKTA                                      0x116B7
#define unicode_TAKRI_DIGIT_ZERO                                      0x116C0
#define unicode_TAKRI_DIGIT_ONE                                       0x116C1
#define unicode_TAKRI_DIGIT_TWO                                       0x116C2
#define unicode_TAKRI_DIGIT_THREE                                     0x116C3
#define unicode_TAKRI_DIGIT_FOUR                                      0x116C4
#define unicode_TAKRI_DIGIT_FIVE                                      0x116C5
#define unicode_TAKRI_DIGIT_SIX                                       0x116C6
#define unicode_TAKRI_DIGIT_SEVEN                                     0x116C7
#define unicode_TAKRI_DIGIT_EIGHT                                     0x116C8
#define unicode_TAKRI_DIGIT_NINE                                      0x116C9
#define unicode_WARANG_CITI_CAPITAL_LETTER_NGAA                       0x118A0
#define unicode_WARANG_CITI_CAPITAL_LETTER_A                          0x118A1
#define unicode_WARANG_CITI_CAPITAL_LETTER_WI                         0x118A2
#define unicode_WARANG_CITI_CAPITAL_LETTER_YU                         0x118A3
#define unicode_WARANG_CITI_CAPITAL_LETTER_YA                         0x118A4
#define unicode_WARANG_CITI_CAPITAL_LETTER_YO                         0x118A5
#define unicode_WARANG_CITI_CAPITAL_LETTER_II                         0x118A6
#define unicode_WARANG_CITI_CAPITAL_LETTER_UU                         0x118A7
#define unicode_WARANG_CITI_CAPITAL_LETTER_E                          0x118A8
#define unicode_WARANG_CITI_CAPITAL_LETTER_O                          0x118A9
#define unicode_WARANG_CITI_CAPITAL_LETTER_ANG                        0x118AA
#define unicode_WARANG_CITI_CAPITAL_LETTER_GA                         0x118AB
#define unicode_WARANG_CITI_CAPITAL_LETTER_KO                         0x118AC
#define unicode_WARANG_CITI_CAPITAL_LETTER_ENY                        0x118AD
#define unicode_WARANG_CITI_CAPITAL_LETTER_YUJ                        0x118AE
#define unicode_WARANG_CITI_CAPITAL_LETTER_UC                         0x118AF
#define unicode_WARANG_CITI_CAPITAL_LETTER_ENN                        0x118B0
#define unicode_WARANG_CITI_CAPITAL_LETTER_ODD                        0x118B1
#define unicode_WARANG_CITI_CAPITAL_LETTER_TTE                        0x118B2
#define unicode_WARANG_CITI_CAPITAL_LETTER_NUNG                       0x118B3
#define unicode_WARANG_CITI_CAPITAL_LETTER_DA                         0x118B4
#define unicode_WARANG_CITI_CAPITAL_LETTER_AT                         0x118B5
#define unicode_WARANG_CITI_CAPITAL_LETTER_AM                         0x118B6
#define unicode_WARANG_CITI_CAPITAL_LETTER_BU                         0x118B7
#define unicode_WARANG_CITI_CAPITAL_LETTER_PU                         0x118B8
#define unicode_WARANG_CITI_CAPITAL_LETTER_HIYO                       0x118B9
#define unicode_WARANG_CITI_CAPITAL_LETTER_HOLO                       0x118BA
#define unicode_WARANG_CITI_CAPITAL_LETTER_HORR                       0x118BB
#define unicode_WARANG_CITI_CAPITAL_LETTER_HAR                        0x118BC
#define unicode_WARANG_CITI_CAPITAL_LETTER_SSUU                       0x118BD
#define unicode_WARANG_CITI_CAPITAL_LETTER_SII                        0x118BE
#define unicode_WARANG_CITI_CAPITAL_LETTER_VIYO                       0x118BF
#define unicode_WARANG_CITI_SMALL_LETTER_NGAA                         0x118C0
#define unicode_WARANG_CITI_SMALL_LETTER_A                            0x118C1
#define unicode_WARANG_CITI_SMALL_LETTER_WI                           0x118C2
#define unicode_WARANG_CITI_SMALL_LETTER_YU                           0x118C3
#define unicode_WARANG_CITI_SMALL_LETTER_YA                           0x118C4
#define unicode_WARANG_CITI_SMALL_LETTER_YO                           0x118C5
#define unicode_WARANG_CITI_SMALL_LETTER_II                           0x118C6
#define unicode_WARANG_CITI_SMALL_LETTER_UU                           0x118C7
#define unicode_WARANG_CITI_SMALL_LETTER_E                            0x118C8
#define unicode_WARANG_CITI_SMALL_LETTER_O                            0x118C9
#define unicode_WARANG_CITI_SMALL_LETTER_ANG                          0x118CA
#define unicode_WARANG_CITI_SMALL_LETTER_GA                           0x118CB
#define unicode_WARANG_CITI_SMALL_LETTER_KO                           0x118CC
#define unicode_WARANG_CITI_SMALL_LETTER_ENY                          0x118CD
#define unicode_WARANG_CITI_SMALL_LETTER_YUJ                          0x118CE
#define unicode_WARANG_CITI_SMALL_LETTER_UC                           0x118CF
#define unicode_WARANG_CITI_SMALL_LETTER_ENN                          0x118D0
#define unicode_WARANG_CITI_SMALL_LETTER_ODD                          0x118D1
#define unicode_WARANG_CITI_SMALL_LETTER_TTE                          0x118D2
#define unicode_WARANG_CITI_SMALL_LETTER_NUNG                         0x118D3
#define unicode_WARANG_CITI_SMALL_LETTER_DA                           0x118D4
#define unicode_WARANG_CITI_SMALL_LETTER_AT                           0x118D5
#define unicode_WARANG_CITI_SMALL_LETTER_AM                           0x118D6
#define unicode_WARANG_CITI_SMALL_LETTER_BU                           0x118D7
#define unicode_WARANG_CITI_SMALL_LETTER_PU                           0x118D8
#define unicode_WARANG_CITI_SMALL_LETTER_HIYO                         0x118D9
#define unicode_WARANG_CITI_SMALL_LETTER_HOLO                         0x118DA
#define unicode_WARANG_CITI_SMALL_LETTER_HORR                         0x118DB
#define unicode_WARANG_CITI_SMALL_LETTER_HAR                          0x118DC
#define unicode_WARANG_CITI_SMALL_LETTER_SSUU                         0x118DD
#define unicode_WARANG_CITI_SMALL_LETTER_SII                          0x118DE
#define unicode_WARANG_CITI_SMALL_LETTER_VIYO                         0x118DF
#define unicode_WARANG_CITI_DIGIT_ZERO                                0x118E0
#define unicode_WARANG_CITI_DIGIT_ONE                                 0x118E1
#define unicode_WARANG_CITI_DIGIT_TWO                                 0x118E2
#define unicode_WARANG_CITI_DIGIT_THREE                               0x118E3
#define unicode_WARANG_CITI_DIGIT_FOUR                                0x118E4
#define unicode_WARANG_CITI_DIGIT_FIVE                                0x118E5
#define unicode_WARANG_CITI_DIGIT_SIX                                 0x118E6
#define unicode_WARANG_CITI_DIGIT_SEVEN                               0x118E7
#define unicode_WARANG_CITI_DIGIT_EIGHT                               0x118E8
#define unicode_WARANG_CITI_DIGIT_NINE                                0x118E9
#define unicode_WARANG_CITI_NUMBER_TEN                                0x118EA
#define unicode_WARANG_CITI_NUMBER_TWENTY                             0x118EB
#define unicode_WARANG_CITI_NUMBER_THIRTY                             0x118EC
#define unicode_WARANG_CITI_NUMBER_FORTY                              0x118ED
#define unicode_WARANG_CITI_NUMBER_FIFTY                              0x118EE
#define unicode_WARANG_CITI_NUMBER_SIXTY                              0x118EF
#define unicode_WARANG_CITI_NUMBER_SEVENTY                            0x118F0
#define unicode_WARANG_CITI_NUMBER_EIGHTY                             0x118F1
#define unicode_WARANG_CITI_NUMBER_NINETY                             0x118F2
#define unicode_WARANG_CITI_OM                                        0x118FF
#define unicode_PAU_CIN_HAU_LETTER_PA                                 0x11AC0
#define unicode_PAU_CIN_HAU_LETTER_KA                                 0x11AC1
#define unicode_PAU_CIN_HAU_LETTER_LA                                 0x11AC2
#define unicode_PAU_CIN_HAU_LETTER_MA                                 0x11AC3
#define unicode_PAU_CIN_HAU_LETTER_DA                                 0x11AC4
#define unicode_PAU_CIN_HAU_LETTER_ZA                                 0x11AC5
#define unicode_PAU_CIN_HAU_LETTER_VA                                 0x11AC6
#define unicode_PAU_CIN_HAU_LETTER_NGA                                0x11AC7
#define unicode_PAU_CIN_HAU_LETTER_HA                                 0x11AC8
#define unicode_PAU_CIN_HAU_LETTER_GA                                 0x11AC9
#define unicode_PAU_CIN_HAU_LETTER_KHA                                0x11ACA
#define unicode_PAU_CIN_HAU_LETTER_SA                                 0x11ACB
#define unicode_PAU_CIN_HAU_LETTER_BA                                 0x11ACC
#define unicode_PAU_CIN_HAU_LETTER_CA                                 0x11ACD
#define unicode_PAU_CIN_HAU_LETTER_TA                                 0x11ACE
#define unicode_PAU_CIN_HAU_LETTER_THA                                0x11ACF
#define unicode_PAU_CIN_HAU_LETTER_NA                                 0x11AD0
#define unicode_PAU_CIN_HAU_LETTER_PHA                                0x11AD1
#define unicode_PAU_CIN_HAU_LETTER_RA                                 0x11AD2
#define unicode_PAU_CIN_HAU_LETTER_FA                                 0x11AD3
#define unicode_PAU_CIN_HAU_LETTER_CHA                                0x11AD4
#define unicode_PAU_CIN_HAU_LETTER_A                                  0x11AD5
#define unicode_PAU_CIN_HAU_LETTER_E                                  0x11AD6
#define unicode_PAU_CIN_HAU_LETTER_I                                  0x11AD7
#define unicode_PAU_CIN_HAU_LETTER_O                                  0x11AD8
#define unicode_PAU_CIN_HAU_LETTER_U                                  0x11AD9
#define unicode_PAU_CIN_HAU_LETTER_UA                                 0x11ADA
#define unicode_PAU_CIN_HAU_LETTER_IA                                 0x11ADB
#define unicode_PAU_CIN_HAU_LETTER_FINAL_P                            0x11ADC
#define unicode_PAU_CIN_HAU_LETTER_FINAL_K                            0x11ADD
#define unicode_PAU_CIN_HAU_LETTER_FINAL_T                            0x11ADE
#define unicode_PAU_CIN_HAU_LETTER_FINAL_M                            0x11ADF
#define unicode_PAU_CIN_HAU_LETTER_FINAL_N                            0x11AE0
#define unicode_PAU_CIN_HAU_LETTER_FINAL_L                            0x11AE1
#define unicode_PAU_CIN_HAU_LETTER_FINAL_W                            0x11AE2
#define unicode_PAU_CIN_HAU_LETTER_FINAL_NG                           0x11AE3
#define unicode_PAU_CIN_HAU_LETTER_FINAL_Y                            0x11AE4
#define unicode_PAU_CIN_HAU_RISING_TONE_LONG                          0x11AE5
#define unicode_PAU_CIN_HAU_RISING_TONE                               0x11AE6
#define unicode_PAU_CIN_HAU_SANDHI_GLOTTAL_STOP                       0x11AE7
#define unicode_PAU_CIN_HAU_RISING_TONE_LONG_FINAL                    0x11AE8
#define unicode_PAU_CIN_HAU_RISING_TONE_FINAL                         0x11AE9
#define unicode_PAU_CIN_HAU_SANDHI_GLOTTAL_STOP_FINAL                 0x11AEA
#define unicode_PAU_CIN_HAU_SANDHI_TONE_LONG                          0x11AEB
#define unicode_PAU_CIN_HAU_SANDHI_TONE                               0x11AEC
#define unicode_PAU_CIN_HAU_SANDHI_TONE_LONG_FINAL                    0x11AED
#define unicode_PAU_CIN_HAU_SANDHI_TONE_FINAL                         0x11AEE
#define unicode_PAU_CIN_HAU_MID_LEVEL_TONE                            0x11AEF
#define unicode_PAU_CIN_HAU_GLOTTAL_STOP_VARIANT                      0x11AF0
#define unicode_PAU_CIN_HAU_MID_LEVEL_TONE_LONG_FINAL                 0x11AF1
#define unicode_PAU_CIN_HAU_MID_LEVEL_TONE_FINAL                      0x11AF2
#define unicode_PAU_CIN_HAU_LOW_FALLING_TONE_LONG                     0x11AF3
#define unicode_PAU_CIN_HAU_LOW_FALLING_TONE                          0x11AF4
#define unicode_PAU_CIN_HAU_GLOTTAL_STOP                              0x11AF5
#define unicode_PAU_CIN_HAU_LOW_FALLING_TONE_LONG_FINAL               0x11AF6
#define unicode_PAU_CIN_HAU_LOW_FALLING_TONE_FINAL                    0x11AF7
#define unicode_PAU_CIN_HAU_GLOTTAL_STOP_FINAL                        0x11AF8
#define unicode_CUNEIFORM_SIGN_A                                      0x12000
#define unicode_CUNEIFORM_SIGN_A_TIMES_A                              0x12001
#define unicode_CUNEIFORM_SIGN_A_TIMES_BAD                            0x12002
#define unicode_CUNEIFORM_SIGN_A_TIMES_GAN2_TENU                      0x12003
#define unicode_CUNEIFORM_SIGN_A_TIMES_HA                             0x12004
#define unicode_CUNEIFORM_SIGN_A_TIMES_IGI                            0x12005
#define unicode_CUNEIFORM_SIGN_A_TIMES_LAGAR_GUNU                     0x12006
#define unicode_CUNEIFORM_SIGN_A_TIMES_MUSH                           0x12007
#define unicode_CUNEIFORM_SIGN_A_TIMES_SAG                            0x12008
#define unicode_CUNEIFORM_SIGN_A2                                     0x12009
#define unicode_CUNEIFORM_SIGN_AB                                     0x1200A
#define unicode_CUNEIFORM_SIGN_AB_TIMES_ASH2                          0x1200B
#define unicode_CUNEIFORM_SIGN_AB_TIMES_DUN3_GUNU                     0x1200C
#define unicode_CUNEIFORM_SIGN_AB_TIMES_GAL                           0x1200D
#define unicode_CUNEIFORM_SIGN_AB_TIMES_GAN2_TENU                     0x1200E
#define unicode_CUNEIFORM_SIGN_AB_TIMES_HA                            0x1200F
#define unicode_CUNEIFORM_SIGN_AB_TIMES_IGI_GUNU                      0x12010
#define unicode_CUNEIFORM_SIGN_AB_TIMES_IMIN                          0x12011
#define unicode_CUNEIFORM_SIGN_AB_TIMES_LAGAB                         0x12012
#define unicode_CUNEIFORM_SIGN_AB_TIMES_SHESH                         0x12013
#define unicode_CUNEIFORM_SIGN_AB_TIMES_U_PLUS_U_PLUS_U               0x12014
#define unicode_CUNEIFORM_SIGN_AB_GUNU                                0x12015
#define unicode_CUNEIFORM_SIGN_AB2                                    0x12016
#define unicode_CUNEIFORM_SIGN_AB2_TIMES_BALAG                        0x12017
#define unicode_CUNEIFORM_SIGN_AB2_TIMES_GAN2_TENU                    0x12018
#define unicode_CUNEIFORM_SIGN_AB2_TIMES_ME_PLUS_EN                   0x12019
#define unicode_CUNEIFORM_SIGN_AB2_TIMES_SHA3                         0x1201A
#define unicode_CUNEIFORM_SIGN_AB2_TIMES_TAK4                         0x1201B
#define unicode_CUNEIFORM_SIGN_AD                                     0x1201C
#define unicode_CUNEIFORM_SIGN_AK                                     0x1201D
#define unicode_CUNEIFORM_SIGN_AK_TIMES_ERIN2                         0x1201E
#define unicode_CUNEIFORM_SIGN_AK_TIMES_SHITA_PLUS_GISH               0x1201F
#define unicode_CUNEIFORM_SIGN_AL                                     0x12020
#define unicode_CUNEIFORM_SIGN_AL_TIMES_AL                            0x12021
#define unicode_CUNEIFORM_SIGN_AL_TIMES_DIM2                          0x12022
#define unicode_CUNEIFORM_SIGN_AL_TIMES_GISH                          0x12023
#define unicode_CUNEIFORM_SIGN_AL_TIMES_HA                            0x12024
#define unicode_CUNEIFORM_SIGN_AL_TIMES_KAD3                          0x12025
#define unicode_CUNEIFORM_SIGN_AL_TIMES_KI                            0x12026
#define unicode_CUNEIFORM_SIGN_AL_TIMES_SHE                           0x12027
#define unicode_CUNEIFORM_SIGN_AL_TIMES_USH                           0x12028
#define unicode_CUNEIFORM_SIGN_ALAN                                   0x12029
#define unicode_CUNEIFORM_SIGN_ALEPH                                  0x1202A
#define unicode_CUNEIFORM_SIGN_AMAR                                   0x1202B
#define unicode_CUNEIFORM_SIGN_AMAR_TIMES_SHE                         0x1202C
#define unicode_CUNEIFORM_SIGN_AN                                     0x1202D
#define unicode_CUNEIFORM_SIGN_AN_OVER_AN                             0x1202E
#define unicode_CUNEIFORM_SIGN_AN_THREE_TIMES                         0x1202F
#define unicode_CUNEIFORM_SIGN_AN_PLUS_NAGA_OPPOSING_AN_PLUS_NAGA     0x12030
#define unicode_CUNEIFORM_SIGN_AN_PLUS_NAGA_SQUARED                   0x12031
#define unicode_CUNEIFORM_SIGN_ANSHE                                  0x12032
#define unicode_CUNEIFORM_SIGN_APIN                                   0x12033
#define unicode_CUNEIFORM_SIGN_ARAD                                   0x12034
#define unicode_CUNEIFORM_SIGN_ARAD_TIMES_KUR                         0x12035
#define unicode_CUNEIFORM_SIGN_ARKAB                                  0x12036
#define unicode_CUNEIFORM_SIGN_ASAL2                                  0x12037
#define unicode_CUNEIFORM_SIGN_ASH                                    0x12038
#define unicode_CUNEIFORM_SIGN_ASH_ZIDA_TENU                          0x12039
#define unicode_CUNEIFORM_SIGN_ASH_KABA_TENU                          0x1203A
#define unicode_CUNEIFORM_SIGN_ASH_OVER_ASH_TUG2_OVER_TUG2_TUG2_OVER_TUG2_PAP 0x1203B
#define unicode_CUNEIFORM_SIGN_ASH_OVER_ASH_OVER_ASH                  0x1203C
#define unicode_CUNEIFORM_SIGN_ASH_OVER_ASH_OVER_ASH_CROSSING_ASH_OVER_ASH_OVER_ASH 0x1203D
#define unicode_CUNEIFORM_SIGN_ASH2                                   0x1203E
#define unicode_CUNEIFORM_SIGN_ASHGAB                                 0x1203F
#define unicode_CUNEIFORM_SIGN_BA                                     0x12040
#define unicode_CUNEIFORM_SIGN_BAD                                    0x12041
#define unicode_CUNEIFORM_SIGN_BAG3                                   0x12042
#define unicode_CUNEIFORM_SIGN_BAHAR2                                 0x12043
#define unicode_CUNEIFORM_SIGN_BAL                                    0x12044
#define unicode_CUNEIFORM_SIGN_BAL_OVER_BAL                           0x12045
#define unicode_CUNEIFORM_SIGN_BALAG                                  0x12046
#define unicode_CUNEIFORM_SIGN_BAR                                    0x12047
#define unicode_CUNEIFORM_SIGN_BARA2                                  0x12048
#define unicode_CUNEIFORM_SIGN_BI                                     0x12049
#define unicode_CUNEIFORM_SIGN_BI_TIMES_A                             0x1204A
#define unicode_CUNEIFORM_SIGN_BI_TIMES_GAR                           0x1204B
#define unicode_CUNEIFORM_SIGN_BI_TIMES_IGI_GUNU                      0x1204C
#define unicode_CUNEIFORM_SIGN_BU                                     0x1204D
#define unicode_CUNEIFORM_SIGN_BU_OVER_BU_AB                          0x1204E
#define unicode_CUNEIFORM_SIGN_BU_OVER_BU_UN                          0x1204F
#define unicode_CUNEIFORM_SIGN_BU_CROSSING_BU                         0x12050
#define unicode_CUNEIFORM_SIGN_BULUG                                  0x12051
#define unicode_CUNEIFORM_SIGN_BULUG_OVER_BULUG                       0x12052
#define unicode_CUNEIFORM_SIGN_BUR                                    0x12053
#define unicode_CUNEIFORM_SIGN_BUR2                                   0x12054
#define unicode_CUNEIFORM_SIGN_DA                                     0x12055
#define unicode_CUNEIFORM_SIGN_DAG                                    0x12056
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_A_PLUS_MASH           0x12057
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_AMAR                  0x12058
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_BALAG                 0x12059
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_BI                    0x1205A
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GA                    0x1205B
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GA_PLUS_MASH          0x1205C
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GI                    0x1205D
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GIR2                  0x1205E
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GUD                   0x1205F
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_HA                    0x12060
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_IR                    0x12061
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_IR_PLUS_LU            0x12062
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_KAK                   0x12063
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LA                    0x12064
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LU                    0x12065
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LU_PLUS_MASH2         0x12066
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LUM                   0x12067
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_NE                    0x12068
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_PAP_PLUS_PAP          0x12069
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_SI                    0x1206A
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_TAK4                  0x1206B
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_U2_PLUS_GIR2          0x1206C
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_USH                   0x1206D
#define unicode_CUNEIFORM_SIGN_DAM                                    0x1206E
#define unicode_CUNEIFORM_SIGN_DAR                                    0x1206F
#define unicode_CUNEIFORM_SIGN_DARA3                                  0x12070
#define unicode_CUNEIFORM_SIGN_DARA4                                  0x12071
#define unicode_CUNEIFORM_SIGN_DI                                     0x12072
#define unicode_CUNEIFORM_SIGN_DIB                                    0x12073
#define unicode_CUNEIFORM_SIGN_DIM                                    0x12074
#define unicode_CUNEIFORM_SIGN_DIM_TIMES_SHE                          0x12075
#define unicode_CUNEIFORM_SIGN_DIM2                                   0x12076
#define unicode_CUNEIFORM_SIGN_DIN                                    0x12077
#define unicode_CUNEIFORM_SIGN_DIN_KASKAL_U_GUNU_DISH                 0x12078
#define unicode_CUNEIFORM_SIGN_DISH                                   0x12079
#define unicode_CUNEIFORM_SIGN_DU                                     0x1207A
#define unicode_CUNEIFORM_SIGN_DU_OVER_DU                             0x1207B
#define unicode_CUNEIFORM_SIGN_DU_GUNU                                0x1207C
#define unicode_CUNEIFORM_SIGN_DU_SHESHIG                             0x1207D
#define unicode_CUNEIFORM_SIGN_DUB                                    0x1207E
#define unicode_CUNEIFORM_SIGN_DUB_TIMES_ESH2                         0x1207F
#define unicode_CUNEIFORM_SIGN_DUB2                                   0x12080
#define unicode_CUNEIFORM_SIGN_DUG                                    0x12081
#define unicode_CUNEIFORM_SIGN_DUGUD                                  0x12082
#define unicode_CUNEIFORM_SIGN_DUH                                    0x12083
#define unicode_CUNEIFORM_SIGN_DUN                                    0x12084
#define unicode_CUNEIFORM_SIGN_DUN3                                   0x12085
#define unicode_CUNEIFORM_SIGN_DUN3_GUNU                              0x12086
#define unicode_CUNEIFORM_SIGN_DUN3_GUNU_GUNU                         0x12087
#define unicode_CUNEIFORM_SIGN_DUN4                                   0x12088
#define unicode_CUNEIFORM_SIGN_DUR2                                   0x12089
#define unicode_CUNEIFORM_SIGN_E                                      0x1208A
#define unicode_CUNEIFORM_SIGN_E_TIMES_PAP                            0x1208B
#define unicode_CUNEIFORM_SIGN_E_OVER_E_NUN_OVER_NUN                  0x1208C
#define unicode_CUNEIFORM_SIGN_E2                                     0x1208D
#define unicode_CUNEIFORM_SIGN_E2_TIMES_A_PLUS_HA_PLUS_DA             0x1208E
#define unicode_CUNEIFORM_SIGN_E2_TIMES_GAR                           0x1208F
#define unicode_CUNEIFORM_SIGN_E2_TIMES_MI                            0x12090
#define unicode_CUNEIFORM_SIGN_E2_TIMES_SAL                           0x12091
#define unicode_CUNEIFORM_SIGN_E2_TIMES_SHE                           0x12092
#define unicode_CUNEIFORM_SIGN_E2_TIMES_U                             0x12093
#define unicode_CUNEIFORM_SIGN_EDIN                                   0x12094
#define unicode_CUNEIFORM_SIGN_EGIR                                   0x12095
#define unicode_CUNEIFORM_SIGN_EL                                     0x12096
#define unicode_CUNEIFORM_SIGN_EN                                     0x12097
#define unicode_CUNEIFORM_SIGN_EN_TIMES_GAN2                          0x12098
#define unicode_CUNEIFORM_SIGN_EN_TIMES_GAN2_TENU                     0x12099
#define unicode_CUNEIFORM_SIGN_EN_TIMES_ME                            0x1209A
#define unicode_CUNEIFORM_SIGN_EN_CROSSING_EN                         0x1209B
#define unicode_CUNEIFORM_SIGN_EN_OPPOSING_EN                         0x1209C
#define unicode_CUNEIFORM_SIGN_EN_SQUARED                             0x1209D
#define unicode_CUNEIFORM_SIGN_EREN                                   0x1209E
#define unicode_CUNEIFORM_SIGN_ERIN2                                  0x1209F
#define unicode_CUNEIFORM_SIGN_ESH2                                   0x120A0
#define unicode_CUNEIFORM_SIGN_EZEN                                   0x120A1
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_A                           0x120A2
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_A_PLUS_LAL                  0x120A3
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_A_PLUS_LAL_TIMES_LAL        0x120A4
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_AN                          0x120A5
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_BAD                         0x120A6
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_DUN3_GUNU                   0x120A7
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_DUN3_GUNU_GUNU              0x120A8
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_HA                          0x120A9
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_HA_GUNU                     0x120AA
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_IGI_GUNU                    0x120AB
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_KASKAL                      0x120AC
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_KASKAL_SQUARED              0x120AD
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_KU3                         0x120AE
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_LA                          0x120AF
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_LAL_TIMES_LAL               0x120B0
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_LI                          0x120B1
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_LU                          0x120B2
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_U2                          0x120B3
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_UD                          0x120B4
#define unicode_CUNEIFORM_SIGN_GA                                     0x120B5
#define unicode_CUNEIFORM_SIGN_GA_GUNU                                0x120B6
#define unicode_CUNEIFORM_SIGN_GA2                                    0x120B7
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_A_PLUS_DA_PLUS_HA            0x120B8
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_A_PLUS_HA                    0x120B9
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_A_PLUS_IGI                   0x120BA
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_AB2_TENU_PLUS_TAB            0x120BB
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_AN                           0x120BC
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_ASH                          0x120BD
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_ASH2_PLUS_GAL                0x120BE
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_BAD                          0x120BF
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_BAR_PLUS_RA                  0x120C0
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_BUR                          0x120C1
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_BUR_PLUS_RA                  0x120C2
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_DA                           0x120C3
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_DI                           0x120C4
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_DIM_TIMES_SHE                0x120C5
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_DUB                          0x120C6
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_EL                           0x120C7
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_EL_PLUS_LA                   0x120C8
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_EN                           0x120C9
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_EN_TIMES_GAN2_TENU           0x120CA
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_GAN2_TENU                    0x120CB
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_GAR                          0x120CC
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_GI                           0x120CD
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_GI4                          0x120CE
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_GI4_PLUS_A                   0x120CF
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_GIR2_PLUS_SU                 0x120D0
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_HA_PLUS_LU_PLUS_ESH2         0x120D1
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_HAL                          0x120D2
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_HAL_PLUS_LA                  0x120D3
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_HI_PLUS_LI                   0x120D4
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_HUB2                         0x120D5
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_IGI_GUNU                     0x120D6
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_ISH_PLUS_HU_PLUS_ASH         0x120D7
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_KAK                          0x120D8
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_KASKAL                       0x120D9
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_KID                          0x120DA
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_KID_PLUS_LAL                 0x120DB
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_KU3_PLUS_AN                  0x120DC
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_LA                           0x120DD
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_ME_PLUS_EN                   0x120DE
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_MI                           0x120DF
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_NUN                          0x120E0
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_NUN_OVER_NUN                 0x120E1
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_PA                           0x120E2
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_SAL                          0x120E3
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_SAR                          0x120E4
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_SHE                          0x120E5
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_SHE_PLUS_TUR                 0x120E6
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_SHID                         0x120E7
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_SUM                          0x120E8
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_TAK4                         0x120E9
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_U                            0x120EA
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_UD                           0x120EB
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_UD_PLUS_DU                   0x120EC
#define unicode_CUNEIFORM_SIGN_GA2_OVER_GA2                           0x120ED
#define unicode_CUNEIFORM_SIGN_GABA                                   0x120EE
#define unicode_CUNEIFORM_SIGN_GABA_CROSSING_GABA                     0x120EF
#define unicode_CUNEIFORM_SIGN_GAD                                    0x120F0
#define unicode_CUNEIFORM_SIGN_GAD_OVER_GAD_GAR_OVER_GAR              0x120F1
#define unicode_CUNEIFORM_SIGN_GAL                                    0x120F2
#define unicode_CUNEIFORM_SIGN_GAL_GAD_OVER_GAD_GAR_OVER_GAR          0x120F3
#define unicode_CUNEIFORM_SIGN_GALAM                                  0x120F4
#define unicode_CUNEIFORM_SIGN_GAM                                    0x120F5
#define unicode_CUNEIFORM_SIGN_GAN                                    0x120F6
#define unicode_CUNEIFORM_SIGN_GAN2                                   0x120F7
#define unicode_CUNEIFORM_SIGN_GAN2_TENU                              0x120F8
#define unicode_CUNEIFORM_SIGN_GAN2_OVER_GAN2                         0x120F9
#define unicode_CUNEIFORM_SIGN_GAN2_CROSSING_GAN2                     0x120FA
#define unicode_CUNEIFORM_SIGN_GAR                                    0x120FB
#define unicode_CUNEIFORM_SIGN_GAR3                                   0x120FC
#define unicode_CUNEIFORM_SIGN_GASHAN                                 0x120FD
#define unicode_CUNEIFORM_SIGN_GESHTIN                                0x120FE
#define unicode_CUNEIFORM_SIGN_GESHTIN_TIMES_KUR                      0x120FF
#define unicode_CUNEIFORM_SIGN_GI                                     0x12100
#define unicode_CUNEIFORM_SIGN_GI_TIMES_E                             0x12101
#define unicode_CUNEIFORM_SIGN_GI_TIMES_U                             0x12102
#define unicode_CUNEIFORM_SIGN_GI_CROSSING_GI                         0x12103
#define unicode_CUNEIFORM_SIGN_GI4                                    0x12104
#define unicode_CUNEIFORM_SIGN_GI4_OVER_GI4                           0x12105
#define unicode_CUNEIFORM_SIGN_GI4_CROSSING_GI4                       0x12106
#define unicode_CUNEIFORM_SIGN_GIDIM                                  0x12107
#define unicode_CUNEIFORM_SIGN_GIR2                                   0x12108
#define unicode_CUNEIFORM_SIGN_GIR2_GUNU                              0x12109
#define unicode_CUNEIFORM_SIGN_GIR3                                   0x1210A
#define unicode_CUNEIFORM_SIGN_GIR3_TIMES_A_PLUS_IGI                  0x1210B
#define unicode_CUNEIFORM_SIGN_GIR3_TIMES_GAN2_TENU                   0x1210C
#define unicode_CUNEIFORM_SIGN_GIR3_TIMES_IGI                         0x1210D
#define unicode_CUNEIFORM_SIGN_GIR3_TIMES_LU_PLUS_IGI                 0x1210E
#define unicode_CUNEIFORM_SIGN_GIR3_TIMES_PA                          0x1210F
#define unicode_CUNEIFORM_SIGN_GISAL                                  0x12110
#define unicode_CUNEIFORM_SIGN_GISH                                   0x12111
#define unicode_CUNEIFORM_SIGN_GISH_CROSSING_GISH                     0x12112
#define unicode_CUNEIFORM_SIGN_GISH_TIMES_BAD                         0x12113
#define unicode_CUNEIFORM_SIGN_GISH_TIMES_TAK4                        0x12114
#define unicode_CUNEIFORM_SIGN_GISH_TENU                              0x12115
#define unicode_CUNEIFORM_SIGN_GU                                     0x12116
#define unicode_CUNEIFORM_SIGN_GU_CROSSING_GU                         0x12117
#define unicode_CUNEIFORM_SIGN_GU2                                    0x12118
#define unicode_CUNEIFORM_SIGN_GU2_TIMES_KAK                          0x12119
#define unicode_CUNEIFORM_SIGN_GU2_TIMES_KAK_TIMES_IGI_GUNU           0x1211A
#define unicode_CUNEIFORM_SIGN_GU2_TIMES_NUN                          0x1211B
#define unicode_CUNEIFORM_SIGN_GU2_TIMES_SAL_PLUS_TUG2                0x1211C
#define unicode_CUNEIFORM_SIGN_GU2_GUNU                               0x1211D
#define unicode_CUNEIFORM_SIGN_GUD                                    0x1211E
#define unicode_CUNEIFORM_SIGN_GUD_TIMES_A_PLUS_KUR                   0x1211F
#define unicode_CUNEIFORM_SIGN_GUD_TIMES_KUR                          0x12120
#define unicode_CUNEIFORM_SIGN_GUD_OVER_GUD_LUGAL                     0x12121
#define unicode_CUNEIFORM_SIGN_GUL                                    0x12122
#define unicode_CUNEIFORM_SIGN_GUM                                    0x12123
#define unicode_CUNEIFORM_SIGN_GUM_TIMES_SHE                          0x12124
#define unicode_CUNEIFORM_SIGN_GUR                                    0x12125
#define unicode_CUNEIFORM_SIGN_GUR7                                   0x12126
#define unicode_CUNEIFORM_SIGN_GURUN                                  0x12127
#define unicode_CUNEIFORM_SIGN_GURUSH                                 0x12128
#define unicode_CUNEIFORM_SIGN_HA                                     0x12129
#define unicode_CUNEIFORM_SIGN_HA_TENU                                0x1212A
#define unicode_CUNEIFORM_SIGN_HA_GUNU                                0x1212B
#define unicode_CUNEIFORM_SIGN_HAL                                    0x1212C
#define unicode_CUNEIFORM_SIGN_HI                                     0x1212D
#define unicode_CUNEIFORM_SIGN_HI_TIMES_ASH                           0x1212E
#define unicode_CUNEIFORM_SIGN_HI_TIMES_ASH2                          0x1212F
#define unicode_CUNEIFORM_SIGN_HI_TIMES_BAD                           0x12130
#define unicode_CUNEIFORM_SIGN_HI_TIMES_DISH                          0x12131
#define unicode_CUNEIFORM_SIGN_HI_TIMES_GAD                           0x12132
#define unicode_CUNEIFORM_SIGN_HI_TIMES_KIN                           0x12133
#define unicode_CUNEIFORM_SIGN_HI_TIMES_NUN                           0x12134
#define unicode_CUNEIFORM_SIGN_HI_TIMES_SHE                           0x12135
#define unicode_CUNEIFORM_SIGN_HI_TIMES_U                             0x12136
#define unicode_CUNEIFORM_SIGN_HU                                     0x12137
#define unicode_CUNEIFORM_SIGN_HUB2                                   0x12138
#define unicode_CUNEIFORM_SIGN_HUB2_TIMES_AN                          0x12139
#define unicode_CUNEIFORM_SIGN_HUB2_TIMES_HAL                         0x1213A
#define unicode_CUNEIFORM_SIGN_HUB2_TIMES_KASKAL                      0x1213B
#define unicode_CUNEIFORM_SIGN_HUB2_TIMES_LISH                        0x1213C
#define unicode_CUNEIFORM_SIGN_HUB2_TIMES_UD                          0x1213D
#define unicode_CUNEIFORM_SIGN_HUL2                                   0x1213E
#define unicode_CUNEIFORM_SIGN_I                                      0x1213F
#define unicode_CUNEIFORM_SIGN_I_A                                    0x12140
#define unicode_CUNEIFORM_SIGN_IB                                     0x12141
#define unicode_CUNEIFORM_SIGN_IDIM                                   0x12142
#define unicode_CUNEIFORM_SIGN_IDIM_OVER_IDIM_BUR                     0x12143
#define unicode_CUNEIFORM_SIGN_IDIM_OVER_IDIM_SQUARED                 0x12144
#define unicode_CUNEIFORM_SIGN_IG                                     0x12145
#define unicode_CUNEIFORM_SIGN_IGI                                    0x12146
#define unicode_CUNEIFORM_SIGN_IGI_DIB                                0x12147
#define unicode_CUNEIFORM_SIGN_IGI_RI                                 0x12148
#define unicode_CUNEIFORM_SIGN_IGI_OVER_IGI_SHIR_OVER_SHIR_UD_OVER_UD 0x12149
#define unicode_CUNEIFORM_SIGN_IGI_GUNU                               0x1214A
#define unicode_CUNEIFORM_SIGN_IL                                     0x1214B
#define unicode_CUNEIFORM_SIGN_IL_TIMES_GAN2_TENU                     0x1214C
#define unicode_CUNEIFORM_SIGN_IL2                                    0x1214D
#define unicode_CUNEIFORM_SIGN_IM                                     0x1214E
#define unicode_CUNEIFORM_SIGN_IM_TIMES_TAK4                          0x1214F
#define unicode_CUNEIFORM_SIGN_IM_CROSSING_IM                         0x12150
#define unicode_CUNEIFORM_SIGN_IM_OPPOSING_IM                         0x12151
#define unicode_CUNEIFORM_SIGN_IM_SQUARED                             0x12152
#define unicode_CUNEIFORM_SIGN_IMIN                                   0x12153
#define unicode_CUNEIFORM_SIGN_IN                                     0x12154
#define unicode_CUNEIFORM_SIGN_IR                                     0x12155
#define unicode_CUNEIFORM_SIGN_ISH                                    0x12156
#define unicode_CUNEIFORM_SIGN_KA                                     0x12157
#define unicode_CUNEIFORM_SIGN_KA_TIMES_A                             0x12158
#define unicode_CUNEIFORM_SIGN_KA_TIMES_AD                            0x12159
#define unicode_CUNEIFORM_SIGN_KA_TIMES_AD_PLUS_KU3                   0x1215A
#define unicode_CUNEIFORM_SIGN_KA_TIMES_ASH2                          0x1215B
#define unicode_CUNEIFORM_SIGN_KA_TIMES_BAD                           0x1215C
#define unicode_CUNEIFORM_SIGN_KA_TIMES_BALAG                         0x1215D
#define unicode_CUNEIFORM_SIGN_KA_TIMES_BAR                           0x1215E
#define unicode_CUNEIFORM_SIGN_KA_TIMES_BI                            0x1215F
#define unicode_CUNEIFORM_SIGN_KA_TIMES_ERIN2                         0x12160
#define unicode_CUNEIFORM_SIGN_KA_TIMES_ESH2                          0x12161
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GA                            0x12162
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GAL                           0x12163
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GAN2_TENU                     0x12164
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GAR                           0x12165
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GAR_PLUS_SHA3_PLUS_A          0x12166
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GI                            0x12167
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GIR2                          0x12168
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GISH_PLUS_SAR                 0x12169
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GISH_CROSSING_GISH            0x1216A
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GU                            0x1216B
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GUR7                          0x1216C
#define unicode_CUNEIFORM_SIGN_KA_TIMES_IGI                           0x1216D
#define unicode_CUNEIFORM_SIGN_KA_TIMES_IM                            0x1216E
#define unicode_CUNEIFORM_SIGN_KA_TIMES_KAK                           0x1216F
#define unicode_CUNEIFORM_SIGN_KA_TIMES_KI                            0x12170
#define unicode_CUNEIFORM_SIGN_KA_TIMES_KID                           0x12171
#define unicode_CUNEIFORM_SIGN_KA_TIMES_LI                            0x12172
#define unicode_CUNEIFORM_SIGN_KA_TIMES_LU                            0x12173
#define unicode_CUNEIFORM_SIGN_KA_TIMES_ME                            0x12174
#define unicode_CUNEIFORM_SIGN_KA_TIMES_ME_PLUS_DU                    0x12175
#define unicode_CUNEIFORM_SIGN_KA_TIMES_ME_PLUS_GI                    0x12176
#define unicode_CUNEIFORM_SIGN_KA_TIMES_ME_PLUS_TE                    0x12177
#define unicode_CUNEIFORM_SIGN_KA_TIMES_MI                            0x12178
#define unicode_CUNEIFORM_SIGN_KA_TIMES_MI_PLUS_NUNUZ                 0x12179
#define unicode_CUNEIFORM_SIGN_KA_TIMES_NE                            0x1217A
#define unicode_CUNEIFORM_SIGN_KA_TIMES_NUN                           0x1217B
#define unicode_CUNEIFORM_SIGN_KA_TIMES_PI                            0x1217C
#define unicode_CUNEIFORM_SIGN_KA_TIMES_RU                            0x1217D
#define unicode_CUNEIFORM_SIGN_KA_TIMES_SA                            0x1217E
#define unicode_CUNEIFORM_SIGN_KA_TIMES_SAR                           0x1217F
#define unicode_CUNEIFORM_SIGN_KA_TIMES_SHA                           0x12180
#define unicode_CUNEIFORM_SIGN_KA_TIMES_SHE                           0x12181
#define unicode_CUNEIFORM_SIGN_KA_TIMES_SHID                          0x12182
#define unicode_CUNEIFORM_SIGN_KA_TIMES_SHU                           0x12183
#define unicode_CUNEIFORM_SIGN_KA_TIMES_SIG                           0x12184
#define unicode_CUNEIFORM_SIGN_KA_TIMES_SUHUR                         0x12185
#define unicode_CUNEIFORM_SIGN_KA_TIMES_TAR                           0x12186
#define unicode_CUNEIFORM_SIGN_KA_TIMES_U                             0x12187
#define unicode_CUNEIFORM_SIGN_KA_TIMES_U2                            0x12188
#define unicode_CUNEIFORM_SIGN_KA_TIMES_UD                            0x12189
#define unicode_CUNEIFORM_SIGN_KA_TIMES_UMUM_TIMES_PA                 0x1218A
#define unicode_CUNEIFORM_SIGN_KA_TIMES_USH                           0x1218B
#define unicode_CUNEIFORM_SIGN_KA_TIMES_ZI                            0x1218C
#define unicode_CUNEIFORM_SIGN_KA2                                    0x1218D
#define unicode_CUNEIFORM_SIGN_KA2_CROSSING_KA2                       0x1218E
#define unicode_CUNEIFORM_SIGN_KAB                                    0x1218F
#define unicode_CUNEIFORM_SIGN_KAD2                                   0x12190
#define unicode_CUNEIFORM_SIGN_KAD3                                   0x12191
#define unicode_CUNEIFORM_SIGN_KAD4                                   0x12192
#define unicode_CUNEIFORM_SIGN_KAD5                                   0x12193
#define unicode_CUNEIFORM_SIGN_KAD5_OVER_KAD5                         0x12194
#define unicode_CUNEIFORM_SIGN_KAK                                    0x12195
#define unicode_CUNEIFORM_SIGN_KAK_TIMES_IGI_GUNU                     0x12196
#define unicode_CUNEIFORM_SIGN_KAL                                    0x12197
#define unicode_CUNEIFORM_SIGN_KAL_TIMES_BAD                          0x12198
#define unicode_CUNEIFORM_SIGN_KAL_CROSSING_KAL                       0x12199
#define unicode_CUNEIFORM_SIGN_KAM2                                   0x1219A
#define unicode_CUNEIFORM_SIGN_KAM4                                   0x1219B
#define unicode_CUNEIFORM_SIGN_KASKAL                                 0x1219C
#define unicode_CUNEIFORM_SIGN_KASKAL_LAGAB_TIMES_U_OVER_LAGAB_TIMES_U 0x1219D
#define unicode_CUNEIFORM_SIGN_KASKAL_OVER_KASKAL_LAGAB_TIMES_U_OVER_LAGAB_TIMES_U 0x1219E
#define unicode_CUNEIFORM_SIGN_KESH2                                  0x1219F
#define unicode_CUNEIFORM_SIGN_KI                                     0x121A0
#define unicode_CUNEIFORM_SIGN_KI_TIMES_BAD                           0x121A1
#define unicode_CUNEIFORM_SIGN_KI_TIMES_U                             0x121A2
#define unicode_CUNEIFORM_SIGN_KI_TIMES_UD                            0x121A3
#define unicode_CUNEIFORM_SIGN_KID                                    0x121A4
#define unicode_CUNEIFORM_SIGN_KIN                                    0x121A5
#define unicode_CUNEIFORM_SIGN_KISAL                                  0x121A6
#define unicode_CUNEIFORM_SIGN_KISH                                   0x121A7
#define unicode_CUNEIFORM_SIGN_KISIM5                                 0x121A8
#define unicode_CUNEIFORM_SIGN_KISIM5_OVER_KISIM5                     0x121A9
#define unicode_CUNEIFORM_SIGN_KU                                     0x121AA
#define unicode_CUNEIFORM_SIGN_KU_OVER_HI_TIMES_ASH2_KU_OVER_HI_TIMES_ASH2 0x121AB
#define unicode_CUNEIFORM_SIGN_KU3                                    0x121AC
#define unicode_CUNEIFORM_SIGN_KU4                                    0x121AD
#define unicode_CUNEIFORM_SIGN_KU4_VARIANT_FORM                       0x121AE
#define unicode_CUNEIFORM_SIGN_KU7                                    0x121AF
#define unicode_CUNEIFORM_SIGN_KUL                                    0x121B0
#define unicode_CUNEIFORM_SIGN_KUL_GUNU                               0x121B1
#define unicode_CUNEIFORM_SIGN_KUN                                    0x121B2
#define unicode_CUNEIFORM_SIGN_KUR                                    0x121B3
#define unicode_CUNEIFORM_SIGN_KUR_OPPOSING_KUR                       0x121B4
#define unicode_CUNEIFORM_SIGN_KUSHU2                                 0x121B5
#define unicode_CUNEIFORM_SIGN_KWU318                                 0x121B6
#define unicode_CUNEIFORM_SIGN_LA                                     0x121B7
#define unicode_CUNEIFORM_SIGN_LAGAB                                  0x121B8
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_A                          0x121B9
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_A_PLUS_DA_PLUS_HA          0x121BA
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_A_PLUS_GAR                 0x121BB
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_A_PLUS_LAL                 0x121BC
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_AL                         0x121BD
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_AN                         0x121BE
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_ASH_ZIDA_TENU              0x121BF
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_BAD                        0x121C0
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_BI                         0x121C1
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_DAR                        0x121C2
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_EN                         0x121C3
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_GA                         0x121C4
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_GAR                        0x121C5
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_GUD                        0x121C6
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_GUD_PLUS_GUD               0x121C7
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_HA                         0x121C8
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_HAL                        0x121C9
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_HI_TIMES_NUN               0x121CA
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_IGI_GUNU                   0x121CB
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_IM                         0x121CC
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_IM_PLUS_HA                 0x121CD
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_IM_PLUS_LU                 0x121CE
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_KI                         0x121CF
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_KIN                        0x121D0
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_KU3                        0x121D1
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_KUL                        0x121D2
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_KUL_PLUS_HI_PLUS_A         0x121D3
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_LAGAB                      0x121D4
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_LISH                       0x121D5
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_LU                         0x121D6
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_LUL                        0x121D7
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_ME                         0x121D8
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_ME_PLUS_EN                 0x121D9
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_MUSH                       0x121DA
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_NE                         0x121DB
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_SHE_PLUS_SUM               0x121DC
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_SHITA_PLUS_GISH_PLUS_ERIN2 0x121DD
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_SHITA_PLUS_GISH_TENU       0x121DE
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_SHU2                       0x121DF
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_SHU2_PLUS_SHU2             0x121E0
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_SUM                        0x121E1
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_TAG                        0x121E2
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_TAK4                       0x121E3
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_TE_PLUS_A_PLUS_SU_PLUS_NA  0x121E4
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_U                          0x121E5
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_U_PLUS_A                   0x121E6
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_U_PLUS_U_PLUS_U            0x121E7
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_U2_PLUS_ASH                0x121E8
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_UD                         0x121E9
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_USH                        0x121EA
#define unicode_CUNEIFORM_SIGN_LAGAB_SQUARED                          0x121EB
#define unicode_CUNEIFORM_SIGN_LAGAR                                  0x121EC
#define unicode_CUNEIFORM_SIGN_LAGAR_TIMES_SHE                        0x121ED
#define unicode_CUNEIFORM_SIGN_LAGAR_TIMES_SHE_PLUS_SUM               0x121EE
#define unicode_CUNEIFORM_SIGN_LAGAR_GUNU                             0x121EF
#define unicode_CUNEIFORM_SIGN_LAGAR_GUNU_OVER_LAGAR_GUNU_SHE         0x121F0
#define unicode_CUNEIFORM_SIGN_LAHSHU                                 0x121F1
#define unicode_CUNEIFORM_SIGN_LAL                                    0x121F2
#define unicode_CUNEIFORM_SIGN_LAL_TIMES_LAL                          0x121F3
#define unicode_CUNEIFORM_SIGN_LAM                                    0x121F4
#define unicode_CUNEIFORM_SIGN_LAM_TIMES_KUR                          0x121F5
#define unicode_CUNEIFORM_SIGN_LAM_TIMES_KUR_PLUS_RU                  0x121F6
#define unicode_CUNEIFORM_SIGN_LI                                     0x121F7
#define unicode_CUNEIFORM_SIGN_LIL                                    0x121F8
#define unicode_CUNEIFORM_SIGN_LIMMU2                                 0x121F9
#define unicode_CUNEIFORM_SIGN_LISH                                   0x121FA
#define unicode_CUNEIFORM_SIGN_LU                                     0x121FB
#define unicode_CUNEIFORM_SIGN_LU_TIMES_BAD                           0x121FC
#define unicode_CUNEIFORM_SIGN_LU2                                    0x121FD
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_AL                           0x121FE
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_BAD                          0x121FF
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_ESH2                         0x12200
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_ESH2_TENU                    0x12201
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_GAN2_TENU                    0x12202
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_HI_TIMES_BAD                 0x12203
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_IM                           0x12204
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_KAD2                         0x12205
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_KAD3                         0x12206
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_KAD3_PLUS_ASH                0x12207
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_KI                           0x12208
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_LA_PLUS_ASH                  0x12209
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_LAGAB                        0x1220A
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_ME_PLUS_EN                   0x1220B
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_NE                           0x1220C
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_NU                           0x1220D
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_SI_PLUS_ASH                  0x1220E
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_SIK2_PLUS_BU                 0x1220F
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_TUG2                         0x12210
#define unicode_CUNEIFORM_SIGN_LU2_TENU                               0x12211
#define unicode_CUNEIFORM_SIGN_LU2_CROSSING_LU2                       0x12212
#define unicode_CUNEIFORM_SIGN_LU2_OPPOSING_LU2                       0x12213
#define unicode_CUNEIFORM_SIGN_LU2_SQUARED                            0x12214
#define unicode_CUNEIFORM_SIGN_LU2_SHESHIG                            0x12215
#define unicode_CUNEIFORM_SIGN_LU3                                    0x12216
#define unicode_CUNEIFORM_SIGN_LUGAL                                  0x12217
#define unicode_CUNEIFORM_SIGN_LUGAL_OVER_LUGAL                       0x12218
#define unicode_CUNEIFORM_SIGN_LUGAL_OPPOSING_LUGAL                   0x12219
#define unicode_CUNEIFORM_SIGN_LUGAL_SHESHIG                          0x1221A
#define unicode_CUNEIFORM_SIGN_LUH                                    0x1221B
#define unicode_CUNEIFORM_SIGN_LUL                                    0x1221C
#define unicode_CUNEIFORM_SIGN_LUM                                    0x1221D
#define unicode_CUNEIFORM_SIGN_LUM_OVER_LUM                           0x1221E
#define unicode_CUNEIFORM_SIGN_LUM_OVER_LUM_GAR_OVER_GAR              0x1221F
#define unicode_CUNEIFORM_SIGN_MA                                     0x12220
#define unicode_CUNEIFORM_SIGN_MA_TIMES_TAK4                          0x12221
#define unicode_CUNEIFORM_SIGN_MA_GUNU                                0x12222
#define unicode_CUNEIFORM_SIGN_MA2                                    0x12223
#define unicode_CUNEIFORM_SIGN_MAH                                    0x12224
#define unicode_CUNEIFORM_SIGN_MAR                                    0x12225
#define unicode_CUNEIFORM_SIGN_MASH                                   0x12226
#define unicode_CUNEIFORM_SIGN_MASH2                                  0x12227
#define unicode_CUNEIFORM_SIGN_ME                                     0x12228
#define unicode_CUNEIFORM_SIGN_MES                                    0x12229
#define unicode_CUNEIFORM_SIGN_MI                                     0x1222A
#define unicode_CUNEIFORM_SIGN_MIN                                    0x1222B
#define unicode_CUNEIFORM_SIGN_MU                                     0x1222C
#define unicode_CUNEIFORM_SIGN_MU_OVER_MU                             0x1222D
#define unicode_CUNEIFORM_SIGN_MUG                                    0x1222E
#define unicode_CUNEIFORM_SIGN_MUG_GUNU                               0x1222F
#define unicode_CUNEIFORM_SIGN_MUNSUB                                 0x12230
#define unicode_CUNEIFORM_SIGN_MURGU2                                 0x12231
#define unicode_CUNEIFORM_SIGN_MUSH                                   0x12232
#define unicode_CUNEIFORM_SIGN_MUSH_TIMES_A                           0x12233
#define unicode_CUNEIFORM_SIGN_MUSH_TIMES_KUR                         0x12234
#define unicode_CUNEIFORM_SIGN_MUSH_TIMES_ZA                          0x12235
#define unicode_CUNEIFORM_SIGN_MUSH_OVER_MUSH                         0x12236
#define unicode_CUNEIFORM_SIGN_MUSH_OVER_MUSH_TIMES_A_PLUS_NA         0x12237
#define unicode_CUNEIFORM_SIGN_MUSH_CROSSING_MUSH                     0x12238
#define unicode_CUNEIFORM_SIGN_MUSH3                                  0x12239
#define unicode_CUNEIFORM_SIGN_MUSH3_TIMES_A                          0x1223A
#define unicode_CUNEIFORM_SIGN_MUSH3_TIMES_A_PLUS_DI                  0x1223B
#define unicode_CUNEIFORM_SIGN_MUSH3_TIMES_DI                         0x1223C
#define unicode_CUNEIFORM_SIGN_MUSH3_GUNU                             0x1223D
#define unicode_CUNEIFORM_SIGN_NA                                     0x1223E
#define unicode_CUNEIFORM_SIGN_NA2                                    0x1223F
#define unicode_CUNEIFORM_SIGN_NAGA                                   0x12240
#define unicode_CUNEIFORM_SIGN_NAGA_INVERTED                          0x12241
#define unicode_CUNEIFORM_SIGN_NAGA_TIMES_SHU_TENU                    0x12242
#define unicode_CUNEIFORM_SIGN_NAGA_OPPOSING_NAGA                     0x12243
#define unicode_CUNEIFORM_SIGN_NAGAR                                  0x12244
#define unicode_CUNEIFORM_SIGN_NAM_NUTILLU                            0x12245
#define unicode_CUNEIFORM_SIGN_NAM                                    0x12246
#define unicode_CUNEIFORM_SIGN_NAM2                                   0x12247
#define unicode_CUNEIFORM_SIGN_NE                                     0x12248
#define unicode_CUNEIFORM_SIGN_NE_TIMES_A                             0x12249
#define unicode_CUNEIFORM_SIGN_NE_TIMES_UD                            0x1224A
#define unicode_CUNEIFORM_SIGN_NE_SHESHIG                             0x1224B
#define unicode_CUNEIFORM_SIGN_NI                                     0x1224C
#define unicode_CUNEIFORM_SIGN_NI_TIMES_E                             0x1224D
#define unicode_CUNEIFORM_SIGN_NI2                                    0x1224E
#define unicode_CUNEIFORM_SIGN_NIM                                    0x1224F
#define unicode_CUNEIFORM_SIGN_NIM_TIMES_GAN2_TENU                    0x12250
#define unicode_CUNEIFORM_SIGN_NIM_TIMES_GAR_PLUS_GAN2_TENU           0x12251
#define unicode_CUNEIFORM_SIGN_NINDA2                                 0x12252
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_AN                        0x12253
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_ASH                       0x12254
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_ASH_PLUS_ASH              0x12255
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_GUD                       0x12256
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_ME_PLUS_GAN2_TENU         0x12257
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_NE                        0x12258
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_NUN                       0x12259
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_SHE                       0x1225A
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_SHE_PLUS_A_AN             0x1225B
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_SHE_PLUS_ASH              0x1225C
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_SHE_PLUS_ASH_PLUS_ASH     0x1225D
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_U2_PLUS_ASH               0x1225E
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_USH                       0x1225F
#define unicode_CUNEIFORM_SIGN_NISAG                                  0x12260
#define unicode_CUNEIFORM_SIGN_NU                                     0x12261
#define unicode_CUNEIFORM_SIGN_NU11                                   0x12262
#define unicode_CUNEIFORM_SIGN_NUN                                    0x12263
#define unicode_CUNEIFORM_SIGN_NUN_LAGAR_TIMES_GAR                    0x12264
#define unicode_CUNEIFORM_SIGN_NUN_LAGAR_TIMES_MASH                   0x12265
#define unicode_CUNEIFORM_SIGN_NUN_LAGAR_TIMES_SAL                    0x12266
#define unicode_CUNEIFORM_SIGN_NUN_LAGAR_TIMES_SAL_OVER_NUN_LAGAR_TIMES_SAL 0x12267
#define unicode_CUNEIFORM_SIGN_NUN_LAGAR_TIMES_USH                    0x12268
#define unicode_CUNEIFORM_SIGN_NUN_TENU                               0x12269
#define unicode_CUNEIFORM_SIGN_NUN_OVER_NUN                           0x1226A
#define unicode_CUNEIFORM_SIGN_NUN_CROSSING_NUN                       0x1226B
#define unicode_CUNEIFORM_SIGN_NUN_CROSSING_NUN_LAGAR_OVER_LAGAR      0x1226C
#define unicode_CUNEIFORM_SIGN_NUNUZ                                  0x1226D
#define unicode_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_ASHGAB                 0x1226E
#define unicode_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_BI                     0x1226F
#define unicode_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_DUG                    0x12270
#define unicode_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_GUD                    0x12271
#define unicode_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_IGI_GUNU               0x12272
#define unicode_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_KAD3                   0x12273
#define unicode_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_LA                     0x12274
#define unicode_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_NE                     0x12275
#define unicode_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_SILA3                  0x12276
#define unicode_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_U2                     0x12277
#define unicode_CUNEIFORM_SIGN_NUNUZ_KISIM5_TIMES_BI                  0x12278
#define unicode_CUNEIFORM_SIGN_NUNUZ_KISIM5_TIMES_BI_U                0x12279
#define unicode_CUNEIFORM_SIGN_PA                                     0x1227A
#define unicode_CUNEIFORM_SIGN_PAD                                    0x1227B
#define unicode_CUNEIFORM_SIGN_PAN                                    0x1227C
#define unicode_CUNEIFORM_SIGN_PAP                                    0x1227D
#define unicode_CUNEIFORM_SIGN_PESH2                                  0x1227E
#define unicode_CUNEIFORM_SIGN_PI                                     0x1227F
#define unicode_CUNEIFORM_SIGN_PI_TIMES_A                             0x12280
#define unicode_CUNEIFORM_SIGN_PI_TIMES_AB                            0x12281
#define unicode_CUNEIFORM_SIGN_PI_TIMES_BI                            0x12282
#define unicode_CUNEIFORM_SIGN_PI_TIMES_BU                            0x12283
#define unicode_CUNEIFORM_SIGN_PI_TIMES_E                             0x12284
#define unicode_CUNEIFORM_SIGN_PI_TIMES_I                             0x12285
#define unicode_CUNEIFORM_SIGN_PI_TIMES_IB                            0x12286
#define unicode_CUNEIFORM_SIGN_PI_TIMES_U                             0x12287
#define unicode_CUNEIFORM_SIGN_PI_TIMES_U2                            0x12288
#define unicode_CUNEIFORM_SIGN_PI_CROSSING_PI                         0x12289
#define unicode_CUNEIFORM_SIGN_PIRIG                                  0x1228A
#define unicode_CUNEIFORM_SIGN_PIRIG_TIMES_KAL                        0x1228B
#define unicode_CUNEIFORM_SIGN_PIRIG_TIMES_UD                         0x1228C
#define unicode_CUNEIFORM_SIGN_PIRIG_TIMES_ZA                         0x1228D
#define unicode_CUNEIFORM_SIGN_PIRIG_OPPOSING_PIRIG                   0x1228E
#define unicode_CUNEIFORM_SIGN_RA                                     0x1228F
#define unicode_CUNEIFORM_SIGN_RAB                                    0x12290
#define unicode_CUNEIFORM_SIGN_RI                                     0x12291
#define unicode_CUNEIFORM_SIGN_RU                                     0x12292
#define unicode_CUNEIFORM_SIGN_SA                                     0x12293
#define unicode_CUNEIFORM_SIGN_SAG_NUTILLU                            0x12294
#define unicode_CUNEIFORM_SIGN_SAG                                    0x12295
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_A                            0x12296
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_DU                           0x12297
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_DUB                          0x12298
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_HA                           0x12299
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_KAK                          0x1229A
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_KUR                          0x1229B
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_LUM                          0x1229C
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_MI                           0x1229D
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_NUN                          0x1229E
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_SAL                          0x1229F
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_SHID                         0x122A0
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_TAB                          0x122A1
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_U2                           0x122A2
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_UB                           0x122A3
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_UM                           0x122A4
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_UR                           0x122A5
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_USH                          0x122A6
#define unicode_CUNEIFORM_SIGN_SAG_OVER_SAG                           0x122A7
#define unicode_CUNEIFORM_SIGN_SAG_GUNU                               0x122A8
#define unicode_CUNEIFORM_SIGN_SAL                                    0x122A9
#define unicode_CUNEIFORM_SIGN_SAL_LAGAB_TIMES_ASH2                   0x122AA
#define unicode_CUNEIFORM_SIGN_SANGA2                                 0x122AB
#define unicode_CUNEIFORM_SIGN_SAR                                    0x122AC
#define unicode_CUNEIFORM_SIGN_SHA                                    0x122AD
#define unicode_CUNEIFORM_SIGN_SHA3                                   0x122AE
#define unicode_CUNEIFORM_SIGN_SHA3_TIMES_A                           0x122AF
#define unicode_CUNEIFORM_SIGN_SHA3_TIMES_BAD                         0x122B0
#define unicode_CUNEIFORM_SIGN_SHA3_TIMES_GISH                        0x122B1
#define unicode_CUNEIFORM_SIGN_SHA3_TIMES_NE                          0x122B2
#define unicode_CUNEIFORM_SIGN_SHA3_TIMES_SHU2                        0x122B3
#define unicode_CUNEIFORM_SIGN_SHA3_TIMES_TUR                         0x122B4
#define unicode_CUNEIFORM_SIGN_SHA3_TIMES_U                           0x122B5
#define unicode_CUNEIFORM_SIGN_SHA3_TIMES_U_PLUS_A                    0x122B6
#define unicode_CUNEIFORM_SIGN_SHA6                                   0x122B7
#define unicode_CUNEIFORM_SIGN_SHAB6                                  0x122B8
#define unicode_CUNEIFORM_SIGN_SHAR2                                  0x122B9
#define unicode_CUNEIFORM_SIGN_SHE                                    0x122BA
#define unicode_CUNEIFORM_SIGN_SHE_HU                                 0x122BB
#define unicode_CUNEIFORM_SIGN_SHE_OVER_SHE_GAD_OVER_GAD_GAR_OVER_GAR 0x122BC
#define unicode_CUNEIFORM_SIGN_SHE_OVER_SHE_TAB_OVER_TAB_GAR_OVER_GAR 0x122BD
#define unicode_CUNEIFORM_SIGN_SHEG9                                  0x122BE
#define unicode_CUNEIFORM_SIGN_SHEN                                   0x122BF
#define unicode_CUNEIFORM_SIGN_SHESH                                  0x122C0
#define unicode_CUNEIFORM_SIGN_SHESH2                                 0x122C1
#define unicode_CUNEIFORM_SIGN_SHESHLAM                               0x122C2
#define unicode_CUNEIFORM_SIGN_SHID                                   0x122C3
#define unicode_CUNEIFORM_SIGN_SHID_TIMES_A                           0x122C4
#define unicode_CUNEIFORM_SIGN_SHID_TIMES_IM                          0x122C5
#define unicode_CUNEIFORM_SIGN_SHIM                                   0x122C6
#define unicode_CUNEIFORM_SIGN_SHIM_TIMES_A                           0x122C7
#define unicode_CUNEIFORM_SIGN_SHIM_TIMES_BAL                         0x122C8
#define unicode_CUNEIFORM_SIGN_SHIM_TIMES_BULUG                       0x122C9
#define unicode_CUNEIFORM_SIGN_SHIM_TIMES_DIN                         0x122CA
#define unicode_CUNEIFORM_SIGN_SHIM_TIMES_GAR                         0x122CB
#define unicode_CUNEIFORM_SIGN_SHIM_TIMES_IGI                         0x122CC
#define unicode_CUNEIFORM_SIGN_SHIM_TIMES_IGI_GUNU                    0x122CD
#define unicode_CUNEIFORM_SIGN_SHIM_TIMES_KUSHU2                      0x122CE
#define unicode_CUNEIFORM_SIGN_SHIM_TIMES_LUL                         0x122CF
#define unicode_CUNEIFORM_SIGN_SHIM_TIMES_MUG                         0x122D0
#define unicode_CUNEIFORM_SIGN_SHIM_TIMES_SAL                         0x122D1
#define unicode_CUNEIFORM_SIGN_SHINIG                                 0x122D2
#define unicode_CUNEIFORM_SIGN_SHIR                                   0x122D3
#define unicode_CUNEIFORM_SIGN_SHIR_TENU                              0x122D4
#define unicode_CUNEIFORM_SIGN_SHIR_OVER_SHIR_BUR_OVER_BUR            0x122D5
#define unicode_CUNEIFORM_SIGN_SHITA                                  0x122D6
#define unicode_CUNEIFORM_SIGN_SHU                                    0x122D7
#define unicode_CUNEIFORM_SIGN_SHU_OVER_INVERTED_SHU                  0x122D8
#define unicode_CUNEIFORM_SIGN_SHU2                                   0x122D9
#define unicode_CUNEIFORM_SIGN_SHUBUR                                 0x122DA
#define unicode_CUNEIFORM_SIGN_SI                                     0x122DB
#define unicode_CUNEIFORM_SIGN_SI_GUNU                                0x122DC
#define unicode_CUNEIFORM_SIGN_SIG                                    0x122DD
#define unicode_CUNEIFORM_SIGN_SIG4                                   0x122DE
#define unicode_CUNEIFORM_SIGN_SIG4_OVER_SIG4_SHU2                    0x122DF
#define unicode_CUNEIFORM_SIGN_SIK2                                   0x122E0
#define unicode_CUNEIFORM_SIGN_SILA3                                  0x122E1
#define unicode_CUNEIFORM_SIGN_SU                                     0x122E2
#define unicode_CUNEIFORM_SIGN_SU_OVER_SU                             0x122E3
#define unicode_CUNEIFORM_SIGN_SUD                                    0x122E4
#define unicode_CUNEIFORM_SIGN_SUD2                                   0x122E5
#define unicode_CUNEIFORM_SIGN_SUHUR                                  0x122E6
#define unicode_CUNEIFORM_SIGN_SUM                                    0x122E7
#define unicode_CUNEIFORM_SIGN_SUMASH                                 0x122E8
#define unicode_CUNEIFORM_SIGN_SUR                                    0x122E9
#define unicode_CUNEIFORM_SIGN_SUR9                                   0x122EA
#define unicode_CUNEIFORM_SIGN_TA                                     0x122EB
#define unicode_CUNEIFORM_SIGN_TA_ASTERISK                            0x122EC
#define unicode_CUNEIFORM_SIGN_TA_TIMES_HI                            0x122ED
#define unicode_CUNEIFORM_SIGN_TA_TIMES_MI                            0x122EE
#define unicode_CUNEIFORM_SIGN_TA_GUNU                                0x122EF
#define unicode_CUNEIFORM_SIGN_TAB                                    0x122F0
#define unicode_CUNEIFORM_SIGN_TAB_OVER_TAB_NI_OVER_NI_DISH_OVER_DISH 0x122F1
#define unicode_CUNEIFORM_SIGN_TAB_SQUARED                            0x122F2
#define unicode_CUNEIFORM_SIGN_TAG                                    0x122F3
#define unicode_CUNEIFORM_SIGN_TAG_TIMES_BI                           0x122F4
#define unicode_CUNEIFORM_SIGN_TAG_TIMES_GUD                          0x122F5
#define unicode_CUNEIFORM_SIGN_TAG_TIMES_SHE                          0x122F6
#define unicode_CUNEIFORM_SIGN_TAG_TIMES_SHU                          0x122F7
#define unicode_CUNEIFORM_SIGN_TAG_TIMES_TUG2                         0x122F8
#define unicode_CUNEIFORM_SIGN_TAG_TIMES_UD                           0x122F9
#define unicode_CUNEIFORM_SIGN_TAK4                                   0x122FA
#define unicode_CUNEIFORM_SIGN_TAR                                    0x122FB
#define unicode_CUNEIFORM_SIGN_TE                                     0x122FC
#define unicode_CUNEIFORM_SIGN_TE_GUNU                                0x122FD
#define unicode_CUNEIFORM_SIGN_TI                                     0x122FE
#define unicode_CUNEIFORM_SIGN_TI_TENU                                0x122FF
#define unicode_CUNEIFORM_SIGN_TIL                                    0x12300
#define unicode_CUNEIFORM_SIGN_TIR                                    0x12301
#define unicode_CUNEIFORM_SIGN_TIR_TIMES_TAK4                         0x12302
#define unicode_CUNEIFORM_SIGN_TIR_OVER_TIR                           0x12303
#define unicode_CUNEIFORM_SIGN_TIR_OVER_TIR_GAD_OVER_GAD_GAR_OVER_GAR 0x12304
#define unicode_CUNEIFORM_SIGN_TU                                     0x12305
#define unicode_CUNEIFORM_SIGN_TUG2                                   0x12306
#define unicode_CUNEIFORM_SIGN_TUK                                    0x12307
#define unicode_CUNEIFORM_SIGN_TUM                                    0x12308
#define unicode_CUNEIFORM_SIGN_TUR                                    0x12309
#define unicode_CUNEIFORM_SIGN_TUR_OVER_TUR_ZA_OVER_ZA                0x1230A
#define unicode_CUNEIFORM_SIGN_U                                      0x1230B
#define unicode_CUNEIFORM_SIGN_U_GUD                                  0x1230C
#define unicode_CUNEIFORM_SIGN_U_U_U                                  0x1230D
#define unicode_CUNEIFORM_SIGN_U_OVER_U_PA_OVER_PA_GAR_OVER_GAR       0x1230E
#define unicode_CUNEIFORM_SIGN_U_OVER_U_SUR_OVER_SUR                  0x1230F
#define unicode_CUNEIFORM_SIGN_U_OVER_U_U_REVERSED_OVER_U_REVERSED    0x12310
#define unicode_CUNEIFORM_SIGN_U2                                     0x12311
#define unicode_CUNEIFORM_SIGN_UB                                     0x12312
#define unicode_CUNEIFORM_SIGN_UD                                     0x12313
#define unicode_CUNEIFORM_SIGN_UD_KUSHU2                              0x12314
#define unicode_CUNEIFORM_SIGN_UD_TIMES_BAD                           0x12315
#define unicode_CUNEIFORM_SIGN_UD_TIMES_MI                            0x12316
#define unicode_CUNEIFORM_SIGN_UD_TIMES_U_PLUS_U_PLUS_U               0x12317
#define unicode_CUNEIFORM_SIGN_UD_TIMES_U_PLUS_U_PLUS_U_GUNU          0x12318
#define unicode_CUNEIFORM_SIGN_UD_GUNU                                0x12319
#define unicode_CUNEIFORM_SIGN_UD_SHESHIG                             0x1231A
#define unicode_CUNEIFORM_SIGN_UD_SHESHIG_TIMES_BAD                   0x1231B
#define unicode_CUNEIFORM_SIGN_UDUG                                   0x1231C
#define unicode_CUNEIFORM_SIGN_UM                                     0x1231D
#define unicode_CUNEIFORM_SIGN_UM_TIMES_LAGAB                         0x1231E
#define unicode_CUNEIFORM_SIGN_UM_TIMES_ME_PLUS_DA                    0x1231F
#define unicode_CUNEIFORM_SIGN_UM_TIMES_SHA3                          0x12320
#define unicode_CUNEIFORM_SIGN_UM_TIMES_U                             0x12321
#define unicode_CUNEIFORM_SIGN_UMBIN                                  0x12322
#define unicode_CUNEIFORM_SIGN_UMUM                                   0x12323
#define unicode_CUNEIFORM_SIGN_UMUM_TIMES_KASKAL                      0x12324
#define unicode_CUNEIFORM_SIGN_UMUM_TIMES_PA                          0x12325
#define unicode_CUNEIFORM_SIGN_UN                                     0x12326
#define unicode_CUNEIFORM_SIGN_UN_GUNU                                0x12327
#define unicode_CUNEIFORM_SIGN_UR                                     0x12328
#define unicode_CUNEIFORM_SIGN_UR_CROSSING_UR                         0x12329
#define unicode_CUNEIFORM_SIGN_UR_SHESHIG                             0x1232A
#define unicode_CUNEIFORM_SIGN_UR2                                    0x1232B
#define unicode_CUNEIFORM_SIGN_UR2_TIMES_A_PLUS_HA                    0x1232C
#define unicode_CUNEIFORM_SIGN_UR2_TIMES_A_PLUS_NA                    0x1232D
#define unicode_CUNEIFORM_SIGN_UR2_TIMES_AL                           0x1232E
#define unicode_CUNEIFORM_SIGN_UR2_TIMES_HA                           0x1232F
#define unicode_CUNEIFORM_SIGN_UR2_TIMES_NUN                          0x12330
#define unicode_CUNEIFORM_SIGN_UR2_TIMES_U2                           0x12331
#define unicode_CUNEIFORM_SIGN_UR2_TIMES_U2_PLUS_ASH                  0x12332
#define unicode_CUNEIFORM_SIGN_UR2_TIMES_U2_PLUS_BI                   0x12333
#define unicode_CUNEIFORM_SIGN_UR4                                    0x12334
#define unicode_CUNEIFORM_SIGN_URI                                    0x12335
#define unicode_CUNEIFORM_SIGN_URI3                                   0x12336
#define unicode_CUNEIFORM_SIGN_URU                                    0x12337
#define unicode_CUNEIFORM_SIGN_URU_TIMES_A                            0x12338
#define unicode_CUNEIFORM_SIGN_URU_TIMES_ASHGAB                       0x12339
#define unicode_CUNEIFORM_SIGN_URU_TIMES_BAR                          0x1233A
#define unicode_CUNEIFORM_SIGN_URU_TIMES_DUN                          0x1233B
#define unicode_CUNEIFORM_SIGN_URU_TIMES_GA                           0x1233C
#define unicode_CUNEIFORM_SIGN_URU_TIMES_GAL                          0x1233D
#define unicode_CUNEIFORM_SIGN_URU_TIMES_GAN2_TENU                    0x1233E
#define unicode_CUNEIFORM_SIGN_URU_TIMES_GAR                          0x1233F
#define unicode_CUNEIFORM_SIGN_URU_TIMES_GU                           0x12340
#define unicode_CUNEIFORM_SIGN_URU_TIMES_HA                           0x12341
#define unicode_CUNEIFORM_SIGN_URU_TIMES_IGI                          0x12342
#define unicode_CUNEIFORM_SIGN_URU_TIMES_IM                           0x12343
#define unicode_CUNEIFORM_SIGN_URU_TIMES_ISH                          0x12344
#define unicode_CUNEIFORM_SIGN_URU_TIMES_KI                           0x12345
#define unicode_CUNEIFORM_SIGN_URU_TIMES_LUM                          0x12346
#define unicode_CUNEIFORM_SIGN_URU_TIMES_MIN                          0x12347
#define unicode_CUNEIFORM_SIGN_URU_TIMES_PA                           0x12348
#define unicode_CUNEIFORM_SIGN_URU_TIMES_SHE                          0x12349
#define unicode_CUNEIFORM_SIGN_URU_TIMES_SIG4                         0x1234A
#define unicode_CUNEIFORM_SIGN_URU_TIMES_TU                           0x1234B
#define unicode_CUNEIFORM_SIGN_URU_TIMES_U_PLUS_GUD                   0x1234C
#define unicode_CUNEIFORM_SIGN_URU_TIMES_UD                           0x1234D
#define unicode_CUNEIFORM_SIGN_URU_TIMES_URUDA                        0x1234E
#define unicode_CUNEIFORM_SIGN_URUDA                                  0x1234F
#define unicode_CUNEIFORM_SIGN_URUDA_TIMES_U                          0x12350
#define unicode_CUNEIFORM_SIGN_USH                                    0x12351
#define unicode_CUNEIFORM_SIGN_USH_TIMES_A                            0x12352
#define unicode_CUNEIFORM_SIGN_USH_TIMES_KU                           0x12353
#define unicode_CUNEIFORM_SIGN_USH_TIMES_KUR                          0x12354
#define unicode_CUNEIFORM_SIGN_USH_TIMES_TAK4                         0x12355
#define unicode_CUNEIFORM_SIGN_USHX                                   0x12356
#define unicode_CUNEIFORM_SIGN_USH2                                   0x12357
#define unicode_CUNEIFORM_SIGN_USHUMX                                 0x12358
#define unicode_CUNEIFORM_SIGN_UTUKI                                  0x12359
#define unicode_CUNEIFORM_SIGN_UZ3                                    0x1235A
#define unicode_CUNEIFORM_SIGN_UZ3_TIMES_KASKAL                       0x1235B
#define unicode_CUNEIFORM_SIGN_UZU                                    0x1235C
#define unicode_CUNEIFORM_SIGN_ZA                                     0x1235D
#define unicode_CUNEIFORM_SIGN_ZA_TENU                                0x1235E
#define unicode_CUNEIFORM_SIGN_ZA_SQUARED_TIMES_KUR                   0x1235F
#define unicode_CUNEIFORM_SIGN_ZAG                                    0x12360
#define unicode_CUNEIFORM_SIGN_ZAMX                                   0x12361
#define unicode_CUNEIFORM_SIGN_ZE2                                    0x12362
#define unicode_CUNEIFORM_SIGN_ZI                                     0x12363
#define unicode_CUNEIFORM_SIGN_ZI_OVER_ZI                             0x12364
#define unicode_CUNEIFORM_SIGN_ZI3                                    0x12365
#define unicode_CUNEIFORM_SIGN_ZIB                                    0x12366
#define unicode_CUNEIFORM_SIGN_ZIB_KABA_TENU                          0x12367
#define unicode_CUNEIFORM_SIGN_ZIG                                    0x12368
#define unicode_CUNEIFORM_SIGN_ZIZ2                                   0x12369
#define unicode_CUNEIFORM_SIGN_ZU                                     0x1236A
#define unicode_CUNEIFORM_SIGN_ZU5                                    0x1236B
#define unicode_CUNEIFORM_SIGN_ZU5_TIMES_A                            0x1236C
#define unicode_CUNEIFORM_SIGN_ZUBUR                                  0x1236D
#define unicode_CUNEIFORM_SIGN_ZUM                                    0x1236E
#define unicode_CUNEIFORM_SIGN_KAP_ELAMITE                            0x1236F
#define unicode_CUNEIFORM_SIGN_AB_TIMES_NUN                           0x12370
#define unicode_CUNEIFORM_SIGN_AB2_TIMES_A                            0x12371
#define unicode_CUNEIFORM_SIGN_AMAR_TIMES_KUG                         0x12372
#define unicode_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_U2_PLUS_MASH          0x12373
#define unicode_CUNEIFORM_SIGN_DAG3                                   0x12374
#define unicode_CUNEIFORM_SIGN_DISH_PLUS_SHU                          0x12375
#define unicode_CUNEIFORM_SIGN_DUB_TIMES_SHE                          0x12376
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_GUD                         0x12377
#define unicode_CUNEIFORM_SIGN_EZEN_TIMES_SHE                         0x12378
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_AN_PLUS_KAK_PLUS_A           0x12379
#define unicode_CUNEIFORM_SIGN_GA2_TIMES_ASH2                         0x1237A
#define unicode_CUNEIFORM_SIGN_GE22                                   0x1237B
#define unicode_CUNEIFORM_SIGN_GIG                                    0x1237C
#define unicode_CUNEIFORM_SIGN_HUSH                                   0x1237D
#define unicode_CUNEIFORM_SIGN_KA_TIMES_ANSHE                         0x1237E
#define unicode_CUNEIFORM_SIGN_KA_TIMES_ASH3                          0x1237F
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GISH                          0x12380
#define unicode_CUNEIFORM_SIGN_KA_TIMES_GUD                           0x12381
#define unicode_CUNEIFORM_SIGN_KA_TIMES_HI_TIMES_ASH2                 0x12382
#define unicode_CUNEIFORM_SIGN_KA_TIMES_LUM                           0x12383
#define unicode_CUNEIFORM_SIGN_KA_TIMES_PA                            0x12384
#define unicode_CUNEIFORM_SIGN_KA_TIMES_SHUL                          0x12385
#define unicode_CUNEIFORM_SIGN_KA_TIMES_TU                            0x12386
#define unicode_CUNEIFORM_SIGN_KA_TIMES_UR2                           0x12387
#define unicode_CUNEIFORM_SIGN_LAGAB_TIMES_GI                         0x12388
#define unicode_CUNEIFORM_SIGN_LU2_SHESHIG_TIMES_BAD                  0x12389
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_ESH2_PLUS_LAL                0x1238A
#define unicode_CUNEIFORM_SIGN_LU2_TIMES_SHU                          0x1238B
#define unicode_CUNEIFORM_SIGN_MESH                                   0x1238C
#define unicode_CUNEIFORM_SIGN_MUSH3_TIMES_ZA                         0x1238D
#define unicode_CUNEIFORM_SIGN_NA4                                    0x1238E
#define unicode_CUNEIFORM_SIGN_NIN                                    0x1238F
#define unicode_CUNEIFORM_SIGN_NIN9                                   0x12390
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_BAL                       0x12391
#define unicode_CUNEIFORM_SIGN_NINDA2_TIMES_GI                        0x12392
#define unicode_CUNEIFORM_SIGN_NU11_ROTATED_NINETY_DEGREES            0x12393
#define unicode_CUNEIFORM_SIGN_PESH2_ASTERISK                         0x12394
#define unicode_CUNEIFORM_SIGN_PIR2                                   0x12395
#define unicode_CUNEIFORM_SIGN_SAG_TIMES_IGI_GUNU                     0x12396
#define unicode_CUNEIFORM_SIGN_TI2                                    0x12397
#define unicode_CUNEIFORM_SIGN_UM_TIMES_ME                            0x12398
#define unicode_CUNEIFORM_NUMERIC_SIGN_TWO_ASH                        0x12400
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_ASH                      0x12401
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_ASH                       0x12402
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_ASH                       0x12403
#define unicode_CUNEIFORM_NUMERIC_SIGN_SIX_ASH                        0x12404
#define unicode_CUNEIFORM_NUMERIC_SIGN_SEVEN_ASH                      0x12405
#define unicode_CUNEIFORM_NUMERIC_SIGN_EIGHT_ASH                      0x12406
#define unicode_CUNEIFORM_NUMERIC_SIGN_NINE_ASH                       0x12407
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_DISH                     0x12408
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_DISH                      0x12409
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_DISH                      0x1240A
#define unicode_CUNEIFORM_NUMERIC_SIGN_SIX_DISH                       0x1240B
#define unicode_CUNEIFORM_NUMERIC_SIGN_SEVEN_DISH                     0x1240C
#define unicode_CUNEIFORM_NUMERIC_SIGN_EIGHT_DISH                     0x1240D
#define unicode_CUNEIFORM_NUMERIC_SIGN_NINE_DISH                      0x1240E
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_U                         0x1240F
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_U                         0x12410
#define unicode_CUNEIFORM_NUMERIC_SIGN_SIX_U                          0x12411
#define unicode_CUNEIFORM_NUMERIC_SIGN_SEVEN_U                        0x12412
#define unicode_CUNEIFORM_NUMERIC_SIGN_EIGHT_U                        0x12413
#define unicode_CUNEIFORM_NUMERIC_SIGN_NINE_U                         0x12414
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_GESH2                      0x12415
#define unicode_CUNEIFORM_NUMERIC_SIGN_TWO_GESH2                      0x12416
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_GESH2                    0x12417
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_GESH2                     0x12418
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_GESH2                     0x12419
#define unicode_CUNEIFORM_NUMERIC_SIGN_SIX_GESH2                      0x1241A
#define unicode_CUNEIFORM_NUMERIC_SIGN_SEVEN_GESH2                    0x1241B
#define unicode_CUNEIFORM_NUMERIC_SIGN_EIGHT_GESH2                    0x1241C
#define unicode_CUNEIFORM_NUMERIC_SIGN_NINE_GESH2                     0x1241D
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_GESHU                      0x1241E
#define unicode_CUNEIFORM_NUMERIC_SIGN_TWO_GESHU                      0x1241F
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_GESHU                    0x12420
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_GESHU                     0x12421
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_GESHU                     0x12422
#define unicode_CUNEIFORM_NUMERIC_SIGN_TWO_SHAR2                      0x12423
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_SHAR2                    0x12424
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_SHAR2_VARIANT_FORM       0x12425
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_SHAR2                     0x12426
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_SHAR2                     0x12427
#define unicode_CUNEIFORM_NUMERIC_SIGN_SIX_SHAR2                      0x12428
#define unicode_CUNEIFORM_NUMERIC_SIGN_SEVEN_SHAR2                    0x12429
#define unicode_CUNEIFORM_NUMERIC_SIGN_EIGHT_SHAR2                    0x1242A
#define unicode_CUNEIFORM_NUMERIC_SIGN_NINE_SHAR2                     0x1242B
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_SHARU                      0x1242C
#define unicode_CUNEIFORM_NUMERIC_SIGN_TWO_SHARU                      0x1242D
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_SHARU                    0x1242E
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_SHARU_VARIANT_FORM       0x1242F
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_SHARU                     0x12430
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_SHARU                     0x12431
#define unicode_CUNEIFORM_NUMERIC_SIGN_SHAR2_TIMES_GAL_PLUS_DISH      0x12432
#define unicode_CUNEIFORM_NUMERIC_SIGN_SHAR2_TIMES_GAL_PLUS_MIN       0x12433
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_BURU                       0x12434
#define unicode_CUNEIFORM_NUMERIC_SIGN_TWO_BURU                       0x12435
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_BURU                     0x12436
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_BURU_VARIANT_FORM        0x12437
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_BURU                      0x12438
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_BURU                      0x12439
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_VARIANT_FORM_ESH16       0x1243A
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_VARIANT_FORM_ESH21       0x1243B
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU        0x1243C
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU4       0x1243D
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU_A      0x1243E
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU_B      0x1243F
#define unicode_CUNEIFORM_NUMERIC_SIGN_SIX_VARIANT_FORM_ASH9          0x12440
#define unicode_CUNEIFORM_NUMERIC_SIGN_SEVEN_VARIANT_FORM_IMIN3       0x12441
#define unicode_CUNEIFORM_NUMERIC_SIGN_SEVEN_VARIANT_FORM_IMIN_A      0x12442
#define unicode_CUNEIFORM_NUMERIC_SIGN_SEVEN_VARIANT_FORM_IMIN_B      0x12443
#define unicode_CUNEIFORM_NUMERIC_SIGN_EIGHT_VARIANT_FORM_USSU        0x12444
#define unicode_CUNEIFORM_NUMERIC_SIGN_EIGHT_VARIANT_FORM_USSU3       0x12445
#define unicode_CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU       0x12446
#define unicode_CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU3      0x12447
#define unicode_CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU4      0x12448
#define unicode_CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU_A     0x12449
#define unicode_CUNEIFORM_NUMERIC_SIGN_TWO_ASH_TENU                   0x1244A
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_ASH_TENU                 0x1244B
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_ASH_TENU                  0x1244C
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_ASH_TENU                  0x1244D
#define unicode_CUNEIFORM_NUMERIC_SIGN_SIX_ASH_TENU                   0x1244E
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_BAN2                       0x1244F
#define unicode_CUNEIFORM_NUMERIC_SIGN_TWO_BAN2                       0x12450
#define unicode_CUNEIFORM_NUMERIC_SIGN_THREE_BAN2                     0x12451
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_BAN2                      0x12452
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_BAN2_VARIANT_FORM         0x12453
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_BAN2                      0x12454
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_BAN2_VARIANT_FORM         0x12455
#define unicode_CUNEIFORM_NUMERIC_SIGN_NIGIDAMIN                      0x12456
#define unicode_CUNEIFORM_NUMERIC_SIGN_NIGIDAESH                      0x12457
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_ESHE3                      0x12458
#define unicode_CUNEIFORM_NUMERIC_SIGN_TWO_ESHE3                      0x12459
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_THIRD_DISH                 0x1245A
#define unicode_CUNEIFORM_NUMERIC_SIGN_TWO_THIRDS_DISH                0x1245B
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_SIXTHS_DISH               0x1245C
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_THIRD_VARIANT_FORM_A       0x1245D
#define unicode_CUNEIFORM_NUMERIC_SIGN_TWO_THIRDS_VARIANT_FORM_A      0x1245E
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_EIGHTH_ASH                 0x1245F
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_QUARTER_ASH                0x12460
#define unicode_CUNEIFORM_NUMERIC_SIGN_OLD_ASSYRIAN_ONE_SIXTH         0x12461
#define unicode_CUNEIFORM_NUMERIC_SIGN_OLD_ASSYRIAN_ONE_QUARTER       0x12462
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_QUARTER_GUR                0x12463
#define unicode_CUNEIFORM_NUMERIC_SIGN_ONE_HALF_GUR                   0x12464
#define unicode_CUNEIFORM_NUMERIC_SIGN_ELAMITE_ONE_THIRD              0x12465
#define unicode_CUNEIFORM_NUMERIC_SIGN_ELAMITE_TWO_THIRDS             0x12466
#define unicode_CUNEIFORM_NUMERIC_SIGN_ELAMITE_FORTY                  0x12467
#define unicode_CUNEIFORM_NUMERIC_SIGN_ELAMITE_FIFTY                  0x12468
#define unicode_CUNEIFORM_NUMERIC_SIGN_FOUR_U_VARIANT_FORM            0x12469
#define unicode_CUNEIFORM_NUMERIC_SIGN_FIVE_U_VARIANT_FORM            0x1246A
#define unicode_CUNEIFORM_NUMERIC_SIGN_SIX_U_VARIANT_FORM             0x1246B
#define unicode_CUNEIFORM_NUMERIC_SIGN_SEVEN_U_VARIANT_FORM           0x1246C
#define unicode_CUNEIFORM_NUMERIC_SIGN_EIGHT_U_VARIANT_FORM           0x1246D
#define unicode_CUNEIFORM_NUMERIC_SIGN_NINE_U_VARIANT_FORM            0x1246E
#define unicode_CUNEIFORM_PUNCTUATION_SIGN_OLD_ASSYRIAN_WORD_DIVIDER  0x12470
#define unicode_CUNEIFORM_PUNCTUATION_SIGN_VERTICAL_COLON             0x12471
#define unicode_CUNEIFORM_PUNCTUATION_SIGN_DIAGONAL_COLON             0x12472
#define unicode_CUNEIFORM_PUNCTUATION_SIGN_DIAGONAL_TRICOLON          0x12473
#define unicode_CUNEIFORM_PUNCTUATION_SIGN_DIAGONAL_QUADCOLON         0x12474
#define unicode_EGYPTIAN_HIEROGLYPH_A001                              0x13000
#define unicode_EGYPTIAN_HIEROGLYPH_A002                              0x13001
#define unicode_EGYPTIAN_HIEROGLYPH_A003                              0x13002
#define unicode_EGYPTIAN_HIEROGLYPH_A004                              0x13003
#define unicode_EGYPTIAN_HIEROGLYPH_A005                              0x13004
#define unicode_EGYPTIAN_HIEROGLYPH_A005A                             0x13005
#define unicode_EGYPTIAN_HIEROGLYPH_A006                              0x13006
#define unicode_EGYPTIAN_HIEROGLYPH_A006A                             0x13007
#define unicode_EGYPTIAN_HIEROGLYPH_A006B                             0x13008
#define unicode_EGYPTIAN_HIEROGLYPH_A007                              0x13009
#define unicode_EGYPTIAN_HIEROGLYPH_A008                              0x1300A
#define unicode_EGYPTIAN_HIEROGLYPH_A009                              0x1300B
#define unicode_EGYPTIAN_HIEROGLYPH_A010                              0x1300C
#define unicode_EGYPTIAN_HIEROGLYPH_A011                              0x1300D
#define unicode_EGYPTIAN_HIEROGLYPH_A012                              0x1300E
#define unicode_EGYPTIAN_HIEROGLYPH_A013                              0x1300F
#define unicode_EGYPTIAN_HIEROGLYPH_A014                              0x13010
#define unicode_EGYPTIAN_HIEROGLYPH_A014A                             0x13011
#define unicode_EGYPTIAN_HIEROGLYPH_A015                              0x13012
#define unicode_EGYPTIAN_HIEROGLYPH_A016                              0x13013
#define unicode_EGYPTIAN_HIEROGLYPH_A017                              0x13014
#define unicode_EGYPTIAN_HIEROGLYPH_A017A                             0x13015
#define unicode_EGYPTIAN_HIEROGLYPH_A018                              0x13016
#define unicode_EGYPTIAN_HIEROGLYPH_A019                              0x13017
#define unicode_EGYPTIAN_HIEROGLYPH_A020                              0x13018
#define unicode_EGYPTIAN_HIEROGLYPH_A021                              0x13019
#define unicode_EGYPTIAN_HIEROGLYPH_A022                              0x1301A
#define unicode_EGYPTIAN_HIEROGLYPH_A023                              0x1301B
#define unicode_EGYPTIAN_HIEROGLYPH_A024                              0x1301C
#define unicode_EGYPTIAN_HIEROGLYPH_A025                              0x1301D
#define unicode_EGYPTIAN_HIEROGLYPH_A026                              0x1301E
#define unicode_EGYPTIAN_HIEROGLYPH_A027                              0x1301F
#define unicode_EGYPTIAN_HIEROGLYPH_A028                              0x13020
#define unicode_EGYPTIAN_HIEROGLYPH_A029                              0x13021
#define unicode_EGYPTIAN_HIEROGLYPH_A030                              0x13022
#define unicode_EGYPTIAN_HIEROGLYPH_A031                              0x13023
#define unicode_EGYPTIAN_HIEROGLYPH_A032                              0x13024
#define unicode_EGYPTIAN_HIEROGLYPH_A032A                             0x13025
#define unicode_EGYPTIAN_HIEROGLYPH_A033                              0x13026
#define unicode_EGYPTIAN_HIEROGLYPH_A034                              0x13027
#define unicode_EGYPTIAN_HIEROGLYPH_A035                              0x13028
#define unicode_EGYPTIAN_HIEROGLYPH_A036                              0x13029
#define unicode_EGYPTIAN_HIEROGLYPH_A037                              0x1302A
#define unicode_EGYPTIAN_HIEROGLYPH_A038                              0x1302B
#define unicode_EGYPTIAN_HIEROGLYPH_A039                              0x1302C
#define unicode_EGYPTIAN_HIEROGLYPH_A040                              0x1302D
#define unicode_EGYPTIAN_HIEROGLYPH_A040A                             0x1302E
#define unicode_EGYPTIAN_HIEROGLYPH_A041                              0x1302F
#define unicode_EGYPTIAN_HIEROGLYPH_A042                              0x13030
#define unicode_EGYPTIAN_HIEROGLYPH_A042A                             0x13031
#define unicode_EGYPTIAN_HIEROGLYPH_A043                              0x13032
#define unicode_EGYPTIAN_HIEROGLYPH_A043A                             0x13033
#define unicode_EGYPTIAN_HIEROGLYPH_A044                              0x13034
#define unicode_EGYPTIAN_HIEROGLYPH_A045                              0x13035
#define unicode_EGYPTIAN_HIEROGLYPH_A045A                             0x13036
#define unicode_EGYPTIAN_HIEROGLYPH_A046                              0x13037
#define unicode_EGYPTIAN_HIEROGLYPH_A047                              0x13038
#define unicode_EGYPTIAN_HIEROGLYPH_A048                              0x13039
#define unicode_EGYPTIAN_HIEROGLYPH_A049                              0x1303A
#define unicode_EGYPTIAN_HIEROGLYPH_A050                              0x1303B
#define unicode_EGYPTIAN_HIEROGLYPH_A051                              0x1303C
#define unicode_EGYPTIAN_HIEROGLYPH_A052                              0x1303D
#define unicode_EGYPTIAN_HIEROGLYPH_A053                              0x1303E
#define unicode_EGYPTIAN_HIEROGLYPH_A054                              0x1303F
#define unicode_EGYPTIAN_HIEROGLYPH_A055                              0x13040
#define unicode_EGYPTIAN_HIEROGLYPH_A056                              0x13041
#define unicode_EGYPTIAN_HIEROGLYPH_A057                              0x13042
#define unicode_EGYPTIAN_HIEROGLYPH_A058                              0x13043
#define unicode_EGYPTIAN_HIEROGLYPH_A059                              0x13044
#define unicode_EGYPTIAN_HIEROGLYPH_A060                              0x13045
#define unicode_EGYPTIAN_HIEROGLYPH_A061                              0x13046
#define unicode_EGYPTIAN_HIEROGLYPH_A062                              0x13047
#define unicode_EGYPTIAN_HIEROGLYPH_A063                              0x13048
#define unicode_EGYPTIAN_HIEROGLYPH_A064                              0x13049
#define unicode_EGYPTIAN_HIEROGLYPH_A065                              0x1304A
#define unicode_EGYPTIAN_HIEROGLYPH_A066                              0x1304B
#define unicode_EGYPTIAN_HIEROGLYPH_A067                              0x1304C
#define unicode_EGYPTIAN_HIEROGLYPH_A068                              0x1304D
#define unicode_EGYPTIAN_HIEROGLYPH_A069                              0x1304E
#define unicode_EGYPTIAN_HIEROGLYPH_A070                              0x1304F
#define unicode_EGYPTIAN_HIEROGLYPH_B001                              0x13050
#define unicode_EGYPTIAN_HIEROGLYPH_B002                              0x13051
#define unicode_EGYPTIAN_HIEROGLYPH_B003                              0x13052
#define unicode_EGYPTIAN_HIEROGLYPH_B004                              0x13053
#define unicode_EGYPTIAN_HIEROGLYPH_B005                              0x13054
#define unicode_EGYPTIAN_HIEROGLYPH_B005A                             0x13055
#define unicode_EGYPTIAN_HIEROGLYPH_B006                              0x13056
#define unicode_EGYPTIAN_HIEROGLYPH_B007                              0x13057
#define unicode_EGYPTIAN_HIEROGLYPH_B008                              0x13058
#define unicode_EGYPTIAN_HIEROGLYPH_B009                              0x13059
#define unicode_EGYPTIAN_HIEROGLYPH_C001                              0x1305A
#define unicode_EGYPTIAN_HIEROGLYPH_C002                              0x1305B
#define unicode_EGYPTIAN_HIEROGLYPH_C002A                             0x1305C
#define unicode_EGYPTIAN_HIEROGLYPH_C002B                             0x1305D
#define unicode_EGYPTIAN_HIEROGLYPH_C002C                             0x1305E
#define unicode_EGYPTIAN_HIEROGLYPH_C003                              0x1305F
#define unicode_EGYPTIAN_HIEROGLYPH_C004                              0x13060
#define unicode_EGYPTIAN_HIEROGLYPH_C005                              0x13061
#define unicode_EGYPTIAN_HIEROGLYPH_C006                              0x13062
#define unicode_EGYPTIAN_HIEROGLYPH_C007                              0x13063
#define unicode_EGYPTIAN_HIEROGLYPH_C008                              0x13064
#define unicode_EGYPTIAN_HIEROGLYPH_C009                              0x13065
#define unicode_EGYPTIAN_HIEROGLYPH_C010                              0x13066
#define unicode_EGYPTIAN_HIEROGLYPH_C010A                             0x13067
#define unicode_EGYPTIAN_HIEROGLYPH_C011                              0x13068
#define unicode_EGYPTIAN_HIEROGLYPH_C012                              0x13069
#define unicode_EGYPTIAN_HIEROGLYPH_C013                              0x1306A
#define unicode_EGYPTIAN_HIEROGLYPH_C014                              0x1306B
#define unicode_EGYPTIAN_HIEROGLYPH_C015                              0x1306C
#define unicode_EGYPTIAN_HIEROGLYPH_C016                              0x1306D
#define unicode_EGYPTIAN_HIEROGLYPH_C017                              0x1306E
#define unicode_EGYPTIAN_HIEROGLYPH_C018                              0x1306F
#define unicode_EGYPTIAN_HIEROGLYPH_C019                              0x13070
#define unicode_EGYPTIAN_HIEROGLYPH_C020                              0x13071
#define unicode_EGYPTIAN_HIEROGLYPH_C021                              0x13072
#define unicode_EGYPTIAN_HIEROGLYPH_C022                              0x13073
#define unicode_EGYPTIAN_HIEROGLYPH_C023                              0x13074
#define unicode_EGYPTIAN_HIEROGLYPH_C024                              0x13075
#define unicode_EGYPTIAN_HIEROGLYPH_D001                              0x13076
#define unicode_EGYPTIAN_HIEROGLYPH_D002                              0x13077
#define unicode_EGYPTIAN_HIEROGLYPH_D003                              0x13078
#define unicode_EGYPTIAN_HIEROGLYPH_D004                              0x13079
#define unicode_EGYPTIAN_HIEROGLYPH_D005                              0x1307A
#define unicode_EGYPTIAN_HIEROGLYPH_D006                              0x1307B
#define unicode_EGYPTIAN_HIEROGLYPH_D007                              0x1307C
#define unicode_EGYPTIAN_HIEROGLYPH_D008                              0x1307D
#define unicode_EGYPTIAN_HIEROGLYPH_D008A                             0x1307E
#define unicode_EGYPTIAN_HIEROGLYPH_D009                              0x1307F
#define unicode_EGYPTIAN_HIEROGLYPH_D010                              0x13080
#define unicode_EGYPTIAN_HIEROGLYPH_D011                              0x13081
#define unicode_EGYPTIAN_HIEROGLYPH_D012                              0x13082
#define unicode_EGYPTIAN_HIEROGLYPH_D013                              0x13083
#define unicode_EGYPTIAN_HIEROGLYPH_D014                              0x13084
#define unicode_EGYPTIAN_HIEROGLYPH_D015                              0x13085
#define unicode_EGYPTIAN_HIEROGLYPH_D016                              0x13086
#define unicode_EGYPTIAN_HIEROGLYPH_D017                              0x13087
#define unicode_EGYPTIAN_HIEROGLYPH_D018                              0x13088
#define unicode_EGYPTIAN_HIEROGLYPH_D019                              0x13089
#define unicode_EGYPTIAN_HIEROGLYPH_D020                              0x1308A
#define unicode_EGYPTIAN_HIEROGLYPH_D021                              0x1308B
#define unicode_EGYPTIAN_HIEROGLYPH_D022                              0x1308C
#define unicode_EGYPTIAN_HIEROGLYPH_D023                              0x1308D
#define unicode_EGYPTIAN_HIEROGLYPH_D024                              0x1308E
#define unicode_EGYPTIAN_HIEROGLYPH_D025                              0x1308F
#define unicode_EGYPTIAN_HIEROGLYPH_D026                              0x13090
#define unicode_EGYPTIAN_HIEROGLYPH_D027                              0x13091
#define unicode_EGYPTIAN_HIEROGLYPH_D027A                             0x13092
#define unicode_EGYPTIAN_HIEROGLYPH_D028                              0x13093
#define unicode_EGYPTIAN_HIEROGLYPH_D029                              0x13094
#define unicode_EGYPTIAN_HIEROGLYPH_D030                              0x13095
#define unicode_EGYPTIAN_HIEROGLYPH_D031                              0x13096
#define unicode_EGYPTIAN_HIEROGLYPH_D031A                             0x13097
#define unicode_EGYPTIAN_HIEROGLYPH_D032                              0x13098
#define unicode_EGYPTIAN_HIEROGLYPH_D033                              0x13099
#define unicode_EGYPTIAN_HIEROGLYPH_D034                              0x1309A
#define unicode_EGYPTIAN_HIEROGLYPH_D034A                             0x1309B
#define unicode_EGYPTIAN_HIEROGLYPH_D035                              0x1309C
#define unicode_EGYPTIAN_HIEROGLYPH_D036                              0x1309D
#define unicode_EGYPTIAN_HIEROGLYPH_D037                              0x1309E
#define unicode_EGYPTIAN_HIEROGLYPH_D038                              0x1309F
#define unicode_EGYPTIAN_HIEROGLYPH_D039                              0x130A0
#define unicode_EGYPTIAN_HIEROGLYPH_D040                              0x130A1
#define unicode_EGYPTIAN_HIEROGLYPH_D041                              0x130A2
#define unicode_EGYPTIAN_HIEROGLYPH_D042                              0x130A3
#define unicode_EGYPTIAN_HIEROGLYPH_D043                              0x130A4
#define unicode_EGYPTIAN_HIEROGLYPH_D044                              0x130A5
#define unicode_EGYPTIAN_HIEROGLYPH_D045                              0x130A6
#define unicode_EGYPTIAN_HIEROGLYPH_D046                              0x130A7
#define unicode_EGYPTIAN_HIEROGLYPH_D046A                             0x130A8
#define unicode_EGYPTIAN_HIEROGLYPH_D047                              0x130A9
#define unicode_EGYPTIAN_HIEROGLYPH_D048                              0x130AA
#define unicode_EGYPTIAN_HIEROGLYPH_D048A                             0x130AB
#define unicode_EGYPTIAN_HIEROGLYPH_D049                              0x130AC
#define unicode_EGYPTIAN_HIEROGLYPH_D050                              0x130AD
#define unicode_EGYPTIAN_HIEROGLYPH_D050A                             0x130AE
#define unicode_EGYPTIAN_HIEROGLYPH_D050B                             0x130AF
#define unicode_EGYPTIAN_HIEROGLYPH_D050C                             0x130B0
#define unicode_EGYPTIAN_HIEROGLYPH_D050D                             0x130B1
#define unicode_EGYPTIAN_HIEROGLYPH_D050E                             0x130B2
#define unicode_EGYPTIAN_HIEROGLYPH_D050F                             0x130B3
#define unicode_EGYPTIAN_HIEROGLYPH_D050G                             0x130B4
#define unicode_EGYPTIAN_HIEROGLYPH_D050H                             0x130B5
#define unicode_EGYPTIAN_HIEROGLYPH_D050I                             0x130B6
#define unicode_EGYPTIAN_HIEROGLYPH_D051                              0x130B7
#define unicode_EGYPTIAN_HIEROGLYPH_D052                              0x130B8
#define unicode_EGYPTIAN_HIEROGLYPH_D052A                             0x130B9
#define unicode_EGYPTIAN_HIEROGLYPH_D053                              0x130BA
#define unicode_EGYPTIAN_HIEROGLYPH_D054                              0x130BB
#define unicode_EGYPTIAN_HIEROGLYPH_D054A                             0x130BC
#define unicode_EGYPTIAN_HIEROGLYPH_D055                              0x130BD
#define unicode_EGYPTIAN_HIEROGLYPH_D056                              0x130BE
#define unicode_EGYPTIAN_HIEROGLYPH_D057                              0x130BF
#define unicode_EGYPTIAN_HIEROGLYPH_D058                              0x130C0
#define unicode_EGYPTIAN_HIEROGLYPH_D059                              0x130C1
#define unicode_EGYPTIAN_HIEROGLYPH_D060                              0x130C2
#define unicode_EGYPTIAN_HIEROGLYPH_D061                              0x130C3
#define unicode_EGYPTIAN_HIEROGLYPH_D062                              0x130C4
#define unicode_EGYPTIAN_HIEROGLYPH_D063                              0x130C5
#define unicode_EGYPTIAN_HIEROGLYPH_D064                              0x130C6
#define unicode_EGYPTIAN_HIEROGLYPH_D065                              0x130C7
#define unicode_EGYPTIAN_HIEROGLYPH_D066                              0x130C8
#define unicode_EGYPTIAN_HIEROGLYPH_D067                              0x130C9
#define unicode_EGYPTIAN_HIEROGLYPH_D067A                             0x130CA
#define unicode_EGYPTIAN_HIEROGLYPH_D067B                             0x130CB
#define unicode_EGYPTIAN_HIEROGLYPH_D067C                             0x130CC
#define unicode_EGYPTIAN_HIEROGLYPH_D067D                             0x130CD
#define unicode_EGYPTIAN_HIEROGLYPH_D067E                             0x130CE
#define unicode_EGYPTIAN_HIEROGLYPH_D067F                             0x130CF
#define unicode_EGYPTIAN_HIEROGLYPH_D067G                             0x130D0
#define unicode_EGYPTIAN_HIEROGLYPH_D067H                             0x130D1
#define unicode_EGYPTIAN_HIEROGLYPH_E001                              0x130D2
#define unicode_EGYPTIAN_HIEROGLYPH_E002                              0x130D3
#define unicode_EGYPTIAN_HIEROGLYPH_E003                              0x130D4
#define unicode_EGYPTIAN_HIEROGLYPH_E004                              0x130D5
#define unicode_EGYPTIAN_HIEROGLYPH_E005                              0x130D6
#define unicode_EGYPTIAN_HIEROGLYPH_E006                              0x130D7
#define unicode_EGYPTIAN_HIEROGLYPH_E007                              0x130D8
#define unicode_EGYPTIAN_HIEROGLYPH_E008                              0x130D9
#define unicode_EGYPTIAN_HIEROGLYPH_E008A                             0x130DA
#define unicode_EGYPTIAN_HIEROGLYPH_E009                              0x130DB
#define unicode_EGYPTIAN_HIEROGLYPH_E009A                             0x130DC
#define unicode_EGYPTIAN_HIEROGLYPH_E010                              0x130DD
#define unicode_EGYPTIAN_HIEROGLYPH_E011                              0x130DE
#define unicode_EGYPTIAN_HIEROGLYPH_E012                              0x130DF
#define unicode_EGYPTIAN_HIEROGLYPH_E013                              0x130E0
#define unicode_EGYPTIAN_HIEROGLYPH_E014                              0x130E1
#define unicode_EGYPTIAN_HIEROGLYPH_E015                              0x130E2
#define unicode_EGYPTIAN_HIEROGLYPH_E016                              0x130E3
#define unicode_EGYPTIAN_HIEROGLYPH_E016A                             0x130E4
#define unicode_EGYPTIAN_HIEROGLYPH_E017                              0x130E5
#define unicode_EGYPTIAN_HIEROGLYPH_E017A                             0x130E6
#define unicode_EGYPTIAN_HIEROGLYPH_E018                              0x130E7
#define unicode_EGYPTIAN_HIEROGLYPH_E019                              0x130E8
#define unicode_EGYPTIAN_HIEROGLYPH_E020                              0x130E9
#define unicode_EGYPTIAN_HIEROGLYPH_E020A                             0x130EA
#define unicode_EGYPTIAN_HIEROGLYPH_E021                              0x130EB
#define unicode_EGYPTIAN_HIEROGLYPH_E022                              0x130EC
#define unicode_EGYPTIAN_HIEROGLYPH_E023                              0x130ED
#define unicode_EGYPTIAN_HIEROGLYPH_E024                              0x130EE
#define unicode_EGYPTIAN_HIEROGLYPH_E025                              0x130EF
#define unicode_EGYPTIAN_HIEROGLYPH_E026                              0x130F0
#define unicode_EGYPTIAN_HIEROGLYPH_E027                              0x130F1
#define unicode_EGYPTIAN_HIEROGLYPH_E028                              0x130F2
#define unicode_EGYPTIAN_HIEROGLYPH_E028A                             0x130F3
#define unicode_EGYPTIAN_HIEROGLYPH_E029                              0x130F4
#define unicode_EGYPTIAN_HIEROGLYPH_E030                              0x130F5
#define unicode_EGYPTIAN_HIEROGLYPH_E031                              0x130F6
#define unicode_EGYPTIAN_HIEROGLYPH_E032                              0x130F7
#define unicode_EGYPTIAN_HIEROGLYPH_E033                              0x130F8
#define unicode_EGYPTIAN_HIEROGLYPH_E034                              0x130F9
#define unicode_EGYPTIAN_HIEROGLYPH_E034A                             0x130FA
#define unicode_EGYPTIAN_HIEROGLYPH_E036                              0x130FB
#define unicode_EGYPTIAN_HIEROGLYPH_E037                              0x130FC
#define unicode_EGYPTIAN_HIEROGLYPH_E038                              0x130FD
#define unicode_EGYPTIAN_HIEROGLYPH_F001                              0x130FE
#define unicode_EGYPTIAN_HIEROGLYPH_F001A                             0x130FF
#define unicode_EGYPTIAN_HIEROGLYPH_F002                              0x13100
#define unicode_EGYPTIAN_HIEROGLYPH_F003                              0x13101
#define unicode_EGYPTIAN_HIEROGLYPH_F004                              0x13102
#define unicode_EGYPTIAN_HIEROGLYPH_F005                              0x13103
#define unicode_EGYPTIAN_HIEROGLYPH_F006                              0x13104
#define unicode_EGYPTIAN_HIEROGLYPH_F007                              0x13105
#define unicode_EGYPTIAN_HIEROGLYPH_F008                              0x13106
#define unicode_EGYPTIAN_HIEROGLYPH_F009                              0x13107
#define unicode_EGYPTIAN_HIEROGLYPH_F010                              0x13108
#define unicode_EGYPTIAN_HIEROGLYPH_F011                              0x13109
#define unicode_EGYPTIAN_HIEROGLYPH_F012                              0x1310A
#define unicode_EGYPTIAN_HIEROGLYPH_F013                              0x1310B
#define unicode_EGYPTIAN_HIEROGLYPH_F013A                             0x1310C
#define unicode_EGYPTIAN_HIEROGLYPH_F014                              0x1310D
#define unicode_EGYPTIAN_HIEROGLYPH_F015                              0x1310E
#define unicode_EGYPTIAN_HIEROGLYPH_F016                              0x1310F
#define unicode_EGYPTIAN_HIEROGLYPH_F017                              0x13110
#define unicode_EGYPTIAN_HIEROGLYPH_F018                              0x13111
#define unicode_EGYPTIAN_HIEROGLYPH_F019                              0x13112
#define unicode_EGYPTIAN_HIEROGLYPH_F020                              0x13113
#define unicode_EGYPTIAN_HIEROGLYPH_F021                              0x13114
#define unicode_EGYPTIAN_HIEROGLYPH_F021A                             0x13115
#define unicode_EGYPTIAN_HIEROGLYPH_F022                              0x13116
#define unicode_EGYPTIAN_HIEROGLYPH_F023                              0x13117
#define unicode_EGYPTIAN_HIEROGLYPH_F024                              0x13118
#define unicode_EGYPTIAN_HIEROGLYPH_F025                              0x13119
#define unicode_EGYPTIAN_HIEROGLYPH_F026                              0x1311A
#define unicode_EGYPTIAN_HIEROGLYPH_F027                              0x1311B
#define unicode_EGYPTIAN_HIEROGLYPH_F028                              0x1311C
#define unicode_EGYPTIAN_HIEROGLYPH_F029                              0x1311D
#define unicode_EGYPTIAN_HIEROGLYPH_F030                              0x1311E
#define unicode_EGYPTIAN_HIEROGLYPH_F031                              0x1311F
#define unicode_EGYPTIAN_HIEROGLYPH_F031A                             0x13120
#define unicode_EGYPTIAN_HIEROGLYPH_F032                              0x13121
#define unicode_EGYPTIAN_HIEROGLYPH_F033                              0x13122
#define unicode_EGYPTIAN_HIEROGLYPH_F034                              0x13123
#define unicode_EGYPTIAN_HIEROGLYPH_F035                              0x13124
#define unicode_EGYPTIAN_HIEROGLYPH_F036                              0x13125
#define unicode_EGYPTIAN_HIEROGLYPH_F037                              0x13126
#define unicode_EGYPTIAN_HIEROGLYPH_F037A                             0x13127
#define unicode_EGYPTIAN_HIEROGLYPH_F038                              0x13128
#define unicode_EGYPTIAN_HIEROGLYPH_F038A                             0x13129
#define unicode_EGYPTIAN_HIEROGLYPH_F039                              0x1312A
#define unicode_EGYPTIAN_HIEROGLYPH_F040                              0x1312B
#define unicode_EGYPTIAN_HIEROGLYPH_F041                              0x1312C
#define unicode_EGYPTIAN_HIEROGLYPH_F042                              0x1312D
#define unicode_EGYPTIAN_HIEROGLYPH_F043                              0x1312E
#define unicode_EGYPTIAN_HIEROGLYPH_F044                              0x1312F
#define unicode_EGYPTIAN_HIEROGLYPH_F045                              0x13130
#define unicode_EGYPTIAN_HIEROGLYPH_F045A                             0x13131
#define unicode_EGYPTIAN_HIEROGLYPH_F046                              0x13132
#define unicode_EGYPTIAN_HIEROGLYPH_F046A                             0x13133
#define unicode_EGYPTIAN_HIEROGLYPH_F047                              0x13134
#define unicode_EGYPTIAN_HIEROGLYPH_F047A                             0x13135
#define unicode_EGYPTIAN_HIEROGLYPH_F048                              0x13136
#define unicode_EGYPTIAN_HIEROGLYPH_F049                              0x13137
#define unicode_EGYPTIAN_HIEROGLYPH_F050                              0x13138
#define unicode_EGYPTIAN_HIEROGLYPH_F051                              0x13139
#define unicode_EGYPTIAN_HIEROGLYPH_F051A                             0x1313A
#define unicode_EGYPTIAN_HIEROGLYPH_F051B                             0x1313B
#define unicode_EGYPTIAN_HIEROGLYPH_F051C                             0x1313C
#define unicode_EGYPTIAN_HIEROGLYPH_F052                              0x1313D
#define unicode_EGYPTIAN_HIEROGLYPH_F053                              0x1313E
#define unicode_EGYPTIAN_HIEROGLYPH_G001                              0x1313F
#define unicode_EGYPTIAN_HIEROGLYPH_G002                              0x13140
#define unicode_EGYPTIAN_HIEROGLYPH_G003                              0x13141
#define unicode_EGYPTIAN_HIEROGLYPH_G004                              0x13142
#define unicode_EGYPTIAN_HIEROGLYPH_G005                              0x13143
#define unicode_EGYPTIAN_HIEROGLYPH_G006                              0x13144
#define unicode_EGYPTIAN_HIEROGLYPH_G006A                             0x13145
#define unicode_EGYPTIAN_HIEROGLYPH_G007                              0x13146
#define unicode_EGYPTIAN_HIEROGLYPH_G007A                             0x13147
#define unicode_EGYPTIAN_HIEROGLYPH_G007B                             0x13148
#define unicode_EGYPTIAN_HIEROGLYPH_G008                              0x13149
#define unicode_EGYPTIAN_HIEROGLYPH_G009                              0x1314A
#define unicode_EGYPTIAN_HIEROGLYPH_G010                              0x1314B
#define unicode_EGYPTIAN_HIEROGLYPH_G011                              0x1314C
#define unicode_EGYPTIAN_HIEROGLYPH_G011A                             0x1314D
#define unicode_EGYPTIAN_HIEROGLYPH_G012                              0x1314E
#define unicode_EGYPTIAN_HIEROGLYPH_G013                              0x1314F
#define unicode_EGYPTIAN_HIEROGLYPH_G014                              0x13150
#define unicode_EGYPTIAN_HIEROGLYPH_G015                              0x13151
#define unicode_EGYPTIAN_HIEROGLYPH_G016                              0x13152
#define unicode_EGYPTIAN_HIEROGLYPH_G017                              0x13153
#define unicode_EGYPTIAN_HIEROGLYPH_G018                              0x13154
#define unicode_EGYPTIAN_HIEROGLYPH_G019                              0x13155
#define unicode_EGYPTIAN_HIEROGLYPH_G020                              0x13156
#define unicode_EGYPTIAN_HIEROGLYPH_G020A                             0x13157
#define unicode_EGYPTIAN_HIEROGLYPH_G021                              0x13158
#define unicode_EGYPTIAN_HIEROGLYPH_G022                              0x13159
#define unicode_EGYPTIAN_HIEROGLYPH_G023                              0x1315A
#define unicode_EGYPTIAN_HIEROGLYPH_G024                              0x1315B
#define unicode_EGYPTIAN_HIEROGLYPH_G025                              0x1315C
#define unicode_EGYPTIAN_HIEROGLYPH_G026                              0x1315D
#define unicode_EGYPTIAN_HIEROGLYPH_G026A                             0x1315E
#define unicode_EGYPTIAN_HIEROGLYPH_G027                              0x1315F
#define unicode_EGYPTIAN_HIEROGLYPH_G028                              0x13160
#define unicode_EGYPTIAN_HIEROGLYPH_G029                              0x13161
#define unicode_EGYPTIAN_HIEROGLYPH_G030                              0x13162
#define unicode_EGYPTIAN_HIEROGLYPH_G031                              0x13163
#define unicode_EGYPTIAN_HIEROGLYPH_G032                              0x13164
#define unicode_EGYPTIAN_HIEROGLYPH_G033                              0x13165
#define unicode_EGYPTIAN_HIEROGLYPH_G034                              0x13166
#define unicode_EGYPTIAN_HIEROGLYPH_G035                              0x13167
#define unicode_EGYPTIAN_HIEROGLYPH_G036                              0x13168
#define unicode_EGYPTIAN_HIEROGLYPH_G036A                             0x13169
#define unicode_EGYPTIAN_HIEROGLYPH_G037                              0x1316A
#define unicode_EGYPTIAN_HIEROGLYPH_G037A                             0x1316B
#define unicode_EGYPTIAN_HIEROGLYPH_G038                              0x1316C
#define unicode_EGYPTIAN_HIEROGLYPH_G039                              0x1316D
#define unicode_EGYPTIAN_HIEROGLYPH_G040                              0x1316E
#define unicode_EGYPTIAN_HIEROGLYPH_G041                              0x1316F
#define unicode_EGYPTIAN_HIEROGLYPH_G042                              0x13170
#define unicode_EGYPTIAN_HIEROGLYPH_G043                              0x13171
#define unicode_EGYPTIAN_HIEROGLYPH_G043A                             0x13172
#define unicode_EGYPTIAN_HIEROGLYPH_G044                              0x13173
#define unicode_EGYPTIAN_HIEROGLYPH_G045                              0x13174
#define unicode_EGYPTIAN_HIEROGLYPH_G045A                             0x13175
#define unicode_EGYPTIAN_HIEROGLYPH_G046                              0x13176
#define unicode_EGYPTIAN_HIEROGLYPH_G047                              0x13177
#define unicode_EGYPTIAN_HIEROGLYPH_G048                              0x13178
#define unicode_EGYPTIAN_HIEROGLYPH_G049                              0x13179
#define unicode_EGYPTIAN_HIEROGLYPH_G050                              0x1317A
#define unicode_EGYPTIAN_HIEROGLYPH_G051                              0x1317B
#define unicode_EGYPTIAN_HIEROGLYPH_G052                              0x1317C
#define unicode_EGYPTIAN_HIEROGLYPH_G053                              0x1317D
#define unicode_EGYPTIAN_HIEROGLYPH_G054                              0x1317E
#define unicode_EGYPTIAN_HIEROGLYPH_H001                              0x1317F
#define unicode_EGYPTIAN_HIEROGLYPH_H002                              0x13180
#define unicode_EGYPTIAN_HIEROGLYPH_H003                              0x13181
#define unicode_EGYPTIAN_HIEROGLYPH_H004                              0x13182
#define unicode_EGYPTIAN_HIEROGLYPH_H005                              0x13183
#define unicode_EGYPTIAN_HIEROGLYPH_H006                              0x13184
#define unicode_EGYPTIAN_HIEROGLYPH_H006A                             0x13185
#define unicode_EGYPTIAN_HIEROGLYPH_H007                              0x13186
#define unicode_EGYPTIAN_HIEROGLYPH_H008                              0x13187
#define unicode_EGYPTIAN_HIEROGLYPH_I001                              0x13188
#define unicode_EGYPTIAN_HIEROGLYPH_I002                              0x13189
#define unicode_EGYPTIAN_HIEROGLYPH_I003                              0x1318A
#define unicode_EGYPTIAN_HIEROGLYPH_I004                              0x1318B
#define unicode_EGYPTIAN_HIEROGLYPH_I005                              0x1318C
#define unicode_EGYPTIAN_HIEROGLYPH_I005A                             0x1318D
#define unicode_EGYPTIAN_HIEROGLYPH_I006                              0x1318E
#define unicode_EGYPTIAN_HIEROGLYPH_I007                              0x1318F
#define unicode_EGYPTIAN_HIEROGLYPH_I008                              0x13190
#define unicode_EGYPTIAN_HIEROGLYPH_I009                              0x13191
#define unicode_EGYPTIAN_HIEROGLYPH_I009A                             0x13192
#define unicode_EGYPTIAN_HIEROGLYPH_I010                              0x13193
#define unicode_EGYPTIAN_HIEROGLYPH_I010A                             0x13194
#define unicode_EGYPTIAN_HIEROGLYPH_I011                              0x13195
#define unicode_EGYPTIAN_HIEROGLYPH_I011A                             0x13196
#define unicode_EGYPTIAN_HIEROGLYPH_I012                              0x13197
#define unicode_EGYPTIAN_HIEROGLYPH_I013                              0x13198
#define unicode_EGYPTIAN_HIEROGLYPH_I014                              0x13199
#define unicode_EGYPTIAN_HIEROGLYPH_I015                              0x1319A
#define unicode_EGYPTIAN_HIEROGLYPH_K001                              0x1319B
#define unicode_EGYPTIAN_HIEROGLYPH_K002                              0x1319C
#define unicode_EGYPTIAN_HIEROGLYPH_K003                              0x1319D
#define unicode_EGYPTIAN_HIEROGLYPH_K004                              0x1319E
#define unicode_EGYPTIAN_HIEROGLYPH_K005                              0x1319F
#define unicode_EGYPTIAN_HIEROGLYPH_K006                              0x131A0
#define unicode_EGYPTIAN_HIEROGLYPH_K007                              0x131A1
#define unicode_EGYPTIAN_HIEROGLYPH_K008                              0x131A2
#define unicode_EGYPTIAN_HIEROGLYPH_L001                              0x131A3
#define unicode_EGYPTIAN_HIEROGLYPH_L002                              0x131A4
#define unicode_EGYPTIAN_HIEROGLYPH_L002A                             0x131A5
#define unicode_EGYPTIAN_HIEROGLYPH_L003                              0x131A6
#define unicode_EGYPTIAN_HIEROGLYPH_L004                              0x131A7
#define unicode_EGYPTIAN_HIEROGLYPH_L005                              0x131A8
#define unicode_EGYPTIAN_HIEROGLYPH_L006                              0x131A9
#define unicode_EGYPTIAN_HIEROGLYPH_L006A                             0x131AA
#define unicode_EGYPTIAN_HIEROGLYPH_L007                              0x131AB
#define unicode_EGYPTIAN_HIEROGLYPH_L008                              0x131AC
#define unicode_EGYPTIAN_HIEROGLYPH_M001                              0x131AD
#define unicode_EGYPTIAN_HIEROGLYPH_M001A                             0x131AE
#define unicode_EGYPTIAN_HIEROGLYPH_M001B                             0x131AF
#define unicode_EGYPTIAN_HIEROGLYPH_M002                              0x131B0
#define unicode_EGYPTIAN_HIEROGLYPH_M003                              0x131B1
#define unicode_EGYPTIAN_HIEROGLYPH_M003A                             0x131B2
#define unicode_EGYPTIAN_HIEROGLYPH_M004                              0x131B3
#define unicode_EGYPTIAN_HIEROGLYPH_M005                              0x131B4
#define unicode_EGYPTIAN_HIEROGLYPH_M006                              0x131B5
#define unicode_EGYPTIAN_HIEROGLYPH_M007                              0x131B6
#define unicode_EGYPTIAN_HIEROGLYPH_M008                              0x131B7
#define unicode_EGYPTIAN_HIEROGLYPH_M009                              0x131B8
#define unicode_EGYPTIAN_HIEROGLYPH_M010                              0x131B9
#define unicode_EGYPTIAN_HIEROGLYPH_M010A                             0x131BA
#define unicode_EGYPTIAN_HIEROGLYPH_M011                              0x131BB
#define unicode_EGYPTIAN_HIEROGLYPH_M012                              0x131BC
#define unicode_EGYPTIAN_HIEROGLYPH_M012A                             0x131BD
#define unicode_EGYPTIAN_HIEROGLYPH_M012B                             0x131BE
#define unicode_EGYPTIAN_HIEROGLYPH_M012C                             0x131BF
#define unicode_EGYPTIAN_HIEROGLYPH_M012D                             0x131C0
#define unicode_EGYPTIAN_HIEROGLYPH_M012E                             0x131C1
#define unicode_EGYPTIAN_HIEROGLYPH_M012F                             0x131C2
#define unicode_EGYPTIAN_HIEROGLYPH_M012G                             0x131C3
#define unicode_EGYPTIAN_HIEROGLYPH_M012H                             0x131C4
#define unicode_EGYPTIAN_HIEROGLYPH_M013                              0x131C5
#define unicode_EGYPTIAN_HIEROGLYPH_M014                              0x131C6
#define unicode_EGYPTIAN_HIEROGLYPH_M015                              0x131C7
#define unicode_EGYPTIAN_HIEROGLYPH_M015A                             0x131C8
#define unicode_EGYPTIAN_HIEROGLYPH_M016                              0x131C9
#define unicode_EGYPTIAN_HIEROGLYPH_M016A                             0x131CA
#define unicode_EGYPTIAN_HIEROGLYPH_M017                              0x131CB
#define unicode_EGYPTIAN_HIEROGLYPH_M017A                             0x131CC
#define unicode_EGYPTIAN_HIEROGLYPH_M018                              0x131CD
#define unicode_EGYPTIAN_HIEROGLYPH_M019                              0x131CE
#define unicode_EGYPTIAN_HIEROGLYPH_M020                              0x131CF
#define unicode_EGYPTIAN_HIEROGLYPH_M021                              0x131D0
#define unicode_EGYPTIAN_HIEROGLYPH_M022                              0x131D1
#define unicode_EGYPTIAN_HIEROGLYPH_M022A                             0x131D2
#define unicode_EGYPTIAN_HIEROGLYPH_M023                              0x131D3
#define unicode_EGYPTIAN_HIEROGLYPH_M024                              0x131D4
#define unicode_EGYPTIAN_HIEROGLYPH_M024A                             0x131D5
#define unicode_EGYPTIAN_HIEROGLYPH_M025                              0x131D6
#define unicode_EGYPTIAN_HIEROGLYPH_M026                              0x131D7
#define unicode_EGYPTIAN_HIEROGLYPH_M027                              0x131D8
#define unicode_EGYPTIAN_HIEROGLYPH_M028                              0x131D9
#define unicode_EGYPTIAN_HIEROGLYPH_M028A                             0x131DA
#define unicode_EGYPTIAN_HIEROGLYPH_M029                              0x131DB
#define unicode_EGYPTIAN_HIEROGLYPH_M030                              0x131DC
#define unicode_EGYPTIAN_HIEROGLYPH_M031                              0x131DD
#define unicode_EGYPTIAN_HIEROGLYPH_M031A                             0x131DE
#define unicode_EGYPTIAN_HIEROGLYPH_M032                              0x131DF
#define unicode_EGYPTIAN_HIEROGLYPH_M033                              0x131E0
#define unicode_EGYPTIAN_HIEROGLYPH_M033A                             0x131E1
#define unicode_EGYPTIAN_HIEROGLYPH_M033B                             0x131E2
#define unicode_EGYPTIAN_HIEROGLYPH_M034                              0x131E3
#define unicode_EGYPTIAN_HIEROGLYPH_M035                              0x131E4
#define unicode_EGYPTIAN_HIEROGLYPH_M036                              0x131E5
#define unicode_EGYPTIAN_HIEROGLYPH_M037                              0x131E6
#define unicode_EGYPTIAN_HIEROGLYPH_M038                              0x131E7
#define unicode_EGYPTIAN_HIEROGLYPH_M039                              0x131E8
#define unicode_EGYPTIAN_HIEROGLYPH_M040                              0x131E9
#define unicode_EGYPTIAN_HIEROGLYPH_M040A                             0x131EA
#define unicode_EGYPTIAN_HIEROGLYPH_M041                              0x131EB
#define unicode_EGYPTIAN_HIEROGLYPH_M042                              0x131EC
#define unicode_EGYPTIAN_HIEROGLYPH_M043                              0x131ED
#define unicode_EGYPTIAN_HIEROGLYPH_M044                              0x131EE
#define unicode_EGYPTIAN_HIEROGLYPH_N001                              0x131EF
#define unicode_EGYPTIAN_HIEROGLYPH_N002                              0x131F0
#define unicode_EGYPTIAN_HIEROGLYPH_N003                              0x131F1
#define unicode_EGYPTIAN_HIEROGLYPH_N004                              0x131F2
#define unicode_EGYPTIAN_HIEROGLYPH_N005                              0x131F3
#define unicode_EGYPTIAN_HIEROGLYPH_N006                              0x131F4
#define unicode_EGYPTIAN_HIEROGLYPH_N007                              0x131F5
#define unicode_EGYPTIAN_HIEROGLYPH_N008                              0x131F6
#define unicode_EGYPTIAN_HIEROGLYPH_N009                              0x131F7
#define unicode_EGYPTIAN_HIEROGLYPH_N010                              0x131F8
#define unicode_EGYPTIAN_HIEROGLYPH_N011                              0x131F9
#define unicode_EGYPTIAN_HIEROGLYPH_N012                              0x131FA
#define unicode_EGYPTIAN_HIEROGLYPH_N013                              0x131FB
#define unicode_EGYPTIAN_HIEROGLYPH_N014                              0x131FC
#define unicode_EGYPTIAN_HIEROGLYPH_N015                              0x131FD
#define unicode_EGYPTIAN_HIEROGLYPH_N016                              0x131FE
#define unicode_EGYPTIAN_HIEROGLYPH_N017                              0x131FF
#define unicode_EGYPTIAN_HIEROGLYPH_N018                              0x13200
#define unicode_EGYPTIAN_HIEROGLYPH_N018A                             0x13201
#define unicode_EGYPTIAN_HIEROGLYPH_N018B                             0x13202
#define unicode_EGYPTIAN_HIEROGLYPH_N019                              0x13203
#define unicode_EGYPTIAN_HIEROGLYPH_N020                              0x13204
#define unicode_EGYPTIAN_HIEROGLYPH_N021                              0x13205
#define unicode_EGYPTIAN_HIEROGLYPH_N022                              0x13206
#define unicode_EGYPTIAN_HIEROGLYPH_N023                              0x13207
#define unicode_EGYPTIAN_HIEROGLYPH_N024                              0x13208
#define unicode_EGYPTIAN_HIEROGLYPH_N025                              0x13209
#define unicode_EGYPTIAN_HIEROGLYPH_N025A                             0x1320A
#define unicode_EGYPTIAN_HIEROGLYPH_N026                              0x1320B
#define unicode_EGYPTIAN_HIEROGLYPH_N027                              0x1320C
#define unicode_EGYPTIAN_HIEROGLYPH_N028                              0x1320D
#define unicode_EGYPTIAN_HIEROGLYPH_N029                              0x1320E
#define unicode_EGYPTIAN_HIEROGLYPH_N030                              0x1320F
#define unicode_EGYPTIAN_HIEROGLYPH_N031                              0x13210
#define unicode_EGYPTIAN_HIEROGLYPH_N032                              0x13211
#define unicode_EGYPTIAN_HIEROGLYPH_N033                              0x13212
#define unicode_EGYPTIAN_HIEROGLYPH_N033A                             0x13213
#define unicode_EGYPTIAN_HIEROGLYPH_N034                              0x13214
#define unicode_EGYPTIAN_HIEROGLYPH_N034A                             0x13215
#define unicode_EGYPTIAN_HIEROGLYPH_N035                              0x13216
#define unicode_EGYPTIAN_HIEROGLYPH_N035A                             0x13217
#define unicode_EGYPTIAN_HIEROGLYPH_N036                              0x13218
#define unicode_EGYPTIAN_HIEROGLYPH_N037                              0x13219
#define unicode_EGYPTIAN_HIEROGLYPH_N037A                             0x1321A
#define unicode_EGYPTIAN_HIEROGLYPH_N038                              0x1321B
#define unicode_EGYPTIAN_HIEROGLYPH_N039                              0x1321C
#define unicode_EGYPTIAN_HIEROGLYPH_N040                              0x1321D
#define unicode_EGYPTIAN_HIEROGLYPH_N041                              0x1321E
#define unicode_EGYPTIAN_HIEROGLYPH_N042                              0x1321F
#define unicode_EGYPTIAN_HIEROGLYPH_NL001                             0x13220
#define unicode_EGYPTIAN_HIEROGLYPH_NL002                             0x13221
#define unicode_EGYPTIAN_HIEROGLYPH_NL003                             0x13222
#define unicode_EGYPTIAN_HIEROGLYPH_NL004                             0x13223
#define unicode_EGYPTIAN_HIEROGLYPH_NL005                             0x13224
#define unicode_EGYPTIAN_HIEROGLYPH_NL005A                            0x13225
#define unicode_EGYPTIAN_HIEROGLYPH_NL006                             0x13226
#define unicode_EGYPTIAN_HIEROGLYPH_NL007                             0x13227
#define unicode_EGYPTIAN_HIEROGLYPH_NL008                             0x13228
#define unicode_EGYPTIAN_HIEROGLYPH_NL009                             0x13229
#define unicode_EGYPTIAN_HIEROGLYPH_NL010                             0x1322A
#define unicode_EGYPTIAN_HIEROGLYPH_NL011                             0x1322B
#define unicode_EGYPTIAN_HIEROGLYPH_NL012                             0x1322C
#define unicode_EGYPTIAN_HIEROGLYPH_NL013                             0x1322D
#define unicode_EGYPTIAN_HIEROGLYPH_NL014                             0x1322E
#define unicode_EGYPTIAN_HIEROGLYPH_NL015                             0x1322F
#define unicode_EGYPTIAN_HIEROGLYPH_NL016                             0x13230
#define unicode_EGYPTIAN_HIEROGLYPH_NL017                             0x13231
#define unicode_EGYPTIAN_HIEROGLYPH_NL017A                            0x13232
#define unicode_EGYPTIAN_HIEROGLYPH_NL018                             0x13233
#define unicode_EGYPTIAN_HIEROGLYPH_NL019                             0x13234
#define unicode_EGYPTIAN_HIEROGLYPH_NL020                             0x13235
#define unicode_EGYPTIAN_HIEROGLYPH_NU001                             0x13236
#define unicode_EGYPTIAN_HIEROGLYPH_NU002                             0x13237
#define unicode_EGYPTIAN_HIEROGLYPH_NU003                             0x13238
#define unicode_EGYPTIAN_HIEROGLYPH_NU004                             0x13239
#define unicode_EGYPTIAN_HIEROGLYPH_NU005                             0x1323A
#define unicode_EGYPTIAN_HIEROGLYPH_NU006                             0x1323B
#define unicode_EGYPTIAN_HIEROGLYPH_NU007                             0x1323C
#define unicode_EGYPTIAN_HIEROGLYPH_NU008                             0x1323D
#define unicode_EGYPTIAN_HIEROGLYPH_NU009                             0x1323E
#define unicode_EGYPTIAN_HIEROGLYPH_NU010                             0x1323F
#define unicode_EGYPTIAN_HIEROGLYPH_NU010A                            0x13240
#define unicode_EGYPTIAN_HIEROGLYPH_NU011                             0x13241
#define unicode_EGYPTIAN_HIEROGLYPH_NU011A                            0x13242
#define unicode_EGYPTIAN_HIEROGLYPH_NU012                             0x13243
#define unicode_EGYPTIAN_HIEROGLYPH_NU013                             0x13244
#define unicode_EGYPTIAN_HIEROGLYPH_NU014                             0x13245
#define unicode_EGYPTIAN_HIEROGLYPH_NU015                             0x13246
#define unicode_EGYPTIAN_HIEROGLYPH_NU016                             0x13247
#define unicode_EGYPTIAN_HIEROGLYPH_NU017                             0x13248
#define unicode_EGYPTIAN_HIEROGLYPH_NU018                             0x13249
#define unicode_EGYPTIAN_HIEROGLYPH_NU018A                            0x1324A
#define unicode_EGYPTIAN_HIEROGLYPH_NU019                             0x1324B
#define unicode_EGYPTIAN_HIEROGLYPH_NU020                             0x1324C
#define unicode_EGYPTIAN_HIEROGLYPH_NU021                             0x1324D
#define unicode_EGYPTIAN_HIEROGLYPH_NU022                             0x1324E
#define unicode_EGYPTIAN_HIEROGLYPH_NU022A                            0x1324F
#define unicode_EGYPTIAN_HIEROGLYPH_O001                              0x13250
#define unicode_EGYPTIAN_HIEROGLYPH_O001A                             0x13251
#define unicode_EGYPTIAN_HIEROGLYPH_O002                              0x13252
#define unicode_EGYPTIAN_HIEROGLYPH_O003                              0x13253
#define unicode_EGYPTIAN_HIEROGLYPH_O004                              0x13254
#define unicode_EGYPTIAN_HIEROGLYPH_O005                              0x13255
#define unicode_EGYPTIAN_HIEROGLYPH_O005A                             0x13256
#define unicode_EGYPTIAN_HIEROGLYPH_O006                              0x13257
#define unicode_EGYPTIAN_HIEROGLYPH_O006A                             0x13258
#define unicode_EGYPTIAN_HIEROGLYPH_O006B                             0x13259
#define unicode_EGYPTIAN_HIEROGLYPH_O006C                             0x1325A
#define unicode_EGYPTIAN_HIEROGLYPH_O006D                             0x1325B
#define unicode_EGYPTIAN_HIEROGLYPH_O006E                             0x1325C
#define unicode_EGYPTIAN_HIEROGLYPH_O006F                             0x1325D
#define unicode_EGYPTIAN_HIEROGLYPH_O007                              0x1325E
#define unicode_EGYPTIAN_HIEROGLYPH_O008                              0x1325F
#define unicode_EGYPTIAN_HIEROGLYPH_O009                              0x13260
#define unicode_EGYPTIAN_HIEROGLYPH_O010                              0x13261
#define unicode_EGYPTIAN_HIEROGLYPH_O010A                             0x13262
#define unicode_EGYPTIAN_HIEROGLYPH_O010B                             0x13263
#define unicode_EGYPTIAN_HIEROGLYPH_O010C                             0x13264
#define unicode_EGYPTIAN_HIEROGLYPH_O011                              0x13265
#define unicode_EGYPTIAN_HIEROGLYPH_O012                              0x13266
#define unicode_EGYPTIAN_HIEROGLYPH_O013                              0x13267
#define unicode_EGYPTIAN_HIEROGLYPH_O014                              0x13268
#define unicode_EGYPTIAN_HIEROGLYPH_O015                              0x13269
#define unicode_EGYPTIAN_HIEROGLYPH_O016                              0x1326A
#define unicode_EGYPTIAN_HIEROGLYPH_O017                              0x1326B
#define unicode_EGYPTIAN_HIEROGLYPH_O018                              0x1326C
#define unicode_EGYPTIAN_HIEROGLYPH_O019                              0x1326D
#define unicode_EGYPTIAN_HIEROGLYPH_O019A                             0x1326E
#define unicode_EGYPTIAN_HIEROGLYPH_O020                              0x1326F
#define unicode_EGYPTIAN_HIEROGLYPH_O020A                             0x13270
#define unicode_EGYPTIAN_HIEROGLYPH_O021                              0x13271
#define unicode_EGYPTIAN_HIEROGLYPH_O022                              0x13272
#define unicode_EGYPTIAN_HIEROGLYPH_O023                              0x13273
#define unicode_EGYPTIAN_HIEROGLYPH_O024                              0x13274
#define unicode_EGYPTIAN_HIEROGLYPH_O024A                             0x13275
#define unicode_EGYPTIAN_HIEROGLYPH_O025                              0x13276
#define unicode_EGYPTIAN_HIEROGLYPH_O025A                             0x13277
#define unicode_EGYPTIAN_HIEROGLYPH_O026                              0x13278
#define unicode_EGYPTIAN_HIEROGLYPH_O027                              0x13279
#define unicode_EGYPTIAN_HIEROGLYPH_O028                              0x1327A
#define unicode_EGYPTIAN_HIEROGLYPH_O029                              0x1327B
#define unicode_EGYPTIAN_HIEROGLYPH_O029A                             0x1327C
#define unicode_EGYPTIAN_HIEROGLYPH_O030                              0x1327D
#define unicode_EGYPTIAN_HIEROGLYPH_O030A                             0x1327E
#define unicode_EGYPTIAN_HIEROGLYPH_O031                              0x1327F
#define unicode_EGYPTIAN_HIEROGLYPH_O032                              0x13280
#define unicode_EGYPTIAN_HIEROGLYPH_O033                              0x13281
#define unicode_EGYPTIAN_HIEROGLYPH_O033A                             0x13282
#define unicode_EGYPTIAN_HIEROGLYPH_O034                              0x13283
#define unicode_EGYPTIAN_HIEROGLYPH_O035                              0x13284
#define unicode_EGYPTIAN_HIEROGLYPH_O036                              0x13285
#define unicode_EGYPTIAN_HIEROGLYPH_O036A                             0x13286
#define unicode_EGYPTIAN_HIEROGLYPH_O036B                             0x13287
#define unicode_EGYPTIAN_HIEROGLYPH_O036C                             0x13288
#define unicode_EGYPTIAN_HIEROGLYPH_O036D                             0x13289
#define unicode_EGYPTIAN_HIEROGLYPH_O037                              0x1328A
#define unicode_EGYPTIAN_HIEROGLYPH_O038                              0x1328B
#define unicode_EGYPTIAN_HIEROGLYPH_O039                              0x1328C
#define unicode_EGYPTIAN_HIEROGLYPH_O040                              0x1328D
#define unicode_EGYPTIAN_HIEROGLYPH_O041                              0x1328E
#define unicode_EGYPTIAN_HIEROGLYPH_O042                              0x1328F
#define unicode_EGYPTIAN_HIEROGLYPH_O043                              0x13290
#define unicode_EGYPTIAN_HIEROGLYPH_O044                              0x13291
#define unicode_EGYPTIAN_HIEROGLYPH_O045                              0x13292
#define unicode_EGYPTIAN_HIEROGLYPH_O046                              0x13293
#define unicode_EGYPTIAN_HIEROGLYPH_O047                              0x13294
#define unicode_EGYPTIAN_HIEROGLYPH_O048                              0x13295
#define unicode_EGYPTIAN_HIEROGLYPH_O049                              0x13296
#define unicode_EGYPTIAN_HIEROGLYPH_O050                              0x13297
#define unicode_EGYPTIAN_HIEROGLYPH_O050A                             0x13298
#define unicode_EGYPTIAN_HIEROGLYPH_O050B                             0x13299
#define unicode_EGYPTIAN_HIEROGLYPH_O051                              0x1329A
#define unicode_EGYPTIAN_HIEROGLYPH_P001                              0x1329B
#define unicode_EGYPTIAN_HIEROGLYPH_P001A                             0x1329C
#define unicode_EGYPTIAN_HIEROGLYPH_P002                              0x1329D
#define unicode_EGYPTIAN_HIEROGLYPH_P003                              0x1329E
#define unicode_EGYPTIAN_HIEROGLYPH_P003A                             0x1329F
#define unicode_EGYPTIAN_HIEROGLYPH_P004                              0x132A0
#define unicode_EGYPTIAN_HIEROGLYPH_P005                              0x132A1
#define unicode_EGYPTIAN_HIEROGLYPH_P006                              0x132A2
#define unicode_EGYPTIAN_HIEROGLYPH_P007                              0x132A3
#define unicode_EGYPTIAN_HIEROGLYPH_P008                              0x132A4
#define unicode_EGYPTIAN_HIEROGLYPH_P009                              0x132A5
#define unicode_EGYPTIAN_HIEROGLYPH_P010                              0x132A6
#define unicode_EGYPTIAN_HIEROGLYPH_P011                              0x132A7
#define unicode_EGYPTIAN_HIEROGLYPH_Q001                              0x132A8
#define unicode_EGYPTIAN_HIEROGLYPH_Q002                              0x132A9
#define unicode_EGYPTIAN_HIEROGLYPH_Q003                              0x132AA
#define unicode_EGYPTIAN_HIEROGLYPH_Q004                              0x132AB
#define unicode_EGYPTIAN_HIEROGLYPH_Q005                              0x132AC
#define unicode_EGYPTIAN_HIEROGLYPH_Q006                              0x132AD
#define unicode_EGYPTIAN_HIEROGLYPH_Q007                              0x132AE
#define unicode_EGYPTIAN_HIEROGLYPH_R001                              0x132AF
#define unicode_EGYPTIAN_HIEROGLYPH_R002                              0x132B0
#define unicode_EGYPTIAN_HIEROGLYPH_R002A                             0x132B1
#define unicode_EGYPTIAN_HIEROGLYPH_R003                              0x132B2
#define unicode_EGYPTIAN_HIEROGLYPH_R003A                             0x132B3
#define unicode_EGYPTIAN_HIEROGLYPH_R003B                             0x132B4
#define unicode_EGYPTIAN_HIEROGLYPH_R004                              0x132B5
#define unicode_EGYPTIAN_HIEROGLYPH_R005                              0x132B6
#define unicode_EGYPTIAN_HIEROGLYPH_R006                              0x132B7
#define unicode_EGYPTIAN_HIEROGLYPH_R007                              0x132B8
#define unicode_EGYPTIAN_HIEROGLYPH_R008                              0x132B9
#define unicode_EGYPTIAN_HIEROGLYPH_R009                              0x132BA
#define unicode_EGYPTIAN_HIEROGLYPH_R010                              0x132BB
#define unicode_EGYPTIAN_HIEROGLYPH_R010A                             0x132BC
#define unicode_EGYPTIAN_HIEROGLYPH_R011                              0x132BD
#define unicode_EGYPTIAN_HIEROGLYPH_R012                              0x132BE
#define unicode_EGYPTIAN_HIEROGLYPH_R013                              0x132BF
#define unicode_EGYPTIAN_HIEROGLYPH_R014                              0x132C0
#define unicode_EGYPTIAN_HIEROGLYPH_R015                              0x132C1
#define unicode_EGYPTIAN_HIEROGLYPH_R016                              0x132C2
#define unicode_EGYPTIAN_HIEROGLYPH_R016A                             0x132C3
#define unicode_EGYPTIAN_HIEROGLYPH_R017                              0x132C4
#define unicode_EGYPTIAN_HIEROGLYPH_R018                              0x132C5
#define unicode_EGYPTIAN_HIEROGLYPH_R019                              0x132C6
#define unicode_EGYPTIAN_HIEROGLYPH_R020                              0x132C7
#define unicode_EGYPTIAN_HIEROGLYPH_R021                              0x132C8
#define unicode_EGYPTIAN_HIEROGLYPH_R022                              0x132C9
#define unicode_EGYPTIAN_HIEROGLYPH_R023                              0x132CA
#define unicode_EGYPTIAN_HIEROGLYPH_R024                              0x132CB
#define unicode_EGYPTIAN_HIEROGLYPH_R025                              0x132CC
#define unicode_EGYPTIAN_HIEROGLYPH_R026                              0x132CD
#define unicode_EGYPTIAN_HIEROGLYPH_R027                              0x132CE
#define unicode_EGYPTIAN_HIEROGLYPH_R028                              0x132CF
#define unicode_EGYPTIAN_HIEROGLYPH_R029                              0x132D0
#define unicode_EGYPTIAN_HIEROGLYPH_S001                              0x132D1
#define unicode_EGYPTIAN_HIEROGLYPH_S002                              0x132D2
#define unicode_EGYPTIAN_HIEROGLYPH_S002A                             0x132D3
#define unicode_EGYPTIAN_HIEROGLYPH_S003                              0x132D4
#define unicode_EGYPTIAN_HIEROGLYPH_S004                              0x132D5
#define unicode_EGYPTIAN_HIEROGLYPH_S005                              0x132D6
#define unicode_EGYPTIAN_HIEROGLYPH_S006                              0x132D7
#define unicode_EGYPTIAN_HIEROGLYPH_S006A                             0x132D8
#define unicode_EGYPTIAN_HIEROGLYPH_S007                              0x132D9
#define unicode_EGYPTIAN_HIEROGLYPH_S008                              0x132DA
#define unicode_EGYPTIAN_HIEROGLYPH_S009                              0x132DB
#define unicode_EGYPTIAN_HIEROGLYPH_S010                              0x132DC
#define unicode_EGYPTIAN_HIEROGLYPH_S011                              0x132DD
#define unicode_EGYPTIAN_HIEROGLYPH_S012                              0x132DE
#define unicode_EGYPTIAN_HIEROGLYPH_S013                              0x132DF
#define unicode_EGYPTIAN_HIEROGLYPH_S014                              0x132E0
#define unicode_EGYPTIAN_HIEROGLYPH_S014A                             0x132E1
#define unicode_EGYPTIAN_HIEROGLYPH_S014B                             0x132E2
#define unicode_EGYPTIAN_HIEROGLYPH_S015                              0x132E3
#define unicode_EGYPTIAN_HIEROGLYPH_S016                              0x132E4
#define unicode_EGYPTIAN_HIEROGLYPH_S017                              0x132E5
#define unicode_EGYPTIAN_HIEROGLYPH_S017A                             0x132E6
#define unicode_EGYPTIAN_HIEROGLYPH_S018                              0x132E7
#define unicode_EGYPTIAN_HIEROGLYPH_S019                              0x132E8
#define unicode_EGYPTIAN_HIEROGLYPH_S020                              0x132E9
#define unicode_EGYPTIAN_HIEROGLYPH_S021                              0x132EA
#define unicode_EGYPTIAN_HIEROGLYPH_S022                              0x132EB
#define unicode_EGYPTIAN_HIEROGLYPH_S023                              0x132EC
#define unicode_EGYPTIAN_HIEROGLYPH_S024                              0x132ED
#define unicode_EGYPTIAN_HIEROGLYPH_S025                              0x132EE
#define unicode_EGYPTIAN_HIEROGLYPH_S026                              0x132EF
#define unicode_EGYPTIAN_HIEROGLYPH_S026A                             0x132F0
#define unicode_EGYPTIAN_HIEROGLYPH_S026B                             0x132F1
#define unicode_EGYPTIAN_HIEROGLYPH_S027                              0x132F2
#define unicode_EGYPTIAN_HIEROGLYPH_S028                              0x132F3
#define unicode_EGYPTIAN_HIEROGLYPH_S029                              0x132F4
#define unicode_EGYPTIAN_HIEROGLYPH_S030                              0x132F5
#define unicode_EGYPTIAN_HIEROGLYPH_S031                              0x132F6
#define unicode_EGYPTIAN_HIEROGLYPH_S032                              0x132F7
#define unicode_EGYPTIAN_HIEROGLYPH_S033                              0x132F8
#define unicode_EGYPTIAN_HIEROGLYPH_S034                              0x132F9
#define unicode_EGYPTIAN_HIEROGLYPH_S035                              0x132FA
#define unicode_EGYPTIAN_HIEROGLYPH_S035A                             0x132FB
#define unicode_EGYPTIAN_HIEROGLYPH_S036                              0x132FC
#define unicode_EGYPTIAN_HIEROGLYPH_S037                              0x132FD
#define unicode_EGYPTIAN_HIEROGLYPH_S038                              0x132FE
#define unicode_EGYPTIAN_HIEROGLYPH_S039                              0x132FF
#define unicode_EGYPTIAN_HIEROGLYPH_S040                              0x13300
#define unicode_EGYPTIAN_HIEROGLYPH_S041                              0x13301
#define unicode_EGYPTIAN_HIEROGLYPH_S042                              0x13302
#define unicode_EGYPTIAN_HIEROGLYPH_S043                              0x13303
#define unicode_EGYPTIAN_HIEROGLYPH_S044                              0x13304
#define unicode_EGYPTIAN_HIEROGLYPH_S045                              0x13305
#define unicode_EGYPTIAN_HIEROGLYPH_S046                              0x13306
#define unicode_EGYPTIAN_HIEROGLYPH_T001                              0x13307
#define unicode_EGYPTIAN_HIEROGLYPH_T002                              0x13308
#define unicode_EGYPTIAN_HIEROGLYPH_T003                              0x13309
#define unicode_EGYPTIAN_HIEROGLYPH_T003A                             0x1330A
#define unicode_EGYPTIAN_HIEROGLYPH_T004                              0x1330B
#define unicode_EGYPTIAN_HIEROGLYPH_T005                              0x1330C
#define unicode_EGYPTIAN_HIEROGLYPH_T006                              0x1330D
#define unicode_EGYPTIAN_HIEROGLYPH_T007                              0x1330E
#define unicode_EGYPTIAN_HIEROGLYPH_T007A                             0x1330F
#define unicode_EGYPTIAN_HIEROGLYPH_T008                              0x13310
#define unicode_EGYPTIAN_HIEROGLYPH_T008A                             0x13311
#define unicode_EGYPTIAN_HIEROGLYPH_T009                              0x13312
#define unicode_EGYPTIAN_HIEROGLYPH_T009A                             0x13313
#define unicode_EGYPTIAN_HIEROGLYPH_T010                              0x13314
#define unicode_EGYPTIAN_HIEROGLYPH_T011                              0x13315
#define unicode_EGYPTIAN_HIEROGLYPH_T011A                             0x13316
#define unicode_EGYPTIAN_HIEROGLYPH_T012                              0x13317
#define unicode_EGYPTIAN_HIEROGLYPH_T013                              0x13318
#define unicode_EGYPTIAN_HIEROGLYPH_T014                              0x13319
#define unicode_EGYPTIAN_HIEROGLYPH_T015                              0x1331A
#define unicode_EGYPTIAN_HIEROGLYPH_T016                              0x1331B
#define unicode_EGYPTIAN_HIEROGLYPH_T016A                             0x1331C
#define unicode_EGYPTIAN_HIEROGLYPH_T017                              0x1331D
#define unicode_EGYPTIAN_HIEROGLYPH_T018                              0x1331E
#define unicode_EGYPTIAN_HIEROGLYPH_T019                              0x1331F
#define unicode_EGYPTIAN_HIEROGLYPH_T020                              0x13320
#define unicode_EGYPTIAN_HIEROGLYPH_T021                              0x13321
#define unicode_EGYPTIAN_HIEROGLYPH_T022                              0x13322
#define unicode_EGYPTIAN_HIEROGLYPH_T023                              0x13323
#define unicode_EGYPTIAN_HIEROGLYPH_T024                              0x13324
#define unicode_EGYPTIAN_HIEROGLYPH_T025                              0x13325
#define unicode_EGYPTIAN_HIEROGLYPH_T026                              0x13326
#define unicode_EGYPTIAN_HIEROGLYPH_T027                              0x13327
#define unicode_EGYPTIAN_HIEROGLYPH_T028                              0x13328
#define unicode_EGYPTIAN_HIEROGLYPH_T029                              0x13329
#define unicode_EGYPTIAN_HIEROGLYPH_T030                              0x1332A
#define unicode_EGYPTIAN_HIEROGLYPH_T031                              0x1332B
#define unicode_EGYPTIAN_HIEROGLYPH_T032                              0x1332C
#define unicode_EGYPTIAN_HIEROGLYPH_T032A                             0x1332D
#define unicode_EGYPTIAN_HIEROGLYPH_T033                              0x1332E
#define unicode_EGYPTIAN_HIEROGLYPH_T033A                             0x1332F
#define unicode_EGYPTIAN_HIEROGLYPH_T034                              0x13330
#define unicode_EGYPTIAN_HIEROGLYPH_T035                              0x13331
#define unicode_EGYPTIAN_HIEROGLYPH_T036                              0x13332
#define unicode_EGYPTIAN_HIEROGLYPH_U001                              0x13333
#define unicode_EGYPTIAN_HIEROGLYPH_U002                              0x13334
#define unicode_EGYPTIAN_HIEROGLYPH_U003                              0x13335
#define unicode_EGYPTIAN_HIEROGLYPH_U004                              0x13336
#define unicode_EGYPTIAN_HIEROGLYPH_U005                              0x13337
#define unicode_EGYPTIAN_HIEROGLYPH_U006                              0x13338
#define unicode_EGYPTIAN_HIEROGLYPH_U006A                             0x13339
#define unicode_EGYPTIAN_HIEROGLYPH_U006B                             0x1333A
#define unicode_EGYPTIAN_HIEROGLYPH_U007                              0x1333B
#define unicode_EGYPTIAN_HIEROGLYPH_U008                              0x1333C
#define unicode_EGYPTIAN_HIEROGLYPH_U009                              0x1333D
#define unicode_EGYPTIAN_HIEROGLYPH_U010                              0x1333E
#define unicode_EGYPTIAN_HIEROGLYPH_U011                              0x1333F
#define unicode_EGYPTIAN_HIEROGLYPH_U012                              0x13340
#define unicode_EGYPTIAN_HIEROGLYPH_U013                              0x13341
#define unicode_EGYPTIAN_HIEROGLYPH_U014                              0x13342
#define unicode_EGYPTIAN_HIEROGLYPH_U015                              0x13343
#define unicode_EGYPTIAN_HIEROGLYPH_U016                              0x13344
#define unicode_EGYPTIAN_HIEROGLYPH_U017                              0x13345
#define unicode_EGYPTIAN_HIEROGLYPH_U018                              0x13346
#define unicode_EGYPTIAN_HIEROGLYPH_U019                              0x13347
#define unicode_EGYPTIAN_HIEROGLYPH_U020                              0x13348
#define unicode_EGYPTIAN_HIEROGLYPH_U021                              0x13349
#define unicode_EGYPTIAN_HIEROGLYPH_U022                              0x1334A
#define unicode_EGYPTIAN_HIEROGLYPH_U023                              0x1334B
#define unicode_EGYPTIAN_HIEROGLYPH_U023A                             0x1334C
#define unicode_EGYPTIAN_HIEROGLYPH_U024                              0x1334D
#define unicode_EGYPTIAN_HIEROGLYPH_U025                              0x1334E
#define unicode_EGYPTIAN_HIEROGLYPH_U026                              0x1334F
#define unicode_EGYPTIAN_HIEROGLYPH_U027                              0x13350
#define unicode_EGYPTIAN_HIEROGLYPH_U028                              0x13351
#define unicode_EGYPTIAN_HIEROGLYPH_U029                              0x13352
#define unicode_EGYPTIAN_HIEROGLYPH_U029A                             0x13353
#define unicode_EGYPTIAN_HIEROGLYPH_U030                              0x13354
#define unicode_EGYPTIAN_HIEROGLYPH_U031                              0x13355
#define unicode_EGYPTIAN_HIEROGLYPH_U032                              0x13356
#define unicode_EGYPTIAN_HIEROGLYPH_U032A                             0x13357
#define unicode_EGYPTIAN_HIEROGLYPH_U033                              0x13358
#define unicode_EGYPTIAN_HIEROGLYPH_U034                              0x13359
#define unicode_EGYPTIAN_HIEROGLYPH_U035                              0x1335A
#define unicode_EGYPTIAN_HIEROGLYPH_U036                              0x1335B
#define unicode_EGYPTIAN_HIEROGLYPH_U037                              0x1335C
#define unicode_EGYPTIAN_HIEROGLYPH_U038                              0x1335D
#define unicode_EGYPTIAN_HIEROGLYPH_U039                              0x1335E
#define unicode_EGYPTIAN_HIEROGLYPH_U040                              0x1335F
#define unicode_EGYPTIAN_HIEROGLYPH_U041                              0x13360
#define unicode_EGYPTIAN_HIEROGLYPH_U042                              0x13361
#define unicode_EGYPTIAN_HIEROGLYPH_V001                              0x13362
#define unicode_EGYPTIAN_HIEROGLYPH_V001A                             0x13363
#define unicode_EGYPTIAN_HIEROGLYPH_V001B                             0x13364
#define unicode_EGYPTIAN_HIEROGLYPH_V001C                             0x13365
#define unicode_EGYPTIAN_HIEROGLYPH_V001D                             0x13366
#define unicode_EGYPTIAN_HIEROGLYPH_V001E                             0x13367
#define unicode_EGYPTIAN_HIEROGLYPH_V001F                             0x13368
#define unicode_EGYPTIAN_HIEROGLYPH_V001G                             0x13369
#define unicode_EGYPTIAN_HIEROGLYPH_V001H                             0x1336A
#define unicode_EGYPTIAN_HIEROGLYPH_V001I                             0x1336B
#define unicode_EGYPTIAN_HIEROGLYPH_V002                              0x1336C
#define unicode_EGYPTIAN_HIEROGLYPH_V002A                             0x1336D
#define unicode_EGYPTIAN_HIEROGLYPH_V003                              0x1336E
#define unicode_EGYPTIAN_HIEROGLYPH_V004                              0x1336F
#define unicode_EGYPTIAN_HIEROGLYPH_V005                              0x13370
#define unicode_EGYPTIAN_HIEROGLYPH_V006                              0x13371
#define unicode_EGYPTIAN_HIEROGLYPH_V007                              0x13372
#define unicode_EGYPTIAN_HIEROGLYPH_V007A                             0x13373
#define unicode_EGYPTIAN_HIEROGLYPH_V007B                             0x13374
#define unicode_EGYPTIAN_HIEROGLYPH_V008                              0x13375
#define unicode_EGYPTIAN_HIEROGLYPH_V009                              0x13376
#define unicode_EGYPTIAN_HIEROGLYPH_V010                              0x13377
#define unicode_EGYPTIAN_HIEROGLYPH_V011                              0x13378
#define unicode_EGYPTIAN_HIEROGLYPH_V011A                             0x13379
#define unicode_EGYPTIAN_HIEROGLYPH_V011B                             0x1337A
#define unicode_EGYPTIAN_HIEROGLYPH_V011C                             0x1337B
#define unicode_EGYPTIAN_HIEROGLYPH_V012                              0x1337C
#define unicode_EGYPTIAN_HIEROGLYPH_V012A                             0x1337D
#define unicode_EGYPTIAN_HIEROGLYPH_V012B                             0x1337E
#define unicode_EGYPTIAN_HIEROGLYPH_V013                              0x1337F
#define unicode_EGYPTIAN_HIEROGLYPH_V014                              0x13380
#define unicode_EGYPTIAN_HIEROGLYPH_V015                              0x13381
#define unicode_EGYPTIAN_HIEROGLYPH_V016                              0x13382
#define unicode_EGYPTIAN_HIEROGLYPH_V017                              0x13383
#define unicode_EGYPTIAN_HIEROGLYPH_V018                              0x13384
#define unicode_EGYPTIAN_HIEROGLYPH_V019                              0x13385
#define unicode_EGYPTIAN_HIEROGLYPH_V020                              0x13386
#define unicode_EGYPTIAN_HIEROGLYPH_V020A                             0x13387
#define unicode_EGYPTIAN_HIEROGLYPH_V020B                             0x13388
#define unicode_EGYPTIAN_HIEROGLYPH_V020C                             0x13389
#define unicode_EGYPTIAN_HIEROGLYPH_V020D                             0x1338A
#define unicode_EGYPTIAN_HIEROGLYPH_V020E                             0x1338B
#define unicode_EGYPTIAN_HIEROGLYPH_V020F                             0x1338C
#define unicode_EGYPTIAN_HIEROGLYPH_V020G                             0x1338D
#define unicode_EGYPTIAN_HIEROGLYPH_V020H                             0x1338E
#define unicode_EGYPTIAN_HIEROGLYPH_V020I                             0x1338F
#define unicode_EGYPTIAN_HIEROGLYPH_V020J                             0x13390
#define unicode_EGYPTIAN_HIEROGLYPH_V020K                             0x13391
#define unicode_EGYPTIAN_HIEROGLYPH_V020L                             0x13392
#define unicode_EGYPTIAN_HIEROGLYPH_V021                              0x13393
#define unicode_EGYPTIAN_HIEROGLYPH_V022                              0x13394
#define unicode_EGYPTIAN_HIEROGLYPH_V023                              0x13395
#define unicode_EGYPTIAN_HIEROGLYPH_V023A                             0x13396
#define unicode_EGYPTIAN_HIEROGLYPH_V024                              0x13397
#define unicode_EGYPTIAN_HIEROGLYPH_V025                              0x13398
#define unicode_EGYPTIAN_HIEROGLYPH_V026                              0x13399
#define unicode_EGYPTIAN_HIEROGLYPH_V027                              0x1339A
#define unicode_EGYPTIAN_HIEROGLYPH_V028                              0x1339B
#define unicode_EGYPTIAN_HIEROGLYPH_V028A                             0x1339C
#define unicode_EGYPTIAN_HIEROGLYPH_V029                              0x1339D
#define unicode_EGYPTIAN_HIEROGLYPH_V029A                             0x1339E
#define unicode_EGYPTIAN_HIEROGLYPH_V030                              0x1339F
#define unicode_EGYPTIAN_HIEROGLYPH_V030A                             0x133A0
#define unicode_EGYPTIAN_HIEROGLYPH_V031                              0x133A1
#define unicode_EGYPTIAN_HIEROGLYPH_V031A                             0x133A2
#define unicode_EGYPTIAN_HIEROGLYPH_V032                              0x133A3
#define unicode_EGYPTIAN_HIEROGLYPH_V033                              0x133A4
#define unicode_EGYPTIAN_HIEROGLYPH_V033A                             0x133A5
#define unicode_EGYPTIAN_HIEROGLYPH_V034                              0x133A6
#define unicode_EGYPTIAN_HIEROGLYPH_V035                              0x133A7
#define unicode_EGYPTIAN_HIEROGLYPH_V036                              0x133A8
#define unicode_EGYPTIAN_HIEROGLYPH_V037                              0x133A9
#define unicode_EGYPTIAN_HIEROGLYPH_V037A                             0x133AA
#define unicode_EGYPTIAN_HIEROGLYPH_V038                              0x133AB
#define unicode_EGYPTIAN_HIEROGLYPH_V039                              0x133AC
#define unicode_EGYPTIAN_HIEROGLYPH_V040                              0x133AD
#define unicode_EGYPTIAN_HIEROGLYPH_V040A                             0x133AE
#define unicode_EGYPTIAN_HIEROGLYPH_W001                              0x133AF
#define unicode_EGYPTIAN_HIEROGLYPH_W002                              0x133B0
#define unicode_EGYPTIAN_HIEROGLYPH_W003                              0x133B1
#define unicode_EGYPTIAN_HIEROGLYPH_W003A                             0x133B2
#define unicode_EGYPTIAN_HIEROGLYPH_W004                              0x133B3
#define unicode_EGYPTIAN_HIEROGLYPH_W005                              0x133B4
#define unicode_EGYPTIAN_HIEROGLYPH_W006                              0x133B5
#define unicode_EGYPTIAN_HIEROGLYPH_W007                              0x133B6
#define unicode_EGYPTIAN_HIEROGLYPH_W008                              0x133B7
#define unicode_EGYPTIAN_HIEROGLYPH_W009                              0x133B8
#define unicode_EGYPTIAN_HIEROGLYPH_W009A                             0x133B9
#define unicode_EGYPTIAN_HIEROGLYPH_W010                              0x133BA
#define unicode_EGYPTIAN_HIEROGLYPH_W010A                             0x133BB
#define unicode_EGYPTIAN_HIEROGLYPH_W011                              0x133BC
#define unicode_EGYPTIAN_HIEROGLYPH_W012                              0x133BD
#define unicode_EGYPTIAN_HIEROGLYPH_W013                              0x133BE
#define unicode_EGYPTIAN_HIEROGLYPH_W014                              0x133BF
#define unicode_EGYPTIAN_HIEROGLYPH_W014A                             0x133C0
#define unicode_EGYPTIAN_HIEROGLYPH_W015                              0x133C1
#define unicode_EGYPTIAN_HIEROGLYPH_W016                              0x133C2
#define unicode_EGYPTIAN_HIEROGLYPH_W017                              0x133C3
#define unicode_EGYPTIAN_HIEROGLYPH_W017A                             0x133C4
#define unicode_EGYPTIAN_HIEROGLYPH_W018                              0x133C5
#define unicode_EGYPTIAN_HIEROGLYPH_W018A                             0x133C6
#define unicode_EGYPTIAN_HIEROGLYPH_W019                              0x133C7
#define unicode_EGYPTIAN_HIEROGLYPH_W020                              0x133C8
#define unicode_EGYPTIAN_HIEROGLYPH_W021                              0x133C9
#define unicode_EGYPTIAN_HIEROGLYPH_W022                              0x133CA
#define unicode_EGYPTIAN_HIEROGLYPH_W023                              0x133CB
#define unicode_EGYPTIAN_HIEROGLYPH_W024                              0x133CC
#define unicode_EGYPTIAN_HIEROGLYPH_W024A                             0x133CD
#define unicode_EGYPTIAN_HIEROGLYPH_W025                              0x133CE
#define unicode_EGYPTIAN_HIEROGLYPH_X001                              0x133CF
#define unicode_EGYPTIAN_HIEROGLYPH_X002                              0x133D0
#define unicode_EGYPTIAN_HIEROGLYPH_X003                              0x133D1
#define unicode_EGYPTIAN_HIEROGLYPH_X004                              0x133D2
#define unicode_EGYPTIAN_HIEROGLYPH_X004A                             0x133D3
#define unicode_EGYPTIAN_HIEROGLYPH_X004B                             0x133D4
#define unicode_EGYPTIAN_HIEROGLYPH_X005                              0x133D5
#define unicode_EGYPTIAN_HIEROGLYPH_X006                              0x133D6
#define unicode_EGYPTIAN_HIEROGLYPH_X006A                             0x133D7
#define unicode_EGYPTIAN_HIEROGLYPH_X007                              0x133D8
#define unicode_EGYPTIAN_HIEROGLYPH_X008                              0x133D9
#define unicode_EGYPTIAN_HIEROGLYPH_X008A                             0x133DA
#define unicode_EGYPTIAN_HIEROGLYPH_Y001                              0x133DB
#define unicode_EGYPTIAN_HIEROGLYPH_Y001A                             0x133DC
#define unicode_EGYPTIAN_HIEROGLYPH_Y002                              0x133DD
#define unicode_EGYPTIAN_HIEROGLYPH_Y003                              0x133DE
#define unicode_EGYPTIAN_HIEROGLYPH_Y004                              0x133DF
#define unicode_EGYPTIAN_HIEROGLYPH_Y005                              0x133E0
#define unicode_EGYPTIAN_HIEROGLYPH_Y006                              0x133E1
#define unicode_EGYPTIAN_HIEROGLYPH_Y007                              0x133E2
#define unicode_EGYPTIAN_HIEROGLYPH_Y008                              0x133E3
#define unicode_EGYPTIAN_HIEROGLYPH_Z001                              0x133E4
#define unicode_EGYPTIAN_HIEROGLYPH_Z002                              0x133E5
#define unicode_EGYPTIAN_HIEROGLYPH_Z002A                             0x133E6
#define unicode_EGYPTIAN_HIEROGLYPH_Z002B                             0x133E7
#define unicode_EGYPTIAN_HIEROGLYPH_Z002C                             0x133E8
#define unicode_EGYPTIAN_HIEROGLYPH_Z002D                             0x133E9
#define unicode_EGYPTIAN_HIEROGLYPH_Z003                              0x133EA
#define unicode_EGYPTIAN_HIEROGLYPH_Z003A                             0x133EB
#define unicode_EGYPTIAN_HIEROGLYPH_Z003B                             0x133EC
#define unicode_EGYPTIAN_HIEROGLYPH_Z004                              0x133ED
#define unicode_EGYPTIAN_HIEROGLYPH_Z004A                             0x133EE
#define unicode_EGYPTIAN_HIEROGLYPH_Z005                              0x133EF
#define unicode_EGYPTIAN_HIEROGLYPH_Z005A                             0x133F0
#define unicode_EGYPTIAN_HIEROGLYPH_Z006                              0x133F1
#define unicode_EGYPTIAN_HIEROGLYPH_Z007                              0x133F2
#define unicode_EGYPTIAN_HIEROGLYPH_Z008                              0x133F3
#define unicode_EGYPTIAN_HIEROGLYPH_Z009                              0x133F4
#define unicode_EGYPTIAN_HIEROGLYPH_Z010                              0x133F5
#define unicode_EGYPTIAN_HIEROGLYPH_Z011                              0x133F6
#define unicode_EGYPTIAN_HIEROGLYPH_Z012                              0x133F7
#define unicode_EGYPTIAN_HIEROGLYPH_Z013                              0x133F8
#define unicode_EGYPTIAN_HIEROGLYPH_Z014                              0x133F9
#define unicode_EGYPTIAN_HIEROGLYPH_Z015                              0x133FA
#define unicode_EGYPTIAN_HIEROGLYPH_Z015A                             0x133FB
#define unicode_EGYPTIAN_HIEROGLYPH_Z015B                             0x133FC
#define unicode_EGYPTIAN_HIEROGLYPH_Z015C                             0x133FD
#define unicode_EGYPTIAN_HIEROGLYPH_Z015D                             0x133FE
#define unicode_EGYPTIAN_HIEROGLYPH_Z015E                             0x133FF
#define unicode_EGYPTIAN_HIEROGLYPH_Z015F                             0x13400
#define unicode_EGYPTIAN_HIEROGLYPH_Z015G                             0x13401
#define unicode_EGYPTIAN_HIEROGLYPH_Z015H                             0x13402
#define unicode_EGYPTIAN_HIEROGLYPH_Z015I                             0x13403
#define unicode_EGYPTIAN_HIEROGLYPH_Z016                              0x13404
#define unicode_EGYPTIAN_HIEROGLYPH_Z016A                             0x13405
#define unicode_EGYPTIAN_HIEROGLYPH_Z016B                             0x13406
#define unicode_EGYPTIAN_HIEROGLYPH_Z016C                             0x13407
#define unicode_EGYPTIAN_HIEROGLYPH_Z016D                             0x13408
#define unicode_EGYPTIAN_HIEROGLYPH_Z016E                             0x13409
#define unicode_EGYPTIAN_HIEROGLYPH_Z016F                             0x1340A
#define unicode_EGYPTIAN_HIEROGLYPH_Z016G                             0x1340B
#define unicode_EGYPTIAN_HIEROGLYPH_Z016H                             0x1340C
#define unicode_EGYPTIAN_HIEROGLYPH_AA001                             0x1340D
#define unicode_EGYPTIAN_HIEROGLYPH_AA002                             0x1340E
#define unicode_EGYPTIAN_HIEROGLYPH_AA003                             0x1340F
#define unicode_EGYPTIAN_HIEROGLYPH_AA004                             0x13410
#define unicode_EGYPTIAN_HIEROGLYPH_AA005                             0x13411
#define unicode_EGYPTIAN_HIEROGLYPH_AA006                             0x13412
#define unicode_EGYPTIAN_HIEROGLYPH_AA007                             0x13413
#define unicode_EGYPTIAN_HIEROGLYPH_AA007A                            0x13414
#define unicode_EGYPTIAN_HIEROGLYPH_AA007B                            0x13415
#define unicode_EGYPTIAN_HIEROGLYPH_AA008                             0x13416
#define unicode_EGYPTIAN_HIEROGLYPH_AA009                             0x13417
#define unicode_EGYPTIAN_HIEROGLYPH_AA010                             0x13418
#define unicode_EGYPTIAN_HIEROGLYPH_AA011                             0x13419
#define unicode_EGYPTIAN_HIEROGLYPH_AA012                             0x1341A
#define unicode_EGYPTIAN_HIEROGLYPH_AA013                             0x1341B
#define unicode_EGYPTIAN_HIEROGLYPH_AA014                             0x1341C
#define unicode_EGYPTIAN_HIEROGLYPH_AA015                             0x1341D
#define unicode_EGYPTIAN_HIEROGLYPH_AA016                             0x1341E
#define unicode_EGYPTIAN_HIEROGLYPH_AA017                             0x1341F
#define unicode_EGYPTIAN_HIEROGLYPH_AA018                             0x13420
#define unicode_EGYPTIAN_HIEROGLYPH_AA019                             0x13421
#define unicode_EGYPTIAN_HIEROGLYPH_AA020                             0x13422
#define unicode_EGYPTIAN_HIEROGLYPH_AA021                             0x13423
#define unicode_EGYPTIAN_HIEROGLYPH_AA022                             0x13424
#define unicode_EGYPTIAN_HIEROGLYPH_AA023                             0x13425
#define unicode_EGYPTIAN_HIEROGLYPH_AA024                             0x13426
#define unicode_EGYPTIAN_HIEROGLYPH_AA025                             0x13427
#define unicode_EGYPTIAN_HIEROGLYPH_AA026                             0x13428
#define unicode_EGYPTIAN_HIEROGLYPH_AA027                             0x13429
#define unicode_EGYPTIAN_HIEROGLYPH_AA028                             0x1342A
#define unicode_EGYPTIAN_HIEROGLYPH_AA029                             0x1342B
#define unicode_EGYPTIAN_HIEROGLYPH_AA030                             0x1342C
#define unicode_EGYPTIAN_HIEROGLYPH_AA031                             0x1342D
#define unicode_EGYPTIAN_HIEROGLYPH_AA032                             0x1342E
#define unicode_BAMUM_LETTER_PHASE_A_NGKUE_MFON                       0x16800
#define unicode_BAMUM_LETTER_PHASE_A_GBIEE_FON                        0x16801
#define unicode_BAMUM_LETTER_PHASE_A_PON_MFON_PIPAEMGBIEE             0x16802
#define unicode_BAMUM_LETTER_PHASE_A_PON_MFON_PIPAEMBA                0x16803
#define unicode_BAMUM_LETTER_PHASE_A_NAA_MFON                         0x16804
#define unicode_BAMUM_LETTER_PHASE_A_SHUENSHUET                       0x16805
#define unicode_BAMUM_LETTER_PHASE_A_TITA_MFON                        0x16806
#define unicode_BAMUM_LETTER_PHASE_A_NZA_MFON                         0x16807
#define unicode_BAMUM_LETTER_PHASE_A_SHINDA_PA_NJI                    0x16808
#define unicode_BAMUM_LETTER_PHASE_A_PON_PA_NJI_PIPAEMGBIEE           0x16809
#define unicode_BAMUM_LETTER_PHASE_A_PON_PA_NJI_PIPAEMBA              0x1680A
#define unicode_BAMUM_LETTER_PHASE_A_MAEMBGBIEE                       0x1680B
#define unicode_BAMUM_LETTER_PHASE_A_TU_MAEMBA                        0x1680C
#define unicode_BAMUM_LETTER_PHASE_A_NGANGU                           0x1680D
#define unicode_BAMUM_LETTER_PHASE_A_MAEMVEUX                         0x1680E
#define unicode_BAMUM_LETTER_PHASE_A_MANSUAE                          0x1680F
#define unicode_BAMUM_LETTER_PHASE_A_MVEUAENGAM                       0x16810
#define unicode_BAMUM_LETTER_PHASE_A_SEUNYAM                          0x16811
#define unicode_BAMUM_LETTER_PHASE_A_NTOQPEN                          0x16812
#define unicode_BAMUM_LETTER_PHASE_A_KEUKEUTNDA                       0x16813
#define unicode_BAMUM_LETTER_PHASE_A_NKINDI                           0x16814
#define unicode_BAMUM_LETTER_PHASE_A_SUU                              0x16815
#define unicode_BAMUM_LETTER_PHASE_A_NGKUENZEUM                       0x16816
#define unicode_BAMUM_LETTER_PHASE_A_LAPAQ                            0x16817
#define unicode_BAMUM_LETTER_PHASE_A_LET_KUT                          0x16818
#define unicode_BAMUM_LETTER_PHASE_A_NTAP_MFAA                        0x16819
#define unicode_BAMUM_LETTER_PHASE_A_MAEKEUP                          0x1681A
#define unicode_BAMUM_LETTER_PHASE_A_PASHAE                           0x1681B
#define unicode_BAMUM_LETTER_PHASE_A_GHEUAERAE                        0x1681C
#define unicode_BAMUM_LETTER_PHASE_A_PAMSHAE                          0x1681D
#define unicode_BAMUM_LETTER_PHASE_A_MON_NGGEUAET                     0x1681E
#define unicode_BAMUM_LETTER_PHASE_A_NZUN_MEUT                        0x1681F
#define unicode_BAMUM_LETTER_PHASE_A_U_YUQ_NAE                        0x16820
#define unicode_BAMUM_LETTER_PHASE_A_GHEUAEGHEUAE                     0x16821
#define unicode_BAMUM_LETTER_PHASE_A_NTAP_NTAA                        0x16822
#define unicode_BAMUM_LETTER_PHASE_A_SISA                             0x16823
#define unicode_BAMUM_LETTER_PHASE_A_MGBASA                           0x16824
#define unicode_BAMUM_LETTER_PHASE_A_MEUNJOMNDEUQ                     0x16825
#define unicode_BAMUM_LETTER_PHASE_A_MOOMPUQ                          0x16826
#define unicode_BAMUM_LETTER_PHASE_A_KAFA                             0x16827
#define unicode_BAMUM_LETTER_PHASE_A_PA_LEERAEWA                      0x16828
#define unicode_BAMUM_LETTER_PHASE_A_NDA_LEERAEWA                     0x16829
#define unicode_BAMUM_LETTER_PHASE_A_PET                              0x1682A
#define unicode_BAMUM_LETTER_PHASE_A_MAEMKPEN                         0x1682B
#define unicode_BAMUM_LETTER_PHASE_A_NIKA                             0x1682C
#define unicode_BAMUM_LETTER_PHASE_A_PUP                              0x1682D
#define unicode_BAMUM_LETTER_PHASE_A_TUAEP                            0x1682E
#define unicode_BAMUM_LETTER_PHASE_A_LUAEP                            0x1682F
#define unicode_BAMUM_LETTER_PHASE_A_SONJAM                           0x16830
#define unicode_BAMUM_LETTER_PHASE_A_TEUTEUWEN                        0x16831
#define unicode_BAMUM_LETTER_PHASE_A_MAENYI                           0x16832
#define unicode_BAMUM_LETTER_PHASE_A_KET                              0x16833
#define unicode_BAMUM_LETTER_PHASE_A_NDAANGGEUAET                     0x16834
#define unicode_BAMUM_LETTER_PHASE_A_KUOQ                             0x16835
#define unicode_BAMUM_LETTER_PHASE_A_MOOMEUT                          0x16836
#define unicode_BAMUM_LETTER_PHASE_A_SHUM                             0x16837
#define unicode_BAMUM_LETTER_PHASE_A_LOMMAE                           0x16838
#define unicode_BAMUM_LETTER_PHASE_A_FIRI                             0x16839
#define unicode_BAMUM_LETTER_PHASE_A_ROM                              0x1683A
#define unicode_BAMUM_LETTER_PHASE_A_KPOQ                             0x1683B
#define unicode_BAMUM_LETTER_PHASE_A_SOQ                              0x1683C
#define unicode_BAMUM_LETTER_PHASE_A_MAP_PIEET                        0x1683D
#define unicode_BAMUM_LETTER_PHASE_A_SHIRAE                           0x1683E
#define unicode_BAMUM_LETTER_PHASE_A_NTAP                             0x1683F
#define unicode_BAMUM_LETTER_PHASE_A_SHOQ_NSHUT_YUM                   0x16840
#define unicode_BAMUM_LETTER_PHASE_A_NYIT_MONGKEUAEQ                  0x16841
#define unicode_BAMUM_LETTER_PHASE_A_PAARAE                           0x16842
#define unicode_BAMUM_LETTER_PHASE_A_NKAARAE                          0x16843
#define unicode_BAMUM_LETTER_PHASE_A_UNKNOWN                          0x16844
#define unicode_BAMUM_LETTER_PHASE_A_NGGEN                            0x16845
#define unicode_BAMUM_LETTER_PHASE_A_MAESI                            0x16846
#define unicode_BAMUM_LETTER_PHASE_A_NJAM                             0x16847
#define unicode_BAMUM_LETTER_PHASE_A_MBANYI                           0x16848
#define unicode_BAMUM_LETTER_PHASE_A_NYET                             0x16849
#define unicode_BAMUM_LETTER_PHASE_A_TEUAEN                           0x1684A
#define unicode_BAMUM_LETTER_PHASE_A_SOT                              0x1684B
#define unicode_BAMUM_LETTER_PHASE_A_PAAM                             0x1684C
#define unicode_BAMUM_LETTER_PHASE_A_NSHIEE                           0x1684D
#define unicode_BAMUM_LETTER_PHASE_A_MAEM                             0x1684E
#define unicode_BAMUM_LETTER_PHASE_A_NYI                              0x1684F
#define unicode_BAMUM_LETTER_PHASE_A_KAQ                              0x16850
#define unicode_BAMUM_LETTER_PHASE_A_NSHA                             0x16851
#define unicode_BAMUM_LETTER_PHASE_A_VEE                              0x16852
#define unicode_BAMUM_LETTER_PHASE_A_LU                               0x16853
#define unicode_BAMUM_LETTER_PHASE_A_NEN                              0x16854
#define unicode_BAMUM_LETTER_PHASE_A_NAQ                              0x16855
#define unicode_BAMUM_LETTER_PHASE_A_MBAQ                             0x16856
#define unicode_BAMUM_LETTER_PHASE_B_NSHUET                           0x16857
#define unicode_BAMUM_LETTER_PHASE_B_TU_MAEMGBIEE                     0x16858
#define unicode_BAMUM_LETTER_PHASE_B_SIEE                             0x16859
#define unicode_BAMUM_LETTER_PHASE_B_SET_TU                           0x1685A
#define unicode_BAMUM_LETTER_PHASE_B_LOM_NTEUM                        0x1685B
#define unicode_BAMUM_LETTER_PHASE_B_MBA_MAELEE                       0x1685C
#define unicode_BAMUM_LETTER_PHASE_B_KIEEM                            0x1685D
#define unicode_BAMUM_LETTER_PHASE_B_YEURAE                           0x1685E
#define unicode_BAMUM_LETTER_PHASE_B_MBAARAE                          0x1685F
#define unicode_BAMUM_LETTER_PHASE_B_KAM                              0x16860
#define unicode_BAMUM_LETTER_PHASE_B_PEESHI                           0x16861
#define unicode_BAMUM_LETTER_PHASE_B_YAFU_LEERAEWA                    0x16862
#define unicode_BAMUM_LETTER_PHASE_B_LAM_NSHUT_NYAM                   0x16863
#define unicode_BAMUM_LETTER_PHASE_B_NTIEE_SHEUOQ                     0x16864
#define unicode_BAMUM_LETTER_PHASE_B_NDU_NJAA                         0x16865
#define unicode_BAMUM_LETTER_PHASE_B_GHEUGHEUAEM                      0x16866
#define unicode_BAMUM_LETTER_PHASE_B_PIT                              0x16867
#define unicode_BAMUM_LETTER_PHASE_B_TU_NSIEE                         0x16868
#define unicode_BAMUM_LETTER_PHASE_B_SHET_NJAQ                        0x16869
#define unicode_BAMUM_LETTER_PHASE_B_SHEUAEQTU                        0x1686A
#define unicode_BAMUM_LETTER_PHASE_B_MFON_TEUAEQ                      0x1686B
#define unicode_BAMUM_LETTER_PHASE_B_MBIT_MBAAKET                     0x1686C
#define unicode_BAMUM_LETTER_PHASE_B_NYI_NTEUM                        0x1686D
#define unicode_BAMUM_LETTER_PHASE_B_KEUPUQ                           0x1686E
#define unicode_BAMUM_LETTER_PHASE_B_GHEUGHEN                         0x1686F
#define unicode_BAMUM_LETTER_PHASE_B_KEUYEUX                          0x16870
#define unicode_BAMUM_LETTER_PHASE_B_LAANAE                           0x16871
#define unicode_BAMUM_LETTER_PHASE_B_PARUM                            0x16872
#define unicode_BAMUM_LETTER_PHASE_B_VEUM                             0x16873
#define unicode_BAMUM_LETTER_PHASE_B_NGKINDI_MVOP                     0x16874
#define unicode_BAMUM_LETTER_PHASE_B_NGGEU_MBU                        0x16875
#define unicode_BAMUM_LETTER_PHASE_B_WUAET                            0x16876
#define unicode_BAMUM_LETTER_PHASE_B_SAKEUAE                          0x16877
#define unicode_BAMUM_LETTER_PHASE_B_TAAM                             0x16878
#define unicode_BAMUM_LETTER_PHASE_B_MEUQ                             0x16879
#define unicode_BAMUM_LETTER_PHASE_B_NGGUOQ                           0x1687A
#define unicode_BAMUM_LETTER_PHASE_B_NGGUOQ_LARGE                     0x1687B
#define unicode_BAMUM_LETTER_PHASE_B_MFIYAQ                           0x1687C
#define unicode_BAMUM_LETTER_PHASE_B_SUE                              0x1687D
#define unicode_BAMUM_LETTER_PHASE_B_MBEURI                           0x1687E
#define unicode_BAMUM_LETTER_PHASE_B_MONTIEEN                         0x1687F
#define unicode_BAMUM_LETTER_PHASE_B_NYAEMAE                          0x16880
#define unicode_BAMUM_LETTER_PHASE_B_PUNGAAM                          0x16881
#define unicode_BAMUM_LETTER_PHASE_B_MEUT_NGGEET                      0x16882
#define unicode_BAMUM_LETTER_PHASE_B_FEUX                             0x16883
#define unicode_BAMUM_LETTER_PHASE_B_MBUOQ                            0x16884
#define unicode_BAMUM_LETTER_PHASE_B_FEE                              0x16885
#define unicode_BAMUM_LETTER_PHASE_B_KEUAEM                           0x16886
#define unicode_BAMUM_LETTER_PHASE_B_MA_NJEUAENA                      0x16887
#define unicode_BAMUM_LETTER_PHASE_B_MA_NJUQA                         0x16888
#define unicode_BAMUM_LETTER_PHASE_B_LET                              0x16889
#define unicode_BAMUM_LETTER_PHASE_B_NGGAAM                           0x1688A
#define unicode_BAMUM_LETTER_PHASE_B_NSEN                             0x1688B
#define unicode_BAMUM_LETTER_PHASE_B_MA                               0x1688C
#define unicode_BAMUM_LETTER_PHASE_B_KIQ                              0x1688D
#define unicode_BAMUM_LETTER_PHASE_B_NGOM                             0x1688E
#define unicode_BAMUM_LETTER_PHASE_C_NGKUE_MAEMBA                     0x1688F
#define unicode_BAMUM_LETTER_PHASE_C_NZA                              0x16890
#define unicode_BAMUM_LETTER_PHASE_C_YUM                              0x16891
#define unicode_BAMUM_LETTER_PHASE_C_WANGKUOQ                         0x16892
#define unicode_BAMUM_LETTER_PHASE_C_NGGEN                            0x16893
#define unicode_BAMUM_LETTER_PHASE_C_NDEUAEREE                        0x16894
#define unicode_BAMUM_LETTER_PHASE_C_NGKAQ                            0x16895
#define unicode_BAMUM_LETTER_PHASE_C_GHARAE                           0x16896
#define unicode_BAMUM_LETTER_PHASE_C_MBEEKEET                         0x16897
#define unicode_BAMUM_LETTER_PHASE_C_GBAYI                            0x16898
#define unicode_BAMUM_LETTER_PHASE_C_NYIR_MKPARAQ_MEUN                0x16899
#define unicode_BAMUM_LETTER_PHASE_C_NTU_MBIT                         0x1689A
#define unicode_BAMUM_LETTER_PHASE_C_MBEUM                            0x1689B
#define unicode_BAMUM_LETTER_PHASE_C_PIRIEEN                          0x1689C
#define unicode_BAMUM_LETTER_PHASE_C_NDOMBU                           0x1689D
#define unicode_BAMUM_LETTER_PHASE_C_MBAA_CABBAGE_TREE                0x1689E
#define unicode_BAMUM_LETTER_PHASE_C_KEUSHEUAEP                       0x1689F
#define unicode_BAMUM_LETTER_PHASE_C_GHAP                             0x168A0
#define unicode_BAMUM_LETTER_PHASE_C_KEUKAQ                           0x168A1
#define unicode_BAMUM_LETTER_PHASE_C_YU_MUOMAE                        0x168A2
#define unicode_BAMUM_LETTER_PHASE_C_NZEUM                            0x168A3
#define unicode_BAMUM_LETTER_PHASE_C_MBUE                             0x168A4
#define unicode_BAMUM_LETTER_PHASE_C_NSEUAEN                          0x168A5
#define unicode_BAMUM_LETTER_PHASE_C_MBIT                             0x168A6
#define unicode_BAMUM_LETTER_PHASE_C_YEUQ                             0x168A7
#define unicode_BAMUM_LETTER_PHASE_C_KPARAQ                           0x168A8
#define unicode_BAMUM_LETTER_PHASE_C_KAA                              0x168A9
#define unicode_BAMUM_LETTER_PHASE_C_SEUX                             0x168AA
#define unicode_BAMUM_LETTER_PHASE_C_NDIDA                            0x168AB
#define unicode_BAMUM_LETTER_PHASE_C_TAASHAE                          0x168AC
#define unicode_BAMUM_LETTER_PHASE_C_NJUEQ                            0x168AD
#define unicode_BAMUM_LETTER_PHASE_C_TITA_YUE                         0x168AE
#define unicode_BAMUM_LETTER_PHASE_C_SUAET                            0x168AF
#define unicode_BAMUM_LETTER_PHASE_C_NGGUAEN_NYAM                     0x168B0
#define unicode_BAMUM_LETTER_PHASE_C_VEUX                             0x168B1
#define unicode_BAMUM_LETTER_PHASE_C_NANSANAQ                         0x168B2
#define unicode_BAMUM_LETTER_PHASE_C_MA_KEUAERI                       0x168B3
#define unicode_BAMUM_LETTER_PHASE_C_NTAA                             0x168B4
#define unicode_BAMUM_LETTER_PHASE_C_NGGUON                           0x168B5
#define unicode_BAMUM_LETTER_PHASE_C_LAP                              0x168B6
#define unicode_BAMUM_LETTER_PHASE_C_MBIRIEEN                         0x168B7
#define unicode_BAMUM_LETTER_PHASE_C_MGBASAQ                          0x168B8
#define unicode_BAMUM_LETTER_PHASE_C_NTEUNGBA                         0x168B9
#define unicode_BAMUM_LETTER_PHASE_C_TEUTEUX                          0x168BA
#define unicode_BAMUM_LETTER_PHASE_C_NGGUM                            0x168BB
#define unicode_BAMUM_LETTER_PHASE_C_FUE                              0x168BC
#define unicode_BAMUM_LETTER_PHASE_C_NDEUT                            0x168BD
#define unicode_BAMUM_LETTER_PHASE_C_NSA                              0x168BE
#define unicode_BAMUM_LETTER_PHASE_C_NSHAQ                            0x168BF
#define unicode_BAMUM_LETTER_PHASE_C_BUNG                             0x168C0
#define unicode_BAMUM_LETTER_PHASE_C_VEUAEPEN                         0x168C1
#define unicode_BAMUM_LETTER_PHASE_C_MBERAE                           0x168C2
#define unicode_BAMUM_LETTER_PHASE_C_RU                               0x168C3
#define unicode_BAMUM_LETTER_PHASE_C_NJAEM                            0x168C4
#define unicode_BAMUM_LETTER_PHASE_C_LAM                              0x168C5
#define unicode_BAMUM_LETTER_PHASE_C_TITUAEP                          0x168C6
#define unicode_BAMUM_LETTER_PHASE_C_NSUOT_NGOM                       0x168C7
#define unicode_BAMUM_LETTER_PHASE_C_NJEEEE                           0x168C8
#define unicode_BAMUM_LETTER_PHASE_C_KET                              0x168C9
#define unicode_BAMUM_LETTER_PHASE_C_NGGU                             0x168CA
#define unicode_BAMUM_LETTER_PHASE_C_MAESI                            0x168CB
#define unicode_BAMUM_LETTER_PHASE_C_MBUAEM                           0x168CC
#define unicode_BAMUM_LETTER_PHASE_C_LU                               0x168CD
#define unicode_BAMUM_LETTER_PHASE_C_KUT                              0x168CE
#define unicode_BAMUM_LETTER_PHASE_C_NJAM                             0x168CF
#define unicode_BAMUM_LETTER_PHASE_C_NGOM                             0x168D0
#define unicode_BAMUM_LETTER_PHASE_C_WUP                              0x168D1
#define unicode_BAMUM_LETTER_PHASE_C_NGGUEET                          0x168D2
#define unicode_BAMUM_LETTER_PHASE_C_NSOM                             0x168D3
#define unicode_BAMUM_LETTER_PHASE_C_NTEN                             0x168D4
#define unicode_BAMUM_LETTER_PHASE_C_KUOP_NKAARAE                     0x168D5
#define unicode_BAMUM_LETTER_PHASE_C_NSUN                             0x168D6
#define unicode_BAMUM_LETTER_PHASE_C_NDAM                             0x168D7
#define unicode_BAMUM_LETTER_PHASE_C_MA_NSIEE                         0x168D8
#define unicode_BAMUM_LETTER_PHASE_C_YAA                              0x168D9
#define unicode_BAMUM_LETTER_PHASE_C_NDAP                             0x168DA
#define unicode_BAMUM_LETTER_PHASE_C_SHUEQ                            0x168DB
#define unicode_BAMUM_LETTER_PHASE_C_SETFON                           0x168DC
#define unicode_BAMUM_LETTER_PHASE_C_MBI                              0x168DD
#define unicode_BAMUM_LETTER_PHASE_C_MAEMBA                           0x168DE
#define unicode_BAMUM_LETTER_PHASE_C_MBANYI                           0x168DF
#define unicode_BAMUM_LETTER_PHASE_C_KEUSEUX                          0x168E0
#define unicode_BAMUM_LETTER_PHASE_C_MBEUX                            0x168E1
#define unicode_BAMUM_LETTER_PHASE_C_KEUM                             0x168E2
#define unicode_BAMUM_LETTER_PHASE_C_MBAA_PICKET                      0x168E3
#define unicode_BAMUM_LETTER_PHASE_C_YUWOQ                            0x168E4
#define unicode_BAMUM_LETTER_PHASE_C_NJEUX                            0x168E5
#define unicode_BAMUM_LETTER_PHASE_C_MIEE                             0x168E6
#define unicode_BAMUM_LETTER_PHASE_C_MUAE                             0x168E7
#define unicode_BAMUM_LETTER_PHASE_C_SHIQ                             0x168E8
#define unicode_BAMUM_LETTER_PHASE_C_KEN_LAW                          0x168E9
#define unicode_BAMUM_LETTER_PHASE_C_KEN_FATIGUE                      0x168EA
#define unicode_BAMUM_LETTER_PHASE_C_NGAQ                             0x168EB
#define unicode_BAMUM_LETTER_PHASE_C_NAQ                              0x168EC
#define unicode_BAMUM_LETTER_PHASE_C_LIQ                              0x168ED
#define unicode_BAMUM_LETTER_PHASE_C_PIN                              0x168EE
#define unicode_BAMUM_LETTER_PHASE_C_PEN                              0x168EF
#define unicode_BAMUM_LETTER_PHASE_C_TET                              0x168F0
#define unicode_BAMUM_LETTER_PHASE_D_MBUO                             0x168F1
#define unicode_BAMUM_LETTER_PHASE_D_WAP                              0x168F2
#define unicode_BAMUM_LETTER_PHASE_D_NJI                              0x168F3
#define unicode_BAMUM_LETTER_PHASE_D_MFON                             0x168F4
#define unicode_BAMUM_LETTER_PHASE_D_NJIEE                            0x168F5
#define unicode_BAMUM_LETTER_PHASE_D_LIEE                             0x168F6
#define unicode_BAMUM_LETTER_PHASE_D_NJEUT                            0x168F7
#define unicode_BAMUM_LETTER_PHASE_D_NSHEE                            0x168F8
#define unicode_BAMUM_LETTER_PHASE_D_NGGAAMAE                         0x168F9
#define unicode_BAMUM_LETTER_PHASE_D_NYAM                             0x168FA
#define unicode_BAMUM_LETTER_PHASE_D_WUAEN                            0x168FB
#define unicode_BAMUM_LETTER_PHASE_D_NGKUN                            0x168FC
#define unicode_BAMUM_LETTER_PHASE_D_SHEE                             0x168FD
#define unicode_BAMUM_LETTER_PHASE_D_NGKAP                            0x168FE
#define unicode_BAMUM_LETTER_PHASE_D_KEUAETMEUN                       0x168FF
#define unicode_BAMUM_LETTER_PHASE_D_TEUT                             0x16900
#define unicode_BAMUM_LETTER_PHASE_D_SHEUAE                           0x16901
#define unicode_BAMUM_LETTER_PHASE_D_NJAP                             0x16902
#define unicode_BAMUM_LETTER_PHASE_D_SUE                              0x16903
#define unicode_BAMUM_LETTER_PHASE_D_KET                              0x16904
#define unicode_BAMUM_LETTER_PHASE_D_YAEMMAE                          0x16905
#define unicode_BAMUM_LETTER_PHASE_D_KUOM                             0x16906
#define unicode_BAMUM_LETTER_PHASE_D_SAP                              0x16907
#define unicode_BAMUM_LETTER_PHASE_D_MFEUT                            0x16908
#define unicode_BAMUM_LETTER_PHASE_D_NDEUX                            0x16909
#define unicode_BAMUM_LETTER_PHASE_D_MALEERI                          0x1690A
#define unicode_BAMUM_LETTER_PHASE_D_MEUT                             0x1690B
#define unicode_BAMUM_LETTER_PHASE_D_SEUAEQ                           0x1690C
#define unicode_BAMUM_LETTER_PHASE_D_YEN                              0x1690D
#define unicode_BAMUM_LETTER_PHASE_D_NJEUAEM                          0x1690E
#define unicode_BAMUM_LETTER_PHASE_D_KEUOT_MBUAE                      0x1690F
#define unicode_BAMUM_LETTER_PHASE_D_NGKEURI                          0x16910
#define unicode_BAMUM_LETTER_PHASE_D_TU                               0x16911
#define unicode_BAMUM_LETTER_PHASE_D_GHAA                             0x16912
#define unicode_BAMUM_LETTER_PHASE_D_NGKYEE                           0x16913
#define unicode_BAMUM_LETTER_PHASE_D_FEUFEUAET                        0x16914
#define unicode_BAMUM_LETTER_PHASE_D_NDEE                             0x16915
#define unicode_BAMUM_LETTER_PHASE_D_MGBOFUM                          0x16916
#define unicode_BAMUM_LETTER_PHASE_D_LEUAEP                           0x16917
#define unicode_BAMUM_LETTER_PHASE_D_NDON                             0x16918
#define unicode_BAMUM_LETTER_PHASE_D_MONI                             0x16919
#define unicode_BAMUM_LETTER_PHASE_D_MGBEUN                           0x1691A
#define unicode_BAMUM_LETTER_PHASE_D_PUUT                             0x1691B
#define unicode_BAMUM_LETTER_PHASE_D_MGBIEE                           0x1691C
#define unicode_BAMUM_LETTER_PHASE_D_MFO                              0x1691D
#define unicode_BAMUM_LETTER_PHASE_D_LUM                              0x1691E
#define unicode_BAMUM_LETTER_PHASE_D_NSIEEP                           0x1691F
#define unicode_BAMUM_LETTER_PHASE_D_MBAA                             0x16920
#define unicode_BAMUM_LETTER_PHASE_D_KWAET                            0x16921
#define unicode_BAMUM_LETTER_PHASE_D_NYET                             0x16922
#define unicode_BAMUM_LETTER_PHASE_D_TEUAEN                           0x16923
#define unicode_BAMUM_LETTER_PHASE_D_SOT                              0x16924
#define unicode_BAMUM_LETTER_PHASE_D_YUWOQ                            0x16925
#define unicode_BAMUM_LETTER_PHASE_D_KEUM                             0x16926
#define unicode_BAMUM_LETTER_PHASE_D_RAEM                             0x16927
#define unicode_BAMUM_LETTER_PHASE_D_TEEEE                            0x16928
#define unicode_BAMUM_LETTER_PHASE_D_NGKEUAEQ                         0x16929
#define unicode_BAMUM_LETTER_PHASE_D_MFEUAE                           0x1692A
#define unicode_BAMUM_LETTER_PHASE_D_NSIEET                           0x1692B
#define unicode_BAMUM_LETTER_PHASE_D_KEUP                             0x1692C
#define unicode_BAMUM_LETTER_PHASE_D_PIP                              0x1692D
#define unicode_BAMUM_LETTER_PHASE_D_PEUTAE                           0x1692E
#define unicode_BAMUM_LETTER_PHASE_D_NYUE                             0x1692F
#define unicode_BAMUM_LETTER_PHASE_D_LET                              0x16930
#define unicode_BAMUM_LETTER_PHASE_D_NGGAAM                           0x16931
#define unicode_BAMUM_LETTER_PHASE_D_MFIEE                            0x16932
#define unicode_BAMUM_LETTER_PHASE_D_NGGWAEN                          0x16933
#define unicode_BAMUM_LETTER_PHASE_D_YUOM                             0x16934
#define unicode_BAMUM_LETTER_PHASE_D_PAP                              0x16935
#define unicode_BAMUM_LETTER_PHASE_D_YUOP                             0x16936
#define unicode_BAMUM_LETTER_PHASE_D_NDAM                             0x16937
#define unicode_BAMUM_LETTER_PHASE_D_NTEUM                            0x16938
#define unicode_BAMUM_LETTER_PHASE_D_SUAE                             0x16939
#define unicode_BAMUM_LETTER_PHASE_D_KUN                              0x1693A
#define unicode_BAMUM_LETTER_PHASE_D_NGGEUX                           0x1693B
#define unicode_BAMUM_LETTER_PHASE_D_NGKIEE                           0x1693C
#define unicode_BAMUM_LETTER_PHASE_D_TUOT                             0x1693D
#define unicode_BAMUM_LETTER_PHASE_D_MEUN                             0x1693E
#define unicode_BAMUM_LETTER_PHASE_D_KUQ                              0x1693F
#define unicode_BAMUM_LETTER_PHASE_D_NSUM                             0x16940
#define unicode_BAMUM_LETTER_PHASE_D_TEUN                             0x16941
#define unicode_BAMUM_LETTER_PHASE_D_MAENJET                          0x16942
#define unicode_BAMUM_LETTER_PHASE_D_NGGAP                            0x16943
#define unicode_BAMUM_LETTER_PHASE_D_LEUM                             0x16944
#define unicode_BAMUM_LETTER_PHASE_D_NGGUOM                           0x16945
#define unicode_BAMUM_LETTER_PHASE_D_NSHUT                            0x16946
#define unicode_BAMUM_LETTER_PHASE_D_NJUEQ                            0x16947
#define unicode_BAMUM_LETTER_PHASE_D_GHEUAE                           0x16948
#define unicode_BAMUM_LETTER_PHASE_D_KU                               0x16949
#define unicode_BAMUM_LETTER_PHASE_D_REN_OLD                          0x1694A
#define unicode_BAMUM_LETTER_PHASE_D_TAE                              0x1694B
#define unicode_BAMUM_LETTER_PHASE_D_TOQ                              0x1694C
#define unicode_BAMUM_LETTER_PHASE_D_NYI                              0x1694D
#define unicode_BAMUM_LETTER_PHASE_D_RII                              0x1694E
#define unicode_BAMUM_LETTER_PHASE_D_LEEEE                            0x1694F
#define unicode_BAMUM_LETTER_PHASE_D_MEEEE                            0x16950
#define unicode_BAMUM_LETTER_PHASE_D_M                                0x16951
#define unicode_BAMUM_LETTER_PHASE_D_SUU                              0x16952
#define unicode_BAMUM_LETTER_PHASE_D_MU                               0x16953
#define unicode_BAMUM_LETTER_PHASE_D_SHII                             0x16954
#define unicode_BAMUM_LETTER_PHASE_D_SHEUX                            0x16955
#define unicode_BAMUM_LETTER_PHASE_D_KYEE                             0x16956
#define unicode_BAMUM_LETTER_PHASE_D_NU                               0x16957
#define unicode_BAMUM_LETTER_PHASE_D_SHU                              0x16958
#define unicode_BAMUM_LETTER_PHASE_D_NTEE                             0x16959
#define unicode_BAMUM_LETTER_PHASE_D_PEE                              0x1695A
#define unicode_BAMUM_LETTER_PHASE_D_NI                               0x1695B
#define unicode_BAMUM_LETTER_PHASE_D_SHOQ                             0x1695C
#define unicode_BAMUM_LETTER_PHASE_D_PUQ                              0x1695D
#define unicode_BAMUM_LETTER_PHASE_D_MVOP                             0x1695E
#define unicode_BAMUM_LETTER_PHASE_D_LOQ                              0x1695F
#define unicode_BAMUM_LETTER_PHASE_D_REN_MUCH                         0x16960
#define unicode_BAMUM_LETTER_PHASE_D_TI                               0x16961
#define unicode_BAMUM_LETTER_PHASE_D_NTUU                             0x16962
#define unicode_BAMUM_LETTER_PHASE_D_MBAA_SEVEN                       0x16963
#define unicode_BAMUM_LETTER_PHASE_D_SAQ                              0x16964
#define unicode_BAMUM_LETTER_PHASE_D_FAA                              0x16965
#define unicode_BAMUM_LETTER_PHASE_E_NDAP                             0x16966
#define unicode_BAMUM_LETTER_PHASE_E_TOON                             0x16967
#define unicode_BAMUM_LETTER_PHASE_E_MBEUM                            0x16968
#define unicode_BAMUM_LETTER_PHASE_E_LAP                              0x16969
#define unicode_BAMUM_LETTER_PHASE_E_VOM                              0x1696A
#define unicode_BAMUM_LETTER_PHASE_E_LOON                             0x1696B
#define unicode_BAMUM_LETTER_PHASE_E_PAA                              0x1696C
#define unicode_BAMUM_LETTER_PHASE_E_SOM                              0x1696D
#define unicode_BAMUM_LETTER_PHASE_E_RAQ                              0x1696E
#define unicode_BAMUM_LETTER_PHASE_E_NSHUOP                           0x1696F
#define unicode_BAMUM_LETTER_PHASE_E_NDUN                             0x16970
#define unicode_BAMUM_LETTER_PHASE_E_PUAE                             0x16971
#define unicode_BAMUM_LETTER_PHASE_E_TAM                              0x16972
#define unicode_BAMUM_LETTER_PHASE_E_NGKA                             0x16973
#define unicode_BAMUM_LETTER_PHASE_E_KPEUX                            0x16974
#define unicode_BAMUM_LETTER_PHASE_E_WUO                              0x16975
#define unicode_BAMUM_LETTER_PHASE_E_SEE                              0x16976
#define unicode_BAMUM_LETTER_PHASE_E_NGGEUAET                         0x16977
#define unicode_BAMUM_LETTER_PHASE_E_PAAM                             0x16978
#define unicode_BAMUM_LETTER_PHASE_E_TOO                              0x16979
#define unicode_BAMUM_LETTER_PHASE_E_KUOP                             0x1697A
#define unicode_BAMUM_LETTER_PHASE_E_LOM                              0x1697B
#define unicode_BAMUM_LETTER_PHASE_E_NSHIEE                           0x1697C
#define unicode_BAMUM_LETTER_PHASE_E_NGOP                             0x1697D
#define unicode_BAMUM_LETTER_PHASE_E_MAEM                             0x1697E
#define unicode_BAMUM_LETTER_PHASE_E_NGKEUX                           0x1697F
#define unicode_BAMUM_LETTER_PHASE_E_NGOQ                             0x16980
#define unicode_BAMUM_LETTER_PHASE_E_NSHUE                            0x16981
#define unicode_BAMUM_LETTER_PHASE_E_RIMGBA                           0x16982
#define unicode_BAMUM_LETTER_PHASE_E_NJEUX                            0x16983
#define unicode_BAMUM_LETTER_PHASE_E_PEEM                             0x16984
#define unicode_BAMUM_LETTER_PHASE_E_SAA                              0x16985
#define unicode_BAMUM_LETTER_PHASE_E_NGGURAE                          0x16986
#define unicode_BAMUM_LETTER_PHASE_E_MGBA                             0x16987
#define unicode_BAMUM_LETTER_PHASE_E_GHEUX                            0x16988
#define unicode_BAMUM_LETTER_PHASE_E_NGKEUAEM                         0x16989
#define unicode_BAMUM_LETTER_PHASE_E_NJAEMLI                          0x1698A
#define unicode_BAMUM_LETTER_PHASE_E_MAP                              0x1698B
#define unicode_BAMUM_LETTER_PHASE_E_LOOT                             0x1698C
#define unicode_BAMUM_LETTER_PHASE_E_NGGEEEE                          0x1698D
#define unicode_BAMUM_LETTER_PHASE_E_NDIQ                             0x1698E
#define unicode_BAMUM_LETTER_PHASE_E_TAEN_NTEUM                       0x1698F
#define unicode_BAMUM_LETTER_PHASE_E_SET                              0x16990
#define unicode_BAMUM_LETTER_PHASE_E_PUM                              0x16991
#define unicode_BAMUM_LETTER_PHASE_E_NDAA_SOFTNESS                    0x16992
#define unicode_BAMUM_LETTER_PHASE_E_NGGUAESHAE_NYAM                  0x16993
#define unicode_BAMUM_LETTER_PHASE_E_YIEE                             0x16994
#define unicode_BAMUM_LETTER_PHASE_E_GHEUN                            0x16995
#define unicode_BAMUM_LETTER_PHASE_E_TUAE                             0x16996
#define unicode_BAMUM_LETTER_PHASE_E_YEUAE                            0x16997
#define unicode_BAMUM_LETTER_PHASE_E_PO                               0x16998
#define unicode_BAMUM_LETTER_PHASE_E_TUMAE                            0x16999
#define unicode_BAMUM_LETTER_PHASE_E_KEUAE                            0x1699A
#define unicode_BAMUM_LETTER_PHASE_E_SUAEN                            0x1699B
#define unicode_BAMUM_LETTER_PHASE_E_TEUAEQ                           0x1699C
#define unicode_BAMUM_LETTER_PHASE_E_VEUAE                            0x1699D
#define unicode_BAMUM_LETTER_PHASE_E_WEUX                             0x1699E
#define unicode_BAMUM_LETTER_PHASE_E_LAAM                             0x1699F
#define unicode_BAMUM_LETTER_PHASE_E_PU                               0x169A0
#define unicode_BAMUM_LETTER_PHASE_E_TAAQ                             0x169A1
#define unicode_BAMUM_LETTER_PHASE_E_GHAAMAE                          0x169A2
#define unicode_BAMUM_LETTER_PHASE_E_NGEUREUT                         0x169A3
#define unicode_BAMUM_LETTER_PHASE_E_SHEUAEQ                          0x169A4
#define unicode_BAMUM_LETTER_PHASE_E_MGBEN                            0x169A5
#define unicode_BAMUM_LETTER_PHASE_E_MBEE                             0x169A6
#define unicode_BAMUM_LETTER_PHASE_E_NZAQ                             0x169A7
#define unicode_BAMUM_LETTER_PHASE_E_NKOM                             0x169A8
#define unicode_BAMUM_LETTER_PHASE_E_GBET                             0x169A9
#define unicode_BAMUM_LETTER_PHASE_E_TUM                              0x169AA
#define unicode_BAMUM_LETTER_PHASE_E_KUET                             0x169AB
#define unicode_BAMUM_LETTER_PHASE_E_YAP                              0x169AC
#define unicode_BAMUM_LETTER_PHASE_E_NYI_CLEAVER                      0x169AD
#define unicode_BAMUM_LETTER_PHASE_E_YIT                              0x169AE
#define unicode_BAMUM_LETTER_PHASE_E_MFEUQ                            0x169AF
#define unicode_BAMUM_LETTER_PHASE_E_NDIAQ                            0x169B0
#define unicode_BAMUM_LETTER_PHASE_E_PIEEQ                            0x169B1
#define unicode_BAMUM_LETTER_PHASE_E_YUEQ                             0x169B2
#define unicode_BAMUM_LETTER_PHASE_E_LEUAEM                           0x169B3
#define unicode_BAMUM_LETTER_PHASE_E_FUE                              0x169B4
#define unicode_BAMUM_LETTER_PHASE_E_GBEUX                            0x169B5
#define unicode_BAMUM_LETTER_PHASE_E_NGKUP                            0x169B6
#define unicode_BAMUM_LETTER_PHASE_E_KET                              0x169B7
#define unicode_BAMUM_LETTER_PHASE_E_MAE                              0x169B8
#define unicode_BAMUM_LETTER_PHASE_E_NGKAAMI                          0x169B9
#define unicode_BAMUM_LETTER_PHASE_E_GHET                             0x169BA
#define unicode_BAMUM_LETTER_PHASE_E_FA                               0x169BB
#define unicode_BAMUM_LETTER_PHASE_E_NTUM                             0x169BC
#define unicode_BAMUM_LETTER_PHASE_E_PEUT                             0x169BD
#define unicode_BAMUM_LETTER_PHASE_E_YEUM                             0x169BE
#define unicode_BAMUM_LETTER_PHASE_E_NGGEUAE                          0x169BF
#define unicode_BAMUM_LETTER_PHASE_E_NYI_BETWEEN                      0x169C0
#define unicode_BAMUM_LETTER_PHASE_E_NZUQ                             0x169C1
#define unicode_BAMUM_LETTER_PHASE_E_POON                             0x169C2
#define unicode_BAMUM_LETTER_PHASE_E_MIEE                             0x169C3
#define unicode_BAMUM_LETTER_PHASE_E_FUET                             0x169C4
#define unicode_BAMUM_LETTER_PHASE_E_NAE                              0x169C5
#define unicode_BAMUM_LETTER_PHASE_E_MUAE                             0x169C6
#define unicode_BAMUM_LETTER_PHASE_E_GHEUAE                           0x169C7
#define unicode_BAMUM_LETTER_PHASE_E_FU_I                             0x169C8
#define unicode_BAMUM_LETTER_PHASE_E_MVI                              0x169C9
#define unicode_BAMUM_LETTER_PHASE_E_PUAQ                             0x169CA
#define unicode_BAMUM_LETTER_PHASE_E_NGKUM                            0x169CB
#define unicode_BAMUM_LETTER_PHASE_E_KUT                              0x169CC
#define unicode_BAMUM_LETTER_PHASE_E_PIET                             0x169CD
#define unicode_BAMUM_LETTER_PHASE_E_NTAP                             0x169CE
#define unicode_BAMUM_LETTER_PHASE_E_YEUAET                           0x169CF
#define unicode_BAMUM_LETTER_PHASE_E_NGGUP                            0x169D0
#define unicode_BAMUM_LETTER_PHASE_E_PA_PEOPLE                        0x169D1
#define unicode_BAMUM_LETTER_PHASE_E_FU_CALL                          0x169D2
#define unicode_BAMUM_LETTER_PHASE_E_FOM                              0x169D3
#define unicode_BAMUM_LETTER_PHASE_E_NJEE                             0x169D4
#define unicode_BAMUM_LETTER_PHASE_E_A                                0x169D5
#define unicode_BAMUM_LETTER_PHASE_E_TOQ                              0x169D6
#define unicode_BAMUM_LETTER_PHASE_E_O                                0x169D7
#define unicode_BAMUM_LETTER_PHASE_E_I                                0x169D8
#define unicode_BAMUM_LETTER_PHASE_E_LAQ                              0x169D9
#define unicode_BAMUM_LETTER_PHASE_E_PA_PLURAL                        0x169DA
#define unicode_BAMUM_LETTER_PHASE_E_TAA                              0x169DB
#define unicode_BAMUM_LETTER_PHASE_E_TAQ                              0x169DC
#define unicode_BAMUM_LETTER_PHASE_E_NDAA_MY_HOUSE                    0x169DD
#define unicode_BAMUM_LETTER_PHASE_E_SHIQ                             0x169DE
#define unicode_BAMUM_LETTER_PHASE_E_YEUX                             0x169DF
#define unicode_BAMUM_LETTER_PHASE_E_NGUAE                            0x169E0
#define unicode_BAMUM_LETTER_PHASE_E_YUAEN                            0x169E1
#define unicode_BAMUM_LETTER_PHASE_E_YOQ_SWIMMING                     0x169E2
#define unicode_BAMUM_LETTER_PHASE_E_YOQ_COVER                        0x169E3
#define unicode_BAMUM_LETTER_PHASE_E_YUQ                              0x169E4
#define unicode_BAMUM_LETTER_PHASE_E_YUN                              0x169E5
#define unicode_BAMUM_LETTER_PHASE_E_KEUX                             0x169E6
#define unicode_BAMUM_LETTER_PHASE_E_PEUX                             0x169E7
#define unicode_BAMUM_LETTER_PHASE_E_NJEE_EPOCH                       0x169E8
#define unicode_BAMUM_LETTER_PHASE_E_PUE                              0x169E9
#define unicode_BAMUM_LETTER_PHASE_E_WUE                              0x169EA
#define unicode_BAMUM_LETTER_PHASE_E_FEE                              0x169EB
#define unicode_BAMUM_LETTER_PHASE_E_VEE                              0x169EC
#define unicode_BAMUM_LETTER_PHASE_E_LU                               0x169ED
#define unicode_BAMUM_LETTER_PHASE_E_MI                               0x169EE
#define unicode_BAMUM_LETTER_PHASE_E_REUX                             0x169EF
#define unicode_BAMUM_LETTER_PHASE_E_RAE                              0x169F0
#define unicode_BAMUM_LETTER_PHASE_E_NGUAET                           0x169F1
#define unicode_BAMUM_LETTER_PHASE_E_NGA                              0x169F2
#define unicode_BAMUM_LETTER_PHASE_E_SHO                              0x169F3
#define unicode_BAMUM_LETTER_PHASE_E_SHOQ                             0x169F4
#define unicode_BAMUM_LETTER_PHASE_E_FU_REMEDY                        0x169F5
#define unicode_BAMUM_LETTER_PHASE_E_NA                               0x169F6
#define unicode_BAMUM_LETTER_PHASE_E_PI                               0x169F7
#define unicode_BAMUM_LETTER_PHASE_E_LOQ                              0x169F8
#define unicode_BAMUM_LETTER_PHASE_E_KO                               0x169F9
#define unicode_BAMUM_LETTER_PHASE_E_MEN                              0x169FA
#define unicode_BAMUM_LETTER_PHASE_E_MA                               0x169FB
#define unicode_BAMUM_LETTER_PHASE_E_MAQ                              0x169FC
#define unicode_BAMUM_LETTER_PHASE_E_TEU                              0x169FD
#define unicode_BAMUM_LETTER_PHASE_E_KI                               0x169FE
#define unicode_BAMUM_LETTER_PHASE_E_MON                              0x169FF
#define unicode_BAMUM_LETTER_PHASE_E_TEN                              0x16A00
#define unicode_BAMUM_LETTER_PHASE_E_FAQ                              0x16A01
#define unicode_BAMUM_LETTER_PHASE_E_GHOM                             0x16A02
#define unicode_BAMUM_LETTER_PHASE_F_KA                               0x16A03
#define unicode_BAMUM_LETTER_PHASE_F_U                                0x16A04
#define unicode_BAMUM_LETTER_PHASE_F_KU                               0x16A05
#define unicode_BAMUM_LETTER_PHASE_F_EE                               0x16A06
#define unicode_BAMUM_LETTER_PHASE_F_REE                              0x16A07
#define unicode_BAMUM_LETTER_PHASE_F_TAE                              0x16A08
#define unicode_BAMUM_LETTER_PHASE_F_NYI                              0x16A09
#define unicode_BAMUM_LETTER_PHASE_F_LA                               0x16A0A
#define unicode_BAMUM_LETTER_PHASE_F_RII                              0x16A0B
#define unicode_BAMUM_LETTER_PHASE_F_RIEE                             0x16A0C
#define unicode_BAMUM_LETTER_PHASE_F_MEEEE                            0x16A0D
#define unicode_BAMUM_LETTER_PHASE_F_TAA                              0x16A0E
#define unicode_BAMUM_LETTER_PHASE_F_NDAA                             0x16A0F
#define unicode_BAMUM_LETTER_PHASE_F_NJAEM                            0x16A10
#define unicode_BAMUM_LETTER_PHASE_F_M                                0x16A11
#define unicode_BAMUM_LETTER_PHASE_F_SUU                              0x16A12
#define unicode_BAMUM_LETTER_PHASE_F_SHII                             0x16A13
#define unicode_BAMUM_LETTER_PHASE_F_SI                               0x16A14
#define unicode_BAMUM_LETTER_PHASE_F_SEUX                             0x16A15
#define unicode_BAMUM_LETTER_PHASE_F_KYEE                             0x16A16
#define unicode_BAMUM_LETTER_PHASE_F_KET                              0x16A17
#define unicode_BAMUM_LETTER_PHASE_F_NUAE                             0x16A18
#define unicode_BAMUM_LETTER_PHASE_F_NU                               0x16A19
#define unicode_BAMUM_LETTER_PHASE_F_NJUAE                            0x16A1A
#define unicode_BAMUM_LETTER_PHASE_F_YOQ                              0x16A1B
#define unicode_BAMUM_LETTER_PHASE_F_SHU                              0x16A1C
#define unicode_BAMUM_LETTER_PHASE_F_YA                               0x16A1D
#define unicode_BAMUM_LETTER_PHASE_F_NSHA                             0x16A1E
#define unicode_BAMUM_LETTER_PHASE_F_PEUX                             0x16A1F
#define unicode_BAMUM_LETTER_PHASE_F_NTEE                             0x16A20
#define unicode_BAMUM_LETTER_PHASE_F_WUE                              0x16A21
#define unicode_BAMUM_LETTER_PHASE_F_PEE                              0x16A22
#define unicode_BAMUM_LETTER_PHASE_F_RU                               0x16A23
#define unicode_BAMUM_LETTER_PHASE_F_NI                               0x16A24
#define unicode_BAMUM_LETTER_PHASE_F_REUX                             0x16A25
#define unicode_BAMUM_LETTER_PHASE_F_KEN                              0x16A26
#define unicode_BAMUM_LETTER_PHASE_F_NGKWAEN                          0x16A27
#define unicode_BAMUM_LETTER_PHASE_F_NGGA                             0x16A28
#define unicode_BAMUM_LETTER_PHASE_F_SHO                              0x16A29
#define unicode_BAMUM_LETTER_PHASE_F_PUAE                             0x16A2A
#define unicode_BAMUM_LETTER_PHASE_F_FOM                              0x16A2B
#define unicode_BAMUM_LETTER_PHASE_F_WA                               0x16A2C
#define unicode_BAMUM_LETTER_PHASE_F_LI                               0x16A2D
#define unicode_BAMUM_LETTER_PHASE_F_LOQ                              0x16A2E
#define unicode_BAMUM_LETTER_PHASE_F_KO                               0x16A2F
#define unicode_BAMUM_LETTER_PHASE_F_MBEN                             0x16A30
#define unicode_BAMUM_LETTER_PHASE_F_REN                              0x16A31
#define unicode_BAMUM_LETTER_PHASE_F_MA                               0x16A32
#define unicode_BAMUM_LETTER_PHASE_F_MO                               0x16A33
#define unicode_BAMUM_LETTER_PHASE_F_MBAA                             0x16A34
#define unicode_BAMUM_LETTER_PHASE_F_TET                              0x16A35
#define unicode_BAMUM_LETTER_PHASE_F_KPA                              0x16A36
#define unicode_BAMUM_LETTER_PHASE_F_SAMBA                            0x16A37
#define unicode_BAMUM_LETTER_PHASE_F_VUEQ                             0x16A38
#define unicode_MRO_LETTER_TA                                         0x16A40
#define unicode_MRO_LETTER_NGI                                        0x16A41
#define unicode_MRO_LETTER_YO                                         0x16A42
#define unicode_MRO_LETTER_MIM                                        0x16A43
#define unicode_MRO_LETTER_BA                                         0x16A44
#define unicode_MRO_LETTER_DA                                         0x16A45
#define unicode_MRO_LETTER_A                                          0x16A46
#define unicode_MRO_LETTER_PHI                                        0x16A47
#define unicode_MRO_LETTER_KHAI                                       0x16A48
#define unicode_MRO_LETTER_HAO                                        0x16A49
#define unicode_MRO_LETTER_DAI                                        0x16A4A
#define unicode_MRO_LETTER_CHU                                        0x16A4B
#define unicode_MRO_LETTER_KEAAE                                      0x16A4C
#define unicode_MRO_LETTER_OL                                         0x16A4D
#define unicode_MRO_LETTER_MAEM                                       0x16A4E
#define unicode_MRO_LETTER_NIN                                        0x16A4F
#define unicode_MRO_LETTER_PA                                         0x16A50
#define unicode_MRO_LETTER_OO                                         0x16A51
#define unicode_MRO_LETTER_O                                          0x16A52
#define unicode_MRO_LETTER_RO                                         0x16A53
#define unicode_MRO_LETTER_SHI                                        0x16A54
#define unicode_MRO_LETTER_THEA                                       0x16A55
#define unicode_MRO_LETTER_EA                                         0x16A56
#define unicode_MRO_LETTER_WA                                         0x16A57
#define unicode_MRO_LETTER_E                                          0x16A58
#define unicode_MRO_LETTER_KO                                         0x16A59
#define unicode_MRO_LETTER_LAN                                        0x16A5A
#define unicode_MRO_LETTER_LA                                         0x16A5B
#define unicode_MRO_LETTER_HAI                                        0x16A5C
#define unicode_MRO_LETTER_RI                                         0x16A5D
#define unicode_MRO_LETTER_TEK                                        0x16A5E
#define unicode_MRO_DIGIT_ZERO                                        0x16A60
#define unicode_MRO_DIGIT_ONE                                         0x16A61
#define unicode_MRO_DIGIT_TWO                                         0x16A62
#define unicode_MRO_DIGIT_THREE                                       0x16A63
#define unicode_MRO_DIGIT_FOUR                                        0x16A64
#define unicode_MRO_DIGIT_FIVE                                        0x16A65
#define unicode_MRO_DIGIT_SIX                                         0x16A66
#define unicode_MRO_DIGIT_SEVEN                                       0x16A67
#define unicode_MRO_DIGIT_EIGHT                                       0x16A68
#define unicode_MRO_DIGIT_NINE                                        0x16A69
#define unicode_MRO_DANDA                                             0x16A6E
#define unicode_MRO_DOUBLE_DANDA                                      0x16A6F
#define unicode_BASSA_VAH_LETTER_ENNI                                 0x16AD0
#define unicode_BASSA_VAH_LETTER_KA                                   0x16AD1
#define unicode_BASSA_VAH_LETTER_SE                                   0x16AD2
#define unicode_BASSA_VAH_LETTER_FA                                   0x16AD3
#define unicode_BASSA_VAH_LETTER_MBE                                  0x16AD4
#define unicode_BASSA_VAH_LETTER_YIE                                  0x16AD5
#define unicode_BASSA_VAH_LETTER_GAH                                  0x16AD6
#define unicode_BASSA_VAH_LETTER_DHII                                 0x16AD7
#define unicode_BASSA_VAH_LETTER_KPAH                                 0x16AD8
#define unicode_BASSA_VAH_LETTER_JO                                   0x16AD9
#define unicode_BASSA_VAH_LETTER_HWAH                                 0x16ADA
#define unicode_BASSA_VAH_LETTER_WA                                   0x16ADB
#define unicode_BASSA_VAH_LETTER_ZO                                   0x16ADC
#define unicode_BASSA_VAH_LETTER_GBU                                  0x16ADD
#define unicode_BASSA_VAH_LETTER_DO                                   0x16ADE
#define unicode_BASSA_VAH_LETTER_CE                                   0x16ADF
#define unicode_BASSA_VAH_LETTER_UWU                                  0x16AE0
#define unicode_BASSA_VAH_LETTER_TO                                   0x16AE1
#define unicode_BASSA_VAH_LETTER_BA                                   0x16AE2
#define unicode_BASSA_VAH_LETTER_VU                                   0x16AE3
#define unicode_BASSA_VAH_LETTER_YEIN                                 0x16AE4
#define unicode_BASSA_VAH_LETTER_PA                                   0x16AE5
#define unicode_BASSA_VAH_LETTER_WADDA                                0x16AE6
#define unicode_BASSA_VAH_LETTER_A                                    0x16AE7
#define unicode_BASSA_VAH_LETTER_O                                    0x16AE8
#define unicode_BASSA_VAH_LETTER_OO                                   0x16AE9
#define unicode_BASSA_VAH_LETTER_U                                    0x16AEA
#define unicode_BASSA_VAH_LETTER_EE                                   0x16AEB
#define unicode_BASSA_VAH_LETTER_E                                    0x16AEC
#define unicode_BASSA_VAH_LETTER_I                                    0x16AED
#define unicode_BASSA_VAH_COMBINING_HIGH_TONE                         0x16AF0
#define unicode_BASSA_VAH_COMBINING_LOW_TONE                          0x16AF1
#define unicode_BASSA_VAH_COMBINING_MID_TONE                          0x16AF2
#define unicode_BASSA_VAH_COMBINING_LOW_MID_TONE                      0x16AF3
#define unicode_BASSA_VAH_COMBINING_HIGH_LOW_TONE                     0x16AF4
#define unicode_BASSA_VAH_FULL_STOP                                   0x16AF5
#define unicode_PAHAWH_HMONG_VOWEL_KEEB                               0x16B00
#define unicode_PAHAWH_HMONG_VOWEL_KEEV                               0x16B01
#define unicode_PAHAWH_HMONG_VOWEL_KIB                                0x16B02
#define unicode_PAHAWH_HMONG_VOWEL_KIV                                0x16B03
#define unicode_PAHAWH_HMONG_VOWEL_KAUB                               0x16B04
#define unicode_PAHAWH_HMONG_VOWEL_KAUV                               0x16B05
#define unicode_PAHAWH_HMONG_VOWEL_KUB                                0x16B06
#define unicode_PAHAWH_HMONG_VOWEL_KUV                                0x16B07
#define unicode_PAHAWH_HMONG_VOWEL_KEB                                0x16B08
#define unicode_PAHAWH_HMONG_VOWEL_KEV                                0x16B09
#define unicode_PAHAWH_HMONG_VOWEL_KAIB                               0x16B0A
#define unicode_PAHAWH_HMONG_VOWEL_KAIV                               0x16B0B
#define unicode_PAHAWH_HMONG_VOWEL_KOOB                               0x16B0C
#define unicode_PAHAWH_HMONG_VOWEL_KOOV                               0x16B0D
#define unicode_PAHAWH_HMONG_VOWEL_KAWB                               0x16B0E
#define unicode_PAHAWH_HMONG_VOWEL_KAWV                               0x16B0F
#define unicode_PAHAWH_HMONG_VOWEL_KUAB                               0x16B10
#define unicode_PAHAWH_HMONG_VOWEL_KUAV                               0x16B11
#define unicode_PAHAWH_HMONG_VOWEL_KOB                                0x16B12
#define unicode_PAHAWH_HMONG_VOWEL_KOV                                0x16B13
#define unicode_PAHAWH_HMONG_VOWEL_KIAB                               0x16B14
#define unicode_PAHAWH_HMONG_VOWEL_KIAV                               0x16B15
#define unicode_PAHAWH_HMONG_VOWEL_KAB                                0x16B16
#define unicode_PAHAWH_HMONG_VOWEL_KAV                                0x16B17
#define unicode_PAHAWH_HMONG_VOWEL_KWB                                0x16B18
#define unicode_PAHAWH_HMONG_VOWEL_KWV                                0x16B19
#define unicode_PAHAWH_HMONG_VOWEL_KAAB                               0x16B1A
#define unicode_PAHAWH_HMONG_VOWEL_KAAV                               0x16B1B
#define unicode_PAHAWH_HMONG_CONSONANT_VAU                            0x16B1C
#define unicode_PAHAWH_HMONG_CONSONANT_NTSAU                          0x16B1D
#define unicode_PAHAWH_HMONG_CONSONANT_LAU                            0x16B1E
#define unicode_PAHAWH_HMONG_CONSONANT_HAU                            0x16B1F
#define unicode_PAHAWH_HMONG_CONSONANT_NLAU                           0x16B20
#define unicode_PAHAWH_HMONG_CONSONANT_RAU                            0x16B21
#define unicode_PAHAWH_HMONG_CONSONANT_NKAU                           0x16B22
#define unicode_PAHAWH_HMONG_CONSONANT_QHAU                           0x16B23
#define unicode_PAHAWH_HMONG_CONSONANT_YAU                            0x16B24
#define unicode_PAHAWH_HMONG_CONSONANT_HLAU                           0x16B25
#define unicode_PAHAWH_HMONG_CONSONANT_MAU                            0x16B26
#define unicode_PAHAWH_HMONG_CONSONANT_CHAU                           0x16B27
#define unicode_PAHAWH_HMONG_CONSONANT_NCHAU                          0x16B28
#define unicode_PAHAWH_HMONG_CONSONANT_HNAU                           0x16B29
#define unicode_PAHAWH_HMONG_CONSONANT_PLHAU                          0x16B2A
#define unicode_PAHAWH_HMONG_CONSONANT_NTHAU                          0x16B2B
#define unicode_PAHAWH_HMONG_CONSONANT_NAU                            0x16B2C
#define unicode_PAHAWH_HMONG_CONSONANT_AU                             0x16B2D
#define unicode_PAHAWH_HMONG_CONSONANT_XAU                            0x16B2E
#define unicode_PAHAWH_HMONG_CONSONANT_CAU                            0x16B2F
#define unicode_PAHAWH_HMONG_MARK_CIM_TUB                             0x16B30
#define unicode_PAHAWH_HMONG_MARK_CIM_SO                              0x16B31
#define unicode_PAHAWH_HMONG_MARK_CIM_KES                             0x16B32
#define unicode_PAHAWH_HMONG_MARK_CIM_KHAV                            0x16B33
#define unicode_PAHAWH_HMONG_MARK_CIM_SUAM                            0x16B34
#define unicode_PAHAWH_HMONG_MARK_CIM_HOM                             0x16B35
#define unicode_PAHAWH_HMONG_MARK_CIM_TAUM                            0x16B36
#define unicode_PAHAWH_HMONG_SIGN_VOS_THOM                            0x16B37
#define unicode_PAHAWH_HMONG_SIGN_VOS_TSHAB_CEEB                      0x16B38
#define unicode_PAHAWH_HMONG_SIGN_CIM_CHEEM                           0x16B39
#define unicode_PAHAWH_HMONG_SIGN_VOS_THIAB                           0x16B3A
#define unicode_PAHAWH_HMONG_SIGN_VOS_FEEM                            0x16B3B
#define unicode_PAHAWH_HMONG_SIGN_XYEEM_NTXIV                         0x16B3C
#define unicode_PAHAWH_HMONG_SIGN_XYEEM_RHO                           0x16B3D
#define unicode_PAHAWH_HMONG_SIGN_XYEEM_TOV                           0x16B3E
#define unicode_PAHAWH_HMONG_SIGN_XYEEM_FAIB                          0x16B3F
#define unicode_PAHAWH_HMONG_SIGN_VOS_SEEV                            0x16B40
#define unicode_PAHAWH_HMONG_SIGN_MEEJ_SUAB                           0x16B41
#define unicode_PAHAWH_HMONG_SIGN_VOS_NRUA                            0x16B42
#define unicode_PAHAWH_HMONG_SIGN_IB_YAM                              0x16B43
#define unicode_PAHAWH_HMONG_SIGN_XAUS                                0x16B44
#define unicode_PAHAWH_HMONG_SIGN_CIM_TSOV_ROG                        0x16B45
#define unicode_PAHAWH_HMONG_DIGIT_ZERO                               0x16B50
#define unicode_PAHAWH_HMONG_DIGIT_ONE                                0x16B51
#define unicode_PAHAWH_HMONG_DIGIT_TWO                                0x16B52
#define unicode_PAHAWH_HMONG_DIGIT_THREE                              0x16B53
#define unicode_PAHAWH_HMONG_DIGIT_FOUR                               0x16B54
#define unicode_PAHAWH_HMONG_DIGIT_FIVE                               0x16B55
#define unicode_PAHAWH_HMONG_DIGIT_SIX                                0x16B56
#define unicode_PAHAWH_HMONG_DIGIT_SEVEN                              0x16B57
#define unicode_PAHAWH_HMONG_DIGIT_EIGHT                              0x16B58
#define unicode_PAHAWH_HMONG_DIGIT_NINE                               0x16B59
#define unicode_PAHAWH_HMONG_NUMBER_TENS                              0x16B5B
#define unicode_PAHAWH_HMONG_NUMBER_HUNDREDS                          0x16B5C
#define unicode_PAHAWH_HMONG_NUMBER_TEN_THOUSANDS                     0x16B5D
#define unicode_PAHAWH_HMONG_NUMBER_MILLIONS                          0x16B5E
#define unicode_PAHAWH_HMONG_NUMBER_HUNDRED_MILLIONS                  0x16B5F
#define unicode_PAHAWH_HMONG_NUMBER_TEN_BILLIONS                      0x16B60
#define unicode_PAHAWH_HMONG_NUMBER_TRILLIONS                         0x16B61
#define unicode_PAHAWH_HMONG_SIGN_VOS_LUB                             0x16B63
#define unicode_PAHAWH_HMONG_SIGN_XYOO                                0x16B64
#define unicode_PAHAWH_HMONG_SIGN_HLI                                 0x16B65
#define unicode_PAHAWH_HMONG_SIGN_THIRD_STAGE_HLI                     0x16B66
#define unicode_PAHAWH_HMONG_SIGN_ZWJ_THAJ                            0x16B67
#define unicode_PAHAWH_HMONG_SIGN_HNUB                                0x16B68
#define unicode_PAHAWH_HMONG_SIGN_NQIG                                0x16B69
#define unicode_PAHAWH_HMONG_SIGN_XIAB                                0x16B6A
#define unicode_PAHAWH_HMONG_SIGN_NTUJ                                0x16B6B
#define unicode_PAHAWH_HMONG_SIGN_AV                                  0x16B6C
#define unicode_PAHAWH_HMONG_SIGN_TXHEEJ_CEEV                         0x16B6D
#define unicode_PAHAWH_HMONG_SIGN_MEEJ_TSEEB                          0x16B6E
#define unicode_PAHAWH_HMONG_SIGN_TAU                                 0x16B6F
#define unicode_PAHAWH_HMONG_SIGN_LOS                                 0x16B70
#define unicode_PAHAWH_HMONG_SIGN_MUS                                 0x16B71
#define unicode_PAHAWH_HMONG_SIGN_CIM_HAIS_LUS_NTOG_NTOG              0x16B72
#define unicode_PAHAWH_HMONG_SIGN_CIM_CUAM_TSHOOJ                     0x16B73
#define unicode_PAHAWH_HMONG_SIGN_CIM_TXWV                            0x16B74
#define unicode_PAHAWH_HMONG_SIGN_CIM_TXWV_CHWV                       0x16B75
#define unicode_PAHAWH_HMONG_SIGN_CIM_PUB_DAWB                        0x16B76
#define unicode_PAHAWH_HMONG_SIGN_CIM_NRES_TOS                        0x16B77
#define unicode_PAHAWH_HMONG_CLAN_SIGN_TSHEEJ                         0x16B7D
#define unicode_PAHAWH_HMONG_CLAN_SIGN_YEEG                           0x16B7E
#define unicode_PAHAWH_HMONG_CLAN_SIGN_LIS                            0x16B7F
#define unicode_PAHAWH_HMONG_CLAN_SIGN_LAUJ                           0x16B80
#define unicode_PAHAWH_HMONG_CLAN_SIGN_XYOOJ                          0x16B81
#define unicode_PAHAWH_HMONG_CLAN_SIGN_KOO                            0x16B82
#define unicode_PAHAWH_HMONG_CLAN_SIGN_HAWJ                           0x16B83
#define unicode_PAHAWH_HMONG_CLAN_SIGN_MUAS                           0x16B84
#define unicode_PAHAWH_HMONG_CLAN_SIGN_THOJ                           0x16B85
#define unicode_PAHAWH_HMONG_CLAN_SIGN_TSAB                           0x16B86
#define unicode_PAHAWH_HMONG_CLAN_SIGN_PHAB                           0x16B87
#define unicode_PAHAWH_HMONG_CLAN_SIGN_KHAB                           0x16B88
#define unicode_PAHAWH_HMONG_CLAN_SIGN_HAM                            0x16B89
#define unicode_PAHAWH_HMONG_CLAN_SIGN_VAJ                            0x16B8A
#define unicode_PAHAWH_HMONG_CLAN_SIGN_FAJ                            0x16B8B
#define unicode_PAHAWH_HMONG_CLAN_SIGN_YAJ                            0x16B8C
#define unicode_PAHAWH_HMONG_CLAN_SIGN_TSWB                           0x16B8D
#define unicode_PAHAWH_HMONG_CLAN_SIGN_KWM                            0x16B8E
#define unicode_PAHAWH_HMONG_CLAN_SIGN_VWJ                            0x16B8F
#define unicode_MIAO_LETTER_PA                                        0x16F00
#define unicode_MIAO_LETTER_BA                                        0x16F01
#define unicode_MIAO_LETTER_YI_PA                                     0x16F02
#define unicode_MIAO_LETTER_PLA                                       0x16F03
#define unicode_MIAO_LETTER_MA                                        0x16F04
#define unicode_MIAO_LETTER_MHA                                       0x16F05
#define unicode_MIAO_LETTER_ARCHAIC_MA                                0x16F06
#define unicode_MIAO_LETTER_FA                                        0x16F07
#define unicode_MIAO_LETTER_VA                                        0x16F08
#define unicode_MIAO_LETTER_VFA                                       0x16F09
#define unicode_MIAO_LETTER_TA                                        0x16F0A
#define unicode_MIAO_LETTER_DA                                        0x16F0B
#define unicode_MIAO_LETTER_YI_TTA                                    0x16F0C
#define unicode_MIAO_LETTER_YI_TA                                     0x16F0D
#define unicode_MIAO_LETTER_TTA                                       0x16F0E
#define unicode_MIAO_LETTER_DDA                                       0x16F0F
#define unicode_MIAO_LETTER_NA                                        0x16F10
#define unicode_MIAO_LETTER_NHA                                       0x16F11
#define unicode_MIAO_LETTER_YI_NNA                                    0x16F12
#define unicode_MIAO_LETTER_ARCHAIC_NA                                0x16F13
#define unicode_MIAO_LETTER_NNA                                       0x16F14
#define unicode_MIAO_LETTER_NNHA                                      0x16F15
#define unicode_MIAO_LETTER_LA                                        0x16F16
#define unicode_MIAO_LETTER_LYA                                       0x16F17
#define unicode_MIAO_LETTER_LHA                                       0x16F18
#define unicode_MIAO_LETTER_LHYA                                      0x16F19
#define unicode_MIAO_LETTER_TLHA                                      0x16F1A
#define unicode_MIAO_LETTER_DLHA                                      0x16F1B
#define unicode_MIAO_LETTER_TLHYA                                     0x16F1C
#define unicode_MIAO_LETTER_DLHYA                                     0x16F1D
#define unicode_MIAO_LETTER_KA                                        0x16F1E
#define unicode_MIAO_LETTER_GA                                        0x16F1F
#define unicode_MIAO_LETTER_YI_KA                                     0x16F20
#define unicode_MIAO_LETTER_QA                                        0x16F21
#define unicode_MIAO_LETTER_QGA                                       0x16F22
#define unicode_MIAO_LETTER_NGA                                       0x16F23
#define unicode_MIAO_LETTER_NGHA                                      0x16F24
#define unicode_MIAO_LETTER_ARCHAIC_NGA                               0x16F25
#define unicode_MIAO_LETTER_HA                                        0x16F26
#define unicode_MIAO_LETTER_XA                                        0x16F27
#define unicode_MIAO_LETTER_GHA                                       0x16F28
#define unicode_MIAO_LETTER_GHHA                                      0x16F29
#define unicode_MIAO_LETTER_TSSA                                      0x16F2A
#define unicode_MIAO_LETTER_DZZA                                      0x16F2B
#define unicode_MIAO_LETTER_NYA                                       0x16F2C
#define unicode_MIAO_LETTER_NYHA                                      0x16F2D
#define unicode_MIAO_LETTER_TSHA                                      0x16F2E
#define unicode_MIAO_LETTER_DZHA                                      0x16F2F
#define unicode_MIAO_LETTER_YI_TSHA                                   0x16F30
#define unicode_MIAO_LETTER_YI_DZHA                                   0x16F31
#define unicode_MIAO_LETTER_REFORMED_TSHA                             0x16F32
#define unicode_MIAO_LETTER_SHA                                       0x16F33
#define unicode_MIAO_LETTER_SSA                                       0x16F34
#define unicode_MIAO_LETTER_ZHA                                       0x16F35
#define unicode_MIAO_LETTER_ZSHA                                      0x16F36
#define unicode_MIAO_LETTER_TSA                                       0x16F37
#define unicode_MIAO_LETTER_DZA                                       0x16F38
#define unicode_MIAO_LETTER_YI_TSA                                    0x16F39
#define unicode_MIAO_LETTER_SA                                        0x16F3A
#define unicode_MIAO_LETTER_ZA                                        0x16F3B
#define unicode_MIAO_LETTER_ZSA                                       0x16F3C
#define unicode_MIAO_LETTER_ZZA                                       0x16F3D
#define unicode_MIAO_LETTER_ZZSA                                      0x16F3E
#define unicode_MIAO_LETTER_ARCHAIC_ZZA                               0x16F3F
#define unicode_MIAO_LETTER_ZZYA                                      0x16F40
#define unicode_MIAO_LETTER_ZZSYA                                     0x16F41
#define unicode_MIAO_LETTER_WA                                        0x16F42
#define unicode_MIAO_LETTER_AH                                        0x16F43
#define unicode_MIAO_LETTER_HHA                                       0x16F44
#define unicode_MIAO_LETTER_NASALIZATION                              0x16F50
#define unicode_MIAO_SIGN_ASPIRATION                                  0x16F51
#define unicode_MIAO_SIGN_REFORMED_VOICING                            0x16F52
#define unicode_MIAO_SIGN_REFORMED_ASPIRATION                         0x16F53
#define unicode_MIAO_VOWEL_SIGN_A                                     0x16F54
#define unicode_MIAO_VOWEL_SIGN_AA                                    0x16F55
#define unicode_MIAO_VOWEL_SIGN_AHH                                   0x16F56
#define unicode_MIAO_VOWEL_SIGN_AN                                    0x16F57
#define unicode_MIAO_VOWEL_SIGN_ANG                                   0x16F58
#define unicode_MIAO_VOWEL_SIGN_O                                     0x16F59
#define unicode_MIAO_VOWEL_SIGN_OO                                    0x16F5A
#define unicode_MIAO_VOWEL_SIGN_WO                                    0x16F5B
#define unicode_MIAO_VOWEL_SIGN_W                                     0x16F5C
#define unicode_MIAO_VOWEL_SIGN_E                                     0x16F5D
#define unicode_MIAO_VOWEL_SIGN_EN                                    0x16F5E
#define unicode_MIAO_VOWEL_SIGN_ENG                                   0x16F5F
#define unicode_MIAO_VOWEL_SIGN_OEY                                   0x16F60
#define unicode_MIAO_VOWEL_SIGN_I                                     0x16F61
#define unicode_MIAO_VOWEL_SIGN_IA                                    0x16F62
#define unicode_MIAO_VOWEL_SIGN_IAN                                   0x16F63
#define unicode_MIAO_VOWEL_SIGN_IANG                                  0x16F64
#define unicode_MIAO_VOWEL_SIGN_IO                                    0x16F65
#define unicode_MIAO_VOWEL_SIGN_IE                                    0x16F66
#define unicode_MIAO_VOWEL_SIGN_II                                    0x16F67
#define unicode_MIAO_VOWEL_SIGN_IU                                    0x16F68
#define unicode_MIAO_VOWEL_SIGN_ING                                   0x16F69
#define unicode_MIAO_VOWEL_SIGN_U                                     0x16F6A
#define unicode_MIAO_VOWEL_SIGN_UA                                    0x16F6B
#define unicode_MIAO_VOWEL_SIGN_UAN                                   0x16F6C
#define unicode_MIAO_VOWEL_SIGN_UANG                                  0x16F6D
#define unicode_MIAO_VOWEL_SIGN_UU                                    0x16F6E
#define unicode_MIAO_VOWEL_SIGN_UEI                                   0x16F6F
#define unicode_MIAO_VOWEL_SIGN_UNG                                   0x16F70
#define unicode_MIAO_VOWEL_SIGN_Y                                     0x16F71
#define unicode_MIAO_VOWEL_SIGN_YI                                    0x16F72
#define unicode_MIAO_VOWEL_SIGN_AE                                    0x16F73
#define unicode_MIAO_VOWEL_SIGN_AEE                                   0x16F74
#define unicode_MIAO_VOWEL_SIGN_ERR                                   0x16F75
#define unicode_MIAO_VOWEL_SIGN_ROUNDED_ERR                           0x16F76
#define unicode_MIAO_VOWEL_SIGN_ER                                    0x16F77
#define unicode_MIAO_VOWEL_SIGN_ROUNDED_ER                            0x16F78
#define unicode_MIAO_VOWEL_SIGN_AI                                    0x16F79
#define unicode_MIAO_VOWEL_SIGN_EI                                    0x16F7A
#define unicode_MIAO_VOWEL_SIGN_AU                                    0x16F7B
#define unicode_MIAO_VOWEL_SIGN_OU                                    0x16F7C
#define unicode_MIAO_VOWEL_SIGN_N                                     0x16F7D
#define unicode_MIAO_VOWEL_SIGN_NG                                    0x16F7E
#define unicode_MIAO_TONE_RIGHT                                       0x16F8F
#define unicode_MIAO_TONE_TOP_RIGHT                                   0x16F90
#define unicode_MIAO_TONE_ABOVE                                       0x16F91
#define unicode_MIAO_TONE_BELOW                                       0x16F92
#define unicode_MIAO_LETTER_TONE_2                                    0x16F93
#define unicode_MIAO_LETTER_TONE_3                                    0x16F94
#define unicode_MIAO_LETTER_TONE_4                                    0x16F95
#define unicode_MIAO_LETTER_TONE_5                                    0x16F96
#define unicode_MIAO_LETTER_TONE_6                                    0x16F97
#define unicode_MIAO_LETTER_TONE_7                                    0x16F98
#define unicode_MIAO_LETTER_TONE_8                                    0x16F99
#define unicode_MIAO_LETTER_REFORMED_TONE_1                           0x16F9A
#define unicode_MIAO_LETTER_REFORMED_TONE_2                           0x16F9B
#define unicode_MIAO_LETTER_REFORMED_TONE_4                           0x16F9C
#define unicode_MIAO_LETTER_REFORMED_TONE_5                           0x16F9D
#define unicode_MIAO_LETTER_REFORMED_TONE_6                           0x16F9E
#define unicode_MIAO_LETTER_REFORMED_TONE_8                           0x16F9F
#define unicode_KATAKANA_LETTER_ARCHAIC_E                             0x1B000
#define unicode_HIRAGANA_LETTER_ARCHAIC_YE                            0x1B001
#define unicode_DUPLOYAN_LETTER_H                                     0x1BC00
#define unicode_DUPLOYAN_LETTER_X                                     0x1BC01
#define unicode_DUPLOYAN_LETTER_P                                     0x1BC02
#define unicode_DUPLOYAN_LETTER_T                                     0x1BC03
#define unicode_DUPLOYAN_LETTER_F                                     0x1BC04
#define unicode_DUPLOYAN_LETTER_K                                     0x1BC05
#define unicode_DUPLOYAN_LETTER_L                                     0x1BC06
#define unicode_DUPLOYAN_LETTER_B                                     0x1BC07
#define unicode_DUPLOYAN_LETTER_D                                     0x1BC08
#define unicode_DUPLOYAN_LETTER_V                                     0x1BC09
#define unicode_DUPLOYAN_LETTER_G                                     0x1BC0A
#define unicode_DUPLOYAN_LETTER_R                                     0x1BC0B
#define unicode_DUPLOYAN_LETTER_P_N                                   0x1BC0C
#define unicode_DUPLOYAN_LETTER_D_S                                   0x1BC0D
#define unicode_DUPLOYAN_LETTER_F_N                                   0x1BC0E
#define unicode_DUPLOYAN_LETTER_K_M                                   0x1BC0F
#define unicode_DUPLOYAN_LETTER_R_S                                   0x1BC10
#define unicode_DUPLOYAN_LETTER_TH                                    0x1BC11
#define unicode_DUPLOYAN_LETTER_SLOAN_DH                              0x1BC12
#define unicode_DUPLOYAN_LETTER_DH                                    0x1BC13
#define unicode_DUPLOYAN_LETTER_KK                                    0x1BC14
#define unicode_DUPLOYAN_LETTER_SLOAN_J                               0x1BC15
#define unicode_DUPLOYAN_LETTER_HL                                    0x1BC16
#define unicode_DUPLOYAN_LETTER_LH                                    0x1BC17
#define unicode_DUPLOYAN_LETTER_RH                                    0x1BC18
#define unicode_DUPLOYAN_LETTER_M                                     0x1BC19
#define unicode_DUPLOYAN_LETTER_N                                     0x1BC1A
#define unicode_DUPLOYAN_LETTER_J                                     0x1BC1B
#define unicode_DUPLOYAN_LETTER_S                                     0x1BC1C
#define unicode_DUPLOYAN_LETTER_M_N                                   0x1BC1D
#define unicode_DUPLOYAN_LETTER_N_M                                   0x1BC1E
#define unicode_DUPLOYAN_LETTER_J_M                                   0x1BC1F
#define unicode_DUPLOYAN_LETTER_S_J                                   0x1BC20
#define unicode_DUPLOYAN_LETTER_M_WITH_DOT                            0x1BC21
#define unicode_DUPLOYAN_LETTER_N_WITH_DOT                            0x1BC22
#define unicode_DUPLOYAN_LETTER_J_WITH_DOT                            0x1BC23
#define unicode_DUPLOYAN_LETTER_J_WITH_DOTS_INSIDE_AND_ABOVE          0x1BC24
#define unicode_DUPLOYAN_LETTER_S_WITH_DOT                            0x1BC25
#define unicode_DUPLOYAN_LETTER_S_WITH_DOT_BELOW                      0x1BC26
#define unicode_DUPLOYAN_LETTER_M_S                                   0x1BC27
#define unicode_DUPLOYAN_LETTER_N_S                                   0x1BC28
#define unicode_DUPLOYAN_LETTER_J_S                                   0x1BC29
#define unicode_DUPLOYAN_LETTER_S_S                                   0x1BC2A
#define unicode_DUPLOYAN_LETTER_M_N_S                                 0x1BC2B
#define unicode_DUPLOYAN_LETTER_N_M_S                                 0x1BC2C
#define unicode_DUPLOYAN_LETTER_J_M_S                                 0x1BC2D
#define unicode_DUPLOYAN_LETTER_S_J_S                                 0x1BC2E
#define unicode_DUPLOYAN_LETTER_J_S_WITH_DOT                          0x1BC2F
#define unicode_DUPLOYAN_LETTER_J_N                                   0x1BC30
#define unicode_DUPLOYAN_LETTER_J_N_S                                 0x1BC31
#define unicode_DUPLOYAN_LETTER_S_T                                   0x1BC32
#define unicode_DUPLOYAN_LETTER_S_T_R                                 0x1BC33
#define unicode_DUPLOYAN_LETTER_S_P                                   0x1BC34
#define unicode_DUPLOYAN_LETTER_S_P_R                                 0x1BC35
#define unicode_DUPLOYAN_LETTER_T_S                                   0x1BC36
#define unicode_DUPLOYAN_LETTER_T_R_S                                 0x1BC37
#define unicode_DUPLOYAN_LETTER_W                                     0x1BC38
#define unicode_DUPLOYAN_LETTER_WH                                    0x1BC39
#define unicode_DUPLOYAN_LETTER_W_R                                   0x1BC3A
#define unicode_DUPLOYAN_LETTER_S_N                                   0x1BC3B
#define unicode_DUPLOYAN_LETTER_S_M                                   0x1BC3C
#define unicode_DUPLOYAN_LETTER_K_R_S                                 0x1BC3D
#define unicode_DUPLOYAN_LETTER_G_R_S                                 0x1BC3E
#define unicode_DUPLOYAN_LETTER_S_K                                   0x1BC3F
#define unicode_DUPLOYAN_LETTER_S_K_R                                 0x1BC40
#define unicode_DUPLOYAN_LETTER_A                                     0x1BC41
#define unicode_DUPLOYAN_LETTER_SLOAN_OW                              0x1BC42
#define unicode_DUPLOYAN_LETTER_OA                                    0x1BC43
#define unicode_DUPLOYAN_LETTER_O                                     0x1BC44
#define unicode_DUPLOYAN_LETTER_AOU                                   0x1BC45
#define unicode_DUPLOYAN_LETTER_I                                     0x1BC46
#define unicode_DUPLOYAN_LETTER_E                                     0x1BC47
#define unicode_DUPLOYAN_LETTER_IE                                    0x1BC48
#define unicode_DUPLOYAN_LETTER_SHORT_I                               0x1BC49
#define unicode_DUPLOYAN_LETTER_UI                                    0x1BC4A
#define unicode_DUPLOYAN_LETTER_EE                                    0x1BC4B
#define unicode_DUPLOYAN_LETTER_SLOAN_EH                              0x1BC4C
#define unicode_DUPLOYAN_LETTER_ROMANIAN_I                            0x1BC4D
#define unicode_DUPLOYAN_LETTER_SLOAN_EE                              0x1BC4E
#define unicode_DUPLOYAN_LETTER_LONG_I                                0x1BC4F
#define unicode_DUPLOYAN_LETTER_YE                                    0x1BC50
#define unicode_DUPLOYAN_LETTER_U                                     0x1BC51
#define unicode_DUPLOYAN_LETTER_EU                                    0x1BC52
#define unicode_DUPLOYAN_LETTER_XW                                    0x1BC53
#define unicode_DUPLOYAN_LETTER_U_N                                   0x1BC54
#define unicode_DUPLOYAN_LETTER_LONG_U                                0x1BC55
#define unicode_DUPLOYAN_LETTER_ROMANIAN_U                            0x1BC56
#define unicode_DUPLOYAN_LETTER_UH                                    0x1BC57
#define unicode_DUPLOYAN_LETTER_SLOAN_U                               0x1BC58
#define unicode_DUPLOYAN_LETTER_OOH                                   0x1BC59
#define unicode_DUPLOYAN_LETTER_OW                                    0x1BC5A
#define unicode_DUPLOYAN_LETTER_OU                                    0x1BC5B
#define unicode_DUPLOYAN_LETTER_WA                                    0x1BC5C
#define unicode_DUPLOYAN_LETTER_WO                                    0x1BC5D
#define unicode_DUPLOYAN_LETTER_WI                                    0x1BC5E
#define unicode_DUPLOYAN_LETTER_WEI                                   0x1BC5F
#define unicode_DUPLOYAN_LETTER_WOW                                   0x1BC60
#define unicode_DUPLOYAN_LETTER_NASAL_U                               0x1BC61
#define unicode_DUPLOYAN_LETTER_NASAL_O                               0x1BC62
#define unicode_DUPLOYAN_LETTER_NASAL_I                               0x1BC63
#define unicode_DUPLOYAN_LETTER_NASAL_A                               0x1BC64
#define unicode_DUPLOYAN_LETTER_PERNIN_AN                             0x1BC65
#define unicode_DUPLOYAN_LETTER_PERNIN_AM                             0x1BC66
#define unicode_DUPLOYAN_LETTER_SLOAN_EN                              0x1BC67
#define unicode_DUPLOYAN_LETTER_SLOAN_AN                              0x1BC68
#define unicode_DUPLOYAN_LETTER_SLOAN_ON                              0x1BC69
#define unicode_DUPLOYAN_LETTER_VOCALIC_M                             0x1BC6A
#define unicode_DUPLOYAN_AFFIX_LEFT_HORIZONTAL_SECANT                 0x1BC70
#define unicode_DUPLOYAN_AFFIX_MID_HORIZONTAL_SECANT                  0x1BC71
#define unicode_DUPLOYAN_AFFIX_RIGHT_HORIZONTAL_SECANT                0x1BC72
#define unicode_DUPLOYAN_AFFIX_LOW_VERTICAL_SECANT                    0x1BC73
#define unicode_DUPLOYAN_AFFIX_MID_VERTICAL_SECANT                    0x1BC74
#define unicode_DUPLOYAN_AFFIX_HIGH_VERTICAL_SECANT                   0x1BC75
#define unicode_DUPLOYAN_AFFIX_ATTACHED_SECANT                        0x1BC76
#define unicode_DUPLOYAN_AFFIX_ATTACHED_LEFT_TO_RIGHT_SECANT          0x1BC77
#define unicode_DUPLOYAN_AFFIX_ATTACHED_TANGENT                       0x1BC78
#define unicode_DUPLOYAN_AFFIX_ATTACHED_TAIL                          0x1BC79
#define unicode_DUPLOYAN_AFFIX_ATTACHED_E_HOOK                        0x1BC7A
#define unicode_DUPLOYAN_AFFIX_ATTACHED_I_HOOK                        0x1BC7B
#define unicode_DUPLOYAN_AFFIX_ATTACHED_TANGENT_HOOK                  0x1BC7C
#define unicode_DUPLOYAN_AFFIX_HIGH_ACUTE                             0x1BC80
#define unicode_DUPLOYAN_AFFIX_HIGH_TIGHT_ACUTE                       0x1BC81
#define unicode_DUPLOYAN_AFFIX_HIGH_GRAVE                             0x1BC82
#define unicode_DUPLOYAN_AFFIX_HIGH_LONG_GRAVE                        0x1BC83
#define unicode_DUPLOYAN_AFFIX_HIGH_DOT                               0x1BC84
#define unicode_DUPLOYAN_AFFIX_HIGH_CIRCLE                            0x1BC85
#define unicode_DUPLOYAN_AFFIX_HIGH_LINE                              0x1BC86
#define unicode_DUPLOYAN_AFFIX_HIGH_WAVE                              0x1BC87
#define unicode_DUPLOYAN_AFFIX_HIGH_VERTICAL                          0x1BC88
#define unicode_DUPLOYAN_AFFIX_LOW_ACUTE                              0x1BC90
#define unicode_DUPLOYAN_AFFIX_LOW_TIGHT_ACUTE                        0x1BC91
#define unicode_DUPLOYAN_AFFIX_LOW_GRAVE                              0x1BC92
#define unicode_DUPLOYAN_AFFIX_LOW_LONG_GRAVE                         0x1BC93
#define unicode_DUPLOYAN_AFFIX_LOW_DOT                                0x1BC94
#define unicode_DUPLOYAN_AFFIX_LOW_CIRCLE                             0x1BC95
#define unicode_DUPLOYAN_AFFIX_LOW_LINE                               0x1BC96
#define unicode_DUPLOYAN_AFFIX_LOW_WAVE                               0x1BC97
#define unicode_DUPLOYAN_AFFIX_LOW_VERTICAL                           0x1BC98
#define unicode_DUPLOYAN_AFFIX_LOW_ARROW                              0x1BC99
#define unicode_DUPLOYAN_SIGN_O_WITH_CROSS                            0x1BC9C
#define unicode_DUPLOYAN_THICK_LETTER_SELECTOR                        0x1BC9D
#define unicode_DUPLOYAN_DOUBLE_MARK                                  0x1BC9E
#define unicode_DUPLOYAN_PUNCTUATION_CHINOOK_FULL_STOP                0x1BC9F
#define unicode_SHORTHAND_FORMAT_LETTER_OVERLAP                       0x1BCA0
#define unicode_SHORTHAND_FORMAT_CONTINUING_OVERLAP                   0x1BCA1
#define unicode_SHORTHAND_FORMAT_DOWN_STEP                            0x1BCA2
#define unicode_SHORTHAND_FORMAT_UP_STEP                              0x1BCA3
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PSILI                        0x1D000
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DASEIA                       0x1D001
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PERISPOMENI                  0x1D002
#define unicode_BYZANTINE_MUSICAL_SYMBOL_OXEIA_EKFONITIKON            0x1D003
#define unicode_BYZANTINE_MUSICAL_SYMBOL_OXEIA_DIPLI                  0x1D004
#define unicode_BYZANTINE_MUSICAL_SYMBOL_VAREIA_EKFONITIKON           0x1D005
#define unicode_BYZANTINE_MUSICAL_SYMBOL_VAREIA_DIPLI                 0x1D006
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KATHISTI                     0x1D007
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SYRMATIKI                    0x1D008
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PARAKLITIKI                  0x1D009
#define unicode_BYZANTINE_MUSICAL_SYMBOL_YPOKRISIS                    0x1D00A
#define unicode_BYZANTINE_MUSICAL_SYMBOL_YPOKRISIS_DIPLI              0x1D00B
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KREMASTI                     0x1D00C
#define unicode_BYZANTINE_MUSICAL_SYMBOL_APESO_EKFONITIKON            0x1D00D
#define unicode_BYZANTINE_MUSICAL_SYMBOL_EXO_EKFONITIKON              0x1D00E
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TELEIA                       0x1D00F
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KENTIMATA                    0x1D010
#define unicode_BYZANTINE_MUSICAL_SYMBOL_APOSTROFOS                   0x1D011
#define unicode_BYZANTINE_MUSICAL_SYMBOL_APOSTROFOS_DIPLI             0x1D012
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SYNEVMA                      0x1D013
#define unicode_BYZANTINE_MUSICAL_SYMBOL_THITA                        0x1D014
#define unicode_BYZANTINE_MUSICAL_SYMBOL_OLIGON_ARCHAION              0x1D015
#define unicode_BYZANTINE_MUSICAL_SYMBOL_GORGON_ARCHAION              0x1D016
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PSILON                       0x1D017
#define unicode_BYZANTINE_MUSICAL_SYMBOL_CHAMILON                     0x1D018
#define unicode_BYZANTINE_MUSICAL_SYMBOL_VATHY                        0x1D019
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ISON_ARCHAION                0x1D01A
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KENTIMA_ARCHAION             0x1D01B
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_ARCHAION           0x1D01C
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SAXIMATA                     0x1D01D
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PARICHON                     0x1D01E
#define unicode_BYZANTINE_MUSICAL_SYMBOL_STAVROS_APODEXIA             0x1D01F
#define unicode_BYZANTINE_MUSICAL_SYMBOL_OXEIAI_ARCHAION              0x1D020
#define unicode_BYZANTINE_MUSICAL_SYMBOL_VAREIAI_ARCHAION             0x1D021
#define unicode_BYZANTINE_MUSICAL_SYMBOL_APODERMA_ARCHAION            0x1D022
#define unicode_BYZANTINE_MUSICAL_SYMBOL_APOTHEMA                     0x1D023
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KLASMA                       0x1D024
#define unicode_BYZANTINE_MUSICAL_SYMBOL_REVMA                        0x1D025
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PIASMA_ARCHAION              0x1D026
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TINAGMA                      0x1D027
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ANATRICHISMA                 0x1D028
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SEISMA                       0x1D029
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SYNAGMA_ARCHAION             0x1D02A
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SYNAGMA_META_STAVROU         0x1D02B
#define unicode_BYZANTINE_MUSICAL_SYMBOL_OYRANISMA_ARCHAION           0x1D02C
#define unicode_BYZANTINE_MUSICAL_SYMBOL_THEMA                        0x1D02D
#define unicode_BYZANTINE_MUSICAL_SYMBOL_LEMOI                        0x1D02E
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DYO                          0x1D02F
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TRIA                         0x1D030
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TESSERA                      0x1D031
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KRATIMATA                    0x1D032
#define unicode_BYZANTINE_MUSICAL_SYMBOL_APESO_EXO_NEO                0x1D033
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_ARCHAION              0x1D034
#define unicode_BYZANTINE_MUSICAL_SYMBOL_IMIFTHORA                    0x1D035
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TROMIKON_ARCHAION            0x1D036
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KATAVA_TROMIKON              0x1D037
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PELASTON                     0x1D038
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PSIFISTON                    0x1D039
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KONTEVMA                     0x1D03A
#define unicode_BYZANTINE_MUSICAL_SYMBOL_CHOREVMA_ARCHAION            0x1D03B
#define unicode_BYZANTINE_MUSICAL_SYMBOL_RAPISMA                      0x1D03C
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PARAKALESMA_ARCHAION         0x1D03D
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PARAKLITIKI_ARCHAION         0x1D03E
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ICHADIN                      0x1D03F
#define unicode_BYZANTINE_MUSICAL_SYMBOL_NANA                         0x1D040
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PETASMA                      0x1D041
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KONTEVMA_ALLO                0x1D042
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TROMIKON_ALLO                0x1D043
#define unicode_BYZANTINE_MUSICAL_SYMBOL_STRAGGISMATA                 0x1D044
#define unicode_BYZANTINE_MUSICAL_SYMBOL_GRONTHISMATA                 0x1D045
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ISON_NEO                     0x1D046
#define unicode_BYZANTINE_MUSICAL_SYMBOL_OLIGON_NEO                   0x1D047
#define unicode_BYZANTINE_MUSICAL_SYMBOL_OXEIA_NEO                    0x1D048
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PETASTI                      0x1D049
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KOUFISMA                     0x1D04A
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PETASTOKOUFISMA              0x1D04B
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KRATIMOKOUFISMA              0x1D04C
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PELASTON_NEO                 0x1D04D
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_NEO_ANO            0x1D04E
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KENTIMA_NEO_ANO              0x1D04F
#define unicode_BYZANTINE_MUSICAL_SYMBOL_YPSILI                       0x1D050
#define unicode_BYZANTINE_MUSICAL_SYMBOL_APOSTROFOS_NEO               0x1D051
#define unicode_BYZANTINE_MUSICAL_SYMBOL_APOSTROFOI_SYNDESMOS_NEO     0x1D052
#define unicode_BYZANTINE_MUSICAL_SYMBOL_YPORROI                      0x1D053
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KRATIMOYPORROON              0x1D054
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ELAFRON                      0x1D055
#define unicode_BYZANTINE_MUSICAL_SYMBOL_CHAMILI                      0x1D056
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MIKRON_ISON                  0x1D057
#define unicode_BYZANTINE_MUSICAL_SYMBOL_VAREIA_NEO                   0x1D058
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PIASMA_NEO                   0x1D059
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PSIFISTON_NEO                0x1D05A
#define unicode_BYZANTINE_MUSICAL_SYMBOL_OMALON                       0x1D05B
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ANTIKENOMA                   0x1D05C
#define unicode_BYZANTINE_MUSICAL_SYMBOL_LYGISMA                      0x1D05D
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PARAKLITIKI_NEO              0x1D05E
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PARAKALESMA_NEO              0x1D05F
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ETERON_PARAKALESMA           0x1D060
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KYLISMA                      0x1D061
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ANTIKENOKYLISMA              0x1D062
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TROMIKON_NEO                 0x1D063
#define unicode_BYZANTINE_MUSICAL_SYMBOL_EKSTREPTON                   0x1D064
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SYNAGMA_NEO                  0x1D065
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SYRMA                        0x1D066
#define unicode_BYZANTINE_MUSICAL_SYMBOL_CHOREVMA_NEO                 0x1D067
#define unicode_BYZANTINE_MUSICAL_SYMBOL_EPEGERMA                     0x1D068
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SEISMA_NEO                   0x1D069
#define unicode_BYZANTINE_MUSICAL_SYMBOL_XIRON_KLASMA                 0x1D06A
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TROMIKOPSIFISTON             0x1D06B
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PSIFISTOLYGISMA              0x1D06C
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TROMIKOLYGISMA               0x1D06D
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TROMIKOPARAKALESMA           0x1D06E
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PSIFISTOPARAKALESMA          0x1D06F
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TROMIKOSYNAGMA               0x1D070
#define unicode_BYZANTINE_MUSICAL_SYMBOL_PSIFISTOSYNAGMA              0x1D071
#define unicode_BYZANTINE_MUSICAL_SYMBOL_GORGOSYNTHETON               0x1D072
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ARGOSYNTHETON                0x1D073
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ETERON_ARGOSYNTHETON         0x1D074
#define unicode_BYZANTINE_MUSICAL_SYMBOL_OYRANISMA_NEO                0x1D075
#define unicode_BYZANTINE_MUSICAL_SYMBOL_THEMATISMOS_ESO              0x1D076
#define unicode_BYZANTINE_MUSICAL_SYMBOL_THEMATISMOS_EXO              0x1D077
#define unicode_BYZANTINE_MUSICAL_SYMBOL_THEMA_APLOUN                 0x1D078
#define unicode_BYZANTINE_MUSICAL_SYMBOL_THES_KAI_APOTHES             0x1D079
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KATAVASMA                    0x1D07A
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ENDOFONON                    0x1D07B
#define unicode_BYZANTINE_MUSICAL_SYMBOL_YFEN_KATO                    0x1D07C
#define unicode_BYZANTINE_MUSICAL_SYMBOL_YFEN_ANO                     0x1D07D
#define unicode_BYZANTINE_MUSICAL_SYMBOL_STAVROS                      0x1D07E
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KLASMA_ANO                   0x1D07F
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIPLI_ARCHAION               0x1D080
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KRATIMA_ARCHAION             0x1D081
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KRATIMA_ALLO                 0x1D082
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KRATIMA_NEO                  0x1D083
#define unicode_BYZANTINE_MUSICAL_SYMBOL_APODERMA_NEO                 0x1D084
#define unicode_BYZANTINE_MUSICAL_SYMBOL_APLI                         0x1D085
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIPLI                        0x1D086
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TRIPLI                       0x1D087
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TETRAPLI                     0x1D088
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KORONIS                      0x1D089
#define unicode_BYZANTINE_MUSICAL_SYMBOL_LEIMMA_ENOS_CHRONOU          0x1D08A
#define unicode_BYZANTINE_MUSICAL_SYMBOL_LEIMMA_DYO_CHRONON           0x1D08B
#define unicode_BYZANTINE_MUSICAL_SYMBOL_LEIMMA_TRION_CHRONON         0x1D08C
#define unicode_BYZANTINE_MUSICAL_SYMBOL_LEIMMA_TESSARON_CHRONON      0x1D08D
#define unicode_BYZANTINE_MUSICAL_SYMBOL_LEIMMA_IMISEOS_CHRONOU       0x1D08E
#define unicode_BYZANTINE_MUSICAL_SYMBOL_GORGON_NEO_ANO               0x1D08F
#define unicode_BYZANTINE_MUSICAL_SYMBOL_GORGON_PARESTIGMENON_ARISTERA 0x1D090
#define unicode_BYZANTINE_MUSICAL_SYMBOL_GORGON_PARESTIGMENON_DEXIA   0x1D091
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIGORGON                     0x1D092
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIGORGON_PARESTIGMENON_ARISTERA_KATO 0x1D093
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIGORGON_PARESTIGMENON_ARISTERA_ANO 0x1D094
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIGORGON_PARESTIGMENON_DEXIA 0x1D095
#define unicode_BYZANTINE_MUSICAL_SYMBOL_TRIGORGON                    0x1D096
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ARGON                        0x1D097
#define unicode_BYZANTINE_MUSICAL_SYMBOL_IMIDIARGON                   0x1D098
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIARGON                      0x1D099
#define unicode_BYZANTINE_MUSICAL_SYMBOL_AGOGI_POLI_ARGI              0x1D09A
#define unicode_BYZANTINE_MUSICAL_SYMBOL_AGOGI_ARGOTERI               0x1D09B
#define unicode_BYZANTINE_MUSICAL_SYMBOL_AGOGI_ARGI                   0x1D09C
#define unicode_BYZANTINE_MUSICAL_SYMBOL_AGOGI_METRIA                 0x1D09D
#define unicode_BYZANTINE_MUSICAL_SYMBOL_AGOGI_MESI                   0x1D09E
#define unicode_BYZANTINE_MUSICAL_SYMBOL_AGOGI_GORGI                  0x1D09F
#define unicode_BYZANTINE_MUSICAL_SYMBOL_AGOGI_GORGOTERI              0x1D0A0
#define unicode_BYZANTINE_MUSICAL_SYMBOL_AGOGI_POLI_GORGI             0x1D0A1
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PROTOS_ICHOS        0x1D0A2
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_ALLI_PROTOS_ICHOS   0x1D0A3
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_DEYTEROS_ICHOS      0x1D0A4
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_ALLI_DEYTEROS_ICHOS 0x1D0A5
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TRITOS_ICHOS        0x1D0A6
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TRIFONIAS           0x1D0A7
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TETARTOS_ICHOS      0x1D0A8
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TETARTOS_LEGETOS_ICHOS 0x1D0A9
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_LEGETOS_ICHOS       0x1D0AA
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PLAGIOS_ICHOS       0x1D0AB
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ISAKIA_TELOUS_ICHIMATOS      0x1D0AC
#define unicode_BYZANTINE_MUSICAL_SYMBOL_APOSTROFOI_TELOUS_ICHIMATOS  0x1D0AD
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FANEROSIS_TETRAFONIAS        0x1D0AE
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FANEROSIS_MONOFONIAS         0x1D0AF
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FANEROSIS_DIFONIAS           0x1D0B0
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_VARYS_ICHOS         0x1D0B1
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PROTOVARYS_ICHOS    0x1D0B2
#define unicode_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PLAGIOS_TETARTOS_ICHOS 0x1D0B3
#define unicode_BYZANTINE_MUSICAL_SYMBOL_GORTHMIKON_N_APLOUN          0x1D0B4
#define unicode_BYZANTINE_MUSICAL_SYMBOL_GORTHMIKON_N_DIPLOUN         0x1D0B5
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ENARXIS_KAI_FTHORA_VOU       0x1D0B6
#define unicode_BYZANTINE_MUSICAL_SYMBOL_IMIFONON                     0x1D0B7
#define unicode_BYZANTINE_MUSICAL_SYMBOL_IMIFTHORON                   0x1D0B8
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_ARCHAION_DEYTEROU_ICHOU 0x1D0B9
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_PA          0x1D0BA
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_NANA        0x1D0BB
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_NAOS_ICHOS            0x1D0BC
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_DI          0x1D0BD
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_SKLIRON_DIATONON_DI   0x1D0BE
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_KE          0x1D0BF
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_ZO          0x1D0C0
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_NI_KATO     0x1D0C1
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_NI_ANO      0x1D0C2
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_MALAKON_CHROMA_DIFONIAS 0x1D0C3
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_MALAKON_CHROMA_MONOFONIAS 0x1D0C4
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FHTORA_SKLIRON_CHROMA_VASIS  0x1D0C5
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_SKLIRON_CHROMA_SYNAFI 0x1D0C6
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_NENANO                0x1D0C7
#define unicode_BYZANTINE_MUSICAL_SYMBOL_CHROA_ZYGOS                  0x1D0C8
#define unicode_BYZANTINE_MUSICAL_SYMBOL_CHROA_KLITON                 0x1D0C9
#define unicode_BYZANTINE_MUSICAL_SYMBOL_CHROA_SPATHI                 0x1D0CA
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_I_YFESIS_TETARTIMORION 0x1D0CB
#define unicode_BYZANTINE_MUSICAL_SYMBOL_FTHORA_ENARMONIOS_ANTIFONIA  0x1D0CC
#define unicode_BYZANTINE_MUSICAL_SYMBOL_YFESIS_TRITIMORION           0x1D0CD
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIESIS_TRITIMORION           0x1D0CE
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIESIS_TETARTIMORION         0x1D0CF
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIESIS_APLI_DYO_DODEKATA     0x1D0D0
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIESIS_MONOGRAMMOS_TESSERA_DODEKATA 0x1D0D1
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIESIS_DIGRAMMOS_EX_DODEKATA 0x1D0D2
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIESIS_TRIGRAMMOS_OKTO_DODEKATA 0x1D0D3
#define unicode_BYZANTINE_MUSICAL_SYMBOL_YFESIS_APLI_DYO_DODEKATA     0x1D0D4
#define unicode_BYZANTINE_MUSICAL_SYMBOL_YFESIS_MONOGRAMMOS_TESSERA_DODEKATA 0x1D0D5
#define unicode_BYZANTINE_MUSICAL_SYMBOL_YFESIS_DIGRAMMOS_EX_DODEKATA 0x1D0D6
#define unicode_BYZANTINE_MUSICAL_SYMBOL_YFESIS_TRIGRAMMOS_OKTO_DODEKATA 0x1D0D7
#define unicode_BYZANTINE_MUSICAL_SYMBOL_GENIKI_DIESIS                0x1D0D8
#define unicode_BYZANTINE_MUSICAL_SYMBOL_GENIKI_YFESIS                0x1D0D9
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_APLI_MIKRI          0x1D0DA
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_APLI_MEGALI         0x1D0DB
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_DIPLI               0x1D0DC
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_THESEOS             0x1D0DD
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS             0x1D0DE
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS_DISIMOU     0x1D0DF
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS_TRISIMOU    0x1D0E0
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS_TETRASIMOU  0x1D0E1
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS              0x1D0E2
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS_DISIMOU      0x1D0E3
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS_TRISIMOU     0x1D0E4
#define unicode_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS_TETRASIMOU   0x1D0E5
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIGRAMMA_GG                  0x1D0E6
#define unicode_BYZANTINE_MUSICAL_SYMBOL_DIFTOGGOS_OU                 0x1D0E7
#define unicode_BYZANTINE_MUSICAL_SYMBOL_STIGMA                       0x1D0E8
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_PA                   0x1D0E9
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_VOU                  0x1D0EA
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_GA                   0x1D0EB
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_DI                   0x1D0EC
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_KE                   0x1D0ED
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_ZO                   0x1D0EE
#define unicode_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_NI                   0x1D0EF
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_NEO_MESO           0x1D0F0
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KENTIMA_NEO_MESO             0x1D0F1
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_NEO_KATO           0x1D0F2
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KENTIMA_NEO_KATO             0x1D0F3
#define unicode_BYZANTINE_MUSICAL_SYMBOL_KLASMA_KATO                  0x1D0F4
#define unicode_BYZANTINE_MUSICAL_SYMBOL_GORGON_NEO_KATO              0x1D0F5
#define unicode_MUSICAL_SYMBOL_SINGLE_BARLINE                         0x1D100
#define unicode_MUSICAL_SYMBOL_DOUBLE_BARLINE                         0x1D101
#define unicode_MUSICAL_SYMBOL_FINAL_BARLINE                          0x1D102
#define unicode_MUSICAL_SYMBOL_REVERSE_FINAL_BARLINE                  0x1D103
#define unicode_MUSICAL_SYMBOL_DASHED_BARLINE                         0x1D104
#define unicode_MUSICAL_SYMBOL_SHORT_BARLINE                          0x1D105
#define unicode_MUSICAL_SYMBOL_LEFT_REPEAT_SIGN                       0x1D106
#define unicode_MUSICAL_SYMBOL_RIGHT_REPEAT_SIGN                      0x1D107
#define unicode_MUSICAL_SYMBOL_REPEAT_DOTS                            0x1D108
#define unicode_MUSICAL_SYMBOL_DAL_SEGNO                              0x1D109
#define unicode_MUSICAL_SYMBOL_DA_CAPO                                0x1D10A
#define unicode_MUSICAL_SYMBOL_SEGNO                                  0x1D10B
#define unicode_MUSICAL_SYMBOL_CODA                                   0x1D10C
#define unicode_MUSICAL_SYMBOL_REPEATED_FIGURE_1                      0x1D10D
#define unicode_MUSICAL_SYMBOL_REPEATED_FIGURE_2                      0x1D10E
#define unicode_MUSICAL_SYMBOL_REPEATED_FIGURE_3                      0x1D10F
#define unicode_MUSICAL_SYMBOL_FERMATA                                0x1D110
#define unicode_MUSICAL_SYMBOL_FERMATA_BELOW                          0x1D111
#define unicode_MUSICAL_SYMBOL_BREATH_MARK                            0x1D112
#define unicode_MUSICAL_SYMBOL_CAESURA                                0x1D113
#define unicode_MUSICAL_SYMBOL_BRACE                                  0x1D114
#define unicode_MUSICAL_SYMBOL_BRACKET                                0x1D115
#define unicode_MUSICAL_SYMBOL_ONE_LINE_STAFF                         0x1D116
#define unicode_MUSICAL_SYMBOL_TWO_LINE_STAFF                         0x1D117
#define unicode_MUSICAL_SYMBOL_THREE_LINE_STAFF                       0x1D118
#define unicode_MUSICAL_SYMBOL_FOUR_LINE_STAFF                        0x1D119
#define unicode_MUSICAL_SYMBOL_FIVE_LINE_STAFF                        0x1D11A
#define unicode_MUSICAL_SYMBOL_SIX_LINE_STAFF                         0x1D11B
#define unicode_MUSICAL_SYMBOL_SIX_STRING_FRETBOARD                   0x1D11C
#define unicode_MUSICAL_SYMBOL_FOUR_STRING_FRETBOARD                  0x1D11D
#define unicode_MUSICAL_SYMBOL_G_CLEF                                 0x1D11E
#define unicode_MUSICAL_SYMBOL_G_CLEF_OTTAVA_ALTA                     0x1D11F
#define unicode_MUSICAL_SYMBOL_G_CLEF_OTTAVA_BASSA                    0x1D120
#define unicode_MUSICAL_SYMBOL_C_CLEF                                 0x1D121
#define unicode_MUSICAL_SYMBOL_F_CLEF                                 0x1D122
#define unicode_MUSICAL_SYMBOL_F_CLEF_OTTAVA_ALTA                     0x1D123
#define unicode_MUSICAL_SYMBOL_F_CLEF_OTTAVA_BASSA                    0x1D124
#define unicode_MUSICAL_SYMBOL_DRUM_CLEF_1                            0x1D125
#define unicode_MUSICAL_SYMBOL_DRUM_CLEF_2                            0x1D126
#define unicode_MUSICAL_SYMBOL_MULTIPLE_MEASURE_REST                  0x1D129
#define unicode_MUSICAL_SYMBOL_DOUBLE_SHARP                           0x1D12A
#define unicode_MUSICAL_SYMBOL_DOUBLE_FLAT                            0x1D12B
#define unicode_MUSICAL_SYMBOL_FLAT_UP                                0x1D12C
#define unicode_MUSICAL_SYMBOL_FLAT_DOWN                              0x1D12D
#define unicode_MUSICAL_SYMBOL_NATURAL_UP                             0x1D12E
#define unicode_MUSICAL_SYMBOL_NATURAL_DOWN                           0x1D12F
#define unicode_MUSICAL_SYMBOL_SHARP_UP                               0x1D130
#define unicode_MUSICAL_SYMBOL_SHARP_DOWN                             0x1D131
#define unicode_MUSICAL_SYMBOL_QUARTER_TONE_SHARP                     0x1D132
#define unicode_MUSICAL_SYMBOL_QUARTER_TONE_FLAT                      0x1D133
#define unicode_MUSICAL_SYMBOL_COMMON_TIME                            0x1D134
#define unicode_MUSICAL_SYMBOL_CUT_TIME                               0x1D135
#define unicode_MUSICAL_SYMBOL_OTTAVA_ALTA                            0x1D136
#define unicode_MUSICAL_SYMBOL_OTTAVA_BASSA                           0x1D137
#define unicode_MUSICAL_SYMBOL_QUINDICESIMA_ALTA                      0x1D138
#define unicode_MUSICAL_SYMBOL_QUINDICESIMA_BASSA                     0x1D139
#define unicode_MUSICAL_SYMBOL_MULTI_REST                             0x1D13A
#define unicode_MUSICAL_SYMBOL_WHOLE_REST                             0x1D13B
#define unicode_MUSICAL_SYMBOL_HALF_REST                              0x1D13C
#define unicode_MUSICAL_SYMBOL_QUARTER_REST                           0x1D13D
#define unicode_MUSICAL_SYMBOL_EIGHTH_REST                            0x1D13E
#define unicode_MUSICAL_SYMBOL_SIXTEENTH_REST                         0x1D13F
#define unicode_MUSICAL_SYMBOL_THIRTY_SECOND_REST                     0x1D140
#define unicode_MUSICAL_SYMBOL_SIXTY_FOURTH_REST                      0x1D141
#define unicode_MUSICAL_SYMBOL_ONE_HUNDRED_TWENTY_EIGHTH_REST         0x1D142
#define unicode_MUSICAL_SYMBOL_X_NOTEHEAD                             0x1D143
#define unicode_MUSICAL_SYMBOL_PLUS_NOTEHEAD                          0x1D144
#define unicode_MUSICAL_SYMBOL_CIRCLE_X_NOTEHEAD                      0x1D145
#define unicode_MUSICAL_SYMBOL_SQUARE_NOTEHEAD_WHITE                  0x1D146
#define unicode_MUSICAL_SYMBOL_SQUARE_NOTEHEAD_BLACK                  0x1D147
#define unicode_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_WHITE             0x1D148
#define unicode_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_BLACK             0x1D149
#define unicode_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_LEFT_WHITE           0x1D14A
#define unicode_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_LEFT_BLACK           0x1D14B
#define unicode_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_RIGHT_WHITE          0x1D14C
#define unicode_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_RIGHT_BLACK          0x1D14D
#define unicode_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_DOWN_WHITE           0x1D14E
#define unicode_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_DOWN_BLACK           0x1D14F
#define unicode_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_RIGHT_WHITE       0x1D150
#define unicode_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_RIGHT_BLACK       0x1D151
#define unicode_MUSICAL_SYMBOL_MOON_NOTEHEAD_WHITE                    0x1D152
#define unicode_MUSICAL_SYMBOL_MOON_NOTEHEAD_BLACK                    0x1D153
#define unicode_MUSICAL_SYMBOL_TRIANGLE_ROUND_NOTEHEAD_DOWN_WHITE     0x1D154
#define unicode_MUSICAL_SYMBOL_TRIANGLE_ROUND_NOTEHEAD_DOWN_BLACK     0x1D155
#define unicode_MUSICAL_SYMBOL_PARENTHESIS_NOTEHEAD                   0x1D156
#define unicode_MUSICAL_SYMBOL_VOID_NOTEHEAD                          0x1D157
#define unicode_MUSICAL_SYMBOL_NOTEHEAD_BLACK                         0x1D158
#define unicode_MUSICAL_SYMBOL_NULL_NOTEHEAD                          0x1D159
#define unicode_MUSICAL_SYMBOL_CLUSTER_NOTEHEAD_WHITE                 0x1D15A
#define unicode_MUSICAL_SYMBOL_CLUSTER_NOTEHEAD_BLACK                 0x1D15B
#define unicode_MUSICAL_SYMBOL_BREVE                                  0x1D15C
#define unicode_MUSICAL_SYMBOL_WHOLE_NOTE                             0x1D15D
#define unicode_MUSICAL_SYMBOL_HALF_NOTE                              0x1D15E
#define unicode_MUSICAL_SYMBOL_QUARTER_NOTE                           0x1D15F
#define unicode_MUSICAL_SYMBOL_EIGHTH_NOTE                            0x1D160
#define unicode_MUSICAL_SYMBOL_SIXTEENTH_NOTE                         0x1D161
#define unicode_MUSICAL_SYMBOL_THIRTY_SECOND_NOTE                     0x1D162
#define unicode_MUSICAL_SYMBOL_SIXTY_FOURTH_NOTE                      0x1D163
#define unicode_MUSICAL_SYMBOL_ONE_HUNDRED_TWENTY_EIGHTH_NOTE         0x1D164
#define unicode_MUSICAL_SYMBOL_COMBINING_STEM                         0x1D165
#define unicode_MUSICAL_SYMBOL_COMBINING_SPRECHGESANG_STEM            0x1D166
#define unicode_MUSICAL_SYMBOL_COMBINING_TREMOLO_1                    0x1D167
#define unicode_MUSICAL_SYMBOL_COMBINING_TREMOLO_2                    0x1D168
#define unicode_MUSICAL_SYMBOL_COMBINING_TREMOLO_3                    0x1D169
#define unicode_MUSICAL_SYMBOL_FINGERED_TREMOLO_1                     0x1D16A
#define unicode_MUSICAL_SYMBOL_FINGERED_TREMOLO_2                     0x1D16B
#define unicode_MUSICAL_SYMBOL_FINGERED_TREMOLO_3                     0x1D16C
#define unicode_MUSICAL_SYMBOL_COMBINING_AUGMENTATION_DOT             0x1D16D
#define unicode_MUSICAL_SYMBOL_COMBINING_FLAG_1                       0x1D16E
#define unicode_MUSICAL_SYMBOL_COMBINING_FLAG_2                       0x1D16F
#define unicode_MUSICAL_SYMBOL_COMBINING_FLAG_3                       0x1D170
#define unicode_MUSICAL_SYMBOL_COMBINING_FLAG_4                       0x1D171
#define unicode_MUSICAL_SYMBOL_COMBINING_FLAG_5                       0x1D172
#define unicode_MUSICAL_SYMBOL_BEGIN_BEAM                             0x1D173
#define unicode_MUSICAL_SYMBOL_END_BEAM                               0x1D174
#define unicode_MUSICAL_SYMBOL_BEGIN_TIE                              0x1D175
#define unicode_MUSICAL_SYMBOL_END_TIE                                0x1D176
#define unicode_MUSICAL_SYMBOL_BEGIN_SLUR                             0x1D177
#define unicode_MUSICAL_SYMBOL_END_SLUR                               0x1D178
#define unicode_MUSICAL_SYMBOL_BEGIN_PHRASE                           0x1D179
#define unicode_MUSICAL_SYMBOL_END_PHRASE                             0x1D17A
#define unicode_MUSICAL_SYMBOL_COMBINING_ACCENT                       0x1D17B
#define unicode_MUSICAL_SYMBOL_COMBINING_STACCATO                     0x1D17C
#define unicode_MUSICAL_SYMBOL_COMBINING_TENUTO                       0x1D17D
#define unicode_MUSICAL_SYMBOL_COMBINING_STACCATISSIMO                0x1D17E
#define unicode_MUSICAL_SYMBOL_COMBINING_MARCATO                      0x1D17F
#define unicode_MUSICAL_SYMBOL_COMBINING_MARCATO_STACCATO             0x1D180
#define unicode_MUSICAL_SYMBOL_COMBINING_ACCENT_STACCATO              0x1D181
#define unicode_MUSICAL_SYMBOL_COMBINING_LOURE                        0x1D182
#define unicode_MUSICAL_SYMBOL_ARPEGGIATO_UP                          0x1D183
#define unicode_MUSICAL_SYMBOL_ARPEGGIATO_DOWN                        0x1D184
#define unicode_MUSICAL_SYMBOL_COMBINING_DOIT                         0x1D185
#define unicode_MUSICAL_SYMBOL_COMBINING_RIP                          0x1D186
#define unicode_MUSICAL_SYMBOL_COMBINING_FLIP                         0x1D187
#define unicode_MUSICAL_SYMBOL_COMBINING_SMEAR                        0x1D188
#define unicode_MUSICAL_SYMBOL_COMBINING_BEND                         0x1D189
#define unicode_MUSICAL_SYMBOL_COMBINING_DOUBLE_TONGUE                0x1D18A
#define unicode_MUSICAL_SYMBOL_COMBINING_TRIPLE_TONGUE                0x1D18B
#define unicode_MUSICAL_SYMBOL_RINFORZANDO                            0x1D18C
#define unicode_MUSICAL_SYMBOL_SUBITO                                 0x1D18D
#define unicode_MUSICAL_SYMBOL_Z                                      0x1D18E
#define unicode_MUSICAL_SYMBOL_PIANO                                  0x1D18F
#define unicode_MUSICAL_SYMBOL_MEZZO                                  0x1D190
#define unicode_MUSICAL_SYMBOL_FORTE                                  0x1D191
#define unicode_MUSICAL_SYMBOL_CRESCENDO                              0x1D192
#define unicode_MUSICAL_SYMBOL_DECRESCENDO                            0x1D193
#define unicode_MUSICAL_SYMBOL_GRACE_NOTE_SLASH                       0x1D194
#define unicode_MUSICAL_SYMBOL_GRACE_NOTE_NO_SLASH                    0x1D195
#define unicode_MUSICAL_SYMBOL_TR                                     0x1D196
#define unicode_MUSICAL_SYMBOL_TURN                                   0x1D197
#define unicode_MUSICAL_SYMBOL_INVERTED_TURN                          0x1D198
#define unicode_MUSICAL_SYMBOL_TURN_SLASH                             0x1D199
#define unicode_MUSICAL_SYMBOL_TURN_UP                                0x1D19A
#define unicode_MUSICAL_SYMBOL_ORNAMENT_STROKE_1                      0x1D19B
#define unicode_MUSICAL_SYMBOL_ORNAMENT_STROKE_2                      0x1D19C
#define unicode_MUSICAL_SYMBOL_ORNAMENT_STROKE_3                      0x1D19D
#define unicode_MUSICAL_SYMBOL_ORNAMENT_STROKE_4                      0x1D19E
#define unicode_MUSICAL_SYMBOL_ORNAMENT_STROKE_5                      0x1D19F
#define unicode_MUSICAL_SYMBOL_ORNAMENT_STROKE_6                      0x1D1A0
#define unicode_MUSICAL_SYMBOL_ORNAMENT_STROKE_7                      0x1D1A1
#define unicode_MUSICAL_SYMBOL_ORNAMENT_STROKE_8                      0x1D1A2
#define unicode_MUSICAL_SYMBOL_ORNAMENT_STROKE_9                      0x1D1A3
#define unicode_MUSICAL_SYMBOL_ORNAMENT_STROKE_10                     0x1D1A4
#define unicode_MUSICAL_SYMBOL_ORNAMENT_STROKE_11                     0x1D1A5
#define unicode_MUSICAL_SYMBOL_HAUPTSTIMME                            0x1D1A6
#define unicode_MUSICAL_SYMBOL_NEBENSTIMME                            0x1D1A7
#define unicode_MUSICAL_SYMBOL_END_OF_STIMME                          0x1D1A8
#define unicode_MUSICAL_SYMBOL_DEGREE_SLASH                           0x1D1A9
#define unicode_MUSICAL_SYMBOL_COMBINING_DOWN_BOW                     0x1D1AA
#define unicode_MUSICAL_SYMBOL_COMBINING_UP_BOW                       0x1D1AB
#define unicode_MUSICAL_SYMBOL_COMBINING_HARMONIC                     0x1D1AC
#define unicode_MUSICAL_SYMBOL_COMBINING_SNAP_PIZZICATO               0x1D1AD
#define unicode_MUSICAL_SYMBOL_PEDAL_MARK                             0x1D1AE
#define unicode_MUSICAL_SYMBOL_PEDAL_UP_MARK                          0x1D1AF
#define unicode_MUSICAL_SYMBOL_HALF_PEDAL_MARK                        0x1D1B0
#define unicode_MUSICAL_SYMBOL_GLISSANDO_UP                           0x1D1B1
#define unicode_MUSICAL_SYMBOL_GLISSANDO_DOWN                         0x1D1B2
#define unicode_MUSICAL_SYMBOL_WITH_FINGERNAILS                       0x1D1B3
#define unicode_MUSICAL_SYMBOL_DAMP                                   0x1D1B4
#define unicode_MUSICAL_SYMBOL_DAMP_ALL                               0x1D1B5
#define unicode_MUSICAL_SYMBOL_MAXIMA                                 0x1D1B6
#define unicode_MUSICAL_SYMBOL_LONGA                                  0x1D1B7
#define unicode_MUSICAL_SYMBOL_BREVIS                                 0x1D1B8
#define unicode_MUSICAL_SYMBOL_SEMIBREVIS_WHITE                       0x1D1B9
#define unicode_MUSICAL_SYMBOL_SEMIBREVIS_BLACK                       0x1D1BA
#define unicode_MUSICAL_SYMBOL_MINIMA                                 0x1D1BB
#define unicode_MUSICAL_SYMBOL_MINIMA_BLACK                           0x1D1BC
#define unicode_MUSICAL_SYMBOL_SEMIMINIMA_WHITE                       0x1D1BD
#define unicode_MUSICAL_SYMBOL_SEMIMINIMA_BLACK                       0x1D1BE
#define unicode_MUSICAL_SYMBOL_FUSA_WHITE                             0x1D1BF
#define unicode_MUSICAL_SYMBOL_FUSA_BLACK                             0x1D1C0
#define unicode_MUSICAL_SYMBOL_LONGA_PERFECTA_REST                    0x1D1C1
#define unicode_MUSICAL_SYMBOL_LONGA_IMPERFECTA_REST                  0x1D1C2
#define unicode_MUSICAL_SYMBOL_BREVIS_REST                            0x1D1C3
#define unicode_MUSICAL_SYMBOL_SEMIBREVIS_REST                        0x1D1C4
#define unicode_MUSICAL_SYMBOL_MINIMA_REST                            0x1D1C5
#define unicode_MUSICAL_SYMBOL_SEMIMINIMA_REST                        0x1D1C6
#define unicode_MUSICAL_SYMBOL_TEMPUS_PERFECTUM_CUM_PROLATIONE_PERFECTA 0x1D1C7
#define unicode_MUSICAL_SYMBOL_TEMPUS_PERFECTUM_CUM_PROLATIONE_IMPERFECTA 0x1D1C8
#define unicode_MUSICAL_SYMBOL_TEMPUS_PERFECTUM_CUM_PROLATIONE_PERFECTA_DIMINUTION_1 0x1D1C9
#define unicode_MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_PERFECTA 0x1D1CA
#define unicode_MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA 0x1D1CB
#define unicode_MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA_DIMINUTION_1 0x1D1CC
#define unicode_MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA_DIMINUTION_2 0x1D1CD
#define unicode_MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA_DIMINUTION_3 0x1D1CE
#define unicode_MUSICAL_SYMBOL_CROIX                                  0x1D1CF
#define unicode_MUSICAL_SYMBOL_GREGORIAN_C_CLEF                       0x1D1D0
#define unicode_MUSICAL_SYMBOL_GREGORIAN_F_CLEF                       0x1D1D1
#define unicode_MUSICAL_SYMBOL_SQUARE_B                               0x1D1D2
#define unicode_MUSICAL_SYMBOL_VIRGA                                  0x1D1D3
#define unicode_MUSICAL_SYMBOL_PODATUS                                0x1D1D4
#define unicode_MUSICAL_SYMBOL_CLIVIS                                 0x1D1D5
#define unicode_MUSICAL_SYMBOL_SCANDICUS                              0x1D1D6
#define unicode_MUSICAL_SYMBOL_CLIMACUS                               0x1D1D7
#define unicode_MUSICAL_SYMBOL_TORCULUS                               0x1D1D8
#define unicode_MUSICAL_SYMBOL_PORRECTUS                              0x1D1D9
#define unicode_MUSICAL_SYMBOL_PORRECTUS_FLEXUS                       0x1D1DA
#define unicode_MUSICAL_SYMBOL_SCANDICUS_FLEXUS                       0x1D1DB
#define unicode_MUSICAL_SYMBOL_TORCULUS_RESUPINUS                     0x1D1DC
#define unicode_MUSICAL_SYMBOL_PES_SUBPUNCTIS                         0x1D1DD
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_1                         0x1D200
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_2                         0x1D201
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_3                         0x1D202
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_4                         0x1D203
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_5                         0x1D204
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_6                         0x1D205
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_7                         0x1D206
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_8                         0x1D207
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_9                         0x1D208
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_10                        0x1D209
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_11                        0x1D20A
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_12                        0x1D20B
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_13                        0x1D20C
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_14                        0x1D20D
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_15                        0x1D20E
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_16                        0x1D20F
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_17                        0x1D210
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_18                        0x1D211
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_19                        0x1D212
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_20                        0x1D213
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_21                        0x1D214
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_22                        0x1D215
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_23                        0x1D216
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_24                        0x1D217
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_50                        0x1D218
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_51                        0x1D219
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_52                        0x1D21A
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_53                        0x1D21B
#define unicode_GREEK_VOCAL_NOTATION_SYMBOL_54                        0x1D21C
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_1                  0x1D21D
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_2                  0x1D21E
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_4                  0x1D21F
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_5                  0x1D220
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_7                  0x1D221
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_8                  0x1D222
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_11                 0x1D223
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_12                 0x1D224
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_13                 0x1D225
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_14                 0x1D226
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_17                 0x1D227
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_18                 0x1D228
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_19                 0x1D229
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_23                 0x1D22A
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_24                 0x1D22B
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_25                 0x1D22C
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_26                 0x1D22D
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_27                 0x1D22E
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_29                 0x1D22F
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_30                 0x1D230
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_32                 0x1D231
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_36                 0x1D232
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_37                 0x1D233
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_38                 0x1D234
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_39                 0x1D235
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_40                 0x1D236
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_42                 0x1D237
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_43                 0x1D238
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_45                 0x1D239
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_47                 0x1D23A
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_48                 0x1D23B
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_49                 0x1D23C
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_50                 0x1D23D
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_51                 0x1D23E
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_52                 0x1D23F
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_53                 0x1D240
#define unicode_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_54                 0x1D241
#define unicode_COMBINING_GREEK_MUSICAL_TRISEME                       0x1D242
#define unicode_COMBINING_GREEK_MUSICAL_TETRASEME                     0x1D243
#define unicode_COMBINING_GREEK_MUSICAL_PENTASEME                     0x1D244
#define unicode_GREEK_MUSICAL_LEIMMA                                  0x1D245
#define unicode_MONOGRAM_FOR_EARTH                                    0x1D300
#define unicode_DIGRAM_FOR_HEAVENLY_EARTH                             0x1D301
#define unicode_DIGRAM_FOR_HUMAN_EARTH                                0x1D302
#define unicode_DIGRAM_FOR_EARTHLY_HEAVEN                             0x1D303
#define unicode_DIGRAM_FOR_EARTHLY_HUMAN                              0x1D304
#define unicode_DIGRAM_FOR_EARTH                                      0x1D305
#define unicode_TETRAGRAM_FOR_CENTRE                                  0x1D306
#define unicode_TETRAGRAM_FOR_FULL_CIRCLE                             0x1D307
#define unicode_TETRAGRAM_FOR_MIRED                                   0x1D308
#define unicode_TETRAGRAM_FOR_BARRIER                                 0x1D309
#define unicode_TETRAGRAM_FOR_KEEPING_SMALL                           0x1D30A
#define unicode_TETRAGRAM_FOR_CONTRARIETY                             0x1D30B
#define unicode_TETRAGRAM_FOR_ASCENT                                  0x1D30C
#define unicode_TETRAGRAM_FOR_OPPOSITION                              0x1D30D
#define unicode_TETRAGRAM_FOR_BRANCHING_OUT                           0x1D30E
#define unicode_TETRAGRAM_FOR_DEFECTIVENESS_OR_DISTORTION             0x1D30F
#define unicode_TETRAGRAM_FOR_DIVERGENCE                              0x1D310
#define unicode_TETRAGRAM_FOR_YOUTHFULNESS                            0x1D311
#define unicode_TETRAGRAM_FOR_INCREASE                                0x1D312
#define unicode_TETRAGRAM_FOR_PENETRATION                             0x1D313
#define unicode_TETRAGRAM_FOR_REACH                                   0x1D314
#define unicode_TETRAGRAM_FOR_CONTACT                                 0x1D315
#define unicode_TETRAGRAM_FOR_HOLDING_BACK                            0x1D316
#define unicode_TETRAGRAM_FOR_WAITING                                 0x1D317
#define unicode_TETRAGRAM_FOR_FOLLOWING                               0x1D318
#define unicode_TETRAGRAM_FOR_ADVANCE                                 0x1D319
#define unicode_TETRAGRAM_FOR_RELEASE                                 0x1D31A
#define unicode_TETRAGRAM_FOR_RESISTANCE                              0x1D31B
#define unicode_TETRAGRAM_FOR_EASE                                    0x1D31C
#define unicode_TETRAGRAM_FOR_JOY                                     0x1D31D
#define unicode_TETRAGRAM_FOR_CONTENTION                              0x1D31E
#define unicode_TETRAGRAM_FOR_ENDEAVOUR                               0x1D31F
#define unicode_TETRAGRAM_FOR_DUTIES                                  0x1D320
#define unicode_TETRAGRAM_FOR_CHANGE                                  0x1D321
#define unicode_TETRAGRAM_FOR_DECISIVENESS                            0x1D322
#define unicode_TETRAGRAM_FOR_BOLD_RESOLUTION                         0x1D323
#define unicode_TETRAGRAM_FOR_PACKING                                 0x1D324
#define unicode_TETRAGRAM_FOR_LEGION                                  0x1D325
#define unicode_TETRAGRAM_FOR_CLOSENESS                               0x1D326
#define unicode_TETRAGRAM_FOR_KINSHIP                                 0x1D327
#define unicode_TETRAGRAM_FOR_GATHERING                               0x1D328
#define unicode_TETRAGRAM_FOR_STRENGTH                                0x1D329
#define unicode_TETRAGRAM_FOR_PURITY                                  0x1D32A
#define unicode_TETRAGRAM_FOR_FULLNESS                                0x1D32B
#define unicode_TETRAGRAM_FOR_RESIDENCE                               0x1D32C
#define unicode_TETRAGRAM_FOR_LAW_OR_MODEL                            0x1D32D
#define unicode_TETRAGRAM_FOR_RESPONSE                                0x1D32E
#define unicode_TETRAGRAM_FOR_GOING_TO_MEET                           0x1D32F
#define unicode_TETRAGRAM_FOR_ENCOUNTERS                              0x1D330
#define unicode_TETRAGRAM_FOR_STOVE                                   0x1D331
#define unicode_TETRAGRAM_FOR_GREATNESS                               0x1D332
#define unicode_TETRAGRAM_FOR_ENLARGEMENT                             0x1D333
#define unicode_TETRAGRAM_FOR_PATTERN                                 0x1D334
#define unicode_TETRAGRAM_FOR_RITUAL                                  0x1D335
#define unicode_TETRAGRAM_FOR_FLIGHT                                  0x1D336
#define unicode_TETRAGRAM_FOR_VASTNESS_OR_WASTING                     0x1D337
#define unicode_TETRAGRAM_FOR_CONSTANCY                               0x1D338
#define unicode_TETRAGRAM_FOR_MEASURE                                 0x1D339
#define unicode_TETRAGRAM_FOR_ETERNITY                                0x1D33A
#define unicode_TETRAGRAM_FOR_UNITY                                   0x1D33B
#define unicode_TETRAGRAM_FOR_DIMINISHMENT                            0x1D33C
#define unicode_TETRAGRAM_FOR_CLOSED_MOUTH                            0x1D33D
#define unicode_TETRAGRAM_FOR_GUARDEDNESS                             0x1D33E
#define unicode_TETRAGRAM_FOR_GATHERING_IN                            0x1D33F
#define unicode_TETRAGRAM_FOR_MASSING                                 0x1D340
#define unicode_TETRAGRAM_FOR_ACCUMULATION                            0x1D341
#define unicode_TETRAGRAM_FOR_EMBELLISHMENT                           0x1D342
#define unicode_TETRAGRAM_FOR_DOUBT                                   0x1D343
#define unicode_TETRAGRAM_FOR_WATCH                                   0x1D344
#define unicode_TETRAGRAM_FOR_SINKING                                 0x1D345
#define unicode_TETRAGRAM_FOR_INNER                                   0x1D346
#define unicode_TETRAGRAM_FOR_DEPARTURE                               0x1D347
#define unicode_TETRAGRAM_FOR_DARKENING                               0x1D348
#define unicode_TETRAGRAM_FOR_DIMMING                                 0x1D349
#define unicode_TETRAGRAM_FOR_EXHAUSTION                              0x1D34A
#define unicode_TETRAGRAM_FOR_SEVERANCE                               0x1D34B
#define unicode_TETRAGRAM_FOR_STOPPAGE                                0x1D34C
#define unicode_TETRAGRAM_FOR_HARDNESS                                0x1D34D
#define unicode_TETRAGRAM_FOR_COMPLETION                              0x1D34E
#define unicode_TETRAGRAM_FOR_CLOSURE                                 0x1D34F
#define unicode_TETRAGRAM_FOR_FAILURE                                 0x1D350
#define unicode_TETRAGRAM_FOR_AGGRAVATION                             0x1D351
#define unicode_TETRAGRAM_FOR_COMPLIANCE                              0x1D352
#define unicode_TETRAGRAM_FOR_ON_THE_VERGE                            0x1D353
#define unicode_TETRAGRAM_FOR_DIFFICULTIES                            0x1D354
#define unicode_TETRAGRAM_FOR_LABOURING                               0x1D355
#define unicode_TETRAGRAM_FOR_FOSTERING                               0x1D356
#define unicode_COUNTING_ROD_UNIT_DIGIT_ONE                           0x1D360
#define unicode_COUNTING_ROD_UNIT_DIGIT_TWO                           0x1D361
#define unicode_COUNTING_ROD_UNIT_DIGIT_THREE                         0x1D362
#define unicode_COUNTING_ROD_UNIT_DIGIT_FOUR                          0x1D363
#define unicode_COUNTING_ROD_UNIT_DIGIT_FIVE                          0x1D364
#define unicode_COUNTING_ROD_UNIT_DIGIT_SIX                           0x1D365
#define unicode_COUNTING_ROD_UNIT_DIGIT_SEVEN                         0x1D366
#define unicode_COUNTING_ROD_UNIT_DIGIT_EIGHT                         0x1D367
#define unicode_COUNTING_ROD_UNIT_DIGIT_NINE                          0x1D368
#define unicode_COUNTING_ROD_TENS_DIGIT_ONE                           0x1D369
#define unicode_COUNTING_ROD_TENS_DIGIT_TWO                           0x1D36A
#define unicode_COUNTING_ROD_TENS_DIGIT_THREE                         0x1D36B
#define unicode_COUNTING_ROD_TENS_DIGIT_FOUR                          0x1D36C
#define unicode_COUNTING_ROD_TENS_DIGIT_FIVE                          0x1D36D
#define unicode_COUNTING_ROD_TENS_DIGIT_SIX                           0x1D36E
#define unicode_COUNTING_ROD_TENS_DIGIT_SEVEN                         0x1D36F
#define unicode_COUNTING_ROD_TENS_DIGIT_EIGHT                         0x1D370
#define unicode_COUNTING_ROD_TENS_DIGIT_NINE                          0x1D371
#define unicode_MATHEMATICAL_BOLD_CAPITAL_A                           0x1D400
#define unicode_MATHEMATICAL_BOLD_CAPITAL_B                           0x1D401
#define unicode_MATHEMATICAL_BOLD_CAPITAL_C                           0x1D402
#define unicode_MATHEMATICAL_BOLD_CAPITAL_D                           0x1D403
#define unicode_MATHEMATICAL_BOLD_CAPITAL_E                           0x1D404
#define unicode_MATHEMATICAL_BOLD_CAPITAL_F                           0x1D405
#define unicode_MATHEMATICAL_BOLD_CAPITAL_G                           0x1D406
#define unicode_MATHEMATICAL_BOLD_CAPITAL_H                           0x1D407
#define unicode_MATHEMATICAL_BOLD_CAPITAL_I                           0x1D408
#define unicode_MATHEMATICAL_BOLD_CAPITAL_J                           0x1D409
#define unicode_MATHEMATICAL_BOLD_CAPITAL_K                           0x1D40A
#define unicode_MATHEMATICAL_BOLD_CAPITAL_L                           0x1D40B
#define unicode_MATHEMATICAL_BOLD_CAPITAL_M                           0x1D40C
#define unicode_MATHEMATICAL_BOLD_CAPITAL_N                           0x1D40D
#define unicode_MATHEMATICAL_BOLD_CAPITAL_O                           0x1D40E
#define unicode_MATHEMATICAL_BOLD_CAPITAL_P                           0x1D40F
#define unicode_MATHEMATICAL_BOLD_CAPITAL_Q                           0x1D410
#define unicode_MATHEMATICAL_BOLD_CAPITAL_R                           0x1D411
#define unicode_MATHEMATICAL_BOLD_CAPITAL_S                           0x1D412
#define unicode_MATHEMATICAL_BOLD_CAPITAL_T                           0x1D413
#define unicode_MATHEMATICAL_BOLD_CAPITAL_U                           0x1D414
#define unicode_MATHEMATICAL_BOLD_CAPITAL_V                           0x1D415
#define unicode_MATHEMATICAL_BOLD_CAPITAL_W                           0x1D416
#define unicode_MATHEMATICAL_BOLD_CAPITAL_X                           0x1D417
#define unicode_MATHEMATICAL_BOLD_CAPITAL_Y                           0x1D418
#define unicode_MATHEMATICAL_BOLD_CAPITAL_Z                           0x1D419
#define unicode_MATHEMATICAL_BOLD_SMALL_A                             0x1D41A
#define unicode_MATHEMATICAL_BOLD_SMALL_B                             0x1D41B
#define unicode_MATHEMATICAL_BOLD_SMALL_C                             0x1D41C
#define unicode_MATHEMATICAL_BOLD_SMALL_D                             0x1D41D
#define unicode_MATHEMATICAL_BOLD_SMALL_E                             0x1D41E
#define unicode_MATHEMATICAL_BOLD_SMALL_F                             0x1D41F
#define unicode_MATHEMATICAL_BOLD_SMALL_G                             0x1D420
#define unicode_MATHEMATICAL_BOLD_SMALL_H                             0x1D421
#define unicode_MATHEMATICAL_BOLD_SMALL_I                             0x1D422
#define unicode_MATHEMATICAL_BOLD_SMALL_J                             0x1D423
#define unicode_MATHEMATICAL_BOLD_SMALL_K                             0x1D424
#define unicode_MATHEMATICAL_BOLD_SMALL_L                             0x1D425
#define unicode_MATHEMATICAL_BOLD_SMALL_M                             0x1D426
#define unicode_MATHEMATICAL_BOLD_SMALL_N                             0x1D427
#define unicode_MATHEMATICAL_BOLD_SMALL_O                             0x1D428
#define unicode_MATHEMATICAL_BOLD_SMALL_P                             0x1D429
#define unicode_MATHEMATICAL_BOLD_SMALL_Q                             0x1D42A
#define unicode_MATHEMATICAL_BOLD_SMALL_R                             0x1D42B
#define unicode_MATHEMATICAL_BOLD_SMALL_S                             0x1D42C
#define unicode_MATHEMATICAL_BOLD_SMALL_T                             0x1D42D
#define unicode_MATHEMATICAL_BOLD_SMALL_U                             0x1D42E
#define unicode_MATHEMATICAL_BOLD_SMALL_V                             0x1D42F
#define unicode_MATHEMATICAL_BOLD_SMALL_W                             0x1D430
#define unicode_MATHEMATICAL_BOLD_SMALL_X                             0x1D431
#define unicode_MATHEMATICAL_BOLD_SMALL_Y                             0x1D432
#define unicode_MATHEMATICAL_BOLD_SMALL_Z                             0x1D433
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_A                         0x1D434
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_B                         0x1D435
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_C                         0x1D436
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_D                         0x1D437
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_E                         0x1D438
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_F                         0x1D439
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_G                         0x1D43A
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_H                         0x1D43B
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_I                         0x1D43C
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_J                         0x1D43D
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_K                         0x1D43E
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_L                         0x1D43F
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_M                         0x1D440
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_N                         0x1D441
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_O                         0x1D442
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_P                         0x1D443
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_Q                         0x1D444
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_R                         0x1D445
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_S                         0x1D446
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_T                         0x1D447
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_U                         0x1D448
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_V                         0x1D449
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_W                         0x1D44A
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_X                         0x1D44B
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_Y                         0x1D44C
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_Z                         0x1D44D
#define unicode_MATHEMATICAL_ITALIC_SMALL_A                           0x1D44E
#define unicode_MATHEMATICAL_ITALIC_SMALL_B                           0x1D44F
#define unicode_MATHEMATICAL_ITALIC_SMALL_C                           0x1D450
#define unicode_MATHEMATICAL_ITALIC_SMALL_D                           0x1D451
#define unicode_MATHEMATICAL_ITALIC_SMALL_E                           0x1D452
#define unicode_MATHEMATICAL_ITALIC_SMALL_F                           0x1D453
#define unicode_MATHEMATICAL_ITALIC_SMALL_G                           0x1D454
#define unicode_MATHEMATICAL_ITALIC_SMALL_I                           0x1D456
#define unicode_MATHEMATICAL_ITALIC_SMALL_J                           0x1D457
#define unicode_MATHEMATICAL_ITALIC_SMALL_K                           0x1D458
#define unicode_MATHEMATICAL_ITALIC_SMALL_L                           0x1D459
#define unicode_MATHEMATICAL_ITALIC_SMALL_M                           0x1D45A
#define unicode_MATHEMATICAL_ITALIC_SMALL_N                           0x1D45B
#define unicode_MATHEMATICAL_ITALIC_SMALL_O                           0x1D45C
#define unicode_MATHEMATICAL_ITALIC_SMALL_P                           0x1D45D
#define unicode_MATHEMATICAL_ITALIC_SMALL_Q                           0x1D45E
#define unicode_MATHEMATICAL_ITALIC_SMALL_R                           0x1D45F
#define unicode_MATHEMATICAL_ITALIC_SMALL_S                           0x1D460
#define unicode_MATHEMATICAL_ITALIC_SMALL_T                           0x1D461
#define unicode_MATHEMATICAL_ITALIC_SMALL_U                           0x1D462
#define unicode_MATHEMATICAL_ITALIC_SMALL_V                           0x1D463
#define unicode_MATHEMATICAL_ITALIC_SMALL_W                           0x1D464
#define unicode_MATHEMATICAL_ITALIC_SMALL_X                           0x1D465
#define unicode_MATHEMATICAL_ITALIC_SMALL_Y                           0x1D466
#define unicode_MATHEMATICAL_ITALIC_SMALL_Z                           0x1D467
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_A                    0x1D468
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_B                    0x1D469
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_C                    0x1D46A
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_D                    0x1D46B
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_E                    0x1D46C
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_F                    0x1D46D
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_G                    0x1D46E
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_H                    0x1D46F
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_I                    0x1D470
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_J                    0x1D471
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_K                    0x1D472
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_L                    0x1D473
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_M                    0x1D474
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_N                    0x1D475
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_O                    0x1D476
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_P                    0x1D477
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_Q                    0x1D478
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_R                    0x1D479
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_S                    0x1D47A
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_T                    0x1D47B
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_U                    0x1D47C
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_V                    0x1D47D
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_W                    0x1D47E
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_X                    0x1D47F
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_Y                    0x1D480
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_Z                    0x1D481
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_A                      0x1D482
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_B                      0x1D483
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_C                      0x1D484
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_D                      0x1D485
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_E                      0x1D486
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_F                      0x1D487
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_G                      0x1D488
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_H                      0x1D489
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_I                      0x1D48A
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_J                      0x1D48B
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_K                      0x1D48C
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_L                      0x1D48D
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_M                      0x1D48E
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_N                      0x1D48F
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_O                      0x1D490
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_P                      0x1D491
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_Q                      0x1D492
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_R                      0x1D493
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_S                      0x1D494
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_T                      0x1D495
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_U                      0x1D496
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_V                      0x1D497
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_W                      0x1D498
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_X                      0x1D499
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_Y                      0x1D49A
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_Z                      0x1D49B
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_A                         0x1D49C
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_C                         0x1D49E
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_D                         0x1D49F
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_G                         0x1D4A2
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_J                         0x1D4A5
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_K                         0x1D4A6
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_N                         0x1D4A9
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_O                         0x1D4AA
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_P                         0x1D4AB
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_Q                         0x1D4AC
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_S                         0x1D4AE
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_T                         0x1D4AF
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_U                         0x1D4B0
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_V                         0x1D4B1
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_W                         0x1D4B2
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_X                         0x1D4B3
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_Y                         0x1D4B4
#define unicode_MATHEMATICAL_SCRIPT_CAPITAL_Z                         0x1D4B5
#define unicode_MATHEMATICAL_SCRIPT_SMALL_A                           0x1D4B6
#define unicode_MATHEMATICAL_SCRIPT_SMALL_B                           0x1D4B7
#define unicode_MATHEMATICAL_SCRIPT_SMALL_C                           0x1D4B8
#define unicode_MATHEMATICAL_SCRIPT_SMALL_D                           0x1D4B9
#define unicode_MATHEMATICAL_SCRIPT_SMALL_F                           0x1D4BB
#define unicode_MATHEMATICAL_SCRIPT_SMALL_H                           0x1D4BD
#define unicode_MATHEMATICAL_SCRIPT_SMALL_I                           0x1D4BE
#define unicode_MATHEMATICAL_SCRIPT_SMALL_J                           0x1D4BF
#define unicode_MATHEMATICAL_SCRIPT_SMALL_K                           0x1D4C0
#define unicode_MATHEMATICAL_SCRIPT_SMALL_L                           0x1D4C1
#define unicode_MATHEMATICAL_SCRIPT_SMALL_M                           0x1D4C2
#define unicode_MATHEMATICAL_SCRIPT_SMALL_N                           0x1D4C3
#define unicode_MATHEMATICAL_SCRIPT_SMALL_P                           0x1D4C5
#define unicode_MATHEMATICAL_SCRIPT_SMALL_Q                           0x1D4C6
#define unicode_MATHEMATICAL_SCRIPT_SMALL_R                           0x1D4C7
#define unicode_MATHEMATICAL_SCRIPT_SMALL_S                           0x1D4C8
#define unicode_MATHEMATICAL_SCRIPT_SMALL_T                           0x1D4C9
#define unicode_MATHEMATICAL_SCRIPT_SMALL_U                           0x1D4CA
#define unicode_MATHEMATICAL_SCRIPT_SMALL_V                           0x1D4CB
#define unicode_MATHEMATICAL_SCRIPT_SMALL_W                           0x1D4CC
#define unicode_MATHEMATICAL_SCRIPT_SMALL_X                           0x1D4CD
#define unicode_MATHEMATICAL_SCRIPT_SMALL_Y                           0x1D4CE
#define unicode_MATHEMATICAL_SCRIPT_SMALL_Z                           0x1D4CF
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_A                    0x1D4D0
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_B                    0x1D4D1
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_C                    0x1D4D2
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_D                    0x1D4D3
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_E                    0x1D4D4
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_F                    0x1D4D5
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_G                    0x1D4D6
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_H                    0x1D4D7
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_I                    0x1D4D8
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_J                    0x1D4D9
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_K                    0x1D4DA
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_L                    0x1D4DB
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_M                    0x1D4DC
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_N                    0x1D4DD
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_O                    0x1D4DE
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_P                    0x1D4DF
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_Q                    0x1D4E0
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_R                    0x1D4E1
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_S                    0x1D4E2
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_T                    0x1D4E3
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_U                    0x1D4E4
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_V                    0x1D4E5
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_W                    0x1D4E6
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_X                    0x1D4E7
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_Y                    0x1D4E8
#define unicode_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_Z                    0x1D4E9
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_A                      0x1D4EA
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_B                      0x1D4EB
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_C                      0x1D4EC
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_D                      0x1D4ED
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_E                      0x1D4EE
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_F                      0x1D4EF
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_G                      0x1D4F0
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_H                      0x1D4F1
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_I                      0x1D4F2
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_J                      0x1D4F3
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_K                      0x1D4F4
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_L                      0x1D4F5
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_M                      0x1D4F6
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_N                      0x1D4F7
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_O                      0x1D4F8
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_P                      0x1D4F9
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_Q                      0x1D4FA
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_R                      0x1D4FB
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_S                      0x1D4FC
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_T                      0x1D4FD
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_U                      0x1D4FE
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_V                      0x1D4FF
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_W                      0x1D500
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_X                      0x1D501
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_Y                      0x1D502
#define unicode_MATHEMATICAL_BOLD_SCRIPT_SMALL_Z                      0x1D503
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_A                        0x1D504
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_B                        0x1D505
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_D                        0x1D507
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_E                        0x1D508
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_F                        0x1D509
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_G                        0x1D50A
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_J                        0x1D50D
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_K                        0x1D50E
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_L                        0x1D50F
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_M                        0x1D510
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_N                        0x1D511
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_O                        0x1D512
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_P                        0x1D513
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_Q                        0x1D514
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_S                        0x1D516
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_T                        0x1D517
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_U                        0x1D518
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_V                        0x1D519
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_W                        0x1D51A
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_X                        0x1D51B
#define unicode_MATHEMATICAL_FRAKTUR_CAPITAL_Y                        0x1D51C
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_A                          0x1D51E
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_B                          0x1D51F
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_C                          0x1D520
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_D                          0x1D521
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_E                          0x1D522
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_F                          0x1D523
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_G                          0x1D524
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_H                          0x1D525
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_I                          0x1D526
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_J                          0x1D527
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_K                          0x1D528
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_L                          0x1D529
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_M                          0x1D52A
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_N                          0x1D52B
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_O                          0x1D52C
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_P                          0x1D52D
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_Q                          0x1D52E
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_R                          0x1D52F
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_S                          0x1D530
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_T                          0x1D531
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_U                          0x1D532
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_V                          0x1D533
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_W                          0x1D534
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_X                          0x1D535
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_Y                          0x1D536
#define unicode_MATHEMATICAL_FRAKTUR_SMALL_Z                          0x1D537
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_A                  0x1D538
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_B                  0x1D539
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_D                  0x1D53B
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_E                  0x1D53C
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_F                  0x1D53D
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_G                  0x1D53E
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_I                  0x1D540
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_J                  0x1D541
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_K                  0x1D542
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_L                  0x1D543
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_M                  0x1D544
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_O                  0x1D546
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_S                  0x1D54A
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_T                  0x1D54B
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_U                  0x1D54C
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_V                  0x1D54D
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_W                  0x1D54E
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_X                  0x1D54F
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_Y                  0x1D550
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_A                    0x1D552
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_B                    0x1D553
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_C                    0x1D554
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_D                    0x1D555
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_E                    0x1D556
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_F                    0x1D557
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_G                    0x1D558
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_H                    0x1D559
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_I                    0x1D55A
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_J                    0x1D55B
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_K                    0x1D55C
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_L                    0x1D55D
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_M                    0x1D55E
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_N                    0x1D55F
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_O                    0x1D560
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_P                    0x1D561
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_Q                    0x1D562
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_R                    0x1D563
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_S                    0x1D564
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_T                    0x1D565
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_U                    0x1D566
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_V                    0x1D567
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_W                    0x1D568
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_X                    0x1D569
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_Y                    0x1D56A
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_SMALL_Z                    0x1D56B
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_A                   0x1D56C
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_B                   0x1D56D
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_C                   0x1D56E
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_D                   0x1D56F
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_E                   0x1D570
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_F                   0x1D571
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_G                   0x1D572
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_H                   0x1D573
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_I                   0x1D574
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_J                   0x1D575
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_K                   0x1D576
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_L                   0x1D577
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_M                   0x1D578
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_N                   0x1D579
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_O                   0x1D57A
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_P                   0x1D57B
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_Q                   0x1D57C
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_R                   0x1D57D
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_S                   0x1D57E
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_T                   0x1D57F
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_U                   0x1D580
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_V                   0x1D581
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_W                   0x1D582
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_X                   0x1D583
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_Y                   0x1D584
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_Z                   0x1D585
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_A                     0x1D586
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_B                     0x1D587
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_C                     0x1D588
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_D                     0x1D589
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_E                     0x1D58A
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_F                     0x1D58B
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_G                     0x1D58C
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_H                     0x1D58D
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_I                     0x1D58E
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_J                     0x1D58F
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_K                     0x1D590
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_L                     0x1D591
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_M                     0x1D592
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_N                     0x1D593
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_O                     0x1D594
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_P                     0x1D595
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_Q                     0x1D596
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_R                     0x1D597
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_S                     0x1D598
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_T                     0x1D599
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_U                     0x1D59A
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_V                     0x1D59B
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_W                     0x1D59C
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_X                     0x1D59D
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_Y                     0x1D59E
#define unicode_MATHEMATICAL_BOLD_FRAKTUR_SMALL_Z                     0x1D59F
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_A                     0x1D5A0
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_B                     0x1D5A1
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_C                     0x1D5A2
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_D                     0x1D5A3
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_E                     0x1D5A4
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_F                     0x1D5A5
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_G                     0x1D5A6
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_H                     0x1D5A7
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_I                     0x1D5A8
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_J                     0x1D5A9
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_K                     0x1D5AA
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_L                     0x1D5AB
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_M                     0x1D5AC
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_N                     0x1D5AD
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_O                     0x1D5AE
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_P                     0x1D5AF
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_Q                     0x1D5B0
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_R                     0x1D5B1
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_S                     0x1D5B2
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_T                     0x1D5B3
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_U                     0x1D5B4
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_V                     0x1D5B5
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_W                     0x1D5B6
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_X                     0x1D5B7
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_Y                     0x1D5B8
#define unicode_MATHEMATICAL_SANS_SERIF_CAPITAL_Z                     0x1D5B9
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_A                       0x1D5BA
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_B                       0x1D5BB
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_C                       0x1D5BC
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_D                       0x1D5BD
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_E                       0x1D5BE
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_F                       0x1D5BF
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_G                       0x1D5C0
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_H                       0x1D5C1
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_I                       0x1D5C2
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_J                       0x1D5C3
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_K                       0x1D5C4
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_L                       0x1D5C5
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_M                       0x1D5C6
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_N                       0x1D5C7
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_O                       0x1D5C8
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_P                       0x1D5C9
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_Q                       0x1D5CA
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_R                       0x1D5CB
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_S                       0x1D5CC
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_T                       0x1D5CD
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_U                       0x1D5CE
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_V                       0x1D5CF
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_W                       0x1D5D0
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_X                       0x1D5D1
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_Y                       0x1D5D2
#define unicode_MATHEMATICAL_SANS_SERIF_SMALL_Z                       0x1D5D3
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_A                0x1D5D4
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_B                0x1D5D5
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_C                0x1D5D6
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_D                0x1D5D7
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_E                0x1D5D8
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_F                0x1D5D9
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_G                0x1D5DA
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_H                0x1D5DB
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_I                0x1D5DC
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_J                0x1D5DD
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_K                0x1D5DE
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_L                0x1D5DF
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_M                0x1D5E0
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_N                0x1D5E1
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_O                0x1D5E2
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_P                0x1D5E3
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_Q                0x1D5E4
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_R                0x1D5E5
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_S                0x1D5E6
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_T                0x1D5E7
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_U                0x1D5E8
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_V                0x1D5E9
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_W                0x1D5EA
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_X                0x1D5EB
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_Y                0x1D5EC
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_Z                0x1D5ED
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_A                  0x1D5EE
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_B                  0x1D5EF
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_C                  0x1D5F0
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_D                  0x1D5F1
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_E                  0x1D5F2
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_F                  0x1D5F3
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_G                  0x1D5F4
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_H                  0x1D5F5
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_I                  0x1D5F6
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_J                  0x1D5F7
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_K                  0x1D5F8
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_L                  0x1D5F9
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_M                  0x1D5FA
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_N                  0x1D5FB
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_O                  0x1D5FC
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_P                  0x1D5FD
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_Q                  0x1D5FE
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_R                  0x1D5FF
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_S                  0x1D600
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_T                  0x1D601
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_U                  0x1D602
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_V                  0x1D603
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_W                  0x1D604
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_X                  0x1D605
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_Y                  0x1D606
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_Z                  0x1D607
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_A              0x1D608
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_B              0x1D609
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_C              0x1D60A
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_D              0x1D60B
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_E              0x1D60C
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_F              0x1D60D
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_G              0x1D60E
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_H              0x1D60F
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_I              0x1D610
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_J              0x1D611
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_K              0x1D612
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_L              0x1D613
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_M              0x1D614
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_N              0x1D615
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_O              0x1D616
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_P              0x1D617
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_Q              0x1D618
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_R              0x1D619
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_S              0x1D61A
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_T              0x1D61B
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_U              0x1D61C
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_V              0x1D61D
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_W              0x1D61E
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_X              0x1D61F
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_Y              0x1D620
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_Z              0x1D621
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_A                0x1D622
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_B                0x1D623
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_C                0x1D624
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_D                0x1D625
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_E                0x1D626
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_F                0x1D627
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_G                0x1D628
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_H                0x1D629
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_I                0x1D62A
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_J                0x1D62B
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_K                0x1D62C
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_L                0x1D62D
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_M                0x1D62E
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_N                0x1D62F
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_O                0x1D630
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_P                0x1D631
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_Q                0x1D632
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_R                0x1D633
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_S                0x1D634
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_T                0x1D635
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_U                0x1D636
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_V                0x1D637
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_W                0x1D638
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_X                0x1D639
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_Y                0x1D63A
#define unicode_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_Z                0x1D63B
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_A         0x1D63C
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_B         0x1D63D
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_C         0x1D63E
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_D         0x1D63F
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_E         0x1D640
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_F         0x1D641
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_G         0x1D642
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_H         0x1D643
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_I         0x1D644
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_J         0x1D645
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_K         0x1D646
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_L         0x1D647
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_M         0x1D648
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_N         0x1D649
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_O         0x1D64A
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_P         0x1D64B
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_Q         0x1D64C
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_R         0x1D64D
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_S         0x1D64E
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_T         0x1D64F
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_U         0x1D650
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_V         0x1D651
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_W         0x1D652
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_X         0x1D653
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_Y         0x1D654
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_Z         0x1D655
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_A           0x1D656
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_B           0x1D657
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_C           0x1D658
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_D           0x1D659
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_E           0x1D65A
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_F           0x1D65B
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_G           0x1D65C
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_H           0x1D65D
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_I           0x1D65E
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_J           0x1D65F
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_K           0x1D660
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_L           0x1D661
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_M           0x1D662
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_N           0x1D663
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_O           0x1D664
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_P           0x1D665
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_Q           0x1D666
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_R           0x1D667
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_S           0x1D668
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_T           0x1D669
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_U           0x1D66A
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_V           0x1D66B
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_W           0x1D66C
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_X           0x1D66D
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_Y           0x1D66E
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_Z           0x1D66F
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_A                      0x1D670
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_B                      0x1D671
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_C                      0x1D672
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_D                      0x1D673
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_E                      0x1D674
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_F                      0x1D675
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_G                      0x1D676
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_H                      0x1D677
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_I                      0x1D678
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_J                      0x1D679
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_K                      0x1D67A
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_L                      0x1D67B
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_M                      0x1D67C
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_N                      0x1D67D
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_O                      0x1D67E
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_P                      0x1D67F
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_Q                      0x1D680
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_R                      0x1D681
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_S                      0x1D682
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_T                      0x1D683
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_U                      0x1D684
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_V                      0x1D685
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_W                      0x1D686
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_X                      0x1D687
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_Y                      0x1D688
#define unicode_MATHEMATICAL_MONOSPACE_CAPITAL_Z                      0x1D689
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_A                        0x1D68A
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_B                        0x1D68B
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_C                        0x1D68C
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_D                        0x1D68D
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_E                        0x1D68E
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_F                        0x1D68F
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_G                        0x1D690
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_H                        0x1D691
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_I                        0x1D692
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_J                        0x1D693
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_K                        0x1D694
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_L                        0x1D695
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_M                        0x1D696
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_N                        0x1D697
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_O                        0x1D698
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_P                        0x1D699
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_Q                        0x1D69A
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_R                        0x1D69B
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_S                        0x1D69C
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_T                        0x1D69D
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_U                        0x1D69E
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_V                        0x1D69F
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_W                        0x1D6A0
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_X                        0x1D6A1
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_Y                        0x1D6A2
#define unicode_MATHEMATICAL_MONOSPACE_SMALL_Z                        0x1D6A3
#define unicode_MATHEMATICAL_ITALIC_SMALL_DOTLESS_I                   0x1D6A4
#define unicode_MATHEMATICAL_ITALIC_SMALL_DOTLESS_J                   0x1D6A5
#define unicode_MATHEMATICAL_BOLD_CAPITAL_ALPHA                       0x1D6A8
#define unicode_MATHEMATICAL_BOLD_CAPITAL_BETA                        0x1D6A9
#define unicode_MATHEMATICAL_BOLD_CAPITAL_GAMMA                       0x1D6AA
#define unicode_MATHEMATICAL_BOLD_CAPITAL_DELTA                       0x1D6AB
#define unicode_MATHEMATICAL_BOLD_CAPITAL_EPSILON                     0x1D6AC
#define unicode_MATHEMATICAL_BOLD_CAPITAL_ZETA                        0x1D6AD
#define unicode_MATHEMATICAL_BOLD_CAPITAL_ETA                         0x1D6AE
#define unicode_MATHEMATICAL_BOLD_CAPITAL_THETA                       0x1D6AF
#define unicode_MATHEMATICAL_BOLD_CAPITAL_IOTA                        0x1D6B0
#define unicode_MATHEMATICAL_BOLD_CAPITAL_KAPPA                       0x1D6B1
#define unicode_MATHEMATICAL_BOLD_CAPITAL_LAMDA                       0x1D6B2
#define unicode_MATHEMATICAL_BOLD_CAPITAL_MU                          0x1D6B3
#define unicode_MATHEMATICAL_BOLD_CAPITAL_NU                          0x1D6B4
#define unicode_MATHEMATICAL_BOLD_CAPITAL_XI                          0x1D6B5
#define unicode_MATHEMATICAL_BOLD_CAPITAL_OMICRON                     0x1D6B6
#define unicode_MATHEMATICAL_BOLD_CAPITAL_PI                          0x1D6B7
#define unicode_MATHEMATICAL_BOLD_CAPITAL_RHO                         0x1D6B8
#define unicode_MATHEMATICAL_BOLD_CAPITAL_THETA_SYMBOL                0x1D6B9
#define unicode_MATHEMATICAL_BOLD_CAPITAL_SIGMA                       0x1D6BA
#define unicode_MATHEMATICAL_BOLD_CAPITAL_TAU                         0x1D6BB
#define unicode_MATHEMATICAL_BOLD_CAPITAL_UPSILON                     0x1D6BC
#define unicode_MATHEMATICAL_BOLD_CAPITAL_PHI                         0x1D6BD
#define unicode_MATHEMATICAL_BOLD_CAPITAL_CHI                         0x1D6BE
#define unicode_MATHEMATICAL_BOLD_CAPITAL_PSI                         0x1D6BF
#define unicode_MATHEMATICAL_BOLD_CAPITAL_OMEGA                       0x1D6C0
#define unicode_MATHEMATICAL_BOLD_NABLA                               0x1D6C1
#define unicode_MATHEMATICAL_BOLD_SMALL_ALPHA                         0x1D6C2
#define unicode_MATHEMATICAL_BOLD_SMALL_BETA                          0x1D6C3
#define unicode_MATHEMATICAL_BOLD_SMALL_GAMMA                         0x1D6C4
#define unicode_MATHEMATICAL_BOLD_SMALL_DELTA                         0x1D6C5
#define unicode_MATHEMATICAL_BOLD_SMALL_EPSILON                       0x1D6C6
#define unicode_MATHEMATICAL_BOLD_SMALL_ZETA                          0x1D6C7
#define unicode_MATHEMATICAL_BOLD_SMALL_ETA                           0x1D6C8
#define unicode_MATHEMATICAL_BOLD_SMALL_THETA                         0x1D6C9
#define unicode_MATHEMATICAL_BOLD_SMALL_IOTA                          0x1D6CA
#define unicode_MATHEMATICAL_BOLD_SMALL_KAPPA                         0x1D6CB
#define unicode_MATHEMATICAL_BOLD_SMALL_LAMDA                         0x1D6CC
#define unicode_MATHEMATICAL_BOLD_SMALL_MU                            0x1D6CD
#define unicode_MATHEMATICAL_BOLD_SMALL_NU                            0x1D6CE
#define unicode_MATHEMATICAL_BOLD_SMALL_XI                            0x1D6CF
#define unicode_MATHEMATICAL_BOLD_SMALL_OMICRON                       0x1D6D0
#define unicode_MATHEMATICAL_BOLD_SMALL_PI                            0x1D6D1
#define unicode_MATHEMATICAL_BOLD_SMALL_RHO                           0x1D6D2
#define unicode_MATHEMATICAL_BOLD_SMALL_FINAL_SIGMA                   0x1D6D3
#define unicode_MATHEMATICAL_BOLD_SMALL_SIGMA                         0x1D6D4
#define unicode_MATHEMATICAL_BOLD_SMALL_TAU                           0x1D6D5
#define unicode_MATHEMATICAL_BOLD_SMALL_UPSILON                       0x1D6D6
#define unicode_MATHEMATICAL_BOLD_SMALL_PHI                           0x1D6D7
#define unicode_MATHEMATICAL_BOLD_SMALL_CHI                           0x1D6D8
#define unicode_MATHEMATICAL_BOLD_SMALL_PSI                           0x1D6D9
#define unicode_MATHEMATICAL_BOLD_SMALL_OMEGA                         0x1D6DA
#define unicode_MATHEMATICAL_BOLD_PARTIAL_DIFFERENTIAL                0x1D6DB
#define unicode_MATHEMATICAL_BOLD_EPSILON_SYMBOL                      0x1D6DC
#define unicode_MATHEMATICAL_BOLD_THETA_SYMBOL                        0x1D6DD
#define unicode_MATHEMATICAL_BOLD_KAPPA_SYMBOL                        0x1D6DE
#define unicode_MATHEMATICAL_BOLD_PHI_SYMBOL                          0x1D6DF
#define unicode_MATHEMATICAL_BOLD_RHO_SYMBOL                          0x1D6E0
#define unicode_MATHEMATICAL_BOLD_PI_SYMBOL                           0x1D6E1
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_ALPHA                     0x1D6E2
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_BETA                      0x1D6E3
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_GAMMA                     0x1D6E4
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_DELTA                     0x1D6E5
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_EPSILON                   0x1D6E6
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_ZETA                      0x1D6E7
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_ETA                       0x1D6E8
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_THETA                     0x1D6E9
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_IOTA                      0x1D6EA
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_KAPPA                     0x1D6EB
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_LAMDA                     0x1D6EC
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_MU                        0x1D6ED
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_NU                        0x1D6EE
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_XI                        0x1D6EF
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_OMICRON                   0x1D6F0
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_PI                        0x1D6F1
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_RHO                       0x1D6F2
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_THETA_SYMBOL              0x1D6F3
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_SIGMA                     0x1D6F4
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_TAU                       0x1D6F5
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_UPSILON                   0x1D6F6
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_PHI                       0x1D6F7
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_CHI                       0x1D6F8
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_PSI                       0x1D6F9
#define unicode_MATHEMATICAL_ITALIC_CAPITAL_OMEGA                     0x1D6FA
#define unicode_MATHEMATICAL_ITALIC_NABLA                             0x1D6FB
#define unicode_MATHEMATICAL_ITALIC_SMALL_ALPHA                       0x1D6FC
#define unicode_MATHEMATICAL_ITALIC_SMALL_BETA                        0x1D6FD
#define unicode_MATHEMATICAL_ITALIC_SMALL_GAMMA                       0x1D6FE
#define unicode_MATHEMATICAL_ITALIC_SMALL_DELTA                       0x1D6FF
#define unicode_MATHEMATICAL_ITALIC_SMALL_EPSILON                     0x1D700
#define unicode_MATHEMATICAL_ITALIC_SMALL_ZETA                        0x1D701
#define unicode_MATHEMATICAL_ITALIC_SMALL_ETA                         0x1D702
#define unicode_MATHEMATICAL_ITALIC_SMALL_THETA                       0x1D703
#define unicode_MATHEMATICAL_ITALIC_SMALL_IOTA                        0x1D704
#define unicode_MATHEMATICAL_ITALIC_SMALL_KAPPA                       0x1D705
#define unicode_MATHEMATICAL_ITALIC_SMALL_LAMDA                       0x1D706
#define unicode_MATHEMATICAL_ITALIC_SMALL_MU                          0x1D707
#define unicode_MATHEMATICAL_ITALIC_SMALL_NU                          0x1D708
#define unicode_MATHEMATICAL_ITALIC_SMALL_XI                          0x1D709
#define unicode_MATHEMATICAL_ITALIC_SMALL_OMICRON                     0x1D70A
#define unicode_MATHEMATICAL_ITALIC_SMALL_PI                          0x1D70B
#define unicode_MATHEMATICAL_ITALIC_SMALL_RHO                         0x1D70C
#define unicode_MATHEMATICAL_ITALIC_SMALL_FINAL_SIGMA                 0x1D70D
#define unicode_MATHEMATICAL_ITALIC_SMALL_SIGMA                       0x1D70E
#define unicode_MATHEMATICAL_ITALIC_SMALL_TAU                         0x1D70F
#define unicode_MATHEMATICAL_ITALIC_SMALL_UPSILON                     0x1D710
#define unicode_MATHEMATICAL_ITALIC_SMALL_PHI                         0x1D711
#define unicode_MATHEMATICAL_ITALIC_SMALL_CHI                         0x1D712
#define unicode_MATHEMATICAL_ITALIC_SMALL_PSI                         0x1D713
#define unicode_MATHEMATICAL_ITALIC_SMALL_OMEGA                       0x1D714
#define unicode_MATHEMATICAL_ITALIC_PARTIAL_DIFFERENTIAL              0x1D715
#define unicode_MATHEMATICAL_ITALIC_EPSILON_SYMBOL                    0x1D716
#define unicode_MATHEMATICAL_ITALIC_THETA_SYMBOL                      0x1D717
#define unicode_MATHEMATICAL_ITALIC_KAPPA_SYMBOL                      0x1D718
#define unicode_MATHEMATICAL_ITALIC_PHI_SYMBOL                        0x1D719
#define unicode_MATHEMATICAL_ITALIC_RHO_SYMBOL                        0x1D71A
#define unicode_MATHEMATICAL_ITALIC_PI_SYMBOL                         0x1D71B
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_ALPHA                0x1D71C
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_BETA                 0x1D71D
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_GAMMA                0x1D71E
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_DELTA                0x1D71F
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_EPSILON              0x1D720
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_ZETA                 0x1D721
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_ETA                  0x1D722
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_THETA                0x1D723
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_IOTA                 0x1D724
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_KAPPA                0x1D725
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_LAMDA                0x1D726
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_MU                   0x1D727
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_NU                   0x1D728
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_XI                   0x1D729
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_OMICRON              0x1D72A
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_PI                   0x1D72B
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_RHO                  0x1D72C
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_THETA_SYMBOL         0x1D72D
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_SIGMA                0x1D72E
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_TAU                  0x1D72F
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_UPSILON              0x1D730
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_PHI                  0x1D731
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_CHI                  0x1D732
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_PSI                  0x1D733
#define unicode_MATHEMATICAL_BOLD_ITALIC_CAPITAL_OMEGA                0x1D734
#define unicode_MATHEMATICAL_BOLD_ITALIC_NABLA                        0x1D735
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_ALPHA                  0x1D736
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_BETA                   0x1D737
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_GAMMA                  0x1D738
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_DELTA                  0x1D739
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_EPSILON                0x1D73A
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_ZETA                   0x1D73B
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_ETA                    0x1D73C
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_THETA                  0x1D73D
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_IOTA                   0x1D73E
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_KAPPA                  0x1D73F
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_LAMDA                  0x1D740
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_MU                     0x1D741
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_NU                     0x1D742
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_XI                     0x1D743
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_OMICRON                0x1D744
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_PI                     0x1D745
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_RHO                    0x1D746
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_FINAL_SIGMA            0x1D747
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_SIGMA                  0x1D748
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_TAU                    0x1D749
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_UPSILON                0x1D74A
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_PHI                    0x1D74B
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_CHI                    0x1D74C
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_PSI                    0x1D74D
#define unicode_MATHEMATICAL_BOLD_ITALIC_SMALL_OMEGA                  0x1D74E
#define unicode_MATHEMATICAL_BOLD_ITALIC_PARTIAL_DIFFERENTIAL         0x1D74F
#define unicode_MATHEMATICAL_BOLD_ITALIC_EPSILON_SYMBOL               0x1D750
#define unicode_MATHEMATICAL_BOLD_ITALIC_THETA_SYMBOL                 0x1D751
#define unicode_MATHEMATICAL_BOLD_ITALIC_KAPPA_SYMBOL                 0x1D752
#define unicode_MATHEMATICAL_BOLD_ITALIC_PHI_SYMBOL                   0x1D753
#define unicode_MATHEMATICAL_BOLD_ITALIC_RHO_SYMBOL                   0x1D754
#define unicode_MATHEMATICAL_BOLD_ITALIC_PI_SYMBOL                    0x1D755
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_ALPHA            0x1D756
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_BETA             0x1D757
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_GAMMA            0x1D758
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_DELTA            0x1D759
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_EPSILON          0x1D75A
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_ZETA             0x1D75B
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_ETA              0x1D75C
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_THETA            0x1D75D
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_IOTA             0x1D75E
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_KAPPA            0x1D75F
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_LAMDA            0x1D760
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_MU               0x1D761
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_NU               0x1D762
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_XI               0x1D763
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_OMICRON          0x1D764
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_PI               0x1D765
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_RHO              0x1D766
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_THETA_SYMBOL     0x1D767
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_SIGMA            0x1D768
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_TAU              0x1D769
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_UPSILON          0x1D76A
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_PHI              0x1D76B
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_CHI              0x1D76C
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_PSI              0x1D76D
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_OMEGA            0x1D76E
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_NABLA                    0x1D76F
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_ALPHA              0x1D770
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_BETA               0x1D771
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_GAMMA              0x1D772
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_DELTA              0x1D773
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_EPSILON            0x1D774
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_ZETA               0x1D775
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_ETA                0x1D776
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_THETA              0x1D777
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_IOTA               0x1D778
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_KAPPA              0x1D779
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_LAMDA              0x1D77A
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_MU                 0x1D77B
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_NU                 0x1D77C
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_XI                 0x1D77D
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_OMICRON            0x1D77E
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_PI                 0x1D77F
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_RHO                0x1D780
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_FINAL_SIGMA        0x1D781
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_SIGMA              0x1D782
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_TAU                0x1D783
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_UPSILON            0x1D784
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_PHI                0x1D785
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_CHI                0x1D786
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_PSI                0x1D787
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_OMEGA              0x1D788
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_PARTIAL_DIFFERENTIAL     0x1D789
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_EPSILON_SYMBOL           0x1D78A
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_THETA_SYMBOL             0x1D78B
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_KAPPA_SYMBOL             0x1D78C
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_PHI_SYMBOL               0x1D78D
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_RHO_SYMBOL               0x1D78E
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_PI_SYMBOL                0x1D78F
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_ALPHA     0x1D790
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_BETA      0x1D791
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_GAMMA     0x1D792
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_DELTA     0x1D793
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_EPSILON   0x1D794
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_ZETA      0x1D795
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_ETA       0x1D796
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_THETA     0x1D797
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_IOTA      0x1D798
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_KAPPA     0x1D799
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_LAMDA     0x1D79A
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_MU        0x1D79B
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_NU        0x1D79C
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_XI        0x1D79D
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_OMICRON   0x1D79E
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_PI        0x1D79F
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_RHO       0x1D7A0
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_THETA_SYMBOL 0x1D7A1
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_SIGMA     0x1D7A2
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_TAU       0x1D7A3
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_UPSILON   0x1D7A4
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_PHI       0x1D7A5
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_CHI       0x1D7A6
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_PSI       0x1D7A7
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_OMEGA     0x1D7A8
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_NABLA             0x1D7A9
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_ALPHA       0x1D7AA
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_BETA        0x1D7AB
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_GAMMA       0x1D7AC
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_DELTA       0x1D7AD
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_EPSILON     0x1D7AE
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_ZETA        0x1D7AF
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_ETA         0x1D7B0
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_THETA       0x1D7B1
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_IOTA        0x1D7B2
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_KAPPA       0x1D7B3
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_LAMDA       0x1D7B4
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_MU          0x1D7B5
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_NU          0x1D7B6
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_XI          0x1D7B7
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_OMICRON     0x1D7B8
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_PI          0x1D7B9
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_RHO         0x1D7BA
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_FINAL_SIGMA 0x1D7BB
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_SIGMA       0x1D7BC
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_TAU         0x1D7BD
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_UPSILON     0x1D7BE
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_PHI         0x1D7BF
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_CHI         0x1D7C0
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_PSI         0x1D7C1
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_OMEGA       0x1D7C2
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_PARTIAL_DIFFERENTIAL 0x1D7C3
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_EPSILON_SYMBOL    0x1D7C4
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_THETA_SYMBOL      0x1D7C5
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_KAPPA_SYMBOL      0x1D7C6
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_PHI_SYMBOL        0x1D7C7
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_RHO_SYMBOL        0x1D7C8
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_PI_SYMBOL         0x1D7C9
#define unicode_MATHEMATICAL_BOLD_CAPITAL_DIGAMMA                     0x1D7CA
#define unicode_MATHEMATICAL_BOLD_SMALL_DIGAMMA                       0x1D7CB
#define unicode_MATHEMATICAL_BOLD_DIGIT_ZERO                          0x1D7CE
#define unicode_MATHEMATICAL_BOLD_DIGIT_ONE                           0x1D7CF
#define unicode_MATHEMATICAL_BOLD_DIGIT_TWO                           0x1D7D0
#define unicode_MATHEMATICAL_BOLD_DIGIT_THREE                         0x1D7D1
#define unicode_MATHEMATICAL_BOLD_DIGIT_FOUR                          0x1D7D2
#define unicode_MATHEMATICAL_BOLD_DIGIT_FIVE                          0x1D7D3
#define unicode_MATHEMATICAL_BOLD_DIGIT_SIX                           0x1D7D4
#define unicode_MATHEMATICAL_BOLD_DIGIT_SEVEN                         0x1D7D5
#define unicode_MATHEMATICAL_BOLD_DIGIT_EIGHT                         0x1D7D6
#define unicode_MATHEMATICAL_BOLD_DIGIT_NINE                          0x1D7D7
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_ZERO                 0x1D7D8
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_ONE                  0x1D7D9
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_TWO                  0x1D7DA
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_THREE                0x1D7DB
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_FOUR                 0x1D7DC
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_FIVE                 0x1D7DD
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_SIX                  0x1D7DE
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_SEVEN                0x1D7DF
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_EIGHT                0x1D7E0
#define unicode_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_NINE                 0x1D7E1
#define unicode_MATHEMATICAL_SANS_SERIF_DIGIT_ZERO                    0x1D7E2
#define unicode_MATHEMATICAL_SANS_SERIF_DIGIT_ONE                     0x1D7E3
#define unicode_MATHEMATICAL_SANS_SERIF_DIGIT_TWO                     0x1D7E4
#define unicode_MATHEMATICAL_SANS_SERIF_DIGIT_THREE                   0x1D7E5
#define unicode_MATHEMATICAL_SANS_SERIF_DIGIT_FOUR                    0x1D7E6
#define unicode_MATHEMATICAL_SANS_SERIF_DIGIT_FIVE                    0x1D7E7
#define unicode_MATHEMATICAL_SANS_SERIF_DIGIT_SIX                     0x1D7E8
#define unicode_MATHEMATICAL_SANS_SERIF_DIGIT_SEVEN                   0x1D7E9
#define unicode_MATHEMATICAL_SANS_SERIF_DIGIT_EIGHT                   0x1D7EA
#define unicode_MATHEMATICAL_SANS_SERIF_DIGIT_NINE                    0x1D7EB
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_ZERO               0x1D7EC
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_ONE                0x1D7ED
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_TWO                0x1D7EE
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_THREE              0x1D7EF
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_FOUR               0x1D7F0
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_FIVE               0x1D7F1
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_SIX                0x1D7F2
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_SEVEN              0x1D7F3
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_EIGHT              0x1D7F4
#define unicode_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_NINE               0x1D7F5
#define unicode_MATHEMATICAL_MONOSPACE_DIGIT_ZERO                     0x1D7F6
#define unicode_MATHEMATICAL_MONOSPACE_DIGIT_ONE                      0x1D7F7
#define unicode_MATHEMATICAL_MONOSPACE_DIGIT_TWO                      0x1D7F8
#define unicode_MATHEMATICAL_MONOSPACE_DIGIT_THREE                    0x1D7F9
#define unicode_MATHEMATICAL_MONOSPACE_DIGIT_FOUR                     0x1D7FA
#define unicode_MATHEMATICAL_MONOSPACE_DIGIT_FIVE                     0x1D7FB
#define unicode_MATHEMATICAL_MONOSPACE_DIGIT_SIX                      0x1D7FC
#define unicode_MATHEMATICAL_MONOSPACE_DIGIT_SEVEN                    0x1D7FD
#define unicode_MATHEMATICAL_MONOSPACE_DIGIT_EIGHT                    0x1D7FE
#define unicode_MATHEMATICAL_MONOSPACE_DIGIT_NINE                     0x1D7FF
#define unicode_MENDE_KIKAKUI_SYLLABLE_M001_KI                        0x1E800
#define unicode_MENDE_KIKAKUI_SYLLABLE_M002_KA                        0x1E801
#define unicode_MENDE_KIKAKUI_SYLLABLE_M003_KU                        0x1E802
#define unicode_MENDE_KIKAKUI_SYLLABLE_M065_KEE                       0x1E803
#define unicode_MENDE_KIKAKUI_SYLLABLE_M095_KE                        0x1E804
#define unicode_MENDE_KIKAKUI_SYLLABLE_M076_KOO                       0x1E805
#define unicode_MENDE_KIKAKUI_SYLLABLE_M048_KO                        0x1E806
#define unicode_MENDE_KIKAKUI_SYLLABLE_M179_KUA                       0x1E807
#define unicode_MENDE_KIKAKUI_SYLLABLE_M004_WI                        0x1E808
#define unicode_MENDE_KIKAKUI_SYLLABLE_M005_WA                        0x1E809
#define unicode_MENDE_KIKAKUI_SYLLABLE_M006_WU                        0x1E80A
#define unicode_MENDE_KIKAKUI_SYLLABLE_M126_WEE                       0x1E80B
#define unicode_MENDE_KIKAKUI_SYLLABLE_M118_WE                        0x1E80C
#define unicode_MENDE_KIKAKUI_SYLLABLE_M114_WOO                       0x1E80D
#define unicode_MENDE_KIKAKUI_SYLLABLE_M045_WO                        0x1E80E
#define unicode_MENDE_KIKAKUI_SYLLABLE_M194_WUI                       0x1E80F
#define unicode_MENDE_KIKAKUI_SYLLABLE_M143_WEI                       0x1E810
#define unicode_MENDE_KIKAKUI_SYLLABLE_M061_WVI                       0x1E811
#define unicode_MENDE_KIKAKUI_SYLLABLE_M049_WVA                       0x1E812
#define unicode_MENDE_KIKAKUI_SYLLABLE_M139_WVE                       0x1E813
#define unicode_MENDE_KIKAKUI_SYLLABLE_M007_MIN                       0x1E814
#define unicode_MENDE_KIKAKUI_SYLLABLE_M008_MAN                       0x1E815
#define unicode_MENDE_KIKAKUI_SYLLABLE_M009_MUN                       0x1E816
#define unicode_MENDE_KIKAKUI_SYLLABLE_M059_MEN                       0x1E817
#define unicode_MENDE_KIKAKUI_SYLLABLE_M094_MON                       0x1E818
#define unicode_MENDE_KIKAKUI_SYLLABLE_M154_MUAN                      0x1E819
#define unicode_MENDE_KIKAKUI_SYLLABLE_M189_MUEN                      0x1E81A
#define unicode_MENDE_KIKAKUI_SYLLABLE_M010_BI                        0x1E81B
#define unicode_MENDE_KIKAKUI_SYLLABLE_M011_BA                        0x1E81C
#define unicode_MENDE_KIKAKUI_SYLLABLE_M012_BU                        0x1E81D
#define unicode_MENDE_KIKAKUI_SYLLABLE_M150_BEE                       0x1E81E
#define unicode_MENDE_KIKAKUI_SYLLABLE_M097_BE                        0x1E81F
#define unicode_MENDE_KIKAKUI_SYLLABLE_M103_BOO                       0x1E820
#define unicode_MENDE_KIKAKUI_SYLLABLE_M138_BO                        0x1E821
#define unicode_MENDE_KIKAKUI_SYLLABLE_M013_I                         0x1E822
#define unicode_MENDE_KIKAKUI_SYLLABLE_M014_A                         0x1E823
#define unicode_MENDE_KIKAKUI_SYLLABLE_M015_U                         0x1E824
#define unicode_MENDE_KIKAKUI_SYLLABLE_M163_EE                        0x1E825
#define unicode_MENDE_KIKAKUI_SYLLABLE_M100_E                         0x1E826
#define unicode_MENDE_KIKAKUI_SYLLABLE_M165_OO                        0x1E827
#define unicode_MENDE_KIKAKUI_SYLLABLE_M147_O                         0x1E828
#define unicode_MENDE_KIKAKUI_SYLLABLE_M137_EI                        0x1E829
#define unicode_MENDE_KIKAKUI_SYLLABLE_M131_IN                        0x1E82A
#define unicode_MENDE_KIKAKUI_SYLLABLE_M135_IN                        0x1E82B
#define unicode_MENDE_KIKAKUI_SYLLABLE_M195_AN                        0x1E82C
#define unicode_MENDE_KIKAKUI_SYLLABLE_M178_EN                        0x1E82D
#define unicode_MENDE_KIKAKUI_SYLLABLE_M019_SI                        0x1E82E
#define unicode_MENDE_KIKAKUI_SYLLABLE_M020_SA                        0x1E82F
#define unicode_MENDE_KIKAKUI_SYLLABLE_M021_SU                        0x1E830
#define unicode_MENDE_KIKAKUI_SYLLABLE_M162_SEE                       0x1E831
#define unicode_MENDE_KIKAKUI_SYLLABLE_M116_SE                        0x1E832
#define unicode_MENDE_KIKAKUI_SYLLABLE_M136_SOO                       0x1E833
#define unicode_MENDE_KIKAKUI_SYLLABLE_M079_SO                        0x1E834
#define unicode_MENDE_KIKAKUI_SYLLABLE_M196_SIA                       0x1E835
#define unicode_MENDE_KIKAKUI_SYLLABLE_M025_LI                        0x1E836
#define unicode_MENDE_KIKAKUI_SYLLABLE_M026_LA                        0x1E837
#define unicode_MENDE_KIKAKUI_SYLLABLE_M027_LU                        0x1E838
#define unicode_MENDE_KIKAKUI_SYLLABLE_M084_LEE                       0x1E839
#define unicode_MENDE_KIKAKUI_SYLLABLE_M073_LE                        0x1E83A
#define unicode_MENDE_KIKAKUI_SYLLABLE_M054_LOO                       0x1E83B
#define unicode_MENDE_KIKAKUI_SYLLABLE_M153_LO                        0x1E83C
#define unicode_MENDE_KIKAKUI_SYLLABLE_M110_LONG_LE                   0x1E83D
#define unicode_MENDE_KIKAKUI_SYLLABLE_M016_DI                        0x1E83E
#define unicode_MENDE_KIKAKUI_SYLLABLE_M017_DA                        0x1E83F
#define unicode_MENDE_KIKAKUI_SYLLABLE_M018_DU                        0x1E840
#define unicode_MENDE_KIKAKUI_SYLLABLE_M089_DEE                       0x1E841
#define unicode_MENDE_KIKAKUI_SYLLABLE_M180_DOO                       0x1E842
#define unicode_MENDE_KIKAKUI_SYLLABLE_M181_DO                        0x1E843
#define unicode_MENDE_KIKAKUI_SYLLABLE_M022_TI                        0x1E844
#define unicode_MENDE_KIKAKUI_SYLLABLE_M023_TA                        0x1E845
#define unicode_MENDE_KIKAKUI_SYLLABLE_M024_TU                        0x1E846
#define unicode_MENDE_KIKAKUI_SYLLABLE_M091_TEE                       0x1E847
#define unicode_MENDE_KIKAKUI_SYLLABLE_M055_TE                        0x1E848
#define unicode_MENDE_KIKAKUI_SYLLABLE_M104_TOO                       0x1E849
#define unicode_MENDE_KIKAKUI_SYLLABLE_M069_TO                        0x1E84A
#define unicode_MENDE_KIKAKUI_SYLLABLE_M028_JI                        0x1E84B
#define unicode_MENDE_KIKAKUI_SYLLABLE_M029_JA                        0x1E84C
#define unicode_MENDE_KIKAKUI_SYLLABLE_M030_JU                        0x1E84D
#define unicode_MENDE_KIKAKUI_SYLLABLE_M157_JEE                       0x1E84E
#define unicode_MENDE_KIKAKUI_SYLLABLE_M113_JE                        0x1E84F
#define unicode_MENDE_KIKAKUI_SYLLABLE_M160_JOO                       0x1E850
#define unicode_MENDE_KIKAKUI_SYLLABLE_M063_JO                        0x1E851
#define unicode_MENDE_KIKAKUI_SYLLABLE_M175_LONG_JO                   0x1E852
#define unicode_MENDE_KIKAKUI_SYLLABLE_M031_YI                        0x1E853
#define unicode_MENDE_KIKAKUI_SYLLABLE_M032_YA                        0x1E854
#define unicode_MENDE_KIKAKUI_SYLLABLE_M033_YU                        0x1E855
#define unicode_MENDE_KIKAKUI_SYLLABLE_M109_YEE                       0x1E856
#define unicode_MENDE_KIKAKUI_SYLLABLE_M080_YE                        0x1E857
#define unicode_MENDE_KIKAKUI_SYLLABLE_M141_YOO                       0x1E858
#define unicode_MENDE_KIKAKUI_SYLLABLE_M121_YO                        0x1E859
#define unicode_MENDE_KIKAKUI_SYLLABLE_M034_FI                        0x1E85A
#define unicode_MENDE_KIKAKUI_SYLLABLE_M035_FA                        0x1E85B
#define unicode_MENDE_KIKAKUI_SYLLABLE_M036_FU                        0x1E85C
#define unicode_MENDE_KIKAKUI_SYLLABLE_M078_FEE                       0x1E85D
#define unicode_MENDE_KIKAKUI_SYLLABLE_M075_FE                        0x1E85E
#define unicode_MENDE_KIKAKUI_SYLLABLE_M133_FOO                       0x1E85F
#define unicode_MENDE_KIKAKUI_SYLLABLE_M088_FO                        0x1E860
#define unicode_MENDE_KIKAKUI_SYLLABLE_M197_FUA                       0x1E861
#define unicode_MENDE_KIKAKUI_SYLLABLE_M101_FAN                       0x1E862
#define unicode_MENDE_KIKAKUI_SYLLABLE_M037_NIN                       0x1E863
#define unicode_MENDE_KIKAKUI_SYLLABLE_M038_NAN                       0x1E864
#define unicode_MENDE_KIKAKUI_SYLLABLE_M039_NUN                       0x1E865
#define unicode_MENDE_KIKAKUI_SYLLABLE_M117_NEN                       0x1E866
#define unicode_MENDE_KIKAKUI_SYLLABLE_M169_NON                       0x1E867
#define unicode_MENDE_KIKAKUI_SYLLABLE_M176_HI                        0x1E868
#define unicode_MENDE_KIKAKUI_SYLLABLE_M041_HA                        0x1E869
#define unicode_MENDE_KIKAKUI_SYLLABLE_M186_HU                        0x1E86A
#define unicode_MENDE_KIKAKUI_SYLLABLE_M040_HEE                       0x1E86B
#define unicode_MENDE_KIKAKUI_SYLLABLE_M096_HE                        0x1E86C
#define unicode_MENDE_KIKAKUI_SYLLABLE_M042_HOO                       0x1E86D
#define unicode_MENDE_KIKAKUI_SYLLABLE_M140_HO                        0x1E86E
#define unicode_MENDE_KIKAKUI_SYLLABLE_M083_HEEI                      0x1E86F
#define unicode_MENDE_KIKAKUI_SYLLABLE_M128_HOOU                      0x1E870
#define unicode_MENDE_KIKAKUI_SYLLABLE_M053_HIN                       0x1E871
#define unicode_MENDE_KIKAKUI_SYLLABLE_M130_HAN                       0x1E872
#define unicode_MENDE_KIKAKUI_SYLLABLE_M087_HUN                       0x1E873
#define unicode_MENDE_KIKAKUI_SYLLABLE_M052_HEN                       0x1E874
#define unicode_MENDE_KIKAKUI_SYLLABLE_M193_HON                       0x1E875
#define unicode_MENDE_KIKAKUI_SYLLABLE_M046_HUAN                      0x1E876
#define unicode_MENDE_KIKAKUI_SYLLABLE_M090_NGGI                      0x1E877
#define unicode_MENDE_KIKAKUI_SYLLABLE_M043_NGGA                      0x1E878
#define unicode_MENDE_KIKAKUI_SYLLABLE_M082_NGGU                      0x1E879
#define unicode_MENDE_KIKAKUI_SYLLABLE_M115_NGGEE                     0x1E87A
#define unicode_MENDE_KIKAKUI_SYLLABLE_M146_NGGE                      0x1E87B
#define unicode_MENDE_KIKAKUI_SYLLABLE_M156_NGGOO                     0x1E87C
#define unicode_MENDE_KIKAKUI_SYLLABLE_M120_NGGO                      0x1E87D
#define unicode_MENDE_KIKAKUI_SYLLABLE_M159_NGGAA                     0x1E87E
#define unicode_MENDE_KIKAKUI_SYLLABLE_M127_NGGUA                     0x1E87F
#define unicode_MENDE_KIKAKUI_SYLLABLE_M086_LONG_NGGE                 0x1E880
#define unicode_MENDE_KIKAKUI_SYLLABLE_M106_LONG_NGGOO                0x1E881
#define unicode_MENDE_KIKAKUI_SYLLABLE_M183_LONG_NGGO                 0x1E882
#define unicode_MENDE_KIKAKUI_SYLLABLE_M155_GI                        0x1E883
#define unicode_MENDE_KIKAKUI_SYLLABLE_M111_GA                        0x1E884
#define unicode_MENDE_KIKAKUI_SYLLABLE_M168_GU                        0x1E885
#define unicode_MENDE_KIKAKUI_SYLLABLE_M190_GEE                       0x1E886
#define unicode_MENDE_KIKAKUI_SYLLABLE_M166_GUEI                      0x1E887
#define unicode_MENDE_KIKAKUI_SYLLABLE_M167_GUAN                      0x1E888
#define unicode_MENDE_KIKAKUI_SYLLABLE_M184_NGEN                      0x1E889
#define unicode_MENDE_KIKAKUI_SYLLABLE_M057_NGON                      0x1E88A
#define unicode_MENDE_KIKAKUI_SYLLABLE_M177_NGUAN                     0x1E88B
#define unicode_MENDE_KIKAKUI_SYLLABLE_M068_PI                        0x1E88C
#define unicode_MENDE_KIKAKUI_SYLLABLE_M099_PA                        0x1E88D
#define unicode_MENDE_KIKAKUI_SYLLABLE_M050_PU                        0x1E88E
#define unicode_MENDE_KIKAKUI_SYLLABLE_M081_PEE                       0x1E88F
#define unicode_MENDE_KIKAKUI_SYLLABLE_M051_PE                        0x1E890
#define unicode_MENDE_KIKAKUI_SYLLABLE_M102_POO                       0x1E891
#define unicode_MENDE_KIKAKUI_SYLLABLE_M066_PO                        0x1E892
#define unicode_MENDE_KIKAKUI_SYLLABLE_M145_MBI                       0x1E893
#define unicode_MENDE_KIKAKUI_SYLLABLE_M062_MBA                       0x1E894
#define unicode_MENDE_KIKAKUI_SYLLABLE_M122_MBU                       0x1E895
#define unicode_MENDE_KIKAKUI_SYLLABLE_M047_MBEE                      0x1E896
#define unicode_MENDE_KIKAKUI_SYLLABLE_M188_MBEE                      0x1E897
#define unicode_MENDE_KIKAKUI_SYLLABLE_M072_MBE                       0x1E898
#define unicode_MENDE_KIKAKUI_SYLLABLE_M172_MBOO                      0x1E899
#define unicode_MENDE_KIKAKUI_SYLLABLE_M174_MBO                       0x1E89A
#define unicode_MENDE_KIKAKUI_SYLLABLE_M187_MBUU                      0x1E89B
#define unicode_MENDE_KIKAKUI_SYLLABLE_M161_LONG_MBE                  0x1E89C
#define unicode_MENDE_KIKAKUI_SYLLABLE_M105_LONG_MBOO                 0x1E89D
#define unicode_MENDE_KIKAKUI_SYLLABLE_M142_LONG_MBO                  0x1E89E
#define unicode_MENDE_KIKAKUI_SYLLABLE_M132_KPI                       0x1E89F
#define unicode_MENDE_KIKAKUI_SYLLABLE_M092_KPA                       0x1E8A0
#define unicode_MENDE_KIKAKUI_SYLLABLE_M074_KPU                       0x1E8A1
#define unicode_MENDE_KIKAKUI_SYLLABLE_M044_KPEE                      0x1E8A2
#define unicode_MENDE_KIKAKUI_SYLLABLE_M108_KPE                       0x1E8A3
#define unicode_MENDE_KIKAKUI_SYLLABLE_M112_KPOO                      0x1E8A4
#define unicode_MENDE_KIKAKUI_SYLLABLE_M158_KPO                       0x1E8A5
#define unicode_MENDE_KIKAKUI_SYLLABLE_M124_GBI                       0x1E8A6
#define unicode_MENDE_KIKAKUI_SYLLABLE_M056_GBA                       0x1E8A7
#define unicode_MENDE_KIKAKUI_SYLLABLE_M148_GBU                       0x1E8A8
#define unicode_MENDE_KIKAKUI_SYLLABLE_M093_GBEE                      0x1E8A9
#define unicode_MENDE_KIKAKUI_SYLLABLE_M107_GBE                       0x1E8AA
#define unicode_MENDE_KIKAKUI_SYLLABLE_M071_GBOO                      0x1E8AB
#define unicode_MENDE_KIKAKUI_SYLLABLE_M070_GBO                       0x1E8AC
#define unicode_MENDE_KIKAKUI_SYLLABLE_M171_RA                        0x1E8AD
#define unicode_MENDE_KIKAKUI_SYLLABLE_M123_NDI                       0x1E8AE
#define unicode_MENDE_KIKAKUI_SYLLABLE_M129_NDA                       0x1E8AF
#define unicode_MENDE_KIKAKUI_SYLLABLE_M125_NDU                       0x1E8B0
#define unicode_MENDE_KIKAKUI_SYLLABLE_M191_NDEE                      0x1E8B1
#define unicode_MENDE_KIKAKUI_SYLLABLE_M119_NDE                       0x1E8B2
#define unicode_MENDE_KIKAKUI_SYLLABLE_M067_NDOO                      0x1E8B3
#define unicode_MENDE_KIKAKUI_SYLLABLE_M064_NDO                       0x1E8B4
#define unicode_MENDE_KIKAKUI_SYLLABLE_M152_NJA                       0x1E8B5
#define unicode_MENDE_KIKAKUI_SYLLABLE_M192_NJU                       0x1E8B6
#define unicode_MENDE_KIKAKUI_SYLLABLE_M149_NJEE                      0x1E8B7
#define unicode_MENDE_KIKAKUI_SYLLABLE_M134_NJOO                      0x1E8B8
#define unicode_MENDE_KIKAKUI_SYLLABLE_M182_VI                        0x1E8B9
#define unicode_MENDE_KIKAKUI_SYLLABLE_M185_VA                        0x1E8BA
#define unicode_MENDE_KIKAKUI_SYLLABLE_M151_VU                        0x1E8BB
#define unicode_MENDE_KIKAKUI_SYLLABLE_M173_VEE                       0x1E8BC
#define unicode_MENDE_KIKAKUI_SYLLABLE_M085_VE                        0x1E8BD
#define unicode_MENDE_KIKAKUI_SYLLABLE_M144_VOO                       0x1E8BE
#define unicode_MENDE_KIKAKUI_SYLLABLE_M077_VO                        0x1E8BF
#define unicode_MENDE_KIKAKUI_SYLLABLE_M164_NYIN                      0x1E8C0
#define unicode_MENDE_KIKAKUI_SYLLABLE_M058_NYAN                      0x1E8C1
#define unicode_MENDE_KIKAKUI_SYLLABLE_M170_NYUN                      0x1E8C2
#define unicode_MENDE_KIKAKUI_SYLLABLE_M098_NYEN                      0x1E8C3
#define unicode_MENDE_KIKAKUI_SYLLABLE_M060_NYON                      0x1E8C4
#define unicode_MENDE_KIKAKUI_DIGIT_ONE                               0x1E8C7
#define unicode_MENDE_KIKAKUI_DIGIT_TWO                               0x1E8C8
#define unicode_MENDE_KIKAKUI_DIGIT_THREE                             0x1E8C9
#define unicode_MENDE_KIKAKUI_DIGIT_FOUR                              0x1E8CA
#define unicode_MENDE_KIKAKUI_DIGIT_FIVE                              0x1E8CB
#define unicode_MENDE_KIKAKUI_DIGIT_SIX                               0x1E8CC
#define unicode_MENDE_KIKAKUI_DIGIT_SEVEN                             0x1E8CD
#define unicode_MENDE_KIKAKUI_DIGIT_EIGHT                             0x1E8CE
#define unicode_MENDE_KIKAKUI_DIGIT_NINE                              0x1E8CF
#define unicode_MENDE_KIKAKUI_COMBINING_NUMBER_TEENS                  0x1E8D0
#define unicode_MENDE_KIKAKUI_COMBINING_NUMBER_TENS                   0x1E8D1
#define unicode_MENDE_KIKAKUI_COMBINING_NUMBER_HUNDREDS               0x1E8D2
#define unicode_MENDE_KIKAKUI_COMBINING_NUMBER_THOUSANDS              0x1E8D3
#define unicode_MENDE_KIKAKUI_COMBINING_NUMBER_TEN_THOUSANDS          0x1E8D4
#define unicode_MENDE_KIKAKUI_COMBINING_NUMBER_HUNDRED_THOUSANDS      0x1E8D5
#define unicode_MENDE_KIKAKUI_COMBINING_NUMBER_MILLIONS               0x1E8D6
#define unicode_ARABIC_MATHEMATICAL_ALEF                              0x1EE00
#define unicode_ARABIC_MATHEMATICAL_BEH                               0x1EE01
#define unicode_ARABIC_MATHEMATICAL_JEEM                              0x1EE02
#define unicode_ARABIC_MATHEMATICAL_DAL                               0x1EE03
#define unicode_ARABIC_MATHEMATICAL_WAW                               0x1EE05
#define unicode_ARABIC_MATHEMATICAL_ZAIN                              0x1EE06
#define unicode_ARABIC_MATHEMATICAL_HAH                               0x1EE07
#define unicode_ARABIC_MATHEMATICAL_TAH                               0x1EE08
#define unicode_ARABIC_MATHEMATICAL_YEH                               0x1EE09
#define unicode_ARABIC_MATHEMATICAL_KAF                               0x1EE0A
#define unicode_ARABIC_MATHEMATICAL_LAM                               0x1EE0B
#define unicode_ARABIC_MATHEMATICAL_MEEM                              0x1EE0C
#define unicode_ARABIC_MATHEMATICAL_NOON                              0x1EE0D
#define unicode_ARABIC_MATHEMATICAL_SEEN                              0x1EE0E
#define unicode_ARABIC_MATHEMATICAL_AIN                               0x1EE0F
#define unicode_ARABIC_MATHEMATICAL_FEH                               0x1EE10
#define unicode_ARABIC_MATHEMATICAL_SAD                               0x1EE11
#define unicode_ARABIC_MATHEMATICAL_QAF                               0x1EE12
#define unicode_ARABIC_MATHEMATICAL_REH                               0x1EE13
#define unicode_ARABIC_MATHEMATICAL_SHEEN                             0x1EE14
#define unicode_ARABIC_MATHEMATICAL_TEH                               0x1EE15
#define unicode_ARABIC_MATHEMATICAL_THEH                              0x1EE16
#define unicode_ARABIC_MATHEMATICAL_KHAH                              0x1EE17
#define unicode_ARABIC_MATHEMATICAL_THAL                              0x1EE18
#define unicode_ARABIC_MATHEMATICAL_DAD                               0x1EE19
#define unicode_ARABIC_MATHEMATICAL_ZAH                               0x1EE1A
#define unicode_ARABIC_MATHEMATICAL_GHAIN                             0x1EE1B
#define unicode_ARABIC_MATHEMATICAL_DOTLESS_BEH                       0x1EE1C
#define unicode_ARABIC_MATHEMATICAL_DOTLESS_NOON                      0x1EE1D
#define unicode_ARABIC_MATHEMATICAL_DOTLESS_FEH                       0x1EE1E
#define unicode_ARABIC_MATHEMATICAL_DOTLESS_QAF                       0x1EE1F
#define unicode_ARABIC_MATHEMATICAL_INITIAL_BEH                       0x1EE21
#define unicode_ARABIC_MATHEMATICAL_INITIAL_JEEM                      0x1EE22
#define unicode_ARABIC_MATHEMATICAL_INITIAL_HEH                       0x1EE24
#define unicode_ARABIC_MATHEMATICAL_INITIAL_HAH                       0x1EE27
#define unicode_ARABIC_MATHEMATICAL_INITIAL_YEH                       0x1EE29
#define unicode_ARABIC_MATHEMATICAL_INITIAL_KAF                       0x1EE2A
#define unicode_ARABIC_MATHEMATICAL_INITIAL_LAM                       0x1EE2B
#define unicode_ARABIC_MATHEMATICAL_INITIAL_MEEM                      0x1EE2C
#define unicode_ARABIC_MATHEMATICAL_INITIAL_NOON                      0x1EE2D
#define unicode_ARABIC_MATHEMATICAL_INITIAL_SEEN                      0x1EE2E
#define unicode_ARABIC_MATHEMATICAL_INITIAL_AIN                       0x1EE2F
#define unicode_ARABIC_MATHEMATICAL_INITIAL_FEH                       0x1EE30
#define unicode_ARABIC_MATHEMATICAL_INITIAL_SAD                       0x1EE31
#define unicode_ARABIC_MATHEMATICAL_INITIAL_QAF                       0x1EE32
#define unicode_ARABIC_MATHEMATICAL_INITIAL_SHEEN                     0x1EE34
#define unicode_ARABIC_MATHEMATICAL_INITIAL_TEH                       0x1EE35
#define unicode_ARABIC_MATHEMATICAL_INITIAL_THEH                      0x1EE36
#define unicode_ARABIC_MATHEMATICAL_INITIAL_KHAH                      0x1EE37
#define unicode_ARABIC_MATHEMATICAL_INITIAL_DAD                       0x1EE39
#define unicode_ARABIC_MATHEMATICAL_INITIAL_GHAIN                     0x1EE3B
#define unicode_ARABIC_MATHEMATICAL_TAILED_JEEM                       0x1EE42
#define unicode_ARABIC_MATHEMATICAL_TAILED_HAH                        0x1EE47
#define unicode_ARABIC_MATHEMATICAL_TAILED_YEH                        0x1EE49
#define unicode_ARABIC_MATHEMATICAL_TAILED_LAM                        0x1EE4B
#define unicode_ARABIC_MATHEMATICAL_TAILED_NOON                       0x1EE4D
#define unicode_ARABIC_MATHEMATICAL_TAILED_SEEN                       0x1EE4E
#define unicode_ARABIC_MATHEMATICAL_TAILED_AIN                        0x1EE4F
#define unicode_ARABIC_MATHEMATICAL_TAILED_SAD                        0x1EE51
#define unicode_ARABIC_MATHEMATICAL_TAILED_QAF                        0x1EE52
#define unicode_ARABIC_MATHEMATICAL_TAILED_SHEEN                      0x1EE54
#define unicode_ARABIC_MATHEMATICAL_TAILED_KHAH                       0x1EE57
#define unicode_ARABIC_MATHEMATICAL_TAILED_DAD                        0x1EE59
#define unicode_ARABIC_MATHEMATICAL_TAILED_GHAIN                      0x1EE5B
#define unicode_ARABIC_MATHEMATICAL_TAILED_DOTLESS_NOON               0x1EE5D
#define unicode_ARABIC_MATHEMATICAL_TAILED_DOTLESS_QAF                0x1EE5F
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_BEH                     0x1EE61
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_JEEM                    0x1EE62
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_HEH                     0x1EE64
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_HAH                     0x1EE67
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_TAH                     0x1EE68
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_YEH                     0x1EE69
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_KAF                     0x1EE6A
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_MEEM                    0x1EE6C
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_NOON                    0x1EE6D
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_SEEN                    0x1EE6E
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_AIN                     0x1EE6F
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_FEH                     0x1EE70
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_SAD                     0x1EE71
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_QAF                     0x1EE72
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_SHEEN                   0x1EE74
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_TEH                     0x1EE75
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_THEH                    0x1EE76
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_KHAH                    0x1EE77
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_DAD                     0x1EE79
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_ZAH                     0x1EE7A
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_GHAIN                   0x1EE7B
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_DOTLESS_BEH             0x1EE7C
#define unicode_ARABIC_MATHEMATICAL_STRETCHED_DOTLESS_FEH             0x1EE7E
#define unicode_ARABIC_MATHEMATICAL_LOOPED_ALEF                       0x1EE80
#define unicode_ARABIC_MATHEMATICAL_LOOPED_BEH                        0x1EE81
#define unicode_ARABIC_MATHEMATICAL_LOOPED_JEEM                       0x1EE82
#define unicode_ARABIC_MATHEMATICAL_LOOPED_DAL                        0x1EE83
#define unicode_ARABIC_MATHEMATICAL_LOOPED_HEH                        0x1EE84
#define unicode_ARABIC_MATHEMATICAL_LOOPED_WAW                        0x1EE85
#define unicode_ARABIC_MATHEMATICAL_LOOPED_ZAIN                       0x1EE86
#define unicode_ARABIC_MATHEMATICAL_LOOPED_HAH                        0x1EE87
#define unicode_ARABIC_MATHEMATICAL_LOOPED_TAH                        0x1EE88
#define unicode_ARABIC_MATHEMATICAL_LOOPED_YEH                        0x1EE89
#define unicode_ARABIC_MATHEMATICAL_LOOPED_LAM                        0x1EE8B
#define unicode_ARABIC_MATHEMATICAL_LOOPED_MEEM                       0x1EE8C
#define unicode_ARABIC_MATHEMATICAL_LOOPED_NOON                       0x1EE8D
#define unicode_ARABIC_MATHEMATICAL_LOOPED_SEEN                       0x1EE8E
#define unicode_ARABIC_MATHEMATICAL_LOOPED_AIN                        0x1EE8F
#define unicode_ARABIC_MATHEMATICAL_LOOPED_FEH                        0x1EE90
#define unicode_ARABIC_MATHEMATICAL_LOOPED_SAD                        0x1EE91
#define unicode_ARABIC_MATHEMATICAL_LOOPED_QAF                        0x1EE92
#define unicode_ARABIC_MATHEMATICAL_LOOPED_REH                        0x1EE93
#define unicode_ARABIC_MATHEMATICAL_LOOPED_SHEEN                      0x1EE94
#define unicode_ARABIC_MATHEMATICAL_LOOPED_TEH                        0x1EE95
#define unicode_ARABIC_MATHEMATICAL_LOOPED_THEH                       0x1EE96
#define unicode_ARABIC_MATHEMATICAL_LOOPED_KHAH                       0x1EE97
#define unicode_ARABIC_MATHEMATICAL_LOOPED_THAL                       0x1EE98
#define unicode_ARABIC_MATHEMATICAL_LOOPED_DAD                        0x1EE99
#define unicode_ARABIC_MATHEMATICAL_LOOPED_ZAH                        0x1EE9A
#define unicode_ARABIC_MATHEMATICAL_LOOPED_GHAIN                      0x1EE9B
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_BEH                 0x1EEA1
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_JEEM                0x1EEA2
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_DAL                 0x1EEA3
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_WAW                 0x1EEA5
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_ZAIN                0x1EEA6
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_HAH                 0x1EEA7
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_TAH                 0x1EEA8
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_YEH                 0x1EEA9
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_LAM                 0x1EEAB
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_MEEM                0x1EEAC
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_NOON                0x1EEAD
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_SEEN                0x1EEAE
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_AIN                 0x1EEAF
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_FEH                 0x1EEB0
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_SAD                 0x1EEB1
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_QAF                 0x1EEB2
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_REH                 0x1EEB3
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_SHEEN               0x1EEB4
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_TEH                 0x1EEB5
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_THEH                0x1EEB6
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_KHAH                0x1EEB7
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_THAL                0x1EEB8
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_DAD                 0x1EEB9
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_ZAH                 0x1EEBA
#define unicode_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_GHAIN               0x1EEBB
#define unicode_ARABIC_MATHEMATICAL_OPERATOR_MEEM_WITH_HAH_WITH_TATWEEL 0x1EEF0
#define unicode_ARABIC_MATHEMATICAL_OPERATOR_HAH_WITH_DAL             0x1EEF1
#define unicode_MAHJONG_TILE_EAST_WIND                                0x1F000
#define unicode_MAHJONG_TILE_SOUTH_WIND                               0x1F001
#define unicode_MAHJONG_TILE_WEST_WIND                                0x1F002
#define unicode_MAHJONG_TILE_NORTH_WIND                               0x1F003
#define unicode_MAHJONG_TILE_RED_DRAGON                               0x1F004
#define unicode_MAHJONG_TILE_GREEN_DRAGON                             0x1F005
#define unicode_MAHJONG_TILE_WHITE_DRAGON                             0x1F006
#define unicode_MAHJONG_TILE_ONE_OF_CHARACTERS                        0x1F007
#define unicode_MAHJONG_TILE_TWO_OF_CHARACTERS                        0x1F008
#define unicode_MAHJONG_TILE_THREE_OF_CHARACTERS                      0x1F009
#define unicode_MAHJONG_TILE_FOUR_OF_CHARACTERS                       0x1F00A
#define unicode_MAHJONG_TILE_FIVE_OF_CHARACTERS                       0x1F00B
#define unicode_MAHJONG_TILE_SIX_OF_CHARACTERS                        0x1F00C
#define unicode_MAHJONG_TILE_SEVEN_OF_CHARACTERS                      0x1F00D
#define unicode_MAHJONG_TILE_EIGHT_OF_CHARACTERS                      0x1F00E
#define unicode_MAHJONG_TILE_NINE_OF_CHARACTERS                       0x1F00F
#define unicode_MAHJONG_TILE_ONE_OF_BAMBOOS                           0x1F010
#define unicode_MAHJONG_TILE_TWO_OF_BAMBOOS                           0x1F011
#define unicode_MAHJONG_TILE_THREE_OF_BAMBOOS                         0x1F012
#define unicode_MAHJONG_TILE_FOUR_OF_BAMBOOS                          0x1F013
#define unicode_MAHJONG_TILE_FIVE_OF_BAMBOOS                          0x1F014
#define unicode_MAHJONG_TILE_SIX_OF_BAMBOOS                           0x1F015
#define unicode_MAHJONG_TILE_SEVEN_OF_BAMBOOS                         0x1F016
#define unicode_MAHJONG_TILE_EIGHT_OF_BAMBOOS                         0x1F017
#define unicode_MAHJONG_TILE_NINE_OF_BAMBOOS                          0x1F018
#define unicode_MAHJONG_TILE_ONE_OF_CIRCLES                           0x1F019
#define unicode_MAHJONG_TILE_TWO_OF_CIRCLES                           0x1F01A
#define unicode_MAHJONG_TILE_THREE_OF_CIRCLES                         0x1F01B
#define unicode_MAHJONG_TILE_FOUR_OF_CIRCLES                          0x1F01C
#define unicode_MAHJONG_TILE_FIVE_OF_CIRCLES                          0x1F01D
#define unicode_MAHJONG_TILE_SIX_OF_CIRCLES                           0x1F01E
#define unicode_MAHJONG_TILE_SEVEN_OF_CIRCLES                         0x1F01F
#define unicode_MAHJONG_TILE_EIGHT_OF_CIRCLES                         0x1F020
#define unicode_MAHJONG_TILE_NINE_OF_CIRCLES                          0x1F021
#define unicode_MAHJONG_TILE_PLUM                                     0x1F022
#define unicode_MAHJONG_TILE_ORCHID                                   0x1F023
#define unicode_MAHJONG_TILE_BAMBOO                                   0x1F024
#define unicode_MAHJONG_TILE_CHRYSANTHEMUM                            0x1F025
#define unicode_MAHJONG_TILE_SPRING                                   0x1F026
#define unicode_MAHJONG_TILE_SUMMER                                   0x1F027
#define unicode_MAHJONG_TILE_AUTUMN                                   0x1F028
#define unicode_MAHJONG_TILE_WINTER                                   0x1F029
#define unicode_MAHJONG_TILE_JOKER                                    0x1F02A
#define unicode_MAHJONG_TILE_BACK                                     0x1F02B
#define unicode_DOMINO_TILE_HORIZONTAL_BACK                           0x1F030
#define unicode_DOMINO_TILE_HORIZONTAL_00_00                          0x1F031
#define unicode_DOMINO_TILE_HORIZONTAL_00_01                          0x1F032
#define unicode_DOMINO_TILE_HORIZONTAL_00_02                          0x1F033
#define unicode_DOMINO_TILE_HORIZONTAL_00_03                          0x1F034
#define unicode_DOMINO_TILE_HORIZONTAL_00_04                          0x1F035
#define unicode_DOMINO_TILE_HORIZONTAL_00_05                          0x1F036
#define unicode_DOMINO_TILE_HORIZONTAL_00_06                          0x1F037
#define unicode_DOMINO_TILE_HORIZONTAL_01_00                          0x1F038
#define unicode_DOMINO_TILE_HORIZONTAL_01_01                          0x1F039
#define unicode_DOMINO_TILE_HORIZONTAL_01_02                          0x1F03A
#define unicode_DOMINO_TILE_HORIZONTAL_01_03                          0x1F03B
#define unicode_DOMINO_TILE_HORIZONTAL_01_04                          0x1F03C
#define unicode_DOMINO_TILE_HORIZONTAL_01_05                          0x1F03D
#define unicode_DOMINO_TILE_HORIZONTAL_01_06                          0x1F03E
#define unicode_DOMINO_TILE_HORIZONTAL_02_00                          0x1F03F
#define unicode_DOMINO_TILE_HORIZONTAL_02_01                          0x1F040
#define unicode_DOMINO_TILE_HORIZONTAL_02_02                          0x1F041
#define unicode_DOMINO_TILE_HORIZONTAL_02_03                          0x1F042
#define unicode_DOMINO_TILE_HORIZONTAL_02_04                          0x1F043
#define unicode_DOMINO_TILE_HORIZONTAL_02_05                          0x1F044
#define unicode_DOMINO_TILE_HORIZONTAL_02_06                          0x1F045
#define unicode_DOMINO_TILE_HORIZONTAL_03_00                          0x1F046
#define unicode_DOMINO_TILE_HORIZONTAL_03_01                          0x1F047
#define unicode_DOMINO_TILE_HORIZONTAL_03_02                          0x1F048
#define unicode_DOMINO_TILE_HORIZONTAL_03_03                          0x1F049
#define unicode_DOMINO_TILE_HORIZONTAL_03_04                          0x1F04A
#define unicode_DOMINO_TILE_HORIZONTAL_03_05                          0x1F04B
#define unicode_DOMINO_TILE_HORIZONTAL_03_06                          0x1F04C
#define unicode_DOMINO_TILE_HORIZONTAL_04_00                          0x1F04D
#define unicode_DOMINO_TILE_HORIZONTAL_04_01                          0x1F04E
#define unicode_DOMINO_TILE_HORIZONTAL_04_02                          0x1F04F
#define unicode_DOMINO_TILE_HORIZONTAL_04_03                          0x1F050
#define unicode_DOMINO_TILE_HORIZONTAL_04_04                          0x1F051
#define unicode_DOMINO_TILE_HORIZONTAL_04_05                          0x1F052
#define unicode_DOMINO_TILE_HORIZONTAL_04_06                          0x1F053
#define unicode_DOMINO_TILE_HORIZONTAL_05_00                          0x1F054
#define unicode_DOMINO_TILE_HORIZONTAL_05_01                          0x1F055
#define unicode_DOMINO_TILE_HORIZONTAL_05_02                          0x1F056
#define unicode_DOMINO_TILE_HORIZONTAL_05_03                          0x1F057
#define unicode_DOMINO_TILE_HORIZONTAL_05_04                          0x1F058
#define unicode_DOMINO_TILE_HORIZONTAL_05_05                          0x1F059
#define unicode_DOMINO_TILE_HORIZONTAL_05_06                          0x1F05A
#define unicode_DOMINO_TILE_HORIZONTAL_06_00                          0x1F05B
#define unicode_DOMINO_TILE_HORIZONTAL_06_01                          0x1F05C
#define unicode_DOMINO_TILE_HORIZONTAL_06_02                          0x1F05D
#define unicode_DOMINO_TILE_HORIZONTAL_06_03                          0x1F05E
#define unicode_DOMINO_TILE_HORIZONTAL_06_04                          0x1F05F
#define unicode_DOMINO_TILE_HORIZONTAL_06_05                          0x1F060
#define unicode_DOMINO_TILE_HORIZONTAL_06_06                          0x1F061
#define unicode_DOMINO_TILE_VERTICAL_BACK                             0x1F062
#define unicode_DOMINO_TILE_VERTICAL_00_00                            0x1F063
#define unicode_DOMINO_TILE_VERTICAL_00_01                            0x1F064
#define unicode_DOMINO_TILE_VERTICAL_00_02                            0x1F065
#define unicode_DOMINO_TILE_VERTICAL_00_03                            0x1F066
#define unicode_DOMINO_TILE_VERTICAL_00_04                            0x1F067
#define unicode_DOMINO_TILE_VERTICAL_00_05                            0x1F068
#define unicode_DOMINO_TILE_VERTICAL_00_06                            0x1F069
#define unicode_DOMINO_TILE_VERTICAL_01_00                            0x1F06A
#define unicode_DOMINO_TILE_VERTICAL_01_01                            0x1F06B
#define unicode_DOMINO_TILE_VERTICAL_01_02                            0x1F06C
#define unicode_DOMINO_TILE_VERTICAL_01_03                            0x1F06D
#define unicode_DOMINO_TILE_VERTICAL_01_04                            0x1F06E
#define unicode_DOMINO_TILE_VERTICAL_01_05                            0x1F06F
#define unicode_DOMINO_TILE_VERTICAL_01_06                            0x1F070
#define unicode_DOMINO_TILE_VERTICAL_02_00                            0x1F071
#define unicode_DOMINO_TILE_VERTICAL_02_01                            0x1F072
#define unicode_DOMINO_TILE_VERTICAL_02_02                            0x1F073
#define unicode_DOMINO_TILE_VERTICAL_02_03                            0x1F074
#define unicode_DOMINO_TILE_VERTICAL_02_04                            0x1F075
#define unicode_DOMINO_TILE_VERTICAL_02_05                            0x1F076
#define unicode_DOMINO_TILE_VERTICAL_02_06                            0x1F077
#define unicode_DOMINO_TILE_VERTICAL_03_00                            0x1F078
#define unicode_DOMINO_TILE_VERTICAL_03_01                            0x1F079
#define unicode_DOMINO_TILE_VERTICAL_03_02                            0x1F07A
#define unicode_DOMINO_TILE_VERTICAL_03_03                            0x1F07B
#define unicode_DOMINO_TILE_VERTICAL_03_04                            0x1F07C
#define unicode_DOMINO_TILE_VERTICAL_03_05                            0x1F07D
#define unicode_DOMINO_TILE_VERTICAL_03_06                            0x1F07E
#define unicode_DOMINO_TILE_VERTICAL_04_00                            0x1F07F
#define unicode_DOMINO_TILE_VERTICAL_04_01                            0x1F080
#define unicode_DOMINO_TILE_VERTICAL_04_02                            0x1F081
#define unicode_DOMINO_TILE_VERTICAL_04_03                            0x1F082
#define unicode_DOMINO_TILE_VERTICAL_04_04                            0x1F083
#define unicode_DOMINO_TILE_VERTICAL_04_05                            0x1F084
#define unicode_DOMINO_TILE_VERTICAL_04_06                            0x1F085
#define unicode_DOMINO_TILE_VERTICAL_05_00                            0x1F086
#define unicode_DOMINO_TILE_VERTICAL_05_01                            0x1F087
#define unicode_DOMINO_TILE_VERTICAL_05_02                            0x1F088
#define unicode_DOMINO_TILE_VERTICAL_05_03                            0x1F089
#define unicode_DOMINO_TILE_VERTICAL_05_04                            0x1F08A
#define unicode_DOMINO_TILE_VERTICAL_05_05                            0x1F08B
#define unicode_DOMINO_TILE_VERTICAL_05_06                            0x1F08C
#define unicode_DOMINO_TILE_VERTICAL_06_00                            0x1F08D
#define unicode_DOMINO_TILE_VERTICAL_06_01                            0x1F08E
#define unicode_DOMINO_TILE_VERTICAL_06_02                            0x1F08F
#define unicode_DOMINO_TILE_VERTICAL_06_03                            0x1F090
#define unicode_DOMINO_TILE_VERTICAL_06_04                            0x1F091
#define unicode_DOMINO_TILE_VERTICAL_06_05                            0x1F092
#define unicode_DOMINO_TILE_VERTICAL_06_06                            0x1F093
#define unicode_PLAYING_CARD_BACK                                     0x1F0A0
#define unicode_PLAYING_CARD_ACE_OF_SPADES                            0x1F0A1
#define unicode_PLAYING_CARD_TWO_OF_SPADES                            0x1F0A2
#define unicode_PLAYING_CARD_THREE_OF_SPADES                          0x1F0A3
#define unicode_PLAYING_CARD_FOUR_OF_SPADES                           0x1F0A4
#define unicode_PLAYING_CARD_FIVE_OF_SPADES                           0x1F0A5
#define unicode_PLAYING_CARD_SIX_OF_SPADES                            0x1F0A6
#define unicode_PLAYING_CARD_SEVEN_OF_SPADES                          0x1F0A7
#define unicode_PLAYING_CARD_EIGHT_OF_SPADES                          0x1F0A8
#define unicode_PLAYING_CARD_NINE_OF_SPADES                           0x1F0A9
#define unicode_PLAYING_CARD_TEN_OF_SPADES                            0x1F0AA
#define unicode_PLAYING_CARD_JACK_OF_SPADES                           0x1F0AB
#define unicode_PLAYING_CARD_KNIGHT_OF_SPADES                         0x1F0AC
#define unicode_PLAYING_CARD_QUEEN_OF_SPADES                          0x1F0AD
#define unicode_PLAYING_CARD_KING_OF_SPADES                           0x1F0AE
#define unicode_PLAYING_CARD_ACE_OF_HEARTS                            0x1F0B1
#define unicode_PLAYING_CARD_TWO_OF_HEARTS                            0x1F0B2
#define unicode_PLAYING_CARD_THREE_OF_HEARTS                          0x1F0B3
#define unicode_PLAYING_CARD_FOUR_OF_HEARTS                           0x1F0B4
#define unicode_PLAYING_CARD_FIVE_OF_HEARTS                           0x1F0B5
#define unicode_PLAYING_CARD_SIX_OF_HEARTS                            0x1F0B6
#define unicode_PLAYING_CARD_SEVEN_OF_HEARTS                          0x1F0B7
#define unicode_PLAYING_CARD_EIGHT_OF_HEARTS                          0x1F0B8
#define unicode_PLAYING_CARD_NINE_OF_HEARTS                           0x1F0B9
#define unicode_PLAYING_CARD_TEN_OF_HEARTS                            0x1F0BA
#define unicode_PLAYING_CARD_JACK_OF_HEARTS                           0x1F0BB
#define unicode_PLAYING_CARD_KNIGHT_OF_HEARTS                         0x1F0BC
#define unicode_PLAYING_CARD_QUEEN_OF_HEARTS                          0x1F0BD
#define unicode_PLAYING_CARD_KING_OF_HEARTS                           0x1F0BE
#define unicode_PLAYING_CARD_RED_JOKER                                0x1F0BF
#define unicode_PLAYING_CARD_ACE_OF_DIAMONDS                          0x1F0C1
#define unicode_PLAYING_CARD_TWO_OF_DIAMONDS                          0x1F0C2
#define unicode_PLAYING_CARD_THREE_OF_DIAMONDS                        0x1F0C3
#define unicode_PLAYING_CARD_FOUR_OF_DIAMONDS                         0x1F0C4
#define unicode_PLAYING_CARD_FIVE_OF_DIAMONDS                         0x1F0C5
#define unicode_PLAYING_CARD_SIX_OF_DIAMONDS                          0x1F0C6
#define unicode_PLAYING_CARD_SEVEN_OF_DIAMONDS                        0x1F0C7
#define unicode_PLAYING_CARD_EIGHT_OF_DIAMONDS                        0x1F0C8
#define unicode_PLAYING_CARD_NINE_OF_DIAMONDS                         0x1F0C9
#define unicode_PLAYING_CARD_TEN_OF_DIAMONDS                          0x1F0CA
#define unicode_PLAYING_CARD_JACK_OF_DIAMONDS                         0x1F0CB
#define unicode_PLAYING_CARD_KNIGHT_OF_DIAMONDS                       0x1F0CC
#define unicode_PLAYING_CARD_QUEEN_OF_DIAMONDS                        0x1F0CD
#define unicode_PLAYING_CARD_KING_OF_DIAMONDS                         0x1F0CE
#define unicode_PLAYING_CARD_BLACK_JOKER                              0x1F0CF
#define unicode_PLAYING_CARD_ACE_OF_CLUBS                             0x1F0D1
#define unicode_PLAYING_CARD_TWO_OF_CLUBS                             0x1F0D2
#define unicode_PLAYING_CARD_THREE_OF_CLUBS                           0x1F0D3
#define unicode_PLAYING_CARD_FOUR_OF_CLUBS                            0x1F0D4
#define unicode_PLAYING_CARD_FIVE_OF_CLUBS                            0x1F0D5
#define unicode_PLAYING_CARD_SIX_OF_CLUBS                             0x1F0D6
#define unicode_PLAYING_CARD_SEVEN_OF_CLUBS                           0x1F0D7
#define unicode_PLAYING_CARD_EIGHT_OF_CLUBS                           0x1F0D8
#define unicode_PLAYING_CARD_NINE_OF_CLUBS                            0x1F0D9
#define unicode_PLAYING_CARD_TEN_OF_CLUBS                             0x1F0DA
#define unicode_PLAYING_CARD_JACK_OF_CLUBS                            0x1F0DB
#define unicode_PLAYING_CARD_KNIGHT_OF_CLUBS                          0x1F0DC
#define unicode_PLAYING_CARD_QUEEN_OF_CLUBS                           0x1F0DD
#define unicode_PLAYING_CARD_KING_OF_CLUBS                            0x1F0DE
#define unicode_PLAYING_CARD_WHITE_JOKER                              0x1F0DF
#define unicode_PLAYING_CARD_FOOL                                     0x1F0E0
#define unicode_PLAYING_CARD_TRUMP_1                                  0x1F0E1
#define unicode_PLAYING_CARD_TRUMP_2                                  0x1F0E2
#define unicode_PLAYING_CARD_TRUMP_3                                  0x1F0E3
#define unicode_PLAYING_CARD_TRUMP_4                                  0x1F0E4
#define unicode_PLAYING_CARD_TRUMP_5                                  0x1F0E5
#define unicode_PLAYING_CARD_TRUMP_6                                  0x1F0E6
#define unicode_PLAYING_CARD_TRUMP_7                                  0x1F0E7
#define unicode_PLAYING_CARD_TRUMP_8                                  0x1F0E8
#define unicode_PLAYING_CARD_TRUMP_9                                  0x1F0E9
#define unicode_PLAYING_CARD_TRUMP_10                                 0x1F0EA
#define unicode_PLAYING_CARD_TRUMP_11                                 0x1F0EB
#define unicode_PLAYING_CARD_TRUMP_12                                 0x1F0EC
#define unicode_PLAYING_CARD_TRUMP_13                                 0x1F0ED
#define unicode_PLAYING_CARD_TRUMP_14                                 0x1F0EE
#define unicode_PLAYING_CARD_TRUMP_15                                 0x1F0EF
#define unicode_PLAYING_CARD_TRUMP_16                                 0x1F0F0
#define unicode_PLAYING_CARD_TRUMP_17                                 0x1F0F1
#define unicode_PLAYING_CARD_TRUMP_18                                 0x1F0F2
#define unicode_PLAYING_CARD_TRUMP_19                                 0x1F0F3
#define unicode_PLAYING_CARD_TRUMP_20                                 0x1F0F4
#define unicode_PLAYING_CARD_TRUMP_21                                 0x1F0F5
#define unicode_DIGIT_ZERO_FULL_STOP                                  0x1F100
#define unicode_DIGIT_ZERO_COMMA                                      0x1F101
#define unicode_DIGIT_ONE_COMMA                                       0x1F102
#define unicode_DIGIT_TWO_COMMA                                       0x1F103
#define unicode_DIGIT_THREE_COMMA                                     0x1F104
#define unicode_DIGIT_FOUR_COMMA                                      0x1F105
#define unicode_DIGIT_FIVE_COMMA                                      0x1F106
#define unicode_DIGIT_SIX_COMMA                                       0x1F107
#define unicode_DIGIT_SEVEN_COMMA                                     0x1F108
#define unicode_DIGIT_EIGHT_COMMA                                     0x1F109
#define unicode_DIGIT_NINE_COMMA                                      0x1F10A
#define unicode_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_ZERO                 0x1F10B
#define unicode_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_ZERO        0x1F10C
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_A                  0x1F110
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_B                  0x1F111
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_C                  0x1F112
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_D                  0x1F113
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_E                  0x1F114
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_F                  0x1F115
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_G                  0x1F116
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_H                  0x1F117
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_I                  0x1F118
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_J                  0x1F119
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_K                  0x1F11A
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_L                  0x1F11B
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_M                  0x1F11C
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_N                  0x1F11D
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_O                  0x1F11E
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_P                  0x1F11F
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_Q                  0x1F120
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_R                  0x1F121
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_S                  0x1F122
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_T                  0x1F123
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_U                  0x1F124
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_V                  0x1F125
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_W                  0x1F126
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_X                  0x1F127
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_Y                  0x1F128
#define unicode_PARENTHESIZED_LATIN_CAPITAL_LETTER_Z                  0x1F129
#define unicode_TORTOISE_SHELL_BRACKETED_LATIN_CAPITAL_LETTER_S       0x1F12A
#define unicode_CIRCLED_ITALIC_LATIN_CAPITAL_LETTER_C                 0x1F12B
#define unicode_CIRCLED_ITALIC_LATIN_CAPITAL_LETTER_R                 0x1F12C
#define unicode_CIRCLED_CD                                            0x1F12D
#define unicode_CIRCLED_WZ                                            0x1F12E
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_A                        0x1F130
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_B                        0x1F131
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_C                        0x1F132
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_D                        0x1F133
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_E                        0x1F134
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_F                        0x1F135
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_G                        0x1F136
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_H                        0x1F137
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_I                        0x1F138
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_J                        0x1F139
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_K                        0x1F13A
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_L                        0x1F13B
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_M                        0x1F13C
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_N                        0x1F13D
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_O                        0x1F13E
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_P                        0x1F13F
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_Q                        0x1F140
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_R                        0x1F141
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_S                        0x1F142
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_T                        0x1F143
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_U                        0x1F144
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_V                        0x1F145
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_W                        0x1F146
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_X                        0x1F147
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_Y                        0x1F148
#define unicode_SQUARED_LATIN_CAPITAL_LETTER_Z                        0x1F149
#define unicode_SQUARED_HV                                            0x1F14A
#define unicode_SQUARED_MV                                            0x1F14B
#define unicode_SQUARED_SD                                            0x1F14C
#define unicode_SQUARED_SS                                            0x1F14D
#define unicode_SQUARED_PPV                                           0x1F14E
#define unicode_SQUARED_WC                                            0x1F14F
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_A               0x1F150
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_B               0x1F151
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_C               0x1F152
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_D               0x1F153
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_E               0x1F154
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_F               0x1F155
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_G               0x1F156
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_H               0x1F157
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_I               0x1F158
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_J               0x1F159
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_K               0x1F15A
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_L               0x1F15B
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_M               0x1F15C
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_N               0x1F15D
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_O               0x1F15E
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_P               0x1F15F
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_Q               0x1F160
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_R               0x1F161
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_S               0x1F162
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_T               0x1F163
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_U               0x1F164
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_V               0x1F165
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_W               0x1F166
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_X               0x1F167
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_Y               0x1F168
#define unicode_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_Z               0x1F169
#define unicode_RAISED_MC_SIGN                                        0x1F16A
#define unicode_RAISED_MD_SIGN                                        0x1F16B
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_A               0x1F170
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_B               0x1F171
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_C               0x1F172
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_D               0x1F173
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_E               0x1F174
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_F               0x1F175
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_G               0x1F176
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_H               0x1F177
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_I               0x1F178
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_J               0x1F179
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_K               0x1F17A
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_L               0x1F17B
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_M               0x1F17C
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_N               0x1F17D
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_O               0x1F17E
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_P               0x1F17F
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_Q               0x1F180
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_R               0x1F181
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_S               0x1F182
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_T               0x1F183
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_U               0x1F184
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_V               0x1F185
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_W               0x1F186
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_X               0x1F187
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_Y               0x1F188
#define unicode_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_Z               0x1F189
#define unicode_CROSSED_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_P       0x1F18A
#define unicode_NEGATIVE_SQUARED_IC                                   0x1F18B
#define unicode_NEGATIVE_SQUARED_PA                                   0x1F18C
#define unicode_NEGATIVE_SQUARED_SA                                   0x1F18D
#define unicode_NEGATIVE_SQUARED_AB                                   0x1F18E
#define unicode_NEGATIVE_SQUARED_WC                                   0x1F18F
#define unicode_SQUARE_DJ                                             0x1F190
#define unicode_SQUARED_CL                                            0x1F191
#define unicode_SQUARED_COOL                                          0x1F192
#define unicode_SQUARED_FREE                                          0x1F193
#define unicode_SQUARED_ID                                            0x1F194
#define unicode_SQUARED_NEW                                           0x1F195
#define unicode_SQUARED_NG                                            0x1F196
#define unicode_SQUARED_OK                                            0x1F197
#define unicode_SQUARED_SOS                                           0x1F198
#define unicode_SQUARED_UP_WITH_EXCLAMATION_MARK                      0x1F199
#define unicode_SQUARED_VS                                            0x1F19A
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_A                    0x1F1E6
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_B                    0x1F1E7
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_C                    0x1F1E8
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_D                    0x1F1E9
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_E                    0x1F1EA
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_F                    0x1F1EB
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_G                    0x1F1EC
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_H                    0x1F1ED
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_I                    0x1F1EE
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_J                    0x1F1EF
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_K                    0x1F1F0
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_L                    0x1F1F1
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_M                    0x1F1F2
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_N                    0x1F1F3
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_O                    0x1F1F4
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_P                    0x1F1F5
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_Q                    0x1F1F6
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_R                    0x1F1F7
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_S                    0x1F1F8
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_T                    0x1F1F9
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_U                    0x1F1FA
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_V                    0x1F1FB
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_W                    0x1F1FC
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_X                    0x1F1FD
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_Y                    0x1F1FE
#define unicode_REGIONAL_INDICATOR_SYMBOL_LETTER_Z                    0x1F1FF
#define unicode_SQUARE_HIRAGANA_HOKA                                  0x1F200
#define unicode_SQUARED_KATAKANA_KOKO                                 0x1F201
#define unicode_SQUARED_KATAKANA_SA                                   0x1F202
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_624B                    0x1F210
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_5B57                    0x1F211
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_53CC                    0x1F212
#define unicode_SQUARED_KATAKANA_DE                                   0x1F213
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_4E8C                    0x1F214
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_591A                    0x1F215
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_89E3                    0x1F216
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_5929                    0x1F217
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_4EA4                    0x1F218
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_6620                    0x1F219
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_7121                    0x1F21A
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_6599                    0x1F21B
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_524D                    0x1F21C
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_5F8C                    0x1F21D
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_518D                    0x1F21E
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_65B0                    0x1F21F
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_521D                    0x1F220
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_7D42                    0x1F221
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_751F                    0x1F222
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_8CA9                    0x1F223
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_58F0                    0x1F224
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_5439                    0x1F225
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_6F14                    0x1F226
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_6295                    0x1F227
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_6355                    0x1F228
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_4E00                    0x1F229
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_4E09                    0x1F22A
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_904A                    0x1F22B
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_5DE6                    0x1F22C
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_4E2D                    0x1F22D
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_53F3                    0x1F22E
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_6307                    0x1F22F
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_8D70                    0x1F230
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_6253                    0x1F231
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_7981                    0x1F232
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_7A7A                    0x1F233
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_5408                    0x1F234
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_6E80                    0x1F235
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_6709                    0x1F236
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_6708                    0x1F237
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_7533                    0x1F238
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_5272                    0x1F239
#define unicode_SQUARED_CJK_UNIFIED_IDEOGRAPH_55B6                    0x1F23A
#define unicode_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_672C   0x1F240
#define unicode_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_4E09   0x1F241
#define unicode_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_4E8C   0x1F242
#define unicode_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_5B89   0x1F243
#define unicode_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_70B9   0x1F244
#define unicode_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_6253   0x1F245
#define unicode_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_76D7   0x1F246
#define unicode_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_52DD   0x1F247
#define unicode_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_6557   0x1F248
#define unicode_CIRCLED_IDEOGRAPH_ADVANTAGE                           0x1F250
#define unicode_CIRCLED_IDEOGRAPH_ACCEPT                              0x1F251
#define unicode_CYCLONE                                               0x1F300
#define unicode_FOGGY                                                 0x1F301
#define unicode_CLOSED_UMBRELLA                                       0x1F302
#define unicode_NIGHT_WITH_STARS                                      0x1F303
#define unicode_SUNRISE_OVER_MOUNTAINS                                0x1F304
#define unicode_SUNRISE                                               0x1F305
#define unicode_CITYSCAPE_AT_DUSK                                     0x1F306
#define unicode_SUNSET_OVER_BUILDINGS                                 0x1F307
#define unicode_RAINBOW                                               0x1F308
#define unicode_BRIDGE_AT_NIGHT                                       0x1F309
#define unicode_WATER_WAVE                                            0x1F30A
#define unicode_VOLCANO                                               0x1F30B
#define unicode_MILKY_WAY                                             0x1F30C
#define unicode_EARTH_GLOBE_EUROPE_AFRICA                             0x1F30D
#define unicode_EARTH_GLOBE_AMERICAS                                  0x1F30E
#define unicode_EARTH_GLOBE_ASIA_AUSTRALIA                            0x1F30F
#define unicode_GLOBE_WITH_MERIDIANS                                  0x1F310
#define unicode_NEW_MOON_SYMBOL                                       0x1F311
#define unicode_WAXING_CRESCENT_MOON_SYMBOL                           0x1F312
#define unicode_FIRST_QUARTER_MOON_SYMBOL                             0x1F313
#define unicode_WAXING_GIBBOUS_MOON_SYMBOL                            0x1F314
#define unicode_FULL_MOON_SYMBOL                                      0x1F315
#define unicode_WANING_GIBBOUS_MOON_SYMBOL                            0x1F316
#define unicode_LAST_QUARTER_MOON_SYMBOL                              0x1F317
#define unicode_WANING_CRESCENT_MOON_SYMBOL                           0x1F318
#define unicode_CRESCENT_MOON                                         0x1F319
#define unicode_NEW_MOON_WITH_FACE                                    0x1F31A
#define unicode_FIRST_QUARTER_MOON_WITH_FACE                          0x1F31B
#define unicode_LAST_QUARTER_MOON_WITH_FACE                           0x1F31C
#define unicode_FULL_MOON_WITH_FACE                                   0x1F31D
#define unicode_SUN_WITH_FACE                                         0x1F31E
#define unicode_GLOWING_STAR                                          0x1F31F
#define unicode_SHOOTING_STAR                                         0x1F320
#define unicode_THERMOMETER                                           0x1F321
#define unicode_BLACK_DROPLET                                         0x1F322
#define unicode_WHITE_SUN                                             0x1F323
#define unicode_WHITE_SUN_WITH_SMALL_CLOUD                            0x1F324
#define unicode_WHITE_SUN_BEHIND_CLOUD                                0x1F325
#define unicode_WHITE_SUN_BEHIND_CLOUD_WITH_RAIN                      0x1F326
#define unicode_CLOUD_WITH_RAIN                                       0x1F327
#define unicode_CLOUD_WITH_SNOW                                       0x1F328
#define unicode_CLOUD_WITH_LIGHTNING                                  0x1F329
#define unicode_CLOUD_WITH_TORNADO                                    0x1F32A
#define unicode_FOG                                                   0x1F32B
#define unicode_WIND_BLOWING_FACE                                     0x1F32C
#define unicode_CHESTNUT                                              0x1F330
#define unicode_SEEDLING                                              0x1F331
#define unicode_EVERGREEN_TREE                                        0x1F332
#define unicode_DECIDUOUS_TREE                                        0x1F333
#define unicode_PALM_TREE                                             0x1F334
#define unicode_CACTUS                                                0x1F335
#define unicode_HOT_PEPPER                                            0x1F336
#define unicode_TULIP                                                 0x1F337
#define unicode_CHERRY_BLOSSOM                                        0x1F338
#define unicode_ROSE                                                  0x1F339
#define unicode_HIBISCUS                                              0x1F33A
#define unicode_SUNFLOWER                                             0x1F33B
#define unicode_BLOSSOM                                               0x1F33C
#define unicode_EAR_OF_MAIZE                                          0x1F33D
#define unicode_EAR_OF_RICE                                           0x1F33E
#define unicode_HERB                                                  0x1F33F
#define unicode_FOUR_LEAF_CLOVER                                      0x1F340
#define unicode_MAPLE_LEAF                                            0x1F341
#define unicode_FALLEN_LEAF                                           0x1F342
#define unicode_LEAF_FLUTTERING_IN_WIND                               0x1F343
#define unicode_MUSHROOM                                              0x1F344
#define unicode_TOMATO                                                0x1F345
#define unicode_AUBERGINE                                             0x1F346
#define unicode_GRAPES                                                0x1F347
#define unicode_MELON                                                 0x1F348
#define unicode_WATERMELON                                            0x1F349
#define unicode_TANGERINE                                             0x1F34A
#define unicode_LEMON                                                 0x1F34B
#define unicode_BANANA                                                0x1F34C
#define unicode_PINEAPPLE                                             0x1F34D
#define unicode_RED_APPLE                                             0x1F34E
#define unicode_GREEN_APPLE                                           0x1F34F
#define unicode_PEAR                                                  0x1F350
#define unicode_PEACH                                                 0x1F351
#define unicode_CHERRIES                                              0x1F352
#define unicode_STRAWBERRY                                            0x1F353
#define unicode_HAMBURGER                                             0x1F354
#define unicode_SLICE_OF_PIZZA                                        0x1F355
#define unicode_MEAT_ON_BONE                                          0x1F356
#define unicode_POULTRY_LEG                                           0x1F357
#define unicode_RICE_CRACKER                                          0x1F358
#define unicode_RICE_BALL                                             0x1F359
#define unicode_COOKED_RICE                                           0x1F35A
#define unicode_CURRY_AND_RICE                                        0x1F35B
#define unicode_STEAMING_BOWL                                         0x1F35C
#define unicode_SPAGHETTI                                             0x1F35D
#define unicode_BREAD                                                 0x1F35E
#define unicode_FRENCH_FRIES                                          0x1F35F
#define unicode_ROASTED_SWEET_POTATO                                  0x1F360
#define unicode_DANGO                                                 0x1F361
#define unicode_ODEN                                                  0x1F362
#define unicode_SUSHI                                                 0x1F363
#define unicode_FRIED_SHRIMP                                          0x1F364
#define unicode_FISH_CAKE_WITH_SWIRL_DESIGN                           0x1F365
#define unicode_SOFT_ICE_CREAM                                        0x1F366
#define unicode_SHAVED_ICE                                            0x1F367
#define unicode_ICE_CREAM                                             0x1F368
#define unicode_DOUGHNUT                                              0x1F369
#define unicode_COOKIE                                                0x1F36A
#define unicode_CHOCOLATE_BAR                                         0x1F36B
#define unicode_CANDY                                                 0x1F36C
#define unicode_LOLLIPOP                                              0x1F36D
#define unicode_CUSTARD                                               0x1F36E
#define unicode_HONEY_POT                                             0x1F36F
#define unicode_SHORTCAKE                                             0x1F370
#define unicode_BENTO_BOX                                             0x1F371
#define unicode_POT_OF_FOOD                                           0x1F372
#define unicode_COOKING                                               0x1F373
#define unicode_FORK_AND_KNIFE                                        0x1F374
#define unicode_TEACUP_WITHOUT_HANDLE                                 0x1F375
#define unicode_SAKE_BOTTLE_AND_CUP                                   0x1F376
#define unicode_WINE_GLASS                                            0x1F377
#define unicode_COCKTAIL_GLASS                                        0x1F378
#define unicode_TROPICAL_DRINK                                        0x1F379
#define unicode_BEER_MUG                                              0x1F37A
#define unicode_CLINKING_BEER_MUGS                                    0x1F37B
#define unicode_BABY_BOTTLE                                           0x1F37C
#define unicode_FORK_AND_KNIFE_WITH_PLATE                             0x1F37D
#define unicode_RIBBON                                                0x1F380
#define unicode_WRAPPED_PRESENT                                       0x1F381
#define unicode_BIRTHDAY_CAKE                                         0x1F382
#define unicode_JACK_O_LANTERN                                        0x1F383
#define unicode_CHRISTMAS_TREE                                        0x1F384
#define unicode_FATHER_CHRISTMAS                                      0x1F385
#define unicode_FIREWORKS                                             0x1F386
#define unicode_FIREWORK_SPARKLER                                     0x1F387
#define unicode_BALLOON                                               0x1F388
#define unicode_PARTY_POPPER                                          0x1F389
#define unicode_CONFETTI_BALL                                         0x1F38A
#define unicode_TANABATA_TREE                                         0x1F38B
#define unicode_CROSSED_FLAGS                                         0x1F38C
#define unicode_PINE_DECORATION                                       0x1F38D
#define unicode_JAPANESE_DOLLS                                        0x1F38E
#define unicode_CARP_STREAMER                                         0x1F38F
#define unicode_WIND_CHIME                                            0x1F390
#define unicode_MOON_VIEWING_CEREMONY                                 0x1F391
#define unicode_SCHOOL_SATCHEL                                        0x1F392
#define unicode_GRADUATION_CAP                                        0x1F393
#define unicode_HEART_WITH_TIP_ON_THE_LEFT                            0x1F394
#define unicode_BOUQUET_OF_FLOWERS                                    0x1F395
#define unicode_MILITARY_MEDAL                                        0x1F396
#define unicode_REMINDER_RIBBON                                       0x1F397
#define unicode_MUSICAL_KEYBOARD_WITH_JACKS                           0x1F398
#define unicode_STUDIO_MICROPHONE                                     0x1F399
#define unicode_LEVEL_SLIDER                                          0x1F39A
#define unicode_CONTROL_KNOBS                                         0x1F39B
#define unicode_BEAMED_ASCENDING_MUSICAL_NOTES                        0x1F39C
#define unicode_BEAMED_DESCENDING_MUSICAL_NOTES                       0x1F39D
#define unicode_FILM_FRAMES                                           0x1F39E
#define unicode_ADMISSION_TICKETS                                     0x1F39F
#define unicode_CAROUSEL_HORSE                                        0x1F3A0
#define unicode_FERRIS_WHEEL                                          0x1F3A1
#define unicode_ROLLER_COASTER                                        0x1F3A2
#define unicode_FISHING_POLE_AND_FISH                                 0x1F3A3
#define unicode_MICROPHONE                                            0x1F3A4
#define unicode_MOVIE_CAMERA                                          0x1F3A5
#define unicode_CINEMA                                                0x1F3A6
#define unicode_HEADPHONE                                             0x1F3A7
#define unicode_ARTIST_PALETTE                                        0x1F3A8
#define unicode_TOP_HAT                                               0x1F3A9
#define unicode_CIRCUS_TENT                                           0x1F3AA
#define unicode_TICKET                                                0x1F3AB
#define unicode_CLAPPER_BOARD                                         0x1F3AC
#define unicode_PERFORMING_ARTS                                       0x1F3AD
#define unicode_VIDEO_GAME                                            0x1F3AE
#define unicode_DIRECT_HIT                                            0x1F3AF
#define unicode_SLOT_MACHINE                                          0x1F3B0
#define unicode_BILLIARDS                                             0x1F3B1
#define unicode_GAME_DIE                                              0x1F3B2
#define unicode_BOWLING                                               0x1F3B3
#define unicode_FLOWER_PLAYING_CARDS                                  0x1F3B4
#define unicode_MUSICAL_NOTE                                          0x1F3B5
#define unicode_MULTIPLE_MUSICAL_NOTES                                0x1F3B6
#define unicode_SAXOPHONE                                             0x1F3B7
#define unicode_GUITAR                                                0x1F3B8
#define unicode_MUSICAL_KEYBOARD                                      0x1F3B9
#define unicode_TRUMPET                                               0x1F3BA
#define unicode_VIOLIN                                                0x1F3BB
#define unicode_MUSICAL_SCORE                                         0x1F3BC
#define unicode_RUNNING_SHIRT_WITH_SASH                               0x1F3BD
#define unicode_TENNIS_RACQUET_AND_BALL                               0x1F3BE
#define unicode_SKI_AND_SKI_BOOT                                      0x1F3BF
#define unicode_BASKETBALL_AND_HOOP                                   0x1F3C0
#define unicode_CHEQUERED_FLAG                                        0x1F3C1
#define unicode_SNOWBOARDER                                           0x1F3C2
#define unicode_RUNNER                                                0x1F3C3
#define unicode_SURFER                                                0x1F3C4
#define unicode_SPORTS_MEDAL                                          0x1F3C5
#define unicode_TROPHY                                                0x1F3C6
#define unicode_HORSE_RACING                                          0x1F3C7
#define unicode_AMERICAN_FOOTBALL                                     0x1F3C8
#define unicode_RUGBY_FOOTBALL                                        0x1F3C9
#define unicode_SWIMMER                                               0x1F3CA
#define unicode_WEIGHT_LIFTER                                         0x1F3CB
#define unicode_GOLFER                                                0x1F3CC
#define unicode_RACING_MOTORCYCLE                                     0x1F3CD
#define unicode_RACING_CAR                                            0x1F3CE
#define unicode_SNOW_CAPPED_MOUNTAIN                                  0x1F3D4
#define unicode_CAMPING                                               0x1F3D5
#define unicode_BEACH_WITH_UMBRELLA                                   0x1F3D6
#define unicode_BUILDING_CONSTRUCTION                                 0x1F3D7
#define unicode_HOUSE_BUILDINGS                                       0x1F3D8
#define unicode_CITYSCAPE                                             0x1F3D9
#define unicode_DERELICT_HOUSE_BUILDING                               0x1F3DA
#define unicode_CLASSICAL_BUILDING                                    0x1F3DB
#define unicode_DESERT                                                0x1F3DC
#define unicode_DESERT_ISLAND                                         0x1F3DD
#define unicode_NATIONAL_PARK                                         0x1F3DE
#define unicode_STADIUM                                               0x1F3DF
#define unicode_HOUSE_BUILDING                                        0x1F3E0
#define unicode_HOUSE_WITH_GARDEN                                     0x1F3E1
#define unicode_OFFICE_BUILDING                                       0x1F3E2
#define unicode_JAPANESE_POST_OFFICE                                  0x1F3E3
#define unicode_EUROPEAN_POST_OFFICE                                  0x1F3E4
#define unicode_HOSPITAL                                              0x1F3E5
#define unicode_BANK                                                  0x1F3E6
#define unicode_AUTOMATED_TELLER_MACHINE                              0x1F3E7
#define unicode_HOTEL                                                 0x1F3E8
#define unicode_LOVE_HOTEL                                            0x1F3E9
#define unicode_CONVENIENCE_STORE                                     0x1F3EA
#define unicode_SCHOOL                                                0x1F3EB
#define unicode_DEPARTMENT_STORE                                      0x1F3EC
#define unicode_FACTORY                                               0x1F3ED
#define unicode_IZAKAYA_LANTERN                                       0x1F3EE
#define unicode_JAPANESE_CASTLE                                       0x1F3EF
#define unicode_EUROPEAN_CASTLE                                       0x1F3F0
#define unicode_WHITE_PENNANT                                         0x1F3F1
#define unicode_BLACK_PENNANT                                         0x1F3F2
#define unicode_WAVING_WHITE_FLAG                                     0x1F3F3
#define unicode_WAVING_BLACK_FLAG                                     0x1F3F4
#define unicode_ROSETTE                                               0x1F3F5
#define unicode_BLACK_ROSETTE                                         0x1F3F6
#define unicode_LABEL                                                 0x1F3F7
#define unicode_RAT                                                   0x1F400
#define unicode_MOUSE                                                 0x1F401
#define unicode_OX                                                    0x1F402
#define unicode_WATER_BUFFALO                                         0x1F403
#define unicode_COW                                                   0x1F404
#define unicode_TIGER                                                 0x1F405
#define unicode_LEOPARD                                               0x1F406
#define unicode_RABBIT                                                0x1F407
#define unicode_CAT                                                   0x1F408
#define unicode_DRAGON                                                0x1F409
#define unicode_CROCODILE                                             0x1F40A
#define unicode_WHALE                                                 0x1F40B
#define unicode_SNAIL                                                 0x1F40C
#define unicode_SNAKE                                                 0x1F40D
#define unicode_HORSE                                                 0x1F40E
#define unicode_RAM                                                   0x1F40F
#define unicode_GOAT                                                  0x1F410
#define unicode_SHEEP                                                 0x1F411
#define unicode_MONKEY                                                0x1F412
#define unicode_ROOSTER                                               0x1F413
#define unicode_CHICKEN                                               0x1F414
#define unicode_DOG                                                   0x1F415
#define unicode_PIG                                                   0x1F416
#define unicode_BOAR                                                  0x1F417
#define unicode_ELEPHANT                                              0x1F418
#define unicode_OCTOPUS                                               0x1F419
#define unicode_SPIRAL_SHELL                                          0x1F41A
#define unicode_BUG                                                   0x1F41B
#define unicode_ANT                                                   0x1F41C
#define unicode_HONEYBEE                                              0x1F41D
#define unicode_LADY_BEETLE                                           0x1F41E
#define unicode_FISH                                                  0x1F41F
#define unicode_TROPICAL_FISH                                         0x1F420
#define unicode_BLOWFISH                                              0x1F421
#define unicode_TURTLE                                                0x1F422
#define unicode_HATCHING_CHICK                                        0x1F423
#define unicode_BABY_CHICK                                            0x1F424
#define unicode_FRONT_FACING_BABY_CHICK                               0x1F425
#define unicode_BIRD                                                  0x1F426
#define unicode_PENGUIN                                               0x1F427
#define unicode_KOALA                                                 0x1F428
#define unicode_POODLE                                                0x1F429
#define unicode_DROMEDARY_CAMEL                                       0x1F42A
#define unicode_BACTRIAN_CAMEL                                        0x1F42B
#define unicode_DOLPHIN                                               0x1F42C
#define unicode_MOUSE_FACE                                            0x1F42D
#define unicode_COW_FACE                                              0x1F42E
#define unicode_TIGER_FACE                                            0x1F42F
#define unicode_RABBIT_FACE                                           0x1F430
#define unicode_CAT_FACE                                              0x1F431
#define unicode_DRAGON_FACE                                           0x1F432
#define unicode_SPOUTING_WHALE                                        0x1F433
#define unicode_HORSE_FACE                                            0x1F434
#define unicode_MONKEY_FACE                                           0x1F435
#define unicode_DOG_FACE                                              0x1F436
#define unicode_PIG_FACE                                              0x1F437
#define unicode_FROG_FACE                                             0x1F438
#define unicode_HAMSTER_FACE                                          0x1F439
#define unicode_WOLF_FACE                                             0x1F43A
#define unicode_BEAR_FACE                                             0x1F43B
#define unicode_PANDA_FACE                                            0x1F43C
#define unicode_PIG_NOSE                                              0x1F43D
#define unicode_PAW_PRINTS                                            0x1F43E
#define unicode_CHIPMUNK                                              0x1F43F
#define unicode_EYES                                                  0x1F440
#define unicode_EYE                                                   0x1F441
#define unicode_EAR                                                   0x1F442
#define unicode_NOSE                                                  0x1F443
#define unicode_MOUTH                                                 0x1F444
#define unicode_TONGUE                                                0x1F445
#define unicode_WHITE_UP_POINTING_BACKHAND_INDEX                      0x1F446
#define unicode_WHITE_DOWN_POINTING_BACKHAND_INDEX                    0x1F447
#define unicode_WHITE_LEFT_POINTING_BACKHAND_INDEX                    0x1F448
#define unicode_WHITE_RIGHT_POINTING_BACKHAND_INDEX                   0x1F449
#define unicode_FISTED_HAND_SIGN                                      0x1F44A
#define unicode_WAVING_HAND_SIGN                                      0x1F44B
#define unicode_OK_HAND_SIGN                                          0x1F44C
#define unicode_THUMBS_UP_SIGN                                        0x1F44D
#define unicode_THUMBS_DOWN_SIGN                                      0x1F44E
#define unicode_CLAPPING_HANDS_SIGN                                   0x1F44F
#define unicode_OPEN_HANDS_SIGN                                       0x1F450
#define unicode_CROWN                                                 0x1F451
#define unicode_WOMANS_HAT                                            0x1F452
#define unicode_EYEGLASSES                                            0x1F453
#define unicode_NECKTIE                                               0x1F454
#define unicode_T_SHIRT                                               0x1F455
#define unicode_JEANS                                                 0x1F456
#define unicode_DRESS                                                 0x1F457
#define unicode_KIMONO                                                0x1F458
#define unicode_BIKINI                                                0x1F459
#define unicode_WOMANS_CLOTHES                                        0x1F45A
#define unicode_PURSE                                                 0x1F45B
#define unicode_HANDBAG                                               0x1F45C
#define unicode_POUCH                                                 0x1F45D
#define unicode_MANS_SHOE                                             0x1F45E
#define unicode_ATHLETIC_SHOE                                         0x1F45F
#define unicode_HIGH_HEELED_SHOE                                      0x1F460
#define unicode_WOMANS_SANDAL                                         0x1F461
#define unicode_WOMANS_BOOTS                                          0x1F462
#define unicode_FOOTPRINTS                                            0x1F463
#define unicode_BUST_IN_SILHOUETTE                                    0x1F464
#define unicode_BUSTS_IN_SILHOUETTE                                   0x1F465
#define unicode_BOY                                                   0x1F466
#define unicode_GIRL                                                  0x1F467
#define unicode_MAN                                                   0x1F468
#define unicode_WOMAN                                                 0x1F469
#define unicode_FAMILY                                                0x1F46A
#define unicode_MAN_AND_WOMAN_HOLDING_HANDS                           0x1F46B
#define unicode_TWO_MEN_HOLDING_HANDS                                 0x1F46C
#define unicode_TWO_WOMEN_HOLDING_HANDS                               0x1F46D
#define unicode_POLICE_OFFICER                                        0x1F46E
#define unicode_WOMAN_WITH_BUNNY_EARS                                 0x1F46F
#define unicode_BRIDE_WITH_VEIL                                       0x1F470
#define unicode_PERSON_WITH_BLOND_HAIR                                0x1F471
#define unicode_MAN_WITH_GUA_PI_MAO                                   0x1F472
#define unicode_MAN_WITH_TURBAN                                       0x1F473
#define unicode_OLDER_MAN                                             0x1F474
#define unicode_OLDER_WOMAN                                           0x1F475
#define unicode_BABY                                                  0x1F476
#define unicode_CONSTRUCTION_WORKER                                   0x1F477
#define unicode_PRINCESS                                              0x1F478
#define unicode_JAPANESE_OGRE                                         0x1F479
#define unicode_JAPANESE_GOBLIN                                       0x1F47A
#define unicode_GHOST                                                 0x1F47B
#define unicode_BABY_ANGEL                                            0x1F47C
#define unicode_EXTRATERRESTRIAL_ALIEN                                0x1F47D
#define unicode_ALIEN_MONSTER                                         0x1F47E
#define unicode_IMP                                                   0x1F47F
#define unicode_SKULL                                                 0x1F480
#define unicode_INFORMATION_DESK_PERSON                               0x1F481
#define unicode_GUARDSMAN                                             0x1F482
#define unicode_DANCER                                                0x1F483
#define unicode_LIPSTICK                                              0x1F484
#define unicode_NAIL_POLISH                                           0x1F485
#define unicode_FACE_MASSAGE                                          0x1F486
#define unicode_HAIRCUT                                               0x1F487
#define unicode_BARBER_POLE                                           0x1F488
#define unicode_SYRINGE                                               0x1F489
#define unicode_PILL                                                  0x1F48A
#define unicode_KISS_MARK                                             0x1F48B
#define unicode_LOVE_LETTER                                           0x1F48C
#define unicode_RING                                                  0x1F48D
#define unicode_GEM_STONE                                             0x1F48E
#define unicode_KISS                                                  0x1F48F
#define unicode_BOUQUET                                               0x1F490
#define unicode_COUPLE_WITH_HEART                                     0x1F491
#define unicode_WEDDING                                               0x1F492
#define unicode_BEATING_HEART                                         0x1F493
#define unicode_BROKEN_HEART                                          0x1F494
#define unicode_TWO_HEARTS                                            0x1F495
#define unicode_SPARKLING_HEART                                       0x1F496
#define unicode_GROWING_HEART                                         0x1F497
#define unicode_HEART_WITH_ARROW                                      0x1F498
#define unicode_BLUE_HEART                                            0x1F499
#define unicode_GREEN_HEART                                           0x1F49A
#define unicode_YELLOW_HEART                                          0x1F49B
#define unicode_PURPLE_HEART                                          0x1F49C
#define unicode_HEART_WITH_RIBBON                                     0x1F49D
#define unicode_REVOLVING_HEARTS                                      0x1F49E
#define unicode_HEART_DECORATION                                      0x1F49F
#define unicode_DIAMOND_SHAPE_WITH_A_DOT_INSIDE                       0x1F4A0
#define unicode_ELECTRIC_LIGHT_BULB                                   0x1F4A1
#define unicode_ANGER_SYMBOL                                          0x1F4A2
#define unicode_BOMB                                                  0x1F4A3
#define unicode_SLEEPING_SYMBOL                                       0x1F4A4
#define unicode_COLLISION_SYMBOL                                      0x1F4A5
#define unicode_SPLASHING_SWEAT_SYMBOL                                0x1F4A6
#define unicode_DROPLET                                               0x1F4A7
#define unicode_DASH_SYMBOL                                           0x1F4A8
#define unicode_PILE_OF_POO                                           0x1F4A9
#define unicode_FLEXED_BICEPS                                         0x1F4AA
#define unicode_DIZZY_SYMBOL                                          0x1F4AB
#define unicode_SPEECH_BALLOON                                        0x1F4AC
#define unicode_THOUGHT_BALLOON                                       0x1F4AD
#define unicode_WHITE_FLOWER                                          0x1F4AE
#define unicode_HUNDRED_POINTS_SYMBOL                                 0x1F4AF
#define unicode_MONEY_BAG                                             0x1F4B0
#define unicode_CURRENCY_EXCHANGE                                     0x1F4B1
#define unicode_HEAVY_DOLLAR_SIGN                                     0x1F4B2
#define unicode_CREDIT_CARD                                           0x1F4B3
#define unicode_BANKNOTE_WITH_YEN_SIGN                                0x1F4B4
#define unicode_BANKNOTE_WITH_DOLLAR_SIGN                             0x1F4B5
#define unicode_BANKNOTE_WITH_EURO_SIGN                               0x1F4B6
#define unicode_BANKNOTE_WITH_POUND_SIGN                              0x1F4B7
#define unicode_MONEY_WITH_WINGS                                      0x1F4B8
#define unicode_CHART_WITH_UPWARDS_TREND_AND_YEN_SIGN                 0x1F4B9
#define unicode_SEAT                                                  0x1F4BA
#define unicode_PERSONAL_COMPUTER                                     0x1F4BB
#define unicode_BRIEFCASE                                             0x1F4BC
#define unicode_MINIDISC                                              0x1F4BD
#define unicode_FLOPPY_DISK                                           0x1F4BE
#define unicode_OPTICAL_DISC                                          0x1F4BF
#define unicode_DVD                                                   0x1F4C0
#define unicode_FILE_FOLDER                                           0x1F4C1
#define unicode_OPEN_FILE_FOLDER                                      0x1F4C2
#define unicode_PAGE_WITH_CURL                                        0x1F4C3
#define unicode_PAGE_FACING_UP                                        0x1F4C4
#define unicode_CALENDAR                                              0x1F4C5
#define unicode_TEAR_OFF_CALENDAR                                     0x1F4C6
#define unicode_CARD_INDEX                                            0x1F4C7
#define unicode_CHART_WITH_UPWARDS_TREND                              0x1F4C8
#define unicode_CHART_WITH_DOWNWARDS_TREND                            0x1F4C9
#define unicode_BAR_CHART                                             0x1F4CA
#define unicode_CLIPBOARD                                             0x1F4CB
#define unicode_PUSHPIN                                               0x1F4CC
#define unicode_ROUND_PUSHPIN                                         0x1F4CD
#define unicode_PAPERCLIP                                             0x1F4CE
#define unicode_STRAIGHT_RULER                                        0x1F4CF
#define unicode_TRIANGULAR_RULER                                      0x1F4D0
#define unicode_BOOKMARK_TABS                                         0x1F4D1
#define unicode_LEDGER                                                0x1F4D2
#define unicode_NOTEBOOK                                              0x1F4D3
#define unicode_NOTEBOOK_WITH_DECORATIVE_COVER                        0x1F4D4
#define unicode_CLOSED_BOOK                                           0x1F4D5
#define unicode_OPEN_BOOK                                             0x1F4D6
#define unicode_GREEN_BOOK                                            0x1F4D7
#define unicode_BLUE_BOOK                                             0x1F4D8
#define unicode_ORANGE_BOOK                                           0x1F4D9
#define unicode_BOOKS                                                 0x1F4DA
#define unicode_NAME_BADGE                                            0x1F4DB
#define unicode_SCROLL                                                0x1F4DC
#define unicode_MEMO                                                  0x1F4DD
#define unicode_TELEPHONE_RECEIVER                                    0x1F4DE
#define unicode_PAGER                                                 0x1F4DF
#define unicode_FAX_MACHINE                                           0x1F4E0
#define unicode_SATELLITE_ANTENNA                                     0x1F4E1
#define unicode_PUBLIC_ADDRESS_LOUDSPEAKER                            0x1F4E2
#define unicode_CHEERING_MEGAPHONE                                    0x1F4E3
#define unicode_OUTBOX_TRAY                                           0x1F4E4
#define unicode_INBOX_TRAY                                            0x1F4E5
#define unicode_PACKAGE                                               0x1F4E6
#define unicode_E_MAIL_SYMBOL                                         0x1F4E7
#define unicode_INCOMING_ENVELOPE                                     0x1F4E8
#define unicode_ENVELOPE_WITH_DOWNWARDS_ARROW_ABOVE                   0x1F4E9
#define unicode_CLOSED_MAILBOX_WITH_LOWERED_FLAG                      0x1F4EA
#define unicode_CLOSED_MAILBOX_WITH_RAISED_FLAG                       0x1F4EB
#define unicode_OPEN_MAILBOX_WITH_RAISED_FLAG                         0x1F4EC
#define unicode_OPEN_MAILBOX_WITH_LOWERED_FLAG                        0x1F4ED
#define unicode_POSTBOX                                               0x1F4EE
#define unicode_POSTAL_HORN                                           0x1F4EF
#define unicode_NEWSPAPER                                             0x1F4F0
#define unicode_MOBILE_PHONE                                          0x1F4F1
#define unicode_MOBILE_PHONE_WITH_RIGHTWARDS_ARROW_AT_LEFT            0x1F4F2
#define unicode_VIBRATION_MODE                                        0x1F4F3
#define unicode_MOBILE_PHONE_OFF                                      0x1F4F4
#define unicode_NO_MOBILE_PHONES                                      0x1F4F5
#define unicode_ANTENNA_WITH_BARS                                     0x1F4F6
#define unicode_CAMERA                                                0x1F4F7
#define unicode_CAMERA_WITH_FLASH                                     0x1F4F8
#define unicode_VIDEO_CAMERA                                          0x1F4F9
#define unicode_TELEVISION                                            0x1F4FA
#define unicode_RADIO                                                 0x1F4FB
#define unicode_VIDEOCASSETTE                                         0x1F4FC
#define unicode_FILM_PROJECTOR                                        0x1F4FD
#define unicode_PORTABLE_STEREO                                       0x1F4FE
#define unicode_TWISTED_RIGHTWARDS_ARROWS                             0x1F500
#define unicode_CLOCKWISE_RIGHTWARDS_AND_LEFTWARDS_OPEN_CIRCLE_ARROWS 0x1F501
#define unicode_CLOCKWISE_RIGHTWARDS_AND_LEFTWARDS_OPEN_CIRCLE_ARROWS_WITH_CIRCLED_ONE_OVERLAY 0x1F502
#define unicode_CLOCKWISE_DOWNWARDS_AND_UPWARDS_OPEN_CIRCLE_ARROWS    0x1F503
#define unicode_ANTICLOCKWISE_DOWNWARDS_AND_UPWARDS_OPEN_CIRCLE_ARROWS 0x1F504
#define unicode_LOW_BRIGHTNESS_SYMBOL                                 0x1F505
#define unicode_HIGH_BRIGHTNESS_SYMBOL                                0x1F506
#define unicode_SPEAKER_WITH_CANCELLATION_STROKE                      0x1F507
#define unicode_SPEAKER                                               0x1F508
#define unicode_SPEAKER_WITH_ONE_SOUND_WAVE                           0x1F509
#define unicode_SPEAKER_WITH_THREE_SOUND_WAVES                        0x1F50A
#define unicode_BATTERY                                               0x1F50B
#define unicode_ELECTRIC_PLUG                                         0x1F50C
#define unicode_LEFT_POINTING_MAGNIFYING_GLASS                        0x1F50D
#define unicode_RIGHT_POINTING_MAGNIFYING_GLASS                       0x1F50E
#define unicode_LOCK_WITH_INK_PEN                                     0x1F50F
#define unicode_CLOSED_LOCK_WITH_KEY                                  0x1F510
#define unicode_KEY                                                   0x1F511
#define unicode_LOCK                                                  0x1F512
#define unicode_OPEN_LOCK                                             0x1F513
#define unicode_BELL                                                  0x1F514
#define unicode_BELL_WITH_CANCELLATION_STROKE                         0x1F515
#define unicode_BOOKMARK                                              0x1F516
#define unicode_LINK_SYMBOL                                           0x1F517
#define unicode_RADIO_BUTTON                                          0x1F518
#define unicode_BACK_WITH_LEFTWARDS_ARROW_ABOVE                       0x1F519
#define unicode_END_WITH_LEFTWARDS_ARROW_ABOVE                        0x1F51A
#define unicode_ON_WITH_EXCLAMATION_MARK_WITH_LEFT_RIGHT_ARROW_ABOVE  0x1F51B
#define unicode_SOON_WITH_RIGHTWARDS_ARROW_ABOVE                      0x1F51C
#define unicode_TOP_WITH_UPWARDS_ARROW_ABOVE                          0x1F51D
#define unicode_NO_ONE_UNDER_EIGHTEEN_SYMBOL                          0x1F51E
#define unicode_KEYCAP_TEN                                            0x1F51F
#define unicode_INPUT_SYMBOL_FOR_LATIN_CAPITAL_LETTERS                0x1F520
#define unicode_INPUT_SYMBOL_FOR_LATIN_SMALL_LETTERS                  0x1F521
#define unicode_INPUT_SYMBOL_FOR_NUMBERS                              0x1F522
#define unicode_INPUT_SYMBOL_FOR_SYMBOLS                              0x1F523
#define unicode_INPUT_SYMBOL_FOR_LATIN_LETTERS                        0x1F524
#define unicode_FIRE                                                  0x1F525
#define unicode_ELECTRIC_TORCH                                        0x1F526
#define unicode_WRENCH                                                0x1F527
#define unicode_HAMMER                                                0x1F528
#define unicode_NUT_AND_BOLT                                          0x1F529
#define unicode_HOCHO                                                 0x1F52A
#define unicode_PISTOL                                                0x1F52B
#define unicode_MICROSCOPE                                            0x1F52C
#define unicode_TELESCOPE                                             0x1F52D
#define unicode_CRYSTAL_BALL                                          0x1F52E
#define unicode_SIX_POINTED_STAR_WITH_MIDDLE_DOT                      0x1F52F
#define unicode_JAPANESE_SYMBOL_FOR_BEGINNER                          0x1F530
#define unicode_TRIDENT_EMBLEM                                        0x1F531
#define unicode_BLACK_SQUARE_BUTTON                                   0x1F532
#define unicode_WHITE_SQUARE_BUTTON                                   0x1F533
#define unicode_LARGE_RED_CIRCLE                                      0x1F534
#define unicode_LARGE_BLUE_CIRCLE                                     0x1F535
#define unicode_LARGE_ORANGE_DIAMOND                                  0x1F536
#define unicode_LARGE_BLUE_DIAMOND                                    0x1F537
#define unicode_SMALL_ORANGE_DIAMOND                                  0x1F538
#define unicode_SMALL_BLUE_DIAMOND                                    0x1F539
#define unicode_UP_POINTING_RED_TRIANGLE                              0x1F53A
#define unicode_DOWN_POINTING_RED_TRIANGLE                            0x1F53B
#define unicode_UP_POINTING_SMALL_RED_TRIANGLE                        0x1F53C
#define unicode_DOWN_POINTING_SMALL_RED_TRIANGLE                      0x1F53D
#define unicode_LOWER_RIGHT_SHADOWED_WHITE_CIRCLE                     0x1F53E
#define unicode_UPPER_RIGHT_SHADOWED_WHITE_CIRCLE                     0x1F53F
#define unicode_CIRCLED_CROSS_POMMEE                                  0x1F540
#define unicode_CROSS_POMMEE_WITH_HALF_CIRCLE_BELOW                   0x1F541
#define unicode_CROSS_POMMEE                                          0x1F542
#define unicode_NOTCHED_LEFT_SEMICIRCLE_WITH_THREE_DOTS               0x1F543
#define unicode_NOTCHED_RIGHT_SEMICIRCLE_WITH_THREE_DOTS              0x1F544
#define unicode_SYMBOL_FOR_MARKS_CHAPTER                              0x1F545
#define unicode_WHITE_LATIN_CROSS                                     0x1F546
#define unicode_HEAVY_LATIN_CROSS                                     0x1F547
#define unicode_CELTIC_CROSS                                          0x1F548
#define unicode_OM_SYMBOL                                             0x1F549
#define unicode_DOVE_OF_PEACE                                         0x1F54A
#define unicode_CLOCK_FACE_ONE_OCLOCK                                 0x1F550
#define unicode_CLOCK_FACE_TWO_OCLOCK                                 0x1F551
#define unicode_CLOCK_FACE_THREE_OCLOCK                               0x1F552
#define unicode_CLOCK_FACE_FOUR_OCLOCK                                0x1F553
#define unicode_CLOCK_FACE_FIVE_OCLOCK                                0x1F554
#define unicode_CLOCK_FACE_SIX_OCLOCK                                 0x1F555
#define unicode_CLOCK_FACE_SEVEN_OCLOCK                               0x1F556
#define unicode_CLOCK_FACE_EIGHT_OCLOCK                               0x1F557
#define unicode_CLOCK_FACE_NINE_OCLOCK                                0x1F558
#define unicode_CLOCK_FACE_TEN_OCLOCK                                 0x1F559
#define unicode_CLOCK_FACE_ELEVEN_OCLOCK                              0x1F55A
#define unicode_CLOCK_FACE_TWELVE_OCLOCK                              0x1F55B
#define unicode_CLOCK_FACE_ONE_THIRTY                                 0x1F55C
#define unicode_CLOCK_FACE_TWO_THIRTY                                 0x1F55D
#define unicode_CLOCK_FACE_THREE_THIRTY                               0x1F55E
#define unicode_CLOCK_FACE_FOUR_THIRTY                                0x1F55F
#define unicode_CLOCK_FACE_FIVE_THIRTY                                0x1F560
#define unicode_CLOCK_FACE_SIX_THIRTY                                 0x1F561
#define unicode_CLOCK_FACE_SEVEN_THIRTY                               0x1F562
#define unicode_CLOCK_FACE_EIGHT_THIRTY                               0x1F563
#define unicode_CLOCK_FACE_NINE_THIRTY                                0x1F564
#define unicode_CLOCK_FACE_TEN_THIRTY                                 0x1F565
#define unicode_CLOCK_FACE_ELEVEN_THIRTY                              0x1F566
#define unicode_CLOCK_FACE_TWELVE_THIRTY                              0x1F567
#define unicode_RIGHT_SPEAKER                                         0x1F568
#define unicode_RIGHT_SPEAKER_WITH_ONE_SOUND_WAVE                     0x1F569
#define unicode_RIGHT_SPEAKER_WITH_THREE_SOUND_WAVES                  0x1F56A
#define unicode_BULLHORN                                              0x1F56B
#define unicode_BULLHORN_WITH_SOUND_WAVES                             0x1F56C
#define unicode_RINGING_BELL                                          0x1F56D
#define unicode_BOOK                                                  0x1F56E
#define unicode_CANDLE                                                0x1F56F
#define unicode_MANTELPIECE_CLOCK                                     0x1F570
#define unicode_BLACK_SKULL_AND_CROSSBONES                            0x1F571
#define unicode_NO_PIRACY                                             0x1F572
#define unicode_HOLE                                                  0x1F573
#define unicode_MAN_IN_BUSINESS_SUIT_LEVITATING                       0x1F574
#define unicode_SLEUTH_OR_SPY                                         0x1F575
#define unicode_DARK_SUNGLASSES                                       0x1F576
#define unicode_SPIDER                                                0x1F577
#define unicode_SPIDER_WEB                                            0x1F578
#define unicode_JOYSTICK                                              0x1F579
#define unicode_LEFT_HAND_TELEPHONE_RECEIVER                          0x1F57B
#define unicode_TELEPHONE_RECEIVER_WITH_PAGE                          0x1F57C
#define unicode_RIGHT_HAND_TELEPHONE_RECEIVER                         0x1F57D
#define unicode_WHITE_TOUCHTONE_TELEPHONE                             0x1F57E
#define unicode_BLACK_TOUCHTONE_TELEPHONE                             0x1F57F
#define unicode_TELEPHONE_ON_TOP_OF_MODEM                             0x1F580
#define unicode_CLAMSHELL_MOBILE_PHONE                                0x1F581
#define unicode_BACK_OF_ENVELOPE                                      0x1F582
#define unicode_STAMPED_ENVELOPE                                      0x1F583
#define unicode_ENVELOPE_WITH_LIGHTNING                               0x1F584
#define unicode_FLYING_ENVELOPE                                       0x1F585
#define unicode_PEN_OVER_STAMPED_ENVELOPE                             0x1F586
#define unicode_LINKED_PAPERCLIPS                                     0x1F587
#define unicode_BLACK_PUSHPIN                                         0x1F588
#define unicode_LOWER_LEFT_PENCIL                                     0x1F589
#define unicode_LOWER_LEFT_BALLPOINT_PEN                              0x1F58A
#define unicode_LOWER_LEFT_FOUNTAIN_PEN                               0x1F58B
#define unicode_LOWER_LEFT_PAINTBRUSH                                 0x1F58C
#define unicode_LOWER_LEFT_CRAYON                                     0x1F58D
#define unicode_LEFT_WRITING_HAND                                     0x1F58E
#define unicode_TURNED_OK_HAND_SIGN                                   0x1F58F
#define unicode_RAISED_HAND_WITH_FINGERS_SPLAYED                      0x1F590
#define unicode_REVERSED_RAISED_HAND_WITH_FINGERS_SPLAYED             0x1F591
#define unicode_REVERSED_THUMBS_UP_SIGN                               0x1F592
#define unicode_REVERSED_THUMBS_DOWN_SIGN                             0x1F593
#define unicode_REVERSED_VICTORY_HAND                                 0x1F594
#define unicode_REVERSED_HAND_WITH_MIDDLE_FINGER_EXTENDED             0x1F595
#define unicode_RAISED_HAND_WITH_PART_BETWEEN_MIDDLE_AND_RING_FINGERS 0x1F596
#define unicode_WHITE_DOWN_POINTING_LEFT_HAND_INDEX                   0x1F597
#define unicode_SIDEWAYS_WHITE_LEFT_POINTING_INDEX                    0x1F598
#define unicode_SIDEWAYS_WHITE_RIGHT_POINTING_INDEX                   0x1F599
#define unicode_SIDEWAYS_BLACK_LEFT_POINTING_INDEX                    0x1F59A
#define unicode_SIDEWAYS_BLACK_RIGHT_POINTING_INDEX                   0x1F59B
#define unicode_BLACK_LEFT_POINTING_BACKHAND_INDEX                    0x1F59C
#define unicode_BLACK_RIGHT_POINTING_BACKHAND_INDEX                   0x1F59D
#define unicode_SIDEWAYS_WHITE_UP_POINTING_INDEX                      0x1F59E
#define unicode_SIDEWAYS_WHITE_DOWN_POINTING_INDEX                    0x1F59F
#define unicode_SIDEWAYS_BLACK_UP_POINTING_INDEX                      0x1F5A0
#define unicode_SIDEWAYS_BLACK_DOWN_POINTING_INDEX                    0x1F5A1
#define unicode_BLACK_UP_POINTING_BACKHAND_INDEX                      0x1F5A2
#define unicode_BLACK_DOWN_POINTING_BACKHAND_INDEX                    0x1F5A3
#define unicode_DESKTOP_COMPUTER                                      0x1F5A5
#define unicode_KEYBOARD_AND_MOUSE                                    0x1F5A6
#define unicode_THREE_NETWORKED_COMPUTERS                             0x1F5A7
#define unicode_PRINTER                                               0x1F5A8
#define unicode_POCKET_CALCULATOR                                     0x1F5A9
#define unicode_BLACK_HARD_SHELL_FLOPPY_DISK                          0x1F5AA
#define unicode_WHITE_HARD_SHELL_FLOPPY_DISK                          0x1F5AB
#define unicode_SOFT_SHELL_FLOPPY_DISK                                0x1F5AC
#define unicode_TAPE_CARTRIDGE                                        0x1F5AD
#define unicode_WIRED_KEYBOARD                                        0x1F5AE
#define unicode_ONE_BUTTON_MOUSE                                      0x1F5AF
#define unicode_TWO_BUTTON_MOUSE                                      0x1F5B0
#define unicode_THREE_BUTTON_MOUSE                                    0x1F5B1
#define unicode_TRACKBALL                                             0x1F5B2
#define unicode_OLD_PERSONAL_COMPUTER                                 0x1F5B3
#define unicode_HARD_DISK                                             0x1F5B4
#define unicode_SCREEN                                                0x1F5B5
#define unicode_PRINTER_ICON                                          0x1F5B6
#define unicode_FAX_ICON                                              0x1F5B7
#define unicode_OPTICAL_DISC_ICON                                     0x1F5B8
#define unicode_DOCUMENT_WITH_TEXT                                    0x1F5B9
#define unicode_DOCUMENT_WITH_TEXT_AND_PICTURE                        0x1F5BA
#define unicode_DOCUMENT_WITH_PICTURE                                 0x1F5BB
#define unicode_FRAME_WITH_PICTURE                                    0x1F5BC
#define unicode_FRAME_WITH_TILES                                      0x1F5BD
#define unicode_FRAME_WITH_AN_X                                       0x1F5BE
#define unicode_BLACK_FOLDER                                          0x1F5BF
#define unicode_FOLDER                                                0x1F5C0
#define unicode_OPEN_FOLDER                                           0x1F5C1
#define unicode_CARD_INDEX_DIVIDERS                                   0x1F5C2
#define unicode_CARD_FILE_BOX                                         0x1F5C3
#define unicode_FILE_CABINET                                          0x1F5C4
#define unicode_EMPTY_NOTE                                            0x1F5C5
#define unicode_EMPTY_NOTE_PAGE                                       0x1F5C6
#define unicode_EMPTY_NOTE_PAD                                        0x1F5C7
#define unicode_NOTE                                                  0x1F5C8
#define unicode_NOTE_PAGE                                             0x1F5C9
#define unicode_NOTE_PAD                                              0x1F5CA
#define unicode_EMPTY_DOCUMENT                                        0x1F5CB
#define unicode_EMPTY_PAGE                                            0x1F5CC
#define unicode_EMPTY_PAGES                                           0x1F5CD
#define unicode_DOCUMENT                                              0x1F5CE
#define unicode_PAGE                                                  0x1F5CF
#define unicode_PAGES                                                 0x1F5D0
#define unicode_WASTEBASKET                                           0x1F5D1
#define unicode_SPIRAL_NOTE_PAD                                       0x1F5D2
#define unicode_SPIRAL_CALENDAR_PAD                                   0x1F5D3
#define unicode_DESKTOP_WINDOW                                        0x1F5D4
#define unicode_MINIMIZE                                              0x1F5D5
#define unicode_MAXIMIZE                                              0x1F5D6
#define unicode_OVERLAP                                               0x1F5D7
#define unicode_CLOCKWISE_RIGHT_AND_LEFT_SEMICIRCLE_ARROWS            0x1F5D8
#define unicode_CANCELLATION_X                                        0x1F5D9
#define unicode_INCREASE_FONT_SIZE_SYMBOL                             0x1F5DA
#define unicode_DECREASE_FONT_SIZE_SYMBOL                             0x1F5DB
#define unicode_COMPRESSION                                           0x1F5DC
#define unicode_OLD_KEY                                               0x1F5DD
#define unicode_ROLLED_UP_NEWSPAPER                                   0x1F5DE
#define unicode_PAGE_WITH_CIRCLED_TEXT                                0x1F5DF
#define unicode_STOCK_CHART                                           0x1F5E0
#define unicode_DAGGER_KNIFE                                          0x1F5E1
#define unicode_LIPS                                                  0x1F5E2
#define unicode_SPEAKING_HEAD_IN_SILHOUETTE                           0x1F5E3
#define unicode_THREE_RAYS_ABOVE                                      0x1F5E4
#define unicode_THREE_RAYS_BELOW                                      0x1F5E5
#define unicode_THREE_RAYS_LEFT                                       0x1F5E6
#define unicode_THREE_RAYS_RIGHT                                      0x1F5E7
#define unicode_LEFT_SPEECH_BUBBLE                                    0x1F5E8
#define unicode_RIGHT_SPEECH_BUBBLE                                   0x1F5E9
#define unicode_TWO_SPEECH_BUBBLES                                    0x1F5EA
#define unicode_THREE_SPEECH_BUBBLES                                  0x1F5EB
#define unicode_LEFT_THOUGHT_BUBBLE                                   0x1F5EC
#define unicode_RIGHT_THOUGHT_BUBBLE                                  0x1F5ED
#define unicode_LEFT_ANGER_BUBBLE                                     0x1F5EE
#define unicode_RIGHT_ANGER_BUBBLE                                    0x1F5EF
#define unicode_MOOD_BUBBLE                                           0x1F5F0
#define unicode_LIGHTNING_MOOD_BUBBLE                                 0x1F5F1
#define unicode_LIGHTNING_MOOD                                        0x1F5F2
#define unicode_BALLOT_BOX_WITH_BALLOT                                0x1F5F3
#define unicode_BALLOT_SCRIPT_X                                       0x1F5F4
#define unicode_BALLOT_BOX_WITH_SCRIPT_X                              0x1F5F5
#define unicode_BALLOT_BOLD_SCRIPT_X                                  0x1F5F6
#define unicode_BALLOT_BOX_WITH_BOLD_SCRIPT_X                         0x1F5F7
#define unicode_LIGHT_CHECK_MARK                                      0x1F5F8
#define unicode_BALLOT_BOX_WITH_BOLD_CHECK                            0x1F5F9
#define unicode_WORLD_MAP                                             0x1F5FA
#define unicode_MOUNT_FUJI                                            0x1F5FB
#define unicode_TOKYO_TOWER                                           0x1F5FC
#define unicode_STATUE_OF_LIBERTY                                     0x1F5FD
#define unicode_SILHOUETTE_OF_JAPAN                                   0x1F5FE
#define unicode_MOYAI                                                 0x1F5FF
#define unicode_GRINNING_FACE                                         0x1F600
#define unicode_GRINNING_FACE_WITH_SMILING_EYES                       0x1F601
#define unicode_FACE_WITH_TEARS_OF_JOY                                0x1F602
#define unicode_SMILING_FACE_WITH_OPEN_MOUTH                          0x1F603
#define unicode_SMILING_FACE_WITH_OPEN_MOUTH_AND_SMILING_EYES         0x1F604
#define unicode_SMILING_FACE_WITH_OPEN_MOUTH_AND_COLD_SWEAT           0x1F605
#define unicode_SMILING_FACE_WITH_OPEN_MOUTH_AND_TIGHTLY_CLOSED_EYES  0x1F606
#define unicode_SMILING_FACE_WITH_HALO                                0x1F607
#define unicode_SMILING_FACE_WITH_HORNS                               0x1F608
#define unicode_WINKING_FACE                                          0x1F609
#define unicode_SMILING_FACE_WITH_SMILING_EYES                        0x1F60A
#define unicode_FACE_SAVOURING_DELICIOUS_FOOD                         0x1F60B
#define unicode_RELIEVED_FACE                                         0x1F60C
#define unicode_SMILING_FACE_WITH_HEART_SHAPED_EYES                   0x1F60D
#define unicode_SMILING_FACE_WITH_SUNGLASSES                          0x1F60E
#define unicode_SMIRKING_FACE                                         0x1F60F
#define unicode_NEUTRAL_FACE                                          0x1F610
#define unicode_EXPRESSIONLESS_FACE                                   0x1F611
#define unicode_UNAMUSED_FACE                                         0x1F612
#define unicode_FACE_WITH_COLD_SWEAT                                  0x1F613
#define unicode_PENSIVE_FACE                                          0x1F614
#define unicode_CONFUSED_FACE                                         0x1F615
#define unicode_CONFOUNDED_FACE                                       0x1F616
#define unicode_KISSING_FACE                                          0x1F617
#define unicode_FACE_THROWING_A_KISS                                  0x1F618
#define unicode_KISSING_FACE_WITH_SMILING_EYES                        0x1F619
#define unicode_KISSING_FACE_WITH_CLOSED_EYES                         0x1F61A
#define unicode_FACE_WITH_STUCK_OUT_TONGUE                            0x1F61B
#define unicode_FACE_WITH_STUCK_OUT_TONGUE_AND_WINKING_EYE            0x1F61C
#define unicode_FACE_WITH_STUCK_OUT_TONGUE_AND_TIGHTLY_CLOSED_EYES    0x1F61D
#define unicode_DISAPPOINTED_FACE                                     0x1F61E
#define unicode_WORRIED_FACE                                          0x1F61F
#define unicode_ANGRY_FACE                                            0x1F620
#define unicode_POUTING_FACE                                          0x1F621
#define unicode_CRYING_FACE                                           0x1F622
#define unicode_PERSEVERING_FACE                                      0x1F623
#define unicode_FACE_WITH_LOOK_OF_TRIUMPH                             0x1F624
#define unicode_DISAPPOINTED_BUT_RELIEVED_FACE                        0x1F625
#define unicode_FROWNING_FACE_WITH_OPEN_MOUTH                         0x1F626
#define unicode_ANGUISHED_FACE                                        0x1F627
#define unicode_FEARFUL_FACE                                          0x1F628
#define unicode_WEARY_FACE                                            0x1F629
#define unicode_SLEEPY_FACE                                           0x1F62A
#define unicode_TIRED_FACE                                            0x1F62B
#define unicode_GRIMACING_FACE                                        0x1F62C
#define unicode_LOUDLY_CRYING_FACE                                    0x1F62D
#define unicode_FACE_WITH_OPEN_MOUTH                                  0x1F62E
#define unicode_HUSHED_FACE                                           0x1F62F
#define unicode_FACE_WITH_OPEN_MOUTH_AND_COLD_SWEAT                   0x1F630
#define unicode_FACE_SCREAMING_IN_FEAR                                0x1F631
#define unicode_ASTONISHED_FACE                                       0x1F632
#define unicode_FLUSHED_FACE                                          0x1F633
#define unicode_SLEEPING_FACE                                         0x1F634
#define unicode_DIZZY_FACE                                            0x1F635
#define unicode_FACE_WITHOUT_MOUTH                                    0x1F636
#define unicode_FACE_WITH_MEDICAL_MASK                                0x1F637
#define unicode_GRINNING_CAT_FACE_WITH_SMILING_EYES                   0x1F638
#define unicode_CAT_FACE_WITH_TEARS_OF_JOY                            0x1F639
#define unicode_SMILING_CAT_FACE_WITH_OPEN_MOUTH                      0x1F63A
#define unicode_SMILING_CAT_FACE_WITH_HEART_SHAPED_EYES               0x1F63B
#define unicode_CAT_FACE_WITH_WRY_SMILE                               0x1F63C
#define unicode_KISSING_CAT_FACE_WITH_CLOSED_EYES                     0x1F63D
#define unicode_POUTING_CAT_FACE                                      0x1F63E
#define unicode_CRYING_CAT_FACE                                       0x1F63F
#define unicode_WEARY_CAT_FACE                                        0x1F640
#define unicode_SLIGHTLY_FROWNING_FACE                                0x1F641
#define unicode_SLIGHTLY_SMILING_FACE                                 0x1F642
#define unicode_FACE_WITH_NO_GOOD_GESTURE                             0x1F645
#define unicode_FACE_WITH_OK_GESTURE                                  0x1F646
#define unicode_PERSON_BOWING_DEEPLY                                  0x1F647
#define unicode_SEE_NO_EVIL_MONKEY                                    0x1F648
#define unicode_HEAR_NO_EVIL_MONKEY                                   0x1F649
#define unicode_SPEAK_NO_EVIL_MONKEY                                  0x1F64A
#define unicode_HAPPY_PERSON_RAISING_ONE_HAND                         0x1F64B
#define unicode_PERSON_RAISING_BOTH_HANDS_IN_CELEBRATION              0x1F64C
#define unicode_PERSON_FROWNING                                       0x1F64D
#define unicode_PERSON_WITH_POUTING_FACE                              0x1F64E
#define unicode_PERSON_WITH_FOLDED_HANDS                              0x1F64F
#define unicode_NORTH_WEST_POINTING_LEAF                              0x1F650
#define unicode_SOUTH_WEST_POINTING_LEAF                              0x1F651
#define unicode_NORTH_EAST_POINTING_LEAF                              0x1F652
#define unicode_SOUTH_EAST_POINTING_LEAF                              0x1F653
#define unicode_TURNED_NORTH_WEST_POINTING_LEAF                       0x1F654
#define unicode_TURNED_SOUTH_WEST_POINTING_LEAF                       0x1F655
#define unicode_TURNED_NORTH_EAST_POINTING_LEAF                       0x1F656
#define unicode_TURNED_SOUTH_EAST_POINTING_LEAF                       0x1F657
#define unicode_NORTH_WEST_POINTING_VINE_LEAF                         0x1F658
#define unicode_SOUTH_WEST_POINTING_VINE_LEAF                         0x1F659
#define unicode_NORTH_EAST_POINTING_VINE_LEAF                         0x1F65A
#define unicode_SOUTH_EAST_POINTING_VINE_LEAF                         0x1F65B
#define unicode_HEAVY_NORTH_WEST_POINTING_VINE_LEAF                   0x1F65C
#define unicode_HEAVY_SOUTH_WEST_POINTING_VINE_LEAF                   0x1F65D
#define unicode_HEAVY_NORTH_EAST_POINTING_VINE_LEAF                   0x1F65E
#define unicode_HEAVY_SOUTH_EAST_POINTING_VINE_LEAF                   0x1F65F
#define unicode_NORTH_WEST_POINTING_BUD                               0x1F660
#define unicode_SOUTH_WEST_POINTING_BUD                               0x1F661
#define unicode_NORTH_EAST_POINTING_BUD                               0x1F662
#define unicode_SOUTH_EAST_POINTING_BUD                               0x1F663
#define unicode_HEAVY_NORTH_WEST_POINTING_BUD                         0x1F664
#define unicode_HEAVY_SOUTH_WEST_POINTING_BUD                         0x1F665
#define unicode_HEAVY_NORTH_EAST_POINTING_BUD                         0x1F666
#define unicode_HEAVY_SOUTH_EAST_POINTING_BUD                         0x1F667
#define unicode_HOLLOW_QUILT_SQUARE_ORNAMENT                          0x1F668
#define unicode_HOLLOW_QUILT_SQUARE_ORNAMENT_IN_BLACK_SQUARE          0x1F669
#define unicode_SOLID_QUILT_SQUARE_ORNAMENT                           0x1F66A
#define unicode_SOLID_QUILT_SQUARE_ORNAMENT_IN_BLACK_SQUARE           0x1F66B
#define unicode_LEFTWARDS_ROCKET                                      0x1F66C
#define unicode_UPWARDS_ROCKET                                        0x1F66D
#define unicode_RIGHTWARDS_ROCKET                                     0x1F66E
#define unicode_DOWNWARDS_ROCKET                                      0x1F66F
#define unicode_SCRIPT_LIGATURE_ET_ORNAMENT                           0x1F670
#define unicode_HEAVY_SCRIPT_LIGATURE_ET_ORNAMENT                     0x1F671
#define unicode_LIGATURE_OPEN_ET_ORNAMENT                             0x1F672
#define unicode_HEAVY_LIGATURE_OPEN_ET_ORNAMENT                       0x1F673
#define unicode_HEAVY_AMPERSAND_ORNAMENT                              0x1F674
#define unicode_SWASH_AMPERSAND_ORNAMENT                              0x1F675
#define unicode_SANS_SERIF_HEAVY_DOUBLE_TURNED_COMMA_QUOTATION_MARK_ORNAMENT 0x1F676
#define unicode_SANS_SERIF_HEAVY_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT 0x1F677
#define unicode_SANS_SERIF_HEAVY_LOW_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT 0x1F678
#define unicode_HEAVY_INTERROBANG_ORNAMENT                            0x1F679
#define unicode_SANS_SERIF_INTERROBANG_ORNAMENT                       0x1F67A
#define unicode_HEAVY_SANS_SERIF_INTERROBANG_ORNAMENT                 0x1F67B
#define unicode_VERY_HEAVY_SOLIDUS                                    0x1F67C
#define unicode_VERY_HEAVY_REVERSE_SOLIDUS                            0x1F67D
#define unicode_CHECKER_BOARD                                         0x1F67E
#define unicode_REVERSE_CHECKER_BOARD                                 0x1F67F
#define unicode_ROCKET                                                0x1F680
#define unicode_HELICOPTER                                            0x1F681
#define unicode_STEAM_LOCOMOTIVE                                      0x1F682
#define unicode_RAILWAY_CAR                                           0x1F683
#define unicode_HIGH_SPEED_TRAIN                                      0x1F684
#define unicode_HIGH_SPEED_TRAIN_WITH_BULLET_NOSE                     0x1F685
#define unicode_TRAIN                                                 0x1F686
#define unicode_METRO                                                 0x1F687
#define unicode_LIGHT_RAIL                                            0x1F688
#define unicode_STATION                                               0x1F689
#define unicode_TRAM                                                  0x1F68A
#define unicode_TRAM_CAR                                              0x1F68B
#define unicode_BUS                                                   0x1F68C
#define unicode_ONCOMING_BUS                                          0x1F68D
#define unicode_TROLLEYBUS                                            0x1F68E
#define unicode_BUS_STOP                                              0x1F68F
#define unicode_MINIBUS                                               0x1F690
#define unicode_AMBULANCE                                             0x1F691
#define unicode_FIRE_ENGINE                                           0x1F692
#define unicode_POLICE_CAR                                            0x1F693
#define unicode_ONCOMING_POLICE_CAR                                   0x1F694
#define unicode_TAXI                                                  0x1F695
#define unicode_ONCOMING_TAXI                                         0x1F696
#define unicode_AUTOMOBILE                                            0x1F697
#define unicode_ONCOMING_AUTOMOBILE                                   0x1F698
#define unicode_RECREATIONAL_VEHICLE                                  0x1F699
#define unicode_DELIVERY_TRUCK                                        0x1F69A
#define unicode_ARTICULATED_LORRY                                     0x1F69B
#define unicode_TRACTOR                                               0x1F69C
#define unicode_MONORAIL                                              0x1F69D
#define unicode_MOUNTAIN_RAILWAY                                      0x1F69E
#define unicode_SUSPENSION_RAILWAY                                    0x1F69F
#define unicode_MOUNTAIN_CABLEWAY                                     0x1F6A0
#define unicode_AERIAL_TRAMWAY                                        0x1F6A1
#define unicode_SHIP                                                  0x1F6A2
#define unicode_ROWBOAT                                               0x1F6A3
#define unicode_SPEEDBOAT                                             0x1F6A4
#define unicode_HORIZONTAL_TRAFFIC_LIGHT                              0x1F6A5
#define unicode_VERTICAL_TRAFFIC_LIGHT                                0x1F6A6
#define unicode_CONSTRUCTION_SIGN                                     0x1F6A7
#define unicode_POLICE_CARS_REVOLVING_LIGHT                           0x1F6A8
#define unicode_TRIANGULAR_FLAG_ON_POST                               0x1F6A9
#define unicode_DOOR                                                  0x1F6AA
#define unicode_NO_ENTRY_SIGN                                         0x1F6AB
#define unicode_SMOKING_SYMBOL                                        0x1F6AC
#define unicode_NO_SMOKING_SYMBOL                                     0x1F6AD
#define unicode_PUT_LITTER_IN_ITS_PLACE_SYMBOL                        0x1F6AE
#define unicode_DO_NOT_LITTER_SYMBOL                                  0x1F6AF
#define unicode_POTABLE_WATER_SYMBOL                                  0x1F6B0
#define unicode_NON_POTABLE_WATER_SYMBOL                              0x1F6B1
#define unicode_BICYCLE                                               0x1F6B2
#define unicode_NO_BICYCLES                                           0x1F6B3
#define unicode_BICYCLIST                                             0x1F6B4
#define unicode_MOUNTAIN_BICYCLIST                                    0x1F6B5
#define unicode_PEDESTRIAN                                            0x1F6B6
#define unicode_NO_PEDESTRIANS                                        0x1F6B7
#define unicode_CHILDREN_CROSSING                                     0x1F6B8
#define unicode_MENS_SYMBOL                                           0x1F6B9
#define unicode_WOMENS_SYMBOL                                         0x1F6BA
#define unicode_RESTROOM                                              0x1F6BB
#define unicode_BABY_SYMBOL                                           0x1F6BC
#define unicode_TOILET                                                0x1F6BD
#define unicode_WATER_CLOSET                                          0x1F6BE
#define unicode_SHOWER                                                0x1F6BF
#define unicode_BATH                                                  0x1F6C0
#define unicode_BATHTUB                                               0x1F6C1
#define unicode_PASSPORT_CONTROL                                      0x1F6C2
#define unicode_CUSTOMS                                               0x1F6C3
#define unicode_BAGGAGE_CLAIM                                         0x1F6C4
#define unicode_LEFT_LUGGAGE                                          0x1F6C5
#define unicode_TRIANGLE_WITH_ROUNDED_CORNERS                         0x1F6C6
#define unicode_PROHIBITED_SIGN                                       0x1F6C7
#define unicode_CIRCLED_INFORMATION_SOURCE                            0x1F6C8
#define unicode_BOYS_SYMBOL                                           0x1F6C9
#define unicode_GIRLS_SYMBOL                                          0x1F6CA
#define unicode_COUCH_AND_LAMP                                        0x1F6CB
#define unicode_SLEEPING_ACCOMMODATION                                0x1F6CC
#define unicode_SHOPPING_BAGS                                         0x1F6CD
#define unicode_BELLHOP_BELL                                          0x1F6CE
#define unicode_BED                                                   0x1F6CF
#define unicode_HAMMER_AND_WRENCH                                     0x1F6E0
#define unicode_SHIELD                                                0x1F6E1
#define unicode_OIL_DRUM                                              0x1F6E2
#define unicode_MOTORWAY                                              0x1F6E3
#define unicode_RAILWAY_TRACK                                         0x1F6E4
#define unicode_MOTOR_BOAT                                            0x1F6E5
#define unicode_UP_POINTING_MILITARY_AIRPLANE                         0x1F6E6
#define unicode_UP_POINTING_AIRPLANE                                  0x1F6E7
#define unicode_UP_POINTING_SMALL_AIRPLANE                            0x1F6E8
#define unicode_SMALL_AIRPLANE                                        0x1F6E9
#define unicode_NORTHEAST_POINTING_AIRPLANE                           0x1F6EA
#define unicode_AIRPLANE_DEPARTURE                                    0x1F6EB
#define unicode_AIRPLANE_ARRIVING                                     0x1F6EC
#define unicode_SATELLITE                                             0x1F6F0
#define unicode_ONCOMING_FIRE_ENGINE                                  0x1F6F1
#define unicode_DIESEL_LOCOMOTIVE                                     0x1F6F2
#define unicode_PASSENGER_SHIP                                        0x1F6F3
#define unicode_ALCHEMICAL_SYMBOL_FOR_QUINTESSENCE                    0x1F700
#define unicode_ALCHEMICAL_SYMBOL_FOR_AIR                             0x1F701
#define unicode_ALCHEMICAL_SYMBOL_FOR_FIRE                            0x1F702
#define unicode_ALCHEMICAL_SYMBOL_FOR_EARTH                           0x1F703
#define unicode_ALCHEMICAL_SYMBOL_FOR_WATER                           0x1F704
#define unicode_ALCHEMICAL_SYMBOL_FOR_AQUAFORTIS                      0x1F705
#define unicode_ALCHEMICAL_SYMBOL_FOR_AQUA_REGIA                      0x1F706
#define unicode_ALCHEMICAL_SYMBOL_FOR_AQUA_REGIA_2                    0x1F707
#define unicode_ALCHEMICAL_SYMBOL_FOR_AQUA_VITAE                      0x1F708
#define unicode_ALCHEMICAL_SYMBOL_FOR_AQUA_VITAE_2                    0x1F709
#define unicode_ALCHEMICAL_SYMBOL_FOR_VINEGAR                         0x1F70A
#define unicode_ALCHEMICAL_SYMBOL_FOR_VINEGAR_2                       0x1F70B
#define unicode_ALCHEMICAL_SYMBOL_FOR_VINEGAR_3                       0x1F70C
#define unicode_ALCHEMICAL_SYMBOL_FOR_SULFUR                          0x1F70D
#define unicode_ALCHEMICAL_SYMBOL_FOR_PHILOSOPHERS_SULFUR             0x1F70E
#define unicode_ALCHEMICAL_SYMBOL_FOR_BLACK_SULFUR                    0x1F70F
#define unicode_ALCHEMICAL_SYMBOL_FOR_MERCURY_SUBLIMATE               0x1F710
#define unicode_ALCHEMICAL_SYMBOL_FOR_MERCURY_SUBLIMATE_2             0x1F711
#define unicode_ALCHEMICAL_SYMBOL_FOR_MERCURY_SUBLIMATE_3             0x1F712
#define unicode_ALCHEMICAL_SYMBOL_FOR_CINNABAR                        0x1F713
#define unicode_ALCHEMICAL_SYMBOL_FOR_SALT                            0x1F714
#define unicode_ALCHEMICAL_SYMBOL_FOR_NITRE                           0x1F715
#define unicode_ALCHEMICAL_SYMBOL_FOR_VITRIOL                         0x1F716
#define unicode_ALCHEMICAL_SYMBOL_FOR_VITRIOL_2                       0x1F717
#define unicode_ALCHEMICAL_SYMBOL_FOR_ROCK_SALT                       0x1F718
#define unicode_ALCHEMICAL_SYMBOL_FOR_ROCK_SALT_2                     0x1F719
#define unicode_ALCHEMICAL_SYMBOL_FOR_GOLD                            0x1F71A
#define unicode_ALCHEMICAL_SYMBOL_FOR_SILVER                          0x1F71B
#define unicode_ALCHEMICAL_SYMBOL_FOR_IRON_ORE                        0x1F71C
#define unicode_ALCHEMICAL_SYMBOL_FOR_IRON_ORE_2                      0x1F71D
#define unicode_ALCHEMICAL_SYMBOL_FOR_CROCUS_OF_IRON                  0x1F71E
#define unicode_ALCHEMICAL_SYMBOL_FOR_REGULUS_OF_IRON                 0x1F71F
#define unicode_ALCHEMICAL_SYMBOL_FOR_COPPER_ORE                      0x1F720
#define unicode_ALCHEMICAL_SYMBOL_FOR_IRON_COPPER_ORE                 0x1F721
#define unicode_ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_COPPER             0x1F722
#define unicode_ALCHEMICAL_SYMBOL_FOR_CROCUS_OF_COPPER                0x1F723
#define unicode_ALCHEMICAL_SYMBOL_FOR_CROCUS_OF_COPPER_2              0x1F724
#define unicode_ALCHEMICAL_SYMBOL_FOR_COPPER_ANTIMONIATE              0x1F725
#define unicode_ALCHEMICAL_SYMBOL_FOR_SALT_OF_COPPER_ANTIMONIATE      0x1F726
#define unicode_ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_SALT_OF_COPPER     0x1F727
#define unicode_ALCHEMICAL_SYMBOL_FOR_VERDIGRIS                       0x1F728
#define unicode_ALCHEMICAL_SYMBOL_FOR_TIN_ORE                         0x1F729
#define unicode_ALCHEMICAL_SYMBOL_FOR_LEAD_ORE                        0x1F72A
#define unicode_ALCHEMICAL_SYMBOL_FOR_ANTIMONY_ORE                    0x1F72B
#define unicode_ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_ANTIMONY           0x1F72C
#define unicode_ALCHEMICAL_SYMBOL_FOR_SALT_OF_ANTIMONY                0x1F72D
#define unicode_ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_SALT_OF_ANTIMONY   0x1F72E
#define unicode_ALCHEMICAL_SYMBOL_FOR_VINEGAR_OF_ANTIMONY             0x1F72F
#define unicode_ALCHEMICAL_SYMBOL_FOR_REGULUS_OF_ANTIMONY             0x1F730
#define unicode_ALCHEMICAL_SYMBOL_FOR_REGULUS_OF_ANTIMONY_2           0x1F731
#define unicode_ALCHEMICAL_SYMBOL_FOR_REGULUS                         0x1F732
#define unicode_ALCHEMICAL_SYMBOL_FOR_REGULUS_2                       0x1F733
#define unicode_ALCHEMICAL_SYMBOL_FOR_REGULUS_3                       0x1F734
#define unicode_ALCHEMICAL_SYMBOL_FOR_REGULUS_4                       0x1F735
#define unicode_ALCHEMICAL_SYMBOL_FOR_ALKALI                          0x1F736
#define unicode_ALCHEMICAL_SYMBOL_FOR_ALKALI_2                        0x1F737
#define unicode_ALCHEMICAL_SYMBOL_FOR_MARCASITE                       0x1F738
#define unicode_ALCHEMICAL_SYMBOL_FOR_SAL_AMMONIAC                    0x1F739
#define unicode_ALCHEMICAL_SYMBOL_FOR_ARSENIC                         0x1F73A
#define unicode_ALCHEMICAL_SYMBOL_FOR_REALGAR                         0x1F73B
#define unicode_ALCHEMICAL_SYMBOL_FOR_REALGAR_2                       0x1F73C
#define unicode_ALCHEMICAL_SYMBOL_FOR_AURIPIGMENT                     0x1F73D
#define unicode_ALCHEMICAL_SYMBOL_FOR_BISMUTH_ORE                     0x1F73E
#define unicode_ALCHEMICAL_SYMBOL_FOR_TARTAR                          0x1F73F
#define unicode_ALCHEMICAL_SYMBOL_FOR_TARTAR_2                        0x1F740
#define unicode_ALCHEMICAL_SYMBOL_FOR_QUICK_LIME                      0x1F741
#define unicode_ALCHEMICAL_SYMBOL_FOR_BORAX                           0x1F742
#define unicode_ALCHEMICAL_SYMBOL_FOR_BORAX_2                         0x1F743
#define unicode_ALCHEMICAL_SYMBOL_FOR_BORAX_3                         0x1F744
#define unicode_ALCHEMICAL_SYMBOL_FOR_ALUM                            0x1F745
#define unicode_ALCHEMICAL_SYMBOL_FOR_OIL                             0x1F746
#define unicode_ALCHEMICAL_SYMBOL_FOR_SPIRIT                          0x1F747
#define unicode_ALCHEMICAL_SYMBOL_FOR_TINCTURE                        0x1F748
#define unicode_ALCHEMICAL_SYMBOL_FOR_GUM                             0x1F749
#define unicode_ALCHEMICAL_SYMBOL_FOR_WAX                             0x1F74A
#define unicode_ALCHEMICAL_SYMBOL_FOR_POWDER                          0x1F74B
#define unicode_ALCHEMICAL_SYMBOL_FOR_CALX                            0x1F74C
#define unicode_ALCHEMICAL_SYMBOL_FOR_TUTTY                           0x1F74D
#define unicode_ALCHEMICAL_SYMBOL_FOR_CAPUT_MORTUUM                   0x1F74E
#define unicode_ALCHEMICAL_SYMBOL_FOR_SCEPTER_OF_JOVE                 0x1F74F
#define unicode_ALCHEMICAL_SYMBOL_FOR_CADUCEUS                        0x1F750
#define unicode_ALCHEMICAL_SYMBOL_FOR_TRIDENT                         0x1F751
#define unicode_ALCHEMICAL_SYMBOL_FOR_STARRED_TRIDENT                 0x1F752
#define unicode_ALCHEMICAL_SYMBOL_FOR_LODESTONE                       0x1F753
#define unicode_ALCHEMICAL_SYMBOL_FOR_SOAP                            0x1F754
#define unicode_ALCHEMICAL_SYMBOL_FOR_URINE                           0x1F755
#define unicode_ALCHEMICAL_SYMBOL_FOR_HORSE_DUNG                      0x1F756
#define unicode_ALCHEMICAL_SYMBOL_FOR_ASHES                           0x1F757
#define unicode_ALCHEMICAL_SYMBOL_FOR_POT_ASHES                       0x1F758
#define unicode_ALCHEMICAL_SYMBOL_FOR_BRICK                           0x1F759
#define unicode_ALCHEMICAL_SYMBOL_FOR_POWDERED_BRICK                  0x1F75A
#define unicode_ALCHEMICAL_SYMBOL_FOR_AMALGAM                         0x1F75B
#define unicode_ALCHEMICAL_SYMBOL_FOR_STRATUM_SUPER_STRATUM           0x1F75C
#define unicode_ALCHEMICAL_SYMBOL_FOR_STRATUM_SUPER_STRATUM_2         0x1F75D
#define unicode_ALCHEMICAL_SYMBOL_FOR_SUBLIMATION                     0x1F75E
#define unicode_ALCHEMICAL_SYMBOL_FOR_PRECIPITATE                     0x1F75F
#define unicode_ALCHEMICAL_SYMBOL_FOR_DISTILL                         0x1F760
#define unicode_ALCHEMICAL_SYMBOL_FOR_DISSOLVE                        0x1F761
#define unicode_ALCHEMICAL_SYMBOL_FOR_DISSOLVE_2                      0x1F762
#define unicode_ALCHEMICAL_SYMBOL_FOR_PURIFY                          0x1F763
#define unicode_ALCHEMICAL_SYMBOL_FOR_PUTREFACTION                    0x1F764
#define unicode_ALCHEMICAL_SYMBOL_FOR_CRUCIBLE                        0x1F765
#define unicode_ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_2                      0x1F766
#define unicode_ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_3                      0x1F767
#define unicode_ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_4                      0x1F768
#define unicode_ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_5                      0x1F769
#define unicode_ALCHEMICAL_SYMBOL_FOR_ALEMBIC                         0x1F76A
#define unicode_ALCHEMICAL_SYMBOL_FOR_BATH_OF_MARY                    0x1F76B
#define unicode_ALCHEMICAL_SYMBOL_FOR_BATH_OF_VAPOURS                 0x1F76C
#define unicode_ALCHEMICAL_SYMBOL_FOR_RETORT                          0x1F76D
#define unicode_ALCHEMICAL_SYMBOL_FOR_HOUR                            0x1F76E
#define unicode_ALCHEMICAL_SYMBOL_FOR_NIGHT                           0x1F76F
#define unicode_ALCHEMICAL_SYMBOL_FOR_DAY_NIGHT                       0x1F770
#define unicode_ALCHEMICAL_SYMBOL_FOR_MONTH                           0x1F771
#define unicode_ALCHEMICAL_SYMBOL_FOR_HALF_DRAM                       0x1F772
#define unicode_ALCHEMICAL_SYMBOL_FOR_HALF_OUNCE                      0x1F773
#define unicode_BLACK_LEFT_POINTING_ISOSCELES_RIGHT_TRIANGLE          0x1F780
#define unicode_BLACK_UP_POINTING_ISOSCELES_RIGHT_TRIANGLE            0x1F781
#define unicode_BLACK_RIGHT_POINTING_ISOSCELES_RIGHT_TRIANGLE         0x1F782
#define unicode_BLACK_DOWN_POINTING_ISOSCELES_RIGHT_TRIANGLE          0x1F783
#define unicode_BLACK_SLIGHTLY_SMALL_CIRCLE                           0x1F784
#define unicode_MEDIUM_BOLD_WHITE_CIRCLE                              0x1F785
#define unicode_BOLD_WHITE_CIRCLE                                     0x1F786
#define unicode_HEAVY_WHITE_CIRCLE                                    0x1F787
#define unicode_VERY_HEAVY_WHITE_CIRCLE                               0x1F788
#define unicode_EXTREMELY_HEAVY_WHITE_CIRCLE                          0x1F789
#define unicode_WHITE_CIRCLE_CONTAINING_BLACK_SMALL_CIRCLE            0x1F78A
#define unicode_ROUND_TARGET                                          0x1F78B
#define unicode_BLACK_TINY_SQUARE                                     0x1F78C
#define unicode_BLACK_SLIGHTLY_SMALL_SQUARE                           0x1F78D
#define unicode_LIGHT_WHITE_SQUARE                                    0x1F78E
#define unicode_MEDIUM_WHITE_SQUARE                                   0x1F78F
#define unicode_BOLD_WHITE_SQUARE                                     0x1F790
#define unicode_HEAVY_WHITE_SQUARE                                    0x1F791
#define unicode_VERY_HEAVY_WHITE_SQUARE                               0x1F792
#define unicode_EXTREMELY_HEAVY_WHITE_SQUARE                          0x1F793
#define unicode_WHITE_SQUARE_CONTAINING_BLACK_VERY_SMALL_SQUARE       0x1F794
#define unicode_WHITE_SQUARE_CONTAINING_BLACK_MEDIUM_SQUARE           0x1F795
#define unicode_SQUARE_TARGET                                         0x1F796
#define unicode_BLACK_TINY_DIAMOND                                    0x1F797
#define unicode_BLACK_VERY_SMALL_DIAMOND                              0x1F798
#define unicode_BLACK_MEDIUM_SMALL_DIAMOND                            0x1F799
#define unicode_WHITE_DIAMOND_CONTAINING_BLACK_VERY_SMALL_DIAMOND     0x1F79A
#define unicode_WHITE_DIAMOND_CONTAINING_BLACK_MEDIUM_DIAMOND         0x1F79B
#define unicode_DIAMOND_TARGET                                        0x1F79C
#define unicode_BLACK_TINY_LOZENGE                                    0x1F79D
#define unicode_BLACK_VERY_SMALL_LOZENGE                              0x1F79E
#define unicode_BLACK_MEDIUM_SMALL_LOZENGE                            0x1F79F
#define unicode_WHITE_LOZENGE_CONTAINING_BLACK_SMALL_LOZENGE          0x1F7A0
#define unicode_THIN_GREEK_CROSS                                      0x1F7A1
#define unicode_LIGHT_GREEK_CROSS                                     0x1F7A2
#define unicode_MEDIUM_GREEK_CROSS                                    0x1F7A3
#define unicode_BOLD_GREEK_CROSS                                      0x1F7A4
#define unicode_VERY_BOLD_GREEK_CROSS                                 0x1F7A5
#define unicode_VERY_HEAVY_GREEK_CROSS                                0x1F7A6
#define unicode_EXTREMELY_HEAVY_GREEK_CROSS                           0x1F7A7
#define unicode_THIN_SALTIRE                                          0x1F7A8
#define unicode_LIGHT_SALTIRE                                         0x1F7A9
#define unicode_MEDIUM_SALTIRE                                        0x1F7AA
#define unicode_BOLD_SALTIRE                                          0x1F7AB
#define unicode_HEAVY_SALTIRE                                         0x1F7AC
#define unicode_VERY_HEAVY_SALTIRE                                    0x1F7AD
#define unicode_EXTREMELY_HEAVY_SALTIRE                               0x1F7AE
#define unicode_LIGHT_FIVE_SPOKED_ASTERISK                            0x1F7AF
#define unicode_MEDIUM_FIVE_SPOKED_ASTERISK                           0x1F7B0
#define unicode_BOLD_FIVE_SPOKED_ASTERISK                             0x1F7B1
#define unicode_HEAVY_FIVE_SPOKED_ASTERISK                            0x1F7B2
#define unicode_VERY_HEAVY_FIVE_SPOKED_ASTERISK                       0x1F7B3
#define unicode_EXTREMELY_HEAVY_FIVE_SPOKED_ASTERISK                  0x1F7B4
#define unicode_LIGHT_SIX_SPOKED_ASTERISK                             0x1F7B5
#define unicode_MEDIUM_SIX_SPOKED_ASTERISK                            0x1F7B6
#define unicode_BOLD_SIX_SPOKED_ASTERISK                              0x1F7B7
#define unicode_HEAVY_SIX_SPOKED_ASTERISK                             0x1F7B8
#define unicode_VERY_HEAVY_SIX_SPOKED_ASTERISK                        0x1F7B9
#define unicode_EXTREMELY_HEAVY_SIX_SPOKED_ASTERISK                   0x1F7BA
#define unicode_LIGHT_EIGHT_SPOKED_ASTERISK                           0x1F7BB
#define unicode_MEDIUM_EIGHT_SPOKED_ASTERISK                          0x1F7BC
#define unicode_BOLD_EIGHT_SPOKED_ASTERISK                            0x1F7BD
#define unicode_HEAVY_EIGHT_SPOKED_ASTERISK                           0x1F7BE
#define unicode_VERY_HEAVY_EIGHT_SPOKED_ASTERISK                      0x1F7BF
#define unicode_LIGHT_THREE_POINTED_BLACK_STAR                        0x1F7C0
#define unicode_MEDIUM_THREE_POINTED_BLACK_STAR                       0x1F7C1
#define unicode_THREE_POINTED_BLACK_STAR                              0x1F7C2
#define unicode_MEDIUM_THREE_POINTED_PINWHEEL_STAR                    0x1F7C3
#define unicode_LIGHT_FOUR_POINTED_BLACK_STAR                         0x1F7C4
#define unicode_MEDIUM_FOUR_POINTED_BLACK_STAR                        0x1F7C5
#define unicode_FOUR_POINTED_BLACK_STAR                               0x1F7C6
#define unicode_MEDIUM_FOUR_POINTED_PINWHEEL_STAR                     0x1F7C7
#define unicode_REVERSE_LIGHT_FOUR_POINTED_PINWHEEL_STAR              0x1F7C8
#define unicode_LIGHT_FIVE_POINTED_BLACK_STAR                         0x1F7C9
#define unicode_HEAVY_FIVE_POINTED_BLACK_STAR                         0x1F7CA
#define unicode_MEDIUM_SIX_POINTED_BLACK_STAR                         0x1F7CB
#define unicode_HEAVY_SIX_POINTED_BLACK_STAR                          0x1F7CC
#define unicode_SIX_POINTED_PINWHEEL_STAR                             0x1F7CD
#define unicode_MEDIUM_EIGHT_POINTED_BLACK_STAR                       0x1F7CE
#define unicode_HEAVY_EIGHT_POINTED_BLACK_STAR                        0x1F7CF
#define unicode_VERY_HEAVY_EIGHT_POINTED_BLACK_STAR                   0x1F7D0
#define unicode_HEAVY_EIGHT_POINTED_PINWHEEL_STAR                     0x1F7D1
#define unicode_LIGHT_TWELVE_POINTED_BLACK_STAR                       0x1F7D2
#define unicode_HEAVY_TWELVE_POINTED_BLACK_STAR                       0x1F7D3
#define unicode_HEAVY_TWELVE_POINTED_PINWHEEL_STAR                    0x1F7D4
#define unicode_LEFTWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD         0x1F800
#define unicode_UPWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD           0x1F801
#define unicode_RIGHTWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD        0x1F802
#define unicode_DOWNWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD         0x1F803
#define unicode_LEFTWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD        0x1F804
#define unicode_UPWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD          0x1F805
#define unicode_RIGHTWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD       0x1F806
#define unicode_DOWNWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD        0x1F807
#define unicode_LEFTWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD         0x1F808
#define unicode_UPWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD           0x1F809
#define unicode_RIGHTWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD        0x1F80A
#define unicode_DOWNWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD         0x1F80B
#define unicode_LEFTWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD      0x1F810
#define unicode_UPWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD        0x1F811
#define unicode_RIGHTWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD     0x1F812
#define unicode_DOWNWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD      0x1F813
#define unicode_LEFTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD            0x1F814
#define unicode_UPWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD              0x1F815
#define unicode_RIGHTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD           0x1F816
#define unicode_DOWNWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD            0x1F817
#define unicode_HEAVY_LEFTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD      0x1F818
#define unicode_HEAVY_UPWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD        0x1F819
#define unicode_HEAVY_RIGHTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD     0x1F81A
#define unicode_HEAVY_DOWNWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD      0x1F81B
#define unicode_HEAVY_LEFTWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD 0x1F81C
#define unicode_HEAVY_UPWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD  0x1F81D
#define unicode_HEAVY_RIGHTWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD 0x1F81E
#define unicode_HEAVY_DOWNWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD 0x1F81F
#define unicode_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT     0x1F820
#define unicode_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT       0x1F821
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT    0x1F822
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT     0x1F823
#define unicode_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT     0x1F824
#define unicode_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT       0x1F825
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT    0x1F826
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT     0x1F827
#define unicode_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT       0x1F828
#define unicode_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT         0x1F829
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT      0x1F82A
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT       0x1F82B
#define unicode_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT      0x1F82C
#define unicode_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT        0x1F82D
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT     0x1F82E
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT      0x1F82F
#define unicode_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT 0x1F830
#define unicode_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT   0x1F831
#define unicode_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT 0x1F832
#define unicode_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT 0x1F833
#define unicode_LEFTWARDS_FINGER_POST_ARROW                           0x1F834
#define unicode_UPWARDS_FINGER_POST_ARROW                             0x1F835
#define unicode_RIGHTWARDS_FINGER_POST_ARROW                          0x1F836
#define unicode_DOWNWARDS_FINGER_POST_ARROW                           0x1F837
#define unicode_LEFTWARDS_SQUARED_ARROW                               0x1F838
#define unicode_UPWARDS_SQUARED_ARROW                                 0x1F839
#define unicode_RIGHTWARDS_SQUARED_ARROW                              0x1F83A
#define unicode_DOWNWARDS_SQUARED_ARROW                               0x1F83B
#define unicode_LEFTWARDS_COMPRESSED_ARROW                            0x1F83C
#define unicode_UPWARDS_COMPRESSED_ARROW                              0x1F83D
#define unicode_RIGHTWARDS_COMPRESSED_ARROW                           0x1F83E
#define unicode_DOWNWARDS_COMPRESSED_ARROW                            0x1F83F
#define unicode_LEFTWARDS_HEAVY_COMPRESSED_ARROW                      0x1F840
#define unicode_UPWARDS_HEAVY_COMPRESSED_ARROW                        0x1F841
#define unicode_RIGHTWARDS_HEAVY_COMPRESSED_ARROW                     0x1F842
#define unicode_DOWNWARDS_HEAVY_COMPRESSED_ARROW                      0x1F843
#define unicode_LEFTWARDS_HEAVY_ARROW                                 0x1F844
#define unicode_UPWARDS_HEAVY_ARROW                                   0x1F845
#define unicode_RIGHTWARDS_HEAVY_ARROW                                0x1F846
#define unicode_DOWNWARDS_HEAVY_ARROW                                 0x1F847
#define unicode_LEFTWARDS_SANS_SERIF_ARROW                            0x1F850
#define unicode_UPWARDS_SANS_SERIF_ARROW                              0x1F851
#define unicode_RIGHTWARDS_SANS_SERIF_ARROW                           0x1F852
#define unicode_DOWNWARDS_SANS_SERIF_ARROW                            0x1F853
#define unicode_NORTH_WEST_SANS_SERIF_ARROW                           0x1F854
#define unicode_NORTH_EAST_SANS_SERIF_ARROW                           0x1F855
#define unicode_SOUTH_EAST_SANS_SERIF_ARROW                           0x1F856
#define unicode_SOUTH_WEST_SANS_SERIF_ARROW                           0x1F857
#define unicode_LEFT_RIGHT_SANS_SERIF_ARROW                           0x1F858
#define unicode_UP_DOWN_SANS_SERIF_ARROW                              0x1F859
#define unicode_WIDE_HEADED_LEFTWARDS_LIGHT_BARB_ARROW                0x1F860
#define unicode_WIDE_HEADED_UPWARDS_LIGHT_BARB_ARROW                  0x1F861
#define unicode_WIDE_HEADED_RIGHTWARDS_LIGHT_BARB_ARROW               0x1F862
#define unicode_WIDE_HEADED_DOWNWARDS_LIGHT_BARB_ARROW                0x1F863
#define unicode_WIDE_HEADED_NORTH_WEST_LIGHT_BARB_ARROW               0x1F864
#define unicode_WIDE_HEADED_NORTH_EAST_LIGHT_BARB_ARROW               0x1F865
#define unicode_WIDE_HEADED_SOUTH_EAST_LIGHT_BARB_ARROW               0x1F866
#define unicode_WIDE_HEADED_SOUTH_WEST_LIGHT_BARB_ARROW               0x1F867
#define unicode_WIDE_HEADED_LEFTWARDS_BARB_ARROW                      0x1F868
#define unicode_WIDE_HEADED_UPWARDS_BARB_ARROW                        0x1F869
#define unicode_WIDE_HEADED_RIGHTWARDS_BARB_ARROW                     0x1F86A
#define unicode_WIDE_HEADED_DOWNWARDS_BARB_ARROW                      0x1F86B
#define unicode_WIDE_HEADED_NORTH_WEST_BARB_ARROW                     0x1F86C
#define unicode_WIDE_HEADED_NORTH_EAST_BARB_ARROW                     0x1F86D
#define unicode_WIDE_HEADED_SOUTH_EAST_BARB_ARROW                     0x1F86E
#define unicode_WIDE_HEADED_SOUTH_WEST_BARB_ARROW                     0x1F86F
#define unicode_WIDE_HEADED_LEFTWARDS_MEDIUM_BARB_ARROW               0x1F870
#define unicode_WIDE_HEADED_UPWARDS_MEDIUM_BARB_ARROW                 0x1F871
#define unicode_WIDE_HEADED_RIGHTWARDS_MEDIUM_BARB_ARROW              0x1F872
#define unicode_WIDE_HEADED_DOWNWARDS_MEDIUM_BARB_ARROW               0x1F873
#define unicode_WIDE_HEADED_NORTH_WEST_MEDIUM_BARB_ARROW              0x1F874
#define unicode_WIDE_HEADED_NORTH_EAST_MEDIUM_BARB_ARROW              0x1F875
#define unicode_WIDE_HEADED_SOUTH_EAST_MEDIUM_BARB_ARROW              0x1F876
#define unicode_WIDE_HEADED_SOUTH_WEST_MEDIUM_BARB_ARROW              0x1F877
#define unicode_WIDE_HEADED_LEFTWARDS_HEAVY_BARB_ARROW                0x1F878
#define unicode_WIDE_HEADED_UPWARDS_HEAVY_BARB_ARROW                  0x1F879
#define unicode_WIDE_HEADED_RIGHTWARDS_HEAVY_BARB_ARROW               0x1F87A
#define unicode_WIDE_HEADED_DOWNWARDS_HEAVY_BARB_ARROW                0x1F87B
#define unicode_WIDE_HEADED_NORTH_WEST_HEAVY_BARB_ARROW               0x1F87C
#define unicode_WIDE_HEADED_NORTH_EAST_HEAVY_BARB_ARROW               0x1F87D
#define unicode_WIDE_HEADED_SOUTH_EAST_HEAVY_BARB_ARROW               0x1F87E
#define unicode_WIDE_HEADED_SOUTH_WEST_HEAVY_BARB_ARROW               0x1F87F
#define unicode_WIDE_HEADED_LEFTWARDS_VERY_HEAVY_BARB_ARROW           0x1F880
#define unicode_WIDE_HEADED_UPWARDS_VERY_HEAVY_BARB_ARROW             0x1F881
#define unicode_WIDE_HEADED_RIGHTWARDS_VERY_HEAVY_BARB_ARROW          0x1F882
#define unicode_WIDE_HEADED_DOWNWARDS_VERY_HEAVY_BARB_ARROW           0x1F883
#define unicode_WIDE_HEADED_NORTH_WEST_VERY_HEAVY_BARB_ARROW          0x1F884
#define unicode_WIDE_HEADED_NORTH_EAST_VERY_HEAVY_BARB_ARROW          0x1F885
#define unicode_WIDE_HEADED_SOUTH_EAST_VERY_HEAVY_BARB_ARROW          0x1F886
#define unicode_WIDE_HEADED_SOUTH_WEST_VERY_HEAVY_BARB_ARROW          0x1F887
#define unicode_LEFTWARDS_TRIANGLE_ARROWHEAD                          0x1F890
#define unicode_UPWARDS_TRIANGLE_ARROWHEAD                            0x1F891
#define unicode_RIGHTWARDS_TRIANGLE_ARROWHEAD                         0x1F892
#define unicode_DOWNWARDS_TRIANGLE_ARROWHEAD                          0x1F893
#define unicode_LEFTWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD       0x1F894
#define unicode_UPWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD         0x1F895
#define unicode_RIGHTWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD      0x1F896
#define unicode_DOWNWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD       0x1F897
#define unicode_LEFTWARDS_ARROW_WITH_NOTCHED_TAIL                     0x1F898
#define unicode_UPWARDS_ARROW_WITH_NOTCHED_TAIL                       0x1F899
#define unicode_RIGHTWARDS_ARROW_WITH_NOTCHED_TAIL                    0x1F89A
#define unicode_DOWNWARDS_ARROW_WITH_NOTCHED_TAIL                     0x1F89B
#define unicode_HEAVY_ARROW_SHAFT_WIDTH_ONE                           0x1F89C
#define unicode_HEAVY_ARROW_SHAFT_WIDTH_TWO_THIRDS                    0x1F89D
#define unicode_HEAVY_ARROW_SHAFT_WIDTH_ONE_HALF                      0x1F89E
#define unicode_HEAVY_ARROW_SHAFT_WIDTH_ONE_THIRD                     0x1F89F
#define unicode_LEFTWARDS_BOTTOM_SHADED_WHITE_ARROW                   0x1F8A0
#define unicode_RIGHTWARDS_BOTTOM_SHADED_WHITE_ARROW                  0x1F8A1
#define unicode_LEFTWARDS_TOP_SHADED_WHITE_ARROW                      0x1F8A2
#define unicode_RIGHTWARDS_TOP_SHADED_WHITE_ARROW                     0x1F8A3
#define unicode_LEFTWARDS_LEFT_SHADED_WHITE_ARROW                     0x1F8A4
#define unicode_RIGHTWARDS_RIGHT_SHADED_WHITE_ARROW                   0x1F8A5
#define unicode_LEFTWARDS_RIGHT_SHADED_WHITE_ARROW                    0x1F8A6
#define unicode_RIGHTWARDS_LEFT_SHADED_WHITE_ARROW                    0x1F8A7
#define unicode_LEFTWARDS_BACK_TILTED_SHADOWED_WHITE_ARROW            0x1F8A8
#define unicode_RIGHTWARDS_BACK_TILTED_SHADOWED_WHITE_ARROW           0x1F8A9
#define unicode_LEFTWARDS_FRONT_TILTED_SHADOWED_WHITE_ARROW           0x1F8AA
#define unicode_RIGHTWARDS_FRONT_TILTED_SHADOWED_WHITE_ARROW          0x1F8AB
#define unicode_WHITE_ARROW_SHAFT_WIDTH_ONE                           0x1F8AC
#define unicode_WHITE_ARROW_SHAFT_WIDTH_TWO_THIRDS                    0x1F8AD
#define unicode_CJK_Ideograph_Extension_B__First                      0x20000
#define unicode_CJK_Ideograph_Extension_B__Last                       0x2A6D6
#define unicode_CJK_Ideograph_Extension_C__First                      0x2A700
#define unicode_CJK_Ideograph_Extension_C__Last                       0x2B734
#define unicode_CJK_Ideograph_Extension_D__First                      0x2B740
#define unicode_CJK_Ideograph_Extension_D__Last                       0x2B81D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F800                     0x2F800
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F801                     0x2F801
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F802                     0x2F802
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F803                     0x2F803
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F804                     0x2F804
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F805                     0x2F805
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F806                     0x2F806
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F807                     0x2F807
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F808                     0x2F808
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F809                     0x2F809
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F80A                     0x2F80A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F80B                     0x2F80B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F80C                     0x2F80C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F80D                     0x2F80D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F80E                     0x2F80E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F80F                     0x2F80F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F810                     0x2F810
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F811                     0x2F811
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F812                     0x2F812
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F813                     0x2F813
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F814                     0x2F814
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F815                     0x2F815
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F816                     0x2F816
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F817                     0x2F817
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F818                     0x2F818
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F819                     0x2F819
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F81A                     0x2F81A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F81B                     0x2F81B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F81C                     0x2F81C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F81D                     0x2F81D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F81E                     0x2F81E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F81F                     0x2F81F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F820                     0x2F820
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F821                     0x2F821
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F822                     0x2F822
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F823                     0x2F823
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F824                     0x2F824
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F825                     0x2F825
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F826                     0x2F826
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F827                     0x2F827
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F828                     0x2F828
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F829                     0x2F829
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F82A                     0x2F82A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F82B                     0x2F82B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F82C                     0x2F82C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F82D                     0x2F82D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F82E                     0x2F82E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F82F                     0x2F82F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F830                     0x2F830
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F831                     0x2F831
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F832                     0x2F832
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F833                     0x2F833
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F834                     0x2F834
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F835                     0x2F835
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F836                     0x2F836
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F837                     0x2F837
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F838                     0x2F838
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F839                     0x2F839
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F83A                     0x2F83A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F83B                     0x2F83B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F83C                     0x2F83C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F83D                     0x2F83D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F83E                     0x2F83E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F83F                     0x2F83F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F840                     0x2F840
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F841                     0x2F841
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F842                     0x2F842
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F843                     0x2F843
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F844                     0x2F844
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F845                     0x2F845
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F846                     0x2F846
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F847                     0x2F847
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F848                     0x2F848
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F849                     0x2F849
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F84A                     0x2F84A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F84B                     0x2F84B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F84C                     0x2F84C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F84D                     0x2F84D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F84E                     0x2F84E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F84F                     0x2F84F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F850                     0x2F850
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F851                     0x2F851
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F852                     0x2F852
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F853                     0x2F853
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F854                     0x2F854
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F855                     0x2F855
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F856                     0x2F856
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F857                     0x2F857
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F858                     0x2F858
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F859                     0x2F859
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F85A                     0x2F85A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F85B                     0x2F85B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F85C                     0x2F85C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F85D                     0x2F85D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F85E                     0x2F85E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F85F                     0x2F85F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F860                     0x2F860
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F861                     0x2F861
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F862                     0x2F862
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F863                     0x2F863
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F864                     0x2F864
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F865                     0x2F865
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F866                     0x2F866
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F867                     0x2F867
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F868                     0x2F868
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F869                     0x2F869
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F86A                     0x2F86A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F86B                     0x2F86B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F86C                     0x2F86C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F86D                     0x2F86D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F86E                     0x2F86E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F86F                     0x2F86F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F870                     0x2F870
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F871                     0x2F871
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F872                     0x2F872
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F873                     0x2F873
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F874                     0x2F874
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F875                     0x2F875
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F876                     0x2F876
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F877                     0x2F877
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F878                     0x2F878
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F879                     0x2F879
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F87A                     0x2F87A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F87B                     0x2F87B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F87C                     0x2F87C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F87D                     0x2F87D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F87E                     0x2F87E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F87F                     0x2F87F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F880                     0x2F880
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F881                     0x2F881
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F882                     0x2F882
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F883                     0x2F883
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F884                     0x2F884
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F885                     0x2F885
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F886                     0x2F886
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F887                     0x2F887
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F888                     0x2F888
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F889                     0x2F889
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F88A                     0x2F88A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F88B                     0x2F88B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F88C                     0x2F88C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F88D                     0x2F88D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F88E                     0x2F88E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F88F                     0x2F88F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F890                     0x2F890
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F891                     0x2F891
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F892                     0x2F892
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F893                     0x2F893
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F894                     0x2F894
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F895                     0x2F895
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F896                     0x2F896
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F897                     0x2F897
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F898                     0x2F898
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F899                     0x2F899
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F89A                     0x2F89A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F89B                     0x2F89B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F89C                     0x2F89C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F89D                     0x2F89D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F89E                     0x2F89E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F89F                     0x2F89F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8A0                     0x2F8A0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8A1                     0x2F8A1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8A2                     0x2F8A2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8A3                     0x2F8A3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8A4                     0x2F8A4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8A5                     0x2F8A5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8A6                     0x2F8A6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8A7                     0x2F8A7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8A8                     0x2F8A8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8A9                     0x2F8A9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8AA                     0x2F8AA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8AB                     0x2F8AB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8AC                     0x2F8AC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8AD                     0x2F8AD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8AE                     0x2F8AE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8AF                     0x2F8AF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8B0                     0x2F8B0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8B1                     0x2F8B1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8B2                     0x2F8B2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8B3                     0x2F8B3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8B4                     0x2F8B4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8B5                     0x2F8B5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8B6                     0x2F8B6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8B7                     0x2F8B7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8B8                     0x2F8B8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8B9                     0x2F8B9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8BA                     0x2F8BA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8BB                     0x2F8BB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8BC                     0x2F8BC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8BD                     0x2F8BD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8BE                     0x2F8BE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8BF                     0x2F8BF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8C0                     0x2F8C0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8C1                     0x2F8C1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8C2                     0x2F8C2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8C3                     0x2F8C3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8C4                     0x2F8C4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8C5                     0x2F8C5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8C6                     0x2F8C6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8C7                     0x2F8C7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8C8                     0x2F8C8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8C9                     0x2F8C9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8CA                     0x2F8CA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8CB                     0x2F8CB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8CC                     0x2F8CC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8CD                     0x2F8CD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8CE                     0x2F8CE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8CF                     0x2F8CF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8D0                     0x2F8D0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8D1                     0x2F8D1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8D2                     0x2F8D2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8D3                     0x2F8D3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8D4                     0x2F8D4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8D5                     0x2F8D5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8D6                     0x2F8D6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8D7                     0x2F8D7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8D8                     0x2F8D8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8D9                     0x2F8D9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8DA                     0x2F8DA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8DB                     0x2F8DB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8DC                     0x2F8DC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8DD                     0x2F8DD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8DE                     0x2F8DE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8DF                     0x2F8DF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8E0                     0x2F8E0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8E1                     0x2F8E1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8E2                     0x2F8E2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8E3                     0x2F8E3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8E4                     0x2F8E4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8E5                     0x2F8E5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8E6                     0x2F8E6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8E7                     0x2F8E7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8E8                     0x2F8E8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8E9                     0x2F8E9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8EA                     0x2F8EA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8EB                     0x2F8EB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8EC                     0x2F8EC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8ED                     0x2F8ED
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8EE                     0x2F8EE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8EF                     0x2F8EF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8F0                     0x2F8F0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8F1                     0x2F8F1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8F2                     0x2F8F2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8F3                     0x2F8F3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8F4                     0x2F8F4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8F5                     0x2F8F5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8F6                     0x2F8F6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8F7                     0x2F8F7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8F8                     0x2F8F8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8F9                     0x2F8F9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8FA                     0x2F8FA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8FB                     0x2F8FB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8FC                     0x2F8FC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8FD                     0x2F8FD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8FE                     0x2F8FE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F8FF                     0x2F8FF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F900                     0x2F900
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F901                     0x2F901
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F902                     0x2F902
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F903                     0x2F903
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F904                     0x2F904
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F905                     0x2F905
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F906                     0x2F906
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F907                     0x2F907
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F908                     0x2F908
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F909                     0x2F909
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F90A                     0x2F90A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F90B                     0x2F90B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F90C                     0x2F90C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F90D                     0x2F90D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F90E                     0x2F90E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F90F                     0x2F90F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F910                     0x2F910
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F911                     0x2F911
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F912                     0x2F912
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F913                     0x2F913
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F914                     0x2F914
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F915                     0x2F915
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F916                     0x2F916
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F917                     0x2F917
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F918                     0x2F918
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F919                     0x2F919
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F91A                     0x2F91A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F91B                     0x2F91B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F91C                     0x2F91C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F91D                     0x2F91D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F91E                     0x2F91E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F91F                     0x2F91F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F920                     0x2F920
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F921                     0x2F921
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F922                     0x2F922
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F923                     0x2F923
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F924                     0x2F924
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F925                     0x2F925
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F926                     0x2F926
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F927                     0x2F927
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F928                     0x2F928
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F929                     0x2F929
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F92A                     0x2F92A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F92B                     0x2F92B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F92C                     0x2F92C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F92D                     0x2F92D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F92E                     0x2F92E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F92F                     0x2F92F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F930                     0x2F930
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F931                     0x2F931
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F932                     0x2F932
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F933                     0x2F933
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F934                     0x2F934
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F935                     0x2F935
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F936                     0x2F936
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F937                     0x2F937
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F938                     0x2F938
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F939                     0x2F939
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F93A                     0x2F93A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F93B                     0x2F93B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F93C                     0x2F93C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F93D                     0x2F93D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F93E                     0x2F93E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F93F                     0x2F93F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F940                     0x2F940
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F941                     0x2F941
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F942                     0x2F942
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F943                     0x2F943
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F944                     0x2F944
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F945                     0x2F945
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F946                     0x2F946
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F947                     0x2F947
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F948                     0x2F948
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F949                     0x2F949
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F94A                     0x2F94A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F94B                     0x2F94B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F94C                     0x2F94C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F94D                     0x2F94D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F94E                     0x2F94E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F94F                     0x2F94F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F950                     0x2F950
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F951                     0x2F951
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F952                     0x2F952
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F953                     0x2F953
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F954                     0x2F954
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F955                     0x2F955
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F956                     0x2F956
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F957                     0x2F957
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F958                     0x2F958
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F959                     0x2F959
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F95A                     0x2F95A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F95B                     0x2F95B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F95C                     0x2F95C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F95D                     0x2F95D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F95E                     0x2F95E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F95F                     0x2F95F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F960                     0x2F960
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F961                     0x2F961
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F962                     0x2F962
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F963                     0x2F963
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F964                     0x2F964
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F965                     0x2F965
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F966                     0x2F966
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F967                     0x2F967
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F968                     0x2F968
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F969                     0x2F969
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F96A                     0x2F96A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F96B                     0x2F96B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F96C                     0x2F96C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F96D                     0x2F96D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F96E                     0x2F96E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F96F                     0x2F96F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F970                     0x2F970
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F971                     0x2F971
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F972                     0x2F972
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F973                     0x2F973
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F974                     0x2F974
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F975                     0x2F975
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F976                     0x2F976
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F977                     0x2F977
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F978                     0x2F978
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F979                     0x2F979
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F97A                     0x2F97A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F97B                     0x2F97B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F97C                     0x2F97C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F97D                     0x2F97D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F97E                     0x2F97E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F97F                     0x2F97F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F980                     0x2F980
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F981                     0x2F981
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F982                     0x2F982
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F983                     0x2F983
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F984                     0x2F984
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F985                     0x2F985
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F986                     0x2F986
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F987                     0x2F987
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F988                     0x2F988
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F989                     0x2F989
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F98A                     0x2F98A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F98B                     0x2F98B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F98C                     0x2F98C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F98D                     0x2F98D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F98E                     0x2F98E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F98F                     0x2F98F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F990                     0x2F990
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F991                     0x2F991
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F992                     0x2F992
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F993                     0x2F993
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F994                     0x2F994
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F995                     0x2F995
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F996                     0x2F996
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F997                     0x2F997
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F998                     0x2F998
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F999                     0x2F999
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F99A                     0x2F99A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F99B                     0x2F99B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F99C                     0x2F99C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F99D                     0x2F99D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F99E                     0x2F99E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F99F                     0x2F99F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9A0                     0x2F9A0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9A1                     0x2F9A1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9A2                     0x2F9A2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9A3                     0x2F9A3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9A4                     0x2F9A4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9A5                     0x2F9A5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9A6                     0x2F9A6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9A7                     0x2F9A7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9A8                     0x2F9A8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9A9                     0x2F9A9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9AA                     0x2F9AA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9AB                     0x2F9AB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9AC                     0x2F9AC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9AD                     0x2F9AD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9AE                     0x2F9AE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9AF                     0x2F9AF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9B0                     0x2F9B0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9B1                     0x2F9B1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9B2                     0x2F9B2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9B3                     0x2F9B3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9B4                     0x2F9B4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9B5                     0x2F9B5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9B6                     0x2F9B6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9B7                     0x2F9B7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9B8                     0x2F9B8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9B9                     0x2F9B9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9BA                     0x2F9BA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9BB                     0x2F9BB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9BC                     0x2F9BC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9BD                     0x2F9BD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9BE                     0x2F9BE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9BF                     0x2F9BF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9C0                     0x2F9C0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9C1                     0x2F9C1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9C2                     0x2F9C2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9C3                     0x2F9C3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9C4                     0x2F9C4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9C5                     0x2F9C5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9C6                     0x2F9C6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9C7                     0x2F9C7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9C8                     0x2F9C8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9C9                     0x2F9C9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9CA                     0x2F9CA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9CB                     0x2F9CB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9CC                     0x2F9CC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9CD                     0x2F9CD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9CE                     0x2F9CE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9CF                     0x2F9CF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9D0                     0x2F9D0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9D1                     0x2F9D1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9D2                     0x2F9D2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9D3                     0x2F9D3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9D4                     0x2F9D4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9D5                     0x2F9D5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9D6                     0x2F9D6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9D7                     0x2F9D7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9D8                     0x2F9D8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9D9                     0x2F9D9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9DA                     0x2F9DA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9DB                     0x2F9DB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9DC                     0x2F9DC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9DD                     0x2F9DD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9DE                     0x2F9DE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9DF                     0x2F9DF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9E0                     0x2F9E0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9E1                     0x2F9E1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9E2                     0x2F9E2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9E3                     0x2F9E3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9E4                     0x2F9E4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9E5                     0x2F9E5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9E6                     0x2F9E6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9E7                     0x2F9E7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9E8                     0x2F9E8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9E9                     0x2F9E9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9EA                     0x2F9EA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9EB                     0x2F9EB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9EC                     0x2F9EC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9ED                     0x2F9ED
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9EE                     0x2F9EE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9EF                     0x2F9EF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9F0                     0x2F9F0
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9F1                     0x2F9F1
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9F2                     0x2F9F2
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9F3                     0x2F9F3
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9F4                     0x2F9F4
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9F5                     0x2F9F5
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9F6                     0x2F9F6
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9F7                     0x2F9F7
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9F8                     0x2F9F8
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9F9                     0x2F9F9
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9FA                     0x2F9FA
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9FB                     0x2F9FB
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9FC                     0x2F9FC
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9FD                     0x2F9FD
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9FE                     0x2F9FE
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2F9FF                     0x2F9FF
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA00                     0x2FA00
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA01                     0x2FA01
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA02                     0x2FA02
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA03                     0x2FA03
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA04                     0x2FA04
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA05                     0x2FA05
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA06                     0x2FA06
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA07                     0x2FA07
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA08                     0x2FA08
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA09                     0x2FA09
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA0A                     0x2FA0A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA0B                     0x2FA0B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA0C                     0x2FA0C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA0D                     0x2FA0D
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA0E                     0x2FA0E
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA0F                     0x2FA0F
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA10                     0x2FA10
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA11                     0x2FA11
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA12                     0x2FA12
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA13                     0x2FA13
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA14                     0x2FA14
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA15                     0x2FA15
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA16                     0x2FA16
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA17                     0x2FA17
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA18                     0x2FA18
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA19                     0x2FA19
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA1A                     0x2FA1A
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA1B                     0x2FA1B
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA1C                     0x2FA1C
#define unicode_CJK_COMPATIBILITY_IDEOGRAPH_2FA1D                     0x2FA1D
#define unicode_LANGUAGE_TAG                                          0xE0001
#define unicode_TAG_SPACE                                             0xE0020
#define unicode_TAG_EXCLAMATION_MARK                                  0xE0021
#define unicode_TAG_QUOTATION_MARK                                    0xE0022
#define unicode_TAG_NUMBER_SIGN                                       0xE0023
#define unicode_TAG_DOLLAR_SIGN                                       0xE0024
#define unicode_TAG_PERCENT_SIGN                                      0xE0025
#define unicode_TAG_AMPERSAND                                         0xE0026
#define unicode_TAG_APOSTROPHE                                        0xE0027
#define unicode_TAG_LEFT_PARENTHESIS                                  0xE0028
#define unicode_TAG_RIGHT_PARENTHESIS                                 0xE0029
#define unicode_TAG_ASTERISK                                          0xE002A
#define unicode_TAG_PLUS_SIGN                                         0xE002B
#define unicode_TAG_COMMA                                             0xE002C
#define unicode_TAG_HYPHEN_MINUS                                      0xE002D
#define unicode_TAG_FULL_STOP                                         0xE002E
#define unicode_TAG_SOLIDUS                                           0xE002F
#define unicode_TAG_DIGIT_ZERO                                        0xE0030
#define unicode_TAG_DIGIT_ONE                                         0xE0031
#define unicode_TAG_DIGIT_TWO                                         0xE0032
#define unicode_TAG_DIGIT_THREE                                       0xE0033
#define unicode_TAG_DIGIT_FOUR                                        0xE0034
#define unicode_TAG_DIGIT_FIVE                                        0xE0035
#define unicode_TAG_DIGIT_SIX                                         0xE0036
#define unicode_TAG_DIGIT_SEVEN                                       0xE0037
#define unicode_TAG_DIGIT_EIGHT                                       0xE0038
#define unicode_TAG_DIGIT_NINE                                        0xE0039
#define unicode_TAG_COLON                                             0xE003A
#define unicode_TAG_SEMICOLON                                         0xE003B
#define unicode_TAG_LESS_THAN_SIGN                                    0xE003C
#define unicode_TAG_EQUALS_SIGN                                       0xE003D
#define unicode_TAG_GREATER_THAN_SIGN                                 0xE003E
#define unicode_TAG_QUESTION_MARK                                     0xE003F
#define unicode_TAG_COMMERCIAL_AT                                     0xE0040
#define unicode_TAG_LATIN_CAPITAL_LETTER_A                            0xE0041
#define unicode_TAG_LATIN_CAPITAL_LETTER_B                            0xE0042
#define unicode_TAG_LATIN_CAPITAL_LETTER_C                            0xE0043
#define unicode_TAG_LATIN_CAPITAL_LETTER_D                            0xE0044
#define unicode_TAG_LATIN_CAPITAL_LETTER_E                            0xE0045
#define unicode_TAG_LATIN_CAPITAL_LETTER_F                            0xE0046
#define unicode_TAG_LATIN_CAPITAL_LETTER_G                            0xE0047
#define unicode_TAG_LATIN_CAPITAL_LETTER_H                            0xE0048
#define unicode_TAG_LATIN_CAPITAL_LETTER_I                            0xE0049
#define unicode_TAG_LATIN_CAPITAL_LETTER_J                            0xE004A
#define unicode_TAG_LATIN_CAPITAL_LETTER_K                            0xE004B
#define unicode_TAG_LATIN_CAPITAL_LETTER_L                            0xE004C
#define unicode_TAG_LATIN_CAPITAL_LETTER_M                            0xE004D
#define unicode_TAG_LATIN_CAPITAL_LETTER_N                            0xE004E
#define unicode_TAG_LATIN_CAPITAL_LETTER_O                            0xE004F
#define unicode_TAG_LATIN_CAPITAL_LETTER_P                            0xE0050
#define unicode_TAG_LATIN_CAPITAL_LETTER_Q                            0xE0051
#define unicode_TAG_LATIN_CAPITAL_LETTER_R                            0xE0052
#define unicode_TAG_LATIN_CAPITAL_LETTER_S                            0xE0053
#define unicode_TAG_LATIN_CAPITAL_LETTER_T                            0xE0054
#define unicode_TAG_LATIN_CAPITAL_LETTER_U                            0xE0055
#define unicode_TAG_LATIN_CAPITAL_LETTER_V                            0xE0056
#define unicode_TAG_LATIN_CAPITAL_LETTER_W                            0xE0057
#define unicode_TAG_LATIN_CAPITAL_LETTER_X                            0xE0058
#define unicode_TAG_LATIN_CAPITAL_LETTER_Y                            0xE0059
#define unicode_TAG_LATIN_CAPITAL_LETTER_Z                            0xE005A
#define unicode_TAG_LEFT_SQUARE_BRACKET                               0xE005B
#define unicode_TAG_REVERSE_SOLIDUS                                   0xE005C
#define unicode_TAG_RIGHT_SQUARE_BRACKET                              0xE005D
#define unicode_TAG_CIRCUMFLEX_ACCENT                                 0xE005E
#define unicode_TAG_LOW_LINE                                          0xE005F
#define unicode_TAG_GRAVE_ACCENT                                      0xE0060
#define unicode_TAG_LATIN_SMALL_LETTER_A                              0xE0061
#define unicode_TAG_LATIN_SMALL_LETTER_B                              0xE0062
#define unicode_TAG_LATIN_SMALL_LETTER_C                              0xE0063
#define unicode_TAG_LATIN_SMALL_LETTER_D                              0xE0064
#define unicode_TAG_LATIN_SMALL_LETTER_E                              0xE0065
#define unicode_TAG_LATIN_SMALL_LETTER_F                              0xE0066
#define unicode_TAG_LATIN_SMALL_LETTER_G                              0xE0067
#define unicode_TAG_LATIN_SMALL_LETTER_H                              0xE0068
#define unicode_TAG_LATIN_SMALL_LETTER_I                              0xE0069
#define unicode_TAG_LATIN_SMALL_LETTER_J                              0xE006A
#define unicode_TAG_LATIN_SMALL_LETTER_K                              0xE006B
#define unicode_TAG_LATIN_SMALL_LETTER_L                              0xE006C
#define unicode_TAG_LATIN_SMALL_LETTER_M                              0xE006D
#define unicode_TAG_LATIN_SMALL_LETTER_N                              0xE006E
#define unicode_TAG_LATIN_SMALL_LETTER_O                              0xE006F
#define unicode_TAG_LATIN_SMALL_LETTER_P                              0xE0070
#define unicode_TAG_LATIN_SMALL_LETTER_Q                              0xE0071
#define unicode_TAG_LATIN_SMALL_LETTER_R                              0xE0072
#define unicode_TAG_LATIN_SMALL_LETTER_S                              0xE0073
#define unicode_TAG_LATIN_SMALL_LETTER_T                              0xE0074
#define unicode_TAG_LATIN_SMALL_LETTER_U                              0xE0075
#define unicode_TAG_LATIN_SMALL_LETTER_V                              0xE0076
#define unicode_TAG_LATIN_SMALL_LETTER_W                              0xE0077
#define unicode_TAG_LATIN_SMALL_LETTER_X                              0xE0078
#define unicode_TAG_LATIN_SMALL_LETTER_Y                              0xE0079
#define unicode_TAG_LATIN_SMALL_LETTER_Z                              0xE007A
#define unicode_TAG_LEFT_CURLY_BRACKET                                0xE007B
#define unicode_TAG_VERTICAL_LINE                                     0xE007C
#define unicode_TAG_RIGHT_CURLY_BRACKET                               0xE007D
#define unicode_TAG_TILDE                                             0xE007E
#define unicode_CANCEL_TAG                                            0xE007F
#define unicode_VARIATION_SELECTOR_17                                 0xE0100
#define unicode_VARIATION_SELECTOR_18                                 0xE0101
#define unicode_VARIATION_SELECTOR_19                                 0xE0102
#define unicode_VARIATION_SELECTOR_20                                 0xE0103
#define unicode_VARIATION_SELECTOR_21                                 0xE0104
#define unicode_VARIATION_SELECTOR_22                                 0xE0105
#define unicode_VARIATION_SELECTOR_23                                 0xE0106
#define unicode_VARIATION_SELECTOR_24                                 0xE0107
#define unicode_VARIATION_SELECTOR_25                                 0xE0108
#define unicode_VARIATION_SELECTOR_26                                 0xE0109
#define unicode_VARIATION_SELECTOR_27                                 0xE010A
#define unicode_VARIATION_SELECTOR_28                                 0xE010B
#define unicode_VARIATION_SELECTOR_29                                 0xE010C
#define unicode_VARIATION_SELECTOR_30                                 0xE010D
#define unicode_VARIATION_SELECTOR_31                                 0xE010E
#define unicode_VARIATION_SELECTOR_32                                 0xE010F
#define unicode_VARIATION_SELECTOR_33                                 0xE0110
#define unicode_VARIATION_SELECTOR_34                                 0xE0111
#define unicode_VARIATION_SELECTOR_35                                 0xE0112
#define unicode_VARIATION_SELECTOR_36                                 0xE0113
#define unicode_VARIATION_SELECTOR_37                                 0xE0114
#define unicode_VARIATION_SELECTOR_38                                 0xE0115
#define unicode_VARIATION_SELECTOR_39                                 0xE0116
#define unicode_VARIATION_SELECTOR_40                                 0xE0117
#define unicode_VARIATION_SELECTOR_41                                 0xE0118
#define unicode_VARIATION_SELECTOR_42                                 0xE0119
#define unicode_VARIATION_SELECTOR_43                                 0xE011A
#define unicode_VARIATION_SELECTOR_44                                 0xE011B
#define unicode_VARIATION_SELECTOR_45                                 0xE011C
#define unicode_VARIATION_SELECTOR_46                                 0xE011D
#define unicode_VARIATION_SELECTOR_47                                 0xE011E
#define unicode_VARIATION_SELECTOR_48                                 0xE011F
#define unicode_VARIATION_SELECTOR_49                                 0xE0120
#define unicode_VARIATION_SELECTOR_50                                 0xE0121
#define unicode_VARIATION_SELECTOR_51                                 0xE0122
#define unicode_VARIATION_SELECTOR_52                                 0xE0123
#define unicode_VARIATION_SELECTOR_53                                 0xE0124
#define unicode_VARIATION_SELECTOR_54                                 0xE0125
#define unicode_VARIATION_SELECTOR_55                                 0xE0126
#define unicode_VARIATION_SELECTOR_56                                 0xE0127
#define unicode_VARIATION_SELECTOR_57                                 0xE0128
#define unicode_VARIATION_SELECTOR_58                                 0xE0129
#define unicode_VARIATION_SELECTOR_59                                 0xE012A
#define unicode_VARIATION_SELECTOR_60                                 0xE012B
#define unicode_VARIATION_SELECTOR_61                                 0xE012C
#define unicode_VARIATION_SELECTOR_62                                 0xE012D
#define unicode_VARIATION_SELECTOR_63                                 0xE012E
#define unicode_VARIATION_SELECTOR_64                                 0xE012F
#define unicode_VARIATION_SELECTOR_65                                 0xE0130
#define unicode_VARIATION_SELECTOR_66                                 0xE0131
#define unicode_VARIATION_SELECTOR_67                                 0xE0132
#define unicode_VARIATION_SELECTOR_68                                 0xE0133
#define unicode_VARIATION_SELECTOR_69                                 0xE0134
#define unicode_VARIATION_SELECTOR_70                                 0xE0135
#define unicode_VARIATION_SELECTOR_71                                 0xE0136
#define unicode_VARIATION_SELECTOR_72                                 0xE0137
#define unicode_VARIATION_SELECTOR_73                                 0xE0138
#define unicode_VARIATION_SELECTOR_74                                 0xE0139
#define unicode_VARIATION_SELECTOR_75                                 0xE013A
#define unicode_VARIATION_SELECTOR_76                                 0xE013B
#define unicode_VARIATION_SELECTOR_77                                 0xE013C
#define unicode_VARIATION_SELECTOR_78                                 0xE013D
#define unicode_VARIATION_SELECTOR_79                                 0xE013E
#define unicode_VARIATION_SELECTOR_80                                 0xE013F
#define unicode_VARIATION_SELECTOR_81                                 0xE0140
#define unicode_VARIATION_SELECTOR_82                                 0xE0141
#define unicode_VARIATION_SELECTOR_83                                 0xE0142
#define unicode_VARIATION_SELECTOR_84                                 0xE0143
#define unicode_VARIATION_SELECTOR_85                                 0xE0144
#define unicode_VARIATION_SELECTOR_86                                 0xE0145
#define unicode_VARIATION_SELECTOR_87                                 0xE0146
#define unicode_VARIATION_SELECTOR_88                                 0xE0147
#define unicode_VARIATION_SELECTOR_89                                 0xE0148
#define unicode_VARIATION_SELECTOR_90                                 0xE0149
#define unicode_VARIATION_SELECTOR_91                                 0xE014A
#define unicode_VARIATION_SELECTOR_92                                 0xE014B
#define unicode_VARIATION_SELECTOR_93                                 0xE014C
#define unicode_VARIATION_SELECTOR_94                                 0xE014D
#define unicode_VARIATION_SELECTOR_95                                 0xE014E
#define unicode_VARIATION_SELECTOR_96                                 0xE014F
#define unicode_VARIATION_SELECTOR_97                                 0xE0150
#define unicode_VARIATION_SELECTOR_98                                 0xE0151
#define unicode_VARIATION_SELECTOR_99                                 0xE0152
#define unicode_VARIATION_SELECTOR_100                                0xE0153
#define unicode_VARIATION_SELECTOR_101                                0xE0154
#define unicode_VARIATION_SELECTOR_102                                0xE0155
#define unicode_VARIATION_SELECTOR_103                                0xE0156
#define unicode_VARIATION_SELECTOR_104                                0xE0157
#define unicode_VARIATION_SELECTOR_105                                0xE0158
#define unicode_VARIATION_SELECTOR_106                                0xE0159
#define unicode_VARIATION_SELECTOR_107                                0xE015A
#define unicode_VARIATION_SELECTOR_108                                0xE015B
#define unicode_VARIATION_SELECTOR_109                                0xE015C
#define unicode_VARIATION_SELECTOR_110                                0xE015D
#define unicode_VARIATION_SELECTOR_111                                0xE015E
#define unicode_VARIATION_SELECTOR_112                                0xE015F
#define unicode_VARIATION_SELECTOR_113                                0xE0160
#define unicode_VARIATION_SELECTOR_114                                0xE0161
#define unicode_VARIATION_SELECTOR_115                                0xE0162
#define unicode_VARIATION_SELECTOR_116                                0xE0163
#define unicode_VARIATION_SELECTOR_117                                0xE0164
#define unicode_VARIATION_SELECTOR_118                                0xE0165
#define unicode_VARIATION_SELECTOR_119                                0xE0166
#define unicode_VARIATION_SELECTOR_120                                0xE0167
#define unicode_VARIATION_SELECTOR_121                                0xE0168
#define unicode_VARIATION_SELECTOR_122                                0xE0169
#define unicode_VARIATION_SELECTOR_123                                0xE016A
#define unicode_VARIATION_SELECTOR_124                                0xE016B
#define unicode_VARIATION_SELECTOR_125                                0xE016C
#define unicode_VARIATION_SELECTOR_126                                0xE016D
#define unicode_VARIATION_SELECTOR_127                                0xE016E
#define unicode_VARIATION_SELECTOR_128                                0xE016F
#define unicode_VARIATION_SELECTOR_129                                0xE0170
#define unicode_VARIATION_SELECTOR_130                                0xE0171
#define unicode_VARIATION_SELECTOR_131                                0xE0172
#define unicode_VARIATION_SELECTOR_132                                0xE0173
#define unicode_VARIATION_SELECTOR_133                                0xE0174
#define unicode_VARIATION_SELECTOR_134                                0xE0175
#define unicode_VARIATION_SELECTOR_135                                0xE0176
#define unicode_VARIATION_SELECTOR_136                                0xE0177
#define unicode_VARIATION_SELECTOR_137                                0xE0178
#define unicode_VARIATION_SELECTOR_138                                0xE0179
#define unicode_VARIATION_SELECTOR_139                                0xE017A
#define unicode_VARIATION_SELECTOR_140                                0xE017B
#define unicode_VARIATION_SELECTOR_141                                0xE017C
#define unicode_VARIATION_SELECTOR_142                                0xE017D
#define unicode_VARIATION_SELECTOR_143                                0xE017E
#define unicode_VARIATION_SELECTOR_144                                0xE017F
#define unicode_VARIATION_SELECTOR_145                                0xE0180
#define unicode_VARIATION_SELECTOR_146                                0xE0181
#define unicode_VARIATION_SELECTOR_147                                0xE0182
#define unicode_VARIATION_SELECTOR_148                                0xE0183
#define unicode_VARIATION_SELECTOR_149                                0xE0184
#define unicode_VARIATION_SELECTOR_150                                0xE0185
#define unicode_VARIATION_SELECTOR_151                                0xE0186
#define unicode_VARIATION_SELECTOR_152                                0xE0187
#define unicode_VARIATION_SELECTOR_153                                0xE0188
#define unicode_VARIATION_SELECTOR_154                                0xE0189
#define unicode_VARIATION_SELECTOR_155                                0xE018A
#define unicode_VARIATION_SELECTOR_156                                0xE018B
#define unicode_VARIATION_SELECTOR_157                                0xE018C
#define unicode_VARIATION_SELECTOR_158                                0xE018D
#define unicode_VARIATION_SELECTOR_159                                0xE018E
#define unicode_VARIATION_SELECTOR_160                                0xE018F
#define unicode_VARIATION_SELECTOR_161                                0xE0190
#define unicode_VARIATION_SELECTOR_162                                0xE0191
#define unicode_VARIATION_SELECTOR_163                                0xE0192
#define unicode_VARIATION_SELECTOR_164                                0xE0193
#define unicode_VARIATION_SELECTOR_165                                0xE0194
#define unicode_VARIATION_SELECTOR_166                                0xE0195
#define unicode_VARIATION_SELECTOR_167                                0xE0196
#define unicode_VARIATION_SELECTOR_168                                0xE0197
#define unicode_VARIATION_SELECTOR_169                                0xE0198
#define unicode_VARIATION_SELECTOR_170                                0xE0199
#define unicode_VARIATION_SELECTOR_171                                0xE019A
#define unicode_VARIATION_SELECTOR_172                                0xE019B
#define unicode_VARIATION_SELECTOR_173                                0xE019C
#define unicode_VARIATION_SELECTOR_174                                0xE019D
#define unicode_VARIATION_SELECTOR_175                                0xE019E
#define unicode_VARIATION_SELECTOR_176                                0xE019F
#define unicode_VARIATION_SELECTOR_177                                0xE01A0
#define unicode_VARIATION_SELECTOR_178                                0xE01A1
#define unicode_VARIATION_SELECTOR_179                                0xE01A2
#define unicode_VARIATION_SELECTOR_180                                0xE01A3
#define unicode_VARIATION_SELECTOR_181                                0xE01A4
#define unicode_VARIATION_SELECTOR_182                                0xE01A5
#define unicode_VARIATION_SELECTOR_183                                0xE01A6
#define unicode_VARIATION_SELECTOR_184                                0xE01A7
#define unicode_VARIATION_SELECTOR_185                                0xE01A8
#define unicode_VARIATION_SELECTOR_186                                0xE01A9
#define unicode_VARIATION_SELECTOR_187                                0xE01AA
#define unicode_VARIATION_SELECTOR_188                                0xE01AB
#define unicode_VARIATION_SELECTOR_189                                0xE01AC
#define unicode_VARIATION_SELECTOR_190                                0xE01AD
#define unicode_VARIATION_SELECTOR_191                                0xE01AE
#define unicode_VARIATION_SELECTOR_192                                0xE01AF
#define unicode_VARIATION_SELECTOR_193                                0xE01B0
#define unicode_VARIATION_SELECTOR_194                                0xE01B1
#define unicode_VARIATION_SELECTOR_195                                0xE01B2
#define unicode_VARIATION_SELECTOR_196                                0xE01B3
#define unicode_VARIATION_SELECTOR_197                                0xE01B4
#define unicode_VARIATION_SELECTOR_198                                0xE01B5
#define unicode_VARIATION_SELECTOR_199                                0xE01B6
#define unicode_VARIATION_SELECTOR_200                                0xE01B7
#define unicode_VARIATION_SELECTOR_201                                0xE01B8
#define unicode_VARIATION_SELECTOR_202                                0xE01B9
#define unicode_VARIATION_SELECTOR_203                                0xE01BA
#define unicode_VARIATION_SELECTOR_204                                0xE01BB
#define unicode_VARIATION_SELECTOR_205                                0xE01BC
#define unicode_VARIATION_SELECTOR_206                                0xE01BD
#define unicode_VARIATION_SELECTOR_207                                0xE01BE
#define unicode_VARIATION_SELECTOR_208                                0xE01BF
#define unicode_VARIATION_SELECTOR_209                                0xE01C0
#define unicode_VARIATION_SELECTOR_210                                0xE01C1
#define unicode_VARIATION_SELECTOR_211                                0xE01C2
#define unicode_VARIATION_SELECTOR_212                                0xE01C3
#define unicode_VARIATION_SELECTOR_213                                0xE01C4
#define unicode_VARIATION_SELECTOR_214                                0xE01C5
#define unicode_VARIATION_SELECTOR_215                                0xE01C6
#define unicode_VARIATION_SELECTOR_216                                0xE01C7
#define unicode_VARIATION_SELECTOR_217                                0xE01C8
#define unicode_VARIATION_SELECTOR_218                                0xE01C9
#define unicode_VARIATION_SELECTOR_219                                0xE01CA
#define unicode_VARIATION_SELECTOR_220                                0xE01CB
#define unicode_VARIATION_SELECTOR_221                                0xE01CC
#define unicode_VARIATION_SELECTOR_222                                0xE01CD
#define unicode_VARIATION_SELECTOR_223                                0xE01CE
#define unicode_VARIATION_SELECTOR_224                                0xE01CF
#define unicode_VARIATION_SELECTOR_225                                0xE01D0
#define unicode_VARIATION_SELECTOR_226                                0xE01D1
#define unicode_VARIATION_SELECTOR_227                                0xE01D2
#define unicode_VARIATION_SELECTOR_228                                0xE01D3
#define unicode_VARIATION_SELECTOR_229                                0xE01D4
#define unicode_VARIATION_SELECTOR_230                                0xE01D5
#define unicode_VARIATION_SELECTOR_231                                0xE01D6
#define unicode_VARIATION_SELECTOR_232                                0xE01D7
#define unicode_VARIATION_SELECTOR_233                                0xE01D8
#define unicode_VARIATION_SELECTOR_234                                0xE01D9
#define unicode_VARIATION_SELECTOR_235                                0xE01DA
#define unicode_VARIATION_SELECTOR_236                                0xE01DB
#define unicode_VARIATION_SELECTOR_237                                0xE01DC
#define unicode_VARIATION_SELECTOR_238                                0xE01DD
#define unicode_VARIATION_SELECTOR_239                                0xE01DE
#define unicode_VARIATION_SELECTOR_240                                0xE01DF
#define unicode_VARIATION_SELECTOR_241                                0xE01E0
#define unicode_VARIATION_SELECTOR_242                                0xE01E1
#define unicode_VARIATION_SELECTOR_243                                0xE01E2
#define unicode_VARIATION_SELECTOR_244                                0xE01E3
#define unicode_VARIATION_SELECTOR_245                                0xE01E4
#define unicode_VARIATION_SELECTOR_246                                0xE01E5
#define unicode_VARIATION_SELECTOR_247                                0xE01E6
#define unicode_VARIATION_SELECTOR_248                                0xE01E7
#define unicode_VARIATION_SELECTOR_249                                0xE01E8
#define unicode_VARIATION_SELECTOR_250                                0xE01E9
#define unicode_VARIATION_SELECTOR_251                                0xE01EA
#define unicode_VARIATION_SELECTOR_252                                0xE01EB
#define unicode_VARIATION_SELECTOR_253                                0xE01EC
#define unicode_VARIATION_SELECTOR_254                                0xE01ED
#define unicode_VARIATION_SELECTOR_255                                0xE01EE
#define unicode_VARIATION_SELECTOR_256                                0xE01EF
#define unicode_Plane_15_Private_Use__First                           0xF0000
#define unicode_Plane_15_Private_Use__Last                            0xFFFFD
#define unicode_Plane_16_Private_Use__First                           0x100000
#define unicode_Plane_16_Private_Use__Last                            0x10FFFD


// I will now put in some names from the private use area that I use for
// TeX-related stuff... The first few are names I have invented for
// myself when the other sources I have found so far do not help me.

// I have not (so far?) been able to find this in Standard Unicode. I believe
// that TeX uses it to synthesize LATIN_CAPITAL_LETTER_L_WITH_STROKE(u+0141)
// and related letters.

#define nonstandard_POLISHCROSS                                       0x1081B9

// These are probably what I am looking for...
#define nonstandard_ARROW_HOOK_LEFT                                   0x1080DA
#define nonstandard_ARROW_HOOK_RIGHT                                  0x1080DB
#define nonstandard_MAPSTO                                            0x1080DC

// Old style numerals.
#define nonstandard_OLD_STYLE_DIGIT_ZERO                              0x1081AF
#define nonstandard_OLD_STYLE_DIGIT_ONE                               0x1081B0
#define nonstandard_OLD_STYLE_DIGIT_TWO                               0x1081B1
#define nonstandard_OLD_STYLE_DIGIT_THREE                             0x1081B2
#define nonstandard_OLD_STYLE_DIGIT_FOUR                              0x1081B3
#define nonstandard_OLD_STYLE_DIGIT_FIVE                              0x1081B4
#define nonstandard_OLD_STYLE_DIGIT_SIX                               0x1081B5
#define nonstandard_OLD_STYLE_DIGIT_SEVEN                             0x1081B6
#define nonstandard_OLD_STYLE_DIGIT_EIGHT                             0x1081B7
#define nonstandard_OLD_STYLE_DIGIT_NINE                              0x1081B8


// The names defined here are extracted from the font metric file associated
// with STIXMath. Note that I moved these glyphs to give them proper
// accessible codepoints.

#define nonstandard_uniE0B3                                           0x108001
#define nonstandard_w_var                                             0x108002
#define nonstandard_VERTICAL_LINE_var                                 0x108003
#define nonstandard_LATIN_SMALL_LETTER_LAMBDA_WITH_STROKE_var         0x108004
#define nonstandard_LATIN_SMALL_LETTER_RAMS_HORN_var                  0x108005
#define nonstandard_PRIME_var                                         0x108006
#define nonstandard_DOUBLE_PRIME_var                                  0x108007
#define nonstandard_TRIPLE_PRIME_var                                  0x108008
#define nonstandard_REVERSED_PRIME_var                                0x108009
#define nonstandard_REVERSED_DOUBLE_PRIME_var                         0x10800a
#define nonstandard_REVERSED_TRIPLE_PRIME_var                         0x10800b
#define nonstandard_QUADRUPLE_PRIME_var                               0x10800c
#define nonstandard_PLANCK_CONSTANT_OVER_TWO_PI_var                   0x10800d
#define nonstandard_DOUBLE_STRUCK_N_ARY_SUMMATION_var                 0x10800e
#define nonstandard_LEFTWARDS_ARROW_var                               0x10800f
#define nonstandard_UPWARDS_ARROW_var                                 0x108010
#define nonstandard_RIGHTWARDS_ARROW_var                              0x108011
#define nonstandard_DOWNWARDS_ARROW_var                               0x108012
#define nonstandard_UPWARDS_DOUBLE_ARROW_var                          0x108013
#define nonstandard_DOWNWARDS_DOUBLE_ARROW_var                        0x108014
#define nonstandard_LEFTWARDS_DASHED_ARROW_var                        0x108015
#define nonstandard_RIGHTWARDS_DASHED_ARROW_var                       0x108016
#define nonstandard_EMPTY_SET_var                                     0x108017
#define nonstandard_ELEMENT_OF_var                                    0x108018
#define nonstandard_NOT_AN_ELEMENT_OF_var                             0x108019
#define nonstandard_CONTAINS_AS_MEMBER_var                            0x10801a
#define nonstandard_DOES_NOT_CONTAIN_AS_MEMBER_var                    0x10801b
#define nonstandard_N_ARY_PRODUCT_var                                 0x10801c
#define nonstandard_N_ARY_COPRODUCT_var                               0x10801d
#define nonstandard_N_ARY_SUMMATION_var                               0x10801e
#define nonstandard_SET_MINUS_var                                     0x10801f
#define nonstandard_SQUARE_ROOT_var                                   0x108020
#define nonstandard_CUBE_ROOT_var                                     0x108021
#define nonstandard_FOURTH_ROOT_var                                   0x108022
#define nonstandard_PROPORTIONAL_TO_var                               0x108023
#define nonstandard_DIVIDES_var                                       0x108024
#define nonstandard_DOES_NOT_DIVIDE_var                               0x108025
#define nonstandard_PARALLEL_TO_var                                   0x108026
#define nonstandard_NOT_PARALLEL_TO_var                               0x108027
#define nonstandard_INTERSECTION_var                                  0x108028
#define nonstandard_UNION_var                                         0x108029
#define nonstandard_TILDE_OPERATOR_var                                0x10802a
#define nonstandard_INVERTED_LAZY_S_var                               0x10802b
#define nonstandard_SINE_WAVE_var                                     0x10802c
#define nonstandard_NOT_TILDE_var                                     0x10802d
#define nonstandard_NOT_ASYMPTOTICALLY_EQUAL_TO_var                   0x10802e
#define nonstandard_NEITHER_APPROXIMATELY_NOR_ACTUALLY_EQUAL_TO_var   0x10802f
#define nonstandard_ALMOST_EQUAL_TO_var                               0x108030
#define nonstandard_NOT_ALMOST_EQUAL_TO_var                           0x108031
#define nonstandard_ALL_EQUAL_TO_var                                  0x108032
#define nonstandard_NOT_EQUAL_TO_var                                  0x108033
#define nonstandard_NOT_IDENTICAL_TO_var                              0x108034
#define nonstandard_LESS_THAN_BUT_NOT_EQUAL_TO_var                    0x108035
#define nonstandard_GREATER_THAN_BUT_NOT_EQUAL_TO_var                 0x108036
#define nonstandard_NOT_EQUIVALENT_TO_var                             0x108037
#define nonstandard_NOT_LESS_THAN_var                                 0x108038
#define nonstandard_NOT_GREATER_THAN_var                              0x108039
#define nonstandard_NEITHER_LESS_THAN_NOR_EQUAL_TO_var                0x10803a
#define nonstandard_NEITHER_GREATER_THAN_NOR_EQUAL_TO_var             0x10803b
#define nonstandard_LESS_THAN_OR_EQUIVALENT_TO_var                    0x10803c
#define nonstandard_GREATER_THAN_OR_EQUIVALENT_TO_var                 0x10803d
#define nonstandard_NEITHER_LESS_THAN_NOR_EQUIVALENT_TO_var           0x10803e
#define nonstandard_NEITHER_GREATER_THAN_NOR_EQUIVALENT_TO_var        0x10803f
#define nonstandard_NEITHER_LESS_THAN_NOR_GREATER_THAN_var            0x108040
#define nonstandard_NEITHER_GREATER_THAN_NOR_LESS_THAN_var            0x108041
#define nonstandard_DOES_NOT_PRECEDE_var                              0x108042
#define nonstandard_DOES_NOT_SUCCEED_var                              0x108043
#define nonstandard_NOT_A_SUBSET_OF_var                               0x108044
#define nonstandard_NOT_A_SUPERSET_OF_var                             0x108045
#define nonstandard_NEITHER_A_SUBSET_OF_NOR_EQUAL_TO_var              0x108046
#define nonstandard_NEITHER_A_SUPERSET_OF_NOR_EQUAL_TO_var            0x108047
#define nonstandard_SUBSET_OF_WITH_NOT_EQUAL_TO_var                   0x108048
#define nonstandard_SUPERSET_OF_WITH_NOT_EQUAL_TO_var                 0x108049
#define nonstandard_SQUARE_CAP_var                                    0x10804a
#define nonstandard_SQUARE_CUP_var                                    0x10804b
#define nonstandard_CIRCLED_PLUS_var                                  0x10804c
#define nonstandard_CIRCLED_TIMES_var                                 0x10804d
#define nonstandard_CIRCLED_EQUALS_var                                0x10804e
#define nonstandard_LESS_THAN_EQUAL_TO_OR_GREATER_THAN_var            0x10804f
#define nonstandard_GREATER_THAN_EQUAL_TO_OR_LESS_THAN_var            0x108050
#define nonstandard_DOES_NOT_PRECEDE_OR_EQUAL_var                     0x108051
#define nonstandard_DOES_NOT_SUCCEED_OR_EQUAL_var                     0x108052
#define nonstandard_NOT_NORMAL_SUBGROUP_OF_OR_EQUAL_TO_var            0x108053
#define nonstandard_DOES_NOT_CONTAIN_AS_NORMAL_SUBGROUP_OR_EQUAL_var  0x108054
#define nonstandard_FROWN_var                                         0x108055
#define nonstandard_SMILE_var                                         0x108056
#define nonstandard_OPEN_BOX_var                                      0x108057
#define nonstandard_SQUARE_WITH_DIAGONAL_CROSSHATCH_FILL_var          0x108058
#define nonstandard_INTERIOR_PRODUCT_var                              0x108059
#define nonstandard_RIGHTHAND_INTERIOR_PRODUCT_var                    0x10805a
#define nonstandard_SIMILAR_OR_LESS_THAN_var                          0x10805b
#define nonstandard_SIMILAR_OR_GREATER_THAN_var                       0x10805c
#define nonstandard_SMALLER_THAN_OR_EQUAL_TO_var                      0x10805d
#define nonstandard_LARGER_THAN_OR_EQUAL_TO_var                       0x10805e
#define nonstandard_SUBSET_OF_ABOVE_NOT_EQUAL_TO_var                  0x10805f
#define nonstandard_SUPERSET_OF_ABOVE_NOT_EQUAL_TO_var                0x108060
#define nonstandard_DOES_NOT_DIVIDE_WITH_REVERSED_NEGATION_SLASH_var  0x108061
#define nonstandard_Private_Use__First_nu                             0x108062
#define nonstandard_uniE001_nu                                        0x108063
#define nonstandard_uniE002_nu                                        0x108064
#define nonstandard_uniE003_nu                                        0x108065
#define nonstandard_uniE004_nu                                        0x108066
#define nonstandard_uniE005_nu                                        0x108067
#define nonstandard_uniE00A_nu                                        0x108068
#define nonstandard_uniE00B_nu                                        0x108069
#define nonstandard_uniE00E_nu                                        0x10806a
#define nonstandard_uniE00F_nu                                        0x10806b
#define nonstandard_uniE010_nu                                        0x10806c
#define nonstandard_uniE011_nu                                        0x10806d
#define nonstandard_uniE016_nu                                        0x10806e
#define nonstandard_uniE018_nu                                        0x10806f
#define nonstandard_uniE01E_nu                                        0x108070
#define nonstandard_uniE023_nu                                        0x108071
#define nonstandard_uniE025_nu                                        0x108072
#define nonstandard_uniE026_nu                                        0x108073
#define nonstandard_uniE027_nu                                        0x108074
#define nonstandard_uniE028_nu                                        0x108075
#define nonstandard_uniE029_nu                                        0x108076
#define nonstandard_uniE02A_nu                                        0x108077
#define nonstandard_uniE02B_nu                                        0x108078
#define nonstandard_uniE02F_nu                                        0x108079
#define nonstandard_uniE035_nu                                        0x10807a
#define nonstandard_uniE037_nu                                        0x10807b
#define nonstandard_uniE038_nu                                        0x10807c
#define nonstandard_uniE039_nu                                        0x10807d
#define nonstandard_uniE03A_nu                                        0x10807e
#define nonstandard_uniE03B_nu                                        0x10807f
#define nonstandard_uniE03C_nu                                        0x108080
#define nonstandard_uniE03D_nu                                        0x108081
#define nonstandard_uniE040_nu                                        0x108082
#define nonstandard_uniE041_nu                                        0x108083
#define nonstandard_uniE042_nu                                        0x108084
#define nonstandard_uniE043_nu                                        0x108085
#define nonstandard_uniE044_nu                                        0x108086
#define nonstandard_uniE045_nu                                        0x108087
#define nonstandard_uniE046_nu                                        0x108088
#define nonstandard_uniE04B_nu                                        0x108089
#define nonstandard_uniE04C_nu                                        0x10808a
#define nonstandard_uniE04D_nu                                        0x10808b
#define nonstandard_uniE04E_nu                                        0x10808c
#define nonstandard_uniE04F_nu                                        0x10808d
#define nonstandard_uniE050_nu                                        0x10808e
#define nonstandard_uniE051_nu                                        0x10808f
#define nonstandard_uniE052_nu                                        0x108090
#define nonstandard_uniE053_nu                                        0x108091
#define nonstandard_uniE054_nu                                        0x108092
#define nonstandard_uniE055_nu                                        0x108093
#define nonstandard_uniE056_nu                                        0x108094
#define nonstandard_uniE057_nu                                        0x108095
#define nonstandard_uniE059_nu                                        0x108096
#define nonstandard_uniE05A_nu                                        0x108097
#define nonstandard_uniE05B_nu                                        0x108098
#define nonstandard_uniE05C_nu                                        0x108099
#define nonstandard_uniE05D_nu                                        0x10809a
#define nonstandard_uniE05E_nu                                        0x10809b
#define nonstandard_uniE060_nu                                        0x10809c
#define nonstandard_uniE061_nu                                        0x10809d
#define nonstandard_uniE062_nu                                        0x10809e
#define nonstandard_uniE063_nu                                        0x10809f
#define nonstandard_uniE064_nu                                        0x1080a0
#define nonstandard_uniE065_nu                                        0x1080a1
#define nonstandard_uniE066_nu                                        0x1080a2
#define nonstandard_uniE067_nu                                        0x1080a3
#define nonstandard_uniE068_nu                                        0x1080a4
#define nonstandard_uniE06B_nu                                        0x1080a5
#define nonstandard_uniE06C_nu                                        0x1080a6
#define nonstandard_uniE06D_nu                                        0x1080a7
#define nonstandard_uniE06E_nu                                        0x1080a8
#define nonstandard_uniE06F_nu                                        0x1080a9
#define nonstandard_uniE070_nu                                        0x1080aa
#define nonstandard_uniE075_nu                                        0x1080ab
#define nonstandard_uniE076_nu                                        0x1080ac
#define nonstandard_uniE077_nu                                        0x1080ad
#define nonstandard_uniE07C_nu                                        0x1080ae
#define nonstandard_uniE07D_nu                                        0x1080af
#define nonstandard_uniE07E_nu                                        0x1080b0
#define nonstandard_uniE07F_nu                                        0x1080b1
#define nonstandard_uniE080_nu                                        0x1080b2
#define nonstandard_uniE081_nu                                        0x1080b3
#define nonstandard_uniE082_nu                                        0x1080b4
#define nonstandard_uniE083_nu                                        0x1080b5
#define nonstandard_uniE084_nu                                        0x1080b6
#define nonstandard_uniE085_nu                                        0x1080b7
#define nonstandard_uniE086_nu                                        0x1080b8
#define nonstandard_uniE087_nu                                        0x1080b9
#define nonstandard_uniE088_nu                                        0x1080ba
#define nonstandard_uniE089_nu                                        0x1080bb
#define nonstandard_uniE092_nu                                        0x1080bc
#define nonstandard_uniE093_nu                                        0x1080bd
#define nonstandard_uniE094_nu                                        0x1080be
#define nonstandard_uniE095_nu                                        0x1080bf
#define nonstandard_uniE096_nu                                        0x1080c0
#define nonstandard_uniE097_nu                                        0x1080c1
#define nonstandard_uniE098_nu                                        0x1080c2
#define nonstandard_uniE099_nu                                        0x1080c3
#define nonstandard_uniE09A_nu                                        0x1080c4
#define nonstandard_uniE09B_nu                                        0x1080c5
#define nonstandard_uniE09F_nu                                        0x1080c6
#define nonstandard_uniE0A0_nu                                        0x1080c7
#define nonstandard_uniE0A1_nu                                        0x1080c8
#define nonstandard_uniE0A2_nu                                        0x1080c9
#define nonstandard_uniE0A4_nu                                        0x1080ca
#define nonstandard_uniE0A5_nu                                        0x1080cb
#define nonstandard_uniE0A6_nu                                        0x1080cc
#define nonstandard_uniE0A7_nu                                        0x1080cd
#define nonstandard_uniE0A8_nu                                        0x1080ce
#define nonstandard_uniE0A9_nu                                        0x1080cf
#define nonstandard_uniE0AA_nu                                        0x1080d0
#define nonstandard_uniE0AB_nu                                        0x1080d1
#define nonstandard_uniE0AC_nu                                        0x1080d2
#define nonstandard_uniE0AD_nu                                        0x1080d3
#define nonstandard_uniE0AE_nu                                        0x1080d4
#define nonstandard_uniE0AF_nu                                        0x1080d5
#define nonstandard_uniE0B0_nu                                        0x1080d6
#define nonstandard_uniE0B1_nu                                        0x1080d7
#define nonstandard_uniE0B2_nu                                        0x1080d8
#define nonstandard_uniE0B3_nu                                        0x1080d9
#define nonstandard_uniE0B4_nu                                        0x1080da
#define nonstandard_uniE0B5_nu                                        0x1080db
#define nonstandard_uniE0B6_nu                                        0x1080dc
#define nonstandard_uniE0B7_nu                                        0x1080dd
#define nonstandard_uniE0B8_nu                                        0x1080de
#define nonstandard_uniE0B9_nu                                        0x1080df
#define nonstandard_uniE0BB_nu                                        0x1080e0
#define nonstandard_uniE0BC_nu                                        0x1080e1
#define nonstandard_uniE0BD_nu                                        0x1080e2
#define nonstandard_uniE0BE_nu                                        0x1080e3
#define nonstandard_uniE0BF_nu                                        0x1080e4
#define nonstandard_uniE0C0_nu                                        0x1080e5
#define nonstandard_uniE0C1_nu                                        0x1080e6
#define nonstandard_uniE0C2_nu                                        0x1080e7
#define nonstandard_uniE0C3_nu                                        0x1080e8
#define nonstandard_uniE0C4_nu                                        0x1080e9
#define nonstandard_uniE0C5_nu                                        0x1080ea
#define nonstandard_uniE0C6_nu                                        0x1080eb
#define nonstandard_uniE0C7_nu                                        0x1080ec
#define nonstandard_uniE0C8_nu                                        0x1080ed
#define nonstandard_uniE0C9_nu                                        0x1080ee
#define nonstandard_uniE0CA_nu                                        0x1080ef
#define nonstandard_uniE0CB_nu                                        0x1080f0
#define nonstandard_uniE0CC_nu                                        0x1080f1
#define nonstandard_uniE0CD_nu                                        0x1080f2
#define nonstandard_uniE0CE_nu                                        0x1080f3
#define nonstandard_uniE0CF_nu                                        0x1080f4
#define nonstandard_uniE0D0_nu                                        0x1080f5
#define nonstandard_uniE0D1_nu                                        0x1080f6
#define nonstandard_uniE0D2_nu                                        0x1080f7
#define nonstandard_uniE0D3_nu                                        0x1080f8
#define nonstandard_uniE0D4_nu                                        0x1080f9
#define nonstandard_uniE0D5_nu                                        0x1080fa
#define nonstandard_uniE0D6_nu                                        0x1080fb
#define nonstandard_uniE0D7_nu                                        0x1080fc
#define nonstandard_uniE0D8_nu                                        0x1080fd
#define nonstandard_uniE0D9_nu                                        0x1080fe
#define nonstandard_uniE0DA_nu                                        0x1080ff
#define nonstandard_uniE0DB_nu                                        0x108100
#define nonstandard_uniE0DC_nu                                        0x108101
#define nonstandard_uniE0DD_nu                                        0x108102
#define nonstandard_uniE0DE_nu                                        0x108103
#define nonstandard_uniE0DF_nu                                        0x108104
#define nonstandard_uniE0E0_nu                                        0x108105
#define nonstandard_uniE0E1_nu                                        0x108106
#define nonstandard_uniE0E2_nu                                        0x108107
#define nonstandard_uniE0E3_nu                                        0x108108
#define nonstandard_uniE0E4_nu                                        0x108109
#define nonstandard_uniE0E5_nu                                        0x10810a
#define nonstandard_uniE0E6_nu                                        0x10810b
#define nonstandard_uniE0E7_nu                                        0x10810c
#define nonstandard_uniE0E8_nu                                        0x10810d
#define nonstandard_uniE0E9_nu                                        0x10810e
#define nonstandard_uniE0EA_nu                                        0x10810f
#define nonstandard_uniE0EB_nu                                        0x108110
#define nonstandard_uniE0EC_nu                                        0x108111
#define nonstandard_uniE0ED_nu                                        0x108112
#define nonstandard_uniE0EE_nu                                        0x108113
#define nonstandard_uniE0EF_nu                                        0x108114
#define nonstandard_uniE0F1_nu                                        0x108115
#define nonstandard_uniE0F2_nu                                        0x108116
#define nonstandard_uniE0F3_nu                                        0x108117
#define nonstandard_uniE0F4_nu                                        0x108118
#define nonstandard_uniE0F5_nu                                        0x108119
#define nonstandard_uniE0F6_nu                                        0x10811a
#define nonstandard_uniE0F7_nu                                        0x10811b
#define nonstandard_uniE0F8_nu                                        0x10811c
#define nonstandard_uniE0F9_nu                                        0x10811d
#define nonstandard_uniE0FA_nu                                        0x10811e
#define nonstandard_uniE0FB_nu                                        0x10811f
#define nonstandard_uniE0FC_nu                                        0x108120
#define nonstandard_uniE0FD_nu                                        0x108121
#define nonstandard_uniE0FE_nu                                        0x108122
#define nonstandard_uniE0FF_nu                                        0x108123
#define nonstandard_uniE100_nu                                        0x108124
#define nonstandard_uniE101_nu                                        0x108125
#define nonstandard_uniE102_nu                                        0x108126
#define nonstandard_uniE103_nu                                        0x108127
#define nonstandard_uniE104_nu                                        0x108128
#define nonstandard_uniE105_nu                                        0x108129
#define nonstandard_uniE106_nu                                        0x10812a
#define nonstandard_uniE107_nu                                        0x10812b
#define nonstandard_uniE108_nu                                        0x10812c
#define nonstandard_uniE109_nu                                        0x10812d
#define nonstandard_uniE10A_nu                                        0x10812e
#define nonstandard_uniE10C_nu                                        0x10812f
#define nonstandard_uniE10D_nu                                        0x108130
#define nonstandard_UPWARDS_DOUBLE_ARROW_x                            0x108131
#define nonstandard_LEFTWARDS_DOUBLE_ARROW_x                          0x108132
#define nonstandard_uniE110_nu                                        0x108133
#define nonstandard_uniE111_nu                                        0x108134
#define nonstandard_uniE112_nu                                        0x108135
#define nonstandard_uniE113_nu                                        0x108136
#define nonstandard_uniE114_nu                                        0x108137
#define nonstandard_uniE115_nu                                        0x108138
#define nonstandard_uniE116_nu                                        0x108139
#define nonstandard_uniE117_nu                                        0x10813a
#define nonstandard_uniE118_nu                                        0x10813b
#define nonstandard_uniE119_nu                                        0x10813c
#define nonstandard_uniE11A_nu                                        0x10813d
#define nonstandard_uniE11B_nu                                        0x10813e
#define nonstandard_uniE11C_nu                                        0x10813f
#define nonstandard_uniE11D_nu                                        0x108140
#define nonstandard_uniE11E_nu                                        0x108141
#define nonstandard_uniE11F_nu                                        0x108142
#define nonstandard_uniE120_nu                                        0x108143
#define nonstandard_uniE121_nu                                        0x108144
#define nonstandard_uniE122_nu                                        0x108145
#define nonstandard_uniE123_nu                                        0x108146
#define nonstandard_uniE124_nu                                        0x108147
#define nonstandard_uniE125_nu                                        0x108148
#define nonstandard_uniE126_nu                                        0x108149
#define nonstandard_uniE127_nu                                        0x10814a
#define nonstandard_uniE128_nu                                        0x10814b
#define nonstandard_uniE129_nu                                        0x10814c
#define nonstandard_uniE12A_nu                                        0x10814d
#define nonstandard_uniE12B_nu                                        0x10814e
#define nonstandard_uniE12C_nu                                        0x10814f
#define nonstandard_uniE12D_nu                                        0x108150
#define nonstandard_uniE12E_nu                                        0x108151
#define nonstandard_uniE12F_nu                                        0x108152
#define nonstandard_uniE130_nu                                        0x108153
#define nonstandard_uniE131_nu                                        0x108154
#define nonstandard_uniE132_nu                                        0x108155
#define nonstandard_uniE133_nu                                        0x108156
#define nonstandard_LEFTWARDS_TRIPLE_ARROW_x                          0x108157
#define nonstandard_UPWARDS_TRIPLE_ARROW_x                            0x108158
#define nonstandard_LEFTWARDS_QUADRUPLE_ARROW_x                       0x108159
#define nonstandard_UPWARDS_QUADRUPLE_ARROW_x                         0x10815a
#define nonstandard_COMBINING_LEFT_ARROW_ABOVE_x                      0x10815b
#define nonstandard_COMBINING_LEFT_ARROW_BELOW_x                      0x10815c
#define nonstandard_uniE13A_nu                                        0x10815d
#define nonstandard_TOP_CURLY_BRACKET_l                               0x10815e
#define nonstandard_TOP_CURLY_BRACKET_r                               0x10815f
#define nonstandard_BOTTOM_CURLY_BRACKET_l                            0x108160
#define nonstandard_BOTTOM_CURLY_BRACKET_r                            0x108161
#define nonstandard_uniE13F_nu                                        0x108162
#define nonstandard_TOP_CURLY_BRACKET_m                               0x108163
#define nonstandard_BOTTOM_CURLY_BRACKET_m                            0x108164
#define nonstandard_TOP_PARENTHESIS_l                                 0x108165
#define nonstandard_TOP_PARENTHESIS_r                                 0x108166
#define nonstandard_BOTTOM_PARENTHESIS_l                              0x108167
#define nonstandard_BOTTOM_PARENTHESIS_r                              0x108168
#define nonstandard_TOP_SQUARE_BRACKET_l                              0x108169
#define nonstandard_TOP_SQUARE_BRACKET_r                              0x10816a
#define nonstandard_BOTTOM_SQUARE_BRACKET_l                           0x10816b
#define nonstandard_BOTTOM_SQUARE_BRACKET_r                           0x10816c
#define nonstandard_TOP_SQUARE_BRACKET_x                              0x10816d
#define nonstandard_BOTTOM_SQUARE_BRACKET_x                           0x10816e
#define nonstandard_uniE14C_nu                                        0x10816f
#define nonstandard_uniE14D_nu                                        0x108170
#define nonstandard_uniE14E_nu                                        0x108171
#define nonstandard_uniE14F_nu                                        0x108172
#define nonstandard_uniE150_nu                                        0x108173
#define nonstandard_uniE151_nu                                        0x108174
#define nonstandard_uniE152_nu                                        0x108175
#define nonstandard_uniE153_nu                                        0x108176
#define nonstandard_uniE17C_nu                                        0x108177
#define nonstandard_uniE17D_nu                                        0x108178
#define nonstandard_uniE17E_nu                                        0x108179
#define nonstandard_uniE17F_nu                                        0x10817a
#define nonstandard_uniE180_nu                                        0x10817b
#define nonstandard_uniE181_nu                                        0x10817c
#define nonstandard_uniE182_nu                                        0x10817d
#define nonstandard_uniE183_nu                                        0x10817e
#define nonstandard_uniE184_nu                                        0x10817f
#define nonstandard_uniE185_nu                                        0x108180
#define nonstandard_uniE186_nu                                        0x108181
#define nonstandard_uniE187_nu                                        0x108182
#define nonstandard_uniE188_nu                                        0x108183
#define nonstandard_uniE189_nu                                        0x108184
#define nonstandard_uniE18A_nu                                        0x108185
#define nonstandard_uniE18B_nu                                        0x108186
#define nonstandard_uniE18C_nu                                        0x108187
#define nonstandard_uniE18D_nu                                        0x108188
#define nonstandard_uniE18E_nu                                        0x108189
#define nonstandard_uniE18F_nu                                        0x10818a
#define nonstandard_uniE190_nu                                        0x10818b
#define nonstandard_uniE191_nu                                        0x10818c
#define nonstandard_uniE192_nu                                        0x10818d
#define nonstandard_uniE193_nu                                        0x10818e
#define nonstandard_uniE194_nu                                        0x10818f
#define nonstandard_uniE195_nu                                        0x108190
#define nonstandard_uniE196_nu                                        0x108191
#define nonstandard_uniE197_nu                                        0x108192
#define nonstandard_uniE198_nu                                        0x108193
#define nonstandard_uniE199_nu                                        0x108194
#define nonstandard_uniE19A_nu                                        0x108195
#define nonstandard_uniE19B_nu                                        0x108196
#define nonstandard_uniE19C_nu                                        0x108197
#define nonstandard_uniE19D_nu                                        0x108198
#define nonstandard_uniE19E_nu                                        0x108199
#define nonstandard_uniE19F_nu                                        0x10819a
#define nonstandard_uniE1A0_nu                                        0x10819b
#define nonstandard_uniE1A1_nu                                        0x10819c
#define nonstandard_uniE1A2_nu                                        0x10819d
#define nonstandard_uniE1A3_nu                                        0x10819e
#define nonstandard_uniE1A4_nu                                        0x10819f
#define nonstandard_uniE1A5_nu                                        0x1081a0
#define nonstandard_uniE1A6_nu                                        0x1081a1
#define nonstandard_uniE1A7_nu                                        0x1081a2
#define nonstandard_uniE1A8_nu                                        0x1081a3
#define nonstandard_uniE1A9_nu                                        0x1081a4
#define nonstandard_uniE1AA_nu                                        0x1081a5
#define nonstandard_uniE1AB_nu                                        0x1081a6
#define nonstandard_uniE1AC_nu                                        0x1081a7
#define nonstandard_uniE1AD_nu                                        0x1081a8
#define nonstandard_uniE1AE_nu                                        0x1081a9
#define nonstandard_uniE1AF_nu                                        0x1081aa
#define nonstandard_uniE1B0_nu                                        0x1081ab
#define nonstandard_uniE1B1_nu                                        0x1081ac
#define nonstandard_uniE1B2_nu                                        0x1081ad
#define nonstandard_uniE1B3_nu                                        0x1081ae
#define nonstandard_uniE261_nu                                        0x1081af
#define nonstandard_uniE265_nu                                        0x1081b0
#define nonstandard_uniE269_nu                                        0x1081b1
#define nonstandard_uniE26D_nu                                        0x1081b2
#define nonstandard_uniE271_nu                                        0x1081b3
#define nonstandard_uniE275_nu                                        0x1081b4
#define nonstandard_uniE279_nu                                        0x1081b5
#define nonstandard_uniE27D_nu                                        0x1081b6
#define nonstandard_uniE281_nu                                        0x1081b7
#define nonstandard_uniE285_nu                                        0x1081b8
#define nonstandard_uniE28C_nu                                        0x1081b9
#define nonstandard_uniE28D_nu                                        0x1081ba
#define nonstandard_uniE28E_nu                                        0x1081bb
#define nonstandard_uniE28F_nu                                        0x1081bc
#define nonstandard_uniE290_nu                                        0x1081bd
#define nonstandard_uniE291_nu                                        0x1081be
#define nonstandard_uniE292_nu                                        0x1081bf
#define nonstandard_uniE293_nu                                        0x1081c0
#define nonstandard_uniE2FC_nu                                        0x1081c1
#define nonstandard_uniE2FE_nu                                        0x1081c2
#define nonstandard_uniE300_nu                                        0x1081c3
#define nonstandard_uniE302_nu                                        0x1081c4
#define nonstandard_uniE304_nu                                        0x1081c5
#define nonstandard_uniE306_nu                                        0x1081c6
#define nonstandard_uniE308_nu                                        0x1081c7
#define nonstandard_uniE30A_nu                                        0x1081c8
#define nonstandard_uniE30C_nu                                        0x1081c9
#define nonstandard_uniE30E_nu                                        0x1081ca
#define nonstandard_uniE310_nu                                        0x1081cb
#define nonstandard_uniE312_nu                                        0x1081cc
#define nonstandard_uniE314_nu                                        0x1081cd
#define nonstandard_uniE316_nu                                        0x1081ce
#define nonstandard_uniE318_nu                                        0x1081cf
#define nonstandard_uniE31A_nu                                        0x1081d0
#define nonstandard_uniE31C_nu                                        0x1081d1
#define nonstandard_uniE31E_nu                                        0x1081d2
#define nonstandard_uniE320_nu                                        0x1081d3
#define nonstandard_uniE322_nu                                        0x1081d4
#define nonstandard_uniE324_nu                                        0x1081d5
#define nonstandard_uniE326_nu                                        0x1081d6
#define nonstandard_uniE328_nu                                        0x1081d7
#define nonstandard_uniE32A_nu                                        0x1081d8
#define nonstandard_uniE364_nu                                        0x1081d9
#define nonstandard_uniE368_nu                                        0x1081da
#define nonstandard_uniE36C_nu                                        0x1081db
#define nonstandard_uniE370_nu                                        0x1081dc
#define nonstandard_uniE3C2_nu                                        0x1081dd
#define nonstandard_uniE3C3_nu                                        0x1081de
#define nonstandard_uniE3C4_nu                                        0x1081df
#define nonstandard_uniE3C7_nu                                        0x1081e0
#define nonstandard_uniE3C8_nu                                        0x1081e1
#define nonstandard_parenleft_s1                                      0x1081e2
#define nonstandard_parenright_s1                                     0x1081e3
#define nonstandard_slash_s1                                          0x1081e4
#define nonstandard_bracketleft_s1                                    0x1081e5
#define nonstandard_bracketright_s1                                   0x1081e6
#define nonstandard_underscore_s1                                     0x1081e7
#define nonstandard_braceleft_s1                                      0x1081e8
#define nonstandard_braceright_s1                                     0x1081e9
#define nonstandard_REVERSE_SOLIDUS_s1                                0x1081ea
#define nonstandard_MODIFIER_LETTER_CIRCUMFLEX_ACCENT_s1              0x1081eb
#define nonstandard_SMALL_TILDE_s1                                    0x1081ec
#define nonstandard_OVERLINE_s1                                       0x1081ed
#define nonstandard_CARON_s1                                          0x1081ee
#define nonstandard_MODIFIER_LETTER_LOW_TILDE_s1                      0x1081ef
#define nonstandard_COMBINING_CIRCUMFLEX_ACCENT_s1                    0x1081f0
#define nonstandard_COMBINING_TILDE_s1                                0x1081f1
#define nonstandard_COMBINING_OVERLINE_s1                             0x1081f2
#define nonstandard_COMBINING_CARON_s1                                0x1081f3
#define nonstandard_COMBINING_TILDE_BELOW_s1                          0x1081f4
#define nonstandard_COMBINING_LOW_LINE_s1                             0x1081f5
#define nonstandard_COMBINING_LONG_SOLIDUS_OVERLAY_s1                 0x1081f6
#define nonstandard_COMBINING_LEFT_HARPOON_ABOVE_s1                   0x1081f7
#define nonstandard_COMBINING_RIGHT_HARPOON_ABOVE_s1                  0x1081f8
#define nonstandard_COMBINING_LEFT_ARROW_ABOVE_s1                     0x1081f9
#define nonstandard_COMBINING_RIGHT_ARROW_ABOVE_s1                    0x1081fa
#define nonstandard_COMBINING_RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS_s1 0x1081fb
#define nonstandard_COMBINING_LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS_s1 0x1081fc
#define nonstandard_COMBINING_LEFT_ARROW_BELOW_s1                     0x1081fd
#define nonstandard_COMBINING_RIGHT_ARROW_BELOW_s1                    0x1081fe
#define nonstandard_DOUBLE_STRUCK_N_ARY_SUMMATION_s1                  0x1081ff
#define nonstandard_N_ARY_PRODUCT_s1                                  0x108200
#define nonstandard_N_ARY_COPRODUCT_s1                                0x108201
#define nonstandard_N_ARY_SUMMATION_s1                                0x108202
#define nonstandard_SQUARE_ROOT_s1                                    0x108203
#define nonstandard_CUBE_ROOT_s1                                      0x108204
#define nonstandard_FOURTH_ROOT_s1                                    0x108205
#define nonstandard_N_ARY_LOGICAL_AND_s1                              0x108206
#define nonstandard_N_ARY_LOGICAL_OR_s1                               0x108207
#define nonstandard_N_ARY_INTERSECTION_s1                             0x108208
#define nonstandard_N_ARY_UNION_s1                                    0x108209
#define nonstandard_LEFT_CEILING_s1                                   0x10820a
#define nonstandard_RIGHT_CEILING_s1                                  0x10820b
#define nonstandard_LEFT_FLOOR_s1                                     0x10820c
#define nonstandard_RIGHT_FLOOR_s1                                    0x10820d
#define nonstandard_TOP_HALF_INTEGRAL_s1                              0x10820e
#define nonstandard_BOTTOM_HALF_INTEGRAL_s1                           0x10820f
#define nonstandard_LEFT_PARENTHESIS_UPPER_HOOK_s1                    0x108210
#define nonstandard_LEFT_PARENTHESIS_EXTENSION_s1                     0x108211
#define nonstandard_LEFT_PARENTHESIS_LOWER_HOOK_s1                    0x108212
#define nonstandard_RIGHT_PARENTHESIS_UPPER_HOOK_s1                   0x108213
#define nonstandard_RIGHT_PARENTHESIS_EXTENSION_s1                    0x108214
#define nonstandard_RIGHT_PARENTHESIS_LOWER_HOOK_s1                   0x108215
#define nonstandard_LEFT_SQUARE_BRACKET_UPPER_CORNER_s1               0x108216
#define nonstandard_LEFT_SQUARE_BRACKET_EXTENSION_s1                  0x108217
#define nonstandard_LEFT_SQUARE_BRACKET_LOWER_CORNER_s1               0x108218
#define nonstandard_RIGHT_SQUARE_BRACKET_UPPER_CORNER_s1              0x108219
#define nonstandard_RIGHT_SQUARE_BRACKET_EXTENSION_s1                 0x10821a
#define nonstandard_RIGHT_SQUARE_BRACKET_LOWER_CORNER_s1              0x10821b
#define nonstandard_LEFT_CURLY_BRACKET_UPPER_HOOK_s1                  0x10821c
#define nonstandard_LEFT_CURLY_BRACKET_MIDDLE_PIECE_s1                0x10821d
#define nonstandard_LEFT_CURLY_BRACKET_LOWER_HOOK_s1                  0x10821e
#define nonstandard_CURLY_BRACKET_EXTENSION_s1                        0x10821f
#define nonstandard_RIGHT_CURLY_BRACKET_UPPER_HOOK_s1                 0x108220
#define nonstandard_RIGHT_CURLY_BRACKET_MIDDLE_PIECE_s1               0x108221
#define nonstandard_RIGHT_CURLY_BRACKET_LOWER_HOOK_s1                 0x108222
#define nonstandard_INTEGRAL_EXTENSION_s1                             0x108223
#define nonstandard_UPPER_LEFT_OR_LOWER_RIGHT_CURLY_BRACKET_SECTION_s1 0x108224
#define nonstandard_UPPER_RIGHT_OR_LOWER_LEFT_CURLY_BRACKET_SECTION_s1 0x108225
#define nonstandard_SUMMATION_TOP_s1                                  0x108226
#define nonstandard_SUMMATION_BOTTOM_s1                               0x108227
#define nonstandard_TOP_SQUARE_BRACKET_s1                             0x108228
#define nonstandard_BOTTOM_SQUARE_BRACKET_s1                          0x108229
#define nonstandard_RADICAL_SYMBOL_BOTTOM_s1                          0x10822a
#define nonstandard_LEFT_VERTICAL_BOX_LINE_s1                         0x10822b
#define nonstandard_RIGHT_VERTICAL_BOX_LINE_s1                        0x10822c
#define nonstandard_TOP_PARENTHESIS_s1                                0x10822d
#define nonstandard_BOTTOM_PARENTHESIS_s1                             0x10822e
#define nonstandard_TOP_CURLY_BRACKET_s1                              0x10822f
#define nonstandard_BOTTOM_CURLY_BRACKET_s1                           0x108230
#define nonstandard_TOP_TORTOISE_SHELL_BRACKET_s1                     0x108231
#define nonstandard_BOTTOM_TORTOISE_SHELL_BRACKET_s1                  0x108232
#define nonstandard_LIGHT_LEFT_TORTOISE_SHELL_BRACKET_ORNAMENT_s1     0x108233
#define nonstandard_LIGHT_RIGHT_TORTOISE_SHELL_BRACKET_ORNAMENT_s1    0x108234
#define nonstandard_MATHEMATICAL_LEFT_WHITE_SQUARE_BRACKET_s1         0x108235
#define nonstandard_MATHEMATICAL_RIGHT_WHITE_SQUARE_BRACKET_s1        0x108236
#define nonstandard_MATHEMATICAL_LEFT_ANGLE_BRACKET_s1                0x108237
#define nonstandard_MATHEMATICAL_RIGHT_ANGLE_BRACKET_s1               0x108238
#define nonstandard_MATHEMATICAL_LEFT_DOUBLE_ANGLE_BRACKET_s1         0x108239
#define nonstandard_MATHEMATICAL_RIGHT_DOUBLE_ANGLE_BRACKET_s1        0x10823a
#define nonstandard_LEFT_WHITE_CURLY_BRACKET_s1                       0x10823b
#define nonstandard_RIGHT_WHITE_CURLY_BRACKET_s1                      0x10823c
#define nonstandard_LEFT_WHITE_PARENTHESIS_s1                         0x10823d
#define nonstandard_RIGHT_WHITE_PARENTHESIS_s1                        0x10823e
#define nonstandard_BIG_SOLIDUS_s1                                    0x10823f
#define nonstandard_BIG_REVERSE_SOLIDUS_s1                            0x108240
#define nonstandard_N_ARY_CIRCLED_DOT_OPERATOR_s1                     0x108241
#define nonstandard_N_ARY_CIRCLED_PLUS_OPERATOR_s1                    0x108242
#define nonstandard_N_ARY_CIRCLED_TIMES_OPERATOR_s1                   0x108243
#define nonstandard_N_ARY_UNION_OPERATOR_WITH_DOT_s1                  0x108244
#define nonstandard_N_ARY_UNION_OPERATOR_WITH_PLUS_s1                 0x108245
#define nonstandard_N_ARY_SQUARE_INTERSECTION_OPERATOR_s1             0x108246
#define nonstandard_N_ARY_SQUARE_UNION_OPERATOR_s1                    0x108247
#define nonstandard_TWO_LOGICAL_AND_OPERATOR_s1                       0x108248
#define nonstandard_TWO_LOGICAL_OR_OPERATOR_s1                        0x108249
#define nonstandard_N_ARY_TIMES_OPERATOR_s1                           0x10824a
#define nonstandard_MODULO_TWO_SUM_s1                                 0x10824b
#define nonstandard_LARGE_TRIPLE_VERTICAL_BAR_OPERATOR_s1             0x10824c
#define nonstandard_N_ARY_WHITE_VERTICAL_BAR_s1                       0x10824d
#define nonstandard_parenleft_s2                                      0x10824e
#define nonstandard_parenright_s2                                     0x10824f
#define nonstandard_slash_s2                                          0x108250
#define nonstandard_bracketleft_s2                                    0x108251
#define nonstandard_bracketright_s2                                   0x108252
#define nonstandard_underscore_s2                                     0x108253
#define nonstandard_braceleft_s2                                      0x108254
#define nonstandard_braceright_s2                                     0x108255
#define nonstandard_REVERSE_SOLIDUS_s2                                0x108256
#define nonstandard_MODIFIER_LETTER_CIRCUMFLEX_ACCENT_s2              0x108257
#define nonstandard_SMALL_TILDE_s2                                    0x108258
#define nonstandard_OVERLINE_s2                                       0x108259
#define nonstandard_CARON_s2                                          0x10825a
#define nonstandard_MODIFIER_LETTER_LOW_TILDE_s2                      0x10825b
#define nonstandard_COMBINING_CIRCUMFLEX_ACCENT_s2                    0x10825c
#define nonstandard_COMBINING_TILDE_s2                                0x10825d
#define nonstandard_COMBINING_OVERLINE_s2                             0x10825e
#define nonstandard_COMBINING_CARON_s2                                0x10825f
#define nonstandard_COMBINING_TILDE_BELOW_s2                          0x108260
#define nonstandard_COMBINING_LOW_LINE_s2                             0x108261
#define nonstandard_COMBINING_LONG_SOLIDUS_OVERLAY_s2                 0x108262
#define nonstandard_COMBINING_LEFT_HARPOON_ABOVE_s2                   0x108263
#define nonstandard_COMBINING_RIGHT_HARPOON_ABOVE_s2                  0x108264
#define nonstandard_COMBINING_LEFT_ARROW_ABOVE_s2                     0x108265
#define nonstandard_COMBINING_RIGHT_ARROW_ABOVE_s2                    0x108266
#define nonstandard_COMBINING_RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS_s2 0x108267
#define nonstandard_COMBINING_LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS_s2 0x108268
#define nonstandard_COMBINING_LEFT_ARROW_BELOW_s2                     0x108269
#define nonstandard_COMBINING_RIGHT_ARROW_BELOW_s2                    0x10826a
#define nonstandard_SQUARE_ROOT_s2                                    0x10826b
#define nonstandard_CUBE_ROOT_s2                                      0x10826c
#define nonstandard_FOURTH_ROOT_s2                                    0x10826d
#define nonstandard_LEFT_CEILING_s2                                   0x10826e
#define nonstandard_RIGHT_CEILING_s2                                  0x10826f
#define nonstandard_LEFT_FLOOR_s2                                     0x108270
#define nonstandard_RIGHT_FLOOR_s2                                    0x108271
#define nonstandard_TOP_SQUARE_BRACKET_s2                             0x108272
#define nonstandard_BOTTOM_SQUARE_BRACKET_s2                          0x108273
#define nonstandard_TOP_PARENTHESIS_s2                                0x108274
#define nonstandard_BOTTOM_PARENTHESIS_s2                             0x108275
#define nonstandard_TOP_CURLY_BRACKET_s2                              0x108276
#define nonstandard_BOTTOM_CURLY_BRACKET_s2                           0x108277
#define nonstandard_TOP_TORTOISE_SHELL_BRACKET_s2                     0x108278
#define nonstandard_BOTTOM_TORTOISE_SHELL_BRACKET_s2                  0x108279
#define nonstandard_LIGHT_LEFT_TORTOISE_SHELL_BRACKET_ORNAMENT_s2     0x10827a
#define nonstandard_LIGHT_RIGHT_TORTOISE_SHELL_BRACKET_ORNAMENT_s2    0x10827b
#define nonstandard_MATHEMATICAL_LEFT_WHITE_SQUARE_BRACKET_s2         0x10827c
#define nonstandard_MATHEMATICAL_RIGHT_WHITE_SQUARE_BRACKET_s2        0x10827d
#define nonstandard_MATHEMATICAL_LEFT_ANGLE_BRACKET_s2                0x10827e
#define nonstandard_MATHEMATICAL_RIGHT_ANGLE_BRACKET_s2               0x10827f
#define nonstandard_MATHEMATICAL_LEFT_DOUBLE_ANGLE_BRACKET_s2         0x108280
#define nonstandard_MATHEMATICAL_RIGHT_DOUBLE_ANGLE_BRACKET_s2        0x108281
#define nonstandard_LEFT_WHITE_CURLY_BRACKET_s2                       0x108282
#define nonstandard_RIGHT_WHITE_CURLY_BRACKET_s2                      0x108283
#define nonstandard_LEFT_WHITE_PARENTHESIS_s2                         0x108284
#define nonstandard_RIGHT_WHITE_PARENTHESIS_s2                        0x108285
#define nonstandard_LARGE_TRIPLE_VERTICAL_BAR_OPERATOR_s2             0x108286
#define nonstandard_parenleft_s3                                      0x108287
#define nonstandard_parenright_s3                                     0x108288
#define nonstandard_slash_s3                                          0x108289
#define nonstandard_bracketleft_s3                                    0x10828a
#define nonstandard_bracketright_s3                                   0x10828b
#define nonstandard_underscore_s3                                     0x10828c
#define nonstandard_braceleft_s3                                      0x10828d
#define nonstandard_braceright_s3                                     0x10828e
#define nonstandard_REVERSE_SOLIDUS_s3                                0x10828f
#define nonstandard_MODIFIER_LETTER_CIRCUMFLEX_ACCENT_s3              0x108290
#define nonstandard_SMALL_TILDE_s3                                    0x108291
#define nonstandard_OVERLINE_s3                                       0x108292
#define nonstandard_CARON_s3                                          0x108293
#define nonstandard_MODIFIER_LETTER_LOW_TILDE_s3                      0x108294
#define nonstandard_COMBINING_CIRCUMFLEX_ACCENT_s3                    0x108295
#define nonstandard_COMBINING_TILDE_s3                                0x108296
#define nonstandard_COMBINING_OVERLINE_s3                             0x108297
#define nonstandard_COMBINING_CARON_s3                                0x108298
#define nonstandard_COMBINING_TILDE_BELOW_s3                          0x108299
#define nonstandard_COMBINING_LOW_LINE_s3                             0x10829a
#define nonstandard_COMBINING_LONG_SOLIDUS_OVERLAY_s3                 0x10829b
#define nonstandard_COMBINING_LEFT_HARPOON_ABOVE_s3                   0x10829c
#define nonstandard_COMBINING_RIGHT_HARPOON_ABOVE_s3                  0x10829d
#define nonstandard_COMBINING_LEFT_ARROW_ABOVE_s3                     0x10829e
#define nonstandard_COMBINING_RIGHT_ARROW_ABOVE_s3                    0x10829f
#define nonstandard_COMBINING_RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS_s3 0x1082a0
#define nonstandard_COMBINING_LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS_s3 0x1082a1
#define nonstandard_COMBINING_LEFT_ARROW_BELOW_s3                     0x1082a2
#define nonstandard_COMBINING_RIGHT_ARROW_BELOW_s3                    0x1082a3
#define nonstandard_SQUARE_ROOT_s3                                    0x1082a4
#define nonstandard_CUBE_ROOT_s3                                      0x1082a5
#define nonstandard_FOURTH_ROOT_s3                                    0x1082a6
#define nonstandard_LEFT_CEILING_s3                                   0x1082a7
#define nonstandard_RIGHT_CEILING_s3                                  0x1082a8
#define nonstandard_LEFT_FLOOR_s3                                     0x1082a9
#define nonstandard_RIGHT_FLOOR_s3                                    0x1082aa
#define nonstandard_TOP_SQUARE_BRACKET_s3                             0x1082ab
#define nonstandard_BOTTOM_SQUARE_BRACKET_s3                          0x1082ac
#define nonstandard_TOP_PARENTHESIS_s3                                0x1082ad
#define nonstandard_BOTTOM_PARENTHESIS_s3                             0x1082ae
#define nonstandard_TOP_CURLY_BRACKET_s3                              0x1082af
#define nonstandard_BOTTOM_CURLY_BRACKET_s3                           0x1082b0
#define nonstandard_TOP_TORTOISE_SHELL_BRACKET_s3                     0x1082b1
#define nonstandard_BOTTOM_TORTOISE_SHELL_BRACKET_s3                  0x1082b2
#define nonstandard_LIGHT_LEFT_TORTOISE_SHELL_BRACKET_ORNAMENT_s3     0x1082b3
#define nonstandard_LIGHT_RIGHT_TORTOISE_SHELL_BRACKET_ORNAMENT_s3    0x1082b4
#define nonstandard_MATHEMATICAL_LEFT_WHITE_SQUARE_BRACKET_s3         0x1082b5
#define nonstandard_MATHEMATICAL_RIGHT_WHITE_SQUARE_BRACKET_s3        0x1082b6
#define nonstandard_MATHEMATICAL_LEFT_ANGLE_BRACKET_s3                0x1082b7
#define nonstandard_MATHEMATICAL_RIGHT_ANGLE_BRACKET_s3               0x1082b8
#define nonstandard_MATHEMATICAL_LEFT_DOUBLE_ANGLE_BRACKET_s3         0x1082b9
#define nonstandard_MATHEMATICAL_RIGHT_DOUBLE_ANGLE_BRACKET_s3        0x1082ba
#define nonstandard_LEFT_WHITE_CURLY_BRACKET_s3                       0x1082bb
#define nonstandard_RIGHT_WHITE_CURLY_BRACKET_s3                      0x1082bc
#define nonstandard_LEFT_WHITE_PARENTHESIS_s3                         0x1082bd
#define nonstandard_RIGHT_WHITE_PARENTHESIS_s3                        0x1082be
#define nonstandard_parenleft_s4                                      0x1082bf
#define nonstandard_parenright_s4                                     0x1082c0
#define nonstandard_slash_s4                                          0x1082c1
#define nonstandard_bracketleft_s4                                    0x1082c2
#define nonstandard_bracketright_s4                                   0x1082c3
#define nonstandard_underscore_s4                                     0x1082c4
#define nonstandard_braceleft_s4                                      0x1082c5
#define nonstandard_braceright_s4                                     0x1082c6
#define nonstandard_REVERSE_SOLIDUS_s4                                0x1082c7
#define nonstandard_MODIFIER_LETTER_CIRCUMFLEX_ACCENT_s4              0x1082c8
#define nonstandard_SMALL_TILDE_s4                                    0x1082c9
#define nonstandard_OVERLINE_s4                                       0x1082ca
#define nonstandard_CARON_s4                                          0x1082cb
#define nonstandard_MODIFIER_LETTER_LOW_TILDE_s4                      0x1082cc
#define nonstandard_COMBINING_CIRCUMFLEX_ACCENT_s4                    0x1082cd
#define nonstandard_COMBINING_TILDE_s4                                0x1082ce
#define nonstandard_COMBINING_OVERLINE_s4                             0x1082cf
#define nonstandard_COMBINING_CARON_s4                                0x1082d0
#define nonstandard_COMBINING_TILDE_BELOW_s4                          0x1082d1
#define nonstandard_COMBINING_LOW_LINE_s4                             0x1082d2
#define nonstandard_COMBINING_LONG_SOLIDUS_OVERLAY_s4                 0x1082d3
#define nonstandard_COMBINING_LEFT_HARPOON_ABOVE_s4                   0x1082d4
#define nonstandard_COMBINING_RIGHT_HARPOON_ABOVE_s4                  0x1082d5
#define nonstandard_COMBINING_LEFT_ARROW_ABOVE_s4                     0x1082d6
#define nonstandard_COMBINING_RIGHT_ARROW_ABOVE_s4                    0x1082d7
#define nonstandard_COMBINING_RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS_s4 0x1082d8
#define nonstandard_COMBINING_LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS_s4 0x1082d9
#define nonstandard_COMBINING_LEFT_ARROW_BELOW_s4                     0x1082da
#define nonstandard_COMBINING_RIGHT_ARROW_BELOW_s4                    0x1082db
#define nonstandard_SQUARE_ROOT_s4                                    0x1082dc
#define nonstandard_CUBE_ROOT_s4                                      0x1082dd
#define nonstandard_FOURTH_ROOT_s4                                    0x1082de
#define nonstandard_LEFT_CEILING_s4                                   0x1082df
#define nonstandard_RIGHT_CEILING_s4                                  0x1082e0
#define nonstandard_LEFT_FLOOR_s4                                     0x1082e1
#define nonstandard_RIGHT_FLOOR_s4                                    0x1082e2
#define nonstandard_TOP_SQUARE_BRACKET_s4                             0x1082e3
#define nonstandard_BOTTOM_SQUARE_BRACKET_s4                          0x1082e4
#define nonstandard_TOP_PARENTHESIS_s4                                0x1082e5
#define nonstandard_BOTTOM_PARENTHESIS_s4                             0x1082e6
#define nonstandard_TOP_CURLY_BRACKET_s4                              0x1082e7
#define nonstandard_BOTTOM_CURLY_BRACKET_s4                           0x1082e8
#define nonstandard_TOP_TORTOISE_SHELL_BRACKET_s4                     0x1082e9
#define nonstandard_BOTTOM_TORTOISE_SHELL_BRACKET_s4                  0x1082ea
#define nonstandard_LIGHT_LEFT_TORTOISE_SHELL_BRACKET_ORNAMENT_s4     0x1082eb
#define nonstandard_LIGHT_RIGHT_TORTOISE_SHELL_BRACKET_ORNAMENT_s4    0x1082ec
#define nonstandard_MATHEMATICAL_LEFT_WHITE_SQUARE_BRACKET_s4         0x1082ed
#define nonstandard_MATHEMATICAL_RIGHT_WHITE_SQUARE_BRACKET_s4        0x1082ee
#define nonstandard_MATHEMATICAL_LEFT_ANGLE_BRACKET_s4                0x1082ef
#define nonstandard_MATHEMATICAL_RIGHT_ANGLE_BRACKET_s4               0x1082f0
#define nonstandard_MATHEMATICAL_LEFT_DOUBLE_ANGLE_BRACKET_s4         0x1082f1
#define nonstandard_MATHEMATICAL_RIGHT_DOUBLE_ANGLE_BRACKET_s4        0x1082f2
#define nonstandard_LEFT_WHITE_CURLY_BRACKET_s4                       0x1082f3
#define nonstandard_RIGHT_WHITE_CURLY_BRACKET_s4                      0x1082f4
#define nonstandard_LEFT_WHITE_PARENTHESIS_s4                         0x1082f5
#define nonstandard_RIGHT_WHITE_PARENTHESIS_s4                        0x1082f6
#define nonstandard_underscore_s5                                     0x1082f7
#define nonstandard_MODIFIER_LETTER_CIRCUMFLEX_ACCENT_s5              0x1082f8
#define nonstandard_SMALL_TILDE_s5                                    0x1082f9
#define nonstandard_OVERLINE_s5                                       0x1082fa
#define nonstandard_CARON_s5                                          0x1082fb
#define nonstandard_MODIFIER_LETTER_LOW_TILDE_s5                      0x1082fc
#define nonstandard_COMBINING_CIRCUMFLEX_ACCENT_s5                    0x1082fd
#define nonstandard_COMBINING_TILDE_s5                                0x1082fe
#define nonstandard_COMBINING_OVERLINE_s5                             0x1082ff
#define nonstandard_COMBINING_CARON_s5                                0x108300
#define nonstandard_COMBINING_TILDE_BELOW_s5                          0x108301
#define nonstandard_COMBINING_LOW_LINE_s5                             0x108302
#define nonstandard_COMBINING_LONG_SOLIDUS_OVERLAY_s5                 0x108303
#define nonstandard_COMBINING_LEFT_HARPOON_ABOVE_s5                   0x108304
#define nonstandard_COMBINING_RIGHT_HARPOON_ABOVE_s5                  0x108305
#define nonstandard_COMBINING_LEFT_ARROW_ABOVE_s5                     0x108306
#define nonstandard_COMBINING_RIGHT_ARROW_ABOVE_s5                    0x108307
#define nonstandard_COMBINING_RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS_s5 0x108308
#define nonstandard_COMBINING_LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS_s5 0x108309
#define nonstandard_COMBINING_LEFT_ARROW_BELOW_s5                     0x10830a
#define nonstandard_COMBINING_RIGHT_ARROW_BELOW_s5                    0x10830b
#define nonstandard_TOP_SQUARE_BRACKET_s5                             0x10830c
#define nonstandard_BOTTOM_SQUARE_BRACKET_s5                          0x10830d
#define nonstandard_TOP_PARENTHESIS_s5                                0x10830e
#define nonstandard_BOTTOM_PARENTHESIS_s5                             0x10830f
#define nonstandard_TOP_CURLY_BRACKET_s5                              0x108310
#define nonstandard_BOTTOM_CURLY_BRACKET_s5                           0x108311
#define nonstandard_TOP_TORTOISE_SHELL_BRACKET_s5                     0x108312
#define nonstandard_BOTTOM_TORTOISE_SHELL_BRACKET_s5                  0x108313
#define nonstandard_INTEGRAL_dsp                                      0x108314
#define nonstandard_DOUBLE_INTEGRAL_dsp                               0x108315
#define nonstandard_TRIPLE_INTEGRAL_dsp                               0x108316
#define nonstandard_CONTOUR_INTEGRAL_dsp                              0x108317
#define nonstandard_SURFACE_INTEGRAL_dsp                              0x108318
#define nonstandard_VOLUME_INTEGRAL_dsp                               0x108319
#define nonstandard_CLOCKWISE_INTEGRAL_dsp                            0x10831a
#define nonstandard_CLOCKWISE_CONTOUR_INTEGRAL_dsp                    0x10831b
#define nonstandard_ANTICLOCKWISE_CONTOUR_INTEGRAL_dsp                0x10831c
#define nonstandard_SUMMATION_WITH_INTEGRAL_dsp                       0x10831d
#define nonstandard_QUADRUPLE_INTEGRAL_OPERATOR_dsp                   0x10831e
#define nonstandard_FINITE_PART_INTEGRAL_dsp                          0x10831f
#define nonstandard_INTEGRAL_WITH_DOUBLE_STROKE_dsp                   0x108320
#define nonstandard_INTEGRAL_AVERAGE_WITH_SLASH_dsp                   0x108321
#define nonstandard_CIRCULATION_FUNCTION_dsp                          0x108322
#define nonstandard_ANTICLOCKWISE_INTEGRATION_dsp                     0x108323
#define nonstandard_LINE_INTEGRATION_WITH_RECTANGULAR_PATH_AROUND_POLE_dsp 0x108324
#define nonstandard_LINE_INTEGRATION_WITH_SEMICIRCULAR_PATH_AROUND_POLE_dsp 0x108325
#define nonstandard_LINE_INTEGRATION_NOT_INCLUDING_THE_POLE_dsp       0x108326
#define nonstandard_INTEGRAL_AROUND_A_POINT_OPERATOR_dsp              0x108327
#define nonstandard_QUATERNION_INTEGRAL_OPERATOR_dsp                  0x108328
#define nonstandard_INTEGRAL_WITH_LEFTWARDS_ARROW_WITH_HOOK_dsp       0x108329
#define nonstandard_INTEGRAL_WITH_TIMES_SIGN_dsp                      0x10832a
#define nonstandard_INTEGRAL_WITH_INTERSECTION_dsp                    0x10832b
#define nonstandard_INTEGRAL_WITH_UNION_dsp                           0x10832c
#define nonstandard_INTEGRAL_WITH_OVERBAR_dsp                         0x10832d
#define nonstandard_INTEGRAL_WITH_UNDERBAR_dsp                        0x10832e
#define nonstandard_INTEGRAL_sm                                       0x10832f
#define nonstandard_DOUBLE_INTEGRAL_sm                                0x108330
#define nonstandard_TRIPLE_INTEGRAL_sm                                0x108331
#define nonstandard_CONTOUR_INTEGRAL_sm                               0x108332
#define nonstandard_SURFACE_INTEGRAL_sm                               0x108333
#define nonstandard_VOLUME_INTEGRAL_sm                                0x108334
#define nonstandard_CLOCKWISE_INTEGRAL_sm                             0x108335
#define nonstandard_CLOCKWISE_CONTOUR_INTEGRAL_sm                     0x108336
#define nonstandard_ANTICLOCKWISE_CONTOUR_INTEGRAL_sm                 0x108337
#define nonstandard_SUMMATION_WITH_INTEGRAL_sm                        0x108338
#define nonstandard_QUADRUPLE_INTEGRAL_OPERATOR_sm                    0x108339
#define nonstandard_FINITE_PART_INTEGRAL_sm                           0x10833a
#define nonstandard_INTEGRAL_WITH_DOUBLE_STROKE_sm                    0x10833b
#define nonstandard_INTEGRAL_AVERAGE_WITH_SLASH_sm                    0x10833c
#define nonstandard_CIRCULATION_FUNCTION_sm                           0x10833d
#define nonstandard_ANTICLOCKWISE_INTEGRATION_sm                      0x10833e
#define nonstandard_LINE_INTEGRATION_WITH_RECTANGULAR_PATH_AROUND_POLE_sm 0x10833f
#define nonstandard_LINE_INTEGRATION_WITH_SEMICIRCULAR_PATH_AROUND_POLE_sm 0x108340
#define nonstandard_LINE_INTEGRATION_NOT_INCLUDING_THE_POLE_sm        0x108341
#define nonstandard_INTEGRAL_AROUND_A_POINT_OPERATOR_sm               0x108342
#define nonstandard_QUATERNION_INTEGRAL_OPERATOR_sm                   0x108343
#define nonstandard_INTEGRAL_WITH_LEFTWARDS_ARROW_WITH_HOOK_sm        0x108344
#define nonstandard_INTEGRAL_WITH_TIMES_SIGN_sm                       0x108345
#define nonstandard_INTEGRAL_WITH_INTERSECTION_sm                     0x108346
#define nonstandard_INTEGRAL_WITH_UNION_sm                            0x108347
#define nonstandard_INTEGRAL_WITH_OVERBAR_sm                          0x108348
#define nonstandard_INTEGRAL_WITH_UNDERBAR_sm                         0x108349
#define nonstandard_INTEGRAL_up                                       0x10834a
#define nonstandard_DOUBLE_INTEGRAL_up                                0x10834b
#define nonstandard_TRIPLE_INTEGRAL_up                                0x10834c
#define nonstandard_CONTOUR_INTEGRAL_up                               0x10834d
#define nonstandard_SURFACE_INTEGRAL_up                               0x10834e
#define nonstandard_VOLUME_INTEGRAL_up                                0x10834f
#define nonstandard_CLOCKWISE_INTEGRAL_up                             0x108350
#define nonstandard_CLOCKWISE_CONTOUR_INTEGRAL_up                     0x108351
#define nonstandard_ANTICLOCKWISE_CONTOUR_INTEGRAL_up                 0x108352
#define nonstandard_SUMMATION_WITH_INTEGRAL_up                        0x108353
#define nonstandard_QUADRUPLE_INTEGRAL_OPERATOR_up                    0x108354
#define nonstandard_FINITE_PART_INTEGRAL_up                           0x108355
#define nonstandard_INTEGRAL_WITH_DOUBLE_STROKE_up                    0x108356
#define nonstandard_INTEGRAL_AVERAGE_WITH_SLASH_up                    0x108357
#define nonstandard_CIRCULATION_FUNCTION_up                           0x108358
#define nonstandard_ANTICLOCKWISE_INTEGRATION_up                      0x108359
#define nonstandard_LINE_INTEGRATION_WITH_RECTANGULAR_PATH_AROUND_POLE_up 0x10835a
#define nonstandard_LINE_INTEGRATION_WITH_SEMICIRCULAR_PATH_AROUND_POLE_up 0x10835b
#define nonstandard_LINE_INTEGRATION_NOT_INCLUDING_THE_POLE_up        0x10835c
#define nonstandard_INTEGRAL_AROUND_A_POINT_OPERATOR_up               0x10835d
#define nonstandard_QUATERNION_INTEGRAL_OPERATOR_up                   0x10835e
#define nonstandard_INTEGRAL_WITH_LEFTWARDS_ARROW_WITH_HOOK_up        0x10835f
#define nonstandard_INTEGRAL_WITH_TIMES_SIGN_up                       0x108360
#define nonstandard_INTEGRAL_WITH_INTERSECTION_up                     0x108361
#define nonstandard_INTEGRAL_WITH_UNION_up                            0x108362
#define nonstandard_INTEGRAL_WITH_OVERBAR_up                          0x108363
#define nonstandard_INTEGRAL_WITH_UNDERBAR_up                         0x108364
#define nonstandard_INTEGRAL_updsp                                    0x108365
#define nonstandard_DOUBLE_INTEGRAL_updsp                             0x108366
#define nonstandard_TRIPLE_INTEGRAL_updsp                             0x108367
#define nonstandard_CONTOUR_INTEGRAL_updsp                            0x108368
#define nonstandard_SURFACE_INTEGRAL_updsp                            0x108369
#define nonstandard_VOLUME_INTEGRAL_updsp                             0x10836a
#define nonstandard_CLOCKWISE_INTEGRAL_updsp                          0x10836b
#define nonstandard_CLOCKWISE_CONTOUR_INTEGRAL_updsp                  0x10836c
#define nonstandard_ANTICLOCKWISE_CONTOUR_INTEGRAL_updsp              0x10836d
#define nonstandard_SUMMATION_WITH_INTEGRAL_updsp                     0x10836e
#define nonstandard_QUADRUPLE_INTEGRAL_OPERATOR_updsp                 0x10836f
#define nonstandard_FINITE_PART_INTEGRAL_updsp                        0x108370
#define nonstandard_INTEGRAL_WITH_DOUBLE_STROKE_updsp                 0x108371
#define nonstandard_INTEGRAL_AVERAGE_WITH_SLASH_updsp                 0x108372
#define nonstandard_CIRCULATION_FUNCTION_updsp                        0x108373
#define nonstandard_ANTICLOCKWISE_INTEGRATION_updsp                   0x108374
#define nonstandard_LINE_INTEGRATION_WITH_RECTANGULAR_PATH_AROUND_POLE_updsp 0x108375
#define nonstandard_LINE_INTEGRATION_WITH_SEMICIRCULAR_PATH_AROUND_POLE_updsp 0x108376
#define nonstandard_LINE_INTEGRATION_NOT_INCLUDING_THE_POLE_updsp     0x108377
#define nonstandard_INTEGRAL_AROUND_A_POINT_OPERATOR_updsp            0x108378
#define nonstandard_QUATERNION_INTEGRAL_OPERATOR_updsp                0x108379
#define nonstandard_INTEGRAL_WITH_LEFTWARDS_ARROW_WITH_HOOK_updsp     0x10837a
#define nonstandard_INTEGRAL_WITH_TIMES_SIGN_updsp                    0x10837b
#define nonstandard_INTEGRAL_WITH_INTERSECTION_updsp                  0x10837c
#define nonstandard_INTEGRAL_WITH_UNION_updsp                         0x10837d
#define nonstandard_INTEGRAL_WITH_OVERBAR_updsp                       0x10837e
#define nonstandard_INTEGRAL_WITH_UNDERBAR_updsp                      0x10837f
#define nonstandard_INTEGRAL_upsm                                     0x108380
#define nonstandard_DOUBLE_INTEGRAL_upsm                              0x108381
#define nonstandard_TRIPLE_INTEGRAL_upsm                              0x108382
#define nonstandard_CONTOUR_INTEGRAL_upsm                             0x108383
#define nonstandard_SURFACE_INTEGRAL_upsm                             0x108384
#define nonstandard_VOLUME_INTEGRAL_upsm                              0x108385
#define nonstandard_CLOCKWISE_INTEGRAL_upsm                           0x108386
#define nonstandard_CLOCKWISE_CONTOUR_INTEGRAL_upsm                   0x108387
#define nonstandard_ANTICLOCKWISE_CONTOUR_INTEGRAL_upsm               0x108388
#define nonstandard_SUMMATION_WITH_INTEGRAL_upsm                      0x108389
#define nonstandard_QUADRUPLE_INTEGRAL_OPERATOR_upsm                  0x10838a
#define nonstandard_FINITE_PART_INTEGRAL_upsm                         0x10838b
#define nonstandard_INTEGRAL_WITH_DOUBLE_STROKE_upsm                  0x10838c
#define nonstandard_INTEGRAL_AVERAGE_WITH_SLASH_upsm                  0x10838d
#define nonstandard_CIRCULATION_FUNCTION_upsm                         0x10838e
#define nonstandard_ANTICLOCKWISE_INTEGRATION_upsm                    0x10838f
#define nonstandard_LINE_INTEGRATION_WITH_RECTANGULAR_PATH_AROUND_POLE_upsm 0x108390
#define nonstandard_LINE_INTEGRATION_WITH_SEMICIRCULAR_PATH_AROUND_POLE_upsm 0x108391
#define nonstandard_LINE_INTEGRATION_NOT_INCLUDING_THE_POLE_upsm      0x108392
#define nonstandard_INTEGRAL_AROUND_A_POINT_OPERATOR_upsm             0x108393
#define nonstandard_QUATERNION_INTEGRAL_OPERATOR_upsm                 0x108394
#define nonstandard_INTEGRAL_WITH_LEFTWARDS_ARROW_WITH_HOOK_upsm      0x108395
#define nonstandard_INTEGRAL_WITH_TIMES_SIGN_upsm                     0x108396
#define nonstandard_INTEGRAL_WITH_INTERSECTION_upsm                   0x108397
#define nonstandard_INTEGRAL_WITH_UNION_upsm                          0x108398
#define nonstandard_INTEGRAL_WITH_OVERBAR_upsm                        0x108399
#define nonstandard_INTEGRAL_WITH_UNDERBAR_upsm                       0x10839a
#define nonstandard_SQUARE_ROOT_x                                     0x10839b
#define nonstandard_SQUARE_ROOT_t                                     0x10839c
#define nonstandard_N_ARY_WHITE_VERTICAL_BAR_s2                       0x10839d

// end of uninames.h
